// -----------
// This file was generated by riscv_ctg (https://gitlab.com/incoresemi/riscv-compliance/riscv_ctg)
// version   : 0.5.1
// timestamp : Mon Aug  2 08:58:53 2021 GMT
// usage     : riscv_ctg \
//                  --cgf /home/bilalsakhawat/riscv-ctg/sample_cgfs/dataset.cgf \
//                  --cgf /home/bilalsakhawat/riscv-ctg/sample_cgfs/rv32e.cgf \
//                  --base-isa rv32e \
//                  --randomize
// -----------
//
// -----------
// Copyright (c) 2020. RISC-V International. All rights reserved.
// SPDX-License-Identifier: BSD-3-Clause
// -----------
//
// This assembly file tests the auipc instruction of the RISC-V E extension for the auipc covergroup.
// 
#include "model_test.h"
#include "arch_test.h"
RVTEST_ISA("RV32E")

.section .text.init
.globl rvtest_entry_point
rvtest_entry_point:
RVMODEL_BOOT
RVTEST_CODE_BEGIN

#ifdef TEST_CASE_1

RVTEST_CASE(0,"//check ISA:=regex(.*32.*);check ISA:=regex(.*E.*) ;def RVTEST_E = True;def TEST_CASE_1=True;",auipc)

RVTEST_SIGBASE( x2,signature_x2_1)

inst_0:
// rd==x9, imm_val == ((2**20)-1), imm_val > 0
// opcode: auipc ; dest:x9; immval:0xfffff
TEST_AUIPC(auipc, x9, -0x1000, 0xfffff, x2, 0, x3)

inst_1:
// rd==x6, imm_val == 524287, 
// opcode: auipc ; dest:x6; immval:0x7ffff
TEST_AUIPC(auipc, x6, 0x7ffff000, 0x7ffff, x2, 4, x3)

inst_2:
// rd==x1, imm_val == 786431, 
// opcode: auipc ; dest:x1; immval:0xbffff
TEST_AUIPC(auipc, x1, -0x40001000, 0xbffff, x2, 8, x3)

inst_3:
// rd==x5, imm_val == 917503, 
// opcode: auipc ; dest:x5; immval:0xdffff
TEST_AUIPC(auipc, x5, -0x20001000, 0xdffff, x2, 12, x3)

inst_4:
// rd==x14, imm_val == 983039, 
// opcode: auipc ; dest:x14; immval:0xeffff
TEST_AUIPC(auipc, x14, -0x10001000, 0xeffff, x2, 16, x3)

inst_5:
// rd==x7, imm_val == 1015807, 
// opcode: auipc ; dest:x7; immval:0xf7fff
TEST_AUIPC(auipc, x7, -0x8001000, 0xf7fff, x2, 20, x3)

inst_6:
// rd==x15, imm_val == 1032191, 
// opcode: auipc ; dest:x15; immval:0xfbfff
TEST_AUIPC(auipc, x15, -0x4001000, 0xfbfff, x2, 24, x3)

inst_7:
// rd==x10, imm_val == 1040383, 
// opcode: auipc ; dest:x10; immval:0xfdfff
TEST_AUIPC(auipc, x10, -0x2001000, 0xfdfff, x2, 28, x3)

inst_8:
// rd==x12, imm_val == 1044479, 
// opcode: auipc ; dest:x12; immval:0xfefff
TEST_AUIPC(auipc, x12, -0x1001000, 0xfefff, x2, 32, x3)

inst_9:
// rd==x0, imm_val == 1046527, 
// opcode: auipc ; dest:x0; immval:0xff7ff
TEST_AUIPC(auipc, x0, 0, 0xff7ff, x2, 36, x3)

inst_10:
// rd==x8, imm_val == 1047551, 
// opcode: auipc ; dest:x8; immval:0xffbff
TEST_AUIPC(auipc, x8, -0x401000, 0xffbff, x2, 40, x3)

inst_11:
// rd==x4, imm_val == 1048063, 
// opcode: auipc ; dest:x4; immval:0xffdff
TEST_AUIPC(auipc, x4, -0x201000, 0xffdff, x2, 44, x3)

inst_12:
// rd==x13, imm_val == 1048319, 
// opcode: auipc ; dest:x13; immval:0xffeff
TEST_AUIPC(auipc, x13, -0x101000, 0xffeff, x2, 48, x4)
RVTEST_SIGBASE( x1,signature_x1_0)

inst_13:
// rd==x3, imm_val == 1048447, 
// opcode: auipc ; dest:x3; immval:0xfff7f
TEST_AUIPC(auipc, x3, -0x81000, 0xfff7f, x1, 0, x4)

inst_14:
// rd==x11, imm_val == 1048511, 
// opcode: auipc ; dest:x11; immval:0xfffbf
TEST_AUIPC(auipc, x11, -0x41000, 0xfffbf, x1, 4, x4)

inst_15:
// rd==x2, imm_val == 1048543, 
// opcode: auipc ; dest:x2; immval:0xfffdf
TEST_AUIPC(auipc, x2, -0x21000, 0xfffdf, x1, 8, x4)

inst_16:
// imm_val == 1048559, 
// opcode: auipc ; dest:x10; immval:0xfffef
TEST_AUIPC(auipc, x10, -0x11000, 0xfffef, x1, 12, x4)

inst_17:
// imm_val == 1048567, 
// opcode: auipc ; dest:x10; immval:0xffff7
TEST_AUIPC(auipc, x10, -0x9000, 0xffff7, x1, 16, x4)

inst_18:
// imm_val == 1048571, 
// opcode: auipc ; dest:x10; immval:0xffffb
TEST_AUIPC(auipc, x10, -0x5000, 0xffffb, x1, 20, x4)

inst_19:
// imm_val == 1048573, 
// opcode: auipc ; dest:x10; immval:0xffffd
TEST_AUIPC(auipc, x10, -0x3000, 0xffffd, x1, 24, x4)

inst_20:
// imm_val == 1048574, 
// opcode: auipc ; dest:x10; immval:0xffffe
TEST_AUIPC(auipc, x10, -0x2000, 0xffffe, x1, 28, x4)

inst_21:
// imm_val == 524288, 
// opcode: auipc ; dest:x10; immval:0x80000
TEST_AUIPC(auipc, x10, -0x80000000, 0x80000, x1, 32, x4)

inst_22:
// imm_val == 262144, 
// opcode: auipc ; dest:x10; immval:0x40000
TEST_AUIPC(auipc, x10, 0x40000000, 0x40000, x1, 36, x4)

inst_23:
// imm_val == 131072, 
// opcode: auipc ; dest:x10; immval:0x20000
TEST_AUIPC(auipc, x10, 0x20000000, 0x20000, x1, 40, x4)

inst_24:
// imm_val == 65536, 
// opcode: auipc ; dest:x10; immval:0x10000
TEST_AUIPC(auipc, x10, 0x10000000, 0x10000, x1, 44, x4)

inst_25:
// imm_val == 32768, 
// opcode: auipc ; dest:x10; immval:0x8000
TEST_AUIPC(auipc, x10, 0x8000000, 0x8000, x1, 48, x4)

inst_26:
// imm_val == 16384, 
// opcode: auipc ; dest:x10; immval:0x4000
TEST_AUIPC(auipc, x10, 0x4000000, 0x4000, x1, 52, x4)

inst_27:
// imm_val == 8192, 
// opcode: auipc ; dest:x10; immval:0x2000
TEST_AUIPC(auipc, x10, 0x2000000, 0x2000, x1, 56, x4)

inst_28:
// imm_val == 4096, 
// opcode: auipc ; dest:x10; immval:0x1000
TEST_AUIPC(auipc, x10, 0x1000000, 0x1000, x1, 60, x4)

inst_29:
// imm_val == 2048, 
// opcode: auipc ; dest:x10; immval:0x800
TEST_AUIPC(auipc, x10, 0x800000, 0x800, x1, 64, x4)

inst_30:
// imm_val == 1024, imm_val==1024
// opcode: auipc ; dest:x10; immval:0x400
TEST_AUIPC(auipc, x10, 0x400000, 0x400, x1, 68, x4)

inst_31:
// imm_val == 512, 
// opcode: auipc ; dest:x10; immval:0x200
TEST_AUIPC(auipc, x10, 0x200000, 0x200, x1, 72, x4)

inst_32:
// imm_val == 256, 
// opcode: auipc ; dest:x10; immval:0x100
TEST_AUIPC(auipc, x10, 0x100000, 0x100, x1, 76, x4)

inst_33:
// imm_val == 128, 
// opcode: auipc ; dest:x10; immval:0x80
TEST_AUIPC(auipc, x10, 0x80000, 0x80, x1, 80, x4)

inst_34:
// imm_val == 64, 
// opcode: auipc ; dest:x10; immval:0x40
TEST_AUIPC(auipc, x10, 0x40000, 0x40, x1, 84, x4)

inst_35:
// imm_val == 32, 
// opcode: auipc ; dest:x10; immval:0x20
TEST_AUIPC(auipc, x10, 0x20000, 0x20, x1, 88, x4)

inst_36:
// imm_val == 16, 
// opcode: auipc ; dest:x10; immval:0x10
TEST_AUIPC(auipc, x10, 0x10000, 0x10, x1, 92, x4)

inst_37:
// imm_val==349525, imm_val == 349525
// opcode: auipc ; dest:x10; immval:0x55555
TEST_AUIPC(auipc, x10, 0x55555000, 0x55555, x1, 96, x4)

inst_38:
// imm_val==3, 
// opcode: auipc ; dest:x10; immval:0x3
TEST_AUIPC(auipc, x10, 0x3000, 0x3, x1, 100, x4)

inst_39:
// imm_val == 699050, imm_val==699050
// opcode: auipc ; dest:x10; immval:0xaaaaa
TEST_AUIPC(auipc, x10, -0x55556000, 0xaaaaa, x1, 104, x4)

inst_40:
// imm_val == 0, imm_val==0
// opcode: auipc ; dest:x10; immval:0x0
TEST_AUIPC(auipc, x10, 0x0, 0x0, x1, 108, x4)

inst_41:
// imm_val == 8, 
// opcode: auipc ; dest:x10; immval:0x8
TEST_AUIPC(auipc, x10, 0x8000, 0x8, x1, 112, x4)

inst_42:
// imm_val == 4, imm_val==4
// opcode: auipc ; dest:x10; immval:0x4
TEST_AUIPC(auipc, x10, 0x4000, 0x4, x1, 116, x4)

inst_43:
// imm_val == 2, imm_val==2
// opcode: auipc ; dest:x10; immval:0x2
TEST_AUIPC(auipc, x10, 0x2000, 0x2, x1, 120, x4)

inst_44:
// imm_val == 1, imm_val==1
// opcode: auipc ; dest:x10; immval:0x1
TEST_AUIPC(auipc, x10, 0x1000, 0x1, x1, 124, x4)

inst_45:
// imm_val==725, 
// opcode: auipc ; dest:x10; immval:0x2d5
TEST_AUIPC(auipc, x10, 0x2d5000, 0x2d5, x1, 128, x4)

inst_46:
// imm_val==419431, 
// opcode: auipc ; dest:x10; immval:0x66667
TEST_AUIPC(auipc, x10, 0x66667000, 0x66667, x1, 132, x4)

inst_47:
// imm_val==209716, 
// opcode: auipc ; dest:x10; immval:0x33334
TEST_AUIPC(auipc, x10, 0x33334000, 0x33334, x1, 136, x4)

inst_48:
// imm_val==6, 
// opcode: auipc ; dest:x10; immval:0x6
TEST_AUIPC(auipc, x10, 0x6000, 0x6, x1, 140, x4)

inst_49:
// imm_val==699051, 
// opcode: auipc ; dest:x10; immval:0xaaaab
TEST_AUIPC(auipc, x10, -0x55555000, 0xaaaab, x1, 144, x4)

inst_50:
// imm_val==349526, 
// opcode: auipc ; dest:x10; immval:0x55556
TEST_AUIPC(auipc, x10, 0x55556000, 0x55556, x1, 148, x4)

inst_51:
// imm_val==1022, 
// opcode: auipc ; dest:x10; immval:0x3fe
TEST_AUIPC(auipc, x10, 0x3fe000, 0x3fe, x1, 152, x4)

inst_52:
// imm_val==723, 
// opcode: auipc ; dest:x10; immval:0x2d3
TEST_AUIPC(auipc, x10, 0x2d3000, 0x2d3, x1, 156, x4)

inst_53:
// imm_val==419429, 
// opcode: auipc ; dest:x10; immval:0x66665
TEST_AUIPC(auipc, x10, 0x66665000, 0x66665, x1, 160, x4)

inst_54:
// imm_val==209714, 
// opcode: auipc ; dest:x10; immval:0x33332
TEST_AUIPC(auipc, x10, 0x33332000, 0x33332, x1, 164, x4)

inst_55:
// imm_val==699049, 
// opcode: auipc ; dest:x10; immval:0xaaaa9
TEST_AUIPC(auipc, x10, -0x55557000, 0xaaaa9, x1, 168, x4)

inst_56:
// imm_val==349524, 
// opcode: auipc ; dest:x10; immval:0x55554
TEST_AUIPC(auipc, x10, 0x55554000, 0x55554, x1, 172, x4)

inst_57:
// imm_val==1023, 
// opcode: auipc ; dest:x10; immval:0x3ff
TEST_AUIPC(auipc, x10, 0x3ff000, 0x3ff, x1, 176, x4)

inst_58:
// imm_val==724, 
// opcode: auipc ; dest:x10; immval:0x2d4
TEST_AUIPC(auipc, x10, 0x2d4000, 0x2d4, x1, 180, x4)

inst_59:
// imm_val==419430, 
// opcode: auipc ; dest:x10; immval:0x66666
TEST_AUIPC(auipc, x10, 0x66666000, 0x66666, x1, 184, x4)

inst_60:
// imm_val==209715, 
// opcode: auipc ; dest:x10; immval:0x33333
TEST_AUIPC(auipc, x10, 0x33333000, 0x33333, x1, 188, x4)

inst_61:
// imm_val==5, 
// opcode: auipc ; dest:x10; immval:0x5
TEST_AUIPC(auipc, x10, 0x5000, 0x5, x1, 192, x4)

inst_62:
// imm_val == 1046527, 
// opcode: auipc ; dest:x10; immval:0xff7ff
TEST_AUIPC(auipc, x10, -0x801000, 0xff7ff, x1, 196, x4)
#endif


RVTEST_CODE_END
RVMODEL_HALT

RVTEST_DATA_BEGIN
.align 4

rvtest_data:
.word 0xbabecafe
.word 0xbabecafe
.word 0xbabecafe
.word 0xbabecafe
RVTEST_DATA_END


RVMODEL_DATA_BEGIN
rvtest_sig_begin:
sig_begin_canary:
CANARY;


signature_x2_0:
    .fill 0*(XLEN/32),4,0xdeadbeef


signature_x2_1:
    .fill 13*(XLEN/32),4,0xdeadbeef


signature_x1_0:
    .fill 50*(XLEN/32),4,0xdeadbeef

#ifdef rvtest_mtrap_routine

tsig_begin_canary:
CANARY;
mtrap_sigptr:
    .fill 64*(XLEN/32),4,0xdeadbeef
tsig_end_canary:
CANARY;

#endif

#ifdef rvtest_gpr_save

gpr_save:
    .fill 32*(XLEN/32),4,0xdeadbeef

#endif

sig_end_canary:
CANARY;
rvtest_sig_end:
RVMODEL_DATA_END
