// -----------
// This file was generated by riscv_ctg (https://gitlab.com/incoresemi/riscv-compliance/riscv_ctg)
// version   : 0.5.1
// timestamp : Mon Aug  2 08:58:53 2021 GMT
// usage     : riscv_ctg \
//                  --cgf /home/bilalsakhawat/riscv-ctg/sample_cgfs/dataset.cgf \
//                  --cgf /home/bilalsakhawat/riscv-ctg/sample_cgfs/rv32e.cgf \
//                  --base-isa rv32e \
//                  --randomize
// -----------
//
// -----------
// Copyright (c) 2020. RISC-V International. All rights reserved.
// SPDX-License-Identifier: BSD-3-Clause
// -----------
//
// This assembly file tests the ori instruction of the RISC-V E extension for the ori covergroup.
// 
#include "model_test.h"
#include "arch_test.h"
RVTEST_ISA("RV32E")

.section .text.init
.globl rvtest_entry_point
rvtest_entry_point:
RVMODEL_BOOT
RVTEST_CODE_BEGIN

#ifdef TEST_CASE_1

RVTEST_CASE(0,"//check ISA:=regex(.*32.*);check ISA:=regex(.*E.*) ;def RVTEST_E = True;def TEST_CASE_1=True;",ori)

RVTEST_SIGBASE( x1,signature_x1_1)

inst_0:
// rs1 != rd, rs1==x12, rd==x9, imm_val == (-2**(12-1)), rs1_val > 0 and imm_val < 0, rs1_val != imm_val, imm_val == -2048, rs1_val == 2097152
// opcode: ori ; op1:x12; dest:x9; op1val:0x200000;  immval:-0x800
TEST_IMM_OP( ori, x9, x12, 0xfffff800, 0x200000, -0x800, x1, 0, x2)

inst_1:
// rs1 == rd, rs1==x0, rd==x0, rs1_val == 2147483647, rs1_val > 0 and imm_val > 0, rs1_val == (2**(xlen-1)-1)
// opcode: ori ; op1:x0; dest:x0; op1val:0x0;  immval:0x3ff
TEST_IMM_OP( ori, x0, x0, 0, 0x0, 0x3ff, x1, 4, x2)

inst_2:
// rs1==x6, rd==x7, rs1_val == -1073741825, rs1_val < 0 and imm_val > 0, imm_val == 1024
// opcode: ori ; op1:x6; dest:x7; op1val:-0x40000001;  immval:0x400
TEST_IMM_OP( ori, x7, x6, 0xbfffffff, -0x40000001, 0x400, x1, 8, x2)

inst_3:
// rs1==x9, rd==x3, rs1_val == -536870913, 
// opcode: ori ; op1:x9; dest:x3; op1val:-0x20000001;  immval:0x2d
TEST_IMM_OP( ori, x3, x9, 0xdfffffff, -0x20000001, 0x2d, x1, 12, x2)

inst_4:
// rs1==x5, rd==x14, rs1_val == -268435457, 
// opcode: ori ; op1:x5; dest:x14; op1val:-0x10000001;  immval:0x666
TEST_IMM_OP( ori, x14, x5, 0xefffffff, -0x10000001, 0x666, x1, 16, x2)

inst_5:
// rs1==x13, rd==x11, rs1_val == -134217729, imm_val == 2
// opcode: ori ; op1:x13; dest:x11; op1val:-0x8000001;  immval:0x2
TEST_IMM_OP( ori, x11, x13, 0xf7ffffff, -0x8000001, 0x2, x1, 20, x2)

inst_6:
// rs1==x3, rd==x5, rs1_val == -67108865, 
// opcode: ori ; op1:x3; dest:x5; op1val:-0x4000001;  immval:0x2
TEST_IMM_OP( ori, x5, x3, 0xfbffffff, -0x4000001, 0x2, x1, 24, x2)

inst_7:
// rs1==x11, rd==x12, rs1_val == -33554433, 
// opcode: ori ; op1:x11; dest:x12; op1val:-0x2000001;  immval:0x3
TEST_IMM_OP( ori, x12, x11, 0xfdffffff, -0x2000001, 0x3, x1, 28, x2)

inst_8:
// rs1==x10, rd==x15, rs1_val == -16777217, imm_val == 1
// opcode: ori ; op1:x10; dest:x15; op1val:-0x1000001;  immval:0x1
TEST_IMM_OP( ori, x15, x10, 0xfeffffff, -0x1000001, 0x1, x1, 32, x2)

inst_9:
// rs1==x4, rd==x13, rs1_val == -8388609, rs1_val < 0 and imm_val < 0
// opcode: ori ; op1:x4; dest:x13; op1val:-0x800001;  immval:-0x555
TEST_IMM_OP( ori, x13, x4, 0xffffffff, -0x800001, -0x555, x1, 36, x5)
RVTEST_SIGBASE( x3,signature_x3_0)

inst_10:
// rs1==x15, rd==x10, rs1_val == -4194305, imm_val == -3
// opcode: ori ; op1:x15; dest:x10; op1val:-0x400001;  immval:-0x3
TEST_IMM_OP( ori, x10, x15, 0xffffffff, -0x400001, -0x3, x3, 0, x5)

inst_11:
// rs1==x7, rd==x4, rs1_val == -2097153, imm_val == 1365
// opcode: ori ; op1:x7; dest:x4; op1val:-0x200001;  immval:0x555
TEST_IMM_OP( ori, x4, x7, 0xffdfffff, -0x200001, 0x555, x3, 4, x5)

inst_12:
// rs1==x2, rd==x6, rs1_val == -1048577, imm_val == -5
// opcode: ori ; op1:x2; dest:x6; op1val:-0x100001;  immval:-0x5
TEST_IMM_OP( ori, x6, x2, 0xffffffff, -0x100001, -0x5, x3, 8, x5)

inst_13:
// rs1==x8, rd==x1, rs1_val == -524289, 
// opcode: ori ; op1:x8; dest:x1; op1val:-0x80001;  immval:-0x3
TEST_IMM_OP( ori, x1, x8, 0xffffffff, -0x80001, -0x3, x3, 12, x5)

inst_14:
// rs1==x1, rd==x2, rs1_val == -262145, 
// opcode: ori ; op1:x1; dest:x2; op1val:-0x40001;  immval:0x333
TEST_IMM_OP( ori, x2, x1, 0xfffbffff, -0x40001, 0x333, x3, 16, x5)

inst_15:
// rs1==x14, rd==x8, rs1_val == -131073, 
// opcode: ori ; op1:x14; dest:x8; op1val:-0x20001;  immval:0x332
TEST_IMM_OP( ori, x8, x14, 0xfffdffff, -0x20001, 0x332, x3, 20, x5)

inst_16:
// rs1_val == -65537, imm_val == 4
// opcode: ori ; op1:x10; dest:x11; op1val:-0x10001;  immval:0x4
TEST_IMM_OP( ori, x11, x10, 0xfffeffff, -0x10001, 0x4, x3, 24, x5)

inst_17:
// rs1_val == -32769, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x8001;  immval:0x555
TEST_IMM_OP( ori, x11, x10, 0xffff7fff, -0x8001, 0x555, x3, 28, x1)

inst_18:
// rs1_val == -16385, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x4001;  immval:0x666
TEST_IMM_OP( ori, x11, x10, 0xffffbfff, -0x4001, 0x666, x3, 32, x1)

inst_19:
// rs1_val == -8193, imm_val == -9
// opcode: ori ; op1:x10; dest:x11; op1val:-0x2001;  immval:-0x9
TEST_IMM_OP( ori, x11, x10, 0xffffffff, -0x2001, -0x9, x3, 36, x1)

inst_20:
// rs1_val == -4097, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x1001;  immval:-0x2d
TEST_IMM_OP( ori, x11, x10, 0xffffffff, -0x1001, -0x2d, x3, 40, x1)

inst_21:
// rs1_val == -2049, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x801;  immval:0x666
TEST_IMM_OP( ori, x11, x10, 0xfffff7ff, -0x801, 0x666, x3, 44, x1)

inst_22:
// rs1_val == -1025, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x401;  immval:-0x2c
TEST_IMM_OP( ori, x11, x10, 0xffffffff, -0x401, -0x2c, x3, 48, x1)

inst_23:
// rs1_val == -513, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x201;  immval:0x555
TEST_IMM_OP( ori, x11, x10, 0xfffffdff, -0x201, 0x555, x3, 52, x1)

inst_24:
// rs1_val == -257, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x101;  immval:-0x3
TEST_IMM_OP( ori, x11, x10, 0xffffffff, -0x101, -0x3, x3, 56, x1)

inst_25:
// rs1_val == -129, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x81;  immval:-0x9
TEST_IMM_OP( ori, x11, x10, 0xffffffff, -0x81, -0x9, x3, 60, x1)

inst_26:
// rs1_val == -65, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x41;  immval:-0x4
TEST_IMM_OP( ori, x11, x10, 0xffffffff, -0x41, -0x4, x3, 64, x1)

inst_27:
// rs1_val == -33, imm_val == -17
// opcode: ori ; op1:x10; dest:x11; op1val:-0x21;  immval:-0x11
TEST_IMM_OP( ori, x11, x10, 0xffffffff, -0x21, -0x11, x3, 68, x1)

inst_28:
// rs1_val == -17, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x11;  immval:-0x5
TEST_IMM_OP( ori, x11, x10, 0xffffffff, -0x11, -0x5, x3, 72, x1)

inst_29:
// rs1_val == -9, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x9;  immval:0x4
TEST_IMM_OP( ori, x11, x10, 0xfffffff7, -0x9, 0x4, x3, 76, x1)

inst_30:
// rs1_val == -5, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x5;  immval:-0x7
TEST_IMM_OP( ori, x11, x10, 0xfffffffb, -0x5, -0x7, x3, 80, x1)

inst_31:
// rs1_val == -3, imm_val == -65
// opcode: ori ; op1:x10; dest:x11; op1val:-0x3;  immval:-0x41
TEST_IMM_OP( ori, x11, x10, 0xffffffff, -0x3, -0x41, x3, 84, x1)

inst_32:
// rs1_val == -2, imm_val == -129
// opcode: ori ; op1:x10; dest:x11; op1val:-0x2;  immval:-0x81
TEST_IMM_OP( ori, x11, x10, 0xffffffff, -0x2, -0x81, x3, 88, x1)

inst_33:
// imm_val == 2047, imm_val == (2**(12-1)-1), rs1_val == 8192
// opcode: ori ; op1:x10; dest:x11; op1val:0x2000;  immval:0x7ff
TEST_IMM_OP( ori, x11, x10, 0x27ff, 0x2000, 0x7ff, x3, 92, x1)

inst_34:
// imm_val == -1025, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x6;  immval:-0x401
TEST_IMM_OP( ori, x11, x10, 0xfffffbff, 0x6, -0x401, x3, 96, x1)

inst_35:
// imm_val == -513, rs1_val == 131072
// opcode: ori ; op1:x10; dest:x11; op1val:0x20000;  immval:-0x201
TEST_IMM_OP( ori, x11, x10, 0xfffffdff, 0x20000, -0x201, x3, 100, x1)

inst_36:
// imm_val == -257, rs1_val == 1431655765
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555555;  immval:-0x101
TEST_IMM_OP( ori, x11, x10, 0xffffffff, 0x55555555, -0x101, x3, 104, x1)

inst_37:
// imm_val == -33, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555555;  immval:-0x21
TEST_IMM_OP( ori, x11, x10, 0xffffffff, -0x55555555, -0x21, x3, 108, x1)

inst_38:
// imm_val == -2, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x200001;  immval:-0x2
TEST_IMM_OP( ori, x11, x10, 0xffffffff, -0x200001, -0x2, x3, 112, x1)

inst_39:
// rs1_val == -2147483648, imm_val == 0, rs1_val == (-2**(xlen-1))
// opcode: ori ; op1:x10; dest:x11; op1val:-0x80000000;  immval:0x0
TEST_IMM_OP( ori, x11, x10, 0x80000000, -0x80000000, 0x0, x3, 116, x1)

inst_40:
// rs1_val == 1073741824, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x40000000;  immval:-0x2
TEST_IMM_OP( ori, x11, x10, 0xfffffffe, 0x40000000, -0x2, x3, 120, x1)

inst_41:
// rs1_val == 536870912, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x20000000;  immval:0x555
TEST_IMM_OP( ori, x11, x10, 0x20000555, 0x20000000, 0x555, x3, 124, x1)

inst_42:
// rs1_val == 268435456, imm_val == -1366
// opcode: ori ; op1:x10; dest:x11; op1val:0x10000000;  immval:-0x556
TEST_IMM_OP( ori, x11, x10, 0xfffffaaa, 0x10000000, -0x556, x3, 128, x1)

inst_43:
// rs1_val == 134217728, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x8000000;  immval:-0x1
TEST_IMM_OP( ori, x11, x10, 0xffffffff, 0x8000000, -0x1, x3, 132, x1)

inst_44:
// rs1_val == 67108864, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x4000000;  immval:0x332
TEST_IMM_OP( ori, x11, x10, 0x4000332, 0x4000000, 0x332, x3, 136, x1)

inst_45:
// rs1_val == 33554432, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x2000000;  immval:0x556
TEST_IMM_OP( ori, x11, x10, 0x2000556, 0x2000000, 0x556, x3, 140, x1)

inst_46:
// rs1_val == 16777216, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x1000000;  immval:-0x401
TEST_IMM_OP( ori, x11, x10, 0xfffffbff, 0x1000000, -0x401, x3, 144, x1)

inst_47:
// rs1_val == 8388608, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x800000;  immval:-0x101
TEST_IMM_OP( ori, x11, x10, 0xfffffeff, 0x800000, -0x101, x3, 148, x1)

inst_48:
// rs1_val == 4194304, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x400000;  immval:0x0
TEST_IMM_OP( ori, x11, x10, 0x400000, 0x400000, 0x0, x3, 152, x1)

inst_49:
// rs1_val == 1048576, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x100000;  immval:-0x21
TEST_IMM_OP( ori, x11, x10, 0xffffffdf, 0x100000, -0x21, x3, 156, x1)

inst_50:
// rs1_val == 524288, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x80000;  immval:-0x401
TEST_IMM_OP( ori, x11, x10, 0xfffffbff, 0x80000, -0x401, x3, 160, x1)

inst_51:
// rs1_val == 262144, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x40000;  immval:0x556
TEST_IMM_OP( ori, x11, x10, 0x40556, 0x40000, 0x556, x3, 164, x1)

inst_52:
// rs1_val == 65536, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x10000;  immval:0x1
TEST_IMM_OP( ori, x11, x10, 0x10001, 0x10000, 0x1, x3, 168, x1)

inst_53:
// rs1_val == 32768, imm_val == 512
// opcode: ori ; op1:x10; dest:x11; op1val:0x8000;  immval:0x200
TEST_IMM_OP( ori, x11, x10, 0x8200, 0x8000, 0x200, x3, 172, x1)

inst_54:
// rs1_val == 16384, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x4000;  immval:-0x2c
TEST_IMM_OP( ori, x11, x10, 0xffffffd4, 0x4000, -0x2c, x3, 176, x1)

inst_55:
// rs1_val == 4096, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x1000;  immval:-0x8
TEST_IMM_OP( ori, x11, x10, 0xfffffff8, 0x1000, -0x8, x3, 180, x1)

inst_56:
// rs1_val == 2048, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x800;  immval:-0x8
TEST_IMM_OP( ori, x11, x10, 0xfffffff8, 0x800, -0x8, x3, 184, x1)

inst_57:
// rs1_val == 1024, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x400;  immval:-0x2d
TEST_IMM_OP( ori, x11, x10, 0xffffffd3, 0x400, -0x2d, x3, 188, x1)

inst_58:
// rs1_val == 512, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x200;  immval:-0x2c
TEST_IMM_OP( ori, x11, x10, 0xffffffd4, 0x200, -0x2c, x3, 192, x1)

inst_59:
// rs1_val == 256, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x100;  immval:0x2
TEST_IMM_OP( ori, x11, x10, 0x102, 0x100, 0x2, x3, 196, x1)

inst_60:
// rs1_val == 128, rs1_val == imm_val, imm_val == 128
// opcode: ori ; op1:x10; dest:x11; op1val:0x80;  immval:0x80
TEST_IMM_OP( ori, x11, x10, 0x80, 0x80, 0x80, x3, 200, x1)

inst_61:
// rs1_val == 64, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x40;  immval:0x6
TEST_IMM_OP( ori, x11, x10, 0x46, 0x40, 0x6, x3, 204, x1)

inst_62:
// rs1_val == 32, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x20;  immval:-0x2c
TEST_IMM_OP( ori, x11, x10, 0xfffffff4, 0x20, -0x2c, x3, 208, x1)

inst_63:
// rs1_val == 16, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x10;  immval:0x555
TEST_IMM_OP( ori, x11, x10, 0x555, 0x10, 0x555, x3, 212, x1)

inst_64:
// rs1_val == 8, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x8;  immval:-0xa
TEST_IMM_OP( ori, x11, x10, 0xfffffffe, 0x8, -0xa, x3, 216, x1)

inst_65:
// rs1_val == 4, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x4;  immval:0x3ff
TEST_IMM_OP( ori, x11, x10, 0x3ff, 0x4, 0x3ff, x3, 220, x1)

inst_66:
// rs1_val == 2, rs1_val==2 and imm_val==2
// opcode: ori ; op1:x10; dest:x11; op1val:0x2;  immval:0x2
TEST_IMM_OP( ori, x11, x10, 0x2, 0x2, 0x2, x3, 224, x1)

inst_67:
// rs1_val == 1, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x1;  immval:0x0
TEST_IMM_OP( ori, x11, x10, 0x1, 0x1, 0x0, x3, 228, x1)

inst_68:
// imm_val == 256, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x20000000;  immval:0x100
TEST_IMM_OP( ori, x11, x10, 0x20000100, 0x20000000, 0x100, x3, 232, x1)

inst_69:
// imm_val == 64, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x4;  immval:0x40
TEST_IMM_OP( ori, x11, x10, 0x44, 0x4, 0x40, x3, 236, x1)

inst_70:
// imm_val == 32, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333334;  immval:0x20
TEST_IMM_OP( ori, x11, x10, 0x33333334, 0x33333334, 0x20, x3, 240, x1)

inst_71:
// imm_val == 16, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333333;  immval:0x10
TEST_IMM_OP( ori, x11, x10, 0x33333333, 0x33333333, 0x10, x3, 244, x1)

inst_72:
// imm_val == 8, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x8;  immval:0x8
TEST_IMM_OP( ori, x11, x10, 0xfffffff8, -0x8, 0x8, x3, 248, x1)

inst_73:
// rs1_val==46341 and imm_val==46, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb505;  immval:0x2e
TEST_IMM_OP( ori, x11, x10, 0xb52f, 0xb505, 0x2e, x3, 252, x1)

inst_74:
// rs1_val==46341 and imm_val==-44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb505;  immval:-0x2c
TEST_IMM_OP( ori, x11, x10, 0xffffffd5, 0xb505, -0x2c, x3, 256, x1)

inst_75:
// rs1_val==46341 and imm_val==1639, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb505;  immval:0x667
TEST_IMM_OP( ori, x11, x10, 0xb767, 0xb505, 0x667, x3, 260, x1)

inst_76:
// rs1_val==46341 and imm_val==820, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb505;  immval:0x334
TEST_IMM_OP( ori, x11, x10, 0xb735, 0xb505, 0x334, x3, 264, x1)

inst_77:
// rs1_val==46341 and imm_val==6, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb505;  immval:0x6
TEST_IMM_OP( ori, x11, x10, 0xb507, 0xb505, 0x6, x3, 268, x1)

inst_78:
// rs1_val==46341 and imm_val==-1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb505;  immval:-0x555
TEST_IMM_OP( ori, x11, x10, 0xffffffaf, 0xb505, -0x555, x3, 272, x1)

inst_79:
// rs1_val==46341 and imm_val==1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb505;  immval:0x556
TEST_IMM_OP( ori, x11, x10, 0xb557, 0xb505, 0x556, x3, 276, x1)

inst_80:
// rs1_val==46341 and imm_val==4, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb505;  immval:0x4
TEST_IMM_OP( ori, x11, x10, 0xb505, 0xb505, 0x4, x3, 280, x1)

inst_81:
// rs1_val==46341 and imm_val==44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb505;  immval:0x2c
TEST_IMM_OP( ori, x11, x10, 0xb52d, 0xb505, 0x2c, x3, 284, x1)

inst_82:
// rs1_val==46341 and imm_val==0, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb505;  immval:0x0
TEST_IMM_OP( ori, x11, x10, 0xb505, 0xb505, 0x0, x3, 288, x1)

inst_83:
// rs1_val==46341 and imm_val==1637, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb505;  immval:0x665
TEST_IMM_OP( ori, x11, x10, 0xb765, 0xb505, 0x665, x3, 292, x1)

inst_84:
// rs1_val==46341 and imm_val==818, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb505;  immval:0x332
TEST_IMM_OP( ori, x11, x10, 0xb737, 0xb505, 0x332, x3, 296, x1)

inst_85:
// rs1_val==46341 and imm_val==1364, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb505;  immval:0x554
TEST_IMM_OP( ori, x11, x10, 0xb555, 0xb505, 0x554, x3, 300, x1)

inst_86:
// rs1_val==46341 and imm_val==2, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb505;  immval:0x2
TEST_IMM_OP( ori, x11, x10, 0xb507, 0xb505, 0x2, x3, 304, x1)

inst_87:
// rs1_val==46341 and imm_val==45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb505;  immval:0x2d
TEST_IMM_OP( ori, x11, x10, 0xb52d, 0xb505, 0x2d, x3, 308, x1)

inst_88:
// rs1_val==46341 and imm_val==-45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb505;  immval:-0x2d
TEST_IMM_OP( ori, x11, x10, 0xffffffd7, 0xb505, -0x2d, x3, 312, x1)

inst_89:
// rs1_val==46341 and imm_val==1638, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb505;  immval:0x666
TEST_IMM_OP( ori, x11, x10, 0xb767, 0xb505, 0x666, x3, 316, x1)

inst_90:
// rs1_val==46341 and imm_val==819, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb505;  immval:0x333
TEST_IMM_OP( ori, x11, x10, 0xb737, 0xb505, 0x333, x3, 320, x1)

inst_91:
// rs1_val==46341 and imm_val==5, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb505;  immval:0x5
TEST_IMM_OP( ori, x11, x10, 0xb505, 0xb505, 0x5, x3, 324, x1)

inst_92:
// rs1_val==46341 and imm_val==-1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb505;  immval:-0x556
TEST_IMM_OP( ori, x11, x10, 0xffffffaf, 0xb505, -0x556, x3, 328, x1)

inst_93:
// rs1_val==46341 and imm_val==1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb505;  immval:0x555
TEST_IMM_OP( ori, x11, x10, 0xb555, 0xb505, 0x555, x3, 332, x1)

inst_94:
// rs1_val==46341 and imm_val==3, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb505;  immval:0x3
TEST_IMM_OP( ori, x11, x10, 0xb507, 0xb505, 0x3, x3, 336, x1)

inst_95:
// rs1_val==-46339 and imm_val==46, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb503;  immval:0x2e
TEST_IMM_OP( ori, x11, x10, 0xffff4aff, -0xb503, 0x2e, x3, 340, x1)

inst_96:
// rs1_val==-46339 and imm_val==-44, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb503;  immval:-0x2c
TEST_IMM_OP( ori, x11, x10, 0xfffffffd, -0xb503, -0x2c, x3, 344, x1)

inst_97:
// rs1_val==-46339 and imm_val==1639, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb503;  immval:0x667
TEST_IMM_OP( ori, x11, x10, 0xffff4eff, -0xb503, 0x667, x3, 348, x1)

inst_98:
// rs1_val==-46339 and imm_val==820, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb503;  immval:0x334
TEST_IMM_OP( ori, x11, x10, 0xffff4bfd, -0xb503, 0x334, x3, 352, x1)

inst_99:
// rs1_val==-46339 and imm_val==6, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb503;  immval:0x6
TEST_IMM_OP( ori, x11, x10, 0xffff4aff, -0xb503, 0x6, x3, 356, x1)

inst_100:
// rs1_val==-46339 and imm_val==-1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb503;  immval:-0x555
TEST_IMM_OP( ori, x11, x10, 0xfffffaff, -0xb503, -0x555, x3, 360, x1)

inst_101:
// rs1_val==-46339 and imm_val==1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb503;  immval:0x556
TEST_IMM_OP( ori, x11, x10, 0xffff4fff, -0xb503, 0x556, x3, 364, x1)

inst_102:
// rs1_val==-46339 and imm_val==4, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb503;  immval:0x4
TEST_IMM_OP( ori, x11, x10, 0xffff4afd, -0xb503, 0x4, x3, 368, x1)

inst_103:
// rs1_val==-46339 and imm_val==44, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb503;  immval:0x2c
TEST_IMM_OP( ori, x11, x10, 0xffff4afd, -0xb503, 0x2c, x3, 372, x1)

inst_104:
// rs1_val==-46339 and imm_val==0, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb503;  immval:0x0
TEST_IMM_OP( ori, x11, x10, 0xffff4afd, -0xb503, 0x0, x3, 376, x1)

inst_105:
// rs1_val==-46339 and imm_val==1637, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb503;  immval:0x665
TEST_IMM_OP( ori, x11, x10, 0xffff4efd, -0xb503, 0x665, x3, 380, x1)

inst_106:
// rs1_val==-46339 and imm_val==818, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb503;  immval:0x332
TEST_IMM_OP( ori, x11, x10, 0xffff4bff, -0xb503, 0x332, x3, 384, x1)

inst_107:
// rs1_val==-46339 and imm_val==1364, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb503;  immval:0x554
TEST_IMM_OP( ori, x11, x10, 0xffff4ffd, -0xb503, 0x554, x3, 388, x1)

inst_108:
// rs1_val==-46339 and imm_val==2, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb503;  immval:0x2
TEST_IMM_OP( ori, x11, x10, 0xffff4aff, -0xb503, 0x2, x3, 392, x1)

inst_109:
// rs1_val==-46339 and imm_val==45, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb503;  immval:0x2d
TEST_IMM_OP( ori, x11, x10, 0xffff4afd, -0xb503, 0x2d, x3, 396, x1)

inst_110:
// rs1_val==-46339 and imm_val==-45, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb503;  immval:-0x2d
TEST_IMM_OP( ori, x11, x10, 0xffffffff, -0xb503, -0x2d, x3, 400, x1)

inst_111:
// rs1_val==-46339 and imm_val==1638, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb503;  immval:0x666
TEST_IMM_OP( ori, x11, x10, 0xffff4eff, -0xb503, 0x666, x3, 404, x1)

inst_112:
// rs1_val==-46339 and imm_val==819, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb503;  immval:0x333
TEST_IMM_OP( ori, x11, x10, 0xffff4bff, -0xb503, 0x333, x3, 408, x1)

inst_113:
// rs1_val==-46339 and imm_val==5, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb503;  immval:0x5
TEST_IMM_OP( ori, x11, x10, 0xffff4afd, -0xb503, 0x5, x3, 412, x1)

inst_114:
// rs1_val==-46339 and imm_val==-1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb503;  immval:-0x556
TEST_IMM_OP( ori, x11, x10, 0xfffffaff, -0xb503, -0x556, x3, 416, x1)

inst_115:
// rs1_val==-46339 and imm_val==1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb503;  immval:0x555
TEST_IMM_OP( ori, x11, x10, 0xffff4ffd, -0xb503, 0x555, x3, 420, x1)

inst_116:
// rs1_val==-46339 and imm_val==3, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb503;  immval:0x3
TEST_IMM_OP( ori, x11, x10, 0xffff4aff, -0xb503, 0x3, x3, 424, x1)

inst_117:
// rs1_val==1717986919 and imm_val==46, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666667;  immval:0x2e
TEST_IMM_OP( ori, x11, x10, 0x6666666f, 0x66666667, 0x2e, x3, 428, x1)

inst_118:
// rs1_val==1717986919 and imm_val==-44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666667;  immval:-0x2c
TEST_IMM_OP( ori, x11, x10, 0xfffffff7, 0x66666667, -0x2c, x3, 432, x1)

inst_119:
// rs1_val==1717986919 and imm_val==1639, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666667;  immval:0x667
TEST_IMM_OP( ori, x11, x10, 0x66666667, 0x66666667, 0x667, x3, 436, x1)

inst_120:
// rs1_val==1717986919 and imm_val==820, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666667;  immval:0x334
TEST_IMM_OP( ori, x11, x10, 0x66666777, 0x66666667, 0x334, x3, 440, x1)

inst_121:
// rs1_val==1717986919 and imm_val==6, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666667;  immval:0x6
TEST_IMM_OP( ori, x11, x10, 0x66666667, 0x66666667, 0x6, x3, 444, x1)

inst_122:
// rs1_val==1717986919 and imm_val==-1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666667;  immval:-0x555
TEST_IMM_OP( ori, x11, x10, 0xfffffeef, 0x66666667, -0x555, x3, 448, x1)

inst_123:
// rs1_val==1717986919 and imm_val==1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666667;  immval:0x556
TEST_IMM_OP( ori, x11, x10, 0x66666777, 0x66666667, 0x556, x3, 452, x1)

inst_124:
// rs1_val==1717986919 and imm_val==4, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666667;  immval:0x4
TEST_IMM_OP( ori, x11, x10, 0x66666667, 0x66666667, 0x4, x3, 456, x1)

inst_125:
// rs1_val==1717986919 and imm_val==44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666667;  immval:0x2c
TEST_IMM_OP( ori, x11, x10, 0x6666666f, 0x66666667, 0x2c, x3, 460, x1)

inst_126:
// rs1_val==1717986919 and imm_val==0, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666667;  immval:0x0
TEST_IMM_OP( ori, x11, x10, 0x66666667, 0x66666667, 0x0, x3, 464, x1)

inst_127:
// rs1_val==1717986919 and imm_val==1637, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666667;  immval:0x665
TEST_IMM_OP( ori, x11, x10, 0x66666667, 0x66666667, 0x665, x3, 468, x1)

inst_128:
// rs1_val==1717986919 and imm_val==818, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666667;  immval:0x332
TEST_IMM_OP( ori, x11, x10, 0x66666777, 0x66666667, 0x332, x3, 472, x1)

inst_129:
// rs1_val==1717986919 and imm_val==1364, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666667;  immval:0x554
TEST_IMM_OP( ori, x11, x10, 0x66666777, 0x66666667, 0x554, x3, 476, x1)

inst_130:
// rs1_val==1717986919 and imm_val==2, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666667;  immval:0x2
TEST_IMM_OP( ori, x11, x10, 0x66666667, 0x66666667, 0x2, x3, 480, x1)

inst_131:
// rs1_val==1717986919 and imm_val==45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666667;  immval:0x2d
TEST_IMM_OP( ori, x11, x10, 0x6666666f, 0x66666667, 0x2d, x3, 484, x1)

inst_132:
// rs1_val==1717986919 and imm_val==-45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666667;  immval:-0x2d
TEST_IMM_OP( ori, x11, x10, 0xfffffff7, 0x66666667, -0x2d, x3, 488, x1)

inst_133:
// rs1_val==1717986919 and imm_val==1638, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666667;  immval:0x666
TEST_IMM_OP( ori, x11, x10, 0x66666667, 0x66666667, 0x666, x3, 492, x1)

inst_134:
// rs1_val==1717986919 and imm_val==819, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666667;  immval:0x333
TEST_IMM_OP( ori, x11, x10, 0x66666777, 0x66666667, 0x333, x3, 496, x1)

inst_135:
// rs1_val==1717986919 and imm_val==5, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666667;  immval:0x5
TEST_IMM_OP( ori, x11, x10, 0x66666667, 0x66666667, 0x5, x3, 500, x1)

inst_136:
// rs1_val==1717986919 and imm_val==-1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666667;  immval:-0x556
TEST_IMM_OP( ori, x11, x10, 0xfffffeef, 0x66666667, -0x556, x3, 504, x1)

inst_137:
// rs1_val==1717986919 and imm_val==1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666667;  immval:0x555
TEST_IMM_OP( ori, x11, x10, 0x66666777, 0x66666667, 0x555, x3, 508, x1)

inst_138:
// rs1_val==1717986919 and imm_val==3, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666667;  immval:0x3
TEST_IMM_OP( ori, x11, x10, 0x66666667, 0x66666667, 0x3, x3, 512, x1)

inst_139:
// rs1_val==858993460 and imm_val==46, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333334;  immval:0x2e
TEST_IMM_OP( ori, x11, x10, 0x3333333e, 0x33333334, 0x2e, x3, 516, x1)

inst_140:
// rs1_val==858993460 and imm_val==-44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333334;  immval:-0x2c
TEST_IMM_OP( ori, x11, x10, 0xfffffff4, 0x33333334, -0x2c, x3, 520, x1)

inst_141:
// rs1_val==858993460 and imm_val==1639, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333334;  immval:0x667
TEST_IMM_OP( ori, x11, x10, 0x33333777, 0x33333334, 0x667, x3, 524, x1)

inst_142:
// rs1_val==858993460 and imm_val==820, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333334;  immval:0x334
TEST_IMM_OP( ori, x11, x10, 0x33333334, 0x33333334, 0x334, x3, 528, x1)

inst_143:
// rs1_val==858993460 and imm_val==6, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333334;  immval:0x6
TEST_IMM_OP( ori, x11, x10, 0x33333336, 0x33333334, 0x6, x3, 532, x1)

inst_144:
// rs1_val==858993460 and imm_val==-1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333334;  immval:-0x555
TEST_IMM_OP( ori, x11, x10, 0xfffffbbf, 0x33333334, -0x555, x3, 536, x1)

inst_145:
// rs1_val==858993460 and imm_val==1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333334;  immval:0x556
TEST_IMM_OP( ori, x11, x10, 0x33333776, 0x33333334, 0x556, x3, 540, x1)

inst_146:
// rs1_val==858993460 and imm_val==4, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333334;  immval:0x4
TEST_IMM_OP( ori, x11, x10, 0x33333334, 0x33333334, 0x4, x3, 544, x1)

inst_147:
// rs1_val==858993460 and imm_val==44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333334;  immval:0x2c
TEST_IMM_OP( ori, x11, x10, 0x3333333c, 0x33333334, 0x2c, x3, 548, x1)

inst_148:
// rs1_val==858993460 and imm_val==0, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333334;  immval:0x0
TEST_IMM_OP( ori, x11, x10, 0x33333334, 0x33333334, 0x0, x3, 552, x1)

inst_149:
// rs1_val==858993460 and imm_val==1637, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333334;  immval:0x665
TEST_IMM_OP( ori, x11, x10, 0x33333775, 0x33333334, 0x665, x3, 556, x1)

inst_150:
// rs1_val==858993460 and imm_val==818, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333334;  immval:0x332
TEST_IMM_OP( ori, x11, x10, 0x33333336, 0x33333334, 0x332, x3, 560, x1)

inst_151:
// rs1_val==858993460 and imm_val==1364, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333334;  immval:0x554
TEST_IMM_OP( ori, x11, x10, 0x33333774, 0x33333334, 0x554, x3, 564, x1)

inst_152:
// rs1_val==858993460 and imm_val==2, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333334;  immval:0x2
TEST_IMM_OP( ori, x11, x10, 0x33333336, 0x33333334, 0x2, x3, 568, x1)

inst_153:
// rs1_val==858993460 and imm_val==45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333334;  immval:0x2d
TEST_IMM_OP( ori, x11, x10, 0x3333333d, 0x33333334, 0x2d, x3, 572, x1)

inst_154:
// rs1_val==858993460 and imm_val==-45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333334;  immval:-0x2d
TEST_IMM_OP( ori, x11, x10, 0xfffffff7, 0x33333334, -0x2d, x3, 576, x1)

inst_155:
// rs1_val==858993460 and imm_val==1638, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333334;  immval:0x666
TEST_IMM_OP( ori, x11, x10, 0x33333776, 0x33333334, 0x666, x3, 580, x1)

inst_156:
// rs1_val==858993460 and imm_val==819, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333334;  immval:0x333
TEST_IMM_OP( ori, x11, x10, 0x33333337, 0x33333334, 0x333, x3, 584, x1)

inst_157:
// rs1_val==858993460 and imm_val==5, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333334;  immval:0x5
TEST_IMM_OP( ori, x11, x10, 0x33333335, 0x33333334, 0x5, x3, 588, x1)

inst_158:
// rs1_val==858993460 and imm_val==-1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333334;  immval:-0x556
TEST_IMM_OP( ori, x11, x10, 0xfffffbbe, 0x33333334, -0x556, x3, 592, x1)

inst_159:
// rs1_val==858993460 and imm_val==1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333334;  immval:0x555
TEST_IMM_OP( ori, x11, x10, 0x33333775, 0x33333334, 0x555, x3, 596, x1)

inst_160:
// rs1_val==858993460 and imm_val==3, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333334;  immval:0x3
TEST_IMM_OP( ori, x11, x10, 0x33333337, 0x33333334, 0x3, x3, 600, x1)

inst_161:
// rs1_val==6 and imm_val==46, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x6;  immval:0x2e
TEST_IMM_OP( ori, x11, x10, 0x2e, 0x6, 0x2e, x3, 604, x1)

inst_162:
// rs1_val==6 and imm_val==-44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x6;  immval:-0x2c
TEST_IMM_OP( ori, x11, x10, 0xffffffd6, 0x6, -0x2c, x3, 608, x1)

inst_163:
// rs1_val==6 and imm_val==1639, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x6;  immval:0x667
TEST_IMM_OP( ori, x11, x10, 0x667, 0x6, 0x667, x3, 612, x1)

inst_164:
// rs1_val==6 and imm_val==820, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x6;  immval:0x334
TEST_IMM_OP( ori, x11, x10, 0x336, 0x6, 0x334, x3, 616, x1)

inst_165:
// rs1_val==6 and imm_val==6, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x6;  immval:0x6
TEST_IMM_OP( ori, x11, x10, 0x6, 0x6, 0x6, x3, 620, x1)

inst_166:
// rs1_val==6 and imm_val==-1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x6;  immval:-0x555
TEST_IMM_OP( ori, x11, x10, 0xfffffaaf, 0x6, -0x555, x3, 624, x1)

inst_167:
// rs1_val==6 and imm_val==1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x6;  immval:0x556
TEST_IMM_OP( ori, x11, x10, 0x556, 0x6, 0x556, x3, 628, x1)

inst_168:
// rs1_val==6 and imm_val==4, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x6;  immval:0x4
TEST_IMM_OP( ori, x11, x10, 0x6, 0x6, 0x4, x3, 632, x1)

inst_169:
// rs1_val==6 and imm_val==44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x6;  immval:0x2c
TEST_IMM_OP( ori, x11, x10, 0x2e, 0x6, 0x2c, x3, 636, x1)

inst_170:
// rs1_val==6 and imm_val==0, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x6;  immval:0x0
TEST_IMM_OP( ori, x11, x10, 0x6, 0x6, 0x0, x3, 640, x1)

inst_171:
// rs1_val==6 and imm_val==1637, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x6;  immval:0x665
TEST_IMM_OP( ori, x11, x10, 0x667, 0x6, 0x665, x3, 644, x1)

inst_172:
// rs1_val==6 and imm_val==818, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x6;  immval:0x332
TEST_IMM_OP( ori, x11, x10, 0x336, 0x6, 0x332, x3, 648, x1)

inst_173:
// rs1_val==6 and imm_val==1364, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x6;  immval:0x554
TEST_IMM_OP( ori, x11, x10, 0x556, 0x6, 0x554, x3, 652, x1)

inst_174:
// rs1_val==6 and imm_val==2, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x6;  immval:0x2
TEST_IMM_OP( ori, x11, x10, 0x6, 0x6, 0x2, x3, 656, x1)

inst_175:
// rs1_val==6 and imm_val==45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x6;  immval:0x2d
TEST_IMM_OP( ori, x11, x10, 0x2f, 0x6, 0x2d, x3, 660, x1)

inst_176:
// rs1_val==6 and imm_val==-45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x6;  immval:-0x2d
TEST_IMM_OP( ori, x11, x10, 0xffffffd7, 0x6, -0x2d, x3, 664, x1)

inst_177:
// rs1_val==6 and imm_val==1638, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x6;  immval:0x666
TEST_IMM_OP( ori, x11, x10, 0x666, 0x6, 0x666, x3, 668, x1)

inst_178:
// rs1_val==6 and imm_val==819, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x6;  immval:0x333
TEST_IMM_OP( ori, x11, x10, 0x337, 0x6, 0x333, x3, 672, x1)

inst_179:
// rs1_val==6 and imm_val==5, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x6;  immval:0x5
TEST_IMM_OP( ori, x11, x10, 0x7, 0x6, 0x5, x3, 676, x1)

inst_180:
// rs1_val==6 and imm_val==-1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x6;  immval:-0x556
TEST_IMM_OP( ori, x11, x10, 0xfffffaae, 0x6, -0x556, x3, 680, x1)

inst_181:
// rs1_val==6 and imm_val==1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x6;  immval:0x555
TEST_IMM_OP( ori, x11, x10, 0x557, 0x6, 0x555, x3, 684, x1)

inst_182:
// rs1_val==6 and imm_val==3, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x6;  immval:0x3
TEST_IMM_OP( ori, x11, x10, 0x7, 0x6, 0x3, x3, 688, x1)

inst_183:
// rs1_val==-1431655765 and imm_val==46, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555555;  immval:0x2e
TEST_IMM_OP( ori, x11, x10, 0xaaaaaaaf, -0x55555555, 0x2e, x3, 692, x1)

inst_184:
// rs1_val==-1431655765 and imm_val==-44, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555555;  immval:-0x2c
TEST_IMM_OP( ori, x11, x10, 0xffffffff, -0x55555555, -0x2c, x3, 696, x1)

inst_185:
// rs1_val==-1431655765 and imm_val==1639, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555555;  immval:0x667
TEST_IMM_OP( ori, x11, x10, 0xaaaaaeef, -0x55555555, 0x667, x3, 700, x1)

inst_186:
// rs1_val==-1431655765 and imm_val==820, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555555;  immval:0x334
TEST_IMM_OP( ori, x11, x10, 0xaaaaabbf, -0x55555555, 0x334, x3, 704, x1)

inst_187:
// rs1_val==-1431655765 and imm_val==6, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555555;  immval:0x6
TEST_IMM_OP( ori, x11, x10, 0xaaaaaaaf, -0x55555555, 0x6, x3, 708, x1)

inst_188:
// rs1_val==-1431655765 and imm_val==-1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555555;  immval:-0x555
TEST_IMM_OP( ori, x11, x10, 0xfffffaab, -0x55555555, -0x555, x3, 712, x1)

inst_189:
// rs1_val==-1431655765 and imm_val==1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555555;  immval:0x556
TEST_IMM_OP( ori, x11, x10, 0xaaaaafff, -0x55555555, 0x556, x3, 716, x1)

inst_190:
// rs1_val==-1431655765 and imm_val==4, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555555;  immval:0x4
TEST_IMM_OP( ori, x11, x10, 0xaaaaaaaf, -0x55555555, 0x4, x3, 720, x1)

inst_191:
// rs1_val==-1431655765 and imm_val==44, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555555;  immval:0x2c
TEST_IMM_OP( ori, x11, x10, 0xaaaaaaaf, -0x55555555, 0x2c, x3, 724, x1)

inst_192:
// rs1_val==-1431655765 and imm_val==0, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555555;  immval:0x0
TEST_IMM_OP( ori, x11, x10, 0xaaaaaaab, -0x55555555, 0x0, x3, 728, x1)

inst_193:
// rs1_val==-1431655765 and imm_val==1637, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555555;  immval:0x665
TEST_IMM_OP( ori, x11, x10, 0xaaaaaeef, -0x55555555, 0x665, x3, 732, x1)

inst_194:
// rs1_val==-1431655765 and imm_val==818, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555555;  immval:0x332
TEST_IMM_OP( ori, x11, x10, 0xaaaaabbb, -0x55555555, 0x332, x3, 736, x1)

inst_195:
// rs1_val==-1431655765 and imm_val==1364, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555555;  immval:0x554
TEST_IMM_OP( ori, x11, x10, 0xaaaaafff, -0x55555555, 0x554, x3, 740, x1)

inst_196:
// rs1_val==-1431655765 and imm_val==2, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555555;  immval:0x2
TEST_IMM_OP( ori, x11, x10, 0xaaaaaaab, -0x55555555, 0x2, x3, 744, x1)

inst_197:
// rs1_val==-1431655765 and imm_val==45, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555555;  immval:0x2d
TEST_IMM_OP( ori, x11, x10, 0xaaaaaaaf, -0x55555555, 0x2d, x3, 748, x1)

inst_198:
// rs1_val==-1431655765 and imm_val==-45, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555555;  immval:-0x2d
TEST_IMM_OP( ori, x11, x10, 0xfffffffb, -0x55555555, -0x2d, x3, 752, x1)

inst_199:
// rs1_val==-1431655765 and imm_val==1638, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555555;  immval:0x666
TEST_IMM_OP( ori, x11, x10, 0xaaaaaeef, -0x55555555, 0x666, x3, 756, x1)

inst_200:
// rs1_val==-1431655765 and imm_val==819, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555555;  immval:0x333
TEST_IMM_OP( ori, x11, x10, 0xaaaaabbb, -0x55555555, 0x333, x3, 760, x1)

inst_201:
// rs1_val==-1431655765 and imm_val==5, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555555;  immval:0x5
TEST_IMM_OP( ori, x11, x10, 0xaaaaaaaf, -0x55555555, 0x5, x3, 764, x1)

inst_202:
// rs1_val==-1431655765 and imm_val==-1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555555;  immval:-0x556
TEST_IMM_OP( ori, x11, x10, 0xfffffaab, -0x55555555, -0x556, x3, 768, x1)

inst_203:
// rs1_val==-1431655765 and imm_val==1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555555;  immval:0x555
TEST_IMM_OP( ori, x11, x10, 0xaaaaafff, -0x55555555, 0x555, x3, 772, x1)

inst_204:
// rs1_val==-1431655765 and imm_val==3, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555555;  immval:0x3
TEST_IMM_OP( ori, x11, x10, 0xaaaaaaab, -0x55555555, 0x3, x3, 776, x1)

inst_205:
// rs1_val==1431655766 and imm_val==46, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555556;  immval:0x2e
TEST_IMM_OP( ori, x11, x10, 0x5555557e, 0x55555556, 0x2e, x3, 780, x1)

inst_206:
// rs1_val==1431655766 and imm_val==-44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555556;  immval:-0x2c
TEST_IMM_OP( ori, x11, x10, 0xffffffd6, 0x55555556, -0x2c, x3, 784, x1)

inst_207:
// rs1_val==1431655766 and imm_val==1639, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555556;  immval:0x667
TEST_IMM_OP( ori, x11, x10, 0x55555777, 0x55555556, 0x667, x3, 788, x1)

inst_208:
// rs1_val==1431655766 and imm_val==820, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555556;  immval:0x334
TEST_IMM_OP( ori, x11, x10, 0x55555776, 0x55555556, 0x334, x3, 792, x1)

inst_209:
// rs1_val==1431655766 and imm_val==6, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555556;  immval:0x6
TEST_IMM_OP( ori, x11, x10, 0x55555556, 0x55555556, 0x6, x3, 796, x1)

inst_210:
// rs1_val==1431655766 and imm_val==-1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555556;  immval:-0x555
TEST_IMM_OP( ori, x11, x10, 0xffffffff, 0x55555556, -0x555, x3, 800, x1)

inst_211:
// rs1_val==1431655766 and imm_val==1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555556;  immval:0x556
TEST_IMM_OP( ori, x11, x10, 0x55555556, 0x55555556, 0x556, x3, 804, x1)

inst_212:
// rs1_val==1431655766 and imm_val==4, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555556;  immval:0x4
TEST_IMM_OP( ori, x11, x10, 0x55555556, 0x55555556, 0x4, x3, 808, x1)

inst_213:
// rs1_val==1431655766 and imm_val==44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555556;  immval:0x2c
TEST_IMM_OP( ori, x11, x10, 0x5555557e, 0x55555556, 0x2c, x3, 812, x1)

inst_214:
// rs1_val==1431655766 and imm_val==0, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555556;  immval:0x0
TEST_IMM_OP( ori, x11, x10, 0x55555556, 0x55555556, 0x0, x3, 816, x1)

inst_215:
// rs1_val==1431655766 and imm_val==1637, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555556;  immval:0x665
TEST_IMM_OP( ori, x11, x10, 0x55555777, 0x55555556, 0x665, x3, 820, x1)

inst_216:
// rs1_val==1431655766 and imm_val==818, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555556;  immval:0x332
TEST_IMM_OP( ori, x11, x10, 0x55555776, 0x55555556, 0x332, x3, 824, x1)

inst_217:
// rs1_val==1431655766 and imm_val==1364, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555556;  immval:0x554
TEST_IMM_OP( ori, x11, x10, 0x55555556, 0x55555556, 0x554, x3, 828, x1)

inst_218:
// rs1_val==1431655766 and imm_val==2, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555556;  immval:0x2
TEST_IMM_OP( ori, x11, x10, 0x55555556, 0x55555556, 0x2, x3, 832, x1)

inst_219:
// rs1_val==1431655766 and imm_val==45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555556;  immval:0x2d
TEST_IMM_OP( ori, x11, x10, 0x5555557f, 0x55555556, 0x2d, x3, 836, x1)

inst_220:
// rs1_val==1431655766 and imm_val==-45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555556;  immval:-0x2d
TEST_IMM_OP( ori, x11, x10, 0xffffffd7, 0x55555556, -0x2d, x3, 840, x1)

inst_221:
// rs1_val==1431655766 and imm_val==1638, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555556;  immval:0x666
TEST_IMM_OP( ori, x11, x10, 0x55555776, 0x55555556, 0x666, x3, 844, x1)

inst_222:
// rs1_val==1431655766 and imm_val==819, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555556;  immval:0x333
TEST_IMM_OP( ori, x11, x10, 0x55555777, 0x55555556, 0x333, x3, 848, x1)

inst_223:
// rs1_val==1431655766 and imm_val==5, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555556;  immval:0x5
TEST_IMM_OP( ori, x11, x10, 0x55555557, 0x55555556, 0x5, x3, 852, x1)

inst_224:
// rs1_val==1431655766 and imm_val==-1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555556;  immval:-0x556
TEST_IMM_OP( ori, x11, x10, 0xfffffffe, 0x55555556, -0x556, x3, 856, x1)

inst_225:
// rs1_val==1431655766 and imm_val==1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555556;  immval:0x555
TEST_IMM_OP( ori, x11, x10, 0x55555557, 0x55555556, 0x555, x3, 860, x1)

inst_226:
// rs1_val==1431655766 and imm_val==3, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555556;  immval:0x3
TEST_IMM_OP( ori, x11, x10, 0x55555557, 0x55555556, 0x3, x3, 864, x1)

inst_227:
// rs1_val==4 and imm_val==46, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x4;  immval:0x2e
TEST_IMM_OP( ori, x11, x10, 0x2e, 0x4, 0x2e, x3, 868, x1)

inst_228:
// rs1_val==4 and imm_val==-44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x4;  immval:-0x2c
TEST_IMM_OP( ori, x11, x10, 0xffffffd4, 0x4, -0x2c, x3, 872, x1)

inst_229:
// rs1_val==4 and imm_val==1639, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x4;  immval:0x667
TEST_IMM_OP( ori, x11, x10, 0x667, 0x4, 0x667, x3, 876, x1)

inst_230:
// rs1_val==4 and imm_val==820, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x4;  immval:0x334
TEST_IMM_OP( ori, x11, x10, 0x334, 0x4, 0x334, x3, 880, x1)

inst_231:
// rs1_val==4 and imm_val==6, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x4;  immval:0x6
TEST_IMM_OP( ori, x11, x10, 0x6, 0x4, 0x6, x3, 884, x1)

inst_232:
// rs1_val==4 and imm_val==-1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x4;  immval:-0x555
TEST_IMM_OP( ori, x11, x10, 0xfffffaaf, 0x4, -0x555, x3, 888, x1)

inst_233:
// rs1_val==4 and imm_val==1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x4;  immval:0x556
TEST_IMM_OP( ori, x11, x10, 0x556, 0x4, 0x556, x3, 892, x1)

inst_234:
// rs1_val==4 and imm_val==4, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x4;  immval:0x4
TEST_IMM_OP( ori, x11, x10, 0x4, 0x4, 0x4, x3, 896, x1)

inst_235:
// rs1_val==4 and imm_val==44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x4;  immval:0x2c
TEST_IMM_OP( ori, x11, x10, 0x2c, 0x4, 0x2c, x3, 900, x1)

inst_236:
// rs1_val==4 and imm_val==0, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x4;  immval:0x0
TEST_IMM_OP( ori, x11, x10, 0x4, 0x4, 0x0, x3, 904, x1)

inst_237:
// rs1_val==4 and imm_val==1637, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x4;  immval:0x665
TEST_IMM_OP( ori, x11, x10, 0x665, 0x4, 0x665, x3, 908, x1)

inst_238:
// rs1_val==4 and imm_val==818, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x4;  immval:0x332
TEST_IMM_OP( ori, x11, x10, 0x336, 0x4, 0x332, x3, 912, x1)

inst_239:
// rs1_val==4 and imm_val==1364, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x4;  immval:0x554
TEST_IMM_OP( ori, x11, x10, 0x554, 0x4, 0x554, x3, 916, x1)

inst_240:
// rs1_val==4 and imm_val==2, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x4;  immval:0x2
TEST_IMM_OP( ori, x11, x10, 0x6, 0x4, 0x2, x3, 920, x1)

inst_241:
// rs1_val==4 and imm_val==45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x4;  immval:0x2d
TEST_IMM_OP( ori, x11, x10, 0x2d, 0x4, 0x2d, x3, 924, x1)

inst_242:
// rs1_val==4 and imm_val==-45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x4;  immval:-0x2d
TEST_IMM_OP( ori, x11, x10, 0xffffffd7, 0x4, -0x2d, x3, 928, x1)

inst_243:
// rs1_val==4 and imm_val==1638, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x4;  immval:0x666
TEST_IMM_OP( ori, x11, x10, 0x666, 0x4, 0x666, x3, 932, x1)

inst_244:
// rs1_val==4 and imm_val==819, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x4;  immval:0x333
TEST_IMM_OP( ori, x11, x10, 0x337, 0x4, 0x333, x3, 936, x1)

inst_245:
// rs1_val==4 and imm_val==5, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x4;  immval:0x5
TEST_IMM_OP( ori, x11, x10, 0x5, 0x4, 0x5, x3, 940, x1)

inst_246:
// rs1_val==4 and imm_val==-1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x4;  immval:-0x556
TEST_IMM_OP( ori, x11, x10, 0xfffffaae, 0x4, -0x556, x3, 944, x1)

inst_247:
// rs1_val==4 and imm_val==1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x4;  immval:0x555
TEST_IMM_OP( ori, x11, x10, 0x555, 0x4, 0x555, x3, 948, x1)

inst_248:
// rs1_val==4 and imm_val==3, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x4;  immval:0x3
TEST_IMM_OP( ori, x11, x10, 0x7, 0x4, 0x3, x3, 952, x1)

inst_249:
// rs1_val==46339 and imm_val==46, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb503;  immval:0x2e
TEST_IMM_OP( ori, x11, x10, 0xb52f, 0xb503, 0x2e, x3, 956, x1)

inst_250:
// rs1_val==46339 and imm_val==-44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb503;  immval:-0x2c
TEST_IMM_OP( ori, x11, x10, 0xffffffd7, 0xb503, -0x2c, x3, 960, x1)

inst_251:
// rs1_val==46339 and imm_val==1639, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb503;  immval:0x667
TEST_IMM_OP( ori, x11, x10, 0xb767, 0xb503, 0x667, x3, 964, x1)

inst_252:
// rs1_val==46339 and imm_val==820, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb503;  immval:0x334
TEST_IMM_OP( ori, x11, x10, 0xb737, 0xb503, 0x334, x3, 968, x1)

inst_253:
// rs1_val==46339 and imm_val==6, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb503;  immval:0x6
TEST_IMM_OP( ori, x11, x10, 0xb507, 0xb503, 0x6, x3, 972, x1)

inst_254:
// rs1_val==46339 and imm_val==-1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb503;  immval:-0x555
TEST_IMM_OP( ori, x11, x10, 0xffffffab, 0xb503, -0x555, x3, 976, x1)

inst_255:
// rs1_val==46339 and imm_val==1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb503;  immval:0x556
TEST_IMM_OP( ori, x11, x10, 0xb557, 0xb503, 0x556, x3, 980, x1)

inst_256:
// rs1_val==46339 and imm_val==4, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb503;  immval:0x4
TEST_IMM_OP( ori, x11, x10, 0xb507, 0xb503, 0x4, x3, 984, x1)

inst_257:
// rs1_val==46339 and imm_val==44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb503;  immval:0x2c
TEST_IMM_OP( ori, x11, x10, 0xb52f, 0xb503, 0x2c, x3, 988, x1)

inst_258:
// rs1_val==46339 and imm_val==0, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb503;  immval:0x0
TEST_IMM_OP( ori, x11, x10, 0xb503, 0xb503, 0x0, x3, 992, x1)

inst_259:
// rs1_val==46339 and imm_val==1637, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb503;  immval:0x665
TEST_IMM_OP( ori, x11, x10, 0xb767, 0xb503, 0x665, x3, 996, x1)

inst_260:
// rs1_val==46339 and imm_val==818, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb503;  immval:0x332
TEST_IMM_OP( ori, x11, x10, 0xb733, 0xb503, 0x332, x3, 1000, x1)

inst_261:
// rs1_val==46339 and imm_val==1364, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb503;  immval:0x554
TEST_IMM_OP( ori, x11, x10, 0xb557, 0xb503, 0x554, x3, 1004, x1)

inst_262:
// rs1_val==46339 and imm_val==2, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb503;  immval:0x2
TEST_IMM_OP( ori, x11, x10, 0xb503, 0xb503, 0x2, x3, 1008, x1)

inst_263:
// rs1_val==46339 and imm_val==45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb503;  immval:0x2d
TEST_IMM_OP( ori, x11, x10, 0xb52f, 0xb503, 0x2d, x3, 1012, x1)

inst_264:
// rs1_val==46339 and imm_val==-45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb503;  immval:-0x2d
TEST_IMM_OP( ori, x11, x10, 0xffffffd3, 0xb503, -0x2d, x3, 1016, x1)

inst_265:
// rs1_val==46339 and imm_val==1638, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb503;  immval:0x666
TEST_IMM_OP( ori, x11, x10, 0xb767, 0xb503, 0x666, x3, 1020, x1)

inst_266:
// rs1_val==46339 and imm_val==819, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb503;  immval:0x333
TEST_IMM_OP( ori, x11, x10, 0xb733, 0xb503, 0x333, x3, 1024, x1)

inst_267:
// rs1_val==46339 and imm_val==5, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb503;  immval:0x5
TEST_IMM_OP( ori, x11, x10, 0xb507, 0xb503, 0x5, x3, 1028, x1)

inst_268:
// rs1_val==46339 and imm_val==-1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb503;  immval:-0x556
TEST_IMM_OP( ori, x11, x10, 0xffffffab, 0xb503, -0x556, x3, 1032, x1)

inst_269:
// rs1_val==46339 and imm_val==1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb503;  immval:0x555
TEST_IMM_OP( ori, x11, x10, 0xb557, 0xb503, 0x555, x3, 1036, x1)

inst_270:
// rs1_val==46339 and imm_val==3, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb503;  immval:0x3
TEST_IMM_OP( ori, x11, x10, 0xb503, 0xb503, 0x3, x3, 1040, x1)

inst_271:
// rs1_val==0 and imm_val==46, rs1_val == 0
// opcode: ori ; op1:x10; dest:x11; op1val:0x0;  immval:0x2e
TEST_IMM_OP( ori, x11, x10, 0x2e, 0x0, 0x2e, x3, 1044, x1)

inst_272:
// rs1_val==0 and imm_val==-44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x0;  immval:-0x2c
TEST_IMM_OP( ori, x11, x10, 0xffffffd4, 0x0, -0x2c, x3, 1048, x1)

inst_273:
// rs1_val==0 and imm_val==1639, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x0;  immval:0x667
TEST_IMM_OP( ori, x11, x10, 0x667, 0x0, 0x667, x3, 1052, x1)

inst_274:
// rs1_val==0 and imm_val==820, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x0;  immval:0x334
TEST_IMM_OP( ori, x11, x10, 0x334, 0x0, 0x334, x3, 1056, x1)

inst_275:
// rs1_val==0 and imm_val==6, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x0;  immval:0x6
TEST_IMM_OP( ori, x11, x10, 0x6, 0x0, 0x6, x3, 1060, x1)

inst_276:
// rs1_val==0 and imm_val==-1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x0;  immval:-0x555
TEST_IMM_OP( ori, x11, x10, 0xfffffaab, 0x0, -0x555, x3, 1064, x1)

inst_277:
// rs1_val==0 and imm_val==1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x0;  immval:0x556
TEST_IMM_OP( ori, x11, x10, 0x556, 0x0, 0x556, x3, 1068, x1)

inst_278:
// rs1_val==0 and imm_val==4, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x0;  immval:0x4
TEST_IMM_OP( ori, x11, x10, 0x4, 0x0, 0x4, x3, 1072, x1)

inst_279:
// rs1_val==0 and imm_val==44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x0;  immval:0x2c
TEST_IMM_OP( ori, x11, x10, 0x2c, 0x0, 0x2c, x3, 1076, x1)

inst_280:
// rs1_val==0 and imm_val==0, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x0;  immval:0x0
TEST_IMM_OP( ori, x11, x10, 0x0, 0x0, 0x0, x3, 1080, x1)

inst_281:
// rs1_val==0 and imm_val==1637, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x0;  immval:0x665
TEST_IMM_OP( ori, x11, x10, 0x665, 0x0, 0x665, x3, 1084, x1)

inst_282:
// rs1_val==0 and imm_val==818, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x0;  immval:0x332
TEST_IMM_OP( ori, x11, x10, 0x332, 0x0, 0x332, x3, 1088, x1)

inst_283:
// rs1_val==0 and imm_val==1364, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x0;  immval:0x554
TEST_IMM_OP( ori, x11, x10, 0x554, 0x0, 0x554, x3, 1092, x1)

inst_284:
// rs1_val==0 and imm_val==2, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x0;  immval:0x2
TEST_IMM_OP( ori, x11, x10, 0x2, 0x0, 0x2, x3, 1096, x1)

inst_285:
// rs1_val==0 and imm_val==45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x0;  immval:0x2d
TEST_IMM_OP( ori, x11, x10, 0x2d, 0x0, 0x2d, x3, 1100, x1)

inst_286:
// rs1_val==0 and imm_val==-45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x0;  immval:-0x2d
TEST_IMM_OP( ori, x11, x10, 0xffffffd3, 0x0, -0x2d, x3, 1104, x1)

inst_287:
// rs1_val==0 and imm_val==1638, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x0;  immval:0x666
TEST_IMM_OP( ori, x11, x10, 0x666, 0x0, 0x666, x3, 1108, x1)

inst_288:
// rs1_val==0 and imm_val==819, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x0;  immval:0x333
TEST_IMM_OP( ori, x11, x10, 0x333, 0x0, 0x333, x3, 1112, x1)

inst_289:
// rs1_val==0 and imm_val==5, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x0;  immval:0x5
TEST_IMM_OP( ori, x11, x10, 0x5, 0x0, 0x5, x3, 1116, x1)

inst_290:
// rs1_val==0 and imm_val==-1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x0;  immval:-0x556
TEST_IMM_OP( ori, x11, x10, 0xfffffaaa, 0x0, -0x556, x3, 1120, x1)

inst_291:
// rs1_val==0 and imm_val==1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x0;  immval:0x555
TEST_IMM_OP( ori, x11, x10, 0x555, 0x0, 0x555, x3, 1124, x1)

inst_292:
// rs1_val==0 and imm_val==3, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x0;  immval:0x3
TEST_IMM_OP( ori, x11, x10, 0x3, 0x0, 0x3, x3, 1128, x1)

inst_293:
// rs1_val==1717986917 and imm_val==46, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666665;  immval:0x2e
TEST_IMM_OP( ori, x11, x10, 0x6666666f, 0x66666665, 0x2e, x3, 1132, x1)

inst_294:
// rs1_val==1717986917 and imm_val==-44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666665;  immval:-0x2c
TEST_IMM_OP( ori, x11, x10, 0xfffffff5, 0x66666665, -0x2c, x3, 1136, x1)

inst_295:
// rs1_val==1717986917 and imm_val==1639, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666665;  immval:0x667
TEST_IMM_OP( ori, x11, x10, 0x66666667, 0x66666665, 0x667, x3, 1140, x1)

inst_296:
// rs1_val==1717986917 and imm_val==820, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666665;  immval:0x334
TEST_IMM_OP( ori, x11, x10, 0x66666775, 0x66666665, 0x334, x3, 1144, x1)

inst_297:
// rs1_val==1717986917 and imm_val==6, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666665;  immval:0x6
TEST_IMM_OP( ori, x11, x10, 0x66666667, 0x66666665, 0x6, x3, 1148, x1)

inst_298:
// rs1_val==1717986917 and imm_val==-1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666665;  immval:-0x555
TEST_IMM_OP( ori, x11, x10, 0xfffffeef, 0x66666665, -0x555, x3, 1152, x1)

inst_299:
// rs1_val==1717986917 and imm_val==1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666665;  immval:0x556
TEST_IMM_OP( ori, x11, x10, 0x66666777, 0x66666665, 0x556, x3, 1156, x1)

inst_300:
// rs1_val==1717986917 and imm_val==4, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666665;  immval:0x4
TEST_IMM_OP( ori, x11, x10, 0x66666665, 0x66666665, 0x4, x3, 1160, x1)

inst_301:
// rs1_val==1717986917 and imm_val==44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666665;  immval:0x2c
TEST_IMM_OP( ori, x11, x10, 0x6666666d, 0x66666665, 0x2c, x3, 1164, x1)

inst_302:
// rs1_val==-1431655766 and imm_val==-1365, rs1_val == -1431655766
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555556;  immval:-0x555
TEST_IMM_OP( ori, x11, x10, 0xfffffaab, -0x55555556, -0x555, x3, 1168, x1)

inst_303:
// rs1_val==-1431655766 and imm_val==1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555556;  immval:0x556
TEST_IMM_OP( ori, x11, x10, 0xaaaaaffe, -0x55555556, 0x556, x3, 1172, x1)

inst_304:
// rs1_val==-1431655766 and imm_val==4, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555556;  immval:0x4
TEST_IMM_OP( ori, x11, x10, 0xaaaaaaae, -0x55555556, 0x4, x3, 1176, x1)

inst_305:
// rs1_val==-1431655766 and imm_val==44, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555556;  immval:0x2c
TEST_IMM_OP( ori, x11, x10, 0xaaaaaaae, -0x55555556, 0x2c, x3, 1180, x1)

inst_306:
// rs1_val==-1431655766 and imm_val==0, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555556;  immval:0x0
TEST_IMM_OP( ori, x11, x10, 0xaaaaaaaa, -0x55555556, 0x0, x3, 1184, x1)

inst_307:
// rs1_val==-1431655766 and imm_val==1637, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555556;  immval:0x665
TEST_IMM_OP( ori, x11, x10, 0xaaaaaeef, -0x55555556, 0x665, x3, 1188, x1)

inst_308:
// rs1_val==-1431655766 and imm_val==818, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555556;  immval:0x332
TEST_IMM_OP( ori, x11, x10, 0xaaaaabba, -0x55555556, 0x332, x3, 1192, x1)

inst_309:
// rs1_val==-1431655766 and imm_val==1364, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555556;  immval:0x554
TEST_IMM_OP( ori, x11, x10, 0xaaaaaffe, -0x55555556, 0x554, x3, 1196, x1)

inst_310:
// rs1_val==-1431655766 and imm_val==2, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555556;  immval:0x2
TEST_IMM_OP( ori, x11, x10, 0xaaaaaaaa, -0x55555556, 0x2, x3, 1200, x1)

inst_311:
// rs1_val==-1431655766 and imm_val==45, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555556;  immval:0x2d
TEST_IMM_OP( ori, x11, x10, 0xaaaaaaaf, -0x55555556, 0x2d, x3, 1204, x1)

inst_312:
// rs1_val==-1431655766 and imm_val==-45, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555556;  immval:-0x2d
TEST_IMM_OP( ori, x11, x10, 0xfffffffb, -0x55555556, -0x2d, x3, 1208, x1)

inst_313:
// rs1_val==-1431655766 and imm_val==1638, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555556;  immval:0x666
TEST_IMM_OP( ori, x11, x10, 0xaaaaaeee, -0x55555556, 0x666, x3, 1212, x1)

inst_314:
// rs1_val==-1431655766 and imm_val==819, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555556;  immval:0x333
TEST_IMM_OP( ori, x11, x10, 0xaaaaabbb, -0x55555556, 0x333, x3, 1216, x1)

inst_315:
// rs1_val==-1431655766 and imm_val==5, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555556;  immval:0x5
TEST_IMM_OP( ori, x11, x10, 0xaaaaaaaf, -0x55555556, 0x5, x3, 1220, x1)

inst_316:
// rs1_val==-1431655766 and imm_val==-1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555556;  immval:-0x556
TEST_IMM_OP( ori, x11, x10, 0xfffffaaa, -0x55555556, -0x556, x3, 1224, x1)

inst_317:
// rs1_val==-1431655766 and imm_val==1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555556;  immval:0x555
TEST_IMM_OP( ori, x11, x10, 0xaaaaafff, -0x55555556, 0x555, x3, 1228, x1)

inst_318:
// rs1_val==-1431655766 and imm_val==3, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555556;  immval:0x3
TEST_IMM_OP( ori, x11, x10, 0xaaaaaaab, -0x55555556, 0x3, x3, 1232, x1)

inst_319:
// rs1_val==1431655765 and imm_val==46, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555555;  immval:0x2e
TEST_IMM_OP( ori, x11, x10, 0x5555557f, 0x55555555, 0x2e, x3, 1236, x1)

inst_320:
// rs1_val==1431655765 and imm_val==-44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555555;  immval:-0x2c
TEST_IMM_OP( ori, x11, x10, 0xffffffd5, 0x55555555, -0x2c, x3, 1240, x1)

inst_321:
// rs1_val==1431655765 and imm_val==1639, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555555;  immval:0x667
TEST_IMM_OP( ori, x11, x10, 0x55555777, 0x55555555, 0x667, x3, 1244, x1)

inst_322:
// rs1_val==1431655765 and imm_val==820, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555555;  immval:0x334
TEST_IMM_OP( ori, x11, x10, 0x55555775, 0x55555555, 0x334, x3, 1248, x1)

inst_323:
// rs1_val==1431655765 and imm_val==6, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555555;  immval:0x6
TEST_IMM_OP( ori, x11, x10, 0x55555557, 0x55555555, 0x6, x3, 1252, x1)

inst_324:
// rs1_val==1431655765 and imm_val==-1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555555;  immval:-0x555
TEST_IMM_OP( ori, x11, x10, 0xffffffff, 0x55555555, -0x555, x3, 1256, x1)

inst_325:
// rs1_val==1431655765 and imm_val==1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555555;  immval:0x556
TEST_IMM_OP( ori, x11, x10, 0x55555557, 0x55555555, 0x556, x3, 1260, x1)

inst_326:
// rs1_val==1431655765 and imm_val==4, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555555;  immval:0x4
TEST_IMM_OP( ori, x11, x10, 0x55555555, 0x55555555, 0x4, x3, 1264, x1)

inst_327:
// rs1_val==1431655765 and imm_val==44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555555;  immval:0x2c
TEST_IMM_OP( ori, x11, x10, 0x5555557d, 0x55555555, 0x2c, x3, 1268, x1)

inst_328:
// rs1_val==1431655765 and imm_val==0, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555555;  immval:0x0
TEST_IMM_OP( ori, x11, x10, 0x55555555, 0x55555555, 0x0, x3, 1272, x1)

inst_329:
// rs1_val==1431655765 and imm_val==1637, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555555;  immval:0x665
TEST_IMM_OP( ori, x11, x10, 0x55555775, 0x55555555, 0x665, x3, 1276, x1)

inst_330:
// rs1_val==1431655765 and imm_val==818, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555555;  immval:0x332
TEST_IMM_OP( ori, x11, x10, 0x55555777, 0x55555555, 0x332, x3, 1280, x1)

inst_331:
// rs1_val==1431655765 and imm_val==1364, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555555;  immval:0x554
TEST_IMM_OP( ori, x11, x10, 0x55555555, 0x55555555, 0x554, x3, 1284, x1)

inst_332:
// rs1_val==1431655765 and imm_val==2, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555555;  immval:0x2
TEST_IMM_OP( ori, x11, x10, 0x55555557, 0x55555555, 0x2, x3, 1288, x1)

inst_333:
// rs1_val==1431655765 and imm_val==45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555555;  immval:0x2d
TEST_IMM_OP( ori, x11, x10, 0x5555557d, 0x55555555, 0x2d, x3, 1292, x1)

inst_334:
// rs1_val==1431655765 and imm_val==-45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555555;  immval:-0x2d
TEST_IMM_OP( ori, x11, x10, 0xffffffd7, 0x55555555, -0x2d, x3, 1296, x1)

inst_335:
// rs1_val==1431655765 and imm_val==1638, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555555;  immval:0x666
TEST_IMM_OP( ori, x11, x10, 0x55555777, 0x55555555, 0x666, x3, 1300, x1)

inst_336:
// rs1_val==1431655765 and imm_val==819, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555555;  immval:0x333
TEST_IMM_OP( ori, x11, x10, 0x55555777, 0x55555555, 0x333, x3, 1304, x1)

inst_337:
// rs1_val==1431655765 and imm_val==5, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555555;  immval:0x5
TEST_IMM_OP( ori, x11, x10, 0x55555555, 0x55555555, 0x5, x3, 1308, x1)

inst_338:
// rs1_val==1431655765 and imm_val==-1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555555;  immval:-0x556
TEST_IMM_OP( ori, x11, x10, 0xffffffff, 0x55555555, -0x556, x3, 1312, x1)

inst_339:
// rs1_val==1431655765 and imm_val==1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555555;  immval:0x555
TEST_IMM_OP( ori, x11, x10, 0x55555555, 0x55555555, 0x555, x3, 1316, x1)

inst_340:
// rs1_val==1431655765 and imm_val==3, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555555;  immval:0x3
TEST_IMM_OP( ori, x11, x10, 0x55555557, 0x55555555, 0x3, x3, 1320, x1)

inst_341:
// rs1_val==3 and imm_val==46, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x3;  immval:0x2e
TEST_IMM_OP( ori, x11, x10, 0x2f, 0x3, 0x2e, x3, 1324, x1)

inst_342:
// rs1_val==3 and imm_val==-44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x3;  immval:-0x2c
TEST_IMM_OP( ori, x11, x10, 0xffffffd7, 0x3, -0x2c, x3, 1328, x1)

inst_343:
// rs1_val==3 and imm_val==1639, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x3;  immval:0x667
TEST_IMM_OP( ori, x11, x10, 0x667, 0x3, 0x667, x3, 1332, x1)

inst_344:
// rs1_val==3 and imm_val==820, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x3;  immval:0x334
TEST_IMM_OP( ori, x11, x10, 0x337, 0x3, 0x334, x3, 1336, x1)

inst_345:
// rs1_val==3 and imm_val==6, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x3;  immval:0x6
TEST_IMM_OP( ori, x11, x10, 0x7, 0x3, 0x6, x3, 1340, x1)

inst_346:
// rs1_val==3 and imm_val==-1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x3;  immval:-0x555
TEST_IMM_OP( ori, x11, x10, 0xfffffaab, 0x3, -0x555, x3, 1344, x1)

inst_347:
// rs1_val==3 and imm_val==1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x3;  immval:0x556
TEST_IMM_OP( ori, x11, x10, 0x557, 0x3, 0x556, x3, 1348, x1)

inst_348:
// rs1_val==3 and imm_val==4, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x3;  immval:0x4
TEST_IMM_OP( ori, x11, x10, 0x7, 0x3, 0x4, x3, 1352, x1)

inst_349:
// rs1_val==3 and imm_val==44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x3;  immval:0x2c
TEST_IMM_OP( ori, x11, x10, 0x2f, 0x3, 0x2c, x3, 1356, x1)

inst_350:
// rs1_val==3 and imm_val==0, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x3;  immval:0x0
TEST_IMM_OP( ori, x11, x10, 0x3, 0x3, 0x0, x3, 1360, x1)

inst_351:
// rs1_val==3 and imm_val==1637, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x3;  immval:0x665
TEST_IMM_OP( ori, x11, x10, 0x667, 0x3, 0x665, x3, 1364, x1)

inst_352:
// rs1_val==3 and imm_val==818, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x3;  immval:0x332
TEST_IMM_OP( ori, x11, x10, 0x333, 0x3, 0x332, x3, 1368, x1)

inst_353:
// rs1_val==3 and imm_val==1364, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x3;  immval:0x554
TEST_IMM_OP( ori, x11, x10, 0x557, 0x3, 0x554, x3, 1372, x1)

inst_354:
// rs1_val==3 and imm_val==2, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x3;  immval:0x2
TEST_IMM_OP( ori, x11, x10, 0x3, 0x3, 0x2, x3, 1376, x1)

inst_355:
// rs1_val==3 and imm_val==45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x3;  immval:0x2d
TEST_IMM_OP( ori, x11, x10, 0x2f, 0x3, 0x2d, x3, 1380, x1)

inst_356:
// rs1_val==3 and imm_val==-45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x3;  immval:-0x2d
TEST_IMM_OP( ori, x11, x10, 0xffffffd3, 0x3, -0x2d, x3, 1384, x1)

inst_357:
// rs1_val==3 and imm_val==1638, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x3;  immval:0x666
TEST_IMM_OP( ori, x11, x10, 0x667, 0x3, 0x666, x3, 1388, x1)

inst_358:
// rs1_val==3 and imm_val==819, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x3;  immval:0x333
TEST_IMM_OP( ori, x11, x10, 0x333, 0x3, 0x333, x3, 1392, x1)

inst_359:
// rs1_val==3 and imm_val==5, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x3;  immval:0x5
TEST_IMM_OP( ori, x11, x10, 0x7, 0x3, 0x5, x3, 1396, x1)

inst_360:
// rs1_val==3 and imm_val==-1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x3;  immval:-0x556
TEST_IMM_OP( ori, x11, x10, 0xfffffaab, 0x3, -0x556, x3, 1400, x1)

inst_361:
// rs1_val==3 and imm_val==1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x3;  immval:0x555
TEST_IMM_OP( ori, x11, x10, 0x557, 0x3, 0x555, x3, 1404, x1)

inst_362:
// rs1_val==3 and imm_val==3, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x3;  immval:0x3
TEST_IMM_OP( ori, x11, x10, 0x3, 0x3, 0x3, x3, 1408, x1)

inst_363:
// rs1_val==1717986917 and imm_val==0, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666665;  immval:0x0
TEST_IMM_OP( ori, x11, x10, 0x66666665, 0x66666665, 0x0, x3, 1412, x1)

inst_364:
// rs1_val==1717986917 and imm_val==1637, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666665;  immval:0x665
TEST_IMM_OP( ori, x11, x10, 0x66666665, 0x66666665, 0x665, x3, 1416, x1)

inst_365:
// rs1_val==1717986917 and imm_val==818, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666665;  immval:0x332
TEST_IMM_OP( ori, x11, x10, 0x66666777, 0x66666665, 0x332, x3, 1420, x1)

inst_366:
// rs1_val==1717986917 and imm_val==1364, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666665;  immval:0x554
TEST_IMM_OP( ori, x11, x10, 0x66666775, 0x66666665, 0x554, x3, 1424, x1)

inst_367:
// rs1_val==1717986917 and imm_val==2, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666665;  immval:0x2
TEST_IMM_OP( ori, x11, x10, 0x66666667, 0x66666665, 0x2, x3, 1428, x1)

inst_368:
// rs1_val==1717986917 and imm_val==45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666665;  immval:0x2d
TEST_IMM_OP( ori, x11, x10, 0x6666666d, 0x66666665, 0x2d, x3, 1432, x1)

inst_369:
// rs1_val==1717986917 and imm_val==-45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666665;  immval:-0x2d
TEST_IMM_OP( ori, x11, x10, 0xfffffff7, 0x66666665, -0x2d, x3, 1436, x1)

inst_370:
// rs1_val==1717986917 and imm_val==1638, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666665;  immval:0x666
TEST_IMM_OP( ori, x11, x10, 0x66666667, 0x66666665, 0x666, x3, 1440, x1)

inst_371:
// rs1_val==1717986917 and imm_val==819, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666665;  immval:0x333
TEST_IMM_OP( ori, x11, x10, 0x66666777, 0x66666665, 0x333, x3, 1444, x1)

inst_372:
// rs1_val==1717986917 and imm_val==5, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666665;  immval:0x5
TEST_IMM_OP( ori, x11, x10, 0x66666665, 0x66666665, 0x5, x3, 1448, x1)

inst_373:
// rs1_val==1717986917 and imm_val==-1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666665;  immval:-0x556
TEST_IMM_OP( ori, x11, x10, 0xfffffeef, 0x66666665, -0x556, x3, 1452, x1)

inst_374:
// rs1_val==1717986917 and imm_val==1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666665;  immval:0x555
TEST_IMM_OP( ori, x11, x10, 0x66666775, 0x66666665, 0x555, x3, 1456, x1)

inst_375:
// rs1_val==1717986917 and imm_val==3, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666665;  immval:0x3
TEST_IMM_OP( ori, x11, x10, 0x66666667, 0x66666665, 0x3, x3, 1460, x1)

inst_376:
// rs1_val==858993458 and imm_val==46, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333332;  immval:0x2e
TEST_IMM_OP( ori, x11, x10, 0x3333333e, 0x33333332, 0x2e, x3, 1464, x1)

inst_377:
// rs1_val==858993458 and imm_val==-44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333332;  immval:-0x2c
TEST_IMM_OP( ori, x11, x10, 0xfffffff6, 0x33333332, -0x2c, x3, 1468, x1)

inst_378:
// rs1_val==858993458 and imm_val==1639, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333332;  immval:0x667
TEST_IMM_OP( ori, x11, x10, 0x33333777, 0x33333332, 0x667, x3, 1472, x1)

inst_379:
// rs1_val==858993458 and imm_val==820, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333332;  immval:0x334
TEST_IMM_OP( ori, x11, x10, 0x33333336, 0x33333332, 0x334, x3, 1476, x1)

inst_380:
// rs1_val==858993458 and imm_val==6, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333332;  immval:0x6
TEST_IMM_OP( ori, x11, x10, 0x33333336, 0x33333332, 0x6, x3, 1480, x1)

inst_381:
// rs1_val==858993458 and imm_val==-1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333332;  immval:-0x555
TEST_IMM_OP( ori, x11, x10, 0xfffffbbb, 0x33333332, -0x555, x3, 1484, x1)

inst_382:
// rs1_val==858993458 and imm_val==1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333332;  immval:0x556
TEST_IMM_OP( ori, x11, x10, 0x33333776, 0x33333332, 0x556, x3, 1488, x1)

inst_383:
// rs1_val==858993458 and imm_val==4, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333332;  immval:0x4
TEST_IMM_OP( ori, x11, x10, 0x33333336, 0x33333332, 0x4, x3, 1492, x1)

inst_384:
// rs1_val==858993458 and imm_val==44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333332;  immval:0x2c
TEST_IMM_OP( ori, x11, x10, 0x3333333e, 0x33333332, 0x2c, x3, 1496, x1)

inst_385:
// rs1_val==858993458 and imm_val==0, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333332;  immval:0x0
TEST_IMM_OP( ori, x11, x10, 0x33333332, 0x33333332, 0x0, x3, 1500, x1)

inst_386:
// rs1_val==858993458 and imm_val==1637, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333332;  immval:0x665
TEST_IMM_OP( ori, x11, x10, 0x33333777, 0x33333332, 0x665, x3, 1504, x1)

inst_387:
// rs1_val==858993458 and imm_val==818, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333332;  immval:0x332
TEST_IMM_OP( ori, x11, x10, 0x33333332, 0x33333332, 0x332, x3, 1508, x1)

inst_388:
// rs1_val==858993458 and imm_val==1364, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333332;  immval:0x554
TEST_IMM_OP( ori, x11, x10, 0x33333776, 0x33333332, 0x554, x3, 1512, x1)

inst_389:
// rs1_val==858993458 and imm_val==2, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333332;  immval:0x2
TEST_IMM_OP( ori, x11, x10, 0x33333332, 0x33333332, 0x2, x3, 1516, x1)

inst_390:
// rs1_val==858993458 and imm_val==45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333332;  immval:0x2d
TEST_IMM_OP( ori, x11, x10, 0x3333333f, 0x33333332, 0x2d, x3, 1520, x1)

inst_391:
// rs1_val==858993458 and imm_val==-45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333332;  immval:-0x2d
TEST_IMM_OP( ori, x11, x10, 0xfffffff3, 0x33333332, -0x2d, x3, 1524, x1)

inst_392:
// rs1_val==858993458 and imm_val==1638, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333332;  immval:0x666
TEST_IMM_OP( ori, x11, x10, 0x33333776, 0x33333332, 0x666, x3, 1528, x1)

inst_393:
// rs1_val==858993458 and imm_val==819, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333332;  immval:0x333
TEST_IMM_OP( ori, x11, x10, 0x33333333, 0x33333332, 0x333, x3, 1532, x1)

inst_394:
// rs1_val==858993458 and imm_val==5, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333332;  immval:0x5
TEST_IMM_OP( ori, x11, x10, 0x33333337, 0x33333332, 0x5, x3, 1536, x1)

inst_395:
// rs1_val==858993458 and imm_val==-1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333332;  immval:-0x556
TEST_IMM_OP( ori, x11, x10, 0xfffffbba, 0x33333332, -0x556, x3, 1540, x1)

inst_396:
// rs1_val==858993458 and imm_val==1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333332;  immval:0x555
TEST_IMM_OP( ori, x11, x10, 0x33333777, 0x33333332, 0x555, x3, 1544, x1)

inst_397:
// rs1_val==858993458 and imm_val==3, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333332;  immval:0x3
TEST_IMM_OP( ori, x11, x10, 0x33333333, 0x33333332, 0x3, x3, 1548, x1)

inst_398:
// rs1_val==1431655764 and imm_val==46, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555554;  immval:0x2e
TEST_IMM_OP( ori, x11, x10, 0x5555557e, 0x55555554, 0x2e, x3, 1552, x1)

inst_399:
// rs1_val==1431655764 and imm_val==-44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555554;  immval:-0x2c
TEST_IMM_OP( ori, x11, x10, 0xffffffd4, 0x55555554, -0x2c, x3, 1556, x1)

inst_400:
// rs1_val==1431655764 and imm_val==1639, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555554;  immval:0x667
TEST_IMM_OP( ori, x11, x10, 0x55555777, 0x55555554, 0x667, x3, 1560, x1)

inst_401:
// rs1_val==1431655764 and imm_val==820, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555554;  immval:0x334
TEST_IMM_OP( ori, x11, x10, 0x55555774, 0x55555554, 0x334, x3, 1564, x1)

inst_402:
// rs1_val==1431655764 and imm_val==6, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555554;  immval:0x6
TEST_IMM_OP( ori, x11, x10, 0x55555556, 0x55555554, 0x6, x3, 1568, x1)

inst_403:
// rs1_val==1431655764 and imm_val==-1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555554;  immval:-0x555
TEST_IMM_OP( ori, x11, x10, 0xffffffff, 0x55555554, -0x555, x3, 1572, x1)

inst_404:
// rs1_val==1431655764 and imm_val==1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555554;  immval:0x556
TEST_IMM_OP( ori, x11, x10, 0x55555556, 0x55555554, 0x556, x3, 1576, x1)

inst_405:
// rs1_val==1431655764 and imm_val==4, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555554;  immval:0x4
TEST_IMM_OP( ori, x11, x10, 0x55555554, 0x55555554, 0x4, x3, 1580, x1)

inst_406:
// rs1_val==1431655764 and imm_val==44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555554;  immval:0x2c
TEST_IMM_OP( ori, x11, x10, 0x5555557c, 0x55555554, 0x2c, x3, 1584, x1)

inst_407:
// rs1_val==1431655764 and imm_val==0, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555554;  immval:0x0
TEST_IMM_OP( ori, x11, x10, 0x55555554, 0x55555554, 0x0, x3, 1588, x1)

inst_408:
// rs1_val==1431655764 and imm_val==1637, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555554;  immval:0x665
TEST_IMM_OP( ori, x11, x10, 0x55555775, 0x55555554, 0x665, x3, 1592, x1)

inst_409:
// rs1_val==1431655764 and imm_val==818, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555554;  immval:0x332
TEST_IMM_OP( ori, x11, x10, 0x55555776, 0x55555554, 0x332, x3, 1596, x1)

inst_410:
// rs1_val==1431655764 and imm_val==1364, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555554;  immval:0x554
TEST_IMM_OP( ori, x11, x10, 0x55555554, 0x55555554, 0x554, x3, 1600, x1)

inst_411:
// rs1_val==1431655764 and imm_val==2, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555554;  immval:0x2
TEST_IMM_OP( ori, x11, x10, 0x55555556, 0x55555554, 0x2, x3, 1604, x1)

inst_412:
// rs1_val==1431655764 and imm_val==45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555554;  immval:0x2d
TEST_IMM_OP( ori, x11, x10, 0x5555557d, 0x55555554, 0x2d, x3, 1608, x1)

inst_413:
// rs1_val==1431655764 and imm_val==-45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555554;  immval:-0x2d
TEST_IMM_OP( ori, x11, x10, 0xffffffd7, 0x55555554, -0x2d, x3, 1612, x1)

inst_414:
// rs1_val==1431655764 and imm_val==1638, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555554;  immval:0x666
TEST_IMM_OP( ori, x11, x10, 0x55555776, 0x55555554, 0x666, x3, 1616, x1)

inst_415:
// rs1_val==1431655764 and imm_val==819, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555554;  immval:0x333
TEST_IMM_OP( ori, x11, x10, 0x55555777, 0x55555554, 0x333, x3, 1620, x1)

inst_416:
// rs1_val==1431655764 and imm_val==5, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555554;  immval:0x5
TEST_IMM_OP( ori, x11, x10, 0x55555555, 0x55555554, 0x5, x3, 1624, x1)

inst_417:
// rs1_val==1431655764 and imm_val==-1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555554;  immval:-0x556
TEST_IMM_OP( ori, x11, x10, 0xfffffffe, 0x55555554, -0x556, x3, 1628, x1)

inst_418:
// rs1_val==1431655764 and imm_val==1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555554;  immval:0x555
TEST_IMM_OP( ori, x11, x10, 0x55555555, 0x55555554, 0x555, x3, 1632, x1)

inst_419:
// rs1_val==1431655764 and imm_val==3, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555554;  immval:0x3
TEST_IMM_OP( ori, x11, x10, 0x55555557, 0x55555554, 0x3, x3, 1636, x1)

inst_420:
// rs1_val==2 and imm_val==46, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x2;  immval:0x2e
TEST_IMM_OP( ori, x11, x10, 0x2e, 0x2, 0x2e, x3, 1640, x1)

inst_421:
// rs1_val==2 and imm_val==-44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x2;  immval:-0x2c
TEST_IMM_OP( ori, x11, x10, 0xffffffd6, 0x2, -0x2c, x3, 1644, x1)

inst_422:
// rs1_val==2 and imm_val==1639, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x2;  immval:0x667
TEST_IMM_OP( ori, x11, x10, 0x667, 0x2, 0x667, x3, 1648, x1)

inst_423:
// rs1_val==2 and imm_val==820, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x2;  immval:0x334
TEST_IMM_OP( ori, x11, x10, 0x336, 0x2, 0x334, x3, 1652, x1)

inst_424:
// rs1_val==2 and imm_val==6, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x2;  immval:0x6
TEST_IMM_OP( ori, x11, x10, 0x6, 0x2, 0x6, x3, 1656, x1)

inst_425:
// rs1_val==2 and imm_val==-1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x2;  immval:-0x555
TEST_IMM_OP( ori, x11, x10, 0xfffffaab, 0x2, -0x555, x3, 1660, x1)

inst_426:
// rs1_val==2 and imm_val==1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x2;  immval:0x556
TEST_IMM_OP( ori, x11, x10, 0x556, 0x2, 0x556, x3, 1664, x1)

inst_427:
// rs1_val==2 and imm_val==4, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x2;  immval:0x4
TEST_IMM_OP( ori, x11, x10, 0x6, 0x2, 0x4, x3, 1668, x1)

inst_428:
// rs1_val==2 and imm_val==44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x2;  immval:0x2c
TEST_IMM_OP( ori, x11, x10, 0x2e, 0x2, 0x2c, x3, 1672, x1)

inst_429:
// rs1_val==2 and imm_val==0, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x2;  immval:0x0
TEST_IMM_OP( ori, x11, x10, 0x2, 0x2, 0x0, x3, 1676, x1)

inst_430:
// rs1_val==2 and imm_val==1637, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x2;  immval:0x665
TEST_IMM_OP( ori, x11, x10, 0x667, 0x2, 0x665, x3, 1680, x1)

inst_431:
// rs1_val==2 and imm_val==818, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x2;  immval:0x332
TEST_IMM_OP( ori, x11, x10, 0x332, 0x2, 0x332, x3, 1684, x1)

inst_432:
// rs1_val==2 and imm_val==1364, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x2;  immval:0x554
TEST_IMM_OP( ori, x11, x10, 0x556, 0x2, 0x554, x3, 1688, x1)

inst_433:
// rs1_val==2 and imm_val==45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x2;  immval:0x2d
TEST_IMM_OP( ori, x11, x10, 0x2f, 0x2, 0x2d, x3, 1692, x1)

inst_434:
// rs1_val==2 and imm_val==-45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x2;  immval:-0x2d
TEST_IMM_OP( ori, x11, x10, 0xffffffd3, 0x2, -0x2d, x3, 1696, x1)

inst_435:
// rs1_val==2 and imm_val==1638, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x2;  immval:0x666
TEST_IMM_OP( ori, x11, x10, 0x666, 0x2, 0x666, x3, 1700, x1)

inst_436:
// rs1_val==2 and imm_val==819, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x2;  immval:0x333
TEST_IMM_OP( ori, x11, x10, 0x333, 0x2, 0x333, x3, 1704, x1)

inst_437:
// rs1_val==2 and imm_val==5, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x2;  immval:0x5
TEST_IMM_OP( ori, x11, x10, 0x7, 0x2, 0x5, x3, 1708, x1)

inst_438:
// rs1_val==2 and imm_val==-1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x2;  immval:-0x556
TEST_IMM_OP( ori, x11, x10, 0xfffffaaa, 0x2, -0x556, x3, 1712, x1)

inst_439:
// rs1_val==2 and imm_val==1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x2;  immval:0x555
TEST_IMM_OP( ori, x11, x10, 0x557, 0x2, 0x555, x3, 1716, x1)

inst_440:
// rs1_val==2 and imm_val==3, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x2;  immval:0x3
TEST_IMM_OP( ori, x11, x10, 0x3, 0x2, 0x3, x3, 1720, x1)

inst_441:
// rs1_val==46340 and imm_val==46, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb504;  immval:0x2e
TEST_IMM_OP( ori, x11, x10, 0xb52e, 0xb504, 0x2e, x3, 1724, x1)

inst_442:
// rs1_val==46340 and imm_val==-44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb504;  immval:-0x2c
TEST_IMM_OP( ori, x11, x10, 0xffffffd4, 0xb504, -0x2c, x3, 1728, x1)

inst_443:
// rs1_val==46340 and imm_val==1639, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb504;  immval:0x667
TEST_IMM_OP( ori, x11, x10, 0xb767, 0xb504, 0x667, x3, 1732, x1)

inst_444:
// rs1_val==46340 and imm_val==820, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb504;  immval:0x334
TEST_IMM_OP( ori, x11, x10, 0xb734, 0xb504, 0x334, x3, 1736, x1)

inst_445:
// rs1_val==46340 and imm_val==6, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb504;  immval:0x6
TEST_IMM_OP( ori, x11, x10, 0xb506, 0xb504, 0x6, x3, 1740, x1)

inst_446:
// rs1_val==46340 and imm_val==-1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb504;  immval:-0x555
TEST_IMM_OP( ori, x11, x10, 0xffffffaf, 0xb504, -0x555, x3, 1744, x1)

inst_447:
// rs1_val==46340 and imm_val==1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb504;  immval:0x556
TEST_IMM_OP( ori, x11, x10, 0xb556, 0xb504, 0x556, x3, 1748, x1)

inst_448:
// rs1_val==46340 and imm_val==4, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb504;  immval:0x4
TEST_IMM_OP( ori, x11, x10, 0xb504, 0xb504, 0x4, x3, 1752, x1)

inst_449:
// rs1_val==46340 and imm_val==44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb504;  immval:0x2c
TEST_IMM_OP( ori, x11, x10, 0xb52c, 0xb504, 0x2c, x3, 1756, x1)

inst_450:
// rs1_val==46340 and imm_val==0, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb504;  immval:0x0
TEST_IMM_OP( ori, x11, x10, 0xb504, 0xb504, 0x0, x3, 1760, x1)

inst_451:
// rs1_val==46340 and imm_val==1637, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb504;  immval:0x665
TEST_IMM_OP( ori, x11, x10, 0xb765, 0xb504, 0x665, x3, 1764, x1)

inst_452:
// rs1_val==46340 and imm_val==818, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb504;  immval:0x332
TEST_IMM_OP( ori, x11, x10, 0xb736, 0xb504, 0x332, x3, 1768, x1)

inst_453:
// rs1_val==46340 and imm_val==1364, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb504;  immval:0x554
TEST_IMM_OP( ori, x11, x10, 0xb554, 0xb504, 0x554, x3, 1772, x1)

inst_454:
// rs1_val==46340 and imm_val==2, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb504;  immval:0x2
TEST_IMM_OP( ori, x11, x10, 0xb506, 0xb504, 0x2, x3, 1776, x1)

inst_455:
// rs1_val==46340 and imm_val==45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb504;  immval:0x2d
TEST_IMM_OP( ori, x11, x10, 0xb52d, 0xb504, 0x2d, x3, 1780, x1)

inst_456:
// rs1_val==46340 and imm_val==-45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb504;  immval:-0x2d
TEST_IMM_OP( ori, x11, x10, 0xffffffd7, 0xb504, -0x2d, x3, 1784, x1)

inst_457:
// rs1_val==46340 and imm_val==1638, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb504;  immval:0x666
TEST_IMM_OP( ori, x11, x10, 0xb766, 0xb504, 0x666, x3, 1788, x1)

inst_458:
// rs1_val==46340 and imm_val==819, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb504;  immval:0x333
TEST_IMM_OP( ori, x11, x10, 0xb737, 0xb504, 0x333, x3, 1792, x1)

inst_459:
// rs1_val==46340 and imm_val==5, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb504;  immval:0x5
TEST_IMM_OP( ori, x11, x10, 0xb505, 0xb504, 0x5, x3, 1796, x1)

inst_460:
// rs1_val==46340 and imm_val==-1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb504;  immval:-0x556
TEST_IMM_OP( ori, x11, x10, 0xffffffae, 0xb504, -0x556, x3, 1800, x1)

inst_461:
// rs1_val==46340 and imm_val==1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb504;  immval:0x555
TEST_IMM_OP( ori, x11, x10, 0xb555, 0xb504, 0x555, x3, 1804, x1)

inst_462:
// rs1_val==46340 and imm_val==3, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb504;  immval:0x3
TEST_IMM_OP( ori, x11, x10, 0xb507, 0xb504, 0x3, x3, 1808, x1)

inst_463:
// rs1_val==-46340 and imm_val==46, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb504;  immval:0x2e
TEST_IMM_OP( ori, x11, x10, 0xffff4afe, -0xb504, 0x2e, x3, 1812, x1)

inst_464:
// rs1_val==-46340 and imm_val==-44, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb504;  immval:-0x2c
TEST_IMM_OP( ori, x11, x10, 0xfffffffc, -0xb504, -0x2c, x3, 1816, x1)

inst_465:
// rs1_val==-46340 and imm_val==1639, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb504;  immval:0x667
TEST_IMM_OP( ori, x11, x10, 0xffff4eff, -0xb504, 0x667, x3, 1820, x1)

inst_466:
// rs1_val==-46340 and imm_val==820, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb504;  immval:0x334
TEST_IMM_OP( ori, x11, x10, 0xffff4bfc, -0xb504, 0x334, x3, 1824, x1)

inst_467:
// rs1_val==-46340 and imm_val==6, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb504;  immval:0x6
TEST_IMM_OP( ori, x11, x10, 0xffff4afe, -0xb504, 0x6, x3, 1828, x1)

inst_468:
// rs1_val==-46340 and imm_val==-1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb504;  immval:-0x555
TEST_IMM_OP( ori, x11, x10, 0xfffffaff, -0xb504, -0x555, x3, 1832, x1)

inst_469:
// rs1_val==-46340 and imm_val==1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb504;  immval:0x556
TEST_IMM_OP( ori, x11, x10, 0xffff4ffe, -0xb504, 0x556, x3, 1836, x1)

inst_470:
// rs1_val==-46340 and imm_val==4, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb504;  immval:0x4
TEST_IMM_OP( ori, x11, x10, 0xffff4afc, -0xb504, 0x4, x3, 1840, x1)

inst_471:
// rs1_val==-46340 and imm_val==44, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb504;  immval:0x2c
TEST_IMM_OP( ori, x11, x10, 0xffff4afc, -0xb504, 0x2c, x3, 1844, x1)

inst_472:
// rs1_val==-46340 and imm_val==0, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb504;  immval:0x0
TEST_IMM_OP( ori, x11, x10, 0xffff4afc, -0xb504, 0x0, x3, 1848, x1)

inst_473:
// rs1_val==-46340 and imm_val==1637, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb504;  immval:0x665
TEST_IMM_OP( ori, x11, x10, 0xffff4efd, -0xb504, 0x665, x3, 1852, x1)

inst_474:
// rs1_val==-46340 and imm_val==818, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb504;  immval:0x332
TEST_IMM_OP( ori, x11, x10, 0xffff4bfe, -0xb504, 0x332, x3, 1856, x1)

inst_475:
// rs1_val==-46340 and imm_val==1364, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb504;  immval:0x554
TEST_IMM_OP( ori, x11, x10, 0xffff4ffc, -0xb504, 0x554, x3, 1860, x1)

inst_476:
// rs1_val==-46340 and imm_val==2, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb504;  immval:0x2
TEST_IMM_OP( ori, x11, x10, 0xffff4afe, -0xb504, 0x2, x3, 1864, x1)

inst_477:
// rs1_val==-46340 and imm_val==45, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb504;  immval:0x2d
TEST_IMM_OP( ori, x11, x10, 0xffff4afd, -0xb504, 0x2d, x3, 1868, x1)

inst_478:
// rs1_val==-46340 and imm_val==-45, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb504;  immval:-0x2d
TEST_IMM_OP( ori, x11, x10, 0xffffffff, -0xb504, -0x2d, x3, 1872, x1)

inst_479:
// rs1_val==-46340 and imm_val==1638, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb504;  immval:0x666
TEST_IMM_OP( ori, x11, x10, 0xffff4efe, -0xb504, 0x666, x3, 1876, x1)

inst_480:
// rs1_val==-46340 and imm_val==819, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb504;  immval:0x333
TEST_IMM_OP( ori, x11, x10, 0xffff4bff, -0xb504, 0x333, x3, 1880, x1)

inst_481:
// rs1_val==-46340 and imm_val==5, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb504;  immval:0x5
TEST_IMM_OP( ori, x11, x10, 0xffff4afd, -0xb504, 0x5, x3, 1884, x1)

inst_482:
// rs1_val==-46340 and imm_val==-1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb504;  immval:-0x556
TEST_IMM_OP( ori, x11, x10, 0xfffffafe, -0xb504, -0x556, x3, 1888, x1)

inst_483:
// rs1_val==-46340 and imm_val==1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb504;  immval:0x555
TEST_IMM_OP( ori, x11, x10, 0xffff4ffd, -0xb504, 0x555, x3, 1892, x1)

inst_484:
// rs1_val==-46340 and imm_val==3, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb504;  immval:0x3
TEST_IMM_OP( ori, x11, x10, 0xffff4aff, -0xb504, 0x3, x3, 1896, x1)

inst_485:
// rs1_val==1717986918 and imm_val==46, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666666;  immval:0x2e
TEST_IMM_OP( ori, x11, x10, 0x6666666e, 0x66666666, 0x2e, x3, 1900, x1)

inst_486:
// rs1_val==1717986918 and imm_val==-44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666666;  immval:-0x2c
TEST_IMM_OP( ori, x11, x10, 0xfffffff6, 0x66666666, -0x2c, x3, 1904, x1)

inst_487:
// rs1_val==1717986918 and imm_val==1639, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666666;  immval:0x667
TEST_IMM_OP( ori, x11, x10, 0x66666667, 0x66666666, 0x667, x3, 1908, x1)

inst_488:
// rs1_val==1717986918 and imm_val==820, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666666;  immval:0x334
TEST_IMM_OP( ori, x11, x10, 0x66666776, 0x66666666, 0x334, x3, 1912, x1)

inst_489:
// rs1_val==1717986918 and imm_val==6, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666666;  immval:0x6
TEST_IMM_OP( ori, x11, x10, 0x66666666, 0x66666666, 0x6, x3, 1916, x1)

inst_490:
// rs1_val==1717986918 and imm_val==-1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666666;  immval:-0x555
TEST_IMM_OP( ori, x11, x10, 0xfffffeef, 0x66666666, -0x555, x3, 1920, x1)

inst_491:
// rs1_val==1717986918 and imm_val==1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666666;  immval:0x556
TEST_IMM_OP( ori, x11, x10, 0x66666776, 0x66666666, 0x556, x3, 1924, x1)

inst_492:
// rs1_val==1717986918 and imm_val==4, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666666;  immval:0x4
TEST_IMM_OP( ori, x11, x10, 0x66666666, 0x66666666, 0x4, x3, 1928, x1)

inst_493:
// rs1_val==1717986918 and imm_val==44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666666;  immval:0x2c
TEST_IMM_OP( ori, x11, x10, 0x6666666e, 0x66666666, 0x2c, x3, 1932, x1)

inst_494:
// rs1_val==1717986918 and imm_val==0, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666666;  immval:0x0
TEST_IMM_OP( ori, x11, x10, 0x66666666, 0x66666666, 0x0, x3, 1936, x1)

inst_495:
// rs1_val==1717986918 and imm_val==1637, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666666;  immval:0x665
TEST_IMM_OP( ori, x11, x10, 0x66666667, 0x66666666, 0x665, x3, 1940, x1)

inst_496:
// rs1_val==1717986918 and imm_val==818, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666666;  immval:0x332
TEST_IMM_OP( ori, x11, x10, 0x66666776, 0x66666666, 0x332, x3, 1944, x1)

inst_497:
// rs1_val==1717986918 and imm_val==1364, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666666;  immval:0x554
TEST_IMM_OP( ori, x11, x10, 0x66666776, 0x66666666, 0x554, x3, 1948, x1)

inst_498:
// rs1_val==1717986918 and imm_val==2, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666666;  immval:0x2
TEST_IMM_OP( ori, x11, x10, 0x66666666, 0x66666666, 0x2, x3, 1952, x1)

inst_499:
// rs1_val==1717986918 and imm_val==45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666666;  immval:0x2d
TEST_IMM_OP( ori, x11, x10, 0x6666666f, 0x66666666, 0x2d, x3, 1956, x1)

inst_500:
// rs1_val==1717986918 and imm_val==-45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666666;  immval:-0x2d
TEST_IMM_OP( ori, x11, x10, 0xfffffff7, 0x66666666, -0x2d, x3, 1960, x1)

inst_501:
// rs1_val==1717986918 and imm_val==1638, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666666;  immval:0x666
TEST_IMM_OP( ori, x11, x10, 0x66666666, 0x66666666, 0x666, x3, 1964, x1)

inst_502:
// rs1_val==1717986918 and imm_val==819, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666666;  immval:0x333
TEST_IMM_OP( ori, x11, x10, 0x66666777, 0x66666666, 0x333, x3, 1968, x1)

inst_503:
// rs1_val==1717986918 and imm_val==5, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666666;  immval:0x5
TEST_IMM_OP( ori, x11, x10, 0x66666667, 0x66666666, 0x5, x3, 1972, x1)

inst_504:
// rs1_val==1717986918 and imm_val==-1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666666;  immval:-0x556
TEST_IMM_OP( ori, x11, x10, 0xfffffeee, 0x66666666, -0x556, x3, 1976, x1)

inst_505:
// rs1_val==1717986918 and imm_val==1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666666;  immval:0x555
TEST_IMM_OP( ori, x11, x10, 0x66666777, 0x66666666, 0x555, x3, 1980, x1)

inst_506:
// rs1_val==1717986918 and imm_val==3, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666666;  immval:0x3
TEST_IMM_OP( ori, x11, x10, 0x66666667, 0x66666666, 0x3, x3, 1984, x1)

inst_507:
// rs1_val==858993459 and imm_val==46, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333333;  immval:0x2e
TEST_IMM_OP( ori, x11, x10, 0x3333333f, 0x33333333, 0x2e, x3, 1988, x1)

inst_508:
// rs1_val==858993459 and imm_val==-44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333333;  immval:-0x2c
TEST_IMM_OP( ori, x11, x10, 0xfffffff7, 0x33333333, -0x2c, x3, 1992, x1)

inst_509:
// rs1_val==858993459 and imm_val==1639, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333333;  immval:0x667
TEST_IMM_OP( ori, x11, x10, 0x33333777, 0x33333333, 0x667, x3, 1996, x1)

inst_510:
// rs1_val==858993459 and imm_val==820, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333333;  immval:0x334
TEST_IMM_OP( ori, x11, x10, 0x33333337, 0x33333333, 0x334, x3, 2000, x1)

inst_511:
// rs1_val==858993459 and imm_val==6, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333333;  immval:0x6
TEST_IMM_OP( ori, x11, x10, 0x33333337, 0x33333333, 0x6, x3, 2004, x1)

inst_512:
// rs1_val==858993459 and imm_val==-1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333333;  immval:-0x555
TEST_IMM_OP( ori, x11, x10, 0xfffffbbb, 0x33333333, -0x555, x3, 2008, x1)

inst_513:
// rs1_val==858993459 and imm_val==1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333333;  immval:0x556
TEST_IMM_OP( ori, x11, x10, 0x33333777, 0x33333333, 0x556, x3, 2012, x1)

inst_514:
// rs1_val==858993459 and imm_val==4, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333333;  immval:0x4
TEST_IMM_OP( ori, x11, x10, 0x33333337, 0x33333333, 0x4, x3, 2016, x1)

inst_515:
// rs1_val==858993459 and imm_val==44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333333;  immval:0x2c
TEST_IMM_OP( ori, x11, x10, 0x3333333f, 0x33333333, 0x2c, x3, 2020, x1)

inst_516:
// rs1_val==858993459 and imm_val==0, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333333;  immval:0x0
TEST_IMM_OP( ori, x11, x10, 0x33333333, 0x33333333, 0x0, x3, 2024, x1)

inst_517:
// rs1_val==858993459 and imm_val==1637, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333333;  immval:0x665
TEST_IMM_OP( ori, x11, x10, 0x33333777, 0x33333333, 0x665, x3, 2028, x1)

inst_518:
// rs1_val==858993459 and imm_val==818, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333333;  immval:0x332
TEST_IMM_OP( ori, x11, x10, 0x33333333, 0x33333333, 0x332, x3, 2032, x1)

inst_519:
// rs1_val==858993459 and imm_val==1364, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333333;  immval:0x554
TEST_IMM_OP( ori, x11, x10, 0x33333777, 0x33333333, 0x554, x3, 2036, x1)

inst_520:
// rs1_val==858993459 and imm_val==2, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333333;  immval:0x2
TEST_IMM_OP( ori, x11, x10, 0x33333333, 0x33333333, 0x2, x3, 2040, x1)

inst_521:
// rs1_val==858993459 and imm_val==45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333333;  immval:0x2d
TEST_IMM_OP( ori, x11, x10, 0x3333333f, 0x33333333, 0x2d, x3, 2044, x1)
RVTEST_SIGBASE( x3,signature_x3_1)

inst_522:
// rs1_val==858993459 and imm_val==-45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333333;  immval:-0x2d
TEST_IMM_OP( ori, x11, x10, 0xfffffff3, 0x33333333, -0x2d, x3, 0, x1)

inst_523:
// rs1_val==858993459 and imm_val==1638, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333333;  immval:0x666
TEST_IMM_OP( ori, x11, x10, 0x33333777, 0x33333333, 0x666, x3, 4, x1)

inst_524:
// rs1_val==858993459 and imm_val==819, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333333;  immval:0x333
TEST_IMM_OP( ori, x11, x10, 0x33333333, 0x33333333, 0x333, x3, 8, x1)

inst_525:
// rs1_val==858993459 and imm_val==5, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333333;  immval:0x5
TEST_IMM_OP( ori, x11, x10, 0x33333337, 0x33333333, 0x5, x3, 12, x1)

inst_526:
// rs1_val==858993459 and imm_val==-1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333333;  immval:-0x556
TEST_IMM_OP( ori, x11, x10, 0xfffffbbb, 0x33333333, -0x556, x3, 16, x1)

inst_527:
// rs1_val==858993459 and imm_val==1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333333;  immval:0x555
TEST_IMM_OP( ori, x11, x10, 0x33333777, 0x33333333, 0x555, x3, 20, x1)

inst_528:
// rs1_val==858993459 and imm_val==3, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333333;  immval:0x3
TEST_IMM_OP( ori, x11, x10, 0x33333333, 0x33333333, 0x3, x3, 24, x1)

inst_529:
// rs1_val==5 and imm_val==46, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x5;  immval:0x2e
TEST_IMM_OP( ori, x11, x10, 0x2f, 0x5, 0x2e, x3, 28, x1)

inst_530:
// rs1_val==5 and imm_val==-44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x5;  immval:-0x2c
TEST_IMM_OP( ori, x11, x10, 0xffffffd5, 0x5, -0x2c, x3, 32, x1)

inst_531:
// rs1_val==5 and imm_val==1639, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x5;  immval:0x667
TEST_IMM_OP( ori, x11, x10, 0x667, 0x5, 0x667, x3, 36, x1)

inst_532:
// rs1_val==5 and imm_val==820, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x5;  immval:0x334
TEST_IMM_OP( ori, x11, x10, 0x335, 0x5, 0x334, x3, 40, x1)

inst_533:
// rs1_val==5 and imm_val==6, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x5;  immval:0x6
TEST_IMM_OP( ori, x11, x10, 0x7, 0x5, 0x6, x3, 44, x1)

inst_534:
// rs1_val==5 and imm_val==-1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x5;  immval:-0x555
TEST_IMM_OP( ori, x11, x10, 0xfffffaaf, 0x5, -0x555, x3, 48, x1)

inst_535:
// rs1_val==5 and imm_val==1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x5;  immval:0x556
TEST_IMM_OP( ori, x11, x10, 0x557, 0x5, 0x556, x3, 52, x1)

inst_536:
// rs1_val==5 and imm_val==4, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x5;  immval:0x4
TEST_IMM_OP( ori, x11, x10, 0x5, 0x5, 0x4, x3, 56, x1)

inst_537:
// rs1_val==5 and imm_val==44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x5;  immval:0x2c
TEST_IMM_OP( ori, x11, x10, 0x2d, 0x5, 0x2c, x3, 60, x1)

inst_538:
// rs1_val==5 and imm_val==0, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x5;  immval:0x0
TEST_IMM_OP( ori, x11, x10, 0x5, 0x5, 0x0, x3, 64, x1)

inst_539:
// rs1_val==5 and imm_val==1637, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x5;  immval:0x665
TEST_IMM_OP( ori, x11, x10, 0x665, 0x5, 0x665, x3, 68, x1)

inst_540:
// rs1_val==5 and imm_val==818, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x5;  immval:0x332
TEST_IMM_OP( ori, x11, x10, 0x337, 0x5, 0x332, x3, 72, x1)

inst_541:
// rs1_val==5 and imm_val==1364, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x5;  immval:0x554
TEST_IMM_OP( ori, x11, x10, 0x555, 0x5, 0x554, x3, 76, x1)

inst_542:
// rs1_val==5 and imm_val==2, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x5;  immval:0x2
TEST_IMM_OP( ori, x11, x10, 0x7, 0x5, 0x2, x3, 80, x1)

inst_543:
// rs1_val==5 and imm_val==45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x5;  immval:0x2d
TEST_IMM_OP( ori, x11, x10, 0x2d, 0x5, 0x2d, x3, 84, x1)

inst_544:
// rs1_val==5 and imm_val==-45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x5;  immval:-0x2d
TEST_IMM_OP( ori, x11, x10, 0xffffffd7, 0x5, -0x2d, x3, 88, x1)

inst_545:
// rs1_val==5 and imm_val==1638, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x5;  immval:0x666
TEST_IMM_OP( ori, x11, x10, 0x667, 0x5, 0x666, x3, 92, x1)

inst_546:
// rs1_val==5 and imm_val==819, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x5;  immval:0x333
TEST_IMM_OP( ori, x11, x10, 0x337, 0x5, 0x333, x3, 96, x1)

inst_547:
// rs1_val==5 and imm_val==5, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x5;  immval:0x5
TEST_IMM_OP( ori, x11, x10, 0x5, 0x5, 0x5, x3, 100, x1)

inst_548:
// rs1_val==5 and imm_val==-1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x5;  immval:-0x556
TEST_IMM_OP( ori, x11, x10, 0xfffffaaf, 0x5, -0x556, x3, 104, x1)

inst_549:
// rs1_val==5 and imm_val==1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x5;  immval:0x555
TEST_IMM_OP( ori, x11, x10, 0x555, 0x5, 0x555, x3, 108, x1)

inst_550:
// rs1_val==5 and imm_val==3, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x5;  immval:0x3
TEST_IMM_OP( ori, x11, x10, 0x7, 0x5, 0x3, x3, 112, x1)

inst_551:
// rs1_val==-1431655766 and imm_val==46, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555556;  immval:0x2e
TEST_IMM_OP( ori, x11, x10, 0xaaaaaaae, -0x55555556, 0x2e, x3, 116, x1)

inst_552:
// rs1_val==-1431655766 and imm_val==-44, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555556;  immval:-0x2c
TEST_IMM_OP( ori, x11, x10, 0xfffffffe, -0x55555556, -0x2c, x3, 120, x1)

inst_553:
// rs1_val==-1431655766 and imm_val==1639, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555556;  immval:0x667
TEST_IMM_OP( ori, x11, x10, 0xaaaaaeef, -0x55555556, 0x667, x3, 124, x1)

inst_554:
// rs1_val==-1431655766 and imm_val==820, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555556;  immval:0x334
TEST_IMM_OP( ori, x11, x10, 0xaaaaabbe, -0x55555556, 0x334, x3, 128, x1)

inst_555:
// rs1_val==-1431655766 and imm_val==6, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555556;  immval:0x6
TEST_IMM_OP( ori, x11, x10, 0xaaaaaaae, -0x55555556, 0x6, x3, 132, x1)

inst_556:
// rs1_val == 2147483647, rs1_val > 0 and imm_val > 0, rs1_val == (2**(xlen-1)-1)
// opcode: ori ; op1:x10; dest:x11; op1val:0x7fffffff;  immval:0x3ff
TEST_IMM_OP( ori, x11, x10, 0x7fffffff, 0x7fffffff, 0x3ff, x3, 136, x1)
#endif


RVTEST_CODE_END
RVMODEL_HALT

RVTEST_DATA_BEGIN
.align 4

rvtest_data:
.word 0xbabecafe
.word 0xbabecafe
.word 0xbabecafe
.word 0xbabecafe
RVTEST_DATA_END


RVMODEL_DATA_BEGIN
rvtest_sig_begin:
sig_begin_canary:
CANARY;


signature_x1_0:
    .fill 0*(XLEN/32),4,0xdeadbeef


signature_x1_1:
    .fill 10*(XLEN/32),4,0xdeadbeef


signature_x3_0:
    .fill 512*(XLEN/32),4,0xdeadbeef


signature_x3_1:
    .fill 35*(XLEN/32),4,0xdeadbeef

#ifdef rvtest_mtrap_routine

tsig_begin_canary:
CANARY;
mtrap_sigptr:
    .fill 64*(XLEN/32),4,0xdeadbeef
tsig_end_canary:
CANARY;

#endif

#ifdef rvtest_gpr_save

gpr_save:
    .fill 32*(XLEN/32),4,0xdeadbeef

#endif

sig_end_canary:
CANARY;
rvtest_sig_end:
RVMODEL_DATA_END
