// -----------
// This file was generated by riscv_ctg (https://gitlab.com/incoresemi/riscv-compliance/riscv_ctg)
// version   : 0.5.1
// timestamp : Mon Aug  2 08:58:53 2021 GMT
// usage     : riscv_ctg \
//                  --cgf /home/bilalsakhawat/riscv-ctg/sample_cgfs/dataset.cgf \
//                  --cgf /home/bilalsakhawat/riscv-ctg/sample_cgfs/rv32e.cgf \
//                  --base-isa rv32e \
//                  --randomize
// -----------
//
// -----------
// Copyright (c) 2020. RISC-V International. All rights reserved.
// SPDX-License-Identifier: BSD-3-Clause
// -----------
//
// This assembly file tests the sb instruction of the RISC-V E extension for the sb-align covergroup.
// 
#include "model_test.h"
#include "arch_test.h"
RVTEST_ISA("RV32E")

.section .text.init
.globl rvtest_entry_point
rvtest_entry_point:
RVMODEL_BOOT
RVTEST_CODE_BEGIN

#ifdef TEST_CASE_1

RVTEST_CASE(0,"//check ISA:=regex(.*32.*);check ISA:=regex(.*E.*) ;def RVTEST_E = True;def TEST_CASE_1=True;",sb-align)

RVTEST_SIGBASE( x3,signature_x3_1)

inst_0:
// rs1 != rs2, rs1==x4, rs2==x0, ea_align == 0 and (imm_val % 4) == 0, imm_val > 0
// opcode: sb; op1:x4; op2:x0; op2val:0x0; immval:0x8; align:0
TEST_STORE(x3,x5,0,x4,x0,0x0,0x8,0,sb,0)

inst_1:
// rs1==x8, rs2==x11, rs2_val == 2147483647, imm_val < 0, ea_align == 0 and (imm_val % 4) == 3, rs2_val == (2**(xlen-1)-1)
// opcode: sb; op1:x8; op2:x11; op2val:0x7fffffff; immval:-0x41; align:0
TEST_STORE(x3,x5,0,x8,x11,0x7fffffff,-0x41,4,sb,0)

inst_2:
// rs1==x1, rs2==x15, rs2_val == -1073741825, 
// opcode: sb; op1:x1; op2:x15; op2val:-0x40000001; immval:-0x11; align:0
TEST_STORE(x3,x5,0,x1,x15,-0x40000001,-0x11,8,sb,0)

inst_3:
// rs1==x14, rs2==x2, rs2_val == -536870913, 
// opcode: sb; op1:x14; op2:x2; op2val:-0x20000001; immval:-0x101; align:0
TEST_STORE(x3,x5,0,x14,x2,-0x20000001,-0x101,12,sb,0)

inst_4:
// rs1==x15, rs2==x8, rs2_val == -268435457, ea_align == 0 and (imm_val % 4) == 1
// opcode: sb; op1:x15; op2:x8; op2val:-0x10000001; immval:-0x3; align:0
TEST_STORE(x3,x5,0,x15,x8,-0x10000001,-0x3,16,sb,0)

inst_5:
// rs1==x6, rs2==x7, rs2_val == -134217729, 
// opcode: sb; op1:x6; op2:x7; op2val:-0x8000001; immval:-0x8; align:0
TEST_STORE(x3,x5,0,x6,x7,-0x8000001,-0x8,20,sb,0)

inst_6:
// rs1==x2, rs2==x10, rs2_val == -67108865, 
// opcode: sb; op1:x2; op2:x10; op2val:-0x4000001; immval:0x7ff; align:0
TEST_STORE(x3,x5,0,x2,x10,-0x4000001,0x7ff,24,sb,0)

inst_7:
// rs1==x13, rs2==x6, rs2_val == -33554433, 
// opcode: sb; op1:x13; op2:x6; op2val:-0x2000001; immval:0x555; align:0
TEST_STORE(x3,x5,0,x13,x6,-0x2000001,0x555,28,sb,0)

inst_8:
// rs1==x7, rs2==x4, rs2_val == -16777217, 
// opcode: sb; op1:x7; op2:x4; op2val:-0x1000001; immval:0x100; align:0
TEST_STORE(x3,x2,0,x7,x4,-0x1000001,0x100,32,sb,0)

inst_9:
// rs1==x9, rs2==x1, rs2_val == -8388609, 
// opcode: sb; op1:x9; op2:x1; op2val:-0x800001; immval:-0x3; align:0
TEST_STORE(x3,x2,0,x9,x1,-0x800001,-0x3,36,sb,0)
RVTEST_SIGBASE( x1,signature_x1_0)

inst_10:
// rs1==x10, rs2==x12, rs2_val == -4194305, 
// opcode: sb; op1:x10; op2:x12; op2val:-0x400001; immval:0x1; align:0
TEST_STORE(x1,x2,0,x10,x12,-0x400001,0x1,0,sb,0)

inst_11:
// rs1==x3, rs2==x13, rs2_val == -2097153, 
// opcode: sb; op1:x3; op2:x13; op2val:-0x200001; immval:0x80; align:0
TEST_STORE(x1,x2,0,x3,x13,-0x200001,0x80,4,sb,0)

inst_12:
// rs1==x11, rs2==x5, rs2_val == -1048577, 
// opcode: sb; op1:x11; op2:x5; op2val:-0x100001; immval:-0x401; align:0
TEST_STORE(x1,x2,0,x11,x5,-0x100001,-0x401,8,sb,0)

inst_13:
// rs1==x5, rs2==x9, rs2_val == -524289, 
// opcode: sb; op1:x5; op2:x9; op2val:-0x80001; immval:-0x800; align:0
TEST_STORE(x1,x2,0,x5,x9,-0x80001,-0x800,12,sb,0)

inst_14:
// rs1==x12, rs2==x3, rs2_val == -262145, 
// opcode: sb; op1:x12; op2:x3; op2val:-0x40001; immval:-0x9; align:0
TEST_STORE(x1,x2,0,x12,x3,-0x40001,-0x9,16,sb,0)

inst_15:
// rs2==x14, rs2_val == -131073, 
// opcode: sb; op1:x4; op2:x14; op2val:-0x20001; immval:0x8; align:0
TEST_STORE(x1,x2,0,x4,x14,-0x20001,0x8,20,sb,0)

inst_16:
// rs2_val == -65537, 
// opcode: sb; op1:x10; op2:x11; op2val:-0x10001; immval:-0x800; align:0
TEST_STORE(x1,x2,0,x10,x11,-0x10001,-0x800,24,sb,0)

inst_17:
// rs2_val == -32769, 
// opcode: sb; op1:x10; op2:x11; op2val:-0x8001; immval:0x9; align:0
TEST_STORE(x1,x2,0,x10,x11,-0x8001,0x9,28,sb,0)

inst_18:
// rs2_val == -16385, ea_align == 0 and (imm_val % 4) == 2
// opcode: sb; op1:x10; op2:x11; op2val:-0x4001; immval:-0x556; align:0
TEST_STORE(x1,x2,0,x10,x11,-0x4001,-0x556,32,sb,0)

inst_19:
// rs2_val == -8193, 
// opcode: sb; op1:x10; op2:x11; op2val:-0x2001; immval:0x7ff; align:0
TEST_STORE(x1,x2,0,x10,x11,-0x2001,0x7ff,36,sb,0)

inst_20:
// rs2_val == -4097, 
// opcode: sb; op1:x10; op2:x11; op2val:-0x1001; immval:0x7; align:0
TEST_STORE(x1,x2,0,x10,x11,-0x1001,0x7,40,sb,0)

inst_21:
// rs2_val == -2049, 
// opcode: sb; op1:x10; op2:x11; op2val:-0x801; immval:-0x800; align:0
TEST_STORE(x1,x2,0,x10,x11,-0x801,-0x800,44,sb,0)

inst_22:
// rs2_val == -1025, 
// opcode: sb; op1:x10; op2:x11; op2val:-0x401; immval:0x9; align:0
TEST_STORE(x1,x2,0,x10,x11,-0x401,0x9,48,sb,0)

inst_23:
// rs2_val == -513, 
// opcode: sb; op1:x10; op2:x11; op2val:-0x201; immval:-0x3; align:0
TEST_STORE(x1,x2,0,x10,x11,-0x201,-0x3,52,sb,0)

inst_24:
// rs2_val == -257, 
// opcode: sb; op1:x10; op2:x11; op2val:-0x101; immval:-0x41; align:0
TEST_STORE(x1,x2,0,x10,x11,-0x101,-0x41,56,sb,0)

inst_25:
// rs2_val == -129, 
// opcode: sb; op1:x10; op2:x11; op2val:-0x81; immval:0x2; align:0
TEST_STORE(x1,x2,0,x10,x11,-0x81,0x2,60,sb,0)

inst_26:
// rs2_val == -65, 
// opcode: sb; op1:x10; op2:x11; op2val:-0x41; immval:-0xa; align:0
TEST_STORE(x1,x2,0,x10,x11,-0x41,-0xa,64,sb,0)

inst_27:
// rs2_val == -33, 
// opcode: sb; op1:x10; op2:x11; op2val:-0x21; immval:-0x41; align:0
TEST_STORE(x1,x2,0,x10,x11,-0x21,-0x41,68,sb,0)

inst_28:
// rs2_val == -17, 
// opcode: sb; op1:x10; op2:x11; op2val:-0x11; immval:0x3; align:0
TEST_STORE(x1,x2,0,x10,x11,-0x11,0x3,72,sb,0)

inst_29:
// rs2_val == -9, 
// opcode: sb; op1:x10; op2:x11; op2val:-0x9; immval:0x10; align:0
TEST_STORE(x1,x2,0,x10,x11,-0x9,0x10,76,sb,0)

inst_30:
// rs2_val == -5, 
// opcode: sb; op1:x10; op2:x11; op2val:-0x5; immval:-0x7; align:0
TEST_STORE(x1,x2,0,x10,x11,-0x5,-0x7,80,sb,0)

inst_31:
// rs2_val == -3, 
// opcode: sb; op1:x10; op2:x11; op2val:-0x3; immval:0x555; align:0
TEST_STORE(x1,x2,0,x10,x11,-0x3,0x555,84,sb,0)

inst_32:
// rs2_val == -2, 
// opcode: sb; op1:x10; op2:x11; op2val:-0x2; immval:-0xa; align:0
TEST_STORE(x1,x2,0,x10,x11,-0x2,-0xa,88,sb,0)

inst_33:
// rs2_val == -2147483648, rs2_val == (-2**(xlen-1))
// opcode: sb; op1:x10; op2:x11; op2val:-0x80000000; immval:-0x8; align:0
TEST_STORE(x1,x2,0,x10,x11,-0x80000000,-0x8,92,sb,0)

inst_34:
// rs2_val == 1073741824, 
// opcode: sb; op1:x10; op2:x11; op2val:0x40000000; immval:-0x5; align:0
TEST_STORE(x1,x2,0,x10,x11,0x40000000,-0x5,96,sb,0)

inst_35:
// rs2_val == 536870912, 
// opcode: sb; op1:x10; op2:x11; op2val:0x20000000; immval:-0x41; align:0
TEST_STORE(x1,x2,0,x10,x11,0x20000000,-0x41,100,sb,0)

inst_36:
// rs2_val == 268435456, 
// opcode: sb; op1:x10; op2:x11; op2val:0x10000000; immval:-0xa; align:0
TEST_STORE(x1,x2,0,x10,x11,0x10000000,-0xa,104,sb,0)

inst_37:
// rs2_val == 134217728, 
// opcode: sb; op1:x10; op2:x11; op2val:0x8000000; immval:0x555; align:0
TEST_STORE(x1,x2,0,x10,x11,0x8000000,0x555,108,sb,0)

inst_38:
// rs2_val == 67108864, 
// opcode: sb; op1:x10; op2:x11; op2val:0x4000000; immval:-0x81; align:0
TEST_STORE(x1,x2,0,x10,x11,0x4000000,-0x81,112,sb,0)

inst_39:
// rs2_val == 33554432, 
// opcode: sb; op1:x10; op2:x11; op2val:0x2000000; immval:-0x400; align:0
TEST_STORE(x1,x2,0,x10,x11,0x2000000,-0x400,116,sb,0)

inst_40:
// rs2_val == 16777216, 
// opcode: sb; op1:x10; op2:x11; op2val:0x1000000; immval:-0x41; align:0
TEST_STORE(x1,x2,0,x10,x11,0x1000000,-0x41,120,sb,0)

inst_41:
// rs2_val == 8388608, 
// opcode: sb; op1:x10; op2:x11; op2val:0x800000; immval:-0x5; align:0
TEST_STORE(x1,x2,0,x10,x11,0x800000,-0x5,124,sb,0)

inst_42:
// rs2_val == 4194304, 
// opcode: sb; op1:x10; op2:x11; op2val:0x400000; immval:-0x9; align:0
TEST_STORE(x1,x2,0,x10,x11,0x400000,-0x9,128,sb,0)

inst_43:
// rs2_val == 2097152, 
// opcode: sb; op1:x10; op2:x11; op2val:0x200000; immval:0x7ff; align:0
TEST_STORE(x1,x2,0,x10,x11,0x200000,0x7ff,132,sb,0)

inst_44:
// rs2_val == 1048576, 
// opcode: sb; op1:x10; op2:x11; op2val:0x100000; immval:-0x41; align:0
TEST_STORE(x1,x2,0,x10,x11,0x100000,-0x41,136,sb,0)

inst_45:
// rs2_val == 524288, 
// opcode: sb; op1:x10; op2:x11; op2val:0x80000; immval:-0x3; align:0
TEST_STORE(x1,x2,0,x10,x11,0x80000,-0x3,140,sb,0)

inst_46:
// rs2_val == 262144, 
// opcode: sb; op1:x10; op2:x11; op2val:0x40000; immval:0x6; align:0
TEST_STORE(x1,x2,0,x10,x11,0x40000,0x6,144,sb,0)

inst_47:
// rs2_val == 131072, 
// opcode: sb; op1:x10; op2:x11; op2val:0x20000; immval:0x80; align:0
TEST_STORE(x1,x2,0,x10,x11,0x20000,0x80,148,sb,0)

inst_48:
// rs2_val == 65536, 
// opcode: sb; op1:x10; op2:x11; op2val:0x10000; immval:0x555; align:0
TEST_STORE(x1,x2,0,x10,x11,0x10000,0x555,152,sb,0)

inst_49:
// rs2_val == 32768, 
// opcode: sb; op1:x10; op2:x11; op2val:0x8000; immval:0x5; align:0
TEST_STORE(x1,x2,0,x10,x11,0x8000,0x5,156,sb,0)

inst_50:
// rs2_val == 1, 
// opcode: sb; op1:x10; op2:x11; op2val:0x1; immval:0x400; align:0
TEST_STORE(x1,x2,0,x10,x11,0x1,0x400,160,sb,0)

inst_51:
// rs2_val == -1431655766, 
// opcode: sb; op1:x10; op2:x11; op2val:-0x55555556; immval:-0x6; align:0
TEST_STORE(x1,x2,0,x10,x11,-0x55555556,-0x6,164,sb,0)

inst_52:
// rs2_val == 1431655765, 
// opcode: sb; op1:x10; op2:x11; op2val:0x55555555; immval:0x555; align:0
TEST_STORE(x1,x2,0,x10,x11,0x55555555,0x555,168,sb,0)

inst_53:
// ea_align == 1 and (imm_val % 4) == 0, 
// opcode: sb; op1:x10; op2:x11; op2val:-0x5; immval:0x20; align:1
TEST_STORE(x1,x2,0,x10,x11,-0x5,0x20,172,sb,1)

inst_54:
// ea_align == 1 and (imm_val % 4) == 1, 
// opcode: sb; op1:x10; op2:x11; op2val:-0x101; immval:0x5; align:1
TEST_STORE(x1,x2,0,x10,x11,-0x101,0x5,176,sb,1)

inst_55:
// ea_align == 1 and (imm_val % 4) == 2, rs2_val == 8
// opcode: sb; op1:x10; op2:x11; op2val:0x8; immval:-0x2; align:1
TEST_STORE(x1,x2,0,x10,x11,0x8,-0x2,180,sb,1)

inst_56:
// ea_align == 1 and (imm_val % 4) == 3, 
// opcode: sb; op1:x10; op2:x11; op2val:-0x8; immval:-0x201; align:1
TEST_STORE(x1,x2,0,x10,x11,-0x8,-0x201,184,sb,1)

inst_57:
// ea_align == 2 and (imm_val % 4) == 0, 
// opcode: sb; op1:x10; op2:x11; op2val:0x2000000; immval:-0x400; align:2
TEST_STORE(x1,x2,0,x10,x11,0x2000000,-0x400,188,sb,2)

inst_58:
// ea_align == 2 and (imm_val % 4) == 1, 
// opcode: sb; op1:x10; op2:x11; op2val:-0x41; immval:0x9; align:2
TEST_STORE(x1,x2,0,x10,x11,-0x41,0x9,192,sb,2)

inst_59:
// ea_align == 2 and (imm_val % 4) == 2, 
// opcode: sb; op1:x10; op2:x11; op2val:-0x8; immval:0x2; align:2
TEST_STORE(x1,x2,0,x10,x11,-0x8,0x2,196,sb,2)

inst_60:
// ea_align == 2 and (imm_val % 4) == 3, 
// opcode: sb; op1:x10; op2:x11; op2val:0x9; immval:-0x5; align:2
TEST_STORE(x1,x2,0,x10,x11,0x9,-0x5,200,sb,2)

inst_61:
// ea_align == 3 and (imm_val % 4) == 0, rs2_val == 16
// opcode: sb; op1:x10; op2:x11; op2val:0x10; immval:0x400; align:3
TEST_STORE(x1,x2,0,x10,x11,0x10,0x400,204,sb,3)

inst_62:
// ea_align == 3 and (imm_val % 4) == 1, 
// opcode: sb; op1:x10; op2:x11; op2val:-0x200001; immval:0x555; align:3
TEST_STORE(x1,x2,0,x10,x11,-0x200001,0x555,208,sb,3)

inst_63:
// ea_align == 3 and (imm_val % 4) == 2, 
// opcode: sb; op1:x10; op2:x11; op2val:0x10000000; immval:-0x556; align:3
TEST_STORE(x1,x2,0,x10,x11,0x10000000,-0x556,212,sb,3)

inst_64:
// rs2_val == 64, 
// opcode: sb; op1:x10; op2:x11; op2val:0x40; immval:0x20; align:0
TEST_STORE(x1,x2,0,x10,x11,0x40,0x20,216,sb,0)

inst_65:
// ea_align == 3 and (imm_val % 4) == 3, 
// opcode: sb; op1:x10; op2:x11; op2val:0x8000; immval:0x3ff; align:3
TEST_STORE(x1,x2,0,x10,x11,0x8000,0x3ff,220,sb,3)

inst_66:
// rs2_val == 16384, imm_val == 0
// opcode: sb; op1:x10; op2:x11; op2val:0x4000; immval:0x0; align:0
TEST_STORE(x1,x2,0,x10,x11,0x4000,0x0,224,sb,0)

inst_67:
// rs2_val == 8192, 
// opcode: sb; op1:x10; op2:x11; op2val:0x2000; immval:0x40; align:0
TEST_STORE(x1,x2,0,x10,x11,0x2000,0x40,228,sb,0)

inst_68:
// rs2_val == 4096, 
// opcode: sb; op1:x10; op2:x11; op2val:0x1000; immval:0x9; align:0
TEST_STORE(x1,x2,0,x10,x11,0x1000,0x9,232,sb,0)

inst_69:
// rs2_val == 2048, 
// opcode: sb; op1:x10; op2:x11; op2val:0x800; immval:-0x556; align:0
TEST_STORE(x1,x2,0,x10,x11,0x800,-0x556,236,sb,0)

inst_70:
// rs2_val == 512, 
// opcode: sb; op1:x10; op2:x11; op2val:0x200; immval:0x5; align:0
TEST_STORE(x1,x2,0,x10,x11,0x200,0x5,240,sb,0)

inst_71:
// rs2_val == 1024, 
// opcode: sb; op1:x10; op2:x11; op2val:0x400; immval:-0x11; align:0
TEST_STORE(x1,x2,0,x10,x11,0x400,-0x11,244,sb,0)

inst_72:
// rs2_val == 0, 
// opcode: sb; op1:x10; op2:x11; op2val:0x0; immval:-0x11; align:0
TEST_STORE(x1,x2,0,x10,x11,0x0,-0x11,248,sb,0)

inst_73:
// rs2_val == 256, 
// opcode: sb; op1:x10; op2:x11; op2val:0x100; immval:0x80; align:0
TEST_STORE(x1,x2,0,x10,x11,0x100,0x80,252,sb,0)

inst_74:
// rs2_val == 128, 
// opcode: sb; op1:x10; op2:x11; op2val:0x80; immval:0x7; align:0
TEST_STORE(x1,x2,0,x10,x11,0x80,0x7,256,sb,0)

inst_75:
// rs2_val == 32, 
// opcode: sb; op1:x10; op2:x11; op2val:0x20; immval:0x200; align:0
TEST_STORE(x1,x2,0,x10,x11,0x20,0x200,260,sb,0)

inst_76:
// rs2_val == 4, 
// opcode: sb; op1:x10; op2:x11; op2val:0x4; immval:0x3; align:0
TEST_STORE(x1,x2,0,x10,x11,0x4,0x3,264,sb,0)

inst_77:
// rs2_val == 2, 
// opcode: sb; op1:x10; op2:x11; op2val:0x2; immval:0x400; align:0
TEST_STORE(x1,x2,0,x10,x11,0x2,0x400,268,sb,0)
#endif


RVTEST_CODE_END
RVMODEL_HALT

RVTEST_DATA_BEGIN
.align 4

rvtest_data:
.word 0xbabecafe
.word 0xbabecafe
.word 0xbabecafe
.word 0xbabecafe
RVTEST_DATA_END


RVMODEL_DATA_BEGIN
rvtest_sig_begin:
sig_begin_canary:
CANARY;


signature_x3_0:
    .fill 0*(XLEN/32),4,0xdeadbeef


signature_x3_1:
    .fill 10*(XLEN/32),4,0xdeadbeef


signature_x1_0:
    .fill 68*(XLEN/32),4,0xdeadbeef

#ifdef rvtest_mtrap_routine

tsig_begin_canary:
CANARY;
mtrap_sigptr:
    .fill 64*(XLEN/32),4,0xdeadbeef
tsig_end_canary:
CANARY;

#endif

#ifdef rvtest_gpr_save

gpr_save:
    .fill 32*(XLEN/32),4,0xdeadbeef

#endif

sig_end_canary:
CANARY;
rvtest_sig_end:
RVMODEL_DATA_END
