// -----------
// This file was generated by riscv_ctg (https://gitlab.com/incoresemi/riscv-compliance/riscv_ctg)
// version   : 0.5.1
// timestamp : Mon Aug  2 08:58:53 2021 GMT
// usage     : riscv_ctg \
//                  --cgf /home/bilalsakhawat/riscv-ctg/sample_cgfs/dataset.cgf \
//                  --cgf /home/bilalsakhawat/riscv-ctg/sample_cgfs/rv32e.cgf \
//                  --base-isa rv32e \
//                  --randomize
// -----------
//
// -----------
// Copyright (c) 2020. RISC-V International. All rights reserved.
// SPDX-License-Identifier: BSD-3-Clause
// -----------
//
// This assembly file tests the sll instruction of the RISC-V E extension for the sll covergroup.
// 
#include "model_test.h"
#include "arch_test.h"
RVTEST_ISA("RV32E")

.section .text.init
.globl rvtest_entry_point
rvtest_entry_point:
RVMODEL_BOOT
RVTEST_CODE_BEGIN

#ifdef TEST_CASE_1

RVTEST_CASE(0,"//check ISA:=regex(.*32.*);check ISA:=regex(.*E.*) ;def RVTEST_E = True;def TEST_CASE_1=True;",sll)

RVTEST_SIGBASE( x2,signature_x2_1)

inst_0:
// rs1 != rs2  and rs1 != rd and rs2 != rd, rs1==x6, rs2==x13, rd==x1, rs1_val < 0 and rs2_val == 0, 
// opcode: sll ; op1:x6; op2:x13; dest:x1; op1val:-0x40000000;  op2val:0x0
TEST_RR_OP(sll, x1, x6, x13, 0xc0000000, -0x40000000, 0x0, x2, 0, x7)

inst_1:
// rs1 == rd != rs2, rs1==x4, rs2==x1, rd==x4, rs2_val == 15, rs1_val == -17, rs1_val < 0 and rs2_val > 0 and rs2_val < xlen
// opcode: sll ; op1:x4; op2:x1; dest:x4; op1val:-0x11;  op2val:0xf
TEST_RR_OP(sll, x4, x4, x1, 0xfff78000, -0x11, 0xf, x2, 4, x7)

inst_2:
// rs2 == rd != rs1, rs1==x9, rs2==x11, rd==x11, rs2_val == 23, rs1_val == -257
// opcode: sll ; op1:x9; op2:x11; dest:x11; op1val:-0x101;  op2val:0x17
TEST_RR_OP(sll, x11, x9, x11, 0x7f800000, -0x101, 0x17, x2, 8, x7)

inst_3:
// rs1 == rs2 != rd, rs1==x12, rs2==x12, rd==x9, rs2_val == 27, rs1_val==-46340
// opcode: sll ; op1:x12; op2:x12; dest:x9; op1val:-0xb504;  op2val:-0xb504
TEST_RR_OP(sll, x9, x12, x12, 0xc0000000, -0xb504, -0xb504, x2, 12, x7)

inst_4:
// rs1 == rs2 == rd, rs1==x0, rs2==x0, rd==x0, rs2_val == 29, rs1_val == 4, rs1_val==4, rs1_val > 0 and rs2_val > 0 and rs2_val < xlen
// opcode: sll ; op1:x0; op2:x0; dest:x0; op1val:0x0;  op2val:0x0
TEST_RR_OP(sll, x0, x0, x0, 0, 0x0, 0x0, x2, 16, x7)

inst_5:
// rs1==x5, rs2==x4, rd==x15, rs2_val == 30, rs1_val == -65
// opcode: sll ; op1:x5; op2:x4; dest:x15; op1val:-0x41;  op2val:0x1e
TEST_RR_OP(sll, x15, x5, x4, 0xc0000000, -0x41, 0x1e, x2, 20, x7)

inst_6:
// rs1==x1, rs2==x10, rd==x3, rs1_val == 2147483647, rs1_val == (2**(xlen-1)-1) and rs2_val >= 0 and rs2_val < xlen
// opcode: sll ; op1:x1; op2:x10; dest:x3; op1val:0x7fffffff;  op2val:0x9
TEST_RR_OP(sll, x3, x1, x10, 0xfffffe00, 0x7fffffff, 0x9, x2, 24, x7)

inst_7:
// rs1==x8, rs2==x15, rd==x10, rs1_val == -1073741825, 
// opcode: sll ; op1:x8; op2:x15; dest:x10; op1val:-0x40000001;  op2val:0x11
TEST_RR_OP(sll, x10, x8, x15, 0xfffe0000, -0x40000001, 0x11, x2, 28, x4)
RVTEST_SIGBASE( x1,signature_x1_0)

inst_8:
// rs1==x13, rs2==x6, rd==x12, rs1_val == -536870913, rs2_val == 1
// opcode: sll ; op1:x13; op2:x6; dest:x12; op1val:-0x20000001;  op2val:0x1
TEST_RR_OP(sll, x12, x13, x6, 0xbffffffe, -0x20000001, 0x1, x1, 0, x4)

inst_9:
// rs1==x3, rs2==x9, rd==x5, rs1_val == -268435457, 
// opcode: sll ; op1:x3; op2:x9; dest:x5; op1val:-0x10000001;  op2val:0xe
TEST_RR_OP(sll, x5, x3, x9, 0xffffc000, -0x10000001, 0xe, x1, 4, x4)

inst_10:
// rs1==x7, rs2==x2, rd==x13, rs1_val == -134217729, 
// opcode: sll ; op1:x7; op2:x2; dest:x13; op1val:-0x8000001;  op2val:0x1e
TEST_RR_OP(sll, x13, x7, x2, 0xc0000000, -0x8000001, 0x1e, x1, 8, x4)

inst_11:
// rs1==x11, rs2==x7, rd==x8, rs1_val == -67108865, 
// opcode: sll ; op1:x11; op2:x7; dest:x8; op1val:-0x4000001;  op2val:0x17
TEST_RR_OP(sll, x8, x11, x7, 0xff800000, -0x4000001, 0x17, x1, 12, x4)

inst_12:
// rs1==x10, rs2==x14, rd==x7, rs1_val == -33554433, rs2_val == 8
// opcode: sll ; op1:x10; op2:x14; dest:x7; op1val:-0x2000001;  op2val:0x8
TEST_RR_OP(sll, x7, x10, x14, 0xffffff00, -0x2000001, 0x8, x1, 16, x4)
RVTEST_SIGBASE( x1,signature_x1_1)

inst_13:
// rs1==x14, rs2==x8, rd==x6, rs1_val == -16777217, 
// opcode: sll ; op1:x14; op2:x8; dest:x6; op1val:-0x1000001;  op2val:0xd
TEST_RR_OP(sll, x6, x14, x8, 0xffffe000, -0x1000001, 0xd, x1, 0, x4)

inst_14:
// rs1==x15, rs2==x3, rd==x2, rs1_val == -8388609, rs2_val == 21
// opcode: sll ; op1:x15; op2:x3; dest:x2; op1val:-0x800001;  op2val:0x15
TEST_RR_OP(sll, x2, x15, x3, 0xffe00000, -0x800001, 0x15, x1, 4, x4)

inst_15:
// rs1==x2, rs2==x5, rd==x14, rs1_val == -4194305, 
// opcode: sll ; op1:x2; op2:x5; dest:x14; op1val:-0x400001;  op2val:0xb
TEST_RR_OP(sll, x14, x2, x5, 0xfffff800, -0x400001, 0xb, x1, 8, x4)

inst_16:
// rs1_val == -2097153, 
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:-0x200001;  op2val:0xb
TEST_RR_OP(sll, x12, x10, x11, 0xfffff800, -0x200001, 0xb, x1, 12, x4)

inst_17:
// rs1_val == -1048577, rs2_val == 2
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:-0x100001;  op2val:0x2
TEST_RR_OP(sll, x12, x10, x11, 0xffbffffc, -0x100001, 0x2, x1, 16, x2)

inst_18:
// rs1_val == -524289, 
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:-0x80001;  op2val:0x9
TEST_RR_OP(sll, x12, x10, x11, 0xeffffe00, -0x80001, 0x9, x1, 20, x2)

inst_19:
// rs1_val == -262145, 
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:-0x40001;  op2val:0xf
TEST_RR_OP(sll, x12, x10, x11, 0xffff8000, -0x40001, 0xf, x1, 24, x2)

inst_20:
// rs1_val == -131073, rs2_val == 10
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:-0x20001;  op2val:0xa
TEST_RR_OP(sll, x12, x10, x11, 0xf7fffc00, -0x20001, 0xa, x1, 28, x2)

inst_21:
// rs1_val == -65537, 
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:-0x10001;  op2val:0x2
TEST_RR_OP(sll, x12, x10, x11, 0xfffbfffc, -0x10001, 0x2, x1, 32, x2)

inst_22:
// rs1_val == -32769, rs2_val == 4
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:-0x8001;  op2val:0x4
TEST_RR_OP(sll, x12, x10, x11, 0xfff7fff0, -0x8001, 0x4, x1, 36, x2)

inst_23:
// rs1_val == -16385, 
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:-0x4001;  op2val:0x0
TEST_RR_OP(sll, x12, x10, x11, 0xffffbfff, -0x4001, 0x0, x1, 40, x2)

inst_24:
// rs1_val == -8193, 
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:-0x2001;  op2val:0xd
TEST_RR_OP(sll, x12, x10, x11, 0xfbffe000, -0x2001, 0xd, x1, 44, x2)

inst_25:
// rs1_val == -4097, 
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:-0x1001;  op2val:0x1e
TEST_RR_OP(sll, x12, x10, x11, 0xc0000000, -0x1001, 0x1e, x1, 48, x2)

inst_26:
// rs1_val == -2049, rs2_val == 16
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:-0x801;  op2val:0x10
TEST_RR_OP(sll, x12, x10, x11, 0xf7ff0000, -0x801, 0x10, x1, 52, x2)

inst_27:
// rs1_val == -1025, 
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:-0x401;  op2val:0x5
TEST_RR_OP(sll, x12, x10, x11, 0xffff7fe0, -0x401, 0x5, x1, 56, x2)

inst_28:
// rs1_val == -513, 
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:-0x201;  op2val:0x5
TEST_RR_OP(sll, x12, x10, x11, 0xffffbfe0, -0x201, 0x5, x1, 60, x2)

inst_29:
// rs1_val == -129, 
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:-0x81;  op2val:0x10
TEST_RR_OP(sll, x12, x10, x11, 0xff7f0000, -0x81, 0x10, x1, 64, x2)

inst_30:
// rs1_val == -33, 
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:-0x21;  op2val:0x10
TEST_RR_OP(sll, x12, x10, x11, 0xffdf0000, -0x21, 0x10, x1, 68, x2)

inst_31:
// rs1_val == -9, 
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:-0x9;  op2val:0x10
TEST_RR_OP(sll, x12, x10, x11, 0xfff70000, -0x9, 0x10, x1, 72, x2)

inst_32:
// rs1_val == -5, 
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:-0x5;  op2val:0xf
TEST_RR_OP(sll, x12, x10, x11, 0xfffd8000, -0x5, 0xf, x1, 76, x2)

inst_33:
// rs1_val == -3, 
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:-0x3;  op2val:0x4
TEST_RR_OP(sll, x12, x10, x11, 0xffffffd0, -0x3, 0x4, x1, 80, x2)

inst_34:
// rs1_val == -2, 
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:-0x2;  op2val:0x2
TEST_RR_OP(sll, x12, x10, x11, 0xfffffff8, -0x2, 0x2, x1, 84, x2)

inst_35:
// rs1_val == -2147483648, rs1_val == (-2**(xlen-1)) and rs2_val >= 0 and rs2_val < xlen
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:-0x80000000;  op2val:0x1f
TEST_RR_OP(sll, x12, x10, x11, 0x0, -0x80000000, 0x1f, x1, 88, x2)

inst_36:
// rs1_val == 1073741824, 
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:0x40000000;  op2val:0x17
TEST_RR_OP(sll, x12, x10, x11, 0x0, 0x40000000, 0x17, x1, 92, x2)

inst_37:
// rs1_val == 536870912, 
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:0x20000000;  op2val:0xb
TEST_RR_OP(sll, x12, x10, x11, 0x0, 0x20000000, 0xb, x1, 96, x2)

inst_38:
// rs1_val == 268435456, 
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:0x10000000;  op2val:0x1
TEST_RR_OP(sll, x12, x10, x11, 0x20000000, 0x10000000, 0x1, x1, 100, x2)

inst_39:
// rs1_val == 134217728, 
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:0x8000000;  op2val:0x13
TEST_RR_OP(sll, x12, x10, x11, 0x0, 0x8000000, 0x13, x1, 104, x2)

inst_40:
// rs1_val == 67108864, 
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:0x4000000;  op2val:0x5
TEST_RR_OP(sll, x12, x10, x11, 0x80000000, 0x4000000, 0x5, x1, 108, x2)

inst_41:
// rs1_val == 33554432, 
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:0x2000000;  op2val:0x3
TEST_RR_OP(sll, x12, x10, x11, 0x10000000, 0x2000000, 0x3, x1, 112, x2)

inst_42:
// rs1_val == 16777216, 
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:0x1000000;  op2val:0xa
TEST_RR_OP(sll, x12, x10, x11, 0x0, 0x1000000, 0xa, x1, 116, x2)

inst_43:
// rs1_val == 8388608, 
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:0x800000;  op2val:0x4
TEST_RR_OP(sll, x12, x10, x11, 0x8000000, 0x800000, 0x4, x1, 120, x2)

inst_44:
// rs1_val == 4194304, rs1_val > 0 and rs2_val == 0
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:0x400000;  op2val:0x0
TEST_RR_OP(sll, x12, x10, x11, 0x400000, 0x400000, 0x0, x1, 124, x2)

inst_45:
// rs1_val == 2097152, 
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:0x200000;  op2val:0x12
TEST_RR_OP(sll, x12, x10, x11, 0x0, 0x200000, 0x12, x1, 128, x2)

inst_46:
// rs1_val == 1048576, 
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:0x100000;  op2val:0x1f
TEST_RR_OP(sll, x12, x10, x11, 0x0, 0x100000, 0x1f, x1, 132, x2)

inst_47:
// rs1_val == 524288, 
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:0x80000;  op2val:0x7
TEST_RR_OP(sll, x12, x10, x11, 0x4000000, 0x80000, 0x7, x1, 136, x2)

inst_48:
// rs1_val == 262144, 
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:0x40000;  op2val:0x1b
TEST_RR_OP(sll, x12, x10, x11, 0x0, 0x40000, 0x1b, x1, 140, x2)

inst_49:
// rs1_val == 131072, 
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:0x20000;  op2val:0x10
TEST_RR_OP(sll, x12, x10, x11, 0x0, 0x20000, 0x10, x1, 144, x2)

inst_50:
// rs1_val == 65536, 
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:0x10000;  op2val:0x11
TEST_RR_OP(sll, x12, x10, x11, 0x0, 0x10000, 0x11, x1, 148, x2)

inst_51:
// rs1_val == 32768, 
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:0x8000;  op2val:0xc
TEST_RR_OP(sll, x12, x10, x11, 0x8000000, 0x8000, 0xc, x1, 152, x2)

inst_52:
// rs1_val == 16384, 
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:0x4000;  op2val:0x12
TEST_RR_OP(sll, x12, x10, x11, 0x0, 0x4000, 0x12, x1, 156, x2)

inst_53:
// rs1_val == 8192, 
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:0x2000;  op2val:0x8
TEST_RR_OP(sll, x12, x10, x11, 0x200000, 0x2000, 0x8, x1, 160, x2)

inst_54:
// rs1_val == 4096, 
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:0x1000;  op2val:0xa
TEST_RR_OP(sll, x12, x10, x11, 0x400000, 0x1000, 0xa, x1, 164, x2)

inst_55:
// rs1_val == 2048, 
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:0x800;  op2val:0xa
TEST_RR_OP(sll, x12, x10, x11, 0x200000, 0x800, 0xa, x1, 168, x2)

inst_56:
// rs1_val == 1024, 
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:0x400;  op2val:0x11
TEST_RR_OP(sll, x12, x10, x11, 0x8000000, 0x400, 0x11, x1, 172, x2)

inst_57:
// rs1_val == 512, 
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:0x200;  op2val:0x17
TEST_RR_OP(sll, x12, x10, x11, 0x0, 0x200, 0x17, x1, 176, x2)

inst_58:
// rs1_val == 256, 
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:0x100;  op2val:0x7
TEST_RR_OP(sll, x12, x10, x11, 0x8000, 0x100, 0x7, x1, 180, x2)

inst_59:
// rs1_val == 128, 
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:0x80;  op2val:0x1f
TEST_RR_OP(sll, x12, x10, x11, 0x0, 0x80, 0x1f, x1, 184, x2)

inst_60:
// rs1_val == 64, 
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:0x40;  op2val:0xa
TEST_RR_OP(sll, x12, x10, x11, 0x10000, 0x40, 0xa, x1, 188, x2)

inst_61:
// rs1_val == 32, 
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:0x20;  op2val:0xa
TEST_RR_OP(sll, x12, x10, x11, 0x8000, 0x20, 0xa, x1, 192, x2)

inst_62:
// rs1_val == 16, 
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:0x10;  op2val:0x17
TEST_RR_OP(sll, x12, x10, x11, 0x8000000, 0x10, 0x17, x1, 196, x2)

inst_63:
// rs1_val == 8, 
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:0x8;  op2val:0x1d
TEST_RR_OP(sll, x12, x10, x11, 0x0, 0x8, 0x1d, x1, 200, x2)

inst_64:
// rs1_val == 2, rs1_val==2
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x1b
TEST_RR_OP(sll, x12, x10, x11, 0x10000000, 0x2, 0x1b, x1, 204, x2)

inst_65:
// rs1_val == 1, rs1_val == 1 and rs2_val >= 0 and rs2_val < xlen
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:0x1;  op2val:0x1f
TEST_RR_OP(sll, x12, x10, x11, 0x80000000, 0x1, 0x1f, x1, 208, x2)

inst_66:
// rs1_val==46341, 
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x13
TEST_RR_OP(sll, x12, x10, x11, 0xa8280000, 0xb505, 0x13, x1, 212, x2)

inst_67:
// rs1_val==-46339, 
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x8
TEST_RR_OP(sll, x12, x10, x11, 0xff4afd00, -0xb503, 0x8, x1, 216, x2)

inst_68:
// rs1_val==1717986919, 
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x2
TEST_RR_OP(sll, x12, x10, x11, 0x9999999c, 0x66666667, 0x2, x1, 220, x2)

inst_69:
// rs1_val==858993460, 
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x5
TEST_RR_OP(sll, x12, x10, x11, 0x66666680, 0x33333334, 0x5, x1, 224, x2)

inst_70:
// rs1_val==6, 
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x11
TEST_RR_OP(sll, x12, x10, x11, 0xc0000, 0x6, 0x11, x1, 228, x2)

inst_71:
// rs1_val==-1431655765, 
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x11
TEST_RR_OP(sll, x12, x10, x11, 0x55560000, -0x55555555, 0x11, x1, 232, x2)

inst_72:
// rs1_val==1431655766, 
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x13
TEST_RR_OP(sll, x12, x10, x11, 0xaab00000, 0x55555556, 0x13, x1, 236, x2)

inst_73:
// rs1_val==46339, 
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x0
TEST_RR_OP(sll, x12, x10, x11, 0xb503, 0xb503, 0x0, x1, 240, x2)

inst_74:
// rs1_val==3, 
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x11
TEST_RR_OP(sll, x12, x10, x11, 0x60000, 0x3, 0x11, x1, 244, x2)

inst_75:
// rs1_val == -1431655766, rs1_val==-1431655766
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x10
TEST_RR_OP(sll, x12, x10, x11, 0xaaaa0000, -0x55555556, 0x10, x1, 248, x2)

inst_76:
// rs1_val == 1431655765, rs1_val==1431655765
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x12
TEST_RR_OP(sll, x12, x10, x11, 0x55540000, 0x55555555, 0x12, x1, 252, x2)

inst_77:
// rs1_val == 0 and rs2_val >= 0 and rs2_val < xlen, rs1_val==0
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0xc
TEST_RR_OP(sll, x12, x10, x11, 0x0, 0x0, 0xc, x1, 256, x2)

inst_78:
// rs1_val == rs2_val and rs2_val > 0 and rs2_val < xlen, 
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x2
TEST_RR_OP(sll, x12, x10, x11, 0x8, 0x2, 0x2, x1, 260, x2)

inst_79:
// rs1_val==1717986917, 
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x8
TEST_RR_OP(sll, x12, x10, x11, 0x66666500, 0x66666665, 0x8, x1, 264, x2)

inst_80:
// rs1_val==858993458, 
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0xe
TEST_RR_OP(sll, x12, x10, x11, 0xcccc8000, 0x33333332, 0xe, x1, 268, x2)

inst_81:
// rs1_val==1431655764, 
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x0
TEST_RR_OP(sll, x12, x10, x11, 0x55555554, 0x55555554, 0x0, x1, 272, x2)

inst_82:
// rs1_val==46340, 
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x12
TEST_RR_OP(sll, x12, x10, x11, 0xd4100000, 0xb504, 0x12, x1, 276, x2)

inst_83:
// rs1_val==1717986918, 
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x15
TEST_RR_OP(sll, x12, x10, x11, 0xccc00000, 0x66666666, 0x15, x1, 280, x2)

inst_84:
// rs1_val==858993459, 
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x6
TEST_RR_OP(sll, x12, x10, x11, 0xccccccc0, 0x33333333, 0x6, x1, 284, x2)

inst_85:
// rs1_val==5, 
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0xa
TEST_RR_OP(sll, x12, x10, x11, 0x1400, 0x5, 0xa, x1, 288, x2)

inst_86:
// rs2_val == 27, rs1_val==-46340
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x1b
TEST_RR_OP(sll, x12, x10, x11, 0xe0000000, -0xb504, 0x1b, x1, 292, x2)

inst_87:
// rs2_val == 29, rs1_val == 4, rs1_val==4, rs1_val > 0 and rs2_val > 0 and rs2_val < xlen
// opcode: sll ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x1d
TEST_RR_OP(sll, x12, x10, x11, 0x80000000, 0x4, 0x1d, x1, 296, x2)
#endif


RVTEST_CODE_END
RVMODEL_HALT

RVTEST_DATA_BEGIN
.align 4

rvtest_data:
.word 0xbabecafe
.word 0xbabecafe
.word 0xbabecafe
.word 0xbabecafe
RVTEST_DATA_END


RVMODEL_DATA_BEGIN
rvtest_sig_begin:
sig_begin_canary:
CANARY;


signature_x2_0:
    .fill 0*(XLEN/32),4,0xdeadbeef


signature_x2_1:
    .fill 8*(XLEN/32),4,0xdeadbeef


signature_x1_0:
    .fill 5*(XLEN/32),4,0xdeadbeef


signature_x1_1:
    .fill 75*(XLEN/32),4,0xdeadbeef

#ifdef rvtest_mtrap_routine

tsig_begin_canary:
CANARY;
mtrap_sigptr:
    .fill 64*(XLEN/32),4,0xdeadbeef
tsig_end_canary:
CANARY;

#endif

#ifdef rvtest_gpr_save

gpr_save:
    .fill 32*(XLEN/32),4,0xdeadbeef

#endif

sig_end_canary:
CANARY;
rvtest_sig_end:
RVMODEL_DATA_END
