// -----------
// This file was generated by riscv_ctg (https://gitlab.com/incoresemi/riscv-compliance/riscv_ctg)
// version   : 0.5.1
// timestamp : Mon Aug  2 08:58:53 2021 GMT
// usage     : riscv_ctg \
//                  --cgf /home/bilalsakhawat/riscv-ctg/sample_cgfs/dataset.cgf \
//                  --cgf /home/bilalsakhawat/riscv-ctg/sample_cgfs/rv32e.cgf \
//                  --base-isa rv32e \
//                  --randomize
// -----------
//
// -----------
// Copyright (c) 2020. RISC-V International. All rights reserved.
// SPDX-License-Identifier: BSD-3-Clause
// -----------
//
// This assembly file tests the srl instruction of the RISC-V E extension for the srl covergroup.
// 
#include "model_test.h"
#include "arch_test.h"
RVTEST_ISA("RV32E")

.section .text.init
.globl rvtest_entry_point
rvtest_entry_point:
RVMODEL_BOOT
RVTEST_CODE_BEGIN

#ifdef TEST_CASE_1

RVTEST_CASE(0,"//check ISA:=regex(.*32.*);check ISA:=regex(.*E.*) ;def RVTEST_E = True;def TEST_CASE_1=True;",srl)

RVTEST_SIGBASE( x1,signature_x1_1)

inst_0:
// rs1 != rs2  and rs1 != rd and rs2 != rd, rs1==x10, rs2==x4, rd==x7, rs1_val < 0 and rs2_val == 0, rs1_val == -9
// opcode: srl ; op1:x10; op2:x4; dest:x7; op1val:-0x9;  op2val:0x0
TEST_RR_OP(srl, x7, x10, x4, 0xfffffff7, -0x9, 0x0, x1, 0, x6)

inst_1:
// rs1 == rd != rs2, rs1==x15, rs2==x0, rd==x15, rs2_val == 15, rs1_val < 0 and rs2_val > 0 and rs2_val < xlen
// opcode: srl ; op1:x15; op2:x0; dest:x15; op1val:-0x6;  op2val:0x0
TEST_RR_OP(srl, x15, x15, x0, 0xfffffffa, -0x6, 0x0, x1, 4, x6)

inst_2:
// rs2 == rd != rs1, rs1==x2, rs2==x3, rd==x3, rs2_val == 23, rs1_val == -2049
// opcode: srl ; op1:x2; op2:x3; dest:x3; op1val:-0x801;  op2val:0x17
TEST_RR_OP(srl, x3, x2, x3, 0x1ff, -0x801, 0x17, x1, 8, x6)

inst_3:
// rs1 == rs2 != rd, rs1==x5, rs2==x5, rd==x12, rs2_val == 27, rs1_val == -1048577
// opcode: srl ; op1:x5; op2:x5; dest:x12; op1val:-0x100001;  op2val:-0x100001
TEST_RR_OP(srl, x12, x5, x5, 0x1, -0x100001, -0x100001, x1, 12, x6)

inst_4:
// rs1 == rs2 == rd, rs1==x14, rs2==x14, rd==x14, rs2_val == 29, rs1_val == -16777217
// opcode: srl ; op1:x14; op2:x14; dest:x14; op1val:-0x1000001;  op2val:-0x1000001
TEST_RR_OP(srl, x14, x14, x14, 0x1, -0x1000001, -0x1000001, x1, 16, x6)

inst_5:
// rs1==x12, rs2==x10, rd==x2, rs2_val == 30, rs1_val == -1073741825
// opcode: srl ; op1:x12; op2:x10; dest:x2; op1val:-0x40000001;  op2val:0x1e
TEST_RR_OP(srl, x2, x12, x10, 0x2, -0x40000001, 0x1e, x1, 20, x6)

inst_6:
// rs1==x11, rs2==x15, rd==x9, rs1_val == 2147483647, rs1_val > 0 and rs2_val > 0 and rs2_val < xlen, rs1_val == (2**(xlen-1)-1) and rs2_val >= 0 and rs2_val < xlen
// opcode: srl ; op1:x11; op2:x15; dest:x9; op1val:0x7fffffff;  op2val:0x1b
TEST_RR_OP(srl, x9, x11, x15, 0xf, 0x7fffffff, 0x1b, x1, 24, x6)

inst_7:
// rs1==x4, rs2==x6, rd==x10, rs1_val == -536870913, 
// opcode: srl ; op1:x4; op2:x6; dest:x10; op1val:-0x20000001;  op2val:0x13
TEST_RR_OP(srl, x10, x4, x6, 0x1bff, -0x20000001, 0x13, x1, 28, x2)
RVTEST_SIGBASE( x10,signature_x10_0)

inst_8:
// rs1==x0, rs2==x9, rd==x8, rs1_val == -268435457, 
// opcode: srl ; op1:x0; op2:x9; dest:x8; op1val:0x0;  op2val:0xe
TEST_RR_OP(srl, x8, x0, x9, 0x0, 0x0, 0xe, x10, 0, x2)

inst_9:
// rs1==x1, rs2==x7, rd==x11, rs1_val == -134217729, 
// opcode: srl ; op1:x1; op2:x7; dest:x11; op1val:-0x8000001;  op2val:0x13
TEST_RR_OP(srl, x11, x1, x7, 0x1eff, -0x8000001, 0x13, x10, 4, x2)

inst_10:
// rs1==x7, rs2==x12, rd==x5, rs1_val == -67108865, 
// opcode: srl ; op1:x7; op2:x12; dest:x5; op1val:-0x4000001;  op2val:0x1b
TEST_RR_OP(srl, x5, x7, x12, 0x1f, -0x4000001, 0x1b, x10, 8, x2)

inst_11:
// rs1==x6, rs2==x13, rd==x1, rs1_val == -33554433, 
// opcode: srl ; op1:x6; op2:x13; dest:x1; op1val:-0x2000001;  op2val:0x6
TEST_RR_OP(srl, x1, x6, x13, 0x3f7ffff, -0x2000001, 0x6, x10, 12, x2)

inst_12:
// rs1==x9, rs2==x8, rd==x4, rs1_val == -8388609, 
// opcode: srl ; op1:x9; op2:x8; dest:x4; op1val:-0x800001;  op2val:0xe
TEST_RR_OP(srl, x4, x9, x8, 0x3fdff, -0x800001, 0xe, x10, 16, x2)

inst_13:
// rs1==x3, rs2==x11, rd==x6, rs1_val == -4194305, rs2_val == 8
// opcode: srl ; op1:x3; op2:x11; dest:x6; op1val:-0x400001;  op2val:0x8
TEST_RR_OP(srl, x6, x3, x11, 0xffbfff, -0x400001, 0x8, x10, 20, x2)

inst_14:
// rs1==x13, rs2==x1, rd==x0, rs1_val == -2097153, rs2_val == 4
// opcode: srl ; op1:x13; op2:x1; dest:x0; op1val:-0x200001;  op2val:0x4
TEST_RR_OP(srl, x0, x13, x1, 0, -0x200001, 0x4, x10, 24, x3)

inst_15:
// rs1==x8, rs2==x2, rd==x13, rs1_val == -524289, 
// opcode: srl ; op1:x8; op2:x2; dest:x13; op1val:-0x80001;  op2val:0x1d
TEST_RR_OP(srl, x13, x8, x2, 0x7, -0x80001, 0x1d, x10, 28, x3)
RVTEST_SIGBASE( x1,signature_x1_2)

inst_16:
// rs1_val == -262145, 
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:-0x40001;  op2val:0x4
TEST_RR_OP(srl, x12, x10, x11, 0xfffbfff, -0x40001, 0x4, x1, 0, x3)

inst_17:
// rs1_val == -131073, 
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:-0x20001;  op2val:0x8
TEST_RR_OP(srl, x12, x10, x11, 0xfffdff, -0x20001, 0x8, x1, 4, x3)

inst_18:
// rs1_val == -65537, 
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:-0x10001;  op2val:0x1e
TEST_RR_OP(srl, x12, x10, x11, 0x3, -0x10001, 0x1e, x1, 8, x3)

inst_19:
// rs1_val == -32769, 
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:-0x8001;  op2val:0x1d
TEST_RR_OP(srl, x12, x10, x11, 0x7, -0x8001, 0x1d, x1, 12, x3)

inst_20:
// rs1_val == -16385, rs2_val == 10
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:-0x4001;  op2val:0xa
TEST_RR_OP(srl, x12, x10, x11, 0x3fffef, -0x4001, 0xa, x1, 16, x3)

inst_21:
// rs1_val == -8193, 
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:-0x2001;  op2val:0xe
TEST_RR_OP(srl, x12, x10, x11, 0x3ffff, -0x2001, 0xe, x1, 20, x3)

inst_22:
// rs1_val == -4097, 
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:-0x1001;  op2val:0x1f
TEST_RR_OP(srl, x12, x10, x11, 0x1, -0x1001, 0x1f, x1, 24, x3)

inst_23:
// rs1_val == -1025, 
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:-0x401;  op2val:0x1e
TEST_RR_OP(srl, x12, x10, x11, 0x3, -0x401, 0x1e, x1, 28, x3)

inst_24:
// rs1_val == -513, 
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:-0x201;  op2val:0x11
TEST_RR_OP(srl, x12, x10, x11, 0x7fff, -0x201, 0x11, x1, 32, x3)

inst_25:
// rs1_val == -257, 
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:-0x101;  op2val:0x1d
TEST_RR_OP(srl, x12, x10, x11, 0x7, -0x101, 0x1d, x1, 36, x3)

inst_26:
// rs1_val == -129, 
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:-0x81;  op2val:0xd
TEST_RR_OP(srl, x12, x10, x11, 0x7ffff, -0x81, 0xd, x1, 40, x3)

inst_27:
// rs1_val == -65, 
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:-0x41;  op2val:0x9
TEST_RR_OP(srl, x12, x10, x11, 0x7fffff, -0x41, 0x9, x1, 44, x3)

inst_28:
// rs1_val == -33, rs2_val == 21
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:-0x21;  op2val:0x15
TEST_RR_OP(srl, x12, x10, x11, 0x7ff, -0x21, 0x15, x1, 48, x3)

inst_29:
// rs1_val == -17, 
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:-0x11;  op2val:0xe
TEST_RR_OP(srl, x12, x10, x11, 0x3ffff, -0x11, 0xe, x1, 52, x3)

inst_30:
// rs1_val == -5, 
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:-0x5;  op2val:0x0
TEST_RR_OP(srl, x12, x10, x11, 0xfffffffb, -0x5, 0x0, x1, 56, x3)

inst_31:
// rs1_val == -3, 
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:-0x3;  op2val:0x1f
TEST_RR_OP(srl, x12, x10, x11, 0x1, -0x3, 0x1f, x1, 60, x3)

inst_32:
// rs1_val == -2, 
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:-0x2;  op2val:0x5
TEST_RR_OP(srl, x12, x10, x11, 0x7ffffff, -0x2, 0x5, x1, 64, x3)

inst_33:
// rs2_val == 16, rs1_val == 524288
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:0x80000;  op2val:0x10
TEST_RR_OP(srl, x12, x10, x11, 0x8, 0x80000, 0x10, x1, 68, x3)

inst_34:
// rs2_val == 2, rs1_val==46341
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x2
TEST_RR_OP(srl, x12, x10, x11, 0x2d41, 0xb505, 0x2, x1, 72, x3)

inst_35:
// rs2_val == 1, rs1_val == 268435456
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:0x10000000;  op2val:0x1
TEST_RR_OP(srl, x12, x10, x11, 0x8000000, 0x10000000, 0x1, x1, 76, x3)

inst_36:
// rs1_val == -2147483648, rs1_val == (-2**(xlen-1)) and rs2_val >= 0 and rs2_val < xlen
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:-0x80000000;  op2val:0x17
TEST_RR_OP(srl, x12, x10, x11, 0x100, -0x80000000, 0x17, x1, 80, x3)

inst_37:
// rs1_val == 1073741824, 
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:0x40000000;  op2val:0x6
TEST_RR_OP(srl, x12, x10, x11, 0x1000000, 0x40000000, 0x6, x1, 84, x3)

inst_38:
// rs1_val == 536870912, 
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:0x20000000;  op2val:0xa
TEST_RR_OP(srl, x12, x10, x11, 0x80000, 0x20000000, 0xa, x1, 88, x3)

inst_39:
// rs1_val == 134217728, 
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:0x8000000;  op2val:0x11
TEST_RR_OP(srl, x12, x10, x11, 0x400, 0x8000000, 0x11, x1, 92, x3)

inst_40:
// rs1_val == 67108864, 
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:0x4000000;  op2val:0xe
TEST_RR_OP(srl, x12, x10, x11, 0x1000, 0x4000000, 0xe, x1, 96, x3)

inst_41:
// rs1_val == 33554432, 
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:0x2000000;  op2val:0x12
TEST_RR_OP(srl, x12, x10, x11, 0x80, 0x2000000, 0x12, x1, 100, x3)

inst_42:
// rs1_val == 16777216, 
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:0x1000000;  op2val:0xa
TEST_RR_OP(srl, x12, x10, x11, 0x4000, 0x1000000, 0xa, x1, 104, x3)

inst_43:
// rs1_val == 8388608, 
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:0x800000;  op2val:0x13
TEST_RR_OP(srl, x12, x10, x11, 0x10, 0x800000, 0x13, x1, 108, x3)

inst_44:
// rs1_val == 4194304, 
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:0x400000;  op2val:0xb
TEST_RR_OP(srl, x12, x10, x11, 0x800, 0x400000, 0xb, x1, 112, x3)

inst_45:
// rs1_val == 2097152, 
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:0x200000;  op2val:0x8
TEST_RR_OP(srl, x12, x10, x11, 0x2000, 0x200000, 0x8, x1, 116, x3)

inst_46:
// rs1_val == 1048576, 
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:0x100000;  op2val:0xe
TEST_RR_OP(srl, x12, x10, x11, 0x40, 0x100000, 0xe, x1, 120, x3)

inst_47:
// rs1_val == 262144, 
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:0x40000;  op2val:0x11
TEST_RR_OP(srl, x12, x10, x11, 0x2, 0x40000, 0x11, x1, 124, x3)

inst_48:
// rs1_val == 131072, 
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:0x20000;  op2val:0xe
TEST_RR_OP(srl, x12, x10, x11, 0x8, 0x20000, 0xe, x1, 128, x3)

inst_49:
// rs1_val == 65536, 
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:0x10000;  op2val:0x13
TEST_RR_OP(srl, x12, x10, x11, 0x0, 0x10000, 0x13, x1, 132, x3)

inst_50:
// rs1_val == 32768, 
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:0x8000;  op2val:0xf
TEST_RR_OP(srl, x12, x10, x11, 0x1, 0x8000, 0xf, x1, 136, x3)

inst_51:
// rs1_val == 16384, 
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:0x4000;  op2val:0xe
TEST_RR_OP(srl, x12, x10, x11, 0x1, 0x4000, 0xe, x1, 140, x3)

inst_52:
// rs1_val == 8192, 
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:0x2000;  op2val:0x8
TEST_RR_OP(srl, x12, x10, x11, 0x20, 0x2000, 0x8, x1, 144, x3)

inst_53:
// rs1_val == 4096, 
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:0x1000;  op2val:0x6
TEST_RR_OP(srl, x12, x10, x11, 0x40, 0x1000, 0x6, x1, 148, x3)

inst_54:
// rs1_val == 2048, 
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:0x800;  op2val:0x1b
TEST_RR_OP(srl, x12, x10, x11, 0x0, 0x800, 0x1b, x1, 152, x3)

inst_55:
// rs1_val == 1024, 
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:0x400;  op2val:0x13
TEST_RR_OP(srl, x12, x10, x11, 0x0, 0x400, 0x13, x1, 156, x3)

inst_56:
// rs1_val == 512, 
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:0x200;  op2val:0x3
TEST_RR_OP(srl, x12, x10, x11, 0x40, 0x200, 0x3, x1, 160, x3)

inst_57:
// rs1_val == 256, 
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:0x100;  op2val:0x1e
TEST_RR_OP(srl, x12, x10, x11, 0x0, 0x100, 0x1e, x1, 164, x3)

inst_58:
// rs1_val == 128, 
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:0x80;  op2val:0xa
TEST_RR_OP(srl, x12, x10, x11, 0x0, 0x80, 0xa, x1, 168, x3)

inst_59:
// rs1_val == 64, 
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:0x40;  op2val:0x4
TEST_RR_OP(srl, x12, x10, x11, 0x4, 0x40, 0x4, x1, 172, x3)

inst_60:
// rs1_val == 32, 
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:0x20;  op2val:0xd
TEST_RR_OP(srl, x12, x10, x11, 0x0, 0x20, 0xd, x1, 176, x3)

inst_61:
// rs1_val == 16, 
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:0x10;  op2val:0x11
TEST_RR_OP(srl, x12, x10, x11, 0x0, 0x10, 0x11, x1, 180, x3)

inst_62:
// rs1_val == 8, 
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:0x8;  op2val:0x12
TEST_RR_OP(srl, x12, x10, x11, 0x0, 0x8, 0x12, x1, 184, x3)

inst_63:
// rs1_val == 4, rs1_val==4
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x10
TEST_RR_OP(srl, x12, x10, x11, 0x0, 0x4, 0x10, x1, 188, x3)

inst_64:
// rs1_val == 2, rs1_val==2, rs1_val == rs2_val and rs2_val > 0 and rs2_val < xlen
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x2
TEST_RR_OP(srl, x12, x10, x11, 0x0, 0x2, 0x2, x1, 192, x3)

inst_65:
// rs1_val == 1, rs1_val == 1 and rs2_val >= 0 and rs2_val < xlen
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:0x1;  op2val:0x1f
TEST_RR_OP(srl, x12, x10, x11, 0x0, 0x1, 0x1f, x1, 196, x3)

inst_66:
// rs1_val==-46339, 
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x6
TEST_RR_OP(srl, x12, x10, x11, 0x3fffd2b, -0xb503, 0x6, x1, 200, x3)

inst_67:
// rs1_val==1717986919, 
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0xe
TEST_RR_OP(srl, x12, x10, x11, 0x19999, 0x66666667, 0xe, x1, 204, x3)

inst_68:
// rs1_val==858993460, 
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x9
TEST_RR_OP(srl, x12, x10, x11, 0x199999, 0x33333334, 0x9, x1, 208, x3)

inst_69:
// rs1_val==6, 
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0xd
TEST_RR_OP(srl, x12, x10, x11, 0x0, 0x6, 0xd, x1, 212, x3)

inst_70:
// rs1_val==-1431655765, 
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0xe
TEST_RR_OP(srl, x12, x10, x11, 0x2aaaa, -0x55555555, 0xe, x1, 216, x3)

inst_71:
// rs1_val==1431655766, rs1_val > 0 and rs2_val == 0
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x0
TEST_RR_OP(srl, x12, x10, x11, 0x55555556, 0x55555556, 0x0, x1, 220, x3)

inst_72:
// rs1_val==46339, 
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0xd
TEST_RR_OP(srl, x12, x10, x11, 0x5, 0xb503, 0xd, x1, 224, x3)

inst_73:
// rs1_val==3, 
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0xf
TEST_RR_OP(srl, x12, x10, x11, 0x0, 0x3, 0xf, x1, 228, x3)

inst_74:
// rs1_val == -1431655766, rs1_val==-1431655766
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x4
TEST_RR_OP(srl, x12, x10, x11, 0xaaaaaaa, -0x55555556, 0x4, x1, 232, x3)

inst_75:
// rs1_val == 1431655765, rs1_val==1431655765
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x7
TEST_RR_OP(srl, x12, x10, x11, 0xaaaaaa, 0x55555555, 0x7, x1, 236, x3)

inst_76:
// rs1_val == 0 and rs2_val >= 0 and rs2_val < xlen, rs1_val==0
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x7
TEST_RR_OP(srl, x12, x10, x11, 0x0, 0x0, 0x7, x1, 240, x3)

inst_77:
// rs1_val==1717986917, 
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x1b
TEST_RR_OP(srl, x12, x10, x11, 0xc, 0x66666665, 0x1b, x1, 244, x3)

inst_78:
// rs1_val==858993458, 
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x11
TEST_RR_OP(srl, x12, x10, x11, 0x1999, 0x33333332, 0x11, x1, 248, x3)

inst_79:
// rs1_val==1431655764, 
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x13
TEST_RR_OP(srl, x12, x10, x11, 0xaaa, 0x55555554, 0x13, x1, 252, x3)

inst_80:
// rs1_val==46340, 
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x12
TEST_RR_OP(srl, x12, x10, x11, 0x0, 0xb504, 0x12, x1, 256, x3)

inst_81:
// rs1_val==-46340, 
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x4
TEST_RR_OP(srl, x12, x10, x11, 0xffff4af, -0xb504, 0x4, x1, 260, x3)

inst_82:
// rs1_val==1717986918, 
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x1b
TEST_RR_OP(srl, x12, x10, x11, 0xc, 0x66666666, 0x1b, x1, 264, x3)

inst_83:
// rs1_val==858993459, 
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x15
TEST_RR_OP(srl, x12, x10, x11, 0x199, 0x33333333, 0x15, x1, 268, x3)

inst_84:
// rs1_val==5, 
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x10
TEST_RR_OP(srl, x12, x10, x11, 0x0, 0x5, 0x10, x1, 272, x3)

inst_85:
// rs2_val == 27, rs1_val == -1048577
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:-0x100001;  op2val:0x1b
TEST_RR_OP(srl, x12, x10, x11, 0x1f, -0x100001, 0x1b, x1, 276, x3)

inst_86:
// rs2_val == 29, rs1_val == -16777217
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:-0x1000001;  op2val:0x1d
TEST_RR_OP(srl, x12, x10, x11, 0x7, -0x1000001, 0x1d, x1, 280, x3)

inst_87:
// rs1_val == -268435457, 
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:-0x10000001;  op2val:0xe
TEST_RR_OP(srl, x12, x10, x11, 0x3bfff, -0x10000001, 0xe, x1, 284, x3)

inst_88:
// rs1_val == -2097153, rs2_val == 4
// opcode: srl ; op1:x10; op2:x11; dest:x12; op1val:-0x200001;  op2val:0x4
TEST_RR_OP(srl, x12, x10, x11, 0xffdffff, -0x200001, 0x4, x1, 288, x3)
#endif


RVTEST_CODE_END
RVMODEL_HALT

RVTEST_DATA_BEGIN
.align 4

rvtest_data:
.word 0xbabecafe
.word 0xbabecafe
.word 0xbabecafe
.word 0xbabecafe
RVTEST_DATA_END


RVMODEL_DATA_BEGIN
rvtest_sig_begin:
sig_begin_canary:
CANARY;


signature_x1_0:
    .fill 0*(XLEN/32),4,0xdeadbeef


signature_x1_1:
    .fill 8*(XLEN/32),4,0xdeadbeef


signature_x10_0:
    .fill 8*(XLEN/32),4,0xdeadbeef


signature_x1_2:
    .fill 73*(XLEN/32),4,0xdeadbeef

#ifdef rvtest_mtrap_routine

tsig_begin_canary:
CANARY;
mtrap_sigptr:
    .fill 64*(XLEN/32),4,0xdeadbeef
tsig_end_canary:
CANARY;

#endif

#ifdef rvtest_gpr_save

gpr_save:
    .fill 32*(XLEN/32),4,0xdeadbeef

#endif

sig_end_canary:
CANARY;
rvtest_sig_end:
RVMODEL_DATA_END
