// -----------
// This file was generated by riscv_ctg (https://gitlab.com/incoresemi/riscv-compliance/riscv_ctg)
// version   : 0.5.1
// timestamp : Mon Aug  2 08:58:53 2021 GMT
// usage     : riscv_ctg \
//                  --cgf /home/bilalsakhawat/riscv-ctg/sample_cgfs/dataset.cgf \
//                  --cgf /home/bilalsakhawat/riscv-ctg/sample_cgfs/rv32e.cgf \
//                  --base-isa rv32e \
//                  --randomize
// -----------
//
// -----------
// Copyright (c) 2020. RISC-V International. All rights reserved.
// SPDX-License-Identifier: BSD-3-Clause
// -----------
//
// This assembly file tests the sw instruction of the RISC-V E extension for the sw-align covergroup.
// 
#include "model_test.h"
#include "arch_test.h"
RVTEST_ISA("RV32E")

.section .text.init
.globl rvtest_entry_point
rvtest_entry_point:
RVMODEL_BOOT
RVTEST_CODE_BEGIN

#ifdef TEST_CASE_1

RVTEST_CASE(0,"//check ISA:=regex(.*32.*);check ISA:=regex(.*E.*) ;def RVTEST_E = True;def TEST_CASE_1=True;",sw-align)

RVTEST_SIGBASE( x2,signature_x2_1)

inst_0:
// rs1 != rs2, rs1==x13, rs2==x1, ea_align == 0 and (imm_val % 4) == 0, imm_val > 0, rs2_val == 67108864
// opcode: sw; op1:x13; op2:x1; op2val:0x4000000; immval:0x4; align:0
TEST_STORE(x2,x9,0,x13,x1,0x4000000,0x4,0,sw,0)

inst_1:
// rs1==x7, rs2==x6, rs2_val == 2147483647, rs2_val == (2**(xlen-1)-1)
// opcode: sw; op1:x7; op2:x6; op2val:0x7fffffff; immval:0x20; align:0
TEST_STORE(x2,x9,0,x7,x6,0x7fffffff,0x20,4,sw,0)

inst_2:
// rs1==x5, rs2==x0, rs2_val == -1073741825, imm_val < 0
// opcode: sw; op1:x5; op2:x0; op2val:0x0; immval:-0x4; align:0
TEST_STORE(x2,x9,0,x5,x0,0x0,-0x4,8,sw,0)

inst_3:
// rs1==x4, rs2==x5, rs2_val == -536870913, ea_align == 0 and (imm_val % 4) == 3
// opcode: sw; op1:x4; op2:x5; op2val:-0x20000001; immval:-0x11; align:0
TEST_STORE(x2,x9,0,x4,x5,-0x20000001,-0x11,12,sw,0)

inst_4:
// rs1==x12, rs2==x3, rs2_val == -268435457, 
// opcode: sw; op1:x12; op2:x3; op2val:-0x10000001; immval:-0x101; align:0
TEST_STORE(x2,x9,0,x12,x3,-0x10000001,-0x101,16,sw,0)

inst_5:
// rs1==x8, rs2==x10, rs2_val == -134217729, 
// opcode: sw; op1:x8; op2:x10; op2val:-0x8000001; immval:-0x1; align:0
TEST_STORE(x2,x9,0,x8,x10,-0x8000001,-0x1,20,sw,0)

inst_6:
// rs1==x1, rs2==x8, rs2_val == -67108865, 
// opcode: sw; op1:x1; op2:x8; op2val:-0x4000001; immval:-0x401; align:0
TEST_STORE(x2,x9,0,x1,x8,-0x4000001,-0x401,24,sw,0)

inst_7:
// rs1==x6, rs2==x15, rs2_val == -33554433, 
// opcode: sw; op1:x6; op2:x15; op2val:-0x2000001; immval:0x40; align:0
TEST_STORE(x2,x9,0,x6,x15,-0x2000001,0x40,28,sw,0)

inst_8:
// rs1==x11, rs2==x14, rs2_val == -16777217, ea_align == 0 and (imm_val % 4) == 1
// opcode: sw; op1:x11; op2:x14; op2val:-0x1000001; immval:0x555; align:0
TEST_STORE(x2,x5,0,x11,x14,-0x1000001,0x555,32,sw,0)
RVTEST_SIGBASE( x1,signature_x1_0)

inst_9:
// rs1==x15, rs2==x7, rs2_val == -8388609, 
// opcode: sw; op1:x15; op2:x7; op2val:-0x800001; immval:-0x201; align:0
TEST_STORE(x1,x5,0,x15,x7,-0x800001,-0x201,0,sw,0)

inst_10:
// rs1==x3, rs2==x12, rs2_val == -4194305, 
// opcode: sw; op1:x3; op2:x12; op2val:-0x400001; immval:-0x8; align:0
TEST_STORE(x1,x5,0,x3,x12,-0x400001,-0x8,4,sw,0)

inst_11:
// rs1==x14, rs2==x9, rs2_val == -2097153, 
// opcode: sw; op1:x14; op2:x9; op2val:-0x200001; immval:-0x800; align:0
TEST_STORE(x1,x5,0,x14,x9,-0x200001,-0x800,8,sw,0)

inst_12:
// rs1==x9, rs2==x13, rs2_val == -1048577, 
// opcode: sw; op1:x9; op2:x13; op2val:-0x100001; immval:0x9; align:0
TEST_STORE(x1,x5,0,x9,x13,-0x100001,0x9,12,sw,0)

inst_13:
// rs1==x10, rs2==x4, rs2_val == -524289, 
// opcode: sw; op1:x10; op2:x4; op2val:-0x80001; immval:0x7; align:0
TEST_STORE(x1,x5,0,x10,x4,-0x80001,0x7,16,sw,0)

inst_14:
// rs1==x2, rs2==x11, rs2_val == -262145, ea_align == 0 and (imm_val % 4) == 2
// opcode: sw; op1:x2; op2:x11; op2val:-0x40001; immval:0x6; align:0
TEST_STORE(x1,x3,0,x2,x11,-0x40001,0x6,20,sw,0)

inst_15:
// rs2==x2, rs2_val == -131073, 
// opcode: sw; op1:x9; op2:x2; op2val:-0x20001; immval:0x20; align:0
TEST_STORE(x1,x3,0,x9,x2,-0x20001,0x20,24,sw,0)

inst_16:
// rs2_val == -65537, 
// opcode: sw; op1:x10; op2:x11; op2val:-0x10001; immval:-0x81; align:0
TEST_STORE(x1,x3,0,x10,x11,-0x10001,-0x81,28,sw,0)

inst_17:
// rs2_val == -32769, 
// opcode: sw; op1:x10; op2:x11; op2val:-0x8001; immval:-0x11; align:0
TEST_STORE(x1,x3,0,x10,x11,-0x8001,-0x11,32,sw,0)

inst_18:
// rs2_val == -16385, imm_val == 0
// opcode: sw; op1:x10; op2:x11; op2val:-0x4001; immval:0x0; align:0
TEST_STORE(x1,x3,0,x10,x11,-0x4001,0x0,36,sw,0)

inst_19:
// rs2_val == -8193, 
// opcode: sw; op1:x10; op2:x11; op2val:-0x2001; immval:0x3ff; align:0
TEST_STORE(x1,x3,0,x10,x11,-0x2001,0x3ff,40,sw,0)

inst_20:
// rs2_val == -4097, 
// opcode: sw; op1:x10; op2:x11; op2val:-0x1001; immval:0x200; align:0
TEST_STORE(x1,x3,0,x10,x11,-0x1001,0x200,44,sw,0)

inst_21:
// rs2_val == -2049, 
// opcode: sw; op1:x10; op2:x11; op2val:-0x801; immval:0x4; align:0
TEST_STORE(x1,x3,0,x10,x11,-0x801,0x4,48,sw,0)

inst_22:
// rs2_val == -1025, 
// opcode: sw; op1:x10; op2:x11; op2val:-0x401; immval:-0x401; align:0
TEST_STORE(x1,x3,0,x10,x11,-0x401,-0x401,52,sw,0)

inst_23:
// rs2_val == -513, 
// opcode: sw; op1:x10; op2:x11; op2val:-0x201; immval:0x3ff; align:0
TEST_STORE(x1,x3,0,x10,x11,-0x201,0x3ff,56,sw,0)

inst_24:
// rs2_val == -257, 
// opcode: sw; op1:x10; op2:x11; op2val:-0x101; immval:-0x81; align:0
TEST_STORE(x1,x3,0,x10,x11,-0x101,-0x81,60,sw,0)

inst_25:
// rs2_val == -129, 
// opcode: sw; op1:x10; op2:x11; op2val:-0x81; immval:0x1; align:0
TEST_STORE(x1,x3,0,x10,x11,-0x81,0x1,64,sw,0)

inst_26:
// rs2_val == -65, 
// opcode: sw; op1:x10; op2:x11; op2val:-0x41; immval:-0xa; align:0
TEST_STORE(x1,x3,0,x10,x11,-0x41,-0xa,68,sw,0)

inst_27:
// rs2_val == -33, 
// opcode: sw; op1:x10; op2:x11; op2val:-0x21; immval:0x3; align:0
TEST_STORE(x1,x3,0,x10,x11,-0x21,0x3,72,sw,0)

inst_28:
// rs2_val == -17, 
// opcode: sw; op1:x10; op2:x11; op2val:-0x11; immval:0x2; align:0
TEST_STORE(x1,x3,0,x10,x11,-0x11,0x2,76,sw,0)

inst_29:
// rs2_val == -9, 
// opcode: sw; op1:x10; op2:x11; op2val:-0x9; immval:-0xa; align:0
TEST_STORE(x1,x3,0,x10,x11,-0x9,-0xa,80,sw,0)

inst_30:
// rs2_val == -5, 
// opcode: sw; op1:x10; op2:x11; op2val:-0x5; immval:0x40; align:0
TEST_STORE(x1,x3,0,x10,x11,-0x5,0x40,84,sw,0)

inst_31:
// rs2_val == -3, 
// opcode: sw; op1:x10; op2:x11; op2val:-0x3; immval:0x1; align:0
TEST_STORE(x1,x3,0,x10,x11,-0x3,0x1,88,sw,0)

inst_32:
// rs2_val == -2, 
// opcode: sw; op1:x10; op2:x11; op2val:-0x2; immval:-0x201; align:0
TEST_STORE(x1,x3,0,x10,x11,-0x2,-0x201,92,sw,0)

inst_33:
// rs2_val == -2147483648, rs2_val == (-2**(xlen-1))
// opcode: sw; op1:x10; op2:x11; op2val:-0x80000000; immval:0x20; align:0
TEST_STORE(x1,x3,0,x10,x11,-0x80000000,0x20,96,sw,0)

inst_34:
// rs2_val == 1073741824, 
// opcode: sw; op1:x10; op2:x11; op2val:0x40000000; immval:-0x401; align:0
TEST_STORE(x1,x3,0,x10,x11,0x40000000,-0x401,100,sw,0)

inst_35:
// rs2_val == 536870912, 
// opcode: sw; op1:x10; op2:x11; op2val:0x20000000; immval:-0x8; align:0
TEST_STORE(x1,x3,0,x10,x11,0x20000000,-0x8,104,sw,0)

inst_36:
// rs2_val == 1, 
// opcode: sw; op1:x10; op2:x11; op2val:0x1; immval:-0x2; align:0
TEST_STORE(x1,x3,0,x10,x11,0x1,-0x2,108,sw,0)

inst_37:
// rs2_val == -1431655766, 
// opcode: sw; op1:x10; op2:x11; op2val:-0x55555556; immval:-0x556; align:0
TEST_STORE(x1,x3,0,x10,x11,-0x55555556,-0x556,112,sw,0)

inst_38:
// rs2_val == 1431655765, 
// opcode: sw; op1:x10; op2:x11; op2val:0x55555555; immval:0x40; align:0
TEST_STORE(x1,x3,0,x10,x11,0x55555555,0x40,116,sw,0)

inst_39:
// rs2_val == 0, 
// opcode: sw; op1:x10; op2:x11; op2val:0x0; immval:-0xa; align:0
TEST_STORE(x1,x3,0,x10,x11,0x0,-0xa,120,sw,0)

inst_40:
// rs2_val == 268435456, 
// opcode: sw; op1:x10; op2:x11; op2val:0x10000000; immval:-0x4; align:0
TEST_STORE(x1,x3,0,x10,x11,0x10000000,-0x4,124,sw,0)

inst_41:
// rs2_val == 134217728, 
// opcode: sw; op1:x10; op2:x11; op2val:0x8000000; immval:0x7ff; align:0
TEST_STORE(x1,x3,0,x10,x11,0x8000000,0x7ff,128,sw,0)

inst_42:
// rs2_val == 33554432, 
// opcode: sw; op1:x10; op2:x11; op2val:0x2000000; immval:0x555; align:0
TEST_STORE(x1,x3,0,x10,x11,0x2000000,0x555,132,sw,0)

inst_43:
// rs2_val == 16777216, 
// opcode: sw; op1:x10; op2:x11; op2val:0x1000000; immval:0x1; align:0
TEST_STORE(x1,x3,0,x10,x11,0x1000000,0x1,136,sw,0)

inst_44:
// rs2_val == 8388608, 
// opcode: sw; op1:x10; op2:x11; op2val:0x800000; immval:-0x5; align:0
TEST_STORE(x1,x3,0,x10,x11,0x800000,-0x5,140,sw,0)

inst_45:
// rs2_val == 4194304, 
// opcode: sw; op1:x10; op2:x11; op2val:0x400000; immval:0x2; align:0
TEST_STORE(x1,x3,0,x10,x11,0x400000,0x2,144,sw,0)

inst_46:
// rs2_val == 2097152, 
// opcode: sw; op1:x10; op2:x11; op2val:0x200000; immval:-0x1; align:0
TEST_STORE(x1,x3,0,x10,x11,0x200000,-0x1,148,sw,0)

inst_47:
// rs2_val == 1048576, 
// opcode: sw; op1:x10; op2:x11; op2val:0x100000; immval:-0x9; align:0
TEST_STORE(x1,x3,0,x10,x11,0x100000,-0x9,152,sw,0)

inst_48:
// rs2_val == 524288, 
// opcode: sw; op1:x10; op2:x11; op2val:0x80000; immval:0x400; align:0
TEST_STORE(x1,x3,0,x10,x11,0x80000,0x400,156,sw,0)

inst_49:
// rs2_val == 262144, 
// opcode: sw; op1:x10; op2:x11; op2val:0x40000; immval:0x555; align:0
TEST_STORE(x1,x3,0,x10,x11,0x40000,0x555,160,sw,0)

inst_50:
// rs2_val == 131072, 
// opcode: sw; op1:x10; op2:x11; op2val:0x20000; immval:-0x8; align:0
TEST_STORE(x1,x3,0,x10,x11,0x20000,-0x8,164,sw,0)

inst_51:
// rs2_val == 65536, 
// opcode: sw; op1:x10; op2:x11; op2val:0x10000; immval:-0x2; align:0
TEST_STORE(x1,x3,0,x10,x11,0x10000,-0x2,168,sw,0)

inst_52:
// rs2_val == 32768, 
// opcode: sw; op1:x10; op2:x11; op2val:0x8000; immval:-0xa; align:0
TEST_STORE(x1,x3,0,x10,x11,0x8000,-0xa,172,sw,0)

inst_53:
// rs2_val == 16384, 
// opcode: sw; op1:x10; op2:x11; op2val:0x4000; immval:-0x1; align:0
TEST_STORE(x1,x3,0,x10,x11,0x4000,-0x1,176,sw,0)

inst_54:
// rs2_val == 8192, 
// opcode: sw; op1:x10; op2:x11; op2val:0x2000; immval:-0x201; align:0
TEST_STORE(x1,x3,0,x10,x11,0x2000,-0x201,180,sw,0)

inst_55:
// rs2_val == 4096, 
// opcode: sw; op1:x10; op2:x11; op2val:0x1000; immval:0x7; align:0
TEST_STORE(x1,x3,0,x10,x11,0x1000,0x7,184,sw,0)

inst_56:
// rs2_val == 2048, 
// opcode: sw; op1:x10; op2:x11; op2val:0x800; immval:-0x81; align:0
TEST_STORE(x1,x3,0,x10,x11,0x800,-0x81,188,sw,0)

inst_57:
// rs2_val == 1024, 
// opcode: sw; op1:x10; op2:x11; op2val:0x400; immval:-0x401; align:0
TEST_STORE(x1,x3,0,x10,x11,0x400,-0x401,192,sw,0)

inst_58:
// rs2_val == 512, 
// opcode: sw; op1:x10; op2:x11; op2val:0x200; immval:0x7; align:0
TEST_STORE(x1,x3,0,x10,x11,0x200,0x7,196,sw,0)

inst_59:
// rs2_val == 256, 
// opcode: sw; op1:x10; op2:x11; op2val:0x100; immval:-0x101; align:0
TEST_STORE(x1,x3,0,x10,x11,0x100,-0x101,200,sw,0)

inst_60:
// rs2_val == 128, 
// opcode: sw; op1:x10; op2:x11; op2val:0x80; immval:-0x21; align:0
TEST_STORE(x1,x3,0,x10,x11,0x80,-0x21,204,sw,0)

inst_61:
// rs2_val == 64, 
// opcode: sw; op1:x10; op2:x11; op2val:0x40; immval:0x40; align:0
TEST_STORE(x1,x3,0,x10,x11,0x40,0x40,208,sw,0)

inst_62:
// rs2_val == 32, 
// opcode: sw; op1:x10; op2:x11; op2val:0x20; immval:0x9; align:0
TEST_STORE(x1,x3,0,x10,x11,0x20,0x9,212,sw,0)

inst_63:
// rs2_val == 16, 
// opcode: sw; op1:x10; op2:x11; op2val:0x10; immval:0x10; align:0
TEST_STORE(x1,x3,0,x10,x11,0x10,0x10,216,sw,0)

inst_64:
// rs2_val == 8, 
// opcode: sw; op1:x10; op2:x11; op2val:0x8; immval:0x400; align:0
TEST_STORE(x1,x3,0,x10,x11,0x8,0x400,220,sw,0)

inst_65:
// rs2_val == 4, 
// opcode: sw; op1:x10; op2:x11; op2val:0x4; immval:-0x401; align:0
TEST_STORE(x1,x3,0,x10,x11,0x4,-0x401,224,sw,0)

inst_66:
// rs2_val == 2, 
// opcode: sw; op1:x10; op2:x11; op2val:0x2; immval:-0x400; align:0
TEST_STORE(x1,x3,0,x10,x11,0x2,-0x400,228,sw,0)

inst_67:
// rs2_val == -1073741825, imm_val < 0
// opcode: sw; op1:x10; op2:x11; op2val:-0x40000001; immval:-0x4; align:0
TEST_STORE(x1,x3,0,x10,x11,-0x40000001,-0x4,232,sw,0)
#endif


RVTEST_CODE_END
RVMODEL_HALT

RVTEST_DATA_BEGIN
.align 4

rvtest_data:
.word 0xbabecafe
.word 0xbabecafe
.word 0xbabecafe
.word 0xbabecafe
RVTEST_DATA_END


RVMODEL_DATA_BEGIN
rvtest_sig_begin:
sig_begin_canary:
CANARY;


signature_x2_0:
    .fill 0*(XLEN/32),4,0xdeadbeef


signature_x2_1:
    .fill 9*(XLEN/32),4,0xdeadbeef


signature_x1_0:
    .fill 59*(XLEN/32),4,0xdeadbeef

#ifdef rvtest_mtrap_routine

tsig_begin_canary:
CANARY;
mtrap_sigptr:
    .fill 64*(XLEN/32),4,0xdeadbeef
tsig_end_canary:
CANARY;

#endif

#ifdef rvtest_gpr_save

gpr_save:
    .fill 32*(XLEN/32),4,0xdeadbeef

#endif

sig_end_canary:
CANARY;
rvtest_sig_end:
RVMODEL_DATA_END
