
// -----------
// This file was generated by riscv_ctg (https://github.com/riscv-software-src/riscv-ctg)
// version   : 0.7.1
// timestamp : Sun Aug  7 17:43:57 2022 GMT
// usage     : riscv_ctg \
//                  -- cgf //                  --cgf /home/anku/work2/bmanip/32/dataset.yaml \
//                  --cgf /home/anku/work2/bmanip/32/rv32ib.yaml \
 \
//                  -- xlen 32  \
// -----------
//
// -----------
// Copyright (c) 2020. RISC-V International. All rights reserved.
// SPDX-License-Identifier: BSD-3-Clause
// -----------
//
// This assembly file tests the binv instruction of the RISC-V RV32Zbs extension for the binv covergroup.
// 
#include "model_test.h"
#include "arch_test.h"
RVTEST_ISA("RV32IZbs")

.section .text.init
.org 0x80
.globl rvtest_entry_point
rvtest_entry_point:
RVMODEL_BOOT
RVTEST_CODE_BEGIN

#ifdef TEST_CASE_1

RVTEST_CASE(0,"//check ISA:=regex(.*32.*);check ISA:=regex(.*I.*Zbs.*);def TEST_CASE_1=True;",binv)

RVTEST_SIGBASE(x1,signature_x1_1)

inst_0:
// rs1 == rs2 == rd, rs1==x31, rs2==x31, rd==x31, 
// opcode: binv ; op1:x31; op2:x31; dest:x31; op1val:0x55555555;  op2val:0x55555555
TEST_RR_OP(binv, x31, x31, x31, 0x00000000, 0x55555555, 0x55555555, x1, 0, x2)

inst_1:
// rs1 != rs2  and rs1 != rd and rs2 != rd, rs1==x29, rs2==x28, rd==x30, 
// opcode: binv ; op1:x29; op2:x28; dest:x30; op1val:0x7fffffff;  op2val:0xbfffffff
TEST_RR_OP(binv, x30, x29, x28, 0x00000000, 0x7fffffff, 0xbfffffff, x1, 4, x2)

inst_2:
// rs1 == rd != rs2, rs1==x28, rs2==x30, rd==x28, 
// opcode: binv ; op1:x28; op2:x30; dest:x28; op1val:0x7fffffff;  op2val:0xdfffffff
TEST_RR_OP(binv, x28, x28, x30, 0x00000000, 0x7fffffff, 0xdfffffff, x1, 8, x2)

inst_3:
// rs1 == rs2 != rd, rs1==x27, rs2==x27, rd==x29, 
// opcode: binv ; op1:x27; op2:x27; dest:x29; op1val:0x7fffffff;  op2val:0x7fffffff
TEST_RR_OP(binv, x29, x27, x27, 0x00000000, 0x7fffffff, 0x7fffffff, x1, 12, x2)

inst_4:
// rs2 == rd != rs1, rs1==x30, rs2==x26, rd==x26, 
// opcode: binv ; op1:x30; op2:x26; dest:x26; op1val:0x7fffffff;  op2val:0xf7ffffff
TEST_RR_OP(binv, x26, x30, x26, 0x00000000, 0x7fffffff, 0xf7ffffff, x1, 16, x2)

inst_5:
// rs1==x26, rs2==x29, rd==x27, 
// opcode: binv ; op1:x26; op2:x29; dest:x27; op1val:0x7fffffff;  op2val:0xfbffffff
TEST_RR_OP(binv, x27, x26, x29, 0x00000000, 0x7fffffff, 0xfbffffff, x1, 20, x2)

inst_6:
// rs1==x24, rs2==x23, rd==x25, 
// opcode: binv ; op1:x24; op2:x23; dest:x25; op1val:0x7fffffff;  op2val:0xfdffffff
TEST_RR_OP(binv, x25, x24, x23, 0x00000000, 0x7fffffff, 0xfdffffff, x1, 24, x2)

inst_7:
// rs1==x23, rs2==x25, rd==x24, 
// opcode: binv ; op1:x23; op2:x25; dest:x24; op1val:0x7fffffff;  op2val:0xfeffffff
TEST_RR_OP(binv, x24, x23, x25, 0x00000000, 0x7fffffff, 0xfeffffff, x1, 28, x2)

inst_8:
// rs1==x25, rs2==x24, rd==x23, 
// opcode: binv ; op1:x25; op2:x24; dest:x23; op1val:0x7fffffff;  op2val:0xff7fffff
TEST_RR_OP(binv, x23, x25, x24, 0x00000000, 0x7fffffff, 0xff7fffff, x1, 32, x2)

inst_9:
// rs1==x21, rs2==x20, rd==x22, 
// opcode: binv ; op1:x21; op2:x20; dest:x22; op1val:0x7fffffff;  op2val:0xffbfffff
TEST_RR_OP(binv, x22, x21, x20, 0x00000000, 0x7fffffff, 0xffbfffff, x1, 36, x2)

inst_10:
// rs1==x20, rs2==x22, rd==x21, 
// opcode: binv ; op1:x20; op2:x22; dest:x21; op1val:0x7fffffff;  op2val:0xffdfffff
TEST_RR_OP(binv, x21, x20, x22, 0x00000000, 0x7fffffff, 0xffdfffff, x1, 40, x2)

inst_11:
// rs1==x22, rs2==x21, rd==x20, 
// opcode: binv ; op1:x22; op2:x21; dest:x20; op1val:0x7fffffff;  op2val:0xffefffff
TEST_RR_OP(binv, x20, x22, x21, 0x00000000, 0x7fffffff, 0xffefffff, x1, 44, x2)

inst_12:
// rs1==x18, rs2==x17, rd==x19, 
// opcode: binv ; op1:x18; op2:x17; dest:x19; op1val:0x7fffffff;  op2val:0xfff7ffff
TEST_RR_OP(binv, x19, x18, x17, 0x00000000, 0x7fffffff, 0xfff7ffff, x1, 48, x2)

inst_13:
// rs1==x17, rs2==x19, rd==x18, 
// opcode: binv ; op1:x17; op2:x19; dest:x18; op1val:0x7fffffff;  op2val:0xfffbffff
TEST_RR_OP(binv, x18, x17, x19, 0x00000000, 0x7fffffff, 0xfffbffff, x1, 52, x2)

inst_14:
// rs1==x19, rs2==x18, rd==x17, 
// opcode: binv ; op1:x19; op2:x18; dest:x17; op1val:0x7fffffff;  op2val:0xfffdffff
TEST_RR_OP(binv, x17, x19, x18, 0x00000000, 0x7fffffff, 0xfffdffff, x1, 56, x2)

inst_15:
// rs1==x15, rs2==x14, rd==x16, 
// opcode: binv ; op1:x15; op2:x14; dest:x16; op1val:0x7fffffff;  op2val:0xfffeffff
TEST_RR_OP(binv, x16, x15, x14, 0x00000000, 0x7fffffff, 0xfffeffff, x1, 60, x2)

inst_16:
// rs1==x14, rs2==x16, rd==x15, 
// opcode: binv ; op1:x14; op2:x16; dest:x15; op1val:0x7fffffff;  op2val:0xffff7fff
TEST_RR_OP(binv, x15, x14, x16, 0x00000000, 0x7fffffff, 0xffff7fff, x1, 64, x2)

inst_17:
// rs1==x16, rs2==x15, rd==x14, 
// opcode: binv ; op1:x16; op2:x15; dest:x14; op1val:0x7fffffff;  op2val:0xffffbfff
TEST_RR_OP(binv, x14, x16, x15, 0x00000000, 0x7fffffff, 0xffffbfff, x1, 68, x2)

inst_18:
// rs1==x12, rs2==x11, rd==x13, 
// opcode: binv ; op1:x12; op2:x11; dest:x13; op1val:0x7fffffff;  op2val:0xffffdfff
TEST_RR_OP(binv, x13, x12, x11, 0x00000000, 0x7fffffff, 0xffffdfff, x1, 72, x2)

inst_19:
// rs1==x11, rs2==x13, rd==x12, 
// opcode: binv ; op1:x11; op2:x13; dest:x12; op1val:0x7fffffff;  op2val:0xffffefff
TEST_RR_OP(binv, x12, x11, x13, 0x00000000, 0x7fffffff, 0xffffefff, x1, 76, x2)

inst_20:
// rs1==x13, rs2==x12, rd==x11, 
// opcode: binv ; op1:x13; op2:x12; dest:x11; op1val:0x7fffffff;  op2val:0xfffff7ff
TEST_RR_OP(binv, x11, x13, x12, 0x00000000, 0x7fffffff, 0xfffff7ff, x1, 80, x2)

inst_21:
// rs1==x9, rs2==x8, rd==x10, 
// opcode: binv ; op1:x9; op2:x8; dest:x10; op1val:0x7fffffff;  op2val:0xfffffbff
TEST_RR_OP(binv, x10, x9, x8, 0x00000000, 0x7fffffff, 0xfffffbff, x1, 84, x2)

inst_22:
// rs1==x8, rs2==x10, rd==x9, 
// opcode: binv ; op1:x8; op2:x10; dest:x9; op1val:0x7fffffff;  op2val:0xfffffdff
TEST_RR_OP(binv, x9, x8, x10, 0x00000000, 0x7fffffff, 0xfffffdff, x1, 88, x2)

inst_23:
// rs1==x10, rs2==x9, rd==x8, 
// opcode: binv ; op1:x10; op2:x9; dest:x8; op1val:0x7fffffff;  op2val:0xfffffeff
TEST_RR_OP(binv, x8, x10, x9, 0x00000000, 0x7fffffff, 0xfffffeff, x1, 92, x2)

inst_24:
// rs1==x6, rs2==x5, rd==x7, 
// opcode: binv ; op1:x6; op2:x5; dest:x7; op1val:0x7fffffff;  op2val:0xffffff7f
TEST_RR_OP(binv, x7, x6, x5, 0x00000000, 0x7fffffff, 0xffffff7f, x1, 96, x2)
RVTEST_SIGBASE(x8,signature_x8_0)

inst_25:
// rs1==x5, rs2==x7, rd==x6, 
// opcode: binv ; op1:x5; op2:x7; dest:x6; op1val:0x7fffffff;  op2val:0xffffffbf
TEST_RR_OP(binv, x6, x5, x7, 0x00000000, 0x7fffffff, 0xffffffbf, x8, 0, x9)

inst_26:
// rs1==x7, rs2==x6, rd==x5, 
// opcode: binv ; op1:x7; op2:x6; dest:x5; op1val:0x7fffffff;  op2val:0xffffffdf
TEST_RR_OP(binv, x5, x7, x6, 0x00000000, 0x7fffffff, 0xffffffdf, x8, 4, x9)

inst_27:
// rs1==x3, rs2==x2, rd==x4, 
// opcode: binv ; op1:x3; op2:x2; dest:x4; op1val:0x7fffffff;  op2val:0xffffffef
TEST_RR_OP(binv, x4, x3, x2, 0x00000000, 0x7fffffff, 0xffffffef, x8, 8, x9)

inst_28:
// rs1==x2, rs2==x4, rd==x3, 
// opcode: binv ; op1:x2; op2:x4; dest:x3; op1val:0x7fffffff;  op2val:0xfffffff7
TEST_RR_OP(binv, x3, x2, x4, 0x00000000, 0x7fffffff, 0xfffffff7, x8, 12, x9)

inst_29:
// rs1==x4, rs2==x3, rd==x2, 
// opcode: binv ; op1:x4; op2:x3; dest:x2; op1val:0x7fffffff;  op2val:0xfffffffb
TEST_RR_OP(binv, x2, x4, x3, 0x00000000, 0x7fffffff, 0xfffffffb, x8, 16, x9)

inst_30:
// rs1==x1, 
// opcode: binv ; op1:x1; op2:x30; dest:x31; op1val:0x7fffffff;  op2val:0xfffffffd
TEST_RR_OP(binv, x31, x1, x30, 0x00000000, 0x7fffffff, 0xfffffffd, x8, 20, x9)

inst_31:
// rs1==x0, 
// opcode: binv ; op1:x0; op2:x30; dest:x31; op1val:0x0;  op2val:0xfffffffe
TEST_RR_OP(binv, x31, x0, x30, 0x00000000, 0x0, 0xfffffffe, x8, 24, x9)

inst_32:
// rs2==x1, 
// opcode: binv ; op1:x30; op2:x1; dest:x31; op1val:0xbfffffff;  op2val:0x7fffffff
TEST_RR_OP(binv, x31, x30, x1, 0x00000000, 0xbfffffff, 0x7fffffff, x8, 28, x9)

inst_33:
// rs2==x0, 
// opcode: binv ; op1:x30; op2:x0; dest:x31; op1val:0xdfffffff;  op2val:0x0
TEST_RR_OP(binv, x31, x30, x0, 0x00000000, 0xdfffffff, 0x0, x8, 32, x9)

inst_34:
// rd==x1, 
// opcode: binv ; op1:x31; op2:x30; dest:x1; op1val:0xefffffff;  op2val:0x7fffffff
TEST_RR_OP(binv, x1, x31, x30, 0x00000000, 0xefffffff, 0x7fffffff, x8, 36, x9)

inst_35:
// rd==x0, 
// opcode: binv ; op1:x31; op2:x30; dest:x0; op1val:0xf7ffffff;  op2val:0x7fffffff
TEST_RR_OP(binv, x0, x31, x30, 0x00000000, 0xf7ffffff, 0x7fffffff, x8, 40, x9)

inst_36:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xfbffffff;  op2val:0x7fffffff
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xfbffffff, 0x7fffffff, x8, 44, x9)

inst_37:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xfdffffff;  op2val:0x7fffffff
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xfdffffff, 0x7fffffff, x8, 48, x9)

inst_38:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xfeffffff;  op2val:0x7fffffff
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xfeffffff, 0x7fffffff, x8, 52, x9)

inst_39:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xff7fffff;  op2val:0x7fffffff
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xff7fffff, 0x7fffffff, x8, 56, x9)

inst_40:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xffbfffff;  op2val:0x7fffffff
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xffbfffff, 0x7fffffff, x8, 60, x9)

inst_41:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xffdfffff;  op2val:0x7fffffff
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xffdfffff, 0x7fffffff, x8, 64, x9)

inst_42:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xffefffff;  op2val:0x7fffffff
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xffefffff, 0x7fffffff, x8, 68, x9)

inst_43:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xfff7ffff;  op2val:0x7fffffff
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xfff7ffff, 0x7fffffff, x8, 72, x9)

inst_44:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xfffbffff;  op2val:0x7fffffff
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xfffbffff, 0x7fffffff, x8, 76, x9)

inst_45:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xfffdffff;  op2val:0x7fffffff
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xfffdffff, 0x7fffffff, x8, 80, x9)

inst_46:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xfffeffff;  op2val:0x7fffffff
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xfffeffff, 0x7fffffff, x8, 84, x9)

inst_47:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xffff7fff;  op2val:0x7fffffff
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xffff7fff, 0x7fffffff, x8, 88, x9)

inst_48:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xffffbfff;  op2val:0x7fffffff
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xffffbfff, 0x7fffffff, x8, 92, x9)

inst_49:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xffffdfff;  op2val:0x7fffffff
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xffffdfff, 0x7fffffff, x8, 96, x9)

inst_50:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xffffefff;  op2val:0x7fffffff
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xffffefff, 0x7fffffff, x8, 100, x9)

inst_51:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xfffff7ff;  op2val:0x7fffffff
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xfffff7ff, 0x7fffffff, x8, 104, x9)

inst_52:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xfffffbff;  op2val:0x7fffffff
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xfffffbff, 0x7fffffff, x8, 108, x9)

inst_53:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xfffffdff;  op2val:0x7fffffff
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xfffffdff, 0x7fffffff, x8, 112, x9)

inst_54:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xfffffeff;  op2val:0x7fffffff
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xfffffeff, 0x7fffffff, x8, 116, x9)

inst_55:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xffffff7f;  op2val:0x7fffffff
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xffffff7f, 0x7fffffff, x8, 120, x9)

inst_56:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xffffffbf;  op2val:0x7fffffff
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xffffffbf, 0x7fffffff, x8, 124, x9)

inst_57:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xffffffdf;  op2val:0x7fffffff
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xffffffdf, 0x7fffffff, x8, 128, x9)

inst_58:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xffffffef;  op2val:0x7fffffff
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xffffffef, 0x7fffffff, x8, 132, x9)

inst_59:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xfffffff7;  op2val:0x7fffffff
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xfffffff7, 0x7fffffff, x8, 136, x9)

inst_60:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xfffffffb;  op2val:0x7fffffff
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xfffffffb, 0x7fffffff, x8, 140, x9)

inst_61:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xfffffffd;  op2val:0x7fffffff
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xfffffffd, 0x7fffffff, x8, 144, x9)

inst_62:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xfffffffe;  op2val:0x7fffffff
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xfffffffe, 0x7fffffff, x8, 148, x9)

inst_63:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x7fffffff;  op2val:0x80000000
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x7fffffff, 0x80000000, x8, 152, x9)

inst_64:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x7fffffff;  op2val:0x40000000
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x7fffffff, 0x40000000, x8, 156, x9)

inst_65:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x7fffffff;  op2val:0x20000000
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x7fffffff, 0x20000000, x8, 160, x9)

inst_66:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x7fffffff;  op2val:0x10000000
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x7fffffff, 0x10000000, x8, 164, x9)

inst_67:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x7fffffff;  op2val:0x8000000
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x7fffffff, 0x8000000, x8, 168, x9)

inst_68:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x7fffffff;  op2val:0x4000000
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x7fffffff, 0x4000000, x8, 172, x9)

inst_69:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x7fffffff;  op2val:0x2000000
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x7fffffff, 0x2000000, x8, 176, x9)

inst_70:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x7fffffff;  op2val:0x1000000
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x7fffffff, 0x1000000, x8, 180, x9)

inst_71:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x7fffffff;  op2val:0x800000
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x7fffffff, 0x800000, x8, 184, x9)

inst_72:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x7fffffff;  op2val:0x400000
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x7fffffff, 0x400000, x8, 188, x9)

inst_73:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x7fffffff;  op2val:0x200000
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x7fffffff, 0x200000, x8, 192, x9)

inst_74:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x7fffffff;  op2val:0x100000
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x7fffffff, 0x100000, x8, 196, x9)

inst_75:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x7fffffff;  op2val:0x80000
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x7fffffff, 0x80000, x8, 200, x9)

inst_76:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x7fffffff;  op2val:0x40000
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x7fffffff, 0x40000, x8, 204, x9)

inst_77:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x7fffffff;  op2val:0x20000
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x7fffffff, 0x20000, x8, 208, x9)

inst_78:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x7fffffff;  op2val:0x10000
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x7fffffff, 0x10000, x8, 212, x9)

inst_79:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x7fffffff;  op2val:0x8000
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x7fffffff, 0x8000, x8, 216, x9)

inst_80:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x7fffffff;  op2val:0x4000
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x7fffffff, 0x4000, x8, 220, x9)

inst_81:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x7fffffff;  op2val:0x2000
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x7fffffff, 0x2000, x8, 224, x9)

inst_82:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x7fffffff;  op2val:0x1000
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x7fffffff, 0x1000, x8, 228, x9)

inst_83:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x7fffffff;  op2val:0x800
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x7fffffff, 0x800, x8, 232, x9)

inst_84:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x7fffffff;  op2val:0x400
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x7fffffff, 0x400, x8, 236, x9)

inst_85:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x7fffffff;  op2val:0x200
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x7fffffff, 0x200, x8, 240, x9)

inst_86:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x7fffffff;  op2val:0x100
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x7fffffff, 0x100, x8, 244, x9)

inst_87:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x7fffffff;  op2val:0x80
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x7fffffff, 0x80, x8, 248, x9)

inst_88:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x7fffffff;  op2val:0x40
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x7fffffff, 0x40, x8, 252, x9)

inst_89:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x7fffffff;  op2val:0x20
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x7fffffff, 0x20, x8, 256, x9)

inst_90:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x7fffffff;  op2val:0x10
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x7fffffff, 0x10, x8, 260, x9)

inst_91:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x7fffffff;  op2val:0x8
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x7fffffff, 0x8, x8, 264, x9)

inst_92:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x7fffffff;  op2val:0x4
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x7fffffff, 0x4, x8, 268, x9)

inst_93:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x7fffffff;  op2val:0x2
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x7fffffff, 0x2, x8, 272, x9)

inst_94:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x7fffffff;  op2val:0x1
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x7fffffff, 0x1, x8, 276, x9)

inst_95:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x80000000;  op2val:0x7fffffff
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x80000000, 0x7fffffff, x8, 280, x9)

inst_96:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x40000000;  op2val:0x7fffffff
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x40000000, 0x7fffffff, x8, 284, x9)

inst_97:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x20000000;  op2val:0x7fffffff
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x20000000, 0x7fffffff, x8, 288, x9)

inst_98:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x10000000;  op2val:0x7fffffff
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x10000000, 0x7fffffff, x8, 292, x9)

inst_99:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x8000000;  op2val:0x7fffffff
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x8000000, 0x7fffffff, x8, 296, x9)

inst_100:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x4000000;  op2val:0x7fffffff
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x4000000, 0x7fffffff, x8, 300, x9)

inst_101:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x2000000;  op2val:0x7fffffff
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x2000000, 0x7fffffff, x8, 304, x9)

inst_102:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x1000000;  op2val:0x7fffffff
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x1000000, 0x7fffffff, x8, 308, x9)

inst_103:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x800000;  op2val:0x7fffffff
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x800000, 0x7fffffff, x8, 312, x9)

inst_104:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x400000;  op2val:0x7fffffff
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x400000, 0x7fffffff, x8, 316, x9)

inst_105:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x200000;  op2val:0x7fffffff
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x200000, 0x7fffffff, x8, 320, x9)

inst_106:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x100000;  op2val:0x7fffffff
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x100000, 0x7fffffff, x8, 324, x9)

inst_107:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x80000;  op2val:0x7fffffff
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x80000, 0x7fffffff, x8, 328, x9)

inst_108:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x40000;  op2val:0x7fffffff
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x40000, 0x7fffffff, x8, 332, x9)

inst_109:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x20000;  op2val:0x7fffffff
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x20000, 0x7fffffff, x8, 336, x9)

inst_110:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x10000;  op2val:0x7fffffff
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x10000, 0x7fffffff, x8, 340, x9)

inst_111:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x8000;  op2val:0x7fffffff
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x8000, 0x7fffffff, x8, 344, x9)

inst_112:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x4000;  op2val:0x7fffffff
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x4000, 0x7fffffff, x8, 348, x9)

inst_113:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x2000;  op2val:0x7fffffff
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x2000, 0x7fffffff, x8, 352, x9)

inst_114:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x1000;  op2val:0x7fffffff
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x1000, 0x7fffffff, x8, 356, x9)

inst_115:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x800;  op2val:0x7fffffff
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x800, 0x7fffffff, x8, 360, x9)

inst_116:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x400;  op2val:0x7fffffff
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x400, 0x7fffffff, x8, 364, x9)

inst_117:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x200;  op2val:0x7fffffff
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x200, 0x7fffffff, x8, 368, x9)

inst_118:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x100;  op2val:0x7fffffff
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x100, 0x7fffffff, x8, 372, x9)

inst_119:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x80;  op2val:0x7fffffff
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x80, 0x7fffffff, x8, 376, x9)

inst_120:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x40;  op2val:0x7fffffff
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x40, 0x7fffffff, x8, 380, x9)

inst_121:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x20;  op2val:0x7fffffff
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x20, 0x7fffffff, x8, 384, x9)

inst_122:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x10;  op2val:0x7fffffff
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x10, 0x7fffffff, x8, 388, x9)

inst_123:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x8;  op2val:0x7fffffff
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x8, 0x7fffffff, x8, 392, x9)

inst_124:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x4;  op2val:0x7fffffff
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x4, 0x7fffffff, x8, 396, x9)

inst_125:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x2;  op2val:0x7fffffff
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x2, 0x7fffffff, x8, 400, x9)

inst_126:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x1;  op2val:0x7fffffff
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x1, 0x7fffffff, x8, 404, x9)

inst_127:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x2dedb6a7;  op2val:0x0
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x2dedb6a7, 0x0, x8, 408, x9)

inst_128:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x3c272728;  op2val:0x10
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x3c272728, 0x10, x8, 412, x9)

inst_129:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x4f55c73d;  op2val:0x18
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x4f55c73d, 0x18, x8, 416, x9)

inst_130:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xb0ab577a;  op2val:0x14
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xb0ab577a, 0x14, x8, 420, x9)

inst_131:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xf0eb21aa;  op2val:0x1a
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xf0eb21aa, 0x1a, x8, 424, x9)

inst_132:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xa9e16e27;  op2val:0x1b
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xa9e16e27, 0x1b, x8, 428, x9)

inst_133:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x0;  op2val:0xc
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x0, 0xc, x8, 432, x9)

inst_134:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x80000000;  op2val:0x5
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x80000000, 0x5, x8, 436, x9)

inst_135:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x40000000;  op2val:0x1
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x40000000, 0x1, x8, 440, x9)

inst_136:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x60000000;  op2val:0x18
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x60000000, 0x18, x8, 444, x9)

inst_137:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xb0000000;  op2val:0x1e
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xb0000000, 0x1e, x8, 448, x9)

inst_138:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x8000000;  op2val:0x1a
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x8000000, 0x1a, x8, 452, x9)

inst_139:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xf4000000;  op2val:0x5
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xf4000000, 0x5, x8, 456, x9)

inst_140:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x82000000;  op2val:0xa
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x82000000, 0xa, x8, 460, x9)

inst_141:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xfd000000;  op2val:0x3
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xfd000000, 0x3, x8, 464, x9)

inst_142:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xd8800000;  op2val:0xa
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xd8800000, 0xa, x8, 468, x9)

inst_143:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xc8c00000;  op2val:0x14
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xc8c00000, 0x14, x8, 472, x9)

inst_144:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xa3200000;  op2val:0x8
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xa3200000, 0x8, x8, 476, x9)

inst_145:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xc7900000;  op2val:0x1b
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xc7900000, 0x1b, x8, 480, x9)

inst_146:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x46880000;  op2val:0x1c
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x46880000, 0x1c, x8, 484, x9)

inst_147:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x55440000;  op2val:0x1b
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x55440000, 0x1b, x8, 488, x9)

inst_148:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xa56a0000;  op2val:0xe
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xa56a0000, 0xe, x8, 492, x9)

inst_149:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x405d0000;  op2val:0x3
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x405d0000, 0x3, x8, 496, x9)

inst_150:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xcd2f8000;  op2val:0x5
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xcd2f8000, 0x5, x8, 500, x9)

inst_151:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xa6c04000;  op2val:0x19
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xa6c04000, 0x19, x8, 504, x9)

inst_152:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x33bc2000;  op2val:0x15
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x33bc2000, 0x15, x8, 508, x9)

inst_153:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xf1c6b000;  op2val:0xc
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xf1c6b000, 0xc, x8, 512, x9)

inst_154:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xaa3d6800;  op2val:0xd
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xaa3d6800, 0xd, x8, 516, x9)

inst_155:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x7aa5e400;  op2val:0xa
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x7aa5e400, 0xa, x8, 520, x9)

inst_156:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xc1b7ae00;  op2val:0x1c
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xc1b7ae00, 0x1c, x8, 524, x9)

inst_157:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x4c56bb00;  op2val:0x9
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x4c56bb00, 0x9, x8, 528, x9)

inst_158:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x72c58380;  op2val:0x0
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x72c58380, 0x0, x8, 532, x9)

inst_159:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x32ab8740;  op2val:0xe
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x32ab8740, 0xe, x8, 536, x9)

inst_160:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x96cdf1a0;  op2val:0x1d
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x96cdf1a0, 0x1d, x8, 540, x9)

inst_161:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xb87a9e30;  op2val:0x11
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xb87a9e30, 0x11, x8, 544, x9)

inst_162:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x163dff98;  op2val:0x17
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x163dff98, 0x17, x8, 548, x9)

inst_163:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x9205d39c;  op2val:0x18
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x9205d39c, 0x18, x8, 552, x9)

inst_164:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x50a03c5a;  op2val:0x16
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x50a03c5a, 0x16, x8, 556, x9)

inst_165:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x797d76df;  op2val:0x11
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x797d76df, 0x11, x8, 560, x9)

inst_166:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x24496fe3;  op2val:0x8
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x24496fe3, 0x8, x8, 564, x9)

inst_167:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xde14bff2;  op2val:0x1d
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xde14bff2, 0x1d, x8, 568, x9)

inst_168:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xb808a677;  op2val:0x3
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xb808a677, 0x3, x8, 572, x9)

inst_169:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x76b1fd3d;  op2val:0x7
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x76b1fd3d, 0x7, x8, 576, x9)

inst_170:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x5dcf019d;  op2val:0xf
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x5dcf019d, 0xf, x8, 580, x9)

inst_171:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x47b7097b;  op2val:0x1f
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x47b7097b, 0x1f, x8, 584, x9)

inst_172:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x759f1b44;  op2val:0x10
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x759f1b44, 0x10, x8, 588, x9)

inst_173:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x40d90a1d;  op2val:0x17
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x40d90a1d, 0x17, x8, 592, x9)

inst_174:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x2dedf123;  op2val:0x16
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x2dedf123, 0x16, x8, 596, x9)

inst_175:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x4b1634e7;  op2val:0xc
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x4b1634e7, 0xc, x8, 600, x9)

inst_176:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x8935b82f;  op2val:0xb
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x8935b82f, 0xb, x8, 604, x9)

inst_177:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x70bcb8df;  op2val:0x1c
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x70bcb8df, 0x1c, x8, 608, x9)

inst_178:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x8de1c73f;  op2val:0x8
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x8de1c73f, 0x8, x8, 612, x9)

inst_179:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xb0e04e7f;  op2val:0x1c
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xb0e04e7f, 0x1c, x8, 616, x9)

inst_180:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x589218ff;  op2val:0x10
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x589218ff, 0x10, x8, 620, x9)

inst_181:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xa7be99ff;  op2val:0x7
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xa7be99ff, 0x7, x8, 624, x9)

inst_182:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xa37e33ff;  op2val:0x14
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xa37e33ff, 0x14, x8, 628, x9)

inst_183:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xe37d37ff;  op2val:0x1b
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xe37d37ff, 0x1b, x8, 632, x9)

inst_184:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xabb4cfff;  op2val:0x17
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xabb4cfff, 0x17, x8, 636, x9)

inst_185:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x7c9ddfff;  op2val:0x1b
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x7c9ddfff, 0x1b, x8, 640, x9)

inst_186:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x5b11bfff;  op2val:0xe
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x5b11bfff, 0xe, x8, 644, x9)

inst_187:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xcb347fff;  op2val:0x10
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xcb347fff, 0x10, x8, 648, x9)

inst_188:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xf306ffff;  op2val:0x8
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xf306ffff, 0x8, x8, 652, x9)

inst_189:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xbea5ffff;  op2val:0x1b
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xbea5ffff, 0x1b, x8, 656, x9)

inst_190:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xd38bffff;  op2val:0x1c
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xd38bffff, 0x1c, x8, 660, x9)

inst_191:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x15b7ffff;  op2val:0x10
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x15b7ffff, 0x10, x8, 664, x9)

inst_192:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xd58fffff;  op2val:0x9
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xd58fffff, 0x9, x8, 668, x9)

inst_193:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xfe1fffff;  op2val:0x11
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xfe1fffff, 0x11, x8, 672, x9)

inst_194:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x203fffff;  op2val:0x0
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x203fffff, 0x0, x8, 676, x9)

inst_195:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x77fffff;  op2val:0x1b
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x77fffff, 0x1b, x8, 680, x9)

inst_196:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xbeffffff;  op2val:0x12
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xbeffffff, 0x12, x8, 684, x9)

inst_197:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x89ffffff;  op2val:0xd
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x89ffffff, 0xd, x8, 688, x9)

inst_198:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x23ffffff;  op2val:0x4
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x23ffffff, 0x4, x8, 692, x9)

inst_199:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xa7ffffff;  op2val:0xb
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xa7ffffff, 0xb, x8, 696, x9)

inst_200:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xcfffffff;  op2val:0xe
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xcfffffff, 0xe, x8, 700, x9)

inst_201:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x9fffffff;  op2val:0x9
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x9fffffff, 0x9, x8, 704, x9)

inst_202:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xbfffffff;  op2val:0xe
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xbfffffff, 0xe, x8, 708, x9)

inst_203:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x7fffffff;  op2val:0xb
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x7fffffff, 0xb, x8, 712, x9)

inst_204:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x12
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xffffffff, 0x12, x8, 716, x9)

inst_205:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x164f1513;  op2val:0x1b
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x164f1513, 0x1b, x8, 720, x9)

inst_206:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xacc6d8f2;  op2val:0x9
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xacc6d8f2, 0x9, x8, 724, x9)

inst_207:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xa123f501;  op2val:0x6
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xa123f501, 0x6, x8, 728, x9)

inst_208:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xb57a6a1d;  op2val:0x2
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xb57a6a1d, 0x2, x8, 732, x9)

inst_209:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xe90794df;  op2val:0x1
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xe90794df, 0x1, x8, 736, x9)

inst_210:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xaf5570ee;  op2val:0x0
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xaf5570ee, 0x0, x8, 740, x9)

inst_211:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xf542441e;  op2val:0x1
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xf542441e, 0x1, x8, 744, x9)

inst_212:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x62f28d1b;  op2val:0x4
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x62f28d1b, 0x4, x8, 748, x9)

inst_213:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x38b9b45d;  op2val:0x12
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x38b9b45d, 0x12, x8, 752, x9)

inst_214:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x16809a12;  op2val:0x6
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x16809a12, 0x6, x8, 756, x9)

inst_215:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x82a1750;  op2val:0x6
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x82a1750, 0x6, x8, 760, x9)

inst_216:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x79dd25b;  op2val:0x4
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x79dd25b, 0x4, x8, 764, x9)

inst_217:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x34c687b;  op2val:0x12
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x34c687b, 0x12, x8, 768, x9)

inst_218:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x1b601fd;  op2val:0xe
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x1b601fd, 0xe, x8, 772, x9)

inst_219:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xb302fd;  op2val:0x10
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xb302fd, 0x10, x8, 776, x9)

inst_220:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x62a6b3;  op2val:0x5
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x62a6b3, 0x5, x8, 780, x9)

inst_221:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x339238;  op2val:0x11
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x339238, 0x11, x8, 784, x9)

inst_222:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x164af0;  op2val:0x5
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x164af0, 0x5, x8, 788, x9)

inst_223:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x9222a;  op2val:0x0
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x9222a, 0x0, x8, 792, x9)

inst_224:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x6284e;  op2val:0x12
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x6284e, 0x12, x8, 796, x9)

inst_225:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x35161;  op2val:0xe
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x35161, 0xe, x8, 800, x9)

inst_226:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x11e24;  op2val:0xc
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x11e24, 0xc, x8, 804, x9)

inst_227:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xf614;  op2val:0x1c
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xf614, 0x1c, x8, 808, x9)

inst_228:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x5cc1;  op2val:0x1d
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x5cc1, 0x1d, x8, 812, x9)

inst_229:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x3226;  op2val:0x1
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x3226, 0x1, x8, 816, x9)

inst_230:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x1d0c;  op2val:0xf
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x1d0c, 0xf, x8, 820, x9)

inst_231:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xdd4;  op2val:0x2
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xdd4, 0x2, x8, 824, x9)

inst_232:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x5d1;  op2val:0x4
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x5d1, 0x4, x8, 828, x9)

inst_233:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x2a7;  op2val:0x0
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x2a7, 0x0, x8, 832, x9)

inst_234:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x197;  op2val:0xa
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x197, 0xa, x8, 836, x9)

inst_235:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xb9;  op2val:0x1c
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xb9, 0x1c, x8, 840, x9)

inst_236:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x4c;  op2val:0x19
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x4c, 0x19, x8, 844, x9)

inst_237:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x26;  op2val:0x2
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x26, 0x2, x8, 848, x9)

inst_238:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x12;  op2val:0x9
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x12, 0x9, x8, 852, x9)

inst_239:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xc;  op2val:0x1c
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xc, 0x1c, x8, 856, x9)

inst_240:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x6;  op2val:0xb
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x6, 0xb, x8, 860, x9)

inst_241:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x3;  op2val:0x1e
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x3, 0x1e, x8, 864, x9)

inst_242:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x1;  op2val:0xc
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x1, 0xc, x8, 868, x9)

inst_243:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x0;  op2val:0x1d
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x0, 0x1d, x8, 872, x9)

inst_244:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x59432a19;  op2val:0xf
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x59432a19, 0xf, x8, 876, x9)

inst_245:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xceb506f6;  op2val:0x17
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xceb506f6, 0x17, x8, 880, x9)

inst_246:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xc5ec6148;  op2val:0x18
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xc5ec6148, 0x18, x8, 884, x9)

inst_247:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x99ef1857;  op2val:0x1d
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x99ef1857, 0x1d, x8, 888, x9)

inst_248:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x14b91c79;  op2val:0x1e
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x14b91c79, 0x1e, x8, 892, x9)

inst_249:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x973e89c;  op2val:0x1f
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x973e89c, 0x1f, x8, 896, x9)

inst_250:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x7843bdb9;  op2val:0x1a
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x7843bdb9, 0x1a, x8, 900, x9)

inst_251:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x9798c9d0;  op2val:0xe
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x9798c9d0, 0xe, x8, 904, x9)

inst_252:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xd814d576;  op2val:0xa
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xd814d576, 0xa, x8, 908, x9)

inst_253:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xe0a37559;  op2val:0x14
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xe0a37559, 0x14, x8, 912, x9)

inst_254:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xf79fb998;  op2val:0x1e
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xf79fb998, 0x1e, x8, 916, x9)

inst_255:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xf87a2561;  op2val:0x1c
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xf87a2561, 0x1c, x8, 920, x9)

inst_256:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xfda56d7f;  op2val:0xf
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xfda56d7f, 0xf, x8, 924, x9)

inst_257:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xfe4deab5;  op2val:0x17
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xfe4deab5, 0x17, x8, 928, x9)

inst_258:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xff6875bb;  op2val:0x13
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xff6875bb, 0x13, x8, 932, x9)

inst_259:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xff93d0e4;  op2val:0x8
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xff93d0e4, 0x8, x8, 936, x9)

inst_260:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xffd4aa23;  op2val:0x0
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xffd4aa23, 0x0, x8, 940, x9)

inst_261:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xffe2fc91;  op2val:0x18
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xffe2fc91, 0x18, x8, 944, x9)

inst_262:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xfff1d2a0;  op2val:0x1c
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xfff1d2a0, 0x1c, x8, 948, x9)

inst_263:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xfff904d1;  op2val:0xf
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xfff904d1, 0xf, x8, 952, x9)

inst_264:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xfffcdb0b;  op2val:0x1d
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xfffcdb0b, 0x1d, x8, 956, x9)

inst_265:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xfffec2b4;  op2val:0x17
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xfffec2b4, 0x17, x8, 960, x9)

inst_266:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xffff1e5f;  op2val:0x13
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xffff1e5f, 0x13, x8, 964, x9)

inst_267:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xffffa2ee;  op2val:0xb
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xffffa2ee, 0xb, x8, 968, x9)

inst_268:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xffffd410;  op2val:0x10
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xffffd410, 0x10, x8, 972, x9)

inst_269:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xffffee0a;  op2val:0x1a
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xffffee0a, 0x1a, x8, 976, x9)

inst_270:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xfffff32a;  op2val:0x16
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xfffff32a, 0x16, x8, 980, x9)

inst_271:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xfffffb84;  op2val:0x8
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xfffffb84, 0x8, x8, 984, x9)

inst_272:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xfffffc1d;  op2val:0x1a
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xfffffc1d, 0x1a, x8, 988, x9)

inst_273:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xfffffe31;  op2val:0x17
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xfffffe31, 0x17, x8, 992, x9)

inst_274:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xffffff44;  op2val:0x4
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xffffff44, 0x4, x8, 996, x9)

inst_275:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xffffffba;  op2val:0x1f
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xffffffba, 0x1f, x8, 1000, x9)

inst_276:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xffffffc6;  op2val:0xa
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xffffffc6, 0xa, x8, 1004, x9)

inst_277:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xffffffe8;  op2val:0x11
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xffffffe8, 0x11, x8, 1008, x9)

inst_278:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xfffffff2;  op2val:0x1f
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xfffffff2, 0x1f, x8, 1012, x9)

inst_279:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xfffffff9;  op2val:0x1d
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xfffffff9, 0x1d, x8, 1016, x9)

inst_280:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xfffffffd;  op2val:0x0
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xfffffffd, 0x0, x8, 1020, x9)

inst_281:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xfffffffe;  op2val:0x1e
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xfffffffe, 0x1e, x8, 1024, x9)

inst_282:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x2
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xffffffff, 0x2, x8, 1028, x9)

inst_283:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x7fffffff;  op2val:0xaaaaaaaa
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x7fffffff, 0xaaaaaaaa, x8, 1032, x9)

inst_284:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x7fffffff;  op2val:0x55555555
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x7fffffff, 0x55555555, x8, 1036, x9)

inst_285:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaaa;  op2val:0x7fffffff
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xaaaaaaaa, 0x7fffffff, x8, 1040, x9)

inst_286:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x55555555;  op2val:0x7fffffff
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x55555555, 0x7fffffff, x8, 1044, x9)

inst_287:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x7fffffff;  op2val:0xefffffff
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x7fffffff, 0xefffffff, x8, 1048, x9)

inst_288:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0x7fffffff;  op2val:0xfffffffe
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0x7fffffff, 0xfffffffe, x8, 1052, x9)

inst_289:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xdfffffff;  op2val:0x7fffffff
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xdfffffff, 0x7fffffff, x8, 1056, x9)

inst_290:
// 
// opcode: binv ; op1:x30; op2:x29; dest:x31; op1val:0xf7ffffff;  op2val:0x7fffffff
TEST_RR_OP(binv, x31, x30, x29, 0x00000000, 0xf7ffffff, 0x7fffffff, x8, 1060, x9)
#endif


RVTEST_CODE_END
RVMODEL_HALT

RVTEST_DATA_BEGIN
.align 4
rvtest_data:
.word 0xbabecafe
.word 0xabecafeb
.word 0xbecafeba
.word 0xecafebab
RVTEST_DATA_END

RVMODEL_DATA_BEGIN
rvtest_sig_begin:
sig_begin_canary:
CANARY;


signature_x1_0:
    .fill 0*(XLEN/32),4,0xdeadbeef


signature_x1_1:
    .fill 25*(XLEN/32),4,0xdeadbeef


signature_x8_0:
    .fill 266*(XLEN/32),4,0xdeadbeef

#ifdef rvtest_mtrap_routine

tsig_begin_canary:
CANARY;
mtrap_sigptr:
    .fill 64*(XLEN/32),4,0xdeadbeef
tsig_end_canary:
CANARY;

#endif

#ifdef rvtest_gpr_save

gpr_save:
    .fill 32*(XLEN/32),4,0xdeadbeef

#endif

sig_end_canary:
CANARY;
rvtest_sig_end:
RVMODEL_DATA_END
