
// -----------
// This file was generated by riscv_ctg (https://github.com/riscv-software-src/riscv-ctg)
// version   : 0.7.1
// timestamp : Sun Aug  7 17:43:57 2022 GMT
// usage     : riscv_ctg \
//                  -- cgf //                  --cgf /home/anku/work2/bmanip/32/dataset.yaml \
//                  --cgf /home/anku/work2/bmanip/32/rv32ib.yaml \
 \
//                  -- xlen 32  \
// -----------
//
// -----------
// Copyright (c) 2020. RISC-V International. All rights reserved.
// SPDX-License-Identifier: BSD-3-Clause
// -----------
//
// This assembly file tests the maxu instruction of the RISC-V RV32Zbb extension for the maxu covergroup.
// 
#include "model_test.h"
#include "arch_test.h"
RVTEST_ISA("RV32IZbb")

.section .text.init
.org 0x80
.globl rvtest_entry_point
rvtest_entry_point:
RVMODEL_BOOT
RVTEST_CODE_BEGIN

#ifdef TEST_CASE_1

RVTEST_CASE(0,"//check ISA:=regex(.*32.*);check ISA:=regex(.*I.*Zbb.*);def TEST_CASE_1=True;",maxu)

RVTEST_SIGBASE(x1,signature_x1_1)

inst_0:
// rs1 == rs2 == rd, rs1==x31, rs2==x31, rd==x31, 
// opcode: maxu ; op1:x31; op2:x31; dest:x31; op1val:0xffffffff;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x31, x31, 0x00000000, 0xffffffff, 0xffffffff, x1, 0, x2)

inst_1:
// rs1 != rs2  and rs1 != rd and rs2 != rd, rs1==x29, rs2==x28, rd==x30, 
// opcode: maxu ; op1:x29; op2:x28; dest:x30; op1val:0xffffffff;  op2val:0x7fffffff
TEST_RR_OP(maxu, x30, x29, x28, 0x00000000, 0xffffffff, 0x7fffffff, x1, 4, x2)

inst_2:
// rs1 == rd != rs2, rs1==x28, rs2==x30, rd==x28, 
// opcode: maxu ; op1:x28; op2:x30; dest:x28; op1val:0xffffffff;  op2val:0xbfffffff
TEST_RR_OP(maxu, x28, x28, x30, 0x00000000, 0xffffffff, 0xbfffffff, x1, 8, x2)

inst_3:
// rs1 == rs2 != rd, rs1==x27, rs2==x27, rd==x29, 
// opcode: maxu ; op1:x27; op2:x27; dest:x29; op1val:0xffffffff;  op2val:0xffffffff
TEST_RR_OP(maxu, x29, x27, x27, 0x00000000, 0xffffffff, 0xffffffff, x1, 12, x2)

inst_4:
// rs2 == rd != rs1, rs1==x30, rs2==x26, rd==x26, 
// opcode: maxu ; op1:x30; op2:x26; dest:x26; op1val:0xffffffff;  op2val:0xefffffff
TEST_RR_OP(maxu, x26, x30, x26, 0x00000000, 0xffffffff, 0xefffffff, x1, 16, x2)

inst_5:
// rs1==x26, rs2==x29, rd==x27, 
// opcode: maxu ; op1:x26; op2:x29; dest:x27; op1val:0xffffffff;  op2val:0xf7ffffff
TEST_RR_OP(maxu, x27, x26, x29, 0x00000000, 0xffffffff, 0xf7ffffff, x1, 20, x2)

inst_6:
// rs1==x24, rs2==x23, rd==x25, 
// opcode: maxu ; op1:x24; op2:x23; dest:x25; op1val:0xffffffff;  op2val:0xfbffffff
TEST_RR_OP(maxu, x25, x24, x23, 0x00000000, 0xffffffff, 0xfbffffff, x1, 24, x2)

inst_7:
// rs1==x23, rs2==x25, rd==x24, 
// opcode: maxu ; op1:x23; op2:x25; dest:x24; op1val:0xffffffff;  op2val:0xfdffffff
TEST_RR_OP(maxu, x24, x23, x25, 0x00000000, 0xffffffff, 0xfdffffff, x1, 28, x2)

inst_8:
// rs1==x25, rs2==x24, rd==x23, 
// opcode: maxu ; op1:x25; op2:x24; dest:x23; op1val:0xffffffff;  op2val:0xfeffffff
TEST_RR_OP(maxu, x23, x25, x24, 0x00000000, 0xffffffff, 0xfeffffff, x1, 32, x2)

inst_9:
// rs1==x21, rs2==x20, rd==x22, 
// opcode: maxu ; op1:x21; op2:x20; dest:x22; op1val:0xffffffff;  op2val:0xff7fffff
TEST_RR_OP(maxu, x22, x21, x20, 0x00000000, 0xffffffff, 0xff7fffff, x1, 36, x2)

inst_10:
// rs1==x20, rs2==x22, rd==x21, 
// opcode: maxu ; op1:x20; op2:x22; dest:x21; op1val:0xffffffff;  op2val:0xffbfffff
TEST_RR_OP(maxu, x21, x20, x22, 0x00000000, 0xffffffff, 0xffbfffff, x1, 40, x2)

inst_11:
// rs1==x22, rs2==x21, rd==x20, 
// opcode: maxu ; op1:x22; op2:x21; dest:x20; op1val:0xffffffff;  op2val:0xffdfffff
TEST_RR_OP(maxu, x20, x22, x21, 0x00000000, 0xffffffff, 0xffdfffff, x1, 44, x2)

inst_12:
// rs1==x18, rs2==x17, rd==x19, 
// opcode: maxu ; op1:x18; op2:x17; dest:x19; op1val:0xffffffff;  op2val:0xffefffff
TEST_RR_OP(maxu, x19, x18, x17, 0x00000000, 0xffffffff, 0xffefffff, x1, 48, x2)

inst_13:
// rs1==x17, rs2==x19, rd==x18, 
// opcode: maxu ; op1:x17; op2:x19; dest:x18; op1val:0xffffffff;  op2val:0xfff7ffff
TEST_RR_OP(maxu, x18, x17, x19, 0x00000000, 0xffffffff, 0xfff7ffff, x1, 52, x2)

inst_14:
// rs1==x19, rs2==x18, rd==x17, 
// opcode: maxu ; op1:x19; op2:x18; dest:x17; op1val:0xffffffff;  op2val:0xfffbffff
TEST_RR_OP(maxu, x17, x19, x18, 0x00000000, 0xffffffff, 0xfffbffff, x1, 56, x2)

inst_15:
// rs1==x15, rs2==x14, rd==x16, 
// opcode: maxu ; op1:x15; op2:x14; dest:x16; op1val:0xffffffff;  op2val:0xfffdffff
TEST_RR_OP(maxu, x16, x15, x14, 0x00000000, 0xffffffff, 0xfffdffff, x1, 60, x2)

inst_16:
// rs1==x14, rs2==x16, rd==x15, 
// opcode: maxu ; op1:x14; op2:x16; dest:x15; op1val:0xffffffff;  op2val:0xfffeffff
TEST_RR_OP(maxu, x15, x14, x16, 0x00000000, 0xffffffff, 0xfffeffff, x1, 64, x2)

inst_17:
// rs1==x16, rs2==x15, rd==x14, 
// opcode: maxu ; op1:x16; op2:x15; dest:x14; op1val:0xffffffff;  op2val:0xffff7fff
TEST_RR_OP(maxu, x14, x16, x15, 0x00000000, 0xffffffff, 0xffff7fff, x1, 68, x2)

inst_18:
// rs1==x12, rs2==x11, rd==x13, 
// opcode: maxu ; op1:x12; op2:x11; dest:x13; op1val:0xffffffff;  op2val:0xffffbfff
TEST_RR_OP(maxu, x13, x12, x11, 0x00000000, 0xffffffff, 0xffffbfff, x1, 72, x2)

inst_19:
// rs1==x11, rs2==x13, rd==x12, 
// opcode: maxu ; op1:x11; op2:x13; dest:x12; op1val:0xffffffff;  op2val:0xffffdfff
TEST_RR_OP(maxu, x12, x11, x13, 0x00000000, 0xffffffff, 0xffffdfff, x1, 76, x2)

inst_20:
// rs1==x13, rs2==x12, rd==x11, 
// opcode: maxu ; op1:x13; op2:x12; dest:x11; op1val:0xffffffff;  op2val:0xffffefff
TEST_RR_OP(maxu, x11, x13, x12, 0x00000000, 0xffffffff, 0xffffefff, x1, 80, x2)

inst_21:
// rs1==x9, rs2==x8, rd==x10, 
// opcode: maxu ; op1:x9; op2:x8; dest:x10; op1val:0xffffffff;  op2val:0xfffff7ff
TEST_RR_OP(maxu, x10, x9, x8, 0x00000000, 0xffffffff, 0xfffff7ff, x1, 84, x2)

inst_22:
// rs1==x8, rs2==x10, rd==x9, 
// opcode: maxu ; op1:x8; op2:x10; dest:x9; op1val:0xffffffff;  op2val:0xfffffbff
TEST_RR_OP(maxu, x9, x8, x10, 0x00000000, 0xffffffff, 0xfffffbff, x1, 88, x2)

inst_23:
// rs1==x10, rs2==x9, rd==x8, 
// opcode: maxu ; op1:x10; op2:x9; dest:x8; op1val:0xffffffff;  op2val:0xfffffdff
TEST_RR_OP(maxu, x8, x10, x9, 0x00000000, 0xffffffff, 0xfffffdff, x1, 92, x2)

inst_24:
// rs1==x6, rs2==x5, rd==x7, 
// opcode: maxu ; op1:x6; op2:x5; dest:x7; op1val:0xffffffff;  op2val:0xfffffeff
TEST_RR_OP(maxu, x7, x6, x5, 0x00000000, 0xffffffff, 0xfffffeff, x1, 96, x2)
RVTEST_SIGBASE(x8,signature_x8_0)

inst_25:
// rs1==x5, rs2==x7, rd==x6, 
// opcode: maxu ; op1:x5; op2:x7; dest:x6; op1val:0xffffffff;  op2val:0xffffff7f
TEST_RR_OP(maxu, x6, x5, x7, 0x00000000, 0xffffffff, 0xffffff7f, x8, 0, x9)

inst_26:
// rs1==x7, rs2==x6, rd==x5, 
// opcode: maxu ; op1:x7; op2:x6; dest:x5; op1val:0xffffffff;  op2val:0xffffffbf
TEST_RR_OP(maxu, x5, x7, x6, 0x00000000, 0xffffffff, 0xffffffbf, x8, 4, x9)

inst_27:
// rs1==x3, rs2==x2, rd==x4, 
// opcode: maxu ; op1:x3; op2:x2; dest:x4; op1val:0xffffffff;  op2val:0xffffffdf
TEST_RR_OP(maxu, x4, x3, x2, 0x00000000, 0xffffffff, 0xffffffdf, x8, 8, x9)

inst_28:
// rs1==x2, rs2==x4, rd==x3, 
// opcode: maxu ; op1:x2; op2:x4; dest:x3; op1val:0xffffffff;  op2val:0xffffffef
TEST_RR_OP(maxu, x3, x2, x4, 0x00000000, 0xffffffff, 0xffffffef, x8, 12, x9)

inst_29:
// rs1==x4, rs2==x3, rd==x2, 
// opcode: maxu ; op1:x4; op2:x3; dest:x2; op1val:0xffffffff;  op2val:0xfffffff7
TEST_RR_OP(maxu, x2, x4, x3, 0x00000000, 0xffffffff, 0xfffffff7, x8, 16, x9)

inst_30:
// rs1==x1, 
// opcode: maxu ; op1:x1; op2:x30; dest:x31; op1val:0xffffffff;  op2val:0xfffffffb
TEST_RR_OP(maxu, x31, x1, x30, 0x00000000, 0xffffffff, 0xfffffffb, x8, 20, x9)

inst_31:
// rs1==x0, 
// opcode: maxu ; op1:x0; op2:x30; dest:x31; op1val:0x0;  op2val:0xfffffffd
TEST_RR_OP(maxu, x31, x0, x30, 0x00000000, 0x0, 0xfffffffd, x8, 24, x9)

inst_32:
// rs2==x1, 
// opcode: maxu ; op1:x30; op2:x1; dest:x31; op1val:0xffffffff;  op2val:0xfffffffe
TEST_RR_OP(maxu, x31, x30, x1, 0x00000000, 0xffffffff, 0xfffffffe, x8, 28, x9)

inst_33:
// rs2==x0, 
// opcode: maxu ; op1:x30; op2:x0; dest:x31; op1val:0x7fffffff;  op2val:0x0
TEST_RR_OP(maxu, x31, x30, x0, 0x00000000, 0x7fffffff, 0x0, x8, 32, x9)

inst_34:
// rd==x1, 
// opcode: maxu ; op1:x31; op2:x30; dest:x1; op1val:0xbfffffff;  op2val:0xffffffff
TEST_RR_OP(maxu, x1, x31, x30, 0x00000000, 0xbfffffff, 0xffffffff, x8, 36, x9)

inst_35:
// rd==x0, 
// opcode: maxu ; op1:x31; op2:x30; dest:x0; op1val:0xdfffffff;  op2val:0xffffffff
TEST_RR_OP(maxu, x0, x31, x30, 0x00000000, 0xdfffffff, 0xffffffff, x8, 40, x9)

inst_36:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xefffffff;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xefffffff, 0xffffffff, x8, 44, x9)

inst_37:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xf7ffffff;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xf7ffffff, 0xffffffff, x8, 48, x9)

inst_38:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xfbffffff;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xfbffffff, 0xffffffff, x8, 52, x9)

inst_39:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xfdffffff;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xfdffffff, 0xffffffff, x8, 56, x9)

inst_40:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xfeffffff;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xfeffffff, 0xffffffff, x8, 60, x9)

inst_41:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xff7fffff;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xff7fffff, 0xffffffff, x8, 64, x9)

inst_42:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xffbfffff;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xffbfffff, 0xffffffff, x8, 68, x9)

inst_43:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xffdfffff;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xffdfffff, 0xffffffff, x8, 72, x9)

inst_44:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xffefffff;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xffefffff, 0xffffffff, x8, 76, x9)

inst_45:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xfff7ffff;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xfff7ffff, 0xffffffff, x8, 80, x9)

inst_46:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xfffbffff;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xfffbffff, 0xffffffff, x8, 84, x9)

inst_47:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xfffdffff;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xfffdffff, 0xffffffff, x8, 88, x9)

inst_48:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xfffeffff;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xfffeffff, 0xffffffff, x8, 92, x9)

inst_49:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xffff7fff;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xffff7fff, 0xffffffff, x8, 96, x9)

inst_50:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xffffbfff;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xffffbfff, 0xffffffff, x8, 100, x9)

inst_51:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xffffdfff;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xffffdfff, 0xffffffff, x8, 104, x9)

inst_52:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xffffefff;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xffffefff, 0xffffffff, x8, 108, x9)

inst_53:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xfffff7ff;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xfffff7ff, 0xffffffff, x8, 112, x9)

inst_54:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xfffffbff;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xfffffbff, 0xffffffff, x8, 116, x9)

inst_55:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xfffffdff;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xfffffdff, 0xffffffff, x8, 120, x9)

inst_56:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xfffffeff;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xfffffeff, 0xffffffff, x8, 124, x9)

inst_57:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xffffff7f;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xffffff7f, 0xffffffff, x8, 128, x9)

inst_58:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xffffffbf;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xffffffbf, 0xffffffff, x8, 132, x9)

inst_59:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xffffffdf;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xffffffdf, 0xffffffff, x8, 136, x9)

inst_60:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xffffffef;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xffffffef, 0xffffffff, x8, 140, x9)

inst_61:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xfffffff7;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xfffffff7, 0xffffffff, x8, 144, x9)

inst_62:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xfffffffb;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xfffffffb, 0xffffffff, x8, 148, x9)

inst_63:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xfffffffd;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xfffffffd, 0xffffffff, x8, 152, x9)

inst_64:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xfffffffe;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xfffffffe, 0xffffffff, x8, 156, x9)

inst_65:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x80000000
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xffffffff, 0x80000000, x8, 160, x9)

inst_66:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x40000000
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xffffffff, 0x40000000, x8, 164, x9)

inst_67:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x20000000
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xffffffff, 0x20000000, x8, 168, x9)

inst_68:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x10000000
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xffffffff, 0x10000000, x8, 172, x9)

inst_69:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x8000000
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xffffffff, 0x8000000, x8, 176, x9)

inst_70:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x4000000
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xffffffff, 0x4000000, x8, 180, x9)

inst_71:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x2000000
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xffffffff, 0x2000000, x8, 184, x9)

inst_72:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x1000000
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xffffffff, 0x1000000, x8, 188, x9)

inst_73:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x800000
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xffffffff, 0x800000, x8, 192, x9)

inst_74:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x400000
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xffffffff, 0x400000, x8, 196, x9)

inst_75:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x200000
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xffffffff, 0x200000, x8, 200, x9)

inst_76:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x100000
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xffffffff, 0x100000, x8, 204, x9)

inst_77:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x80000
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xffffffff, 0x80000, x8, 208, x9)

inst_78:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x40000
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xffffffff, 0x40000, x8, 212, x9)

inst_79:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x20000
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xffffffff, 0x20000, x8, 216, x9)

inst_80:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x10000
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xffffffff, 0x10000, x8, 220, x9)

inst_81:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x8000
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xffffffff, 0x8000, x8, 224, x9)

inst_82:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x4000
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xffffffff, 0x4000, x8, 228, x9)

inst_83:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x2000
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xffffffff, 0x2000, x8, 232, x9)

inst_84:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x1000
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xffffffff, 0x1000, x8, 236, x9)

inst_85:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x800
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xffffffff, 0x800, x8, 240, x9)

inst_86:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x400
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xffffffff, 0x400, x8, 244, x9)

inst_87:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x200
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xffffffff, 0x200, x8, 248, x9)

inst_88:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x100
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xffffffff, 0x100, x8, 252, x9)

inst_89:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x80
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xffffffff, 0x80, x8, 256, x9)

inst_90:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x40
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xffffffff, 0x40, x8, 260, x9)

inst_91:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x20
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xffffffff, 0x20, x8, 264, x9)

inst_92:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x10
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xffffffff, 0x10, x8, 268, x9)

inst_93:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x8
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xffffffff, 0x8, x8, 272, x9)

inst_94:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x4
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xffffffff, 0x4, x8, 276, x9)

inst_95:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x2
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xffffffff, 0x2, x8, 280, x9)

inst_96:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x80000000;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x80000000, 0xffffffff, x8, 284, x9)

inst_97:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x40000000;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x40000000, 0xffffffff, x8, 288, x9)

inst_98:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x20000000;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x20000000, 0xffffffff, x8, 292, x9)

inst_99:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x10000000;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x10000000, 0xffffffff, x8, 296, x9)

inst_100:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x8000000;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x8000000, 0xffffffff, x8, 300, x9)

inst_101:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x4000000;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x4000000, 0xffffffff, x8, 304, x9)

inst_102:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x2000000;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x2000000, 0xffffffff, x8, 308, x9)

inst_103:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x1000000;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x1000000, 0xffffffff, x8, 312, x9)

inst_104:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x800000;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x800000, 0xffffffff, x8, 316, x9)

inst_105:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x400000;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x400000, 0xffffffff, x8, 320, x9)

inst_106:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x200000;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x200000, 0xffffffff, x8, 324, x9)

inst_107:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x100000;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x100000, 0xffffffff, x8, 328, x9)

inst_108:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x80000;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x80000, 0xffffffff, x8, 332, x9)

inst_109:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x40000;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x40000, 0xffffffff, x8, 336, x9)

inst_110:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x20000;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x20000, 0xffffffff, x8, 340, x9)

inst_111:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x10000;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x10000, 0xffffffff, x8, 344, x9)

inst_112:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x8000;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x8000, 0xffffffff, x8, 348, x9)

inst_113:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x4000;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x4000, 0xffffffff, x8, 352, x9)

inst_114:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x2000;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x2000, 0xffffffff, x8, 356, x9)

inst_115:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x1000;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x1000, 0xffffffff, x8, 360, x9)

inst_116:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x800;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x800, 0xffffffff, x8, 364, x9)

inst_117:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x400;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x400, 0xffffffff, x8, 368, x9)

inst_118:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x200;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x200, 0xffffffff, x8, 372, x9)

inst_119:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x100;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x100, 0xffffffff, x8, 376, x9)

inst_120:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x80;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x80, 0xffffffff, x8, 380, x9)

inst_121:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x40;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x40, 0xffffffff, x8, 384, x9)

inst_122:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x20;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x20, 0xffffffff, x8, 388, x9)

inst_123:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x10;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x10, 0xffffffff, x8, 392, x9)

inst_124:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x8;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x8, 0xffffffff, x8, 396, x9)

inst_125:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x4;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x4, 0xffffffff, x8, 400, x9)

inst_126:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x2;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x2, 0xffffffff, x8, 404, x9)

inst_127:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x1;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x1, 0xffffffff, x8, 408, x9)

inst_128:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xffffffff, 0xffffffff, x8, 412, x9)

inst_129:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x0
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xffffffff, 0x0, x8, 416, x9)

inst_130:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x9999999a
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xffffffff, 0x9999999a, x8, 420, x9)

inst_131:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x66666667
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xffffffff, 0x66666667, x8, 424, x9)

inst_132:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0xcccccccd
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xffffffff, 0xcccccccd, x8, 428, x9)

inst_133:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x33333334
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xffffffff, 0x33333334, x8, 432, x9)

inst_134:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0xaaaaaaab
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xffffffff, 0xaaaaaaab, x8, 436, x9)

inst_135:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x55555556
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xffffffff, 0x55555556, x8, 440, x9)

inst_136:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x99999998
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xffffffff, 0x99999998, x8, 444, x9)

inst_137:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x66666665
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xffffffff, 0x66666665, x8, 448, x9)

inst_138:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0xcccccccb
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xffffffff, 0xcccccccb, x8, 452, x9)

inst_139:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x33333332
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xffffffff, 0x33333332, x8, 456, x9)

inst_140:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0xaaaaaaa9
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xffffffff, 0xaaaaaaa9, x8, 460, x9)

inst_141:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x55555554
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xffffffff, 0x55555554, x8, 464, x9)

inst_142:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x99999999
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xffffffff, 0x99999999, x8, 468, x9)

inst_143:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x66666666
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xffffffff, 0x66666666, x8, 472, x9)

inst_144:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0xcccccccc
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xffffffff, 0xcccccccc, x8, 476, x9)

inst_145:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x33333333
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xffffffff, 0x33333333, x8, 480, x9)

inst_146:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0xaaaaaaaa
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xffffffff, 0xaaaaaaaa, x8, 484, x9)

inst_147:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x55555555
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xffffffff, 0x55555555, x8, 488, x9)

inst_148:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x1;  op2val:0x1
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x1, 0x1, x8, 492, x9)

inst_149:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x1;  op2val:0x0
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x1, 0x0, x8, 496, x9)

inst_150:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x1;  op2val:0x9999999a
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x1, 0x9999999a, x8, 500, x9)

inst_151:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x1;  op2val:0x66666667
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x1, 0x66666667, x8, 504, x9)

inst_152:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x1;  op2val:0xcccccccd
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x1, 0xcccccccd, x8, 508, x9)

inst_153:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x1;  op2val:0x33333334
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x1, 0x33333334, x8, 512, x9)

inst_154:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x1;  op2val:0xaaaaaaab
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x1, 0xaaaaaaab, x8, 516, x9)

inst_155:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x1;  op2val:0x55555556
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x1, 0x55555556, x8, 520, x9)

inst_156:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x1;  op2val:0x99999998
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x1, 0x99999998, x8, 524, x9)

inst_157:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x1;  op2val:0x66666665
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x1, 0x66666665, x8, 528, x9)

inst_158:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x1;  op2val:0xcccccccb
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x1, 0xcccccccb, x8, 532, x9)

inst_159:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x1;  op2val:0x33333332
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x1, 0x33333332, x8, 536, x9)

inst_160:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x1;  op2val:0xaaaaaaa9
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x1, 0xaaaaaaa9, x8, 540, x9)

inst_161:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x1;  op2val:0x55555554
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x1, 0x55555554, x8, 544, x9)

inst_162:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x1;  op2val:0x99999999
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x1, 0x99999999, x8, 548, x9)

inst_163:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x1;  op2val:0x66666666
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x1, 0x66666666, x8, 552, x9)

inst_164:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x1;  op2val:0xcccccccc
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x1, 0xcccccccc, x8, 556, x9)

inst_165:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x1;  op2val:0x33333333
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x1, 0x33333333, x8, 560, x9)

inst_166:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x1;  op2val:0xaaaaaaaa
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x1, 0xaaaaaaaa, x8, 564, x9)

inst_167:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x1;  op2val:0x55555555
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x1, 0x55555555, x8, 568, x9)

inst_168:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x0;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x0, 0xffffffff, x8, 572, x9)

inst_169:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x0;  op2val:0x1
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x0, 0x1, x8, 576, x9)

inst_170:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x0;  op2val:0x0
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x0, 0x0, x8, 580, x9)

inst_171:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x0;  op2val:0x9999999a
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x0, 0x9999999a, x8, 584, x9)

inst_172:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x0;  op2val:0x66666667
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x0, 0x66666667, x8, 588, x9)

inst_173:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x0;  op2val:0xcccccccd
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x0, 0xcccccccd, x8, 592, x9)

inst_174:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x0;  op2val:0x33333334
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x0, 0x33333334, x8, 596, x9)

inst_175:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x0;  op2val:0xaaaaaaab
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x0, 0xaaaaaaab, x8, 600, x9)

inst_176:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x0;  op2val:0x55555556
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x0, 0x55555556, x8, 604, x9)

inst_177:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x0;  op2val:0x99999998
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x0, 0x99999998, x8, 608, x9)

inst_178:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x0;  op2val:0x66666665
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x0, 0x66666665, x8, 612, x9)

inst_179:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x0;  op2val:0xcccccccb
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x0, 0xcccccccb, x8, 616, x9)

inst_180:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x0;  op2val:0x33333332
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x0, 0x33333332, x8, 620, x9)

inst_181:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x0;  op2val:0xaaaaaaa9
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x0, 0xaaaaaaa9, x8, 624, x9)

inst_182:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x0;  op2val:0x55555554
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x0, 0x55555554, x8, 628, x9)

inst_183:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x0;  op2val:0x99999999
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x0, 0x99999999, x8, 632, x9)

inst_184:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x0;  op2val:0x66666666
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x0, 0x66666666, x8, 636, x9)

inst_185:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x0;  op2val:0xcccccccc
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x0, 0xcccccccc, x8, 640, x9)

inst_186:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x0;  op2val:0x33333333
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x0, 0x33333333, x8, 644, x9)

inst_187:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x0;  op2val:0xaaaaaaaa
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x0, 0xaaaaaaaa, x8, 648, x9)

inst_188:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x0;  op2val:0x55555555
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x0, 0x55555555, x8, 652, x9)

inst_189:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x9999999a;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x9999999a, 0xffffffff, x8, 656, x9)

inst_190:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x9999999a;  op2val:0x1
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x9999999a, 0x1, x8, 660, x9)

inst_191:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x9999999a;  op2val:0x0
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x9999999a, 0x0, x8, 664, x9)

inst_192:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x9999999a;  op2val:0x9999999a
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x9999999a, 0x9999999a, x8, 668, x9)

inst_193:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x9999999a;  op2val:0x66666667
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x9999999a, 0x66666667, x8, 672, x9)

inst_194:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x9999999a;  op2val:0xcccccccd
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x9999999a, 0xcccccccd, x8, 676, x9)

inst_195:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x9999999a;  op2val:0x33333334
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x9999999a, 0x33333334, x8, 680, x9)

inst_196:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x9999999a;  op2val:0xaaaaaaab
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x9999999a, 0xaaaaaaab, x8, 684, x9)

inst_197:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x9999999a;  op2val:0x55555556
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x9999999a, 0x55555556, x8, 688, x9)

inst_198:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x9999999a;  op2val:0x99999998
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x9999999a, 0x99999998, x8, 692, x9)

inst_199:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x9999999a;  op2val:0x66666665
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x9999999a, 0x66666665, x8, 696, x9)

inst_200:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x9999999a;  op2val:0xcccccccb
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x9999999a, 0xcccccccb, x8, 700, x9)

inst_201:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x9999999a;  op2val:0x33333332
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x9999999a, 0x33333332, x8, 704, x9)

inst_202:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x9999999a;  op2val:0xaaaaaaa9
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x9999999a, 0xaaaaaaa9, x8, 708, x9)

inst_203:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x9999999a;  op2val:0x55555554
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x9999999a, 0x55555554, x8, 712, x9)

inst_204:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x9999999a;  op2val:0x99999999
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x9999999a, 0x99999999, x8, 716, x9)

inst_205:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x9999999a;  op2val:0x66666666
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x9999999a, 0x66666666, x8, 720, x9)

inst_206:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x9999999a;  op2val:0xcccccccc
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x9999999a, 0xcccccccc, x8, 724, x9)

inst_207:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x9999999a;  op2val:0x33333333
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x9999999a, 0x33333333, x8, 728, x9)

inst_208:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x9999999a;  op2val:0xaaaaaaaa
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x9999999a, 0xaaaaaaaa, x8, 732, x9)

inst_209:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x9999999a;  op2val:0x55555555
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x9999999a, 0x55555555, x8, 736, x9)

inst_210:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x66666667;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x66666667, 0xffffffff, x8, 740, x9)

inst_211:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x66666667;  op2val:0x1
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x66666667, 0x1, x8, 744, x9)

inst_212:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x66666667;  op2val:0x0
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x66666667, 0x0, x8, 748, x9)

inst_213:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x66666667;  op2val:0x9999999a
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x66666667, 0x9999999a, x8, 752, x9)

inst_214:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x66666667;  op2val:0x66666667
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x66666667, 0x66666667, x8, 756, x9)

inst_215:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x66666667;  op2val:0xcccccccd
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x66666667, 0xcccccccd, x8, 760, x9)

inst_216:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x66666667;  op2val:0x33333334
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x66666667, 0x33333334, x8, 764, x9)

inst_217:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x66666667;  op2val:0xaaaaaaab
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x66666667, 0xaaaaaaab, x8, 768, x9)

inst_218:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x66666667;  op2val:0x55555556
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x66666667, 0x55555556, x8, 772, x9)

inst_219:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x66666667;  op2val:0x99999998
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x66666667, 0x99999998, x8, 776, x9)

inst_220:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x66666667;  op2val:0x66666665
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x66666667, 0x66666665, x8, 780, x9)

inst_221:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x66666667;  op2val:0xcccccccb
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x66666667, 0xcccccccb, x8, 784, x9)

inst_222:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x66666667;  op2val:0x33333332
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x66666667, 0x33333332, x8, 788, x9)

inst_223:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x66666667;  op2val:0xaaaaaaa9
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x66666667, 0xaaaaaaa9, x8, 792, x9)

inst_224:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x66666667;  op2val:0x55555554
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x66666667, 0x55555554, x8, 796, x9)

inst_225:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x66666667;  op2val:0x99999999
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x66666667, 0x99999999, x8, 800, x9)

inst_226:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x66666667;  op2val:0x66666666
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x66666667, 0x66666666, x8, 804, x9)

inst_227:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x66666667;  op2val:0xcccccccc
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x66666667, 0xcccccccc, x8, 808, x9)

inst_228:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x66666667;  op2val:0x33333333
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x66666667, 0x33333333, x8, 812, x9)

inst_229:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x66666667;  op2val:0xaaaaaaaa
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x66666667, 0xaaaaaaaa, x8, 816, x9)

inst_230:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x66666667;  op2val:0x55555555
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x66666667, 0x55555555, x8, 820, x9)

inst_231:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xcccccccd;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xcccccccd, 0xffffffff, x8, 824, x9)

inst_232:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xcccccccd;  op2val:0x1
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xcccccccd, 0x1, x8, 828, x9)

inst_233:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xcccccccd;  op2val:0x0
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xcccccccd, 0x0, x8, 832, x9)

inst_234:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xcccccccd;  op2val:0x9999999a
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xcccccccd, 0x9999999a, x8, 836, x9)

inst_235:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xcccccccd;  op2val:0x66666667
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xcccccccd, 0x66666667, x8, 840, x9)

inst_236:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xcccccccd;  op2val:0xcccccccd
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xcccccccd, 0xcccccccd, x8, 844, x9)

inst_237:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xcccccccd;  op2val:0x33333334
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xcccccccd, 0x33333334, x8, 848, x9)

inst_238:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xcccccccd;  op2val:0xaaaaaaab
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xcccccccd, 0xaaaaaaab, x8, 852, x9)

inst_239:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xcccccccd;  op2val:0x55555556
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xcccccccd, 0x55555556, x8, 856, x9)

inst_240:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xcccccccd;  op2val:0x99999998
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xcccccccd, 0x99999998, x8, 860, x9)

inst_241:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xcccccccd;  op2val:0x66666665
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xcccccccd, 0x66666665, x8, 864, x9)

inst_242:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xcccccccd;  op2val:0xcccccccb
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xcccccccd, 0xcccccccb, x8, 868, x9)

inst_243:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xcccccccd;  op2val:0x33333332
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xcccccccd, 0x33333332, x8, 872, x9)

inst_244:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xcccccccd;  op2val:0xaaaaaaa9
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xcccccccd, 0xaaaaaaa9, x8, 876, x9)

inst_245:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xcccccccd;  op2val:0x55555554
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xcccccccd, 0x55555554, x8, 880, x9)

inst_246:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xcccccccd;  op2val:0x99999999
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xcccccccd, 0x99999999, x8, 884, x9)

inst_247:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xcccccccd;  op2val:0x66666666
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xcccccccd, 0x66666666, x8, 888, x9)

inst_248:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xcccccccd;  op2val:0xcccccccc
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xcccccccd, 0xcccccccc, x8, 892, x9)

inst_249:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xcccccccd;  op2val:0x33333333
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xcccccccd, 0x33333333, x8, 896, x9)

inst_250:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xcccccccd;  op2val:0xaaaaaaaa
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xcccccccd, 0xaaaaaaaa, x8, 900, x9)

inst_251:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xcccccccd;  op2val:0x55555555
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xcccccccd, 0x55555555, x8, 904, x9)

inst_252:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x33333334;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x33333334, 0xffffffff, x8, 908, x9)

inst_253:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x33333334;  op2val:0x1
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x33333334, 0x1, x8, 912, x9)

inst_254:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x33333334;  op2val:0x0
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x33333334, 0x0, x8, 916, x9)

inst_255:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x33333334;  op2val:0x9999999a
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x33333334, 0x9999999a, x8, 920, x9)

inst_256:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x33333334;  op2val:0x66666667
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x33333334, 0x66666667, x8, 924, x9)

inst_257:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x33333334;  op2val:0xcccccccd
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x33333334, 0xcccccccd, x8, 928, x9)

inst_258:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x33333334;  op2val:0x33333334
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x33333334, 0x33333334, x8, 932, x9)

inst_259:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x33333334;  op2val:0xaaaaaaab
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x33333334, 0xaaaaaaab, x8, 936, x9)

inst_260:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x33333334;  op2val:0x55555556
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x33333334, 0x55555556, x8, 940, x9)

inst_261:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x33333334;  op2val:0x99999998
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x33333334, 0x99999998, x8, 944, x9)

inst_262:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x33333334;  op2val:0x66666665
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x33333334, 0x66666665, x8, 948, x9)

inst_263:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x33333334;  op2val:0xcccccccb
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x33333334, 0xcccccccb, x8, 952, x9)

inst_264:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x33333334;  op2val:0x33333332
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x33333334, 0x33333332, x8, 956, x9)

inst_265:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x33333334;  op2val:0xaaaaaaa9
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x33333334, 0xaaaaaaa9, x8, 960, x9)

inst_266:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x33333334;  op2val:0x55555554
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x33333334, 0x55555554, x8, 964, x9)

inst_267:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x33333334;  op2val:0x99999999
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x33333334, 0x99999999, x8, 968, x9)

inst_268:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x33333334;  op2val:0x66666666
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x33333334, 0x66666666, x8, 972, x9)

inst_269:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x33333334;  op2val:0xcccccccc
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x33333334, 0xcccccccc, x8, 976, x9)

inst_270:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x33333334;  op2val:0x33333333
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x33333334, 0x33333333, x8, 980, x9)

inst_271:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x33333334;  op2val:0xaaaaaaaa
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x33333334, 0xaaaaaaaa, x8, 984, x9)

inst_272:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x33333334;  op2val:0x55555555
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x33333334, 0x55555555, x8, 988, x9)

inst_273:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaab;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xaaaaaaab, 0xffffffff, x8, 992, x9)

inst_274:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaab;  op2val:0x1
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xaaaaaaab, 0x1, x8, 996, x9)

inst_275:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaab;  op2val:0x0
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xaaaaaaab, 0x0, x8, 1000, x9)

inst_276:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaab;  op2val:0x9999999a
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xaaaaaaab, 0x9999999a, x8, 1004, x9)

inst_277:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaab;  op2val:0x66666667
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xaaaaaaab, 0x66666667, x8, 1008, x9)

inst_278:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaab;  op2val:0xcccccccd
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xaaaaaaab, 0xcccccccd, x8, 1012, x9)

inst_279:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaab;  op2val:0x33333334
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xaaaaaaab, 0x33333334, x8, 1016, x9)

inst_280:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaab;  op2val:0xaaaaaaab
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xaaaaaaab, 0xaaaaaaab, x8, 1020, x9)

inst_281:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaab;  op2val:0x55555556
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xaaaaaaab, 0x55555556, x8, 1024, x9)

inst_282:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaab;  op2val:0x99999998
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xaaaaaaab, 0x99999998, x8, 1028, x9)

inst_283:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaab;  op2val:0x66666665
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xaaaaaaab, 0x66666665, x8, 1032, x9)

inst_284:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaab;  op2val:0xcccccccb
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xaaaaaaab, 0xcccccccb, x8, 1036, x9)

inst_285:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaab;  op2val:0x33333332
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xaaaaaaab, 0x33333332, x8, 1040, x9)

inst_286:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaab;  op2val:0xaaaaaaa9
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xaaaaaaab, 0xaaaaaaa9, x8, 1044, x9)

inst_287:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaab;  op2val:0x55555554
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xaaaaaaab, 0x55555554, x8, 1048, x9)

inst_288:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaab;  op2val:0x99999999
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xaaaaaaab, 0x99999999, x8, 1052, x9)

inst_289:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaab;  op2val:0x66666666
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xaaaaaaab, 0x66666666, x8, 1056, x9)

inst_290:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaab;  op2val:0xcccccccc
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xaaaaaaab, 0xcccccccc, x8, 1060, x9)

inst_291:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaab;  op2val:0x33333333
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xaaaaaaab, 0x33333333, x8, 1064, x9)

inst_292:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaab;  op2val:0xaaaaaaaa
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xaaaaaaab, 0xaaaaaaaa, x8, 1068, x9)

inst_293:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaab;  op2val:0x55555555
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xaaaaaaab, 0x55555555, x8, 1072, x9)

inst_294:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x55555556;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x55555556, 0xffffffff, x8, 1076, x9)

inst_295:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x55555556;  op2val:0x1
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x55555556, 0x1, x8, 1080, x9)

inst_296:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x55555556;  op2val:0x0
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x55555556, 0x0, x8, 1084, x9)

inst_297:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x55555556;  op2val:0x9999999a
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x55555556, 0x9999999a, x8, 1088, x9)

inst_298:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x55555556;  op2val:0x66666667
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x55555556, 0x66666667, x8, 1092, x9)

inst_299:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x55555556;  op2val:0xcccccccd
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x55555556, 0xcccccccd, x8, 1096, x9)

inst_300:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x55555556;  op2val:0x33333334
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x55555556, 0x33333334, x8, 1100, x9)

inst_301:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x55555556;  op2val:0xaaaaaaab
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x55555556, 0xaaaaaaab, x8, 1104, x9)

inst_302:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x55555556;  op2val:0x55555556
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x55555556, 0x55555556, x8, 1108, x9)

inst_303:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x55555556;  op2val:0x99999998
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x55555556, 0x99999998, x8, 1112, x9)

inst_304:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x55555556;  op2val:0x66666665
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x55555556, 0x66666665, x8, 1116, x9)

inst_305:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x55555556;  op2val:0xcccccccb
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x55555556, 0xcccccccb, x8, 1120, x9)

inst_306:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x55555556;  op2val:0x33333332
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x55555556, 0x33333332, x8, 1124, x9)

inst_307:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x55555556;  op2val:0xaaaaaaa9
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x55555556, 0xaaaaaaa9, x8, 1128, x9)

inst_308:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x55555556;  op2val:0x55555554
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x55555556, 0x55555554, x8, 1132, x9)

inst_309:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x55555556;  op2val:0x99999999
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x55555556, 0x99999999, x8, 1136, x9)

inst_310:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x55555556;  op2val:0x66666666
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x55555556, 0x66666666, x8, 1140, x9)

inst_311:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x55555556;  op2val:0xcccccccc
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x55555556, 0xcccccccc, x8, 1144, x9)

inst_312:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x55555556;  op2val:0x33333333
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x55555556, 0x33333333, x8, 1148, x9)

inst_313:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x55555556;  op2val:0xaaaaaaaa
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x55555556, 0xaaaaaaaa, x8, 1152, x9)

inst_314:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x33333333;  op2val:0xcccccccd
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x33333333, 0xcccccccd, x8, 1156, x9)

inst_315:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x33333333;  op2val:0x33333334
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x33333333, 0x33333334, x8, 1160, x9)

inst_316:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x33333333;  op2val:0xaaaaaaab
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x33333333, 0xaaaaaaab, x8, 1164, x9)

inst_317:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x33333333;  op2val:0x55555556
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x33333333, 0x55555556, x8, 1168, x9)

inst_318:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x33333333;  op2val:0x99999998
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x33333333, 0x99999998, x8, 1172, x9)

inst_319:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x33333333;  op2val:0x66666665
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x33333333, 0x66666665, x8, 1176, x9)

inst_320:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x33333333;  op2val:0xcccccccb
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x33333333, 0xcccccccb, x8, 1180, x9)

inst_321:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x33333333;  op2val:0x33333332
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x33333333, 0x33333332, x8, 1184, x9)

inst_322:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x33333333;  op2val:0xaaaaaaa9
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x33333333, 0xaaaaaaa9, x8, 1188, x9)

inst_323:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x33333333;  op2val:0x55555554
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x33333333, 0x55555554, x8, 1192, x9)

inst_324:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x33333333;  op2val:0x99999999
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x33333333, 0x99999999, x8, 1196, x9)

inst_325:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x33333333;  op2val:0x66666666
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x33333333, 0x66666666, x8, 1200, x9)

inst_326:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x33333333;  op2val:0xcccccccc
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x33333333, 0xcccccccc, x8, 1204, x9)

inst_327:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x33333333;  op2val:0x33333333
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x33333333, 0x33333333, x8, 1208, x9)

inst_328:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x33333333;  op2val:0xaaaaaaaa
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x33333333, 0xaaaaaaaa, x8, 1212, x9)

inst_329:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x33333333;  op2val:0x55555555
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x33333333, 0x55555555, x8, 1216, x9)

inst_330:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaaa;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xaaaaaaaa, 0xffffffff, x8, 1220, x9)

inst_331:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaaa;  op2val:0x1
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xaaaaaaaa, 0x1, x8, 1224, x9)

inst_332:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaaa;  op2val:0x0
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xaaaaaaaa, 0x0, x8, 1228, x9)

inst_333:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaaa;  op2val:0x9999999a
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xaaaaaaaa, 0x9999999a, x8, 1232, x9)

inst_334:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaaa;  op2val:0x66666667
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xaaaaaaaa, 0x66666667, x8, 1236, x9)

inst_335:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaaa;  op2val:0xcccccccd
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xaaaaaaaa, 0xcccccccd, x8, 1240, x9)

inst_336:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaaa;  op2val:0x33333334
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xaaaaaaaa, 0x33333334, x8, 1244, x9)

inst_337:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaaa;  op2val:0xaaaaaaab
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xaaaaaaaa, 0xaaaaaaab, x8, 1248, x9)

inst_338:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaaa;  op2val:0x55555556
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xaaaaaaaa, 0x55555556, x8, 1252, x9)

inst_339:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaaa;  op2val:0x99999998
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xaaaaaaaa, 0x99999998, x8, 1256, x9)

inst_340:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaaa;  op2val:0x66666665
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xaaaaaaaa, 0x66666665, x8, 1260, x9)

inst_341:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaaa;  op2val:0xcccccccb
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xaaaaaaaa, 0xcccccccb, x8, 1264, x9)

inst_342:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaaa;  op2val:0x33333332
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xaaaaaaaa, 0x33333332, x8, 1268, x9)

inst_343:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaaa;  op2val:0xaaaaaaa9
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xaaaaaaaa, 0xaaaaaaa9, x8, 1272, x9)

inst_344:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaaa;  op2val:0x55555554
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xaaaaaaaa, 0x55555554, x8, 1276, x9)

inst_345:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaaa;  op2val:0x99999999
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xaaaaaaaa, 0x99999999, x8, 1280, x9)

inst_346:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaaa;  op2val:0x66666666
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xaaaaaaaa, 0x66666666, x8, 1284, x9)

inst_347:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaaa;  op2val:0xcccccccc
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xaaaaaaaa, 0xcccccccc, x8, 1288, x9)

inst_348:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaaa;  op2val:0x33333333
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xaaaaaaaa, 0x33333333, x8, 1292, x9)

inst_349:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaaa;  op2val:0xaaaaaaaa
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xaaaaaaaa, 0xaaaaaaaa, x8, 1296, x9)

inst_350:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaaa;  op2val:0x55555555
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xaaaaaaaa, 0x55555555, x8, 1300, x9)

inst_351:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x55555555;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x55555555, 0xffffffff, x8, 1304, x9)

inst_352:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x55555555;  op2val:0x1
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x55555555, 0x1, x8, 1308, x9)

inst_353:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x55555555;  op2val:0x0
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x55555555, 0x0, x8, 1312, x9)

inst_354:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x55555555;  op2val:0x9999999a
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x55555555, 0x9999999a, x8, 1316, x9)

inst_355:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x55555555;  op2val:0x66666667
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x55555555, 0x66666667, x8, 1320, x9)

inst_356:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x55555555;  op2val:0xcccccccd
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x55555555, 0xcccccccd, x8, 1324, x9)

inst_357:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x55555555;  op2val:0x33333334
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x55555555, 0x33333334, x8, 1328, x9)

inst_358:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x55555555;  op2val:0xaaaaaaab
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x55555555, 0xaaaaaaab, x8, 1332, x9)

inst_359:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x55555555;  op2val:0x55555556
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x55555555, 0x55555556, x8, 1336, x9)

inst_360:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x55555555;  op2val:0x99999998
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x55555555, 0x99999998, x8, 1340, x9)

inst_361:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x55555555;  op2val:0x66666665
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x55555555, 0x66666665, x8, 1344, x9)

inst_362:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x55555555;  op2val:0xcccccccb
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x55555555, 0xcccccccb, x8, 1348, x9)

inst_363:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x55555555;  op2val:0x33333332
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x55555555, 0x33333332, x8, 1352, x9)

inst_364:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x55555555;  op2val:0xaaaaaaa9
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x55555555, 0xaaaaaaa9, x8, 1356, x9)

inst_365:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x55555555;  op2val:0x55555554
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x55555555, 0x55555554, x8, 1360, x9)

inst_366:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x55555555;  op2val:0x99999999
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x55555555, 0x99999999, x8, 1364, x9)

inst_367:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x55555555;  op2val:0x66666666
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x55555555, 0x66666666, x8, 1368, x9)

inst_368:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x55555555;  op2val:0xcccccccc
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x55555555, 0xcccccccc, x8, 1372, x9)

inst_369:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x55555555;  op2val:0x33333333
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x55555555, 0x33333333, x8, 1376, x9)

inst_370:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x55555555;  op2val:0xaaaaaaaa
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x55555555, 0xaaaaaaaa, x8, 1380, x9)

inst_371:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x55555555;  op2val:0x55555555
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x55555555, 0x55555555, x8, 1384, x9)

inst_372:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x55555556;  op2val:0x55555555
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x55555556, 0x55555555, x8, 1388, x9)

inst_373:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x99999998;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x99999998, 0xffffffff, x8, 1392, x9)

inst_374:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x99999998;  op2val:0x1
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x99999998, 0x1, x8, 1396, x9)

inst_375:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x99999998;  op2val:0x0
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x99999998, 0x0, x8, 1400, x9)

inst_376:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x99999998;  op2val:0x9999999a
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x99999998, 0x9999999a, x8, 1404, x9)

inst_377:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x99999998;  op2val:0x66666667
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x99999998, 0x66666667, x8, 1408, x9)

inst_378:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x99999998;  op2val:0xcccccccd
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x99999998, 0xcccccccd, x8, 1412, x9)

inst_379:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x99999998;  op2val:0x33333334
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x99999998, 0x33333334, x8, 1416, x9)

inst_380:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x99999998;  op2val:0xaaaaaaab
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x99999998, 0xaaaaaaab, x8, 1420, x9)

inst_381:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x99999998;  op2val:0x55555556
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x99999998, 0x55555556, x8, 1424, x9)

inst_382:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x99999998;  op2val:0x99999998
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x99999998, 0x99999998, x8, 1428, x9)

inst_383:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x99999998;  op2val:0x66666665
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x99999998, 0x66666665, x8, 1432, x9)

inst_384:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x99999998;  op2val:0xcccccccb
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x99999998, 0xcccccccb, x8, 1436, x9)

inst_385:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x99999998;  op2val:0x33333332
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x99999998, 0x33333332, x8, 1440, x9)

inst_386:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x99999998;  op2val:0xaaaaaaa9
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x99999998, 0xaaaaaaa9, x8, 1444, x9)

inst_387:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x99999998;  op2val:0x55555554
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x99999998, 0x55555554, x8, 1448, x9)

inst_388:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x99999998;  op2val:0x99999999
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x99999998, 0x99999999, x8, 1452, x9)

inst_389:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x99999998;  op2val:0x66666666
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x99999998, 0x66666666, x8, 1456, x9)

inst_390:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x99999998;  op2val:0xcccccccc
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x99999998, 0xcccccccc, x8, 1460, x9)

inst_391:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x99999998;  op2val:0x33333333
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x99999998, 0x33333333, x8, 1464, x9)

inst_392:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x99999998;  op2val:0xaaaaaaaa
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x99999998, 0xaaaaaaaa, x8, 1468, x9)

inst_393:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x99999998;  op2val:0x55555555
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x99999998, 0x55555555, x8, 1472, x9)

inst_394:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x66666665;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x66666665, 0xffffffff, x8, 1476, x9)

inst_395:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x66666665;  op2val:0x1
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x66666665, 0x1, x8, 1480, x9)

inst_396:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x66666665;  op2val:0x0
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x66666665, 0x0, x8, 1484, x9)

inst_397:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x66666665;  op2val:0x9999999a
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x66666665, 0x9999999a, x8, 1488, x9)

inst_398:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x66666665;  op2val:0x66666667
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x66666665, 0x66666667, x8, 1492, x9)

inst_399:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x66666665;  op2val:0xcccccccd
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x66666665, 0xcccccccd, x8, 1496, x9)

inst_400:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x66666665;  op2val:0x33333334
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x66666665, 0x33333334, x8, 1500, x9)

inst_401:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x66666665;  op2val:0xaaaaaaab
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x66666665, 0xaaaaaaab, x8, 1504, x9)

inst_402:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x66666665;  op2val:0x55555556
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x66666665, 0x55555556, x8, 1508, x9)

inst_403:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x66666665;  op2val:0x99999998
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x66666665, 0x99999998, x8, 1512, x9)

inst_404:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x66666665;  op2val:0x66666665
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x66666665, 0x66666665, x8, 1516, x9)

inst_405:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x66666665;  op2val:0xcccccccb
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x66666665, 0xcccccccb, x8, 1520, x9)

inst_406:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x66666665;  op2val:0x33333332
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x66666665, 0x33333332, x8, 1524, x9)

inst_407:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x66666665;  op2val:0xaaaaaaa9
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x66666665, 0xaaaaaaa9, x8, 1528, x9)

inst_408:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x66666665;  op2val:0x55555554
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x66666665, 0x55555554, x8, 1532, x9)

inst_409:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x66666665;  op2val:0x99999999
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x66666665, 0x99999999, x8, 1536, x9)

inst_410:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x66666665;  op2val:0x66666666
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x66666665, 0x66666666, x8, 1540, x9)

inst_411:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x66666665;  op2val:0xcccccccc
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x66666665, 0xcccccccc, x8, 1544, x9)

inst_412:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x66666665;  op2val:0x33333333
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x66666665, 0x33333333, x8, 1548, x9)

inst_413:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x66666665;  op2val:0xaaaaaaaa
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x66666665, 0xaaaaaaaa, x8, 1552, x9)

inst_414:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x66666665;  op2val:0x55555555
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x66666665, 0x55555555, x8, 1556, x9)

inst_415:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xcccccccb;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xcccccccb, 0xffffffff, x8, 1560, x9)

inst_416:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xcccccccb;  op2val:0x1
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xcccccccb, 0x1, x8, 1564, x9)

inst_417:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xcccccccb;  op2val:0x0
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xcccccccb, 0x0, x8, 1568, x9)

inst_418:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xcccccccb;  op2val:0x9999999a
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xcccccccb, 0x9999999a, x8, 1572, x9)

inst_419:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xcccccccb;  op2val:0x66666667
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xcccccccb, 0x66666667, x8, 1576, x9)

inst_420:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xcccccccb;  op2val:0xcccccccd
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xcccccccb, 0xcccccccd, x8, 1580, x9)

inst_421:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xcccccccb;  op2val:0x33333334
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xcccccccb, 0x33333334, x8, 1584, x9)

inst_422:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xcccccccb;  op2val:0xaaaaaaab
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xcccccccb, 0xaaaaaaab, x8, 1588, x9)

inst_423:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xcccccccb;  op2val:0x55555556
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xcccccccb, 0x55555556, x8, 1592, x9)

inst_424:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xcccccccb;  op2val:0x99999998
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xcccccccb, 0x99999998, x8, 1596, x9)

inst_425:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xcccccccb;  op2val:0x66666665
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xcccccccb, 0x66666665, x8, 1600, x9)

inst_426:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xcccccccb;  op2val:0xcccccccb
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xcccccccb, 0xcccccccb, x8, 1604, x9)

inst_427:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xcccccccb;  op2val:0x33333332
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xcccccccb, 0x33333332, x8, 1608, x9)

inst_428:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xcccccccb;  op2val:0xaaaaaaa9
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xcccccccb, 0xaaaaaaa9, x8, 1612, x9)

inst_429:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xcccccccb;  op2val:0x55555554
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xcccccccb, 0x55555554, x8, 1616, x9)

inst_430:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xcccccccb;  op2val:0x99999999
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xcccccccb, 0x99999999, x8, 1620, x9)

inst_431:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xcccccccb;  op2val:0x66666666
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xcccccccb, 0x66666666, x8, 1624, x9)

inst_432:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xcccccccb;  op2val:0xcccccccc
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xcccccccb, 0xcccccccc, x8, 1628, x9)

inst_433:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xcccccccb;  op2val:0x33333333
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xcccccccb, 0x33333333, x8, 1632, x9)

inst_434:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xcccccccb;  op2val:0xaaaaaaaa
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xcccccccb, 0xaaaaaaaa, x8, 1636, x9)

inst_435:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xcccccccb;  op2val:0x55555555
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xcccccccb, 0x55555555, x8, 1640, x9)

inst_436:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x33333332;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x33333332, 0xffffffff, x8, 1644, x9)

inst_437:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x33333332;  op2val:0x1
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x33333332, 0x1, x8, 1648, x9)

inst_438:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x33333332;  op2val:0x0
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x33333332, 0x0, x8, 1652, x9)

inst_439:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x33333332;  op2val:0x9999999a
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x33333332, 0x9999999a, x8, 1656, x9)

inst_440:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x33333332;  op2val:0x66666667
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x33333332, 0x66666667, x8, 1660, x9)

inst_441:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x33333332;  op2val:0xcccccccd
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x33333332, 0xcccccccd, x8, 1664, x9)

inst_442:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x33333332;  op2val:0x33333334
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x33333332, 0x33333334, x8, 1668, x9)

inst_443:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x33333332;  op2val:0xaaaaaaab
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x33333332, 0xaaaaaaab, x8, 1672, x9)

inst_444:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x33333332;  op2val:0x55555556
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x33333332, 0x55555556, x8, 1676, x9)

inst_445:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x33333332;  op2val:0x99999998
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x33333332, 0x99999998, x8, 1680, x9)

inst_446:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x33333332;  op2val:0x66666665
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x33333332, 0x66666665, x8, 1684, x9)

inst_447:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x33333332;  op2val:0xcccccccb
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x33333332, 0xcccccccb, x8, 1688, x9)

inst_448:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x33333332;  op2val:0x33333332
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x33333332, 0x33333332, x8, 1692, x9)

inst_449:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x33333332;  op2val:0xaaaaaaa9
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x33333332, 0xaaaaaaa9, x8, 1696, x9)

inst_450:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x33333332;  op2val:0x55555554
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x33333332, 0x55555554, x8, 1700, x9)

inst_451:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x33333332;  op2val:0x99999999
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x33333332, 0x99999999, x8, 1704, x9)

inst_452:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x33333332;  op2val:0x66666666
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x33333332, 0x66666666, x8, 1708, x9)

inst_453:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x33333332;  op2val:0xcccccccc
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x33333332, 0xcccccccc, x8, 1712, x9)

inst_454:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x33333332;  op2val:0x33333333
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x33333332, 0x33333333, x8, 1716, x9)

inst_455:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x33333332;  op2val:0xaaaaaaaa
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x33333332, 0xaaaaaaaa, x8, 1720, x9)

inst_456:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x33333332;  op2val:0x55555555
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x33333332, 0x55555555, x8, 1724, x9)

inst_457:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaa9;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xaaaaaaa9, 0xffffffff, x8, 1728, x9)

inst_458:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaa9;  op2val:0x1
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xaaaaaaa9, 0x1, x8, 1732, x9)

inst_459:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaa9;  op2val:0x0
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xaaaaaaa9, 0x0, x8, 1736, x9)

inst_460:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaa9;  op2val:0x9999999a
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xaaaaaaa9, 0x9999999a, x8, 1740, x9)

inst_461:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaa9;  op2val:0x66666667
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xaaaaaaa9, 0x66666667, x8, 1744, x9)

inst_462:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaa9;  op2val:0xcccccccd
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xaaaaaaa9, 0xcccccccd, x8, 1748, x9)

inst_463:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaa9;  op2val:0x33333334
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xaaaaaaa9, 0x33333334, x8, 1752, x9)

inst_464:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaa9;  op2val:0xaaaaaaab
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xaaaaaaa9, 0xaaaaaaab, x8, 1756, x9)

inst_465:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaa9;  op2val:0x55555556
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xaaaaaaa9, 0x55555556, x8, 1760, x9)

inst_466:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaa9;  op2val:0x99999998
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xaaaaaaa9, 0x99999998, x8, 1764, x9)

inst_467:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaa9;  op2val:0x66666665
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xaaaaaaa9, 0x66666665, x8, 1768, x9)

inst_468:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaa9;  op2val:0xcccccccb
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xaaaaaaa9, 0xcccccccb, x8, 1772, x9)

inst_469:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaa9;  op2val:0x33333332
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xaaaaaaa9, 0x33333332, x8, 1776, x9)

inst_470:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaa9;  op2val:0xaaaaaaa9
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xaaaaaaa9, 0xaaaaaaa9, x8, 1780, x9)

inst_471:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaa9;  op2val:0x55555554
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xaaaaaaa9, 0x55555554, x8, 1784, x9)

inst_472:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaa9;  op2val:0x99999999
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xaaaaaaa9, 0x99999999, x8, 1788, x9)

inst_473:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaa9;  op2val:0x66666666
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xaaaaaaa9, 0x66666666, x8, 1792, x9)

inst_474:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaa9;  op2val:0xcccccccc
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xaaaaaaa9, 0xcccccccc, x8, 1796, x9)

inst_475:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaa9;  op2val:0x33333333
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xaaaaaaa9, 0x33333333, x8, 1800, x9)

inst_476:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaa9;  op2val:0xaaaaaaaa
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xaaaaaaa9, 0xaaaaaaaa, x8, 1804, x9)

inst_477:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaa9;  op2val:0x55555555
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xaaaaaaa9, 0x55555555, x8, 1808, x9)

inst_478:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x55555554;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x55555554, 0xffffffff, x8, 1812, x9)

inst_479:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x55555554;  op2val:0x1
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x55555554, 0x1, x8, 1816, x9)

inst_480:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x55555554;  op2val:0x0
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x55555554, 0x0, x8, 1820, x9)

inst_481:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x55555554;  op2val:0x9999999a
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x55555554, 0x9999999a, x8, 1824, x9)

inst_482:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x55555554;  op2val:0x66666667
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x55555554, 0x66666667, x8, 1828, x9)

inst_483:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x55555554;  op2val:0xcccccccd
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x55555554, 0xcccccccd, x8, 1832, x9)

inst_484:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x55555554;  op2val:0x33333334
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x55555554, 0x33333334, x8, 1836, x9)

inst_485:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x55555554;  op2val:0xaaaaaaab
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x55555554, 0xaaaaaaab, x8, 1840, x9)

inst_486:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x55555554;  op2val:0x55555556
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x55555554, 0x55555556, x8, 1844, x9)

inst_487:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x55555554;  op2val:0x99999998
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x55555554, 0x99999998, x8, 1848, x9)

inst_488:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x55555554;  op2val:0x66666665
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x55555554, 0x66666665, x8, 1852, x9)

inst_489:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x55555554;  op2val:0xcccccccb
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x55555554, 0xcccccccb, x8, 1856, x9)

inst_490:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x55555554;  op2val:0x33333332
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x55555554, 0x33333332, x8, 1860, x9)

inst_491:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x55555554;  op2val:0xaaaaaaa9
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x55555554, 0xaaaaaaa9, x8, 1864, x9)

inst_492:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x55555554;  op2val:0x55555554
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x55555554, 0x55555554, x8, 1868, x9)

inst_493:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x55555554;  op2val:0x99999999
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x55555554, 0x99999999, x8, 1872, x9)

inst_494:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x55555554;  op2val:0x66666666
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x55555554, 0x66666666, x8, 1876, x9)

inst_495:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x55555554;  op2val:0xcccccccc
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x55555554, 0xcccccccc, x8, 1880, x9)

inst_496:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x55555554;  op2val:0x33333333
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x55555554, 0x33333333, x8, 1884, x9)

inst_497:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x55555554;  op2val:0xaaaaaaaa
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x55555554, 0xaaaaaaaa, x8, 1888, x9)

inst_498:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x55555554;  op2val:0x55555555
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x55555554, 0x55555555, x8, 1892, x9)

inst_499:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x99999999;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x99999999, 0xffffffff, x8, 1896, x9)

inst_500:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x99999999;  op2val:0x1
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x99999999, 0x1, x8, 1900, x9)

inst_501:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x99999999;  op2val:0x0
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x99999999, 0x0, x8, 1904, x9)

inst_502:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x99999999;  op2val:0x9999999a
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x99999999, 0x9999999a, x8, 1908, x9)

inst_503:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x99999999;  op2val:0x66666667
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x99999999, 0x66666667, x8, 1912, x9)

inst_504:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x99999999;  op2val:0xcccccccd
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x99999999, 0xcccccccd, x8, 1916, x9)

inst_505:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x99999999;  op2val:0x33333334
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x99999999, 0x33333334, x8, 1920, x9)

inst_506:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x99999999;  op2val:0xaaaaaaab
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x99999999, 0xaaaaaaab, x8, 1924, x9)

inst_507:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x99999999;  op2val:0x55555556
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x99999999, 0x55555556, x8, 1928, x9)

inst_508:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x99999999;  op2val:0x99999998
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x99999999, 0x99999998, x8, 1932, x9)

inst_509:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x99999999;  op2val:0x66666665
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x99999999, 0x66666665, x8, 1936, x9)

inst_510:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x99999999;  op2val:0xcccccccb
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x99999999, 0xcccccccb, x8, 1940, x9)

inst_511:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x99999999;  op2val:0x33333332
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x99999999, 0x33333332, x8, 1944, x9)

inst_512:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x99999999;  op2val:0xaaaaaaa9
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x99999999, 0xaaaaaaa9, x8, 1948, x9)

inst_513:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x99999999;  op2val:0x55555554
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x99999999, 0x55555554, x8, 1952, x9)

inst_514:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x99999999;  op2val:0x99999999
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x99999999, 0x99999999, x8, 1956, x9)

inst_515:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x99999999;  op2val:0x66666666
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x99999999, 0x66666666, x8, 1960, x9)

inst_516:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x99999999;  op2val:0xcccccccc
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x99999999, 0xcccccccc, x8, 1964, x9)

inst_517:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x99999999;  op2val:0x33333333
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x99999999, 0x33333333, x8, 1968, x9)

inst_518:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x99999999;  op2val:0xaaaaaaaa
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x99999999, 0xaaaaaaaa, x8, 1972, x9)

inst_519:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x99999999;  op2val:0x55555555
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x99999999, 0x55555555, x8, 1976, x9)

inst_520:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x66666666;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x66666666, 0xffffffff, x8, 1980, x9)

inst_521:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x66666666;  op2val:0x1
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x66666666, 0x1, x8, 1984, x9)

inst_522:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x66666666;  op2val:0x0
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x66666666, 0x0, x8, 1988, x9)

inst_523:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x66666666;  op2val:0x9999999a
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x66666666, 0x9999999a, x8, 1992, x9)

inst_524:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x66666666;  op2val:0x66666667
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x66666666, 0x66666667, x8, 1996, x9)

inst_525:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x66666666;  op2val:0xcccccccd
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x66666666, 0xcccccccd, x8, 2000, x9)

inst_526:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x66666666;  op2val:0x33333334
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x66666666, 0x33333334, x8, 2004, x9)

inst_527:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x66666666;  op2val:0xaaaaaaab
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x66666666, 0xaaaaaaab, x8, 2008, x9)

inst_528:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x66666666;  op2val:0x55555556
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x66666666, 0x55555556, x8, 2012, x9)

inst_529:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x66666666;  op2val:0x99999998
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x66666666, 0x99999998, x8, 2016, x9)

inst_530:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x66666666;  op2val:0x66666665
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x66666666, 0x66666665, x8, 2020, x9)

inst_531:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x66666666;  op2val:0xcccccccb
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x66666666, 0xcccccccb, x8, 2024, x9)

inst_532:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x66666666;  op2val:0x33333332
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x66666666, 0x33333332, x8, 2028, x9)

inst_533:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x66666666;  op2val:0xaaaaaaa9
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x66666666, 0xaaaaaaa9, x8, 2032, x9)

inst_534:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x66666666;  op2val:0x55555554
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x66666666, 0x55555554, x8, 2036, x9)

inst_535:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x66666666;  op2val:0x99999999
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x66666666, 0x99999999, x8, 2040, x9)

inst_536:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x66666666;  op2val:0x66666666
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x66666666, 0x66666666, x8, 2044, x9)
RVTEST_SIGBASE(x8,signature_x8_1)

inst_537:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x66666666;  op2val:0xcccccccc
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x66666666, 0xcccccccc, x8, 0, x9)
RVTEST_SIGBASE(x8,signature_x8_2)

inst_538:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x66666666;  op2val:0x33333333
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x66666666, 0x33333333, x8, 0, x9)

inst_539:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x66666666;  op2val:0xaaaaaaaa
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x66666666, 0xaaaaaaaa, x8, 4, x9)

inst_540:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x66666666;  op2val:0x55555555
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x66666666, 0x55555555, x8, 8, x9)

inst_541:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xcccccccc;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xcccccccc, 0xffffffff, x8, 12, x9)

inst_542:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xcccccccc;  op2val:0x1
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xcccccccc, 0x1, x8, 16, x9)

inst_543:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xcccccccc;  op2val:0x0
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xcccccccc, 0x0, x8, 20, x9)

inst_544:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xcccccccc;  op2val:0x9999999a
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xcccccccc, 0x9999999a, x8, 24, x9)

inst_545:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xcccccccc;  op2val:0x66666667
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xcccccccc, 0x66666667, x8, 28, x9)

inst_546:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xcccccccc;  op2val:0xcccccccd
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xcccccccc, 0xcccccccd, x8, 32, x9)

inst_547:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xcccccccc;  op2val:0x33333334
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xcccccccc, 0x33333334, x8, 36, x9)

inst_548:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xcccccccc;  op2val:0xaaaaaaab
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xcccccccc, 0xaaaaaaab, x8, 40, x9)

inst_549:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xcccccccc;  op2val:0x55555556
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xcccccccc, 0x55555556, x8, 44, x9)

inst_550:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xcccccccc;  op2val:0x99999998
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xcccccccc, 0x99999998, x8, 48, x9)

inst_551:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xcccccccc;  op2val:0x66666665
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xcccccccc, 0x66666665, x8, 52, x9)

inst_552:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xcccccccc;  op2val:0xcccccccb
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xcccccccc, 0xcccccccb, x8, 56, x9)

inst_553:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xcccccccc;  op2val:0x33333332
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xcccccccc, 0x33333332, x8, 60, x9)

inst_554:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xcccccccc;  op2val:0xaaaaaaa9
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xcccccccc, 0xaaaaaaa9, x8, 64, x9)

inst_555:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xcccccccc;  op2val:0x55555554
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xcccccccc, 0x55555554, x8, 68, x9)

inst_556:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xcccccccc;  op2val:0x99999999
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xcccccccc, 0x99999999, x8, 72, x9)

inst_557:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xcccccccc;  op2val:0x66666666
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xcccccccc, 0x66666666, x8, 76, x9)

inst_558:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xcccccccc;  op2val:0xcccccccc
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xcccccccc, 0xcccccccc, x8, 80, x9)

inst_559:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xcccccccc;  op2val:0x33333333
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xcccccccc, 0x33333333, x8, 84, x9)

inst_560:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xcccccccc;  op2val:0xaaaaaaaa
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xcccccccc, 0xaaaaaaaa, x8, 88, x9)

inst_561:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xcccccccc;  op2val:0x55555555
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xcccccccc, 0x55555555, x8, 92, x9)

inst_562:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x33333333;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x33333333, 0xffffffff, x8, 96, x9)

inst_563:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x33333333;  op2val:0x1
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x33333333, 0x1, x8, 100, x9)

inst_564:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x33333333;  op2val:0x0
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x33333333, 0x0, x8, 104, x9)

inst_565:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x33333333;  op2val:0x9999999a
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x33333333, 0x9999999a, x8, 108, x9)

inst_566:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x33333333;  op2val:0x66666667
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x33333333, 0x66666667, x8, 112, x9)

inst_567:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x1
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xffffffff, 0x1, x8, 116, x9)

inst_568:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0xdfffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xffffffff, 0xdfffffff, x8, 120, x9)

inst_569:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0xfffffffd
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xffffffff, 0xfffffffd, x8, 124, x9)

inst_570:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0x7fffffff;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0x7fffffff, 0xffffffff, x8, 128, x9)

inst_571:
// 
// opcode: maxu ; op1:x30; op2:x29; dest:x31; op1val:0xdfffffff;  op2val:0xffffffff
TEST_RR_OP(maxu, x31, x30, x29, 0x00000000, 0xdfffffff, 0xffffffff, x8, 132, x9)
#endif


RVTEST_CODE_END
RVMODEL_HALT

RVTEST_DATA_BEGIN
.align 4
rvtest_data:
.word 0xbabecafe
.word 0xabecafeb
.word 0xbecafeba
.word 0xecafebab
RVTEST_DATA_END

RVMODEL_DATA_BEGIN
rvtest_sig_begin:
sig_begin_canary:
CANARY;


signature_x1_0:
    .fill 0*(XLEN/32),4,0xdeadbeef


signature_x1_1:
    .fill 25*(XLEN/32),4,0xdeadbeef


signature_x8_0:
    .fill 512*(XLEN/32),4,0xdeadbeef


signature_x8_1:
    .fill 1*(XLEN/32),4,0xdeadbeef


signature_x8_2:
    .fill 34*(XLEN/32),4,0xdeadbeef

#ifdef rvtest_mtrap_routine

tsig_begin_canary:
CANARY;
mtrap_sigptr:
    .fill 64*(XLEN/32),4,0xdeadbeef
tsig_end_canary:
CANARY;

#endif

#ifdef rvtest_gpr_save

gpr_save:
    .fill 32*(XLEN/32),4,0xdeadbeef

#endif

sig_end_canary:
CANARY;
rvtest_sig_end:
RVMODEL_DATA_END
