
// -----------
// This file was generated by riscv_ctg (https://github.com/riscv-software-src/riscv-ctg)
// version   : 0.7.1
// timestamp : Sun Aug  7 17:43:57 2022 GMT
// usage     : riscv_ctg \
//                  -- cgf //                  --cgf /home/anku/work2/bmanip/32/dataset.yaml \
//                  --cgf /home/anku/work2/bmanip/32/rv32ib.yaml \
 \
//                  -- xlen 32  \
// -----------
//
// -----------
// Copyright (c) 2020. RISC-V International. All rights reserved.
// SPDX-License-Identifier: BSD-3-Clause
// -----------
//
// This assembly file tests the rev8 instruction of the RISC-V RV32Zbb,RV32Zbkb,RV32Zk,RV32Zkn,RV32Zks extension for the rev8_32 covergroup.
// 
#include "model_test.h"
#include "arch_test.h"
RVTEST_ISA("RV32IZbb,RV32IZbkb,RV32IZk,RV32IZkn,RV32IZks")

.section .text.init
.org 0x80
.globl rvtest_entry_point
rvtest_entry_point:
RVMODEL_BOOT
RVTEST_CODE_BEGIN

#ifdef TEST_CASE_1

RVTEST_CASE(0,"//check ISA:=regex(.*32.*);check ISA:=regex(.*I.*Zbb.*);def TEST_CASE_1=True;",rev8_32)

RVTEST_CASE(1,"//check ISA:=regex(.*32.*);check ISA:=regex(.*I.*Zbkb.*);def TEST_CASE_1=True;",rev8_32)

RVTEST_CASE(2,"//check ISA:=regex(.*32.*);check ISA:=regex(.*I.*Zk.*);def TEST_CASE_1=True;",rev8_32)

RVTEST_CASE(3,"//check ISA:=regex(.*32.*);check ISA:=regex(.*I.*Zkn.*);def TEST_CASE_1=True;",rev8_32)

RVTEST_CASE(4,"//check ISA:=regex(.*32.*);check ISA:=regex(.*I.*Zks.*);def TEST_CASE_1=True;",rev8_32)

RVTEST_SIGBASE(x1,signature_x1_1)

inst_0:
// rs1 == rd, rs1==x31, rd==x31, 
// opcode: rev8 ; op1:x31; dest:x31; op1val:0x1020408;
LI(x31,0x1020408)
rev8 x31, x31
RVTEST_SIGUPD(x1,x31,0)
RVMODEL_IO_ASSERT_GPR_EQ(x2, x31, 0x00000000)

inst_1:
// rs1 != rd, rs1==x29, rd==x30, 
// opcode: rev8 ; op1:x29; dest:x30; op1val:0x0;
LI(x29,0x0)
rev8 x30, x29
RVTEST_SIGUPD(x1,x30,4)
RVMODEL_IO_ASSERT_GPR_EQ(x2, x30, 0x00000000)

inst_2:
// rs1==x30, rd==x29, 
// opcode: rev8 ; op1:x30; dest:x29; op1val:0x80000000;
LI(x30,0x80000000)
rev8 x29, x30
RVTEST_SIGUPD(x1,x29,8)
RVMODEL_IO_ASSERT_GPR_EQ(x2, x29, 0x00000000)

inst_3:
// rs1==x27, rd==x28, 
// opcode: rev8 ; op1:x27; dest:x28; op1val:0x40000000;
LI(x27,0x40000000)
rev8 x28, x27
RVTEST_SIGUPD(x1,x28,12)
RVMODEL_IO_ASSERT_GPR_EQ(x2, x28, 0x00000000)

inst_4:
// rs1==x28, rd==x27, 
// opcode: rev8 ; op1:x28; dest:x27; op1val:0xa0000000;
LI(x28,0xa0000000)
rev8 x27, x28
RVTEST_SIGUPD(x1,x27,16)
RVMODEL_IO_ASSERT_GPR_EQ(x2, x27, 0x00000000)

inst_5:
// rs1==x25, rd==x26, 
// opcode: rev8 ; op1:x25; dest:x26; op1val:0x90000000;
LI(x25,0x90000000)
rev8 x26, x25
RVTEST_SIGUPD(x1,x26,20)
RVMODEL_IO_ASSERT_GPR_EQ(x2, x26, 0x00000000)

inst_6:
// rs1==x26, rd==x25, 
// opcode: rev8 ; op1:x26; dest:x25; op1val:0xc8000000;
LI(x26,0xc8000000)
rev8 x25, x26
RVTEST_SIGUPD(x1,x25,24)
RVMODEL_IO_ASSERT_GPR_EQ(x2, x25, 0x00000000)

inst_7:
// rs1==x23, rd==x24, 
// opcode: rev8 ; op1:x23; dest:x24; op1val:0x2c000000;
LI(x23,0x2c000000)
rev8 x24, x23
RVTEST_SIGUPD(x1,x24,28)
RVMODEL_IO_ASSERT_GPR_EQ(x2, x24, 0x00000000)

inst_8:
// rs1==x24, rd==x23, 
// opcode: rev8 ; op1:x24; dest:x23; op1val:0xae000000;
LI(x24,0xae000000)
rev8 x23, x24
RVTEST_SIGUPD(x1,x23,32)
RVMODEL_IO_ASSERT_GPR_EQ(x2, x23, 0x00000000)

inst_9:
// rs1==x21, rd==x22, 
// opcode: rev8 ; op1:x21; dest:x22; op1val:0x43000000;
LI(x21,0x43000000)
rev8 x22, x21
RVTEST_SIGUPD(x1,x22,36)
RVMODEL_IO_ASSERT_GPR_EQ(x2, x22, 0x00000000)

inst_10:
// rs1==x22, rd==x21, 
// opcode: rev8 ; op1:x22; dest:x21; op1val:0xf1800000;
LI(x22,0xf1800000)
rev8 x21, x22
RVTEST_SIGUPD(x1,x21,40)
RVMODEL_IO_ASSERT_GPR_EQ(x2, x21, 0x00000000)

inst_11:
// rs1==x19, rd==x20, 
// opcode: rev8 ; op1:x19; dest:x20; op1val:0xaec00000;
LI(x19,0xaec00000)
rev8 x20, x19
RVTEST_SIGUPD(x1,x20,44)
RVMODEL_IO_ASSERT_GPR_EQ(x2, x20, 0x00000000)

inst_12:
// rs1==x20, rd==x19, 
// opcode: rev8 ; op1:x20; dest:x19; op1val:0x99200000;
LI(x20,0x99200000)
rev8 x19, x20
RVTEST_SIGUPD(x1,x19,48)
RVMODEL_IO_ASSERT_GPR_EQ(x2, x19, 0x00000000)

inst_13:
// rs1==x17, rd==x18, 
// opcode: rev8 ; op1:x17; dest:x18; op1val:0xb0700000;
LI(x17,0xb0700000)
rev8 x18, x17
RVTEST_SIGUPD(x1,x18,52)
RVMODEL_IO_ASSERT_GPR_EQ(x2, x18, 0x00000000)

inst_14:
// rs1==x18, rd==x17, 
// opcode: rev8 ; op1:x18; dest:x17; op1val:0x35880000;
LI(x18,0x35880000)
rev8 x17, x18
RVTEST_SIGUPD(x1,x17,56)
RVMODEL_IO_ASSERT_GPR_EQ(x2, x17, 0x00000000)

inst_15:
// rs1==x15, rd==x16, 
// opcode: rev8 ; op1:x15; dest:x16; op1val:0x5acc0000;
LI(x15,0x5acc0000)
rev8 x16, x15
RVTEST_SIGUPD(x1,x16,60)
RVMODEL_IO_ASSERT_GPR_EQ(x2, x16, 0x00000000)

inst_16:
// rs1==x16, rd==x15, 
// opcode: rev8 ; op1:x16; dest:x15; op1val:0x5e3a0000;
LI(x16,0x5e3a0000)
rev8 x15, x16
RVTEST_SIGUPD(x1,x15,64)
RVMODEL_IO_ASSERT_GPR_EQ(x2, x15, 0x00000000)

inst_17:
// rs1==x13, rd==x14, 
// opcode: rev8 ; op1:x13; dest:x14; op1val:0xae1d0000;
LI(x13,0xae1d0000)
rev8 x14, x13
RVTEST_SIGUPD(x1,x14,68)
RVMODEL_IO_ASSERT_GPR_EQ(x2, x14, 0x00000000)

inst_18:
// rs1==x14, rd==x13, 
// opcode: rev8 ; op1:x14; dest:x13; op1val:0x6eb38000;
LI(x14,0x6eb38000)
rev8 x13, x14
RVTEST_SIGUPD(x1,x13,72)
RVMODEL_IO_ASSERT_GPR_EQ(x2, x13, 0x00000000)

inst_19:
// rs1==x11, rd==x12, 
// opcode: rev8 ; op1:x11; dest:x12; op1val:0xbe164000;
LI(x11,0xbe164000)
rev8 x12, x11
RVTEST_SIGUPD(x1,x12,76)
RVMODEL_IO_ASSERT_GPR_EQ(x2, x12, 0x00000000)

inst_20:
// rs1==x12, rd==x11, 
// opcode: rev8 ; op1:x12; dest:x11; op1val:0xcdf1a000;
LI(x12,0xcdf1a000)
rev8 x11, x12
RVTEST_SIGUPD(x1,x11,80)
RVMODEL_IO_ASSERT_GPR_EQ(x2, x11, 0x00000000)

inst_21:
// rs1==x9, rd==x10, 
// opcode: rev8 ; op1:x9; dest:x10; op1val:0x804dd000;
LI(x9,0x804dd000)
rev8 x10, x9
RVTEST_SIGUPD(x1,x10,84)
RVMODEL_IO_ASSERT_GPR_EQ(x2, x10, 0x00000000)

inst_22:
// rs1==x10, rd==x9, 
// opcode: rev8 ; op1:x10; dest:x9; op1val:0x3d4f1800;
LI(x10,0x3d4f1800)
rev8 x9, x10
RVTEST_SIGUPD(x1,x9,88)
RVMODEL_IO_ASSERT_GPR_EQ(x2, x9, 0x00000000)

inst_23:
// rs1==x7, rd==x8, 
// opcode: rev8 ; op1:x7; dest:x8; op1val:0xbfa44c00;
LI(x7,0xbfa44c00)
rev8 x8, x7
RVTEST_SIGUPD(x1,x8,92)
RVMODEL_IO_ASSERT_GPR_EQ(x2, x8, 0x00000000)

inst_24:
// rs1==x8, rd==x7, 
// opcode: rev8 ; op1:x8; dest:x7; op1val:0x4544fa00;
LI(x8,0x4544fa00)
rev8 x7, x8
RVTEST_SIGUPD(x1,x7,96)
RVMODEL_IO_ASSERT_GPR_EQ(x2, x7, 0x00000000)

inst_25:
// rs1==x5, rd==x6, 
// opcode: rev8 ; op1:x5; dest:x6; op1val:0xc7bff300;
LI(x5,0xc7bff300)
rev8 x6, x5
RVTEST_SIGUPD(x1,x6,100)
RVMODEL_IO_ASSERT_GPR_EQ(x2, x6, 0x00000000)

inst_26:
// rs1==x6, rd==x5, 
// opcode: rev8 ; op1:x6; dest:x5; op1val:0xd99d0080;
LI(x6,0xd99d0080)
rev8 x5, x6
RVTEST_SIGUPD(x1,x5,104)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x5, 0x00000000)

inst_27:
// rs1==x3, rd==x4, 
// opcode: rev8 ; op1:x3; dest:x4; op1val:0x205d39c0;
LI(x3,0x205d39c0)
rev8 x4, x3
RVTEST_SIGUPD(x1,x4,108)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x4, 0x00000000)
RVTEST_SIGBASE(x5,signature_x5_0)

inst_28:
// rs1==x4, rd==x3, 
// opcode: rev8 ; op1:x4; dest:x3; op1val:0x31711ba0;
LI(x4,0x31711ba0)
rev8 x3, x4
RVTEST_SIGUPD(x5,x3,0)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x3, 0x00000000)

inst_29:
// rs1==x1, rd==x2, 
// opcode: rev8 ; op1:x1; dest:x2; op1val:0xa99e07b0;
LI(x1,0xa99e07b0)
rev8 x2, x1
RVTEST_SIGUPD(x5,x2,4)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x2, 0x00000000)

inst_30:
// rs1==x2, rd==x1, 
// opcode: rev8 ; op1:x2; dest:x1; op1val:0x3ba8ea68;
LI(x2,0x3ba8ea68)
rev8 x1, x2
RVTEST_SIGUPD(x5,x1,8)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x1, 0x00000000)

inst_31:
// rs1==x0, 
// opcode: rev8 ; op1:x0; dest:x31; op1val:0x0;
LI(x0,0x0)
rev8 x31, x0
RVTEST_SIGUPD(x5,x31,12)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_32:
// rd==x0, 
// opcode: rev8 ; op1:x31; dest:x0; op1val:0x89b9b4d6;
LI(x31,0x89b9b4d6)
rev8 x0, x31
RVTEST_SIGUPD(x5,x0,16)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x0, 0x00000000)

inst_33:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0x797d76df;
LI(x30,0x797d76df)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,20)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_34:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0x3b1d74c;
LI(x30,0x3b1d74c)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,24)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_35:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0xff7d5ec1;
LI(x30,0xff7d5ec1)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,28)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_36:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0x9bc03e23;
LI(x30,0x9bc03e23)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,32)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_37:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0xaf2529c7;
LI(x30,0xaf2529c7)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,36)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_38:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0xd670a82f;
LI(x30,0xd670a82f)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,40)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_39:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0x2054fa9f;
LI(x30,0x2054fa9f)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,44)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_40:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0x6e7c0c3f;
LI(x30,0x6e7c0c3f)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,48)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_41:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0x7ac5f7f;
LI(x30,0x7ac5f7f)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,52)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_42:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0x4b6ea0ff;
LI(x30,0x4b6ea0ff)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,56)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_43:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0xbea425ff;
LI(x30,0xbea425ff)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,60)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_44:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0x36c2a3ff;
LI(x30,0x36c2a3ff)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,64)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_45:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0xd885b7ff;
LI(x30,0xd885b7ff)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,68)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_46:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0x88042fff;
LI(x30,0x88042fff)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,72)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_47:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0x12219fff;
LI(x30,0x12219fff)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,76)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_48:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0x2155bfff;
LI(x30,0x2155bfff)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,80)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_49:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0x2ff77fff;
LI(x30,0x2ff77fff)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,84)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_50:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0xbbe8ffff;
LI(x30,0xbbe8ffff)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,88)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_51:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0xa415ffff;
LI(x30,0xa415ffff)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,92)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_52:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0x39a3ffff;
LI(x30,0x39a3ffff)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,96)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_53:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0xde87ffff;
LI(x30,0xde87ffff)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,100)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_54:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0x25afffff;
LI(x30,0x25afffff)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,104)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_55:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0xaa9fffff;
LI(x30,0xaa9fffff)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,108)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_56:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0x3b3fffff;
LI(x30,0x3b3fffff)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,112)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_57:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0xa67fffff;
LI(x30,0xa67fffff)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,116)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_58:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0x2effffff;
LI(x30,0x2effffff)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,120)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_59:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0xe1ffffff;
LI(x30,0xe1ffffff)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,124)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_60:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0xdbffffff;
LI(x30,0xdbffffff)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,128)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_61:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0xc7ffffff;
LI(x30,0xc7ffffff)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,132)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_62:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0xafffffff;
LI(x30,0xafffffff)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,136)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_63:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0xdfffffff;
LI(x30,0xdfffffff)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,140)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_64:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0xbfffffff;
LI(x30,0xbfffffff)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,144)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_65:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0x7fffffff;
LI(x30,0x7fffffff)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,148)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_66:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0xffffffff;
LI(x30,0xffffffff)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,152)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_67:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0xfb710735;
LI(x30,0xfb710735)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,156)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_68:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0x586e86cc;
LI(x30,0x586e86cc)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,160)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_69:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0x2ab8ab68;
LI(x30,0x2ab8ab68)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,164)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_70:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0x126b7f63;
LI(x30,0x126b7f63)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,168)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_71:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0x9852f28;
LI(x30,0x9852f28)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,172)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_72:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0x7eff9c1;
LI(x30,0x7eff9c1)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,176)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_73:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0x344dd40;
LI(x30,0x344dd40)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,180)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_74:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0x1e7d160;
LI(x30,0x1e7d160)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,184)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_75:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0xb62f26;
LI(x30,0xb62f26)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,188)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_76:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0x4caf9d;
LI(x30,0x4caf9d)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,192)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_77:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0x2bb482;
LI(x30,0x2bb482)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,196)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_78:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0x13edc7;
LI(x30,0x13edc7)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,200)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_79:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0x87994;
LI(x30,0x87994)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,204)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_80:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0x51426;
LI(x30,0x51426)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,208)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_81:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0x28854;
LI(x30,0x28854)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,212)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_82:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0x167ee;
LI(x30,0x167ee)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,216)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_83:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0xfe7a;
LI(x30,0xfe7a)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,220)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_84:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0x5e87;
LI(x30,0x5e87)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,224)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_85:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0x31c3;
LI(x30,0x31c3)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,228)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_86:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0x192a;
LI(x30,0x192a)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,232)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_87:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0xe79;
LI(x30,0xe79)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,236)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_88:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0x77a;
LI(x30,0x77a)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,240)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_89:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0x233;
LI(x30,0x233)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,244)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_90:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0x151;
LI(x30,0x151)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,248)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_91:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0xbe;
LI(x30,0xbe)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,252)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_92:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0x77;
LI(x30,0x77)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,256)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_93:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0x22;
LI(x30,0x22)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,260)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_94:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0x16;
LI(x30,0x16)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,264)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_95:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0xe;
LI(x30,0xe)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,268)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_96:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0x4;
LI(x30,0x4)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,272)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_97:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0x2;
LI(x30,0x2)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,276)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_98:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0x1;
LI(x30,0x1)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,280)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_99:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0x61b0ee0a;
LI(x30,0x61b0ee0a)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,284)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_100:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0x9ae6a229;
LI(x30,0x9ae6a229)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,288)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_101:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0xda6ab32a;
LI(x30,0xda6ab32a)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,292)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_102:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0xe38123e6;
LI(x30,0xe38123e6)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,296)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_103:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0xf4338384;
LI(x30,0xf4338384)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,300)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_104:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0xfb9f15c5;
LI(x30,0xfb9f15c5)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,304)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_105:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0xfd680c1d;
LI(x30,0xfd680c1d)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,308)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_106:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0xfe74e45f;
LI(x30,0xfe74e45f)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,312)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_107:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0xff1e5bf0;
LI(x30,0xff1e5bf0)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,316)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_108:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0xff9c25e7;
LI(x30,0xff9c25e7)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,320)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_109:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0xffcbcf13;
LI(x30,0xffcbcf13)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,324)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_110:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0xffe06f87;
LI(x30,0xffe06f87)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,328)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_111:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0xfff7c831;
LI(x30,0xfff7c831)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,332)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_112:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0xfffa9778;
LI(x30,0xfffa9778)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,336)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_113:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0xfffceb44;
LI(x30,0xfffceb44)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,340)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_114:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0xfffe3fba;
LI(x30,0xfffe3fba)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,344)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_115:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0xffff1658;
LI(x30,0xffff1658)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,348)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_116:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0xffffac3a;
LI(x30,0xffffac3a)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,352)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_117:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0xffffcdf0;
LI(x30,0xffffcdf0)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,356)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_118:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0xffffe684;
LI(x30,0xffffe684)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,360)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_119:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0xfffff1c6;
LI(x30,0xfffff1c6)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,364)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_120:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0xfffff806;
LI(x30,0xfffff806)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,368)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_121:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0xfffffc78;
LI(x30,0xfffffc78)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,372)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_122:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0xfffffe3b;
LI(x30,0xfffffe3b)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,376)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_123:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0xffffff5a;
LI(x30,0xffffff5a)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,380)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_124:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0xffffff88;
LI(x30,0xffffff88)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,384)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_125:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0xffffffc1;
LI(x30,0xffffffc1)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,388)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_126:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0xffffffe8;
LI(x30,0xffffffe8)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,392)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_127:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0xfffffff1;
LI(x30,0xfffffff1)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,396)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_128:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0xfffffff9;
LI(x30,0xfffffff9)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,400)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_129:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0xfffffffd;
LI(x30,0xfffffffd)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,404)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_130:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0xfffffffe;
LI(x30,0xfffffffe)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,408)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_131:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0x9999999a;
LI(x30,0x9999999a)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,412)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_132:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0x66666667;
LI(x30,0x66666667)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,416)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_133:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0xcccccccd;
LI(x30,0xcccccccd)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,420)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_134:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0x33333334;
LI(x30,0x33333334)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,424)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_135:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0xaaaaaaab;
LI(x30,0xaaaaaaab)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,428)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_136:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0x55555556;
LI(x30,0x55555556)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,432)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_137:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0x99999998;
LI(x30,0x99999998)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,436)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_138:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0x66666665;
LI(x30,0x66666665)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,440)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_139:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0xcccccccb;
LI(x30,0xcccccccb)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,444)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_140:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0x33333332;
LI(x30,0x33333332)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,448)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_141:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0xaaaaaaa9;
LI(x30,0xaaaaaaa9)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,452)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_142:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0x55555554;
LI(x30,0x55555554)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,456)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_143:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0x99999999;
LI(x30,0x99999999)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,460)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_144:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0x66666666;
LI(x30,0x66666666)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,464)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_145:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0xcccccccc;
LI(x30,0xcccccccc)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,468)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_146:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0x33333333;
LI(x30,0x33333333)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,472)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_147:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0xaaaaaaaa;
LI(x30,0xaaaaaaaa)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,476)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_148:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0x2040801;
LI(x30,0x2040801)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,480)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_149:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0x4080102;
LI(x30,0x4080102)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,484)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_150:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0x8010204;
LI(x30,0x8010204)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,488)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_151:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0x55555555;
LI(x30,0x55555555)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,492)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_152:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0xa14078b4;
LI(x30,0xa14078b4)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,496)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)

inst_153:
// 
// opcode: rev8 ; op1:x30; dest:x31; op1val:0x89b9b4d6;
LI(x30,0x89b9b4d6)
rev8 x31, x30
RVTEST_SIGUPD(x5,x31,500)
RVMODEL_IO_ASSERT_GPR_EQ(x7, x31, 0x00000000)
#endif


RVTEST_CODE_END
RVMODEL_HALT

RVTEST_DATA_BEGIN
.align 4
rvtest_data:
.word 0xbabecafe
.word 0xabecafeb
.word 0xbecafeba
.word 0xecafebab
RVTEST_DATA_END

RVMODEL_DATA_BEGIN
rvtest_sig_begin:
sig_begin_canary:
CANARY;


signature_x1_0:
    .fill 0*(XLEN/32),4,0xdeadbeef


signature_x1_1:
    .fill 28*(XLEN/32),4,0xdeadbeef


signature_x5_0:
    .fill 126*(XLEN/32),4,0xdeadbeef

#ifdef rvtest_mtrap_routine

tsig_begin_canary:
CANARY;
mtrap_sigptr:
    .fill 64*(XLEN/32),4,0xdeadbeef
tsig_end_canary:
CANARY;

#endif

#ifdef rvtest_gpr_save

gpr_save:
    .fill 32*(XLEN/32),4,0xdeadbeef

#endif

sig_end_canary:
CANARY;
rvtest_sig_end:
RVMODEL_DATA_END
