
// -----------
// This file was generated by riscv_ctg (https://github.com/riscv-software-src/riscv-ctg)
// version   : 0.7.1
// timestamp : Sun Aug  7 17:43:57 2022 GMT
// usage     : riscv_ctg \
//                  -- cgf //                  --cgf /home/anku/work2/bmanip/32/dataset.yaml \
//                  --cgf /home/anku/work2/bmanip/32/rv32ib.yaml \
 \
//                  -- xlen 32  \
// -----------
//
// -----------
// Copyright (c) 2020. RISC-V International. All rights reserved.
// SPDX-License-Identifier: BSD-3-Clause
// -----------
//
// This assembly file tests the ror instruction of the RISC-V RV32Zbb,RV32Zbkb,RV32Zk,RV32Zkn,RV32Zks extension for the ror covergroup.
// 
#include "model_test.h"
#include "arch_test.h"
RVTEST_ISA("RV32IZbb,RV32IZbkb,RV32IZk,RV32IZkn,RV32IZks")

.section .text.init
.org 0x80
.globl rvtest_entry_point
rvtest_entry_point:
RVMODEL_BOOT
RVTEST_CODE_BEGIN

#ifdef TEST_CASE_1

RVTEST_CASE(0,"//check ISA:=regex(.*32.*);check ISA:=regex(.*I.*Zbb.*);def TEST_CASE_1=True;",ror)

RVTEST_CASE(1,"//check ISA:=regex(.*32.*);check ISA:=regex(.*I.*Zbkb.*);def TEST_CASE_1=True;",ror)

RVTEST_CASE(2,"//check ISA:=regex(.*32.*);check ISA:=regex(.*I.*Zk.*);def TEST_CASE_1=True;",ror)

RVTEST_CASE(3,"//check ISA:=regex(.*32.*);check ISA:=regex(.*I.*Zkn.*);def TEST_CASE_1=True;",ror)

RVTEST_CASE(4,"//check ISA:=regex(.*32.*);check ISA:=regex(.*I.*Zks.*);def TEST_CASE_1=True;",ror)

RVTEST_SIGBASE(x1,signature_x1_1)

inst_0:
// rs1 == rs2 == rd, rs1==x31, rs2==x31, rd==x31, 
// opcode: ror ; op1:x31; op2:x31; dest:x31; op1val:0xffffffff;  op2val:0xffffffff
TEST_RR_OP(ror, x31, x31, x31, 0x00000000, 0xffffffff, 0xffffffff, x1, 0, x2)

inst_1:
// rs1 != rs2  and rs1 != rd and rs2 != rd, rs1==x29, rs2==x28, rd==x30, 
// opcode: ror ; op1:x29; op2:x28; dest:x30; op1val:0x4ffe831a;  op2val:0x0
TEST_RR_OP(ror, x30, x29, x28, 0x00000000, 0x4ffe831a, 0x0, x1, 4, x2)

inst_2:
// rs1 == rd != rs2, rs1==x28, rs2==x30, rd==x28, 
// opcode: ror ; op1:x28; op2:x30; dest:x28; op1val:0xafc08ace;  op2val:0x80000000
TEST_RR_OP(ror, x28, x28, x30, 0x00000000, 0xafc08ace, 0x80000000, x1, 8, x2)

inst_3:
// rs1 == rs2 != rd, rs1==x27, rs2==x27, rd==x29, 
// opcode: ror ; op1:x27; op2:x27; dest:x29; op1val:0xaf6e9055;  op2val:0xaf6e9055
TEST_RR_OP(ror, x29, x27, x27, 0x00000000, 0xaf6e9055, 0xaf6e9055, x1, 12, x2)

inst_4:
// rs2 == rd != rs1, rs1==x30, rs2==x26, rd==x26, 
// opcode: ror ; op1:x30; op2:x26; dest:x26; op1val:0x5b130474;  op2val:0xe0000000
TEST_RR_OP(ror, x26, x30, x26, 0x00000000, 0x5b130474, 0xe0000000, x1, 16, x2)

inst_5:
// rs1==x26, rs2==x29, rd==x27, 
// opcode: ror ; op1:x26; op2:x29; dest:x27; op1val:0x3eea126e;  op2val:0x90000000
TEST_RR_OP(ror, x27, x26, x29, 0x00000000, 0x3eea126e, 0x90000000, x1, 20, x2)

inst_6:
// rs1==x24, rs2==x23, rd==x25, 
// opcode: ror ; op1:x24; op2:x23; dest:x25; op1val:0x9c734d77;  op2val:0xb8000000
TEST_RR_OP(ror, x25, x24, x23, 0x00000000, 0x9c734d77, 0xb8000000, x1, 24, x2)

inst_7:
// rs1==x23, rs2==x25, rd==x24, 
// opcode: ror ; op1:x23; op2:x25; dest:x24; op1val:0x5a694bca;  op2val:0xb4000000
TEST_RR_OP(ror, x24, x23, x25, 0x00000000, 0x5a694bca, 0xb4000000, x1, 28, x2)

inst_8:
// rs1==x25, rs2==x24, rd==x23, 
// opcode: ror ; op1:x25; op2:x24; dest:x23; op1val:0xed52e4ca;  op2val:0x3e000000
TEST_RR_OP(ror, x23, x25, x24, 0x00000000, 0xed52e4ca, 0x3e000000, x1, 32, x2)

inst_9:
// rs1==x21, rs2==x20, rd==x22, 
// opcode: ror ; op1:x21; op2:x20; dest:x22; op1val:0xb5cb2a93;  op2val:0xfb000000
TEST_RR_OP(ror, x22, x21, x20, 0x00000000, 0xb5cb2a93, 0xfb000000, x1, 36, x2)

inst_10:
// rs1==x20, rs2==x22, rd==x21, 
// opcode: ror ; op1:x20; op2:x22; dest:x21; op1val:0x29324e16;  op2val:0x68800000
TEST_RR_OP(ror, x21, x20, x22, 0x00000000, 0x29324e16, 0x68800000, x1, 40, x2)

inst_11:
// rs1==x22, rs2==x21, rd==x20, 
// opcode: ror ; op1:x22; op2:x21; dest:x20; op1val:0xbc5fb419;  op2val:0xb7400000
TEST_RR_OP(ror, x20, x22, x21, 0x00000000, 0xbc5fb419, 0xb7400000, x1, 44, x2)

inst_12:
// rs1==x18, rs2==x17, rd==x19, 
// opcode: ror ; op1:x18; op2:x17; dest:x19; op1val:0x8e92e1b8;  op2val:0x5ce00000
TEST_RR_OP(ror, x19, x18, x17, 0x00000000, 0x8e92e1b8, 0x5ce00000, x1, 48, x2)

inst_13:
// rs1==x17, rs2==x19, rd==x18, 
// opcode: ror ; op1:x17; op2:x19; dest:x18; op1val:0x96a3b48b;  op2val:0x49f00000
TEST_RR_OP(ror, x18, x17, x19, 0x00000000, 0x96a3b48b, 0x49f00000, x1, 52, x2)

inst_14:
// rs1==x19, rs2==x18, rd==x17, 
// opcode: ror ; op1:x19; op2:x18; dest:x17; op1val:0xa095049;  op2val:0x53d80000
TEST_RR_OP(ror, x17, x19, x18, 0x00000000, 0xa095049, 0x53d80000, x1, 56, x2)

inst_15:
// rs1==x15, rs2==x14, rd==x16, 
// opcode: ror ; op1:x15; op2:x14; dest:x16; op1val:0x6f6e71b7;  op2val:0x2ec40000
TEST_RR_OP(ror, x16, x15, x14, 0x00000000, 0x6f6e71b7, 0x2ec40000, x1, 60, x2)

inst_16:
// rs1==x14, rs2==x16, rd==x15, 
// opcode: ror ; op1:x14; op2:x16; dest:x15; op1val:0x236cc43d;  op2val:0x8e860000
TEST_RR_OP(ror, x15, x14, x16, 0x00000000, 0x236cc43d, 0x8e860000, x1, 64, x2)

inst_17:
// rs1==x16, rs2==x15, rd==x14, 
// opcode: ror ; op1:x16; op2:x15; dest:x14; op1val:0xe2ed8971;  op2val:0x6fbf0000
TEST_RR_OP(ror, x14, x16, x15, 0x00000000, 0xe2ed8971, 0x6fbf0000, x1, 68, x2)

inst_18:
// rs1==x12, rs2==x11, rd==x13, 
// opcode: ror ; op1:x12; op2:x11; dest:x13; op1val:0x6fa7b3e;  op2val:0x354e8000
TEST_RR_OP(ror, x13, x12, x11, 0x00000000, 0x6fa7b3e, 0x354e8000, x1, 72, x2)

inst_19:
// rs1==x11, rs2==x13, rd==x12, 
// opcode: ror ; op1:x11; op2:x13; dest:x12; op1val:0x4143da51;  op2val:0xfb07c000
TEST_RR_OP(ror, x12, x11, x13, 0x00000000, 0x4143da51, 0xfb07c000, x1, 76, x2)

inst_20:
// rs1==x13, rs2==x12, rd==x11, 
// opcode: ror ; op1:x13; op2:x12; dest:x11; op1val:0xcac78511;  op2val:0xdffa2000
TEST_RR_OP(ror, x11, x13, x12, 0x00000000, 0xcac78511, 0xdffa2000, x1, 80, x2)

inst_21:
// rs1==x9, rs2==x8, rd==x10, 
// opcode: ror ; op1:x9; op2:x8; dest:x10; op1val:0xdf880b11;  op2val:0x45d1f000
TEST_RR_OP(ror, x10, x9, x8, 0x00000000, 0xdf880b11, 0x45d1f000, x1, 84, x2)

inst_22:
// rs1==x8, rs2==x10, rd==x9, 
// opcode: ror ; op1:x8; op2:x10; dest:x9; op1val:0xbd230058;  op2val:0x9069a800
TEST_RR_OP(ror, x9, x8, x10, 0x00000000, 0xbd230058, 0x9069a800, x1, 88, x2)

inst_23:
// rs1==x10, rs2==x9, rd==x8, 
// opcode: ror ; op1:x10; op2:x9; dest:x8; op1val:0xf2597377;  op2val:0xf5b1b400
TEST_RR_OP(ror, x8, x10, x9, 0x00000000, 0xf2597377, 0xf5b1b400, x1, 92, x2)

inst_24:
// rs1==x6, rs2==x5, rd==x7, 
// opcode: ror ; op1:x6; op2:x5; dest:x7; op1val:0x5a8e7f31;  op2val:0x6b6da00
TEST_RR_OP(ror, x7, x6, x5, 0x00000000, 0x5a8e7f31, 0x6b6da00, x1, 96, x2)
RVTEST_SIGBASE(x8,signature_x8_0)

inst_25:
// rs1==x5, rs2==x7, rd==x6, 
// opcode: ror ; op1:x5; op2:x7; dest:x6; op1val:0x7a3621f5;  op2val:0xbfb0f100
TEST_RR_OP(ror, x6, x5, x7, 0x00000000, 0x7a3621f5, 0xbfb0f100, x8, 0, x9)

inst_26:
// rs1==x7, rs2==x6, rd==x5, 
// opcode: ror ; op1:x7; op2:x6; dest:x5; op1val:0x1e3c492c;  op2val:0xd838c880
TEST_RR_OP(ror, x5, x7, x6, 0x00000000, 0x1e3c492c, 0xd838c880, x8, 4, x9)

inst_27:
// rs1==x3, rs2==x2, rd==x4, 
// opcode: ror ; op1:x3; op2:x2; dest:x4; op1val:0xd4faf4b1;  op2val:0x5c46aec0
TEST_RR_OP(ror, x4, x3, x2, 0x00000000, 0xd4faf4b1, 0x5c46aec0, x8, 8, x9)

inst_28:
// rs1==x2, rs2==x4, rd==x3, 
// opcode: ror ; op1:x2; op2:x4; dest:x3; op1val:0x27a16894;  op2val:0xcf7ac620
TEST_RR_OP(ror, x3, x2, x4, 0x00000000, 0x27a16894, 0xcf7ac620, x8, 12, x9)

inst_29:
// rs1==x4, rs2==x3, rd==x2, 
// opcode: ror ; op1:x4; op2:x3; dest:x2; op1val:0xa3ef19e;  op2val:0x5c2f650
TEST_RR_OP(ror, x2, x4, x3, 0x00000000, 0xa3ef19e, 0x5c2f650, x8, 16, x9)

inst_30:
// rs1==x1, 
// opcode: ror ; op1:x1; op2:x30; dest:x31; op1val:0xcb8193ef;  op2val:0xeec50588
TEST_RR_OP(ror, x31, x1, x30, 0x00000000, 0xcb8193ef, 0xeec50588, x8, 20, x9)

inst_31:
// rs1==x0, 
// opcode: ror ; op1:x0; op2:x30; dest:x31; op1val:0x0;  op2val:0xca7160cc
TEST_RR_OP(ror, x31, x0, x30, 0x00000000, 0x0, 0xca7160cc, x8, 24, x9)

inst_32:
// rs2==x1, 
// opcode: ror ; op1:x30; op2:x1; dest:x31; op1val:0x9b5eaf0a;  op2val:0x60e30da2
TEST_RR_OP(ror, x31, x30, x1, 0x00000000, 0x9b5eaf0a, 0x60e30da2, x8, 28, x9)

inst_33:
// rs2==x0, 
// opcode: ror ; op1:x30; op2:x0; dest:x31; op1val:0x5d3bbce0;  op2val:0x0
TEST_RR_OP(ror, x31, x30, x0, 0x00000000, 0x5d3bbce0, 0x0, x8, 32, x9)

inst_34:
// rd==x1, 
// opcode: ror ; op1:x31; op2:x30; dest:x1; op1val:0x0;  op2val:0xfd1032e8
TEST_RR_OP(ror, x1, x31, x30, 0x00000000, 0x0, 0xfd1032e8, x8, 36, x9)

inst_35:
// rd==x0, 
// opcode: ror ; op1:x31; op2:x30; dest:x0; op1val:0x80000000;  op2val:0x7b246c17
TEST_RR_OP(ror, x0, x31, x30, 0x00000000, 0x80000000, 0x7b246c17, x8, 40, x9)

inst_36:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x40000000;  op2val:0x56f3eef1
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x40000000, 0x56f3eef1, x8, 44, x9)

inst_37:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xa0000000;  op2val:0x75923260
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xa0000000, 0x75923260, x8, 48, x9)

inst_38:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x10000000;  op2val:0xb9d3087c
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x10000000, 0xb9d3087c, x8, 52, x9)

inst_39:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xa8000000;  op2val:0x46cbd355
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xa8000000, 0x46cbd355, x8, 56, x9)

inst_40:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xe4000000;  op2val:0x4616e73d
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xe4000000, 0x4616e73d, x8, 60, x9)

inst_41:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x8e000000;  op2val:0x8ccaec71
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x8e000000, 0x8ccaec71, x8, 64, x9)

inst_42:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x13000000;  op2val:0x9b774054
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x13000000, 0x9b774054, x8, 68, x9)

inst_43:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x8b800000;  op2val:0x6d5fcd18
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x8b800000, 0x6d5fcd18, x8, 72, x9)

inst_44:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x7ec00000;  op2val:0x696f561
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x7ec00000, 0x696f561, x8, 76, x9)

inst_45:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x3da00000;  op2val:0x6e1e98e2
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x3da00000, 0x6e1e98e2, x8, 80, x9)

inst_46:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x20100000;  op2val:0x2dedb6a7
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x20100000, 0x2dedb6a7, x8, 84, x9)

inst_47:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x98380000;  op2val:0x3c272728
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x98380000, 0x3c272728, x8, 88, x9)

inst_48:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x80f40000;  op2val:0x4f55c73d
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x80f40000, 0x4f55c73d, x8, 92, x9)

inst_49:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x43560000;  op2val:0xb0ab577a
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x43560000, 0xb0ab577a, x8, 96, x9)

inst_50:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x62a90000;  op2val:0x42f5d75e
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x62a90000, 0x42f5d75e, x8, 100, x9)

inst_51:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x60348000;  op2val:0xb9f09825
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x60348000, 0xb9f09825, x8, 104, x9)

inst_52:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x5ef6c000;  op2val:0x9bfad94f
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x5ef6c000, 0x9bfad94f, x8, 108, x9)

inst_53:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x79df6000;  op2val:0x98918dd8
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x79df6000, 0x98918dd8, x8, 112, x9)

inst_54:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x864c1000;  op2val:0x9b811f47
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x864c1000, 0x9b811f47, x8, 116, x9)

inst_55:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x735cb800;  op2val:0xd0d18fb0
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x735cb800, 0xd0d18fb0, x8, 120, x9)

inst_56:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x29554400;  op2val:0x71992790
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x29554400, 0x71992790, x8, 124, x9)

inst_57:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xa9a56a00;  op2val:0x8248f803
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xa9a56a00, 0x8248f803, x8, 128, x9)

inst_58:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xc3405d00;  op2val:0xeb3d7873
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xc3405d00, 0xeb3d7873, x8, 132, x9)

inst_59:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x394d8080;  op2val:0xd7a7bf5e
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x394d8080, 0xd7a7bf5e, x8, 136, x9)

inst_60:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xc6677840;  op2val:0xd1ba5c0f
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xc6677840, 0xd1ba5c0f, x8, 140, x9)

inst_61:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x70598e60;  op2val:0xd19e3224
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x70598e60, 0xd19e3224, x8, 144, x9)

inst_62:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x98a59f90;  op2val:0x35d30d74
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x98a59f90, 0x35d30d74, x8, 148, x9)

inst_63:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xd306deb8;  op2val:0x70a76e49
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xd306deb8, 0x70a76e49, x8, 152, x9)

inst_64:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x18a01374;  op2val:0x9fcdb9e1
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x18a01374, 0x9fcdb9e1, x8, 156, x9)

inst_65:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xc3667402;  op2val:0x5fefe911
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xc3667402, 0x5fefe911, x8, 160, x9)

inst_66:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x797d76df;  op2val:0x598b88db
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x797d76df, 0x598b88db, x8, 164, x9)

inst_67:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xb7e7669e;  op2val:0xc04f662
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xb7e7669e, 0xc04f662, x8, 168, x9)

inst_68:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xd24f0724;  op2val:0xcd41cad1
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xd24f0724, 0xcd41cad1, x8, 172, x9)

inst_69:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x585022a3;  op2val:0x1203965b
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x585022a3, 0x1203965b, x8, 176, x9)

inst_70:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xee8f948a;  op2val:0x7a9ac0a7
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xee8f948a, 0x7a9ac0a7, x8, 180, x9)

inst_71:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x2655fa99;  op2val:0x2aa8e42f
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x2655fa99, 0x2aa8e42f, x8, 184, x9)

inst_72:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xc96a183;  op2val:0x211d785f
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xc96a183, 0x211d785f, x8, 188, x9)

inst_73:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x88f931f4;  op2val:0x59dde33f
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x88f931f4, 0x59dde33f, x8, 192, x9)

inst_74:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x6f2bf862;  op2val:0x711e627f
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x6f2bf862, 0x711e627f, x8, 196, x9)

inst_75:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x5c6c32a5;  op2val:0x19835aff
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x5c6c32a5, 0x19835aff, x8, 200, x9)

inst_76:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x58fc0342;  op2val:0x88b3dff
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x58fc0342, 0x88b3dff, x8, 204, x9)

inst_77:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x636a75e3;  op2val:0x9a6da3ff
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x636a75e3, 0x9a6da3ff, x8, 208, x9)

inst_78:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x4ed62428;  op2val:0x37e0d7ff
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x4ed62428, 0x37e0d7ff, x8, 212, x9)

inst_79:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xd2d12745;  op2val:0x5e59cfff
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xd2d12745, 0x5e59cfff, x8, 216, x9)

inst_80:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xd770f3c;  op2val:0xdd129fff
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xd770f3c, 0xdd129fff, x8, 220, x9)

inst_81:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x2311acfb;  op2val:0x872ebfff
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x2311acfb, 0x872ebfff, x8, 224, x9)

inst_82:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xfb13bbc;  op2val:0x55367fff
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xfb13bbc, 0x55367fff, x8, 228, x9)

inst_83:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x8dfc2307;  op2val:0xfdd2ffff
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x8dfc2307, 0xfdd2ffff, x8, 232, x9)

inst_84:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x7312be6d;  op2val:0x30bdffff
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x7312be6d, 0x30bdffff, x8, 236, x9)

inst_85:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xc61b1fbf;  op2val:0xa743ffff
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xc61b1fbf, 0xa743ffff, x8, 240, x9)

inst_86:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xebda5a4f;  op2val:0x9987ffff
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xebda5a4f, 0x9987ffff, x8, 244, x9)

inst_87:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xc215e193;  op2val:0x118fffff
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xc215e193, 0x118fffff, x8, 248, x9)

inst_88:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x75ee935f;  op2val:0x65dfffff
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x75ee935f, 0x65dfffff, x8, 252, x9)

inst_89:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x9c16162;  op2val:0x6cbfffff
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x9c16162, 0x6cbfffff, x8, 256, x9)

inst_90:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xa4053175;  op2val:0x347fffff
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xa4053175, 0x347fffff, x8, 260, x9)

inst_91:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x499006c8;  op2val:0xc4ffffff
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x499006c8, 0xc4ffffff, x8, 264, x9)

inst_92:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x3c5b3eee;  op2val:0x41ffffff
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x3c5b3eee, 0x41ffffff, x8, 268, x9)

inst_93:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xd95fd86a;  op2val:0x6bffffff
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xd95fd86a, 0x6bffffff, x8, 272, x9)

inst_94:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x25784f4f;  op2val:0x87ffffff
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x25784f4f, 0x87ffffff, x8, 276, x9)

inst_95:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x82018fa;  op2val:0xcfffffff
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x82018fa, 0xcfffffff, x8, 280, x9)

inst_96:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x350cc530;  op2val:0x9fffffff
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x350cc530, 0x9fffffff, x8, 284, x9)

inst_97:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x7966a24e;  op2val:0x3fffffff
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x7966a24e, 0x3fffffff, x8, 288, x9)

inst_98:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x51d6d6da;  op2val:0x7fffffff
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x51d6d6da, 0x7fffffff, x8, 292, x9)

inst_99:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xd5a2038f;  op2val:0xffffffff
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xd5a2038f, 0xffffffff, x8, 296, x9)

inst_100:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xff7746e6;  op2val:0x4f829b65
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xff7746e6, 0x4f829b65, x8, 300, x9)

inst_101:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xf89a7241;  op2val:0xc2f091
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xf89a7241, 0xc2f091, x8, 304, x9)

inst_102:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x11b36a93;  op2val:0xb1f5d853
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x11b36a93, 0xb1f5d853, x8, 308, x9)

inst_103:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xc9932457;  op2val:0x39be2172
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xc9932457, 0x39be2172, x8, 312, x9)

inst_104:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x4b9a6c8f;  op2val:0x316039ee
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x4b9a6c8f, 0x316039ee, x8, 316, x9)

inst_105:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x9541241f;  op2val:0x5761a866
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x9541241f, 0x5761a866, x8, 320, x9)

inst_106:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x94b431bf;  op2val:0x9e4d1f4
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x94b431bf, 0x9e4d1f4, x8, 324, x9)

inst_107:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xdc8fe97f;  op2val:0x9e03793f
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xdc8fe97f, 0x9e03793f, x8, 328, x9)

inst_108:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xb903ceff;  op2val:0x7f1071ec
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xb903ceff, 0x7f1071ec, x8, 332, x9)

inst_109:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xb494a5ff;  op2val:0x9a7ef9e4
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xb494a5ff, 0x9a7ef9e4, x8, 336, x9)

inst_110:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xe2dd83ff;  op2val:0x59c05bb9
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xe2dd83ff, 0x59c05bb9, x8, 340, x9)

inst_111:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xbbafd7ff;  op2val:0xde451397
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xbbafd7ff, 0xde451397, x8, 344, x9)

inst_112:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xce5c4fff;  op2val:0x40f27005
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xce5c4fff, 0x40f27005, x8, 348, x9)

inst_113:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x39935fff;  op2val:0x24496fe3
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x39935fff, 0x24496fe3, x8, 352, x9)

inst_114:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xeed7bfff;  op2val:0xde14bff2
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xeed7bfff, 0xde14bff2, x8, 356, x9)

inst_115:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x8e7fff;  op2val:0xb808a677
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x8e7fff, 0xb808a677, x8, 360, x9)

inst_116:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x12c2ffff;  op2val:0x76b1fd3d
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x12c2ffff, 0x76b1fd3d, x8, 364, x9)

inst_117:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xe3a5ffff;  op2val:0x5dcf019d
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xe3a5ffff, 0x5dcf019d, x8, 368, x9)

inst_118:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x9b03ffff;  op2val:0x47b7097b
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x9b03ffff, 0x47b7097b, x8, 372, x9)

inst_119:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x5f07ffff;  op2val:0x759f1b43
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x5f07ffff, 0x759f1b43, x8, 376, x9)

inst_120:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x33cfffff;  op2val:0x5b331999
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x33cfffff, 0x5b331999, x8, 380, x9)

inst_121:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x709fffff;  op2val:0x2d37de81
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x709fffff, 0x2d37de81, x8, 384, x9)

inst_122:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xd1bfffff;  op2val:0xfcb627af
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xd1bfffff, 0xfcb627af, x8, 388, x9)

inst_123:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xab7fffff;  op2val:0x1e0b4ee5
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xab7fffff, 0x1e0b4ee5, x8, 392, x9)

inst_124:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x7cffffff;  op2val:0xfb3e7196
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x7cffffff, 0xfb3e7196, x8, 396, x9)

inst_125:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x59ffffff;  op2val:0xd9959a62
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x59ffffff, 0xd9959a62, x8, 400, x9)

inst_126:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xdbffffff;  op2val:0xe08409f0
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xdbffffff, 0xe08409f0, x8, 404, x9)

inst_127:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xf7ffffff;  op2val:0x258ececb
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xf7ffffff, 0x258ececb, x8, 408, x9)

inst_128:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x6fffffff;  op2val:0xff7d5ec0
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x6fffffff, 0xff7d5ec0, x8, 412, x9)

inst_129:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x9fffffff;  op2val:0x4b6ea010
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x9fffffff, 0x4b6ea010, x8, 416, x9)

inst_130:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x3fffffff;  op2val:0xd885bbac
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x3fffffff, 0xd885bbac, x8, 420, x9)

inst_131:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x7fffffff;  op2val:0xbbe8f88d
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x7fffffff, 0xbbe8f88d, x8, 424, x9)

inst_132:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0xe3d6e4b9
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xffffffff, 0xe3d6e4b9, x8, 428, x9)

inst_133:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x494b6d2;  op2val:0x970216fd
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x494b6d2, 0x970216fd, x8, 432, x9)

inst_134:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xf2650b71;  op2val:0x5cb58b8f
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xf2650b71, 0x5cb58b8f, x8, 436, x9)

inst_135:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x21af214a;  op2val:0x27efda6c
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x21af214a, 0x27efda6c, x8, 440, x9)

inst_136:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x482ea760;  op2val:0x1d1ef7c0
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x482ea760, 0x1d1ef7c0, x8, 444, x9)

inst_137:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xf7a0443;  op2val:0xfc2a909
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xf7a0443, 0xfc2a909, x8, 448, x9)

inst_138:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x69534048;  op2val:0x4e9e4a6
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x69534048, 0x4e9e4a6, x8, 452, x9)

inst_139:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x43e3ef5;  op2val:0x25fdcd7
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x43e3ef5, 0x25fdcd7, x8, 456, x9)

inst_140:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x12fad802;  op2val:0x1782ebc
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x12fad802, 0x1782ebc, x8, 460, x9)

inst_141:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x119b4fe5;  op2val:0xa39575
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x119b4fe5, 0xa39575, x8, 464, x9)

inst_142:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x7db224cb;  op2val:0x49886f
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x7db224cb, 0x49886f, x8, 468, x9)

inst_143:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xb45f51c3;  op2val:0x25693c
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xb45f51c3, 0x25693c, x8, 472, x9)

inst_144:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x41536363;  op2val:0x18031a
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x41536363, 0x18031a, x8, 476, x9)

inst_145:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x1a953cca;  op2val:0xa8267
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x1a953cca, 0xa8267, x8, 480, x9)

inst_146:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x14186ebf;  op2val:0x73010
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x14186ebf, 0x73010, x8, 484, x9)

inst_147:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xf33c1a7f;  op2val:0x38734
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xf33c1a7f, 0x38734, x8, 488, x9)

inst_148:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x8dce6f52;  op2val:0x1eab1
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x8dce6f52, 0x1eab1, x8, 492, x9)

inst_149:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x3096c6c8;  op2val:0xb8ec
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x3096c6c8, 0xb8ec, x8, 496, x9)

inst_150:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x9c461cb5;  op2val:0x7530
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x9c461cb5, 0x7530, x8, 500, x9)

inst_151:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x27756991;  op2val:0x3ed5
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x27756991, 0x3ed5, x8, 504, x9)

inst_152:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x62d74145;  op2val:0x1055
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x62d74145, 0x1055, x8, 508, x9)

inst_153:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x931719fd;  op2val:0xe9e
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x931719fd, 0xe9e, x8, 512, x9)

inst_154:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x965768e0;  op2val:0x59b
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x965768e0, 0x59b, x8, 516, x9)

inst_155:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x74057241;  op2val:0x208
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x74057241, 0x208, x8, 520, x9)

inst_156:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x5e617f8e;  op2val:0x1e8
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x5e617f8e, 0x1e8, x8, 524, x9)

inst_157:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x3e361858;  op2val:0xd2
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x3e361858, 0xd2, x8, 528, x9)

inst_158:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x13041452;  op2val:0x71
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x13041452, 0x71, x8, 532, x9)

inst_159:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x4bdbf090;  op2val:0x34
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x4bdbf090, 0x34, x8, 536, x9)

inst_160:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x9c3ecb54;  op2val:0x19
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x9c3ecb54, 0x19, x8, 540, x9)

inst_161:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x421e7a60;  op2val:0xb
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x421e7a60, 0xb, x8, 544, x9)

inst_162:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x2577c1ec;  op2val:0x5
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x2577c1ec, 0x5, x8, 548, x9)

inst_163:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x19af685d;  op2val:0x2
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x19af685d, 0x2, x8, 552, x9)

inst_164:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x2ff36007;  op2val:0x1
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x2ff36007, 0x1, x8, 556, x9)

inst_165:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xe286852c;  op2val:0x0
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xe286852c, 0x0, x8, 560, x9)

inst_166:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xc511488a;  op2val:0x97bdd982
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xc511488a, 0x97bdd982, x8, 564, x9)

inst_167:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x65151c41;  op2val:0x367e5d6d
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x65151c41, 0x367e5d6d, x8, 568, x9)

inst_168:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x24ca83b3;  op2val:0x623d8eb7
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x24ca83b3, 0x623d8eb7, x8, 572, x9)

inst_169:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x1c3b66fb;  op2val:0x21870f0b
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x1c3b66fb, 0x21870f0b, x8, 576, x9)

inst_170:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xa8a6fd0;  op2val:0x82450164
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xa8a6fd0, 0x82450164, x8, 580, x9)

inst_171:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x69ca08c;  op2val:0x8f2df760
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x69ca08c, 0x8f2df760, x8, 584, x9)

inst_172:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x3552c95;  op2val:0x7ca07386
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x3552c95, 0x7ca07386, x8, 588, x9)

inst_173:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x174ea19;  op2val:0x19de2bc1
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x174ea19, 0x19de2bc1, x8, 592, x9)

inst_174:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xa454f2;  op2val:0xec3fbf4d
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xa454f2, 0xec3fbf4d, x8, 596, x9)

inst_175:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x7e9bee;  op2val:0x164f1513
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x7e9bee, 0x164f1513, x8, 600, x9)

inst_176:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x2c7cd0;  op2val:0xacc6d8f2
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x2c7cd0, 0xacc6d8f2, x8, 604, x9)

inst_177:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x177310;  op2val:0xa123f501
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x177310, 0xa123f501, x8, 608, x9)

inst_178:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x91609;  op2val:0xb57a6a1d
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x91609, 0xb57a6a1d, x8, 612, x9)

inst_179:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x40be0;  op2val:0xe90794df
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x40be0, 0xe90794df, x8, 616, x9)

inst_180:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x28d1b;  op2val:0xaf5570ee
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x28d1b, 0xaf5570ee, x8, 620, x9)

inst_181:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x1fbe5;  op2val:0xd8b9b45c
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x1fbe5, 0xd8b9b45c, x8, 624, x9)

inst_182:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xaac1;  op2val:0x1ba1192e
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xaac1, 0x1ba1192e, x8, 628, x9)

inst_183:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x62c3;  op2val:0x49fe85b0
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x62c3, 0x49fe85b0, x8, 632, x9)

inst_184:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x22fd;  op2val:0x4105cca7
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x22fd, 0x4105cca7, x8, 636, x9)

inst_185:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x16b3;  op2val:0xd7185dda
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x16b3, 0xd7185dda, x8, 640, x9)

inst_186:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xa38;  op2val:0xa7a11490
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xa38, 0xa7a11490, x8, 644, x9)

inst_187:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x6a7;  op2val:0xa9964aef
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x6a7, 0xa9964aef, x8, 648, x9)

inst_188:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x3b9;  op2val:0x4b4d8474
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x3b9, 0x4b4d8474, x8, 652, x9)

inst_189:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x190;  op2val:0x76c468ae
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x190, 0x76c468ae, x8, 656, x9)

inst_190:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xd4;  op2val:0x9208a65
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xd4, 0x9208a65, x8, 660, x9)

inst_191:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x67;  op2val:0x8743feb6
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x67, 0x8743feb6, x8, 664, x9)

inst_192:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x39;  op2val:0xa66b0d38
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x39, 0xa66b0d38, x8, 668, x9)

inst_193:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x1c;  op2val:0xfb710734
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x1c, 0xfb710734, x8, 672, x9)

inst_194:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xe;  op2val:0xa26b7f62
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xe, 0xa26b7f62, x8, 676, x9)

inst_195:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x7;  op2val:0x4dabb481
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x7, 0x4dabb481, x8, 680, x9)

inst_196:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x3;  op2val:0x2fa91425
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x3, 0x2fa91425, x8, 684, x9)

inst_197:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x1;  op2val:0x965eda32
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x1, 0x965eda32, x8, 688, x9)

inst_198:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x0;  op2val:0xc7fde805
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x0, 0xc7fde805, x8, 692, x9)

inst_199:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xffec35fe;  op2val:0x6d3f408c
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xffec35fe, 0x6d3f408c, x8, 696, x9)

inst_200:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x976ad220;  op2val:0x946a3674
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x976ad220, 0x946a3674, x8, 700, x9)

inst_201:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x5990fe96;  op2val:0xdc6113a4
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x5990fe96, 0xdc6113a4, x8, 704, x9)

inst_202:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xc96efdc4;  op2val:0xe42a809c
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xc96efdc4, 0xe42a809c, x8, 708, x9)

inst_203:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xab8534c1;  op2val:0xf1a25760
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xab8534c1, 0xf1a25760, x8, 712, x9)

inst_204:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xd1142724;  op2val:0xfb37bec9
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xd1142724, 0xfb37bec9, x8, 716, x9)

inst_205:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xf65e7737;  op2val:0xfce51a66
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xf65e7737, 0xfce51a66, x8, 720, x9)

inst_206:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x16cbc21c;  op2val:0xfedebb9c
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x16cbc21c, 0xfedebb9c, x8, 724, x9)

inst_207:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xdbdd4dd9;  op2val:0xff69340a
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xdbdd4dd9, 0xff69340a, x8, 728, x9)

inst_208:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x4bd90a77;  op2val:0xff9cf3f4
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x4bd90a77, 0xff9cf3f4, x8, 732, x9)

inst_209:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xcebe24d9;  op2val:0xffc00793
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xcebe24d9, 0xffc00793, x8, 736, x9)

inst_210:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xa0e0bd86;  op2val:0xffee1fc4
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xa0e0bd86, 0xffee1fc4, x8, 740, x9)

inst_211:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x3cc279b3;  op2val:0xfff06038
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x3cc279b3, 0xfff06038, x8, 744, x9)

inst_212:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x754f9b96;  op2val:0xfff93d53
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x754f9b96, 0xfff93d53, x8, 748, x9)

inst_213:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x72745307;  op2val:0xfffc47e8
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x72745307, 0xfffc47e8, x8, 752, x9)

inst_214:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xdcae6d62;  op2val:0xfffe7302
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xdcae6d62, 0xfffe7302, x8, 756, x9)

inst_215:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x7c2c966d;  op2val:0xffff1ce8
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x7c2c966d, 0xffff1ce8, x8, 760, x9)

inst_216:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x9bb4752d;  op2val:0xffffb5c6
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x9bb4752d, 0xffffb5c6, x8, 764, x9)

inst_217:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x17be082f;  op2val:0xffffdfa4
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x17be082f, 0xffffdfa4, x8, 768, x9)

inst_218:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x109ff475;  op2val:0xffffef0b
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x109ff475, 0xffffef0b, x8, 772, x9)

inst_219:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xb97ea6;  op2val:0xfffff43f
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xb97ea6, 0xfffff43f, x8, 776, x9)

inst_220:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xf956ec0b;  op2val:0xfffffb4a
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xf956ec0b, 0xfffffb4a, x8, 780, x9)

inst_221:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x70fc1afc;  op2val:0xfffffda4
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x70fc1afc, 0xfffffda4, x8, 784, x9)

inst_222:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x6348306e;  op2val:0xfffffecb
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x6348306e, 0xfffffecb, x8, 788, x9)

inst_223:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x66b072b9;  op2val:0xffffff54
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x66b072b9, 0xffffff54, x8, 792, x9)

inst_224:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x7ff822ed;  op2val:0xffffffa9
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x7ff822ed, 0xffffffa9, x8, 796, x9)

inst_225:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xe918be9f;  op2val:0xffffffc3
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xe918be9f, 0xffffffc3, x8, 800, x9)

inst_226:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xe4bae7f6;  op2val:0xffffffe7
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xe4bae7f6, 0xffffffe7, x8, 804, x9)

inst_227:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xde9a896f;  op2val:0xfffffff1
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xde9a896f, 0xfffffff1, x8, 808, x9)

inst_228:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x2881e531;  op2val:0xfffffff8
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x2881e531, 0xfffffff8, x8, 812, x9)

inst_229:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x1475f78d;  op2val:0xfffffffc
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x1475f78d, 0xfffffffc, x8, 816, x9)

inst_230:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xe59cf78f;  op2val:0xfffffffe
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xe59cf78f, 0xfffffffe, x8, 820, x9)

inst_231:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xb66b3284;  op2val:0xffffffff
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xb66b3284, 0xffffffff, x8, 824, x9)

inst_232:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x6f4930c9;  op2val:0x39422745
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x6f4930c9, 0x39422745, x8, 828, x9)

inst_233:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x85d97467;  op2val:0x58fa6e1c
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x85d97467, 0x58fa6e1c, x8, 832, x9)

inst_234:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xc70afc93;  op2val:0x2d143295
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xc70afc93, 0x2d143295, x8, 836, x9)

inst_235:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xe911655f;  op2val:0xd230b46c
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xe911655f, 0xd230b46c, x8, 840, x9)

inst_236:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xf4ab0a39;  op2val:0x4d753ac1
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xf4ab0a39, 0x4d753ac1, x8, 844, x9)

inst_237:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xf8bd4821;  op2val:0x1e9667c2
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xf8bd4821, 0x1e9667c2, x8, 848, x9)

inst_238:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xfcd7e667;  op2val:0xae4839a1
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xfcd7e667, 0xae4839a1, x8, 852, x9)

inst_239:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xfe71cfdf;  op2val:0x6a013380
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xfe71cfdf, 0x6a013380, x8, 856, x9)

inst_240:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xff1c11ae;  op2val:0x59432a19
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xff1c11ae, 0x59432a19, x8, 860, x9)

inst_241:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xff89799a;  op2val:0xceb506f6
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xff89799a, 0xceb506f6, x8, 864, x9)

inst_242:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xffc80b13;  op2val:0xc5ec6148
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xffc80b13, 0xc5ec6148, x8, 868, x9)

inst_243:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xffe94647;  op2val:0x99ef1857
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xffe94647, 0x99ef1857, x8, 872, x9)

inst_244:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xfff263cf;  op2val:0x14b91c79
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xfff263cf, 0x14b91c79, x8, 876, x9)

inst_245:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xfff919a1;  op2val:0xa86b8a6e
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xfff919a1, 0xa86b8a6e, x8, 880, x9)

inst_246:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xfffde89d;  op2val:0x8208d09
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xfffde89d, 0x8208d09, x8, 884, x9)

inst_247:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xfffec9d0;  op2val:0x69b1dcbf
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xfffec9d0, 0x69b1dcbf, x8, 888, x9)

inst_248:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xffff5576;  op2val:0x807da245
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xffff5576, 0x807da245, x8, 892, x9)

inst_249:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xffffb6df;  op2val:0x95a4d257
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xffffb6df, 0x95a4d257, x8, 896, x9)

inst_250:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xffffc561;  op2val:0x735c076b
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xffffc561, 0x735c076b, x8, 900, x9)

inst_251:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xffffeab5;  op2val:0xe5f0307e
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xffffeab5, 0xe5f0307e, x8, 904, x9)

inst_252:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xfffff602;  op2val:0xe8dac663
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xfffff602, 0xe8dac663, x8, 908, x9)

inst_253:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xfffff8b1;  op2val:0x109c207
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xfffff8b1, 0x109c207, x8, 912, x9)

inst_254:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xfffffca0;  op2val:0x600fecc1
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xfffffca0, 0x600fecc1, x8, 916, x9)

inst_255:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xfffffecc;  op2val:0xfb7f6f5d
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xfffffecc, 0xfb7f6f5d, x8, 920, x9)

inst_256:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xffffff6e;  op2val:0x5cd2875e
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xffffff6e, 0x5cd2875e, x8, 924, x9)

inst_257:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xffffff84;  op2val:0xacca7f0d
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xffffff84, 0xacca7f0d, x8, 928, x9)

inst_258:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xffffffdd;  op2val:0x5ae6a228
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xffffffdd, 0x5ae6a228, x8, 932, x9)

inst_259:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xffffffe7;  op2val:0xff1e5bef
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xffffffe7, 0xff1e5bef, x8, 936, x9)

inst_260:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xfffffff4;  op2val:0x137a9777
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xfffffff4, 0x137a9777, x8, 940, x9)

inst_261:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xfffffffa;  op2val:0x854a9657
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xfffffffa, 0x854a9657, x8, 944, x9)

inst_262:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xfffffffd;  op2val:0xcf84b683
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xfffffffd, 0xcf84b683, x8, 948, x9)

inst_263:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xfffffffe;  op2val:0x93fdcab8
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xfffffffe, 0x93fdcab8, x8, 952, x9)

inst_264:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x8577eb1
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xffffffff, 0x8577eb1, x8, 956, x9)

inst_265:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0xaf6e9055;  op2val:0x40000000
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0xaf6e9055, 0x40000000, x8, 960, x9)

inst_266:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x577f8847;  op2val:0xca7160cc
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x577f8847, 0xca7160cc, x8, 964, x9)

inst_267:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x5d3bbce0;  op2val:0x76f86039
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x5d3bbce0, 0x76f86039, x8, 968, x9)

inst_268:
// 
// opcode: ror ; op1:x30; op2:x29; dest:x31; op1val:0x80000000;  op2val:0x7b246c17
TEST_RR_OP(ror, x31, x30, x29, 0x00000000, 0x80000000, 0x7b246c17, x8, 972, x9)
#endif


RVTEST_CODE_END
RVMODEL_HALT

RVTEST_DATA_BEGIN
.align 4
rvtest_data:
.word 0xbabecafe
.word 0xabecafeb
.word 0xbecafeba
.word 0xecafebab
RVTEST_DATA_END

RVMODEL_DATA_BEGIN
rvtest_sig_begin:
sig_begin_canary:
CANARY;


signature_x1_0:
    .fill 0*(XLEN/32),4,0xdeadbeef


signature_x1_1:
    .fill 25*(XLEN/32),4,0xdeadbeef


signature_x8_0:
    .fill 244*(XLEN/32),4,0xdeadbeef

#ifdef rvtest_mtrap_routine

tsig_begin_canary:
CANARY;
mtrap_sigptr:
    .fill 64*(XLEN/32),4,0xdeadbeef
tsig_end_canary:
CANARY;

#endif

#ifdef rvtest_gpr_save

gpr_save:
    .fill 32*(XLEN/32),4,0xdeadbeef

#endif

sig_end_canary:
CANARY;
rvtest_sig_end:
RVMODEL_DATA_END
