
// -----------
// This file was generated by riscv_ctg (https://gitlab.com/incoresemi/riscv-compliance/riscv_ctg)
// version   : 0.4.1
// timestamp : Wed Dec 16 03:37:04 2020 GMT
// usage     : riscv_ctg \
//                  -- cgf ('/scratch/git-repo/incoresemi/riscv-compliance/riscv_ctg/sample_cgfs/dataset.cgf', '/scratch/git-repo/incoresemi/riscv-compliance/riscv_ctg/sample_cgfs/rv32ic.cgf') \
//                  -- xlen 32 \
// -----------
//
// -----------
// Copyright (c) 2020. RISC-V International. All rights reserved.
// SPDX-License-Identifier: BSD-3-Clause
// -----------
//
// This assembly file tests the c.lw instruction of the RISC-V C extension for the clw covergroup.
// 
#include "model_test.h"
#include "arch_test.h"
RVTEST_ISA("RV32IC")

.section .text.init
.org 0x80
.globl rvtest_entry_point
rvtest_entry_point:
RVMODEL_BOOT
RVTEST_CODE_BEGIN

#ifdef TEST_CASE_1

RVTEST_CASE(0,"//check ISA:=regex(.*32.*);check ISA:=regex(.*I.*C.*);def TEST_CASE_1=True;",clw)

RVTEST_SIGBASE( x1,signature_x1_1)

inst_0:
// rs1 == rd, rd==x12, rs1==x12, imm_val > 0, 
// opcode: c.lw; op1:x12; dest:x12; immval:0x30
TEST_LOAD(x1,x2,0,x12,x12,0x30,0,c.lw,0)

inst_1:
// rs1 != rd, rd==x11, rs1==x10, imm_val == 0, 
// opcode: c.lw; op1:x10; dest:x11; immval:0x0
TEST_LOAD(x1,x2,0,x10,x11,0x0,4,c.lw,0)

inst_2:
// rd==x14, rs1==x9, imm_val == 4, 
// opcode: c.lw; op1:x9; dest:x14; immval:0x4
TEST_LOAD(x1,x2,0,x9,x14,0x4,8,c.lw,0)

inst_3:
// rd==x13, rs1==x15, imm_val == 8, 
// opcode: c.lw; op1:x15; dest:x13; immval:0x8
TEST_LOAD(x1,x2,0,x15,x13,0x8,12,c.lw,0)

inst_4:
// rd==x10, rs1==x14, imm_val == 16, 
// opcode: c.lw; op1:x14; dest:x10; immval:0x10
TEST_LOAD(x1,x2,0,x14,x10,0x10,16,c.lw,0)

inst_5:
// rd==x15, rs1==x8, imm_val == 32, 
// opcode: c.lw; op1:x8; dest:x15; immval:0x20
TEST_LOAD(x1,x2,0,x8,x15,0x20,20,c.lw,0)

inst_6:
// rd==x8, rs1==x11, imm_val == 64, 
// opcode: c.lw; op1:x11; dest:x8; immval:0x40
TEST_LOAD(x1,x2,0,x11,x8,0x40,24,c.lw,0)

inst_7:
// rd==x9, rs1==x13, imm_val == 120, 
// opcode: c.lw; op1:x13; dest:x9; immval:0x78
TEST_LOAD(x1,x2,0,x13,x9,0x78,28,c.lw,0)

inst_8:
// imm_val == 116, 
// opcode: c.lw; op1:x11; dest:x10; immval:0x74
TEST_LOAD(x1,x2,0,x11,x10,0x74,32,c.lw,0)

inst_9:
// imm_val == 108, 
// opcode: c.lw; op1:x11; dest:x10; immval:0x6c
TEST_LOAD(x1,x2,0,x11,x10,0x6c,36,c.lw,0)

inst_10:
// imm_val == 92, 
// opcode: c.lw; op1:x11; dest:x10; immval:0x5c
TEST_LOAD(x1,x2,0,x11,x10,0x5c,40,c.lw,0)

inst_11:
// imm_val == 60, 
// opcode: c.lw; op1:x11; dest:x10; immval:0x3c
TEST_LOAD(x1,x2,0,x11,x10,0x3c,44,c.lw,0)

inst_12:
// imm_val == 84, 
// opcode: c.lw; op1:x11; dest:x10; immval:0x54
TEST_LOAD(x1,x2,0,x11,x10,0x54,48,c.lw,0)

inst_13:
// imm_val == 40, 
// opcode: c.lw; op1:x11; dest:x10; immval:0x28
TEST_LOAD(x1,x2,0,x11,x10,0x28,52,c.lw,0)
#endif


RVTEST_CODE_END
RVMODEL_HALT

RVTEST_DATA_BEGIN
.align 4

rvtest_data:
.word 0xbabecafe
.word 0xbabecafe
.word 0xbabecafe
.word 0xbabecafe
RVTEST_DATA_END


RVMODEL_DATA_BEGIN
rvtest_sig_begin:
sig_begin_canary:
CANARY;


signature_x1_0:
    .fill 0*(XLEN/32),4,0xdeadbeef


signature_x1_1:
    .fill 14*(XLEN/32),4,0xdeadbeef

#ifdef rvtest_mtrap_routine

tsig_begin_canary:
CANARY;
mtrap_sigptr:
    .fill 64*(XLEN/32),4,0xdeadbeef
tsig_end_canary:
CANARY;

#endif

#ifdef rvtest_gpr_save

gpr_save:
    .fill 32*(XLEN/32),4,0xdeadbeef

#endif

sig_end_canary:
CANARY;
rvtest_sig_end:
RVMODEL_DATA_END
