
// -----------
// This file was generated by riscv_ctg (https://gitlab.com/incoresemi/riscv-compliance/riscv_ctg)
// version   : 0.4.1
// timestamp : Wed Dec 16 03:37:04 2020 GMT
// usage     : riscv_ctg \
//                  -- cgf ('/scratch/git-repo/incoresemi/riscv-compliance/riscv_ctg/sample_cgfs/dataset.cgf', '/scratch/git-repo/incoresemi/riscv-compliance/riscv_ctg/sample_cgfs/rv32ic.cgf') \
//                  -- xlen 32 \
// -----------
//
// -----------
// Copyright (c) 2020. RISC-V International. All rights reserved.
// SPDX-License-Identifier: BSD-3-Clause
// -----------
//
// This assembly file tests the c.swsp instruction of the RISC-V C extension for the cswsp covergroup.
// 
#include "model_test.h"
#include "arch_test.h"
RVTEST_ISA("RV32IC")

.section .text.init
.org 0x80
.globl rvtest_entry_point
rvtest_entry_point:
RVMODEL_BOOT
RVTEST_CODE_BEGIN

#ifdef TEST_CASE_1

RVTEST_CASE(0,"//check ISA:=regex(.*32.*);check ISA:=regex(.*I.*C.*);def TEST_CASE_1=True;",cswsp)

RVTEST_SIGBASE( x8,signature_x8_1)

inst_0:
// rs2==x18, rs2_val == (-2**(xlen-1)), imm_val > 0, rs2_val == -2147483648
// opcode:c.swsp; op1:x2; op2:x18; op2val:-0x80000000; immval:0xc
TEST_STORE(x8,x11,0,x2,x18,-0x80000000,0xc,0,c.swsp,0)

inst_1:
// rs2==x19, rs2_val == 0, 
// opcode:c.swsp; op1:x2; op2:x19; op2val:0x0; immval:0x38
TEST_STORE(x8,x11,0,x2,x19,0x0,0x38,4,c.swsp,0)

inst_2:
// rs2==x21, rs2_val == (2**(xlen-1)-1), rs2_val == 2147483647
// opcode:c.swsp; op1:x2; op2:x21; op2val:0x7fffffff; immval:0x18
TEST_STORE(x8,x11,0,x2,x21,0x7fffffff,0x18,8,c.swsp,0)

inst_3:
// rs2==x7, rs2_val == 1, 
// opcode:c.swsp; op1:x2; op2:x7; op2val:0x1; immval:0x2c
TEST_STORE(x8,x11,0,x2,x7,0x1,0x2c,12,c.swsp,0)

inst_4:
// rs2==x6, imm_val == 0, rs2_val == 524288
// opcode:c.swsp; op1:x2; op2:x6; op2val:0x80000; immval:0x0
TEST_STORE(x8,x11,0,x2,x6,0x80000,0x0,16,c.swsp,0)

inst_5:
// rs2==x26, rs2_val == 2, 
// opcode:c.swsp; op1:x2; op2:x26; op2val:0x2; immval:0x48
TEST_STORE(x8,x11,0,x2,x26,0x2,0x48,20,c.swsp,0)

inst_6:
// rs2==x14, rs2_val == 4, imm_val == 64
// opcode:c.swsp; op1:x2; op2:x14; op2val:0x4; immval:0x40
TEST_STORE(x8,x11,0,x2,x14,0x4,0x40,24,c.swsp,0)

inst_7:
// rs2==x3, rs2_val == 8, imm_val == 220
// opcode:c.swsp; op1:x2; op2:x3; op2val:0x8; immval:0xdc
TEST_STORE(x8,x11,0,x2,x3,0x8,0xdc,28,c.swsp,0)

inst_8:
// rs2==x1, rs2_val == 16, 
// opcode:c.swsp; op1:x2; op2:x1; op2val:0x10; immval:0x4c
TEST_STORE(x8,x11,0,x2,x1,0x10,0x4c,32,c.swsp,0)

inst_9:
// rs2==x15, rs2_val == 32, imm_val == 244
// opcode:c.swsp; op1:x2; op2:x15; op2val:0x20; immval:0xf4
TEST_STORE(x8,x11,0,x2,x15,0x20,0xf4,36,c.swsp,0)

inst_10:
// rs2==x12, rs2_val == 64, 
// opcode:c.swsp; op1:x2; op2:x12; op2val:0x40; immval:0x14
TEST_STORE(x8,x11,0,x2,x12,0x40,0x14,40,c.swsp,0)

inst_11:
// rs2==x16, rs2_val == 128, 
// opcode:c.swsp; op1:x2; op2:x16; op2val:0x80; immval:0x34
TEST_STORE(x8,x11,0,x2,x16,0x80,0x34,44,c.swsp,0)

inst_12:
// rs2==x30, rs2_val == 256, imm_val == 32
// opcode:c.swsp; op1:x2; op2:x30; op2val:0x100; immval:0x20
TEST_STORE(x8,x11,0,x2,x30,0x100,0x20,48,c.swsp,0)

inst_13:
// rs2==x5, rs2_val == 512, 
// opcode:c.swsp; op1:x2; op2:x5; op2val:0x200; immval:0xfc
TEST_STORE(x8,x11,0,x2,x5,0x200,0xfc,52,c.swsp,0)

inst_14:
// rs2==x9, rs2_val == 1024, 
// opcode:c.swsp; op1:x2; op2:x9; op2val:0x400; immval:0x3c
TEST_STORE(x8,x11,0,x2,x9,0x400,0x3c,56,c.swsp,0)

inst_15:
// rs2==x25, rs2_val == 2048, 
// opcode:c.swsp; op1:x2; op2:x25; op2val:0x800; immval:0x48
TEST_STORE(x8,x11,0,x2,x25,0x800,0x48,60,c.swsp,0)

inst_16:
// rs2==x22, rs2_val == 4096, 
// opcode:c.swsp; op1:x2; op2:x22; op2val:0x1000; immval:0x44
TEST_STORE(x8,x11,0,x2,x22,0x1000,0x44,64,c.swsp,0)

inst_17:
// rs2==x4, rs2_val == 8192, imm_val == 4
// opcode:c.swsp; op1:x2; op2:x4; op2val:0x2000; immval:0x4
TEST_STORE(x8,x11,0,x2,x4,0x2000,0x4,68,c.swsp,0)

inst_18:
// rs2==x17, rs2_val == 16384, imm_val == 8
// opcode:c.swsp; op1:x2; op2:x17; op2val:0x4000; immval:0x8
TEST_STORE(x8,x11,0,x2,x17,0x4000,0x8,72,c.swsp,0)

inst_19:
// rs2==x27, rs2_val == 32768, imm_val == 124
// opcode:c.swsp; op1:x2; op2:x27; op2val:0x8000; immval:0x7c
TEST_STORE(x8,x11,0,x2,x27,0x8000,0x7c,76,c.swsp,0)

inst_20:
// rs2==x24, rs2_val == 65536, 
// opcode:c.swsp; op1:x2; op2:x24; op2val:0x10000; immval:0x3c
TEST_STORE(x8,x11,0,x2,x24,0x10000,0x3c,80,c.swsp,0)

inst_21:
// rs2==x20, rs2_val == 131072, 
// opcode:c.swsp; op1:x2; op2:x20; op2val:0x20000; immval:0x40
TEST_STORE(x8,x11,0,x2,x20,0x20000,0x40,84,c.swsp,0)

inst_22:
// rs2==x10, rs2_val == 262144, 
// opcode:c.swsp; op1:x2; op2:x10; op2val:0x40000; immval:0xf4
TEST_STORE(x8,x11,0,x2,x10,0x40000,0xf4,88,c.swsp,0)

inst_23:
// rs2==x23, rs2_val == 1048576, 
// opcode:c.swsp; op1:x2; op2:x23; op2val:0x100000; immval:0xfc
TEST_STORE(x8,x11,0,x2,x23,0x100000,0xfc,92,c.swsp,0)

inst_24:
// rs2==x13, rs2_val == 2097152, 
// opcode:c.swsp; op1:x2; op2:x13; op2val:0x200000; immval:0x1c
TEST_STORE(x8,x11,0,x2,x13,0x200000,0x1c,96,c.swsp,0)

inst_25:
// rs2==x29, rs2_val == 4194304, 
// opcode:c.swsp; op1:x2; op2:x29; op2val:0x400000; immval:0x48
TEST_STORE(x8,x11,0,x2,x29,0x400000,0x48,100,c.swsp,0)

inst_26:
// rs2==x31, rs2_val == 8388608, imm_val == 16
// opcode:c.swsp; op1:x2; op2:x31; op2val:0x800000; immval:0x10
TEST_STORE(x8,x3,0,x2,x31,0x800000,0x10,104,c.swsp,0)
RVTEST_SIGBASE( x1,signature_x1_0)

inst_27:
// rs2==x11, rs2_val == 16777216, 
// opcode:c.swsp; op1:x2; op2:x11; op2val:0x1000000; immval:0xc
TEST_STORE(x1,x3,0,x2,x11,0x1000000,0xc,0,c.swsp,0)

inst_28:
// rs2==x8, rs2_val == 33554432, 
// opcode:c.swsp; op1:x2; op2:x8; op2val:0x2000000; immval:0xfc
TEST_STORE(x1,x3,0,x2,x8,0x2000000,0xfc,4,c.swsp,0)

inst_29:
// rs2==x28, rs2_val == 67108864, 
// opcode:c.swsp; op1:x2; op2:x28; op2val:0x4000000; immval:0x2c
TEST_STORE(x1,x3,0,x2,x28,0x4000000,0x2c,8,c.swsp,0)

inst_30:
// rs2_val == 134217728, 
// opcode:c.swsp; op1:x2; op2:x10; op2val:0x8000000; immval:0x14
TEST_STORE(x1,x3,0,x2,x10,0x8000000,0x14,12,c.swsp,0)

inst_31:
// rs2_val == 268435456, imm_val == 128
// opcode:c.swsp; op1:x2; op2:x10; op2val:0x10000000; immval:0x80
TEST_STORE(x1,x3,0,x2,x10,0x10000000,0x80,16,c.swsp,0)

inst_32:
// rs2_val == 536870912, 
// opcode:c.swsp; op1:x2; op2:x10; op2val:0x20000000; immval:0x0
TEST_STORE(x1,x3,0,x2,x10,0x20000000,0x0,20,c.swsp,0)

inst_33:
// rs2_val == 1073741824, 
// opcode:c.swsp; op1:x2; op2:x10; op2val:0x40000000; immval:0x3c
TEST_STORE(x1,x3,0,x2,x10,0x40000000,0x3c,24,c.swsp,0)

inst_34:
// rs2_val == -2, 
// opcode:c.swsp; op1:x2; op2:x10; op2val:-0x2; immval:0x30
TEST_STORE(x1,x3,0,x2,x10,-0x2,0x30,28,c.swsp,0)

inst_35:
// rs2_val == -3, 
// opcode:c.swsp; op1:x2; op2:x10; op2val:-0x3; immval:0xc
TEST_STORE(x1,x3,0,x2,x10,-0x3,0xc,32,c.swsp,0)

inst_36:
// rs2_val == -5, imm_val == 248
// opcode:c.swsp; op1:x2; op2:x10; op2val:-0x5; immval:0xf8
TEST_STORE(x1,x3,0,x2,x10,-0x5,0xf8,36,c.swsp,0)

inst_37:
// rs2_val == -9, 
// opcode:c.swsp; op1:x2; op2:x10; op2val:-0x9; immval:0x14
TEST_STORE(x1,x3,0,x2,x10,-0x9,0x14,40,c.swsp,0)

inst_38:
// rs2_val == -17, 
// opcode:c.swsp; op1:x2; op2:x10; op2val:-0x11; immval:0x2c
TEST_STORE(x1,x3,0,x2,x10,-0x11,0x2c,44,c.swsp,0)

inst_39:
// rs2_val == -33, 
// opcode:c.swsp; op1:x2; op2:x10; op2val:-0x21; immval:0x34
TEST_STORE(x1,x3,0,x2,x10,-0x21,0x34,48,c.swsp,0)

inst_40:
// rs2_val == -134217729, 
// opcode:c.swsp; op1:x2; op2:x10; op2val:-0x8000001; immval:0x28
TEST_STORE(x1,x3,0,x2,x10,-0x8000001,0x28,52,c.swsp,0)

inst_41:
// rs2_val == -268435457, 
// opcode:c.swsp; op1:x2; op2:x10; op2val:-0x10000001; immval:0x4c
TEST_STORE(x1,x3,0,x2,x10,-0x10000001,0x4c,56,c.swsp,0)

inst_42:
// rs2_val == -536870913, 
// opcode:c.swsp; op1:x2; op2:x10; op2val:-0x20000001; immval:0x30
TEST_STORE(x1,x3,0,x2,x10,-0x20000001,0x30,60,c.swsp,0)

inst_43:
// rs2_val == -1073741825, 
// opcode:c.swsp; op1:x2; op2:x10; op2val:-0x40000001; immval:0x7c
TEST_STORE(x1,x3,0,x2,x10,-0x40000001,0x7c,64,c.swsp,0)

inst_44:
// rs2_val == 1431655765, imm_val == 236
// opcode:c.swsp; op1:x2; op2:x10; op2val:0x55555555; immval:0xec
TEST_STORE(x1,x3,0,x2,x10,0x55555555,0xec,68,c.swsp,0)

inst_45:
// rs2_val == -1431655766, imm_val == 188
// opcode:c.swsp; op1:x2; op2:x10; op2val:-0x55555556; immval:0xbc
TEST_STORE(x1,x3,0,x2,x10,-0x55555556,0xbc,72,c.swsp,0)

inst_46:
// imm_val == 84, 
// opcode:c.swsp; op1:x2; op2:x10; op2val:0x80000; immval:0x54
TEST_STORE(x1,x3,0,x2,x10,0x80000,0x54,76,c.swsp,0)

inst_47:
// imm_val == 168, 
// opcode:c.swsp; op1:x2; op2:x10; op2val:-0x21; immval:0xa8
TEST_STORE(x1,x3,0,x2,x10,-0x21,0xa8,80,c.swsp,0)

inst_48:
// rs2_val == -65, 
// opcode:c.swsp; op1:x2; op2:x10; op2val:-0x41; immval:0xdc
TEST_STORE(x1,x3,0,x2,x10,-0x41,0xdc,84,c.swsp,0)

inst_49:
// rs2_val == -129, 
// opcode:c.swsp; op1:x2; op2:x10; op2val:-0x81; immval:0xf4
TEST_STORE(x1,x3,0,x2,x10,-0x81,0xf4,88,c.swsp,0)

inst_50:
// rs2_val == -257, 
// opcode:c.swsp; op1:x2; op2:x10; op2val:-0x101; immval:0x80
TEST_STORE(x1,x3,0,x2,x10,-0x101,0x80,92,c.swsp,0)

inst_51:
// rs2_val == -513, 
// opcode:c.swsp; op1:x2; op2:x10; op2val:-0x201; immval:0xc
TEST_STORE(x1,x3,0,x2,x10,-0x201,0xc,96,c.swsp,0)

inst_52:
// rs2_val == -1025, 
// opcode:c.swsp; op1:x2; op2:x10; op2val:-0x401; immval:0x20
TEST_STORE(x1,x3,0,x2,x10,-0x401,0x20,100,c.swsp,0)

inst_53:
// rs2_val == -2049, 
// opcode:c.swsp; op1:x2; op2:x10; op2val:-0x801; immval:0x40
TEST_STORE(x1,x3,0,x2,x10,-0x801,0x40,104,c.swsp,0)

inst_54:
// rs2_val == -4097, 
// opcode:c.swsp; op1:x2; op2:x10; op2val:-0x1001; immval:0x38
TEST_STORE(x1,x3,0,x2,x10,-0x1001,0x38,108,c.swsp,0)

inst_55:
// rs2_val == -8193, 
// opcode:c.swsp; op1:x2; op2:x10; op2val:-0x2001; immval:0x80
TEST_STORE(x1,x3,0,x2,x10,-0x2001,0x80,112,c.swsp,0)

inst_56:
// rs2_val == -16385, 
// opcode:c.swsp; op1:x2; op2:x10; op2val:-0x4001; immval:0x34
TEST_STORE(x1,x3,0,x2,x10,-0x4001,0x34,116,c.swsp,0)

inst_57:
// rs2_val == -32769, 
// opcode:c.swsp; op1:x2; op2:x10; op2val:-0x8001; immval:0x80
TEST_STORE(x1,x3,0,x2,x10,-0x8001,0x80,120,c.swsp,0)

inst_58:
// rs2_val == -65537, 
// opcode:c.swsp; op1:x2; op2:x10; op2val:-0x10001; immval:0x2c
TEST_STORE(x1,x3,0,x2,x10,-0x10001,0x2c,124,c.swsp,0)

inst_59:
// rs2_val == -131073, 
// opcode:c.swsp; op1:x2; op2:x10; op2val:-0x20001; immval:0x4
TEST_STORE(x1,x3,0,x2,x10,-0x20001,0x4,128,c.swsp,0)

inst_60:
// rs2_val == -262145, 
// opcode:c.swsp; op1:x2; op2:x10; op2val:-0x40001; immval:0x18
TEST_STORE(x1,x3,0,x2,x10,-0x40001,0x18,132,c.swsp,0)

inst_61:
// rs2_val == -524289, 
// opcode:c.swsp; op1:x2; op2:x10; op2val:-0x80001; immval:0x24
TEST_STORE(x1,x3,0,x2,x10,-0x80001,0x24,136,c.swsp,0)

inst_62:
// rs2_val == -1048577, 
// opcode:c.swsp; op1:x2; op2:x10; op2val:-0x100001; immval:0xec
TEST_STORE(x1,x3,0,x2,x10,-0x100001,0xec,140,c.swsp,0)

inst_63:
// rs2_val == -2097153, 
// opcode:c.swsp; op1:x2; op2:x10; op2val:-0x200001; immval:0xbc
TEST_STORE(x1,x3,0,x2,x10,-0x200001,0xbc,144,c.swsp,0)

inst_64:
// rs2_val == -4194305, 
// opcode:c.swsp; op1:x2; op2:x10; op2val:-0x400001; immval:0x80
TEST_STORE(x1,x3,0,x2,x10,-0x400001,0x80,148,c.swsp,0)

inst_65:
// rs2_val == -8388609, 
// opcode:c.swsp; op1:x2; op2:x10; op2val:-0x800001; immval:0x4
TEST_STORE(x1,x3,0,x2,x10,-0x800001,0x4,152,c.swsp,0)

inst_66:
// rs2_val == -16777217, 
// opcode:c.swsp; op1:x2; op2:x10; op2val:-0x1000001; immval:0xf4
TEST_STORE(x1,x3,0,x2,x10,-0x1000001,0xf4,156,c.swsp,0)

inst_67:
// rs2_val == -33554433, 
// opcode:c.swsp; op1:x2; op2:x10; op2val:-0x2000001; immval:0x4c
TEST_STORE(x1,x3,0,x2,x10,-0x2000001,0x4c,160,c.swsp,0)

inst_68:
// rs2_val == -67108865, 
// opcode:c.swsp; op1:x2; op2:x10; op2val:-0x4000001; immval:0x8
TEST_STORE(x1,x3,0,x2,x10,-0x4000001,0x8,164,c.swsp,0)
#endif


RVTEST_CODE_END
RVMODEL_HALT

RVTEST_DATA_BEGIN
.align 4

rvtest_data:
.word 0xbabecafe
.word 0xbabecafe
.word 0xbabecafe
.word 0xbabecafe
RVTEST_DATA_END


RVMODEL_DATA_BEGIN
rvtest_sig_begin:
sig_begin_canary:
CANARY;


signature_x8_0:
    .fill 0*(XLEN/32),4,0xdeadbeef


signature_x8_1:
    .fill 27*(XLEN/32),4,0xdeadbeef


signature_x1_0:
    .fill 42*(XLEN/32),4,0xdeadbeef

#ifdef rvtest_mtrap_routine

tsig_begin_canary:
CANARY;
mtrap_sigptr:
    .fill 64*(XLEN/32),4,0xdeadbeef
tsig_end_canary:
CANARY;

#endif

#ifdef rvtest_gpr_save

gpr_save:
    .fill 32*(XLEN/32),4,0xdeadbeef

#endif

sig_end_canary:
CANARY;
rvtest_sig_end:
RVMODEL_DATA_END
