
// -----------
// This file was generated by riscv_ctg (https://gitlab.com/incoresemi/riscv-compliance/riscv_ctg)
// version   : 0.4.1
// timestamp : Tue Dec 15 15:36:11 2020 GMT
// usage     : riscv_ctg \
//                  -- cgf ('/scratch/git-repo/incoresemi/riscv-compliance/riscv_ctg/sample_cgfs/dataset.cgf', '/scratch/git-repo/incoresemi/riscv-compliance/riscv_ctg/sample_cgfs/rv32i.cgf') \
//                  -- xlen 32 \
// -----------
//
// -----------
// Copyright (c) 2020. RISC-V International. All rights reserved.
// SPDX-License-Identifier: BSD-3-Clause
// -----------
//
// This assembly file tests the ori instruction of the RISC-V I extension for the ori covergroup.
// 
#include "model_test.h"
#include "arch_test.h"
RVTEST_ISA("RV32I")

.section .text.init
.org 0x80
.globl rvtest_entry_point
rvtest_entry_point:
RVMODEL_BOOT
RVTEST_CODE_BEGIN

#ifdef TEST_CASE_1

RVTEST_CASE(0,"//check ISA:=regex(.*32.*);check ISA:=regex(.*I.*);def TEST_CASE_1=True;",ori)

RVTEST_SIGBASE( x2,signature_x2_1)

inst_0:
// rs1 != rd, rs1==x5, rd==x22, imm_val == (-2**(12-1)), imm_val == -2048, rs1_val != imm_val, rs1_val < 0 and imm_val < 0, rs1_val == -513
// opcode: ori ; op1:x5; dest:x22; op1val:-0x201;  immval:-0x800
TEST_IMM_OP( ori, x22, x5, 0xfffffdff, -0x201, -0x800, x2, 0, x9)

inst_1:
// rs1 == rd, rs1==x27, rd==x27, imm_val == 0, rs1_val == imm_val, rs1_val == 0, rs1_val==0 and imm_val==0
// opcode: ori ; op1:x27; dest:x27; op1val:0x0;  immval:0x0
TEST_IMM_OP( ori, x27, x27, 0x0, 0x0, 0x0, x2, 4, x9)

inst_2:
// rs1==x17, rd==x8, imm_val == (2**(12-1)-1), rs1_val > 0 and imm_val > 0, imm_val == 2047
// opcode: ori ; op1:x17; dest:x8; op1val:0x33333334;  immval:0x7ff
TEST_IMM_OP( ori, x8, x17, 0x333337ff, 0x33333334, 0x7ff, x2, 8, x9)

inst_3:
// rs1==x20, rd==x1, imm_val == 1, rs1_val < 0 and imm_val > 0
// opcode: ori ; op1:x20; dest:x1; op1val:-0xb504;  immval:0x1
TEST_IMM_OP( ori, x1, x20, 0xffff4afd, -0xb504, 0x1, x2, 12, x9)

inst_4:
// rs1==x12, rd==x19, rs1_val == (-2**(xlen-1)), rs1_val == -2147483648
// opcode: ori ; op1:x12; dest:x19; op1val:-0x80000000;  immval:0x2d
TEST_IMM_OP( ori, x19, x12, 0x8000002d, -0x80000000, 0x2d, x2, 16, x9)

inst_5:
// rs1==x8, rd==x3, rs1_val == (2**(xlen-1)-1), rs1_val == 2147483647, imm_val == 1365
// opcode: ori ; op1:x8; dest:x3; op1val:0x7fffffff;  immval:0x555
TEST_IMM_OP( ori, x3, x8, 0x7fffffff, 0x7fffffff, 0x555, x2, 20, x9)

inst_6:
// rs1==x28, rd==x26, rs1_val == 1, 
// opcode: ori ; op1:x28; dest:x26; op1val:0x1;  immval:0x667
TEST_IMM_OP( ori, x26, x28, 0x667, 0x1, 0x667, x2, 24, x9)

inst_7:
// rs1==x16, rd==x23, rs1_val > 0 and imm_val < 0, 
// opcode: ori ; op1:x16; dest:x23; op1val:0x7;  immval:-0x7
TEST_IMM_OP( ori, x23, x16, 0xffffffff, 0x7, -0x7, x2, 28, x9)

inst_8:
// rs1==x25, rd==x31, imm_val == 2, rs1_val == 262144
// opcode: ori ; op1:x25; dest:x31; op1val:0x40000;  immval:0x2
TEST_IMM_OP( ori, x31, x25, 0x40002, 0x40000, 0x2, x2, 32, x9)

inst_9:
// rs1==x23, rd==x11, imm_val == 4, rs1_val == 536870912
// opcode: ori ; op1:x23; dest:x11; op1val:0x20000000;  immval:0x4
TEST_IMM_OP( ori, x11, x23, 0x20000004, 0x20000000, 0x4, x2, 36, x9)

inst_10:
// rs1==x14, rd==x17, imm_val == 8, 
// opcode: ori ; op1:x14; dest:x17; op1val:-0x201;  immval:0x8
TEST_IMM_OP( ori, x17, x14, 0xfffffdff, -0x201, 0x8, x2, 40, x9)

inst_11:
// rs1==x31, rd==x7, imm_val == 16, rs1_val == 2
// opcode: ori ; op1:x31; dest:x7; op1val:0x2;  immval:0x10
TEST_IMM_OP( ori, x7, x31, 0x12, 0x2, 0x10, x2, 44, x9)

inst_12:
// rs1==x21, rd==x4, imm_val == 32, rs1_val == 32768
// opcode: ori ; op1:x21; dest:x4; op1val:0x8000;  immval:0x20
TEST_IMM_OP( ori, x4, x21, 0x8020, 0x8000, 0x20, x2, 48, x9)

inst_13:
// rs1==x15, rd==x5, imm_val == 64, rs1_val == 2048
// opcode: ori ; op1:x15; dest:x5; op1val:0x800;  immval:0x40
TEST_IMM_OP( ori, x5, x15, 0x840, 0x800, 0x40, x2, 52, x9)

inst_14:
// rs1==x30, rd==x25, imm_val == 128, rs1_val == -262145
// opcode: ori ; op1:x30; dest:x25; op1val:-0x40001;  immval:0x80
TEST_IMM_OP( ori, x25, x30, 0xfffbffff, -0x40001, 0x80, x2, 56, x9)

inst_15:
// rs1==x11, rd==x30, imm_val == 256, rs1_val == -5
// opcode: ori ; op1:x11; dest:x30; op1val:-0x5;  immval:0x100
TEST_IMM_OP( ori, x30, x11, 0xfffffffb, -0x5, 0x100, x2, 60, x9)

inst_16:
// rs1==x4, rd==x10, imm_val == 512, rs1_val == -524289
// opcode: ori ; op1:x4; dest:x10; op1val:-0x80001;  immval:0x200
TEST_IMM_OP( ori, x10, x4, 0xfff7ffff, -0x80001, 0x200, x2, 64, x9)

inst_17:
// rs1==x13, rd==x0, imm_val == 1024, rs1_val == -1073741825
// opcode: ori ; op1:x13; dest:x0; op1val:-0x40000001;  immval:0x400
TEST_IMM_OP( ori, x0, x13, 0, -0x40000001, 0x400, x2, 68, x9)

inst_18:
// rs1==x26, rd==x6, imm_val == -2, rs1_val == -33
// opcode: ori ; op1:x26; dest:x6; op1val:-0x21;  immval:-0x2
TEST_IMM_OP( ori, x6, x26, 0xffffffff, -0x21, -0x2, x2, 72, x9)

inst_19:
// rs1==x19, rd==x18, imm_val == -3, 
// opcode: ori ; op1:x19; dest:x18; op1val:0xb503;  immval:-0x3
TEST_IMM_OP( ori, x18, x19, 0xffffffff, 0xb503, -0x3, x2, 76, x9)

inst_20:
// rs1==x7, rd==x21, imm_val == -5, rs1_val == 268435456
// opcode: ori ; op1:x7; dest:x21; op1val:0x10000000;  immval:-0x5
TEST_IMM_OP( ori, x21, x7, 0xfffffffb, 0x10000000, -0x5, x2, 80, x5)

inst_21:
// rs1==x24, rd==x16, imm_val == -9, 
// opcode: ori ; op1:x24; dest:x16; op1val:-0x80001;  immval:-0x9
TEST_IMM_OP( ori, x16, x24, 0xffffffff, -0x80001, -0x9, x2, 84, x5)
RVTEST_SIGBASE( x4,signature_x4_0)

inst_22:
// rs1==x0, rd==x9, imm_val == -17, rs1_val == -16385
// opcode: ori ; op1:x0; dest:x9; op1val:0x0;  immval:-0x11
TEST_IMM_OP( ori, x9, x0, 0xffffffef, 0x0, -0x11, x4, 0, x5)

inst_23:
// rs1==x3, rd==x28, imm_val == -33, rs1_val == 8192
// opcode: ori ; op1:x3; dest:x28; op1val:0x2000;  immval:-0x21
TEST_IMM_OP( ori, x28, x3, 0xffffffdf, 0x2000, -0x21, x4, 4, x5)

inst_24:
// rs1==x1, rd==x15, imm_val == -65, 
// opcode: ori ; op1:x1; dest:x15; op1val:0x55555556;  immval:-0x41
TEST_IMM_OP( ori, x15, x1, 0xffffffff, 0x55555556, -0x41, x4, 8, x5)

inst_25:
// rs1==x18, rd==x2, imm_val == -129, 
// opcode: ori ; op1:x18; dest:x2; op1val:-0xb504;  immval:-0x81
TEST_IMM_OP( ori, x2, x18, 0xffffffff, -0xb504, -0x81, x4, 12, x5)

inst_26:
// rs1==x22, rd==x20, imm_val == -257, rs1_val == -1431655766
// opcode: ori ; op1:x22; dest:x20; op1val:-0x55555556;  immval:-0x101
TEST_IMM_OP( ori, x20, x22, 0xfffffeff, -0x55555556, -0x101, x4, 16, x5)

inst_27:
// rs1==x6, rd==x13, imm_val == -513, rs1_val == 16777216
// opcode: ori ; op1:x6; dest:x13; op1val:0x1000000;  immval:-0x201
TEST_IMM_OP( ori, x13, x6, 0xfffffdff, 0x1000000, -0x201, x4, 20, x5)

inst_28:
// rs1==x29, rd==x14, imm_val == -1025, 
// opcode: ori ; op1:x29; dest:x14; op1val:0x20000000;  immval:-0x401
TEST_IMM_OP( ori, x14, x29, 0xfffffbff, 0x20000000, -0x401, x4, 24, x5)

inst_29:
// rs1==x2, rd==x12, imm_val == -1366, rs1_val==-46340 and imm_val==-1366
// opcode: ori ; op1:x2; dest:x12; op1val:-0xb504;  immval:-0x556
TEST_IMM_OP( ori, x12, x2, 0xfffffafe, -0xb504, -0x556, x4, 28, x5)

inst_30:
// rs1==x9, rd==x24, rs1_val == 4, rs1_val==4 and imm_val==5
// opcode: ori ; op1:x9; dest:x24; op1val:0x4;  immval:0x5
TEST_IMM_OP( ori, x24, x9, 0x5, 0x4, 0x5, x4, 32, x5)

inst_31:
// rs1==x10, rd==x29, rs1_val == 8, 
// opcode: ori ; op1:x10; dest:x29; op1val:0x8;  immval:0x6
TEST_IMM_OP( ori, x29, x10, 0xe, 0x8, 0x6, x4, 36, x5)

inst_32:
// rs1_val == 16, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x10;  immval:0x200
TEST_IMM_OP( ori, x11, x10, 0x210, 0x10, 0x200, x4, 40, x5)

inst_33:
// rs1_val == 32, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x20;  immval:0x2c
TEST_IMM_OP( ori, x11, x10, 0x2c, 0x20, 0x2c, x4, 44, x5)

inst_34:
// rs1_val == 64, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x40;  immval:0x3
TEST_IMM_OP( ori, x11, x10, 0x43, 0x40, 0x3, x4, 48, x5)

inst_35:
// rs1_val == 128, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x80;  immval:0x20
TEST_IMM_OP( ori, x11, x10, 0xa0, 0x80, 0x20, x4, 52, x5)

inst_36:
// rs1_val == 256, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x100;  immval:-0x41
TEST_IMM_OP( ori, x11, x10, 0xffffffbf, 0x100, -0x41, x4, 56, x5)

inst_37:
// rs1_val == 512, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x200;  immval:-0x6
TEST_IMM_OP( ori, x11, x10, 0xfffffffa, 0x200, -0x6, x4, 60, x5)

inst_38:
// rs1_val == 1024, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x400;  immval:-0x2d
TEST_IMM_OP( ori, x11, x10, 0xffffffd3, 0x400, -0x2d, x4, 64, x5)

inst_39:
// rs1_val == 4096, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x1000;  immval:0x5
TEST_IMM_OP( ori, x11, x10, 0x1005, 0x1000, 0x5, x4, 68, x5)

inst_40:
// rs1_val == 16384, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x4000;  immval:0x665
TEST_IMM_OP( ori, x11, x10, 0x4665, 0x4000, 0x665, x4, 72, x5)

inst_41:
// rs1_val == 65536, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x10000;  immval:0x9
TEST_IMM_OP( ori, x11, x10, 0x10009, 0x10000, 0x9, x4, 76, x5)

inst_42:
// rs1_val == 131072, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x20000;  immval:0x200
TEST_IMM_OP( ori, x11, x10, 0x20200, 0x20000, 0x200, x4, 80, x5)

inst_43:
// rs1_val == 524288, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x80000;  immval:0x0
TEST_IMM_OP( ori, x11, x10, 0x80000, 0x80000, 0x0, x4, 84, x5)

inst_44:
// rs1_val == 1048576, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x100000;  immval:0x200
TEST_IMM_OP( ori, x11, x10, 0x100200, 0x100000, 0x200, x4, 88, x5)

inst_45:
// rs1_val == 2097152, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x200000;  immval:-0x2c
TEST_IMM_OP( ori, x11, x10, 0xffffffd4, 0x200000, -0x2c, x4, 92, x5)

inst_46:
// rs1_val == 4194304, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x400000;  immval:-0x201
TEST_IMM_OP( ori, x11, x10, 0xfffffdff, 0x400000, -0x201, x4, 96, x5)

inst_47:
// rs1_val == 8388608, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x800000;  immval:0x80
TEST_IMM_OP( ori, x11, x10, 0x800080, 0x800000, 0x80, x4, 100, x5)

inst_48:
// rs1_val == 33554432, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x2000000;  immval:-0x21
TEST_IMM_OP( ori, x11, x10, 0xffffffdf, 0x2000000, -0x21, x4, 104, x5)

inst_49:
// rs1_val == 67108864, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x4000000;  immval:0x10
TEST_IMM_OP( ori, x11, x10, 0x4000010, 0x4000000, 0x10, x4, 108, x5)

inst_50:
// rs1_val == 134217728, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x8000000;  immval:0x554
TEST_IMM_OP( ori, x11, x10, 0x8000554, 0x8000000, 0x554, x4, 112, x5)

inst_51:
// rs1_val == 1073741824, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x40000000;  immval:-0x6
TEST_IMM_OP( ori, x11, x10, 0xfffffffa, 0x40000000, -0x6, x4, 116, x5)

inst_52:
// rs1_val == -2, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x2;  immval:-0x41
TEST_IMM_OP( ori, x11, x10, 0xffffffff, -0x2, -0x41, x4, 120, x5)

inst_53:
// rs1_val == -3, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x3;  immval:-0x9
TEST_IMM_OP( ori, x11, x10, 0xffffffff, -0x3, -0x9, x4, 124, x5)

inst_54:
// rs1_val == -9, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x9;  immval:-0x800
TEST_IMM_OP( ori, x11, x10, 0xfffffff7, -0x9, -0x800, x4, 128, x5)

inst_55:
// rs1_val == -17, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x11;  immval:-0x2d
TEST_IMM_OP( ori, x11, x10, 0xffffffff, -0x11, -0x2d, x4, 132, x5)

inst_56:
// rs1_val == -65, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x41;  immval:-0x556
TEST_IMM_OP( ori, x11, x10, 0xffffffbf, -0x41, -0x556, x4, 136, x5)

inst_57:
// rs1_val == -129, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x81;  immval:0x665
TEST_IMM_OP( ori, x11, x10, 0xffffff7f, -0x81, 0x665, x4, 140, x5)

inst_58:
// rs1_val == -257, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x101;  immval:0x666
TEST_IMM_OP( ori, x11, x10, 0xfffffeff, -0x101, 0x666, x4, 144, x5)

inst_59:
// rs1_val == -1025, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x401;  immval:0x666
TEST_IMM_OP( ori, x11, x10, 0xffffffff, -0x401, 0x666, x4, 148, x5)

inst_60:
// rs1_val == -2049, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x801;  immval:0x7ff
TEST_IMM_OP( ori, x11, x10, 0xfffff7ff, -0x801, 0x7ff, x4, 152, x5)

inst_61:
// rs1_val == -4097, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x1001;  immval:0x7
TEST_IMM_OP( ori, x11, x10, 0xffffefff, -0x1001, 0x7, x4, 156, x5)

inst_62:
// rs1_val == -8193, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x2001;  immval:-0x21
TEST_IMM_OP( ori, x11, x10, 0xffffffff, -0x2001, -0x21, x4, 160, x5)

inst_63:
// rs1_val == -32769, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x8001;  immval:0x2d
TEST_IMM_OP( ori, x11, x10, 0xffff7fff, -0x8001, 0x2d, x4, 164, x5)

inst_64:
// rs1_val == -65537, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x10001;  immval:0x332
TEST_IMM_OP( ori, x11, x10, 0xfffeffff, -0x10001, 0x332, x4, 168, x5)

inst_65:
// rs1_val == -131073, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x20001;  immval:-0xa
TEST_IMM_OP( ori, x11, x10, 0xffffffff, -0x20001, -0xa, x4, 172, x5)

inst_66:
// rs1_val == -1048577, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x100001;  immval:0x6
TEST_IMM_OP( ori, x11, x10, 0xffefffff, -0x100001, 0x6, x4, 176, x5)

inst_67:
// rs1_val == -2097153, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x200001;  immval:-0x400
TEST_IMM_OP( ori, x11, x10, 0xffffffff, -0x200001, -0x400, x4, 180, x5)

inst_68:
// rs1_val == -4194305, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x400001;  immval:-0x2c
TEST_IMM_OP( ori, x11, x10, 0xffffffff, -0x400001, -0x2c, x4, 184, x5)

inst_69:
// rs1_val == -8388609, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x800001;  immval:-0xa
TEST_IMM_OP( ori, x11, x10, 0xffffffff, -0x800001, -0xa, x4, 188, x5)

inst_70:
// rs1_val == -16777217, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x1000001;  immval:0x3ff
TEST_IMM_OP( ori, x11, x10, 0xfeffffff, -0x1000001, 0x3ff, x4, 192, x5)

inst_71:
// rs1_val == -33554433, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x2000001;  immval:-0x8
TEST_IMM_OP( ori, x11, x10, 0xffffffff, -0x2000001, -0x8, x4, 196, x5)

inst_72:
// rs1_val == -67108865, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x4000001;  immval:0x4
TEST_IMM_OP( ori, x11, x10, 0xfbffffff, -0x4000001, 0x4, x4, 200, x5)

inst_73:
// rs1_val == -134217729, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x8000001;  immval:-0x6
TEST_IMM_OP( ori, x11, x10, 0xffffffff, -0x8000001, -0x6, x4, 204, x5)

inst_74:
// rs1_val == -268435457, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x10000001;  immval:-0x7
TEST_IMM_OP( ori, x11, x10, 0xffffffff, -0x10000001, -0x7, x4, 208, x5)

inst_75:
// rs1_val == -536870913, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x20000001;  immval:0x554
TEST_IMM_OP( ori, x11, x10, 0xdfffffff, -0x20000001, 0x554, x4, 212, x5)

inst_76:
// rs1_val == 1431655765, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555555;  immval:-0x101
TEST_IMM_OP( ori, x11, x10, 0xffffffff, 0x55555555, -0x101, x4, 216, x5)

inst_77:
// rs1_val==3 and imm_val==3, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x3;  immval:0x3
TEST_IMM_OP( ori, x11, x10, 0x3, 0x3, 0x3, x4, 220, x5)

inst_78:
// rs1_val==3 and imm_val==1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x3;  immval:0x555
TEST_IMM_OP( ori, x11, x10, 0x557, 0x3, 0x555, x4, 224, x5)

inst_79:
// rs1_val==3 and imm_val==-1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x3;  immval:-0x556
TEST_IMM_OP( ori, x11, x10, 0xfffffaab, 0x3, -0x556, x4, 228, x5)

inst_80:
// rs1_val==3 and imm_val==5, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x3;  immval:0x5
TEST_IMM_OP( ori, x11, x10, 0x7, 0x3, 0x5, x4, 232, x5)

inst_81:
// rs1_val==3 and imm_val==819, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x3;  immval:0x333
TEST_IMM_OP( ori, x11, x10, 0x333, 0x3, 0x333, x4, 236, x5)

inst_82:
// rs1_val==3 and imm_val==1638, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x3;  immval:0x666
TEST_IMM_OP( ori, x11, x10, 0x667, 0x3, 0x666, x4, 240, x5)

inst_83:
// rs1_val==3 and imm_val==-45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x3;  immval:-0x2d
TEST_IMM_OP( ori, x11, x10, 0xffffffd3, 0x3, -0x2d, x4, 244, x5)

inst_84:
// rs1_val==3 and imm_val==45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x3;  immval:0x2d
TEST_IMM_OP( ori, x11, x10, 0x2f, 0x3, 0x2d, x4, 248, x5)

inst_85:
// rs1_val==3 and imm_val==2, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x3;  immval:0x2
TEST_IMM_OP( ori, x11, x10, 0x3, 0x3, 0x2, x4, 252, x5)

inst_86:
// rs1_val==3 and imm_val==1364, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x3;  immval:0x554
TEST_IMM_OP( ori, x11, x10, 0x557, 0x3, 0x554, x4, 256, x5)

inst_87:
// rs1_val==3 and imm_val==0, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x3;  immval:0x0
TEST_IMM_OP( ori, x11, x10, 0x3, 0x3, 0x0, x4, 260, x5)

inst_88:
// rs1_val==3 and imm_val==4, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x3;  immval:0x4
TEST_IMM_OP( ori, x11, x10, 0x7, 0x3, 0x4, x4, 264, x5)

inst_89:
// rs1_val==3 and imm_val==818, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x3;  immval:0x332
TEST_IMM_OP( ori, x11, x10, 0x333, 0x3, 0x332, x4, 268, x5)

inst_90:
// rs1_val==3 and imm_val==1637, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x3;  immval:0x665
TEST_IMM_OP( ori, x11, x10, 0x667, 0x3, 0x665, x4, 272, x5)

inst_91:
// rs1_val==3 and imm_val==44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x3;  immval:0x2c
TEST_IMM_OP( ori, x11, x10, 0x2f, 0x3, 0x2c, x4, 276, x5)

inst_92:
// rs1_val==3 and imm_val==1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x3;  immval:0x556
TEST_IMM_OP( ori, x11, x10, 0x557, 0x3, 0x556, x4, 280, x5)

inst_93:
// rs1_val==3 and imm_val==-1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x3;  immval:-0x555
TEST_IMM_OP( ori, x11, x10, 0xfffffaab, 0x3, -0x555, x4, 284, x5)

inst_94:
// rs1_val==3 and imm_val==6, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x3;  immval:0x6
TEST_IMM_OP( ori, x11, x10, 0x7, 0x3, 0x6, x4, 288, x5)

inst_95:
// rs1_val==3 and imm_val==820, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x3;  immval:0x334
TEST_IMM_OP( ori, x11, x10, 0x337, 0x3, 0x334, x4, 292, x5)

inst_96:
// rs1_val==3 and imm_val==1639, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x3;  immval:0x667
TEST_IMM_OP( ori, x11, x10, 0x667, 0x3, 0x667, x4, 296, x5)

inst_97:
// rs1_val==3 and imm_val==-44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x3;  immval:-0x2c
TEST_IMM_OP( ori, x11, x10, 0xffffffd7, 0x3, -0x2c, x4, 300, x5)

inst_98:
// rs1_val==3 and imm_val==46, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x3;  immval:0x2e
TEST_IMM_OP( ori, x11, x10, 0x2f, 0x3, 0x2e, x4, 304, x5)

inst_99:
// rs1_val==1431655765 and imm_val==3, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555555;  immval:0x3
TEST_IMM_OP( ori, x11, x10, 0x55555557, 0x55555555, 0x3, x4, 308, x5)

inst_100:
// rs1_val==1431655765 and imm_val==1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555555;  immval:0x555
TEST_IMM_OP( ori, x11, x10, 0x55555555, 0x55555555, 0x555, x4, 312, x5)

inst_101:
// rs1_val==1431655765 and imm_val==-1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555555;  immval:-0x556
TEST_IMM_OP( ori, x11, x10, 0xffffffff, 0x55555555, -0x556, x4, 316, x5)

inst_102:
// rs1_val==1431655765 and imm_val==5, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555555;  immval:0x5
TEST_IMM_OP( ori, x11, x10, 0x55555555, 0x55555555, 0x5, x4, 320, x5)

inst_103:
// rs1_val==1431655765 and imm_val==819, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555555;  immval:0x333
TEST_IMM_OP( ori, x11, x10, 0x55555777, 0x55555555, 0x333, x4, 324, x5)

inst_104:
// rs1_val==1431655765 and imm_val==1638, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555555;  immval:0x666
TEST_IMM_OP( ori, x11, x10, 0x55555777, 0x55555555, 0x666, x4, 328, x5)

inst_105:
// rs1_val==1431655765 and imm_val==-45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555555;  immval:-0x2d
TEST_IMM_OP( ori, x11, x10, 0xffffffd7, 0x55555555, -0x2d, x4, 332, x5)

inst_106:
// rs1_val==1431655765 and imm_val==45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555555;  immval:0x2d
TEST_IMM_OP( ori, x11, x10, 0x5555557d, 0x55555555, 0x2d, x4, 336, x5)

inst_107:
// rs1_val==1431655765 and imm_val==2, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555555;  immval:0x2
TEST_IMM_OP( ori, x11, x10, 0x55555557, 0x55555555, 0x2, x4, 340, x5)

inst_108:
// rs1_val==1431655765 and imm_val==1364, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555555;  immval:0x554
TEST_IMM_OP( ori, x11, x10, 0x55555555, 0x55555555, 0x554, x4, 344, x5)

inst_109:
// rs1_val==1431655765 and imm_val==0, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555555;  immval:0x0
TEST_IMM_OP( ori, x11, x10, 0x55555555, 0x55555555, 0x0, x4, 348, x5)

inst_110:
// rs1_val==1431655765 and imm_val==4, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555555;  immval:0x4
TEST_IMM_OP( ori, x11, x10, 0x55555555, 0x55555555, 0x4, x4, 352, x5)

inst_111:
// rs1_val==1431655765 and imm_val==818, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555555;  immval:0x332
TEST_IMM_OP( ori, x11, x10, 0x55555777, 0x55555555, 0x332, x4, 356, x5)

inst_112:
// rs1_val==1431655765 and imm_val==1637, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555555;  immval:0x665
TEST_IMM_OP( ori, x11, x10, 0x55555775, 0x55555555, 0x665, x4, 360, x5)

inst_113:
// rs1_val==1431655765 and imm_val==44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555555;  immval:0x2c
TEST_IMM_OP( ori, x11, x10, 0x5555557d, 0x55555555, 0x2c, x4, 364, x5)

inst_114:
// rs1_val==1431655765 and imm_val==1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555555;  immval:0x556
TEST_IMM_OP( ori, x11, x10, 0x55555557, 0x55555555, 0x556, x4, 368, x5)

inst_115:
// rs1_val==1431655765 and imm_val==-1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555555;  immval:-0x555
TEST_IMM_OP( ori, x11, x10, 0xffffffff, 0x55555555, -0x555, x4, 372, x5)

inst_116:
// rs1_val==1431655765 and imm_val==6, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555555;  immval:0x6
TEST_IMM_OP( ori, x11, x10, 0x55555557, 0x55555555, 0x6, x4, 376, x5)

inst_117:
// rs1_val==1431655765 and imm_val==820, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555555;  immval:0x334
TEST_IMM_OP( ori, x11, x10, 0x55555775, 0x55555555, 0x334, x4, 380, x5)

inst_118:
// rs1_val==1431655765 and imm_val==1639, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555555;  immval:0x667
TEST_IMM_OP( ori, x11, x10, 0x55555777, 0x55555555, 0x667, x4, 384, x5)

inst_119:
// rs1_val==1431655765 and imm_val==-44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555555;  immval:-0x2c
TEST_IMM_OP( ori, x11, x10, 0xffffffd5, 0x55555555, -0x2c, x4, 388, x5)

inst_120:
// rs1_val==1431655765 and imm_val==46, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555555;  immval:0x2e
TEST_IMM_OP( ori, x11, x10, 0x5555557f, 0x55555555, 0x2e, x4, 392, x5)

inst_121:
// rs1_val==-1431655766 and imm_val==3, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555556;  immval:0x3
TEST_IMM_OP( ori, x11, x10, 0xaaaaaaab, -0x55555556, 0x3, x4, 396, x5)

inst_122:
// rs1_val==-1431655766 and imm_val==1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555556;  immval:0x555
TEST_IMM_OP( ori, x11, x10, 0xaaaaafff, -0x55555556, 0x555, x4, 400, x5)

inst_123:
// rs1_val==-1431655766 and imm_val==-1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555556;  immval:-0x556
TEST_IMM_OP( ori, x11, x10, 0xfffffaaa, -0x55555556, -0x556, x4, 404, x5)

inst_124:
// rs1_val==-1431655766 and imm_val==5, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555556;  immval:0x5
TEST_IMM_OP( ori, x11, x10, 0xaaaaaaaf, -0x55555556, 0x5, x4, 408, x5)

inst_125:
// rs1_val==-1431655766 and imm_val==819, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555556;  immval:0x333
TEST_IMM_OP( ori, x11, x10, 0xaaaaabbb, -0x55555556, 0x333, x4, 412, x5)

inst_126:
// rs1_val==-1431655766 and imm_val==1638, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555556;  immval:0x666
TEST_IMM_OP( ori, x11, x10, 0xaaaaaeee, -0x55555556, 0x666, x4, 416, x5)

inst_127:
// rs1_val==-1431655766 and imm_val==-45, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555556;  immval:-0x2d
TEST_IMM_OP( ori, x11, x10, 0xfffffffb, -0x55555556, -0x2d, x4, 420, x5)

inst_128:
// rs1_val==-1431655766 and imm_val==45, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555556;  immval:0x2d
TEST_IMM_OP( ori, x11, x10, 0xaaaaaaaf, -0x55555556, 0x2d, x4, 424, x5)

inst_129:
// rs1_val==-1431655766 and imm_val==2, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555556;  immval:0x2
TEST_IMM_OP( ori, x11, x10, 0xaaaaaaaa, -0x55555556, 0x2, x4, 428, x5)

inst_130:
// rs1_val==-1431655766 and imm_val==1364, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555556;  immval:0x554
TEST_IMM_OP( ori, x11, x10, 0xaaaaaffe, -0x55555556, 0x554, x4, 432, x5)

inst_131:
// rs1_val==-1431655766 and imm_val==0, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555556;  immval:0x0
TEST_IMM_OP( ori, x11, x10, 0xaaaaaaaa, -0x55555556, 0x0, x4, 436, x5)

inst_132:
// rs1_val==-1431655766 and imm_val==4, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555556;  immval:0x4
TEST_IMM_OP( ori, x11, x10, 0xaaaaaaae, -0x55555556, 0x4, x4, 440, x5)

inst_133:
// rs1_val==-1431655766 and imm_val==818, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555556;  immval:0x332
TEST_IMM_OP( ori, x11, x10, 0xaaaaabba, -0x55555556, 0x332, x4, 444, x5)

inst_134:
// rs1_val==-1431655766 and imm_val==1637, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555556;  immval:0x665
TEST_IMM_OP( ori, x11, x10, 0xaaaaaeef, -0x55555556, 0x665, x4, 448, x5)

inst_135:
// rs1_val==-1431655766 and imm_val==44, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555556;  immval:0x2c
TEST_IMM_OP( ori, x11, x10, 0xaaaaaaae, -0x55555556, 0x2c, x4, 452, x5)

inst_136:
// rs1_val==-1431655766 and imm_val==1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555556;  immval:0x556
TEST_IMM_OP( ori, x11, x10, 0xaaaaaffe, -0x55555556, 0x556, x4, 456, x5)

inst_137:
// rs1_val==-1431655766 and imm_val==-1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555556;  immval:-0x555
TEST_IMM_OP( ori, x11, x10, 0xfffffaab, -0x55555556, -0x555, x4, 460, x5)

inst_138:
// rs1_val==-1431655766 and imm_val==6, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555556;  immval:0x6
TEST_IMM_OP( ori, x11, x10, 0xaaaaaaae, -0x55555556, 0x6, x4, 464, x5)

inst_139:
// rs1_val==-1431655766 and imm_val==820, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555556;  immval:0x334
TEST_IMM_OP( ori, x11, x10, 0xaaaaabbe, -0x55555556, 0x334, x4, 468, x5)

inst_140:
// rs1_val==-1431655766 and imm_val==1639, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555556;  immval:0x667
TEST_IMM_OP( ori, x11, x10, 0xaaaaaeef, -0x55555556, 0x667, x4, 472, x5)

inst_141:
// rs1_val==-1431655766 and imm_val==-44, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555556;  immval:-0x2c
TEST_IMM_OP( ori, x11, x10, 0xfffffffe, -0x55555556, -0x2c, x4, 476, x5)

inst_142:
// rs1_val==-1431655766 and imm_val==46, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555556;  immval:0x2e
TEST_IMM_OP( ori, x11, x10, 0xaaaaaaae, -0x55555556, 0x2e, x4, 480, x5)

inst_143:
// rs1_val==5 and imm_val==3, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x5;  immval:0x3
TEST_IMM_OP( ori, x11, x10, 0x7, 0x5, 0x3, x4, 484, x5)

inst_144:
// rs1_val==5 and imm_val==1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x5;  immval:0x555
TEST_IMM_OP( ori, x11, x10, 0x555, 0x5, 0x555, x4, 488, x5)

inst_145:
// rs1_val==5 and imm_val==-1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x5;  immval:-0x556
TEST_IMM_OP( ori, x11, x10, 0xfffffaaf, 0x5, -0x556, x4, 492, x5)

inst_146:
// rs1_val==5 and imm_val==5, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x5;  immval:0x5
TEST_IMM_OP( ori, x11, x10, 0x5, 0x5, 0x5, x4, 496, x5)

inst_147:
// rs1_val==5 and imm_val==819, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x5;  immval:0x333
TEST_IMM_OP( ori, x11, x10, 0x337, 0x5, 0x333, x4, 500, x5)

inst_148:
// rs1_val==5 and imm_val==1638, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x5;  immval:0x666
TEST_IMM_OP( ori, x11, x10, 0x667, 0x5, 0x666, x4, 504, x5)

inst_149:
// rs1_val==5 and imm_val==-45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x5;  immval:-0x2d
TEST_IMM_OP( ori, x11, x10, 0xffffffd7, 0x5, -0x2d, x4, 508, x5)

inst_150:
// rs1_val==5 and imm_val==45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x5;  immval:0x2d
TEST_IMM_OP( ori, x11, x10, 0x2d, 0x5, 0x2d, x4, 512, x5)

inst_151:
// rs1_val==5 and imm_val==2, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x5;  immval:0x2
TEST_IMM_OP( ori, x11, x10, 0x7, 0x5, 0x2, x4, 516, x5)

inst_152:
// rs1_val==5 and imm_val==1364, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x5;  immval:0x554
TEST_IMM_OP( ori, x11, x10, 0x555, 0x5, 0x554, x4, 520, x5)

inst_153:
// rs1_val==5 and imm_val==0, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x5;  immval:0x0
TEST_IMM_OP( ori, x11, x10, 0x5, 0x5, 0x0, x4, 524, x5)

inst_154:
// rs1_val==5 and imm_val==4, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x5;  immval:0x4
TEST_IMM_OP( ori, x11, x10, 0x5, 0x5, 0x4, x4, 528, x5)

inst_155:
// rs1_val==5 and imm_val==818, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x5;  immval:0x332
TEST_IMM_OP( ori, x11, x10, 0x337, 0x5, 0x332, x4, 532, x5)

inst_156:
// rs1_val==5 and imm_val==1637, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x5;  immval:0x665
TEST_IMM_OP( ori, x11, x10, 0x665, 0x5, 0x665, x4, 536, x5)

inst_157:
// rs1_val==5 and imm_val==44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x5;  immval:0x2c
TEST_IMM_OP( ori, x11, x10, 0x2d, 0x5, 0x2c, x4, 540, x5)

inst_158:
// rs1_val==5 and imm_val==1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x5;  immval:0x556
TEST_IMM_OP( ori, x11, x10, 0x557, 0x5, 0x556, x4, 544, x5)

inst_159:
// rs1_val==5 and imm_val==-1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x5;  immval:-0x555
TEST_IMM_OP( ori, x11, x10, 0xfffffaaf, 0x5, -0x555, x4, 548, x5)

inst_160:
// rs1_val==5 and imm_val==6, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x5;  immval:0x6
TEST_IMM_OP( ori, x11, x10, 0x7, 0x5, 0x6, x4, 552, x5)

inst_161:
// rs1_val==5 and imm_val==820, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x5;  immval:0x334
TEST_IMM_OP( ori, x11, x10, 0x335, 0x5, 0x334, x4, 556, x5)

inst_162:
// rs1_val==5 and imm_val==1639, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x5;  immval:0x667
TEST_IMM_OP( ori, x11, x10, 0x667, 0x5, 0x667, x4, 560, x5)

inst_163:
// rs1_val==5 and imm_val==-44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x5;  immval:-0x2c
TEST_IMM_OP( ori, x11, x10, 0xffffffd5, 0x5, -0x2c, x4, 564, x5)

inst_164:
// rs1_val==5 and imm_val==46, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x5;  immval:0x2e
TEST_IMM_OP( ori, x11, x10, 0x2f, 0x5, 0x2e, x4, 568, x5)

inst_165:
// rs1_val==858993459 and imm_val==3, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333333;  immval:0x3
TEST_IMM_OP( ori, x11, x10, 0x33333333, 0x33333333, 0x3, x4, 572, x5)

inst_166:
// rs1_val==858993459 and imm_val==1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333333;  immval:0x555
TEST_IMM_OP( ori, x11, x10, 0x33333777, 0x33333333, 0x555, x4, 576, x5)

inst_167:
// rs1_val==858993459 and imm_val==-1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333333;  immval:-0x556
TEST_IMM_OP( ori, x11, x10, 0xfffffbbb, 0x33333333, -0x556, x4, 580, x5)

inst_168:
// rs1_val==858993459 and imm_val==5, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333333;  immval:0x5
TEST_IMM_OP( ori, x11, x10, 0x33333337, 0x33333333, 0x5, x4, 584, x5)

inst_169:
// rs1_val==858993459 and imm_val==819, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333333;  immval:0x333
TEST_IMM_OP( ori, x11, x10, 0x33333333, 0x33333333, 0x333, x4, 588, x5)

inst_170:
// rs1_val==858993459 and imm_val==1638, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333333;  immval:0x666
TEST_IMM_OP( ori, x11, x10, 0x33333777, 0x33333333, 0x666, x4, 592, x5)

inst_171:
// rs1_val==858993459 and imm_val==-45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333333;  immval:-0x2d
TEST_IMM_OP( ori, x11, x10, 0xfffffff3, 0x33333333, -0x2d, x4, 596, x5)

inst_172:
// rs1_val==858993459 and imm_val==45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333333;  immval:0x2d
TEST_IMM_OP( ori, x11, x10, 0x3333333f, 0x33333333, 0x2d, x4, 600, x5)

inst_173:
// rs1_val==858993459 and imm_val==2, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333333;  immval:0x2
TEST_IMM_OP( ori, x11, x10, 0x33333333, 0x33333333, 0x2, x4, 604, x5)

inst_174:
// rs1_val==858993459 and imm_val==1364, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333333;  immval:0x554
TEST_IMM_OP( ori, x11, x10, 0x33333777, 0x33333333, 0x554, x4, 608, x5)

inst_175:
// rs1_val==858993459 and imm_val==0, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333333;  immval:0x0
TEST_IMM_OP( ori, x11, x10, 0x33333333, 0x33333333, 0x0, x4, 612, x5)

inst_176:
// rs1_val==858993459 and imm_val==4, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333333;  immval:0x4
TEST_IMM_OP( ori, x11, x10, 0x33333337, 0x33333333, 0x4, x4, 616, x5)

inst_177:
// rs1_val==858993459 and imm_val==818, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333333;  immval:0x332
TEST_IMM_OP( ori, x11, x10, 0x33333333, 0x33333333, 0x332, x4, 620, x5)

inst_178:
// rs1_val==858993459 and imm_val==1637, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333333;  immval:0x665
TEST_IMM_OP( ori, x11, x10, 0x33333777, 0x33333333, 0x665, x4, 624, x5)

inst_179:
// rs1_val==858993459 and imm_val==44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333333;  immval:0x2c
TEST_IMM_OP( ori, x11, x10, 0x3333333f, 0x33333333, 0x2c, x4, 628, x5)

inst_180:
// rs1_val==858993459 and imm_val==1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333333;  immval:0x556
TEST_IMM_OP( ori, x11, x10, 0x33333777, 0x33333333, 0x556, x4, 632, x5)

inst_181:
// rs1_val==858993459 and imm_val==-1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333333;  immval:-0x555
TEST_IMM_OP( ori, x11, x10, 0xfffffbbb, 0x33333333, -0x555, x4, 636, x5)

inst_182:
// rs1_val==858993459 and imm_val==6, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333333;  immval:0x6
TEST_IMM_OP( ori, x11, x10, 0x33333337, 0x33333333, 0x6, x4, 640, x5)

inst_183:
// rs1_val==858993459 and imm_val==820, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333333;  immval:0x334
TEST_IMM_OP( ori, x11, x10, 0x33333337, 0x33333333, 0x334, x4, 644, x5)

inst_184:
// rs1_val==858993459 and imm_val==1639, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333333;  immval:0x667
TEST_IMM_OP( ori, x11, x10, 0x33333777, 0x33333333, 0x667, x4, 648, x5)

inst_185:
// rs1_val==858993459 and imm_val==-44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333333;  immval:-0x2c
TEST_IMM_OP( ori, x11, x10, 0xfffffff7, 0x33333333, -0x2c, x4, 652, x5)

inst_186:
// rs1_val==858993459 and imm_val==46, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333333;  immval:0x2e
TEST_IMM_OP( ori, x11, x10, 0x3333333f, 0x33333333, 0x2e, x4, 656, x5)

inst_187:
// rs1_val==1717986918 and imm_val==3, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666666;  immval:0x3
TEST_IMM_OP( ori, x11, x10, 0x66666667, 0x66666666, 0x3, x4, 660, x5)

inst_188:
// rs1_val==1717986918 and imm_val==1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666666;  immval:0x555
TEST_IMM_OP( ori, x11, x10, 0x66666777, 0x66666666, 0x555, x4, 664, x5)

inst_189:
// rs1_val==1717986918 and imm_val==-1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666666;  immval:-0x556
TEST_IMM_OP( ori, x11, x10, 0xfffffeee, 0x66666666, -0x556, x4, 668, x5)

inst_190:
// rs1_val==1717986918 and imm_val==5, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666666;  immval:0x5
TEST_IMM_OP( ori, x11, x10, 0x66666667, 0x66666666, 0x5, x4, 672, x5)

inst_191:
// rs1_val==1717986918 and imm_val==819, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666666;  immval:0x333
TEST_IMM_OP( ori, x11, x10, 0x66666777, 0x66666666, 0x333, x4, 676, x5)

inst_192:
// rs1_val==1717986918 and imm_val==1638, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666666;  immval:0x666
TEST_IMM_OP( ori, x11, x10, 0x66666666, 0x66666666, 0x666, x4, 680, x5)

inst_193:
// rs1_val==1717986918 and imm_val==-45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666666;  immval:-0x2d
TEST_IMM_OP( ori, x11, x10, 0xfffffff7, 0x66666666, -0x2d, x4, 684, x5)

inst_194:
// rs1_val==1717986918 and imm_val==45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666666;  immval:0x2d
TEST_IMM_OP( ori, x11, x10, 0x6666666f, 0x66666666, 0x2d, x4, 688, x5)

inst_195:
// rs1_val==1717986918 and imm_val==2, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666666;  immval:0x2
TEST_IMM_OP( ori, x11, x10, 0x66666666, 0x66666666, 0x2, x4, 692, x5)

inst_196:
// rs1_val==1717986918 and imm_val==1364, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666666;  immval:0x554
TEST_IMM_OP( ori, x11, x10, 0x66666776, 0x66666666, 0x554, x4, 696, x5)

inst_197:
// rs1_val==1717986918 and imm_val==0, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666666;  immval:0x0
TEST_IMM_OP( ori, x11, x10, 0x66666666, 0x66666666, 0x0, x4, 700, x5)

inst_198:
// rs1_val==1717986918 and imm_val==4, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666666;  immval:0x4
TEST_IMM_OP( ori, x11, x10, 0x66666666, 0x66666666, 0x4, x4, 704, x5)

inst_199:
// rs1_val==1717986918 and imm_val==818, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666666;  immval:0x332
TEST_IMM_OP( ori, x11, x10, 0x66666776, 0x66666666, 0x332, x4, 708, x5)

inst_200:
// rs1_val==1717986918 and imm_val==1637, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666666;  immval:0x665
TEST_IMM_OP( ori, x11, x10, 0x66666667, 0x66666666, 0x665, x4, 712, x5)

inst_201:
// rs1_val==1717986918 and imm_val==44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666666;  immval:0x2c
TEST_IMM_OP( ori, x11, x10, 0x6666666e, 0x66666666, 0x2c, x4, 716, x5)

inst_202:
// rs1_val==1717986918 and imm_val==1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666666;  immval:0x556
TEST_IMM_OP( ori, x11, x10, 0x66666776, 0x66666666, 0x556, x4, 720, x5)

inst_203:
// rs1_val==1717986918 and imm_val==-1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666666;  immval:-0x555
TEST_IMM_OP( ori, x11, x10, 0xfffffeef, 0x66666666, -0x555, x4, 724, x5)

inst_204:
// rs1_val==1717986918 and imm_val==6, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666666;  immval:0x6
TEST_IMM_OP( ori, x11, x10, 0x66666666, 0x66666666, 0x6, x4, 728, x5)

inst_205:
// rs1_val==1717986918 and imm_val==820, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666666;  immval:0x334
TEST_IMM_OP( ori, x11, x10, 0x66666776, 0x66666666, 0x334, x4, 732, x5)

inst_206:
// rs1_val==1717986918 and imm_val==1639, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666666;  immval:0x667
TEST_IMM_OP( ori, x11, x10, 0x66666667, 0x66666666, 0x667, x4, 736, x5)

inst_207:
// rs1_val==1717986918 and imm_val==-44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666666;  immval:-0x2c
TEST_IMM_OP( ori, x11, x10, 0xfffffff6, 0x66666666, -0x2c, x4, 740, x5)

inst_208:
// rs1_val==1717986918 and imm_val==46, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666666;  immval:0x2e
TEST_IMM_OP( ori, x11, x10, 0x6666666e, 0x66666666, 0x2e, x4, 744, x5)

inst_209:
// rs1_val==-46340 and imm_val==3, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb504;  immval:0x3
TEST_IMM_OP( ori, x11, x10, 0xffff4aff, -0xb504, 0x3, x4, 748, x5)

inst_210:
// rs1_val==-46340 and imm_val==1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb504;  immval:0x555
TEST_IMM_OP( ori, x11, x10, 0xffff4ffd, -0xb504, 0x555, x4, 752, x5)

inst_211:
// rs1_val==-46340 and imm_val==5, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb504;  immval:0x5
TEST_IMM_OP( ori, x11, x10, 0xffff4afd, -0xb504, 0x5, x4, 756, x5)

inst_212:
// rs1_val==-46340 and imm_val==819, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb504;  immval:0x333
TEST_IMM_OP( ori, x11, x10, 0xffff4bff, -0xb504, 0x333, x4, 760, x5)

inst_213:
// rs1_val==-46340 and imm_val==1638, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb504;  immval:0x666
TEST_IMM_OP( ori, x11, x10, 0xffff4efe, -0xb504, 0x666, x4, 764, x5)

inst_214:
// rs1_val==-46340 and imm_val==-45, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb504;  immval:-0x2d
TEST_IMM_OP( ori, x11, x10, 0xffffffff, -0xb504, -0x2d, x4, 768, x5)

inst_215:
// rs1_val==-46340 and imm_val==45, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb504;  immval:0x2d
TEST_IMM_OP( ori, x11, x10, 0xffff4afd, -0xb504, 0x2d, x4, 772, x5)

inst_216:
// rs1_val==-46340 and imm_val==2, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb504;  immval:0x2
TEST_IMM_OP( ori, x11, x10, 0xffff4afe, -0xb504, 0x2, x4, 776, x5)

inst_217:
// rs1_val==-46340 and imm_val==1364, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb504;  immval:0x554
TEST_IMM_OP( ori, x11, x10, 0xffff4ffc, -0xb504, 0x554, x4, 780, x5)

inst_218:
// rs1_val==-46340 and imm_val==0, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb504;  immval:0x0
TEST_IMM_OP( ori, x11, x10, 0xffff4afc, -0xb504, 0x0, x4, 784, x5)

inst_219:
// rs1_val==-46340 and imm_val==4, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb504;  immval:0x4
TEST_IMM_OP( ori, x11, x10, 0xffff4afc, -0xb504, 0x4, x4, 788, x5)

inst_220:
// rs1_val==-46340 and imm_val==818, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb504;  immval:0x332
TEST_IMM_OP( ori, x11, x10, 0xffff4bfe, -0xb504, 0x332, x4, 792, x5)

inst_221:
// rs1_val==-46340 and imm_val==1637, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb504;  immval:0x665
TEST_IMM_OP( ori, x11, x10, 0xffff4efd, -0xb504, 0x665, x4, 796, x5)

inst_222:
// rs1_val==-46340 and imm_val==44, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb504;  immval:0x2c
TEST_IMM_OP( ori, x11, x10, 0xffff4afc, -0xb504, 0x2c, x4, 800, x5)

inst_223:
// rs1_val==-46340 and imm_val==1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb504;  immval:0x556
TEST_IMM_OP( ori, x11, x10, 0xffff4ffe, -0xb504, 0x556, x4, 804, x5)

inst_224:
// rs1_val==-46340 and imm_val==-1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb504;  immval:-0x555
TEST_IMM_OP( ori, x11, x10, 0xfffffaff, -0xb504, -0x555, x4, 808, x5)

inst_225:
// rs1_val==-46340 and imm_val==6, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb504;  immval:0x6
TEST_IMM_OP( ori, x11, x10, 0xffff4afe, -0xb504, 0x6, x4, 812, x5)

inst_226:
// rs1_val==-46340 and imm_val==820, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb504;  immval:0x334
TEST_IMM_OP( ori, x11, x10, 0xffff4bfc, -0xb504, 0x334, x4, 816, x5)

inst_227:
// rs1_val==-46340 and imm_val==1639, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb504;  immval:0x667
TEST_IMM_OP( ori, x11, x10, 0xffff4eff, -0xb504, 0x667, x4, 820, x5)

inst_228:
// rs1_val==-46340 and imm_val==-44, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb504;  immval:-0x2c
TEST_IMM_OP( ori, x11, x10, 0xfffffffc, -0xb504, -0x2c, x4, 824, x5)

inst_229:
// rs1_val==-46340 and imm_val==46, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb504;  immval:0x2e
TEST_IMM_OP( ori, x11, x10, 0xffff4afe, -0xb504, 0x2e, x4, 828, x5)

inst_230:
// rs1_val==46340 and imm_val==3, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb504;  immval:0x3
TEST_IMM_OP( ori, x11, x10, 0xb507, 0xb504, 0x3, x4, 832, x5)

inst_231:
// rs1_val==46340 and imm_val==1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb504;  immval:0x555
TEST_IMM_OP( ori, x11, x10, 0xb555, 0xb504, 0x555, x4, 836, x5)

inst_232:
// rs1_val==46340 and imm_val==-1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb504;  immval:-0x556
TEST_IMM_OP( ori, x11, x10, 0xffffffae, 0xb504, -0x556, x4, 840, x5)

inst_233:
// rs1_val==46340 and imm_val==5, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb504;  immval:0x5
TEST_IMM_OP( ori, x11, x10, 0xb505, 0xb504, 0x5, x4, 844, x5)

inst_234:
// rs1_val==46340 and imm_val==819, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb504;  immval:0x333
TEST_IMM_OP( ori, x11, x10, 0xb737, 0xb504, 0x333, x4, 848, x5)

inst_235:
// rs1_val==46340 and imm_val==1638, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb504;  immval:0x666
TEST_IMM_OP( ori, x11, x10, 0xb766, 0xb504, 0x666, x4, 852, x5)

inst_236:
// rs1_val==46340 and imm_val==-45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb504;  immval:-0x2d
TEST_IMM_OP( ori, x11, x10, 0xffffffd7, 0xb504, -0x2d, x4, 856, x5)

inst_237:
// rs1_val==46340 and imm_val==45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb504;  immval:0x2d
TEST_IMM_OP( ori, x11, x10, 0xb52d, 0xb504, 0x2d, x4, 860, x5)

inst_238:
// rs1_val==46340 and imm_val==2, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb504;  immval:0x2
TEST_IMM_OP( ori, x11, x10, 0xb506, 0xb504, 0x2, x4, 864, x5)

inst_239:
// rs1_val==46340 and imm_val==1364, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb504;  immval:0x554
TEST_IMM_OP( ori, x11, x10, 0xb554, 0xb504, 0x554, x4, 868, x5)

inst_240:
// rs1_val==46340 and imm_val==0, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb504;  immval:0x0
TEST_IMM_OP( ori, x11, x10, 0xb504, 0xb504, 0x0, x4, 872, x5)

inst_241:
// rs1_val==46340 and imm_val==4, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb504;  immval:0x4
TEST_IMM_OP( ori, x11, x10, 0xb504, 0xb504, 0x4, x4, 876, x5)

inst_242:
// rs1_val==46340 and imm_val==818, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb504;  immval:0x332
TEST_IMM_OP( ori, x11, x10, 0xb736, 0xb504, 0x332, x4, 880, x5)

inst_243:
// rs1_val==46340 and imm_val==1637, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb504;  immval:0x665
TEST_IMM_OP( ori, x11, x10, 0xb765, 0xb504, 0x665, x4, 884, x5)

inst_244:
// rs1_val==46340 and imm_val==44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb504;  immval:0x2c
TEST_IMM_OP( ori, x11, x10, 0xb52c, 0xb504, 0x2c, x4, 888, x5)

inst_245:
// rs1_val==46340 and imm_val==1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb504;  immval:0x556
TEST_IMM_OP( ori, x11, x10, 0xb556, 0xb504, 0x556, x4, 892, x5)

inst_246:
// rs1_val==46340 and imm_val==-1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb504;  immval:-0x555
TEST_IMM_OP( ori, x11, x10, 0xffffffaf, 0xb504, -0x555, x4, 896, x5)

inst_247:
// rs1_val==46340 and imm_val==6, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb504;  immval:0x6
TEST_IMM_OP( ori, x11, x10, 0xb506, 0xb504, 0x6, x4, 900, x5)

inst_248:
// rs1_val==46340 and imm_val==820, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb504;  immval:0x334
TEST_IMM_OP( ori, x11, x10, 0xb734, 0xb504, 0x334, x4, 904, x5)

inst_249:
// rs1_val==46340 and imm_val==1639, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb504;  immval:0x667
TEST_IMM_OP( ori, x11, x10, 0xb767, 0xb504, 0x667, x4, 908, x5)

inst_250:
// rs1_val==46340 and imm_val==-44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb504;  immval:-0x2c
TEST_IMM_OP( ori, x11, x10, 0xffffffd4, 0xb504, -0x2c, x4, 912, x5)

inst_251:
// rs1_val==46340 and imm_val==46, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb504;  immval:0x2e
TEST_IMM_OP( ori, x11, x10, 0xb52e, 0xb504, 0x2e, x4, 916, x5)

inst_252:
// rs1_val==2 and imm_val==3, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x2;  immval:0x3
TEST_IMM_OP( ori, x11, x10, 0x3, 0x2, 0x3, x4, 920, x5)

inst_253:
// rs1_val==2 and imm_val==1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x2;  immval:0x555
TEST_IMM_OP( ori, x11, x10, 0x557, 0x2, 0x555, x4, 924, x5)

inst_254:
// rs1_val==2 and imm_val==-1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x2;  immval:-0x556
TEST_IMM_OP( ori, x11, x10, 0xfffffaaa, 0x2, -0x556, x4, 928, x5)

inst_255:
// rs1_val==2 and imm_val==5, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x2;  immval:0x5
TEST_IMM_OP( ori, x11, x10, 0x7, 0x2, 0x5, x4, 932, x5)

inst_256:
// rs1_val==2 and imm_val==819, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x2;  immval:0x333
TEST_IMM_OP( ori, x11, x10, 0x333, 0x2, 0x333, x4, 936, x5)

inst_257:
// rs1_val==2 and imm_val==1638, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x2;  immval:0x666
TEST_IMM_OP( ori, x11, x10, 0x666, 0x2, 0x666, x4, 940, x5)

inst_258:
// rs1_val==2 and imm_val==-45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x2;  immval:-0x2d
TEST_IMM_OP( ori, x11, x10, 0xffffffd3, 0x2, -0x2d, x4, 944, x5)

inst_259:
// rs1_val==2 and imm_val==45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x2;  immval:0x2d
TEST_IMM_OP( ori, x11, x10, 0x2f, 0x2, 0x2d, x4, 948, x5)

inst_260:
// rs1_val==2 and imm_val==2, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x2;  immval:0x2
TEST_IMM_OP( ori, x11, x10, 0x2, 0x2, 0x2, x4, 952, x5)

inst_261:
// rs1_val==2 and imm_val==1364, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x2;  immval:0x554
TEST_IMM_OP( ori, x11, x10, 0x556, 0x2, 0x554, x4, 956, x5)

inst_262:
// rs1_val==2 and imm_val==0, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x2;  immval:0x0
TEST_IMM_OP( ori, x11, x10, 0x2, 0x2, 0x0, x4, 960, x5)

inst_263:
// rs1_val==2 and imm_val==4, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x2;  immval:0x4
TEST_IMM_OP( ori, x11, x10, 0x6, 0x2, 0x4, x4, 964, x5)

inst_264:
// rs1_val==2 and imm_val==818, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x2;  immval:0x332
TEST_IMM_OP( ori, x11, x10, 0x332, 0x2, 0x332, x4, 968, x5)

inst_265:
// rs1_val==2 and imm_val==1637, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x2;  immval:0x665
TEST_IMM_OP( ori, x11, x10, 0x667, 0x2, 0x665, x4, 972, x5)

inst_266:
// rs1_val==2 and imm_val==44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x2;  immval:0x2c
TEST_IMM_OP( ori, x11, x10, 0x2e, 0x2, 0x2c, x4, 976, x5)

inst_267:
// rs1_val==2 and imm_val==1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x2;  immval:0x556
TEST_IMM_OP( ori, x11, x10, 0x556, 0x2, 0x556, x4, 980, x5)

inst_268:
// rs1_val==2 and imm_val==-1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x2;  immval:-0x555
TEST_IMM_OP( ori, x11, x10, 0xfffffaab, 0x2, -0x555, x4, 984, x5)

inst_269:
// rs1_val==2 and imm_val==6, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x2;  immval:0x6
TEST_IMM_OP( ori, x11, x10, 0x6, 0x2, 0x6, x4, 988, x5)

inst_270:
// rs1_val==2 and imm_val==820, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x2;  immval:0x334
TEST_IMM_OP( ori, x11, x10, 0x336, 0x2, 0x334, x4, 992, x5)

inst_271:
// rs1_val==2 and imm_val==1639, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x2;  immval:0x667
TEST_IMM_OP( ori, x11, x10, 0x667, 0x2, 0x667, x4, 996, x5)

inst_272:
// rs1_val==2 and imm_val==-44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x2;  immval:-0x2c
TEST_IMM_OP( ori, x11, x10, 0xffffffd6, 0x2, -0x2c, x4, 1000, x5)

inst_273:
// rs1_val==2 and imm_val==46, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x2;  immval:0x2e
TEST_IMM_OP( ori, x11, x10, 0x2e, 0x2, 0x2e, x4, 1004, x5)

inst_274:
// rs1_val==1431655764 and imm_val==3, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555554;  immval:0x3
TEST_IMM_OP( ori, x11, x10, 0x55555557, 0x55555554, 0x3, x4, 1008, x5)

inst_275:
// rs1_val==1431655764 and imm_val==1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555554;  immval:0x555
TEST_IMM_OP( ori, x11, x10, 0x55555555, 0x55555554, 0x555, x4, 1012, x5)

inst_276:
// rs1_val==1431655764 and imm_val==-1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555554;  immval:-0x556
TEST_IMM_OP( ori, x11, x10, 0xfffffffe, 0x55555554, -0x556, x4, 1016, x5)

inst_277:
// rs1_val==1431655764 and imm_val==5, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555554;  immval:0x5
TEST_IMM_OP( ori, x11, x10, 0x55555555, 0x55555554, 0x5, x4, 1020, x5)

inst_278:
// rs1_val==1431655764 and imm_val==819, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555554;  immval:0x333
TEST_IMM_OP( ori, x11, x10, 0x55555777, 0x55555554, 0x333, x4, 1024, x5)

inst_279:
// rs1_val==1431655764 and imm_val==1638, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555554;  immval:0x666
TEST_IMM_OP( ori, x11, x10, 0x55555776, 0x55555554, 0x666, x4, 1028, x5)

inst_280:
// rs1_val==1431655764 and imm_val==-45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555554;  immval:-0x2d
TEST_IMM_OP( ori, x11, x10, 0xffffffd7, 0x55555554, -0x2d, x4, 1032, x5)

inst_281:
// rs1_val==1431655764 and imm_val==45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555554;  immval:0x2d
TEST_IMM_OP( ori, x11, x10, 0x5555557d, 0x55555554, 0x2d, x4, 1036, x5)

inst_282:
// rs1_val==1431655764 and imm_val==2, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555554;  immval:0x2
TEST_IMM_OP( ori, x11, x10, 0x55555556, 0x55555554, 0x2, x4, 1040, x5)

inst_283:
// rs1_val==1431655764 and imm_val==1364, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555554;  immval:0x554
TEST_IMM_OP( ori, x11, x10, 0x55555554, 0x55555554, 0x554, x4, 1044, x5)

inst_284:
// rs1_val==1431655764 and imm_val==0, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555554;  immval:0x0
TEST_IMM_OP( ori, x11, x10, 0x55555554, 0x55555554, 0x0, x4, 1048, x5)

inst_285:
// rs1_val==1431655764 and imm_val==4, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555554;  immval:0x4
TEST_IMM_OP( ori, x11, x10, 0x55555554, 0x55555554, 0x4, x4, 1052, x5)

inst_286:
// rs1_val==1431655764 and imm_val==818, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555554;  immval:0x332
TEST_IMM_OP( ori, x11, x10, 0x55555776, 0x55555554, 0x332, x4, 1056, x5)

inst_287:
// rs1_val==1431655764 and imm_val==1637, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555554;  immval:0x665
TEST_IMM_OP( ori, x11, x10, 0x55555775, 0x55555554, 0x665, x4, 1060, x5)

inst_288:
// rs1_val==1431655764 and imm_val==44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555554;  immval:0x2c
TEST_IMM_OP( ori, x11, x10, 0x5555557c, 0x55555554, 0x2c, x4, 1064, x5)

inst_289:
// rs1_val==1431655764 and imm_val==1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555554;  immval:0x556
TEST_IMM_OP( ori, x11, x10, 0x55555556, 0x55555554, 0x556, x4, 1068, x5)

inst_290:
// rs1_val==1431655764 and imm_val==-1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555554;  immval:-0x555
TEST_IMM_OP( ori, x11, x10, 0xffffffff, 0x55555554, -0x555, x4, 1072, x5)

inst_291:
// rs1_val==1431655764 and imm_val==6, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555554;  immval:0x6
TEST_IMM_OP( ori, x11, x10, 0x55555556, 0x55555554, 0x6, x4, 1076, x5)

inst_292:
// rs1_val==1431655764 and imm_val==820, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555554;  immval:0x334
TEST_IMM_OP( ori, x11, x10, 0x55555774, 0x55555554, 0x334, x4, 1080, x5)

inst_293:
// rs1_val==1431655764 and imm_val==1639, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555554;  immval:0x667
TEST_IMM_OP( ori, x11, x10, 0x55555777, 0x55555554, 0x667, x4, 1084, x5)

inst_294:
// rs1_val==1431655764 and imm_val==-44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555554;  immval:-0x2c
TEST_IMM_OP( ori, x11, x10, 0xffffffd4, 0x55555554, -0x2c, x4, 1088, x5)

inst_295:
// rs1_val==1431655764 and imm_val==46, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555554;  immval:0x2e
TEST_IMM_OP( ori, x11, x10, 0x5555557e, 0x55555554, 0x2e, x4, 1092, x5)

inst_296:
// rs1_val==0 and imm_val==3, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x0;  immval:0x3
TEST_IMM_OP( ori, x11, x10, 0x3, 0x0, 0x3, x4, 1096, x5)

inst_297:
// rs1_val==0 and imm_val==1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x0;  immval:0x555
TEST_IMM_OP( ori, x11, x10, 0x555, 0x0, 0x555, x4, 1100, x5)

inst_298:
// rs1_val==0 and imm_val==-1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x0;  immval:-0x556
TEST_IMM_OP( ori, x11, x10, 0xfffffaaa, 0x0, -0x556, x4, 1104, x5)

inst_299:
// rs1_val==0 and imm_val==5, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x0;  immval:0x5
TEST_IMM_OP( ori, x11, x10, 0x5, 0x0, 0x5, x4, 1108, x5)

inst_300:
// rs1_val==0 and imm_val==819, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x0;  immval:0x333
TEST_IMM_OP( ori, x11, x10, 0x333, 0x0, 0x333, x4, 1112, x5)

inst_301:
// rs1_val==0 and imm_val==1638, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x0;  immval:0x666
TEST_IMM_OP( ori, x11, x10, 0x666, 0x0, 0x666, x4, 1116, x5)

inst_302:
// rs1_val==0 and imm_val==-45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x0;  immval:-0x2d
TEST_IMM_OP( ori, x11, x10, 0xffffffd3, 0x0, -0x2d, x4, 1120, x5)

inst_303:
// rs1_val==858993460 and imm_val==818, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333334;  immval:0x332
TEST_IMM_OP( ori, x11, x10, 0x33333336, 0x33333334, 0x332, x4, 1124, x5)

inst_304:
// rs1_val==858993460 and imm_val==1637, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333334;  immval:0x665
TEST_IMM_OP( ori, x11, x10, 0x33333775, 0x33333334, 0x665, x4, 1128, x5)

inst_305:
// rs1_val==858993460 and imm_val==44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333334;  immval:0x2c
TEST_IMM_OP( ori, x11, x10, 0x3333333c, 0x33333334, 0x2c, x4, 1132, x5)

inst_306:
// rs1_val==858993460 and imm_val==1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333334;  immval:0x556
TEST_IMM_OP( ori, x11, x10, 0x33333776, 0x33333334, 0x556, x4, 1136, x5)

inst_307:
// rs1_val==858993460 and imm_val==-1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333334;  immval:-0x555
TEST_IMM_OP( ori, x11, x10, 0xfffffbbf, 0x33333334, -0x555, x4, 1140, x5)

inst_308:
// rs1_val==858993460 and imm_val==6, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333334;  immval:0x6
TEST_IMM_OP( ori, x11, x10, 0x33333336, 0x33333334, 0x6, x4, 1144, x5)

inst_309:
// rs1_val==858993460 and imm_val==820, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333334;  immval:0x334
TEST_IMM_OP( ori, x11, x10, 0x33333334, 0x33333334, 0x334, x4, 1148, x5)

inst_310:
// rs1_val==858993460 and imm_val==1639, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333334;  immval:0x667
TEST_IMM_OP( ori, x11, x10, 0x33333777, 0x33333334, 0x667, x4, 1152, x5)

inst_311:
// rs1_val==858993460 and imm_val==-44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333334;  immval:-0x2c
TEST_IMM_OP( ori, x11, x10, 0xfffffff4, 0x33333334, -0x2c, x4, 1156, x5)

inst_312:
// rs1_val==858993460 and imm_val==46, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333334;  immval:0x2e
TEST_IMM_OP( ori, x11, x10, 0x3333333e, 0x33333334, 0x2e, x4, 1160, x5)

inst_313:
// rs1_val==1717986919 and imm_val==3, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666667;  immval:0x3
TEST_IMM_OP( ori, x11, x10, 0x66666667, 0x66666667, 0x3, x4, 1164, x5)

inst_314:
// rs1_val==1717986919 and imm_val==1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666667;  immval:0x555
TEST_IMM_OP( ori, x11, x10, 0x66666777, 0x66666667, 0x555, x4, 1168, x5)

inst_315:
// rs1_val==1717986919 and imm_val==-1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666667;  immval:-0x556
TEST_IMM_OP( ori, x11, x10, 0xfffffeef, 0x66666667, -0x556, x4, 1172, x5)

inst_316:
// rs1_val==1717986919 and imm_val==5, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666667;  immval:0x5
TEST_IMM_OP( ori, x11, x10, 0x66666667, 0x66666667, 0x5, x4, 1176, x5)

inst_317:
// rs1_val==1717986919 and imm_val==819, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666667;  immval:0x333
TEST_IMM_OP( ori, x11, x10, 0x66666777, 0x66666667, 0x333, x4, 1180, x5)

inst_318:
// rs1_val==1717986919 and imm_val==1638, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666667;  immval:0x666
TEST_IMM_OP( ori, x11, x10, 0x66666667, 0x66666667, 0x666, x4, 1184, x5)

inst_319:
// rs1_val==1717986919 and imm_val==-45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666667;  immval:-0x2d
TEST_IMM_OP( ori, x11, x10, 0xfffffff7, 0x66666667, -0x2d, x4, 1188, x5)

inst_320:
// rs1_val==1717986919 and imm_val==45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666667;  immval:0x2d
TEST_IMM_OP( ori, x11, x10, 0x6666666f, 0x66666667, 0x2d, x4, 1192, x5)

inst_321:
// rs1_val==1717986919 and imm_val==2, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666667;  immval:0x2
TEST_IMM_OP( ori, x11, x10, 0x66666667, 0x66666667, 0x2, x4, 1196, x5)

inst_322:
// rs1_val==1717986919 and imm_val==1364, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666667;  immval:0x554
TEST_IMM_OP( ori, x11, x10, 0x66666777, 0x66666667, 0x554, x4, 1200, x5)

inst_323:
// rs1_val==1717986919 and imm_val==0, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666667;  immval:0x0
TEST_IMM_OP( ori, x11, x10, 0x66666667, 0x66666667, 0x0, x4, 1204, x5)

inst_324:
// rs1_val==1717986919 and imm_val==4, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666667;  immval:0x4
TEST_IMM_OP( ori, x11, x10, 0x66666667, 0x66666667, 0x4, x4, 1208, x5)

inst_325:
// rs1_val==1717986919 and imm_val==818, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666667;  immval:0x332
TEST_IMM_OP( ori, x11, x10, 0x66666777, 0x66666667, 0x332, x4, 1212, x5)

inst_326:
// rs1_val==1717986919 and imm_val==1637, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666667;  immval:0x665
TEST_IMM_OP( ori, x11, x10, 0x66666667, 0x66666667, 0x665, x4, 1216, x5)

inst_327:
// rs1_val==1717986919 and imm_val==44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666667;  immval:0x2c
TEST_IMM_OP( ori, x11, x10, 0x6666666f, 0x66666667, 0x2c, x4, 1220, x5)

inst_328:
// rs1_val==1717986919 and imm_val==1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666667;  immval:0x556
TEST_IMM_OP( ori, x11, x10, 0x66666777, 0x66666667, 0x556, x4, 1224, x5)

inst_329:
// rs1_val==1717986919 and imm_val==-1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666667;  immval:-0x555
TEST_IMM_OP( ori, x11, x10, 0xfffffeef, 0x66666667, -0x555, x4, 1228, x5)

inst_330:
// rs1_val==1717986919 and imm_val==6, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666667;  immval:0x6
TEST_IMM_OP( ori, x11, x10, 0x66666667, 0x66666667, 0x6, x4, 1232, x5)

inst_331:
// rs1_val==1717986919 and imm_val==820, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666667;  immval:0x334
TEST_IMM_OP( ori, x11, x10, 0x66666777, 0x66666667, 0x334, x4, 1236, x5)

inst_332:
// rs1_val==1717986919 and imm_val==1639, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666667;  immval:0x667
TEST_IMM_OP( ori, x11, x10, 0x66666667, 0x66666667, 0x667, x4, 1240, x5)

inst_333:
// rs1_val==1717986919 and imm_val==-44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666667;  immval:-0x2c
TEST_IMM_OP( ori, x11, x10, 0xfffffff7, 0x66666667, -0x2c, x4, 1244, x5)

inst_334:
// rs1_val==1717986919 and imm_val==46, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666667;  immval:0x2e
TEST_IMM_OP( ori, x11, x10, 0x6666666f, 0x66666667, 0x2e, x4, 1248, x5)

inst_335:
// rs1_val==-46339 and imm_val==3, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb503;  immval:0x3
TEST_IMM_OP( ori, x11, x10, 0xffff4aff, -0xb503, 0x3, x4, 1252, x5)

inst_336:
// rs1_val==-46339 and imm_val==1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb503;  immval:0x555
TEST_IMM_OP( ori, x11, x10, 0xffff4ffd, -0xb503, 0x555, x4, 1256, x5)

inst_337:
// rs1_val==-46339 and imm_val==-1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb503;  immval:-0x556
TEST_IMM_OP( ori, x11, x10, 0xfffffaff, -0xb503, -0x556, x4, 1260, x5)

inst_338:
// rs1_val==-46339 and imm_val==5, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb503;  immval:0x5
TEST_IMM_OP( ori, x11, x10, 0xffff4afd, -0xb503, 0x5, x4, 1264, x5)

inst_339:
// rs1_val==-46339 and imm_val==819, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb503;  immval:0x333
TEST_IMM_OP( ori, x11, x10, 0xffff4bff, -0xb503, 0x333, x4, 1268, x5)

inst_340:
// rs1_val==-46339 and imm_val==1638, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb503;  immval:0x666
TEST_IMM_OP( ori, x11, x10, 0xffff4eff, -0xb503, 0x666, x4, 1272, x5)

inst_341:
// rs1_val==-46339 and imm_val==-45, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb503;  immval:-0x2d
TEST_IMM_OP( ori, x11, x10, 0xffffffff, -0xb503, -0x2d, x4, 1276, x5)

inst_342:
// rs1_val==-46339 and imm_val==45, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb503;  immval:0x2d
TEST_IMM_OP( ori, x11, x10, 0xffff4afd, -0xb503, 0x2d, x4, 1280, x5)

inst_343:
// rs1_val==-46339 and imm_val==2, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb503;  immval:0x2
TEST_IMM_OP( ori, x11, x10, 0xffff4aff, -0xb503, 0x2, x4, 1284, x5)

inst_344:
// rs1_val==-46339 and imm_val==1364, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb503;  immval:0x554
TEST_IMM_OP( ori, x11, x10, 0xffff4ffd, -0xb503, 0x554, x4, 1288, x5)

inst_345:
// rs1_val==-46339 and imm_val==0, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb503;  immval:0x0
TEST_IMM_OP( ori, x11, x10, 0xffff4afd, -0xb503, 0x0, x4, 1292, x5)

inst_346:
// rs1_val==-46339 and imm_val==4, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb503;  immval:0x4
TEST_IMM_OP( ori, x11, x10, 0xffff4afd, -0xb503, 0x4, x4, 1296, x5)

inst_347:
// rs1_val==-46339 and imm_val==818, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb503;  immval:0x332
TEST_IMM_OP( ori, x11, x10, 0xffff4bff, -0xb503, 0x332, x4, 1300, x5)

inst_348:
// rs1_val==-46339 and imm_val==1637, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb503;  immval:0x665
TEST_IMM_OP( ori, x11, x10, 0xffff4efd, -0xb503, 0x665, x4, 1304, x5)

inst_349:
// rs1_val==-46339 and imm_val==44, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb503;  immval:0x2c
TEST_IMM_OP( ori, x11, x10, 0xffff4afd, -0xb503, 0x2c, x4, 1308, x5)

inst_350:
// rs1_val==-46339 and imm_val==1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb503;  immval:0x556
TEST_IMM_OP( ori, x11, x10, 0xffff4fff, -0xb503, 0x556, x4, 1312, x5)

inst_351:
// rs1_val==-46339 and imm_val==-1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb503;  immval:-0x555
TEST_IMM_OP( ori, x11, x10, 0xfffffaff, -0xb503, -0x555, x4, 1316, x5)

inst_352:
// rs1_val==-46339 and imm_val==6, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb503;  immval:0x6
TEST_IMM_OP( ori, x11, x10, 0xffff4aff, -0xb503, 0x6, x4, 1320, x5)

inst_353:
// rs1_val==-46339 and imm_val==820, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb503;  immval:0x334
TEST_IMM_OP( ori, x11, x10, 0xffff4bfd, -0xb503, 0x334, x4, 1324, x5)

inst_354:
// rs1_val==-46339 and imm_val==1639, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb503;  immval:0x667
TEST_IMM_OP( ori, x11, x10, 0xffff4eff, -0xb503, 0x667, x4, 1328, x5)

inst_355:
// rs1_val==-46339 and imm_val==-44, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb503;  immval:-0x2c
TEST_IMM_OP( ori, x11, x10, 0xfffffffd, -0xb503, -0x2c, x4, 1332, x5)

inst_356:
// rs1_val==-46339 and imm_val==46, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0xb503;  immval:0x2e
TEST_IMM_OP( ori, x11, x10, 0xffff4aff, -0xb503, 0x2e, x4, 1336, x5)

inst_357:
// rs1_val==46341 and imm_val==3, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb505;  immval:0x3
TEST_IMM_OP( ori, x11, x10, 0xb507, 0xb505, 0x3, x4, 1340, x5)

inst_358:
// rs1_val==46341 and imm_val==1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb505;  immval:0x555
TEST_IMM_OP( ori, x11, x10, 0xb555, 0xb505, 0x555, x4, 1344, x5)

inst_359:
// rs1_val==46341 and imm_val==-1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb505;  immval:-0x556
TEST_IMM_OP( ori, x11, x10, 0xffffffaf, 0xb505, -0x556, x4, 1348, x5)

inst_360:
// rs1_val==46341 and imm_val==5, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb505;  immval:0x5
TEST_IMM_OP( ori, x11, x10, 0xb505, 0xb505, 0x5, x4, 1352, x5)

inst_361:
// rs1_val==46341 and imm_val==819, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb505;  immval:0x333
TEST_IMM_OP( ori, x11, x10, 0xb737, 0xb505, 0x333, x4, 1356, x5)

inst_362:
// rs1_val==46341 and imm_val==1638, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb505;  immval:0x666
TEST_IMM_OP( ori, x11, x10, 0xb767, 0xb505, 0x666, x4, 1360, x5)

inst_363:
// rs1_val==46341 and imm_val==-45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb505;  immval:-0x2d
TEST_IMM_OP( ori, x11, x10, 0xffffffd7, 0xb505, -0x2d, x4, 1364, x5)

inst_364:
// rs1_val==46341 and imm_val==45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb505;  immval:0x2d
TEST_IMM_OP( ori, x11, x10, 0xb52d, 0xb505, 0x2d, x4, 1368, x5)

inst_365:
// rs1_val==46341 and imm_val==2, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb505;  immval:0x2
TEST_IMM_OP( ori, x11, x10, 0xb507, 0xb505, 0x2, x4, 1372, x5)

inst_366:
// rs1_val==46341 and imm_val==1364, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb505;  immval:0x554
TEST_IMM_OP( ori, x11, x10, 0xb555, 0xb505, 0x554, x4, 1376, x5)

inst_367:
// rs1_val==46341 and imm_val==0, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb505;  immval:0x0
TEST_IMM_OP( ori, x11, x10, 0xb505, 0xb505, 0x0, x4, 1380, x5)

inst_368:
// rs1_val==46341 and imm_val==4, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb505;  immval:0x4
TEST_IMM_OP( ori, x11, x10, 0xb505, 0xb505, 0x4, x4, 1384, x5)

inst_369:
// rs1_val==46341 and imm_val==818, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb505;  immval:0x332
TEST_IMM_OP( ori, x11, x10, 0xb737, 0xb505, 0x332, x4, 1388, x5)

inst_370:
// rs1_val==46341 and imm_val==1637, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb505;  immval:0x665
TEST_IMM_OP( ori, x11, x10, 0xb765, 0xb505, 0x665, x4, 1392, x5)

inst_371:
// rs1_val==46341 and imm_val==44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb505;  immval:0x2c
TEST_IMM_OP( ori, x11, x10, 0xb52d, 0xb505, 0x2c, x4, 1396, x5)

inst_372:
// rs1_val==46341 and imm_val==1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb505;  immval:0x556
TEST_IMM_OP( ori, x11, x10, 0xb557, 0xb505, 0x556, x4, 1400, x5)

inst_373:
// rs1_val==46341 and imm_val==-1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb505;  immval:-0x555
TEST_IMM_OP( ori, x11, x10, 0xffffffaf, 0xb505, -0x555, x4, 1404, x5)

inst_374:
// rs1_val==46341 and imm_val==6, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb505;  immval:0x6
TEST_IMM_OP( ori, x11, x10, 0xb507, 0xb505, 0x6, x4, 1408, x5)

inst_375:
// rs1_val==46341 and imm_val==820, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb505;  immval:0x334
TEST_IMM_OP( ori, x11, x10, 0xb735, 0xb505, 0x334, x4, 1412, x5)

inst_376:
// rs1_val==46341 and imm_val==1639, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb505;  immval:0x667
TEST_IMM_OP( ori, x11, x10, 0xb767, 0xb505, 0x667, x4, 1416, x5)

inst_377:
// rs1_val==46341 and imm_val==-44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb505;  immval:-0x2c
TEST_IMM_OP( ori, x11, x10, 0xffffffd5, 0xb505, -0x2c, x4, 1420, x5)

inst_378:
// rs1_val==46341 and imm_val==46, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb505;  immval:0x2e
TEST_IMM_OP( ori, x11, x10, 0xb52f, 0xb505, 0x2e, x4, 1424, x5)

inst_379:
// rs1_val==0 and imm_val==45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x0;  immval:0x2d
TEST_IMM_OP( ori, x11, x10, 0x2d, 0x0, 0x2d, x4, 1428, x5)

inst_380:
// rs1_val==0 and imm_val==2, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x0;  immval:0x2
TEST_IMM_OP( ori, x11, x10, 0x2, 0x0, 0x2, x4, 1432, x5)

inst_381:
// rs1_val==0 and imm_val==1364, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x0;  immval:0x554
TEST_IMM_OP( ori, x11, x10, 0x554, 0x0, 0x554, x4, 1436, x5)

inst_382:
// rs1_val==0 and imm_val==4, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x0;  immval:0x4
TEST_IMM_OP( ori, x11, x10, 0x4, 0x0, 0x4, x4, 1440, x5)

inst_383:
// rs1_val==0 and imm_val==818, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x0;  immval:0x332
TEST_IMM_OP( ori, x11, x10, 0x332, 0x0, 0x332, x4, 1444, x5)

inst_384:
// rs1_val==0 and imm_val==1637, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x0;  immval:0x665
TEST_IMM_OP( ori, x11, x10, 0x665, 0x0, 0x665, x4, 1448, x5)

inst_385:
// rs1_val==0 and imm_val==44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x0;  immval:0x2c
TEST_IMM_OP( ori, x11, x10, 0x2c, 0x0, 0x2c, x4, 1452, x5)

inst_386:
// rs1_val==0 and imm_val==1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x0;  immval:0x556
TEST_IMM_OP( ori, x11, x10, 0x556, 0x0, 0x556, x4, 1456, x5)

inst_387:
// rs1_val==0 and imm_val==-1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x0;  immval:-0x555
TEST_IMM_OP( ori, x11, x10, 0xfffffaab, 0x0, -0x555, x4, 1460, x5)

inst_388:
// rs1_val==0 and imm_val==6, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x0;  immval:0x6
TEST_IMM_OP( ori, x11, x10, 0x6, 0x0, 0x6, x4, 1464, x5)

inst_389:
// rs1_val==0 and imm_val==820, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x0;  immval:0x334
TEST_IMM_OP( ori, x11, x10, 0x334, 0x0, 0x334, x4, 1468, x5)

inst_390:
// rs1_val==0 and imm_val==1639, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x0;  immval:0x667
TEST_IMM_OP( ori, x11, x10, 0x667, 0x0, 0x667, x4, 1472, x5)

inst_391:
// rs1_val==0 and imm_val==-44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x0;  immval:-0x2c
TEST_IMM_OP( ori, x11, x10, 0xffffffd4, 0x0, -0x2c, x4, 1476, x5)

inst_392:
// rs1_val==0 and imm_val==46, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x0;  immval:0x2e
TEST_IMM_OP( ori, x11, x10, 0x2e, 0x0, 0x2e, x4, 1480, x5)

inst_393:
// rs1_val==4 and imm_val==3, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x4;  immval:0x3
TEST_IMM_OP( ori, x11, x10, 0x7, 0x4, 0x3, x4, 1484, x5)

inst_394:
// rs1_val==4 and imm_val==1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x4;  immval:0x555
TEST_IMM_OP( ori, x11, x10, 0x555, 0x4, 0x555, x4, 1488, x5)

inst_395:
// rs1_val==4 and imm_val==-1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x4;  immval:-0x556
TEST_IMM_OP( ori, x11, x10, 0xfffffaae, 0x4, -0x556, x4, 1492, x5)

inst_396:
// rs1_val==4 and imm_val==819, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x4;  immval:0x333
TEST_IMM_OP( ori, x11, x10, 0x337, 0x4, 0x333, x4, 1496, x5)

inst_397:
// rs1_val==4 and imm_val==1638, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x4;  immval:0x666
TEST_IMM_OP( ori, x11, x10, 0x666, 0x4, 0x666, x4, 1500, x5)

inst_398:
// rs1_val==4 and imm_val==-45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x4;  immval:-0x2d
TEST_IMM_OP( ori, x11, x10, 0xffffffd7, 0x4, -0x2d, x4, 1504, x5)

inst_399:
// rs1_val==4 and imm_val==45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x4;  immval:0x2d
TEST_IMM_OP( ori, x11, x10, 0x2d, 0x4, 0x2d, x4, 1508, x5)

inst_400:
// rs1_val==4 and imm_val==2, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x4;  immval:0x2
TEST_IMM_OP( ori, x11, x10, 0x6, 0x4, 0x2, x4, 1512, x5)

inst_401:
// rs1_val==4 and imm_val==1364, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x4;  immval:0x554
TEST_IMM_OP( ori, x11, x10, 0x554, 0x4, 0x554, x4, 1516, x5)

inst_402:
// rs1_val==4 and imm_val==0, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x4;  immval:0x0
TEST_IMM_OP( ori, x11, x10, 0x4, 0x4, 0x0, x4, 1520, x5)

inst_403:
// rs1_val==4 and imm_val==4, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x4;  immval:0x4
TEST_IMM_OP( ori, x11, x10, 0x4, 0x4, 0x4, x4, 1524, x5)

inst_404:
// rs1_val==4 and imm_val==818, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x4;  immval:0x332
TEST_IMM_OP( ori, x11, x10, 0x336, 0x4, 0x332, x4, 1528, x5)

inst_405:
// rs1_val==4 and imm_val==1637, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x4;  immval:0x665
TEST_IMM_OP( ori, x11, x10, 0x665, 0x4, 0x665, x4, 1532, x5)

inst_406:
// rs1_val==4 and imm_val==44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x4;  immval:0x2c
TEST_IMM_OP( ori, x11, x10, 0x2c, 0x4, 0x2c, x4, 1536, x5)

inst_407:
// rs1_val==4 and imm_val==1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x4;  immval:0x556
TEST_IMM_OP( ori, x11, x10, 0x556, 0x4, 0x556, x4, 1540, x5)

inst_408:
// rs1_val==4 and imm_val==-1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x4;  immval:-0x555
TEST_IMM_OP( ori, x11, x10, 0xfffffaaf, 0x4, -0x555, x4, 1544, x5)

inst_409:
// rs1_val==4 and imm_val==6, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x4;  immval:0x6
TEST_IMM_OP( ori, x11, x10, 0x6, 0x4, 0x6, x4, 1548, x5)

inst_410:
// rs1_val==4 and imm_val==820, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x4;  immval:0x334
TEST_IMM_OP( ori, x11, x10, 0x334, 0x4, 0x334, x4, 1552, x5)

inst_411:
// rs1_val==4 and imm_val==1639, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x4;  immval:0x667
TEST_IMM_OP( ori, x11, x10, 0x667, 0x4, 0x667, x4, 1556, x5)

inst_412:
// rs1_val==4 and imm_val==-44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x4;  immval:-0x2c
TEST_IMM_OP( ori, x11, x10, 0xffffffd4, 0x4, -0x2c, x4, 1560, x5)

inst_413:
// rs1_val==4 and imm_val==46, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x4;  immval:0x2e
TEST_IMM_OP( ori, x11, x10, 0x2e, 0x4, 0x2e, x4, 1564, x5)

inst_414:
// rs1_val==858993458 and imm_val==3, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333332;  immval:0x3
TEST_IMM_OP( ori, x11, x10, 0x33333333, 0x33333332, 0x3, x4, 1568, x5)

inst_415:
// rs1_val==858993458 and imm_val==1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333332;  immval:0x555
TEST_IMM_OP( ori, x11, x10, 0x33333777, 0x33333332, 0x555, x4, 1572, x5)

inst_416:
// rs1_val==858993458 and imm_val==-1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333332;  immval:-0x556
TEST_IMM_OP( ori, x11, x10, 0xfffffbba, 0x33333332, -0x556, x4, 1576, x5)

inst_417:
// rs1_val==858993458 and imm_val==5, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333332;  immval:0x5
TEST_IMM_OP( ori, x11, x10, 0x33333337, 0x33333332, 0x5, x4, 1580, x5)

inst_418:
// rs1_val==858993458 and imm_val==819, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333332;  immval:0x333
TEST_IMM_OP( ori, x11, x10, 0x33333333, 0x33333332, 0x333, x4, 1584, x5)

inst_419:
// rs1_val==858993458 and imm_val==1638, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333332;  immval:0x666
TEST_IMM_OP( ori, x11, x10, 0x33333776, 0x33333332, 0x666, x4, 1588, x5)

inst_420:
// rs1_val==858993458 and imm_val==-45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333332;  immval:-0x2d
TEST_IMM_OP( ori, x11, x10, 0xfffffff3, 0x33333332, -0x2d, x4, 1592, x5)

inst_421:
// rs1_val==858993458 and imm_val==45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333332;  immval:0x2d
TEST_IMM_OP( ori, x11, x10, 0x3333333f, 0x33333332, 0x2d, x4, 1596, x5)

inst_422:
// rs1_val==858993458 and imm_val==2, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333332;  immval:0x2
TEST_IMM_OP( ori, x11, x10, 0x33333332, 0x33333332, 0x2, x4, 1600, x5)

inst_423:
// rs1_val==858993458 and imm_val==1364, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333332;  immval:0x554
TEST_IMM_OP( ori, x11, x10, 0x33333776, 0x33333332, 0x554, x4, 1604, x5)

inst_424:
// rs1_val==858993458 and imm_val==0, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333332;  immval:0x0
TEST_IMM_OP( ori, x11, x10, 0x33333332, 0x33333332, 0x0, x4, 1608, x5)

inst_425:
// rs1_val==858993458 and imm_val==4, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333332;  immval:0x4
TEST_IMM_OP( ori, x11, x10, 0x33333336, 0x33333332, 0x4, x4, 1612, x5)

inst_426:
// rs1_val==858993458 and imm_val==818, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333332;  immval:0x332
TEST_IMM_OP( ori, x11, x10, 0x33333332, 0x33333332, 0x332, x4, 1616, x5)

inst_427:
// rs1_val==858993458 and imm_val==1637, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333332;  immval:0x665
TEST_IMM_OP( ori, x11, x10, 0x33333777, 0x33333332, 0x665, x4, 1620, x5)

inst_428:
// rs1_val==858993458 and imm_val==44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333332;  immval:0x2c
TEST_IMM_OP( ori, x11, x10, 0x3333333e, 0x33333332, 0x2c, x4, 1624, x5)

inst_429:
// rs1_val==858993458 and imm_val==1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333332;  immval:0x556
TEST_IMM_OP( ori, x11, x10, 0x33333776, 0x33333332, 0x556, x4, 1628, x5)

inst_430:
// rs1_val==858993458 and imm_val==-1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333332;  immval:-0x555
TEST_IMM_OP( ori, x11, x10, 0xfffffbbb, 0x33333332, -0x555, x4, 1632, x5)

inst_431:
// rs1_val==858993458 and imm_val==6, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333332;  immval:0x6
TEST_IMM_OP( ori, x11, x10, 0x33333336, 0x33333332, 0x6, x4, 1636, x5)

inst_432:
// rs1_val==858993458 and imm_val==820, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333332;  immval:0x334
TEST_IMM_OP( ori, x11, x10, 0x33333336, 0x33333332, 0x334, x4, 1640, x5)

inst_433:
// rs1_val==858993458 and imm_val==1639, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333332;  immval:0x667
TEST_IMM_OP( ori, x11, x10, 0x33333777, 0x33333332, 0x667, x4, 1644, x5)

inst_434:
// rs1_val==858993458 and imm_val==-44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333332;  immval:-0x2c
TEST_IMM_OP( ori, x11, x10, 0xfffffff6, 0x33333332, -0x2c, x4, 1648, x5)

inst_435:
// rs1_val==858993458 and imm_val==46, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333332;  immval:0x2e
TEST_IMM_OP( ori, x11, x10, 0x3333333e, 0x33333332, 0x2e, x4, 1652, x5)

inst_436:
// rs1_val==1717986917 and imm_val==3, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666665;  immval:0x3
TEST_IMM_OP( ori, x11, x10, 0x66666667, 0x66666665, 0x3, x4, 1656, x5)

inst_437:
// rs1_val==1717986917 and imm_val==1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666665;  immval:0x555
TEST_IMM_OP( ori, x11, x10, 0x66666775, 0x66666665, 0x555, x4, 1660, x5)

inst_438:
// rs1_val==1717986917 and imm_val==-1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666665;  immval:-0x556
TEST_IMM_OP( ori, x11, x10, 0xfffffeef, 0x66666665, -0x556, x4, 1664, x5)

inst_439:
// rs1_val==1717986917 and imm_val==5, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666665;  immval:0x5
TEST_IMM_OP( ori, x11, x10, 0x66666665, 0x66666665, 0x5, x4, 1668, x5)

inst_440:
// rs1_val==1717986917 and imm_val==819, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666665;  immval:0x333
TEST_IMM_OP( ori, x11, x10, 0x66666777, 0x66666665, 0x333, x4, 1672, x5)

inst_441:
// rs1_val==1717986917 and imm_val==1638, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666665;  immval:0x666
TEST_IMM_OP( ori, x11, x10, 0x66666667, 0x66666665, 0x666, x4, 1676, x5)

inst_442:
// rs1_val==1717986917 and imm_val==-45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666665;  immval:-0x2d
TEST_IMM_OP( ori, x11, x10, 0xfffffff7, 0x66666665, -0x2d, x4, 1680, x5)

inst_443:
// rs1_val==1717986917 and imm_val==45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666665;  immval:0x2d
TEST_IMM_OP( ori, x11, x10, 0x6666666d, 0x66666665, 0x2d, x4, 1684, x5)

inst_444:
// rs1_val==1717986917 and imm_val==2, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666665;  immval:0x2
TEST_IMM_OP( ori, x11, x10, 0x66666667, 0x66666665, 0x2, x4, 1688, x5)

inst_445:
// rs1_val==1717986917 and imm_val==1364, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666665;  immval:0x554
TEST_IMM_OP( ori, x11, x10, 0x66666775, 0x66666665, 0x554, x4, 1692, x5)

inst_446:
// rs1_val==1717986917 and imm_val==0, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666665;  immval:0x0
TEST_IMM_OP( ori, x11, x10, 0x66666665, 0x66666665, 0x0, x4, 1696, x5)

inst_447:
// rs1_val==1717986917 and imm_val==4, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666665;  immval:0x4
TEST_IMM_OP( ori, x11, x10, 0x66666665, 0x66666665, 0x4, x4, 1700, x5)

inst_448:
// rs1_val==1717986917 and imm_val==818, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666665;  immval:0x332
TEST_IMM_OP( ori, x11, x10, 0x66666777, 0x66666665, 0x332, x4, 1704, x5)

inst_449:
// rs1_val==1717986917 and imm_val==1637, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666665;  immval:0x665
TEST_IMM_OP( ori, x11, x10, 0x66666665, 0x66666665, 0x665, x4, 1708, x5)

inst_450:
// rs1_val==1717986917 and imm_val==44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666665;  immval:0x2c
TEST_IMM_OP( ori, x11, x10, 0x6666666d, 0x66666665, 0x2c, x4, 1712, x5)

inst_451:
// rs1_val==1717986917 and imm_val==1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666665;  immval:0x556
TEST_IMM_OP( ori, x11, x10, 0x66666777, 0x66666665, 0x556, x4, 1716, x5)

inst_452:
// rs1_val==1717986917 and imm_val==-1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666665;  immval:-0x555
TEST_IMM_OP( ori, x11, x10, 0xfffffeef, 0x66666665, -0x555, x4, 1720, x5)

inst_453:
// rs1_val==1717986917 and imm_val==6, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666665;  immval:0x6
TEST_IMM_OP( ori, x11, x10, 0x66666667, 0x66666665, 0x6, x4, 1724, x5)

inst_454:
// rs1_val==1717986917 and imm_val==820, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666665;  immval:0x334
TEST_IMM_OP( ori, x11, x10, 0x66666775, 0x66666665, 0x334, x4, 1728, x5)

inst_455:
// rs1_val==1717986917 and imm_val==1639, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666665;  immval:0x667
TEST_IMM_OP( ori, x11, x10, 0x66666667, 0x66666665, 0x667, x4, 1732, x5)

inst_456:
// rs1_val==1717986917 and imm_val==-44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666665;  immval:-0x2c
TEST_IMM_OP( ori, x11, x10, 0xfffffff5, 0x66666665, -0x2c, x4, 1736, x5)

inst_457:
// rs1_val==1717986917 and imm_val==46, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x66666665;  immval:0x2e
TEST_IMM_OP( ori, x11, x10, 0x6666666f, 0x66666665, 0x2e, x4, 1740, x5)

inst_458:
// rs1_val==46339 and imm_val==3, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb503;  immval:0x3
TEST_IMM_OP( ori, x11, x10, 0xb503, 0xb503, 0x3, x4, 1744, x5)

inst_459:
// rs1_val==46339 and imm_val==1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb503;  immval:0x555
TEST_IMM_OP( ori, x11, x10, 0xb557, 0xb503, 0x555, x4, 1748, x5)

inst_460:
// rs1_val==46339 and imm_val==-1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb503;  immval:-0x556
TEST_IMM_OP( ori, x11, x10, 0xffffffab, 0xb503, -0x556, x4, 1752, x5)

inst_461:
// rs1_val==46339 and imm_val==5, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb503;  immval:0x5
TEST_IMM_OP( ori, x11, x10, 0xb507, 0xb503, 0x5, x4, 1756, x5)

inst_462:
// rs1_val==46339 and imm_val==819, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb503;  immval:0x333
TEST_IMM_OP( ori, x11, x10, 0xb733, 0xb503, 0x333, x4, 1760, x5)

inst_463:
// rs1_val==46339 and imm_val==1638, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb503;  immval:0x666
TEST_IMM_OP( ori, x11, x10, 0xb767, 0xb503, 0x666, x4, 1764, x5)

inst_464:
// rs1_val==46339 and imm_val==-45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb503;  immval:-0x2d
TEST_IMM_OP( ori, x11, x10, 0xffffffd3, 0xb503, -0x2d, x4, 1768, x5)

inst_465:
// rs1_val==46339 and imm_val==45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb503;  immval:0x2d
TEST_IMM_OP( ori, x11, x10, 0xb52f, 0xb503, 0x2d, x4, 1772, x5)

inst_466:
// rs1_val==46339 and imm_val==2, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb503;  immval:0x2
TEST_IMM_OP( ori, x11, x10, 0xb503, 0xb503, 0x2, x4, 1776, x5)

inst_467:
// rs1_val==46339 and imm_val==1364, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb503;  immval:0x554
TEST_IMM_OP( ori, x11, x10, 0xb557, 0xb503, 0x554, x4, 1780, x5)

inst_468:
// rs1_val==46339 and imm_val==0, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb503;  immval:0x0
TEST_IMM_OP( ori, x11, x10, 0xb503, 0xb503, 0x0, x4, 1784, x5)

inst_469:
// rs1_val==46339 and imm_val==4, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb503;  immval:0x4
TEST_IMM_OP( ori, x11, x10, 0xb507, 0xb503, 0x4, x4, 1788, x5)

inst_470:
// rs1_val==46339 and imm_val==818, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb503;  immval:0x332
TEST_IMM_OP( ori, x11, x10, 0xb733, 0xb503, 0x332, x4, 1792, x5)

inst_471:
// rs1_val==46339 and imm_val==1637, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb503;  immval:0x665
TEST_IMM_OP( ori, x11, x10, 0xb767, 0xb503, 0x665, x4, 1796, x5)

inst_472:
// rs1_val==46339 and imm_val==44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb503;  immval:0x2c
TEST_IMM_OP( ori, x11, x10, 0xb52f, 0xb503, 0x2c, x4, 1800, x5)

inst_473:
// rs1_val==46339 and imm_val==1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb503;  immval:0x556
TEST_IMM_OP( ori, x11, x10, 0xb557, 0xb503, 0x556, x4, 1804, x5)

inst_474:
// rs1_val==46339 and imm_val==-1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb503;  immval:-0x555
TEST_IMM_OP( ori, x11, x10, 0xffffffab, 0xb503, -0x555, x4, 1808, x5)

inst_475:
// rs1_val==46339 and imm_val==6, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb503;  immval:0x6
TEST_IMM_OP( ori, x11, x10, 0xb507, 0xb503, 0x6, x4, 1812, x5)

inst_476:
// rs1_val==46339 and imm_val==820, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb503;  immval:0x334
TEST_IMM_OP( ori, x11, x10, 0xb737, 0xb503, 0x334, x4, 1816, x5)

inst_477:
// rs1_val==46339 and imm_val==1639, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb503;  immval:0x667
TEST_IMM_OP( ori, x11, x10, 0xb767, 0xb503, 0x667, x4, 1820, x5)

inst_478:
// rs1_val==46339 and imm_val==-44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb503;  immval:-0x2c
TEST_IMM_OP( ori, x11, x10, 0xffffffd7, 0xb503, -0x2c, x4, 1824, x5)

inst_479:
// rs1_val==46339 and imm_val==46, 
// opcode: ori ; op1:x10; dest:x11; op1val:0xb503;  immval:0x2e
TEST_IMM_OP( ori, x11, x10, 0xb52f, 0xb503, 0x2e, x4, 1828, x5)

inst_480:
// rs1_val==1431655766 and imm_val==3, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555556;  immval:0x3
TEST_IMM_OP( ori, x11, x10, 0x55555557, 0x55555556, 0x3, x4, 1832, x5)

inst_481:
// rs1_val==1431655766 and imm_val==1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555556;  immval:0x555
TEST_IMM_OP( ori, x11, x10, 0x55555557, 0x55555556, 0x555, x4, 1836, x5)

inst_482:
// rs1_val==1431655766 and imm_val==-1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555556;  immval:-0x556
TEST_IMM_OP( ori, x11, x10, 0xfffffffe, 0x55555556, -0x556, x4, 1840, x5)

inst_483:
// rs1_val==1431655766 and imm_val==5, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555556;  immval:0x5
TEST_IMM_OP( ori, x11, x10, 0x55555557, 0x55555556, 0x5, x4, 1844, x5)

inst_484:
// rs1_val==1431655766 and imm_val==819, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555556;  immval:0x333
TEST_IMM_OP( ori, x11, x10, 0x55555777, 0x55555556, 0x333, x4, 1848, x5)

inst_485:
// rs1_val==1431655766 and imm_val==1638, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555556;  immval:0x666
TEST_IMM_OP( ori, x11, x10, 0x55555776, 0x55555556, 0x666, x4, 1852, x5)

inst_486:
// rs1_val==1431655766 and imm_val==-45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555556;  immval:-0x2d
TEST_IMM_OP( ori, x11, x10, 0xffffffd7, 0x55555556, -0x2d, x4, 1856, x5)

inst_487:
// rs1_val==1431655766 and imm_val==45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555556;  immval:0x2d
TEST_IMM_OP( ori, x11, x10, 0x5555557f, 0x55555556, 0x2d, x4, 1860, x5)

inst_488:
// rs1_val==1431655766 and imm_val==2, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555556;  immval:0x2
TEST_IMM_OP( ori, x11, x10, 0x55555556, 0x55555556, 0x2, x4, 1864, x5)

inst_489:
// rs1_val==1431655766 and imm_val==1364, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555556;  immval:0x554
TEST_IMM_OP( ori, x11, x10, 0x55555556, 0x55555556, 0x554, x4, 1868, x5)

inst_490:
// rs1_val==1431655766 and imm_val==0, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555556;  immval:0x0
TEST_IMM_OP( ori, x11, x10, 0x55555556, 0x55555556, 0x0, x4, 1872, x5)

inst_491:
// rs1_val==1431655766 and imm_val==4, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555556;  immval:0x4
TEST_IMM_OP( ori, x11, x10, 0x55555556, 0x55555556, 0x4, x4, 1876, x5)

inst_492:
// rs1_val==1431655766 and imm_val==818, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555556;  immval:0x332
TEST_IMM_OP( ori, x11, x10, 0x55555776, 0x55555556, 0x332, x4, 1880, x5)

inst_493:
// rs1_val==1431655766 and imm_val==1637, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555556;  immval:0x665
TEST_IMM_OP( ori, x11, x10, 0x55555777, 0x55555556, 0x665, x4, 1884, x5)

inst_494:
// rs1_val==1431655766 and imm_val==44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555556;  immval:0x2c
TEST_IMM_OP( ori, x11, x10, 0x5555557e, 0x55555556, 0x2c, x4, 1888, x5)

inst_495:
// rs1_val==1431655766 and imm_val==1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555556;  immval:0x556
TEST_IMM_OP( ori, x11, x10, 0x55555556, 0x55555556, 0x556, x4, 1892, x5)

inst_496:
// rs1_val==1431655766 and imm_val==-1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555556;  immval:-0x555
TEST_IMM_OP( ori, x11, x10, 0xffffffff, 0x55555556, -0x555, x4, 1896, x5)

inst_497:
// rs1_val==1431655766 and imm_val==6, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555556;  immval:0x6
TEST_IMM_OP( ori, x11, x10, 0x55555556, 0x55555556, 0x6, x4, 1900, x5)

inst_498:
// rs1_val==1431655766 and imm_val==820, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555556;  immval:0x334
TEST_IMM_OP( ori, x11, x10, 0x55555776, 0x55555556, 0x334, x4, 1904, x5)

inst_499:
// rs1_val==1431655766 and imm_val==1639, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555556;  immval:0x667
TEST_IMM_OP( ori, x11, x10, 0x55555777, 0x55555556, 0x667, x4, 1908, x5)

inst_500:
// rs1_val==1431655766 and imm_val==-44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555556;  immval:-0x2c
TEST_IMM_OP( ori, x11, x10, 0xffffffd6, 0x55555556, -0x2c, x4, 1912, x5)

inst_501:
// rs1_val==1431655766 and imm_val==46, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x55555556;  immval:0x2e
TEST_IMM_OP( ori, x11, x10, 0x5555557e, 0x55555556, 0x2e, x4, 1916, x5)

inst_502:
// rs1_val==-1431655765 and imm_val==3, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555555;  immval:0x3
TEST_IMM_OP( ori, x11, x10, 0xaaaaaaab, -0x55555555, 0x3, x4, 1920, x5)

inst_503:
// rs1_val==-1431655765 and imm_val==1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555555;  immval:0x555
TEST_IMM_OP( ori, x11, x10, 0xaaaaafff, -0x55555555, 0x555, x4, 1924, x5)

inst_504:
// rs1_val==-1431655765 and imm_val==-1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555555;  immval:-0x556
TEST_IMM_OP( ori, x11, x10, 0xfffffaab, -0x55555555, -0x556, x4, 1928, x5)

inst_505:
// rs1_val==-1431655765 and imm_val==5, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555555;  immval:0x5
TEST_IMM_OP( ori, x11, x10, 0xaaaaaaaf, -0x55555555, 0x5, x4, 1932, x5)

inst_506:
// rs1_val==-1431655765 and imm_val==819, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555555;  immval:0x333
TEST_IMM_OP( ori, x11, x10, 0xaaaaabbb, -0x55555555, 0x333, x4, 1936, x5)

inst_507:
// rs1_val==-1431655765 and imm_val==1638, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555555;  immval:0x666
TEST_IMM_OP( ori, x11, x10, 0xaaaaaeef, -0x55555555, 0x666, x4, 1940, x5)

inst_508:
// rs1_val==-1431655765 and imm_val==-45, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555555;  immval:-0x2d
TEST_IMM_OP( ori, x11, x10, 0xfffffffb, -0x55555555, -0x2d, x4, 1944, x5)

inst_509:
// rs1_val==-1431655765 and imm_val==45, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555555;  immval:0x2d
TEST_IMM_OP( ori, x11, x10, 0xaaaaaaaf, -0x55555555, 0x2d, x4, 1948, x5)

inst_510:
// rs1_val==-1431655765 and imm_val==2, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555555;  immval:0x2
TEST_IMM_OP( ori, x11, x10, 0xaaaaaaab, -0x55555555, 0x2, x4, 1952, x5)

inst_511:
// rs1_val==-1431655765 and imm_val==1364, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555555;  immval:0x554
TEST_IMM_OP( ori, x11, x10, 0xaaaaafff, -0x55555555, 0x554, x4, 1956, x5)

inst_512:
// rs1_val==-1431655765 and imm_val==0, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555555;  immval:0x0
TEST_IMM_OP( ori, x11, x10, 0xaaaaaaab, -0x55555555, 0x0, x4, 1960, x5)

inst_513:
// rs1_val==-1431655765 and imm_val==4, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555555;  immval:0x4
TEST_IMM_OP( ori, x11, x10, 0xaaaaaaaf, -0x55555555, 0x4, x4, 1964, x5)

inst_514:
// rs1_val==-1431655765 and imm_val==818, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555555;  immval:0x332
TEST_IMM_OP( ori, x11, x10, 0xaaaaabbb, -0x55555555, 0x332, x4, 1968, x5)

inst_515:
// rs1_val==-1431655765 and imm_val==1637, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555555;  immval:0x665
TEST_IMM_OP( ori, x11, x10, 0xaaaaaeef, -0x55555555, 0x665, x4, 1972, x5)

inst_516:
// rs1_val==-1431655765 and imm_val==44, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555555;  immval:0x2c
TEST_IMM_OP( ori, x11, x10, 0xaaaaaaaf, -0x55555555, 0x2c, x4, 1976, x5)

inst_517:
// rs1_val==-1431655765 and imm_val==1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555555;  immval:0x556
TEST_IMM_OP( ori, x11, x10, 0xaaaaafff, -0x55555555, 0x556, x4, 1980, x5)

inst_518:
// rs1_val==-1431655765 and imm_val==-1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555555;  immval:-0x555
TEST_IMM_OP( ori, x11, x10, 0xfffffaab, -0x55555555, -0x555, x4, 1984, x5)

inst_519:
// rs1_val==-1431655765 and imm_val==6, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555555;  immval:0x6
TEST_IMM_OP( ori, x11, x10, 0xaaaaaaaf, -0x55555555, 0x6, x4, 1988, x5)

inst_520:
// rs1_val==-1431655765 and imm_val==820, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555555;  immval:0x334
TEST_IMM_OP( ori, x11, x10, 0xaaaaabbf, -0x55555555, 0x334, x4, 1992, x5)

inst_521:
// rs1_val==-1431655765 and imm_val==1639, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555555;  immval:0x667
TEST_IMM_OP( ori, x11, x10, 0xaaaaaeef, -0x55555555, 0x667, x4, 1996, x5)

inst_522:
// rs1_val==-1431655765 and imm_val==-44, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555555;  immval:-0x2c
TEST_IMM_OP( ori, x11, x10, 0xffffffff, -0x55555555, -0x2c, x4, 2000, x5)

inst_523:
// rs1_val==-1431655765 and imm_val==46, 
// opcode: ori ; op1:x10; dest:x11; op1val:-0x55555555;  immval:0x2e
TEST_IMM_OP( ori, x11, x10, 0xaaaaaaaf, -0x55555555, 0x2e, x4, 2004, x5)

inst_524:
// rs1_val==6 and imm_val==3, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x6;  immval:0x3
TEST_IMM_OP( ori, x11, x10, 0x7, 0x6, 0x3, x4, 2008, x5)

inst_525:
// rs1_val==6 and imm_val==1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x6;  immval:0x555
TEST_IMM_OP( ori, x11, x10, 0x557, 0x6, 0x555, x4, 2012, x5)

inst_526:
// rs1_val==6 and imm_val==-1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x6;  immval:-0x556
TEST_IMM_OP( ori, x11, x10, 0xfffffaae, 0x6, -0x556, x4, 2016, x5)

inst_527:
// rs1_val==6 and imm_val==5, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x6;  immval:0x5
TEST_IMM_OP( ori, x11, x10, 0x7, 0x6, 0x5, x4, 2020, x5)

inst_528:
// rs1_val==6 and imm_val==819, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x6;  immval:0x333
TEST_IMM_OP( ori, x11, x10, 0x337, 0x6, 0x333, x4, 2024, x5)

inst_529:
// rs1_val==6 and imm_val==1638, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x6;  immval:0x666
TEST_IMM_OP( ori, x11, x10, 0x666, 0x6, 0x666, x4, 2028, x5)

inst_530:
// rs1_val==6 and imm_val==-45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x6;  immval:-0x2d
TEST_IMM_OP( ori, x11, x10, 0xffffffd7, 0x6, -0x2d, x4, 2032, x5)

inst_531:
// rs1_val==6 and imm_val==45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x6;  immval:0x2d
TEST_IMM_OP( ori, x11, x10, 0x2f, 0x6, 0x2d, x4, 2036, x5)

inst_532:
// rs1_val==6 and imm_val==2, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x6;  immval:0x2
TEST_IMM_OP( ori, x11, x10, 0x6, 0x6, 0x2, x4, 2040, x5)

inst_533:
// rs1_val==6 and imm_val==1364, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x6;  immval:0x554
TEST_IMM_OP( ori, x11, x10, 0x556, 0x6, 0x554, x4, 2044, x5)
RVTEST_SIGBASE( x4,signature_x4_1)

inst_534:
// rs1_val==6 and imm_val==0, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x6;  immval:0x0
TEST_IMM_OP( ori, x11, x10, 0x6, 0x6, 0x0, x4, 0, x5)

inst_535:
// rs1_val==6 and imm_val==4, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x6;  immval:0x4
TEST_IMM_OP( ori, x11, x10, 0x6, 0x6, 0x4, x4, 4, x5)

inst_536:
// rs1_val==6 and imm_val==818, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x6;  immval:0x332
TEST_IMM_OP( ori, x11, x10, 0x336, 0x6, 0x332, x4, 8, x5)

inst_537:
// rs1_val==6 and imm_val==1637, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x6;  immval:0x665
TEST_IMM_OP( ori, x11, x10, 0x667, 0x6, 0x665, x4, 12, x5)

inst_538:
// rs1_val==6 and imm_val==44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x6;  immval:0x2c
TEST_IMM_OP( ori, x11, x10, 0x2e, 0x6, 0x2c, x4, 16, x5)

inst_539:
// rs1_val==6 and imm_val==1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x6;  immval:0x556
TEST_IMM_OP( ori, x11, x10, 0x556, 0x6, 0x556, x4, 20, x5)

inst_540:
// rs1_val==6 and imm_val==-1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x6;  immval:-0x555
TEST_IMM_OP( ori, x11, x10, 0xfffffaaf, 0x6, -0x555, x4, 24, x5)

inst_541:
// rs1_val==6 and imm_val==6, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x6;  immval:0x6
TEST_IMM_OP( ori, x11, x10, 0x6, 0x6, 0x6, x4, 28, x5)

inst_542:
// rs1_val==6 and imm_val==820, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x6;  immval:0x334
TEST_IMM_OP( ori, x11, x10, 0x336, 0x6, 0x334, x4, 32, x5)

inst_543:
// rs1_val==6 and imm_val==1639, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x6;  immval:0x667
TEST_IMM_OP( ori, x11, x10, 0x667, 0x6, 0x667, x4, 36, x5)

inst_544:
// rs1_val==6 and imm_val==-44, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x6;  immval:-0x2c
TEST_IMM_OP( ori, x11, x10, 0xffffffd6, 0x6, -0x2c, x4, 40, x5)

inst_545:
// rs1_val==6 and imm_val==46, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x6;  immval:0x2e
TEST_IMM_OP( ori, x11, x10, 0x2e, 0x6, 0x2e, x4, 44, x5)

inst_546:
// rs1_val==858993460 and imm_val==3, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333334;  immval:0x3
TEST_IMM_OP( ori, x11, x10, 0x33333337, 0x33333334, 0x3, x4, 48, x5)

inst_547:
// rs1_val==858993460 and imm_val==1365, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333334;  immval:0x555
TEST_IMM_OP( ori, x11, x10, 0x33333775, 0x33333334, 0x555, x4, 52, x5)

inst_548:
// rs1_val==858993460 and imm_val==-1366, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333334;  immval:-0x556
TEST_IMM_OP( ori, x11, x10, 0xfffffbbe, 0x33333334, -0x556, x4, 56, x5)

inst_549:
// rs1_val==858993460 and imm_val==5, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333334;  immval:0x5
TEST_IMM_OP( ori, x11, x10, 0x33333335, 0x33333334, 0x5, x4, 60, x5)

inst_550:
// rs1_val==858993460 and imm_val==819, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333334;  immval:0x333
TEST_IMM_OP( ori, x11, x10, 0x33333337, 0x33333334, 0x333, x4, 64, x5)

inst_551:
// rs1_val==858993460 and imm_val==1638, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333334;  immval:0x666
TEST_IMM_OP( ori, x11, x10, 0x33333776, 0x33333334, 0x666, x4, 68, x5)

inst_552:
// rs1_val==858993460 and imm_val==-45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333334;  immval:-0x2d
TEST_IMM_OP( ori, x11, x10, 0xfffffff7, 0x33333334, -0x2d, x4, 72, x5)

inst_553:
// rs1_val==858993460 and imm_val==45, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333334;  immval:0x2d
TEST_IMM_OP( ori, x11, x10, 0x3333333d, 0x33333334, 0x2d, x4, 76, x5)

inst_554:
// rs1_val==858993460 and imm_val==2, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333334;  immval:0x2
TEST_IMM_OP( ori, x11, x10, 0x33333336, 0x33333334, 0x2, x4, 80, x5)

inst_555:
// rs1_val==858993460 and imm_val==1364, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333334;  immval:0x554
TEST_IMM_OP( ori, x11, x10, 0x33333774, 0x33333334, 0x554, x4, 84, x5)

inst_556:
// rs1_val==858993460 and imm_val==0, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333334;  immval:0x0
TEST_IMM_OP( ori, x11, x10, 0x33333334, 0x33333334, 0x0, x4, 88, x5)

inst_557:
// rs1_val==858993460 and imm_val==4, 
// opcode: ori ; op1:x10; dest:x11; op1val:0x33333334;  immval:0x4
TEST_IMM_OP( ori, x11, x10, 0x33333334, 0x33333334, 0x4, x4, 92, x5)

inst_558:
// imm_val == 1024, rs1_val == -1073741825
// opcode: ori ; op1:x10; dest:x11; op1val:-0x40000001;  immval:0x400
TEST_IMM_OP( ori, x11, x10, 0xbfffffff, -0x40000001, 0x400, x4, 96, x5)

inst_559:
// imm_val == -17, rs1_val == -16385
// opcode: ori ; op1:x10; dest:x11; op1val:-0x4001;  immval:-0x11
TEST_IMM_OP( ori, x11, x10, 0xffffffff, -0x4001, -0x11, x4, 100, x5)
#endif


RVTEST_CODE_END
RVMODEL_HALT

RVTEST_DATA_BEGIN
.align 4

rvtest_data:
.word 0xbabecafe
.word 0xbabecafe
.word 0xbabecafe
.word 0xbabecafe
RVTEST_DATA_END


RVMODEL_DATA_BEGIN
rvtest_sig_begin:
sig_begin_canary:
CANARY;


signature_x2_0:
    .fill 0*(XLEN/32),4,0xdeadbeef


signature_x2_1:
    .fill 22*(XLEN/32),4,0xdeadbeef


signature_x4_0:
    .fill 512*(XLEN/32),4,0xdeadbeef


signature_x4_1:
    .fill 26*(XLEN/32),4,0xdeadbeef

#ifdef rvtest_mtrap_routine

tsig_begin_canary:
CANARY;
mtrap_sigptr:
    .fill 64*(XLEN/32),4,0xdeadbeef
tsig_end_canary:
CANARY;

#endif

#ifdef rvtest_gpr_save

gpr_save:
    .fill 32*(XLEN/32),4,0xdeadbeef

#endif

sig_end_canary:
CANARY;
rvtest_sig_end:
RVMODEL_DATA_END
