
// -----------
// This file was generated by riscv_ctg (https://gitlab.com/incoresemi/riscv-compliance/riscv_ctg)
// version   : 0.4.1
// timestamp : Tue Dec 15 15:36:11 2020 GMT
// usage     : riscv_ctg \
//                  -- cgf ('/scratch/git-repo/incoresemi/riscv-compliance/riscv_ctg/sample_cgfs/dataset.cgf', '/scratch/git-repo/incoresemi/riscv-compliance/riscv_ctg/sample_cgfs/rv32i.cgf') \
//                  -- xlen 32 \
// -----------
//
// -----------
// Copyright (c) 2020. RISC-V International. All rights reserved.
// SPDX-License-Identifier: BSD-3-Clause
// -----------
//
// This assembly file tests the sh instruction of the RISC-V I extension for the sh-align covergroup.
// 
#include "model_test.h"
#include "arch_test.h"
RVTEST_ISA("RV32I")

.section .text.init
.org 0x80
.globl rvtest_entry_point
rvtest_entry_point:
RVMODEL_BOOT
RVTEST_CODE_BEGIN

#ifdef TEST_CASE_1

RVTEST_CASE(0,"//check ISA:=regex(.*32.*);check ISA:=regex(.*I.*);def TEST_CASE_1=True;",sh-align)

RVTEST_SIGBASE( x4,signature_x4_1)

inst_0:
// rs1 != rs2, rs1==x15, rs2==x26, rs2_val == (-2**(xlen-1)), imm_val > 0, rs2_val == -2147483648, ea_align == 0 and (imm_val % 4) == 3
// opcode: sh; op1:x15; op2:x26; op2val:-0x80000000; immval:0x7; align:0
TEST_STORE(x4,x16,0,x15,x26,-0x80000000,0x7,0,sh,0)

inst_1:
// rs1==x10, rs2==x7, rs2_val == 0, imm_val < 0
// opcode: sh; op1:x10; op2:x7; op2val:0x0; immval:-0x5; align:0
TEST_STORE(x4,x16,0,x10,x7,0x0,-0x5,4,sh,0)

inst_2:
// rs1==x1, rs2==x8, rs2_val == (2**(xlen-1)-1), ea_align == 0 and (imm_val % 4) == 0, rs2_val == 2147483647
// opcode: sh; op1:x1; op2:x8; op2val:0x7fffffff; immval:0x10; align:0
TEST_STORE(x4,x16,0,x1,x8,0x7fffffff,0x10,8,sh,0)

inst_3:
// rs1==x22, rs2==x27, rs2_val == 1, 
// opcode: sh; op1:x22; op2:x27; op2val:0x1; immval:-0x21; align:0
TEST_STORE(x4,x16,0,x22,x27,0x1,-0x21,12,sh,0)

inst_4:
// rs1==x14, rs2==x18, ea_align == 0 and (imm_val % 4) == 1, 
// opcode: sh; op1:x14; op2:x18; op2val:-0x40000000; immval:-0x7; align:0
TEST_STORE(x4,x16,0,x14,x18,-0x40000000,-0x7,16,sh,0)

inst_5:
// rs1==x19, rs2==x2, ea_align == 0 and (imm_val % 4) == 2, rs2_val == -262145
// opcode: sh; op1:x19; op2:x2; op2val:-0x40001; immval:-0xa; align:0
TEST_STORE(x4,x16,0,x19,x2,-0x40001,-0xa,20,sh,0)

inst_6:
// rs1==x24, rs2==x9, ea_align == 2 and (imm_val % 4) == 0, rs2_val == -9
// opcode: sh; op1:x24; op2:x9; op2val:-0x9; immval:0x8; align:2
TEST_STORE(x4,x16,0,x24,x9,-0x9,0x8,24,sh,2)

inst_7:
// rs1==x3, rs2==x25, ea_align == 2 and (imm_val % 4) == 1, rs2_val == 1024
// opcode: sh; op1:x3; op2:x25; op2val:0x400; immval:-0x3; align:2
TEST_STORE(x4,x16,0,x3,x25,0x400,-0x3,28,sh,2)

inst_8:
// rs1==x11, rs2==x30, ea_align == 2 and (imm_val % 4) == 2, 
// opcode: sh; op1:x11; op2:x30; op2val:-0x40001; immval:0x2; align:2
TEST_STORE(x4,x16,0,x11,x30,-0x40001,0x2,32,sh,2)

inst_9:
// rs1==x26, rs2==x13, ea_align == 2 and (imm_val % 4) == 3, rs2_val == 512
// opcode: sh; op1:x26; op2:x13; op2val:0x200; immval:-0x9; align:2
TEST_STORE(x4,x16,0,x26,x13,0x200,-0x9,36,sh,2)

inst_10:
// rs1==x6, rs2==x11, imm_val == 0, 
// opcode: sh; op1:x6; op2:x11; op2val:-0x40000000; immval:0x0; align:0
TEST_STORE(x4,x16,0,x6,x11,-0x40000000,0x0,40,sh,0)

inst_11:
// rs1==x12, rs2==x20, rs2_val == 2, 
// opcode: sh; op1:x12; op2:x20; op2val:0x2; immval:0x0; align:0
TEST_STORE(x4,x16,0,x12,x20,0x2,0x0,44,sh,0)

inst_12:
// rs1==x7, rs2==x14, rs2_val == 4, 
// opcode: sh; op1:x7; op2:x14; op2val:0x4; immval:0x40; align:0
TEST_STORE(x4,x16,0,x7,x14,0x4,0x40,48,sh,0)

inst_13:
// rs1==x13, rs2==x1, rs2_val == 8, 
// opcode: sh; op1:x13; op2:x1; op2val:0x8; immval:-0x1; align:0
TEST_STORE(x4,x16,0,x13,x1,0x8,-0x1,52,sh,0)

inst_14:
// rs1==x27, rs2==x6, rs2_val == 16, 
// opcode: sh; op1:x27; op2:x6; op2val:0x10; immval:-0x8; align:0
TEST_STORE(x4,x16,0,x27,x6,0x10,-0x8,56,sh,0)

inst_15:
// rs1==x31, rs2==x22, rs2_val == 32, 
// opcode: sh; op1:x31; op2:x22; op2val:0x20; immval:0x40; align:0
TEST_STORE(x4,x16,0,x31,x22,0x20,0x40,60,sh,0)

inst_16:
// rs1==x8, rs2==x21, rs2_val == 64, 
// opcode: sh; op1:x8; op2:x21; op2val:0x40; immval:-0x2; align:0
TEST_STORE(x4,x16,0,x8,x21,0x40,-0x2,64,sh,0)

inst_17:
// rs1==x5, rs2==x28, rs2_val == 128, 
// opcode: sh; op1:x5; op2:x28; op2val:0x80; immval:-0x800; align:0
TEST_STORE(x4,x16,0,x5,x28,0x80,-0x800,68,sh,0)

inst_18:
// rs1==x18, rs2==x15, rs2_val == 256, 
// opcode: sh; op1:x18; op2:x15; op2val:0x100; immval:0x7; align:0
TEST_STORE(x4,x16,0,x18,x15,0x100,0x7,72,sh,0)

inst_19:
// rs1==x29, rs2==x17, rs2_val == 2048, 
// opcode: sh; op1:x29; op2:x17; op2val:0x800; immval:-0x2; align:0
TEST_STORE(x4,x16,0,x29,x17,0x800,-0x2,76,sh,0)
RVTEST_SIGBASE( x1,signature_x1_0)

inst_20:
// rs1==x23, rs2==x3, rs2_val == 4096, 
// opcode: sh; op1:x23; op2:x3; op2val:0x1000; immval:0x7ff; align:0
TEST_STORE(x1,x6,0,x23,x3,0x1000,0x7ff,0,sh,0)

inst_21:
// rs1==x20, rs2==x12, rs2_val == 8192, 
// opcode: sh; op1:x20; op2:x12; op2val:0x2000; immval:-0x2; align:0
TEST_STORE(x1,x6,0,x20,x12,0x2000,-0x2,4,sh,0)

inst_22:
// rs1==x16, rs2==x29, rs2_val == 16384, 
// opcode: sh; op1:x16; op2:x29; op2val:0x4000; immval:0x3; align:0
TEST_STORE(x1,x6,0,x16,x29,0x4000,0x3,8,sh,0)

inst_23:
// rs1==x25, rs2==x0, rs2_val == 32768, 
// opcode: sh; op1:x25; op2:x0; op2val:0x0; immval:-0x201; align:0
TEST_STORE(x1,x6,0,x25,x0,0x0,-0x201,12,sh,0)

inst_24:
// rs1==x4, rs2==x5, rs2_val == 65536, 
// opcode: sh; op1:x4; op2:x5; op2val:0x10000; immval:0x20; align:0
TEST_STORE(x1,x6,0,x4,x5,0x10000,0x20,16,sh,0)

inst_25:
// rs1==x30, rs2==x23, rs2_val == 131072, 
// opcode: sh; op1:x30; op2:x23; op2val:0x20000; immval:0x10; align:0
TEST_STORE(x1,x6,0,x30,x23,0x20000,0x10,20,sh,0)

inst_26:
// rs1==x28, rs2==x24, rs2_val == 262144, 
// opcode: sh; op1:x28; op2:x24; op2val:0x40000; immval:0x0; align:0
TEST_STORE(x1,x6,0,x28,x24,0x40000,0x0,24,sh,0)

inst_27:
// rs1==x21, rs2==x10, rs2_val == 524288, 
// opcode: sh; op1:x21; op2:x10; op2val:0x80000; immval:0x7ff; align:0
TEST_STORE(x1,x6,0,x21,x10,0x80000,0x7ff,28,sh,0)

inst_28:
// rs1==x17, rs2==x16, rs2_val == 1048576, 
// opcode: sh; op1:x17; op2:x16; op2val:0x100000; immval:-0x401; align:0
TEST_STORE(x1,x6,0,x17,x16,0x100000,-0x401,32,sh,0)

inst_29:
// rs1==x9, rs2==x19, rs2_val == 2097152, 
// opcode: sh; op1:x9; op2:x19; op2val:0x200000; immval:-0x556; align:0
TEST_STORE(x1,x6,0,x9,x19,0x200000,-0x556,36,sh,0)

inst_30:
// rs1==x2, rs2==x4, rs2_val == 4194304, 
// opcode: sh; op1:x2; op2:x4; op2val:0x400000; immval:0x80; align:0
TEST_STORE(x1,x6,0,x2,x4,0x400000,0x80,40,sh,0)

inst_31:
// rs2==x31, rs2_val == 8388608, 
// opcode: sh; op1:x29; op2:x31; op2val:0x800000; immval:0x0; align:0
TEST_STORE(x1,x6,0,x29,x31,0x800000,0x0,44,sh,0)

inst_32:
// rs2_val == 16777216, 
// opcode: sh; op1:x10; op2:x11; op2val:0x1000000; immval:0x3ff; align:0
TEST_STORE(x1,x6,0,x10,x11,0x1000000,0x3ff,48,sh,0)

inst_33:
// rs2_val == 33554432, 
// opcode: sh; op1:x10; op2:x11; op2val:0x2000000; immval:0x7ff; align:0
TEST_STORE(x1,x6,0,x10,x11,0x2000000,0x7ff,52,sh,0)

inst_34:
// rs2_val == 67108864, 
// opcode: sh; op1:x10; op2:x11; op2val:0x4000000; immval:0x555; align:0
TEST_STORE(x1,x6,0,x10,x11,0x4000000,0x555,56,sh,0)

inst_35:
// rs2_val == 134217728, 
// opcode: sh; op1:x10; op2:x11; op2val:0x8000000; immval:-0x8; align:0
TEST_STORE(x1,x6,0,x10,x11,0x8000000,-0x8,60,sh,0)

inst_36:
// rs2_val == 268435456, 
// opcode: sh; op1:x10; op2:x11; op2val:0x10000000; immval:0x6; align:0
TEST_STORE(x1,x6,0,x10,x11,0x10000000,0x6,64,sh,0)

inst_37:
// rs2_val == 536870912, 
// opcode: sh; op1:x10; op2:x11; op2val:0x20000000; immval:-0x5; align:0
TEST_STORE(x1,x6,0,x10,x11,0x20000000,-0x5,68,sh,0)

inst_38:
// rs2_val == 1073741824, 
// opcode: sh; op1:x10; op2:x11; op2val:0x40000000; immval:-0x800; align:0
TEST_STORE(x1,x6,0,x10,x11,0x40000000,-0x800,72,sh,0)

inst_39:
// rs2_val == -524289, 
// opcode: sh; op1:x10; op2:x11; op2val:-0x80001; immval:-0x101; align:0
TEST_STORE(x1,x6,0,x10,x11,-0x80001,-0x101,76,sh,0)

inst_40:
// rs2_val == -1048577, 
// opcode: sh; op1:x10; op2:x11; op2val:-0x100001; immval:0x40; align:0
TEST_STORE(x1,x6,0,x10,x11,-0x100001,0x40,80,sh,0)

inst_41:
// rs2_val == -2097153, 
// opcode: sh; op1:x10; op2:x11; op2val:-0x200001; immval:0x6; align:0
TEST_STORE(x1,x6,0,x10,x11,-0x200001,0x6,84,sh,0)

inst_42:
// rs2_val == -4194305, 
// opcode: sh; op1:x10; op2:x11; op2val:-0x400001; immval:0x555; align:0
TEST_STORE(x1,x6,0,x10,x11,-0x400001,0x555,88,sh,0)

inst_43:
// rs2_val == -8388609, 
// opcode: sh; op1:x10; op2:x11; op2val:-0x800001; immval:0x6; align:0
TEST_STORE(x1,x6,0,x10,x11,-0x800001,0x6,92,sh,0)

inst_44:
// rs2_val == -16777217, 
// opcode: sh; op1:x10; op2:x11; op2val:-0x1000001; immval:0x4; align:0
TEST_STORE(x1,x6,0,x10,x11,-0x1000001,0x4,96,sh,0)

inst_45:
// rs2_val == -33554433, 
// opcode: sh; op1:x10; op2:x11; op2val:-0x2000001; immval:-0x401; align:0
TEST_STORE(x1,x6,0,x10,x11,-0x2000001,-0x401,100,sh,0)

inst_46:
// rs2_val == -67108865, 
// opcode: sh; op1:x10; op2:x11; op2val:-0x4000001; immval:0x3; align:0
TEST_STORE(x1,x6,0,x10,x11,-0x4000001,0x3,104,sh,0)

inst_47:
// rs2_val == -134217729, 
// opcode: sh; op1:x10; op2:x11; op2val:-0x8000001; immval:0x5; align:0
TEST_STORE(x1,x6,0,x10,x11,-0x8000001,0x5,108,sh,0)

inst_48:
// rs2_val == -268435457, 
// opcode: sh; op1:x10; op2:x11; op2val:-0x10000001; immval:0x80; align:0
TEST_STORE(x1,x6,0,x10,x11,-0x10000001,0x80,112,sh,0)

inst_49:
// rs2_val == -536870913, 
// opcode: sh; op1:x10; op2:x11; op2val:-0x20000001; immval:0x10; align:0
TEST_STORE(x1,x6,0,x10,x11,-0x20000001,0x10,116,sh,0)

inst_50:
// rs2_val == -1073741825, 
// opcode: sh; op1:x10; op2:x11; op2val:-0x40000001; immval:-0x201; align:0
TEST_STORE(x1,x6,0,x10,x11,-0x40000001,-0x201,120,sh,0)

inst_51:
// rs2_val == 1431655765, 
// opcode: sh; op1:x10; op2:x11; op2val:0x55555555; immval:0x40; align:0
TEST_STORE(x1,x6,0,x10,x11,0x55555555,0x40,124,sh,0)

inst_52:
// rs2_val == -1431655766, 
// opcode: sh; op1:x10; op2:x11; op2val:-0x55555556; immval:-0x4; align:0
TEST_STORE(x1,x6,0,x10,x11,-0x55555556,-0x4,128,sh,0)

inst_53:
// rs2_val == -2, 
// opcode: sh; op1:x10; op2:x11; op2val:-0x2; immval:-0x41; align:0
TEST_STORE(x1,x6,0,x10,x11,-0x2,-0x41,132,sh,0)

inst_54:
// rs2_val == -3, 
// opcode: sh; op1:x10; op2:x11; op2val:-0x3; immval:-0x11; align:0
TEST_STORE(x1,x6,0,x10,x11,-0x3,-0x11,136,sh,0)

inst_55:
// rs2_val == -5, 
// opcode: sh; op1:x10; op2:x11; op2val:-0x5; immval:0x10; align:0
TEST_STORE(x1,x6,0,x10,x11,-0x5,0x10,140,sh,0)

inst_56:
// rs2_val == -17, 
// opcode: sh; op1:x10; op2:x11; op2val:-0x11; immval:0x20; align:0
TEST_STORE(x1,x6,0,x10,x11,-0x11,0x20,144,sh,0)

inst_57:
// rs2_val == -33, 
// opcode: sh; op1:x10; op2:x11; op2val:-0x21; immval:0x40; align:0
TEST_STORE(x1,x6,0,x10,x11,-0x21,0x40,148,sh,0)

inst_58:
// rs2_val == -65, 
// opcode: sh; op1:x10; op2:x11; op2val:-0x41; immval:-0x2; align:0
TEST_STORE(x1,x6,0,x10,x11,-0x41,-0x2,152,sh,0)

inst_59:
// rs2_val == -129, 
// opcode: sh; op1:x10; op2:x11; op2val:-0x81; immval:-0x9; align:0
TEST_STORE(x1,x6,0,x10,x11,-0x81,-0x9,156,sh,0)

inst_60:
// rs2_val == -257, 
// opcode: sh; op1:x10; op2:x11; op2val:-0x101; immval:-0x401; align:0
TEST_STORE(x1,x6,0,x10,x11,-0x101,-0x401,160,sh,0)

inst_61:
// rs2_val == -513, 
// opcode: sh; op1:x10; op2:x11; op2val:-0x201; immval:-0x3; align:0
TEST_STORE(x1,x6,0,x10,x11,-0x201,-0x3,164,sh,0)

inst_62:
// rs2_val == -1025, 
// opcode: sh; op1:x10; op2:x11; op2val:-0x401; immval:0x3; align:0
TEST_STORE(x1,x6,0,x10,x11,-0x401,0x3,168,sh,0)

inst_63:
// rs2_val == -2049, 
// opcode: sh; op1:x10; op2:x11; op2val:-0x801; immval:-0x21; align:0
TEST_STORE(x1,x6,0,x10,x11,-0x801,-0x21,172,sh,0)

inst_64:
// rs2_val == -4097, 
// opcode: sh; op1:x10; op2:x11; op2val:-0x1001; immval:-0x6; align:0
TEST_STORE(x1,x6,0,x10,x11,-0x1001,-0x6,176,sh,0)

inst_65:
// rs2_val == -8193, 
// opcode: sh; op1:x10; op2:x11; op2val:-0x2001; immval:0x10; align:0
TEST_STORE(x1,x6,0,x10,x11,-0x2001,0x10,180,sh,0)

inst_66:
// rs2_val == -16385, 
// opcode: sh; op1:x10; op2:x11; op2val:-0x4001; immval:-0xa; align:0
TEST_STORE(x1,x6,0,x10,x11,-0x4001,-0xa,184,sh,0)

inst_67:
// rs2_val == -32769, 
// opcode: sh; op1:x10; op2:x11; op2val:-0x8001; immval:0x200; align:0
TEST_STORE(x1,x6,0,x10,x11,-0x8001,0x200,188,sh,0)

inst_68:
// rs2_val == -65537, 
// opcode: sh; op1:x10; op2:x11; op2val:-0x10001; immval:-0x556; align:0
TEST_STORE(x1,x6,0,x10,x11,-0x10001,-0x556,192,sh,0)

inst_69:
// rs2_val == -131073, 
// opcode: sh; op1:x10; op2:x11; op2val:-0x20001; immval:-0x1; align:0
TEST_STORE(x1,x6,0,x10,x11,-0x20001,-0x1,196,sh,0)

inst_70:
// rs2_val == 32768, 
// opcode: sh; op1:x10; op2:x11; op2val:0x8000; immval:-0x201; align:0
TEST_STORE(x1,x6,0,x10,x11,0x8000,-0x201,200,sh,0)
#endif


RVTEST_CODE_END
RVMODEL_HALT

RVTEST_DATA_BEGIN
.align 4

rvtest_data:
.word 0xbabecafe
.word 0xbabecafe
.word 0xbabecafe
.word 0xbabecafe
RVTEST_DATA_END


RVMODEL_DATA_BEGIN
rvtest_sig_begin:
sig_begin_canary:
CANARY;


signature_x4_0:
    .fill 0*(XLEN/32),4,0xdeadbeef


signature_x4_1:
    .fill 20*(XLEN/32),4,0xdeadbeef


signature_x1_0:
    .fill 51*(XLEN/32),4,0xdeadbeef

#ifdef rvtest_mtrap_routine

tsig_begin_canary:
CANARY;
mtrap_sigptr:
    .fill 64*(XLEN/32),4,0xdeadbeef
tsig_end_canary:
CANARY;

#endif

#ifdef rvtest_gpr_save

gpr_save:
    .fill 32*(XLEN/32),4,0xdeadbeef

#endif

sig_end_canary:
CANARY;
rvtest_sig_end:
RVMODEL_DATA_END
