
// -----------
// This file was generated by riscv_ctg (https://gitlab.com/incoresemi/riscv-compliance/riscv_ctg)
// version   : 0.4.1
// timestamp : Tue Dec 15 15:36:11 2020 GMT
// usage     : riscv_ctg \
//                  -- cgf ('/scratch/git-repo/incoresemi/riscv-compliance/riscv_ctg/sample_cgfs/dataset.cgf', '/scratch/git-repo/incoresemi/riscv-compliance/riscv_ctg/sample_cgfs/rv32i.cgf') \
//                  -- xlen 32 \
// -----------
//
// -----------
// Copyright (c) 2020. RISC-V International. All rights reserved.
// SPDX-License-Identifier: BSD-3-Clause
// -----------
//
// This assembly file tests the slti instruction of the RISC-V I extension for the slti covergroup.
// 
#include "model_test.h"
#include "arch_test.h"
RVTEST_ISA("RV32I")

.section .text.init
.org 0x80
.globl rvtest_entry_point
rvtest_entry_point:
RVMODEL_BOOT
RVTEST_CODE_BEGIN

#ifdef TEST_CASE_1

RVTEST_CASE(0,"//check ISA:=regex(.*32.*);check ISA:=regex(.*I.*);def TEST_CASE_1=True;",slti)

RVTEST_SIGBASE( x2,signature_x2_1)

inst_0:
// rs1 != rd, rs1==x25, rd==x12, imm_val == (-2**(12-1)), imm_val == -2048, rs1_val != imm_val, rs1_val == -129, rs1_val < 0 and imm_val < 0
// opcode: slti ; op1:x25; dest:x12; op1val:-0x81;  immval:-0x800
TEST_IMM_OP( slti, x12, x25, 0x0, -0x81, -0x800, x2, 0, x19)

inst_1:
// rs1 == rd, rs1==x5, rd==x5, imm_val == 0, rs1_val == -4097
// opcode: slti ; op1:x5; dest:x5; op1val:-0x1001;  immval:0x0
TEST_IMM_OP( slti, x5, x5, 0x1, -0x1001, 0x0, x2, 4, x19)

inst_2:
// rs1==x4, rd==x28, imm_val == (2**(12-1)-1), rs1_val < 0 and imm_val > 0, imm_val == 2047
// opcode: slti ; op1:x4; dest:x28; op1val:-0x40000000;  immval:0x7ff
TEST_IMM_OP( slti, x28, x4, 0x1, -0x40000000, 0x7ff, x2, 8, x19)

inst_3:
// rs1==x31, rd==x15, imm_val == 1, rs1_val == -17
// opcode: slti ; op1:x31; dest:x15; op1val:-0x11;  immval:0x1
TEST_IMM_OP( slti, x15, x31, 0x1, -0x11, 0x1, x2, 12, x19)

inst_4:
// rs1==x1, rd==x13, rs1_val == (-2**(xlen-1)), rs1_val == -2147483648
// opcode: slti ; op1:x1; dest:x13; op1val:-0x80000000;  immval:0x3
TEST_IMM_OP( slti, x13, x1, 0x1, -0x80000000, 0x3, x2, 16, x19)

inst_5:
// rs1==x15, rd==x1, rs1_val == 0, rs1_val==0 and imm_val==2, imm_val == 2
// opcode: slti ; op1:x15; dest:x1; op1val:0x0;  immval:0x2
TEST_IMM_OP( slti, x1, x15, 0x1, 0x0, 0x2, x2, 20, x19)

inst_6:
// rs1==x16, rd==x9, rs1_val == (2**(xlen-1)-1), rs1_val > 0 and imm_val < 0, rs1_val == 2147483647
// opcode: slti ; op1:x16; dest:x9; op1val:0x7fffffff;  immval:-0x8
TEST_IMM_OP( slti, x9, x16, 0x0, 0x7fffffff, -0x8, x2, 24, x19)

inst_7:
// rs1==x11, rd==x31, rs1_val == 1, 
// opcode: slti ; op1:x11; dest:x31; op1val:0x1;  immval:-0x400
TEST_IMM_OP( slti, x31, x11, 0x0, 0x1, -0x400, x2, 28, x19)

inst_8:
// rs1==x14, rd==x27, rs1_val == imm_val, imm_val == 16, rs1_val > 0 and imm_val > 0, rs1_val == 16
// opcode: slti ; op1:x14; dest:x27; op1val:0x10;  immval:0x10
TEST_IMM_OP( slti, x27, x14, 0x0, 0x10, 0x10, x2, 32, x19)

inst_9:
// rs1==x12, rd==x26, imm_val == 4, rs1_val==858993460 and imm_val==4
// opcode: slti ; op1:x12; dest:x26; op1val:0x33333334;  immval:0x4
TEST_IMM_OP( slti, x26, x12, 0x0, 0x33333334, 0x4, x2, 36, x19)

inst_10:
// rs1==x17, rd==x4, imm_val == 8, 
// opcode: slti ; op1:x17; dest:x4; op1val:0x3fffffff;  immval:0x8
TEST_IMM_OP( slti, x4, x17, 0x0, 0x3fffffff, 0x8, x2, 40, x19)

inst_11:
// rs1==x18, rd==x10, imm_val == 32, rs1_val == -8193
// opcode: slti ; op1:x18; dest:x10; op1val:-0x2001;  immval:0x20
TEST_IMM_OP( slti, x10, x18, 0x1, -0x2001, 0x20, x2, 44, x19)

inst_12:
// rs1==x27, rd==x21, imm_val == 64, 
// opcode: slti ; op1:x27; dest:x21; op1val:0x3;  immval:0x40
TEST_IMM_OP( slti, x21, x27, 0x1, 0x3, 0x40, x2, 48, x19)

inst_13:
// rs1==x3, rd==x8, imm_val == 128, 
// opcode: slti ; op1:x3; dest:x8; op1val:0x55555554;  immval:0x80
TEST_IMM_OP( slti, x8, x3, 0x0, 0x55555554, 0x80, x2, 52, x19)

inst_14:
// rs1==x7, rd==x0, imm_val == 256, 
// opcode: slti ; op1:x7; dest:x0; op1val:0x55555554;  immval:0x100
TEST_IMM_OP( slti, x0, x7, 0, 0x55555554, 0x100, x2, 56, x19)

inst_15:
// rs1==x22, rd==x24, imm_val == 512, rs1_val == -1431655766
// opcode: slti ; op1:x22; dest:x24; op1val:-0x55555556;  immval:0x200
TEST_IMM_OP( slti, x24, x22, 0x1, -0x55555556, 0x200, x2, 60, x19)

inst_16:
// rs1==x24, rd==x18, imm_val == 1024, rs1_val == 16384
// opcode: slti ; op1:x24; dest:x18; op1val:0x4000;  immval:0x400
TEST_IMM_OP( slti, x18, x24, 0x0, 0x4000, 0x400, x2, 64, x19)

inst_17:
// rs1==x6, rd==x25, imm_val == -2, rs1_val == -1025
// opcode: slti ; op1:x6; dest:x25; op1val:-0x401;  immval:-0x2
TEST_IMM_OP( slti, x25, x6, 0x1, -0x401, -0x2, x2, 68, x19)

inst_18:
// rs1==x21, rd==x23, imm_val == -3, 
// opcode: slti ; op1:x21; dest:x23; op1val:0x66666667;  immval:-0x3
TEST_IMM_OP( slti, x23, x21, 0x0, 0x66666667, -0x3, x2, 72, x19)

inst_19:
// rs1==x0, rd==x7, imm_val == -5, rs1_val == -1048577
// opcode: slti ; op1:x0; dest:x7; op1val:0x0;  immval:-0x5
TEST_IMM_OP( slti, x7, x0, 0x0, 0x0, -0x5, x2, 76, x19)

inst_20:
// rs1==x10, rd==x20, imm_val == -9, 
// opcode: slti ; op1:x10; dest:x20; op1val:-0xb504;  immval:-0x9
TEST_IMM_OP( slti, x20, x10, 0x1, -0xb504, -0x9, x2, 80, x19)

inst_21:
// rs1==x26, rd==x16, imm_val == -17, 
// opcode: slti ; op1:x26; dest:x16; op1val:0x3fffffff;  immval:-0x11
TEST_IMM_OP( slti, x16, x26, 0x0, 0x3fffffff, -0x11, x2, 84, x4)

inst_22:
// rs1==x20, rd==x29, imm_val == -33, rs1_val == -524289
// opcode: slti ; op1:x20; dest:x29; op1val:-0x80001;  immval:-0x21
TEST_IMM_OP( slti, x29, x20, 0x1, -0x80001, -0x21, x2, 88, x4)
RVTEST_SIGBASE( x1,signature_x1_0)

inst_23:
// rs1==x13, rd==x3, imm_val == -65, rs1_val == -268435457
// opcode: slti ; op1:x13; dest:x3; op1val:-0x10000001;  immval:-0x41
TEST_IMM_OP( slti, x3, x13, 0x1, -0x10000001, -0x41, x1, 0, x4)

inst_24:
// rs1==x29, rd==x14, imm_val == -129, rs1_val == 8388608
// opcode: slti ; op1:x29; dest:x14; op1val:0x800000;  immval:-0x81
TEST_IMM_OP( slti, x14, x29, 0x0, 0x800000, -0x81, x1, 4, x4)

inst_25:
// rs1==x23, rd==x2, imm_val == -257, 
// opcode: slti ; op1:x23; dest:x2; op1val:-0x10000001;  immval:-0x101
TEST_IMM_OP( slti, x2, x23, 0x1, -0x10000001, -0x101, x1, 8, x4)

inst_26:
// rs1==x2, rd==x22, imm_val == -513, 
// opcode: slti ; op1:x2; dest:x22; op1val:0x0;  immval:-0x201
TEST_IMM_OP( slti, x22, x2, 0x0, 0x0, -0x201, x1, 12, x4)

inst_27:
// rs1==x30, rd==x19, imm_val == -1025, rs1_val == -262145
// opcode: slti ; op1:x30; dest:x19; op1val:-0x40001;  immval:-0x401
TEST_IMM_OP( slti, x19, x30, 0x1, -0x40001, -0x401, x1, 16, x4)

inst_28:
// rs1==x19, rd==x11, imm_val == 1365, rs1_val == 4, rs1_val==4 and imm_val==1365
// opcode: slti ; op1:x19; dest:x11; op1val:0x4;  immval:0x555
TEST_IMM_OP( slti, x11, x19, 0x1, 0x4, 0x555, x1, 20, x4)

inst_29:
// rs1==x8, rd==x30, imm_val == -1366, 
// opcode: slti ; op1:x8; dest:x30; op1val:-0x40000000;  immval:-0x556
TEST_IMM_OP( slti, x30, x8, 0x1, -0x40000000, -0x556, x1, 24, x4)

inst_30:
// rs1==x9, rd==x17, rs1_val == 2, 
// opcode: slti ; op1:x9; dest:x17; op1val:0x2;  immval:0x7ff
TEST_IMM_OP( slti, x17, x9, 0x1, 0x2, 0x7ff, x1, 28, x4)

inst_31:
// rs1==x28, rd==x6, rs1_val == 8, 
// opcode: slti ; op1:x28; dest:x6; op1val:0x8;  immval:-0x555
TEST_IMM_OP( slti, x6, x28, 0x0, 0x8, -0x555, x1, 32, x4)

inst_32:
// rs1_val == 32, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x20;  immval:0x555
TEST_IMM_OP( slti, x11, x10, 0x1, 0x20, 0x555, x1, 36, x4)

inst_33:
// rs1_val == 64, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x40;  immval:0x555
TEST_IMM_OP( slti, x11, x10, 0x1, 0x40, 0x555, x1, 40, x4)

inst_34:
// rs1_val == 128, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x80;  immval:0x200
TEST_IMM_OP( slti, x11, x10, 0x1, 0x80, 0x200, x1, 44, x4)

inst_35:
// rs1_val == 256, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x100;  immval:0x2e
TEST_IMM_OP( slti, x11, x10, 0x0, 0x100, 0x2e, x1, 48, x4)

inst_36:
// rs1_val == 512, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x200;  immval:-0x3
TEST_IMM_OP( slti, x11, x10, 0x0, 0x200, -0x3, x1, 52, x4)

inst_37:
// rs1_val == 1024, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x400;  immval:-0x101
TEST_IMM_OP( slti, x11, x10, 0x0, 0x400, -0x101, x1, 56, x4)

inst_38:
// rs1_val == 2048, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x800;  immval:0x2d
TEST_IMM_OP( slti, x11, x10, 0x0, 0x800, 0x2d, x1, 60, x4)

inst_39:
// rs1_val == 4096, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x1000;  immval:-0x5
TEST_IMM_OP( slti, x11, x10, 0x0, 0x1000, -0x5, x1, 64, x4)

inst_40:
// rs1_val == 8192, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x2000;  immval:0x0
TEST_IMM_OP( slti, x11, x10, 0x0, 0x2000, 0x0, x1, 68, x4)

inst_41:
// rs1_val == 32768, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x8000;  immval:-0x556
TEST_IMM_OP( slti, x11, x10, 0x0, 0x8000, -0x556, x1, 72, x4)

inst_42:
// rs1_val == 65536, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x10000;  immval:-0x1
TEST_IMM_OP( slti, x11, x10, 0x0, 0x10000, -0x1, x1, 76, x4)

inst_43:
// rs1_val == 131072, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x20000;  immval:-0x2
TEST_IMM_OP( slti, x11, x10, 0x0, 0x20000, -0x2, x1, 80, x4)

inst_44:
// rs1_val == 262144, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x40000;  immval:0x6
TEST_IMM_OP( slti, x11, x10, 0x0, 0x40000, 0x6, x1, 84, x4)

inst_45:
// rs1_val == 524288, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x80000;  immval:-0x41
TEST_IMM_OP( slti, x11, x10, 0x0, 0x80000, -0x41, x1, 88, x4)

inst_46:
// rs1_val == 1048576, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x100000;  immval:-0x556
TEST_IMM_OP( slti, x11, x10, 0x0, 0x100000, -0x556, x1, 92, x4)

inst_47:
// rs1_val == 2097152, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x200000;  immval:-0x11
TEST_IMM_OP( slti, x11, x10, 0x0, 0x200000, -0x11, x1, 96, x4)

inst_48:
// rs1_val == 4194304, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x400000;  immval:0x2e
TEST_IMM_OP( slti, x11, x10, 0x0, 0x400000, 0x2e, x1, 100, x4)

inst_49:
// rs1_val == 16777216, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x1000000;  immval:-0x2c
TEST_IMM_OP( slti, x11, x10, 0x0, 0x1000000, -0x2c, x1, 104, x4)

inst_50:
// rs1_val == 33554432, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x2000000;  immval:0x555
TEST_IMM_OP( slti, x11, x10, 0x0, 0x2000000, 0x555, x1, 108, x4)

inst_51:
// rs1_val == 67108864, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x4000000;  immval:-0x41
TEST_IMM_OP( slti, x11, x10, 0x0, 0x4000000, -0x41, x1, 112, x4)

inst_52:
// rs1_val == 134217728, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x8000000;  immval:0x7ff
TEST_IMM_OP( slti, x11, x10, 0x0, 0x8000000, 0x7ff, x1, 116, x4)

inst_53:
// rs1_val == 268435456, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x10000000;  immval:0x2d
TEST_IMM_OP( slti, x11, x10, 0x0, 0x10000000, 0x2d, x1, 120, x4)

inst_54:
// rs1_val == 536870912, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x20000000;  immval:0x0
TEST_IMM_OP( slti, x11, x10, 0x0, 0x20000000, 0x0, x1, 124, x4)

inst_55:
// rs1_val == 1073741824, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x40000000;  immval:-0x11
TEST_IMM_OP( slti, x11, x10, 0x0, 0x40000000, -0x11, x1, 128, x4)

inst_56:
// rs1_val == -2, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0x2;  immval:0x1
TEST_IMM_OP( slti, x11, x10, 0x1, -0x2, 0x1, x1, 132, x4)

inst_57:
// rs1_val == -3, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0x3;  immval:-0x555
TEST_IMM_OP( slti, x11, x10, 0x0, -0x3, -0x555, x1, 136, x4)

inst_58:
// rs1_val == -5, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0x5;  immval:0x100
TEST_IMM_OP( slti, x11, x10, 0x1, -0x5, 0x100, x1, 140, x4)

inst_59:
// rs1_val == -9, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0x9;  immval:0x2
TEST_IMM_OP( slti, x11, x10, 0x1, -0x9, 0x2, x1, 144, x4)

inst_60:
// rs1_val == -33, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0x21;  immval:0x1
TEST_IMM_OP( slti, x11, x10, 0x1, -0x21, 0x1, x1, 148, x4)

inst_61:
// rs1_val == -65, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0x41;  immval:-0x4
TEST_IMM_OP( slti, x11, x10, 0x1, -0x41, -0x4, x1, 152, x4)

inst_62:
// rs1_val == -257, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0x101;  immval:-0x800
TEST_IMM_OP( slti, x11, x10, 0x0, -0x101, -0x800, x1, 156, x4)

inst_63:
// rs1_val == -513, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0x201;  immval:0x9
TEST_IMM_OP( slti, x11, x10, 0x1, -0x201, 0x9, x1, 160, x4)

inst_64:
// rs1_val == -2049, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0x801;  immval:-0x8
TEST_IMM_OP( slti, x11, x10, 0x1, -0x801, -0x8, x1, 164, x4)

inst_65:
// rs1_val == -16385, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0x4001;  immval:0x400
TEST_IMM_OP( slti, x11, x10, 0x1, -0x4001, 0x400, x1, 168, x4)

inst_66:
// rs1_val == -32769, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0x8001;  immval:0x333
TEST_IMM_OP( slti, x11, x10, 0x1, -0x8001, 0x333, x1, 172, x4)

inst_67:
// rs1_val == -65537, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0x10001;  immval:-0x101
TEST_IMM_OP( slti, x11, x10, 0x1, -0x10001, -0x101, x1, 176, x4)

inst_68:
// rs1_val == -131073, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0x20001;  immval:0x3
TEST_IMM_OP( slti, x11, x10, 0x1, -0x20001, 0x3, x1, 180, x4)

inst_69:
// rs1_val == -2097153, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0x200001;  immval:-0x6
TEST_IMM_OP( slti, x11, x10, 0x1, -0x200001, -0x6, x1, 184, x4)

inst_70:
// rs1_val == -4194305, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0x400001;  immval:0x555
TEST_IMM_OP( slti, x11, x10, 0x1, -0x400001, 0x555, x1, 188, x4)

inst_71:
// rs1_val == -8388609, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0x800001;  immval:0x7
TEST_IMM_OP( slti, x11, x10, 0x1, -0x800001, 0x7, x1, 192, x4)

inst_72:
// rs1_val == -16777217, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0x1000001;  immval:-0x2d
TEST_IMM_OP( slti, x11, x10, 0x1, -0x1000001, -0x2d, x1, 196, x4)

inst_73:
// rs1_val == -33554433, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0x2000001;  immval:0x334
TEST_IMM_OP( slti, x11, x10, 0x1, -0x2000001, 0x334, x1, 200, x4)

inst_74:
// rs1_val == -67108865, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0x4000001;  immval:-0x4
TEST_IMM_OP( slti, x11, x10, 0x1, -0x4000001, -0x4, x1, 204, x4)

inst_75:
// rs1_val == -134217729, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0x8000001;  immval:0x2d
TEST_IMM_OP( slti, x11, x10, 0x1, -0x8000001, 0x2d, x1, 208, x4)

inst_76:
// rs1_val == -536870913, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0x20000001;  immval:0x10
TEST_IMM_OP( slti, x11, x10, 0x1, -0x20000001, 0x10, x1, 212, x4)

inst_77:
// rs1_val == -1073741825, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0x40000001;  immval:-0x101
TEST_IMM_OP( slti, x11, x10, 0x1, -0x40000001, -0x101, x1, 216, x4)

inst_78:
// rs1_val == 1431655765, rs1_val==1431655765 and imm_val==0
// opcode: slti ; op1:x10; dest:x11; op1val:0x55555555;  immval:0x0
TEST_IMM_OP( slti, x11, x10, 0x0, 0x55555555, 0x0, x1, 220, x4)

inst_79:
// rs1_val==3 and imm_val==3, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x3;  immval:0x3
TEST_IMM_OP( slti, x11, x10, 0x0, 0x3, 0x3, x1, 224, x4)

inst_80:
// rs1_val==3 and imm_val==1365, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x3;  immval:0x555
TEST_IMM_OP( slti, x11, x10, 0x1, 0x3, 0x555, x1, 228, x4)

inst_81:
// rs1_val==3 and imm_val==-1366, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x3;  immval:-0x556
TEST_IMM_OP( slti, x11, x10, 0x0, 0x3, -0x556, x1, 232, x4)

inst_82:
// rs1_val==3 and imm_val==5, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x3;  immval:0x5
TEST_IMM_OP( slti, x11, x10, 0x1, 0x3, 0x5, x1, 236, x4)

inst_83:
// rs1_val==3 and imm_val==819, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x3;  immval:0x333
TEST_IMM_OP( slti, x11, x10, 0x1, 0x3, 0x333, x1, 240, x4)

inst_84:
// rs1_val==3 and imm_val==1638, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x3;  immval:0x666
TEST_IMM_OP( slti, x11, x10, 0x1, 0x3, 0x666, x1, 244, x4)

inst_85:
// rs1_val==3 and imm_val==-45, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x3;  immval:-0x2d
TEST_IMM_OP( slti, x11, x10, 0x0, 0x3, -0x2d, x1, 248, x4)

inst_86:
// rs1_val==3 and imm_val==45, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x3;  immval:0x2d
TEST_IMM_OP( slti, x11, x10, 0x1, 0x3, 0x2d, x1, 252, x4)

inst_87:
// rs1_val==3 and imm_val==2, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x3;  immval:0x2
TEST_IMM_OP( slti, x11, x10, 0x0, 0x3, 0x2, x1, 256, x4)

inst_88:
// rs1_val==3 and imm_val==1364, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x3;  immval:0x554
TEST_IMM_OP( slti, x11, x10, 0x1, 0x3, 0x554, x1, 260, x4)

inst_89:
// rs1_val==3 and imm_val==0, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x3;  immval:0x0
TEST_IMM_OP( slti, x11, x10, 0x0, 0x3, 0x0, x1, 264, x4)

inst_90:
// rs1_val==3 and imm_val==4, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x3;  immval:0x4
TEST_IMM_OP( slti, x11, x10, 0x1, 0x3, 0x4, x1, 268, x4)

inst_91:
// rs1_val==3 and imm_val==818, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x3;  immval:0x332
TEST_IMM_OP( slti, x11, x10, 0x1, 0x3, 0x332, x1, 272, x4)

inst_92:
// rs1_val==3 and imm_val==1637, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x3;  immval:0x665
TEST_IMM_OP( slti, x11, x10, 0x1, 0x3, 0x665, x1, 276, x4)

inst_93:
// rs1_val==3 and imm_val==44, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x3;  immval:0x2c
TEST_IMM_OP( slti, x11, x10, 0x1, 0x3, 0x2c, x1, 280, x4)

inst_94:
// rs1_val==3 and imm_val==1366, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x3;  immval:0x556
TEST_IMM_OP( slti, x11, x10, 0x1, 0x3, 0x556, x1, 284, x4)

inst_95:
// rs1_val==3 and imm_val==-1365, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x3;  immval:-0x555
TEST_IMM_OP( slti, x11, x10, 0x0, 0x3, -0x555, x1, 288, x4)

inst_96:
// rs1_val==3 and imm_val==6, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x3;  immval:0x6
TEST_IMM_OP( slti, x11, x10, 0x1, 0x3, 0x6, x1, 292, x4)

inst_97:
// rs1_val==3 and imm_val==820, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x3;  immval:0x334
TEST_IMM_OP( slti, x11, x10, 0x1, 0x3, 0x334, x1, 296, x4)

inst_98:
// rs1_val==3 and imm_val==1639, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x3;  immval:0x667
TEST_IMM_OP( slti, x11, x10, 0x1, 0x3, 0x667, x1, 300, x4)

inst_99:
// rs1_val==3 and imm_val==-44, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x3;  immval:-0x2c
TEST_IMM_OP( slti, x11, x10, 0x0, 0x3, -0x2c, x1, 304, x4)

inst_100:
// rs1_val==3 and imm_val==46, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x3;  immval:0x2e
TEST_IMM_OP( slti, x11, x10, 0x1, 0x3, 0x2e, x1, 308, x4)

inst_101:
// rs1_val==1431655765 and imm_val==3, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x55555555;  immval:0x3
TEST_IMM_OP( slti, x11, x10, 0x0, 0x55555555, 0x3, x1, 312, x4)

inst_102:
// rs1_val==1431655765 and imm_val==1365, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x55555555;  immval:0x555
TEST_IMM_OP( slti, x11, x10, 0x0, 0x55555555, 0x555, x1, 316, x4)

inst_103:
// rs1_val==1431655765 and imm_val==-1366, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x55555555;  immval:-0x556
TEST_IMM_OP( slti, x11, x10, 0x0, 0x55555555, -0x556, x1, 320, x4)

inst_104:
// rs1_val==1431655765 and imm_val==5, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x55555555;  immval:0x5
TEST_IMM_OP( slti, x11, x10, 0x0, 0x55555555, 0x5, x1, 324, x4)

inst_105:
// rs1_val==1431655765 and imm_val==819, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x55555555;  immval:0x333
TEST_IMM_OP( slti, x11, x10, 0x0, 0x55555555, 0x333, x1, 328, x4)

inst_106:
// rs1_val==1431655765 and imm_val==1638, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x55555555;  immval:0x666
TEST_IMM_OP( slti, x11, x10, 0x0, 0x55555555, 0x666, x1, 332, x4)

inst_107:
// rs1_val==1431655765 and imm_val==-45, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x55555555;  immval:-0x2d
TEST_IMM_OP( slti, x11, x10, 0x0, 0x55555555, -0x2d, x1, 336, x4)

inst_108:
// rs1_val==1431655765 and imm_val==45, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x55555555;  immval:0x2d
TEST_IMM_OP( slti, x11, x10, 0x0, 0x55555555, 0x2d, x1, 340, x4)

inst_109:
// rs1_val==1431655765 and imm_val==2, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x55555555;  immval:0x2
TEST_IMM_OP( slti, x11, x10, 0x0, 0x55555555, 0x2, x1, 344, x4)

inst_110:
// rs1_val==1431655765 and imm_val==1364, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x55555555;  immval:0x554
TEST_IMM_OP( slti, x11, x10, 0x0, 0x55555555, 0x554, x1, 348, x4)

inst_111:
// rs1_val==1431655765 and imm_val==4, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x55555555;  immval:0x4
TEST_IMM_OP( slti, x11, x10, 0x0, 0x55555555, 0x4, x1, 352, x4)

inst_112:
// rs1_val==1431655765 and imm_val==818, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x55555555;  immval:0x332
TEST_IMM_OP( slti, x11, x10, 0x0, 0x55555555, 0x332, x1, 356, x4)

inst_113:
// rs1_val==1431655765 and imm_val==1637, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x55555555;  immval:0x665
TEST_IMM_OP( slti, x11, x10, 0x0, 0x55555555, 0x665, x1, 360, x4)

inst_114:
// rs1_val==1431655765 and imm_val==44, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x55555555;  immval:0x2c
TEST_IMM_OP( slti, x11, x10, 0x0, 0x55555555, 0x2c, x1, 364, x4)

inst_115:
// rs1_val==1431655765 and imm_val==1366, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x55555555;  immval:0x556
TEST_IMM_OP( slti, x11, x10, 0x0, 0x55555555, 0x556, x1, 368, x4)

inst_116:
// rs1_val==1431655765 and imm_val==-1365, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x55555555;  immval:-0x555
TEST_IMM_OP( slti, x11, x10, 0x0, 0x55555555, -0x555, x1, 372, x4)

inst_117:
// rs1_val==1431655765 and imm_val==6, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x55555555;  immval:0x6
TEST_IMM_OP( slti, x11, x10, 0x0, 0x55555555, 0x6, x1, 376, x4)

inst_118:
// rs1_val==1431655765 and imm_val==820, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x55555555;  immval:0x334
TEST_IMM_OP( slti, x11, x10, 0x0, 0x55555555, 0x334, x1, 380, x4)

inst_119:
// rs1_val==1431655765 and imm_val==1639, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x55555555;  immval:0x667
TEST_IMM_OP( slti, x11, x10, 0x0, 0x55555555, 0x667, x1, 384, x4)

inst_120:
// rs1_val==1431655765 and imm_val==-44, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x55555555;  immval:-0x2c
TEST_IMM_OP( slti, x11, x10, 0x0, 0x55555555, -0x2c, x1, 388, x4)

inst_121:
// rs1_val==1431655765 and imm_val==46, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x55555555;  immval:0x2e
TEST_IMM_OP( slti, x11, x10, 0x0, 0x55555555, 0x2e, x1, 392, x4)

inst_122:
// rs1_val==-1431655766 and imm_val==3, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0x55555556;  immval:0x3
TEST_IMM_OP( slti, x11, x10, 0x1, -0x55555556, 0x3, x1, 396, x4)

inst_123:
// rs1_val==-1431655766 and imm_val==1365, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0x55555556;  immval:0x555
TEST_IMM_OP( slti, x11, x10, 0x1, -0x55555556, 0x555, x1, 400, x4)

inst_124:
// rs1_val==-1431655766 and imm_val==-1366, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0x55555556;  immval:-0x556
TEST_IMM_OP( slti, x11, x10, 0x1, -0x55555556, -0x556, x1, 404, x4)

inst_125:
// rs1_val==-1431655766 and imm_val==5, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0x55555556;  immval:0x5
TEST_IMM_OP( slti, x11, x10, 0x1, -0x55555556, 0x5, x1, 408, x4)

inst_126:
// rs1_val==-1431655766 and imm_val==819, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0x55555556;  immval:0x333
TEST_IMM_OP( slti, x11, x10, 0x1, -0x55555556, 0x333, x1, 412, x4)

inst_127:
// rs1_val==-1431655766 and imm_val==1638, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0x55555556;  immval:0x666
TEST_IMM_OP( slti, x11, x10, 0x1, -0x55555556, 0x666, x1, 416, x4)

inst_128:
// rs1_val==-1431655766 and imm_val==-45, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0x55555556;  immval:-0x2d
TEST_IMM_OP( slti, x11, x10, 0x1, -0x55555556, -0x2d, x1, 420, x4)

inst_129:
// rs1_val==-1431655766 and imm_val==45, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0x55555556;  immval:0x2d
TEST_IMM_OP( slti, x11, x10, 0x1, -0x55555556, 0x2d, x1, 424, x4)

inst_130:
// rs1_val==-1431655766 and imm_val==2, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0x55555556;  immval:0x2
TEST_IMM_OP( slti, x11, x10, 0x1, -0x55555556, 0x2, x1, 428, x4)

inst_131:
// rs1_val==-1431655766 and imm_val==1364, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0x55555556;  immval:0x554
TEST_IMM_OP( slti, x11, x10, 0x1, -0x55555556, 0x554, x1, 432, x4)

inst_132:
// rs1_val==-1431655766 and imm_val==0, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0x55555556;  immval:0x0
TEST_IMM_OP( slti, x11, x10, 0x1, -0x55555556, 0x0, x1, 436, x4)

inst_133:
// rs1_val==-1431655766 and imm_val==4, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0x55555556;  immval:0x4
TEST_IMM_OP( slti, x11, x10, 0x1, -0x55555556, 0x4, x1, 440, x4)

inst_134:
// rs1_val==-1431655766 and imm_val==818, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0x55555556;  immval:0x332
TEST_IMM_OP( slti, x11, x10, 0x1, -0x55555556, 0x332, x1, 444, x4)

inst_135:
// rs1_val==-1431655766 and imm_val==1637, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0x55555556;  immval:0x665
TEST_IMM_OP( slti, x11, x10, 0x1, -0x55555556, 0x665, x1, 448, x4)

inst_136:
// rs1_val==-1431655766 and imm_val==44, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0x55555556;  immval:0x2c
TEST_IMM_OP( slti, x11, x10, 0x1, -0x55555556, 0x2c, x1, 452, x4)

inst_137:
// rs1_val==-1431655766 and imm_val==1366, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0x55555556;  immval:0x556
TEST_IMM_OP( slti, x11, x10, 0x1, -0x55555556, 0x556, x1, 456, x4)

inst_138:
// rs1_val==-1431655766 and imm_val==-1365, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0x55555556;  immval:-0x555
TEST_IMM_OP( slti, x11, x10, 0x1, -0x55555556, -0x555, x1, 460, x4)

inst_139:
// rs1_val==-1431655766 and imm_val==6, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0x55555556;  immval:0x6
TEST_IMM_OP( slti, x11, x10, 0x1, -0x55555556, 0x6, x1, 464, x4)

inst_140:
// rs1_val==-1431655766 and imm_val==820, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0x55555556;  immval:0x334
TEST_IMM_OP( slti, x11, x10, 0x1, -0x55555556, 0x334, x1, 468, x4)

inst_141:
// rs1_val==-1431655766 and imm_val==1639, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0x55555556;  immval:0x667
TEST_IMM_OP( slti, x11, x10, 0x1, -0x55555556, 0x667, x1, 472, x4)

inst_142:
// rs1_val==-1431655766 and imm_val==-44, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0x55555556;  immval:-0x2c
TEST_IMM_OP( slti, x11, x10, 0x1, -0x55555556, -0x2c, x1, 476, x4)

inst_143:
// rs1_val==-1431655766 and imm_val==46, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0x55555556;  immval:0x2e
TEST_IMM_OP( slti, x11, x10, 0x1, -0x55555556, 0x2e, x1, 480, x4)

inst_144:
// rs1_val==5 and imm_val==3, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x5;  immval:0x3
TEST_IMM_OP( slti, x11, x10, 0x0, 0x5, 0x3, x1, 484, x4)

inst_145:
// rs1_val==5 and imm_val==1365, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x5;  immval:0x555
TEST_IMM_OP( slti, x11, x10, 0x1, 0x5, 0x555, x1, 488, x4)

inst_146:
// rs1_val==5 and imm_val==-1366, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x5;  immval:-0x556
TEST_IMM_OP( slti, x11, x10, 0x0, 0x5, -0x556, x1, 492, x4)

inst_147:
// rs1_val==5 and imm_val==5, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x5;  immval:0x5
TEST_IMM_OP( slti, x11, x10, 0x0, 0x5, 0x5, x1, 496, x4)

inst_148:
// rs1_val==5 and imm_val==819, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x5;  immval:0x333
TEST_IMM_OP( slti, x11, x10, 0x1, 0x5, 0x333, x1, 500, x4)

inst_149:
// rs1_val==5 and imm_val==1638, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x5;  immval:0x666
TEST_IMM_OP( slti, x11, x10, 0x1, 0x5, 0x666, x1, 504, x4)

inst_150:
// rs1_val==5 and imm_val==-45, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x5;  immval:-0x2d
TEST_IMM_OP( slti, x11, x10, 0x0, 0x5, -0x2d, x1, 508, x4)

inst_151:
// rs1_val==5 and imm_val==45, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x5;  immval:0x2d
TEST_IMM_OP( slti, x11, x10, 0x1, 0x5, 0x2d, x1, 512, x4)

inst_152:
// rs1_val==5 and imm_val==2, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x5;  immval:0x2
TEST_IMM_OP( slti, x11, x10, 0x0, 0x5, 0x2, x1, 516, x4)

inst_153:
// rs1_val==5 and imm_val==1364, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x5;  immval:0x554
TEST_IMM_OP( slti, x11, x10, 0x1, 0x5, 0x554, x1, 520, x4)

inst_154:
// rs1_val==5 and imm_val==0, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x5;  immval:0x0
TEST_IMM_OP( slti, x11, x10, 0x0, 0x5, 0x0, x1, 524, x4)

inst_155:
// rs1_val==5 and imm_val==4, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x5;  immval:0x4
TEST_IMM_OP( slti, x11, x10, 0x0, 0x5, 0x4, x1, 528, x4)

inst_156:
// rs1_val==5 and imm_val==818, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x5;  immval:0x332
TEST_IMM_OP( slti, x11, x10, 0x1, 0x5, 0x332, x1, 532, x4)

inst_157:
// rs1_val==5 and imm_val==1637, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x5;  immval:0x665
TEST_IMM_OP( slti, x11, x10, 0x1, 0x5, 0x665, x1, 536, x4)

inst_158:
// rs1_val==5 and imm_val==44, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x5;  immval:0x2c
TEST_IMM_OP( slti, x11, x10, 0x1, 0x5, 0x2c, x1, 540, x4)

inst_159:
// rs1_val==5 and imm_val==1366, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x5;  immval:0x556
TEST_IMM_OP( slti, x11, x10, 0x1, 0x5, 0x556, x1, 544, x4)

inst_160:
// rs1_val==5 and imm_val==-1365, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x5;  immval:-0x555
TEST_IMM_OP( slti, x11, x10, 0x0, 0x5, -0x555, x1, 548, x4)

inst_161:
// rs1_val==5 and imm_val==6, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x5;  immval:0x6
TEST_IMM_OP( slti, x11, x10, 0x1, 0x5, 0x6, x1, 552, x4)

inst_162:
// rs1_val==5 and imm_val==820, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x5;  immval:0x334
TEST_IMM_OP( slti, x11, x10, 0x1, 0x5, 0x334, x1, 556, x4)

inst_163:
// rs1_val==5 and imm_val==1639, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x5;  immval:0x667
TEST_IMM_OP( slti, x11, x10, 0x1, 0x5, 0x667, x1, 560, x4)

inst_164:
// rs1_val==5 and imm_val==-44, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x5;  immval:-0x2c
TEST_IMM_OP( slti, x11, x10, 0x0, 0x5, -0x2c, x1, 564, x4)

inst_165:
// rs1_val==5 and imm_val==46, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x5;  immval:0x2e
TEST_IMM_OP( slti, x11, x10, 0x1, 0x5, 0x2e, x1, 568, x4)

inst_166:
// rs1_val==858993459 and imm_val==3, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x33333333;  immval:0x3
TEST_IMM_OP( slti, x11, x10, 0x0, 0x33333333, 0x3, x1, 572, x4)

inst_167:
// rs1_val==858993459 and imm_val==1365, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x33333333;  immval:0x555
TEST_IMM_OP( slti, x11, x10, 0x0, 0x33333333, 0x555, x1, 576, x4)

inst_168:
// rs1_val==858993459 and imm_val==-1366, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x33333333;  immval:-0x556
TEST_IMM_OP( slti, x11, x10, 0x0, 0x33333333, -0x556, x1, 580, x4)

inst_169:
// rs1_val==858993459 and imm_val==5, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x33333333;  immval:0x5
TEST_IMM_OP( slti, x11, x10, 0x0, 0x33333333, 0x5, x1, 584, x4)

inst_170:
// rs1_val==858993459 and imm_val==819, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x33333333;  immval:0x333
TEST_IMM_OP( slti, x11, x10, 0x0, 0x33333333, 0x333, x1, 588, x4)

inst_171:
// rs1_val==858993459 and imm_val==1638, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x33333333;  immval:0x666
TEST_IMM_OP( slti, x11, x10, 0x0, 0x33333333, 0x666, x1, 592, x4)

inst_172:
// rs1_val==858993459 and imm_val==-45, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x33333333;  immval:-0x2d
TEST_IMM_OP( slti, x11, x10, 0x0, 0x33333333, -0x2d, x1, 596, x4)

inst_173:
// rs1_val==858993459 and imm_val==45, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x33333333;  immval:0x2d
TEST_IMM_OP( slti, x11, x10, 0x0, 0x33333333, 0x2d, x1, 600, x4)

inst_174:
// rs1_val==858993459 and imm_val==2, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x33333333;  immval:0x2
TEST_IMM_OP( slti, x11, x10, 0x0, 0x33333333, 0x2, x1, 604, x4)

inst_175:
// rs1_val==858993459 and imm_val==1364, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x33333333;  immval:0x554
TEST_IMM_OP( slti, x11, x10, 0x0, 0x33333333, 0x554, x1, 608, x4)

inst_176:
// rs1_val==858993459 and imm_val==0, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x33333333;  immval:0x0
TEST_IMM_OP( slti, x11, x10, 0x0, 0x33333333, 0x0, x1, 612, x4)

inst_177:
// rs1_val==858993459 and imm_val==4, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x33333333;  immval:0x4
TEST_IMM_OP( slti, x11, x10, 0x0, 0x33333333, 0x4, x1, 616, x4)

inst_178:
// rs1_val==858993459 and imm_val==818, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x33333333;  immval:0x332
TEST_IMM_OP( slti, x11, x10, 0x0, 0x33333333, 0x332, x1, 620, x4)

inst_179:
// rs1_val==858993459 and imm_val==1637, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x33333333;  immval:0x665
TEST_IMM_OP( slti, x11, x10, 0x0, 0x33333333, 0x665, x1, 624, x4)

inst_180:
// rs1_val==858993459 and imm_val==44, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x33333333;  immval:0x2c
TEST_IMM_OP( slti, x11, x10, 0x0, 0x33333333, 0x2c, x1, 628, x4)

inst_181:
// rs1_val==858993459 and imm_val==1366, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x33333333;  immval:0x556
TEST_IMM_OP( slti, x11, x10, 0x0, 0x33333333, 0x556, x1, 632, x4)

inst_182:
// rs1_val==858993459 and imm_val==-1365, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x33333333;  immval:-0x555
TEST_IMM_OP( slti, x11, x10, 0x0, 0x33333333, -0x555, x1, 636, x4)

inst_183:
// rs1_val==858993459 and imm_val==6, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x33333333;  immval:0x6
TEST_IMM_OP( slti, x11, x10, 0x0, 0x33333333, 0x6, x1, 640, x4)

inst_184:
// rs1_val==858993459 and imm_val==820, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x33333333;  immval:0x334
TEST_IMM_OP( slti, x11, x10, 0x0, 0x33333333, 0x334, x1, 644, x4)

inst_185:
// rs1_val==858993459 and imm_val==1639, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x33333333;  immval:0x667
TEST_IMM_OP( slti, x11, x10, 0x0, 0x33333333, 0x667, x1, 648, x4)

inst_186:
// rs1_val==858993459 and imm_val==-44, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x33333333;  immval:-0x2c
TEST_IMM_OP( slti, x11, x10, 0x0, 0x33333333, -0x2c, x1, 652, x4)

inst_187:
// rs1_val==858993459 and imm_val==46, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x33333333;  immval:0x2e
TEST_IMM_OP( slti, x11, x10, 0x0, 0x33333333, 0x2e, x1, 656, x4)

inst_188:
// rs1_val==1717986918 and imm_val==3, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x66666666;  immval:0x3
TEST_IMM_OP( slti, x11, x10, 0x0, 0x66666666, 0x3, x1, 660, x4)

inst_189:
// rs1_val==1717986918 and imm_val==1365, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x66666666;  immval:0x555
TEST_IMM_OP( slti, x11, x10, 0x0, 0x66666666, 0x555, x1, 664, x4)

inst_190:
// rs1_val==1717986918 and imm_val==-1366, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x66666666;  immval:-0x556
TEST_IMM_OP( slti, x11, x10, 0x0, 0x66666666, -0x556, x1, 668, x4)

inst_191:
// rs1_val==1717986918 and imm_val==5, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x66666666;  immval:0x5
TEST_IMM_OP( slti, x11, x10, 0x0, 0x66666666, 0x5, x1, 672, x4)

inst_192:
// rs1_val==1717986918 and imm_val==819, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x66666666;  immval:0x333
TEST_IMM_OP( slti, x11, x10, 0x0, 0x66666666, 0x333, x1, 676, x4)

inst_193:
// rs1_val==1717986918 and imm_val==1638, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x66666666;  immval:0x666
TEST_IMM_OP( slti, x11, x10, 0x0, 0x66666666, 0x666, x1, 680, x4)

inst_194:
// rs1_val==1717986918 and imm_val==-45, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x66666666;  immval:-0x2d
TEST_IMM_OP( slti, x11, x10, 0x0, 0x66666666, -0x2d, x1, 684, x4)

inst_195:
// rs1_val==1717986918 and imm_val==45, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x66666666;  immval:0x2d
TEST_IMM_OP( slti, x11, x10, 0x0, 0x66666666, 0x2d, x1, 688, x4)

inst_196:
// rs1_val==1717986918 and imm_val==2, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x66666666;  immval:0x2
TEST_IMM_OP( slti, x11, x10, 0x0, 0x66666666, 0x2, x1, 692, x4)

inst_197:
// rs1_val==1717986918 and imm_val==1364, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x66666666;  immval:0x554
TEST_IMM_OP( slti, x11, x10, 0x0, 0x66666666, 0x554, x1, 696, x4)

inst_198:
// rs1_val==1717986918 and imm_val==0, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x66666666;  immval:0x0
TEST_IMM_OP( slti, x11, x10, 0x0, 0x66666666, 0x0, x1, 700, x4)

inst_199:
// rs1_val==1717986918 and imm_val==4, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x66666666;  immval:0x4
TEST_IMM_OP( slti, x11, x10, 0x0, 0x66666666, 0x4, x1, 704, x4)

inst_200:
// rs1_val==1717986918 and imm_val==818, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x66666666;  immval:0x332
TEST_IMM_OP( slti, x11, x10, 0x0, 0x66666666, 0x332, x1, 708, x4)

inst_201:
// rs1_val==1717986918 and imm_val==1637, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x66666666;  immval:0x665
TEST_IMM_OP( slti, x11, x10, 0x0, 0x66666666, 0x665, x1, 712, x4)

inst_202:
// rs1_val==1717986918 and imm_val==44, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x66666666;  immval:0x2c
TEST_IMM_OP( slti, x11, x10, 0x0, 0x66666666, 0x2c, x1, 716, x4)

inst_203:
// rs1_val==1717986918 and imm_val==1366, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x66666666;  immval:0x556
TEST_IMM_OP( slti, x11, x10, 0x0, 0x66666666, 0x556, x1, 720, x4)

inst_204:
// rs1_val==1717986918 and imm_val==-1365, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x66666666;  immval:-0x555
TEST_IMM_OP( slti, x11, x10, 0x0, 0x66666666, -0x555, x1, 724, x4)

inst_205:
// rs1_val==1717986918 and imm_val==6, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x66666666;  immval:0x6
TEST_IMM_OP( slti, x11, x10, 0x0, 0x66666666, 0x6, x1, 728, x4)

inst_206:
// rs1_val==1717986918 and imm_val==820, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x66666666;  immval:0x334
TEST_IMM_OP( slti, x11, x10, 0x0, 0x66666666, 0x334, x1, 732, x4)

inst_207:
// rs1_val==1717986918 and imm_val==1639, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x66666666;  immval:0x667
TEST_IMM_OP( slti, x11, x10, 0x0, 0x66666666, 0x667, x1, 736, x4)

inst_208:
// rs1_val==1717986918 and imm_val==-44, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x66666666;  immval:-0x2c
TEST_IMM_OP( slti, x11, x10, 0x0, 0x66666666, -0x2c, x1, 740, x4)

inst_209:
// rs1_val==1717986918 and imm_val==46, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x66666666;  immval:0x2e
TEST_IMM_OP( slti, x11, x10, 0x0, 0x66666666, 0x2e, x1, 744, x4)

inst_210:
// rs1_val==-46340 and imm_val==3, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0xb504;  immval:0x3
TEST_IMM_OP( slti, x11, x10, 0x1, -0xb504, 0x3, x1, 748, x4)

inst_211:
// rs1_val==-46340 and imm_val==1365, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0xb504;  immval:0x555
TEST_IMM_OP( slti, x11, x10, 0x1, -0xb504, 0x555, x1, 752, x4)

inst_212:
// rs1_val==-46340 and imm_val==-1366, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0xb504;  immval:-0x556
TEST_IMM_OP( slti, x11, x10, 0x1, -0xb504, -0x556, x1, 756, x4)

inst_213:
// rs1_val==-46340 and imm_val==5, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0xb504;  immval:0x5
TEST_IMM_OP( slti, x11, x10, 0x1, -0xb504, 0x5, x1, 760, x4)

inst_214:
// rs1_val==-46340 and imm_val==819, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0xb504;  immval:0x333
TEST_IMM_OP( slti, x11, x10, 0x1, -0xb504, 0x333, x1, 764, x4)

inst_215:
// rs1_val==-46340 and imm_val==1638, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0xb504;  immval:0x666
TEST_IMM_OP( slti, x11, x10, 0x1, -0xb504, 0x666, x1, 768, x4)

inst_216:
// rs1_val==-46340 and imm_val==-45, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0xb504;  immval:-0x2d
TEST_IMM_OP( slti, x11, x10, 0x1, -0xb504, -0x2d, x1, 772, x4)

inst_217:
// rs1_val==-46340 and imm_val==45, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0xb504;  immval:0x2d
TEST_IMM_OP( slti, x11, x10, 0x1, -0xb504, 0x2d, x1, 776, x4)

inst_218:
// rs1_val==-46340 and imm_val==2, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0xb504;  immval:0x2
TEST_IMM_OP( slti, x11, x10, 0x1, -0xb504, 0x2, x1, 780, x4)

inst_219:
// rs1_val==-46340 and imm_val==1364, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0xb504;  immval:0x554
TEST_IMM_OP( slti, x11, x10, 0x1, -0xb504, 0x554, x1, 784, x4)

inst_220:
// rs1_val==-46340 and imm_val==0, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0xb504;  immval:0x0
TEST_IMM_OP( slti, x11, x10, 0x1, -0xb504, 0x0, x1, 788, x4)

inst_221:
// rs1_val==-46340 and imm_val==4, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0xb504;  immval:0x4
TEST_IMM_OP( slti, x11, x10, 0x1, -0xb504, 0x4, x1, 792, x4)

inst_222:
// rs1_val==-46340 and imm_val==818, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0xb504;  immval:0x332
TEST_IMM_OP( slti, x11, x10, 0x1, -0xb504, 0x332, x1, 796, x4)

inst_223:
// rs1_val==-46340 and imm_val==1637, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0xb504;  immval:0x665
TEST_IMM_OP( slti, x11, x10, 0x1, -0xb504, 0x665, x1, 800, x4)

inst_224:
// rs1_val==-46340 and imm_val==44, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0xb504;  immval:0x2c
TEST_IMM_OP( slti, x11, x10, 0x1, -0xb504, 0x2c, x1, 804, x4)

inst_225:
// rs1_val==-46340 and imm_val==1366, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0xb504;  immval:0x556
TEST_IMM_OP( slti, x11, x10, 0x1, -0xb504, 0x556, x1, 808, x4)

inst_226:
// rs1_val==-46340 and imm_val==-1365, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0xb504;  immval:-0x555
TEST_IMM_OP( slti, x11, x10, 0x1, -0xb504, -0x555, x1, 812, x4)

inst_227:
// rs1_val==-46340 and imm_val==6, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0xb504;  immval:0x6
TEST_IMM_OP( slti, x11, x10, 0x1, -0xb504, 0x6, x1, 816, x4)

inst_228:
// rs1_val==-46340 and imm_val==820, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0xb504;  immval:0x334
TEST_IMM_OP( slti, x11, x10, 0x1, -0xb504, 0x334, x1, 820, x4)

inst_229:
// rs1_val==-46340 and imm_val==1639, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0xb504;  immval:0x667
TEST_IMM_OP( slti, x11, x10, 0x1, -0xb504, 0x667, x1, 824, x4)

inst_230:
// rs1_val==-46340 and imm_val==-44, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0xb504;  immval:-0x2c
TEST_IMM_OP( slti, x11, x10, 0x1, -0xb504, -0x2c, x1, 828, x4)

inst_231:
// rs1_val==-46340 and imm_val==46, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0xb504;  immval:0x2e
TEST_IMM_OP( slti, x11, x10, 0x1, -0xb504, 0x2e, x1, 832, x4)

inst_232:
// rs1_val==46340 and imm_val==3, 
// opcode: slti ; op1:x10; dest:x11; op1val:0xb504;  immval:0x3
TEST_IMM_OP( slti, x11, x10, 0x0, 0xb504, 0x3, x1, 836, x4)

inst_233:
// rs1_val==46340 and imm_val==1365, 
// opcode: slti ; op1:x10; dest:x11; op1val:0xb504;  immval:0x555
TEST_IMM_OP( slti, x11, x10, 0x0, 0xb504, 0x555, x1, 840, x4)

inst_234:
// rs1_val==46340 and imm_val==-1366, 
// opcode: slti ; op1:x10; dest:x11; op1val:0xb504;  immval:-0x556
TEST_IMM_OP( slti, x11, x10, 0x0, 0xb504, -0x556, x1, 844, x4)

inst_235:
// rs1_val==46340 and imm_val==5, 
// opcode: slti ; op1:x10; dest:x11; op1val:0xb504;  immval:0x5
TEST_IMM_OP( slti, x11, x10, 0x0, 0xb504, 0x5, x1, 848, x4)

inst_236:
// rs1_val==46340 and imm_val==819, 
// opcode: slti ; op1:x10; dest:x11; op1val:0xb504;  immval:0x333
TEST_IMM_OP( slti, x11, x10, 0x0, 0xb504, 0x333, x1, 852, x4)

inst_237:
// rs1_val==46340 and imm_val==1638, 
// opcode: slti ; op1:x10; dest:x11; op1val:0xb504;  immval:0x666
TEST_IMM_OP( slti, x11, x10, 0x0, 0xb504, 0x666, x1, 856, x4)

inst_238:
// rs1_val==46340 and imm_val==-45, 
// opcode: slti ; op1:x10; dest:x11; op1val:0xb504;  immval:-0x2d
TEST_IMM_OP( slti, x11, x10, 0x0, 0xb504, -0x2d, x1, 860, x4)

inst_239:
// rs1_val==46340 and imm_val==45, 
// opcode: slti ; op1:x10; dest:x11; op1val:0xb504;  immval:0x2d
TEST_IMM_OP( slti, x11, x10, 0x0, 0xb504, 0x2d, x1, 864, x4)

inst_240:
// rs1_val==46340 and imm_val==2, 
// opcode: slti ; op1:x10; dest:x11; op1val:0xb504;  immval:0x2
TEST_IMM_OP( slti, x11, x10, 0x0, 0xb504, 0x2, x1, 868, x4)

inst_241:
// rs1_val==46340 and imm_val==1364, 
// opcode: slti ; op1:x10; dest:x11; op1val:0xb504;  immval:0x554
TEST_IMM_OP( slti, x11, x10, 0x0, 0xb504, 0x554, x1, 872, x4)

inst_242:
// rs1_val==46340 and imm_val==0, 
// opcode: slti ; op1:x10; dest:x11; op1val:0xb504;  immval:0x0
TEST_IMM_OP( slti, x11, x10, 0x0, 0xb504, 0x0, x1, 876, x4)

inst_243:
// rs1_val==46340 and imm_val==4, 
// opcode: slti ; op1:x10; dest:x11; op1val:0xb504;  immval:0x4
TEST_IMM_OP( slti, x11, x10, 0x0, 0xb504, 0x4, x1, 880, x4)

inst_244:
// rs1_val==46340 and imm_val==818, 
// opcode: slti ; op1:x10; dest:x11; op1val:0xb504;  immval:0x332
TEST_IMM_OP( slti, x11, x10, 0x0, 0xb504, 0x332, x1, 884, x4)

inst_245:
// rs1_val==46340 and imm_val==1637, 
// opcode: slti ; op1:x10; dest:x11; op1val:0xb504;  immval:0x665
TEST_IMM_OP( slti, x11, x10, 0x0, 0xb504, 0x665, x1, 888, x4)

inst_246:
// rs1_val==46340 and imm_val==44, 
// opcode: slti ; op1:x10; dest:x11; op1val:0xb504;  immval:0x2c
TEST_IMM_OP( slti, x11, x10, 0x0, 0xb504, 0x2c, x1, 892, x4)

inst_247:
// rs1_val==46340 and imm_val==1366, 
// opcode: slti ; op1:x10; dest:x11; op1val:0xb504;  immval:0x556
TEST_IMM_OP( slti, x11, x10, 0x0, 0xb504, 0x556, x1, 896, x4)

inst_248:
// rs1_val==46340 and imm_val==-1365, 
// opcode: slti ; op1:x10; dest:x11; op1val:0xb504;  immval:-0x555
TEST_IMM_OP( slti, x11, x10, 0x0, 0xb504, -0x555, x1, 900, x4)

inst_249:
// rs1_val==46340 and imm_val==6, 
// opcode: slti ; op1:x10; dest:x11; op1val:0xb504;  immval:0x6
TEST_IMM_OP( slti, x11, x10, 0x0, 0xb504, 0x6, x1, 904, x4)

inst_250:
// rs1_val==46340 and imm_val==820, 
// opcode: slti ; op1:x10; dest:x11; op1val:0xb504;  immval:0x334
TEST_IMM_OP( slti, x11, x10, 0x0, 0xb504, 0x334, x1, 908, x4)

inst_251:
// rs1_val==46340 and imm_val==1639, 
// opcode: slti ; op1:x10; dest:x11; op1val:0xb504;  immval:0x667
TEST_IMM_OP( slti, x11, x10, 0x0, 0xb504, 0x667, x1, 912, x4)

inst_252:
// rs1_val==46340 and imm_val==-44, 
// opcode: slti ; op1:x10; dest:x11; op1val:0xb504;  immval:-0x2c
TEST_IMM_OP( slti, x11, x10, 0x0, 0xb504, -0x2c, x1, 916, x4)

inst_253:
// rs1_val==46340 and imm_val==46, 
// opcode: slti ; op1:x10; dest:x11; op1val:0xb504;  immval:0x2e
TEST_IMM_OP( slti, x11, x10, 0x0, 0xb504, 0x2e, x1, 920, x4)

inst_254:
// rs1_val==2 and imm_val==3, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x2;  immval:0x3
TEST_IMM_OP( slti, x11, x10, 0x1, 0x2, 0x3, x1, 924, x4)

inst_255:
// rs1_val==2 and imm_val==1365, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x2;  immval:0x555
TEST_IMM_OP( slti, x11, x10, 0x1, 0x2, 0x555, x1, 928, x4)

inst_256:
// rs1_val==2 and imm_val==-1366, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x2;  immval:-0x556
TEST_IMM_OP( slti, x11, x10, 0x0, 0x2, -0x556, x1, 932, x4)

inst_257:
// rs1_val==2 and imm_val==5, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x2;  immval:0x5
TEST_IMM_OP( slti, x11, x10, 0x1, 0x2, 0x5, x1, 936, x4)

inst_258:
// rs1_val==2 and imm_val==819, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x2;  immval:0x333
TEST_IMM_OP( slti, x11, x10, 0x1, 0x2, 0x333, x1, 940, x4)

inst_259:
// rs1_val==2 and imm_val==1638, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x2;  immval:0x666
TEST_IMM_OP( slti, x11, x10, 0x1, 0x2, 0x666, x1, 944, x4)

inst_260:
// rs1_val==2 and imm_val==-45, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x2;  immval:-0x2d
TEST_IMM_OP( slti, x11, x10, 0x0, 0x2, -0x2d, x1, 948, x4)

inst_261:
// rs1_val==2 and imm_val==45, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x2;  immval:0x2d
TEST_IMM_OP( slti, x11, x10, 0x1, 0x2, 0x2d, x1, 952, x4)

inst_262:
// rs1_val==2 and imm_val==2, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x2;  immval:0x2
TEST_IMM_OP( slti, x11, x10, 0x0, 0x2, 0x2, x1, 956, x4)

inst_263:
// rs1_val==2 and imm_val==1364, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x2;  immval:0x554
TEST_IMM_OP( slti, x11, x10, 0x1, 0x2, 0x554, x1, 960, x4)

inst_264:
// rs1_val==2 and imm_val==0, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x2;  immval:0x0
TEST_IMM_OP( slti, x11, x10, 0x0, 0x2, 0x0, x1, 964, x4)

inst_265:
// rs1_val==2 and imm_val==4, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x2;  immval:0x4
TEST_IMM_OP( slti, x11, x10, 0x1, 0x2, 0x4, x1, 968, x4)

inst_266:
// rs1_val==2 and imm_val==818, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x2;  immval:0x332
TEST_IMM_OP( slti, x11, x10, 0x1, 0x2, 0x332, x1, 972, x4)

inst_267:
// rs1_val==2 and imm_val==1637, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x2;  immval:0x665
TEST_IMM_OP( slti, x11, x10, 0x1, 0x2, 0x665, x1, 976, x4)

inst_268:
// rs1_val==2 and imm_val==44, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x2;  immval:0x2c
TEST_IMM_OP( slti, x11, x10, 0x1, 0x2, 0x2c, x1, 980, x4)

inst_269:
// rs1_val==2 and imm_val==1366, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x2;  immval:0x556
TEST_IMM_OP( slti, x11, x10, 0x1, 0x2, 0x556, x1, 984, x4)

inst_270:
// rs1_val==2 and imm_val==-1365, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x2;  immval:-0x555
TEST_IMM_OP( slti, x11, x10, 0x0, 0x2, -0x555, x1, 988, x4)

inst_271:
// rs1_val==2 and imm_val==6, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x2;  immval:0x6
TEST_IMM_OP( slti, x11, x10, 0x1, 0x2, 0x6, x1, 992, x4)

inst_272:
// rs1_val==2 and imm_val==820, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x2;  immval:0x334
TEST_IMM_OP( slti, x11, x10, 0x1, 0x2, 0x334, x1, 996, x4)

inst_273:
// rs1_val==2 and imm_val==1639, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x2;  immval:0x667
TEST_IMM_OP( slti, x11, x10, 0x1, 0x2, 0x667, x1, 1000, x4)

inst_274:
// rs1_val==2 and imm_val==-44, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x2;  immval:-0x2c
TEST_IMM_OP( slti, x11, x10, 0x0, 0x2, -0x2c, x1, 1004, x4)

inst_275:
// rs1_val==2 and imm_val==46, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x2;  immval:0x2e
TEST_IMM_OP( slti, x11, x10, 0x1, 0x2, 0x2e, x1, 1008, x4)

inst_276:
// rs1_val==1431655764 and imm_val==3, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x55555554;  immval:0x3
TEST_IMM_OP( slti, x11, x10, 0x0, 0x55555554, 0x3, x1, 1012, x4)

inst_277:
// rs1_val==1431655764 and imm_val==1365, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x55555554;  immval:0x555
TEST_IMM_OP( slti, x11, x10, 0x0, 0x55555554, 0x555, x1, 1016, x4)

inst_278:
// rs1_val==1431655764 and imm_val==-1366, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x55555554;  immval:-0x556
TEST_IMM_OP( slti, x11, x10, 0x0, 0x55555554, -0x556, x1, 1020, x4)

inst_279:
// rs1_val==1431655764 and imm_val==5, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x55555554;  immval:0x5
TEST_IMM_OP( slti, x11, x10, 0x0, 0x55555554, 0x5, x1, 1024, x4)

inst_280:
// rs1_val==1431655764 and imm_val==819, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x55555554;  immval:0x333
TEST_IMM_OP( slti, x11, x10, 0x0, 0x55555554, 0x333, x1, 1028, x4)

inst_281:
// rs1_val==1431655764 and imm_val==1638, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x55555554;  immval:0x666
TEST_IMM_OP( slti, x11, x10, 0x0, 0x55555554, 0x666, x1, 1032, x4)

inst_282:
// rs1_val==1431655764 and imm_val==-45, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x55555554;  immval:-0x2d
TEST_IMM_OP( slti, x11, x10, 0x0, 0x55555554, -0x2d, x1, 1036, x4)

inst_283:
// rs1_val==1431655764 and imm_val==45, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x55555554;  immval:0x2d
TEST_IMM_OP( slti, x11, x10, 0x0, 0x55555554, 0x2d, x1, 1040, x4)

inst_284:
// rs1_val==1431655764 and imm_val==2, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x55555554;  immval:0x2
TEST_IMM_OP( slti, x11, x10, 0x0, 0x55555554, 0x2, x1, 1044, x4)

inst_285:
// rs1_val==1431655764 and imm_val==1364, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x55555554;  immval:0x554
TEST_IMM_OP( slti, x11, x10, 0x0, 0x55555554, 0x554, x1, 1048, x4)

inst_286:
// rs1_val==1431655764 and imm_val==0, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x55555554;  immval:0x0
TEST_IMM_OP( slti, x11, x10, 0x0, 0x55555554, 0x0, x1, 1052, x4)

inst_287:
// rs1_val==1431655764 and imm_val==4, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x55555554;  immval:0x4
TEST_IMM_OP( slti, x11, x10, 0x0, 0x55555554, 0x4, x1, 1056, x4)

inst_288:
// rs1_val==1431655764 and imm_val==818, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x55555554;  immval:0x332
TEST_IMM_OP( slti, x11, x10, 0x0, 0x55555554, 0x332, x1, 1060, x4)

inst_289:
// rs1_val==1431655764 and imm_val==1637, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x55555554;  immval:0x665
TEST_IMM_OP( slti, x11, x10, 0x0, 0x55555554, 0x665, x1, 1064, x4)

inst_290:
// rs1_val==1431655764 and imm_val==44, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x55555554;  immval:0x2c
TEST_IMM_OP( slti, x11, x10, 0x0, 0x55555554, 0x2c, x1, 1068, x4)

inst_291:
// rs1_val==1431655764 and imm_val==1366, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x55555554;  immval:0x556
TEST_IMM_OP( slti, x11, x10, 0x0, 0x55555554, 0x556, x1, 1072, x4)

inst_292:
// rs1_val==1431655764 and imm_val==-1365, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x55555554;  immval:-0x555
TEST_IMM_OP( slti, x11, x10, 0x0, 0x55555554, -0x555, x1, 1076, x4)

inst_293:
// rs1_val==1431655764 and imm_val==6, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x55555554;  immval:0x6
TEST_IMM_OP( slti, x11, x10, 0x0, 0x55555554, 0x6, x1, 1080, x4)

inst_294:
// rs1_val==1431655764 and imm_val==820, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x55555554;  immval:0x334
TEST_IMM_OP( slti, x11, x10, 0x0, 0x55555554, 0x334, x1, 1084, x4)

inst_295:
// rs1_val==1431655764 and imm_val==1639, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x55555554;  immval:0x667
TEST_IMM_OP( slti, x11, x10, 0x0, 0x55555554, 0x667, x1, 1088, x4)

inst_296:
// rs1_val==1431655764 and imm_val==-44, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x55555554;  immval:-0x2c
TEST_IMM_OP( slti, x11, x10, 0x0, 0x55555554, -0x2c, x1, 1092, x4)

inst_297:
// rs1_val==1431655764 and imm_val==46, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x55555554;  immval:0x2e
TEST_IMM_OP( slti, x11, x10, 0x0, 0x55555554, 0x2e, x1, 1096, x4)

inst_298:
// rs1_val==0 and imm_val==3, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x0;  immval:0x3
TEST_IMM_OP( slti, x11, x10, 0x1, 0x0, 0x3, x1, 1100, x4)

inst_299:
// rs1_val==0 and imm_val==1365, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x0;  immval:0x555
TEST_IMM_OP( slti, x11, x10, 0x1, 0x0, 0x555, x1, 1104, x4)

inst_300:
// rs1_val==0 and imm_val==-1366, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x0;  immval:-0x556
TEST_IMM_OP( slti, x11, x10, 0x0, 0x0, -0x556, x1, 1108, x4)

inst_301:
// rs1_val==0 and imm_val==5, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x0;  immval:0x5
TEST_IMM_OP( slti, x11, x10, 0x1, 0x0, 0x5, x1, 1112, x4)

inst_302:
// rs1_val==0 and imm_val==819, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x0;  immval:0x333
TEST_IMM_OP( slti, x11, x10, 0x1, 0x0, 0x333, x1, 1116, x4)

inst_303:
// rs1_val==0 and imm_val==1638, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x0;  immval:0x666
TEST_IMM_OP( slti, x11, x10, 0x1, 0x0, 0x666, x1, 1120, x4)

inst_304:
// rs1_val==858993460 and imm_val==818, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x33333334;  immval:0x332
TEST_IMM_OP( slti, x11, x10, 0x0, 0x33333334, 0x332, x1, 1124, x4)

inst_305:
// rs1_val==858993460 and imm_val==1637, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x33333334;  immval:0x665
TEST_IMM_OP( slti, x11, x10, 0x0, 0x33333334, 0x665, x1, 1128, x4)

inst_306:
// rs1_val==858993460 and imm_val==44, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x33333334;  immval:0x2c
TEST_IMM_OP( slti, x11, x10, 0x0, 0x33333334, 0x2c, x1, 1132, x4)

inst_307:
// rs1_val==858993460 and imm_val==1366, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x33333334;  immval:0x556
TEST_IMM_OP( slti, x11, x10, 0x0, 0x33333334, 0x556, x1, 1136, x4)

inst_308:
// rs1_val==858993460 and imm_val==-1365, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x33333334;  immval:-0x555
TEST_IMM_OP( slti, x11, x10, 0x0, 0x33333334, -0x555, x1, 1140, x4)

inst_309:
// rs1_val==858993460 and imm_val==6, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x33333334;  immval:0x6
TEST_IMM_OP( slti, x11, x10, 0x0, 0x33333334, 0x6, x1, 1144, x4)

inst_310:
// rs1_val==858993460 and imm_val==820, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x33333334;  immval:0x334
TEST_IMM_OP( slti, x11, x10, 0x0, 0x33333334, 0x334, x1, 1148, x4)

inst_311:
// rs1_val==858993460 and imm_val==1639, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x33333334;  immval:0x667
TEST_IMM_OP( slti, x11, x10, 0x0, 0x33333334, 0x667, x1, 1152, x4)

inst_312:
// rs1_val==858993460 and imm_val==-44, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x33333334;  immval:-0x2c
TEST_IMM_OP( slti, x11, x10, 0x0, 0x33333334, -0x2c, x1, 1156, x4)

inst_313:
// rs1_val==858993460 and imm_val==46, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x33333334;  immval:0x2e
TEST_IMM_OP( slti, x11, x10, 0x0, 0x33333334, 0x2e, x1, 1160, x4)

inst_314:
// rs1_val==1717986919 and imm_val==3, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x66666667;  immval:0x3
TEST_IMM_OP( slti, x11, x10, 0x0, 0x66666667, 0x3, x1, 1164, x4)

inst_315:
// rs1_val==1717986919 and imm_val==1365, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x66666667;  immval:0x555
TEST_IMM_OP( slti, x11, x10, 0x0, 0x66666667, 0x555, x1, 1168, x4)

inst_316:
// rs1_val==1717986919 and imm_val==-1366, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x66666667;  immval:-0x556
TEST_IMM_OP( slti, x11, x10, 0x0, 0x66666667, -0x556, x1, 1172, x4)

inst_317:
// rs1_val==1717986919 and imm_val==5, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x66666667;  immval:0x5
TEST_IMM_OP( slti, x11, x10, 0x0, 0x66666667, 0x5, x1, 1176, x4)

inst_318:
// rs1_val==1717986919 and imm_val==819, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x66666667;  immval:0x333
TEST_IMM_OP( slti, x11, x10, 0x0, 0x66666667, 0x333, x1, 1180, x4)

inst_319:
// rs1_val==1717986919 and imm_val==1638, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x66666667;  immval:0x666
TEST_IMM_OP( slti, x11, x10, 0x0, 0x66666667, 0x666, x1, 1184, x4)

inst_320:
// rs1_val==1717986919 and imm_val==-45, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x66666667;  immval:-0x2d
TEST_IMM_OP( slti, x11, x10, 0x0, 0x66666667, -0x2d, x1, 1188, x4)

inst_321:
// rs1_val==1717986919 and imm_val==45, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x66666667;  immval:0x2d
TEST_IMM_OP( slti, x11, x10, 0x0, 0x66666667, 0x2d, x1, 1192, x4)

inst_322:
// rs1_val==1717986919 and imm_val==2, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x66666667;  immval:0x2
TEST_IMM_OP( slti, x11, x10, 0x0, 0x66666667, 0x2, x1, 1196, x4)

inst_323:
// rs1_val==1717986919 and imm_val==1364, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x66666667;  immval:0x554
TEST_IMM_OP( slti, x11, x10, 0x0, 0x66666667, 0x554, x1, 1200, x4)

inst_324:
// rs1_val==1717986919 and imm_val==0, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x66666667;  immval:0x0
TEST_IMM_OP( slti, x11, x10, 0x0, 0x66666667, 0x0, x1, 1204, x4)

inst_325:
// rs1_val==1717986919 and imm_val==4, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x66666667;  immval:0x4
TEST_IMM_OP( slti, x11, x10, 0x0, 0x66666667, 0x4, x1, 1208, x4)

inst_326:
// rs1_val==1717986919 and imm_val==818, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x66666667;  immval:0x332
TEST_IMM_OP( slti, x11, x10, 0x0, 0x66666667, 0x332, x1, 1212, x4)

inst_327:
// rs1_val==1717986919 and imm_val==1637, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x66666667;  immval:0x665
TEST_IMM_OP( slti, x11, x10, 0x0, 0x66666667, 0x665, x1, 1216, x4)

inst_328:
// rs1_val==1717986919 and imm_val==44, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x66666667;  immval:0x2c
TEST_IMM_OP( slti, x11, x10, 0x0, 0x66666667, 0x2c, x1, 1220, x4)

inst_329:
// rs1_val==1717986919 and imm_val==1366, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x66666667;  immval:0x556
TEST_IMM_OP( slti, x11, x10, 0x0, 0x66666667, 0x556, x1, 1224, x4)

inst_330:
// rs1_val==1717986919 and imm_val==-1365, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x66666667;  immval:-0x555
TEST_IMM_OP( slti, x11, x10, 0x0, 0x66666667, -0x555, x1, 1228, x4)

inst_331:
// rs1_val==1717986919 and imm_val==6, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x66666667;  immval:0x6
TEST_IMM_OP( slti, x11, x10, 0x0, 0x66666667, 0x6, x1, 1232, x4)

inst_332:
// rs1_val==1717986919 and imm_val==820, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x66666667;  immval:0x334
TEST_IMM_OP( slti, x11, x10, 0x0, 0x66666667, 0x334, x1, 1236, x4)

inst_333:
// rs1_val==1717986919 and imm_val==1639, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x66666667;  immval:0x667
TEST_IMM_OP( slti, x11, x10, 0x0, 0x66666667, 0x667, x1, 1240, x4)

inst_334:
// rs1_val==1717986919 and imm_val==-44, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x66666667;  immval:-0x2c
TEST_IMM_OP( slti, x11, x10, 0x0, 0x66666667, -0x2c, x1, 1244, x4)

inst_335:
// rs1_val==1717986919 and imm_val==46, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x66666667;  immval:0x2e
TEST_IMM_OP( slti, x11, x10, 0x0, 0x66666667, 0x2e, x1, 1248, x4)

inst_336:
// rs1_val==-46339 and imm_val==3, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0xb503;  immval:0x3
TEST_IMM_OP( slti, x11, x10, 0x1, -0xb503, 0x3, x1, 1252, x4)

inst_337:
// rs1_val==-46339 and imm_val==1365, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0xb503;  immval:0x555
TEST_IMM_OP( slti, x11, x10, 0x1, -0xb503, 0x555, x1, 1256, x4)

inst_338:
// rs1_val==-46339 and imm_val==-1366, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0xb503;  immval:-0x556
TEST_IMM_OP( slti, x11, x10, 0x1, -0xb503, -0x556, x1, 1260, x4)

inst_339:
// rs1_val==-46339 and imm_val==5, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0xb503;  immval:0x5
TEST_IMM_OP( slti, x11, x10, 0x1, -0xb503, 0x5, x1, 1264, x4)

inst_340:
// rs1_val==-46339 and imm_val==819, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0xb503;  immval:0x333
TEST_IMM_OP( slti, x11, x10, 0x1, -0xb503, 0x333, x1, 1268, x4)

inst_341:
// rs1_val==-46339 and imm_val==1638, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0xb503;  immval:0x666
TEST_IMM_OP( slti, x11, x10, 0x1, -0xb503, 0x666, x1, 1272, x4)

inst_342:
// rs1_val==-46339 and imm_val==-45, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0xb503;  immval:-0x2d
TEST_IMM_OP( slti, x11, x10, 0x1, -0xb503, -0x2d, x1, 1276, x4)

inst_343:
// rs1_val==-46339 and imm_val==45, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0xb503;  immval:0x2d
TEST_IMM_OP( slti, x11, x10, 0x1, -0xb503, 0x2d, x1, 1280, x4)

inst_344:
// rs1_val==-46339 and imm_val==2, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0xb503;  immval:0x2
TEST_IMM_OP( slti, x11, x10, 0x1, -0xb503, 0x2, x1, 1284, x4)

inst_345:
// rs1_val==-46339 and imm_val==1364, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0xb503;  immval:0x554
TEST_IMM_OP( slti, x11, x10, 0x1, -0xb503, 0x554, x1, 1288, x4)

inst_346:
// rs1_val==-46339 and imm_val==0, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0xb503;  immval:0x0
TEST_IMM_OP( slti, x11, x10, 0x1, -0xb503, 0x0, x1, 1292, x4)

inst_347:
// rs1_val==-46339 and imm_val==4, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0xb503;  immval:0x4
TEST_IMM_OP( slti, x11, x10, 0x1, -0xb503, 0x4, x1, 1296, x4)

inst_348:
// rs1_val==-46339 and imm_val==818, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0xb503;  immval:0x332
TEST_IMM_OP( slti, x11, x10, 0x1, -0xb503, 0x332, x1, 1300, x4)

inst_349:
// rs1_val==-46339 and imm_val==1637, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0xb503;  immval:0x665
TEST_IMM_OP( slti, x11, x10, 0x1, -0xb503, 0x665, x1, 1304, x4)

inst_350:
// rs1_val==-46339 and imm_val==44, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0xb503;  immval:0x2c
TEST_IMM_OP( slti, x11, x10, 0x1, -0xb503, 0x2c, x1, 1308, x4)

inst_351:
// rs1_val==-46339 and imm_val==1366, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0xb503;  immval:0x556
TEST_IMM_OP( slti, x11, x10, 0x1, -0xb503, 0x556, x1, 1312, x4)

inst_352:
// rs1_val==-46339 and imm_val==-1365, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0xb503;  immval:-0x555
TEST_IMM_OP( slti, x11, x10, 0x1, -0xb503, -0x555, x1, 1316, x4)

inst_353:
// rs1_val==-46339 and imm_val==6, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0xb503;  immval:0x6
TEST_IMM_OP( slti, x11, x10, 0x1, -0xb503, 0x6, x1, 1320, x4)

inst_354:
// rs1_val==-46339 and imm_val==820, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0xb503;  immval:0x334
TEST_IMM_OP( slti, x11, x10, 0x1, -0xb503, 0x334, x1, 1324, x4)

inst_355:
// rs1_val==-46339 and imm_val==1639, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0xb503;  immval:0x667
TEST_IMM_OP( slti, x11, x10, 0x1, -0xb503, 0x667, x1, 1328, x4)

inst_356:
// rs1_val==-46339 and imm_val==-44, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0xb503;  immval:-0x2c
TEST_IMM_OP( slti, x11, x10, 0x1, -0xb503, -0x2c, x1, 1332, x4)

inst_357:
// rs1_val==-46339 and imm_val==46, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0xb503;  immval:0x2e
TEST_IMM_OP( slti, x11, x10, 0x1, -0xb503, 0x2e, x1, 1336, x4)

inst_358:
// rs1_val==46341 and imm_val==3, 
// opcode: slti ; op1:x10; dest:x11; op1val:0xb505;  immval:0x3
TEST_IMM_OP( slti, x11, x10, 0x0, 0xb505, 0x3, x1, 1340, x4)

inst_359:
// rs1_val==46341 and imm_val==1365, 
// opcode: slti ; op1:x10; dest:x11; op1val:0xb505;  immval:0x555
TEST_IMM_OP( slti, x11, x10, 0x0, 0xb505, 0x555, x1, 1344, x4)

inst_360:
// rs1_val==46341 and imm_val==-1366, 
// opcode: slti ; op1:x10; dest:x11; op1val:0xb505;  immval:-0x556
TEST_IMM_OP( slti, x11, x10, 0x0, 0xb505, -0x556, x1, 1348, x4)

inst_361:
// rs1_val==46341 and imm_val==5, 
// opcode: slti ; op1:x10; dest:x11; op1val:0xb505;  immval:0x5
TEST_IMM_OP( slti, x11, x10, 0x0, 0xb505, 0x5, x1, 1352, x4)

inst_362:
// rs1_val==46341 and imm_val==819, 
// opcode: slti ; op1:x10; dest:x11; op1val:0xb505;  immval:0x333
TEST_IMM_OP( slti, x11, x10, 0x0, 0xb505, 0x333, x1, 1356, x4)

inst_363:
// rs1_val==46341 and imm_val==1638, 
// opcode: slti ; op1:x10; dest:x11; op1val:0xb505;  immval:0x666
TEST_IMM_OP( slti, x11, x10, 0x0, 0xb505, 0x666, x1, 1360, x4)

inst_364:
// rs1_val==46341 and imm_val==-45, 
// opcode: slti ; op1:x10; dest:x11; op1val:0xb505;  immval:-0x2d
TEST_IMM_OP( slti, x11, x10, 0x0, 0xb505, -0x2d, x1, 1364, x4)

inst_365:
// rs1_val==46341 and imm_val==45, 
// opcode: slti ; op1:x10; dest:x11; op1val:0xb505;  immval:0x2d
TEST_IMM_OP( slti, x11, x10, 0x0, 0xb505, 0x2d, x1, 1368, x4)

inst_366:
// rs1_val==46341 and imm_val==2, 
// opcode: slti ; op1:x10; dest:x11; op1val:0xb505;  immval:0x2
TEST_IMM_OP( slti, x11, x10, 0x0, 0xb505, 0x2, x1, 1372, x4)

inst_367:
// rs1_val==46341 and imm_val==1364, 
// opcode: slti ; op1:x10; dest:x11; op1val:0xb505;  immval:0x554
TEST_IMM_OP( slti, x11, x10, 0x0, 0xb505, 0x554, x1, 1376, x4)

inst_368:
// rs1_val==46341 and imm_val==0, 
// opcode: slti ; op1:x10; dest:x11; op1val:0xb505;  immval:0x0
TEST_IMM_OP( slti, x11, x10, 0x0, 0xb505, 0x0, x1, 1380, x4)

inst_369:
// rs1_val==46341 and imm_val==4, 
// opcode: slti ; op1:x10; dest:x11; op1val:0xb505;  immval:0x4
TEST_IMM_OP( slti, x11, x10, 0x0, 0xb505, 0x4, x1, 1384, x4)

inst_370:
// rs1_val==46341 and imm_val==818, 
// opcode: slti ; op1:x10; dest:x11; op1val:0xb505;  immval:0x332
TEST_IMM_OP( slti, x11, x10, 0x0, 0xb505, 0x332, x1, 1388, x4)

inst_371:
// rs1_val==46341 and imm_val==1637, 
// opcode: slti ; op1:x10; dest:x11; op1val:0xb505;  immval:0x665
TEST_IMM_OP( slti, x11, x10, 0x0, 0xb505, 0x665, x1, 1392, x4)

inst_372:
// rs1_val==46341 and imm_val==44, 
// opcode: slti ; op1:x10; dest:x11; op1val:0xb505;  immval:0x2c
TEST_IMM_OP( slti, x11, x10, 0x0, 0xb505, 0x2c, x1, 1396, x4)

inst_373:
// rs1_val==46341 and imm_val==1366, 
// opcode: slti ; op1:x10; dest:x11; op1val:0xb505;  immval:0x556
TEST_IMM_OP( slti, x11, x10, 0x0, 0xb505, 0x556, x1, 1400, x4)

inst_374:
// rs1_val==46341 and imm_val==-1365, 
// opcode: slti ; op1:x10; dest:x11; op1val:0xb505;  immval:-0x555
TEST_IMM_OP( slti, x11, x10, 0x0, 0xb505, -0x555, x1, 1404, x4)

inst_375:
// rs1_val==46341 and imm_val==6, 
// opcode: slti ; op1:x10; dest:x11; op1val:0xb505;  immval:0x6
TEST_IMM_OP( slti, x11, x10, 0x0, 0xb505, 0x6, x1, 1408, x4)

inst_376:
// rs1_val==46341 and imm_val==820, 
// opcode: slti ; op1:x10; dest:x11; op1val:0xb505;  immval:0x334
TEST_IMM_OP( slti, x11, x10, 0x0, 0xb505, 0x334, x1, 1412, x4)

inst_377:
// rs1_val==46341 and imm_val==1639, 
// opcode: slti ; op1:x10; dest:x11; op1val:0xb505;  immval:0x667
TEST_IMM_OP( slti, x11, x10, 0x0, 0xb505, 0x667, x1, 1416, x4)

inst_378:
// rs1_val==46341 and imm_val==-44, 
// opcode: slti ; op1:x10; dest:x11; op1val:0xb505;  immval:-0x2c
TEST_IMM_OP( slti, x11, x10, 0x0, 0xb505, -0x2c, x1, 1420, x4)

inst_379:
// rs1_val==46341 and imm_val==46, 
// opcode: slti ; op1:x10; dest:x11; op1val:0xb505;  immval:0x2e
TEST_IMM_OP( slti, x11, x10, 0x0, 0xb505, 0x2e, x1, 1424, x4)

inst_380:
// rs1_val==0 and imm_val==-45, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x0;  immval:-0x2d
TEST_IMM_OP( slti, x11, x10, 0x0, 0x0, -0x2d, x1, 1428, x4)

inst_381:
// rs1_val==0 and imm_val==45, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x0;  immval:0x2d
TEST_IMM_OP( slti, x11, x10, 0x1, 0x0, 0x2d, x1, 1432, x4)

inst_382:
// rs1_val==0 and imm_val==1364, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x0;  immval:0x554
TEST_IMM_OP( slti, x11, x10, 0x1, 0x0, 0x554, x1, 1436, x4)

inst_383:
// rs1_val==0 and imm_val==0, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x0;  immval:0x0
TEST_IMM_OP( slti, x11, x10, 0x0, 0x0, 0x0, x1, 1440, x4)

inst_384:
// rs1_val==0 and imm_val==4, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x0;  immval:0x4
TEST_IMM_OP( slti, x11, x10, 0x1, 0x0, 0x4, x1, 1444, x4)

inst_385:
// rs1_val==0 and imm_val==818, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x0;  immval:0x332
TEST_IMM_OP( slti, x11, x10, 0x1, 0x0, 0x332, x1, 1448, x4)

inst_386:
// rs1_val==0 and imm_val==1637, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x0;  immval:0x665
TEST_IMM_OP( slti, x11, x10, 0x1, 0x0, 0x665, x1, 1452, x4)

inst_387:
// rs1_val==0 and imm_val==44, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x0;  immval:0x2c
TEST_IMM_OP( slti, x11, x10, 0x1, 0x0, 0x2c, x1, 1456, x4)

inst_388:
// rs1_val==0 and imm_val==1366, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x0;  immval:0x556
TEST_IMM_OP( slti, x11, x10, 0x1, 0x0, 0x556, x1, 1460, x4)

inst_389:
// rs1_val==0 and imm_val==-1365, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x0;  immval:-0x555
TEST_IMM_OP( slti, x11, x10, 0x0, 0x0, -0x555, x1, 1464, x4)

inst_390:
// rs1_val==0 and imm_val==6, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x0;  immval:0x6
TEST_IMM_OP( slti, x11, x10, 0x1, 0x0, 0x6, x1, 1468, x4)

inst_391:
// rs1_val==0 and imm_val==820, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x0;  immval:0x334
TEST_IMM_OP( slti, x11, x10, 0x1, 0x0, 0x334, x1, 1472, x4)

inst_392:
// rs1_val==0 and imm_val==1639, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x0;  immval:0x667
TEST_IMM_OP( slti, x11, x10, 0x1, 0x0, 0x667, x1, 1476, x4)

inst_393:
// rs1_val==0 and imm_val==-44, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x0;  immval:-0x2c
TEST_IMM_OP( slti, x11, x10, 0x0, 0x0, -0x2c, x1, 1480, x4)

inst_394:
// rs1_val==0 and imm_val==46, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x0;  immval:0x2e
TEST_IMM_OP( slti, x11, x10, 0x1, 0x0, 0x2e, x1, 1484, x4)

inst_395:
// rs1_val==4 and imm_val==3, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x4;  immval:0x3
TEST_IMM_OP( slti, x11, x10, 0x0, 0x4, 0x3, x1, 1488, x4)

inst_396:
// rs1_val==4 and imm_val==-1366, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x4;  immval:-0x556
TEST_IMM_OP( slti, x11, x10, 0x0, 0x4, -0x556, x1, 1492, x4)

inst_397:
// rs1_val==4 and imm_val==5, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x4;  immval:0x5
TEST_IMM_OP( slti, x11, x10, 0x1, 0x4, 0x5, x1, 1496, x4)

inst_398:
// rs1_val==4 and imm_val==819, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x4;  immval:0x333
TEST_IMM_OP( slti, x11, x10, 0x1, 0x4, 0x333, x1, 1500, x4)

inst_399:
// rs1_val==4 and imm_val==1638, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x4;  immval:0x666
TEST_IMM_OP( slti, x11, x10, 0x1, 0x4, 0x666, x1, 1504, x4)

inst_400:
// rs1_val==4 and imm_val==-45, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x4;  immval:-0x2d
TEST_IMM_OP( slti, x11, x10, 0x0, 0x4, -0x2d, x1, 1508, x4)

inst_401:
// rs1_val==4 and imm_val==45, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x4;  immval:0x2d
TEST_IMM_OP( slti, x11, x10, 0x1, 0x4, 0x2d, x1, 1512, x4)

inst_402:
// rs1_val==4 and imm_val==2, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x4;  immval:0x2
TEST_IMM_OP( slti, x11, x10, 0x0, 0x4, 0x2, x1, 1516, x4)

inst_403:
// rs1_val==4 and imm_val==1364, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x4;  immval:0x554
TEST_IMM_OP( slti, x11, x10, 0x1, 0x4, 0x554, x1, 1520, x4)

inst_404:
// rs1_val==4 and imm_val==0, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x4;  immval:0x0
TEST_IMM_OP( slti, x11, x10, 0x0, 0x4, 0x0, x1, 1524, x4)

inst_405:
// rs1_val==4 and imm_val==4, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x4;  immval:0x4
TEST_IMM_OP( slti, x11, x10, 0x0, 0x4, 0x4, x1, 1528, x4)

inst_406:
// rs1_val==4 and imm_val==818, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x4;  immval:0x332
TEST_IMM_OP( slti, x11, x10, 0x1, 0x4, 0x332, x1, 1532, x4)

inst_407:
// rs1_val==4 and imm_val==1637, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x4;  immval:0x665
TEST_IMM_OP( slti, x11, x10, 0x1, 0x4, 0x665, x1, 1536, x4)

inst_408:
// rs1_val==4 and imm_val==44, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x4;  immval:0x2c
TEST_IMM_OP( slti, x11, x10, 0x1, 0x4, 0x2c, x1, 1540, x4)

inst_409:
// rs1_val==4 and imm_val==1366, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x4;  immval:0x556
TEST_IMM_OP( slti, x11, x10, 0x1, 0x4, 0x556, x1, 1544, x4)

inst_410:
// rs1_val==4 and imm_val==-1365, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x4;  immval:-0x555
TEST_IMM_OP( slti, x11, x10, 0x0, 0x4, -0x555, x1, 1548, x4)

inst_411:
// rs1_val==4 and imm_val==6, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x4;  immval:0x6
TEST_IMM_OP( slti, x11, x10, 0x1, 0x4, 0x6, x1, 1552, x4)

inst_412:
// rs1_val==4 and imm_val==820, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x4;  immval:0x334
TEST_IMM_OP( slti, x11, x10, 0x1, 0x4, 0x334, x1, 1556, x4)

inst_413:
// rs1_val==4 and imm_val==1639, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x4;  immval:0x667
TEST_IMM_OP( slti, x11, x10, 0x1, 0x4, 0x667, x1, 1560, x4)

inst_414:
// rs1_val==4 and imm_val==-44, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x4;  immval:-0x2c
TEST_IMM_OP( slti, x11, x10, 0x0, 0x4, -0x2c, x1, 1564, x4)

inst_415:
// rs1_val==4 and imm_val==46, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x4;  immval:0x2e
TEST_IMM_OP( slti, x11, x10, 0x1, 0x4, 0x2e, x1, 1568, x4)

inst_416:
// rs1_val==858993458 and imm_val==3, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x33333332;  immval:0x3
TEST_IMM_OP( slti, x11, x10, 0x0, 0x33333332, 0x3, x1, 1572, x4)

inst_417:
// rs1_val==858993458 and imm_val==1365, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x33333332;  immval:0x555
TEST_IMM_OP( slti, x11, x10, 0x0, 0x33333332, 0x555, x1, 1576, x4)

inst_418:
// rs1_val==858993458 and imm_val==-1366, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x33333332;  immval:-0x556
TEST_IMM_OP( slti, x11, x10, 0x0, 0x33333332, -0x556, x1, 1580, x4)

inst_419:
// rs1_val==858993458 and imm_val==5, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x33333332;  immval:0x5
TEST_IMM_OP( slti, x11, x10, 0x0, 0x33333332, 0x5, x1, 1584, x4)

inst_420:
// rs1_val==858993458 and imm_val==819, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x33333332;  immval:0x333
TEST_IMM_OP( slti, x11, x10, 0x0, 0x33333332, 0x333, x1, 1588, x4)

inst_421:
// rs1_val==858993458 and imm_val==1638, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x33333332;  immval:0x666
TEST_IMM_OP( slti, x11, x10, 0x0, 0x33333332, 0x666, x1, 1592, x4)

inst_422:
// rs1_val==858993458 and imm_val==-45, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x33333332;  immval:-0x2d
TEST_IMM_OP( slti, x11, x10, 0x0, 0x33333332, -0x2d, x1, 1596, x4)

inst_423:
// rs1_val==858993458 and imm_val==45, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x33333332;  immval:0x2d
TEST_IMM_OP( slti, x11, x10, 0x0, 0x33333332, 0x2d, x1, 1600, x4)

inst_424:
// rs1_val==858993458 and imm_val==2, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x33333332;  immval:0x2
TEST_IMM_OP( slti, x11, x10, 0x0, 0x33333332, 0x2, x1, 1604, x4)

inst_425:
// rs1_val==858993458 and imm_val==1364, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x33333332;  immval:0x554
TEST_IMM_OP( slti, x11, x10, 0x0, 0x33333332, 0x554, x1, 1608, x4)

inst_426:
// rs1_val==858993458 and imm_val==0, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x33333332;  immval:0x0
TEST_IMM_OP( slti, x11, x10, 0x0, 0x33333332, 0x0, x1, 1612, x4)

inst_427:
// rs1_val==858993458 and imm_val==4, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x33333332;  immval:0x4
TEST_IMM_OP( slti, x11, x10, 0x0, 0x33333332, 0x4, x1, 1616, x4)

inst_428:
// rs1_val==858993458 and imm_val==818, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x33333332;  immval:0x332
TEST_IMM_OP( slti, x11, x10, 0x0, 0x33333332, 0x332, x1, 1620, x4)

inst_429:
// rs1_val==858993458 and imm_val==1637, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x33333332;  immval:0x665
TEST_IMM_OP( slti, x11, x10, 0x0, 0x33333332, 0x665, x1, 1624, x4)

inst_430:
// rs1_val==858993458 and imm_val==44, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x33333332;  immval:0x2c
TEST_IMM_OP( slti, x11, x10, 0x0, 0x33333332, 0x2c, x1, 1628, x4)

inst_431:
// rs1_val==858993458 and imm_val==1366, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x33333332;  immval:0x556
TEST_IMM_OP( slti, x11, x10, 0x0, 0x33333332, 0x556, x1, 1632, x4)

inst_432:
// rs1_val==858993458 and imm_val==-1365, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x33333332;  immval:-0x555
TEST_IMM_OP( slti, x11, x10, 0x0, 0x33333332, -0x555, x1, 1636, x4)

inst_433:
// rs1_val==858993458 and imm_val==6, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x33333332;  immval:0x6
TEST_IMM_OP( slti, x11, x10, 0x0, 0x33333332, 0x6, x1, 1640, x4)

inst_434:
// rs1_val==858993458 and imm_val==820, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x33333332;  immval:0x334
TEST_IMM_OP( slti, x11, x10, 0x0, 0x33333332, 0x334, x1, 1644, x4)

inst_435:
// rs1_val==858993458 and imm_val==1639, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x33333332;  immval:0x667
TEST_IMM_OP( slti, x11, x10, 0x0, 0x33333332, 0x667, x1, 1648, x4)

inst_436:
// rs1_val==858993458 and imm_val==-44, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x33333332;  immval:-0x2c
TEST_IMM_OP( slti, x11, x10, 0x0, 0x33333332, -0x2c, x1, 1652, x4)

inst_437:
// rs1_val==858993458 and imm_val==46, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x33333332;  immval:0x2e
TEST_IMM_OP( slti, x11, x10, 0x0, 0x33333332, 0x2e, x1, 1656, x4)

inst_438:
// rs1_val==1717986917 and imm_val==3, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x66666665;  immval:0x3
TEST_IMM_OP( slti, x11, x10, 0x0, 0x66666665, 0x3, x1, 1660, x4)

inst_439:
// rs1_val==1717986917 and imm_val==1365, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x66666665;  immval:0x555
TEST_IMM_OP( slti, x11, x10, 0x0, 0x66666665, 0x555, x1, 1664, x4)

inst_440:
// rs1_val==1717986917 and imm_val==-1366, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x66666665;  immval:-0x556
TEST_IMM_OP( slti, x11, x10, 0x0, 0x66666665, -0x556, x1, 1668, x4)

inst_441:
// rs1_val==1717986917 and imm_val==5, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x66666665;  immval:0x5
TEST_IMM_OP( slti, x11, x10, 0x0, 0x66666665, 0x5, x1, 1672, x4)

inst_442:
// rs1_val==1717986917 and imm_val==819, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x66666665;  immval:0x333
TEST_IMM_OP( slti, x11, x10, 0x0, 0x66666665, 0x333, x1, 1676, x4)

inst_443:
// rs1_val==1717986917 and imm_val==1638, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x66666665;  immval:0x666
TEST_IMM_OP( slti, x11, x10, 0x0, 0x66666665, 0x666, x1, 1680, x4)

inst_444:
// rs1_val==1717986917 and imm_val==-45, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x66666665;  immval:-0x2d
TEST_IMM_OP( slti, x11, x10, 0x0, 0x66666665, -0x2d, x1, 1684, x4)

inst_445:
// rs1_val==1717986917 and imm_val==45, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x66666665;  immval:0x2d
TEST_IMM_OP( slti, x11, x10, 0x0, 0x66666665, 0x2d, x1, 1688, x4)

inst_446:
// rs1_val==1717986917 and imm_val==2, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x66666665;  immval:0x2
TEST_IMM_OP( slti, x11, x10, 0x0, 0x66666665, 0x2, x1, 1692, x4)

inst_447:
// rs1_val==1717986917 and imm_val==1364, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x66666665;  immval:0x554
TEST_IMM_OP( slti, x11, x10, 0x0, 0x66666665, 0x554, x1, 1696, x4)

inst_448:
// rs1_val==1717986917 and imm_val==0, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x66666665;  immval:0x0
TEST_IMM_OP( slti, x11, x10, 0x0, 0x66666665, 0x0, x1, 1700, x4)

inst_449:
// rs1_val==1717986917 and imm_val==4, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x66666665;  immval:0x4
TEST_IMM_OP( slti, x11, x10, 0x0, 0x66666665, 0x4, x1, 1704, x4)

inst_450:
// rs1_val==1717986917 and imm_val==818, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x66666665;  immval:0x332
TEST_IMM_OP( slti, x11, x10, 0x0, 0x66666665, 0x332, x1, 1708, x4)

inst_451:
// rs1_val==1717986917 and imm_val==1637, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x66666665;  immval:0x665
TEST_IMM_OP( slti, x11, x10, 0x0, 0x66666665, 0x665, x1, 1712, x4)

inst_452:
// rs1_val==1717986917 and imm_val==44, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x66666665;  immval:0x2c
TEST_IMM_OP( slti, x11, x10, 0x0, 0x66666665, 0x2c, x1, 1716, x4)

inst_453:
// rs1_val==1717986917 and imm_val==1366, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x66666665;  immval:0x556
TEST_IMM_OP( slti, x11, x10, 0x0, 0x66666665, 0x556, x1, 1720, x4)

inst_454:
// rs1_val==1717986917 and imm_val==-1365, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x66666665;  immval:-0x555
TEST_IMM_OP( slti, x11, x10, 0x0, 0x66666665, -0x555, x1, 1724, x4)

inst_455:
// rs1_val==1717986917 and imm_val==6, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x66666665;  immval:0x6
TEST_IMM_OP( slti, x11, x10, 0x0, 0x66666665, 0x6, x1, 1728, x4)

inst_456:
// rs1_val==1717986917 and imm_val==820, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x66666665;  immval:0x334
TEST_IMM_OP( slti, x11, x10, 0x0, 0x66666665, 0x334, x1, 1732, x4)

inst_457:
// rs1_val==1717986917 and imm_val==1639, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x66666665;  immval:0x667
TEST_IMM_OP( slti, x11, x10, 0x0, 0x66666665, 0x667, x1, 1736, x4)

inst_458:
// rs1_val==1717986917 and imm_val==-44, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x66666665;  immval:-0x2c
TEST_IMM_OP( slti, x11, x10, 0x0, 0x66666665, -0x2c, x1, 1740, x4)

inst_459:
// rs1_val==1717986917 and imm_val==46, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x66666665;  immval:0x2e
TEST_IMM_OP( slti, x11, x10, 0x0, 0x66666665, 0x2e, x1, 1744, x4)

inst_460:
// rs1_val==46339 and imm_val==3, 
// opcode: slti ; op1:x10; dest:x11; op1val:0xb503;  immval:0x3
TEST_IMM_OP( slti, x11, x10, 0x0, 0xb503, 0x3, x1, 1748, x4)

inst_461:
// rs1_val==46339 and imm_val==1365, 
// opcode: slti ; op1:x10; dest:x11; op1val:0xb503;  immval:0x555
TEST_IMM_OP( slti, x11, x10, 0x0, 0xb503, 0x555, x1, 1752, x4)

inst_462:
// rs1_val==46339 and imm_val==-1366, 
// opcode: slti ; op1:x10; dest:x11; op1val:0xb503;  immval:-0x556
TEST_IMM_OP( slti, x11, x10, 0x0, 0xb503, -0x556, x1, 1756, x4)

inst_463:
// rs1_val==46339 and imm_val==5, 
// opcode: slti ; op1:x10; dest:x11; op1val:0xb503;  immval:0x5
TEST_IMM_OP( slti, x11, x10, 0x0, 0xb503, 0x5, x1, 1760, x4)

inst_464:
// rs1_val==46339 and imm_val==819, 
// opcode: slti ; op1:x10; dest:x11; op1val:0xb503;  immval:0x333
TEST_IMM_OP( slti, x11, x10, 0x0, 0xb503, 0x333, x1, 1764, x4)

inst_465:
// rs1_val==46339 and imm_val==1638, 
// opcode: slti ; op1:x10; dest:x11; op1val:0xb503;  immval:0x666
TEST_IMM_OP( slti, x11, x10, 0x0, 0xb503, 0x666, x1, 1768, x4)

inst_466:
// rs1_val==46339 and imm_val==-45, 
// opcode: slti ; op1:x10; dest:x11; op1val:0xb503;  immval:-0x2d
TEST_IMM_OP( slti, x11, x10, 0x0, 0xb503, -0x2d, x1, 1772, x4)

inst_467:
// rs1_val==46339 and imm_val==45, 
// opcode: slti ; op1:x10; dest:x11; op1val:0xb503;  immval:0x2d
TEST_IMM_OP( slti, x11, x10, 0x0, 0xb503, 0x2d, x1, 1776, x4)

inst_468:
// rs1_val==46339 and imm_val==2, 
// opcode: slti ; op1:x10; dest:x11; op1val:0xb503;  immval:0x2
TEST_IMM_OP( slti, x11, x10, 0x0, 0xb503, 0x2, x1, 1780, x4)

inst_469:
// rs1_val==46339 and imm_val==1364, 
// opcode: slti ; op1:x10; dest:x11; op1val:0xb503;  immval:0x554
TEST_IMM_OP( slti, x11, x10, 0x0, 0xb503, 0x554, x1, 1784, x4)

inst_470:
// rs1_val==46339 and imm_val==0, 
// opcode: slti ; op1:x10; dest:x11; op1val:0xb503;  immval:0x0
TEST_IMM_OP( slti, x11, x10, 0x0, 0xb503, 0x0, x1, 1788, x4)

inst_471:
// rs1_val==46339 and imm_val==4, 
// opcode: slti ; op1:x10; dest:x11; op1val:0xb503;  immval:0x4
TEST_IMM_OP( slti, x11, x10, 0x0, 0xb503, 0x4, x1, 1792, x4)

inst_472:
// rs1_val==46339 and imm_val==818, 
// opcode: slti ; op1:x10; dest:x11; op1val:0xb503;  immval:0x332
TEST_IMM_OP( slti, x11, x10, 0x0, 0xb503, 0x332, x1, 1796, x4)

inst_473:
// rs1_val==46339 and imm_val==1637, 
// opcode: slti ; op1:x10; dest:x11; op1val:0xb503;  immval:0x665
TEST_IMM_OP( slti, x11, x10, 0x0, 0xb503, 0x665, x1, 1800, x4)

inst_474:
// rs1_val==46339 and imm_val==44, 
// opcode: slti ; op1:x10; dest:x11; op1val:0xb503;  immval:0x2c
TEST_IMM_OP( slti, x11, x10, 0x0, 0xb503, 0x2c, x1, 1804, x4)

inst_475:
// rs1_val==46339 and imm_val==1366, 
// opcode: slti ; op1:x10; dest:x11; op1val:0xb503;  immval:0x556
TEST_IMM_OP( slti, x11, x10, 0x0, 0xb503, 0x556, x1, 1808, x4)

inst_476:
// rs1_val==46339 and imm_val==-1365, 
// opcode: slti ; op1:x10; dest:x11; op1val:0xb503;  immval:-0x555
TEST_IMM_OP( slti, x11, x10, 0x0, 0xb503, -0x555, x1, 1812, x4)

inst_477:
// rs1_val==46339 and imm_val==6, 
// opcode: slti ; op1:x10; dest:x11; op1val:0xb503;  immval:0x6
TEST_IMM_OP( slti, x11, x10, 0x0, 0xb503, 0x6, x1, 1816, x4)

inst_478:
// rs1_val==46339 and imm_val==820, 
// opcode: slti ; op1:x10; dest:x11; op1val:0xb503;  immval:0x334
TEST_IMM_OP( slti, x11, x10, 0x0, 0xb503, 0x334, x1, 1820, x4)

inst_479:
// rs1_val==46339 and imm_val==1639, 
// opcode: slti ; op1:x10; dest:x11; op1val:0xb503;  immval:0x667
TEST_IMM_OP( slti, x11, x10, 0x0, 0xb503, 0x667, x1, 1824, x4)

inst_480:
// rs1_val==46339 and imm_val==-44, 
// opcode: slti ; op1:x10; dest:x11; op1val:0xb503;  immval:-0x2c
TEST_IMM_OP( slti, x11, x10, 0x0, 0xb503, -0x2c, x1, 1828, x4)

inst_481:
// rs1_val==46339 and imm_val==46, 
// opcode: slti ; op1:x10; dest:x11; op1val:0xb503;  immval:0x2e
TEST_IMM_OP( slti, x11, x10, 0x0, 0xb503, 0x2e, x1, 1832, x4)

inst_482:
// rs1_val==1431655766 and imm_val==3, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x55555556;  immval:0x3
TEST_IMM_OP( slti, x11, x10, 0x0, 0x55555556, 0x3, x1, 1836, x4)

inst_483:
// rs1_val==1431655766 and imm_val==1365, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x55555556;  immval:0x555
TEST_IMM_OP( slti, x11, x10, 0x0, 0x55555556, 0x555, x1, 1840, x4)

inst_484:
// rs1_val==1431655766 and imm_val==-1366, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x55555556;  immval:-0x556
TEST_IMM_OP( slti, x11, x10, 0x0, 0x55555556, -0x556, x1, 1844, x4)

inst_485:
// rs1_val==1431655766 and imm_val==5, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x55555556;  immval:0x5
TEST_IMM_OP( slti, x11, x10, 0x0, 0x55555556, 0x5, x1, 1848, x4)

inst_486:
// rs1_val==1431655766 and imm_val==819, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x55555556;  immval:0x333
TEST_IMM_OP( slti, x11, x10, 0x0, 0x55555556, 0x333, x1, 1852, x4)

inst_487:
// rs1_val==1431655766 and imm_val==1638, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x55555556;  immval:0x666
TEST_IMM_OP( slti, x11, x10, 0x0, 0x55555556, 0x666, x1, 1856, x4)

inst_488:
// rs1_val==1431655766 and imm_val==-45, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x55555556;  immval:-0x2d
TEST_IMM_OP( slti, x11, x10, 0x0, 0x55555556, -0x2d, x1, 1860, x4)

inst_489:
// rs1_val==1431655766 and imm_val==45, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x55555556;  immval:0x2d
TEST_IMM_OP( slti, x11, x10, 0x0, 0x55555556, 0x2d, x1, 1864, x4)

inst_490:
// rs1_val==1431655766 and imm_val==2, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x55555556;  immval:0x2
TEST_IMM_OP( slti, x11, x10, 0x0, 0x55555556, 0x2, x1, 1868, x4)

inst_491:
// rs1_val==1431655766 and imm_val==1364, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x55555556;  immval:0x554
TEST_IMM_OP( slti, x11, x10, 0x0, 0x55555556, 0x554, x1, 1872, x4)

inst_492:
// rs1_val==1431655766 and imm_val==0, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x55555556;  immval:0x0
TEST_IMM_OP( slti, x11, x10, 0x0, 0x55555556, 0x0, x1, 1876, x4)

inst_493:
// rs1_val==1431655766 and imm_val==4, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x55555556;  immval:0x4
TEST_IMM_OP( slti, x11, x10, 0x0, 0x55555556, 0x4, x1, 1880, x4)

inst_494:
// rs1_val==1431655766 and imm_val==818, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x55555556;  immval:0x332
TEST_IMM_OP( slti, x11, x10, 0x0, 0x55555556, 0x332, x1, 1884, x4)

inst_495:
// rs1_val==1431655766 and imm_val==1637, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x55555556;  immval:0x665
TEST_IMM_OP( slti, x11, x10, 0x0, 0x55555556, 0x665, x1, 1888, x4)

inst_496:
// rs1_val==1431655766 and imm_val==44, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x55555556;  immval:0x2c
TEST_IMM_OP( slti, x11, x10, 0x0, 0x55555556, 0x2c, x1, 1892, x4)

inst_497:
// rs1_val==1431655766 and imm_val==1366, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x55555556;  immval:0x556
TEST_IMM_OP( slti, x11, x10, 0x0, 0x55555556, 0x556, x1, 1896, x4)

inst_498:
// rs1_val==1431655766 and imm_val==-1365, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x55555556;  immval:-0x555
TEST_IMM_OP( slti, x11, x10, 0x0, 0x55555556, -0x555, x1, 1900, x4)

inst_499:
// rs1_val==1431655766 and imm_val==6, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x55555556;  immval:0x6
TEST_IMM_OP( slti, x11, x10, 0x0, 0x55555556, 0x6, x1, 1904, x4)

inst_500:
// rs1_val==1431655766 and imm_val==820, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x55555556;  immval:0x334
TEST_IMM_OP( slti, x11, x10, 0x0, 0x55555556, 0x334, x1, 1908, x4)

inst_501:
// rs1_val==1431655766 and imm_val==1639, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x55555556;  immval:0x667
TEST_IMM_OP( slti, x11, x10, 0x0, 0x55555556, 0x667, x1, 1912, x4)

inst_502:
// rs1_val==1431655766 and imm_val==-44, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x55555556;  immval:-0x2c
TEST_IMM_OP( slti, x11, x10, 0x0, 0x55555556, -0x2c, x1, 1916, x4)

inst_503:
// rs1_val==1431655766 and imm_val==46, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x55555556;  immval:0x2e
TEST_IMM_OP( slti, x11, x10, 0x0, 0x55555556, 0x2e, x1, 1920, x4)

inst_504:
// rs1_val==-1431655765 and imm_val==3, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0x55555555;  immval:0x3
TEST_IMM_OP( slti, x11, x10, 0x1, -0x55555555, 0x3, x1, 1924, x4)

inst_505:
// rs1_val==-1431655765 and imm_val==1365, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0x55555555;  immval:0x555
TEST_IMM_OP( slti, x11, x10, 0x1, -0x55555555, 0x555, x1, 1928, x4)

inst_506:
// rs1_val==-1431655765 and imm_val==-1366, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0x55555555;  immval:-0x556
TEST_IMM_OP( slti, x11, x10, 0x1, -0x55555555, -0x556, x1, 1932, x4)

inst_507:
// rs1_val==-1431655765 and imm_val==5, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0x55555555;  immval:0x5
TEST_IMM_OP( slti, x11, x10, 0x1, -0x55555555, 0x5, x1, 1936, x4)

inst_508:
// rs1_val==-1431655765 and imm_val==819, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0x55555555;  immval:0x333
TEST_IMM_OP( slti, x11, x10, 0x1, -0x55555555, 0x333, x1, 1940, x4)

inst_509:
// rs1_val==-1431655765 and imm_val==1638, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0x55555555;  immval:0x666
TEST_IMM_OP( slti, x11, x10, 0x1, -0x55555555, 0x666, x1, 1944, x4)

inst_510:
// rs1_val==-1431655765 and imm_val==-45, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0x55555555;  immval:-0x2d
TEST_IMM_OP( slti, x11, x10, 0x1, -0x55555555, -0x2d, x1, 1948, x4)

inst_511:
// rs1_val==-1431655765 and imm_val==45, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0x55555555;  immval:0x2d
TEST_IMM_OP( slti, x11, x10, 0x1, -0x55555555, 0x2d, x1, 1952, x4)

inst_512:
// rs1_val==-1431655765 and imm_val==2, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0x55555555;  immval:0x2
TEST_IMM_OP( slti, x11, x10, 0x1, -0x55555555, 0x2, x1, 1956, x4)

inst_513:
// rs1_val==-1431655765 and imm_val==1364, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0x55555555;  immval:0x554
TEST_IMM_OP( slti, x11, x10, 0x1, -0x55555555, 0x554, x1, 1960, x4)

inst_514:
// rs1_val==-1431655765 and imm_val==0, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0x55555555;  immval:0x0
TEST_IMM_OP( slti, x11, x10, 0x1, -0x55555555, 0x0, x1, 1964, x4)

inst_515:
// rs1_val==-1431655765 and imm_val==4, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0x55555555;  immval:0x4
TEST_IMM_OP( slti, x11, x10, 0x1, -0x55555555, 0x4, x1, 1968, x4)

inst_516:
// rs1_val==-1431655765 and imm_val==818, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0x55555555;  immval:0x332
TEST_IMM_OP( slti, x11, x10, 0x1, -0x55555555, 0x332, x1, 1972, x4)

inst_517:
// rs1_val==-1431655765 and imm_val==1637, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0x55555555;  immval:0x665
TEST_IMM_OP( slti, x11, x10, 0x1, -0x55555555, 0x665, x1, 1976, x4)

inst_518:
// rs1_val==-1431655765 and imm_val==44, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0x55555555;  immval:0x2c
TEST_IMM_OP( slti, x11, x10, 0x1, -0x55555555, 0x2c, x1, 1980, x4)

inst_519:
// rs1_val==-1431655765 and imm_val==1366, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0x55555555;  immval:0x556
TEST_IMM_OP( slti, x11, x10, 0x1, -0x55555555, 0x556, x1, 1984, x4)

inst_520:
// rs1_val==-1431655765 and imm_val==-1365, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0x55555555;  immval:-0x555
TEST_IMM_OP( slti, x11, x10, 0x1, -0x55555555, -0x555, x1, 1988, x4)

inst_521:
// rs1_val==-1431655765 and imm_val==6, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0x55555555;  immval:0x6
TEST_IMM_OP( slti, x11, x10, 0x1, -0x55555555, 0x6, x1, 1992, x4)

inst_522:
// rs1_val==-1431655765 and imm_val==820, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0x55555555;  immval:0x334
TEST_IMM_OP( slti, x11, x10, 0x1, -0x55555555, 0x334, x1, 1996, x4)

inst_523:
// rs1_val==-1431655765 and imm_val==1639, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0x55555555;  immval:0x667
TEST_IMM_OP( slti, x11, x10, 0x1, -0x55555555, 0x667, x1, 2000, x4)

inst_524:
// rs1_val==-1431655765 and imm_val==-44, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0x55555555;  immval:-0x2c
TEST_IMM_OP( slti, x11, x10, 0x1, -0x55555555, -0x2c, x1, 2004, x4)

inst_525:
// rs1_val==-1431655765 and imm_val==46, 
// opcode: slti ; op1:x10; dest:x11; op1val:-0x55555555;  immval:0x2e
TEST_IMM_OP( slti, x11, x10, 0x1, -0x55555555, 0x2e, x1, 2008, x4)

inst_526:
// rs1_val==6 and imm_val==3, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x6;  immval:0x3
TEST_IMM_OP( slti, x11, x10, 0x0, 0x6, 0x3, x1, 2012, x4)

inst_527:
// rs1_val==6 and imm_val==1365, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x6;  immval:0x555
TEST_IMM_OP( slti, x11, x10, 0x1, 0x6, 0x555, x1, 2016, x4)

inst_528:
// rs1_val==6 and imm_val==-1366, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x6;  immval:-0x556
TEST_IMM_OP( slti, x11, x10, 0x0, 0x6, -0x556, x1, 2020, x4)

inst_529:
// rs1_val==6 and imm_val==5, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x6;  immval:0x5
TEST_IMM_OP( slti, x11, x10, 0x0, 0x6, 0x5, x1, 2024, x4)

inst_530:
// rs1_val==6 and imm_val==819, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x6;  immval:0x333
TEST_IMM_OP( slti, x11, x10, 0x1, 0x6, 0x333, x1, 2028, x4)

inst_531:
// rs1_val==6 and imm_val==1638, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x6;  immval:0x666
TEST_IMM_OP( slti, x11, x10, 0x1, 0x6, 0x666, x1, 2032, x4)

inst_532:
// rs1_val==6 and imm_val==-45, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x6;  immval:-0x2d
TEST_IMM_OP( slti, x11, x10, 0x0, 0x6, -0x2d, x1, 2036, x4)

inst_533:
// rs1_val==6 and imm_val==45, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x6;  immval:0x2d
TEST_IMM_OP( slti, x11, x10, 0x1, 0x6, 0x2d, x1, 2040, x4)

inst_534:
// rs1_val==6 and imm_val==2, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x6;  immval:0x2
TEST_IMM_OP( slti, x11, x10, 0x0, 0x6, 0x2, x1, 2044, x4)
RVTEST_SIGBASE( x1,signature_x1_1)

inst_535:
// rs1_val==6 and imm_val==1364, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x6;  immval:0x554
TEST_IMM_OP( slti, x11, x10, 0x1, 0x6, 0x554, x1, 0, x4)

inst_536:
// rs1_val==6 and imm_val==0, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x6;  immval:0x0
TEST_IMM_OP( slti, x11, x10, 0x0, 0x6, 0x0, x1, 4, x4)

inst_537:
// rs1_val==6 and imm_val==4, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x6;  immval:0x4
TEST_IMM_OP( slti, x11, x10, 0x0, 0x6, 0x4, x1, 8, x4)

inst_538:
// rs1_val==6 and imm_val==818, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x6;  immval:0x332
TEST_IMM_OP( slti, x11, x10, 0x1, 0x6, 0x332, x1, 12, x4)

inst_539:
// rs1_val==6 and imm_val==1637, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x6;  immval:0x665
TEST_IMM_OP( slti, x11, x10, 0x1, 0x6, 0x665, x1, 16, x4)

inst_540:
// rs1_val==6 and imm_val==44, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x6;  immval:0x2c
TEST_IMM_OP( slti, x11, x10, 0x1, 0x6, 0x2c, x1, 20, x4)

inst_541:
// rs1_val==6 and imm_val==1366, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x6;  immval:0x556
TEST_IMM_OP( slti, x11, x10, 0x1, 0x6, 0x556, x1, 24, x4)

inst_542:
// rs1_val==6 and imm_val==-1365, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x6;  immval:-0x555
TEST_IMM_OP( slti, x11, x10, 0x0, 0x6, -0x555, x1, 28, x4)

inst_543:
// rs1_val==6 and imm_val==6, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x6;  immval:0x6
TEST_IMM_OP( slti, x11, x10, 0x0, 0x6, 0x6, x1, 32, x4)

inst_544:
// rs1_val==6 and imm_val==820, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x6;  immval:0x334
TEST_IMM_OP( slti, x11, x10, 0x1, 0x6, 0x334, x1, 36, x4)

inst_545:
// rs1_val==6 and imm_val==1639, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x6;  immval:0x667
TEST_IMM_OP( slti, x11, x10, 0x1, 0x6, 0x667, x1, 40, x4)

inst_546:
// rs1_val==6 and imm_val==-44, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x6;  immval:-0x2c
TEST_IMM_OP( slti, x11, x10, 0x0, 0x6, -0x2c, x1, 44, x4)

inst_547:
// rs1_val==6 and imm_val==46, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x6;  immval:0x2e
TEST_IMM_OP( slti, x11, x10, 0x1, 0x6, 0x2e, x1, 48, x4)

inst_548:
// rs1_val==858993460 and imm_val==3, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x33333334;  immval:0x3
TEST_IMM_OP( slti, x11, x10, 0x0, 0x33333334, 0x3, x1, 52, x4)

inst_549:
// rs1_val==858993460 and imm_val==1365, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x33333334;  immval:0x555
TEST_IMM_OP( slti, x11, x10, 0x0, 0x33333334, 0x555, x1, 56, x4)

inst_550:
// rs1_val==858993460 and imm_val==-1366, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x33333334;  immval:-0x556
TEST_IMM_OP( slti, x11, x10, 0x0, 0x33333334, -0x556, x1, 60, x4)

inst_551:
// rs1_val==858993460 and imm_val==5, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x33333334;  immval:0x5
TEST_IMM_OP( slti, x11, x10, 0x0, 0x33333334, 0x5, x1, 64, x4)

inst_552:
// rs1_val==858993460 and imm_val==819, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x33333334;  immval:0x333
TEST_IMM_OP( slti, x11, x10, 0x0, 0x33333334, 0x333, x1, 68, x4)

inst_553:
// rs1_val==858993460 and imm_val==1638, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x33333334;  immval:0x666
TEST_IMM_OP( slti, x11, x10, 0x0, 0x33333334, 0x666, x1, 72, x4)

inst_554:
// rs1_val==858993460 and imm_val==-45, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x33333334;  immval:-0x2d
TEST_IMM_OP( slti, x11, x10, 0x0, 0x33333334, -0x2d, x1, 76, x4)

inst_555:
// rs1_val==858993460 and imm_val==45, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x33333334;  immval:0x2d
TEST_IMM_OP( slti, x11, x10, 0x0, 0x33333334, 0x2d, x1, 80, x4)

inst_556:
// rs1_val==858993460 and imm_val==2, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x33333334;  immval:0x2
TEST_IMM_OP( slti, x11, x10, 0x0, 0x33333334, 0x2, x1, 84, x4)

inst_557:
// rs1_val==858993460 and imm_val==1364, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x33333334;  immval:0x554
TEST_IMM_OP( slti, x11, x10, 0x0, 0x33333334, 0x554, x1, 88, x4)

inst_558:
// rs1_val==858993460 and imm_val==0, 
// opcode: slti ; op1:x10; dest:x11; op1val:0x33333334;  immval:0x0
TEST_IMM_OP( slti, x11, x10, 0x0, 0x33333334, 0x0, x1, 92, x4)

inst_559:
// imm_val == -5, rs1_val == -1048577
// opcode: slti ; op1:x10; dest:x11; op1val:-0x100001;  immval:-0x5
TEST_IMM_OP( slti, x11, x10, 0x1, -0x100001, -0x5, x1, 96, x4)
#endif


RVTEST_CODE_END
RVMODEL_HALT

RVTEST_DATA_BEGIN
.align 4

rvtest_data:
.word 0xbabecafe
.word 0xbabecafe
.word 0xbabecafe
.word 0xbabecafe
RVTEST_DATA_END


RVMODEL_DATA_BEGIN
rvtest_sig_begin:
sig_begin_canary:
CANARY;


signature_x2_0:
    .fill 0*(XLEN/32),4,0xdeadbeef


signature_x2_1:
    .fill 23*(XLEN/32),4,0xdeadbeef


signature_x1_0:
    .fill 512*(XLEN/32),4,0xdeadbeef


signature_x1_1:
    .fill 25*(XLEN/32),4,0xdeadbeef

#ifdef rvtest_mtrap_routine

tsig_begin_canary:
CANARY;
mtrap_sigptr:
    .fill 64*(XLEN/32),4,0xdeadbeef
tsig_end_canary:
CANARY;

#endif

#ifdef rvtest_gpr_save

gpr_save:
    .fill 32*(XLEN/32),4,0xdeadbeef

#endif

sig_end_canary:
CANARY;
rvtest_sig_end:
RVMODEL_DATA_END
