
// -----------
// This file was generated by riscv_ctg (https://github.com/riscv-software-src/riscv-ctg)
// version   : 0.7.1
// timestamp : Sun Aug  7 18:29:26 2022 GMT
// usage     : riscv_ctg \
//                  -- cgf //                  --cgf /home/anku/work2/bcrypto/32/dataset.yaml \
//                  --cgf /home/anku/work2/bcrypto/32/rv32ik.yaml \
 \
//                  -- xlen 32  \
// -----------
//
// -----------
// Copyright (c) 2020. RISC-V International. All rights reserved.
// SPDX-License-Identifier: BSD-3-Clause
// -----------
//
// This assembly file tests the sha512sum1r instruction of the RISC-V RV32Zk,RV32Zkn,RV32Zknh extension for the sha512sum1r covergroup.
// 
#include "model_test.h"
#include "arch_test.h"
RVTEST_ISA("RV32IZk,RV32IZkn,RV32IZknh")

.section .text.init
.org 0x80
.globl rvtest_entry_point
rvtest_entry_point:
RVMODEL_BOOT
RVTEST_CODE_BEGIN

#ifdef TEST_CASE_1

RVTEST_CASE(0,"//check ISA:=regex(.*32.*);check ISA:=regex(.*I.*Zk.*);def TEST_CASE_1=True;",sha512sum1r)

RVTEST_CASE(1,"//check ISA:=regex(.*32.*);check ISA:=regex(.*RV32.*I.*Zkn.*);def TEST_CASE_1=True;",sha512sum1r)

RVTEST_CASE(2,"//check ISA:=regex(.*32.*);check ISA:=regex(.*RV32.*I.*Zknh.*);def TEST_CASE_1=True;",sha512sum1r)

RVTEST_SIGBASE(x1,signature_x1_1)

inst_0:
// rs1 == rd != rs2, rs1==x31, rs2==x30, rd==x31, 
// opcode: sha512sum1r ; op1:x31; op2:x30; dest:x31; op1val:0x254a9493;  op2val:0xc5521660
TEST_RR_OP(sha512sum1r, x31, x31, x30, 0x00000000, 0x254a9493, 0xc5521660, x1, 0, x2)

inst_1:
// rs1 != rs2  and rs1 != rd and rs2 != rd, rs1==x29, rs2==x31, rd==x30, 
// opcode: sha512sum1r ; op1:x29; op2:x31; dest:x30; op1val:0xffffffff;  op2val:0x7fffffff
TEST_RR_OP(sha512sum1r, x30, x29, x31, 0x00000000, 0xffffffff, 0x7fffffff, x1, 4, x2)

inst_2:
// rs1 == rs2 == rd, rs1==x28, rs2==x28, rd==x28, 
// opcode: sha512sum1r ; op1:x28; op2:x28; dest:x28; op1val:0xffffffff;  op2val:0xffffffff
TEST_RR_OP(sha512sum1r, x28, x28, x28, 0x00000000, 0xffffffff, 0xffffffff, x1, 8, x2)

inst_3:
// rs2 == rd != rs1, rs1==x30, rs2==x29, rd==x29, 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x29; op1val:0xffffffff;  op2val:0xdfffffff
TEST_RR_OP(sha512sum1r, x29, x30, x29, 0x00000000, 0xffffffff, 0xdfffffff, x1, 12, x2)

inst_4:
// rs1 == rs2 != rd, rs1==x26, rs2==x26, rd==x27, 
// opcode: sha512sum1r ; op1:x26; op2:x26; dest:x27; op1val:0xffffffff;  op2val:0xffffffff
TEST_RR_OP(sha512sum1r, x27, x26, x26, 0x00000000, 0xffffffff, 0xffffffff, x1, 16, x2)

inst_5:
// rs1==x27, rs2==x25, rd==x26, 
// opcode: sha512sum1r ; op1:x27; op2:x25; dest:x26; op1val:0xffffffff;  op2val:0xf7ffffff
TEST_RR_OP(sha512sum1r, x26, x27, x25, 0x00000000, 0xffffffff, 0xf7ffffff, x1, 20, x2)

inst_6:
// rs1==x24, rs2==x27, rd==x25, 
// opcode: sha512sum1r ; op1:x24; op2:x27; dest:x25; op1val:0xffffffff;  op2val:0xfbffffff
TEST_RR_OP(sha512sum1r, x25, x24, x27, 0x00000000, 0xffffffff, 0xfbffffff, x1, 24, x2)

inst_7:
// rs1==x25, rs2==x23, rd==x24, 
// opcode: sha512sum1r ; op1:x25; op2:x23; dest:x24; op1val:0xffffffff;  op2val:0xfdffffff
TEST_RR_OP(sha512sum1r, x24, x25, x23, 0x00000000, 0xffffffff, 0xfdffffff, x1, 28, x2)

inst_8:
// rs1==x22, rs2==x24, rd==x23, 
// opcode: sha512sum1r ; op1:x22; op2:x24; dest:x23; op1val:0xffffffff;  op2val:0xfeffffff
TEST_RR_OP(sha512sum1r, x23, x22, x24, 0x00000000, 0xffffffff, 0xfeffffff, x1, 32, x2)

inst_9:
// rs1==x23, rs2==x21, rd==x22, 
// opcode: sha512sum1r ; op1:x23; op2:x21; dest:x22; op1val:0xffffffff;  op2val:0xff7fffff
TEST_RR_OP(sha512sum1r, x22, x23, x21, 0x00000000, 0xffffffff, 0xff7fffff, x1, 36, x2)

inst_10:
// rs1==x20, rs2==x22, rd==x21, 
// opcode: sha512sum1r ; op1:x20; op2:x22; dest:x21; op1val:0xffffffff;  op2val:0xffbfffff
TEST_RR_OP(sha512sum1r, x21, x20, x22, 0x00000000, 0xffffffff, 0xffbfffff, x1, 40, x2)

inst_11:
// rs1==x21, rs2==x19, rd==x20, 
// opcode: sha512sum1r ; op1:x21; op2:x19; dest:x20; op1val:0xffffffff;  op2val:0xffdfffff
TEST_RR_OP(sha512sum1r, x20, x21, x19, 0x00000000, 0xffffffff, 0xffdfffff, x1, 44, x2)

inst_12:
// rs1==x18, rs2==x20, rd==x19, 
// opcode: sha512sum1r ; op1:x18; op2:x20; dest:x19; op1val:0xffffffff;  op2val:0xffefffff
TEST_RR_OP(sha512sum1r, x19, x18, x20, 0x00000000, 0xffffffff, 0xffefffff, x1, 48, x2)

inst_13:
// rs1==x19, rs2==x17, rd==x18, 
// opcode: sha512sum1r ; op1:x19; op2:x17; dest:x18; op1val:0xffffffff;  op2val:0xfff7ffff
TEST_RR_OP(sha512sum1r, x18, x19, x17, 0x00000000, 0xffffffff, 0xfff7ffff, x1, 52, x2)

inst_14:
// rs1==x16, rs2==x18, rd==x17, 
// opcode: sha512sum1r ; op1:x16; op2:x18; dest:x17; op1val:0xffffffff;  op2val:0xfffbffff
TEST_RR_OP(sha512sum1r, x17, x16, x18, 0x00000000, 0xffffffff, 0xfffbffff, x1, 56, x2)

inst_15:
// rs1==x17, rs2==x15, rd==x16, 
// opcode: sha512sum1r ; op1:x17; op2:x15; dest:x16; op1val:0xffffffff;  op2val:0xfffdffff
TEST_RR_OP(sha512sum1r, x16, x17, x15, 0x00000000, 0xffffffff, 0xfffdffff, x1, 60, x2)

inst_16:
// rs1==x14, rs2==x16, rd==x15, 
// opcode: sha512sum1r ; op1:x14; op2:x16; dest:x15; op1val:0xffffffff;  op2val:0xfffeffff
TEST_RR_OP(sha512sum1r, x15, x14, x16, 0x00000000, 0xffffffff, 0xfffeffff, x1, 64, x2)

inst_17:
// rs1==x15, rs2==x13, rd==x14, 
// opcode: sha512sum1r ; op1:x15; op2:x13; dest:x14; op1val:0xffffffff;  op2val:0xffff7fff
TEST_RR_OP(sha512sum1r, x14, x15, x13, 0x00000000, 0xffffffff, 0xffff7fff, x1, 68, x2)

inst_18:
// rs1==x12, rs2==x14, rd==x13, 
// opcode: sha512sum1r ; op1:x12; op2:x14; dest:x13; op1val:0xffffffff;  op2val:0xffffbfff
TEST_RR_OP(sha512sum1r, x13, x12, x14, 0x00000000, 0xffffffff, 0xffffbfff, x1, 72, x2)

inst_19:
// rs1==x13, rs2==x11, rd==x12, 
// opcode: sha512sum1r ; op1:x13; op2:x11; dest:x12; op1val:0xffffffff;  op2val:0xffffdfff
TEST_RR_OP(sha512sum1r, x12, x13, x11, 0x00000000, 0xffffffff, 0xffffdfff, x1, 76, x2)

inst_20:
// rs1==x10, rs2==x12, rd==x11, 
// opcode: sha512sum1r ; op1:x10; op2:x12; dest:x11; op1val:0xffffffff;  op2val:0xffffefff
TEST_RR_OP(sha512sum1r, x11, x10, x12, 0x00000000, 0xffffffff, 0xffffefff, x1, 80, x2)

inst_21:
// rs1==x11, rs2==x9, rd==x10, 
// opcode: sha512sum1r ; op1:x11; op2:x9; dest:x10; op1val:0xffffffff;  op2val:0xfffff7ff
TEST_RR_OP(sha512sum1r, x10, x11, x9, 0x00000000, 0xffffffff, 0xfffff7ff, x1, 84, x2)

inst_22:
// rs1==x8, rs2==x10, rd==x9, 
// opcode: sha512sum1r ; op1:x8; op2:x10; dest:x9; op1val:0xffffffff;  op2val:0xfffffbff
TEST_RR_OP(sha512sum1r, x9, x8, x10, 0x00000000, 0xffffffff, 0xfffffbff, x1, 88, x2)

inst_23:
// rs1==x9, rs2==x7, rd==x8, 
// opcode: sha512sum1r ; op1:x9; op2:x7; dest:x8; op1val:0xffffffff;  op2val:0xfffffdff
TEST_RR_OP(sha512sum1r, x8, x9, x7, 0x00000000, 0xffffffff, 0xfffffdff, x1, 92, x2)

inst_24:
// rs1==x6, rs2==x8, rd==x7, 
// opcode: sha512sum1r ; op1:x6; op2:x8; dest:x7; op1val:0xffffffff;  op2val:0xfffffeff
TEST_RR_OP(sha512sum1r, x7, x6, x8, 0x00000000, 0xffffffff, 0xfffffeff, x1, 96, x2)

inst_25:
// rs1==x7, rs2==x5, rd==x6, 
// opcode: sha512sum1r ; op1:x7; op2:x5; dest:x6; op1val:0xffffffff;  op2val:0xffffff7f
TEST_RR_OP(sha512sum1r, x6, x7, x5, 0x00000000, 0xffffffff, 0xffffff7f, x1, 100, x8)
RVTEST_SIGBASE(x7,signature_x7_0)

inst_26:
// rs1==x4, rs2==x6, rd==x5, 
// opcode: sha512sum1r ; op1:x4; op2:x6; dest:x5; op1val:0xffffffff;  op2val:0xffffffbf
TEST_RR_OP(sha512sum1r, x5, x4, x6, 0x00000000, 0xffffffff, 0xffffffbf, x7, 0, x8)

inst_27:
// rs1==x5, rs2==x3, rd==x4, 
// opcode: sha512sum1r ; op1:x5; op2:x3; dest:x4; op1val:0xffffffff;  op2val:0xffffffdf
TEST_RR_OP(sha512sum1r, x4, x5, x3, 0x00000000, 0xffffffff, 0xffffffdf, x7, 4, x8)

inst_28:
// rs1==x2, rs2==x4, rd==x3, 
// opcode: sha512sum1r ; op1:x2; op2:x4; dest:x3; op1val:0xffffffff;  op2val:0xffffffef
TEST_RR_OP(sha512sum1r, x3, x2, x4, 0x00000000, 0xffffffff, 0xffffffef, x7, 8, x8)

inst_29:
// rs1==x3, rs2==x1, rd==x2, 
// opcode: sha512sum1r ; op1:x3; op2:x1; dest:x2; op1val:0xffffffff;  op2val:0xfffffff7
TEST_RR_OP(sha512sum1r, x2, x3, x1, 0x00000000, 0xffffffff, 0xfffffff7, x7, 12, x8)

inst_30:
// rs1==x0, rs2==x2, rd==x1, 
// opcode: sha512sum1r ; op1:x0; op2:x2; dest:x1; op1val:0x0;  op2val:0xfffffffb
TEST_RR_OP(sha512sum1r, x1, x0, x2, 0x00000000, 0x0, 0xfffffffb, x7, 16, x8)

inst_31:
// rs1==x1, 
// opcode: sha512sum1r ; op1:x1; op2:x30; dest:x31; op1val:0xffffffff;  op2val:0xfffffffd
TEST_RR_OP(sha512sum1r, x31, x1, x30, 0x00000000, 0xffffffff, 0xfffffffd, x7, 20, x8)

inst_32:
// rs2==x0, 
// opcode: sha512sum1r ; op1:x30; op2:x0; dest:x31; op1val:0xffffffff;  op2val:0x0
TEST_RR_OP(sha512sum1r, x31, x30, x0, 0x00000000, 0xffffffff, 0x0, x7, 24, x8)

inst_33:
// rd==x0, 
// opcode: sha512sum1r ; op1:x31; op2:x30; dest:x0; op1val:0x7fffffff;  op2val:0xffffffff
TEST_RR_OP(sha512sum1r, x0, x31, x30, 0x00000000, 0x7fffffff, 0xffffffff, x7, 28, x8)

inst_34:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xbfffffff;  op2val:0xffffffff
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xbfffffff, 0xffffffff, x7, 32, x8)

inst_35:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xdfffffff;  op2val:0xffffffff
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xdfffffff, 0xffffffff, x7, 36, x8)

inst_36:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xefffffff;  op2val:0xffffffff
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xefffffff, 0xffffffff, x7, 40, x8)

inst_37:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xf7ffffff;  op2val:0xffffffff
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xf7ffffff, 0xffffffff, x7, 44, x8)

inst_38:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xfbffffff;  op2val:0xffffffff
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xfbffffff, 0xffffffff, x7, 48, x8)

inst_39:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xfdffffff;  op2val:0xffffffff
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xfdffffff, 0xffffffff, x7, 52, x8)

inst_40:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xfeffffff;  op2val:0xffffffff
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xfeffffff, 0xffffffff, x7, 56, x8)

inst_41:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xff7fffff;  op2val:0xffffffff
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xff7fffff, 0xffffffff, x7, 60, x8)

inst_42:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xffbfffff;  op2val:0xffffffff
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xffbfffff, 0xffffffff, x7, 64, x8)

inst_43:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xffdfffff;  op2val:0xffffffff
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xffdfffff, 0xffffffff, x7, 68, x8)

inst_44:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xffefffff;  op2val:0xffffffff
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xffefffff, 0xffffffff, x7, 72, x8)

inst_45:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xfff7ffff;  op2val:0xffffffff
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xfff7ffff, 0xffffffff, x7, 76, x8)

inst_46:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xfffbffff;  op2val:0xffffffff
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xfffbffff, 0xffffffff, x7, 80, x8)

inst_47:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xfffdffff;  op2val:0xffffffff
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xfffdffff, 0xffffffff, x7, 84, x8)

inst_48:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xfffeffff;  op2val:0xffffffff
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xfffeffff, 0xffffffff, x7, 88, x8)

inst_49:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xffff7fff;  op2val:0xffffffff
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xffff7fff, 0xffffffff, x7, 92, x8)

inst_50:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xffffbfff;  op2val:0xffffffff
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xffffbfff, 0xffffffff, x7, 96, x8)

inst_51:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xffffdfff;  op2val:0xffffffff
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xffffdfff, 0xffffffff, x7, 100, x8)

inst_52:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xffffefff;  op2val:0xffffffff
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xffffefff, 0xffffffff, x7, 104, x8)

inst_53:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xfffff7ff;  op2val:0xffffffff
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xfffff7ff, 0xffffffff, x7, 108, x8)

inst_54:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xfffffbff;  op2val:0xffffffff
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xfffffbff, 0xffffffff, x7, 112, x8)

inst_55:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xfffffdff;  op2val:0xffffffff
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xfffffdff, 0xffffffff, x7, 116, x8)

inst_56:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xfffffeff;  op2val:0xffffffff
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xfffffeff, 0xffffffff, x7, 120, x8)

inst_57:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xffffff7f;  op2val:0xffffffff
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xffffff7f, 0xffffffff, x7, 124, x8)

inst_58:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xffffffbf;  op2val:0xffffffff
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xffffffbf, 0xffffffff, x7, 128, x8)

inst_59:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xffffffdf;  op2val:0xffffffff
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xffffffdf, 0xffffffff, x7, 132, x8)

inst_60:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xffffffef;  op2val:0xffffffff
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xffffffef, 0xffffffff, x7, 136, x8)

inst_61:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xfffffff7;  op2val:0xffffffff
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xfffffff7, 0xffffffff, x7, 140, x8)

inst_62:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xfffffffb;  op2val:0xffffffff
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xfffffffb, 0xffffffff, x7, 144, x8)

inst_63:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xfffffffd;  op2val:0xffffffff
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xfffffffd, 0xffffffff, x7, 148, x8)

inst_64:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xfffffffe;  op2val:0xffffffff
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xfffffffe, 0xffffffff, x7, 152, x8)

inst_65:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x80000000
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xffffffff, 0x80000000, x7, 156, x8)

inst_66:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x40000000
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xffffffff, 0x40000000, x7, 160, x8)

inst_67:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x20000000
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xffffffff, 0x20000000, x7, 164, x8)

inst_68:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x10000000
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xffffffff, 0x10000000, x7, 168, x8)

inst_69:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x8000000
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xffffffff, 0x8000000, x7, 172, x8)

inst_70:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x4000000
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xffffffff, 0x4000000, x7, 176, x8)

inst_71:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x2000000
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xffffffff, 0x2000000, x7, 180, x8)

inst_72:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x1000000
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xffffffff, 0x1000000, x7, 184, x8)

inst_73:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x800000
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xffffffff, 0x800000, x7, 188, x8)

inst_74:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x400000
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xffffffff, 0x400000, x7, 192, x8)

inst_75:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x200000
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xffffffff, 0x200000, x7, 196, x8)

inst_76:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x100000
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xffffffff, 0x100000, x7, 200, x8)

inst_77:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x80000
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xffffffff, 0x80000, x7, 204, x8)

inst_78:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x40000
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xffffffff, 0x40000, x7, 208, x8)

inst_79:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x20000
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xffffffff, 0x20000, x7, 212, x8)

inst_80:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x10000
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xffffffff, 0x10000, x7, 216, x8)

inst_81:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x8000
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xffffffff, 0x8000, x7, 220, x8)

inst_82:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x4000
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xffffffff, 0x4000, x7, 224, x8)

inst_83:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x2000
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xffffffff, 0x2000, x7, 228, x8)

inst_84:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x1000
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xffffffff, 0x1000, x7, 232, x8)

inst_85:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0x1;  op2val:0xffffffff
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0x1, 0xffffffff, x7, 236, x8)

inst_86:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0x91766f62;  op2val:0x5570084b
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0x91766f62, 0x5570084b, x7, 240, x8)

inst_87:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xc0fe15dd;  op2val:0x9f053821
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xc0fe15dd, 0x9f053821, x7, 244, x8)

inst_88:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xdc80d916;  op2val:0x2a2a146d
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xdc80d916, 0x2a2a146d, x7, 248, x8)

inst_89:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0x952acffe;  op2val:0x25ae27ee
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0x952acffe, 0x25ae27ee, x7, 252, x8)

inst_90:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0x40a5ff52;  op2val:0xb6f9706f
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0x40a5ff52, 0xb6f9706f, x7, 256, x8)

inst_91:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xe3f4fca3;  op2val:0xa6c9253a
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xe3f4fca3, 0xa6c9253a, x7, 260, x8)

inst_92:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xc2f1c53e;  op2val:0xd05668ae
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xc2f1c53e, 0xd05668ae, x7, 264, x8)

inst_93:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0x9722c9a6;  op2val:0x7bcad7c4
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0x9722c9a6, 0x7bcad7c4, x7, 268, x8)

inst_94:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xf7f1305a;  op2val:0x9bedfe39
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xf7f1305a, 0x9bedfe39, x7, 272, x8)

inst_95:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xd75739f8;  op2val:0xe6fff3d9
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xd75739f8, 0xe6fff3d9, x7, 276, x8)

inst_96:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0x90efb625;  op2val:0x3150e5fa
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0x90efb625, 0x3150e5fa, x7, 280, x8)

inst_97:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0x1fc493ca;  op2val:0x65408c73
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0x1fc493ca, 0x65408c73, x7, 284, x8)

inst_98:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0x8e2eac2a;  op2val:0xd169a3f8
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0x8e2eac2a, 0xd169a3f8, x7, 288, x8)

inst_99:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0x35f9377f;  op2val:0xf4c30307
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0x35f9377f, 0xf4c30307, x7, 292, x8)

inst_100:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0x58d548aa;  op2val:0xa0569d76
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0x58d548aa, 0xa0569d76, x7, 296, x8)

inst_101:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0x55d98c6e;  op2val:0x2daf9ac7
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0x55d98c6e, 0x2daf9ac7, x7, 300, x8)

inst_102:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0x74b8de87;  op2val:0xf273b44c
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0x74b8de87, 0xf273b44c, x7, 304, x8)

inst_103:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xccce240c;  op2val:0x886c3a30
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xccce240c, 0x886c3a30, x7, 308, x8)

inst_104:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xb49c83dc;  op2val:0xbb61a9cd
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xb49c83dc, 0xbb61a9cd, x7, 312, x8)

inst_105:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x800
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xffffffff, 0x800, x7, 316, x8)

inst_106:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x400
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xffffffff, 0x400, x7, 320, x8)

inst_107:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x200
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xffffffff, 0x200, x7, 324, x8)

inst_108:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x100
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xffffffff, 0x100, x7, 328, x8)

inst_109:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x80
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xffffffff, 0x80, x7, 332, x8)

inst_110:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x40
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xffffffff, 0x40, x7, 336, x8)

inst_111:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x20
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xffffffff, 0x20, x7, 340, x8)

inst_112:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x10
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xffffffff, 0x10, x7, 344, x8)

inst_113:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x8
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xffffffff, 0x8, x7, 348, x8)

inst_114:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x4
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xffffffff, 0x4, x7, 352, x8)

inst_115:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x2
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xffffffff, 0x2, x7, 356, x8)

inst_116:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x1
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xffffffff, 0x1, x7, 360, x8)

inst_117:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0x80000000;  op2val:0xffffffff
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0x80000000, 0xffffffff, x7, 364, x8)

inst_118:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0x40000000;  op2val:0xffffffff
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0x40000000, 0xffffffff, x7, 368, x8)

inst_119:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0x20000000;  op2val:0xffffffff
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0x20000000, 0xffffffff, x7, 372, x8)

inst_120:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0x10000000;  op2val:0xffffffff
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0x10000000, 0xffffffff, x7, 376, x8)

inst_121:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0x8000000;  op2val:0xffffffff
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0x8000000, 0xffffffff, x7, 380, x8)

inst_122:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0x4000000;  op2val:0xffffffff
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0x4000000, 0xffffffff, x7, 384, x8)

inst_123:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0x2000000;  op2val:0xffffffff
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0x2000000, 0xffffffff, x7, 388, x8)

inst_124:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0x1000000;  op2val:0xffffffff
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0x1000000, 0xffffffff, x7, 392, x8)

inst_125:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0x800000;  op2val:0xffffffff
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0x800000, 0xffffffff, x7, 396, x8)

inst_126:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0x400000;  op2val:0xffffffff
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0x400000, 0xffffffff, x7, 400, x8)

inst_127:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0x200000;  op2val:0xffffffff
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0x200000, 0xffffffff, x7, 404, x8)

inst_128:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0x100000;  op2val:0xffffffff
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0x100000, 0xffffffff, x7, 408, x8)

inst_129:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0x80000;  op2val:0xffffffff
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0x80000, 0xffffffff, x7, 412, x8)

inst_130:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0x40000;  op2val:0xffffffff
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0x40000, 0xffffffff, x7, 416, x8)

inst_131:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0x20000;  op2val:0xffffffff
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0x20000, 0xffffffff, x7, 420, x8)

inst_132:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0x10000;  op2val:0xffffffff
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0x10000, 0xffffffff, x7, 424, x8)

inst_133:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0x8000;  op2val:0xffffffff
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0x8000, 0xffffffff, x7, 428, x8)

inst_134:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0x4000;  op2val:0xffffffff
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0x4000, 0xffffffff, x7, 432, x8)

inst_135:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0x2000;  op2val:0xffffffff
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0x2000, 0xffffffff, x7, 436, x8)

inst_136:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0x1000;  op2val:0xffffffff
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0x1000, 0xffffffff, x7, 440, x8)

inst_137:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0x800;  op2val:0xffffffff
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0x800, 0xffffffff, x7, 444, x8)

inst_138:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0x400;  op2val:0xffffffff
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0x400, 0xffffffff, x7, 448, x8)

inst_139:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0x200;  op2val:0xffffffff
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0x200, 0xffffffff, x7, 452, x8)

inst_140:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0x100;  op2val:0xffffffff
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0x100, 0xffffffff, x7, 456, x8)

inst_141:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0x80;  op2val:0xffffffff
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0x80, 0xffffffff, x7, 460, x8)

inst_142:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0x40;  op2val:0xffffffff
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0x40, 0xffffffff, x7, 464, x8)

inst_143:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0x20;  op2val:0xffffffff
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0x20, 0xffffffff, x7, 468, x8)

inst_144:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0x10;  op2val:0xffffffff
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0x10, 0xffffffff, x7, 472, x8)

inst_145:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0x8;  op2val:0xffffffff
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0x8, 0xffffffff, x7, 476, x8)

inst_146:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0x4;  op2val:0xffffffff
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0x4, 0xffffffff, x7, 480, x8)

inst_147:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0x2;  op2val:0xffffffff
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0x2, 0xffffffff, x7, 484, x8)

inst_148:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0xbfffffff
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xffffffff, 0xbfffffff, x7, 488, x8)

inst_149:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0xefffffff
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xffffffff, 0xefffffff, x7, 492, x8)

inst_150:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0xfffffffb
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xffffffff, 0xfffffffb, x7, 496, x8)

inst_151:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0xfffffffe
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0xffffffff, 0xfffffffe, x7, 500, x8)

inst_152:
// 
// opcode: sha512sum1r ; op1:x30; op2:x29; dest:x31; op1val:0x7fffffff;  op2val:0xffffffff
TEST_RR_OP(sha512sum1r, x31, x30, x29, 0x00000000, 0x7fffffff, 0xffffffff, x7, 504, x8)
#endif


RVTEST_CODE_END
RVMODEL_HALT

RVTEST_DATA_BEGIN
.align 4
rvtest_data:
.word 0xbabecafe
.word 0xabecafeb
.word 0xbecafeba
.word 0xecafebab
RVTEST_DATA_END

RVMODEL_DATA_BEGIN
rvtest_sig_begin:
sig_begin_canary:
CANARY;


signature_x1_0:
    .fill 0*(XLEN/32),4,0xdeadbeef


signature_x1_1:
    .fill 26*(XLEN/32),4,0xdeadbeef


signature_x7_0:
    .fill 127*(XLEN/32),4,0xdeadbeef

#ifdef rvtest_mtrap_routine

tsig_begin_canary:
CANARY;
mtrap_sigptr:
    .fill 64*(XLEN/32),4,0xdeadbeef
tsig_end_canary:
CANARY;

#endif

#ifdef rvtest_gpr_save

gpr_save:
    .fill 32*(XLEN/32),4,0xdeadbeef

#endif

sig_end_canary:
CANARY;
rvtest_sig_end:
RVMODEL_DATA_END
