
// -----------
// This file was generated by riscv_ctg (https://github.com/riscv-software-src/riscv-ctg)
// version   : 0.6.3
// timestamp : Sat Apr 23 14:53:29 2022 GMT
// usage     : riscv_ctg \
//                  --cgf /scratch/git-repo/github/riscv_ctg/sample_cgfs/dataset.cgf \
//                  --cgf /scratch/git-repo/github/riscv_ctg/sample_cgfs/rv32ip.cgf \
//                  --xlen 32  \
//                  --randomize \
// -----------
//
// -----------
// Copyright (c) 2020. RISC-V International. All rights reserved.
// SPDX-License-Identifier: BSD-3-Clause
// -----------
//
// This assembly file tests the insb instruction of the RISC-V RV32PZicsr extension for the insb covergroup.
// 
#include "model_test.h"
#include "arch_test.h"
RVTEST_ISA("RV32IPZicsr")

.section .text.init
.org 0x80
.globl rvtest_entry_point
rvtest_entry_point:
RVMODEL_BOOT
RVTEST_CODE_BEGIN

#ifdef TEST_CASE_1

RVTEST_CASE(0,"//check ISA:=regex(.*32.*);check ISA:=regex(.*I.*P.*Zicsr.*);def TEST_CASE_1=True;",insb)

RVTEST_VXSAT_ENABLE()
RVTEST_SIGBASE(x3,signature_x3_1)

inst_0:
// rs1 != rd, rs1==x12, rd==x31, rs1_val == (-2**(xlen-1)), imm_val == 3
// opcode: insb ; op1:x12; dest:x31; op1val:-0x80000000;  immval:0x3
TEST_IMM_OP( insb, x31, x12, 0x00000000, -0x80000000, 0x3, x3, 0, x16)

inst_1:
// rs1 == rd, rs1==x15, rd==x15, imm_val == 2, 
// opcode: insb ; op1:x15; dest:x15; op1val:0x800000;  immval:0x2
TEST_IMM_OP( insb, x15, x15, 0x00000000, 0x800000, 0x2, x3, 4, x16)

inst_2:
// rs1==x5, rd==x10, imm_val == 1, 
// opcode: insb ; op1:x5; dest:x10; op1val:0x20;  immval:0x1
TEST_IMM_OP( insb, x10, x5, 0x00000000, 0x20, 0x1, x3, 8, x16)

inst_3:
// rs1==x6, rd==x18, imm_val == 0, 
// opcode: insb ; op1:x6; dest:x18; op1val:0x8000000;  immval:0x0
TEST_IMM_OP( insb, x18, x6, 0x00000000, 0x8000000, 0x0, x3, 12, x16)

inst_4:
// rs1==x24, rd==x0, rs1_val == (2**(xlen-1)-1), 
// opcode: insb ; op1:x24; dest:x0; op1val:0x7fffffff;  immval:0x0
TEST_IMM_OP( insb, x0, x24, 0x00000000, 0x7fffffff, 0x0, x3, 16, x16)

inst_5:
// rs1==x22, rd==x21, rs1_val == 0, 
// opcode: insb ; op1:x22; dest:x21; op1val:0x0;  immval:0x2
TEST_IMM_OP( insb, x21, x22, 0x00000000, 0x0, 0x2, x3, 20, x16)

inst_6:
// rs1==x2, rd==x30, rs1_val == 1, 
// opcode: insb ; op1:x2; dest:x30; op1val:0x1;  immval:0x2
TEST_IMM_OP( insb, x30, x2, 0x00000000, 0x1, 0x2, x3, 24, x16)

inst_7:
// rs1==x30, rd==x27, 
// opcode: insb ; op1:x30; dest:x27; op1val:-0x80000000;  immval:0x0
TEST_IMM_OP( insb, x27, x30, 0x00000000, -0x80000000, 0x0, x3, 28, x16)

inst_8:
// rs1==x23, rd==x5, 
// opcode: insb ; op1:x23; dest:x5; op1val:-0x80000000;  immval:0x0
TEST_IMM_OP( insb, x5, x23, 0x00000000, -0x80000000, 0x0, x3, 32, x16)

inst_9:
// rs1==x19, rd==x12, 
// opcode: insb ; op1:x19; dest:x12; op1val:-0x80000000;  immval:0x0
TEST_IMM_OP( insb, x12, x19, 0x00000000, -0x80000000, 0x0, x3, 36, x16)

inst_10:
// rs1==x4, rd==x8, 
// opcode: insb ; op1:x4; dest:x8; op1val:-0x80000000;  immval:0x0
TEST_IMM_OP( insb, x8, x4, 0x00000000, -0x80000000, 0x0, x3, 40, x16)

inst_11:
// rs1==x14, rd==x26, 
// opcode: insb ; op1:x14; dest:x26; op1val:-0x80000000;  immval:0x0
TEST_IMM_OP( insb, x26, x14, 0x00000000, -0x80000000, 0x0, x3, 44, x16)

inst_12:
// rs1==x21, rd==x28, 
// opcode: insb ; op1:x21; dest:x28; op1val:-0x80000000;  immval:0x0
TEST_IMM_OP( insb, x28, x21, 0x00000000, -0x80000000, 0x0, x3, 48, x16)

inst_13:
// rs1==x29, rd==x14, 
// opcode: insb ; op1:x29; dest:x14; op1val:-0x80000000;  immval:0x0
TEST_IMM_OP( insb, x14, x29, 0x00000000, -0x80000000, 0x0, x3, 52, x16)

inst_14:
// rs1==x9, rd==x23, 
// opcode: insb ; op1:x9; dest:x23; op1val:-0x80000000;  immval:0x0
TEST_IMM_OP( insb, x23, x9, 0x00000000, -0x80000000, 0x0, x3, 56, x16)

inst_15:
// rs1==x11, rd==x2, 
// opcode: insb ; op1:x11; dest:x2; op1val:-0x80000000;  immval:0x0
TEST_IMM_OP( insb, x2, x11, 0x00000000, -0x80000000, 0x0, x3, 60, x16)

inst_16:
// rs1==x0, rd==x22, 
// opcode: insb ; op1:x0; dest:x22; op1val:0x0;  immval:0x0
TEST_IMM_OP( insb, x22, x0, 0x00000000, 0x0, 0x0, x3, 64, x16)

inst_17:
// rs1==x7, rd==x1, 
// opcode: insb ; op1:x7; dest:x1; op1val:-0x80000000;  immval:0x0
TEST_IMM_OP( insb, x1, x7, 0x00000000, -0x80000000, 0x0, x3, 68, x16)

inst_18:
// rs1==x27, rd==x25, 
// opcode: insb ; op1:x27; dest:x25; op1val:-0x80000000;  immval:0x0
TEST_IMM_OP( insb, x25, x27, 0x00000000, -0x80000000, 0x0, x3, 72, x16)

inst_19:
// rs1==x13, rd==x20, 
// opcode: insb ; op1:x13; dest:x20; op1val:-0x80000000;  immval:0x0
TEST_IMM_OP( insb, x20, x13, 0x00000000, -0x80000000, 0x0, x3, 76, x16)
RVTEST_SIGBASE(x2,signature_x2_0)

inst_20:
// rs1==x26, rd==x6, 
// opcode: insb ; op1:x26; dest:x6; op1val:-0x80000000;  immval:0x0
TEST_IMM_OP( insb, x6, x26, 0x00000000, -0x80000000, 0x0, x2, 0, x5)

inst_21:
// rs1==x18, rd==x19, 
// opcode: insb ; op1:x18; dest:x19; op1val:-0x80000000;  immval:0x0
TEST_IMM_OP( insb, x19, x18, 0x00000000, -0x80000000, 0x0, x2, 4, x5)

inst_22:
// rs1==x17, rd==x4, 
// opcode: insb ; op1:x17; dest:x4; op1val:-0x80000000;  immval:0x0
TEST_IMM_OP( insb, x4, x17, 0x00000000, -0x80000000, 0x0, x2, 8, x5)

inst_23:
// rs1==x8, rd==x3, 
// opcode: insb ; op1:x8; dest:x3; op1val:-0x80000000;  immval:0x0
TEST_IMM_OP( insb, x3, x8, 0x00000000, -0x80000000, 0x0, x2, 12, x5)

inst_24:
// rs1==x28, rd==x11, 
// opcode: insb ; op1:x28; dest:x11; op1val:-0x80000000;  immval:0x0
TEST_IMM_OP( insb, x11, x28, 0x00000000, -0x80000000, 0x0, x2, 16, x5)

inst_25:
// rs1==x3, rd==x7, 
// opcode: insb ; op1:x3; dest:x7; op1val:-0x80000000;  immval:0x0
TEST_IMM_OP( insb, x7, x3, 0x00000000, -0x80000000, 0x0, x2, 20, x5)

inst_26:
// rs1==x25, rd==x13, 
// opcode: insb ; op1:x25; dest:x13; op1val:-0x80000000;  immval:0x0
TEST_IMM_OP( insb, x13, x25, 0x00000000, -0x80000000, 0x0, x2, 24, x5)

inst_27:
// rs1==x1, rd==x9, 
// opcode: insb ; op1:x1; dest:x9; op1val:-0x80000000;  immval:0x0
TEST_IMM_OP( insb, x9, x1, 0x00000000, -0x80000000, 0x0, x2, 28, x5)

inst_28:
// rs1==x10, rd==x29, 
// opcode: insb ; op1:x10; dest:x29; op1val:-0x80000000;  immval:0x0
TEST_IMM_OP( insb, x29, x10, 0x00000000, -0x80000000, 0x0, x2, 32, x5)

inst_29:
// rs1==x16, rd==x17, 
// opcode: insb ; op1:x16; dest:x17; op1val:-0x80000000;  immval:0x0
TEST_IMM_OP( insb, x17, x16, 0x00000000, -0x80000000, 0x0, x2, 36, x5)

inst_30:
// rs1==x31, rd==x16, 
// opcode: insb ; op1:x31; dest:x16; op1val:-0x80000000;  immval:0x0
TEST_IMM_OP( insb, x16, x31, 0x00000000, -0x80000000, 0x0, x2, 40, x5)

inst_31:
// rs1==x20, rd==x24, 
// opcode: insb ; op1:x20; dest:x24; op1val:-0x80000000;  immval:0x0
TEST_IMM_OP( insb, x24, x20, 0x00000000, -0x80000000, 0x0, x2, 44, x5)

inst_32:
// rs1_val == (2**(xlen-1)-1), 
// opcode: insb ; op1:x30; dest:x31; op1val:0x7fffffff;  immval:0x0
TEST_IMM_OP( insb, x31, x30, 0x00000000, 0x7fffffff, 0x0, x2, 48, x5)
#endif


RVTEST_CODE_END
RVMODEL_HALT

RVTEST_DATA_BEGIN
.align 4
rvtest_data:
.word 0xbabecafe
.word 0xabecafeb
.word 0xbecafeba
.word 0xecafebab
RVTEST_DATA_END

RVMODEL_DATA_BEGIN


signature_x3_0:
    .fill 0*(XLEN/32),4,0xdeadbeef


signature_x3_1:
    .fill 20*(XLEN/32),4,0xdeadbeef


signature_x2_0:
    .fill 13*(XLEN/32),4,0xdeadbeef

#ifdef rvtest_mtrap_routine

mtrap_sigptr:
    .fill 64*(XLEN/32),4,0xdeadbeef

#endif

#ifdef rvtest_gpr_save

gpr_save:
    .fill 32*(XLEN/32),4,0xdeadbeef

#endif

RVMODEL_DATA_END
