
// -----------
// This file was generated by riscv_ctg (https://github.com/riscv-software-src/riscv-ctg)
// version   : 0.6.3
// timestamp : Sat Apr 23 14:53:29 2022 GMT
// usage     : riscv_ctg \
//                  --cgf /scratch/git-repo/github/riscv_ctg/sample_cgfs/dataset.cgf \
//                  --cgf /scratch/git-repo/github/riscv_ctg/sample_cgfs/rv32ip.cgf \
//                  --xlen 32  \
//                  --randomize \
// -----------
//
// -----------
// Copyright (c) 2020. RISC-V International. All rights reserved.
// SPDX-License-Identifier: BSD-3-Clause
// -----------
//
// This assembly file tests the kabsw instruction of the RISC-V RV32PZicsr extension for the kabsw covergroup.
// 
#include "model_test.h"
#include "arch_test.h"
RVTEST_ISA("RV32IPZicsr")

.section .text.init
.org 0x80
.globl rvtest_entry_point
rvtest_entry_point:
RVMODEL_BOOT
RVTEST_CODE_BEGIN

#ifdef TEST_CASE_1

RVTEST_CASE(0,"//check ISA:=regex(.*32.*);check ISA:=regex(.*I.*P.*Zicsr.*);def TEST_CASE_1=True;",kabsw)

RVTEST_VXSAT_ENABLE()
RVTEST_SIGBASE(x16,signature_x16_1)

inst_0:
// rs1==x7, rd==x31, rs1_w0_val == -2147483648, 
// opcode: kabsw ; op1:x7; dest:x31; op1val:0x80000000;
TEST_PKR_OP( kabsw, x31, x7, 0x00000000, 0x80000000, x7, x16, 0, x21)

inst_1:
// rs1==x19, rd==x28, rs1_w0_val == -1431655766, 
// opcode: kabsw ; op1:x19; dest:x28; op1val:0xaaaaaaaa;
TEST_PKR_OP( kabsw, x28, x19, 0x00000000, 0xaaaaaaaa, x19, x16, 8, x21)

inst_2:
// rs1==x10, rd==x0, rs1_w0_val == 1431655765, 
// opcode: kabsw ; op1:x10; dest:x0; op1val:0x55555555;
TEST_PKR_OP( kabsw, x0, x10, 0x00000000, 0x55555555, x10, x16, 16, x21)

inst_3:
// rs1==x12, rd==x13, rs1_w0_val == 2147483647, 
// opcode: kabsw ; op1:x12; dest:x13; op1val:0x7fffffff;
TEST_PKR_OP( kabsw, x13, x12, 0x00000000, 0x7fffffff, x12, x16, 24, x21)

inst_4:
// rs1==x8, rd==x2, rs1_w0_val == -1073741825, 
// opcode: kabsw ; op1:x8; dest:x2; op1val:0xbfffffff;
TEST_PKR_OP( kabsw, x2, x8, 0x00000000, 0xbfffffff, x8, x16, 32, x21)

inst_5:
// rs1==x14, rd==x19, rs1_w0_val == -536870913, 
// opcode: kabsw ; op1:x14; dest:x19; op1val:0xdfffffff;
TEST_PKR_OP( kabsw, x19, x14, 0x00000000, 0xdfffffff, x14, x16, 40, x21)

inst_6:
// rs1==x9, rd==x6, rs1_w0_val == -268435457, 
// opcode: kabsw ; op1:x9; dest:x6; op1val:0xefffffff;
TEST_PKR_OP( kabsw, x6, x9, 0x00000000, 0xefffffff, x9, x16, 48, x21)

inst_7:
// rs1==x17, rd==x9, rs1_w0_val == -134217729, 
// opcode: kabsw ; op1:x17; dest:x9; op1val:0xf7ffffff;
TEST_PKR_OP( kabsw, x9, x17, 0x00000000, 0xf7ffffff, x17, x16, 56, x21)

inst_8:
// rs1==x29, rd==x14, rs1_w0_val == -67108865, 
// opcode: kabsw ; op1:x29; dest:x14; op1val:0xfbffffff;
TEST_PKR_OP( kabsw, x14, x29, 0x00000000, 0xfbffffff, x29, x16, 64, x21)

inst_9:
// rs1==x1, rd==x18, rs1_w0_val == -33554433, 
// opcode: kabsw ; op1:x1; dest:x18; op1val:0xfdffffff;
TEST_PKR_OP( kabsw, x18, x1, 0x00000000, 0xfdffffff, x1, x16, 72, x21)

inst_10:
// rs1==x0, rd==x4, rs1_w0_val == -16777217, 
// opcode: kabsw ; op1:x0; dest:x4; op1val:0xfeffffff;
TEST_PKR_OP( kabsw, x4, x0, 0x00000000, 0xfeffffff, x0, x16, 80, x21)

inst_11:
// rs1==x31, rd==x11, rs1_w0_val == -8388609, 
// opcode: kabsw ; op1:x31; dest:x11; op1val:0xff7fffff;
TEST_PKR_OP( kabsw, x11, x31, 0x00000000, 0xff7fffff, x31, x16, 88, x21)

inst_12:
// rs1==x3, rd==x5, rs1_w0_val == -4194305, 
// opcode: kabsw ; op1:x3; dest:x5; op1val:0xffbfffff;
TEST_PKR_OP( kabsw, x5, x3, 0x00000000, 0xffbfffff, x3, x16, 96, x21)

inst_13:
// rs1==x27, rd==x30, rs1_w0_val == -2097153, 
// opcode: kabsw ; op1:x27; dest:x30; op1val:0xffdfffff;
TEST_PKR_OP( kabsw, x30, x27, 0x00000000, 0xffdfffff, x27, x16, 104, x21)

inst_14:
// rs1==x20, rd==x29, rs1_w0_val == -1048577, 
// opcode: kabsw ; op1:x20; dest:x29; op1val:0xffefffff;
TEST_PKR_OP( kabsw, x29, x20, 0x00000000, 0xffefffff, x20, x16, 112, x21)

inst_15:
// rs1==x2, rd==x26, rs1_w0_val == -524289, 
// opcode: kabsw ; op1:x2; dest:x26; op1val:0xfff7ffff;
TEST_PKR_OP( kabsw, x26, x2, 0x00000000, 0xfff7ffff, x2, x16, 120, x21)

inst_16:
// rs1==x13, rd==x8, rs1_w0_val == -262145, 
// opcode: kabsw ; op1:x13; dest:x8; op1val:0xfffbffff;
TEST_PKR_OP( kabsw, x8, x13, 0x00000000, 0xfffbffff, x13, x16, 128, x21)

inst_17:
// rs1==x24, rd==x17, rs1_w0_val == -131073, 
// opcode: kabsw ; op1:x24; dest:x17; op1val:0xfffdffff;
TEST_PKR_OP( kabsw, x17, x24, 0x00000000, 0xfffdffff, x24, x16, 136, x21)

inst_18:
// rs1==x4, rd==x15, rs1_w0_val == -65537, 
// opcode: kabsw ; op1:x4; dest:x15; op1val:0xfffeffff;
TEST_PKR_OP( kabsw, x15, x4, 0x00000000, 0xfffeffff, x4, x16, 144, x21)

inst_19:
// rs1==x15, rd==x22, rs1_w0_val == -32769, 
// opcode: kabsw ; op1:x15; dest:x22; op1val:0xffff7fff;
TEST_PKR_OP( kabsw, x22, x15, 0x00000000, 0xffff7fff, x15, x16, 152, x21)

inst_20:
// rs1==x21, rd==x20, rs1_w0_val == -16385, 
// opcode: kabsw ; op1:x21; dest:x20; op1val:0xffffbfff;
TEST_PKR_OP( kabsw, x20, x21, 0x00000000, 0xffffbfff, x21, x16, 160, x4)
RVTEST_SIGBASE(x2,signature_x2_0)

inst_21:
// rs1==x28, rd==x10, rs1_w0_val == -8193, 
// opcode: kabsw ; op1:x28; dest:x10; op1val:0xffffdfff;
TEST_PKR_OP( kabsw, x10, x28, 0x00000000, 0xffffdfff, x28, x2, 0, x4)

inst_22:
// rs1==x22, rd==x25, rs1_w0_val == -4097, 
// opcode: kabsw ; op1:x22; dest:x25; op1val:0xffffefff;
TEST_PKR_OP( kabsw, x25, x22, 0x00000000, 0xffffefff, x22, x2, 8, x4)

inst_23:
// rs1==x5, rd==x21, rs1_w0_val == -2049, 
// opcode: kabsw ; op1:x5; dest:x21; op1val:0xfffff7ff;
TEST_PKR_OP( kabsw, x21, x5, 0x00000000, 0xfffff7ff, x5, x2, 16, x4)

inst_24:
// rs1==x6, rd==x1, rs1_w0_val == -1025, 
// opcode: kabsw ; op1:x6; dest:x1; op1val:0xfffffbff;
TEST_PKR_OP( kabsw, x1, x6, 0x00000000, 0xfffffbff, x6, x2, 24, x4)

inst_25:
// rs1==x18, rd==x12, rs1_w0_val == -513, 
// opcode: kabsw ; op1:x18; dest:x12; op1val:0xfffffdff;
TEST_PKR_OP( kabsw, x12, x18, 0x00000000, 0xfffffdff, x18, x2, 32, x4)

inst_26:
// rs1==x30, rd==x16, rs1_w0_val == -257, 
// opcode: kabsw ; op1:x30; dest:x16; op1val:0xfffffeff;
TEST_PKR_OP( kabsw, x16, x30, 0x00000000, 0xfffffeff, x30, x2, 40, x4)

inst_27:
// rs1==x23, rd==x7, rs1_w0_val == -129, 
// opcode: kabsw ; op1:x23; dest:x7; op1val:0xffffff7f;
TEST_PKR_OP( kabsw, x7, x23, 0x00000000, 0xffffff7f, x23, x2, 48, x4)

inst_28:
// rs1==x16, rd==x3, rs1_w0_val == -65, 
// opcode: kabsw ; op1:x16; dest:x3; op1val:0xffffffbf;
TEST_PKR_OP( kabsw, x3, x16, 0x00000000, 0xffffffbf, x16, x2, 56, x4)

inst_29:
// rs1==x25, rd==x27, rs1_w0_val == -33, 
// opcode: kabsw ; op1:x25; dest:x27; op1val:0xffffffdf;
TEST_PKR_OP( kabsw, x27, x25, 0x00000000, 0xffffffdf, x25, x2, 64, x4)

inst_30:
// rs1==x11, rd==x24, rs1_w0_val == -17, 
// opcode: kabsw ; op1:x11; dest:x24; op1val:0xffffffef;
TEST_PKR_OP( kabsw, x24, x11, 0x00000000, 0xffffffef, x11, x2, 72, x4)

inst_31:
// rs1==x26, rd==x23, rs1_w0_val == -9, 
// opcode: kabsw ; op1:x26; dest:x23; op1val:0xfffffff7;
TEST_PKR_OP( kabsw, x23, x26, 0x00000000, 0xfffffff7, x26, x2, 80, x4)

inst_32:
// rs1_w0_val == -5, 
// opcode: kabsw ; op1:x30; dest:x31; op1val:0xfffffffb;
TEST_PKR_OP( kabsw, x31, x30, 0x00000000, 0xfffffffb, x30, x2, 88, x4)

inst_33:
// rs1_w0_val == -3, 
// opcode: kabsw ; op1:x30; dest:x31; op1val:0xfffffffd;
TEST_PKR_OP( kabsw, x31, x30, 0x00000000, 0xfffffffd, x30, x2, 96, x4)

inst_34:
// rs1_w0_val == -2, 
// opcode: kabsw ; op1:x30; dest:x31; op1val:0xfffffffe;
TEST_PKR_OP( kabsw, x31, x30, 0x00000000, 0xfffffffe, x30, x2, 104, x4)

inst_35:
// rs1_w0_val == 1073741824, 
// opcode: kabsw ; op1:x30; dest:x31; op1val:0x40000000;
TEST_PKR_OP( kabsw, x31, x30, 0x00000000, 0x40000000, x30, x2, 112, x4)

inst_36:
// rs1_w0_val == 536870912, 
// opcode: kabsw ; op1:x30; dest:x31; op1val:0x20000000;
TEST_PKR_OP( kabsw, x31, x30, 0x00000000, 0x20000000, x30, x2, 120, x4)

inst_37:
// rs1_w0_val == 2, 
// opcode: kabsw ; op1:x30; dest:x31; op1val:0x000002;
TEST_PKR_OP( kabsw, x31, x30, 0x00000000, 0x000002, x30, x2, 128, x4)

inst_38:
// rs1_w0_val == 1, 
// opcode: kabsw ; op1:x30; dest:x31; op1val:0x000001;
TEST_PKR_OP( kabsw, x31, x30, 0x00000000, 0x000001, x30, x2, 136, x4)

inst_39:
// rs1_w0_val == 0, 
// opcode: kabsw ; op1:x30; dest:x31; op1val:0x000000;
TEST_PKR_OP( kabsw, x31, x30, 0x00000000, 0x000000, x30, x2, 144, x4)

inst_40:
// rs1_w0_val == -1, 
// opcode: kabsw ; op1:x30; dest:x31; op1val:0xffffffff;
TEST_PKR_OP( kabsw, x31, x30, 0x00000000, 0xffffffff, x30, x2, 152, x4)

inst_41:
// rs1_w0_val == 268435456, 
// opcode: kabsw ; op1:x30; dest:x31; op1val:0x10000000;
TEST_PKR_OP( kabsw, x31, x30, 0x00000000, 0x10000000, x30, x2, 160, x4)

inst_42:
// rs1_w0_val == 134217728, 
// opcode: kabsw ; op1:x30; dest:x31; op1val:0x8000000;
TEST_PKR_OP( kabsw, x31, x30, 0x00000000, 0x8000000, x30, x2, 168, x4)

inst_43:
// rs1_w0_val == 67108864, 
// opcode: kabsw ; op1:x30; dest:x31; op1val:0x4000000;
TEST_PKR_OP( kabsw, x31, x30, 0x00000000, 0x4000000, x30, x2, 176, x4)

inst_44:
// rs1_w0_val == 33554432, 
// opcode: kabsw ; op1:x30; dest:x31; op1val:0x2000000;
TEST_PKR_OP( kabsw, x31, x30, 0x00000000, 0x2000000, x30, x2, 184, x4)

inst_45:
// rs1_w0_val == 16777216, 
// opcode: kabsw ; op1:x30; dest:x31; op1val:0x1000000;
TEST_PKR_OP( kabsw, x31, x30, 0x00000000, 0x1000000, x30, x2, 192, x4)

inst_46:
// rs1_w0_val == 8388608, 
// opcode: kabsw ; op1:x30; dest:x31; op1val:0x800000;
TEST_PKR_OP( kabsw, x31, x30, 0x00000000, 0x800000, x30, x2, 200, x4)

inst_47:
// rs1_w0_val == 4194304, 
// opcode: kabsw ; op1:x30; dest:x31; op1val:0x400000;
TEST_PKR_OP( kabsw, x31, x30, 0x00000000, 0x400000, x30, x2, 208, x4)

inst_48:
// rs1_w0_val == 2097152, 
// opcode: kabsw ; op1:x30; dest:x31; op1val:0x200000;
TEST_PKR_OP( kabsw, x31, x30, 0x00000000, 0x200000, x30, x2, 216, x4)

inst_49:
// rs1_w0_val == 1048576, 
// opcode: kabsw ; op1:x30; dest:x31; op1val:0x100000;
TEST_PKR_OP( kabsw, x31, x30, 0x00000000, 0x100000, x30, x2, 224, x4)

inst_50:
// rs1_w0_val == 524288, 
// opcode: kabsw ; op1:x30; dest:x31; op1val:0x080000;
TEST_PKR_OP( kabsw, x31, x30, 0x00000000, 0x080000, x30, x2, 232, x4)

inst_51:
// rs1_w0_val == 262144, 
// opcode: kabsw ; op1:x30; dest:x31; op1val:0x040000;
TEST_PKR_OP( kabsw, x31, x30, 0x00000000, 0x040000, x30, x2, 240, x4)

inst_52:
// rs1_w0_val == 131072, 
// opcode: kabsw ; op1:x30; dest:x31; op1val:0x020000;
TEST_PKR_OP( kabsw, x31, x30, 0x00000000, 0x020000, x30, x2, 248, x4)

inst_53:
// rs1_w0_val == 65536, 
// opcode: kabsw ; op1:x30; dest:x31; op1val:0x010000;
TEST_PKR_OP( kabsw, x31, x30, 0x00000000, 0x010000, x30, x2, 256, x4)

inst_54:
// rs1_w0_val == 32768, 
// opcode: kabsw ; op1:x30; dest:x31; op1val:0x008000;
TEST_PKR_OP( kabsw, x31, x30, 0x00000000, 0x008000, x30, x2, 264, x4)

inst_55:
// rs1_w0_val == 16384, 
// opcode: kabsw ; op1:x30; dest:x31; op1val:0x004000;
TEST_PKR_OP( kabsw, x31, x30, 0x00000000, 0x004000, x30, x2, 272, x4)

inst_56:
// rs1_w0_val == 8192, 
// opcode: kabsw ; op1:x30; dest:x31; op1val:0x002000;
TEST_PKR_OP( kabsw, x31, x30, 0x00000000, 0x002000, x30, x2, 280, x4)

inst_57:
// rs1_w0_val == 4096, 
// opcode: kabsw ; op1:x30; dest:x31; op1val:0x001000;
TEST_PKR_OP( kabsw, x31, x30, 0x00000000, 0x001000, x30, x2, 288, x4)

inst_58:
// rs1_w0_val == 2048, 
// opcode: kabsw ; op1:x30; dest:x31; op1val:0x000800;
TEST_PKR_OP( kabsw, x31, x30, 0x00000000, 0x000800, x30, x2, 296, x4)

inst_59:
// rs1_w0_val == 1024, 
// opcode: kabsw ; op1:x30; dest:x31; op1val:0x000400;
TEST_PKR_OP( kabsw, x31, x30, 0x00000000, 0x000400, x30, x2, 304, x4)

inst_60:
// rs1_w0_val == 512, 
// opcode: kabsw ; op1:x30; dest:x31; op1val:0x000200;
TEST_PKR_OP( kabsw, x31, x30, 0x00000000, 0x000200, x30, x2, 312, x4)

inst_61:
// rs1_w0_val == 256, 
// opcode: kabsw ; op1:x30; dest:x31; op1val:0x000100;
TEST_PKR_OP( kabsw, x31, x30, 0x00000000, 0x000100, x30, x2, 320, x4)

inst_62:
// rs1_w0_val == 128, 
// opcode: kabsw ; op1:x30; dest:x31; op1val:0x000080;
TEST_PKR_OP( kabsw, x31, x30, 0x00000000, 0x000080, x30, x2, 328, x4)

inst_63:
// rs1_w0_val == 64, 
// opcode: kabsw ; op1:x30; dest:x31; op1val:0x000040;
TEST_PKR_OP( kabsw, x31, x30, 0x00000000, 0x000040, x30, x2, 336, x4)

inst_64:
// rs1_w0_val == 32, 
// opcode: kabsw ; op1:x30; dest:x31; op1val:0x000020;
TEST_PKR_OP( kabsw, x31, x30, 0x00000000, 0x000020, x30, x2, 344, x4)

inst_65:
// rs1_w0_val == 16, 
// opcode: kabsw ; op1:x30; dest:x31; op1val:0x000010;
TEST_PKR_OP( kabsw, x31, x30, 0x00000000, 0x000010, x30, x2, 352, x4)

inst_66:
// rs1_w0_val == 8, 
// opcode: kabsw ; op1:x30; dest:x31; op1val:0x000008;
TEST_PKR_OP( kabsw, x31, x30, 0x00000000, 0x000008, x30, x2, 360, x4)

inst_67:
// rs1_w0_val == 4, 
// opcode: kabsw ; op1:x30; dest:x31; op1val:0x000004;
TEST_PKR_OP( kabsw, x31, x30, 0x00000000, 0x000004, x30, x2, 368, x4)

inst_68:
// rs1_w0_val == 1431655765, 
// opcode: kabsw ; op1:x30; dest:x31; op1val:0x55555555;
TEST_PKR_OP( kabsw, x31, x30, 0x00000000, 0x55555555, x30, x2, 376, x4)

inst_69:
// rs1_w0_val == -16777217, 
// opcode: kabsw ; op1:x30; dest:x31; op1val:0xfeffffff;
TEST_PKR_OP( kabsw, x31, x30, 0x00000000, 0xfeffffff, x30, x2, 384, x4)
#endif


RVTEST_CODE_END
RVMODEL_HALT

RVTEST_DATA_BEGIN
.align 4
rvtest_data:
.word 0xbabecafe
.word 0xabecafeb
.word 0xbecafeba
.word 0xecafebab
RVTEST_DATA_END

RVMODEL_DATA_BEGIN


signature_x16_0:
    .fill 0*(XLEN/32),4,0xdeadbeef


signature_x16_1:
    .fill 42*(XLEN/32),4,0xdeadbeef


signature_x2_0:
    .fill 98*(XLEN/32),4,0xdeadbeef

#ifdef rvtest_mtrap_routine

mtrap_sigptr:
    .fill 64*(XLEN/32),4,0xdeadbeef

#endif

#ifdef rvtest_gpr_save

gpr_save:
    .fill 32*(XLEN/32),4,0xdeadbeef

#endif

RVMODEL_DATA_END
