
// -----------
// This file was generated by riscv_ctg (https://github.com/riscv-software-src/riscv-ctg)
// version   : 0.6.3
// timestamp : Sat Apr 23 14:53:29 2022 GMT
// usage     : riscv_ctg \
//                  --cgf /scratch/git-repo/github/riscv_ctg/sample_cgfs/dataset.cgf \
//                  --cgf /scratch/git-repo/github/riscv_ctg/sample_cgfs/rv32ip.cgf \
//                  --xlen 32  \
//                  --randomize \
// -----------
//
// -----------
// Copyright (c) 2020. RISC-V International. All rights reserved.
// SPDX-License-Identifier: BSD-3-Clause
// -----------
//
// This assembly file tests the kadd64 instruction of the RISC-V RV32PZicsr extension for the kadd64 covergroup.
// 
#include "model_test.h"
#include "arch_test.h"
RVTEST_ISA("RV32IPZicsr")

.section .text.init
.org 0x80
.globl rvtest_entry_point
rvtest_entry_point:
RVMODEL_BOOT
RVTEST_CODE_BEGIN

#ifdef TEST_CASE_1

RVTEST_CASE(0,"//check ISA:=regex(.*32.*);check ISA:=regex(.*I.*P.*Zicsr.*);def TEST_CASE_1=True;",kadd64)

RVTEST_VXSAT_ENABLE()
RVTEST_SIGBASE(x1,signature_x1_1)

inst_0:
// rs1 != rs2  and rs1 != rd and rs2 != rd, rs1==x26, rs2==x12, rd==x24, rs1_val != rs2_val, rs1_val == -281474976710657, rs2_val == -129, rs1_val < 0 and rs2_val < 0
// opcode: kadd64 ; op1:x26; op2:x12; dest:x24; op1val:0xfffeffffffffffff;  op2val:0xffffffffffffff7f;
TEST_PK64_PPP_OP(kadd64, x24, x25, x26, x27, x12, x13, 0x00000000, 0, 0xffffffff, 0xfffeffff, 0xffffff7f, 0xffffffff, x26, x1, 0, x4)

inst_1:
// rs1 == rs2 != rd, rs1==x30, rs2==x30, rd==x10, rs2_val == 9223372036854775807, rs1_val == -1073741825, rs1_val < 0 and rs2_val > 0, rs2_val == (2**63-1)
// opcode: kadd64 ; op1:x30; op2:x30; dest:x10; op1val:0xffffffffbfffffff;  op2val:0xffffffffbfffffff;
TEST_PK64_PPP_OP(kadd64, x10, x11, x30, x31, x30, x31, 0x00000000, 0, 0xbfffffff, 0xffffffff, 0xbfffffff, 0xffffffff, x30, x1, 12, x4)

inst_2:
// rs1 == rd != rs2, rs1==x12, rs2==x20, rd==x12, rs2_val == -4611686018427387905, rs1_val == -32769
// opcode: kadd64 ; op1:x12; op2:x20; dest:x12; op1val:0xffffffffffff7fff;  op2val:0xbfffffffffffffff;
TEST_PK64_PPP_OP(kadd64, x12, x13, x12, x13, x20, x21, 0x00000000, 0, 0xffff7fff, 0xffffffff, 0xffffffff, 0xbfffffff, x12, x1, 24, x4)

inst_3:
// rs1 == rs2 == rd, rs1==x22, rs2==x22, rd==x22, rs2_val == -2305843009213693953, rs1_val == -17592186044417
// opcode: kadd64 ; op1:x22; op2:x22; dest:x22; op1val:0xffffefffffffffff;  op2val:0xffffefffffffffff;
TEST_PK64_PPP_OP(kadd64, x22, x23, x22, x23, x22, x23, 0x00000000, 0, 0xffffffff, 0xffffefff, 0xffffffff, 0xffffefff, x22, x1, 36, x4)

inst_4:
// rs2 == rd != rs1, rs1==x28, rs2==x18, rd==x18, rs2_val == -1152921504606846977, rs1_val == -4194305
// opcode: kadd64 ; op1:x28; op2:x18; dest:x18; op1val:0xffffffffffbfffff;  op2val:0xefffffffffffffff;
TEST_PK64_PPP_OP(kadd64, x18, x19, x28, x29, x18, x19, 0x00000000, 0, 0xffbfffff, 0xffffffff, 0xffffffff, 0xefffffff, x28, x1, 48, x4)

inst_5:
// rs1==x14, rs2==x2, rd==x16, rs2_val == -576460752303423489, rs1_val == -5
// opcode: kadd64 ; op1:x14; op2:x2; dest:x16; op1val:0xfffffffffffffffb;  op2val:0xf7ffffffffffffff;
TEST_PK64_PPP_OP(kadd64, x16, x17, x14, x15, x2, x3, 0x00000000, 0, 0xfffffffb, 0xffffffff, 0xffffffff, 0xf7ffffff, x14, x1, 60, x4)
RVTEST_SIGBASE(x1,signature_x1_2)

inst_6:
// rs1==x2, rs2==x8, rd==x26, rs2_val == -288230376151711745, rs1_val > 0 and rs2_val < 0, rs1_val == 2251799813685248
// opcode: kadd64 ; op1:x2; op2:x8; dest:x26; op1val:0x0008000000000000;  op2val:0xfbffffffffffffff;
TEST_PK64_PPP_OP(kadd64, x26, x27, x2, x3, x8, x9, 0x00000000, 0, 0x00000000, 0x00080000, 0xffffffff, 0xfbffffff, x2, x1, 0, x12)

inst_7:
// rs1==x20, rs2==x14, rd==x4, rs2_val == -144115188075855873, rs1_val == -9223372036854775808, rs1_val == (-2**63)
// opcode: kadd64 ; op1:x20; op2:x14; dest:x4; op1val:0x8000000000000000;  op2val:0xfdffffffffffffff;
TEST_PK64_PPP_OP(kadd64, x4, x5, x20, x21, x14, x15, 0x00000000, 0, 0x00000000, 0x80000000, 0xffffffff, 0xfdffffff, x20, x1, 12, x12)

inst_8:
// rs1==x10, rs2==x4, rd==x30, rs2_val == -72057594037927937, rs1_val == 68719476736
// opcode: kadd64 ; op1:x10; op2:x4; dest:x30; op1val:0x0000001000000000;  op2val:0xfeffffffffffffff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x10, x11, x4, x5, 0x00000000, 0, 0x00000000, 0x00000010, 0xffffffff, 0xfeffffff, x10, x1, 24, x12)

inst_9:
// rs1==x18, rs2==x6, rd==x8, rs2_val == -36028797018963969, 
// opcode: kadd64 ; op1:x18; op2:x6; dest:x8; op1val:0x0000001000000000;  op2val:0xff7fffffffffffff;
TEST_PK64_PPP_OP(kadd64, x8, x9, x18, x19, x6, x7, 0x00000000, 0, 0x00000000, 0x00000010, 0xffffffff, 0xff7fffff, x18, x1, 36, x12)

inst_10:
// rs1==x16, rs2==x28, rd==x20, rs2_val == -18014398509481985, rs1_val == 32768
// opcode: kadd64 ; op1:x16; op2:x28; dest:x20; op1val:0x0000000000008000;  op2val:0xffbfffffffffffff;
TEST_PK64_PPP_OP(kadd64, x20, x21, x16, x17, x28, x29, 0x00000000, 0, 0x00008000, 0x00000000, 0xffffffff, 0xffbfffff, x16, x1, 48, x12)
RVTEST_SIGBASE(x1,signature_x1_3)

inst_11:
// rs1==x8, rs2==x10, rd==x6, rs2_val == -9007199254740993, rs1_val == 18014398509481984
// opcode: kadd64 ; op1:x8; op2:x10; dest:x6; op1val:0x0040000000000000;  op2val:0xffdfffffffffffff;
TEST_PK64_PPP_OP(kadd64, x6, x7, x8, x9, x10, x11, 0x00000000, 0, 0x00000000, 0x00400000, 0xffffffff, 0xffdfffff, x8, x1, 0, x12)

inst_12:
// rs1==x24, rs2==x26, rd==x14, rs2_val == -4503599627370497, rs1_val == -18014398509481985
// opcode: kadd64 ; op1:x24; op2:x26; dest:x14; op1val:0xffbfffffffffffff;  op2val:0xffefffffffffffff;
TEST_PK64_PPP_OP(kadd64, x14, x15, x24, x25, x26, x27, 0x00000000, 0, 0xffffffff, 0xffbfffff, 0xffffffff, 0xffefffff, x24, x1, 12, x12)

inst_13:
// rs1==x4, rs2==x16, rd==x2, rs2_val == -2251799813685249, rs1_val == -262145
// opcode: kadd64 ; op1:x4; op2:x16; dest:x2; op1val:0xfffffffffffbffff;  op2val:0xfff7ffffffffffff;
TEST_PK64_PPP_OP(kadd64, x2, x3, x4, x5, x16, x17, 0x00000000, 0, 0xfffbffff, 0xffffffff, 0xffffffff, 0xfff7ffff, x4, x1, 24, x12)

inst_14:
// rs1==x6, rs2==x24, rd==x28, rs2_val == -1125899906842625, rs1_val == 6148914691236517205
// opcode: kadd64 ; op1:x6; op2:x24; dest:x28; op1val:0x5555555555555555;  op2val:0xfffbffffffffffff;
TEST_PK64_PPP_OP(kadd64, x28, x29, x6, x7, x24, x25, 0x00000000, 0, 0x55555555, 0x55555555, 0xffffffff, 0xfffbffff, x6, x1, 36, x12)

inst_15:
// rs2_val == -562949953421313, rs1_val == 17179869184
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0000000400000000;  op2val:0xfffdffffffffffff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00000000, 0x00000004, 0xffffffff, 0xfffdffff, x28, x1, 48, x12)

inst_16:
// rs2_val == -281474976710657, rs1_val == 562949953421312
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0002000000000000;  op2val:0xfffeffffffffffff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00000000, 0x00020000, 0xffffffff, 0xfffeffff, x28, x1, 60, x12)

inst_17:
// rs2_val == -140737488355329, rs1_val == -34359738369
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xfffffff7ffffffff;  op2val:0xffff7fffffffffff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xffffffff, 0xfffffff7, 0xffffffff, 0xffff7fff, x28, x1, 72, x12)

inst_18:
// rs2_val == -70368744177665, rs1_val == 268435456
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0000000010000000;  op2val:0xffffbfffffffffff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x10000000, 0x00000000, 0xffffffff, 0xffffbfff, x28, x1, 84, x12)

inst_19:
// rs2_val == -35184372088833, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x8000000000000000;  op2val:0xffffdfffffffffff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00000000, 0x80000000, 0xffffffff, 0xffffdfff, x28, x1, 96, x12)

inst_20:
// rs2_val == -17592186044417, rs1_val == 34359738368
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0000000800000000;  op2val:0xffffefffffffffff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00000000, 0x00000008, 0xffffffff, 0xffffefff, x28, x1, 108, x12)

inst_21:
// rs2_val == -8796093022209, rs1_val == -131073
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xfffffffffffdffff;  op2val:0xfffff7ffffffffff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xfffdffff, 0xffffffff, 0xffffffff, 0xfffff7ff, x28, x1, 120, x12)

inst_22:
// rs2_val == -4398046511105, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xfffffff7ffffffff;  op2val:0xfffffbffffffffff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xffffffff, 0xfffffff7, 0xffffffff, 0xfffffbff, x28, x1, 132, x12)

inst_23:
// rs2_val == -2199023255553, rs1_val == 524288
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0000000000080000;  op2val:0xfffffdffffffffff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00080000, 0x00000000, 0xffffffff, 0xfffffdff, x28, x1, 144, x12)

inst_24:
// rs2_val == -1099511627777, rs1_val == -8796093022209
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xfffff7ffffffffff;  op2val:0xfffffeffffffffff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xffffffff, 0xfffff7ff, 0xffffffff, 0xfffffeff, x28, x1, 156, x12)

inst_25:
// rs2_val == -549755813889, rs1_val == -2097153
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xffffffffffdfffff;  op2val:0xffffff7fffffffff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xffdfffff, 0xffffffff, 0xffffffff, 0xffffff7f, x28, x1, 168, x12)

inst_26:
// rs2_val == -274877906945, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0000000000000006;  op2val:0xffffffbfffffffff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00000006, 0x00000000, 0xffffffff, 0xffffffbf, x28, x1, 180, x12)

inst_27:
// rs2_val == -137438953473, rs1_val == -6148914691236517206
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xaaaaaaaaaaaaaaaa;  op2val:0xffffffdfffffffff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xaaaaaaaa, 0xaaaaaaaa, 0xffffffff, 0xffffffdf, x28, x1, 192, x12)

inst_28:
// rs2_val == -68719476737, rs1_val == -4611686018427387905
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xbfffffffffffffff;  op2val:0xffffffefffffffff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xffffffff, 0xbfffffff, 0xffffffff, 0xffffffef, x28, x1, 204, x12)

inst_29:
// rs2_val == -34359738369, rs1_val == -4097
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xffffffffffffefff;  op2val:0xfffffff7ffffffff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xffffefff, 0xffffffff, 0xffffffff, 0xfffffff7, x28, x1, 216, x12)

inst_30:
// rs2_val == -17179869185, rs1_val == 2305843009213693952
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x2000000000000000;  op2val:0xfffffffbffffffff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00000000, 0x20000000, 0xffffffff, 0xfffffffb, x28, x1, 228, x12)

inst_31:
// rs2_val == -8589934593, rs1_val == -70368744177665
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xffffbfffffffffff;  op2val:0xfffffffdffffffff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xffffffff, 0xffffbfff, 0xffffffff, 0xfffffffd, x28, x1, 240, x12)

inst_32:
// rs2_val == -4294967297, rs1_val == 288230376151711744
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0400000000000000;  op2val:0xfffffffeffffffff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00000000, 0x04000000, 0xffffffff, 0xfffffffe, x28, x1, 252, x12)

inst_33:
// rs2_val == -2147483649, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xfffffffffffffff6;  op2val:0xffffffff7fffffff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xfffffff6, 0xffffffff, 0x7fffffff, 0xffffffff, x28, x1, 264, x12)

inst_34:
// rs2_val == -1073741825, rs1_val == -288230376151711745
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xfbffffffffffffff;  op2val:0xffffffffbfffffff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xffffffff, 0xfbffffff, 0xbfffffff, 0xffffffff, x28, x1, 276, x12)

inst_35:
// rs2_val == -536870913, rs1_val == 137438953472
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0000002000000000;  op2val:0xffffffffdfffffff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00000000, 0x00000020, 0xdfffffff, 0xffffffff, x28, x1, 288, x12)

inst_36:
// rs2_val == -268435457, rs1_val == 16
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0000000000000010;  op2val:0xffffffffefffffff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00000010, 0x00000000, 0xefffffff, 0xffffffff, x28, x1, 300, x12)

inst_37:
// rs2_val == -134217729, rs1_val == 536870912
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0000000020000000;  op2val:0xfffffffff7ffffff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x20000000, 0x00000000, 0xf7ffffff, 0xffffffff, x28, x1, 312, x12)

inst_38:
// rs2_val == -67108865, rs1_val == -16385
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xffffffffffffbfff;  op2val:0xfffffffffbffffff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xffffbfff, 0xffffffff, 0xfbffffff, 0xffffffff, x28, x1, 324, x12)

inst_39:
// rs2_val == -33554433, rs1_val == 32
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0000000000000020;  op2val:0xfffffffffdffffff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00000020, 0x00000000, 0xfdffffff, 0xffffffff, x28, x1, 336, x12)

inst_40:
// rs2_val == -16777217, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xffffefffffffffff;  op2val:0xfffffffffeffffff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xffffffff, 0xffffefff, 0xfeffffff, 0xffffffff, x28, x1, 348, x12)

inst_41:
// rs2_val == -8388609, rs1_val == 131072
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0000000000020000;  op2val:0xffffffffff7fffff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00020000, 0x00000000, 0xff7fffff, 0xffffffff, x28, x1, 360, x12)

inst_42:
// rs2_val == -4194305, rs1_val == -8388609
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xffffffffff7fffff;  op2val:0xffffffffffbfffff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xff7fffff, 0xffffffff, 0xffbfffff, 0xffffffff, x28, x1, 372, x12)

inst_43:
// rs2_val == -2097153, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0000000800000000;  op2val:0xffffffffffdfffff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00000000, 0x00000008, 0xffdfffff, 0xffffffff, x28, x1, 384, x12)

inst_44:
// rs2_val == -1048577, rs1_val == 1152921504606846976
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x1000000000000000;  op2val:0xffffffffffefffff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00000000, 0x10000000, 0xffefffff, 0xffffffff, x28, x1, 396, x12)

inst_45:
// rs2_val == -524289, rs1_val == -129
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xffffffffffffff7f;  op2val:0xfffffffffff7ffff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xffffff7f, 0xffffffff, 0xfff7ffff, 0xffffffff, x28, x1, 408, x12)

inst_46:
// rs2_val == -262145, rs1_val == -2251799813685249
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xfff7ffffffffffff;  op2val:0xfffffffffffbffff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xffffffff, 0xfff7ffff, 0xfffbffff, 0xffffffff, x28, x1, 420, x12)

inst_47:
// rs2_val == -131073, rs1_val == -67108865
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xfffffffffbffffff;  op2val:0xfffffffffffdffff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xfbffffff, 0xffffffff, 0xfffdffff, 0xffffffff, x28, x1, 432, x12)

inst_48:
// rs2_val == -65537, rs1_val == -1099511627777
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xfffffeffffffffff;  op2val:0xfffffffffffeffff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xffffffff, 0xfffffeff, 0xfffeffff, 0xffffffff, x28, x1, 444, x12)

inst_49:
// rs2_val == -32769, rs1_val == 2
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0000000000000002;  op2val:0xffffffffffff7fff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00000002, 0x00000000, 0xffff7fff, 0xffffffff, x28, x1, 456, x12)

inst_50:
// rs2_val == -16385, rs1_val == 144115188075855872
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0200000000000000;  op2val:0xffffffffffffbfff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00000000, 0x02000000, 0xffffbfff, 0xffffffff, x28, x1, 468, x12)

inst_51:
// rs2_val == -8193, rs1_val == -268435457
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xffffffffefffffff;  op2val:0xffffffffffffdfff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xefffffff, 0xffffffff, 0xffffdfff, 0xffffffff, x28, x1, 480, x12)

inst_52:
// rs2_val == -4097, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0000000000020000;  op2val:0xffffffffffffefff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00020000, 0x00000000, 0xffffefff, 0xffffffff, x28, x1, 492, x12)

inst_53:
// rs2_val == -2049, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xfffffffffffdffff;  op2val:0xfffffffffffff7ff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xfffdffff, 0xffffffff, 0xfffff7ff, 0xffffffff, x28, x1, 504, x12)

inst_54:
// rs2_val == -1025, rs1_val == -2199023255553
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xfffffdffffffffff;  op2val:0xfffffffffffffbff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xffffffff, 0xfffffdff, 0xfffffbff, 0xffffffff, x28, x1, 516, x12)

inst_55:
// rs2_val == -513, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0000000000000006;  op2val:0xfffffffffffffdff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00000006, 0x00000000, 0xfffffdff, 0xffffffff, x28, x1, 528, x12)

inst_56:
// rs2_val == -257, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xffffefffffffffff;  op2val:0xfffffffffffffeff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xffffffff, 0xffffefff, 0xfffffeff, 0xffffffff, x28, x1, 540, x12)

inst_57:
// rs2_val == -65, rs1_val == 1099511627776
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0000010000000000;  op2val:0xffffffffffffffbf;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00000000, 0x00000100, 0xffffffbf, 0xffffffff, x28, x1, 552, x12)

inst_58:
// rs2_val == -33, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0000000800000000;  op2val:0xffffffffffffffdf;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00000000, 0x00000008, 0xffffffdf, 0xffffffff, x28, x1, 564, x12)

inst_59:
// rs2_val == -17, rs1_val == -72057594037927937
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xfeffffffffffffff;  op2val:0xffffffffffffffef;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xffffffff, 0xfeffffff, 0xffffffef, 0xffffffff, x28, x1, 576, x12)

inst_60:
// rs2_val == -9, rs1_val == 1
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0000000000000001;  op2val:0xfffffffffffffff7;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00000001, 0x00000000, 0xfffffff7, 0xffffffff, x28, x1, 588, x12)

inst_61:
// rs2_val == -5, rs1_val == -2049
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xfffffffffffff7ff;  op2val:0xfffffffffffffffb;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xfffff7ff, 0xffffffff, 0xfffffffb, 0xffffffff, x28, x1, 600, x12)

inst_62:
// rs2_val == -3, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0000000000020000;  op2val:0xfffffffffffffffd;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00020000, 0x00000000, 0xfffffffd, 0xffffffff, x28, x1, 612, x12)

inst_63:
// rs2_val == -2, rs1_val == -4294967297
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xfffffffeffffffff;  op2val:0xfffffffffffffffe;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xffffffff, 0xfffffffe, 0xfffffffe, 0xffffffff, x28, x1, 624, x12)

inst_64:
// rs1_val == 9223372036854775807, rs1_val == (2**63-1), rs2_val == 36028797018963968, rs1_val > 0 and rs2_val > 0
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x7fffffffffffffff;  op2val:0x0080000000000000;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xffffffff, 0x7fffffff, 0x00000000, 0x00800000, x28, x1, 636, x12)

inst_65:
// rs1_val == -2305843009213693953, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xdfffffffffffffff;  op2val:0xffdfffffffffffff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xffffffff, 0xdfffffff, 0xffffffff, 0xffdfffff, x28, x1, 648, x12)

inst_66:
// rs1_val == -1152921504606846977, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xefffffffffffffff;  op2val:0xffffffffbfffffff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xffffffff, 0xefffffff, 0xbfffffff, 0xffffffff, x28, x1, 660, x12)

inst_67:
// rs1_val == -576460752303423489, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xf7ffffffffffffff;  op2val:0xfffffffbffffffff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xffffffff, 0xf7ffffff, 0xffffffff, 0xfffffffb, x28, x1, 672, x12)

inst_68:
// rs1_val == -144115188075855873, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xfdffffffffffffff;  op2val:0xefffffffffffffff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xffffffff, 0xfdffffff, 0xffffffff, 0xefffffff, x28, x1, 684, x12)

inst_69:
// rs1_val == -36028797018963969, rs2_val == 262144
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xff7fffffffffffff;  op2val:0x0000000000040000;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xffffffff, 0xff7fffff, 0x00040000, 0x00000000, x28, x1, 696, x12)

inst_70:
// rs1_val == -9007199254740993, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xffdfffffffffffff;  op2val:0x0000000000000005;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xffffffff, 0xffdfffff, 0x00000005, 0x00000000, x28, x1, 708, x12)

inst_71:
// rs1_val == -4503599627370497, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xffefffffffffffff;  op2val:0xffffffffffefffff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xffffffff, 0xffefffff, 0xffefffff, 0xffffffff, x28, x1, 720, x12)

inst_72:
// rs1_val == -1125899906842625, rs2_val == 562949953421312
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xfffbffffffffffff;  op2val:0x0002000000000000;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xffffffff, 0xfffbffff, 0x00000000, 0x00020000, x28, x1, 732, x12)

inst_73:
// rs1_val == -562949953421313, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xfffdffffffffffff;  op2val:0xfffffffffbffffff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xffffffff, 0xfffdffff, 0xfbffffff, 0xffffffff, x28, x1, 744, x12)

inst_74:
// rs1_val == -140737488355329, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xffff7fffffffffff;  op2val:0x0000000000040000;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xffffffff, 0xffff7fff, 0x00040000, 0x00000000, x28, x1, 756, x12)

inst_75:
// rs1_val == -35184372088833, rs2_val == 576460752303423488
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xffffdfffffffffff;  op2val:0x0800000000000000;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xffffffff, 0xffffdfff, 0x00000000, 0x08000000, x28, x1, 768, x12)

inst_76:
// rs1_val == -4398046511105, rs2_val == 2147483648
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xfffffbffffffffff;  op2val:0x0000000080000000;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xffffffff, 0xfffffbff, 0x80000000, 0x00000000, x28, x1, 780, x12)

inst_77:
// rs1_val == -549755813889, rs2_val == 8192
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xffffff7fffffffff;  op2val:0x0000000000002000;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xffffffff, 0xffffff7f, 0x00002000, 0x00000000, x28, x1, 792, x12)

inst_78:
// rs1_val == -274877906945, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xffffffbfffffffff;  op2val:0xffffffffff7fffff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xffffffff, 0xffffffbf, 0xff7fffff, 0xffffffff, x28, x1, 804, x12)

inst_79:
// rs1_val == -137438953473, rs2_val == 4
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xffffffdfffffffff;  op2val:0x0000000000000004;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xffffffff, 0xffffffdf, 0x00000004, 0x00000000, x28, x1, 816, x12)

inst_80:
// rs2_val == -6148914691236517206, rs1_val == 256
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0000000000000100;  op2val:0xaaaaaaaaaaaaaaaa;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00000100, 0x00000000, 0xaaaaaaaa, 0xaaaaaaaa, x28, x1, 828, x12)

inst_81:
// rs2_val == 6148914691236517205, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xfffffffffbffffff;  op2val:0x5555555555555555;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xfbffffff, 0xffffffff, 0x55555555, 0x55555555, x28, x1, 840, x12)

inst_82:
// rs1_val == 0, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0000000000000000;  op2val:0xfffffffffffeffff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00000000, 0x00000000, 0xfffeffff, 0xffffffff, x28, x1, 852, x12)

inst_83:
// rs1_val == rs2_val, rs1_val == -16777217
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xfffffffffeffffff;  op2val:0xfffffffffeffffff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xfeffffff, 0xffffffff, 0xfeffffff, 0xffffffff, x28, x1, 864, x12)

inst_84:
// rs2_val == (-2**63), rs2_val == -9223372036854775808, rs1_val == -513
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xfffffffffffffdff;  op2val:0x8000000000000000;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xfffffdff, 0xffffffff, 0x00000000, 0x80000000, x28, x1, 876, x12)

inst_85:
// rs2_val == 0, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xfffbffffffffffff;  op2val:0x0000000000000000;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xffffffff, 0xfffbffff, 0x00000000, 0x00000000, x28, x1, 888, x12)

inst_86:
// rs1_val == -68719476737, rs2_val == 512
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xffffffefffffffff;  op2val:0x0000000000000200;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xffffffff, 0xffffffef, 0x00000200, 0x00000000, x28, x1, 900, x12)

inst_87:
// rs1_val == -17179869185, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xfffffffbffffffff;  op2val:0x5555555555555555;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xffffffff, 0xfffffffb, 0x55555555, 0x55555555, x28, x1, 912, x12)

inst_88:
// rs1_val == -8589934593, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xfffffffdffffffff;  op2val:0xffffbfffffffffff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xffffffff, 0xfffffffd, 0xffffffff, 0xffffbfff, x28, x1, 924, x12)

inst_89:
// rs1_val == -2147483649, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xffffffff7fffffff;  op2val:0xffffffffff7fffff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x7fffffff, 0xffffffff, 0xff7fffff, 0xffffffff, x28, x1, 936, x12)

inst_90:
// rs1_val == -536870913, rs2_val == 34359738368
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xffffffffdfffffff;  op2val:0x0000000800000000;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xdfffffff, 0xffffffff, 0x00000000, 0x00000008, x28, x1, 948, x12)

inst_91:
// rs1_val == -134217729, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xfffffffff7ffffff;  op2val:0x5555555555555555;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xf7ffffff, 0xffffffff, 0x55555555, 0x55555555, x28, x1, 960, x12)

inst_92:
// rs1_val == -33554433, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xfffffffffdffffff;  op2val:0xffffffffffffefff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xfdffffff, 0xffffffff, 0xffffefff, 0xffffffff, x28, x1, 972, x12)

inst_93:
// rs1_val == -1048577, rs2_val == 268435456
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xffffffffffefffff;  op2val:0x0000000010000000;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xffefffff, 0xffffffff, 0x10000000, 0x00000000, x28, x1, 984, x12)

inst_94:
// rs1_val == -524289, rs2_val == 16384
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xfffffffffff7ffff;  op2val:0x0000000000004000;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xfff7ffff, 0xffffffff, 0x00004000, 0x00000000, x28, x1, 996, x12)

inst_95:
// rs1_val == -65537, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xfffffffffffeffff;  op2val:0xfffffffffffffff6;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xfffeffff, 0xffffffff, 0xfffffff6, 0xffffffff, x28, x1, 1008, x12)

inst_96:
// rs1_val == -8193, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xffffffffffffdfff;  op2val:0xfffeffffffffffff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xffffdfff, 0xffffffff, 0xffffffff, 0xfffeffff, x28, x1, 1020, x12)

inst_97:
// rs1_val == -1025, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xfffffffffffffbff;  op2val:0xff7fffffffffffff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xfffffbff, 0xffffffff, 0xffffffff, 0xff7fffff, x28, x1, 1032, x12)

inst_98:
// rs1_val == -257, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xfffffffffffffeff;  op2val:0x0080000000000000;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xfffffeff, 0xffffffff, 0x00000000, 0x00800000, x28, x1, 1044, x12)

inst_99:
// rs1_val == -65, rs2_val == 4096
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xffffffffffffffbf;  op2val:0x0000000000001000;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xffffffbf, 0xffffffff, 0x00001000, 0x00000000, x28, x1, 1056, x12)

inst_100:
// rs1_val == -33, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xffffffffffffffdf;  op2val:0xfffdffffffffffff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xffffffdf, 0xffffffff, 0xffffffff, 0xfffdffff, x28, x1, 1068, x12)

inst_101:
// rs1_val == -17, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xffffffffffffffef;  op2val:0xffffffbfffffffff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xffffffef, 0xffffffff, 0xffffffff, 0xffffffbf, x28, x1, 1080, x12)

inst_102:
// rs1_val == -9, rs2_val == 128
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xfffffffffffffff7;  op2val:0x0000000000000080;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xfffffff7, 0xffffffff, 0x00000080, 0x00000000, x28, x1, 1092, x12)

inst_103:
// rs1_val == -3, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xfffffffffffffffd;  op2val:0x0080000000000000;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xfffffffd, 0xffffffff, 0x00000000, 0x00800000, x28, x1, 1104, x12)

inst_104:
// rs1_val == -2, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xfffffffffffffffe;  op2val:0xffffffffffbfffff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xfffffffe, 0xffffffff, 0xffbfffff, 0xffffffff, x28, x1, 1116, x12)

inst_105:
// rs2_val == 4611686018427387904, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0400000000000000;  op2val:0x4000000000000000;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00000000, 0x04000000, 0x00000000, 0x40000000, x28, x1, 1128, x12)

inst_106:
// rs2_val == 2305843009213693952, rs1_val == 67108864
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0000000004000000;  op2val:0x2000000000000000;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x04000000, 0x00000000, 0x00000000, 0x20000000, x28, x1, 1140, x12)

inst_107:
// rs2_val == 1152921504606846976, rs1_val == 72057594037927936
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0100000000000000;  op2val:0x1000000000000000;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00000000, 0x01000000, 0x00000000, 0x10000000, x28, x1, 1152, x12)

inst_108:
// rs2_val == 288230376151711744, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0000000000000010;  op2val:0x0400000000000000;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00000010, 0x00000000, 0x00000000, 0x04000000, x28, x1, 1164, x12)

inst_109:
// rs2_val == 144115188075855872, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x7fffffffffffffff;  op2val:0x0200000000000000;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xffffffff, 0x7fffffff, 0x00000000, 0x02000000, x28, x1, 1176, x12)

inst_110:
// rs2_val == 72057594037927936, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0000000000000006;  op2val:0x0100000000000000;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00000006, 0x00000000, 0x00000000, 0x01000000, x28, x1, 1188, x12)

inst_111:
// rs2_val == 18014398509481984, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xfffffffffffffffb;  op2val:0x0040000000000000;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xfffffffb, 0xffffffff, 0x00000000, 0x00400000, x28, x1, 1200, x12)

inst_112:
// rs2_val == 9007199254740992, rs1_val == 8796093022208
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0000080000000000;  op2val:0x0020000000000000;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00000000, 0x00000800, 0x00000000, 0x00200000, x28, x1, 1212, x12)

inst_113:
// rs2_val == 4503599627370496, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xfffffffffffffff6;  op2val:0x0010000000000000;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xfffffff6, 0xffffffff, 0x00000000, 0x00100000, x28, x1, 1224, x12)

inst_114:
// rs2_val == 2251799813685248, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xfffffffdffffffff;  op2val:0x0008000000000000;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xffffffff, 0xfffffffd, 0x00000000, 0x00080000, x28, x1, 1236, x12)

inst_115:
// rs2_val == 1125899906842624, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xffffffbfffffffff;  op2val:0x0004000000000000;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xffffffff, 0xffffffbf, 0x00000000, 0x00040000, x28, x1, 1248, x12)

inst_116:
// rs2_val == 281474976710656, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0000000000000020;  op2val:0x0001000000000000;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00000020, 0x00000000, 0x00000000, 0x00010000, x28, x1, 1260, x12)

inst_117:
// rs2_val == 140737488355328, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0000002000000000;  op2val:0x0000800000000000;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00000000, 0x00000020, 0x00000000, 0x00008000, x28, x1, 1272, x12)

inst_118:
// rs2_val == 70368744177664, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xffffffffffffffef;  op2val:0x0000400000000000;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xffffffef, 0xffffffff, 0x00000000, 0x00004000, x28, x1, 1284, x12)

inst_119:
// rs2_val == 35184372088832, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xfffffffffffff7ff;  op2val:0x0000200000000000;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xfffff7ff, 0xffffffff, 0x00000000, 0x00002000, x28, x1, 1296, x12)

inst_120:
// rs2_val == 17592186044416, rs1_val == 2199023255552
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0000020000000000;  op2val:0x0000100000000000;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00000000, 0x00000200, 0x00000000, 0x00001000, x28, x1, 1308, x12)

inst_121:
// rs2_val == 8796093022208, rs1_val == 140737488355328
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0000800000000000;  op2val:0x0000080000000000;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00000000, 0x00008000, 0x00000000, 0x00000800, x28, x1, 1320, x12)

inst_122:
// rs2_val == 4398046511104, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xffdfffffffffffff;  op2val:0x0000040000000000;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xffffffff, 0xffdfffff, 0x00000000, 0x00000400, x28, x1, 1332, x12)

inst_123:
// rs2_val == 2199023255552, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xfffffffffffffbff;  op2val:0x0000020000000000;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xfffffbff, 0xffffffff, 0x00000000, 0x00000200, x28, x1, 1344, x12)

inst_124:
// rs2_val == 1099511627776, rs1_val == 2097152
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0000000000200000;  op2val:0x0000010000000000;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00200000, 0x00000000, 0x00000000, 0x00000100, x28, x1, 1356, x12)

inst_125:
// rs2_val == 549755813888, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0000000000000002;  op2val:0x0000008000000000;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00000002, 0x00000000, 0x00000000, 0x00000080, x28, x1, 1368, x12)

inst_126:
// rs2_val == 274877906944, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xdfffffffffffffff;  op2val:0x0000004000000000;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xffffffff, 0xdfffffff, 0x00000000, 0x00000040, x28, x1, 1380, x12)

inst_127:
// rs2_val == 137438953472, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xffffffffffffdfff;  op2val:0x0000002000000000;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xffffdfff, 0xffffffff, 0x00000000, 0x00000020, x28, x1, 1392, x12)

inst_128:
// rs2_val == 68719476736, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xffffffffffffffdf;  op2val:0x0000001000000000;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xffffffdf, 0xffffffff, 0x00000000, 0x00000010, x28, x1, 1404, x12)

inst_129:
// rs2_val == 17179869184, rs1_val == 4611686018427387904
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x4000000000000000;  op2val:0x0000000400000000;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00000000, 0x40000000, 0x00000000, 0x00000004, x28, x1, 1416, x12)

inst_130:
// rs2_val == 8589934592, rs1_val == 16777216
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0000000001000000;  op2val:0x0000000200000000;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x01000000, 0x00000000, 0x00000000, 0x00000002, x28, x1, 1428, x12)

inst_131:
// rs2_val == 4294967296, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xfffffffffffff7ff;  op2val:0x0000000100000000;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xfffff7ff, 0xffffffff, 0x00000000, 0x00000001, x28, x1, 1440, x12)

inst_132:
// rs2_val == 1073741824, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xbfffffffffffffff;  op2val:0x0000000040000000;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xffffffff, 0xbfffffff, 0x40000000, 0x00000000, x28, x1, 1452, x12)

inst_133:
// rs2_val == 536870912, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0000000000020000;  op2val:0x0000000020000000;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00020000, 0x00000000, 0x20000000, 0x00000000, x28, x1, 1464, x12)

inst_134:
// rs2_val == 134217728, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xfffffffffffffffb;  op2val:0x0000000008000000;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xfffffffb, 0xffffffff, 0x08000000, 0x00000000, x28, x1, 1476, x12)

inst_135:
// rs2_val == 67108864, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xfffffffffff7ffff;  op2val:0x0000000004000000;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xfff7ffff, 0xffffffff, 0x04000000, 0x00000000, x28, x1, 1488, x12)

inst_136:
// rs2_val == 33554432, rs1_val == 36028797018963968
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0080000000000000;  op2val:0x0000000002000000;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00000000, 0x00800000, 0x02000000, 0x00000000, x28, x1, 1500, x12)

inst_137:
// rs2_val == 16777216, rs1_val == 134217728
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0000000008000000;  op2val:0x0000000001000000;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x08000000, 0x00000000, 0x01000000, 0x00000000, x28, x1, 1512, x12)

inst_138:
// rs2_val == 8388608, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xffffffffffffff7f;  op2val:0x0000000000800000;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xffffff7f, 0xffffffff, 0x00800000, 0x00000000, x28, x1, 1524, x12)

inst_139:
// rs2_val == 4194304, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xfffffffffffffffe;  op2val:0x0000000000400000;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xfffffffe, 0xffffffff, 0x00400000, 0x00000000, x28, x1, 1536, x12)

inst_140:
// rs2_val == 2097152, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0000000000000020;  op2val:0x0000000000200000;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00000020, 0x00000000, 0x00200000, 0x00000000, x28, x1, 1548, x12)

inst_141:
// rs2_val == 1048576, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xfffff7ffffffffff;  op2val:0x0000000000100000;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xffffffff, 0xfffff7ff, 0x00100000, 0x00000000, x28, x1, 1560, x12)

inst_142:
// rs2_val == 524288, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0040000000000000;  op2val:0x0000000000080000;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00000000, 0x00400000, 0x00080000, 0x00000000, x28, x1, 1572, x12)

inst_143:
// rs2_val == 131072, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0000000000000100;  op2val:0x0000000000020000;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00000100, 0x00000000, 0x00020000, 0x00000000, x28, x1, 1584, x12)

inst_144:
// rs2_val == 65536, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xffffffffbfffffff;  op2val:0x0000000000010000;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xbfffffff, 0xffffffff, 0x00010000, 0x00000000, x28, x1, 1596, x12)

inst_145:
// rs2_val == 32768, rs1_val == 8
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0000000000000008;  op2val:0x0000000000008000;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00000008, 0x00000000, 0x00008000, 0x00000000, x28, x1, 1608, x12)

inst_146:
// rs2_val == 2048, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xffffffffffffffef;  op2val:0x0000000000000800;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xffffffef, 0xffffffff, 0x00000800, 0x00000000, x28, x1, 1620, x12)

inst_147:
// rs2_val == 1024, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xfffffffffffffff9;  op2val:0x0000000000000400;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xfffffff9, 0xffffffff, 0x00000400, 0x00000000, x28, x1, 1632, x12)

inst_148:
// rs2_val == 256, rs1_val == 8388608
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0000000000800000;  op2val:0x0000000000000100;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00800000, 0x00000000, 0x00000100, 0x00000000, x28, x1, 1644, x12)

inst_149:
// rs2_val == 64, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0000000000008000;  op2val:0x0000000000000040;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00008000, 0x00000000, 0x00000040, 0x00000000, x28, x1, 1656, x12)

inst_150:
// rs2_val == 32, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xfffffffffffffbff;  op2val:0x0000000000000020;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xfffffbff, 0xffffffff, 0x00000020, 0x00000000, x28, x1, 1668, x12)

inst_151:
// rs2_val == 16, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xfffffffffffffbff;  op2val:0x0000000000000010;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xfffffbff, 0xffffffff, 0x00000010, 0x00000000, x28, x1, 1680, x12)

inst_152:
// rs2_val == 8, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xffffffffff7fffff;  op2val:0x0000000000000008;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xff7fffff, 0xffffffff, 0x00000008, 0x00000000, x28, x1, 1692, x12)

inst_153:
// rs2_val == 1, rs1_val == 281474976710656
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0001000000000000;  op2val:0x0000000000000001;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00000000, 0x00010000, 0x00000001, 0x00000000, x28, x1, 1704, x12)

inst_154:
// rs1_val == 576460752303423488, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0800000000000000;  op2val:0xfff7ffffffffffff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00000000, 0x08000000, 0xffffffff, 0xfff7ffff, x28, x1, 1716, x12)

inst_155:
// rs1_val == 9007199254740992, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0020000000000000;  op2val:0xffffffffbfffffff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00000000, 0x00200000, 0xbfffffff, 0xffffffff, x28, x1, 1728, x12)

inst_156:
// rs1_val == 4503599627370496, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0010000000000000;  op2val:0x0100000000000000;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00000000, 0x00100000, 0x00000000, 0x01000000, x28, x1, 1740, x12)

inst_157:
// rs1_val == 1125899906842624, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0004000000000000;  op2val:0xffffffffffffbfff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00000000, 0x00040000, 0xffffbfff, 0xffffffff, x28, x1, 1752, x12)

inst_158:
// rs1_val == 70368744177664, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0000400000000000;  op2val:0xfffffffffffffffa;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00000000, 0x00004000, 0xfffffffa, 0xffffffff, x28, x1, 1764, x12)

inst_159:
// rs1_val == 35184372088832, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0000200000000000;  op2val:0x0000000002000000;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00000000, 0x00002000, 0x02000000, 0x00000000, x28, x1, 1776, x12)

inst_160:
// rs1_val == 17592186044416, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0000100000000000;  op2val:0xffefffffffffffff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00000000, 0x00001000, 0xffffffff, 0xffefffff, x28, x1, 1788, x12)

inst_161:
// rs1_val == 4398046511104, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0000040000000000;  op2val:0xfffffff7ffffffff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00000000, 0x00000400, 0xffffffff, 0xfffffff7, x28, x1, 1800, x12)

inst_162:
// rs1_val == 549755813888, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0000008000000000;  op2val:0xc000000000000000;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00000000, 0x00000080, 0x00000000, 0xc0000000, x28, x1, 1812, x12)

inst_163:
// rs1_val == 274877906944, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0000004000000000;  op2val:0x0000000000000200;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00000000, 0x00000040, 0x00000200, 0x00000000, x28, x1, 1824, x12)

inst_164:
// rs1_val == 8589934592, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0000000200000000;  op2val:0x0000002000000000;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00000000, 0x00000002, 0x00000000, 0x00000020, x28, x1, 1836, x12)

inst_165:
// rs1_val == 4294967296, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0000000100000000;  op2val:0xfffffffffffff7ff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00000000, 0x00000001, 0xfffff7ff, 0xffffffff, x28, x1, 1848, x12)

inst_166:
// rs1_val == 2147483648, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0000000080000000;  op2val:0xfffffdffffffffff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x80000000, 0x00000000, 0xffffffff, 0xfffffdff, x28, x1, 1860, x12)

inst_167:
// rs1_val == 1073741824, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0000000040000000;  op2val:0x0000000001000000;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x40000000, 0x00000000, 0x01000000, 0x00000000, x28, x1, 1872, x12)

inst_168:
// rs1_val == 33554432, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0000000002000000;  op2val:0xffffffffffdfffff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x02000000, 0x00000000, 0xffdfffff, 0xffffffff, x28, x1, 1884, x12)

inst_169:
// rs1_val == 4194304, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0000000000400000;  op2val:0xfffffffffffffff7;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00400000, 0x00000000, 0xfffffff7, 0xffffffff, x28, x1, 1896, x12)

inst_170:
// rs1_val == 1048576, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0000000000100000;  op2val:0x0000000200000000;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00100000, 0x00000000, 0x00000000, 0x00000002, x28, x1, 1908, x12)

inst_171:
// rs1_val == 262144, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0000000000040000;  op2val:0x0000040000000000;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00040000, 0x00000000, 0x00000000, 0x00000400, x28, x1, 1920, x12)

inst_172:
// rs1_val == 65536, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0000000000010000;  op2val:0xc000000000000000;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00010000, 0x00000000, 0x00000000, 0xc0000000, x28, x1, 1932, x12)

inst_173:
// rs1_val == 16384, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0000000000004000;  op2val:0xffffffffffdfffff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00004000, 0x00000000, 0xffdfffff, 0xffffffff, x28, x1, 1944, x12)

inst_174:
// rs1_val == 8192, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0000000000002000;  op2val:0xffffffffffffbfff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00002000, 0x00000000, 0xffffbfff, 0xffffffff, x28, x1, 1956, x12)

inst_175:
// rs1_val == 4096, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0000000000001000;  op2val:0x0000000040000000;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00001000, 0x00000000, 0x40000000, 0x00000000, x28, x1, 1968, x12)

inst_176:
// rs1_val == 2048, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0000000000000800;  op2val:0x2000000000000000;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00000800, 0x00000000, 0x00000000, 0x20000000, x28, x1, 1980, x12)

inst_177:
// rs1_val == 1024, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0000000000000400;  op2val:0x0400000000000000;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00000400, 0x00000000, 0x00000000, 0x04000000, x28, x1, 1992, x12)

inst_178:
// rs1_val == 512, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0000000000000200;  op2val:0x0000002000000000;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00000200, 0x00000000, 0x00000000, 0x00000020, x28, x1, 2004, x12)

inst_179:
// rs1_val == 128, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0000000000000080;  op2val:0xffffffbfffffffff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00000080, 0x00000000, 0xffffffff, 0xffffffbf, x28, x1, 2016, x12)

inst_180:
// rs1_val == 64, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0000000000000040;  op2val:0x0000000000000000;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00000040, 0x00000000, 0x00000000, 0x00000000, x28, x1, 2028, x12)
RVTEST_SIGBASE(x1,signature_x1_4)

inst_181:
// rs1_val == 4, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0000000000000004;  op2val:0x0000000000000040;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00000004, 0x00000000, 0x00000040, 0x00000000, x28, x1, 0, x12)
RVTEST_SIGBASE(x1,signature_x1_5)

inst_182:
// rs2_val == 2, 
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0x0400000000000000;  op2val:0x0000000000000002;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0x00000000, 0x04000000, 0x00000002, 0x00000000, x28, x1, 0, x12)

inst_183:
// rs2_val == 9223372036854775807, rs1_val == -1073741825, rs1_val < 0 and rs2_val > 0, rs2_val == (2**63-1)
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xffffffffbfffffff;  op2val:0x7fffffffffffffff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xbfffffff, 0xffffffff, 0xffffffff, 0x7fffffff, x28, x1, 12, x12)

inst_184:
// rs2_val == -2305843009213693953, rs1_val == -17592186044417
// opcode: kadd64 ; op1:x28; op2:x26; dest:x30; op1val:0xffffefffffffffff;  op2val:0xdfffffffffffffff;
TEST_PK64_PPP_OP(kadd64, x30, x31, x28, x29, x26, x27, 0x00000000, 0, 0xffffffff, 0xffffefff, 0xffffffff, 0xdfffffff, x28, x1, 24, x12)
#endif


RVTEST_CODE_END
RVMODEL_HALT

RVTEST_DATA_BEGIN
.align 4
rvtest_data:
.word 0xbabecafe
.word 0xabecafeb
.word 0xbecafeba
.word 0xecafebab
RVTEST_DATA_END

RVMODEL_DATA_BEGIN


signature_x1_0:
    .fill 0*(XLEN/32),4,0xdeadbeef


signature_x1_1:
    .fill 18*(XLEN/32),4,0xdeadbeef


signature_x1_2:
    .fill 15*(XLEN/32),4,0xdeadbeef


signature_x1_3:
    .fill 510*(XLEN/32),4,0xdeadbeef


signature_x1_4:
    .fill 3*(XLEN/32),4,0xdeadbeef


signature_x1_5:
    .fill 9*(XLEN/32),4,0xdeadbeef

#ifdef rvtest_mtrap_routine

mtrap_sigptr:
    .fill 64*(XLEN/32),4,0xdeadbeef

#endif

#ifdef rvtest_gpr_save

gpr_save:
    .fill 32*(XLEN/32),4,0xdeadbeef

#endif

RVMODEL_DATA_END
