
// -----------
// This file was generated by riscv_ctg (https://github.com/riscv-software-src/riscv-ctg)
// version   : 0.6.3
// timestamp : Sat Apr 23 14:53:29 2022 GMT
// usage     : riscv_ctg \
//                  --cgf /scratch/git-repo/github/riscv_ctg/sample_cgfs/dataset.cgf \
//                  --cgf /scratch/git-repo/github/riscv_ctg/sample_cgfs/rv32ip.cgf \
//                  --xlen 32  \
//                  --randomize \
// -----------
//
// -----------
// Copyright (c) 2020. RISC-V International. All rights reserved.
// SPDX-License-Identifier: BSD-3-Clause
// -----------
//
// This assembly file tests the kmmac instruction of the RISC-V RV32PZicsr extension for the kmmac covergroup.
// 
#include "model_test.h"
#include "arch_test.h"
RVTEST_ISA("RV32IPZicsr")

.section .text.init
.org 0x80
.globl rvtest_entry_point
rvtest_entry_point:
RVMODEL_BOOT
RVTEST_CODE_BEGIN

#ifdef TEST_CASE_1

RVTEST_CASE(0,"//check ISA:=regex(.*32.*);check ISA:=regex(.*I.*P.*Zicsr.*);def TEST_CASE_1=True;",kmmac)

RVTEST_VXSAT_ENABLE()
RVTEST_SIGBASE(x1,signature_x1_1)

inst_0:
// rs1 != rs2  and rs1 != rd and rs2 != rd, rs1==x29, rs2==x28, rd==x18, rs1_w0_val == -2147483648, rs2_w0_val == 536870912
// opcode: kmmac ; op1:x29; dest:x18; op1val:0x80000000;  immval:$imm_val
TEST_PKRR_OP(kmmac, x18, x29, x28, 0x00000000, 0x80000000, 0x20000000, x29, x1, 0, x2)

inst_1:
// rs1 == rs2 != rd, rs1==x12, rs2==x12, rd==x30, rs2_w0_val == -1431655766, rs1_w0_val == 2
// opcode: kmmac ; op1:x12; dest:x30; op1val:0x000002;  immval:$imm_val
TEST_PKRR_OP(kmmac, x30, x12, x12, 0x00000000, 0x000002, 0xaaaaaaaa, x12, x1, 8, x2)

inst_2:
// rs1 == rd != rs2, rs1==x5, rs2==x30, rd==x5, rs2_w0_val == 1431655765, rs1_w0_val == -134217729
// opcode: kmmac ; op1:x5; dest:x5; op1val:0xf7ffffff;  immval:$imm_val
TEST_PKRR_OP(kmmac, x5, x5, x30, 0x00000000, 0xf7ffffff, 0x55555555, x5, x1, 16, x2)

inst_3:
// rs1 == rs2 == rd, rs1==x6, rs2==x6, rd==x6, rs2_w0_val == 2147483647, rs1_w0_val == 8388608
// opcode: kmmac ; op1:x6; dest:x6; op1val:0x800000;  immval:$imm_val
TEST_PKRR_OP(kmmac, x6, x6, x6, 0x00000000, 0x800000, 0x7fffffff, x6, x1, 24, x2)

inst_4:
// rs2 == rd != rs1, rs1==x15, rs2==x0, rd==x0, rs2_w0_val == -1073741825, rs1_w0_val == -257
// opcode: kmmac ; op1:x15; dest:x0; op1val:0xfffffeff;  immval:$imm_val
TEST_PKRR_OP(kmmac, x0, x15, x0, 0x00000000, 0xfffffeff, 0xbfffffff, x15, x1, 32, x2)

inst_5:
// rs1==x11, rs2==x19, rd==x21, rs2_w0_val == -536870913, 
// opcode: kmmac ; op1:x11; dest:x21; op1val:0xffff4afd;  immval:$imm_val
TEST_PKRR_OP(kmmac, x21, x11, x19, 0x00000000, 0xffff4afd, 0xdfffffff, x11, x1, 40, x2)

inst_6:
// rs1==x13, rs2==x25, rd==x7, rs2_w0_val == -268435457, rs1_w0_val == 1048576
// opcode: kmmac ; op1:x13; dest:x7; op1val:0x100000;  immval:$imm_val
TEST_PKRR_OP(kmmac, x7, x13, x25, 0x00000000, 0x100000, 0xefffffff, x13, x1, 48, x2)

inst_7:
// rs1==x19, rs2==x14, rd==x28, rs2_w0_val == -134217729, rs1_w0_val == -9
// opcode: kmmac ; op1:x19; dest:x28; op1val:0xfffffff7;  immval:$imm_val
TEST_PKRR_OP(kmmac, x28, x19, x14, 0x00000000, 0xfffffff7, 0xf7ffffff, x19, x1, 56, x2)

inst_8:
// rs1==x8, rs2==x7, rd==x27, rs2_w0_val == -67108865, 
// opcode: kmmac ; op1:x8; dest:x27; op1val:0x000006;  immval:$imm_val
TEST_PKRR_OP(kmmac, x27, x8, x7, 0x00000000, 0x000006, 0xfbffffff, x8, x1, 64, x2)

inst_9:
// rs1==x20, rs2==x13, rd==x9, rs2_w0_val == -33554433, rs1_w0_val == 1
// opcode: kmmac ; op1:x20; dest:x9; op1val:0x000001;  immval:$imm_val
TEST_PKRR_OP(kmmac, x9, x20, x13, 0x00000000, 0x000001, 0xfdffffff, x20, x1, 72, x2)

inst_10:
// rs1==x18, rs2==x23, rd==x26, rs2_w0_val == -16777217, 
// opcode: kmmac ; op1:x18; dest:x26; op1val:0x100000;  immval:$imm_val
TEST_PKRR_OP(kmmac, x26, x18, x23, 0x00000000, 0x100000, 0xfeffffff, x18, x1, 80, x2)

inst_11:
// rs1==x7, rs2==x10, rd==x31, rs2_w0_val == -8388609, 
// opcode: kmmac ; op1:x7; dest:x31; op1val:0x66666667;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x7, x10, 0x00000000, 0x66666667, 0xff7fffff, x7, x1, 88, x2)

inst_12:
// rs1==x23, rs2==x4, rd==x19, rs2_w0_val == -4194305, rs1_w0_val == -2097153
// opcode: kmmac ; op1:x23; dest:x19; op1val:0xffdfffff;  immval:$imm_val
TEST_PKRR_OP(kmmac, x19, x23, x4, 0x00000000, 0xffdfffff, 0xffbfffff, x23, x1, 96, x2)

inst_13:
// rs1==x30, rs2==x20, rd==x22, rs2_w0_val == -2097153, 
// opcode: kmmac ; op1:x30; dest:x22; op1val:0xc0000000;  immval:$imm_val
TEST_PKRR_OP(kmmac, x22, x30, x20, 0x00000000, 0xc0000000, 0xffdfffff, x30, x1, 104, x2)

inst_14:
// rs1==x16, rs2==x24, rd==x13, rs2_w0_val == -1048577, 
// opcode: kmmac ; op1:x16; dest:x13; op1val:0x000003;  immval:$imm_val
TEST_PKRR_OP(kmmac, x13, x16, x24, 0x00000000, 0x000003, 0xffefffff, x16, x1, 112, x2)
RVTEST_SIGBASE(x6,signature_x6_0)

inst_15:
// rs1==x25, rs2==x11, rd==x3, rs2_w0_val == -524289, 
// opcode: kmmac ; op1:x25; dest:x3; op1val:0x000003;  immval:$imm_val
TEST_PKRR_OP(kmmac, x3, x25, x11, 0x00000000, 0x000003, 0xfff7ffff, x25, x6, 0, x7)

inst_16:
// rs1==x10, rs2==x17, rd==x4, rs2_w0_val == -262145, rs1_w0_val == 1024
// opcode: kmmac ; op1:x10; dest:x4; op1val:0x000400;  immval:$imm_val
TEST_PKRR_OP(kmmac, x4, x10, x17, 0x00000000, 0x000400, 0xfffbffff, x10, x6, 8, x7)

inst_17:
// rs1==x24, rs2==x2, rd==x17, rs2_w0_val == -131073, 
// opcode: kmmac ; op1:x24; dest:x17; op1val:0xfffffffc;  immval:$imm_val
TEST_PKRR_OP(kmmac, x17, x24, x2, 0x00000000, 0xfffffffc, 0xfffdffff, x24, x6, 16, x7)

inst_18:
// rs1==x27, rs2==x29, rd==x20, rs2_w0_val == -65537, rs1_w0_val == 512
// opcode: kmmac ; op1:x27; dest:x20; op1val:0x000200;  immval:$imm_val
TEST_PKRR_OP(kmmac, x20, x27, x29, 0x00000000, 0x000200, 0xfffeffff, x27, x6, 24, x7)

inst_19:
// rs1==x26, rs2==x31, rd==x23, rs2_w0_val == -32769, rs1_w0_val == -129
// opcode: kmmac ; op1:x26; dest:x23; op1val:0xffffff7f;  immval:$imm_val
TEST_PKRR_OP(kmmac, x23, x26, x31, 0x00000000, 0xffffff7f, 0xffff7fff, x26, x6, 32, x7)

inst_20:
// rs1==x21, rs2==x16, rd==x11, rs2_w0_val == -16385, rs1_w0_val == 256
// opcode: kmmac ; op1:x21; dest:x11; op1val:0x000100;  immval:$imm_val
TEST_PKRR_OP(kmmac, x11, x21, x16, 0x00000000, 0x000100, 0xffffbfff, x21, x6, 40, x7)

inst_21:
// rs1==x2, rs2==x9, rd==x24, rs2_w0_val == -8193, 
// opcode: kmmac ; op1:x2; dest:x24; op1val:0x000100;  immval:$imm_val
TEST_PKRR_OP(kmmac, x24, x2, x9, 0x00000000, 0x000100, 0xffffdfff, x2, x6, 48, x7)

inst_22:
// rs1==x14, rs2==x18, rd==x25, rs2_w0_val == -4097, 
// opcode: kmmac ; op1:x14; dest:x25; op1val:0x800000;  immval:$imm_val
TEST_PKRR_OP(kmmac, x25, x14, x18, 0x00000000, 0x800000, 0xffffefff, x14, x6, 56, x7)

inst_23:
// rs1==x31, rs2==x26, rd==x29, rs2_w0_val == -2049, 
// opcode: kmmac ; op1:x31; dest:x29; op1val:0xffdfffff;  immval:$imm_val
TEST_PKRR_OP(kmmac, x29, x31, x26, 0x00000000, 0xffdfffff, 0xfffff7ff, x31, x6, 64, x7)

inst_24:
// rs1==x22, rs2==x3, rd==x1, rs2_w0_val == -1025, 
// opcode: kmmac ; op1:x22; dest:x1; op1val:0x00b504;  immval:$imm_val
TEST_PKRR_OP(kmmac, x1, x22, x3, 0x00000000, 0x00b504, 0xfffffbff, x22, x6, 72, x7)

inst_25:
// rs1==x17, rs2==x5, rd==x15, rs2_w0_val == -513, 
// opcode: kmmac ; op1:x17; dest:x15; op1val:0x33333334;  immval:$imm_val
TEST_PKRR_OP(kmmac, x15, x17, x5, 0x00000000, 0x33333334, 0xfffffdff, x17, x6, 80, x7)

inst_26:
// rs1==x28, rs2==x8, rd==x14, rs2_w0_val == -257, rs1_w0_val == 2048
// opcode: kmmac ; op1:x28; dest:x14; op1val:0x000800;  immval:$imm_val
TEST_PKRR_OP(kmmac, x14, x28, x8, 0x00000000, 0x000800, 0xfffffeff, x28, x6, 88, x7)

inst_27:
// rs1==x4, rs2==x1, rd==x16, rs2_w0_val == -129, rs1_w0_val == 32768
// opcode: kmmac ; op1:x4; dest:x16; op1val:0x008000;  immval:$imm_val
TEST_PKRR_OP(kmmac, x16, x4, x1, 0x00000000, 0x008000, 0xffffff7f, x4, x6, 96, x7)

inst_28:
// rs1==x3, rs2==x15, rd==x12, rs2_w0_val == -65, 
// opcode: kmmac ; op1:x3; dest:x12; op1val:0x000002;  immval:$imm_val
TEST_PKRR_OP(kmmac, x12, x3, x15, 0x00000000, 0x000002, 0xffffffbf, x3, x6, 104, x7)

inst_29:
// rs1==x1, rs2==x21, rd==x10, rs2_w0_val == -33, rs1_w0_val == 2097152
// opcode: kmmac ; op1:x1; dest:x10; op1val:0x200000;  immval:$imm_val
TEST_PKRR_OP(kmmac, x10, x1, x21, 0x00000000, 0x200000, 0xffffffdf, x1, x6, 112, x3)

inst_30:
// rs1==x0, rs2==x27, rd==x8, rs2_w0_val == -17, 
// opcode: kmmac ; op1:x0; dest:x8; op1val:0xfffffeff;  immval:$imm_val
TEST_PKRR_OP(kmmac, x8, x0, x27, 0x00000000, 0xfffffeff, 0xffffffef, x0, x6, 120, x3)

inst_31:
// rs1==x9, rs2==x22, rd==x2, rs2_w0_val == -9, 
// opcode: kmmac ; op1:x9; dest:x2; op1val:0x000002;  immval:$imm_val
TEST_PKRR_OP(kmmac, x2, x9, x22, 0x00000000, 0x000002, 0xfffffff7, x9, x6, 128, x3)

inst_32:
// rs2_w0_val == -5, rs1_w0_val == 64
// opcode: kmmac ; op1:x30; dest:x31; op1val:0x000040;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0x000040, 0xfffffffb, x30, x6, 136, x3)
RVTEST_SIGBASE(x1,signature_x1_2)

inst_33:
// rs2_w0_val == -3, 
// opcode: kmmac ; op1:x30; dest:x31; op1val:0x000005;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0x000005, 0xfffffffd, x30, x1, 0, x3)

inst_34:
// rs2_w0_val == -2, rs1_w0_val == 262144
// opcode: kmmac ; op1:x30; dest:x31; op1val:0x040000;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0x040000, 0xfffffffe, x30, x1, 8, x3)

inst_35:
// rs2_w0_val == -2147483648, rs1_w0_val == 4
// opcode: kmmac ; op1:x30; dest:x31; op1val:0x000004;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0x000004, 0x80000000, x30, x1, 16, x3)

inst_36:
// rs2_w0_val == 1073741824, rs1_w0_val == -16385
// opcode: kmmac ; op1:x30; dest:x31; op1val:0xffffbfff;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0xffffbfff, 0x40000000, x30, x1, 24, x3)

inst_37:
// rs2_w0_val == 268435456, rs1_w0_val == -8193
// opcode: kmmac ; op1:x30; dest:x31; op1val:0xffffdfff;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0xffffdfff, 0x10000000, x30, x1, 32, x3)

inst_38:
// rs2_w0_val == 134217728, 
// opcode: kmmac ; op1:x30; dest:x31; op1val:0x80000000;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0x80000000, 0x8000000, x30, x1, 40, x3)

inst_39:
// rs2_w0_val == 67108864, rs1_w0_val == -67108865
// opcode: kmmac ; op1:x30; dest:x31; op1val:0xfbffffff;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0xfbffffff, 0x4000000, x30, x1, 48, x3)

inst_40:
// rs2_w0_val == 33554432, rs1_w0_val == 1073741824
// opcode: kmmac ; op1:x30; dest:x31; op1val:0x40000000;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0x40000000, 0x2000000, x30, x1, 56, x3)

inst_41:
// rs2_w0_val == 16777216, 
// opcode: kmmac ; op1:x30; dest:x31; op1val:0x40000000;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0x40000000, 0x1000000, x30, x1, 64, x3)

inst_42:
// rs2_w0_val == 8388608, 
// opcode: kmmac ; op1:x30; dest:x31; op1val:0x000004;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0x000004, 0x800000, x30, x1, 72, x3)

inst_43:
// rs2_w0_val == 4194304, 
// opcode: kmmac ; op1:x30; dest:x31; op1val:0x000002;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0x000002, 0x400000, x30, x1, 80, x3)

inst_44:
// rs2_w0_val == 2097152, rs1_w0_val == -2
// opcode: kmmac ; op1:x30; dest:x31; op1val:0xfffffffe;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0xfffffffe, 0x200000, x30, x1, 88, x3)

inst_45:
// rs2_w0_val == 1048576, rs1_w0_val == 536870912
// opcode: kmmac ; op1:x30; dest:x31; op1val:0x20000000;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0x20000000, 0x100000, x30, x1, 96, x3)

inst_46:
// rs2_w0_val == 524288, 
// opcode: kmmac ; op1:x30; dest:x31; op1val:0x000100;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0x000100, 0x080000, x30, x1, 104, x3)

inst_47:
// rs2_w0_val == 262144, rs1_w0_val == 4096
// opcode: kmmac ; op1:x30; dest:x31; op1val:0x001000;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0x001000, 0x040000, x30, x1, 112, x3)

inst_48:
// rs1_w0_val == 32, 
// opcode: kmmac ; op1:x30; dest:x31; op1val:0x000020;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0x000020, 0xf7ffffff, x30, x1, 120, x3)

inst_49:
// rs1_w0_val == 16, 
// opcode: kmmac ; op1:x30; dest:x31; op1val:0x000010;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0x000010, 0x55555554, x30, x1, 128, x3)

inst_50:
// rs1_w0_val == 8, 
// opcode: kmmac ; op1:x30; dest:x31; op1val:0x000008;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0x000008, 0x4000000, x30, x1, 136, x3)

inst_51:
// rs1_w0_val == 0, 
// opcode: kmmac ; op1:x30; dest:x31; op1val:0x000000;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0x000000, 0x4000000, x30, x1, 144, x3)

inst_52:
// rs1_w0_val == -1, rs2_w0_val == 8
// opcode: kmmac ; op1:x30; dest:x31; op1val:0xffffffff;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0xffffffff, 0x000008, x30, x1, 152, x3)

inst_53:
// rs2_w0_val == 131072, 
// opcode: kmmac ; op1:x30; dest:x31; op1val:0xffff4afd;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0xffff4afd, 0x020000, x30, x1, 160, x3)

inst_54:
// rs2_w0_val == 65536, rs1_w0_val == 134217728
// opcode: kmmac ; op1:x30; dest:x31; op1val:0x8000000;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0x8000000, 0x010000, x30, x1, 168, x3)

inst_55:
// rs2_w0_val == 32768, 
// opcode: kmmac ; op1:x30; dest:x31; op1val:0x200000;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0x200000, 0x008000, x30, x1, 176, x3)

inst_56:
// rs2_w0_val == 16384, 
// opcode: kmmac ; op1:x30; dest:x31; op1val:0x66666665;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0x66666665, 0x004000, x30, x1, 184, x3)

inst_57:
// rs2_w0_val == 8192, 
// opcode: kmmac ; op1:x30; dest:x31; op1val:0x55555554;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0x55555554, 0x002000, x30, x1, 192, x3)

inst_58:
// rs2_w0_val == 4096, 
// opcode: kmmac ; op1:x30; dest:x31; op1val:0x040000;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0x040000, 0x001000, x30, x1, 200, x3)

inst_59:
// rs2_w0_val == 2048, rs1_w0_val == 4194304
// opcode: kmmac ; op1:x30; dest:x31; op1val:0x400000;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0x400000, 0x000800, x30, x1, 208, x3)

inst_60:
// rs2_w0_val == 1024, 
// opcode: kmmac ; op1:x30; dest:x31; op1val:0xffffbfff;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0xffffbfff, 0x000400, x30, x1, 216, x3)

inst_61:
// rs2_w0_val == 512, rs1_w0_val == -33
// opcode: kmmac ; op1:x30; dest:x31; op1val:0xffffffdf;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0xffffffdf, 0x000200, x30, x1, 224, x3)

inst_62:
// rs2_w0_val == 256, 
// opcode: kmmac ; op1:x30; dest:x31; op1val:0x66666665;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0x66666665, 0x000100, x30, x1, 232, x3)

inst_63:
// rs2_w0_val == 128, rs1_w0_val == -262145
// opcode: kmmac ; op1:x30; dest:x31; op1val:0xfffbffff;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0xfffbffff, 0x000080, x30, x1, 240, x3)

inst_64:
// rs2_w0_val == 64, rs1_w0_val == -1073741825
// opcode: kmmac ; op1:x30; dest:x31; op1val:0xbfffffff;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0xbfffffff, 0x000040, x30, x1, 248, x3)

inst_65:
// rs2_w0_val == 32, 
// opcode: kmmac ; op1:x30; dest:x31; op1val:0x00b504;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0x00b504, 0x000020, x30, x1, 256, x3)

inst_66:
// rs2_w0_val == 16, 
// opcode: kmmac ; op1:x30; dest:x31; op1val:0x008000;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0x008000, 0x000010, x30, x1, 264, x3)

inst_67:
// rs2_w0_val == 4, 
// opcode: kmmac ; op1:x30; dest:x31; op1val:0xffffffff;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0xffffffff, 0x000004, x30, x1, 272, x3)

inst_68:
// rs2_w0_val == 2, rs1_w0_val == -1025
// opcode: kmmac ; op1:x30; dest:x31; op1val:0xfffffbff;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0xfffffbff, 0x000002, x30, x1, 280, x3)

inst_69:
// rs2_w0_val == 1, 
// opcode: kmmac ; op1:x30; dest:x31; op1val:0x000003;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0x000003, 0x000001, x30, x1, 288, x3)

inst_70:
// rs2_w0_val == 0, 
// opcode: kmmac ; op1:x30; dest:x31; op1val:0x040000;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0x040000, 0x000000, x30, x1, 296, x3)

inst_71:
// rs2_w0_val == -1, 
// opcode: kmmac ; op1:x30; dest:x31; op1val:0xffff4afc;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0xffff4afc, 0xffffffff, x30, x1, 304, x3)

inst_72:
// rs1_w0_val == -1431655766, 
// opcode: kmmac ; op1:x30; dest:x31; op1val:0xaaaaaaaa;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0xaaaaaaaa, 0x55555555, x30, x1, 312, x3)

inst_73:
// rs1_w0_val == 1431655765, 
// opcode: kmmac ; op1:x30; dest:x31; op1val:0x55555555;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0x55555555, 0x7fffffff, x30, x1, 320, x3)

inst_74:
// rs1_w0_val == 2147483647, 
// opcode: kmmac ; op1:x30; dest:x31; op1val:0x7fffffff;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0x7fffffff, 0x010000, x30, x1, 328, x3)

inst_75:
// rs1_w0_val == -536870913, 
// opcode: kmmac ; op1:x30; dest:x31; op1val:0xdfffffff;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0xdfffffff, 0xfffffdff, x30, x1, 336, x3)

inst_76:
// rs1_w0_val == -268435457, 
// opcode: kmmac ; op1:x30; dest:x31; op1val:0xefffffff;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0xefffffff, 0xc0000000, x30, x1, 344, x3)

inst_77:
// rs1_w0_val == -33554433, 
// opcode: kmmac ; op1:x30; dest:x31; op1val:0xfdffffff;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0xfdffffff, 0xfffffff7, x30, x1, 352, x3)

inst_78:
// rs1_w0_val == -16777217, 
// opcode: kmmac ; op1:x30; dest:x31; op1val:0xfeffffff;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0xfeffffff, 0x000200, x30, x1, 360, x3)

inst_79:
// rs1_w0_val == -8388609, 
// opcode: kmmac ; op1:x30; dest:x31; op1val:0xff7fffff;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0xff7fffff, 0x33333334, x30, x1, 368, x3)

inst_80:
// rs1_w0_val == -4194305, 
// opcode: kmmac ; op1:x30; dest:x31; op1val:0xffbfffff;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0xffbfffff, 0x001000, x30, x1, 376, x3)

inst_81:
// rs1_w0_val == -1048577, 
// opcode: kmmac ; op1:x30; dest:x31; op1val:0xffefffff;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0xffefffff, 0xfffbffff, x30, x1, 384, x3)

inst_82:
// rs1_w0_val == -524289, 
// opcode: kmmac ; op1:x30; dest:x31; op1val:0xfff7ffff;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0xfff7ffff, 0xfffffeff, x30, x1, 392, x3)

inst_83:
// rs1_w0_val == -131073, 
// opcode: kmmac ; op1:x30; dest:x31; op1val:0xfffdffff;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0xfffdffff, 0x000200, x30, x1, 400, x3)

inst_84:
// rs1_w0_val == -65537, 
// opcode: kmmac ; op1:x30; dest:x31; op1val:0xfffeffff;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0xfffeffff, 0x000000, x30, x1, 408, x3)

inst_85:
// rs1_w0_val == -32769, 
// opcode: kmmac ; op1:x30; dest:x31; op1val:0xffff7fff;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0xffff7fff, 0xfffffff6, x30, x1, 416, x3)

inst_86:
// rs1_w0_val == -4097, 
// opcode: kmmac ; op1:x30; dest:x31; op1val:0xffffefff;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0xffffefff, 0x000002, x30, x1, 424, x3)

inst_87:
// rs1_w0_val == -2049, 
// opcode: kmmac ; op1:x30; dest:x31; op1val:0xfffff7ff;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0xfffff7ff, 0xffdfffff, x30, x1, 432, x3)

inst_88:
// rs1_w0_val == -65, 
// opcode: kmmac ; op1:x30; dest:x31; op1val:0xffffffbf;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0xffffffbf, 0x008000, x30, x1, 440, x3)

inst_89:
// rs1_w0_val == -17, 
// opcode: kmmac ; op1:x30; dest:x31; op1val:0xffffffef;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0xffffffef, 0xfffffdff, x30, x1, 448, x3)

inst_90:
// rs1_w0_val == -5, 
// opcode: kmmac ; op1:x30; dest:x31; op1val:0xfffffffb;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0xfffffffb, 0x001000, x30, x1, 456, x3)

inst_91:
// rs1_w0_val == -3, 
// opcode: kmmac ; op1:x30; dest:x31; op1val:0xfffffffd;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0xfffffffd, 0xffffffff, x30, x1, 464, x3)

inst_92:
// rs1_w0_val == 268435456, 
// opcode: kmmac ; op1:x30; dest:x31; op1val:0x10000000;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0x10000000, 0xffffbfff, x30, x1, 472, x3)

inst_93:
// rs1_w0_val == 67108864, 
// opcode: kmmac ; op1:x30; dest:x31; op1val:0x4000000;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0x4000000, 0xfffeffff, x30, x1, 480, x3)

inst_94:
// rs1_w0_val == 33554432, 
// opcode: kmmac ; op1:x30; dest:x31; op1val:0x2000000;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0x2000000, 0x100000, x30, x1, 488, x3)

inst_95:
// rs1_w0_val == 16777216, 
// opcode: kmmac ; op1:x30; dest:x31; op1val:0x1000000;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0x1000000, 0xfffffffc, x30, x1, 496, x3)

inst_96:
// rs1_w0_val == 524288, 
// opcode: kmmac ; op1:x30; dest:x31; op1val:0x080000;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0x080000, 0xffff4afd, x30, x1, 504, x3)

inst_97:
// rs1_w0_val == 131072, 
// opcode: kmmac ; op1:x30; dest:x31; op1val:0x020000;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0x020000, 0x66666665, x30, x1, 512, x3)

inst_98:
// rs1_w0_val == 65536, 
// opcode: kmmac ; op1:x30; dest:x31; op1val:0x010000;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0x010000, 0xff7fffff, x30, x1, 520, x3)

inst_99:
// rs1_w0_val == 8192, 
// opcode: kmmac ; op1:x30; dest:x31; op1val:0x002000;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0x002000, 0x000001, x30, x1, 528, x3)

inst_100:
// rs1_w0_val == -513, 
// opcode: kmmac ; op1:x30; dest:x31; op1val:0xfffffdff;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0xfffffdff, 0xfffbffff, x30, x1, 536, x3)

inst_101:
// rs1_w0_val == 128, 
// opcode: kmmac ; op1:x30; dest:x31; op1val:0x000080;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0x000080, 0xefffffff, x30, x1, 544, x3)

inst_102:
// rs1_w0_val == 16384, 
// opcode: kmmac ; op1:x30; dest:x31; op1val:0x004000;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0x004000, 0x000007, x30, x1, 552, x3)

inst_103:
// rs2_w0_val == -1431655766, rs1_w0_val == 2
// opcode: kmmac ; op1:x30; dest:x31; op1val:0x000002;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0x000002, 0xaaaaaaaa, x30, x1, 560, x3)

inst_104:
// rs2_w0_val == -1073741825, rs1_w0_val == -257
// opcode: kmmac ; op1:x30; dest:x31; op1val:0xfffffeff;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0xfffffeff, 0xbfffffff, x30, x1, 568, x3)

inst_105:
// rs2_w0_val == -17, 
// opcode: kmmac ; op1:x30; dest:x31; op1val:0xfffffeff;  immval:$imm_val
TEST_PKRR_OP(kmmac, x31, x30, x29, 0x00000000, 0xfffffeff, 0xffffffef, x30, x1, 576, x3)
#endif


RVTEST_CODE_END
RVMODEL_HALT

RVTEST_DATA_BEGIN
.align 4
rvtest_data:
.word 0xbabecafe
.word 0xabecafeb
.word 0xbecafeba
.word 0xecafebab
RVTEST_DATA_END

RVMODEL_DATA_BEGIN


signature_x1_0:
    .fill 0*(XLEN/32),4,0xdeadbeef


signature_x1_1:
    .fill 30*(XLEN/32),4,0xdeadbeef


signature_x6_0:
    .fill 36*(XLEN/32),4,0xdeadbeef


signature_x1_2:
    .fill 146*(XLEN/32),4,0xdeadbeef

#ifdef rvtest_mtrap_routine

mtrap_sigptr:
    .fill 64*(XLEN/32),4,0xdeadbeef

#endif

#ifdef rvtest_gpr_save

gpr_save:
    .fill 32*(XLEN/32),4,0xdeadbeef

#endif

RVMODEL_DATA_END
