
// -----------
// This file was generated by riscv_ctg (https://github.com/riscv-software-src/riscv-ctg)
// version   : 0.6.3
// timestamp : Sat Apr 23 14:53:29 2022 GMT
// usage     : riscv_ctg \
//                  --cgf /scratch/git-repo/github/riscv_ctg/sample_cgfs/dataset.cgf \
//                  --cgf /scratch/git-repo/github/riscv_ctg/sample_cgfs/rv32ip.cgf \
//                  --xlen 32  \
//                  --randomize \
// -----------
//
// -----------
// Copyright (c) 2020. RISC-V International. All rights reserved.
// SPDX-License-Identifier: BSD-3-Clause
// -----------
//
// This assembly file tests the kmmawb instruction of the RISC-V RV32PZicsr extension for the kmmawb covergroup.
// 
#include "model_test.h"
#include "arch_test.h"
RVTEST_ISA("RV32IPZicsr")

.section .text.init
.org 0x80
.globl rvtest_entry_point
rvtest_entry_point:
RVMODEL_BOOT
RVTEST_CODE_BEGIN

#ifdef TEST_CASE_1

RVTEST_CASE(0,"//check ISA:=regex(.*32.*);check ISA:=regex(.*I.*P.*Zicsr.*);def TEST_CASE_1=True;",kmmawb)

RVTEST_VXSAT_ENABLE()
RVTEST_SIGBASE(x2,signature_x2_1)

inst_0:
// rs1 != rs2  and rs1 != rd and rs2 != rd, rs1==x1, rs2==x29, rd==x9, rs1_w0_val == -2147483648, rs2_h1_val == 16384, rs2_h0_val == -32768
// opcode: kmmawb ; op1:x1; op2:x29; dest:x9; op1val:0x80000000;  op2val:0x40008000
TEST_PKRR_OP(kmmawb, x9, x1, x29, 0x00000000, 0x80000000, 0x40008000, x1, x2, 0, x6)

inst_1:
// rs1 == rs2 != rd, rs1==x9, rs2==x9, rd==x22, rs2_h1_val == -21846, rs2_h0_val == -21846
// opcode: kmmawb ; op1:x9; op2:x9; dest:x22; op1val:0xfffffff9;  op2val:0xaaaaaaaa
TEST_PKRR_OP(kmmawb, x22, x9, x9, 0x00000000, 0xfffffff9, 0xaaaaaaaa, x9, x2, 8, x6)

inst_2:
// rs1 == rd != rs2, rs1==x31, rs2==x26, rd==x31, rs2_h1_val == 21845, rs2_h0_val == 8192, rs1_w0_val == 1048576
// opcode: kmmawb ; op1:x31; op2:x26; dest:x31; op1val:0x100000;  op2val:0x55552000
TEST_PKRR_OP(kmmawb, x31, x31, x26, 0x00000000, 0x100000, 0x55552000, x31, x2, 16, x6)

inst_3:
// rs1 == rs2 == rd, rs1==x15, rs2==x15, rd==x15, rs2_h1_val == 32767, rs1_w0_val == 0, rs2_h0_val == 2
// opcode: kmmawb ; op1:x15; op2:x15; dest:x15; op1val:0x000000;  op2val:0x7fff0002
TEST_PKRR_OP(kmmawb, x15, x15, x15, 0x00000000, 0x000000, 0x7fff0002, x15, x2, 24, x6)

inst_4:
// rs2 == rd != rs1, rs1==x30, rs2==x1, rd==x1, rs2_h1_val == -16385, 
// opcode: kmmawb ; op1:x30; op2:x1; dest:x1; op1val:0xfffffffa;  op2val:0xbfff0009
TEST_PKRR_OP(kmmawb, x1, x30, x1, 0x00000000, 0xfffffffa, 0xbfff0009, x30, x2, 32, x6)

inst_5:
// rs1==x10, rs2==x19, rd==x4, rs2_h1_val == -8193, rs1_w0_val == 536870912
// opcode: kmmawb ; op1:x10; op2:x19; dest:x4; op1val:0x20000000;  op2val:0xdffffffc
TEST_PKRR_OP(kmmawb, x4, x10, x19, 0x00000000, 0x20000000, 0xdffffffc, x10, x2, 40, x6)

inst_6:
// rs1==x24, rs2==x5, rd==x30, rs2_h1_val == -4097, rs1_w0_val == 256
// opcode: kmmawb ; op1:x24; op2:x5; dest:x30; op1val:0x000100;  op2val:0xefff0007
TEST_PKRR_OP(kmmawb, x30, x24, x5, 0x00000000, 0x000100, 0xefff0007, x24, x2, 48, x6)

inst_7:
// rs1==x16, rs2==x25, rd==x29, rs2_h1_val == -2049, rs1_w0_val == -1
// opcode: kmmawb ; op1:x16; op2:x25; dest:x29; op1val:0xffffffff;  op2val:0xf7ff0007
TEST_PKRR_OP(kmmawb, x29, x16, x25, 0x00000000, 0xffffffff, 0xf7ff0007, x16, x2, 56, x6)

inst_8:
// rs1==x0, rs2==x4, rd==x3, rs2_h1_val == -1025, rs1_w0_val == -134217729
// opcode: kmmawb ; op1:x0; op2:x4; dest:x3; op1val:0xf7ffffff;  op2val:0xfbfffff9
TEST_PKRR_OP(kmmawb, x3, x0, x4, 0x00000000, 0xf7ffffff, 0xfbfffff9, x0, x2, 64, x6)

inst_9:
// rs1==x18, rs2==x3, rd==x26, rs2_h1_val == -513, rs2_h0_val == 16384, rs1_w0_val == 2147483647
// opcode: kmmawb ; op1:x18; op2:x3; dest:x26; op1val:0x7fffffff;  op2val:0xfdff4000
TEST_PKRR_OP(kmmawb, x26, x18, x3, 0x00000000, 0x7fffffff, 0xfdff4000, x18, x2, 72, x6)

inst_10:
// rs1==x19, rs2==x11, rd==x14, rs2_h1_val == -257, rs2_h0_val == 64, rs1_w0_val == -3
// opcode: kmmawb ; op1:x19; op2:x11; dest:x14; op1val:0xfffffffd;  op2val:0xfeff0040
TEST_PKRR_OP(kmmawb, x14, x19, x11, 0x00000000, 0xfffffffd, 0xfeff0040, x19, x2, 80, x6)

inst_11:
// rs1==x23, rs2==x8, rd==x28, rs2_h1_val == -129, rs1_w0_val == -5, rs2_h0_val == 32767
// opcode: kmmawb ; op1:x23; op2:x8; dest:x28; op1val:0xfffffffb;  op2val:0xff7f7fff
TEST_PKRR_OP(kmmawb, x28, x23, x8, 0x00000000, 0xfffffffb, 0xff7f7fff, x23, x2, 88, x6)

inst_12:
// rs1==x12, rs2==x27, rd==x16, rs2_h1_val == -65, rs2_h0_val == 16, rs1_w0_val == -65
// opcode: kmmawb ; op1:x12; op2:x27; dest:x16; op1val:0xffffffbf;  op2val:0xffbf0010
TEST_PKRR_OP(kmmawb, x16, x12, x27, 0x00000000, 0xffffffbf, 0xffbf0010, x12, x2, 96, x6)

inst_13:
// rs1==x13, rs2==x30, rd==x10, rs2_h1_val == -33, 
// opcode: kmmawb ; op1:x13; op2:x30; dest:x10; op1val:0x20000000;  op2val:0xffdf0040
TEST_PKRR_OP(kmmawb, x10, x13, x30, 0x00000000, 0x20000000, 0xffdf0040, x13, x2, 104, x6)

inst_14:
// rs1==x17, rs2==x24, rd==x8, rs2_h1_val == -17, rs2_h0_val == -3
// opcode: kmmawb ; op1:x17; op2:x24; dest:x8; op1val:0xfffffffa;  op2val:0xffeffffd
TEST_PKRR_OP(kmmawb, x8, x17, x24, 0x00000000, 0xfffffffa, 0xffeffffd, x17, x2, 112, x6)

inst_15:
// rs1==x4, rs2==x6, rd==x17, rs2_h1_val == -9, rs2_h0_val == -4097, rs1_w0_val == -129
// opcode: kmmawb ; op1:x4; op2:x6; dest:x17; op1val:0xffffff7f;  op2val:0xfff7efff
TEST_PKRR_OP(kmmawb, x17, x4, x6, 0x00000000, 0xffffff7f, 0xfff7efff, x4, x2, 120, x9)
RVTEST_SIGBASE(x1,signature_x1_0)

inst_16:
// rs1==x26, rs2==x0, rd==x5, rs2_h1_val == -5, rs1_w0_val == -268435457
// opcode: kmmawb ; op1:x26; op2:x0; dest:x5; op1val:0xefffffff;  op2val:0xfffbfff9
TEST_PKRR_OP(kmmawb, x5, x26, x0, 0x00000000, 0xefffffff, 0xfffbfff9, x26, x1, 0, x9)

inst_17:
// rs1==x7, rs2==x12, rd==x21, rs2_h1_val == -3, rs1_w0_val == -8388609, rs2_h0_val == -9
// opcode: kmmawb ; op1:x7; op2:x12; dest:x21; op1val:0xff7fffff;  op2val:0xfffdfff7
TEST_PKRR_OP(kmmawb, x21, x7, x12, 0x00000000, 0xff7fffff, 0xfffdfff7, x7, x1, 8, x9)

inst_18:
// rs1==x6, rs2==x14, rd==x27, rs2_h1_val == -2, rs1_w0_val == -16777217
// opcode: kmmawb ; op1:x6; op2:x14; dest:x27; op1val:0xfeffffff;  op2val:0xfffe0009
TEST_PKRR_OP(kmmawb, x27, x6, x14, 0x00000000, 0xfeffffff, 0xfffe0009, x6, x1, 16, x9)

inst_19:
// rs1==x27, rs2==x17, rd==x20, rs2_h1_val == -32768, rs1_w0_val == 33554432
// opcode: kmmawb ; op1:x27; op2:x17; dest:x20; op1val:0x2000000;  op2val:0x8000c000
TEST_PKRR_OP(kmmawb, x20, x27, x17, 0x00000000, 0x2000000, 0x8000c000, x27, x1, 24, x9)

inst_20:
// rs1==x5, rs2==x18, rd==x23, rs2_h1_val == 8192, rs1_w0_val == -513, rs2_h0_val == 128
// opcode: kmmawb ; op1:x5; op2:x18; dest:x23; op1val:0xfffffdff;  op2val:0x20000080
TEST_PKRR_OP(kmmawb, x23, x5, x18, 0x00000000, 0xfffffdff, 0x20000080, x5, x1, 32, x9)

inst_21:
// rs1==x21, rs2==x23, rd==x25, rs2_h1_val == 4096, rs1_w0_val == 2048
// opcode: kmmawb ; op1:x21; op2:x23; dest:x25; op1val:0x000800;  op2val:0x10000002
TEST_PKRR_OP(kmmawb, x25, x21, x23, 0x00000000, 0x000800, 0x10000002, x21, x1, 40, x9)

inst_22:
// rs1==x11, rs2==x20, rd==x7, rs2_h1_val == 2048, rs1_w0_val == 16777216
// opcode: kmmawb ; op1:x11; op2:x20; dest:x7; op1val:0x1000000;  op2val:0x800aaaa
TEST_PKRR_OP(kmmawb, x7, x11, x20, 0x00000000, 0x1000000, 0x800aaaa, x11, x1, 48, x9)

inst_23:
// rs1==x8, rs2==x10, rd==x0, rs2_h1_val == 1024, 
// opcode: kmmawb ; op1:x8; op2:x10; dest:x0; op1val:0xefffffff;  op2val:0x400aaaa
TEST_PKRR_OP(kmmawb, x0, x8, x10, 0x00000000, 0xefffffff, 0x400aaaa, x8, x1, 56, x9)

inst_24:
// rs1==x20, rs2==x22, rd==x6, rs2_h1_val == 512, rs2_h0_val == -2049
// opcode: kmmawb ; op1:x20; op2:x22; dest:x6; op1val:0xfffffffb;  op2val:0x200f7ff
TEST_PKRR_OP(kmmawb, x6, x20, x22, 0x00000000, 0xfffffffb, 0x200f7ff, x20, x1, 64, x9)

inst_25:
// rs1==x22, rs2==x28, rd==x12, rs2_h1_val == 256, rs1_w0_val == -9
// opcode: kmmawb ; op1:x22; op2:x28; dest:x12; op1val:0xfffffff7;  op2val:0x1007fff
TEST_PKRR_OP(kmmawb, x12, x22, x28, 0x00000000, 0xfffffff7, 0x1007fff, x22, x1, 72, x9)

inst_26:
// rs1==x28, rs2==x7, rd==x2, rs2_h1_val == 128, 
// opcode: kmmawb ; op1:x28; op2:x7; dest:x2; op1val:0xfffffdff;  op2val:0x800080
TEST_PKRR_OP(kmmawb, x2, x28, x7, 0x00000000, 0xfffffdff, 0x800080, x28, x1, 80, x9)

inst_27:
// rs1==x2, rs2==x13, rd==x24, rs2_h1_val == 64, rs2_h0_val == 2048
// opcode: kmmawb ; op1:x2; op2:x13; dest:x24; op1val:0x7fffffff;  op2val:0x400800
TEST_PKRR_OP(kmmawb, x24, x2, x13, 0x00000000, 0x7fffffff, 0x400800, x2, x1, 88, x9)

inst_28:
// rs1==x14, rs2==x31, rd==x19, rs2_h1_val == 32, 
// opcode: kmmawb ; op1:x14; op2:x31; dest:x19; op1val:0xfffffffa;  op2val:0x200800
TEST_PKRR_OP(kmmawb, x19, x14, x31, 0x00000000, 0xfffffffa, 0x200800, x14, x1, 96, x9)

inst_29:
// rs1==x3, rs2==x21, rd==x11, rs2_h1_val == 16, rs2_h0_val == -1
// opcode: kmmawb ; op1:x3; op2:x21; dest:x11; op1val:0xfffffffb;  op2val:0x10ffff
TEST_PKRR_OP(kmmawb, x11, x3, x21, 0x00000000, 0xfffffffb, 0x10ffff, x3, x1, 104, x9)

inst_30:
// rs1==x29, rs2==x16, rd==x13, rs2_h1_val == 8, rs1_w0_val == 4194304
// opcode: kmmawb ; op1:x29; op2:x16; dest:x13; op1val:0x400000;  op2val:0x08ffff
TEST_PKRR_OP(kmmawb, x13, x29, x16, 0x00000000, 0x400000, 0x08ffff, x29, x1, 112, x9)

inst_31:
// rs1==x25, rs2==x2, rd==x18, rs2_h1_val == 4, rs1_w0_val == 1431655765
// opcode: kmmawb ; op1:x25; op2:x2; dest:x18; op1val:0x55555555;  op2val:0x04fff9
TEST_PKRR_OP(kmmawb, x18, x25, x2, 0x00000000, 0x55555555, 0x04fff9, x25, x1, 120, x3)

inst_32:
// rs2_h1_val == 2, rs1_w0_val == -1025, rs2_h0_val == 4
// opcode: kmmawb ; op1:x30; op2:x29; dest:x31; op1val:0xfffffbff;  op2val:0x020004
TEST_PKRR_OP(kmmawb, x31, x30, x29, 0x00000000, 0xfffffbff, 0x020004, x30, x1, 128, x3)
RVTEST_SIGBASE(x1,signature_x1_1)

inst_33:
// rs2_h1_val == 1, rs2_h0_val == 21845, rs1_w0_val == 1024
// opcode: kmmawb ; op1:x30; op2:x29; dest:x31; op1val:0x000400;  op2val:0x015555
TEST_PKRR_OP(kmmawb, x31, x30, x29, 0x00000000, 0x000400, 0x015555, x30, x1, 0, x3)

inst_34:
// rs2_h1_val == 0, rs1_w0_val == 1
// opcode: kmmawb ; op1:x30; op2:x29; dest:x31; op1val:0x000001;  op2val:0x005555
TEST_PKRR_OP(kmmawb, x31, x30, x29, 0x00000000, 0x000001, 0x005555, x30, x1, 8, x3)

inst_35:
// rs2_h1_val == -1, rs1_w0_val == -257
// opcode: kmmawb ; op1:x30; op2:x29; dest:x31; op1val:0xfffffeff;  op2val:0xffff8000
TEST_PKRR_OP(kmmawb, x31, x30, x29, 0x00000000, 0xfffffeff, 0xffff8000, x30, x1, 16, x3)

inst_36:
// rs1_w0_val == 512, rs2_h0_val == 0
// opcode: kmmawb ; op1:x30; op2:x29; dest:x31; op1val:0x000200;  op2val:0xf7ff0000
TEST_PKRR_OP(kmmawb, x31, x30, x29, 0x00000000, 0x000200, 0xf7ff0000, x30, x1, 24, x3)

inst_37:
// rs1_w0_val == 128, 
// opcode: kmmawb ; op1:x30; op2:x29; dest:x31; op1val:0x000080;  op2val:0x7fff0009
TEST_PKRR_OP(kmmawb, x31, x30, x29, 0x00000000, 0x000080, 0x7fff0009, x30, x1, 32, x3)

inst_38:
// rs1_w0_val == 64, 
// opcode: kmmawb ; op1:x30; op2:x29; dest:x31; op1val:0x000040;  op2val:0x02fffa
TEST_PKRR_OP(kmmawb, x31, x30, x29, 0x00000000, 0x000040, 0x02fffa, x30, x1, 40, x3)

inst_39:
// rs1_w0_val == 32, 
// opcode: kmmawb ; op1:x30; op2:x29; dest:x31; op1val:0x000020;  op2val:0xffeffff9
TEST_PKRR_OP(kmmawb, x31, x30, x29, 0x00000000, 0x000020, 0xffeffff9, x30, x1, 48, x3)

inst_40:
// rs1_w0_val == 16, 
// opcode: kmmawb ; op1:x30; op2:x29; dest:x31; op1val:0x000010;  op2val:0x065555
TEST_PKRR_OP(kmmawb, x31, x30, x29, 0x00000000, 0x000010, 0x065555, x30, x1, 56, x3)

inst_41:
// rs1_w0_val == 8, rs2_h0_val == -257
// opcode: kmmawb ; op1:x30; op2:x29; dest:x31; op1val:0x000008;  op2val:0x06feff
TEST_PKRR_OP(kmmawb, x31, x30, x29, 0x00000000, 0x000008, 0x06feff, x30, x1, 64, x3)

inst_42:
// rs1_w0_val == 4, 
// opcode: kmmawb ; op1:x30; op2:x29; dest:x31; op1val:0x000004;  op2val:0x8000fff8
TEST_PKRR_OP(kmmawb, x31, x30, x29, 0x00000000, 0x000004, 0x8000fff8, x30, x1, 72, x3)

inst_43:
// rs1_w0_val == 2, 
// opcode: kmmawb ; op1:x30; op2:x29; dest:x31; op1val:0x000002;  op2val:0xfeff2000
TEST_PKRR_OP(kmmawb, x31, x30, x29, 0x00000000, 0x000002, 0xfeff2000, x30, x1, 80, x3)

inst_44:
// rs2_h0_val == -16385, 
// opcode: kmmawb ; op1:x30; op2:x29; dest:x31; op1val:0xff7fffff;  op2val:0xfffdbfff
TEST_PKRR_OP(kmmawb, x31, x30, x29, 0x00000000, 0xff7fffff, 0xfffdbfff, x30, x1, 88, x3)

inst_45:
// rs2_h0_val == -8193, rs1_w0_val == 134217728
// opcode: kmmawb ; op1:x30; op2:x29; dest:x31; op1val:0x8000000;  op2val:0xaaaadfff
TEST_PKRR_OP(kmmawb, x31, x30, x29, 0x00000000, 0x8000000, 0xaaaadfff, x30, x1, 96, x3)

inst_46:
// rs2_h0_val == -1025, 
// opcode: kmmawb ; op1:x30; op2:x29; dest:x31; op1val:0xefffffff;  op2val:0xfefffbff
TEST_PKRR_OP(kmmawb, x31, x30, x29, 0x00000000, 0xefffffff, 0xfefffbff, x30, x1, 104, x3)

inst_47:
// rs2_h0_val == -513, 
// opcode: kmmawb ; op1:x30; op2:x29; dest:x31; op1val:0xfffffffd;  op2val:0xfffcfdff
TEST_PKRR_OP(kmmawb, x31, x30, x29, 0x00000000, 0xfffffffd, 0xfffcfdff, x30, x1, 112, x3)

inst_48:
// rs2_h0_val == -129, rs1_w0_val == 268435456
// opcode: kmmawb ; op1:x30; op2:x29; dest:x31; op1val:0x10000000;  op2val:0x4000ff7f
TEST_PKRR_OP(kmmawb, x31, x30, x29, 0x00000000, 0x10000000, 0x4000ff7f, x30, x1, 120, x3)

inst_49:
// rs2_h0_val == -65, 
// opcode: kmmawb ; op1:x30; op2:x29; dest:x31; op1val:0xfeffffff;  op2val:0xfeffffbf
TEST_PKRR_OP(kmmawb, x31, x30, x29, 0x00000000, 0xfeffffff, 0xfeffffbf, x30, x1, 128, x3)

inst_50:
// rs2_h0_val == -33, 
// opcode: kmmawb ; op1:x30; op2:x29; dest:x31; op1val:0xfffffffa;  op2val:0x200ffdf
TEST_PKRR_OP(kmmawb, x31, x30, x29, 0x00000000, 0xfffffffa, 0x200ffdf, x30, x1, 136, x3)

inst_51:
// rs2_h0_val == -17, 
// opcode: kmmawb ; op1:x30; op2:x29; dest:x31; op1val:0x000800;  op2val:0xbfffffef
TEST_PKRR_OP(kmmawb, x31, x30, x29, 0x00000000, 0x000800, 0xbfffffef, x30, x1, 144, x3)

inst_52:
// rs2_h0_val == -5, 
// opcode: kmmawb ; op1:x30; op2:x29; dest:x31; op1val:0xfffffffd;  op2val:0x08fffb
TEST_PKRR_OP(kmmawb, x31, x30, x29, 0x00000000, 0xfffffffd, 0x08fffb, x30, x1, 152, x3)

inst_53:
// rs2_h0_val == -2, rs1_w0_val == 67108864
// opcode: kmmawb ; op1:x30; op2:x29; dest:x31; op1val:0x4000000;  op2val:0xfffcfffe
TEST_PKRR_OP(kmmawb, x31, x30, x29, 0x00000000, 0x4000000, 0xfffcfffe, x30, x1, 160, x3)

inst_54:
// rs2_h0_val == 4096, rs1_w0_val == 524288
// opcode: kmmawb ; op1:x30; op2:x29; dest:x31; op1val:0x080000;  op2val:0xfeff1000
TEST_PKRR_OP(kmmawb, x31, x30, x29, 0x00000000, 0x080000, 0xfeff1000, x30, x1, 168, x3)

inst_55:
// rs2_h0_val == 1024, rs1_w0_val == -2049
// opcode: kmmawb ; op1:x30; op2:x29; dest:x31; op1val:0xfffff7ff;  op2val:0xfbff0400
TEST_PKRR_OP(kmmawb, x31, x30, x29, 0x00000000, 0xfffff7ff, 0xfbff0400, x30, x1, 176, x3)

inst_56:
// rs2_h0_val == 512, 
// opcode: kmmawb ; op1:x30; op2:x29; dest:x31; op1val:0x000004;  op2val:0xdfff0200
TEST_PKRR_OP(kmmawb, x31, x30, x29, 0x00000000, 0x000004, 0xdfff0200, x30, x1, 184, x3)

inst_57:
// rs2_h0_val == 256, rs1_w0_val == -524289
// opcode: kmmawb ; op1:x30; op2:x29; dest:x31; op1val:0xfff7ffff;  op2val:0xfeff0100
TEST_PKRR_OP(kmmawb, x31, x30, x29, 0x00000000, 0xfff7ffff, 0xfeff0100, x30, x1, 192, x3)

inst_58:
// rs2_h0_val == 32, 
// opcode: kmmawb ; op1:x30; op2:x29; dest:x31; op1val:0x000004;  op2val:0x000020
TEST_PKRR_OP(kmmawb, x31, x30, x29, 0x00000000, 0x000004, 0x000020, x30, x1, 200, x3)

inst_59:
// rs2_h0_val == 8, 
// opcode: kmmawb ; op1:x30; op2:x29; dest:x31; op1val:0x000200;  op2val:0xfffa0008
TEST_PKRR_OP(kmmawb, x31, x30, x29, 0x00000000, 0x000200, 0xfffa0008, x30, x1, 208, x3)

inst_60:
// rs2_h0_val == 1, 
// opcode: kmmawb ; op1:x30; op2:x29; dest:x31; op1val:0xfffffdff;  op2val:0xfeff0001
TEST_PKRR_OP(kmmawb, x31, x30, x29, 0x00000000, 0xfffffdff, 0xfeff0001, x30, x1, 216, x3)

inst_61:
// rs1_w0_val == -1431655766, 
// opcode: kmmawb ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaaa;  op2val:0x8000020
TEST_PKRR_OP(kmmawb, x31, x30, x29, 0x00000000, 0xaaaaaaaa, 0x8000020, x30, x1, 224, x3)

inst_62:
// rs1_w0_val == -1073741825, 
// opcode: kmmawb ; op1:x30; op2:x29; dest:x31; op1val:0xbfffffff;  op2val:0xbfff8000
TEST_PKRR_OP(kmmawb, x31, x30, x29, 0x00000000, 0xbfffffff, 0xbfff8000, x30, x1, 232, x3)

inst_63:
// rs1_w0_val == -536870913, 
// opcode: kmmawb ; op1:x30; op2:x29; dest:x31; op1val:0xdfffffff;  op2val:0x08fff7
TEST_PKRR_OP(kmmawb, x31, x30, x29, 0x00000000, 0xdfffffff, 0x08fff7, x30, x1, 240, x3)

inst_64:
// rs1_w0_val == -67108865, 
// opcode: kmmawb ; op1:x30; op2:x29; dest:x31; op1val:0xfbffffff;  op2val:0xff7f2000
TEST_PKRR_OP(kmmawb, x31, x30, x29, 0x00000000, 0xfbffffff, 0xff7f2000, x30, x1, 248, x3)

inst_65:
// rs1_w0_val == -33554433, 
// opcode: kmmawb ; op1:x30; op2:x29; dest:x31; op1val:0xfdffffff;  op2val:0x4000005
TEST_PKRR_OP(kmmawb, x31, x30, x29, 0x00000000, 0xfdffffff, 0x4000005, x30, x1, 256, x3)

inst_66:
// rs1_w0_val == -4194305, 
// opcode: kmmawb ; op1:x30; op2:x29; dest:x31; op1val:0xffbfffff;  op2val:0xfffffff8
TEST_PKRR_OP(kmmawb, x31, x30, x29, 0x00000000, 0xffbfffff, 0xfffffff8, x30, x1, 264, x3)

inst_67:
// rs1_w0_val == -2097153, 
// opcode: kmmawb ; op1:x30; op2:x29; dest:x31; op1val:0xffdfffff;  op2val:0xffeffff8
TEST_PKRR_OP(kmmawb, x31, x30, x29, 0x00000000, 0xffdfffff, 0xffeffff8, x30, x1, 272, x3)

inst_68:
// rs1_w0_val == -1048577, 
// opcode: kmmawb ; op1:x30; op2:x29; dest:x31; op1val:0xffefffff;  op2val:0x3fff0002
TEST_PKRR_OP(kmmawb, x31, x30, x29, 0x00000000, 0xffefffff, 0x3fff0002, x30, x1, 280, x3)

inst_69:
// rs1_w0_val == -262145, 
// opcode: kmmawb ; op1:x30; op2:x29; dest:x31; op1val:0xfffbffff;  op2val:0x400fffc
TEST_PKRR_OP(kmmawb, x31, x30, x29, 0x00000000, 0xfffbffff, 0x400fffc, x30, x1, 288, x3)

inst_70:
// rs1_w0_val == -131073, 
// opcode: kmmawb ; op1:x30; op2:x29; dest:x31; op1val:0xfffdffff;  op2val:0x051000
TEST_PKRR_OP(kmmawb, x31, x30, x29, 0x00000000, 0xfffdffff, 0x051000, x30, x1, 296, x3)

inst_71:
// rs1_w0_val == -65537, 
// opcode: kmmawb ; op1:x30; op2:x29; dest:x31; op1val:0xfffeffff;  op2val:0xfdfffeff
TEST_PKRR_OP(kmmawb, x31, x30, x29, 0x00000000, 0xfffeffff, 0xfdfffeff, x30, x1, 304, x3)

inst_72:
// rs1_w0_val == -32769, 
// opcode: kmmawb ; op1:x30; op2:x29; dest:x31; op1val:0xffff7fff;  op2val:0x050005
TEST_PKRR_OP(kmmawb, x31, x30, x29, 0x00000000, 0xffff7fff, 0x050005, x30, x1, 312, x3)

inst_73:
// rs1_w0_val == -16385, 
// opcode: kmmawb ; op1:x30; op2:x29; dest:x31; op1val:0xffffbfff;  op2val:0x04aaaa
TEST_PKRR_OP(kmmawb, x31, x30, x29, 0x00000000, 0xffffbfff, 0x04aaaa, x30, x1, 320, x3)

inst_74:
// rs1_w0_val == -33, 
// opcode: kmmawb ; op1:x30; op2:x29; dest:x31; op1val:0xffffffdf;  op2val:0xfff7aaaa
TEST_PKRR_OP(kmmawb, x31, x30, x29, 0x00000000, 0xffffffdf, 0xfff7aaaa, x30, x1, 328, x3)

inst_75:
// rs1_w0_val == -17, 
// opcode: kmmawb ; op1:x30; op2:x29; dest:x31; op1val:0xffffffef;  op2val:0xfffdffdf
TEST_PKRR_OP(kmmawb, x31, x30, x29, 0x00000000, 0xffffffef, 0xfffdffdf, x30, x1, 336, x3)

inst_76:
// rs1_w0_val == -2, 
// opcode: kmmawb ; op1:x30; op2:x29; dest:x31; op1val:0xfffffffe;  op2val:0xfffb0004
TEST_PKRR_OP(kmmawb, x31, x30, x29, 0x00000000, 0xfffffffe, 0xfffb0004, x30, x1, 344, x3)

inst_77:
// rs1_w0_val == 1073741824, 
// opcode: kmmawb ; op1:x30; op2:x29; dest:x31; op1val:0x40000000;  op2val:0x3ffffffc
TEST_PKRR_OP(kmmawb, x31, x30, x29, 0x00000000, 0x40000000, 0x3ffffffc, x30, x1, 352, x3)

inst_78:
// rs1_w0_val == 8388608, 
// opcode: kmmawb ; op1:x30; op2:x29; dest:x31; op1val:0x800000;  op2val:0x8003fff
TEST_PKRR_OP(kmmawb, x31, x30, x29, 0x00000000, 0x800000, 0x8003fff, x30, x1, 360, x3)

inst_79:
// rs1_w0_val == 2097152, 
// opcode: kmmawb ; op1:x30; op2:x29; dest:x31; op1val:0x200000;  op2val:0x8000efff
TEST_PKRR_OP(kmmawb, x31, x30, x29, 0x00000000, 0x200000, 0x8000efff, x30, x1, 368, x3)

inst_80:
// rs1_w0_val == 4096, 
// opcode: kmmawb ; op1:x30; op2:x29; dest:x31; op1val:0x001000;  op2val:0xfffa0002
TEST_PKRR_OP(kmmawb, x31, x30, x29, 0x00000000, 0x001000, 0xfffa0002, x30, x1, 376, x3)

inst_81:
// rs1_w0_val == 262144, 
// opcode: kmmawb ; op1:x30; op2:x29; dest:x31; op1val:0x040000;  op2val:0xfffcfffe
TEST_PKRR_OP(kmmawb, x31, x30, x29, 0x00000000, 0x040000, 0xfffcfffe, x30, x1, 384, x3)

inst_82:
// rs1_w0_val == 131072, 
// opcode: kmmawb ; op1:x30; op2:x29; dest:x31; op1val:0x020000;  op2val:0xefff0010
TEST_PKRR_OP(kmmawb, x31, x30, x29, 0x00000000, 0x020000, 0xefff0010, x30, x1, 392, x3)

inst_83:
// rs1_w0_val == 65536, 
// opcode: kmmawb ; op1:x30; op2:x29; dest:x31; op1val:0x010000;  op2val:0xfbff0800
TEST_PKRR_OP(kmmawb, x31, x30, x29, 0x00000000, 0x010000, 0xfbff0800, x30, x1, 400, x3)

inst_84:
// rs1_w0_val == 32768, 
// opcode: kmmawb ; op1:x30; op2:x29; dest:x31; op1val:0x008000;  op2val:0x8000fffc
TEST_PKRR_OP(kmmawb, x31, x30, x29, 0x00000000, 0x008000, 0x8000fffc, x30, x1, 408, x3)

inst_85:
// rs1_w0_val == 16384, 
// opcode: kmmawb ; op1:x30; op2:x29; dest:x31; op1val:0x004000;  op2val:0x00fffe
TEST_PKRR_OP(kmmawb, x31, x30, x29, 0x00000000, 0x004000, 0x00fffe, x30, x1, 416, x3)

inst_86:
// rs1_w0_val == 8192, 
// opcode: kmmawb ; op1:x30; op2:x29; dest:x31; op1val:0x002000;  op2val:0xffffffdf
TEST_PKRR_OP(kmmawb, x31, x30, x29, 0x00000000, 0x002000, 0xffffffdf, x30, x1, 424, x3)

inst_87:
// rs1_w0_val == -8193, 
// opcode: kmmawb ; op1:x30; op2:x29; dest:x31; op1val:0xffffdfff;  op2val:0x4000fffa
TEST_PKRR_OP(kmmawb, x31, x30, x29, 0x00000000, 0xffffdfff, 0x4000fffa, x30, x1, 432, x3)

inst_88:
// rs1_w0_val == -4097, 
// opcode: kmmawb ; op1:x30; op2:x29; dest:x31; op1val:0xffffefff;  op2val:0x1000040
TEST_PKRR_OP(kmmawb, x31, x30, x29, 0x00000000, 0xffffefff, 0x1000040, x30, x1, 440, x3)

inst_89:
// rs2_h1_val == 32767, rs1_w0_val == 0, rs2_h0_val == 2
// opcode: kmmawb ; op1:x30; op2:x29; dest:x31; op1val:0x000000;  op2val:0x7fff0002
TEST_PKRR_OP(kmmawb, x31, x30, x29, 0x00000000, 0x000000, 0x7fff0002, x30, x1, 448, x3)

inst_90:
// rs2_h1_val == -1025, rs1_w0_val == -134217729
// opcode: kmmawb ; op1:x30; op2:x29; dest:x31; op1val:0xf7ffffff;  op2val:0xfbfffff9
TEST_PKRR_OP(kmmawb, x31, x30, x29, 0x00000000, 0xf7ffffff, 0xfbfffff9, x30, x1, 456, x3)
#endif


RVTEST_CODE_END
RVMODEL_HALT

RVTEST_DATA_BEGIN
.align 4
rvtest_data:
.word 0xbabecafe
.word 0xabecafeb
.word 0xbecafeba
.word 0xecafebab
RVTEST_DATA_END

RVMODEL_DATA_BEGIN


signature_x2_0:
    .fill 0*(XLEN/32),4,0xdeadbeef


signature_x2_1:
    .fill 32*(XLEN/32),4,0xdeadbeef


signature_x1_0:
    .fill 34*(XLEN/32),4,0xdeadbeef


signature_x1_1:
    .fill 116*(XLEN/32),4,0xdeadbeef

#ifdef rvtest_mtrap_routine

mtrap_sigptr:
    .fill 64*(XLEN/32),4,0xdeadbeef

#endif

#ifdef rvtest_gpr_save

gpr_save:
    .fill 32*(XLEN/32),4,0xdeadbeef

#endif

RVMODEL_DATA_END
