
// -----------
// This file was generated by riscv_ctg (https://github.com/riscv-software-src/riscv-ctg)
// version   : 0.6.3
// timestamp : Sat Apr 23 14:53:29 2022 GMT
// usage     : riscv_ctg \
//                  --cgf /scratch/git-repo/github/riscv_ctg/sample_cgfs/dataset.cgf \
//                  --cgf /scratch/git-repo/github/riscv_ctg/sample_cgfs/rv32ip.cgf \
//                  --xlen 32  \
//                  --randomize \
// -----------
//
// -----------
// Copyright (c) 2020. RISC-V International. All rights reserved.
// SPDX-License-Identifier: BSD-3-Clause
// -----------
//
// This assembly file tests the kmmawb2 instruction of the RISC-V RV32PZicsr extension for the kmmawb2 covergroup.
// 
#include "model_test.h"
#include "arch_test.h"
RVTEST_ISA("RV32IPZicsr")

.section .text.init
.org 0x80
.globl rvtest_entry_point
rvtest_entry_point:
RVMODEL_BOOT
RVTEST_CODE_BEGIN

#ifdef TEST_CASE_1

RVTEST_CASE(0,"//check ISA:=regex(.*32.*);check ISA:=regex(.*I.*P.*Zicsr.*);def TEST_CASE_1=True;",kmmawb2)

RVTEST_VXSAT_ENABLE()
RVTEST_SIGBASE(x9,signature_x9_1)

inst_0:
// rs1 != rs2  and rs1 != rd and rs2 != rd, rs1==x13, rs2==x11, rd==x0, rs1_w0_val == -2147483648, rs2_h0_val == 2048, rs2_h1_val == -129
// opcode: kmmawb2 ; op1:x13; op2:x11; dest:x0; op1val:0x80000000;  op2val:0xff7f0800
TEST_PKRR_OP(kmmawb2, x0, x13, x11, 0x00000000, 0x80000000, 0xff7f0800, x13, x9, 0, x12)

inst_1:
// rs1 == rs2 != rd, rs1==x16, rs2==x16, rd==x26, rs2_h1_val == -21846, rs1_w0_val == 134217728
// opcode: kmmawb2 ; op1:x16; op2:x16; dest:x26; op1val:0x8000000;  op2val:0xaaaafff9
TEST_PKRR_OP(kmmawb2, x26, x16, x16, 0x00000000, 0x8000000, 0xaaaafff9, x16, x9, 8, x12)

inst_2:
// rs1 == rd != rs2, rs1==x21, rs2==x6, rd==x21, rs2_h1_val == 21845, rs2_h0_val == 16
// opcode: kmmawb2 ; op1:x21; op2:x6; dest:x21; op1val:0x000005;  op2val:0x55550010
TEST_PKRR_OP(kmmawb2, x21, x21, x6, 0x00000000, 0x000005, 0x55550010, x21, x9, 16, x12)

inst_3:
// rs1 == rs2 == rd, rs1==x14, rs2==x14, rd==x14, rs2_h1_val == 32767, rs2_h0_val == 2, rs1_w0_val == 2048
// opcode: kmmawb2 ; op1:x14; op2:x14; dest:x14; op1val:0x000800;  op2val:0x7fff0002
TEST_PKRR_OP(kmmawb2, x14, x14, x14, 0x00000000, 0x000800, 0x7fff0002, x14, x9, 24, x12)

inst_4:
// rs2 == rd != rs1, rs1==x22, rs2==x7, rd==x7, rs2_h1_val == -16385, rs1_w0_val == 2
// opcode: kmmawb2 ; op1:x22; op2:x7; dest:x7; op1val:0x000002;  op2val:0xbffffff8
TEST_PKRR_OP(kmmawb2, x7, x22, x7, 0x00000000, 0x000002, 0xbffffff8, x22, x9, 32, x12)

inst_5:
// rs1==x17, rs2==x27, rd==x1, rs2_h1_val == -8193, rs1_w0_val == -513
// opcode: kmmawb2 ; op1:x17; op2:x27; dest:x1; op1val:0xfffffdff;  op2val:0xdffffffc
TEST_PKRR_OP(kmmawb2, x1, x17, x27, 0x00000000, 0xfffffdff, 0xdffffffc, x17, x9, 40, x12)

inst_6:
// rs1==x20, rs2==x0, rd==x3, rs2_h1_val == -4097, rs1_w0_val == -4194305, rs2_h0_val == 21845
// opcode: kmmawb2 ; op1:x20; op2:x0; dest:x3; op1val:0xffbfffff;  op2val:0xefff5555
TEST_PKRR_OP(kmmawb2, x3, x20, x0, 0x00000000, 0xffbfffff, 0xefff5555, x20, x9, 48, x12)

inst_7:
// rs1==x10, rs2==x23, rd==x18, rs2_h1_val == -2049, rs1_w0_val == 2097152
// opcode: kmmawb2 ; op1:x10; op2:x23; dest:x18; op1val:0x200000;  op2val:0xf7fffff6
TEST_PKRR_OP(kmmawb2, x18, x10, x23, 0x00000000, 0x200000, 0xf7fffff6, x10, x9, 56, x12)

inst_8:
// rs1==x28, rs2==x29, rd==x5, rs2_h1_val == -1025, rs1_w0_val == 256
// opcode: kmmawb2 ; op1:x28; op2:x29; dest:x5; op1val:0x000100;  op2val:0xfbff0007
TEST_PKRR_OP(kmmawb2, x5, x28, x29, 0x00000000, 0x000100, 0xfbff0007, x28, x9, 64, x12)

inst_9:
// rs1==x19, rs2==x26, rd==x24, rs2_h1_val == -513, rs2_h0_val == -16385
// opcode: kmmawb2 ; op1:x19; op2:x26; dest:x24; op1val:0x200000;  op2val:0xfdffbfff
TEST_PKRR_OP(kmmawb2, x24, x19, x26, 0x00000000, 0x200000, 0xfdffbfff, x19, x9, 72, x12)

inst_10:
// rs1==x3, rs2==x25, rd==x31, rs2_h1_val == -257, rs1_w0_val == -32769, rs2_h0_val == 32767
// opcode: kmmawb2 ; op1:x3; op2:x25; dest:x31; op1val:0xffff7fff;  op2val:0xfeff7fff
TEST_PKRR_OP(kmmawb2, x31, x3, x25, 0x00000000, 0xffff7fff, 0xfeff7fff, x3, x9, 80, x12)

inst_11:
// rs1==x8, rs2==x17, rd==x28, rs2_h1_val == -65, rs1_w0_val == -262145, rs2_h0_val == 128
// opcode: kmmawb2 ; op1:x8; op2:x17; dest:x28; op1val:0xfffbffff;  op2val:0xffbf0080
TEST_PKRR_OP(kmmawb2, x28, x8, x17, 0x00000000, 0xfffbffff, 0xffbf0080, x8, x9, 88, x12)

inst_12:
// rs1==x24, rs2==x2, rd==x4, rs2_h1_val == -33, rs1_w0_val == -16777217, rs2_h0_val == 8
// opcode: kmmawb2 ; op1:x24; op2:x2; dest:x4; op1val:0xfeffffff;  op2val:0xffdf0008
TEST_PKRR_OP(kmmawb2, x4, x24, x2, 0x00000000, 0xfeffffff, 0xffdf0008, x24, x9, 96, x12)
RVTEST_SIGBASE(x14,signature_x14_0)

inst_13:
// rs1==x23, rs2==x22, rd==x10, rs2_h1_val == -17, rs1_w0_val == 33554432
// opcode: kmmawb2 ; op1:x23; op2:x22; dest:x10; op1val:0x2000000;  op2val:0xffeffff8
TEST_PKRR_OP(kmmawb2, x10, x23, x22, 0x00000000, 0x2000000, 0xffeffff8, x23, x14, 0, x5)

inst_14:
// rs1==x2, rs2==x28, rd==x6, rs2_h1_val == -9, 
// opcode: kmmawb2 ; op1:x2; op2:x28; dest:x6; op1val:0x000006;  op2val:0xfff7fffc
TEST_PKRR_OP(kmmawb2, x6, x2, x28, 0x00000000, 0x000006, 0xfff7fffc, x2, x14, 8, x5)

inst_15:
// rs1==x0, rs2==x24, rd==x22, rs2_h1_val == -5, rs1_w0_val == -33554433
// opcode: kmmawb2 ; op1:x0; op2:x24; dest:x22; op1val:0xfdffffff;  op2val:0xfffb0002
TEST_PKRR_OP(kmmawb2, x22, x0, x24, 0x00000000, 0xfdffffff, 0xfffb0002, x0, x14, 16, x5)

inst_16:
// rs1==x7, rs2==x8, rd==x23, rs2_h1_val == -3, rs2_h0_val == 32, rs1_w0_val == 8192
// opcode: kmmawb2 ; op1:x7; op2:x8; dest:x23; op1val:0x002000;  op2val:0xfffd0020
TEST_PKRR_OP(kmmawb2, x23, x7, x8, 0x00000000, 0x002000, 0xfffd0020, x7, x14, 24, x5)

inst_17:
// rs1==x12, rs2==x9, rd==x2, rs2_h1_val == -2, rs1_w0_val == 262144
// opcode: kmmawb2 ; op1:x12; op2:x9; dest:x2; op1val:0x040000;  op2val:0xfffe3fff
TEST_PKRR_OP(kmmawb2, x2, x12, x9, 0x00000000, 0x040000, 0xfffe3fff, x12, x14, 32, x5)

inst_18:
// rs1==x11, rs2==x31, rd==x29, rs2_h1_val == -32768, rs2_h0_val == 4
// opcode: kmmawb2 ; op1:x11; op2:x31; dest:x29; op1val:0x2000000;  op2val:0x80000004
TEST_PKRR_OP(kmmawb2, x29, x11, x31, 0x00000000, 0x2000000, 0x80000004, x11, x14, 40, x5)

inst_19:
// rs1==x4, rs2==x18, rd==x17, rs2_h1_val == 16384, rs1_w0_val == -2097153, rs2_h0_val == -2
// opcode: kmmawb2 ; op1:x4; op2:x18; dest:x17; op1val:0xffdfffff;  op2val:0x4000fffe
TEST_PKRR_OP(kmmawb2, x17, x4, x18, 0x00000000, 0xffdfffff, 0x4000fffe, x4, x14, 48, x5)

inst_20:
// rs1==x6, rs2==x30, rd==x27, rs2_h1_val == 8192, rs2_h0_val == -17, rs1_w0_val == -17
// opcode: kmmawb2 ; op1:x6; op2:x30; dest:x27; op1val:0xffffffef;  op2val:0x2000ffef
TEST_PKRR_OP(kmmawb2, x27, x6, x30, 0x00000000, 0xffffffef, 0x2000ffef, x6, x14, 56, x5)

inst_21:
// rs1==x26, rs2==x3, rd==x9, rs2_h1_val == 4096, rs2_h0_val == 64, rs1_w0_val == 4194304
// opcode: kmmawb2 ; op1:x26; op2:x3; dest:x9; op1val:0x400000;  op2val:0x10000040
TEST_PKRR_OP(kmmawb2, x9, x26, x3, 0x00000000, 0x400000, 0x10000040, x26, x14, 64, x5)

inst_22:
// rs1==x1, rs2==x13, rd==x20, rs2_h1_val == 2048, rs2_h0_val == 8192
// opcode: kmmawb2 ; op1:x1; op2:x13; dest:x20; op1val:0xffbfffff;  op2val:0x8002000
TEST_PKRR_OP(kmmawb2, x20, x1, x13, 0x00000000, 0xffbfffff, 0x8002000, x1, x14, 72, x5)

inst_23:
// rs1==x25, rs2==x10, rd==x30, rs2_h1_val == 1024, 
// opcode: kmmawb2 ; op1:x25; op2:x10; dest:x30; op1val:0xfffffdff;  op2val:0x400fff8
TEST_PKRR_OP(kmmawb2, x30, x25, x10, 0x00000000, 0xfffffdff, 0x400fff8, x25, x14, 80, x5)

inst_24:
// rs1==x27, rs2==x19, rd==x8, rs2_h1_val == 512, rs1_w0_val == 8
// opcode: kmmawb2 ; op1:x27; op2:x19; dest:x8; op1val:0x000008;  op2val:0x200fff6
TEST_PKRR_OP(kmmawb2, x8, x27, x19, 0x00000000, 0x000008, 0x200fff6, x27, x14, 88, x5)

inst_25:
// rs1==x5, rs2==x12, rd==x15, rs2_h1_val == 256, rs1_w0_val == 524288
// opcode: kmmawb2 ; op1:x5; op2:x12; dest:x15; op1val:0x080000;  op2val:0x1000007
TEST_PKRR_OP(kmmawb2, x15, x5, x12, 0x00000000, 0x080000, 0x1000007, x5, x14, 96, x3)
RVTEST_SIGBASE(x2,signature_x2_0)

inst_26:
// rs1==x15, rs2==x21, rd==x11, rs2_h1_val == 128, 
// opcode: kmmawb2 ; op1:x15; op2:x21; dest:x11; op1val:0xfffbffff;  op2val:0x80fff8
TEST_PKRR_OP(kmmawb2, x11, x15, x21, 0x00000000, 0xfffbffff, 0x80fff8, x15, x2, 0, x3)

inst_27:
// rs1==x9, rs2==x1, rd==x19, rs2_h1_val == 64, 
// opcode: kmmawb2 ; op1:x9; op2:x1; dest:x19; op1val:0x000007;  op2val:0x400007
TEST_PKRR_OP(kmmawb2, x19, x9, x1, 0x00000000, 0x000007, 0x400007, x9, x2, 8, x3)

inst_28:
// rs1==x29, rs2==x15, rd==x13, rs2_h1_val == 32, rs1_w0_val == -1073741825
// opcode: kmmawb2 ; op1:x29; op2:x15; dest:x13; op1val:0xbfffffff;  op2val:0x200009
TEST_PKRR_OP(kmmawb2, x13, x29, x15, 0x00000000, 0xbfffffff, 0x200009, x29, x2, 16, x3)

inst_29:
// rs1==x30, rs2==x20, rd==x16, rs2_h1_val == 16, rs1_w0_val == 1073741824, rs2_h0_val == 1
// opcode: kmmawb2 ; op1:x30; op2:x20; dest:x16; op1val:0x40000000;  op2val:0x100001
TEST_PKRR_OP(kmmawb2, x16, x30, x20, 0x00000000, 0x40000000, 0x100001, x30, x2, 24, x3)

inst_30:
// rs1==x31, rs2==x5, rd==x12, rs2_h1_val == 8, rs1_w0_val == -67108865, rs2_h0_val == -129
// opcode: kmmawb2 ; op1:x31; op2:x5; dest:x12; op1val:0xfbffffff;  op2val:0x08ff7f
TEST_PKRR_OP(kmmawb2, x12, x31, x5, 0x00000000, 0xfbffffff, 0x08ff7f, x31, x2, 32, x3)

inst_31:
// rs1==x18, rs2==x4, rd==x25, rs2_h1_val == 4, rs1_w0_val == 65536
// opcode: kmmawb2 ; op1:x18; op2:x4; dest:x25; op1val:0x010000;  op2val:0x04ff7f
TEST_PKRR_OP(kmmawb2, x25, x18, x4, 0x00000000, 0x010000, 0x04ff7f, x18, x2, 40, x3)

inst_32:
// rs2_h1_val == 2, rs1_w0_val == -2049
// opcode: kmmawb2 ; op1:x30; op2:x29; dest:x31; op1val:0xfffff7ff;  op2val:0x02fff6
TEST_PKRR_OP(kmmawb2, x31, x30, x29, 0x00000000, 0xfffff7ff, 0x02fff6, x30, x2, 48, x3)

inst_33:
// rs2_h1_val == 1, rs2_h0_val == 1024
// opcode: kmmawb2 ; op1:x30; op2:x29; dest:x31; op1val:0xbfffffff;  op2val:0x010400
TEST_PKRR_OP(kmmawb2, x31, x30, x29, 0x00000000, 0xbfffffff, 0x010400, x30, x2, 56, x3)

inst_34:
// rs2_h1_val == 0, rs1_w0_val == -524289
// opcode: kmmawb2 ; op1:x30; op2:x29; dest:x31; op1val:0xfff7ffff;  op2val:0x000004
TEST_PKRR_OP(kmmawb2, x31, x30, x29, 0x00000000, 0xfff7ffff, 0x000004, x30, x2, 64, x3)

inst_35:
// rs1_w0_val == 512, rs2_h0_val == -9
// opcode: kmmawb2 ; op1:x30; op2:x29; dest:x31; op1val:0x000200;  op2val:0x1000fff7
TEST_PKRR_OP(kmmawb2, x31, x30, x29, 0x00000000, 0x000200, 0x1000fff7, x30, x2, 72, x3)

inst_36:
// rs1_w0_val == 128, 
// opcode: kmmawb2 ; op1:x30; op2:x29; dest:x31; op1val:0x000080;  op2val:0x7ffffff9
TEST_PKRR_OP(kmmawb2, x31, x30, x29, 0x00000000, 0x000080, 0x7ffffff9, x30, x2, 80, x3)

inst_37:
// rs1_w0_val == 64, 
// opcode: kmmawb2 ; op1:x30; op2:x29; dest:x31; op1val:0x000040;  op2val:0xc0007fff
TEST_PKRR_OP(kmmawb2, x31, x30, x29, 0x00000000, 0x000040, 0xc0007fff, x30, x2, 88, x3)

inst_38:
// rs1_w0_val == 32, rs2_h0_val == -3
// opcode: kmmawb2 ; op1:x30; op2:x29; dest:x31; op1val:0x000020;  op2val:0xfffefffd
TEST_PKRR_OP(kmmawb2, x31, x30, x29, 0x00000000, 0x000020, 0xfffefffd, x30, x2, 96, x3)

inst_39:
// rs1_w0_val == 16, 
// opcode: kmmawb2 ; op1:x30; op2:x29; dest:x31; op1val:0x000010;  op2val:0xbfff0001
TEST_PKRR_OP(kmmawb2, x31, x30, x29, 0x00000000, 0x000010, 0xbfff0001, x30, x2, 104, x3)

inst_40:
// rs1_w0_val == 4, rs2_h0_val == 512
// opcode: kmmawb2 ; op1:x30; op2:x29; dest:x31; op1val:0x000004;  op2val:0xc0000200
TEST_PKRR_OP(kmmawb2, x31, x30, x29, 0x00000000, 0x000004, 0xc0000200, x30, x2, 112, x3)

inst_41:
// rs1_w0_val == 1, 
// opcode: kmmawb2 ; op1:x30; op2:x29; dest:x31; op1val:0x000001;  op2val:0x070007
TEST_PKRR_OP(kmmawb2, x31, x30, x29, 0x00000000, 0x000001, 0x070007, x30, x2, 120, x3)

inst_42:
// rs1_w0_val == 0, 
// opcode: kmmawb2 ; op1:x30; op2:x29; dest:x31; op1val:0x000000;  op2val:0xaaaa0002
TEST_PKRR_OP(kmmawb2, x31, x30, x29, 0x00000000, 0x000000, 0xaaaa0002, x30, x2, 128, x3)

inst_43:
// rs1_w0_val == -1, 
// opcode: kmmawb2 ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0xfdff0800
TEST_PKRR_OP(kmmawb2, x31, x30, x29, 0x00000000, 0xffffffff, 0xfdff0800, x30, x2, 136, x3)

inst_44:
// rs2_h1_val == -1, 
// opcode: kmmawb2 ; op1:x30; op2:x29; dest:x31; op1val:0xffff7fff;  op2val:0xfffffffa
TEST_PKRR_OP(kmmawb2, x31, x30, x29, 0x00000000, 0xffff7fff, 0xfffffffa, x30, x2, 144, x3)

inst_45:
// rs2_h0_val == -21846, 
// opcode: kmmawb2 ; op1:x30; op2:x29; dest:x31; op1val:0x3fffffff;  op2val:0x800aaaa
TEST_PKRR_OP(kmmawb2, x31, x30, x29, 0x00000000, 0x3fffffff, 0x800aaaa, x30, x2, 152, x3)

inst_46:
// rs2_h0_val == -8193, rs1_w0_val == 1431655765
// opcode: kmmawb2 ; op1:x30; op2:x29; dest:x31; op1val:0x55555555;  op2val:0xfff9dfff
TEST_PKRR_OP(kmmawb2, x31, x30, x29, 0x00000000, 0x55555555, 0xfff9dfff, x30, x2, 160, x3)

inst_47:
// rs2_h0_val == -4097, 
// opcode: kmmawb2 ; op1:x30; op2:x29; dest:x31; op1val:0x002000;  op2val:0x10efff
TEST_PKRR_OP(kmmawb2, x31, x30, x29, 0x00000000, 0x002000, 0x10efff, x30, x2, 168, x3)

inst_48:
// rs2_h0_val == -2049, 
// opcode: kmmawb2 ; op1:x30; op2:x29; dest:x31; op1val:0x000100;  op2val:0xfff6f7ff
TEST_PKRR_OP(kmmawb2, x31, x30, x29, 0x00000000, 0x000100, 0xfff6f7ff, x30, x2, 176, x3)

inst_49:
// rs2_h0_val == -1025, 
// opcode: kmmawb2 ; op1:x30; op2:x29; dest:x31; op1val:0x000800;  op2val:0x02fbff
TEST_PKRR_OP(kmmawb2, x31, x30, x29, 0x00000000, 0x000800, 0x02fbff, x30, x2, 184, x3)

inst_50:
// rs2_h0_val == -513, 
// opcode: kmmawb2 ; op1:x30; op2:x29; dest:x31; op1val:0x40000000;  op2val:0x5555fdff
TEST_PKRR_OP(kmmawb2, x31, x30, x29, 0x00000000, 0x40000000, 0x5555fdff, x30, x2, 192, x3)

inst_51:
// rs2_h0_val == -257, 
// opcode: kmmawb2 ; op1:x30; op2:x29; dest:x31; op1val:0x200000;  op2val:0x800feff
TEST_PKRR_OP(kmmawb2, x31, x30, x29, 0x00000000, 0x200000, 0x800feff, x30, x2, 200, x3)

inst_52:
// rs2_h0_val == -65, 
// opcode: kmmawb2 ; op1:x30; op2:x29; dest:x31; op1val:0xffffffef;  op2val:0x800ffbf
TEST_PKRR_OP(kmmawb2, x31, x30, x29, 0x00000000, 0xffffffef, 0x800ffbf, x30, x2, 208, x3)

inst_53:
// rs2_h0_val == -33, 
// opcode: kmmawb2 ; op1:x30; op2:x29; dest:x31; op1val:0xfffffff9;  op2val:0x04ffdf
TEST_PKRR_OP(kmmawb2, x31, x30, x29, 0x00000000, 0xfffffff9, 0x04ffdf, x30, x2, 216, x3)

inst_54:
// rs2_h0_val == -5, 
// opcode: kmmawb2 ; op1:x30; op2:x29; dest:x31; op1val:0x000080;  op2val:0xc000fffb
TEST_PKRR_OP(kmmawb2, x31, x30, x29, 0x00000000, 0x000080, 0xc000fffb, x30, x2, 224, x3)

inst_55:
// rs2_h0_val == -32768, 
// opcode: kmmawb2 ; op1:x30; op2:x29; dest:x31; op1val:0x040000;  op2val:0x408000
TEST_PKRR_OP(kmmawb2, x31, x30, x29, 0x00000000, 0x040000, 0x408000, x30, x2, 232, x3)

inst_56:
// rs2_h0_val == 16384, rs1_w0_val == 67108864
// opcode: kmmawb2 ; op1:x30; op2:x29; dest:x31; op1val:0x4000000;  op2val:0xaaaa4000
TEST_PKRR_OP(kmmawb2, x31, x30, x29, 0x00000000, 0x4000000, 0xaaaa4000, x30, x2, 240, x3)

inst_57:
// rs2_h0_val == 4096, 
// opcode: kmmawb2 ; op1:x30; op2:x29; dest:x31; op1val:0x000005;  op2val:0x2001000
TEST_PKRR_OP(kmmawb2, x31, x30, x29, 0x00000000, 0x000005, 0x2001000, x30, x2, 248, x3)

inst_58:
// rs2_h0_val == 256, 
// opcode: kmmawb2 ; op1:x30; op2:x29; dest:x31; op1val:0xfffffdff;  op2val:0xffbf0100
TEST_PKRR_OP(kmmawb2, x31, x30, x29, 0x00000000, 0xfffffdff, 0xffbf0100, x30, x2, 256, x3)

inst_59:
// rs2_h0_val == 0, 
// opcode: kmmawb2 ; op1:x30; op2:x29; dest:x31; op1val:0x040000;  op2val:0x800000
TEST_PKRR_OP(kmmawb2, x31, x30, x29, 0x00000000, 0x040000, 0x800000, x30, x2, 264, x3)

inst_60:
// rs2_h0_val == -1, 
// opcode: kmmawb2 ; op1:x30; op2:x29; dest:x31; op1val:0x000001;  op2val:0x2000ffff
TEST_PKRR_OP(kmmawb2, x31, x30, x29, 0x00000000, 0x000001, 0x2000ffff, x30, x2, 272, x3)

inst_61:
// rs1_w0_val == -1431655766, 
// opcode: kmmawb2 ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaaa;  op2val:0xffbffeff
TEST_PKRR_OP(kmmawb2, x31, x30, x29, 0x00000000, 0xaaaaaaaa, 0xffbffeff, x30, x2, 280, x3)

inst_62:
// rs1_w0_val == 2147483647, 
// opcode: kmmawb2 ; op1:x30; op2:x29; dest:x31; op1val:0x7fffffff;  op2val:0xfffdfffb
TEST_PKRR_OP(kmmawb2, x31, x30, x29, 0x00000000, 0x7fffffff, 0xfffdfffb, x30, x2, 288, x3)

inst_63:
// rs1_w0_val == -536870913, 
// opcode: kmmawb2 ; op1:x30; op2:x29; dest:x31; op1val:0xdfffffff;  op2val:0x20004000
TEST_PKRR_OP(kmmawb2, x31, x30, x29, 0x00000000, 0xdfffffff, 0x20004000, x30, x2, 296, x3)

inst_64:
// rs1_w0_val == -268435457, 
// opcode: kmmawb2 ; op1:x30; op2:x29; dest:x31; op1val:0xefffffff;  op2val:0x800c000
TEST_PKRR_OP(kmmawb2, x31, x30, x29, 0x00000000, 0xefffffff, 0x800c000, x30, x2, 304, x3)

inst_65:
// rs1_w0_val == -134217729, 
// opcode: kmmawb2 ; op1:x30; op2:x29; dest:x31; op1val:0xf7ffffff;  op2val:0xfbff0008
TEST_PKRR_OP(kmmawb2, x31, x30, x29, 0x00000000, 0xf7ffffff, 0xfbff0008, x30, x2, 312, x3)

inst_66:
// rs1_w0_val == -8388609, 
// opcode: kmmawb2 ; op1:x30; op2:x29; dest:x31; op1val:0xff7fffff;  op2val:0xfff6ffff
TEST_PKRR_OP(kmmawb2, x31, x30, x29, 0x00000000, 0xff7fffff, 0xfff6ffff, x30, x2, 320, x3)

inst_67:
// rs1_w0_val == -1048577, 
// opcode: kmmawb2 ; op1:x30; op2:x29; dest:x31; op1val:0xffefffff;  op2val:0x050007
TEST_PKRR_OP(kmmawb2, x31, x30, x29, 0x00000000, 0xffefffff, 0x050007, x30, x2, 328, x3)

inst_68:
// rs1_w0_val == -131073, 
// opcode: kmmawb2 ; op1:x30; op2:x29; dest:x31; op1val:0xfffdffff;  op2val:0x100fff8
TEST_PKRR_OP(kmmawb2, x31, x30, x29, 0x00000000, 0xfffdffff, 0x100fff8, x30, x2, 336, x3)

inst_69:
// rs1_w0_val == -65537, 
// opcode: kmmawb2 ; op1:x30; op2:x29; dest:x31; op1val:0xfffeffff;  op2val:0x050400
TEST_PKRR_OP(kmmawb2, x31, x30, x29, 0x00000000, 0xfffeffff, 0x050400, x30, x2, 344, x3)

inst_70:
// rs1_w0_val == -16385, 
// opcode: kmmawb2 ; op1:x30; op2:x29; dest:x31; op1val:0xffffbfff;  op2val:0x030005
TEST_PKRR_OP(kmmawb2, x31, x30, x29, 0x00000000, 0xffffbfff, 0x030005, x30, x2, 352, x3)

inst_71:
// rs1_w0_val == -8193, 
// opcode: kmmawb2 ; op1:x30; op2:x29; dest:x31; op1val:0xffffdfff;  op2val:0x03dfff
TEST_PKRR_OP(kmmawb2, x31, x30, x29, 0x00000000, 0xffffdfff, 0x03dfff, x30, x2, 360, x3)

inst_72:
// rs1_w0_val == -4097, 
// opcode: kmmawb2 ; op1:x30; op2:x29; dest:x31; op1val:0xffffefff;  op2val:0xfffadfff
TEST_PKRR_OP(kmmawb2, x31, x30, x29, 0x00000000, 0xffffefff, 0xfffadfff, x30, x2, 368, x3)

inst_73:
// rs1_w0_val == -1025, 
// opcode: kmmawb2 ; op1:x30; op2:x29; dest:x31; op1val:0xfffffbff;  op2val:0xffff0000
TEST_PKRR_OP(kmmawb2, x31, x30, x29, 0x00000000, 0xfffffbff, 0xffff0000, x30, x2, 376, x3)

inst_74:
// rs1_w0_val == -257, 
// opcode: kmmawb2 ; op1:x30; op2:x29; dest:x31; op1val:0xfffffeff;  op2val:0xc000aaaa
TEST_PKRR_OP(kmmawb2, x31, x30, x29, 0x00000000, 0xfffffeff, 0xc000aaaa, x30, x2, 384, x3)

inst_75:
// rs1_w0_val == -129, 
// opcode: kmmawb2 ; op1:x30; op2:x29; dest:x31; op1val:0xffffff7f;  op2val:0x80001000
TEST_PKRR_OP(kmmawb2, x31, x30, x29, 0x00000000, 0xffffff7f, 0x80001000, x30, x2, 392, x3)

inst_76:
// rs1_w0_val == -65, 
// opcode: kmmawb2 ; op1:x30; op2:x29; dest:x31; op1val:0xffffffbf;  op2val:0x1000ff7f
TEST_PKRR_OP(kmmawb2, x31, x30, x29, 0x00000000, 0xffffffbf, 0x1000ff7f, x30, x2, 400, x3)

inst_77:
// rs1_w0_val == -33, 
// opcode: kmmawb2 ; op1:x30; op2:x29; dest:x31; op1val:0xffffffdf;  op2val:0xfff80002
TEST_PKRR_OP(kmmawb2, x31, x30, x29, 0x00000000, 0xffffffdf, 0xfff80002, x30, x2, 408, x3)

inst_78:
// rs1_w0_val == -9, 
// opcode: kmmawb2 ; op1:x30; op2:x29; dest:x31; op1val:0xfffffff7;  op2val:0x5555f7ff
TEST_PKRR_OP(kmmawb2, x31, x30, x29, 0x00000000, 0xfffffff7, 0x5555f7ff, x30, x2, 416, x3)

inst_79:
// rs1_w0_val == -5, 
// opcode: kmmawb2 ; op1:x30; op2:x29; dest:x31; op1val:0xfffffffb;  op2val:0x030000
TEST_PKRR_OP(kmmawb2, x31, x30, x29, 0x00000000, 0xfffffffb, 0x030000, x30, x2, 424, x3)

inst_80:
// rs1_w0_val == -3, 
// opcode: kmmawb2 ; op1:x30; op2:x29; dest:x31; op1val:0xfffffffd;  op2val:0x070200
TEST_PKRR_OP(kmmawb2, x31, x30, x29, 0x00000000, 0xfffffffd, 0x070200, x30, x2, 432, x3)

inst_81:
// rs1_w0_val == -2, 
// opcode: kmmawb2 ; op1:x30; op2:x29; dest:x31; op1val:0xfffffffe;  op2val:0xfffbfffe
TEST_PKRR_OP(kmmawb2, x31, x30, x29, 0x00000000, 0xfffffffe, 0xfffbfffe, x30, x2, 440, x3)

inst_82:
// rs1_w0_val == 536870912, 
// opcode: kmmawb2 ; op1:x30; op2:x29; dest:x31; op1val:0x20000000;  op2val:0x200100
TEST_PKRR_OP(kmmawb2, x31, x30, x29, 0x00000000, 0x20000000, 0x200100, x30, x2, 448, x3)

inst_83:
// rs1_w0_val == 268435456, 
// opcode: kmmawb2 ; op1:x30; op2:x29; dest:x31; op1val:0x10000000;  op2val:0x025555
TEST_PKRR_OP(kmmawb2, x31, x30, x29, 0x00000000, 0x10000000, 0x025555, x30, x2, 456, x3)

inst_84:
// rs1_w0_val == 16777216, 
// opcode: kmmawb2 ; op1:x30; op2:x29; dest:x31; op1val:0x1000000;  op2val:0xfff8ffff
TEST_PKRR_OP(kmmawb2, x31, x30, x29, 0x00000000, 0x1000000, 0xfff8ffff, x30, x2, 464, x3)

inst_85:
// rs1_w0_val == 8388608, 
// opcode: kmmawb2 ; op1:x30; op2:x29; dest:x31; op1val:0x800000;  op2val:0x4000f7ff
TEST_PKRR_OP(kmmawb2, x31, x30, x29, 0x00000000, 0x800000, 0x4000f7ff, x30, x2, 472, x3)

inst_86:
// rs1_w0_val == 1048576, 
// opcode: kmmawb2 ; op1:x30; op2:x29; dest:x31; op1val:0x100000;  op2val:0x4000003
TEST_PKRR_OP(kmmawb2, x31, x30, x29, 0x00000000, 0x100000, 0x4000003, x30, x2, 480, x3)

inst_87:
// rs1_w0_val == 131072, 
// opcode: kmmawb2 ; op1:x30; op2:x29; dest:x31; op1val:0x020000;  op2val:0x2000fffb
TEST_PKRR_OP(kmmawb2, x31, x30, x29, 0x00000000, 0x020000, 0x2000fffb, x30, x2, 488, x3)

inst_88:
// rs1_w0_val == 32768, 
// opcode: kmmawb2 ; op1:x30; op2:x29; dest:x31; op1val:0x008000;  op2val:0x7fffffef
TEST_PKRR_OP(kmmawb2, x31, x30, x29, 0x00000000, 0x008000, 0x7fffffef, x30, x2, 496, x3)

inst_89:
// rs1_w0_val == 16384, 
// opcode: kmmawb2 ; op1:x30; op2:x29; dest:x31; op1val:0x004000;  op2val:0x06efff
TEST_PKRR_OP(kmmawb2, x31, x30, x29, 0x00000000, 0x004000, 0x06efff, x30, x2, 504, x3)

inst_90:
// rs1_w0_val == 4096, 
// opcode: kmmawb2 ; op1:x30; op2:x29; dest:x31; op1val:0x001000;  op2val:0xfffa1000
TEST_PKRR_OP(kmmawb2, x31, x30, x29, 0x00000000, 0x001000, 0xfffa1000, x30, x2, 512, x3)

inst_91:
// rs1_w0_val == 1024, 
// opcode: kmmawb2 ; op1:x30; op2:x29; dest:x31; op1val:0x000400;  op2val:0xfff9f7ff
TEST_PKRR_OP(kmmawb2, x31, x30, x29, 0x00000000, 0x000400, 0xfff9f7ff, x30, x2, 520, x3)

inst_92:
// rs1_w0_val == -2147483648, rs2_h0_val == 2048, rs2_h1_val == -129
// opcode: kmmawb2 ; op1:x30; op2:x29; dest:x31; op1val:0x80000000;  op2val:0xff7f0800
TEST_PKRR_OP(kmmawb2, x31, x30, x29, 0x00000000, 0x80000000, 0xff7f0800, x30, x2, 528, x3)

inst_93:
// rs2_h1_val == -21846, rs1_w0_val == 134217728
// opcode: kmmawb2 ; op1:x30; op2:x29; dest:x31; op1val:0x8000000;  op2val:0xaaaafff9
TEST_PKRR_OP(kmmawb2, x31, x30, x29, 0x00000000, 0x8000000, 0xaaaafff9, x30, x2, 536, x3)

inst_94:
// rs2_h1_val == -4097, rs1_w0_val == -4194305, rs2_h0_val == 21845
// opcode: kmmawb2 ; op1:x30; op2:x29; dest:x31; op1val:0xffbfffff;  op2val:0xefff5555
TEST_PKRR_OP(kmmawb2, x31, x30, x29, 0x00000000, 0xffbfffff, 0xefff5555, x30, x2, 544, x3)

inst_95:
// rs2_h1_val == -5, rs1_w0_val == -33554433
// opcode: kmmawb2 ; op1:x30; op2:x29; dest:x31; op1val:0xfdffffff;  op2val:0xfffb0002
TEST_PKRR_OP(kmmawb2, x31, x30, x29, 0x00000000, 0xfdffffff, 0xfffb0002, x30, x2, 552, x3)
#endif


RVTEST_CODE_END
RVMODEL_HALT

RVTEST_DATA_BEGIN
.align 4
rvtest_data:
.word 0xbabecafe
.word 0xabecafeb
.word 0xbecafeba
.word 0xecafebab
RVTEST_DATA_END

RVMODEL_DATA_BEGIN


signature_x9_0:
    .fill 0*(XLEN/32),4,0xdeadbeef


signature_x9_1:
    .fill 26*(XLEN/32),4,0xdeadbeef


signature_x14_0:
    .fill 26*(XLEN/32),4,0xdeadbeef


signature_x2_0:
    .fill 140*(XLEN/32),4,0xdeadbeef

#ifdef rvtest_mtrap_routine

mtrap_sigptr:
    .fill 64*(XLEN/32),4,0xdeadbeef

#endif

#ifdef rvtest_gpr_save

gpr_save:
    .fill 32*(XLEN/32),4,0xdeadbeef

#endif

RVMODEL_DATA_END
