
// -----------
// This file was generated by riscv_ctg (https://github.com/riscv-software-src/riscv-ctg)
// version   : 0.6.3
// timestamp : Sat Apr 23 14:53:29 2022 GMT
// usage     : riscv_ctg \
//                  --cgf /scratch/git-repo/github/riscv_ctg/sample_cgfs/dataset.cgf \
//                  --cgf /scratch/git-repo/github/riscv_ctg/sample_cgfs/rv32ip.cgf \
//                  --xlen 32  \
//                  --randomize \
// -----------
//
// -----------
// Copyright (c) 2020. RISC-V International. All rights reserved.
// SPDX-License-Identifier: BSD-3-Clause
// -----------
//
// This assembly file tests the kmmawb2.u instruction of the RISC-V RV32PZicsr extension for the kmmawb2.u covergroup.
// 
#include "model_test.h"
#include "arch_test.h"
RVTEST_ISA("RV32IPZicsr")

.section .text.init
.org 0x80
.globl rvtest_entry_point
rvtest_entry_point:
RVMODEL_BOOT
RVTEST_CODE_BEGIN

#ifdef TEST_CASE_1

RVTEST_CASE(0,"//check ISA:=regex(.*32.*);check ISA:=regex(.*I.*P.*Zicsr.*);def TEST_CASE_1=True;",kmmawb2.u)

RVTEST_VXSAT_ENABLE()
RVTEST_SIGBASE(x11,signature_x11_1)

inst_0:
// rs1 != rs2  and rs1 != rd and rs2 != rd, rs1==x3, rs2==x29, rd==x9, rs1_w0_val == -2147483648, rs2_h0_val == -8193
// opcode: kmmawb2.u ; op1:x3; op2:x29; dest:x9; op1val:0x80000000;  op2val:0x06dfff
TEST_PKRR_OP(kmmawb2.u, x9, x3, x29, 0x00000000, 0x80000000, 0x06dfff, x3, x11, 0, x14)

inst_1:
// rs1 == rs2 != rd, rs1==x21, rs2==x21, rd==x13, rs2_h1_val == -21846, rs1_w0_val == 8, rs2_h0_val == 256
// opcode: kmmawb2.u ; op1:x21; op2:x21; dest:x13; op1val:0x000008;  op2val:0xaaaa0100
TEST_PKRR_OP(kmmawb2.u, x13, x21, x21, 0x00000000, 0x000008, 0xaaaa0100, x21, x11, 8, x14)

inst_2:
// rs1 == rd != rs2, rs1==x28, rs2==x10, rd==x28, rs2_h1_val == 21845, rs1_w0_val == -3, rs2_h0_val == -32768
// opcode: kmmawb2.u ; op1:x28; op2:x10; dest:x28; op1val:0xfffffffd;  op2val:0x55558000
TEST_PKRR_OP(kmmawb2.u, x28, x28, x10, 0x00000000, 0xfffffffd, 0x55558000, x28, x11, 16, x14)

inst_3:
// rs1 == rs2 == rd, rs1==x4, rs2==x4, rd==x4, rs2_h1_val == 32767, rs1_w0_val == 1431655765, rs2_h0_val == -5
// opcode: kmmawb2.u ; op1:x4; op2:x4; dest:x4; op1val:0x55555555;  op2val:0x7ffffffb
TEST_PKRR_OP(kmmawb2.u, x4, x4, x4, 0x00000000, 0x55555555, 0x7ffffffb, x4, x11, 24, x14)

inst_4:
// rs2 == rd != rs1, rs1==x9, rs2==x30, rd==x30, rs2_h1_val == -16385, rs2_h0_val == -17
// opcode: kmmawb2.u ; op1:x9; op2:x30; dest:x30; op1val:0x000003;  op2val:0xbfffffef
TEST_PKRR_OP(kmmawb2.u, x30, x9, x30, 0x00000000, 0x000003, 0xbfffffef, x9, x11, 32, x14)

inst_5:
// rs1==x17, rs2==x12, rd==x23, rs2_h1_val == -8193, rs1_w0_val == 262144
// opcode: kmmawb2.u ; op1:x17; op2:x12; dest:x23; op1val:0x040000;  op2val:0xdfff0009
TEST_PKRR_OP(kmmawb2.u, x23, x17, x12, 0x00000000, 0x040000, 0xdfff0009, x17, x11, 40, x14)

inst_6:
// rs1==x19, rs2==x25, rd==x12, rs2_h1_val == -4097, rs2_h0_val == 64, rs1_w0_val == -134217729
// opcode: kmmawb2.u ; op1:x19; op2:x25; dest:x12; op1val:0xf7ffffff;  op2val:0xefff0040
TEST_PKRR_OP(kmmawb2.u, x12, x19, x25, 0x00000000, 0xf7ffffff, 0xefff0040, x19, x11, 48, x14)

inst_7:
// rs1==x30, rs2==x19, rd==x3, rs2_h1_val == -2049, rs1_w0_val == -1048577, rs2_h0_val == -129
// opcode: kmmawb2.u ; op1:x30; op2:x19; dest:x3; op1val:0xffefffff;  op2val:0xf7ffff7f
TEST_PKRR_OP(kmmawb2.u, x3, x30, x19, 0x00000000, 0xffefffff, 0xf7ffff7f, x30, x11, 56, x14)

inst_8:
// rs1==x7, rs2==x17, rd==x25, rs2_h1_val == -1025, rs2_h0_val == -65, rs1_w0_val == 536870912
// opcode: kmmawb2.u ; op1:x7; op2:x17; dest:x25; op1val:0x20000000;  op2val:0xfbffffbf
TEST_PKRR_OP(kmmawb2.u, x25, x7, x17, 0x00000000, 0x20000000, 0xfbffffbf, x7, x11, 64, x14)

inst_9:
// rs1==x23, rs2==x31, rd==x21, rs2_h1_val == -513, rs1_w0_val == 64
// opcode: kmmawb2.u ; op1:x23; op2:x31; dest:x21; op1val:0x000040;  op2val:0xfdff0007
TEST_PKRR_OP(kmmawb2.u, x21, x23, x31, 0x00000000, 0x000040, 0xfdff0007, x23, x11, 72, x14)

inst_10:
// rs1==x13, rs2==x23, rd==x18, rs2_h1_val == -257, rs2_h0_val == 8192, rs1_w0_val == 16
// opcode: kmmawb2.u ; op1:x13; op2:x23; dest:x18; op1val:0x000010;  op2val:0xfeff2000
TEST_PKRR_OP(kmmawb2.u, x18, x13, x23, 0x00000000, 0x000010, 0xfeff2000, x13, x11, 80, x14)

inst_11:
// rs1==x12, rs2==x22, rd==x19, rs2_h1_val == -129, rs1_w0_val == 1048576, rs2_h0_val == -257
// opcode: kmmawb2.u ; op1:x12; op2:x22; dest:x19; op1val:0x100000;  op2val:0xff7ffeff
TEST_PKRR_OP(kmmawb2.u, x19, x12, x22, 0x00000000, 0x100000, 0xff7ffeff, x12, x11, 88, x14)

inst_12:
// rs1==x2, rs2==x18, rd==x5, rs2_h1_val == -65, rs2_h0_val == -21846
// opcode: kmmawb2.u ; op1:x2; op2:x18; dest:x5; op1val:0x000006;  op2val:0xffbfaaaa
TEST_PKRR_OP(kmmawb2.u, x5, x2, x18, 0x00000000, 0x000006, 0xffbfaaaa, x2, x11, 96, x14)

inst_13:
// rs1==x27, rs2==x24, rd==x29, rs2_h1_val == -33, 
// opcode: kmmawb2.u ; op1:x27; op2:x24; dest:x29; op1val:0x000005;  op2val:0xffdf2000
TEST_PKRR_OP(kmmawb2.u, x29, x27, x24, 0x00000000, 0x000005, 0xffdf2000, x27, x11, 104, x14)

inst_14:
// rs1==x10, rs2==x5, rd==x17, rs2_h1_val == -17, rs1_w0_val == 134217728
// opcode: kmmawb2.u ; op1:x10; op2:x5; dest:x17; op1val:0x8000000;  op2val:0xffeffffc
TEST_PKRR_OP(kmmawb2.u, x17, x10, x5, 0x00000000, 0x8000000, 0xffeffffc, x10, x11, 112, x14)

inst_15:
// rs1==x5, rs2==x26, rd==x10, rs2_h1_val == -9, rs2_h0_val == 4096
// opcode: kmmawb2.u ; op1:x5; op2:x26; dest:x10; op1val:0x55555555;  op2val:0xfff71000
TEST_PKRR_OP(kmmawb2.u, x10, x5, x26, 0x00000000, 0x55555555, 0xfff71000, x5, x11, 120, x14)

inst_16:
// rs1==x6, rs2==x28, rd==x22, rs2_h1_val == -5, rs2_h0_val == -16385, rs1_w0_val == -33
// opcode: kmmawb2.u ; op1:x6; op2:x28; dest:x22; op1val:0xffffffdf;  op2val:0xfffbbfff
TEST_PKRR_OP(kmmawb2.u, x22, x6, x28, 0x00000000, 0xffffffdf, 0xfffbbfff, x6, x11, 128, x14)

inst_17:
// rs1==x24, rs2==x0, rd==x6, rs2_h1_val == -3, rs1_w0_val == -65537
// opcode: kmmawb2.u ; op1:x24; op2:x0; dest:x6; op1val:0xfffeffff;  op2val:0xfffdc000
TEST_PKRR_OP(kmmawb2.u, x6, x24, x0, 0x00000000, 0xfffeffff, 0xfffdc000, x24, x11, 136, x14)

inst_18:
// rs1==x25, rs2==x8, rd==x31, rs2_h1_val == -2, rs1_w0_val == -1025
// opcode: kmmawb2.u ; op1:x25; op2:x8; dest:x31; op1val:0xfffffbff;  op2val:0xfffe0007
TEST_PKRR_OP(kmmawb2.u, x31, x25, x8, 0x00000000, 0xfffffbff, 0xfffe0007, x25, x11, 144, x14)

inst_19:
// rs1==x18, rs2==x1, rd==x0, rs2_h1_val == -32768, 
// opcode: kmmawb2.u ; op1:x18; op2:x1; dest:x0; op1val:0x000040;  op2val:0x80002000
TEST_PKRR_OP(kmmawb2.u, x0, x18, x1, 0x00000000, 0x000040, 0x80002000, x18, x11, 152, x14)

inst_20:
// rs1==x26, rs2==x9, rd==x8, rs2_h1_val == 16384, rs1_w0_val == -33554433, rs2_h0_val == -2049
// opcode: kmmawb2.u ; op1:x26; op2:x9; dest:x8; op1val:0xfdffffff;  op2val:0x4000f7ff
TEST_PKRR_OP(kmmawb2.u, x8, x26, x9, 0x00000000, 0xfdffffff, 0x4000f7ff, x26, x11, 160, x5)

inst_21:
// rs1==x22, rs2==x13, rd==x14, rs2_h1_val == 8192, rs1_w0_val == -262145
// opcode: kmmawb2.u ; op1:x22; op2:x13; dest:x14; op1val:0xfffbffff;  op2val:0x2000c000
TEST_PKRR_OP(kmmawb2.u, x14, x22, x13, 0x00000000, 0xfffbffff, 0x2000c000, x22, x11, 168, x5)
RVTEST_SIGBASE(x4,signature_x4_0)

inst_22:
// rs1==x31, rs2==x15, rd==x1, rs2_h1_val == 4096, rs1_w0_val == 2048
// opcode: kmmawb2.u ; op1:x31; op2:x15; dest:x1; op1val:0x000800;  op2val:0x10001000
TEST_PKRR_OP(kmmawb2.u, x1, x31, x15, 0x00000000, 0x000800, 0x10001000, x31, x4, 0, x5)

inst_23:
// rs1==x8, rs2==x6, rd==x24, rs2_h1_val == 2048, rs2_h0_val == 4
// opcode: kmmawb2.u ; op1:x8; op2:x6; dest:x24; op1val:0x000006;  op2val:0x8000004
TEST_PKRR_OP(kmmawb2.u, x24, x8, x6, 0x00000000, 0x000006, 0x8000004, x8, x4, 8, x5)

inst_24:
// rs1==x15, rs2==x20, rd==x16, rs2_h1_val == 1024, 
// opcode: kmmawb2.u ; op1:x15; op2:x20; dest:x16; op1val:0xfffffff9;  op2val:0x400fff9
TEST_PKRR_OP(kmmawb2.u, x16, x15, x20, 0x00000000, 0xfffffff9, 0x400fff9, x15, x4, 16, x5)

inst_25:
// rs1==x0, rs2==x3, rd==x11, rs2_h1_val == 512, rs1_w0_val == 4194304
// opcode: kmmawb2.u ; op1:x0; op2:x3; dest:x11; op1val:0x400000;  op2val:0x200fff6
TEST_PKRR_OP(kmmawb2.u, x11, x0, x3, 0x00000000, 0x400000, 0x200fff6, x0, x4, 24, x5)

inst_26:
// rs1==x1, rs2==x27, rd==x20, rs2_h1_val == 256, rs1_w0_val == -2049
// opcode: kmmawb2.u ; op1:x1; op2:x27; dest:x20; op1val:0xfffff7ff;  op2val:0x1003fff
TEST_PKRR_OP(kmmawb2.u, x20, x1, x27, 0x00000000, 0xfffff7ff, 0x1003fff, x1, x4, 32, x5)

inst_27:
// rs1==x14, rs2==x2, rd==x7, rs2_h1_val == 128, 
// opcode: kmmawb2.u ; op1:x14; op2:x2; dest:x7; op1val:0x000040;  op2val:0x80fff6
TEST_PKRR_OP(kmmawb2.u, x7, x14, x2, 0x00000000, 0x000040, 0x80fff6, x14, x4, 40, x5)

inst_28:
// rs1==x20, rs2==x7, rd==x15, rs2_h1_val == 64, rs1_w0_val == -1, rs2_h0_val == 1
// opcode: kmmawb2.u ; op1:x20; op2:x7; dest:x15; op1val:0xffffffff;  op2val:0x400001
TEST_PKRR_OP(kmmawb2.u, x15, x20, x7, 0x00000000, 0xffffffff, 0x400001, x20, x4, 48, x5)

inst_29:
// rs1==x29, rs2==x11, rd==x26, rs2_h1_val == 32, rs1_w0_val == 8388608
// opcode: kmmawb2.u ; op1:x29; op2:x11; dest:x26; op1val:0x800000;  op2val:0x20fffb
TEST_PKRR_OP(kmmawb2.u, x26, x29, x11, 0x00000000, 0x800000, 0x20fffb, x29, x4, 56, x5)

inst_30:
// rs1==x11, rs2==x14, rd==x27, rs2_h1_val == 16, 
// opcode: kmmawb2.u ; op1:x11; op2:x14; dest:x27; op1val:0x000008;  op2val:0x10fff6
TEST_PKRR_OP(kmmawb2.u, x27, x11, x14, 0x00000000, 0x000008, 0x10fff6, x11, x4, 64, x5)

inst_31:
// rs1==x16, rs2_h1_val == 8, rs2_h0_val == -4097, rs1_w0_val == -16385
// opcode: kmmawb2.u ; op1:x16; op2:x23; dest:x22; op1val:0xffffbfff;  op2val:0x08efff
TEST_PKRR_OP(kmmawb2.u, x22, x16, x23, 0x00000000, 0xffffbfff, 0x08efff, x16, x4, 72, x5)

inst_32:
// rs2==x16, rs2_h1_val == 4, rs1_w0_val == -17
// opcode: kmmawb2.u ; op1:x26; op2:x16; dest:x11; op1val:0xffffffef;  op2val:0x040007
TEST_PKRR_OP(kmmawb2.u, x11, x26, x16, 0x00000000, 0xffffffef, 0x040007, x26, x4, 80, x5)

inst_33:
// rd==x2, rs2_h1_val == 2, rs2_h0_val == 2048, rs1_w0_val == 4
// opcode: kmmawb2.u ; op1:x29; op2:x17; dest:x2; op1val:0x000004;  op2val:0x020800
TEST_PKRR_OP(kmmawb2.u, x2, x29, x17, 0x00000000, 0x000004, 0x020800, x29, x4, 88, x5)

inst_34:
// rs2_h1_val == 1, 
// opcode: kmmawb2.u ; op1:x30; op2:x29; dest:x31; op1val:0x8000000;  op2val:0x01fff8
TEST_PKRR_OP(kmmawb2.u, x31, x30, x29, 0x00000000, 0x8000000, 0x01fff8, x30, x4, 96, x5)

inst_35:
// rs1_w0_val == 512, rs2_h0_val == 0
// opcode: kmmawb2.u ; op1:x30; op2:x29; dest:x31; op1val:0x000200;  op2val:0x3fff0000
TEST_PKRR_OP(kmmawb2.u, x31, x30, x29, 0x00000000, 0x000200, 0x3fff0000, x30, x4, 104, x5)

inst_36:
// rs1_w0_val == 256, 
// opcode: kmmawb2.u ; op1:x30; op2:x29; dest:x31; op1val:0x000100;  op2val:0x200f7ff
TEST_PKRR_OP(kmmawb2.u, x31, x30, x29, 0x00000000, 0x000100, 0x200f7ff, x30, x4, 112, x5)

inst_37:
// rs1_w0_val == 128, 
// opcode: kmmawb2.u ; op1:x30; op2:x29; dest:x31; op1val:0x000080;  op2val:0xaaaafff9
TEST_PKRR_OP(kmmawb2.u, x31, x30, x29, 0x00000000, 0x000080, 0xaaaafff9, x30, x4, 120, x5)

inst_38:
// rs1_w0_val == 32, rs2_h0_val == 128
// opcode: kmmawb2.u ; op1:x30; op2:x29; dest:x31; op1val:0x000020;  op2val:0x030080
TEST_PKRR_OP(kmmawb2.u, x31, x30, x29, 0x00000000, 0x000020, 0x030080, x30, x4, 128, x5)

inst_39:
// rs1_w0_val == 2, 
// opcode: kmmawb2.u ; op1:x30; op2:x29; dest:x31; op1val:0x000002;  op2val:0xfdfffeff
TEST_PKRR_OP(kmmawb2.u, x31, x30, x29, 0x00000000, 0x000002, 0xfdfffeff, x30, x4, 136, x5)

inst_40:
// rs1_w0_val == 1, 
// opcode: kmmawb2.u ; op1:x30; op2:x29; dest:x31; op1val:0x000001;  op2val:0xfff9efff
TEST_PKRR_OP(kmmawb2.u, x31, x30, x29, 0x00000000, 0x000001, 0xfff9efff, x30, x4, 144, x5)

inst_41:
// rs1_w0_val == 0, rs2_h0_val == 1024
// opcode: kmmawb2.u ; op1:x30; op2:x29; dest:x31; op1val:0x000000;  op2val:0xfffb0400
TEST_PKRR_OP(kmmawb2.u, x31, x30, x29, 0x00000000, 0x000000, 0xfffb0400, x30, x4, 152, x5)

inst_42:
// rs2_h1_val == 0, rs2_h0_val == 16
// opcode: kmmawb2.u ; op1:x30; op2:x29; dest:x31; op1val:0x000003;  op2val:0x000010
TEST_PKRR_OP(kmmawb2.u, x31, x30, x29, 0x00000000, 0x000003, 0x000010, x30, x4, 160, x5)

inst_43:
// rs2_h1_val == -1, rs1_w0_val == -257
// opcode: kmmawb2.u ; op1:x30; op2:x29; dest:x31; op1val:0xfffffeff;  op2val:0xffffffef
TEST_PKRR_OP(kmmawb2.u, x31, x30, x29, 0x00000000, 0xfffffeff, 0xffffffef, x30, x4, 168, x5)

inst_44:
// rs2_h0_val == 21845, 
// opcode: kmmawb2.u ; op1:x30; op2:x29; dest:x31; op1val:0x80000000;  op2val:0xffef5555
TEST_PKRR_OP(kmmawb2.u, x31, x30, x29, 0x00000000, 0x80000000, 0xffef5555, x30, x4, 176, x5)

inst_45:
// rs2_h0_val == 32767, 
// opcode: kmmawb2.u ; op1:x30; op2:x29; dest:x31; op1val:0xc0000000;  op2val:0xffbf7fff
TEST_PKRR_OP(kmmawb2.u, x31, x30, x29, 0x00000000, 0xc0000000, 0xffbf7fff, x30, x4, 184, x5)

inst_46:
// rs2_h0_val == -1025, rs1_w0_val == -8193
// opcode: kmmawb2.u ; op1:x30; op2:x29; dest:x31; op1val:0xffffdfff;  op2val:0x80fbff
TEST_PKRR_OP(kmmawb2.u, x31, x30, x29, 0x00000000, 0xffffdfff, 0x80fbff, x30, x4, 192, x5)

inst_47:
// rs2_h0_val == -513, 
// opcode: kmmawb2.u ; op1:x30; op2:x29; dest:x31; op1val:0xfffffbff;  op2val:0xfff7fdff
TEST_PKRR_OP(kmmawb2.u, x31, x30, x29, 0x00000000, 0xfffffbff, 0xfff7fdff, x30, x4, 200, x5)

inst_48:
// rs2_h0_val == -33, 
// opcode: kmmawb2.u ; op1:x30; op2:x29; dest:x31; op1val:0x000007;  op2val:0x07ffdf
TEST_PKRR_OP(kmmawb2.u, x31, x30, x29, 0x00000000, 0x000007, 0x07ffdf, x30, x4, 208, x5)

inst_49:
// rs2_h0_val == -9, 
// opcode: kmmawb2.u ; op1:x30; op2:x29; dest:x31; op1val:0xfffffeff;  op2val:0xaaaafff7
TEST_PKRR_OP(kmmawb2.u, x31, x30, x29, 0x00000000, 0xfffffeff, 0xaaaafff7, x30, x4, 216, x5)

inst_50:
// rs2_h0_val == -3, 
// opcode: kmmawb2.u ; op1:x30; op2:x29; dest:x31; op1val:0xffffbfff;  op2val:0x3ffffffd
TEST_PKRR_OP(kmmawb2.u, x31, x30, x29, 0x00000000, 0xffffbfff, 0x3ffffffd, x30, x4, 224, x5)

inst_51:
// rs2_h0_val == -2, 
// opcode: kmmawb2.u ; op1:x30; op2:x29; dest:x31; op1val:0x800000;  op2val:0x10fffe
TEST_PKRR_OP(kmmawb2.u, x31, x30, x29, 0x00000000, 0x800000, 0x10fffe, x30, x4, 232, x5)

inst_52:
// rs2_h0_val == 16384, 
// opcode: kmmawb2.u ; op1:x30; op2:x29; dest:x31; op1val:0xfffffffd;  op2val:0xfffa4000
TEST_PKRR_OP(kmmawb2.u, x31, x30, x29, 0x00000000, 0xfffffffd, 0xfffa4000, x30, x4, 240, x5)

inst_53:
// rs2_h0_val == 512, rs1_w0_val == -65
// opcode: kmmawb2.u ; op1:x30; op2:x29; dest:x31; op1val:0xffffffbf;  op2val:0x000200
TEST_PKRR_OP(kmmawb2.u, x31, x30, x29, 0x00000000, 0xffffffbf, 0x000200, x30, x4, 248, x5)

inst_54:
// rs2_h0_val == 32, rs1_w0_val == 65536
// opcode: kmmawb2.u ; op1:x30; op2:x29; dest:x31; op1val:0x010000;  op2val:0x7fff0020
TEST_PKRR_OP(kmmawb2.u, x31, x30, x29, 0x00000000, 0x010000, 0x7fff0020, x30, x4, 256, x5)

inst_55:
// rs2_h0_val == 8, 
// opcode: kmmawb2.u ; op1:x30; op2:x29; dest:x31; op1val:0x000200;  op2val:0x7fff0008
TEST_PKRR_OP(kmmawb2.u, x31, x30, x29, 0x00000000, 0x000200, 0x7fff0008, x30, x4, 264, x5)

inst_56:
// rs2_h0_val == 2, 
// opcode: kmmawb2.u ; op1:x30; op2:x29; dest:x31; op1val:0x8000000;  op2val:0xaaaa0002
TEST_PKRR_OP(kmmawb2.u, x31, x30, x29, 0x00000000, 0x8000000, 0xaaaa0002, x30, x4, 272, x5)

inst_57:
// rs2_h0_val == -1, rs1_w0_val == 1024
// opcode: kmmawb2.u ; op1:x30; op2:x29; dest:x31; op1val:0x000400;  op2val:0xc000ffff
TEST_PKRR_OP(kmmawb2.u, x31, x30, x29, 0x00000000, 0x000400, 0xc000ffff, x30, x4, 280, x5)

inst_58:
// rs1_w0_val == -1431655766, 
// opcode: kmmawb2.u ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaaa;  op2val:0x7fff0100
TEST_PKRR_OP(kmmawb2.u, x31, x30, x29, 0x00000000, 0xaaaaaaaa, 0x7fff0100, x30, x4, 288, x5)

inst_59:
// rs1_w0_val == 2147483647, 
// opcode: kmmawb2.u ; op1:x30; op2:x29; dest:x31; op1val:0x7fffffff;  op2val:0x02fff7
TEST_PKRR_OP(kmmawb2.u, x31, x30, x29, 0x00000000, 0x7fffffff, 0x02fff7, x30, x4, 296, x5)

inst_60:
// rs1_w0_val == -1073741825, 
// opcode: kmmawb2.u ; op1:x30; op2:x29; dest:x31; op1val:0xbfffffff;  op2val:0x800004
TEST_PKRR_OP(kmmawb2.u, x31, x30, x29, 0x00000000, 0xbfffffff, 0x800004, x30, x4, 304, x5)

inst_61:
// rs1_w0_val == -536870913, 
// opcode: kmmawb2.u ; op1:x30; op2:x29; dest:x31; op1val:0xdfffffff;  op2val:0xfffe0003
TEST_PKRR_OP(kmmawb2.u, x31, x30, x29, 0x00000000, 0xdfffffff, 0xfffe0003, x30, x4, 312, x5)

inst_62:
// rs1_w0_val == -268435457, 
// opcode: kmmawb2.u ; op1:x30; op2:x29; dest:x31; op1val:0xefffffff;  op2val:0x020004
TEST_PKRR_OP(kmmawb2.u, x31, x30, x29, 0x00000000, 0xefffffff, 0x020004, x30, x4, 320, x5)

inst_63:
// rs1_w0_val == -67108865, 
// opcode: kmmawb2.u ; op1:x30; op2:x29; dest:x31; op1val:0xfbffffff;  op2val:0x08fdff
TEST_PKRR_OP(kmmawb2.u, x31, x30, x29, 0x00000000, 0xfbffffff, 0x08fdff, x30, x4, 328, x5)

inst_64:
// rs1_w0_val == -16777217, 
// opcode: kmmawb2.u ; op1:x30; op2:x29; dest:x31; op1val:0xfeffffff;  op2val:0xaaaadfff
TEST_PKRR_OP(kmmawb2.u, x31, x30, x29, 0x00000000, 0xfeffffff, 0xaaaadfff, x30, x4, 336, x5)

inst_65:
// rs1_w0_val == -8388609, 
// opcode: kmmawb2.u ; op1:x30; op2:x29; dest:x31; op1val:0xff7fffff;  op2val:0x20fff8
TEST_PKRR_OP(kmmawb2.u, x31, x30, x29, 0x00000000, 0xff7fffff, 0x20fff8, x30, x4, 344, x5)

inst_66:
// rs1_w0_val == -4194305, 
// opcode: kmmawb2.u ; op1:x30; op2:x29; dest:x31; op1val:0xffbfffff;  op2val:0xf7ff8000
TEST_PKRR_OP(kmmawb2.u, x31, x30, x29, 0x00000000, 0xffbfffff, 0xf7ff8000, x30, x4, 352, x5)

inst_67:
// rs1_w0_val == -2097153, 
// opcode: kmmawb2.u ; op1:x30; op2:x29; dest:x31; op1val:0xffdfffff;  op2val:0x070020
TEST_PKRR_OP(kmmawb2.u, x31, x30, x29, 0x00000000, 0xffdfffff, 0x070020, x30, x4, 360, x5)

inst_68:
// rs1_w0_val == -524289, 
// opcode: kmmawb2.u ; op1:x30; op2:x29; dest:x31; op1val:0xfff7ffff;  op2val:0xf7ff0010
TEST_PKRR_OP(kmmawb2.u, x31, x30, x29, 0x00000000, 0xfff7ffff, 0xf7ff0010, x30, x4, 368, x5)

inst_69:
// rs1_w0_val == -131073, 
// opcode: kmmawb2.u ; op1:x30; op2:x29; dest:x31; op1val:0xfffdffff;  op2val:0xfffe0002
TEST_PKRR_OP(kmmawb2.u, x31, x30, x29, 0x00000000, 0xfffdffff, 0xfffe0002, x30, x4, 376, x5)

inst_70:
// rs1_w0_val == -32769, 
// opcode: kmmawb2.u ; op1:x30; op2:x29; dest:x31; op1val:0xffff7fff;  op2val:0x40004000
TEST_PKRR_OP(kmmawb2.u, x31, x30, x29, 0x00000000, 0xffff7fff, 0x40004000, x30, x4, 384, x5)

inst_71:
// rs1_w0_val == -4097, 
// opcode: kmmawb2.u ; op1:x30; op2:x29; dest:x31; op1val:0xffffefff;  op2val:0xf7fffffe
TEST_PKRR_OP(kmmawb2.u, x31, x30, x29, 0x00000000, 0xffffefff, 0xf7fffffe, x30, x4, 392, x5)

inst_72:
// rs1_w0_val == -513, 
// opcode: kmmawb2.u ; op1:x30; op2:x29; dest:x31; op1val:0xfffffdff;  op2val:0x4000fff8
TEST_PKRR_OP(kmmawb2.u, x31, x30, x29, 0x00000000, 0xfffffdff, 0x4000fff8, x30, x4, 400, x5)

inst_73:
// rs1_w0_val == -129, 
// opcode: kmmawb2.u ; op1:x30; op2:x29; dest:x31; op1val:0xffffff7f;  op2val:0x05ffef
TEST_PKRR_OP(kmmawb2.u, x31, x30, x29, 0x00000000, 0xffffff7f, 0x05ffef, x30, x4, 408, x5)

inst_74:
// rs1_w0_val == -9, 
// opcode: kmmawb2.u ; op1:x30; op2:x29; dest:x31; op1val:0xfffffff7;  op2val:0xfffeffbf
TEST_PKRR_OP(kmmawb2.u, x31, x30, x29, 0x00000000, 0xfffffff7, 0xfffeffbf, x30, x4, 416, x5)

inst_75:
// rs1_w0_val == -5, 
// opcode: kmmawb2.u ; op1:x30; op2:x29; dest:x31; op1val:0xfffffffb;  op2val:0x070080
TEST_PKRR_OP(kmmawb2.u, x31, x30, x29, 0x00000000, 0xfffffffb, 0x070080, x30, x4, 424, x5)

inst_76:
// rs1_w0_val == -2, 
// opcode: kmmawb2.u ; op1:x30; op2:x29; dest:x31; op1val:0xfffffffe;  op2val:0x3fff0002
TEST_PKRR_OP(kmmawb2.u, x31, x30, x29, 0x00000000, 0xfffffffe, 0x3fff0002, x30, x4, 432, x5)

inst_77:
// rs1_w0_val == 1073741824, 
// opcode: kmmawb2.u ; op1:x30; op2:x29; dest:x31; op1val:0x40000000;  op2val:0x800fffb
TEST_PKRR_OP(kmmawb2.u, x31, x30, x29, 0x00000000, 0x40000000, 0x800fffb, x30, x4, 440, x5)

inst_78:
// rs1_w0_val == 268435456, 
// opcode: kmmawb2.u ; op1:x30; op2:x29; dest:x31; op1val:0x10000000;  op2val:0xfdfffeff
TEST_PKRR_OP(kmmawb2.u, x31, x30, x29, 0x00000000, 0x10000000, 0xfdfffeff, x30, x4, 448, x5)

inst_79:
// rs1_w0_val == 67108864, 
// opcode: kmmawb2.u ; op1:x30; op2:x29; dest:x31; op1val:0x4000000;  op2val:0xfff90200
TEST_PKRR_OP(kmmawb2.u, x31, x30, x29, 0x00000000, 0x4000000, 0xfff90200, x30, x4, 456, x5)

inst_80:
// rs1_w0_val == 33554432, 
// opcode: kmmawb2.u ; op1:x30; op2:x29; dest:x31; op1val:0x2000000;  op2val:0x4000ffbf
TEST_PKRR_OP(kmmawb2.u, x31, x30, x29, 0x00000000, 0x2000000, 0x4000ffbf, x30, x4, 464, x5)

inst_81:
// rs1_w0_val == 16777216, 
// opcode: kmmawb2.u ; op1:x30; op2:x29; dest:x31; op1val:0x1000000;  op2val:0xfefffff8
TEST_PKRR_OP(kmmawb2.u, x31, x30, x29, 0x00000000, 0x1000000, 0xfefffff8, x30, x4, 472, x5)

inst_82:
// rs1_w0_val == 2097152, 
// opcode: kmmawb2.u ; op1:x30; op2:x29; dest:x31; op1val:0x200000;  op2val:0x7ffffdff
TEST_PKRR_OP(kmmawb2.u, x31, x30, x29, 0x00000000, 0x200000, 0x7ffffdff, x30, x4, 480, x5)

inst_83:
// rs1_w0_val == 524288, 
// opcode: kmmawb2.u ; op1:x30; op2:x29; dest:x31; op1val:0x080000;  op2val:0x80ffbf
TEST_PKRR_OP(kmmawb2.u, x31, x30, x29, 0x00000000, 0x080000, 0x80ffbf, x30, x4, 488, x5)

inst_84:
// rs1_w0_val == 131072, 
// opcode: kmmawb2.u ; op1:x30; op2:x29; dest:x31; op1val:0x020000;  op2val:0x081000
TEST_PKRR_OP(kmmawb2.u, x31, x30, x29, 0x00000000, 0x020000, 0x081000, x30, x4, 496, x5)

inst_85:
// rs1_w0_val == 32768, 
// opcode: kmmawb2.u ; op1:x30; op2:x29; dest:x31; op1val:0x008000;  op2val:0x400fff6
TEST_PKRR_OP(kmmawb2.u, x31, x30, x29, 0x00000000, 0x008000, 0x400fff6, x30, x4, 504, x5)

inst_86:
// rs1_w0_val == 16384, 
// opcode: kmmawb2.u ; op1:x30; op2:x29; dest:x31; op1val:0x004000;  op2val:0xfbfffffb
TEST_PKRR_OP(kmmawb2.u, x31, x30, x29, 0x00000000, 0x004000, 0xfbfffffb, x30, x4, 512, x5)

inst_87:
// rs1_w0_val == 8192, 
// opcode: kmmawb2.u ; op1:x30; op2:x29; dest:x31; op1val:0x002000;  op2val:0x400feff
TEST_PKRR_OP(kmmawb2.u, x31, x30, x29, 0x00000000, 0x002000, 0x400feff, x30, x4, 520, x5)

inst_88:
// rs1_w0_val == 4096, 
// opcode: kmmawb2.u ; op1:x30; op2:x29; dest:x31; op1val:0x001000;  op2val:0xfffd0006
TEST_PKRR_OP(kmmawb2.u, x31, x30, x29, 0x00000000, 0x001000, 0xfffd0006, x30, x4, 528, x5)

inst_89:
// rs2_h1_val == -3, rs1_w0_val == -65537
// opcode: kmmawb2.u ; op1:x30; op2:x29; dest:x31; op1val:0xfffeffff;  op2val:0xfffdc000
TEST_PKRR_OP(kmmawb2.u, x31, x30, x29, 0x00000000, 0xfffeffff, 0xfffdc000, x30, x4, 536, x5)

inst_90:
// rs2_h1_val == -32768, 
// opcode: kmmawb2.u ; op1:x30; op2:x29; dest:x31; op1val:0x000040;  op2val:0x80002000
TEST_PKRR_OP(kmmawb2.u, x31, x30, x29, 0x00000000, 0x000040, 0x80002000, x30, x4, 544, x5)

inst_91:
// rs2_h1_val == 512, rs1_w0_val == 4194304
// opcode: kmmawb2.u ; op1:x30; op2:x29; dest:x31; op1val:0x400000;  op2val:0x200fff6
TEST_PKRR_OP(kmmawb2.u, x31, x30, x29, 0x00000000, 0x400000, 0x200fff6, x30, x4, 552, x5)
#endif


RVTEST_CODE_END
RVMODEL_HALT

RVTEST_DATA_BEGIN
.align 4
rvtest_data:
.word 0xbabecafe
.word 0xabecafeb
.word 0xbecafeba
.word 0xecafebab
RVTEST_DATA_END

RVMODEL_DATA_BEGIN


signature_x11_0:
    .fill 0*(XLEN/32),4,0xdeadbeef


signature_x11_1:
    .fill 44*(XLEN/32),4,0xdeadbeef


signature_x4_0:
    .fill 140*(XLEN/32),4,0xdeadbeef

#ifdef rvtest_mtrap_routine

mtrap_sigptr:
    .fill 64*(XLEN/32),4,0xdeadbeef

#endif

#ifdef rvtest_gpr_save

gpr_save:
    .fill 32*(XLEN/32),4,0xdeadbeef

#endif

RVMODEL_DATA_END
