
// -----------
// This file was generated by riscv_ctg (https://github.com/riscv-software-src/riscv-ctg)
// version   : 0.6.3
// timestamp : Sat Apr 23 14:53:29 2022 GMT
// usage     : riscv_ctg \
//                  --cgf /scratch/git-repo/github/riscv_ctg/sample_cgfs/dataset.cgf \
//                  --cgf /scratch/git-repo/github/riscv_ctg/sample_cgfs/rv32ip.cgf \
//                  --xlen 32  \
//                  --randomize \
// -----------
//
// -----------
// Copyright (c) 2020. RISC-V International. All rights reserved.
// SPDX-License-Identifier: BSD-3-Clause
// -----------
//
// This assembly file tests the kmmawt.u instruction of the RISC-V RV32PZicsr extension for the kmmawt.u covergroup.
// 
#include "model_test.h"
#include "arch_test.h"
RVTEST_ISA("RV32IPZicsr")

.section .text.init
.org 0x80
.globl rvtest_entry_point
rvtest_entry_point:
RVMODEL_BOOT
RVTEST_CODE_BEGIN

#ifdef TEST_CASE_1

RVTEST_CASE(0,"//check ISA:=regex(.*32.*);check ISA:=regex(.*I.*P.*Zicsr.*);def TEST_CASE_1=True;",kmmawt.u)

RVTEST_VXSAT_ENABLE()
RVTEST_SIGBASE(x22,signature_x22_1)

inst_0:
// rs1 != rs2  and rs1 != rd and rs2 != rd, rs1==x14, rs2==x25, rd==x30, rs1_w0_val == -2147483648, rs2_h1_val == -21846
// opcode: kmmawt.u ; op1:x14; op2:x25; dest:x30; op1val:0x80000000;  op2val:0xaaaafff9
TEST_PKRR_OP(kmmawt.u, x30, x14, x25, 0x00000000, 0x80000000, 0xaaaafff9, x14, x22, 0, x12)

inst_1:
// rs1 == rs2 != rd, rs1==x21, rs2==x21, rd==x1, rs2_h1_val == 21845, rs2_h0_val == 4096, rs1_w0_val == 1431655765
// opcode: kmmawt.u ; op1:x21; op2:x21; dest:x1; op1val:0x55555555;  op2val:0x55551000
TEST_PKRR_OP(kmmawt.u, x1, x21, x21, 0x00000000, 0x55555555, 0x55551000, x21, x22, 8, x12)

inst_2:
// rs1 == rd != rs2, rs1==x27, rs2==x16, rd==x27, rs2_h1_val == 32767, rs1_w0_val == 2, rs2_h0_val == -5
// opcode: kmmawt.u ; op1:x27; op2:x16; dest:x27; op1val:0x000002;  op2val:0x7ffffffb
TEST_PKRR_OP(kmmawt.u, x27, x27, x16, 0x00000000, 0x000002, 0x7ffffffb, x27, x22, 16, x12)

inst_3:
// rs1 == rs2 == rd, rs1==x8, rs2==x8, rd==x8, rs2_h1_val == -16385, rs2_h0_val == 2
// opcode: kmmawt.u ; op1:x8; op2:x8; dest:x8; op1val:0xfffffffa;  op2val:0xbfff0002
TEST_PKRR_OP(kmmawt.u, x8, x8, x8, 0x00000000, 0xfffffffa, 0xbfff0002, x8, x22, 24, x12)

inst_4:
// rs2 == rd != rs1, rs1==x17, rs2==x3, rd==x3, rs2_h1_val == -8193, rs2_h0_val == -3, rs1_w0_val == 524288
// opcode: kmmawt.u ; op1:x17; op2:x3; dest:x3; op1val:0x080000;  op2val:0xdffffffd
TEST_PKRR_OP(kmmawt.u, x3, x17, x3, 0x00000000, 0x080000, 0xdffffffd, x17, x22, 32, x12)

inst_5:
// rs1==x11, rs2==x18, rd==x7, rs2_h1_val == -4097, rs2_h0_val == 32, rs1_w0_val == -129
// opcode: kmmawt.u ; op1:x11; op2:x18; dest:x7; op1val:0xffffff7f;  op2val:0xefff0020
TEST_PKRR_OP(kmmawt.u, x7, x11, x18, 0x00000000, 0xffffff7f, 0xefff0020, x11, x22, 40, x12)

inst_6:
// rs1==x18, rs2==x23, rd==x21, rs2_h1_val == -2049, rs1_w0_val == -8388609
// opcode: kmmawt.u ; op1:x18; op2:x23; dest:x21; op1val:0xff7fffff;  op2val:0xf7fffff9
TEST_PKRR_OP(kmmawt.u, x21, x18, x23, 0x00000000, 0xff7fffff, 0xf7fffff9, x18, x22, 48, x12)

inst_7:
// rs1==x4, rs2==x6, rd==x31, rs2_h1_val == -1025, rs1_w0_val == 512
// opcode: kmmawt.u ; op1:x4; op2:x6; dest:x31; op1val:0x000200;  op2val:0xfbfffffc
TEST_PKRR_OP(kmmawt.u, x31, x4, x6, 0x00000000, 0x000200, 0xfbfffffc, x4, x22, 56, x12)

inst_8:
// rs1==x16, rs2==x24, rd==x13, rs2_h1_val == -513, rs2_h0_val == -65, rs1_w0_val == -1073741825
// opcode: kmmawt.u ; op1:x16; op2:x24; dest:x13; op1val:0xbfffffff;  op2val:0xfdffffbf
TEST_PKRR_OP(kmmawt.u, x13, x16, x24, 0x00000000, 0xbfffffff, 0xfdffffbf, x16, x22, 64, x12)

inst_9:
// rs1==x30, rs2==x14, rd==x15, rs2_h1_val == -257, rs2_h0_val == 1
// opcode: kmmawt.u ; op1:x30; op2:x14; dest:x15; op1val:0xfffffff8;  op2val:0xfeff0001
TEST_PKRR_OP(kmmawt.u, x15, x30, x14, 0x00000000, 0xfffffff8, 0xfeff0001, x30, x22, 72, x12)

inst_10:
// rs1==x10, rs2==x0, rd==x25, rs2_h1_val == -129, rs1_w0_val == -262145, rs2_h0_val == -33
// opcode: kmmawt.u ; op1:x10; op2:x0; dest:x25; op1val:0xfffbffff;  op2val:0xff7fffdf
TEST_PKRR_OP(kmmawt.u, x25, x10, x0, 0x00000000, 0xfffbffff, 0xff7fffdf, x10, x22, 80, x12)

inst_11:
// rs1==x6, rs2==x4, rd==x9, rs2_h1_val == -65, rs2_h0_val == 512, rs1_w0_val == 2048
// opcode: kmmawt.u ; op1:x6; op2:x4; dest:x9; op1val:0x000800;  op2val:0xffbf0200
TEST_PKRR_OP(kmmawt.u, x9, x6, x4, 0x00000000, 0x000800, 0xffbf0200, x6, x22, 88, x12)

inst_12:
// rs1==x9, rs2==x11, rd==x0, rs2_h1_val == -33, rs1_w0_val == -524289, rs2_h0_val == 32767
// opcode: kmmawt.u ; op1:x9; op2:x11; dest:x0; op1val:0xfff7ffff;  op2val:0xffdf7fff
TEST_PKRR_OP(kmmawt.u, x0, x9, x11, 0x00000000, 0xfff7ffff, 0xffdf7fff, x9, x22, 96, x12)

inst_13:
// rs1==x7, rs2==x20, rd==x4, rs2_h1_val == -17, rs2_h0_val == -16385
// opcode: kmmawt.u ; op1:x7; op2:x20; dest:x4; op1val:0x000009;  op2val:0xffefbfff
TEST_PKRR_OP(kmmawt.u, x4, x7, x20, 0x00000000, 0x000009, 0xffefbfff, x7, x22, 104, x12)

inst_14:
// rs1==x24, rs2==x5, rd==x20, rs2_h1_val == -9, rs1_w0_val == 128
// opcode: kmmawt.u ; op1:x24; op2:x5; dest:x20; op1val:0x000080;  op2val:0xfff7c000
TEST_PKRR_OP(kmmawt.u, x20, x24, x5, 0x00000000, 0x000080, 0xfff7c000, x24, x22, 112, x12)

inst_15:
// rs1==x3, rs2==x7, rd==x6, rs2_h1_val == -5, rs2_h0_val == 1024
// opcode: kmmawt.u ; op1:x3; op2:x7; dest:x6; op1val:0xfff7ffff;  op2val:0xfffb0400
TEST_PKRR_OP(kmmawt.u, x6, x3, x7, 0x00000000, 0xfff7ffff, 0xfffb0400, x3, x22, 120, x12)

inst_16:
// rs1==x19, rs2==x9, rd==x17, rs2_h1_val == -3, rs1_w0_val == -4097
// opcode: kmmawt.u ; op1:x19; op2:x9; dest:x17; op1val:0xffffefff;  op2val:0xfffd0001
TEST_PKRR_OP(kmmawt.u, x17, x19, x9, 0x00000000, 0xffffefff, 0xfffd0001, x19, x22, 128, x12)

inst_17:
// rs1==x31, rs2==x13, rd==x2, rs2_h1_val == -2, rs1_w0_val == -16777217
// opcode: kmmawt.u ; op1:x31; op2:x13; dest:x2; op1val:0xfeffffff;  op2val:0xfffefffb
TEST_PKRR_OP(kmmawt.u, x2, x31, x13, 0x00000000, 0xfeffffff, 0xfffefffb, x31, x22, 136, x12)

inst_18:
// rs1==x23, rs2==x28, rd==x12, rs2_h1_val == -32768, rs1_w0_val == -4194305
// opcode: kmmawt.u ; op1:x23; op2:x28; dest:x12; op1val:0xffbfffff;  op2val:0x80001000
TEST_PKRR_OP(kmmawt.u, x12, x23, x28, 0x00000000, 0xffbfffff, 0x80001000, x23, x22, 144, x4)
RVTEST_SIGBASE(x3,signature_x3_0)

inst_19:
// rs1==x0, rs2==x30, rd==x10, rs2_h1_val == 16384, rs2_h0_val == 2048
// opcode: kmmawt.u ; op1:x0; op2:x30; dest:x10; op1val:0xfff7ffff;  op2val:0x40000800
TEST_PKRR_OP(kmmawt.u, x10, x0, x30, 0x00000000, 0xfff7ffff, 0x40000800, x0, x3, 0, x4)

inst_20:
// rs1==x2, rs2==x27, rd==x11, rs2_h1_val == 8192, 
// opcode: kmmawt.u ; op1:x2; op2:x27; dest:x11; op1val:0x000007;  op2val:0x20003fff
TEST_PKRR_OP(kmmawt.u, x11, x2, x27, 0x00000000, 0x000007, 0x20003fff, x2, x3, 8, x4)

inst_21:
// rs1==x25, rs2==x17, rd==x5, rs2_h1_val == 4096, 
// opcode: kmmawt.u ; op1:x25; op2:x17; dest:x5; op1val:0xffffefff;  op2val:0x10000006
TEST_PKRR_OP(kmmawt.u, x5, x25, x17, 0x00000000, 0xffffefff, 0x10000006, x25, x3, 16, x4)

inst_22:
// rs1==x22, rs2==x12, rd==x29, rs2_h1_val == 2048, rs1_w0_val == 4096, rs2_h0_val == 21845
// opcode: kmmawt.u ; op1:x22; op2:x12; dest:x29; op1val:0x001000;  op2val:0x8005555
TEST_PKRR_OP(kmmawt.u, x29, x22, x12, 0x00000000, 0x001000, 0x8005555, x22, x3, 24, x4)

inst_23:
// rs1==x1, rs2==x2, rd==x24, rs2_h1_val == 1024, 
// opcode: kmmawt.u ; op1:x1; op2:x2; dest:x24; op1val:0xfffffffa;  op2val:0x4000001
TEST_PKRR_OP(kmmawt.u, x24, x1, x2, 0x00000000, 0xfffffffa, 0x4000001, x1, x3, 32, x4)

inst_24:
// rs1==x29, rs2==x31, rd==x26, rs2_h1_val == 512, 
// opcode: kmmawt.u ; op1:x29; op2:x31; dest:x26; op1val:0xffbfffff;  op2val:0x200fff6
TEST_PKRR_OP(kmmawt.u, x26, x29, x31, 0x00000000, 0xffbfffff, 0x200fff6, x29, x3, 40, x4)

inst_25:
// rs1==x26, rs2==x1, rd==x19, rs2_h1_val == 256, rs2_h0_val == -2049
// opcode: kmmawt.u ; op1:x26; op2:x1; dest:x19; op1val:0x080000;  op2val:0x100f7ff
TEST_PKRR_OP(kmmawt.u, x19, x26, x1, 0x00000000, 0x080000, 0x100f7ff, x26, x3, 48, x4)

inst_26:
// rs1==x5, rs2==x19, rd==x22, rs2_h1_val == 128, 
// opcode: kmmawt.u ; op1:x5; op2:x19; dest:x22; op1val:0xfffbffff;  op2val:0x80ffdf
TEST_PKRR_OP(kmmawt.u, x22, x5, x19, 0x00000000, 0xfffbffff, 0x80ffdf, x5, x3, 56, x4)

inst_27:
// rs1==x15, rs2==x22, rd==x23, rs2_h1_val == 64, rs2_h0_val == -9, rs1_w0_val == -268435457
// opcode: kmmawt.u ; op1:x15; op2:x22; dest:x23; op1val:0xefffffff;  op2val:0x40fff7
TEST_PKRR_OP(kmmawt.u, x23, x15, x22, 0x00000000, 0xefffffff, 0x40fff7, x15, x3, 64, x4)

inst_28:
// rs1==x13, rs2==x10, rd==x16, rs2_h1_val == 32, rs1_w0_val == 64, rs2_h0_val == 4
// opcode: kmmawt.u ; op1:x13; op2:x10; dest:x16; op1val:0x000040;  op2val:0x200004
TEST_PKRR_OP(kmmawt.u, x16, x13, x10, 0x00000000, 0x000040, 0x200004, x13, x3, 72, x4)

inst_29:
// rs1==x20, rs2==x29, rd==x18, rs2_h1_val == 16, rs2_h0_val == -1
// opcode: kmmawt.u ; op1:x20; op2:x29; dest:x18; op1val:0xff7fffff;  op2val:0x10ffff
TEST_PKRR_OP(kmmawt.u, x18, x20, x29, 0x00000000, 0xff7fffff, 0x10ffff, x20, x3, 80, x4)

inst_30:
// rs1==x12, rs2==x26, rd==x28, rs2_h1_val == 8, rs2_h0_val == 8
// opcode: kmmawt.u ; op1:x12; op2:x26; dest:x28; op1val:0xfffffff6;  op2val:0x080008
TEST_PKRR_OP(kmmawt.u, x28, x12, x26, 0x00000000, 0xfffffff6, 0x080008, x12, x3, 88, x4)

inst_31:
// rs1==x28, rs2==x15, rd==x14, rs2_h1_val == 4, rs1_w0_val == 131072
// opcode: kmmawt.u ; op1:x28; op2:x15; dest:x14; op1val:0x020000;  op2val:0x04fffc
TEST_PKRR_OP(kmmawt.u, x14, x28, x15, 0x00000000, 0x020000, 0x04fffc, x28, x3, 96, x4)

inst_32:
// rs2_h1_val == 2, rs2_h0_val == -32768
// opcode: kmmawt.u ; op1:x30; op2:x29; dest:x31; op1val:0x000006;  op2val:0x028000
TEST_PKRR_OP(kmmawt.u, x31, x30, x29, 0x00000000, 0x000006, 0x028000, x30, x3, 104, x4)

inst_33:
// rs2_h1_val == 1, rs1_w0_val == -131073
// opcode: kmmawt.u ; op1:x30; op2:x29; dest:x31; op1val:0xfffdffff;  op2val:0x01fff8
TEST_PKRR_OP(kmmawt.u, x31, x30, x29, 0x00000000, 0xfffdffff, 0x01fff8, x30, x3, 112, x4)

inst_34:
// rs2_h1_val == 0, rs1_w0_val == 256, rs2_h0_val == -17
// opcode: kmmawt.u ; op1:x30; op2:x29; dest:x31; op1val:0x000100;  op2val:0x00ffef
TEST_PKRR_OP(kmmawt.u, x31, x30, x29, 0x00000000, 0x000100, 0x00ffef, x30, x3, 120, x4)

inst_35:
// rs2_h1_val == -1, rs1_w0_val == -3, rs2_h0_val == 256
// opcode: kmmawt.u ; op1:x30; op2:x29; dest:x31; op1val:0xfffffffd;  op2val:0xffff0100
TEST_PKRR_OP(kmmawt.u, x31, x30, x29, 0x00000000, 0xfffffffd, 0xffff0100, x30, x3, 128, x4)

inst_36:
// rs1_w0_val == 32, rs2_h0_val == -1025
// opcode: kmmawt.u ; op1:x30; op2:x29; dest:x31; op1val:0x000020;  op2val:0xfffefbff
TEST_PKRR_OP(kmmawt.u, x31, x30, x29, 0x00000000, 0x000020, 0xfffefbff, x30, x3, 136, x4)

inst_37:
// rs1_w0_val == 16, 
// opcode: kmmawt.u ; op1:x30; op2:x29; dest:x31; op1val:0x000010;  op2val:0xfff90400
TEST_PKRR_OP(kmmawt.u, x31, x30, x29, 0x00000000, 0x000010, 0xfff90400, x30, x3, 144, x4)

inst_38:
// rs1_w0_val == 8, 
// opcode: kmmawt.u ; op1:x30; op2:x29; dest:x31; op1val:0x000008;  op2val:0xfffffff8
TEST_PKRR_OP(kmmawt.u, x31, x30, x29, 0x00000000, 0x000008, 0xfffffff8, x30, x3, 152, x4)

inst_39:
// rs1_w0_val == 4, 
// opcode: kmmawt.u ; op1:x30; op2:x29; dest:x31; op1val:0x000004;  op2val:0xaaaa7fff
TEST_PKRR_OP(kmmawt.u, x31, x30, x29, 0x00000000, 0x000004, 0xaaaa7fff, x30, x3, 160, x4)

inst_40:
// rs1_w0_val == 1, 
// opcode: kmmawt.u ; op1:x30; op2:x29; dest:x31; op1val:0x000001;  op2val:0xffbffffc
TEST_PKRR_OP(kmmawt.u, x31, x30, x29, 0x00000000, 0x000001, 0xffbffffc, x30, x3, 168, x4)

inst_41:
// rs1_w0_val == 0, rs2_h0_val == 8192
// opcode: kmmawt.u ; op1:x30; op2:x29; dest:x31; op1val:0x000000;  op2val:0xffef2000
TEST_PKRR_OP(kmmawt.u, x31, x30, x29, 0x00000000, 0x000000, 0xffef2000, x30, x3, 176, x4)

inst_42:
// rs1_w0_val == -1, 
// opcode: kmmawt.u ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0xdfff0008
TEST_PKRR_OP(kmmawt.u, x31, x30, x29, 0x00000000, 0xffffffff, 0xdfff0008, x30, x3, 184, x4)

inst_43:
// rs2_h0_val == -21846, rs1_w0_val == -17
// opcode: kmmawt.u ; op1:x30; op2:x29; dest:x31; op1val:0xffffffef;  op2val:0x20aaaa
TEST_PKRR_OP(kmmawt.u, x31, x30, x29, 0x00000000, 0xffffffef, 0x20aaaa, x30, x3, 192, x4)

inst_44:
// rs2_h0_val == -8193, rs1_w0_val == -2
// opcode: kmmawt.u ; op1:x30; op2:x29; dest:x31; op1val:0xfffffffe;  op2val:0x80dfff
TEST_PKRR_OP(kmmawt.u, x31, x30, x29, 0x00000000, 0xfffffffe, 0x80dfff, x30, x3, 200, x4)

inst_45:
// rs2_h0_val == -4097, 
// opcode: kmmawt.u ; op1:x30; op2:x29; dest:x31; op1val:0xfffffffe;  op2val:0xaaaaefff
TEST_PKRR_OP(kmmawt.u, x31, x30, x29, 0x00000000, 0xfffffffe, 0xaaaaefff, x30, x3, 208, x4)

inst_46:
// rs2_h0_val == -513, rs1_w0_val == -8193
// opcode: kmmawt.u ; op1:x30; op2:x29; dest:x31; op1val:0xffffdfff;  op2val:0xfff8fdff
TEST_PKRR_OP(kmmawt.u, x31, x30, x29, 0x00000000, 0xffffdfff, 0xfff8fdff, x30, x3, 216, x4)

inst_47:
// rs2_h0_val == -257, rs1_w0_val == 4194304
// opcode: kmmawt.u ; op1:x30; op2:x29; dest:x31; op1val:0x400000;  op2val:0xfff7feff
TEST_PKRR_OP(kmmawt.u, x31, x30, x29, 0x00000000, 0x400000, 0xfff7feff, x30, x3, 224, x4)

inst_48:
// rs2_h0_val == -129, rs1_w0_val == -536870913
// opcode: kmmawt.u ; op1:x30; op2:x29; dest:x31; op1val:0xdfffffff;  op2val:0xfdffff7f
TEST_PKRR_OP(kmmawt.u, x31, x30, x29, 0x00000000, 0xdfffffff, 0xfdffff7f, x30, x3, 232, x4)

inst_49:
// rs2_h0_val == -2, 
// opcode: kmmawt.u ; op1:x30; op2:x29; dest:x31; op1val:0x080000;  op2val:0x00fffe
TEST_PKRR_OP(kmmawt.u, x31, x30, x29, 0x00000000, 0x080000, 0x00fffe, x30, x3, 240, x4)

inst_50:
// rs2_h0_val == 16384, 
// opcode: kmmawt.u ; op1:x30; op2:x29; dest:x31; op1val:0x000200;  op2val:0xffdf4000
TEST_PKRR_OP(kmmawt.u, x31, x30, x29, 0x00000000, 0x000200, 0xffdf4000, x30, x3, 248, x4)

inst_51:
// rs2_h0_val == 128, rs1_w0_val == -65
// opcode: kmmawt.u ; op1:x30; op2:x29; dest:x31; op1val:0xffffffbf;  op2val:0xfff60080
TEST_PKRR_OP(kmmawt.u, x31, x30, x29, 0x00000000, 0xffffffbf, 0xfff60080, x30, x3, 256, x4)

inst_52:
// rs2_h0_val == 64, 
// opcode: kmmawt.u ; op1:x30; op2:x29; dest:x31; op1val:0xefffffff;  op2val:0x010040
TEST_PKRR_OP(kmmawt.u, x31, x30, x29, 0x00000000, 0xefffffff, 0x010040, x30, x3, 264, x4)

inst_53:
// rs2_h0_val == 16, 
// opcode: kmmawt.u ; op1:x30; op2:x29; dest:x31; op1val:0x000800;  op2val:0xbfff0010
TEST_PKRR_OP(kmmawt.u, x31, x30, x29, 0x00000000, 0x000800, 0xbfff0010, x30, x3, 272, x4)

inst_54:
// rs2_h0_val == 0, 
// opcode: kmmawt.u ; op1:x30; op2:x29; dest:x31; op1val:0xffffefff;  op2val:0x050000
TEST_PKRR_OP(kmmawt.u, x31, x30, x29, 0x00000000, 0xffffefff, 0x050000, x30, x3, 280, x4)

inst_55:
// rs1_w0_val == -1431655766, 
// opcode: kmmawt.u ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaaa;  op2val:0x101000
TEST_PKRR_OP(kmmawt.u, x31, x30, x29, 0x00000000, 0xaaaaaaaa, 0x101000, x30, x3, 288, x4)

inst_56:
// rs1_w0_val == 2147483647, 
// opcode: kmmawt.u ; op1:x30; op2:x29; dest:x31; op1val:0x7fffffff;  op2val:0xc000ffbf
TEST_PKRR_OP(kmmawt.u, x31, x30, x29, 0x00000000, 0x7fffffff, 0xc000ffbf, x30, x3, 296, x4)

inst_57:
// rs1_w0_val == -134217729, 
// opcode: kmmawt.u ; op1:x30; op2:x29; dest:x31; op1val:0xf7ffffff;  op2val:0xfff60003
TEST_PKRR_OP(kmmawt.u, x31, x30, x29, 0x00000000, 0xf7ffffff, 0xfff60003, x30, x3, 304, x4)

inst_58:
// rs1_w0_val == -67108865, 
// opcode: kmmawt.u ; op1:x30; op2:x29; dest:x31; op1val:0xfbffffff;  op2val:0x1000fff9
TEST_PKRR_OP(kmmawt.u, x31, x30, x29, 0x00000000, 0xfbffffff, 0x1000fff9, x30, x3, 312, x4)

inst_59:
// rs1_w0_val == -33554433, 
// opcode: kmmawt.u ; op1:x30; op2:x29; dest:x31; op1val:0xfdffffff;  op2val:0xaaaa0003
TEST_PKRR_OP(kmmawt.u, x31, x30, x29, 0x00000000, 0xfdffffff, 0xaaaa0003, x30, x3, 320, x4)

inst_60:
// rs1_w0_val == -2097153, 
// opcode: kmmawt.u ; op1:x30; op2:x29; dest:x31; op1val:0xffdfffff;  op2val:0xfff9fffe
TEST_PKRR_OP(kmmawt.u, x31, x30, x29, 0x00000000, 0xffdfffff, 0xfff9fffe, x30, x3, 328, x4)

inst_61:
// rs1_w0_val == -1048577, 
// opcode: kmmawt.u ; op1:x30; op2:x29; dest:x31; op1val:0xffefffff;  op2val:0x8000fff6
TEST_PKRR_OP(kmmawt.u, x31, x30, x29, 0x00000000, 0xffefffff, 0x8000fff6, x30, x3, 336, x4)

inst_62:
// rs1_w0_val == -65537, 
// opcode: kmmawt.u ; op1:x30; op2:x29; dest:x31; op1val:0xfffeffff;  op2val:0xff7f0200
TEST_PKRR_OP(kmmawt.u, x31, x30, x29, 0x00000000, 0xfffeffff, 0xff7f0200, x30, x3, 344, x4)

inst_63:
// rs1_w0_val == -32769, 
// opcode: kmmawt.u ; op1:x30; op2:x29; dest:x31; op1val:0xffff7fff;  op2val:0x20fffe
TEST_PKRR_OP(kmmawt.u, x31, x30, x29, 0x00000000, 0xffff7fff, 0x20fffe, x30, x3, 352, x4)

inst_64:
// rs1_w0_val == -16385, 
// opcode: kmmawt.u ; op1:x30; op2:x29; dest:x31; op1val:0xffffbfff;  op2val:0xff7f0004
TEST_PKRR_OP(kmmawt.u, x31, x30, x29, 0x00000000, 0xffffbfff, 0xff7f0004, x30, x3, 360, x4)

inst_65:
// rs1_w0_val == -2049, 
// opcode: kmmawt.u ; op1:x30; op2:x29; dest:x31; op1val:0xfffff7ff;  op2val:0x203fff
TEST_PKRR_OP(kmmawt.u, x31, x30, x29, 0x00000000, 0xfffff7ff, 0x203fff, x30, x3, 368, x4)

inst_66:
// rs1_w0_val == -1025, 
// opcode: kmmawt.u ; op1:x30; op2:x29; dest:x31; op1val:0xfffffbff;  op2val:0x02fff9
TEST_PKRR_OP(kmmawt.u, x31, x30, x29, 0x00000000, 0xfffffbff, 0x02fff9, x30, x3, 376, x4)

inst_67:
// rs1_w0_val == -513, 
// opcode: kmmawt.u ; op1:x30; op2:x29; dest:x31; op1val:0xfffffdff;  op2val:0x040003
TEST_PKRR_OP(kmmawt.u, x31, x30, x29, 0x00000000, 0xfffffdff, 0x040003, x30, x3, 384, x4)

inst_68:
// rs1_w0_val == -257, 
// opcode: kmmawt.u ; op1:x30; op2:x29; dest:x31; op1val:0xfffffeff;  op2val:0xfff9ffbf
TEST_PKRR_OP(kmmawt.u, x31, x30, x29, 0x00000000, 0xfffffeff, 0xfff9ffbf, x30, x3, 392, x4)

inst_69:
// rs1_w0_val == -33, 
// opcode: kmmawt.u ; op1:x30; op2:x29; dest:x31; op1val:0xffffffdf;  op2val:0x8003fff
TEST_PKRR_OP(kmmawt.u, x31, x30, x29, 0x00000000, 0xffffffdf, 0x8003fff, x30, x3, 400, x4)

inst_70:
// rs1_w0_val == -9, 
// opcode: kmmawt.u ; op1:x30; op2:x29; dest:x31; op1val:0xfffffff7;  op2val:0xdfffaaaa
TEST_PKRR_OP(kmmawt.u, x31, x30, x29, 0x00000000, 0xfffffff7, 0xdfffaaaa, x30, x3, 408, x4)

inst_71:
// rs1_w0_val == -5, 
// opcode: kmmawt.u ; op1:x30; op2:x29; dest:x31; op1val:0xfffffffb;  op2val:0x02fffc
TEST_PKRR_OP(kmmawt.u, x31, x30, x29, 0x00000000, 0xfffffffb, 0x02fffc, x30, x3, 416, x4)

inst_72:
// rs1_w0_val == 1073741824, 
// opcode: kmmawt.u ; op1:x30; op2:x29; dest:x31; op1val:0x40000000;  op2val:0x08c000
TEST_PKRR_OP(kmmawt.u, x31, x30, x29, 0x00000000, 0x40000000, 0x08c000, x30, x3, 424, x4)

inst_73:
// rs1_w0_val == 536870912, 
// opcode: kmmawt.u ; op1:x30; op2:x29; dest:x31; op1val:0x20000000;  op2val:0x55550000
TEST_PKRR_OP(kmmawt.u, x31, x30, x29, 0x00000000, 0x20000000, 0x55550000, x30, x3, 432, x4)

inst_74:
// rs1_w0_val == 268435456, 
// opcode: kmmawt.u ; op1:x30; op2:x29; dest:x31; op1val:0x10000000;  op2val:0x00dfff
TEST_PKRR_OP(kmmawt.u, x31, x30, x29, 0x00000000, 0x10000000, 0x00dfff, x30, x3, 440, x4)

inst_75:
// rs1_w0_val == 134217728, 
// opcode: kmmawt.u ; op1:x30; op2:x29; dest:x31; op1val:0x8000000;  op2val:0x030001
TEST_PKRR_OP(kmmawt.u, x31, x30, x29, 0x00000000, 0x8000000, 0x030001, x30, x3, 448, x4)

inst_76:
// rs1_w0_val == 67108864, 
// opcode: kmmawt.u ; op1:x30; op2:x29; dest:x31; op1val:0x4000000;  op2val:0xfffffeff
TEST_PKRR_OP(kmmawt.u, x31, x30, x29, 0x00000000, 0x4000000, 0xfffffeff, x30, x3, 456, x4)

inst_77:
// rs1_w0_val == 33554432, 
// opcode: kmmawt.u ; op1:x30; op2:x29; dest:x31; op1val:0x2000000;  op2val:0xfffb0100
TEST_PKRR_OP(kmmawt.u, x31, x30, x29, 0x00000000, 0x2000000, 0xfffb0100, x30, x3, 464, x4)

inst_78:
// rs1_w0_val == 16777216, 
// opcode: kmmawt.u ; op1:x30; op2:x29; dest:x31; op1val:0x1000000;  op2val:0xeffffeff
TEST_PKRR_OP(kmmawt.u, x31, x30, x29, 0x00000000, 0x1000000, 0xeffffeff, x30, x3, 472, x4)

inst_79:
// rs1_w0_val == 8388608, 
// opcode: kmmawt.u ; op1:x30; op2:x29; dest:x31; op1val:0x800000;  op2val:0x2000ffef
TEST_PKRR_OP(kmmawt.u, x31, x30, x29, 0x00000000, 0x800000, 0x2000ffef, x30, x3, 480, x4)

inst_80:
// rs1_w0_val == 2097152, 
// opcode: kmmawt.u ; op1:x30; op2:x29; dest:x31; op1val:0x200000;  op2val:0x200005
TEST_PKRR_OP(kmmawt.u, x31, x30, x29, 0x00000000, 0x200000, 0x200005, x30, x3, 488, x4)

inst_81:
// rs1_w0_val == 1048576, 
// opcode: kmmawt.u ; op1:x30; op2:x29; dest:x31; op1val:0x100000;  op2val:0xfffcfff8
TEST_PKRR_OP(kmmawt.u, x31, x30, x29, 0x00000000, 0x100000, 0xfffcfff8, x30, x3, 496, x4)

inst_82:
// rs1_w0_val == 262144, 
// opcode: kmmawt.u ; op1:x30; op2:x29; dest:x31; op1val:0x040000;  op2val:0x400001
TEST_PKRR_OP(kmmawt.u, x31, x30, x29, 0x00000000, 0x040000, 0x400001, x30, x3, 504, x4)

inst_83:
// rs1_w0_val == 65536, 
// opcode: kmmawt.u ; op1:x30; op2:x29; dest:x31; op1val:0x010000;  op2val:0x5555ffdf
TEST_PKRR_OP(kmmawt.u, x31, x30, x29, 0x00000000, 0x010000, 0x5555ffdf, x30, x3, 512, x4)

inst_84:
// rs1_w0_val == 32768, 
// opcode: kmmawt.u ; op1:x30; op2:x29; dest:x31; op1val:0x008000;  op2val:0xfff6aaaa
TEST_PKRR_OP(kmmawt.u, x31, x30, x29, 0x00000000, 0x008000, 0xfff6aaaa, x30, x3, 520, x4)

inst_85:
// rs1_w0_val == 16384, 
// opcode: kmmawt.u ; op1:x30; op2:x29; dest:x31; op1val:0x004000;  op2val:0xffefefff
TEST_PKRR_OP(kmmawt.u, x31, x30, x29, 0x00000000, 0x004000, 0xffefefff, x30, x3, 528, x4)

inst_86:
// rs1_w0_val == 8192, 
// opcode: kmmawt.u ; op1:x30; op2:x29; dest:x31; op1val:0x002000;  op2val:0xfbffffdf
TEST_PKRR_OP(kmmawt.u, x31, x30, x29, 0x00000000, 0x002000, 0xfbffffdf, x30, x3, 536, x4)

inst_87:
// rs1_w0_val == 1024, 
// opcode: kmmawt.u ; op1:x30; op2:x29; dest:x31; op1val:0x000400;  op2val:0xc000fffa
TEST_PKRR_OP(kmmawt.u, x31, x30, x29, 0x00000000, 0x000400, 0xc000fffa, x30, x3, 544, x4)

inst_88:
// rs2_h1_val == 21845, rs2_h0_val == 4096, rs1_w0_val == 1431655765
// opcode: kmmawt.u ; op1:x30; op2:x29; dest:x31; op1val:0x55555555;  op2val:0x55551000
TEST_PKRR_OP(kmmawt.u, x31, x30, x29, 0x00000000, 0x55555555, 0x55551000, x30, x3, 552, x4)

inst_89:
// rs2_h1_val == -16385, rs2_h0_val == 2
// opcode: kmmawt.u ; op1:x30; op2:x29; dest:x31; op1val:0xfffffffa;  op2val:0xbfff0002
TEST_PKRR_OP(kmmawt.u, x31, x30, x29, 0x00000000, 0xfffffffa, 0xbfff0002, x30, x3, 560, x4)

inst_90:
// rs2_h1_val == 16384, rs2_h0_val == 2048
// opcode: kmmawt.u ; op1:x30; op2:x29; dest:x31; op1val:0xfff7ffff;  op2val:0x40000800
TEST_PKRR_OP(kmmawt.u, x31, x30, x29, 0x00000000, 0xfff7ffff, 0x40000800, x30, x3, 568, x4)
#endif


RVTEST_CODE_END
RVMODEL_HALT

RVTEST_DATA_BEGIN
.align 4
rvtest_data:
.word 0xbabecafe
.word 0xabecafeb
.word 0xbecafeba
.word 0xecafebab
RVTEST_DATA_END

RVMODEL_DATA_BEGIN


signature_x22_0:
    .fill 0*(XLEN/32),4,0xdeadbeef


signature_x22_1:
    .fill 38*(XLEN/32),4,0xdeadbeef


signature_x3_0:
    .fill 144*(XLEN/32),4,0xdeadbeef

#ifdef rvtest_mtrap_routine

mtrap_sigptr:
    .fill 64*(XLEN/32),4,0xdeadbeef

#endif

#ifdef rvtest_gpr_save

gpr_save:
    .fill 32*(XLEN/32),4,0xdeadbeef

#endif

RVMODEL_DATA_END
