
// -----------
// This file was generated by riscv_ctg (https://github.com/riscv-software-src/riscv-ctg)
// version   : 0.6.3
// timestamp : Sat Apr 23 14:53:29 2022 GMT
// usage     : riscv_ctg \
//                  --cgf /scratch/git-repo/github/riscv_ctg/sample_cgfs/dataset.cgf \
//                  --cgf /scratch/git-repo/github/riscv_ctg/sample_cgfs/rv32ip.cgf \
//                  --xlen 32  \
//                  --randomize \
// -----------
//
// -----------
// Copyright (c) 2020. RISC-V International. All rights reserved.
// SPDX-License-Identifier: BSD-3-Clause
// -----------
//
// This assembly file tests the kmmawt2 instruction of the RISC-V RV32PZicsr extension for the kmmawt2 covergroup.
// 
#include "model_test.h"
#include "arch_test.h"
RVTEST_ISA("RV32IPZicsr")

.section .text.init
.org 0x80
.globl rvtest_entry_point
rvtest_entry_point:
RVMODEL_BOOT
RVTEST_CODE_BEGIN

#ifdef TEST_CASE_1

RVTEST_CASE(0,"//check ISA:=regex(.*32.*);check ISA:=regex(.*I.*P.*Zicsr.*);def TEST_CASE_1=True;",kmmawt2)

RVTEST_VXSAT_ENABLE()
RVTEST_SIGBASE(x10,signature_x10_1)

inst_0:
// rs1 != rs2  and rs1 != rd and rs2 != rd, rs1==x21, rs2==x14, rd==x8, rs1_w0_val == -2147483648, rs2_h0_val == 8
// opcode: kmmawt2 ; op1:x21; op2:x14; dest:x8; op1val:0x80000000;  op2val:0x090008
TEST_PKRR_OP(kmmawt2, x8, x21, x14, 0x00000000, 0x80000000, 0x090008, x21, x10, 0, x15)

inst_1:
// rs1 == rs2 != rd, rs1==x30, rs2==x30, rd==x6, rs2_h1_val == -21846, rs1_w0_val == -1
// opcode: kmmawt2 ; op1:x30; op2:x30; dest:x6; op1val:0xffffffff;  op2val:0xaaaa0003
TEST_PKRR_OP(kmmawt2, x6, x30, x30, 0x00000000, 0xffffffff, 0xaaaa0003, x30, x10, 8, x15)

inst_2:
// rs1 == rd != rs2, rs1==x2, rs2==x20, rd==x2, rs2_h1_val == 21845, rs2_h0_val == -33
// opcode: kmmawt2 ; op1:x2; op2:x20; dest:x2; op1val:0xfffffff9;  op2val:0x5555ffdf
TEST_PKRR_OP(kmmawt2, x2, x2, x20, 0x00000000, 0xfffffff9, 0x5555ffdf, x2, x10, 16, x15)

inst_3:
// rs1 == rs2 == rd, rs1==x3, rs2==x3, rd==x3, rs2_h1_val == 32767, rs2_h0_val == -17
// opcode: kmmawt2 ; op1:x3; op2:x3; dest:x3; op1val:0x000007;  op2val:0x7fffffef
TEST_PKRR_OP(kmmawt2, x3, x3, x3, 0x00000000, 0x000007, 0x7fffffef, x3, x10, 24, x15)

inst_4:
// rs2 == rd != rs1, rs1==x0, rs2==x23, rd==x23, rs2_h1_val == -16385, rs2_h0_val == 16, rs1_w0_val == 2048
// opcode: kmmawt2 ; op1:x0; op2:x23; dest:x23; op1val:0x000800;  op2val:0xbfff0010
TEST_PKRR_OP(kmmawt2, x23, x0, x23, 0x00000000, 0x000800, 0xbfff0010, x0, x10, 32, x15)

inst_5:
// rs1==x17, rs2==x12, rd==x4, rs2_h1_val == -8193, rs1_w0_val == -131073
// opcode: kmmawt2 ; op1:x17; op2:x12; dest:x4; op1val:0xfffdffff;  op2val:0xdfffc000
TEST_PKRR_OP(kmmawt2, x4, x17, x12, 0x00000000, 0xfffdffff, 0xdfffc000, x17, x10, 40, x15)

inst_6:
// rs1==x29, rs2==x7, rd==x1, rs2_h1_val == -4097, rs1_w0_val == 256, rs2_h0_val == 256
// opcode: kmmawt2 ; op1:x29; op2:x7; dest:x1; op1val:0x000100;  op2val:0xefff0100
TEST_PKRR_OP(kmmawt2, x1, x29, x7, 0x00000000, 0x000100, 0xefff0100, x29, x10, 48, x15)

inst_7:
// rs1==x22, rs2==x31, rd==x9, rs2_h1_val == -2049, rs2_h0_val == -1, rs1_w0_val == 2
// opcode: kmmawt2 ; op1:x22; op2:x31; dest:x9; op1val:0x000002;  op2val:0xf7ffffff
TEST_PKRR_OP(kmmawt2, x9, x22, x31, 0x00000000, 0x000002, 0xf7ffffff, x22, x10, 56, x15)

inst_8:
// rs1==x14, rs2==x11, rd==x13, rs2_h1_val == -1025, rs1_w0_val == -262145
// opcode: kmmawt2 ; op1:x14; op2:x11; dest:x13; op1val:0xfffbffff;  op2val:0xfbfffffc
TEST_PKRR_OP(kmmawt2, x13, x14, x11, 0x00000000, 0xfffbffff, 0xfbfffffc, x14, x10, 64, x15)

inst_9:
// rs1==x6, rs2==x2, rd==x25, rs2_h1_val == -513, rs2_h0_val == -2049
// opcode: kmmawt2 ; op1:x6; op2:x2; dest:x25; op1val:0xfffdffff;  op2val:0xfdfff7ff
TEST_PKRR_OP(kmmawt2, x25, x6, x2, 0x00000000, 0xfffdffff, 0xfdfff7ff, x6, x10, 72, x15)

inst_10:
// rs1==x11, rs2==x16, rd==x24, rs2_h1_val == -257, rs1_w0_val == 131072, rs2_h0_val == 21845
// opcode: kmmawt2 ; op1:x11; op2:x16; dest:x24; op1val:0x020000;  op2val:0xfeff5555
TEST_PKRR_OP(kmmawt2, x24, x11, x16, 0x00000000, 0x020000, 0xfeff5555, x11, x10, 80, x15)

inst_11:
// rs1==x23, rs2==x24, rd==x11, rs2_h1_val == -129, rs1_w0_val == 1, rs2_h0_val == -3
// opcode: kmmawt2 ; op1:x23; op2:x24; dest:x11; op1val:0x000001;  op2val:0xff7ffffd
TEST_PKRR_OP(kmmawt2, x11, x23, x24, 0x00000000, 0x000001, 0xff7ffffd, x23, x10, 88, x15)

inst_12:
// rs1==x24, rs2==x27, rd==x19, rs2_h1_val == -65, 
// opcode: kmmawt2 ; op1:x24; op2:x27; dest:x19; op1val:0x000800;  op2val:0xffbffff8
TEST_PKRR_OP(kmmawt2, x19, x24, x27, 0x00000000, 0x000800, 0xffbffff8, x24, x10, 96, x15)

inst_13:
// rs1==x26, rs2==x5, rd==x14, rs2_h1_val == -33, 
// opcode: kmmawt2 ; op1:x26; op2:x5; dest:x14; op1val:0x000100;  op2val:0xffdffff9
TEST_PKRR_OP(kmmawt2, x14, x26, x5, 0x00000000, 0x000100, 0xffdffff9, x26, x10, 104, x15)
RVTEST_SIGBASE(x2,signature_x2_0)

inst_14:
// rs1==x20, rs2==x28, rd==x7, rs2_h1_val == -17, rs1_w0_val == -65537
// opcode: kmmawt2 ; op1:x20; op2:x28; dest:x7; op1val:0xfffeffff;  op2val:0xffeffffc
TEST_PKRR_OP(kmmawt2, x7, x20, x28, 0x00000000, 0xfffeffff, 0xffeffffc, x20, x2, 0, x3)

inst_15:
// rs1==x27, rs2==x25, rd==x12, rs2_h1_val == -9, rs1_w0_val == -1431655766
// opcode: kmmawt2 ; op1:x27; op2:x25; dest:x12; op1val:0xaaaaaaaa;  op2val:0xfff70008
TEST_PKRR_OP(kmmawt2, x12, x27, x25, 0x00000000, 0xaaaaaaaa, 0xfff70008, x27, x2, 8, x3)

inst_16:
// rs1==x1, rs2==x17, rd==x18, rs2_h1_val == -5, rs1_w0_val == 64
// opcode: kmmawt2 ; op1:x1; op2:x17; dest:x18; op1val:0x000040;  op2val:0xfffbffff
TEST_PKRR_OP(kmmawt2, x18, x1, x17, 0x00000000, 0x000040, 0xfffbffff, x1, x2, 16, x3)

inst_17:
// rs1==x18, rs2==x22, rd==x0, rs2_h1_val == -3, rs2_h0_val == -65
// opcode: kmmawt2 ; op1:x18; op2:x22; dest:x0; op1val:0x000800;  op2val:0xfffdffbf
TEST_PKRR_OP(kmmawt2, x0, x18, x22, 0x00000000, 0x000800, 0xfffdffbf, x18, x2, 24, x3)

inst_18:
// rs1==x12, rs2==x29, rd==x27, rs2_h1_val == -2, rs1_w0_val == -1073741825
// opcode: kmmawt2 ; op1:x12; op2:x29; dest:x27; op1val:0xbfffffff;  op2val:0xfffeffbf
TEST_PKRR_OP(kmmawt2, x27, x12, x29, 0x00000000, 0xbfffffff, 0xfffeffbf, x12, x2, 32, x3)

inst_19:
// rs1==x4, rs2==x0, rd==x10, rs2_h1_val == -32768, rs1_w0_val == 32768, rs2_h0_val == -129
// opcode: kmmawt2 ; op1:x4; op2:x0; dest:x10; op1val:0x008000;  op2val:0x8000ff7f
TEST_PKRR_OP(kmmawt2, x10, x4, x0, 0x00000000, 0x008000, 0x8000ff7f, x4, x2, 40, x3)

inst_20:
// rs1==x5, rs2==x6, rd==x26, rs2_h1_val == 16384, rs1_w0_val == 128
// opcode: kmmawt2 ; op1:x5; op2:x6; dest:x26; op1val:0x000080;  op2val:0x4000fffc
TEST_PKRR_OP(kmmawt2, x26, x5, x6, 0x00000000, 0x000080, 0x4000fffc, x5, x2, 48, x3)

inst_21:
// rs1==x19, rs2==x18, rd==x5, rs2_h1_val == 8192, rs2_h0_val == 1024, rs1_w0_val == 16
// opcode: kmmawt2 ; op1:x19; op2:x18; dest:x5; op1val:0x000010;  op2val:0x20000400
TEST_PKRR_OP(kmmawt2, x5, x19, x18, 0x00000000, 0x000010, 0x20000400, x19, x2, 56, x3)

inst_22:
// rs1==x10, rs2==x21, rd==x15, rs2_h1_val == 4096, rs1_w0_val == 1048576
// opcode: kmmawt2 ; op1:x10; op2:x21; dest:x15; op1val:0x100000;  op2val:0x10000100
TEST_PKRR_OP(kmmawt2, x15, x10, x21, 0x00000000, 0x100000, 0x10000100, x10, x2, 64, x3)

inst_23:
// rs1==x13, rs2==x26, rd==x22, rs2_h1_val == 2048, rs1_w0_val == -8388609
// opcode: kmmawt2 ; op1:x13; op2:x26; dest:x22; op1val:0xff7fffff;  op2val:0x800ffff
TEST_PKRR_OP(kmmawt2, x22, x13, x26, 0x00000000, 0xff7fffff, 0x800ffff, x13, x2, 72, x3)

inst_24:
// rs1==x28, rs2==x1, rd==x17, rs2_h1_val == 1024, rs2_h0_val == -16385
// opcode: kmmawt2 ; op1:x28; op2:x1; dest:x17; op1val:0x000009;  op2val:0x400bfff
TEST_PKRR_OP(kmmawt2, x17, x28, x1, 0x00000000, 0x000009, 0x400bfff, x28, x2, 80, x3)

inst_25:
// rs1==x9, rs2==x8, rd==x20, rs2_h1_val == 512, rs1_w0_val == -3, rs2_h0_val == 32767
// opcode: kmmawt2 ; op1:x9; op2:x8; dest:x20; op1val:0xfffffffd;  op2val:0x2007fff
TEST_PKRR_OP(kmmawt2, x20, x9, x8, 0x00000000, 0xfffffffd, 0x2007fff, x9, x2, 88, x3)

inst_26:
// rs1==x25, rs2==x10, rd==x21, rs2_h1_val == 256, 
// opcode: kmmawt2 ; op1:x25; op2:x10; dest:x21; op1val:0x000003;  op2val:0x100ffff
TEST_PKRR_OP(kmmawt2, x21, x25, x10, 0x00000000, 0x000003, 0x100ffff, x25, x2, 96, x3)

inst_27:
// rs1==x15, rs2==x13, rd==x30, rs2_h1_val == 128, 
// opcode: kmmawt2 ; op1:x15; op2:x13; dest:x30; op1val:0x000080;  op2val:0x80bfff
TEST_PKRR_OP(kmmawt2, x30, x15, x13, 0x00000000, 0x000080, 0x80bfff, x15, x2, 104, x3)

inst_28:
// rs1==x31, rs2==x19, rd==x29, rs2_h1_val == 64, 
// opcode: kmmawt2 ; op1:x31; op2:x19; dest:x29; op1val:0xc0000000;  op2val:0x40ffbf
TEST_PKRR_OP(kmmawt2, x29, x31, x19, 0x00000000, 0xc0000000, 0x40ffbf, x31, x2, 112, x3)

inst_29:
// rs1==x16, rs2==x4, rd==x28, rs2_h1_val == 32, 
// opcode: kmmawt2 ; op1:x16; op2:x4; dest:x28; op1val:0x000100;  op2val:0x200008
TEST_PKRR_OP(kmmawt2, x28, x16, x4, 0x00000000, 0x000100, 0x200008, x16, x2, 120, x3)

inst_30:
// rs1==x7, rs2==x9, rd==x16, rs2_h1_val == 16, 
// opcode: kmmawt2 ; op1:x7; op2:x9; dest:x16; op1val:0x000007;  op2val:0x100400
TEST_PKRR_OP(kmmawt2, x16, x7, x9, 0x00000000, 0x000007, 0x100400, x7, x2, 128, x3)

inst_31:
// rs1==x8, rs2==x15, rd==x31, rs2_h1_val == 8, rs1_w0_val == 4
// opcode: kmmawt2 ; op1:x8; op2:x15; dest:x31; op1val:0x000004;  op2val:0x080010
TEST_PKRR_OP(kmmawt2, x31, x8, x15, 0x00000000, 0x000004, 0x080010, x8, x2, 136, x3)

inst_32:
// rs2_h1_val == 4, rs2_h0_val == -5
// opcode: kmmawt2 ; op1:x30; op2:x29; dest:x31; op1val:0xc0000000;  op2val:0x04fffb
TEST_PKRR_OP(kmmawt2, x31, x30, x29, 0x00000000, 0xc0000000, 0x04fffb, x30, x2, 144, x3)

inst_33:
// rs2_h1_val == 2, rs1_w0_val == 2097152, rs2_h0_val == 4
// opcode: kmmawt2 ; op1:x30; op2:x29; dest:x31; op1val:0x200000;  op2val:0x020004
TEST_PKRR_OP(kmmawt2, x31, x30, x29, 0x00000000, 0x200000, 0x020004, x30, x2, 152, x3)

inst_34:
// rs2_h1_val == 1, rs1_w0_val == -1025
// opcode: kmmawt2 ; op1:x30; op2:x29; dest:x31; op1val:0xfffffbff;  op2val:0x010009
TEST_PKRR_OP(kmmawt2, x31, x30, x29, 0x00000000, 0xfffffbff, 0x010009, x30, x2, 160, x3)

inst_35:
// rs2_h1_val == 0, rs1_w0_val == -257
// opcode: kmmawt2 ; op1:x30; op2:x29; dest:x31; op1val:0xfffffeff;  op2val:0x000005
TEST_PKRR_OP(kmmawt2, x31, x30, x29, 0x00000000, 0xfffffeff, 0x000005, x30, x2, 168, x3)

inst_36:
// rs2_h1_val == -1, rs2_h0_val == 0
// opcode: kmmawt2 ; op1:x30; op2:x29; dest:x31; op1val:0xfffffffd;  op2val:0xffff0000
TEST_PKRR_OP(kmmawt2, x31, x30, x29, 0x00000000, 0xfffffffd, 0xffff0000, x30, x2, 176, x3)

inst_37:
// rs2_h0_val == -21846, 
// opcode: kmmawt2 ; op1:x30; op2:x29; dest:x31; op1val:0xfffffffd;  op2val:0xfff9aaaa
TEST_PKRR_OP(kmmawt2, x31, x30, x29, 0x00000000, 0xfffffffd, 0xfff9aaaa, x30, x2, 184, x3)

inst_38:
// rs1_w0_val == 512, 
// opcode: kmmawt2 ; op1:x30; op2:x29; dest:x31; op1val:0x000200;  op2val:0x07fff6
TEST_PKRR_OP(kmmawt2, x31, x30, x29, 0x00000000, 0x000200, 0x07fff6, x30, x2, 192, x3)

inst_39:
// rs1_w0_val == 32, rs2_h0_val == 16384
// opcode: kmmawt2 ; op1:x30; op2:x29; dest:x31; op1val:0x000020;  op2val:0x1004000
TEST_PKRR_OP(kmmawt2, x31, x30, x29, 0x00000000, 0x000020, 0x1004000, x30, x2, 200, x3)

inst_40:
// rs1_w0_val == 8, 
// opcode: kmmawt2 ; op1:x30; op2:x29; dest:x31; op1val:0x000008;  op2val:0x02fffb
TEST_PKRR_OP(kmmawt2, x31, x30, x29, 0x00000000, 0x000008, 0x02fffb, x30, x2, 208, x3)

inst_41:
// rs1_w0_val == 0, rs2_h0_val == -513
// opcode: kmmawt2 ; op1:x30; op2:x29; dest:x31; op1val:0x000000;  op2val:0xf7fffdff
TEST_PKRR_OP(kmmawt2, x31, x30, x29, 0x00000000, 0x000000, 0xf7fffdff, x30, x2, 216, x3)

inst_42:
// rs2_h0_val == -8193, rs1_w0_val == 262144
// opcode: kmmawt2 ; op1:x30; op2:x29; dest:x31; op1val:0x040000;  op2val:0xfbffdfff
TEST_PKRR_OP(kmmawt2, x31, x30, x29, 0x00000000, 0x040000, 0xfbffdfff, x30, x2, 224, x3)

inst_43:
// rs2_h0_val == -4097, rs1_w0_val == -268435457
// opcode: kmmawt2 ; op1:x30; op2:x29; dest:x31; op1val:0xefffffff;  op2val:0x8000efff
TEST_PKRR_OP(kmmawt2, x31, x30, x29, 0x00000000, 0xefffffff, 0x8000efff, x30, x2, 232, x3)

inst_44:
// rs2_h0_val == -1025, 
// opcode: kmmawt2 ; op1:x30; op2:x29; dest:x31; op1val:0x000010;  op2val:0xbffffbff
TEST_PKRR_OP(kmmawt2, x31, x30, x29, 0x00000000, 0x000010, 0xbffffbff, x30, x2, 240, x3)

inst_45:
// rs2_h0_val == -257, rs1_w0_val == -513
// opcode: kmmawt2 ; op1:x30; op2:x29; dest:x31; op1val:0xfffffdff;  op2val:0xfff6feff
TEST_PKRR_OP(kmmawt2, x31, x30, x29, 0x00000000, 0xfffffdff, 0xfff6feff, x30, x2, 248, x3)

inst_46:
// rs2_h0_val == -9, 
// opcode: kmmawt2 ; op1:x30; op2:x29; dest:x31; op1val:0xbfffffff;  op2val:0x10fff7
TEST_PKRR_OP(kmmawt2, x31, x30, x29, 0x00000000, 0xbfffffff, 0x10fff7, x30, x2, 256, x3)

inst_47:
// rs2_h0_val == -2, 
// opcode: kmmawt2 ; op1:x30; op2:x29; dest:x31; op1val:0x000004;  op2val:0xfff7fffe
TEST_PKRR_OP(kmmawt2, x31, x30, x29, 0x00000000, 0x000004, 0xfff7fffe, x30, x2, 264, x3)

inst_48:
// rs2_h0_val == -32768, 
// opcode: kmmawt2 ; op1:x30; op2:x29; dest:x31; op1val:0xfffffff6;  op2val:0x008000
TEST_PKRR_OP(kmmawt2, x31, x30, x29, 0x00000000, 0xfffffff6, 0x008000, x30, x2, 272, x3)

inst_49:
// rs2_h0_val == 8192, 
// opcode: kmmawt2 ; op1:x30; op2:x29; dest:x31; op1val:0x000003;  op2val:0x032000
TEST_PKRR_OP(kmmawt2, x31, x30, x29, 0x00000000, 0x000003, 0x032000, x30, x2, 280, x3)

inst_50:
// rs2_h0_val == 4096, rs1_w0_val == 536870912
// opcode: kmmawt2 ; op1:x30; op2:x29; dest:x31; op1val:0x20000000;  op2val:0xff7f1000
TEST_PKRR_OP(kmmawt2, x31, x30, x29, 0x00000000, 0x20000000, 0xff7f1000, x30, x2, 288, x3)

inst_51:
// rs2_h0_val == 2048, 
// opcode: kmmawt2 ; op1:x30; op2:x29; dest:x31; op1val:0x000800;  op2val:0xfff70800
TEST_PKRR_OP(kmmawt2, x31, x30, x29, 0x00000000, 0x000800, 0xfff70800, x30, x2, 296, x3)

inst_52:
// rs2_h0_val == 512, rs1_w0_val == -2049
// opcode: kmmawt2 ; op1:x30; op2:x29; dest:x31; op1val:0xfffff7ff;  op2val:0xffef0200
TEST_PKRR_OP(kmmawt2, x31, x30, x29, 0x00000000, 0xfffff7ff, 0xffef0200, x30, x2, 304, x3)

inst_53:
// rs2_h0_val == 128, 
// opcode: kmmawt2 ; op1:x30; op2:x29; dest:x31; op1val:0x20000000;  op2val:0x020080
TEST_PKRR_OP(kmmawt2, x31, x30, x29, 0x00000000, 0x20000000, 0x020080, x30, x2, 312, x3)

inst_54:
// rs2_h0_val == 64, 
// opcode: kmmawt2 ; op1:x30; op2:x29; dest:x31; op1val:0xfffffbff;  op2val:0x3fff0040
TEST_PKRR_OP(kmmawt2, x31, x30, x29, 0x00000000, 0xfffffbff, 0x3fff0040, x30, x2, 320, x3)

inst_55:
// rs2_h0_val == 32, rs1_w0_val == 67108864
// opcode: kmmawt2 ; op1:x30; op2:x29; dest:x31; op1val:0x4000000;  op2val:0xdfff0020
TEST_PKRR_OP(kmmawt2, x31, x30, x29, 0x00000000, 0x4000000, 0xdfff0020, x30, x2, 328, x3)

inst_56:
// rs2_h0_val == 2, 
// opcode: kmmawt2 ; op1:x30; op2:x29; dest:x31; op1val:0xfffffbff;  op2val:0xfbff0002
TEST_PKRR_OP(kmmawt2, x31, x30, x29, 0x00000000, 0xfffffbff, 0xfbff0002, x30, x2, 336, x3)

inst_57:
// rs2_h0_val == 1, 
// opcode: kmmawt2 ; op1:x30; op2:x29; dest:x31; op1val:0x000004;  op2val:0x20000001
TEST_PKRR_OP(kmmawt2, x31, x30, x29, 0x00000000, 0x000004, 0x20000001, x30, x2, 344, x3)

inst_58:
// rs1_w0_val == 1431655765, 
// opcode: kmmawt2 ; op1:x30; op2:x29; dest:x31; op1val:0x55555555;  op2val:0xfdfffffe
TEST_PKRR_OP(kmmawt2, x31, x30, x29, 0x00000000, 0x55555555, 0xfdfffffe, x30, x2, 352, x3)

inst_59:
// rs1_w0_val == 2147483647, 
// opcode: kmmawt2 ; op1:x30; op2:x29; dest:x31; op1val:0x7fffffff;  op2val:0xaaaa5555
TEST_PKRR_OP(kmmawt2, x31, x30, x29, 0x00000000, 0x7fffffff, 0xaaaa5555, x30, x2, 360, x3)

inst_60:
// rs1_w0_val == -536870913, 
// opcode: kmmawt2 ; op1:x30; op2:x29; dest:x31; op1val:0xdfffffff;  op2val:0xffbf2000
TEST_PKRR_OP(kmmawt2, x31, x30, x29, 0x00000000, 0xdfffffff, 0xffbf2000, x30, x2, 368, x3)

inst_61:
// rs1_w0_val == -134217729, 
// opcode: kmmawt2 ; op1:x30; op2:x29; dest:x31; op1val:0xf7ffffff;  op2val:0xfff60005
TEST_PKRR_OP(kmmawt2, x31, x30, x29, 0x00000000, 0xf7ffffff, 0xfff60005, x30, x2, 376, x3)

inst_62:
// rs1_w0_val == -67108865, 
// opcode: kmmawt2 ; op1:x30; op2:x29; dest:x31; op1val:0xfbffffff;  op2val:0xfff60001
TEST_PKRR_OP(kmmawt2, x31, x30, x29, 0x00000000, 0xfbffffff, 0xfff60001, x30, x2, 384, x3)

inst_63:
// rs1_w0_val == -33554433, 
// opcode: kmmawt2 ; op1:x30; op2:x29; dest:x31; op1val:0xfdffffff;  op2val:0xfffd5555
TEST_PKRR_OP(kmmawt2, x31, x30, x29, 0x00000000, 0xfdffffff, 0xfffd5555, x30, x2, 392, x3)

inst_64:
// rs1_w0_val == -16777217, 
// opcode: kmmawt2 ; op1:x30; op2:x29; dest:x31; op1val:0xfeffffff;  op2val:0x7fff0001
TEST_PKRR_OP(kmmawt2, x31, x30, x29, 0x00000000, 0xfeffffff, 0x7fff0001, x30, x2, 400, x3)

inst_65:
// rs1_w0_val == -4194305, 
// opcode: kmmawt2 ; op1:x30; op2:x29; dest:x31; op1val:0xffbfffff;  op2val:0xdfff0400
TEST_PKRR_OP(kmmawt2, x31, x30, x29, 0x00000000, 0xffbfffff, 0xdfff0400, x30, x2, 408, x3)

inst_66:
// rs1_w0_val == -2097153, 
// opcode: kmmawt2 ; op1:x30; op2:x29; dest:x31; op1val:0xffdfffff;  op2val:0xfbff0002
TEST_PKRR_OP(kmmawt2, x31, x30, x29, 0x00000000, 0xffdfffff, 0xfbff0002, x30, x2, 416, x3)

inst_67:
// rs1_w0_val == -1048577, 
// opcode: kmmawt2 ; op1:x30; op2:x29; dest:x31; op1val:0xffefffff;  op2val:0x8000005
TEST_PKRR_OP(kmmawt2, x31, x30, x29, 0x00000000, 0xffefffff, 0x8000005, x30, x2, 424, x3)

inst_68:
// rs1_w0_val == -524289, 
// opcode: kmmawt2 ; op1:x30; op2:x29; dest:x31; op1val:0xfff7ffff;  op2val:0x400002
TEST_PKRR_OP(kmmawt2, x31, x30, x29, 0x00000000, 0xfff7ffff, 0x400002, x30, x2, 432, x3)

inst_69:
// rs1_w0_val == -32769, 
// opcode: kmmawt2 ; op1:x30; op2:x29; dest:x31; op1val:0xffff7fff;  op2val:0xfdfffff7
TEST_PKRR_OP(kmmawt2, x31, x30, x29, 0x00000000, 0xffff7fff, 0xfdfffff7, x30, x2, 440, x3)

inst_70:
// rs1_w0_val == -16385, 
// opcode: kmmawt2 ; op1:x30; op2:x29; dest:x31; op1val:0xffffbfff;  op2val:0xfffafffd
TEST_PKRR_OP(kmmawt2, x31, x30, x29, 0x00000000, 0xffffbfff, 0xfffafffd, x30, x2, 448, x3)

inst_71:
// rs1_w0_val == -8193, 
// opcode: kmmawt2 ; op1:x30; op2:x29; dest:x31; op1val:0xffffdfff;  op2val:0x800000
TEST_PKRR_OP(kmmawt2, x31, x30, x29, 0x00000000, 0xffffdfff, 0x800000, x30, x2, 456, x3)

inst_72:
// rs1_w0_val == -4097, 
// opcode: kmmawt2 ; op1:x30; op2:x29; dest:x31; op1val:0xffffefff;  op2val:0x7ffffffe
TEST_PKRR_OP(kmmawt2, x31, x30, x29, 0x00000000, 0xffffefff, 0x7ffffffe, x30, x2, 464, x3)

inst_73:
// rs1_w0_val == -129, 
// opcode: kmmawt2 ; op1:x30; op2:x29; dest:x31; op1val:0xffffff7f;  op2val:0xaaaa0009
TEST_PKRR_OP(kmmawt2, x31, x30, x29, 0x00000000, 0xffffff7f, 0xaaaa0009, x30, x2, 472, x3)

inst_74:
// rs1_w0_val == -65, 
// opcode: kmmawt2 ; op1:x30; op2:x29; dest:x31; op1val:0xffffffbf;  op2val:0xfff67fff
TEST_PKRR_OP(kmmawt2, x31, x30, x29, 0x00000000, 0xffffffbf, 0xfff67fff, x30, x2, 480, x3)

inst_75:
// rs1_w0_val == -33, 
// opcode: kmmawt2 ; op1:x30; op2:x29; dest:x31; op1val:0xffffffdf;  op2val:0xfffbfff6
TEST_PKRR_OP(kmmawt2, x31, x30, x29, 0x00000000, 0xffffffdf, 0xfffbfff6, x30, x2, 488, x3)

inst_76:
// rs1_w0_val == -17, 
// opcode: kmmawt2 ; op1:x30; op2:x29; dest:x31; op1val:0xffffffef;  op2val:0xff7f0002
TEST_PKRR_OP(kmmawt2, x31, x30, x29, 0x00000000, 0xffffffef, 0xff7f0002, x30, x2, 496, x3)

inst_77:
// rs1_w0_val == -9, 
// opcode: kmmawt2 ; op1:x30; op2:x29; dest:x31; op1val:0xfffffff7;  op2val:0xfffffffd
TEST_PKRR_OP(kmmawt2, x31, x30, x29, 0x00000000, 0xfffffff7, 0xfffffffd, x30, x2, 504, x3)

inst_78:
// rs1_w0_val == -5, 
// opcode: kmmawt2 ; op1:x30; op2:x29; dest:x31; op1val:0xfffffffb;  op2val:0x02ffff
TEST_PKRR_OP(kmmawt2, x31, x30, x29, 0x00000000, 0xfffffffb, 0x02ffff, x30, x2, 512, x3)

inst_79:
// rs1_w0_val == -2, 
// opcode: kmmawt2 ; op1:x30; op2:x29; dest:x31; op1val:0xfffffffe;  op2val:0x4000ffbf
TEST_PKRR_OP(kmmawt2, x31, x30, x29, 0x00000000, 0xfffffffe, 0x4000ffbf, x30, x2, 520, x3)

inst_80:
// rs1_w0_val == 1073741824, 
// opcode: kmmawt2 ; op1:x30; op2:x29; dest:x31; op1val:0x40000000;  op2val:0xffdffff7
TEST_PKRR_OP(kmmawt2, x31, x30, x29, 0x00000000, 0x40000000, 0xffdffff7, x30, x2, 528, x3)

inst_81:
// rs1_w0_val == 268435456, 
// opcode: kmmawt2 ; op1:x30; op2:x29; dest:x31; op1val:0x10000000;  op2val:0x000003
TEST_PKRR_OP(kmmawt2, x31, x30, x29, 0x00000000, 0x10000000, 0x000003, x30, x2, 536, x3)

inst_82:
// rs1_w0_val == 134217728, 
// opcode: kmmawt2 ; op1:x30; op2:x29; dest:x31; op1val:0x8000000;  op2val:0x104000
TEST_PKRR_OP(kmmawt2, x31, x30, x29, 0x00000000, 0x8000000, 0x104000, x30, x2, 544, x3)

inst_83:
// rs1_w0_val == 33554432, 
// opcode: kmmawt2 ; op1:x30; op2:x29; dest:x31; op1val:0x2000000;  op2val:0xffbf0008
TEST_PKRR_OP(kmmawt2, x31, x30, x29, 0x00000000, 0x2000000, 0xffbf0008, x30, x2, 552, x3)

inst_84:
// rs1_w0_val == 16777216, 
// opcode: kmmawt2 ; op1:x30; op2:x29; dest:x31; op1val:0x1000000;  op2val:0xffeffffa
TEST_PKRR_OP(kmmawt2, x31, x30, x29, 0x00000000, 0x1000000, 0xffeffffa, x30, x2, 560, x3)

inst_85:
// rs1_w0_val == 8388608, 
// opcode: kmmawt2 ; op1:x30; op2:x29; dest:x31; op1val:0x800000;  op2val:0xfff6aaaa
TEST_PKRR_OP(kmmawt2, x31, x30, x29, 0x00000000, 0x800000, 0xfff6aaaa, x30, x2, 568, x3)

inst_86:
// rs1_w0_val == 4194304, 
// opcode: kmmawt2 ; op1:x30; op2:x29; dest:x31; op1val:0x400000;  op2val:0xfff9f7ff
TEST_PKRR_OP(kmmawt2, x31, x30, x29, 0x00000000, 0x400000, 0xfff9f7ff, x30, x2, 576, x3)

inst_87:
// rs1_w0_val == 524288, 
// opcode: kmmawt2 ; op1:x30; op2:x29; dest:x31; op1val:0x080000;  op2val:0x8000c000
TEST_PKRR_OP(kmmawt2, x31, x30, x29, 0x00000000, 0x080000, 0x8000c000, x30, x2, 584, x3)

inst_88:
// rs1_w0_val == 65536, 
// opcode: kmmawt2 ; op1:x30; op2:x29; dest:x31; op1val:0x010000;  op2val:0x55550001
TEST_PKRR_OP(kmmawt2, x31, x30, x29, 0x00000000, 0x010000, 0x55550001, x30, x2, 592, x3)

inst_89:
// rs1_w0_val == 16384, 
// opcode: kmmawt2 ; op1:x30; op2:x29; dest:x31; op1val:0x004000;  op2val:0x1000fffb
TEST_PKRR_OP(kmmawt2, x31, x30, x29, 0x00000000, 0x004000, 0x1000fffb, x30, x2, 600, x3)

inst_90:
// rs1_w0_val == 8192, 
// opcode: kmmawt2 ; op1:x30; op2:x29; dest:x31; op1val:0x002000;  op2val:0xc0000007
TEST_PKRR_OP(kmmawt2, x31, x30, x29, 0x00000000, 0x002000, 0xc0000007, x30, x2, 608, x3)

inst_91:
// rs1_w0_val == 4096, 
// opcode: kmmawt2 ; op1:x30; op2:x29; dest:x31; op1val:0x001000;  op2val:0x203fff
TEST_PKRR_OP(kmmawt2, x31, x30, x29, 0x00000000, 0x001000, 0x203fff, x30, x2, 616, x3)

inst_92:
// rs1_w0_val == 1024, 
// opcode: kmmawt2 ; op1:x30; op2:x29; dest:x31; op1val:0x000400;  op2val:0xfff7aaaa
TEST_PKRR_OP(kmmawt2, x31, x30, x29, 0x00000000, 0x000400, 0xfff7aaaa, x30, x2, 624, x3)

inst_93:
// rs2_h1_val == -21846, rs1_w0_val == -1
// opcode: kmmawt2 ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0xaaaa0003
TEST_PKRR_OP(kmmawt2, x31, x30, x29, 0x00000000, 0xffffffff, 0xaaaa0003, x30, x2, 632, x3)

inst_94:
// rs2_h1_val == 32767, rs2_h0_val == -17
// opcode: kmmawt2 ; op1:x30; op2:x29; dest:x31; op1val:0x000007;  op2val:0x7fffffef
TEST_PKRR_OP(kmmawt2, x31, x30, x29, 0x00000000, 0x000007, 0x7fffffef, x30, x2, 640, x3)

inst_95:
// rs2_h1_val == -32768, rs1_w0_val == 32768, rs2_h0_val == -129
// opcode: kmmawt2 ; op1:x30; op2:x29; dest:x31; op1val:0x008000;  op2val:0x8000ff7f
TEST_PKRR_OP(kmmawt2, x31, x30, x29, 0x00000000, 0x008000, 0x8000ff7f, x30, x2, 648, x3)
#endif


RVTEST_CODE_END
RVMODEL_HALT

RVTEST_DATA_BEGIN
.align 4
rvtest_data:
.word 0xbabecafe
.word 0xabecafeb
.word 0xbecafeba
.word 0xecafebab
RVTEST_DATA_END

RVMODEL_DATA_BEGIN


signature_x10_0:
    .fill 0*(XLEN/32),4,0xdeadbeef


signature_x10_1:
    .fill 28*(XLEN/32),4,0xdeadbeef


signature_x2_0:
    .fill 164*(XLEN/32),4,0xdeadbeef

#ifdef rvtest_mtrap_routine

mtrap_sigptr:
    .fill 64*(XLEN/32),4,0xdeadbeef

#endif

#ifdef rvtest_gpr_save

gpr_save:
    .fill 32*(XLEN/32),4,0xdeadbeef

#endif

RVMODEL_DATA_END
