
// -----------
// This file was generated by riscv_ctg (https://github.com/riscv-software-src/riscv-ctg)
// version   : 0.6.3
// timestamp : Sat Apr 23 14:53:29 2022 GMT
// usage     : riscv_ctg \
//                  --cgf /scratch/git-repo/github/riscv_ctg/sample_cgfs/dataset.cgf \
//                  --cgf /scratch/git-repo/github/riscv_ctg/sample_cgfs/rv32ip.cgf \
//                  --xlen 32  \
//                  --randomize \
// -----------
//
// -----------
// Copyright (c) 2020. RISC-V International. All rights reserved.
// SPDX-License-Identifier: BSD-3-Clause
// -----------
//
// This assembly file tests the kmmwb2 instruction of the RISC-V RV32PZicsr extension for the kmmwb2 covergroup.
// 
#include "model_test.h"
#include "arch_test.h"
RVTEST_ISA("RV32IPZicsr")

.section .text.init
.org 0x80
.globl rvtest_entry_point
rvtest_entry_point:
RVMODEL_BOOT
RVTEST_CODE_BEGIN

#ifdef TEST_CASE_1

RVTEST_CASE(0,"//check ISA:=regex(.*32.*);check ISA:=regex(.*I.*P.*Zicsr.*);def TEST_CASE_1=True;",kmmwb2)

RVTEST_VXSAT_ENABLE()
RVTEST_SIGBASE(x3,signature_x3_1)

inst_0:
// rs1 != rs2  and rs1 != rd and rs2 != rd, rs1==x13, rs2==x26, rd==x12, rs1_w0_val == -2147483648, rs2_h1_val == -2, rs2_h0_val == -1025
// opcode: kmmwb2 ; op1:x13; op2:x26; dest:x12; op1val:0x80000000;  op2val:0xfffefbff
TEST_PKRR_OP(kmmwb2, x12, x13, x26, 0x00000000, 0x80000000, 0xfffefbff, x13, x3, 0, x11)

inst_1:
// rs1 == rs2 != rd, rs1==x18, rs2==x18, rd==x20, rs2_h1_val == -21846, rs1_w0_val == 8388608, rs2_h0_val == 2
// opcode: kmmwb2 ; op1:x18; op2:x18; dest:x20; op1val:0x800000;  op2val:0xaaaa0002
TEST_PKRR_OP(kmmwb2, x20, x18, x18, 0x00000000, 0x800000, 0xaaaa0002, x18, x3, 8, x11)

inst_2:
// rs1 == rd != rs2, rs1==x5, rs2==x2, rd==x5, rs2_h1_val == 21845, rs1_w0_val == 256, rs2_h0_val == -21846
// opcode: kmmwb2 ; op1:x5; op2:x2; dest:x5; op1val:0x000100;  op2val:0x5555aaaa
TEST_PKRR_OP(kmmwb2, x5, x5, x2, 0x00000000, 0x000100, 0x5555aaaa, x5, x3, 16, x11)

inst_3:
// rs1 == rs2 == rd, rs1==x6, rs2==x6, rd==x6, rs2_h1_val == 32767, rs1_w0_val == -262145
// opcode: kmmwb2 ; op1:x6; op2:x6; dest:x6; op1val:0xfffbffff;  op2val:0x7fff0006
TEST_PKRR_OP(kmmwb2, x6, x6, x6, 0x00000000, 0xfffbffff, 0x7fff0006, x6, x3, 24, x11)

inst_4:
// rs2 == rd != rs1, rs1==x4, rs2==x17, rd==x17, rs2_h1_val == -16385, rs2_h0_val == 128
// opcode: kmmwb2 ; op1:x4; op2:x17; dest:x17; op1val:0xc0000000;  op2val:0xbfff0080
TEST_PKRR_OP(kmmwb2, x17, x4, x17, 0x00000000, 0xc0000000, 0xbfff0080, x4, x3, 32, x11)

inst_5:
// rs1==x29, rs2==x1, rd==x14, rs2_h1_val == -8193, rs2_h0_val == -8193
// opcode: kmmwb2 ; op1:x29; op2:x1; dest:x14; op1val:0xfffffff6;  op2val:0xdfffdfff
TEST_PKRR_OP(kmmwb2, x14, x29, x1, 0x00000000, 0xfffffff6, 0xdfffdfff, x29, x3, 40, x11)

inst_6:
// rs1==x22, rs2==x19, rd==x7, rs2_h1_val == -4097, rs1_w0_val == -17, rs2_h0_val == 1
// opcode: kmmwb2 ; op1:x22; op2:x19; dest:x7; op1val:0xffffffef;  op2val:0xefff0001
TEST_PKRR_OP(kmmwb2, x7, x22, x19, 0x00000000, 0xffffffef, 0xefff0001, x22, x3, 48, x11)

inst_7:
// rs1==x10, rs2==x29, rd==x23, rs2_h1_val == -2049, rs1_w0_val == 1048576, rs2_h0_val == -32768
// opcode: kmmwb2 ; op1:x10; op2:x29; dest:x23; op1val:0x100000;  op2val:0xf7ff8000
TEST_PKRR_OP(kmmwb2, x23, x10, x29, 0x00000000, 0x100000, 0xf7ff8000, x10, x3, 56, x11)

inst_8:
// rs1==x0, rs2==x24, rd==x28, rs2_h1_val == -1025, rs1_w0_val == -33554433
// opcode: kmmwb2 ; op1:x0; op2:x24; dest:x28; op1val:0xfdffffff;  op2val:0xfbff0002
TEST_PKRR_OP(kmmwb2, x28, x0, x24, 0x00000000, 0xfdffffff, 0xfbff0002, x0, x3, 64, x11)

inst_9:
// rs1==x2, rs2==x22, rd==x27, rs2_h1_val == -513, rs2_h0_val == 32767
// opcode: kmmwb2 ; op1:x2; op2:x22; dest:x27; op1val:0xfffffff9;  op2val:0xfdff7fff
TEST_PKRR_OP(kmmwb2, x27, x2, x22, 0x00000000, 0xfffffff9, 0xfdff7fff, x2, x3, 72, x11)

inst_10:
// rs1==x23, rs2==x4, rd==x9, rs2_h1_val == -257, rs1_w0_val == 32768
// opcode: kmmwb2 ; op1:x23; op2:x4; dest:x9; op1val:0x008000;  op2val:0xfeffdfff
TEST_PKRR_OP(kmmwb2, x9, x23, x4, 0x00000000, 0x008000, 0xfeffdfff, x23, x3, 80, x11)

inst_11:
// rs1==x15, rs2==x5, rd==x25, rs2_h1_val == -129, rs1_w0_val == -1431655766, rs2_h0_val == 512
// opcode: kmmwb2 ; op1:x15; op2:x5; dest:x25; op1val:0xaaaaaaaa;  op2val:0xff7f0200
TEST_PKRR_OP(kmmwb2, x25, x15, x5, 0x00000000, 0xaaaaaaaa, 0xff7f0200, x15, x3, 88, x11)

inst_12:
// rs1==x8, rs2==x30, rd==x16, rs2_h1_val == -65, rs2_h0_val == -5
// opcode: kmmwb2 ; op1:x8; op2:x30; dest:x16; op1val:0xfffffff9;  op2val:0xffbffffb
TEST_PKRR_OP(kmmwb2, x16, x8, x30, 0x00000000, 0xfffffff9, 0xffbffffb, x8, x3, 96, x11)
RVTEST_SIGBASE(x2,signature_x2_0)

inst_13:
// rs1==x9, rs2==x13, rd==x29, rs2_h1_val == -33, rs1_w0_val == 1073741824, rs2_h0_val == 0
// opcode: kmmwb2 ; op1:x9; op2:x13; dest:x29; op1val:0x40000000;  op2val:0xffdf0000
TEST_PKRR_OP(kmmwb2, x29, x9, x13, 0x00000000, 0x40000000, 0xffdf0000, x9, x2, 0, x5)

inst_14:
// rs1==x16, rs2==x14, rd==x15, rs2_h1_val == -17, rs1_w0_val == -129, rs2_h0_val == 2048
// opcode: kmmwb2 ; op1:x16; op2:x14; dest:x15; op1val:0xffffff7f;  op2val:0xffef0800
TEST_PKRR_OP(kmmwb2, x15, x16, x14, 0x00000000, 0xffffff7f, 0xffef0800, x16, x2, 8, x5)

inst_15:
// rs1==x11, rs2==x8, rd==x26, rs2_h1_val == -9, 
// opcode: kmmwb2 ; op1:x11; op2:x8; dest:x26; op1val:0x800000;  op2val:0xfff73fff
TEST_PKRR_OP(kmmwb2, x26, x11, x8, 0x00000000, 0x800000, 0xfff73fff, x11, x2, 16, x5)

inst_16:
// rs1==x7, rs2==x9, rd==x30, rs2_h1_val == -5, rs1_w0_val == 128, rs2_h0_val == 256
// opcode: kmmwb2 ; op1:x7; op2:x9; dest:x30; op1val:0x000080;  op2val:0xfffb0100
TEST_PKRR_OP(kmmwb2, x30, x7, x9, 0x00000000, 0x000080, 0xfffb0100, x7, x2, 24, x5)

inst_17:
// rs1==x3, rs2==x12, rd==x4, rs2_h1_val == -3, rs1_w0_val == -4194305
// opcode: kmmwb2 ; op1:x3; op2:x12; dest:x4; op1val:0xffbfffff;  op2val:0xfffd0002
TEST_PKRR_OP(kmmwb2, x4, x3, x12, 0x00000000, 0xffbfffff, 0xfffd0002, x3, x2, 32, x5)

inst_18:
// rs1==x30, rs2==x3, rd==x1, rs2_h1_val == -32768, 
// opcode: kmmwb2 ; op1:x30; op2:x3; dest:x1; op1val:0x80000000;  op2val:0x80000080
TEST_PKRR_OP(kmmwb2, x1, x30, x3, 0x00000000, 0x80000000, 0x80000080, x30, x2, 40, x5)

inst_19:
// rs1==x25, rs2==x16, rd==x3, rs2_h1_val == 16384, rs1_w0_val == -65, rs2_h0_val == -129
// opcode: kmmwb2 ; op1:x25; op2:x16; dest:x3; op1val:0xffffffbf;  op2val:0x4000ff7f
TEST_PKRR_OP(kmmwb2, x3, x25, x16, 0x00000000, 0xffffffbf, 0x4000ff7f, x25, x2, 48, x5)

inst_20:
// rs1==x1, rs2==x25, rd==x11, rs2_h1_val == 8192, rs2_h0_val == -9, rs1_w0_val == -16385
// opcode: kmmwb2 ; op1:x1; op2:x25; dest:x11; op1val:0xffffbfff;  op2val:0x2000fff7
TEST_PKRR_OP(kmmwb2, x11, x1, x25, 0x00000000, 0xffffbfff, 0x2000fff7, x1, x2, 56, x5)

inst_21:
// rs1==x14, rs2==x11, rd==x8, rs2_h1_val == 4096, rs1_w0_val == 524288
// opcode: kmmwb2 ; op1:x14; op2:x11; dest:x8; op1val:0x080000;  op2val:0x10000000
TEST_PKRR_OP(kmmwb2, x8, x14, x11, 0x00000000, 0x080000, 0x10000000, x14, x2, 64, x5)

inst_22:
// rs1==x21, rs2==x23, rd==x0, rs2_h1_val == 2048, rs1_w0_val == 2097152
// opcode: kmmwb2 ; op1:x21; op2:x23; dest:x0; op1val:0x200000;  op2val:0x800fff6
TEST_PKRR_OP(kmmwb2, x0, x21, x23, 0x00000000, 0x200000, 0x800fff6, x21, x2, 72, x5)

inst_23:
// rs1==x28, rs2==x20, rd==x31, rs2_h1_val == 1024, rs1_w0_val == -3
// opcode: kmmwb2 ; op1:x28; op2:x20; dest:x31; op1val:0xfffffffd;  op2val:0x4003fff
TEST_PKRR_OP(kmmwb2, x31, x28, x20, 0x00000000, 0xfffffffd, 0x4003fff, x28, x2, 80, x5)

inst_24:
// rs1==x27, rs2==x10, rd==x21, rs2_h1_val == 512, 
// opcode: kmmwb2 ; op1:x27; op2:x10; dest:x21; op1val:0x3fffffff;  op2val:0x2003fff
TEST_PKRR_OP(kmmwb2, x21, x27, x10, 0x00000000, 0x3fffffff, 0x2003fff, x27, x2, 88, x5)

inst_25:
// rs1==x26, rs2==x31, rd==x18, rs2_h1_val == 256, rs2_h0_val == -513, rs1_w0_val == -268435457
// opcode: kmmwb2 ; op1:x26; op2:x31; dest:x18; op1val:0xefffffff;  op2val:0x100fdff
TEST_PKRR_OP(kmmwb2, x18, x26, x31, 0x00000000, 0xefffffff, 0x100fdff, x26, x2, 96, x5)

inst_26:
// rs1==x17, rs2==x0, rd==x10, rs2_h1_val == 128, rs1_w0_val == -257
// opcode: kmmwb2 ; op1:x17; op2:x0; dest:x10; op1val:0xfffffeff;  op2val:0x80fff8
TEST_PKRR_OP(kmmwb2, x10, x17, x0, 0x00000000, 0xfffffeff, 0x80fff8, x17, x2, 104, x5)

inst_27:
// rs1==x31, rs2==x21, rd==x13, rs2_h1_val == 64, rs1_w0_val == -536870913
// opcode: kmmwb2 ; op1:x31; op2:x21; dest:x13; op1val:0xdfffffff;  op2val:0x400006
TEST_PKRR_OP(kmmwb2, x13, x31, x21, 0x00000000, 0xdfffffff, 0x400006, x31, x2, 112, x5)

inst_28:
// rs1==x24, rs2==x15, rd==x19, rs2_h1_val == 32, 
// opcode: kmmwb2 ; op1:x24; op2:x15; dest:x19; op1val:0xffffffbf;  op2val:0x200001
TEST_PKRR_OP(kmmwb2, x19, x24, x15, 0x00000000, 0xffffffbf, 0x200001, x24, x2, 120, x5)
RVTEST_SIGBASE(x1,signature_x1_0)

inst_29:
// rs1==x20, rs2==x28, rd==x22, rs2_h1_val == 16, rs1_w0_val == 64
// opcode: kmmwb2 ; op1:x20; op2:x28; dest:x22; op1val:0x000040;  op2val:0x100001
TEST_PKRR_OP(kmmwb2, x22, x20, x28, 0x00000000, 0x000040, 0x100001, x20, x1, 0, x3)

inst_30:
// rs1==x19, rs2==x7, rd==x2, rs2_h1_val == 8, 
// opcode: kmmwb2 ; op1:x19; op2:x7; dest:x2; op1val:0xfffffff8;  op2val:0x080003
TEST_PKRR_OP(kmmwb2, x2, x19, x7, 0x00000000, 0xfffffff8, 0x080003, x19, x1, 8, x3)

inst_31:
// rs1==x12, rs2==x27, rd==x24, rs2_h1_val == 4, rs1_w0_val == -2097153, rs2_h0_val == -2
// opcode: kmmwb2 ; op1:x12; op2:x27; dest:x24; op1val:0xffdfffff;  op2val:0x04fffe
TEST_PKRR_OP(kmmwb2, x24, x12, x27, 0x00000000, 0xffdfffff, 0x04fffe, x12, x1, 16, x3)

inst_32:
// rs2_h1_val == 2, rs1_w0_val == 16384
// opcode: kmmwb2 ; op1:x30; op2:x29; dest:x31; op1val:0x004000;  op2val:0x020200
TEST_PKRR_OP(kmmwb2, x31, x30, x29, 0x00000000, 0x004000, 0x020200, x30, x1, 24, x3)

inst_33:
// rs2_h1_val == 1, rs1_w0_val == -1
// opcode: kmmwb2 ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x010002
TEST_PKRR_OP(kmmwb2, x31, x30, x29, 0x00000000, 0xffffffff, 0x010002, x30, x1, 32, x3)

inst_34:
// rs2_h1_val == 0, 
// opcode: kmmwb2 ; op1:x30; op2:x29; dest:x31; op1val:0xfffffffd;  op2val:0x003fff
TEST_PKRR_OP(kmmwb2, x31, x30, x29, 0x00000000, 0xfffffffd, 0x003fff, x30, x1, 40, x3)

inst_35:
// rs1_w0_val == 512, 
// opcode: kmmwb2 ; op1:x30; op2:x29; dest:x31; op1val:0x000200;  op2val:0xf7fffffa
TEST_PKRR_OP(kmmwb2, x31, x30, x29, 0x00000000, 0x000200, 0xf7fffffa, x30, x1, 48, x3)

inst_36:
// rs1_w0_val == 32, 
// opcode: kmmwb2 ; op1:x30; op2:x29; dest:x31; op1val:0x000020;  op2val:0x10007fff
TEST_PKRR_OP(kmmwb2, x31, x30, x29, 0x00000000, 0x000020, 0x10007fff, x30, x1, 56, x3)

inst_37:
// rs1_w0_val == 16, 
// opcode: kmmwb2 ; op1:x30; op2:x29; dest:x31; op1val:0x000010;  op2val:0x2007fff
TEST_PKRR_OP(kmmwb2, x31, x30, x29, 0x00000000, 0x000010, 0x2007fff, x30, x1, 64, x3)

inst_38:
// rs1_w0_val == 8, rs2_h0_val == 4096
// opcode: kmmwb2 ; op1:x30; op2:x29; dest:x31; op1val:0x000008;  op2val:0x051000
TEST_PKRR_OP(kmmwb2, x31, x30, x29, 0x00000000, 0x000008, 0x051000, x30, x1, 72, x3)

inst_39:
// rs1_w0_val == 4, 
// opcode: kmmwb2 ; op1:x30; op2:x29; dest:x31; op1val:0x000004;  op2val:0x800fff7
TEST_PKRR_OP(kmmwb2, x31, x30, x29, 0x00000000, 0x000004, 0x800fff7, x30, x1, 80, x3)

inst_40:
// rs1_w0_val == 2, rs2_h1_val == -1
// opcode: kmmwb2 ; op1:x30; op2:x29; dest:x31; op1val:0x000002;  op2val:0xfffffdff
TEST_PKRR_OP(kmmwb2, x31, x30, x29, 0x00000000, 0x000002, 0xfffffdff, x30, x1, 88, x3)

inst_41:
// rs1_w0_val == 1, 
// opcode: kmmwb2 ; op1:x30; op2:x29; dest:x31; op1val:0x000001;  op2val:0xf7ff0003
TEST_PKRR_OP(kmmwb2, x31, x30, x29, 0x00000000, 0x000001, 0xf7ff0003, x30, x1, 96, x3)

inst_42:
// rs1_w0_val == 0, 
// opcode: kmmwb2 ; op1:x30; op2:x29; dest:x31; op1val:0x000000;  op2val:0x1000002
TEST_PKRR_OP(kmmwb2, x31, x30, x29, 0x00000000, 0x000000, 0x1000002, x30, x1, 104, x3)

inst_43:
// rs2_h0_val == 21845, 
// opcode: kmmwb2 ; op1:x30; op2:x29; dest:x31; op1val:0xefffffff;  op2val:0xdfff5555
TEST_PKRR_OP(kmmwb2, x31, x30, x29, 0x00000000, 0xefffffff, 0xdfff5555, x30, x1, 112, x3)

inst_44:
// rs2_h0_val == -16385, rs1_w0_val == -9
// opcode: kmmwb2 ; op1:x30; op2:x29; dest:x31; op1val:0xfffffff7;  op2val:0xfffcbfff
TEST_PKRR_OP(kmmwb2, x31, x30, x29, 0x00000000, 0xfffffff7, 0xfffcbfff, x30, x1, 120, x3)

inst_45:
// rs2_h0_val == -4097, rs1_w0_val == -2049
// opcode: kmmwb2 ; op1:x30; op2:x29; dest:x31; op1val:0xfffff7ff;  op2val:0xaaaaefff
TEST_PKRR_OP(kmmwb2, x31, x30, x29, 0x00000000, 0xfffff7ff, 0xaaaaefff, x30, x1, 128, x3)

inst_46:
// rs2_h0_val == -2049, 
// opcode: kmmwb2 ; op1:x30; op2:x29; dest:x31; op1val:0xfffffeff;  op2val:0xfffff7ff
TEST_PKRR_OP(kmmwb2, x31, x30, x29, 0x00000000, 0xfffffeff, 0xfffff7ff, x30, x1, 136, x3)

inst_47:
// rs2_h0_val == -257, 
// opcode: kmmwb2 ; op1:x30; op2:x29; dest:x31; op1val:0x000080;  op2val:0x08feff
TEST_PKRR_OP(kmmwb2, x31, x30, x29, 0x00000000, 0x000080, 0x08feff, x30, x1, 144, x3)

inst_48:
// rs2_h0_val == -65, 
// opcode: kmmwb2 ; op1:x30; op2:x29; dest:x31; op1val:0x100000;  op2val:0x40ffbf
TEST_PKRR_OP(kmmwb2, x31, x30, x29, 0x00000000, 0x100000, 0x40ffbf, x30, x1, 152, x3)

inst_49:
// rs2_h0_val == -33, 
// opcode: kmmwb2 ; op1:x30; op2:x29; dest:x31; op1val:0xfffffffd;  op2val:0xc000ffdf
TEST_PKRR_OP(kmmwb2, x31, x30, x29, 0x00000000, 0xfffffffd, 0xc000ffdf, x30, x1, 160, x3)

inst_50:
// rs2_h0_val == -17, 
// opcode: kmmwb2 ; op1:x30; op2:x29; dest:x31; op1val:0x800000;  op2val:0x800ffef
TEST_PKRR_OP(kmmwb2, x31, x30, x29, 0x00000000, 0x800000, 0x800ffef, x30, x1, 168, x3)

inst_51:
// rs2_h0_val == -3, 
// opcode: kmmwb2 ; op1:x30; op2:x29; dest:x31; op1val:0xfffffff7;  op2val:0xfff9fffd
TEST_PKRR_OP(kmmwb2, x31, x30, x29, 0x00000000, 0xfffffff7, 0xfff9fffd, x30, x1, 176, x3)

inst_52:
// rs2_h0_val == 16384, rs1_w0_val == 262144
// opcode: kmmwb2 ; op1:x30; op2:x29; dest:x31; op1val:0x040000;  op2val:0x074000
TEST_PKRR_OP(kmmwb2, x31, x30, x29, 0x00000000, 0x040000, 0x074000, x30, x1, 184, x3)

inst_53:
// rs2_h0_val == 8192, 
// opcode: kmmwb2 ; op1:x30; op2:x29; dest:x31; op1val:0x000080;  op2val:0x2002000
TEST_PKRR_OP(kmmwb2, x31, x30, x29, 0x00000000, 0x000080, 0x2002000, x30, x1, 192, x3)

inst_54:
// rs2_h0_val == 1024, 
// opcode: kmmwb2 ; op1:x30; op2:x29; dest:x31; op1val:0x200000;  op2val:0xfffc0400
TEST_PKRR_OP(kmmwb2, x31, x30, x29, 0x00000000, 0x200000, 0xfffc0400, x30, x1, 200, x3)

inst_55:
// rs2_h0_val == 64, 
// opcode: kmmwb2 ; op1:x30; op2:x29; dest:x31; op1val:0x008000;  op2val:0xefff0040
TEST_PKRR_OP(kmmwb2, x31, x30, x29, 0x00000000, 0x008000, 0xefff0040, x30, x1, 208, x3)

inst_56:
// rs2_h0_val == 32, rs1_w0_val == 536870912
// opcode: kmmwb2 ; op1:x30; op2:x29; dest:x31; op1val:0x20000000;  op2val:0x800020
TEST_PKRR_OP(kmmwb2, x31, x30, x29, 0x00000000, 0x20000000, 0x800020, x30, x1, 216, x3)

inst_57:
// rs2_h0_val == 16, 
// opcode: kmmwb2 ; op1:x30; op2:x29; dest:x31; op1val:0xffffffef;  op2val:0xff7f0010
TEST_PKRR_OP(kmmwb2, x31, x30, x29, 0x00000000, 0xffffffef, 0xff7f0010, x30, x1, 224, x3)

inst_58:
// rs2_h0_val == 8, rs1_w0_val == -1048577
// opcode: kmmwb2 ; op1:x30; op2:x29; dest:x31; op1val:0xffefffff;  op2val:0xff7f0008
TEST_PKRR_OP(kmmwb2, x31, x30, x29, 0x00000000, 0xffefffff, 0xff7f0008, x30, x1, 232, x3)

inst_59:
// rs2_h0_val == 4, 
// opcode: kmmwb2 ; op1:x30; op2:x29; dest:x31; op1val:0x000003;  op2val:0xbfff0004
TEST_PKRR_OP(kmmwb2, x31, x30, x29, 0x00000000, 0x000003, 0xbfff0004, x30, x1, 240, x3)

inst_60:
// rs2_h0_val == -1, 
// opcode: kmmwb2 ; op1:x30; op2:x29; dest:x31; op1val:0x000007;  op2val:0x01ffff
TEST_PKRR_OP(kmmwb2, x31, x30, x29, 0x00000000, 0x000007, 0x01ffff, x30, x1, 248, x3)

inst_61:
// rs1_w0_val == 1431655765, 
// opcode: kmmwb2 ; op1:x30; op2:x29; dest:x31; op1val:0x55555555;  op2val:0x00ffff
TEST_PKRR_OP(kmmwb2, x31, x30, x29, 0x00000000, 0x55555555, 0x00ffff, x30, x1, 256, x3)

inst_62:
// rs1_w0_val == 2147483647, 
// opcode: kmmwb2 ; op1:x30; op2:x29; dest:x31; op1val:0x7fffffff;  op2val:0x55555555
TEST_PKRR_OP(kmmwb2, x31, x30, x29, 0x00000000, 0x7fffffff, 0x55555555, x30, x1, 264, x3)

inst_63:
// rs1_w0_val == -1073741825, 
// opcode: kmmwb2 ; op1:x30; op2:x29; dest:x31; op1val:0xbfffffff;  op2val:0x8000009
TEST_PKRR_OP(kmmwb2, x31, x30, x29, 0x00000000, 0xbfffffff, 0x8000009, x30, x1, 272, x3)

inst_64:
// rs1_w0_val == -134217729, 
// opcode: kmmwb2 ; op1:x30; op2:x29; dest:x31; op1val:0xf7ffffff;  op2val:0xfffb8000
TEST_PKRR_OP(kmmwb2, x31, x30, x29, 0x00000000, 0xf7ffffff, 0xfffb8000, x30, x1, 280, x3)

inst_65:
// rs1_w0_val == -67108865, 
// opcode: kmmwb2 ; op1:x30; op2:x29; dest:x31; op1val:0xfbffffff;  op2val:0x20001000
TEST_PKRR_OP(kmmwb2, x31, x30, x29, 0x00000000, 0xfbffffff, 0x20001000, x30, x1, 288, x3)

inst_66:
// rs1_w0_val == -16777217, 
// opcode: kmmwb2 ; op1:x30; op2:x29; dest:x31; op1val:0xfeffffff;  op2val:0xfff80001
TEST_PKRR_OP(kmmwb2, x31, x30, x29, 0x00000000, 0xfeffffff, 0xfff80001, x30, x1, 296, x3)

inst_67:
// rs1_w0_val == -8388609, 
// opcode: kmmwb2 ; op1:x30; op2:x29; dest:x31; op1val:0xff7fffff;  op2val:0xfff72000
TEST_PKRR_OP(kmmwb2, x31, x30, x29, 0x00000000, 0xff7fffff, 0xfff72000, x30, x1, 304, x3)

inst_68:
// rs1_w0_val == -524289, 
// opcode: kmmwb2 ; op1:x30; op2:x29; dest:x31; op1val:0xfff7ffff;  op2val:0x100f7ff
TEST_PKRR_OP(kmmwb2, x31, x30, x29, 0x00000000, 0xfff7ffff, 0x100f7ff, x30, x1, 312, x3)

inst_69:
// rs1_w0_val == -131073, 
// opcode: kmmwb2 ; op1:x30; op2:x29; dest:x31; op1val:0xfffdffff;  op2val:0xfffc0200
TEST_PKRR_OP(kmmwb2, x31, x30, x29, 0x00000000, 0xfffdffff, 0xfffc0200, x30, x1, 320, x3)

inst_70:
// rs1_w0_val == -65537, 
// opcode: kmmwb2 ; op1:x30; op2:x29; dest:x31; op1val:0xfffeffff;  op2val:0x1000efff
TEST_PKRR_OP(kmmwb2, x31, x30, x29, 0x00000000, 0xfffeffff, 0x1000efff, x30, x1, 328, x3)

inst_71:
// rs1_w0_val == -32769, 
// opcode: kmmwb2 ; op1:x30; op2:x29; dest:x31; op1val:0xffff7fff;  op2val:0x40f7ff
TEST_PKRR_OP(kmmwb2, x31, x30, x29, 0x00000000, 0xffff7fff, 0x40f7ff, x30, x1, 336, x3)

inst_72:
// rs1_w0_val == -8193, 
// opcode: kmmwb2 ; op1:x30; op2:x29; dest:x31; op1val:0xffffdfff;  op2val:0xfffd2000
TEST_PKRR_OP(kmmwb2, x31, x30, x29, 0x00000000, 0xffffdfff, 0xfffd2000, x30, x1, 344, x3)

inst_73:
// rs1_w0_val == -4097, 
// opcode: kmmwb2 ; op1:x30; op2:x29; dest:x31; op1val:0xffffefff;  op2val:0x3fff0007
TEST_PKRR_OP(kmmwb2, x31, x30, x29, 0x00000000, 0xffffefff, 0x3fff0007, x30, x1, 352, x3)

inst_74:
// rs1_w0_val == -1025, 
// opcode: kmmwb2 ; op1:x30; op2:x29; dest:x31; op1val:0xfffffbff;  op2val:0x2000ffbf
TEST_PKRR_OP(kmmwb2, x31, x30, x29, 0x00000000, 0xfffffbff, 0x2000ffbf, x30, x1, 360, x3)

inst_75:
// rs1_w0_val == -513, 
// opcode: kmmwb2 ; op1:x30; op2:x29; dest:x31; op1val:0xfffffdff;  op2val:0x3fff0100
TEST_PKRR_OP(kmmwb2, x31, x30, x29, 0x00000000, 0xfffffdff, 0x3fff0100, x30, x1, 368, x3)

inst_76:
// rs1_w0_val == -33, 
// opcode: kmmwb2 ; op1:x30; op2:x29; dest:x31; op1val:0xffffffdf;  op2val:0xefff0010
TEST_PKRR_OP(kmmwb2, x31, x30, x29, 0x00000000, 0xffffffdf, 0xefff0010, x30, x1, 376, x3)

inst_77:
// rs1_w0_val == -5, 
// opcode: kmmwb2 ; op1:x30; op2:x29; dest:x31; op1val:0xfffffffb;  op2val:0xefff0100
TEST_PKRR_OP(kmmwb2, x31, x30, x29, 0x00000000, 0xfffffffb, 0xefff0100, x30, x1, 384, x3)

inst_78:
// rs1_w0_val == -2, 
// opcode: kmmwb2 ; op1:x30; op2:x29; dest:x31; op1val:0xfffffffe;  op2val:0xdfff0020
TEST_PKRR_OP(kmmwb2, x31, x30, x29, 0x00000000, 0xfffffffe, 0xdfff0020, x30, x1, 392, x3)

inst_79:
// rs1_w0_val == 268435456, 
// opcode: kmmwb2 ; op1:x30; op2:x29; dest:x31; op1val:0x10000000;  op2val:0x00ffff
TEST_PKRR_OP(kmmwb2, x31, x30, x29, 0x00000000, 0x10000000, 0x00ffff, x30, x1, 400, x3)

inst_80:
// rs1_w0_val == 134217728, 
// opcode: kmmwb2 ; op1:x30; op2:x29; dest:x31; op1val:0x8000000;  op2val:0xfffaffbf
TEST_PKRR_OP(kmmwb2, x31, x30, x29, 0x00000000, 0x8000000, 0xfffaffbf, x30, x1, 408, x3)

inst_81:
// rs1_w0_val == 67108864, 
// opcode: kmmwb2 ; op1:x30; op2:x29; dest:x31; op1val:0x4000000;  op2val:0x007fff
TEST_PKRR_OP(kmmwb2, x31, x30, x29, 0x00000000, 0x4000000, 0x007fff, x30, x1, 416, x3)

inst_82:
// rs1_w0_val == 33554432, 
// opcode: kmmwb2 ; op1:x30; op2:x29; dest:x31; op1val:0x2000000;  op2val:0xc0000020
TEST_PKRR_OP(kmmwb2, x31, x30, x29, 0x00000000, 0x2000000, 0xc0000020, x30, x1, 424, x3)

inst_83:
// rs1_w0_val == 16777216, 
// opcode: kmmwb2 ; op1:x30; op2:x29; dest:x31; op1val:0x1000000;  op2val:0x100feff
TEST_PKRR_OP(kmmwb2, x31, x30, x29, 0x00000000, 0x1000000, 0x100feff, x30, x1, 432, x3)

inst_84:
// rs1_w0_val == 4194304, 
// opcode: kmmwb2 ; op1:x30; op2:x29; dest:x31; op1val:0x400000;  op2val:0xfff6fff8
TEST_PKRR_OP(kmmwb2, x31, x30, x29, 0x00000000, 0x400000, 0xfff6fff8, x30, x1, 440, x3)

inst_85:
// rs1_w0_val == 131072, 
// opcode: kmmwb2 ; op1:x30; op2:x29; dest:x31; op1val:0x020000;  op2val:0xfffaaaaa
TEST_PKRR_OP(kmmwb2, x31, x30, x29, 0x00000000, 0x020000, 0xfffaaaaa, x30, x1, 448, x3)

inst_86:
// rs1_w0_val == 65536, 
// opcode: kmmwb2 ; op1:x30; op2:x29; dest:x31; op1val:0x010000;  op2val:0xbfff0800
TEST_PKRR_OP(kmmwb2, x31, x30, x29, 0x00000000, 0x010000, 0xbfff0800, x30, x1, 456, x3)

inst_87:
// rs1_w0_val == 8192, 
// opcode: kmmwb2 ; op1:x30; op2:x29; dest:x31; op1val:0x002000;  op2val:0x09fff8
TEST_PKRR_OP(kmmwb2, x31, x30, x29, 0x00000000, 0x002000, 0x09fff8, x30, x1, 464, x3)

inst_88:
// rs1_w0_val == 4096, 
// opcode: kmmwb2 ; op1:x30; op2:x29; dest:x31; op1val:0x001000;  op2val:0x030005
TEST_PKRR_OP(kmmwb2, x31, x30, x29, 0x00000000, 0x001000, 0x030005, x30, x1, 472, x3)

inst_89:
// rs1_w0_val == 2048, 
// opcode: kmmwb2 ; op1:x30; op2:x29; dest:x31; op1val:0x000800;  op2val:0x5555fffe
TEST_PKRR_OP(kmmwb2, x31, x30, x29, 0x00000000, 0x000800, 0x5555fffe, x30, x1, 480, x3)

inst_90:
// rs1_w0_val == 1024, 
// opcode: kmmwb2 ; op1:x30; op2:x29; dest:x31; op1val:0x000400;  op2val:0x55550400
TEST_PKRR_OP(kmmwb2, x31, x30, x29, 0x00000000, 0x000400, 0x55550400, x30, x1, 488, x3)

inst_91:
// rs2_h1_val == 32767, rs1_w0_val == -262145
// opcode: kmmwb2 ; op1:x30; op2:x29; dest:x31; op1val:0xfffbffff;  op2val:0x7fff0006
TEST_PKRR_OP(kmmwb2, x31, x30, x29, 0x00000000, 0xfffbffff, 0x7fff0006, x30, x1, 496, x3)

inst_92:
// rs2_h1_val == -1025, rs1_w0_val == -33554433
// opcode: kmmwb2 ; op1:x30; op2:x29; dest:x31; op1val:0xfdffffff;  op2val:0xfbff0002
TEST_PKRR_OP(kmmwb2, x31, x30, x29, 0x00000000, 0xfdffffff, 0xfbff0002, x30, x1, 504, x3)
#endif


RVTEST_CODE_END
RVMODEL_HALT

RVTEST_DATA_BEGIN
.align 4
rvtest_data:
.word 0xbabecafe
.word 0xabecafeb
.word 0xbecafeba
.word 0xecafebab
RVTEST_DATA_END

RVMODEL_DATA_BEGIN


signature_x3_0:
    .fill 0*(XLEN/32),4,0xdeadbeef


signature_x3_1:
    .fill 26*(XLEN/32),4,0xdeadbeef


signature_x2_0:
    .fill 32*(XLEN/32),4,0xdeadbeef


signature_x1_0:
    .fill 128*(XLEN/32),4,0xdeadbeef

#ifdef rvtest_mtrap_routine

mtrap_sigptr:
    .fill 64*(XLEN/32),4,0xdeadbeef

#endif

#ifdef rvtest_gpr_save

gpr_save:
    .fill 32*(XLEN/32),4,0xdeadbeef

#endif

RVMODEL_DATA_END
