
// -----------
// This file was generated by riscv_ctg (https://github.com/riscv-software-src/riscv-ctg)
// version   : 0.6.3
// timestamp : Sat Apr 23 14:53:29 2022 GMT
// usage     : riscv_ctg \
//                  --cgf /scratch/git-repo/github/riscv_ctg/sample_cgfs/dataset.cgf \
//                  --cgf /scratch/git-repo/github/riscv_ctg/sample_cgfs/rv32ip.cgf \
//                  --xlen 32  \
//                  --randomize \
// -----------
//
// -----------
// Copyright (c) 2020. RISC-V International. All rights reserved.
// SPDX-License-Identifier: BSD-3-Clause
// -----------
//
// This assembly file tests the kmmwt2 instruction of the RISC-V RV32PZicsr extension for the kmmwt2 covergroup.
// 
#include "model_test.h"
#include "arch_test.h"
RVTEST_ISA("RV32IPZicsr")

.section .text.init
.org 0x80
.globl rvtest_entry_point
rvtest_entry_point:
RVMODEL_BOOT
RVTEST_CODE_BEGIN

#ifdef TEST_CASE_1

RVTEST_CASE(0,"//check ISA:=regex(.*32.*);check ISA:=regex(.*I.*P.*Zicsr.*);def TEST_CASE_1=True;",kmmwt2)

RVTEST_VXSAT_ENABLE()
RVTEST_SIGBASE(x2,signature_x2_1)

inst_0:
// rs1 != rs2  and rs1 != rd and rs2 != rd, rs1==x31, rs2==x20, rd==x11, rs1_w0_val == -2147483648, rs2_h0_val == -129
// opcode: kmmwt2 ; op1:x31; op2:x20; dest:x11; op1val:0x80000000;  op2val:0xfff8ff7f
TEST_PKRR_OP(kmmwt2, x11, x31, x20, 0x00000000, 0x80000000, 0xfff8ff7f, x31, x2, 0, x5)

inst_1:
// rs1 == rs2 != rd, rs1==x10, rs2==x10, rd==x4, rs2_h1_val == -21846, rs1_w0_val == 128
// opcode: kmmwt2 ; op1:x10; op2:x10; dest:x4; op1val:0x000080;  op2val:0xaaaafffa
TEST_PKRR_OP(kmmwt2, x4, x10, x10, 0x00000000, 0x000080, 0xaaaafffa, x10, x2, 8, x5)

inst_2:
// rs1 == rd != rs2, rs1==x1, rs2==x14, rd==x1, rs2_h1_val == 21845, rs1_w0_val == 1073741824
// opcode: kmmwt2 ; op1:x1; op2:x14; dest:x1; op1val:0x40000000;  op2val:0x5555fff8
TEST_PKRR_OP(kmmwt2, x1, x1, x14, 0x00000000, 0x40000000, 0x5555fff8, x1, x2, 16, x5)

inst_3:
// rs1 == rs2 == rd, rs1==x18, rs2==x18, rd==x18, rs2_h1_val == 32767, rs1_w0_val == -16385, rs2_h0_val == 21845
// opcode: kmmwt2 ; op1:x18; op2:x18; dest:x18; op1val:0xffffbfff;  op2val:0x7fff5555
TEST_PKRR_OP(kmmwt2, x18, x18, x18, 0x00000000, 0xffffbfff, 0x7fff5555, x18, x2, 24, x5)

inst_4:
// rs2 == rd != rs1, rs1==x12, rs2==x7, rd==x7, rs2_h1_val == -16385, rs2_h0_val == 16384, rs1_w0_val == -131073
// opcode: kmmwt2 ; op1:x12; op2:x7; dest:x7; op1val:0xfffdffff;  op2val:0xbfff4000
TEST_PKRR_OP(kmmwt2, x7, x12, x7, 0x00000000, 0xfffdffff, 0xbfff4000, x12, x2, 32, x5)

inst_5:
// rs1==x27, rs2==x12, rd==x0, rs2_h1_val == -8193, 
// opcode: kmmwt2 ; op1:x27; op2:x12; dest:x0; op1val:0xfffffff9;  op2val:0xdffffff6
TEST_PKRR_OP(kmmwt2, x0, x27, x12, 0x00000000, 0xfffffff9, 0xdffffff6, x27, x2, 40, x5)

inst_6:
// rs1==x23, rs2==x9, rd==x14, rs2_h1_val == -4097, rs1_w0_val == 256, rs2_h0_val == -32768
// opcode: kmmwt2 ; op1:x23; op2:x9; dest:x14; op1val:0x000100;  op2val:0xefff8000
TEST_PKRR_OP(kmmwt2, x14, x23, x9, 0x00000000, 0x000100, 0xefff8000, x23, x2, 48, x5)

inst_7:
// rs1==x20, rs2==x15, rd==x21, rs2_h1_val == -2049, rs2_h0_val == 512
// opcode: kmmwt2 ; op1:x20; op2:x15; dest:x21; op1val:0x000100;  op2val:0xf7ff0200
TEST_PKRR_OP(kmmwt2, x21, x20, x15, 0x00000000, 0x000100, 0xf7ff0200, x20, x2, 56, x5)

inst_8:
// rs1==x15, rs2==x22, rd==x10, rs2_h1_val == -1025, rs2_h0_val == -4097
// opcode: kmmwt2 ; op1:x15; op2:x22; dest:x10; op1val:0x3fffffff;  op2val:0xfbffefff
TEST_PKRR_OP(kmmwt2, x10, x15, x22, 0x00000000, 0x3fffffff, 0xfbffefff, x15, x2, 64, x5)

inst_9:
// rs1==x21, rs2==x11, rd==x30, rs2_h1_val == -513, rs1_w0_val == 2147483647, rs2_h0_val == 1024
// opcode: kmmwt2 ; op1:x21; op2:x11; dest:x30; op1val:0x7fffffff;  op2val:0xfdff0400
TEST_PKRR_OP(kmmwt2, x30, x21, x11, 0x00000000, 0x7fffffff, 0xfdff0400, x21, x2, 72, x5)

inst_10:
// rs1==x30, rs2==x25, rd==x19, rs2_h1_val == -257, rs2_h0_val == 16, rs1_w0_val == -65537
// opcode: kmmwt2 ; op1:x30; op2:x25; dest:x19; op1val:0xfffeffff;  op2val:0xfeff0010
TEST_PKRR_OP(kmmwt2, x19, x30, x25, 0x00000000, 0xfffeffff, 0xfeff0010, x30, x2, 80, x5)

inst_11:
// rs1==x9, rs2==x0, rd==x29, rs2_h1_val == -129, rs2_h0_val == -17, rs1_w0_val == -268435457
// opcode: kmmwt2 ; op1:x9; op2:x0; dest:x29; op1val:0xefffffff;  op2val:0xff7fffef
TEST_PKRR_OP(kmmwt2, x29, x9, x0, 0x00000000, 0xefffffff, 0xff7fffef, x9, x2, 88, x5)

inst_12:
// rs1==x3, rs2==x19, rd==x13, rs2_h1_val == -65, rs1_w0_val == -1073741825
// opcode: kmmwt2 ; op1:x3; op2:x19; dest:x13; op1val:0xbfffffff;  op2val:0xffbf0003
TEST_PKRR_OP(kmmwt2, x13, x3, x19, 0x00000000, 0xbfffffff, 0xffbf0003, x3, x2, 96, x5)

inst_13:
// rs1==x11, rs2==x28, rd==x31, rs2_h1_val == -33, rs1_w0_val == 16384, rs2_h0_val == 0
// opcode: kmmwt2 ; op1:x11; op2:x28; dest:x31; op1val:0x004000;  op2val:0xffdf0000
TEST_PKRR_OP(kmmwt2, x31, x11, x28, 0x00000000, 0x004000, 0xffdf0000, x11, x2, 104, x5)

inst_14:
// rs1==x0, rs2==x13, rd==x25, rs2_h1_val == -17, rs1_w0_val == 4096
// opcode: kmmwt2 ; op1:x0; op2:x13; dest:x25; op1val:0x001000;  op2val:0xffefffef
TEST_PKRR_OP(kmmwt2, x25, x0, x13, 0x00000000, 0x001000, 0xffefffef, x0, x2, 112, x5)

inst_15:
// rs1==x14, rs2==x17, rd==x28, rs2_h1_val == -9, 
// opcode: kmmwt2 ; op1:x14; op2:x17; dest:x28; op1val:0x000080;  op2val:0xfff70200
TEST_PKRR_OP(kmmwt2, x28, x14, x17, 0x00000000, 0x000080, 0xfff70200, x14, x2, 120, x5)

inst_16:
// rs1==x8, rs2==x16, rd==x22, rs2_h1_val == -5, rs1_w0_val == -32769, rs2_h0_val == -257
// opcode: kmmwt2 ; op1:x8; op2:x16; dest:x22; op1val:0xffff7fff;  op2val:0xfffbfeff
TEST_PKRR_OP(kmmwt2, x22, x8, x16, 0x00000000, 0xffff7fff, 0xfffbfeff, x8, x2, 128, x5)

inst_17:
// rs1==x28, rs2==x29, rd==x17, rs2_h1_val == -3, 
// opcode: kmmwt2 ; op1:x28; op2:x29; dest:x17; op1val:0x7fffffff;  op2val:0xfffdefff
TEST_PKRR_OP(kmmwt2, x17, x28, x29, 0x00000000, 0x7fffffff, 0xfffdefff, x28, x2, 136, x11)

inst_18:
// rs1==x25, rs2==x26, rd==x8, rs2_h1_val == -2, rs2_h0_val == -2049
// opcode: kmmwt2 ; op1:x25; op2:x26; dest:x8; op1val:0x80000000;  op2val:0xfffef7ff
TEST_PKRR_OP(kmmwt2, x8, x25, x26, 0x00000000, 0x80000000, 0xfffef7ff, x25, x2, 144, x11)
RVTEST_SIGBASE(x10,signature_x10_0)

inst_19:
// rs1==x13, rs2==x3, rd==x24, rs2_h1_val == -32768, rs2_h0_val == -9
// opcode: kmmwt2 ; op1:x13; op2:x3; dest:x24; op1val:0xfffffff8;  op2val:0x8000fff7
TEST_PKRR_OP(kmmwt2, x24, x13, x3, 0x00000000, 0xfffffff8, 0x8000fff7, x13, x10, 0, x11)

inst_20:
// rs1==x19, rs2==x1, rd==x3, rs2_h1_val == 16384, rs2_h0_val == 32767
// opcode: kmmwt2 ; op1:x19; op2:x1; dest:x3; op1val:0xfffffff8;  op2val:0x40007fff
TEST_PKRR_OP(kmmwt2, x3, x19, x1, 0x00000000, 0xfffffff8, 0x40007fff, x19, x10, 8, x11)

inst_21:
// rs1==x16, rs2==x24, rd==x15, rs2_h1_val == 8192, rs2_h0_val == -5, rs1_w0_val == -8193
// opcode: kmmwt2 ; op1:x16; op2:x24; dest:x15; op1val:0xffffdfff;  op2val:0x2000fffb
TEST_PKRR_OP(kmmwt2, x15, x16, x24, 0x00000000, 0xffffdfff, 0x2000fffb, x16, x10, 16, x11)

inst_22:
// rs1==x6, rs2==x27, rd==x2, rs2_h1_val == 4096, rs2_h0_val == 32, rs1_w0_val == -33
// opcode: kmmwt2 ; op1:x6; op2:x27; dest:x2; op1val:0xffffffdf;  op2val:0x10000020
TEST_PKRR_OP(kmmwt2, x2, x6, x27, 0x00000000, 0xffffffdf, 0x10000020, x6, x10, 24, x11)

inst_23:
// rs1==x24, rs2==x21, rd==x6, rs2_h1_val == 2048, rs2_h0_val == -1
// opcode: kmmwt2 ; op1:x24; op2:x21; dest:x6; op1val:0x000009;  op2val:0x800ffff
TEST_PKRR_OP(kmmwt2, x6, x24, x21, 0x00000000, 0x000009, 0x800ffff, x24, x10, 32, x11)

inst_24:
// rs1==x2, rs2==x30, rd==x20, rs2_h1_val == 1024, rs2_h0_val == -65
// opcode: kmmwt2 ; op1:x2; op2:x30; dest:x20; op1val:0x7fffffff;  op2val:0x400ffbf
TEST_PKRR_OP(kmmwt2, x20, x2, x30, 0x00000000, 0x7fffffff, 0x400ffbf, x2, x10, 40, x11)

inst_25:
// rs1==x5, rs2==x23, rd==x26, rs2_h1_val == 512, rs2_h0_val == 1
// opcode: kmmwt2 ; op1:x5; op2:x23; dest:x26; op1val:0xefffffff;  op2val:0x2000001
TEST_PKRR_OP(kmmwt2, x26, x5, x23, 0x00000000, 0xefffffff, 0x2000001, x5, x10, 48, x11)

inst_26:
// rs1==x17, rs2==x2, rd==x9, rs2_h1_val == 256, rs1_w0_val == 32
// opcode: kmmwt2 ; op1:x17; op2:x2; dest:x9; op1val:0x000020;  op2val:0x1000005
TEST_PKRR_OP(kmmwt2, x9, x17, x2, 0x00000000, 0x000020, 0x1000005, x17, x10, 56, x11)

inst_27:
// rs1==x26, rs2==x6, rd==x5, rs2_h1_val == 128, rs1_w0_val == -65
// opcode: kmmwt2 ; op1:x26; op2:x6; dest:x5; op1val:0xffffffbf;  op2val:0x80fff6
TEST_PKRR_OP(kmmwt2, x5, x26, x6, 0x00000000, 0xffffffbf, 0x80fff6, x26, x10, 64, x11)

inst_28:
// rs1==x4, rs2==x8, rd==x16, rs2_h1_val == 64, rs2_h0_val == 4096
// opcode: kmmwt2 ; op1:x4; op2:x8; dest:x16; op1val:0xfffffff9;  op2val:0x401000
TEST_PKRR_OP(kmmwt2, x16, x4, x8, 0x00000000, 0xfffffff9, 0x401000, x4, x10, 72, x11)

inst_29:
// rs1==x7, rs2==x4, rd==x12, rs2_h1_val == 32, rs2_h0_val == -8193, rs1_w0_val == -2049
// opcode: kmmwt2 ; op1:x7; op2:x4; dest:x12; op1val:0xfffff7ff;  op2val:0x20dfff
TEST_PKRR_OP(kmmwt2, x12, x7, x4, 0x00000000, 0xfffff7ff, 0x20dfff, x7, x10, 80, x11)

inst_30:
// rs1==x22, rs2==x5, rd==x27, rs2_h1_val == 16, rs1_w0_val == -5
// opcode: kmmwt2 ; op1:x22; op2:x5; dest:x27; op1val:0xfffffffb;  op2val:0x100007
TEST_PKRR_OP(kmmwt2, x27, x22, x5, 0x00000000, 0xfffffffb, 0x100007, x22, x10, 88, x11)

inst_31:
// rs1==x29, rs2==x31, rd==x23, rs2_h1_val == 8, rs1_w0_val == 4194304, rs2_h0_val == 4
// opcode: kmmwt2 ; op1:x29; op2:x31; dest:x23; op1val:0x400000;  op2val:0x080004
TEST_PKRR_OP(kmmwt2, x23, x29, x31, 0x00000000, 0x400000, 0x080004, x29, x10, 96, x1)

inst_32:
// rs2_h1_val == 4, rs1_w0_val == 2097152
// opcode: kmmwt2 ; op1:x30; op2:x29; dest:x31; op1val:0x200000;  op2val:0x040000
TEST_PKRR_OP(kmmwt2, x31, x30, x29, 0x00000000, 0x200000, 0x040000, x30, x10, 104, x1)

inst_33:
// rs2_h1_val == 2, rs1_w0_val == -17
// opcode: kmmwt2 ; op1:x30; op2:x29; dest:x31; op1val:0xffffffef;  op2val:0x020003
TEST_PKRR_OP(kmmwt2, x31, x30, x29, 0x00000000, 0xffffffef, 0x020003, x30, x10, 112, x1)

inst_34:
// rs2_h1_val == 1, rs1_w0_val == 33554432
// opcode: kmmwt2 ; op1:x30; op2:x29; dest:x31; op1val:0x2000000;  op2val:0x01ffef
TEST_PKRR_OP(kmmwt2, x31, x30, x29, 0x00000000, 0x2000000, 0x01ffef, x30, x10, 120, x1)

inst_35:
// rs1_w0_val == 512, 
// opcode: kmmwt2 ; op1:x30; op2:x29; dest:x31; op1val:0x000200;  op2val:0xffdf0005
TEST_PKRR_OP(kmmwt2, x31, x30, x29, 0x00000000, 0x000200, 0xffdf0005, x30, x10, 128, x1)

inst_36:
// rs1_w0_val == 64, rs2_h0_val == 2048
// opcode: kmmwt2 ; op1:x30; op2:x29; dest:x31; op1val:0x000040;  op2val:0x050800
TEST_PKRR_OP(kmmwt2, x31, x30, x29, 0x00000000, 0x000040, 0x050800, x30, x10, 136, x1)

inst_37:
// rs1_w0_val == 16, rs2_h0_val == 8
// opcode: kmmwt2 ; op1:x30; op2:x29; dest:x31; op1val:0x000010;  op2val:0xfffc0008
TEST_PKRR_OP(kmmwt2, x31, x30, x29, 0x00000000, 0x000010, 0xfffc0008, x30, x10, 144, x1)

inst_38:
// rs1_w0_val == 8, rs2_h0_val == -3
// opcode: kmmwt2 ; op1:x30; op2:x29; dest:x31; op1val:0x000008;  op2val:0x10fffd
TEST_PKRR_OP(kmmwt2, x31, x30, x29, 0x00000000, 0x000008, 0x10fffd, x30, x10, 152, x1)

inst_39:
// rs1_w0_val == 4, 
// opcode: kmmwt2 ; op1:x30; op2:x29; dest:x31; op1val:0x000004;  op2val:0xfeff0200
TEST_PKRR_OP(kmmwt2, x31, x30, x29, 0x00000000, 0x000004, 0xfeff0200, x30, x10, 160, x1)

inst_40:
// rs1_w0_val == 2, 
// opcode: kmmwt2 ; op1:x30; op2:x29; dest:x31; op1val:0x000002;  op2val:0x100007
TEST_PKRR_OP(kmmwt2, x31, x30, x29, 0x00000000, 0x000002, 0x100007, x30, x10, 168, x1)

inst_41:
// rs1_w0_val == 1, 
// opcode: kmmwt2 ; op1:x30; op2:x29; dest:x31; op1val:0x000001;  op2val:0xbffffffa
TEST_PKRR_OP(kmmwt2, x31, x30, x29, 0x00000000, 0x000001, 0xbffffffa, x30, x10, 176, x1)

inst_42:
// rs1_w0_val == 0, 
// opcode: kmmwt2 ; op1:x30; op2:x29; dest:x31; op1val:0x000000;  op2val:0x5555ff7f
TEST_PKRR_OP(kmmwt2, x31, x30, x29, 0x00000000, 0x000000, 0x5555ff7f, x30, x10, 184, x1)

inst_43:
// rs1_w0_val == -1, 
// opcode: kmmwt2 ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x4000feff
TEST_PKRR_OP(kmmwt2, x31, x30, x29, 0x00000000, 0xffffffff, 0x4000feff, x30, x10, 192, x1)

inst_44:
// rs2_h1_val == 0, rs1_w0_val == -4194305
// opcode: kmmwt2 ; op1:x30; op2:x29; dest:x31; op1val:0xffbfffff;  op2val:0x00fff9
TEST_PKRR_OP(kmmwt2, x31, x30, x29, 0x00000000, 0xffbfffff, 0x00fff9, x30, x10, 200, x1)

inst_45:
// rs2_h1_val == -1, 
// opcode: kmmwt2 ; op1:x30; op2:x29; dest:x31; op1val:0xffff7fff;  op2val:0xffff0020
TEST_PKRR_OP(kmmwt2, x31, x30, x29, 0x00000000, 0xffff7fff, 0xffff0020, x30, x10, 208, x1)

inst_46:
// rs2_h0_val == -21846, rs1_w0_val == -1431655766
// opcode: kmmwt2 ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaaa;  op2val:0x05aaaa
TEST_PKRR_OP(kmmwt2, x31, x30, x29, 0x00000000, 0xaaaaaaaa, 0x05aaaa, x30, x10, 216, x1)

inst_47:
// rs2_h0_val == -16385, rs1_w0_val == -16777217
// opcode: kmmwt2 ; op1:x30; op2:x29; dest:x31; op1val:0xfeffffff;  op2val:0xfbffbfff
TEST_PKRR_OP(kmmwt2, x31, x30, x29, 0x00000000, 0xfeffffff, 0xfbffbfff, x30, x10, 224, x1)

inst_48:
// rs2_h0_val == -1025, rs1_w0_val == -8388609
// opcode: kmmwt2 ; op1:x30; op2:x29; dest:x31; op1val:0xff7fffff;  op2val:0xfffcfbff
TEST_PKRR_OP(kmmwt2, x31, x30, x29, 0x00000000, 0xff7fffff, 0xfffcfbff, x30, x10, 232, x1)

inst_49:
// rs2_h0_val == -513, 
// opcode: kmmwt2 ; op1:x30; op2:x29; dest:x31; op1val:0x000001;  op2val:0xfefffdff
TEST_PKRR_OP(kmmwt2, x31, x30, x29, 0x00000000, 0x000001, 0xfefffdff, x30, x10, 240, x1)

inst_50:
// rs2_h0_val == -33, rs1_w0_val == -4097
// opcode: kmmwt2 ; op1:x30; op2:x29; dest:x31; op1val:0xffffefff;  op2val:0x20ffdf
TEST_PKRR_OP(kmmwt2, x31, x30, x29, 0x00000000, 0xffffefff, 0x20ffdf, x30, x10, 248, x1)

inst_51:
// rs2_h0_val == -2, rs1_w0_val == 131072
// opcode: kmmwt2 ; op1:x30; op2:x29; dest:x31; op1val:0x020000;  op2val:0xffbffffe
TEST_PKRR_OP(kmmwt2, x31, x30, x29, 0x00000000, 0x020000, 0xffbffffe, x30, x10, 256, x1)

inst_52:
// rs2_h0_val == 8192, 
// opcode: kmmwt2 ; op1:x30; op2:x29; dest:x31; op1val:0xfffffff9;  op2val:0xffbf2000
TEST_PKRR_OP(kmmwt2, x31, x30, x29, 0x00000000, 0xfffffff9, 0xffbf2000, x30, x10, 264, x1)

inst_53:
// rs2_h0_val == 256, 
// opcode: kmmwt2 ; op1:x30; op2:x29; dest:x31; op1val:0xffffefff;  op2val:0x200100
TEST_PKRR_OP(kmmwt2, x31, x30, x29, 0x00000000, 0xffffefff, 0x200100, x30, x10, 272, x1)

inst_54:
// rs2_h0_val == 128, 
// opcode: kmmwt2 ; op1:x30; op2:x29; dest:x31; op1val:0xc0000000;  op2val:0xfbff0080
TEST_PKRR_OP(kmmwt2, x31, x30, x29, 0x00000000, 0xc0000000, 0xfbff0080, x30, x10, 280, x1)

inst_55:
// rs2_h0_val == 64, rs1_w0_val == 8388608
// opcode: kmmwt2 ; op1:x30; op2:x29; dest:x31; op1val:0x800000;  op2val:0xffbf0040
TEST_PKRR_OP(kmmwt2, x31, x30, x29, 0x00000000, 0x800000, 0xffbf0040, x30, x10, 288, x1)

inst_56:
// rs2_h0_val == 2, 
// opcode: kmmwt2 ; op1:x30; op2:x29; dest:x31; op1val:0xbfffffff;  op2val:0xfff90002
TEST_PKRR_OP(kmmwt2, x31, x30, x29, 0x00000000, 0xbfffffff, 0xfff90002, x30, x10, 296, x1)

inst_57:
// rs1_w0_val == 1431655765, 
// opcode: kmmwt2 ; op1:x30; op2:x29; dest:x31; op1val:0x55555555;  op2val:0x053fff
TEST_PKRR_OP(kmmwt2, x31, x30, x29, 0x00000000, 0x55555555, 0x053fff, x30, x10, 304, x1)

inst_58:
// rs1_w0_val == -536870913, 
// opcode: kmmwt2 ; op1:x30; op2:x29; dest:x31; op1val:0xdfffffff;  op2val:0x10ffff
TEST_PKRR_OP(kmmwt2, x31, x30, x29, 0x00000000, 0xdfffffff, 0x10ffff, x30, x10, 312, x1)

inst_59:
// rs1_w0_val == -134217729, 
// opcode: kmmwt2 ; op1:x30; op2:x29; dest:x31; op1val:0xf7ffffff;  op2val:0xf7ff8000
TEST_PKRR_OP(kmmwt2, x31, x30, x29, 0x00000000, 0xf7ffffff, 0xf7ff8000, x30, x10, 320, x1)

inst_60:
// rs1_w0_val == -67108865, 
// opcode: kmmwt2 ; op1:x30; op2:x29; dest:x31; op1val:0xfbffffff;  op2val:0xfbff1000
TEST_PKRR_OP(kmmwt2, x31, x30, x29, 0x00000000, 0xfbffffff, 0xfbff1000, x30, x10, 328, x1)

inst_61:
// rs1_w0_val == -33554433, 
// opcode: kmmwt2 ; op1:x30; op2:x29; dest:x31; op1val:0xfdffffff;  op2val:0x07ffff
TEST_PKRR_OP(kmmwt2, x31, x30, x29, 0x00000000, 0xfdffffff, 0x07ffff, x30, x10, 336, x1)

inst_62:
// rs1_w0_val == -2097153, 
// opcode: kmmwt2 ; op1:x30; op2:x29; dest:x31; op1val:0xffdfffff;  op2val:0x1000200
TEST_PKRR_OP(kmmwt2, x31, x30, x29, 0x00000000, 0xffdfffff, 0x1000200, x30, x10, 344, x1)

inst_63:
// rs1_w0_val == -1048577, 
// opcode: kmmwt2 ; op1:x30; op2:x29; dest:x31; op1val:0xffefffff;  op2val:0xfff7aaaa
TEST_PKRR_OP(kmmwt2, x31, x30, x29, 0x00000000, 0xffefffff, 0xfff7aaaa, x30, x10, 352, x1)

inst_64:
// rs1_w0_val == -524289, 
// opcode: kmmwt2 ; op1:x30; op2:x29; dest:x31; op1val:0xfff7ffff;  op2val:0x20fffe
TEST_PKRR_OP(kmmwt2, x31, x30, x29, 0x00000000, 0xfff7ffff, 0x20fffe, x30, x10, 360, x1)

inst_65:
// rs1_w0_val == -262145, 
// opcode: kmmwt2 ; op1:x30; op2:x29; dest:x31; op1val:0xfffbffff;  op2val:0xf7ff0003
TEST_PKRR_OP(kmmwt2, x31, x30, x29, 0x00000000, 0xfffbffff, 0xf7ff0003, x30, x10, 368, x1)

inst_66:
// rs1_w0_val == -1025, 
// opcode: kmmwt2 ; op1:x30; op2:x29; dest:x31; op1val:0xfffffbff;  op2val:0xf7ffffdf
TEST_PKRR_OP(kmmwt2, x31, x30, x29, 0x00000000, 0xfffffbff, 0xf7ffffdf, x30, x10, 376, x1)

inst_67:
// rs1_w0_val == -513, 
// opcode: kmmwt2 ; op1:x30; op2:x29; dest:x31; op1val:0xfffffdff;  op2val:0xfffc0007
TEST_PKRR_OP(kmmwt2, x31, x30, x29, 0x00000000, 0xfffffdff, 0xfffc0007, x30, x10, 384, x1)

inst_68:
// rs1_w0_val == -257, 
// opcode: kmmwt2 ; op1:x30; op2:x29; dest:x31; op1val:0xfffffeff;  op2val:0x088000
TEST_PKRR_OP(kmmwt2, x31, x30, x29, 0x00000000, 0xfffffeff, 0x088000, x30, x10, 392, x1)

inst_69:
// rs1_w0_val == -129, 
// opcode: kmmwt2 ; op1:x30; op2:x29; dest:x31; op1val:0xffffff7f;  op2val:0x200fff6
TEST_PKRR_OP(kmmwt2, x31, x30, x29, 0x00000000, 0xffffff7f, 0x200fff6, x30, x10, 400, x1)

inst_70:
// rs1_w0_val == -9, 
// opcode: kmmwt2 ; op1:x30; op2:x29; dest:x31; op1val:0xfffffff7;  op2val:0x800ffef
TEST_PKRR_OP(kmmwt2, x31, x30, x29, 0x00000000, 0xfffffff7, 0x800ffef, x30, x10, 408, x1)

inst_71:
// rs1_w0_val == -3, 
// opcode: kmmwt2 ; op1:x30; op2:x29; dest:x31; op1val:0xfffffffd;  op2val:0xfbfffff6
TEST_PKRR_OP(kmmwt2, x31, x30, x29, 0x00000000, 0xfffffffd, 0xfbfffff6, x30, x10, 416, x1)

inst_72:
// rs1_w0_val == -2, 
// opcode: kmmwt2 ; op1:x30; op2:x29; dest:x31; op1val:0xfffffffe;  op2val:0xffbf0004
TEST_PKRR_OP(kmmwt2, x31, x30, x29, 0x00000000, 0xfffffffe, 0xffbf0004, x30, x10, 424, x1)

inst_73:
// rs1_w0_val == 536870912, 
// opcode: kmmwt2 ; op1:x30; op2:x29; dest:x31; op1val:0x20000000;  op2val:0xffff1000
TEST_PKRR_OP(kmmwt2, x31, x30, x29, 0x00000000, 0x20000000, 0xffff1000, x30, x10, 432, x1)

inst_74:
// rs1_w0_val == 268435456, 
// opcode: kmmwt2 ; op1:x30; op2:x29; dest:x31; op1val:0x10000000;  op2val:0xdfff0005
TEST_PKRR_OP(kmmwt2, x31, x30, x29, 0x00000000, 0x10000000, 0xdfff0005, x30, x10, 440, x1)

inst_75:
// rs1_w0_val == 134217728, 
// opcode: kmmwt2 ; op1:x30; op2:x29; dest:x31; op1val:0x8000000;  op2val:0x10000004
TEST_PKRR_OP(kmmwt2, x31, x30, x29, 0x00000000, 0x8000000, 0x10000004, x30, x10, 448, x1)

inst_76:
// rs1_w0_val == 67108864, 
// opcode: kmmwt2 ; op1:x30; op2:x29; dest:x31; op1val:0x4000000;  op2val:0x042000
TEST_PKRR_OP(kmmwt2, x31, x30, x29, 0x00000000, 0x4000000, 0x042000, x30, x10, 456, x1)

inst_77:
// rs1_w0_val == 16777216, 
// opcode: kmmwt2 ; op1:x30; op2:x29; dest:x31; op1val:0x1000000;  op2val:0x20fff7
TEST_PKRR_OP(kmmwt2, x31, x30, x29, 0x00000000, 0x1000000, 0x20fff7, x30, x10, 464, x1)

inst_78:
// rs1_w0_val == 1048576, 
// opcode: kmmwt2 ; op1:x30; op2:x29; dest:x31; op1val:0x100000;  op2val:0xaaaabfff
TEST_PKRR_OP(kmmwt2, x31, x30, x29, 0x00000000, 0x100000, 0xaaaabfff, x30, x10, 472, x1)

inst_79:
// rs1_w0_val == 524288, 
// opcode: kmmwt2 ; op1:x30; op2:x29; dest:x31; op1val:0x080000;  op2val:0x061000
TEST_PKRR_OP(kmmwt2, x31, x30, x29, 0x00000000, 0x080000, 0x061000, x30, x10, 480, x1)

inst_80:
// rs1_w0_val == 262144, 
// opcode: kmmwt2 ; op1:x30; op2:x29; dest:x31; op1val:0x040000;  op2val:0x08fff8
TEST_PKRR_OP(kmmwt2, x31, x30, x29, 0x00000000, 0x040000, 0x08fff8, x30, x10, 488, x1)

inst_81:
// rs1_w0_val == 65536, 
// opcode: kmmwt2 ; op1:x30; op2:x29; dest:x31; op1val:0x010000;  op2val:0xdffffff7
TEST_PKRR_OP(kmmwt2, x31, x30, x29, 0x00000000, 0x010000, 0xdffffff7, x30, x10, 496, x1)

inst_82:
// rs1_w0_val == 32768, 
// opcode: kmmwt2 ; op1:x30; op2:x29; dest:x31; op1val:0x008000;  op2val:0x20000080
TEST_PKRR_OP(kmmwt2, x31, x30, x29, 0x00000000, 0x008000, 0x20000080, x30, x10, 504, x1)

inst_83:
// rs1_w0_val == 8192, 
// opcode: kmmwt2 ; op1:x30; op2:x29; dest:x31; op1val:0x002000;  op2val:0xfff9fffa
TEST_PKRR_OP(kmmwt2, x31, x30, x29, 0x00000000, 0x002000, 0xfff9fffa, x30, x10, 512, x1)

inst_84:
// rs1_w0_val == 2048, 
// opcode: kmmwt2 ; op1:x30; op2:x29; dest:x31; op1val:0x000800;  op2val:0x20fffd
TEST_PKRR_OP(kmmwt2, x31, x30, x29, 0x00000000, 0x000800, 0x20fffd, x30, x10, 520, x1)

inst_85:
// rs1_w0_val == 1024, 
// opcode: kmmwt2 ; op1:x30; op2:x29; dest:x31; op1val:0x000400;  op2val:0x80fff9
TEST_PKRR_OP(kmmwt2, x31, x30, x29, 0x00000000, 0x000400, 0x80fff9, x30, x10, 528, x1)

inst_86:
// rs2_h1_val == 32767, rs1_w0_val == -16385, rs2_h0_val == 21845
// opcode: kmmwt2 ; op1:x30; op2:x29; dest:x31; op1val:0xffffbfff;  op2val:0x7fff5555
TEST_PKRR_OP(kmmwt2, x31, x30, x29, 0x00000000, 0xffffbfff, 0x7fff5555, x30, x10, 536, x1)

inst_87:
// rs2_h1_val == -129, rs2_h0_val == -17, rs1_w0_val == -268435457
// opcode: kmmwt2 ; op1:x30; op2:x29; dest:x31; op1val:0xefffffff;  op2val:0xff7fffef
TEST_PKRR_OP(kmmwt2, x31, x30, x29, 0x00000000, 0xefffffff, 0xff7fffef, x30, x10, 544, x1)

inst_88:
// rs2_h1_val == -17, rs1_w0_val == 4096
// opcode: kmmwt2 ; op1:x30; op2:x29; dest:x31; op1val:0x001000;  op2val:0xffefffef
TEST_PKRR_OP(kmmwt2, x31, x30, x29, 0x00000000, 0x001000, 0xffefffef, x30, x10, 552, x1)
#endif


RVTEST_CODE_END
RVMODEL_HALT

RVTEST_DATA_BEGIN
.align 4
rvtest_data:
.word 0xbabecafe
.word 0xabecafeb
.word 0xbecafeba
.word 0xecafebab
RVTEST_DATA_END

RVMODEL_DATA_BEGIN


signature_x2_0:
    .fill 0*(XLEN/32),4,0xdeadbeef


signature_x2_1:
    .fill 38*(XLEN/32),4,0xdeadbeef


signature_x10_0:
    .fill 140*(XLEN/32),4,0xdeadbeef

#ifdef rvtest_mtrap_routine

mtrap_sigptr:
    .fill 64*(XLEN/32),4,0xdeadbeef

#endif

#ifdef rvtest_gpr_save

gpr_save:
    .fill 32*(XLEN/32),4,0xdeadbeef

#endif

RVMODEL_DATA_END
