
// -----------
// This file was generated by riscv_ctg (https://github.com/riscv-software-src/riscv-ctg)
// version   : 0.6.3
// timestamp : Sat Apr 23 14:53:29 2022 GMT
// usage     : riscv_ctg \
//                  --cgf /scratch/git-repo/github/riscv_ctg/sample_cgfs/dataset.cgf \
//                  --cgf /scratch/git-repo/github/riscv_ctg/sample_cgfs/rv32ip.cgf \
//                  --xlen 32  \
//                  --randomize \
// -----------
//
// -----------
// Copyright (c) 2020. RISC-V International. All rights reserved.
// SPDX-License-Identifier: BSD-3-Clause
// -----------
//
// This assembly file tests the kmmwt2.u instruction of the RISC-V RV32PZicsr extension for the kmmwt2.u covergroup.
// 
#include "model_test.h"
#include "arch_test.h"
RVTEST_ISA("RV32IPZicsr")

.section .text.init
.org 0x80
.globl rvtest_entry_point
rvtest_entry_point:
RVMODEL_BOOT
RVTEST_CODE_BEGIN

#ifdef TEST_CASE_1

RVTEST_CASE(0,"//check ISA:=regex(.*32.*);check ISA:=regex(.*I.*P.*Zicsr.*);def TEST_CASE_1=True;",kmmwt2.u)

RVTEST_VXSAT_ENABLE()
RVTEST_SIGBASE(x13,signature_x13_1)

inst_0:
// rs1 != rs2  and rs1 != rd and rs2 != rd, rs1==x4, rs2==x24, rd==x25, rs1_w0_val == -2147483648, 
// opcode: kmmwt2.u ; op1:x4; op2:x24; dest:x25; op1val:0x80000000;  op2val:0xfff8fffc
TEST_PKRR_OP(kmmwt2.u, x25, x4, x24, 0x00000000, 0x80000000, 0xfff8fffc, x4, x13, 0, x17)

inst_1:
// rs1 == rs2 != rd, rs1==x19, rs2==x19, rd==x6, rs2_h1_val == -21846, rs2_h0_val == -65, rs1_w0_val == 16777216
// opcode: kmmwt2.u ; op1:x19; op2:x19; dest:x6; op1val:0x1000000;  op2val:0xaaaaffbf
TEST_PKRR_OP(kmmwt2.u, x6, x19, x19, 0x00000000, 0x1000000, 0xaaaaffbf, x19, x13, 8, x17)

inst_2:
// rs1 == rd != rs2, rs1==x3, rs2==x9, rd==x3, rs2_h1_val == 21845, rs2_h0_val == -9, rs1_w0_val == -2097153
// opcode: kmmwt2.u ; op1:x3; op2:x9; dest:x3; op1val:0xffdfffff;  op2val:0x5555fff7
TEST_PKRR_OP(kmmwt2.u, x3, x3, x9, 0x00000000, 0xffdfffff, 0x5555fff7, x3, x13, 16, x17)

inst_3:
// rs1 == rs2 == rd, rs1==x28, rs2==x28, rd==x28, rs2_h1_val == 32767, rs2_h0_val == 1024, rs1_w0_val == 4
// opcode: kmmwt2.u ; op1:x28; op2:x28; dest:x28; op1val:0x000004;  op2val:0x7fff0400
TEST_PKRR_OP(kmmwt2.u, x28, x28, x28, 0x00000000, 0x000004, 0x7fff0400, x28, x13, 24, x17)

inst_4:
// rs2 == rd != rs1, rs1==x22, rs2==x15, rd==x15, rs2_h1_val == -16385, rs1_w0_val == 2
// opcode: kmmwt2.u ; op1:x22; op2:x15; dest:x15; op1val:0x000002;  op2val:0xbfffffbf
TEST_PKRR_OP(kmmwt2.u, x15, x22, x15, 0x00000000, 0x000002, 0xbfffffbf, x22, x13, 32, x17)

inst_5:
// rs1==x5, rs2==x11, rd==x27, rs2_h1_val == -8193, 
// opcode: kmmwt2.u ; op1:x5; op2:x11; dest:x27; op1val:0xc0000000;  op2val:0xdfffffbf
TEST_PKRR_OP(kmmwt2.u, x27, x5, x11, 0x00000000, 0xc0000000, 0xdfffffbf, x5, x13, 40, x17)

inst_6:
// rs1==x27, rs2==x12, rd==x10, rs2_h1_val == -4097, rs1_w0_val == 0
// opcode: kmmwt2.u ; op1:x27; op2:x12; dest:x10; op1val:0x000000;  op2val:0xefff0006
TEST_PKRR_OP(kmmwt2.u, x10, x27, x12, 0x00000000, 0x000000, 0xefff0006, x27, x13, 48, x17)

inst_7:
// rs1==x10, rs2==x16, rd==x14, rs2_h1_val == -2049, rs1_w0_val == -134217729
// opcode: kmmwt2.u ; op1:x10; op2:x16; dest:x14; op1val:0xf7ffffff;  op2val:0xf7ff0007
TEST_PKRR_OP(kmmwt2.u, x14, x10, x16, 0x00000000, 0xf7ffffff, 0xf7ff0007, x10, x13, 56, x17)

inst_8:
// rs1==x20, rs2==x22, rd==x1, rs2_h1_val == -1025, rs1_w0_val == -33554433, rs2_h0_val == -2
// opcode: kmmwt2.u ; op1:x20; op2:x22; dest:x1; op1val:0xfdffffff;  op2val:0xfbfffffe
TEST_PKRR_OP(kmmwt2.u, x1, x20, x22, 0x00000000, 0xfdffffff, 0xfbfffffe, x20, x13, 64, x17)

inst_9:
// rs1==x11, rs2==x7, rd==x26, rs2_h1_val == -513, rs1_w0_val == 268435456, rs2_h0_val == -21846
// opcode: kmmwt2.u ; op1:x11; op2:x7; dest:x26; op1val:0x10000000;  op2val:0xfdffaaaa
TEST_PKRR_OP(kmmwt2.u, x26, x11, x7, 0x00000000, 0x10000000, 0xfdffaaaa, x11, x13, 72, x17)

inst_10:
// rs1==x23, rs2==x14, rd==x16, rs2_h1_val == -257, rs1_w0_val == 64, rs2_h0_val == 2
// opcode: kmmwt2.u ; op1:x23; op2:x14; dest:x16; op1val:0x000040;  op2val:0xfeff0002
TEST_PKRR_OP(kmmwt2.u, x16, x23, x14, 0x00000000, 0x000040, 0xfeff0002, x23, x13, 80, x17)

inst_11:
// rs1==x24, rs2==x6, rd==x23, rs2_h1_val == -129, rs2_h0_val == -33, rs1_w0_val == -257
// opcode: kmmwt2.u ; op1:x24; op2:x6; dest:x23; op1val:0xfffffeff;  op2val:0xff7fffdf
TEST_PKRR_OP(kmmwt2.u, x23, x24, x6, 0x00000000, 0xfffffeff, 0xff7fffdf, x24, x13, 88, x17)

inst_12:
// rs1==x18, rs2==x2, rd==x9, rs2_h1_val == -65, rs1_w0_val == -1
// opcode: kmmwt2.u ; op1:x18; op2:x2; dest:x9; op1val:0xffffffff;  op2val:0xffbf0002
TEST_PKRR_OP(kmmwt2.u, x9, x18, x2, 0x00000000, 0xffffffff, 0xffbf0002, x18, x13, 96, x17)

inst_13:
// rs1==x15, rs2==x23, rd==x22, rs2_h1_val == -33, rs2_h0_val == 256
// opcode: kmmwt2.u ; op1:x15; op2:x23; dest:x22; op1val:0x80000000;  op2val:0xffdf0100
TEST_PKRR_OP(kmmwt2.u, x22, x15, x23, 0x00000000, 0x80000000, 0xffdf0100, x15, x13, 104, x17)

inst_14:
// rs1==x25, rs2==x31, rd==x11, rs2_h1_val == -17, rs1_w0_val == -33, rs2_h0_val == 0
// opcode: kmmwt2.u ; op1:x25; op2:x31; dest:x11; op1val:0xffffffdf;  op2val:0xffef0000
TEST_PKRR_OP(kmmwt2.u, x11, x25, x31, 0x00000000, 0xffffffdf, 0xffef0000, x25, x13, 112, x17)

inst_15:
// rs1==x26, rs2==x8, rd==x31, rs2_h1_val == -9, rs1_w0_val == -1073741825, rs2_h0_val == 1
// opcode: kmmwt2.u ; op1:x26; op2:x8; dest:x31; op1val:0xbfffffff;  op2val:0xfff70001
TEST_PKRR_OP(kmmwt2.u, x31, x26, x8, 0x00000000, 0xbfffffff, 0xfff70001, x26, x13, 120, x17)

inst_16:
// rs1==x6, rs2==x30, rd==x7, rs2_h1_val == -5, rs1_w0_val == 4194304, rs2_h0_val == -32768
// opcode: kmmwt2.u ; op1:x6; op2:x30; dest:x7; op1val:0x400000;  op2val:0xfffb8000
TEST_PKRR_OP(kmmwt2.u, x7, x6, x30, 0x00000000, 0x400000, 0xfffb8000, x6, x13, 128, x11)
RVTEST_SIGBASE(x6,signature_x6_0)

inst_17:
// rs1==x13, rs2==x21, rd==x17, rs2_h1_val == -3, rs1_w0_val == 4096
// opcode: kmmwt2.u ; op1:x13; op2:x21; dest:x17; op1val:0x001000;  op2val:0xfffd0002
TEST_PKRR_OP(kmmwt2.u, x17, x13, x21, 0x00000000, 0x001000, 0xfffd0002, x13, x6, 0, x11)

inst_18:
// rs1==x16, rs2==x29, rd==x13, rs2_h1_val == -2, rs1_w0_val == 67108864
// opcode: kmmwt2.u ; op1:x16; op2:x29; dest:x13; op1val:0x4000000;  op2val:0xfffefff8
TEST_PKRR_OP(kmmwt2.u, x13, x16, x29, 0x00000000, 0x4000000, 0xfffefff8, x16, x6, 8, x11)

inst_19:
// rs1==x21, rs2==x25, rd==x4, rs2_h1_val == -32768, rs2_h0_val == -4097, rs1_w0_val == 128
// opcode: kmmwt2.u ; op1:x21; op2:x25; dest:x4; op1val:0x000080;  op2val:0x8000efff
TEST_PKRR_OP(kmmwt2.u, x4, x21, x25, 0x00000000, 0x000080, 0x8000efff, x21, x6, 16, x11)

inst_20:
// rs1==x12, rs2==x3, rd==x5, rs2_h1_val == 16384, rs1_w0_val == 256
// opcode: kmmwt2.u ; op1:x12; op2:x3; dest:x5; op1val:0x000100;  op2val:0x40000400
TEST_PKRR_OP(kmmwt2.u, x5, x12, x3, 0x00000000, 0x000100, 0x40000400, x12, x6, 24, x11)

inst_21:
// rs1==x1, rs2==x13, rd==x19, rs2_h1_val == 8192, rs2_h0_val == -17
// opcode: kmmwt2.u ; op1:x1; op2:x13; dest:x19; op1val:0xfdffffff;  op2val:0x2000ffef
TEST_PKRR_OP(kmmwt2.u, x19, x1, x13, 0x00000000, 0xfdffffff, 0x2000ffef, x1, x6, 32, x11)

inst_22:
// rs1==x8, rs2==x5, rd==x29, rs2_h1_val == 4096, rs2_h0_val == -16385, rs1_w0_val == -16777217
// opcode: kmmwt2.u ; op1:x8; op2:x5; dest:x29; op1val:0xfeffffff;  op2val:0x1000bfff
TEST_PKRR_OP(kmmwt2.u, x29, x8, x5, 0x00000000, 0xfeffffff, 0x1000bfff, x8, x6, 40, x11)

inst_23:
// rs1==x14, rs2==x4, rd==x2, rs2_h1_val == 2048, rs2_h0_val == 512
// opcode: kmmwt2.u ; op1:x14; op2:x4; dest:x2; op1val:0x000100;  op2val:0x8000200
TEST_PKRR_OP(kmmwt2.u, x2, x14, x4, 0x00000000, 0x000100, 0x8000200, x14, x6, 48, x11)

inst_24:
// rs1==x30, rs2==x20, rd==x0, rs2_h1_val == 1024, 
// opcode: kmmwt2.u ; op1:x30; op2:x20; dest:x0; op1val:0xfffffff6;  op2val:0x400fffa
TEST_PKRR_OP(kmmwt2.u, x0, x30, x20, 0x00000000, 0xfffffff6, 0x400fffa, x30, x6, 56, x11)

inst_25:
// rs1==x9, rs2==x1, rd==x21, rs2_h1_val == 512, 
// opcode: kmmwt2.u ; op1:x9; op2:x1; dest:x21; op1val:0x000009;  op2val:0x200fff7
TEST_PKRR_OP(kmmwt2.u, x21, x9, x1, 0x00000000, 0x000009, 0x200fff7, x9, x6, 64, x11)

inst_26:
// rs1==x31, rs2==x10, rd==x18, rs2_h1_val == 256, rs1_w0_val == -262145
// opcode: kmmwt2.u ; op1:x31; op2:x10; dest:x18; op1val:0xfffbffff;  op2val:0x100fffc
TEST_PKRR_OP(kmmwt2.u, x18, x31, x10, 0x00000000, 0xfffbffff, 0x100fffc, x31, x6, 72, x11)

inst_27:
// rs1==x0, rs2==x27, rd==x12, rs2_h1_val == 128, rs1_w0_val == -536870913
// opcode: kmmwt2.u ; op1:x0; op2:x27; dest:x12; op1val:0xdfffffff;  op2val:0x800002
TEST_PKRR_OP(kmmwt2.u, x12, x0, x27, 0x00000000, 0xdfffffff, 0x800002, x0, x6, 80, x11)

inst_28:
// rs1==x2, rs2==x17, rd==x20, rs2_h1_val == 64, rs2_h0_val == 32767
// opcode: kmmwt2.u ; op1:x2; op2:x17; dest:x20; op1val:0x000100;  op2val:0x407fff
TEST_PKRR_OP(kmmwt2.u, x20, x2, x17, 0x00000000, 0x000100, 0x407fff, x2, x6, 88, x11)

inst_29:
// rs1==x7, rs2==x26, rd==x24, rs2_h1_val == 32, rs1_w0_val == 131072, rs2_h0_val == -1025
// opcode: kmmwt2.u ; op1:x7; op2:x26; dest:x24; op1val:0x020000;  op2val:0x20fbff
TEST_PKRR_OP(kmmwt2.u, x24, x7, x26, 0x00000000, 0x020000, 0x20fbff, x7, x6, 96, x11)

inst_30:
// rs1==x29, rs2==x18, rd==x8, rs2_h1_val == 16, rs1_w0_val == -65
// opcode: kmmwt2.u ; op1:x29; op2:x18; dest:x8; op1val:0xffffffbf;  op2val:0x10fbff
TEST_PKRR_OP(kmmwt2.u, x8, x29, x18, 0x00000000, 0xffffffbf, 0x10fbff, x29, x6, 104, x11)

inst_31:
// rs1==x17, rs2==x0, rd==x30, rs2_h1_val == 8, rs2_h0_val == 16384, rs1_w0_val == 32768
// opcode: kmmwt2.u ; op1:x17; op2:x0; dest:x30; op1val:0x008000;  op2val:0x084000
TEST_PKRR_OP(kmmwt2.u, x30, x17, x0, 0x00000000, 0x008000, 0x084000, x17, x6, 112, x11)

inst_32:
// rs2_h1_val == 4, rs1_w0_val == 1431655765
// opcode: kmmwt2.u ; op1:x30; op2:x29; dest:x31; op1val:0x55555555;  op2val:0x04aaaa
TEST_PKRR_OP(kmmwt2.u, x31, x30, x29, 0x00000000, 0x55555555, 0x04aaaa, x30, x6, 120, x11)

inst_33:
// rs2_h1_val == 2, 
// opcode: kmmwt2.u ; op1:x30; op2:x29; dest:x31; op1val:0xf7ffffff;  op2val:0x020005
TEST_PKRR_OP(kmmwt2.u, x31, x30, x29, 0x00000000, 0xf7ffffff, 0x020005, x30, x6, 128, x11)

inst_34:
// rs1_w0_val == 512, 
// opcode: kmmwt2.u ; op1:x30; op2:x29; dest:x31; op1val:0x000200;  op2val:0xfffbfff9
TEST_PKRR_OP(kmmwt2.u, x31, x30, x29, 0x00000000, 0x000200, 0xfffbfff9, x30, x6, 136, x11)

inst_35:
// rs1_w0_val == 32, 
// opcode: kmmwt2.u ; op1:x30; op2:x29; dest:x31; op1val:0x000020;  op2val:0xffef0003
TEST_PKRR_OP(kmmwt2.u, x31, x30, x29, 0x00000000, 0x000020, 0xffef0003, x30, x6, 144, x11)

inst_36:
// rs1_w0_val == 16, 
// opcode: kmmwt2.u ; op1:x30; op2:x29; dest:x31; op1val:0x000010;  op2val:0x200006
TEST_PKRR_OP(kmmwt2.u, x31, x30, x29, 0x00000000, 0x000010, 0x200006, x30, x6, 152, x11)

inst_37:
// rs1_w0_val == 8, 
// opcode: kmmwt2.u ; op1:x30; op2:x29; dest:x31; op1val:0x000008;  op2val:0xfff87fff
TEST_PKRR_OP(kmmwt2.u, x31, x30, x29, 0x00000000, 0x000008, 0xfff87fff, x30, x6, 160, x11)

inst_38:
// rs1_w0_val == 1, rs2_h0_val == 4
// opcode: kmmwt2.u ; op1:x30; op2:x29; dest:x31; op1val:0x000001;  op2val:0x200004
TEST_PKRR_OP(kmmwt2.u, x31, x30, x29, 0x00000000, 0x000001, 0x200004, x30, x6, 168, x11)

inst_39:
// rs2_h1_val == 1, 
// opcode: kmmwt2.u ; op1:x30; op2:x29; dest:x31; op1val:0xfffffeff;  op2val:0x013fff
TEST_PKRR_OP(kmmwt2.u, x31, x30, x29, 0x00000000, 0xfffffeff, 0x013fff, x30, x6, 176, x11)

inst_40:
// rs2_h1_val == 0, rs2_h0_val == -8193
// opcode: kmmwt2.u ; op1:x30; op2:x29; dest:x31; op1val:0x1000000;  op2val:0x00dfff
TEST_PKRR_OP(kmmwt2.u, x31, x30, x29, 0x00000000, 0x1000000, 0x00dfff, x30, x6, 184, x11)

inst_41:
// rs2_h1_val == -1, rs1_w0_val == 262144, rs2_h0_val == 128
// opcode: kmmwt2.u ; op1:x30; op2:x29; dest:x31; op1val:0x040000;  op2val:0xffff0080
TEST_PKRR_OP(kmmwt2.u, x31, x30, x29, 0x00000000, 0x040000, 0xffff0080, x30, x6, 192, x11)

inst_42:
// rs2_h0_val == 21845, 
// opcode: kmmwt2.u ; op1:x30; op2:x29; dest:x31; op1val:0xfffbffff;  op2val:0x025555
TEST_PKRR_OP(kmmwt2.u, x31, x30, x29, 0x00000000, 0xfffbffff, 0x025555, x30, x6, 200, x11)

inst_43:
// rs2_h0_val == -2049, rs1_w0_val == -4097
// opcode: kmmwt2.u ; op1:x30; op2:x29; dest:x31; op1val:0xffffefff;  op2val:0x00f7ff
TEST_PKRR_OP(kmmwt2.u, x31, x30, x29, 0x00000000, 0xffffefff, 0x00f7ff, x30, x6, 208, x11)

inst_44:
// rs2_h0_val == -513, 
// opcode: kmmwt2.u ; op1:x30; op2:x29; dest:x31; op1val:0x000008;  op2val:0x09fdff
TEST_PKRR_OP(kmmwt2.u, x31, x30, x29, 0x00000000, 0x000008, 0x09fdff, x30, x6, 216, x11)

inst_45:
// rs2_h0_val == -257, 
// opcode: kmmwt2.u ; op1:x30; op2:x29; dest:x31; op1val:0xffffffbf;  op2val:0xfefffeff
TEST_PKRR_OP(kmmwt2.u, x31, x30, x29, 0x00000000, 0xffffffbf, 0xfefffeff, x30, x6, 224, x11)

inst_46:
// rs2_h0_val == -129, rs1_w0_val == -4194305
// opcode: kmmwt2.u ; op1:x30; op2:x29; dest:x31; op1val:0xffbfffff;  op2val:0x01ff7f
TEST_PKRR_OP(kmmwt2.u, x31, x30, x29, 0x00000000, 0xffbfffff, 0x01ff7f, x30, x6, 232, x11)

inst_47:
// rs2_h0_val == -5, rs1_w0_val == 1048576
// opcode: kmmwt2.u ; op1:x30; op2:x29; dest:x31; op1val:0x100000;  op2val:0x4000fffb
TEST_PKRR_OP(kmmwt2.u, x31, x30, x29, 0x00000000, 0x100000, 0x4000fffb, x30, x6, 240, x11)

inst_48:
// rs2_h0_val == -3, 
// opcode: kmmwt2.u ; op1:x30; op2:x29; dest:x31; op1val:0xfeffffff;  op2val:0x03fffd
TEST_PKRR_OP(kmmwt2.u, x31, x30, x29, 0x00000000, 0xfeffffff, 0x03fffd, x30, x6, 248, x11)

inst_49:
// rs2_h0_val == 8192, rs1_w0_val == 524288
// opcode: kmmwt2.u ; op1:x30; op2:x29; dest:x31; op1val:0x080000;  op2val:0x102000
TEST_PKRR_OP(kmmwt2.u, x31, x30, x29, 0x00000000, 0x080000, 0x102000, x30, x6, 256, x11)

inst_50:
// rs2_h0_val == 4096, 
// opcode: kmmwt2.u ; op1:x30; op2:x29; dest:x31; op1val:0xffbfffff;  op2val:0xfdff1000
TEST_PKRR_OP(kmmwt2.u, x31, x30, x29, 0x00000000, 0xffbfffff, 0xfdff1000, x30, x6, 264, x11)

inst_51:
// rs2_h0_val == 2048, rs1_w0_val == -1025
// opcode: kmmwt2.u ; op1:x30; op2:x29; dest:x31; op1val:0xfffffbff;  op2val:0x050800
TEST_PKRR_OP(kmmwt2.u, x31, x30, x29, 0x00000000, 0xfffffbff, 0x050800, x30, x6, 272, x11)

inst_52:
// rs2_h0_val == 64, rs1_w0_val == -32769
// opcode: kmmwt2.u ; op1:x30; op2:x29; dest:x31; op1val:0xffff7fff;  op2val:0xdfff0040
TEST_PKRR_OP(kmmwt2.u, x31, x30, x29, 0x00000000, 0xffff7fff, 0xdfff0040, x30, x6, 280, x11)

inst_53:
// rs2_h0_val == 32, 
// opcode: kmmwt2.u ; op1:x30; op2:x29; dest:x31; op1val:0xfffffffa;  op2val:0xfdff0020
TEST_PKRR_OP(kmmwt2.u, x31, x30, x29, 0x00000000, 0xfffffffa, 0xfdff0020, x30, x6, 288, x11)

inst_54:
// rs2_h0_val == 16, rs1_w0_val == 65536
// opcode: kmmwt2.u ; op1:x30; op2:x29; dest:x31; op1val:0x010000;  op2val:0x200010
TEST_PKRR_OP(kmmwt2.u, x31, x30, x29, 0x00000000, 0x010000, 0x200010, x30, x6, 296, x11)

inst_55:
// rs2_h0_val == 8, rs1_w0_val == 1024
// opcode: kmmwt2.u ; op1:x30; op2:x29; dest:x31; op1val:0x000400;  op2val:0x040008
TEST_PKRR_OP(kmmwt2.u, x31, x30, x29, 0x00000000, 0x000400, 0x040008, x30, x6, 304, x11)

inst_56:
// rs2_h0_val == -1, 
// opcode: kmmwt2.u ; op1:x30; op2:x29; dest:x31; op1val:0x000010;  op2val:0xc000ffff
TEST_PKRR_OP(kmmwt2.u, x31, x30, x29, 0x00000000, 0x000010, 0xc000ffff, x30, x6, 312, x11)

inst_57:
// rs1_w0_val == -1431655766, 
// opcode: kmmwt2.u ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaaa;  op2val:0x070007
TEST_PKRR_OP(kmmwt2.u, x31, x30, x29, 0x00000000, 0xaaaaaaaa, 0x070007, x30, x6, 320, x11)

inst_58:
// rs1_w0_val == 2147483647, 
// opcode: kmmwt2.u ; op1:x30; op2:x29; dest:x31; op1val:0x7fffffff;  op2val:0x000003
TEST_PKRR_OP(kmmwt2.u, x31, x30, x29, 0x00000000, 0x7fffffff, 0x000003, x30, x6, 328, x11)

inst_59:
// rs1_w0_val == -268435457, 
// opcode: kmmwt2.u ; op1:x30; op2:x29; dest:x31; op1val:0xefffffff;  op2val:0xffffefff
TEST_PKRR_OP(kmmwt2.u, x31, x30, x29, 0x00000000, 0xefffffff, 0xffffefff, x30, x6, 336, x11)

inst_60:
// rs1_w0_val == -67108865, 
// opcode: kmmwt2.u ; op1:x30; op2:x29; dest:x31; op1val:0xfbffffff;  op2val:0x044000
TEST_PKRR_OP(kmmwt2.u, x31, x30, x29, 0x00000000, 0xfbffffff, 0x044000, x30, x6, 344, x11)

inst_61:
// rs1_w0_val == -8388609, 
// opcode: kmmwt2.u ; op1:x30; op2:x29; dest:x31; op1val:0xff7fffff;  op2val:0x1000fff6
TEST_PKRR_OP(kmmwt2.u, x31, x30, x29, 0x00000000, 0xff7fffff, 0x1000fff6, x30, x6, 352, x11)

inst_62:
// rs1_w0_val == -1048577, 
// opcode: kmmwt2.u ; op1:x30; op2:x29; dest:x31; op1val:0xffefffff;  op2val:0xfff94000
TEST_PKRR_OP(kmmwt2.u, x31, x30, x29, 0x00000000, 0xffefffff, 0xfff94000, x30, x6, 360, x11)

inst_63:
// rs1_w0_val == -524289, 
// opcode: kmmwt2.u ; op1:x30; op2:x29; dest:x31; op1val:0xfff7ffff;  op2val:0x80efff
TEST_PKRR_OP(kmmwt2.u, x31, x30, x29, 0x00000000, 0xfff7ffff, 0x80efff, x30, x6, 368, x11)

inst_64:
// rs1_w0_val == -131073, 
// opcode: kmmwt2.u ; op1:x30; op2:x29; dest:x31; op1val:0xfffdffff;  op2val:0x3ffff7ff
TEST_PKRR_OP(kmmwt2.u, x31, x30, x29, 0x00000000, 0xfffdffff, 0x3ffff7ff, x30, x6, 376, x11)

inst_65:
// rs1_w0_val == -65537, 
// opcode: kmmwt2.u ; op1:x30; op2:x29; dest:x31; op1val:0xfffeffff;  op2val:0x2000008
TEST_PKRR_OP(kmmwt2.u, x31, x30, x29, 0x00000000, 0xfffeffff, 0x2000008, x30, x6, 384, x11)

inst_66:
// rs1_w0_val == -16385, 
// opcode: kmmwt2.u ; op1:x30; op2:x29; dest:x31; op1val:0xffffbfff;  op2val:0x100003
TEST_PKRR_OP(kmmwt2.u, x31, x30, x29, 0x00000000, 0xffffbfff, 0x100003, x30, x6, 392, x11)

inst_67:
// rs1_w0_val == -8193, 
// opcode: kmmwt2.u ; op1:x30; op2:x29; dest:x31; op1val:0xffffdfff;  op2val:0x100003
TEST_PKRR_OP(kmmwt2.u, x31, x30, x29, 0x00000000, 0xffffdfff, 0x100003, x30, x6, 400, x11)

inst_68:
// rs1_w0_val == -2049, 
// opcode: kmmwt2.u ; op1:x30; op2:x29; dest:x31; op1val:0xfffff7ff;  op2val:0xfff6ffef
TEST_PKRR_OP(kmmwt2.u, x31, x30, x29, 0x00000000, 0xfffff7ff, 0xfff6ffef, x30, x6, 408, x11)

inst_69:
// rs1_w0_val == -513, 
// opcode: kmmwt2.u ; op1:x30; op2:x29; dest:x31; op1val:0xfffffdff;  op2val:0x100efff
TEST_PKRR_OP(kmmwt2.u, x31, x30, x29, 0x00000000, 0xfffffdff, 0x100efff, x30, x6, 416, x11)

inst_70:
// rs1_w0_val == -129, 
// opcode: kmmwt2.u ; op1:x30; op2:x29; dest:x31; op1val:0xffffff7f;  op2val:0x3fff5555
TEST_PKRR_OP(kmmwt2.u, x31, x30, x29, 0x00000000, 0xffffff7f, 0x3fff5555, x30, x6, 424, x11)

inst_71:
// rs1_w0_val == -17, 
// opcode: kmmwt2.u ; op1:x30; op2:x29; dest:x31; op1val:0xffffffef;  op2val:0x3fffffdf
TEST_PKRR_OP(kmmwt2.u, x31, x30, x29, 0x00000000, 0xffffffef, 0x3fffffdf, x30, x6, 432, x11)

inst_72:
// rs1_w0_val == -9, 
// opcode: kmmwt2.u ; op1:x30; op2:x29; dest:x31; op1val:0xfffffff7;  op2val:0x80ffff
TEST_PKRR_OP(kmmwt2.u, x31, x30, x29, 0x00000000, 0xfffffff7, 0x80ffff, x30, x6, 440, x11)

inst_73:
// rs1_w0_val == -5, 
// opcode: kmmwt2.u ; op1:x30; op2:x29; dest:x31; op1val:0xfffffffb;  op2val:0x03efff
TEST_PKRR_OP(kmmwt2.u, x31, x30, x29, 0x00000000, 0xfffffffb, 0x03efff, x30, x6, 448, x11)

inst_74:
// rs1_w0_val == -3, 
// opcode: kmmwt2.u ; op1:x30; op2:x29; dest:x31; op1val:0xfffffffd;  op2val:0xc0007fff
TEST_PKRR_OP(kmmwt2.u, x31, x30, x29, 0x00000000, 0xfffffffd, 0xc0007fff, x30, x6, 456, x11)

inst_75:
// rs1_w0_val == -2, 
// opcode: kmmwt2.u ; op1:x30; op2:x29; dest:x31; op1val:0xfffffffe;  op2val:0x010200
TEST_PKRR_OP(kmmwt2.u, x31, x30, x29, 0x00000000, 0xfffffffe, 0x010200, x30, x6, 464, x11)

inst_76:
// rs1_w0_val == 1073741824, 
// opcode: kmmwt2.u ; op1:x30; op2:x29; dest:x31; op1val:0x40000000;  op2val:0xfffcfff9
TEST_PKRR_OP(kmmwt2.u, x31, x30, x29, 0x00000000, 0x40000000, 0xfffcfff9, x30, x6, 472, x11)

inst_77:
// rs1_w0_val == 536870912, 
// opcode: kmmwt2.u ; op1:x30; op2:x29; dest:x31; op1val:0x20000000;  op2val:0x200fff8
TEST_PKRR_OP(kmmwt2.u, x31, x30, x29, 0x00000000, 0x20000000, 0x200fff8, x30, x6, 480, x11)

inst_78:
// rs1_w0_val == 33554432, 
// opcode: kmmwt2.u ; op1:x30; op2:x29; dest:x31; op1val:0x2000000;  op2val:0x1003fff
TEST_PKRR_OP(kmmwt2.u, x31, x30, x29, 0x00000000, 0x2000000, 0x1003fff, x30, x6, 488, x11)

inst_79:
// rs1_w0_val == 8388608, 
// opcode: kmmwt2.u ; op1:x30; op2:x29; dest:x31; op1val:0x800000;  op2val:0x40ff7f
TEST_PKRR_OP(kmmwt2.u, x31, x30, x29, 0x00000000, 0x800000, 0x40ff7f, x30, x6, 496, x11)

inst_80:
// rs1_w0_val == 2097152, 
// opcode: kmmwt2.u ; op1:x30; op2:x29; dest:x31; op1val:0x200000;  op2val:0xfff9fff9
TEST_PKRR_OP(kmmwt2.u, x31, x30, x29, 0x00000000, 0x200000, 0xfff9fff9, x30, x6, 504, x11)

inst_81:
// rs1_w0_val == 134217728, 
// opcode: kmmwt2.u ; op1:x30; op2:x29; dest:x31; op1val:0x8000000;  op2val:0xf7fffbff
TEST_PKRR_OP(kmmwt2.u, x31, x30, x29, 0x00000000, 0x8000000, 0xf7fffbff, x30, x6, 512, x11)

inst_82:
// rs1_w0_val == 16384, 
// opcode: kmmwt2.u ; op1:x30; op2:x29; dest:x31; op1val:0x004000;  op2val:0xffefc000
TEST_PKRR_OP(kmmwt2.u, x31, x30, x29, 0x00000000, 0x004000, 0xffefc000, x30, x6, 520, x11)

inst_83:
// rs1_w0_val == 8192, 
// opcode: kmmwt2.u ; op1:x30; op2:x29; dest:x31; op1val:0x002000;  op2val:0xfff80000
TEST_PKRR_OP(kmmwt2.u, x31, x30, x29, 0x00000000, 0x002000, 0xfff80000, x30, x6, 528, x11)

inst_84:
// rs1_w0_val == 2048, 
// opcode: kmmwt2.u ; op1:x30; op2:x29; dest:x31; op1val:0x000800;  op2val:0x010007
TEST_PKRR_OP(kmmwt2.u, x31, x30, x29, 0x00000000, 0x000800, 0x010007, x30, x6, 536, x11)

inst_85:
// rs2_h1_val == -21846, rs2_h0_val == -65, rs1_w0_val == 16777216
// opcode: kmmwt2.u ; op1:x30; op2:x29; dest:x31; op1val:0x1000000;  op2val:0xaaaaffbf
TEST_PKRR_OP(kmmwt2.u, x31, x30, x29, 0x00000000, 0x1000000, 0xaaaaffbf, x30, x6, 544, x11)

inst_86:
// rs2_h1_val == 32767, rs2_h0_val == 1024, rs1_w0_val == 4
// opcode: kmmwt2.u ; op1:x30; op2:x29; dest:x31; op1val:0x000004;  op2val:0x7fff0400
TEST_PKRR_OP(kmmwt2.u, x31, x30, x29, 0x00000000, 0x000004, 0x7fff0400, x30, x6, 552, x11)

inst_87:
// rs2_h1_val == 1024, 
// opcode: kmmwt2.u ; op1:x30; op2:x29; dest:x31; op1val:0xfffffff6;  op2val:0x400fffa
TEST_PKRR_OP(kmmwt2.u, x31, x30, x29, 0x00000000, 0xfffffff6, 0x400fffa, x30, x6, 560, x11)

inst_88:
// rs2_h1_val == 128, rs1_w0_val == -536870913
// opcode: kmmwt2.u ; op1:x30; op2:x29; dest:x31; op1val:0xdfffffff;  op2val:0x800002
TEST_PKRR_OP(kmmwt2.u, x31, x30, x29, 0x00000000, 0xdfffffff, 0x800002, x30, x6, 568, x11)

inst_89:
// rs2_h1_val == 8, rs2_h0_val == 16384, rs1_w0_val == 32768
// opcode: kmmwt2.u ; op1:x30; op2:x29; dest:x31; op1val:0x008000;  op2val:0x084000
TEST_PKRR_OP(kmmwt2.u, x31, x30, x29, 0x00000000, 0x008000, 0x084000, x30, x6, 576, x11)
#endif


RVTEST_CODE_END
RVMODEL_HALT

RVTEST_DATA_BEGIN
.align 4
rvtest_data:
.word 0xbabecafe
.word 0xabecafeb
.word 0xbecafeba
.word 0xecafebab
RVTEST_DATA_END

RVMODEL_DATA_BEGIN


signature_x13_0:
    .fill 0*(XLEN/32),4,0xdeadbeef


signature_x13_1:
    .fill 34*(XLEN/32),4,0xdeadbeef


signature_x6_0:
    .fill 146*(XLEN/32),4,0xdeadbeef

#ifdef rvtest_mtrap_routine

mtrap_sigptr:
    .fill 64*(XLEN/32),4,0xdeadbeef

#endif

#ifdef rvtest_gpr_save

gpr_save:
    .fill 32*(XLEN/32),4,0xdeadbeef

#endif

RVMODEL_DATA_END
