
// -----------
// This file was generated by riscv_ctg (https://github.com/riscv-software-src/riscv-ctg)
// version   : 0.6.3
// timestamp : Sat Apr 23 14:53:29 2022 GMT
// usage     : riscv_ctg \
//                  --cgf /scratch/git-repo/github/riscv_ctg/sample_cgfs/dataset.cgf \
//                  --cgf /scratch/git-repo/github/riscv_ctg/sample_cgfs/rv32ip.cgf \
//                  --xlen 32  \
//                  --randomize \
// -----------
//
// -----------
// Copyright (c) 2020. RISC-V International. All rights reserved.
// SPDX-License-Identifier: BSD-3-Clause
// -----------
//
// This assembly file tests the kslliw instruction of the RISC-V RV32PZicsr extension for the kslliw covergroup.
// 
#include "model_test.h"
#include "arch_test.h"
RVTEST_ISA("RV32IPZicsr")

.section .text.init
.org 0x80
.globl rvtest_entry_point
rvtest_entry_point:
RVMODEL_BOOT
RVTEST_CODE_BEGIN

#ifdef TEST_CASE_1

RVTEST_CASE(0,"//check ISA:=regex(.*32.*);check ISA:=regex(.*I.*P.*Zicsr.*);def TEST_CASE_1=True;",kslliw)

RVTEST_VXSAT_ENABLE()
RVTEST_SIGBASE(x12,signature_x12_1)

inst_0:
// rs1 != rd, rs1==x2, rd==x18, rs1_w0_val == -2147483648, imm_val == 30
// opcode: kslliw ; op1:x2; dest:x18; op1val:0x80000000;  immval:0x1e
TEST_PKIMM_OP( kslliw, x18, x2, 0x00000000, 0x80000000, 0x1e, x2, x12, 0, x5)

inst_1:
// rs1 == rd, rs1==x4, rd==x4, imm_val == 31, 
// opcode: kslliw ; op1:x4; dest:x4; op1val:0x000005;  immval:0x1f
TEST_PKIMM_OP( kslliw, x4, x4, 0x00000000, 0x000005, 0x1f, x4, x12, 8, x5)

inst_2:
// rs1==x3, rd==x20, imm_val == 29, rs1_w0_val == -33554433
// opcode: kslliw ; op1:x3; dest:x20; op1val:0xfdffffff;  immval:0x1d
TEST_PKIMM_OP( kslliw, x20, x3, 0x00000000, 0xfdffffff, 0x1d, x3, x12, 16, x5)

inst_3:
// rs1==x0, rd==x27, imm_val == 28, rs1_w0_val == 8388608
// opcode: kslliw ; op1:x0; dest:x27; op1val:0x800000;  immval:0x1c
TEST_PKIMM_OP( kslliw, x27, x0, 0x00000000, 0x800000, 0x1c, x0, x12, 24, x5)

inst_4:
// rs1==x15, rd==x10, imm_val == 27, rs1_w0_val == -5
// opcode: kslliw ; op1:x15; dest:x10; op1val:0xfffffffb;  immval:0x1b
TEST_PKIMM_OP( kslliw, x10, x15, 0x00000000, 0xfffffffb, 0x1b, x15, x12, 32, x5)

inst_5:
// rs1==x24, rd==x16, imm_val == 26, rs1_w0_val == -536870913
// opcode: kslliw ; op1:x24; dest:x16; op1val:0xdfffffff;  immval:0x1a
TEST_PKIMM_OP( kslliw, x16, x24, 0x00000000, 0xdfffffff, 0x1a, x24, x12, 40, x5)

inst_6:
// rs1==x13, rd==x7, imm_val == 25, rs1_w0_val == -8388609
// opcode: kslliw ; op1:x13; dest:x7; op1val:0xff7fffff;  immval:0x19
TEST_PKIMM_OP( kslliw, x7, x13, 0x00000000, 0xff7fffff, 0x19, x13, x12, 48, x5)

inst_7:
// rs1==x6, rd==x30, imm_val == 24, rs1_w0_val == 134217728
// opcode: kslliw ; op1:x6; dest:x30; op1val:0x8000000;  immval:0x18
TEST_PKIMM_OP( kslliw, x30, x6, 0x00000000, 0x8000000, 0x18, x6, x12, 56, x5)

inst_8:
// rs1==x11, rd==x24, imm_val == 23, rs1_w0_val == 16777216
// opcode: kslliw ; op1:x11; dest:x24; op1val:0x1000000;  immval:0x17
TEST_PKIMM_OP( kslliw, x24, x11, 0x00000000, 0x1000000, 0x17, x11, x12, 64, x5)

inst_9:
// rs1==x8, rd==x1, imm_val == 22, rs1_w0_val == -1431655766
// opcode: kslliw ; op1:x8; dest:x1; op1val:0xaaaaaaaa;  immval:0x16
TEST_PKIMM_OP( kslliw, x1, x8, 0x00000000, 0xaaaaaaaa, 0x16, x8, x12, 72, x5)

inst_10:
// rs1==x21, rd==x22, imm_val == 21, rs1_w0_val == -16385
// opcode: kslliw ; op1:x21; dest:x22; op1val:0xffffbfff;  immval:0x15
TEST_PKIMM_OP( kslliw, x22, x21, 0x00000000, 0xffffbfff, 0x15, x21, x12, 80, x5)

inst_11:
// rs1==x1, rd==x13, imm_val == 20, 
// opcode: kslliw ; op1:x1; dest:x13; op1val:0xfdffffff;  immval:0x14
TEST_PKIMM_OP( kslliw, x13, x1, 0x00000000, 0xfdffffff, 0x14, x1, x12, 88, x5)

inst_12:
// rs1==x19, rd==x31, imm_val == 19, rs1_w0_val == -1048577
// opcode: kslliw ; op1:x19; dest:x31; op1val:0xffefffff;  immval:0x13
TEST_PKIMM_OP( kslliw, x31, x19, 0x00000000, 0xffefffff, 0x13, x19, x12, 96, x5)

inst_13:
// rs1==x17, rd==x9, imm_val == 18, rs1_w0_val == 8
// opcode: kslliw ; op1:x17; dest:x9; op1val:0x000008;  immval:0x12
TEST_PKIMM_OP( kslliw, x9, x17, 0x00000000, 0x000008, 0x12, x17, x12, 104, x5)

inst_14:
// rs1==x22, rd==x11, imm_val == 17, rs1_w0_val == 268435456
// opcode: kslliw ; op1:x22; dest:x11; op1val:0x10000000;  immval:0x11
TEST_PKIMM_OP( kslliw, x11, x22, 0x00000000, 0x10000000, 0x11, x22, x12, 112, x5)

inst_15:
// rs1==x23, rd==x14, imm_val == 16, 
// opcode: kslliw ; op1:x23; dest:x14; op1val:0xfffffffb;  immval:0x10
TEST_PKIMM_OP( kslliw, x14, x23, 0x00000000, 0xfffffffb, 0x10, x23, x12, 120, x5)

inst_16:
// rs1==x26, rd==x0, imm_val == 15, 
// opcode: kslliw ; op1:x26; dest:x0; op1val:0x8000000;  immval:0xf
TEST_PKIMM_OP( kslliw, x0, x26, 0x00000000, 0x8000000, 0xf, x26, x12, 128, x5)

inst_17:
// rs1==x10, rd==x28, imm_val == 14, 
// opcode: kslliw ; op1:x10; dest:x28; op1val:0x80000000;  immval:0xe
TEST_PKIMM_OP( kslliw, x28, x10, 0x00000000, 0x80000000, 0xe, x10, x12, 136, x5)

inst_18:
// rs1==x30, rd==x5, imm_val == 13, 
// opcode: kslliw ; op1:x30; dest:x5; op1val:0xfffffff6;  immval:0xd
TEST_PKIMM_OP( kslliw, x5, x30, 0x00000000, 0xfffffff6, 0xd, x30, x12, 144, x4)
RVTEST_SIGBASE(x1,signature_x1_0)

inst_19:
// rs1==x16, rd==x26, imm_val == 12, rs1_w0_val == 1
// opcode: kslliw ; op1:x16; dest:x26; op1val:0x000001;  immval:0xc
TEST_PKIMM_OP( kslliw, x26, x16, 0x00000000, 0x000001, 0xc, x16, x1, 0, x4)

inst_20:
// rs1==x31, rd==x2, imm_val == 11, rs1_w0_val == 2147483647
// opcode: kslliw ; op1:x31; dest:x2; op1val:0x7fffffff;  immval:0xb
TEST_PKIMM_OP( kslliw, x2, x31, 0x00000000, 0x7fffffff, 0xb, x31, x1, 8, x4)

inst_21:
// rs1==x7, rd==x17, imm_val == 10, 
// opcode: kslliw ; op1:x7; dest:x17; op1val:0x1000000;  immval:0xa
TEST_PKIMM_OP( kslliw, x17, x7, 0x00000000, 0x1000000, 0xa, x7, x1, 16, x4)

inst_22:
// rs1==x27, rd==x8, imm_val == 9, rs1_w0_val == 128
// opcode: kslliw ; op1:x27; dest:x8; op1val:0x000080;  immval:0x9
TEST_PKIMM_OP( kslliw, x8, x27, 0x00000000, 0x000080, 0x9, x27, x1, 24, x4)

inst_23:
// rs1==x12, rd==x29, imm_val == 8, rs1_w0_val == 1024
// opcode: kslliw ; op1:x12; dest:x29; op1val:0x000400;  immval:0x8
TEST_PKIMM_OP( kslliw, x29, x12, 0x00000000, 0x000400, 0x8, x12, x1, 32, x4)

inst_24:
// rs1==x18, rd==x3, imm_val == 7, rs1_w0_val == -3
// opcode: kslliw ; op1:x18; dest:x3; op1val:0xfffffffd;  immval:0x7
TEST_PKIMM_OP( kslliw, x3, x18, 0x00000000, 0xfffffffd, 0x7, x18, x1, 40, x4)

inst_25:
// rs1==x25, rd==x21, imm_val == 6, 
// opcode: kslliw ; op1:x25; dest:x21; op1val:0xc0000000;  immval:0x6
TEST_PKIMM_OP( kslliw, x21, x25, 0x00000000, 0xc0000000, 0x6, x25, x1, 48, x4)

inst_26:
// rs1==x14, rd==x15, imm_val == 5, rs1_w0_val == -131073
// opcode: kslliw ; op1:x14; dest:x15; op1val:0xfffdffff;  immval:0x5
TEST_PKIMM_OP( kslliw, x15, x14, 0x00000000, 0xfffdffff, 0x5, x14, x1, 56, x4)

inst_27:
// rs1==x28, rd==x23, imm_val == 4, rs1_w0_val == -33
// opcode: kslliw ; op1:x28; dest:x23; op1val:0xffffffdf;  immval:0x4
TEST_PKIMM_OP( kslliw, x23, x28, 0x00000000, 0xffffffdf, 0x4, x28, x1, 64, x4)

inst_28:
// rs1==x5, rd==x6, imm_val == 3, rs1_w0_val == -1073741825
// opcode: kslliw ; op1:x5; dest:x6; op1val:0xbfffffff;  immval:0x3
TEST_PKIMM_OP( kslliw, x6, x5, 0x00000000, 0xbfffffff, 0x3, x5, x1, 72, x4)

inst_29:
// rs1==x9, rd==x25, imm_val == 2, rs1_w0_val == 2097152
// opcode: kslliw ; op1:x9; dest:x25; op1val:0x200000;  immval:0x2
TEST_PKIMM_OP( kslliw, x25, x9, 0x00000000, 0x200000, 0x2, x9, x1, 80, x4)

inst_30:
// rs1==x20, rd==x19, imm_val == 1, rs1_w0_val == 16384
// opcode: kslliw ; op1:x20; dest:x19; op1val:0x004000;  immval:0x1
TEST_PKIMM_OP( kslliw, x19, x20, 0x00000000, 0x004000, 0x1, x20, x1, 88, x4)

inst_31:
// rs1==x29, rd==x12, imm_val == 0, rs1_w0_val == 64
// opcode: kslliw ; op1:x29; dest:x12; op1val:0x000040;  immval:0x0
TEST_PKIMM_OP( kslliw, x12, x29, 0x00000000, 0x000040, 0x0, x29, x1, 96, x4)

inst_32:
// rs1_w0_val == 1431655765, 
// opcode: kslliw ; op1:x30; dest:x31; op1val:0x55555555;  immval:0xb
TEST_PKIMM_OP( kslliw, x31, x30, 0x00000000, 0x55555555, 0xb, x30, x1, 104, x4)

inst_33:
// rs1_w0_val == -268435457, 
// opcode: kslliw ; op1:x30; dest:x31; op1val:0xefffffff;  immval:0x5
TEST_PKIMM_OP( kslliw, x31, x30, 0x00000000, 0xefffffff, 0x5, x30, x1, 112, x4)

inst_34:
// rs1_w0_val == -134217729, 
// opcode: kslliw ; op1:x30; dest:x31; op1val:0xf7ffffff;  immval:0x1f
TEST_PKIMM_OP( kslliw, x31, x30, 0x00000000, 0xf7ffffff, 0x1f, x30, x1, 120, x4)

inst_35:
// rs1_w0_val == -67108865, 
// opcode: kslliw ; op1:x30; dest:x31; op1val:0xfbffffff;  immval:0x1a
TEST_PKIMM_OP( kslliw, x31, x30, 0x00000000, 0xfbffffff, 0x1a, x30, x1, 128, x4)

inst_36:
// rs1_w0_val == -16777217, 
// opcode: kslliw ; op1:x30; dest:x31; op1val:0xfeffffff;  immval:0x5
TEST_PKIMM_OP( kslliw, x31, x30, 0x00000000, 0xfeffffff, 0x5, x30, x1, 136, x4)

inst_37:
// rs1_w0_val == -4194305, 
// opcode: kslliw ; op1:x30; dest:x31; op1val:0xffbfffff;  immval:0x1d
TEST_PKIMM_OP( kslliw, x31, x30, 0x00000000, 0xffbfffff, 0x1d, x30, x1, 144, x4)

inst_38:
// rs1_w0_val == -2097153, 
// opcode: kslliw ; op1:x30; dest:x31; op1val:0xffdfffff;  immval:0x3
TEST_PKIMM_OP( kslliw, x31, x30, 0x00000000, 0xffdfffff, 0x3, x30, x1, 152, x4)

inst_39:
// rs1_w0_val == -524289, 
// opcode: kslliw ; op1:x30; dest:x31; op1val:0xfff7ffff;  immval:0x7
TEST_PKIMM_OP( kslliw, x31, x30, 0x00000000, 0xfff7ffff, 0x7, x30, x1, 160, x4)

inst_40:
// rs1_w0_val == -262145, 
// opcode: kslliw ; op1:x30; dest:x31; op1val:0xfffbffff;  immval:0x10
TEST_PKIMM_OP( kslliw, x31, x30, 0x00000000, 0xfffbffff, 0x10, x30, x1, 168, x4)

inst_41:
// rs1_w0_val == -65537, 
// opcode: kslliw ; op1:x30; dest:x31; op1val:0xfffeffff;  immval:0xa
TEST_PKIMM_OP( kslliw, x31, x30, 0x00000000, 0xfffeffff, 0xa, x30, x1, 176, x4)

inst_42:
// rs1_w0_val == -32769, 
// opcode: kslliw ; op1:x30; dest:x31; op1val:0xffff7fff;  immval:0x1c
TEST_PKIMM_OP( kslliw, x31, x30, 0x00000000, 0xffff7fff, 0x1c, x30, x1, 184, x4)

inst_43:
// rs1_w0_val == -8193, 
// opcode: kslliw ; op1:x30; dest:x31; op1val:0xffffdfff;  immval:0x1a
TEST_PKIMM_OP( kslliw, x31, x30, 0x00000000, 0xffffdfff, 0x1a, x30, x1, 192, x4)

inst_44:
// rs1_w0_val == -4097, 
// opcode: kslliw ; op1:x30; dest:x31; op1val:0xffffefff;  immval:0x12
TEST_PKIMM_OP( kslliw, x31, x30, 0x00000000, 0xffffefff, 0x12, x30, x1, 200, x4)

inst_45:
// rs1_w0_val == -2, 
// opcode: kslliw ; op1:x30; dest:x31; op1val:0xfffffffe;  immval:0x19
TEST_PKIMM_OP( kslliw, x31, x30, 0x00000000, 0xfffffffe, 0x19, x30, x1, 208, x4)

inst_46:
// rs1_w0_val == 1073741824, 
// opcode: kslliw ; op1:x30; dest:x31; op1val:0x40000000;  immval:0x1c
TEST_PKIMM_OP( kslliw, x31, x30, 0x00000000, 0x40000000, 0x1c, x30, x1, 216, x4)

inst_47:
// rs1_w0_val == 536870912, 
// opcode: kslliw ; op1:x30; dest:x31; op1val:0x20000000;  immval:0x4
TEST_PKIMM_OP( kslliw, x31, x30, 0x00000000, 0x20000000, 0x4, x30, x1, 224, x4)

inst_48:
// rs1_w0_val == 67108864, 
// opcode: kslliw ; op1:x30; dest:x31; op1val:0x4000000;  immval:0x1f
TEST_PKIMM_OP( kslliw, x31, x30, 0x00000000, 0x4000000, 0x1f, x30, x1, 232, x4)

inst_49:
// rs1_w0_val == 33554432, 
// opcode: kslliw ; op1:x30; dest:x31; op1val:0x2000000;  immval:0xf
TEST_PKIMM_OP( kslliw, x31, x30, 0x00000000, 0x2000000, 0xf, x30, x1, 240, x4)

inst_50:
// rs1_w0_val == 4194304, 
// opcode: kslliw ; op1:x30; dest:x31; op1val:0x400000;  immval:0x11
TEST_PKIMM_OP( kslliw, x31, x30, 0x00000000, 0x400000, 0x11, x30, x1, 248, x4)

inst_51:
// rs1_w0_val == 1048576, 
// opcode: kslliw ; op1:x30; dest:x31; op1val:0x100000;  immval:0x0
TEST_PKIMM_OP( kslliw, x31, x30, 0x00000000, 0x100000, 0x0, x30, x1, 256, x4)

inst_52:
// rs1_w0_val == 524288, 
// opcode: kslliw ; op1:x30; dest:x31; op1val:0x080000;  immval:0xc
TEST_PKIMM_OP( kslliw, x31, x30, 0x00000000, 0x080000, 0xc, x30, x1, 264, x4)

inst_53:
// rs1_w0_val == 262144, 
// opcode: kslliw ; op1:x30; dest:x31; op1val:0x040000;  immval:0xc
TEST_PKIMM_OP( kslliw, x31, x30, 0x00000000, 0x040000, 0xc, x30, x1, 272, x4)

inst_54:
// rs1_w0_val == 131072, 
// opcode: kslliw ; op1:x30; dest:x31; op1val:0x020000;  immval:0xa
TEST_PKIMM_OP( kslliw, x31, x30, 0x00000000, 0x020000, 0xa, x30, x1, 280, x4)

inst_55:
// rs1_w0_val == 65536, 
// opcode: kslliw ; op1:x30; dest:x31; op1val:0x010000;  immval:0x12
TEST_PKIMM_OP( kslliw, x31, x30, 0x00000000, 0x010000, 0x12, x30, x1, 288, x4)

inst_56:
// rs1_w0_val == 32768, 
// opcode: kslliw ; op1:x30; dest:x31; op1val:0x008000;  immval:0x1
TEST_PKIMM_OP( kslliw, x31, x30, 0x00000000, 0x008000, 0x1, x30, x1, 296, x4)

inst_57:
// rs1_w0_val == 8192, 
// opcode: kslliw ; op1:x30; dest:x31; op1val:0x002000;  immval:0x1
TEST_PKIMM_OP( kslliw, x31, x30, 0x00000000, 0x002000, 0x1, x30, x1, 304, x4)

inst_58:
// rs1_w0_val == 4096, 
// opcode: kslliw ; op1:x30; dest:x31; op1val:0x001000;  immval:0xf
TEST_PKIMM_OP( kslliw, x31, x30, 0x00000000, 0x001000, 0xf, x30, x1, 312, x4)

inst_59:
// rs1_w0_val == 2048, 
// opcode: kslliw ; op1:x30; dest:x31; op1val:0x000800;  immval:0xe
TEST_PKIMM_OP( kslliw, x31, x30, 0x00000000, 0x000800, 0xe, x30, x1, 320, x4)

inst_60:
// rs1_w0_val == 512, 
// opcode: kslliw ; op1:x30; dest:x31; op1val:0x000200;  immval:0x7
TEST_PKIMM_OP( kslliw, x31, x30, 0x00000000, 0x000200, 0x7, x30, x1, 328, x4)

inst_61:
// rs1_w0_val == 2, 
// opcode: kslliw ; op1:x30; dest:x31; op1val:0x000002;  immval:0xd
TEST_PKIMM_OP( kslliw, x31, x30, 0x00000000, 0x000002, 0xd, x30, x1, 336, x4)

inst_62:
// rs1_w0_val == 256, 
// opcode: kslliw ; op1:x30; dest:x31; op1val:0x000100;  immval:0x0
TEST_PKIMM_OP( kslliw, x31, x30, 0x00000000, 0x000100, 0x0, x30, x1, 344, x4)

inst_63:
// rs1_w0_val == 0, 
// opcode: kslliw ; op1:x30; dest:x31; op1val:0x000000;  immval:0x14
TEST_PKIMM_OP( kslliw, x31, x30, 0x00000000, 0x000000, 0x14, x30, x1, 352, x4)

inst_64:
// rs1_w0_val == -1, 
// opcode: kslliw ; op1:x30; dest:x31; op1val:0xffffffff;  immval:0x13
TEST_PKIMM_OP( kslliw, x31, x30, 0x00000000, 0xffffffff, 0x13, x30, x1, 360, x4)

inst_65:
// rs1_w0_val == -65, 
// opcode: kslliw ; op1:x30; dest:x31; op1val:0xffffffbf;  immval:0x10
TEST_PKIMM_OP( kslliw, x31, x30, 0x00000000, 0xffffffbf, 0x10, x30, x1, 368, x4)

inst_66:
// rs1_w0_val == 4, 
// opcode: kslliw ; op1:x30; dest:x31; op1val:0x000004;  immval:0xd
TEST_PKIMM_OP( kslliw, x31, x30, 0x00000000, 0x000004, 0xd, x30, x1, 376, x4)

inst_67:
// rs1_w0_val == -2049, 
// opcode: kslliw ; op1:x30; dest:x31; op1val:0xfffff7ff;  immval:0xf
TEST_PKIMM_OP( kslliw, x31, x30, 0x00000000, 0xfffff7ff, 0xf, x30, x1, 384, x4)

inst_68:
// rs1_w0_val == -1025, 
// opcode: kslliw ; op1:x30; dest:x31; op1val:0xfffffbff;  immval:0x5
TEST_PKIMM_OP( kslliw, x31, x30, 0x00000000, 0xfffffbff, 0x5, x30, x1, 392, x4)

inst_69:
// rs1_w0_val == -513, 
// opcode: kslliw ; op1:x30; dest:x31; op1val:0xfffffdff;  immval:0x4
TEST_PKIMM_OP( kslliw, x31, x30, 0x00000000, 0xfffffdff, 0x4, x30, x1, 400, x4)

inst_70:
// rs1_w0_val == -257, 
// opcode: kslliw ; op1:x30; dest:x31; op1val:0xfffffeff;  immval:0x6
TEST_PKIMM_OP( kslliw, x31, x30, 0x00000000, 0xfffffeff, 0x6, x30, x1, 408, x4)

inst_71:
// rs1_w0_val == -129, 
// opcode: kslliw ; op1:x30; dest:x31; op1val:0xffffff7f;  immval:0x1b
TEST_PKIMM_OP( kslliw, x31, x30, 0x00000000, 0xffffff7f, 0x1b, x30, x1, 416, x4)

inst_72:
// rs1_w0_val == 32, 
// opcode: kslliw ; op1:x30; dest:x31; op1val:0x000020;  immval:0x11
TEST_PKIMM_OP( kslliw, x31, x30, 0x00000000, 0x000020, 0x11, x30, x1, 424, x4)

inst_73:
// rs1_w0_val == 16, 
// opcode: kslliw ; op1:x30; dest:x31; op1val:0x000010;  immval:0x1b
TEST_PKIMM_OP( kslliw, x31, x30, 0x00000000, 0x000010, 0x1b, x30, x1, 432, x4)

inst_74:
// rs1_w0_val == -17, 
// opcode: kslliw ; op1:x30; dest:x31; op1val:0xffffffef;  immval:0x1e
TEST_PKIMM_OP( kslliw, x31, x30, 0x00000000, 0xffffffef, 0x1e, x30, x1, 440, x4)

inst_75:
// rs1_w0_val == -9, 
// opcode: kslliw ; op1:x30; dest:x31; op1val:0xfffffff7;  immval:0x4
TEST_PKIMM_OP( kslliw, x31, x30, 0x00000000, 0xfffffff7, 0x4, x30, x1, 448, x4)

inst_76:
// imm_val == 28, rs1_w0_val == 8388608
// opcode: kslliw ; op1:x30; dest:x31; op1val:0x800000;  immval:0x1c
TEST_PKIMM_OP( kslliw, x31, x30, 0x00000000, 0x800000, 0x1c, x30, x1, 456, x4)
#endif


RVTEST_CODE_END
RVMODEL_HALT

RVTEST_DATA_BEGIN
.align 4
rvtest_data:
.word 0xbabecafe
.word 0xabecafeb
.word 0xbecafeba
.word 0xecafebab
RVTEST_DATA_END

RVMODEL_DATA_BEGIN


signature_x12_0:
    .fill 0*(XLEN/32),4,0xdeadbeef


signature_x12_1:
    .fill 38*(XLEN/32),4,0xdeadbeef


signature_x1_0:
    .fill 116*(XLEN/32),4,0xdeadbeef

#ifdef rvtest_mtrap_routine

mtrap_sigptr:
    .fill 64*(XLEN/32),4,0xdeadbeef

#endif

#ifdef rvtest_gpr_save

gpr_save:
    .fill 32*(XLEN/32),4,0xdeadbeef

#endif

RVMODEL_DATA_END
