
// -----------
// This file was generated by riscv_ctg (https://github.com/riscv-software-src/riscv-ctg)
// version   : 0.6.3
// timestamp : Sat Apr 23 14:53:29 2022 GMT
// usage     : riscv_ctg \
//                  --cgf /scratch/git-repo/github/riscv_ctg/sample_cgfs/dataset.cgf \
//                  --cgf /scratch/git-repo/github/riscv_ctg/sample_cgfs/rv32ip.cgf \
//                  --xlen 32  \
//                  --randomize \
// -----------
//
// -----------
// Copyright (c) 2020. RISC-V International. All rights reserved.
// SPDX-License-Identifier: BSD-3-Clause
// -----------
//
// This assembly file tests the kslraw instruction of the RISC-V RV32PZicsr extension for the kslraw covergroup.
// 
#include "model_test.h"
#include "arch_test.h"
RVTEST_ISA("RV32IPZicsr")

.section .text.init
.org 0x80
.globl rvtest_entry_point
rvtest_entry_point:
RVMODEL_BOOT
RVTEST_CODE_BEGIN

#ifdef TEST_CASE_1

RVTEST_CASE(0,"//check ISA:=regex(.*32.*);check ISA:=regex(.*I.*P.*Zicsr.*);def TEST_CASE_1=True;",kslraw)

RVTEST_VXSAT_ENABLE()
RVTEST_SIGBASE(x1,signature_x1_1)

inst_0:
// rs1 != rs2  and rs1 != rd and rs2 != rd, rs1==x26, rs2==x8, rd==x12, rs1_w0_val == -2147483648, rs1_w0_val != rs2_w0_val, rs2_w0_val == 64, rs1_w0_val < 0 and rs2_w0_val > 0
// opcode: kslraw ; op1:x26; op2:x8; dest:x12; op1val:0x80000000;  op2val:0x000040
TEST_PKRR_OP(kslraw, x12, x26, x8, 0x00000000, 0x80000000, 0x000040, x26, x1, 0, x18)

inst_1:
// rs1 == rs2 != rd, rs1==x15, rs2==x15, rd==x19, rs1_w0_val == rs2_w0_val, rs2_w0_val == 16, rs1_w0_val > 0 and rs2_w0_val > 0, rs1_w0_val == 16
// opcode: kslraw ; op1:x15; op2:x15; dest:x19; op1val:0x000010;  op2val:0x000010
TEST_PKRR_OP(kslraw, x19, x15, x15, 0x00000000, 0x000010, 0x000010, x15, x1, 8, x18)

inst_2:
// rs1 == rd != rs2, rs1==x25, rs2==x28, rd==x25, rs1_w0_val < 0 and rs2_w0_val < 0, rs2_w0_val == -2, rs1_w0_val == -131073
// opcode: kslraw ; op1:x25; op2:x28; dest:x25; op1val:0xfffdffff;  op2val:0xfffffffe
TEST_PKRR_OP(kslraw, x25, x25, x28, 0x00000000, 0xfffdffff, 0xfffffffe, x25, x1, 16, x18)

inst_3:
// rs1 == rs2 == rd, rs1==x11, rs2==x11, rd==x11, rs1_w0_val > 0 and rs2_w0_val < 0, rs2_w0_val == -9
// opcode: kslraw ; op1:x11; op2:x11; dest:x11; op1val:0x000009;  op2val:0xfffffff7
TEST_PKRR_OP(kslraw, x11, x11, x11, 0x00000000, 0x000009, 0xfffffff7, x11, x1, 24, x18)

inst_4:
// rs2 == rd != rs1, rs1==x20, rs2==x13, rd==x13, rs2_w0_val == -1431655766, rs1_w0_val == 2097152
// opcode: kslraw ; op1:x20; op2:x13; dest:x13; op1val:0x200000;  op2val:0xaaaaaaaa
TEST_PKRR_OP(kslraw, x13, x20, x13, 0x00000000, 0x200000, 0xaaaaaaaa, x20, x1, 32, x18)

inst_5:
// rs1==x5, rs2==x6, rd==x17, rs2_w0_val == 1431655765, rs1_w0_val == 131072
// opcode: kslraw ; op1:x5; op2:x6; dest:x17; op1val:0x020000;  op2val:0x55555555
TEST_PKRR_OP(kslraw, x17, x5, x6, 0x00000000, 0x020000, 0x55555555, x5, x1, 40, x18)

inst_6:
// rs1==x2, rs2==x25, rd==x9, rs2_w0_val == 2147483647, rs1_w0_val == -4097
// opcode: kslraw ; op1:x2; op2:x25; dest:x9; op1val:0xffffefff;  op2val:0x7fffffff
TEST_PKRR_OP(kslraw, x9, x2, x25, 0x00000000, 0xffffefff, 0x7fffffff, x2, x1, 48, x18)

inst_7:
// rs1==x8, rs2==x30, rd==x16, rs2_w0_val == -1073741825, rs1_w0_val == -134217729
// opcode: kslraw ; op1:x8; op2:x30; dest:x16; op1val:0xf7ffffff;  op2val:0xbfffffff
TEST_PKRR_OP(kslraw, x16, x8, x30, 0x00000000, 0xf7ffffff, 0xbfffffff, x8, x1, 56, x18)

inst_8:
// rs1==x0, rs2==x4, rd==x23, rs2_w0_val == -536870913, rs1_w0_val == -262145
// opcode: kslraw ; op1:x0; op2:x4; dest:x23; op1val:0xfffbffff;  op2val:0xdfffffff
TEST_PKRR_OP(kslraw, x23, x0, x4, 0x00000000, 0xfffbffff, 0xdfffffff, x0, x1, 64, x18)

inst_9:
// rs1==x16, rs2==x20, rd==x0, rs2_w0_val == -268435457, 
// opcode: kslraw ; op1:x16; op2:x20; dest:x0; op1val:0xfffffff8;  op2val:0xefffffff
TEST_PKRR_OP(kslraw, x0, x16, x20, 0x00000000, 0xfffffff8, 0xefffffff, x16, x1, 72, x18)

inst_10:
// rs1==x30, rs2==x31, rd==x8, rs2_w0_val == -134217729, rs1_w0_val == -1025
// opcode: kslraw ; op1:x30; op2:x31; dest:x8; op1val:0xfffffbff;  op2val:0xf7ffffff
TEST_PKRR_OP(kslraw, x8, x30, x31, 0x00000000, 0xfffffbff, 0xf7ffffff, x30, x1, 80, x18)

inst_11:
// rs1==x22, rs2==x5, rd==x28, rs2_w0_val == -67108865, rs1_w0_val == -268435457
// opcode: kslraw ; op1:x22; op2:x5; dest:x28; op1val:0xefffffff;  op2val:0xfbffffff
TEST_PKRR_OP(kslraw, x28, x22, x5, 0x00000000, 0xefffffff, 0xfbffffff, x22, x1, 88, x18)

inst_12:
// rs1==x7, rs2==x22, rd==x6, rs2_w0_val == -33554433, rs1_w0_val == -33554433
// opcode: kslraw ; op1:x7; op2:x22; dest:x6; op1val:0xfdffffff;  op2val:0xfdffffff
TEST_PKRR_OP(kslraw, x6, x7, x22, 0x00000000, 0xfdffffff, 0xfdffffff, x7, x1, 96, x18)

inst_13:
// rs1==x21, rs2==x12, rd==x22, rs2_w0_val == -16777217, rs1_w0_val == 1073741824
// opcode: kslraw ; op1:x21; op2:x12; dest:x22; op1val:0x40000000;  op2val:0xfeffffff
TEST_PKRR_OP(kslraw, x22, x21, x12, 0x00000000, 0x40000000, 0xfeffffff, x21, x1, 104, x18)

inst_14:
// rs1==x3, rs2==x17, rd==x10, rs2_w0_val == -8388609, rs1_w0_val == 33554432
// opcode: kslraw ; op1:x3; op2:x17; dest:x10; op1val:0x2000000;  op2val:0xff7fffff
TEST_PKRR_OP(kslraw, x10, x3, x17, 0x00000000, 0x2000000, 0xff7fffff, x3, x1, 112, x18)

inst_15:
// rs1==x23, rs2==x16, rd==x31, rs2_w0_val == -4194305, 
// opcode: kslraw ; op1:x23; op2:x16; dest:x31; op1val:0x200000;  op2val:0xffbfffff
TEST_PKRR_OP(kslraw, x31, x23, x16, 0x00000000, 0x200000, 0xffbfffff, x23, x1, 120, x18)

inst_16:
// rs1==x13, rs2==x3, rd==x14, rs2_w0_val == -2097153, rs1_w0_val == -3
// opcode: kslraw ; op1:x13; op2:x3; dest:x14; op1val:0xfffffffd;  op2val:0xffdfffff
TEST_PKRR_OP(kslraw, x14, x13, x3, 0x00000000, 0xfffffffd, 0xffdfffff, x13, x1, 128, x18)

inst_17:
// rs1==x12, rs2==x18, rd==x15, rs2_w0_val == -1048577, rs1_w0_val == 2
// opcode: kslraw ; op1:x12; op2:x18; dest:x15; op1val:0x000002;  op2val:0xffefffff
TEST_PKRR_OP(kslraw, x15, x12, x18, 0x00000000, 0x000002, 0xffefffff, x12, x1, 136, x11)
RVTEST_SIGBASE(x8,signature_x8_0)

inst_18:
// rs1==x1, rs2==x21, rd==x20, rs2_w0_val == -524289, 
// opcode: kslraw ; op1:x1; op2:x21; dest:x20; op1val:0xfdffffff;  op2val:0xfff7ffff
TEST_PKRR_OP(kslraw, x20, x1, x21, 0x00000000, 0xfdffffff, 0xfff7ffff, x1, x8, 0, x11)

inst_19:
// rs1==x10, rs2==x19, rd==x5, rs2_w0_val == -262145, rs1_w0_val == 32768
// opcode: kslraw ; op1:x10; op2:x19; dest:x5; op1val:0x008000;  op2val:0xfffbffff
TEST_PKRR_OP(kslraw, x5, x10, x19, 0x00000000, 0x008000, 0xfffbffff, x10, x8, 8, x11)

inst_20:
// rs1==x9, rs2==x14, rd==x24, rs2_w0_val == -131073, rs1_w0_val == -5
// opcode: kslraw ; op1:x9; op2:x14; dest:x24; op1val:0xfffffffb;  op2val:0xfffdffff
TEST_PKRR_OP(kslraw, x24, x9, x14, 0x00000000, 0xfffffffb, 0xfffdffff, x9, x8, 16, x11)

inst_21:
// rs1==x24, rs2==x10, rd==x3, rs2_w0_val == -65537, 
// opcode: kslraw ; op1:x24; op2:x10; dest:x3; op1val:0x000007;  op2val:0xfffeffff
TEST_PKRR_OP(kslraw, x3, x24, x10, 0x00000000, 0x000007, 0xfffeffff, x24, x8, 24, x11)

inst_22:
// rs1==x28, rs2==x0, rd==x27, rs2_w0_val == -32769, rs1_w0_val == -1
// opcode: kslraw ; op1:x28; op2:x0; dest:x27; op1val:0xffffffff;  op2val:0xffff7fff
TEST_PKRR_OP(kslraw, x27, x28, x0, 0x00000000, 0xffffffff, 0xffff7fff, x28, x8, 32, x11)

inst_23:
// rs1==x27, rs2==x24, rd==x21, rs2_w0_val == -16385, 
// opcode: kslraw ; op1:x27; op2:x24; dest:x21; op1val:0xfffffffc;  op2val:0xffffbfff
TEST_PKRR_OP(kslraw, x21, x27, x24, 0x00000000, 0xfffffffc, 0xffffbfff, x27, x8, 40, x11)

inst_24:
// rs1==x17, rs2==x26, rd==x1, rs2_w0_val == -8193, 
// opcode: kslraw ; op1:x17; op2:x26; dest:x1; op1val:0xfffffffb;  op2val:0xffffdfff
TEST_PKRR_OP(kslraw, x1, x17, x26, 0x00000000, 0xfffffffb, 0xffffdfff, x17, x8, 48, x11)

inst_25:
// rs1==x14, rs2==x23, rd==x29, rs2_w0_val == -4097, rs1_w0_val == 268435456
// opcode: kslraw ; op1:x14; op2:x23; dest:x29; op1val:0x10000000;  op2val:0xffffefff
TEST_PKRR_OP(kslraw, x29, x14, x23, 0x00000000, 0x10000000, 0xffffefff, x14, x8, 56, x11)

inst_26:
// rs1==x19, rs2==x29, rd==x30, rs2_w0_val == -2049, rs1_w0_val == -1073741825
// opcode: kslraw ; op1:x19; op2:x29; dest:x30; op1val:0xbfffffff;  op2val:0xfffff7ff
TEST_PKRR_OP(kslraw, x30, x19, x29, 0x00000000, 0xbfffffff, 0xfffff7ff, x19, x8, 64, x11)

inst_27:
// rs1==x18, rs2==x7, rd==x26, rs2_w0_val == -1025, rs1_w0_val == -16385
// opcode: kslraw ; op1:x18; op2:x7; dest:x26; op1val:0xffffbfff;  op2val:0xfffffbff
TEST_PKRR_OP(kslraw, x26, x18, x7, 0x00000000, 0xffffbfff, 0xfffffbff, x18, x8, 72, x11)

inst_28:
// rs1==x31, rs2==x27, rd==x18, rs2_w0_val == -513, 
// opcode: kslraw ; op1:x31; op2:x27; dest:x18; op1val:0xfdffffff;  op2val:0xfffffdff
TEST_PKRR_OP(kslraw, x18, x31, x27, 0x00000000, 0xfdffffff, 0xfffffdff, x31, x8, 80, x11)

inst_29:
// rs1==x29, rs2==x1, rd==x4, rs2_w0_val == -257, rs1_w0_val == 256
// opcode: kslraw ; op1:x29; op2:x1; dest:x4; op1val:0x000100;  op2val:0xfffffeff
TEST_PKRR_OP(kslraw, x4, x29, x1, 0x00000000, 0x000100, 0xfffffeff, x29, x8, 88, x11)

inst_30:
// rs1==x4, rs2==x9, rd==x2, rs2_w0_val == -129, 
// opcode: kslraw ; op1:x4; op2:x9; dest:x2; op1val:0xfffffbff;  op2val:0xffffff7f
TEST_PKRR_OP(kslraw, x2, x4, x9, 0x00000000, 0xfffffbff, 0xffffff7f, x4, x8, 96, x11)

inst_31:
// rs1==x6, rs2==x2, rd==x7, rs2_w0_val == -65, rs1_w0_val == -65
// opcode: kslraw ; op1:x6; op2:x2; dest:x7; op1val:0xffffffbf;  op2val:0xffffffbf
TEST_PKRR_OP(kslraw, x7, x6, x2, 0x00000000, 0xffffffbf, 0xffffffbf, x6, x8, 104, x11)

inst_32:
// rs2_w0_val == -33, rs1_w0_val == -65537
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0xfffeffff;  op2val:0xffffffdf
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0xfffeffff, 0xffffffdf, x30, x8, 112, x11)

inst_33:
// rs2_w0_val == -17, rs1_w0_val == 1
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0x000001;  op2val:0xffffffef
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0x000001, 0xffffffef, x30, x8, 120, x11)

inst_34:
// rs2_w0_val == -5, rs1_w0_val == 128
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0x000080;  op2val:0xfffffffb
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0x000080, 0xfffffffb, x30, x8, 128, x11)

inst_35:
// rs2_w0_val == -3, 
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0xf7ffffff;  op2val:0xfffffffd
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0xf7ffffff, 0xfffffffd, x30, x8, 136, x11)

inst_36:
// rs2_w0_val == -2147483648, rs1_w0_val == -8388609
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0xff7fffff;  op2val:0x80000000
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0xff7fffff, 0x80000000, x30, x8, 144, x11)

inst_37:
// rs2_w0_val == 1073741824, rs1_w0_val == 4096
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0x001000;  op2val:0x40000000
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0x001000, 0x40000000, x30, x8, 152, x11)

inst_38:
// rs2_w0_val == 536870912, 
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0xff7fffff;  op2val:0x20000000
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0xff7fffff, 0x20000000, x30, x8, 160, x11)

inst_39:
// rs2_w0_val == 268435456, rs1_w0_val == -2097153
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0xffdfffff;  op2val:0x10000000
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0xffdfffff, 0x10000000, x30, x8, 168, x11)

inst_40:
// rs2_w0_val == 134217728, 
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0xfffffffc;  op2val:0x8000000
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0xfffffffc, 0x8000000, x30, x8, 176, x11)

inst_41:
// rs2_w0_val == 67108864, 
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0x000002;  op2val:0x4000000
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0x000002, 0x4000000, x30, x8, 184, x11)

inst_42:
// rs2_w0_val == 33554432, rs1_w0_val == -536870913
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0xdfffffff;  op2val:0x2000000
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0xdfffffff, 0x2000000, x30, x8, 192, x11)

inst_43:
// rs2_w0_val == 16777216, 
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0xfdffffff;  op2val:0x1000000
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0xfdffffff, 0x1000000, x30, x8, 200, x11)

inst_44:
// rs1_w0_val == 2048, 
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0x000800;  op2val:0xffffffbf
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0x000800, 0xffffffbf, x30, x8, 208, x11)

inst_45:
// rs1_w0_val == 1024, rs2_w0_val == 2097152
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0x000400;  op2val:0x200000
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0x000400, 0x200000, x30, x8, 216, x11)

inst_46:
// rs1_w0_val == 512, 
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0x000200;  op2val:0xfffffffd
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0x000200, 0xfffffffd, x30, x8, 224, x11)

inst_47:
// rs1_w0_val == 64, 
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0x000040;  op2val:0xc0000000
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0x000040, 0xc0000000, x30, x8, 232, x11)

inst_48:
// rs1_w0_val == 32, 
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0x000020;  op2val:0x55555555
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0x000020, 0x55555555, x30, x8, 240, x11)

inst_49:
// rs1_w0_val == 8, 
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0x000008;  op2val:0xfffffffa
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0x000008, 0xfffffffa, x30, x8, 248, x11)

inst_50:
// rs1_w0_val == 4, 
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0x000004;  op2val:0xffdfffff
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0x000004, 0xffdfffff, x30, x8, 256, x11)

inst_51:
// rs1_w0_val == 0, rs2_w0_val == 65536
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0x000000;  op2val:0x010000
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0x000000, 0x010000, x30, x8, 264, x11)

inst_52:
// rs2_w0_val == 8388608, rs1_w0_val == 8388608
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0x800000;  op2val:0x800000
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0x800000, 0x800000, x30, x8, 272, x11)

inst_53:
// rs2_w0_val == 4194304, rs1_w0_val == -2
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0xfffffffe;  op2val:0x400000
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0xfffffffe, 0x400000, x30, x8, 280, x11)

inst_54:
// rs2_w0_val == 1048576, 
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0x000007;  op2val:0x100000
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0x000007, 0x100000, x30, x8, 288, x11)

inst_55:
// rs2_w0_val == 524288, rs1_w0_val == 16777216
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0x1000000;  op2val:0x080000
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0x1000000, 0x080000, x30, x8, 296, x11)

inst_56:
// rs2_w0_val == 262144, rs1_w0_val == -1431655766
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaaa;  op2val:0x040000
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0xaaaaaaaa, 0x040000, x30, x8, 304, x11)

inst_57:
// rs2_w0_val == 131072, 
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0x000003;  op2val:0x020000
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0x000003, 0x020000, x30, x8, 312, x11)

inst_58:
// rs2_w0_val == 32768, 
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0x000003;  op2val:0x008000
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0x000003, 0x008000, x30, x8, 320, x11)

inst_59:
// rs2_w0_val == 16384, 
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0x000008;  op2val:0x004000
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0x000008, 0x004000, x30, x8, 328, x11)

inst_60:
// rs2_w0_val == 8192, rs1_w0_val == -524289
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0xfff7ffff;  op2val:0x002000
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0xfff7ffff, 0x002000, x30, x8, 336, x11)

inst_61:
// rs2_w0_val == 4096, 
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0x020000;  op2val:0x001000
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0x020000, 0x001000, x30, x8, 344, x11)

inst_62:
// rs2_w0_val == 2048, 
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0x40000000;  op2val:0x000800
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0x40000000, 0x000800, x30, x8, 352, x11)

inst_63:
// rs2_w0_val == 1024, 
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0xbfffffff;  op2val:0x000400
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0xbfffffff, 0x000400, x30, x8, 360, x11)

inst_64:
// rs2_w0_val == 512, 
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0x000002;  op2val:0x000200
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0x000002, 0x000200, x30, x8, 368, x11)

inst_65:
// rs2_w0_val == 256, rs1_w0_val == 8192
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0x002000;  op2val:0x000100
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0x002000, 0x000100, x30, x8, 376, x11)

inst_66:
// rs2_w0_val == 128, 
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0x000008;  op2val:0x000080
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0x000008, 0x000080, x30, x8, 384, x11)

inst_67:
// rs2_w0_val == 32, 
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0xfffffbff;  op2val:0x000020
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0xfffffbff, 0x000020, x30, x8, 392, x11)

inst_68:
// rs2_w0_val == 8, 
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0xffffbfff;  op2val:0x000008
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0xffffbfff, 0x000008, x30, x8, 400, x11)

inst_69:
// rs2_w0_val == 4, 
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0x008000;  op2val:0x000004
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0x008000, 0x000004, x30, x8, 408, x11)

inst_70:
// rs2_w0_val == 2, 
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0xc0000000;  op2val:0x000002
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0xc0000000, 0x000002, x30, x8, 416, x11)

inst_71:
// rs2_w0_val == 1, 
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0xffdfffff;  op2val:0x000001
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0xffdfffff, 0x000001, x30, x8, 424, x11)

inst_72:
// rs2_w0_val == 0, 
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0x000100;  op2val:0x000000
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0x000100, 0x000000, x30, x8, 432, x11)

inst_73:
// rs2_w0_val == -1, 
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0xfdffffff;  op2val:0xffffffff
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0xfdffffff, 0xffffffff, x30, x8, 440, x11)

inst_74:
// rs1_w0_val == 1431655765, 
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0x55555555;  op2val:0xffff7fff
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0x55555555, 0xffff7fff, x30, x8, 448, x11)

inst_75:
// rs1_w0_val == 2147483647, 
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0x7fffffff;  op2val:0xffefffff
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0x7fffffff, 0xffefffff, x30, x8, 456, x11)

inst_76:
// rs1_w0_val == -67108865, 
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0xfbffffff;  op2val:0xaaaaaaaa
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0xfbffffff, 0xaaaaaaaa, x30, x8, 464, x11)

inst_77:
// rs1_w0_val == -16777217, 
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0xfeffffff;  op2val:0x001000
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0xfeffffff, 0x001000, x30, x8, 472, x11)

inst_78:
// rs1_w0_val == -4194305, 
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0xffbfffff;  op2val:0xfbffffff
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0xffbfffff, 0xfbffffff, x30, x8, 480, x11)

inst_79:
// rs1_w0_val == -1048577, 
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0xffefffff;  op2val:0x1000000
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0xffefffff, 0x1000000, x30, x8, 488, x11)

inst_80:
// rs1_w0_val == -32769, 
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0xffff7fff;  op2val:0xffffffbf
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0xffff7fff, 0xffffffbf, x30, x8, 496, x11)

inst_81:
// rs1_w0_val == -8193, 
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0xffffdfff;  op2val:0x000800
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0xffffdfff, 0x000800, x30, x8, 504, x11)

inst_82:
// rs1_w0_val == -2049, 
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0xfffff7ff;  op2val:0xffffffff
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0xfffff7ff, 0xffffffff, x30, x8, 512, x11)

inst_83:
// rs1_w0_val == -513, 
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0xfffffdff;  op2val:0xff7fffff
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0xfffffdff, 0xff7fffff, x30, x8, 520, x11)

inst_84:
// rs1_w0_val == -257, 
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0xfffffeff;  op2val:0xffff7fff
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0xfffffeff, 0xffff7fff, x30, x8, 528, x11)

inst_85:
// rs1_w0_val == -129, 
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0xffffff7f;  op2val:0xc0000000
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0xffffff7f, 0xc0000000, x30, x8, 536, x11)

inst_86:
// rs1_w0_val == -33, 
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0xffffffdf;  op2val:0x000010
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0xffffffdf, 0x000010, x30, x8, 544, x11)

inst_87:
// rs1_w0_val == -17, 
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0xffffffef;  op2val:0x2000000
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0xffffffef, 0x2000000, x30, x8, 552, x11)

inst_88:
// rs1_w0_val == -9, 
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0xfffffff7;  op2val:0xdfffffff
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0xfffffff7, 0xdfffffff, x30, x8, 560, x11)

inst_89:
// rs1_w0_val == 536870912, 
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0x20000000;  op2val:0xfffffeff
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0x20000000, 0xfffffeff, x30, x8, 568, x11)

inst_90:
// rs1_w0_val == 134217728, 
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0x8000000;  op2val:0xff7fffff
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0x8000000, 0xff7fffff, x30, x8, 576, x11)

inst_91:
// rs1_w0_val == 67108864, 
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0x4000000;  op2val:0xefffffff
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0x4000000, 0xefffffff, x30, x8, 584, x11)

inst_92:
// rs1_w0_val == 4194304, 
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0x400000;  op2val:0x000020
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0x400000, 0x000020, x30, x8, 592, x11)

inst_93:
// rs1_w0_val == 1048576, 
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0x100000;  op2val:0x400000
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0x100000, 0x400000, x30, x8, 600, x11)

inst_94:
// rs1_w0_val == 524288, 
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0x080000;  op2val:0x020000
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0x080000, 0x020000, x30, x8, 608, x11)

inst_95:
// rs1_w0_val == 262144, 
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0x040000;  op2val:0x000009
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0x040000, 0x000009, x30, x8, 616, x11)

inst_96:
// rs1_w0_val == 65536, 
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0x010000;  op2val:0x000009
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0x010000, 0x000009, x30, x8, 624, x11)

inst_97:
// rs1_w0_val == 16384, 
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0x004000;  op2val:0xfffffffd
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0x004000, 0xfffffffd, x30, x8, 632, x11)

inst_98:
// rs1_w0_val == rs2_w0_val, rs2_w0_val == 16, rs1_w0_val > 0 and rs2_w0_val > 0, rs1_w0_val == 16
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0x000010;  op2val:0x000010
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0x000010, 0x000010, x30, x8, 640, x11)

inst_99:
// rs1_w0_val > 0 and rs2_w0_val < 0, rs2_w0_val == -9
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0x000009;  op2val:0xfffffff7
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0x000009, 0xfffffff7, x30, x8, 648, x11)

inst_100:
// rs2_w0_val == -536870913, rs1_w0_val == -262145
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0xfffbffff;  op2val:0xdfffffff
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0xfffbffff, 0xdfffffff, x30, x8, 656, x11)

inst_101:
// rs2_w0_val == -32769, rs1_w0_val == -1
// opcode: kslraw ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0xffff7fff
TEST_PKRR_OP(kslraw, x31, x30, x29, 0x00000000, 0xffffffff, 0xffff7fff, x30, x8, 664, x11)
#endif


RVTEST_CODE_END
RVMODEL_HALT

RVTEST_DATA_BEGIN
.align 4
rvtest_data:
.word 0xbabecafe
.word 0xabecafeb
.word 0xbecafeba
.word 0xecafebab
RVTEST_DATA_END

RVMODEL_DATA_BEGIN


signature_x1_0:
    .fill 0*(XLEN/32),4,0xdeadbeef


signature_x1_1:
    .fill 36*(XLEN/32),4,0xdeadbeef


signature_x8_0:
    .fill 168*(XLEN/32),4,0xdeadbeef

#ifdef rvtest_mtrap_routine

mtrap_sigptr:
    .fill 64*(XLEN/32),4,0xdeadbeef

#endif

#ifdef rvtest_gpr_save

gpr_save:
    .fill 32*(XLEN/32),4,0xdeadbeef

#endif

RVMODEL_DATA_END
