
// -----------
// This file was generated by riscv_ctg (https://github.com/riscv-software-src/riscv-ctg)
// version   : 0.6.3
// timestamp : Sat Apr 23 14:53:29 2022 GMT
// usage     : riscv_ctg \
//                  --cgf /scratch/git-repo/github/riscv_ctg/sample_cgfs/dataset.cgf \
//                  --cgf /scratch/git-repo/github/riscv_ctg/sample_cgfs/rv32ip.cgf \
//                  --xlen 32  \
//                  --randomize \
// -----------
//
// -----------
// Copyright (c) 2020. RISC-V International. All rights reserved.
// SPDX-License-Identifier: BSD-3-Clause
// -----------
//
// This assembly file tests the ksubw instruction of the RISC-V RV32PZicsr extension for the ksubw covergroup.
// 
#include "model_test.h"
#include "arch_test.h"
RVTEST_ISA("RV32IPZicsr")

.section .text.init
.org 0x80
.globl rvtest_entry_point
rvtest_entry_point:
RVMODEL_BOOT
RVTEST_CODE_BEGIN

#ifdef TEST_CASE_1

RVTEST_CASE(0,"//check ISA:=regex(.*32.*);check ISA:=regex(.*I.*P.*Zicsr.*);def TEST_CASE_1=True;",ksubw)

RVTEST_VXSAT_ENABLE()
RVTEST_SIGBASE(x6,signature_x6_1)

inst_0:
// rs1 != rs2  and rs1 != rd and rs2 != rd, rs1==x30, rs2==x12, rd==x2, rs1_w0_val == -2147483648, rs1_w0_val != rs2_w0_val, rs1_w0_val < 0 and rs2_w0_val > 0, rs2_w0_val == 1048576
// opcode: ksubw ; op1:x30; op2:x12; dest:x2; op1val:0x80000000;  op2val:0x100000
TEST_PKRR_OP(ksubw, x2, x30, x12, 0x00000000, 0x80000000, 0x100000, x30, x6, 0, x11)

inst_1:
// rs1 == rs2 != rd, rs1==x5, rs2==x5, rd==x13, rs1_w0_val == rs2_w0_val, rs1_w0_val < 0 and rs2_w0_val < 0
// opcode: ksubw ; op1:x5; op2:x5; dest:x13; op1val:0xfffffffc;  op2val:0xfffffffc
TEST_PKRR_OP(ksubw, x13, x5, x5, 0x00000000, 0xfffffffc, 0xfffffffc, x5, x6, 8, x11)

inst_2:
// rs1 == rd != rs2, rs1==x18, rs2==x15, rd==x18, rs1_w0_val > 0 and rs2_w0_val < 0, rs1_w0_val == 131072
// opcode: ksubw ; op1:x18; op2:x15; dest:x18; op1val:0x020000;  op2val:0xfffffffa
TEST_PKRR_OP(ksubw, x18, x18, x15, 0x00000000, 0x020000, 0xfffffffa, x18, x6, 16, x11)

inst_3:
// rs1 == rs2 == rd, rs1==x0, rs2==x0, rd==x0, rs1_w0_val > 0 and rs2_w0_val > 0, rs2_w0_val == 64, rs1_w0_val == 8192
// opcode: ksubw ; op1:x0; op2:x0; dest:x0; op1val:0x002000;  op2val:0x000040
TEST_PKRR_OP(ksubw, x0, x0, x0, 0x00000000, 0x002000, 0x000040, x0, x6, 24, x11)

inst_4:
// rs2 == rd != rs1, rs1==x25, rs2==x30, rd==x30, rs2_w0_val == -1431655766, rs1_w0_val == 2147483647
// opcode: ksubw ; op1:x25; op2:x30; dest:x30; op1val:0x7fffffff;  op2val:0xaaaaaaaa
TEST_PKRR_OP(ksubw, x30, x25, x30, 0x00000000, 0x7fffffff, 0xaaaaaaaa, x25, x6, 32, x11)

inst_5:
// rs1==x1, rs2==x19, rd==x21, rs2_w0_val == 1431655765, rs1_w0_val == 4194304
// opcode: ksubw ; op1:x1; op2:x19; dest:x21; op1val:0x400000;  op2val:0x55555555
TEST_PKRR_OP(ksubw, x21, x1, x19, 0x00000000, 0x400000, 0x55555555, x1, x6, 40, x11)

inst_6:
// rs1==x20, rs2==x28, rd==x9, rs2_w0_val == 2147483647, rs1_w0_val == 33554432
// opcode: ksubw ; op1:x20; op2:x28; dest:x9; op1val:0x2000000;  op2val:0x7fffffff
TEST_PKRR_OP(ksubw, x9, x20, x28, 0x00000000, 0x2000000, 0x7fffffff, x20, x6, 48, x11)

inst_7:
// rs1==x14, rs2==x13, rd==x15, rs2_w0_val == -1073741825, rs1_w0_val == -8388609
// opcode: ksubw ; op1:x14; op2:x13; dest:x15; op1val:0xff7fffff;  op2val:0xbfffffff
TEST_PKRR_OP(ksubw, x15, x14, x13, 0x00000000, 0xff7fffff, 0xbfffffff, x14, x6, 56, x11)

inst_8:
// rs1==x2, rs2==x26, rd==x24, rs2_w0_val == -536870913, rs1_w0_val == -5
// opcode: ksubw ; op1:x2; op2:x26; dest:x24; op1val:0xfffffffb;  op2val:0xdfffffff
TEST_PKRR_OP(ksubw, x24, x2, x26, 0x00000000, 0xfffffffb, 0xdfffffff, x2, x6, 64, x11)

inst_9:
// rs1==x15, rs2==x4, rd==x5, rs2_w0_val == -268435457, rs1_w0_val == 16
// opcode: ksubw ; op1:x15; op2:x4; dest:x5; op1val:0x000010;  op2val:0xefffffff
TEST_PKRR_OP(ksubw, x5, x15, x4, 0x00000000, 0x000010, 0xefffffff, x15, x6, 72, x11)

inst_10:
// rs1==x13, rs2==x3, rd==x27, rs2_w0_val == -134217729, rs1_w0_val == 1073741824
// opcode: ksubw ; op1:x13; op2:x3; dest:x27; op1val:0x40000000;  op2val:0xf7ffffff
TEST_PKRR_OP(ksubw, x27, x13, x3, 0x00000000, 0x40000000, 0xf7ffffff, x13, x6, 80, x11)

inst_11:
// rs1==x24, rs2==x9, rd==x16, rs2_w0_val == -67108865, 
// opcode: ksubw ; op1:x24; op2:x9; dest:x16; op1val:0xfffffff9;  op2val:0xfbffffff
TEST_PKRR_OP(ksubw, x16, x24, x9, 0x00000000, 0xfffffff9, 0xfbffffff, x24, x6, 88, x11)

inst_12:
// rs1==x9, rs2==x7, rd==x28, rs2_w0_val == -33554433, rs1_w0_val == -1025
// opcode: ksubw ; op1:x9; op2:x7; dest:x28; op1val:0xfffffbff;  op2val:0xfdffffff
TEST_PKRR_OP(ksubw, x28, x9, x7, 0x00000000, 0xfffffbff, 0xfdffffff, x9, x6, 96, x11)

inst_13:
// rs1==x19, rs2==x20, rd==x12, rs2_w0_val == -16777217, rs1_w0_val == 1024
// opcode: ksubw ; op1:x19; op2:x20; dest:x12; op1val:0x000400;  op2val:0xfeffffff
TEST_PKRR_OP(ksubw, x12, x19, x20, 0x00000000, 0x000400, 0xfeffffff, x19, x6, 104, x11)

inst_14:
// rs1==x10, rs2==x31, rd==x1, rs2_w0_val == -8388609, rs1_w0_val == -16777217
// opcode: ksubw ; op1:x10; op2:x31; dest:x1; op1val:0xfeffffff;  op2val:0xff7fffff
TEST_PKRR_OP(ksubw, x1, x10, x31, 0x00000000, 0xfeffffff, 0xff7fffff, x10, x6, 112, x11)

inst_15:
// rs1==x31, rs2==x8, rd==x7, rs2_w0_val == -4194305, rs1_w0_val == -33554433
// opcode: ksubw ; op1:x31; op2:x8; dest:x7; op1val:0xfdffffff;  op2val:0xffbfffff
TEST_PKRR_OP(ksubw, x7, x31, x8, 0x00000000, 0xfdffffff, 0xffbfffff, x31, x6, 120, x11)

inst_16:
// rs1==x4, rs2==x29, rd==x10, rs2_w0_val == -2097153, rs1_w0_val == -129
// opcode: ksubw ; op1:x4; op2:x29; dest:x10; op1val:0xffffff7f;  op2val:0xffdfffff
TEST_PKRR_OP(ksubw, x10, x4, x29, 0x00000000, 0xffffff7f, 0xffdfffff, x4, x6, 128, x11)

inst_17:
// rs1==x22, rs2==x16, rd==x23, rs2_w0_val == -1048577, 
// opcode: ksubw ; op1:x22; op2:x16; dest:x23; op1val:0xfffffffb;  op2val:0xffefffff
TEST_PKRR_OP(ksubw, x23, x22, x16, 0x00000000, 0xfffffffb, 0xffefffff, x22, x6, 136, x9)
RVTEST_SIGBASE(x5,signature_x5_0)

inst_18:
// rs1==x12, rs2==x6, rd==x25, rs2_w0_val == -524289, rs1_w0_val == -513
// opcode: ksubw ; op1:x12; op2:x6; dest:x25; op1val:0xfffffdff;  op2val:0xfff7ffff
TEST_PKRR_OP(ksubw, x25, x12, x6, 0x00000000, 0xfffffdff, 0xfff7ffff, x12, x5, 0, x9)

inst_19:
// rs1==x3, rs2==x21, rd==x29, rs2_w0_val == -262145, 
// opcode: ksubw ; op1:x3; op2:x21; dest:x29; op1val:0xfffffffc;  op2val:0xfffbffff
TEST_PKRR_OP(ksubw, x29, x3, x21, 0x00000000, 0xfffffffc, 0xfffbffff, x3, x5, 8, x9)

inst_20:
// rs1==x26, rs2==x24, rd==x14, rs2_w0_val == -131073, rs1_w0_val == 2048
// opcode: ksubw ; op1:x26; op2:x24; dest:x14; op1val:0x000800;  op2val:0xfffdffff
TEST_PKRR_OP(ksubw, x14, x26, x24, 0x00000000, 0x000800, 0xfffdffff, x26, x5, 16, x9)

inst_21:
// rs1==x28, rs2==x14, rd==x4, rs2_w0_val == -65537, 
// opcode: ksubw ; op1:x28; op2:x14; dest:x4; op1val:0x000006;  op2val:0xfffeffff
TEST_PKRR_OP(ksubw, x4, x28, x14, 0x00000000, 0x000006, 0xfffeffff, x28, x5, 24, x9)

inst_22:
// rs1==x29, rs2==x11, rd==x22, rs2_w0_val == -32769, rs1_w0_val == -2049
// opcode: ksubw ; op1:x29; op2:x11; dest:x22; op1val:0xfffff7ff;  op2val:0xffff7fff
TEST_PKRR_OP(ksubw, x22, x29, x11, 0x00000000, 0xfffff7ff, 0xffff7fff, x29, x5, 32, x9)

inst_23:
// rs1==x6, rs2==x10, rd==x8, rs2_w0_val == -16385, rs1_w0_val == 2
// opcode: ksubw ; op1:x6; op2:x10; dest:x8; op1val:0x000002;  op2val:0xffffbfff
TEST_PKRR_OP(ksubw, x8, x6, x10, 0x00000000, 0x000002, 0xffffbfff, x6, x5, 40, x9)

inst_24:
// rs1==x16, rs2==x27, rd==x6, rs2_w0_val == -8193, rs1_w0_val == -32769
// opcode: ksubw ; op1:x16; op2:x27; dest:x6; op1val:0xffff7fff;  op2val:0xffffdfff
TEST_PKRR_OP(ksubw, x6, x16, x27, 0x00000000, 0xffff7fff, 0xffffdfff, x16, x5, 48, x9)

inst_25:
// rs1==x8, rs2==x2, rd==x3, rs2_w0_val == -4097, rs1_w0_val == -17
// opcode: ksubw ; op1:x8; op2:x2; dest:x3; op1val:0xffffffef;  op2val:0xffffefff
TEST_PKRR_OP(ksubw, x3, x8, x2, 0x00000000, 0xffffffef, 0xffffefff, x8, x5, 56, x9)

inst_26:
// rs1==x27, rs2==x22, rd==x20, rs2_w0_val == -2049, rs1_w0_val == -524289
// opcode: ksubw ; op1:x27; op2:x22; dest:x20; op1val:0xfff7ffff;  op2val:0xfffff7ff
TEST_PKRR_OP(ksubw, x20, x27, x22, 0x00000000, 0xfff7ffff, 0xfffff7ff, x27, x5, 64, x9)

inst_27:
// rs1==x11, rs2==x17, rd==x19, rs2_w0_val == -1025, 
// opcode: ksubw ; op1:x11; op2:x17; dest:x19; op1val:0x000010;  op2val:0xfffffbff
TEST_PKRR_OP(ksubw, x19, x11, x17, 0x00000000, 0x000010, 0xfffffbff, x11, x5, 72, x9)

inst_28:
// rs1==x17, rs2==x25, rd==x11, rs2_w0_val == -513, rs1_w0_val == 64
// opcode: ksubw ; op1:x17; op2:x25; dest:x11; op1val:0x000040;  op2val:0xfffffdff
TEST_PKRR_OP(ksubw, x11, x17, x25, 0x00000000, 0x000040, 0xfffffdff, x17, x5, 80, x9)

inst_29:
// rs1==x21, rs2==x23, rd==x31, rs2_w0_val == -257, rs1_w0_val == 1
// opcode: ksubw ; op1:x21; op2:x23; dest:x31; op1val:0x000001;  op2val:0xfffffeff
TEST_PKRR_OP(ksubw, x31, x21, x23, 0x00000000, 0x000001, 0xfffffeff, x21, x5, 88, x9)

inst_30:
// rs1==x7, rs2==x18, rd==x17, rs2_w0_val == -129, rs1_w0_val == -2
// opcode: ksubw ; op1:x7; op2:x18; dest:x17; op1val:0xfffffffe;  op2val:0xffffff7f
TEST_PKRR_OP(ksubw, x17, x7, x18, 0x00000000, 0xfffffffe, 0xffffff7f, x7, x5, 96, x9)

inst_31:
// rs1==x23, rs2==x1, rd==x26, rs2_w0_val == -65, rs1_w0_val == 128
// opcode: ksubw ; op1:x23; op2:x1; dest:x26; op1val:0x000080;  op2val:0xffffffbf
TEST_PKRR_OP(ksubw, x26, x23, x1, 0x00000000, 0x000080, 0xffffffbf, x23, x5, 104, x9)

inst_32:
// rs2_w0_val == -33, rs1_w0_val == 512
// opcode: ksubw ; op1:x30; op2:x29; dest:x31; op1val:0x000200;  op2val:0xffffffdf
TEST_PKRR_OP(ksubw, x31, x30, x29, 0x00000000, 0x000200, 0xffffffdf, x30, x5, 112, x2)
RVTEST_SIGBASE(x1,signature_x1_0)

inst_33:
// rs2_w0_val == -17, 
// opcode: ksubw ; op1:x30; op2:x29; dest:x31; op1val:0x000800;  op2val:0xffffffef
TEST_PKRR_OP(ksubw, x31, x30, x29, 0x00000000, 0x000800, 0xffffffef, x30, x1, 0, x2)

inst_34:
// rs2_w0_val == -9, 
// opcode: ksubw ; op1:x30; op2:x29; dest:x31; op1val:0x002000;  op2val:0xfffffff7
TEST_PKRR_OP(ksubw, x31, x30, x29, 0x00000000, 0x002000, 0xfffffff7, x30, x1, 8, x2)

inst_35:
// rs2_w0_val == -5, rs1_w0_val == 256
// opcode: ksubw ; op1:x30; op2:x29; dest:x31; op1val:0x000100;  op2val:0xfffffffb
TEST_PKRR_OP(ksubw, x31, x30, x29, 0x00000000, 0x000100, 0xfffffffb, x30, x1, 16, x2)

inst_36:
// rs2_w0_val == -3, rs1_w0_val == -3
// opcode: ksubw ; op1:x30; op2:x29; dest:x31; op1val:0xfffffffd;  op2val:0xfffffffd
TEST_PKRR_OP(ksubw, x31, x30, x29, 0x00000000, 0xfffffffd, 0xfffffffd, x30, x1, 24, x2)

inst_37:
// rs2_w0_val == -2, rs1_w0_val == -131073
// opcode: ksubw ; op1:x30; op2:x29; dest:x31; op1val:0xfffdffff;  op2val:0xfffffffe
TEST_PKRR_OP(ksubw, x31, x30, x29, 0x00000000, 0xfffdffff, 0xfffffffe, x30, x1, 32, x2)

inst_38:
// rs2_w0_val == -2147483648, rs1_w0_val == 262144
// opcode: ksubw ; op1:x30; op2:x29; dest:x31; op1val:0x040000;  op2val:0x80000000
TEST_PKRR_OP(ksubw, x31, x30, x29, 0x00000000, 0x040000, 0x80000000, x30, x1, 40, x2)

inst_39:
// rs2_w0_val == 1073741824, 
// opcode: ksubw ; op1:x30; op2:x29; dest:x31; op1val:0x000200;  op2val:0x40000000
TEST_PKRR_OP(ksubw, x31, x30, x29, 0x00000000, 0x000200, 0x40000000, x30, x1, 48, x2)

inst_40:
// rs2_w0_val == 536870912, 
// opcode: ksubw ; op1:x30; op2:x29; dest:x31; op1val:0x000007;  op2val:0x20000000
TEST_PKRR_OP(ksubw, x31, x30, x29, 0x00000000, 0x000007, 0x20000000, x30, x1, 56, x2)

inst_41:
// rs2_w0_val == 268435456, 
// opcode: ksubw ; op1:x30; op2:x29; dest:x31; op1val:0xffffff7f;  op2val:0x10000000
TEST_PKRR_OP(ksubw, x31, x30, x29, 0x00000000, 0xffffff7f, 0x10000000, x30, x1, 64, x2)

inst_42:
// rs2_w0_val == 134217728, 
// opcode: ksubw ; op1:x30; op2:x29; dest:x31; op1val:0x020000;  op2val:0x8000000
TEST_PKRR_OP(ksubw, x31, x30, x29, 0x00000000, 0x020000, 0x8000000, x30, x1, 72, x2)

inst_43:
// rs2_w0_val == 67108864, 
// opcode: ksubw ; op1:x30; op2:x29; dest:x31; op1val:0x3fffffff;  op2val:0x4000000
TEST_PKRR_OP(ksubw, x31, x30, x29, 0x00000000, 0x3fffffff, 0x4000000, x30, x1, 80, x2)

inst_44:
// rs1_w0_val == 32, rs2_w0_val == 512
// opcode: ksubw ; op1:x30; op2:x29; dest:x31; op1val:0x000020;  op2val:0x000200
TEST_PKRR_OP(ksubw, x31, x30, x29, 0x00000000, 0x000020, 0x000200, x30, x1, 88, x2)

inst_45:
// rs1_w0_val == 8, 
// opcode: ksubw ; op1:x30; op2:x29; dest:x31; op1val:0x000008;  op2val:0x000009
TEST_PKRR_OP(ksubw, x31, x30, x29, 0x00000000, 0x000008, 0x000009, x30, x1, 96, x2)

inst_46:
// rs1_w0_val == 4, 
// opcode: ksubw ; op1:x30; op2:x29; dest:x31; op1val:0x000004;  op2val:0x100000
TEST_PKRR_OP(ksubw, x31, x30, x29, 0x00000000, 0x000004, 0x100000, x30, x1, 104, x2)

inst_47:
// rs1_w0_val == 0, 
// opcode: ksubw ; op1:x30; op2:x29; dest:x31; op1val:0x000000;  op2val:0x55555555
TEST_PKRR_OP(ksubw, x31, x30, x29, 0x00000000, 0x000000, 0x55555555, x30, x1, 112, x2)

inst_48:
// rs1_w0_val == -1, 
// opcode: ksubw ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0xffffffef
TEST_PKRR_OP(ksubw, x31, x30, x29, 0x00000000, 0xffffffff, 0xffffffef, x30, x1, 120, x2)

inst_49:
// rs2_w0_val == 33554432, 
// opcode: ksubw ; op1:x30; op2:x29; dest:x31; op1val:0xffffff7f;  op2val:0x2000000
TEST_PKRR_OP(ksubw, x31, x30, x29, 0x00000000, 0xffffff7f, 0x2000000, x30, x1, 128, x2)

inst_50:
// rs2_w0_val == 16777216, rs1_w0_val == -268435457
// opcode: ksubw ; op1:x30; op2:x29; dest:x31; op1val:0xefffffff;  op2val:0x1000000
TEST_PKRR_OP(ksubw, x31, x30, x29, 0x00000000, 0xefffffff, 0x1000000, x30, x1, 136, x2)

inst_51:
// rs2_w0_val == 8388608, rs1_w0_val == -4194305
// opcode: ksubw ; op1:x30; op2:x29; dest:x31; op1val:0xffbfffff;  op2val:0x800000
TEST_PKRR_OP(ksubw, x31, x30, x29, 0x00000000, 0xffbfffff, 0x800000, x30, x1, 144, x2)

inst_52:
// rs2_w0_val == 4194304, rs1_w0_val == -536870913
// opcode: ksubw ; op1:x30; op2:x29; dest:x31; op1val:0xdfffffff;  op2val:0x400000
TEST_PKRR_OP(ksubw, x31, x30, x29, 0x00000000, 0xdfffffff, 0x400000, x30, x1, 152, x2)

inst_53:
// rs2_w0_val == 2097152, 
// opcode: ksubw ; op1:x30; op2:x29; dest:x31; op1val:0xfffffffb;  op2val:0x200000
TEST_PKRR_OP(ksubw, x31, x30, x29, 0x00000000, 0xfffffffb, 0x200000, x30, x1, 160, x2)

inst_54:
// rs2_w0_val == 524288, 
// opcode: ksubw ; op1:x30; op2:x29; dest:x31; op1val:0xfffffffd;  op2val:0x080000
TEST_PKRR_OP(ksubw, x31, x30, x29, 0x00000000, 0xfffffffd, 0x080000, x30, x1, 168, x2)

inst_55:
// rs2_w0_val == 262144, rs1_w0_val == 524288
// opcode: ksubw ; op1:x30; op2:x29; dest:x31; op1val:0x080000;  op2val:0x040000
TEST_PKRR_OP(ksubw, x31, x30, x29, 0x00000000, 0x080000, 0x040000, x30, x1, 176, x2)

inst_56:
// rs2_w0_val == 131072, 
// opcode: ksubw ; op1:x30; op2:x29; dest:x31; op1val:0x000010;  op2val:0x020000
TEST_PKRR_OP(ksubw, x31, x30, x29, 0x00000000, 0x000010, 0x020000, x30, x1, 184, x2)

inst_57:
// rs2_w0_val == 65536, 
// opcode: ksubw ; op1:x30; op2:x29; dest:x31; op1val:0x000020;  op2val:0x010000
TEST_PKRR_OP(ksubw, x31, x30, x29, 0x00000000, 0x000020, 0x010000, x30, x1, 192, x2)

inst_58:
// rs2_w0_val == 32768, rs1_w0_val == -67108865
// opcode: ksubw ; op1:x30; op2:x29; dest:x31; op1val:0xfbffffff;  op2val:0x008000
TEST_PKRR_OP(ksubw, x31, x30, x29, 0x00000000, 0xfbffffff, 0x008000, x30, x1, 200, x2)

inst_59:
// rs2_w0_val == 16384, 
// opcode: ksubw ; op1:x30; op2:x29; dest:x31; op1val:0x7fffffff;  op2val:0x004000
TEST_PKRR_OP(ksubw, x31, x30, x29, 0x00000000, 0x7fffffff, 0x004000, x30, x1, 208, x2)

inst_60:
// rs2_w0_val == 8192, 
// opcode: ksubw ; op1:x30; op2:x29; dest:x31; op1val:0xff7fffff;  op2val:0x002000
TEST_PKRR_OP(ksubw, x31, x30, x29, 0x00000000, 0xff7fffff, 0x002000, x30, x1, 216, x2)

inst_61:
// rs2_w0_val == 4096, rs1_w0_val == -4097
// opcode: ksubw ; op1:x30; op2:x29; dest:x31; op1val:0xffffefff;  op2val:0x001000
TEST_PKRR_OP(ksubw, x31, x30, x29, 0x00000000, 0xffffefff, 0x001000, x30, x1, 224, x2)

inst_62:
// rs2_w0_val == 2048, rs1_w0_val == 1431655765
// opcode: ksubw ; op1:x30; op2:x29; dest:x31; op1val:0x55555555;  op2val:0x000800
TEST_PKRR_OP(ksubw, x31, x30, x29, 0x00000000, 0x55555555, 0x000800, x30, x1, 232, x2)

inst_63:
// rs2_w0_val == 1024, 
// opcode: ksubw ; op1:x30; op2:x29; dest:x31; op1val:0x7fffffff;  op2val:0x000400
TEST_PKRR_OP(ksubw, x31, x30, x29, 0x00000000, 0x7fffffff, 0x000400, x30, x1, 240, x2)

inst_64:
// rs2_w0_val == 256, rs1_w0_val == -65
// opcode: ksubw ; op1:x30; op2:x29; dest:x31; op1val:0xffffffbf;  op2val:0x000100
TEST_PKRR_OP(ksubw, x31, x30, x29, 0x00000000, 0xffffffbf, 0x000100, x30, x1, 248, x2)

inst_65:
// rs2_w0_val == 128, 
// opcode: ksubw ; op1:x30; op2:x29; dest:x31; op1val:0x000080;  op2val:0x000080
TEST_PKRR_OP(ksubw, x31, x30, x29, 0x00000000, 0x000080, 0x000080, x30, x1, 256, x2)

inst_66:
// rs2_w0_val == 32, 
// opcode: ksubw ; op1:x30; op2:x29; dest:x31; op1val:0x40000000;  op2val:0x000020
TEST_PKRR_OP(ksubw, x31, x30, x29, 0x00000000, 0x40000000, 0x000020, x30, x1, 264, x2)

inst_67:
// rs2_w0_val == 16, 
// opcode: ksubw ; op1:x30; op2:x29; dest:x31; op1val:0xfbffffff;  op2val:0x000010
TEST_PKRR_OP(ksubw, x31, x30, x29, 0x00000000, 0xfbffffff, 0x000010, x30, x1, 272, x2)

inst_68:
// rs2_w0_val == 8, 
// opcode: ksubw ; op1:x30; op2:x29; dest:x31; op1val:0xff7fffff;  op2val:0x000008
TEST_PKRR_OP(ksubw, x31, x30, x29, 0x00000000, 0xff7fffff, 0x000008, x30, x1, 280, x2)

inst_69:
// rs2_w0_val == 4, 
// opcode: ksubw ; op1:x30; op2:x29; dest:x31; op1val:0x000010;  op2val:0x000004
TEST_PKRR_OP(ksubw, x31, x30, x29, 0x00000000, 0x000010, 0x000004, x30, x1, 288, x2)

inst_70:
// rs2_w0_val == 2, rs1_w0_val == -134217729
// opcode: ksubw ; op1:x30; op2:x29; dest:x31; op1val:0xf7ffffff;  op2val:0x000002
TEST_PKRR_OP(ksubw, x31, x30, x29, 0x00000000, 0xf7ffffff, 0x000002, x30, x1, 296, x2)

inst_71:
// rs2_w0_val == 1, 
// opcode: ksubw ; op1:x30; op2:x29; dest:x31; op1val:0xfffffff9;  op2val:0x000001
TEST_PKRR_OP(ksubw, x31, x30, x29, 0x00000000, 0xfffffff9, 0x000001, x30, x1, 304, x2)

inst_72:
// rs2_w0_val == 0, 
// opcode: ksubw ; op1:x30; op2:x29; dest:x31; op1val:0x2000000;  op2val:0x000000
TEST_PKRR_OP(ksubw, x31, x30, x29, 0x00000000, 0x2000000, 0x000000, x30, x1, 312, x2)

inst_73:
// rs2_w0_val == -1, rs1_w0_val == 134217728
// opcode: ksubw ; op1:x30; op2:x29; dest:x31; op1val:0x8000000;  op2val:0xffffffff
TEST_PKRR_OP(ksubw, x31, x30, x29, 0x00000000, 0x8000000, 0xffffffff, x30, x1, 320, x2)

inst_74:
// rs1_w0_val == -1431655766, 
// opcode: ksubw ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaaa;  op2val:0x000007
TEST_PKRR_OP(ksubw, x31, x30, x29, 0x00000000, 0xaaaaaaaa, 0x000007, x30, x1, 328, x2)

inst_75:
// rs1_w0_val == -1073741825, 
// opcode: ksubw ; op1:x30; op2:x29; dest:x31; op1val:0xbfffffff;  op2val:0xfdffffff
TEST_PKRR_OP(ksubw, x31, x30, x29, 0x00000000, 0xbfffffff, 0xfdffffff, x30, x1, 336, x2)

inst_76:
// rs1_w0_val == -2097153, 
// opcode: ksubw ; op1:x30; op2:x29; dest:x31; op1val:0xffdfffff;  op2val:0x020000
TEST_PKRR_OP(ksubw, x31, x30, x29, 0x00000000, 0xffdfffff, 0x020000, x30, x1, 344, x2)

inst_77:
// rs1_w0_val == -1048577, 
// opcode: ksubw ; op1:x30; op2:x29; dest:x31; op1val:0xffefffff;  op2val:0x000020
TEST_PKRR_OP(ksubw, x31, x30, x29, 0x00000000, 0xffefffff, 0x000020, x30, x1, 352, x2)

inst_78:
// rs1_w0_val == -262145, 
// opcode: ksubw ; op1:x30; op2:x29; dest:x31; op1val:0xfffbffff;  op2val:0x000800
TEST_PKRR_OP(ksubw, x31, x30, x29, 0x00000000, 0xfffbffff, 0x000800, x30, x1, 360, x2)

inst_79:
// rs1_w0_val == -65537, 
// opcode: ksubw ; op1:x30; op2:x29; dest:x31; op1val:0xfffeffff;  op2val:0x004000
TEST_PKRR_OP(ksubw, x31, x30, x29, 0x00000000, 0xfffeffff, 0x004000, x30, x1, 368, x2)

inst_80:
// rs1_w0_val == -16385, 
// opcode: ksubw ; op1:x30; op2:x29; dest:x31; op1val:0xffffbfff;  op2val:0x000800
TEST_PKRR_OP(ksubw, x31, x30, x29, 0x00000000, 0xffffbfff, 0x000800, x30, x1, 376, x2)

inst_81:
// rs1_w0_val == -257, 
// opcode: ksubw ; op1:x30; op2:x29; dest:x31; op1val:0xfffffeff;  op2val:0xfffeffff
TEST_PKRR_OP(ksubw, x31, x30, x29, 0x00000000, 0xfffffeff, 0xfffeffff, x30, x1, 384, x2)

inst_82:
// rs1_w0_val == -33, 
// opcode: ksubw ; op1:x30; op2:x29; dest:x31; op1val:0xffffffdf;  op2val:0xfffffff8
TEST_PKRR_OP(ksubw, x31, x30, x29, 0x00000000, 0xffffffdf, 0xfffffff8, x30, x1, 392, x2)

inst_83:
// rs1_w0_val == -9, 
// opcode: ksubw ; op1:x30; op2:x29; dest:x31; op1val:0xfffffff7;  op2val:0xfffdffff
TEST_PKRR_OP(ksubw, x31, x30, x29, 0x00000000, 0xfffffff7, 0xfffdffff, x30, x1, 400, x2)

inst_84:
// rs1_w0_val == 536870912, 
// opcode: ksubw ; op1:x30; op2:x29; dest:x31; op1val:0x20000000;  op2val:0x8000000
TEST_PKRR_OP(ksubw, x31, x30, x29, 0x00000000, 0x20000000, 0x8000000, x30, x1, 408, x2)

inst_85:
// rs1_w0_val == 4096, 
// opcode: ksubw ; op1:x30; op2:x29; dest:x31; op1val:0x001000;  op2val:0xdfffffff
TEST_PKRR_OP(ksubw, x31, x30, x29, 0x00000000, 0x001000, 0xdfffffff, x30, x1, 416, x2)

inst_86:
// rs1_w0_val == 268435456, 
// opcode: ksubw ; op1:x30; op2:x29; dest:x31; op1val:0x10000000;  op2val:0x000007
TEST_PKRR_OP(ksubw, x31, x30, x29, 0x00000000, 0x10000000, 0x000007, x30, x1, 424, x2)

inst_87:
// rs1_w0_val == 67108864, 
// opcode: ksubw ; op1:x30; op2:x29; dest:x31; op1val:0x4000000;  op2val:0x000040
TEST_PKRR_OP(ksubw, x31, x30, x29, 0x00000000, 0x4000000, 0x000040, x30, x1, 432, x2)

inst_88:
// rs1_w0_val == 16777216, 
// opcode: ksubw ; op1:x30; op2:x29; dest:x31; op1val:0x1000000;  op2val:0xffefffff
TEST_PKRR_OP(ksubw, x31, x30, x29, 0x00000000, 0x1000000, 0xffefffff, x30, x1, 440, x2)

inst_89:
// rs1_w0_val == 8388608, 
// opcode: ksubw ; op1:x30; op2:x29; dest:x31; op1val:0x800000;  op2val:0xfffffffa
TEST_PKRR_OP(ksubw, x31, x30, x29, 0x00000000, 0x800000, 0xfffffffa, x30, x1, 448, x2)

inst_90:
// rs1_w0_val == 2097152, 
// opcode: ksubw ; op1:x30; op2:x29; dest:x31; op1val:0x200000;  op2val:0xffffffbf
TEST_PKRR_OP(ksubw, x31, x30, x29, 0x00000000, 0x200000, 0xffffffbf, x30, x1, 456, x2)

inst_91:
// rs1_w0_val == 1048576, 
// opcode: ksubw ; op1:x30; op2:x29; dest:x31; op1val:0x100000;  op2val:0x010000
TEST_PKRR_OP(ksubw, x31, x30, x29, 0x00000000, 0x100000, 0x010000, x30, x1, 464, x2)

inst_92:
// rs1_w0_val == 65536, 
// opcode: ksubw ; op1:x30; op2:x29; dest:x31; op1val:0x010000;  op2val:0x000005
TEST_PKRR_OP(ksubw, x31, x30, x29, 0x00000000, 0x010000, 0x000005, x30, x1, 472, x2)

inst_93:
// rs1_w0_val == 32768, 
// opcode: ksubw ; op1:x30; op2:x29; dest:x31; op1val:0x008000;  op2val:0xffffbfff
TEST_PKRR_OP(ksubw, x31, x30, x29, 0x00000000, 0x008000, 0xffffbfff, x30, x1, 480, x2)

inst_94:
// rs1_w0_val == 16384, 
// opcode: ksubw ; op1:x30; op2:x29; dest:x31; op1val:0x004000;  op2val:0x000001
TEST_PKRR_OP(ksubw, x31, x30, x29, 0x00000000, 0x004000, 0x000001, x30, x1, 488, x2)

inst_95:
// rs1_w0_val == -8193, 
// opcode: ksubw ; op1:x30; op2:x29; dest:x31; op1val:0xffffdfff;  op2val:0x000020
TEST_PKRR_OP(ksubw, x31, x30, x29, 0x00000000, 0xffffdfff, 0x000020, x30, x1, 496, x2)
#endif


RVTEST_CODE_END
RVMODEL_HALT

RVTEST_DATA_BEGIN
.align 4
rvtest_data:
.word 0xbabecafe
.word 0xabecafeb
.word 0xbecafeba
.word 0xecafebab
RVTEST_DATA_END

RVMODEL_DATA_BEGIN


signature_x6_0:
    .fill 0*(XLEN/32),4,0xdeadbeef


signature_x6_1:
    .fill 36*(XLEN/32),4,0xdeadbeef


signature_x5_0:
    .fill 30*(XLEN/32),4,0xdeadbeef


signature_x1_0:
    .fill 126*(XLEN/32),4,0xdeadbeef

#ifdef rvtest_mtrap_routine

mtrap_sigptr:
    .fill 64*(XLEN/32),4,0xdeadbeef

#endif

#ifdef rvtest_gpr_save

gpr_save:
    .fill 32*(XLEN/32),4,0xdeadbeef

#endif

RVMODEL_DATA_END
