
// -----------
// This file was generated by riscv_ctg (https://github.com/riscv-software-src/riscv-ctg)
// version   : 0.6.3
// timestamp : Sat Apr 23 14:53:29 2022 GMT
// usage     : riscv_ctg \
//                  --cgf /scratch/git-repo/github/riscv_ctg/sample_cgfs/dataset.cgf \
//                  --cgf /scratch/git-repo/github/riscv_ctg/sample_cgfs/rv32ip.cgf \
//                  --xlen 32  \
//                  --randomize \
// -----------
//
// -----------
// Copyright (c) 2020. RISC-V International. All rights reserved.
// SPDX-License-Identifier: BSD-3-Clause
// -----------
//
// This assembly file tests the kwmmul instruction of the RISC-V RV32PZicsr extension for the kwmmul covergroup.
// 
#include "model_test.h"
#include "arch_test.h"
RVTEST_ISA("RV32IPZicsr")

.section .text.init
.org 0x80
.globl rvtest_entry_point
rvtest_entry_point:
RVMODEL_BOOT
RVTEST_CODE_BEGIN

#ifdef TEST_CASE_1

RVTEST_CASE(0,"//check ISA:=regex(.*32.*);check ISA:=regex(.*I.*P.*Zicsr.*);def TEST_CASE_1=True;",kwmmul)

RVTEST_VXSAT_ENABLE()
RVTEST_SIGBASE(x8,signature_x8_1)

inst_0:
// rs1 != rs2  and rs1 != rd and rs2 != rd, rs1==x19, rs2==x25, rd==x7, rs1_w0_val == -2147483648, rs2_w0_val == -8388609
// opcode: kwmmul ; op1:x19; dest:x7; op1val:0x80000000;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x7, x19, x25, 0x00000000, 0x80000000, 0xff7fffff, x19, x8, 0, x1)

inst_1:
// rs1 == rs2 != rd, rs1==x14, rs2==x14, rd==x4, rs2_w0_val == -1431655766, rs1_w0_val == -9
// opcode: kwmmul ; op1:x14; dest:x4; op1val:0xfffffff7;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x4, x14, x14, 0x00000000, 0xfffffff7, 0xaaaaaaaa, x14, x8, 8, x1)

inst_2:
// rs1 == rd != rs2, rs1==x24, rs2==x19, rd==x24, rs2_w0_val == 1431655765, rs1_w0_val == 33554432
// opcode: kwmmul ; op1:x24; dest:x24; op1val:0x2000000;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x24, x24, x19, 0x00000000, 0x2000000, 0x55555555, x24, x8, 16, x1)

inst_3:
// rs1 == rs2 == rd, rs1==x26, rs2==x26, rd==x26, rs2_w0_val == 2147483647, rs1_w0_val == -4097
// opcode: kwmmul ; op1:x26; dest:x26; op1val:0xffffefff;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x26, x26, x26, 0x00000000, 0xffffefff, 0x7fffffff, x26, x8, 24, x1)

inst_4:
// rs2 == rd != rs1, rs1==x21, rs2==x11, rd==x11, rs2_w0_val == -1073741825, rs1_w0_val == -2
// opcode: kwmmul ; op1:x21; dest:x11; op1val:0xfffffffe;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x11, x21, x11, 0x00000000, 0xfffffffe, 0xbfffffff, x21, x8, 32, x1)

inst_5:
// rs1==x27, rs2==x15, rd==x21, rs2_w0_val == -536870913, 
// opcode: kwmmul ; op1:x27; dest:x21; op1val:0x66666666;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x21, x27, x15, 0x00000000, 0x66666666, 0xdfffffff, x27, x8, 40, x1)

inst_6:
// rs1==x2, rs2==x10, rd==x20, rs2_w0_val == -268435457, rs1_w0_val == -536870913
// opcode: kwmmul ; op1:x2; dest:x20; op1val:0xdfffffff;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x20, x2, x10, 0x00000000, 0xdfffffff, 0xefffffff, x2, x8, 48, x1)

inst_7:
// rs1==x16, rs2==x30, rd==x18, rs2_w0_val == -134217729, 
// opcode: kwmmul ; op1:x16; dest:x18; op1val:0x33333333;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x18, x16, x30, 0x00000000, 0x33333333, 0xf7ffffff, x16, x8, 56, x1)

inst_8:
// rs1==x9, rs2==x2, rd==x16, rs2_w0_val == -67108865, rs1_w0_val == -67108865
// opcode: kwmmul ; op1:x9; dest:x16; op1val:0xfbffffff;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x16, x9, x2, 0x00000000, 0xfbffffff, 0xfbffffff, x9, x8, 64, x1)

inst_9:
// rs1==x3, rs2==x12, rd==x23, rs2_w0_val == -33554433, rs1_w0_val == 8192
// opcode: kwmmul ; op1:x3; dest:x23; op1val:0x002000;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x23, x3, x12, 0x00000000, 0x002000, 0xfdffffff, x3, x8, 72, x1)

inst_10:
// rs1==x22, rs2==x27, rd==x28, rs2_w0_val == -16777217, rs1_w0_val == 4
// opcode: kwmmul ; op1:x22; dest:x28; op1val:0x000004;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x28, x22, x27, 0x00000000, 0x000004, 0xfeffffff, x22, x8, 80, x1)

inst_11:
// rs1==x4, rs2==x31, rd==x5, rs2_w0_val == -4194305, 
// opcode: kwmmul ; op1:x4; dest:x5; op1val:0xfbffffff;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x5, x4, x31, 0x00000000, 0xfbffffff, 0xffbfffff, x4, x8, 88, x1)

inst_12:
// rs1==x6, rs2==x18, rd==x25, rs2_w0_val == -2097153, rs1_w0_val == 262144
// opcode: kwmmul ; op1:x6; dest:x25; op1val:0x040000;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x25, x6, x18, 0x00000000, 0x040000, 0xffdfffff, x6, x8, 96, x1)

inst_13:
// rs1==x1, rs2==x0, rd==x10, rs2_w0_val == -1048577, 
// opcode: kwmmul ; op1:x1; dest:x10; op1val:0x000006;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x10, x1, x0, 0x00000000, 0x000006, 0xffefffff, x1, x8, 104, x18)
RVTEST_SIGBASE(x3,signature_x3_0)

inst_14:
// rs1==x7, rs2==x5, rd==x31, rs2_w0_val == -524289, rs1_w0_val == -17
// opcode: kwmmul ; op1:x7; dest:x31; op1val:0xffffffef;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x7, x5, 0x00000000, 0xffffffef, 0xfff7ffff, x7, x3, 0, x18)

inst_15:
// rs1==x8, rs2==x21, rd==x13, rs2_w0_val == -262145, rs1_w0_val == -129
// opcode: kwmmul ; op1:x8; dest:x13; op1val:0xffffff7f;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x13, x8, x21, 0x00000000, 0xffffff7f, 0xfffbffff, x8, x3, 8, x18)

inst_16:
// rs1==x10, rs2==x22, rd==x19, rs2_w0_val == -131073, 
// opcode: kwmmul ; op1:x10; dest:x19; op1val:0xfffffff9;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x19, x10, x22, 0x00000000, 0xfffffff9, 0xfffdffff, x10, x3, 16, x18)

inst_17:
// rs1==x12, rs2==x23, rd==x14, rs2_w0_val == -65537, rs1_w0_val == 2
// opcode: kwmmul ; op1:x12; dest:x14; op1val:0x000002;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x14, x12, x23, 0x00000000, 0x000002, 0xfffeffff, x12, x3, 24, x18)

inst_18:
// rs1==x11, rs2==x20, rd==x6, rs2_w0_val == -32769, 
// opcode: kwmmul ; op1:x11; dest:x6; op1val:0x000007;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x6, x11, x20, 0x00000000, 0x000007, 0xffff7fff, x11, x3, 32, x18)

inst_19:
// rs1==x28, rs2==x16, rd==x27, rs2_w0_val == -16385, 
// opcode: kwmmul ; op1:x28; dest:x27; op1val:0xffff4afc;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x27, x28, x16, 0x00000000, 0xffff4afc, 0xffffbfff, x28, x3, 40, x18)

inst_20:
// rs1==x13, rs2==x4, rd==x17, rs2_w0_val == -8193, 
// opcode: kwmmul ; op1:x13; dest:x17; op1val:0x000002;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x17, x13, x4, 0x00000000, 0x000002, 0xffffdfff, x13, x3, 48, x18)

inst_21:
// rs1==x5, rs2==x6, rd==x29, rs2_w0_val == -4097, rs1_w0_val == -1048577
// opcode: kwmmul ; op1:x5; dest:x29; op1val:0xffefffff;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x29, x5, x6, 0x00000000, 0xffefffff, 0xffffefff, x5, x3, 56, x18)

inst_22:
// rs1==x0, rs2==x7, rd==x2, rs2_w0_val == -2049, rs1_w0_val == -1025
// opcode: kwmmul ; op1:x0; dest:x2; op1val:0xfffffbff;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x2, x0, x7, 0x00000000, 0xfffffbff, 0xfffff7ff, x0, x3, 64, x18)

inst_23:
// rs1==x30, rs2==x29, rd==x15, rs2_w0_val == -1025, 
// opcode: kwmmul ; op1:x30; dest:x15; op1val:0xffff4afd;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x15, x30, x29, 0x00000000, 0xffff4afd, 0xfffffbff, x30, x3, 72, x18)

inst_24:
// rs1==x17, rs2==x28, rd==x9, rs2_w0_val == -513, rs1_w0_val == -131073
// opcode: kwmmul ; op1:x17; dest:x9; op1val:0xfffdffff;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x9, x17, x28, 0x00000000, 0xfffdffff, 0xfffffdff, x17, x3, 80, x18)

inst_25:
// rs1==x20, rs2==x17, rd==x1, rs2_w0_val == -257, rs1_w0_val == -8388609
// opcode: kwmmul ; op1:x20; dest:x1; op1val:0xff7fffff;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x1, x20, x17, 0x00000000, 0xff7fffff, 0xfffffeff, x20, x3, 88, x4)

inst_26:
// rs1==x23, rs2==x24, rd==x22, rs2_w0_val == -129, rs1_w0_val == -524289
// opcode: kwmmul ; op1:x23; dest:x22; op1val:0xfff7ffff;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x22, x23, x24, 0x00000000, 0xfff7ffff, 0xffffff7f, x23, x3, 96, x4)
RVTEST_SIGBASE(x2,signature_x2_0)

inst_27:
// rs1==x18, rs2==x1, rd==x8, rs2_w0_val == -65, rs1_w0_val == 8388608
// opcode: kwmmul ; op1:x18; dest:x8; op1val:0x800000;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x8, x18, x1, 0x00000000, 0x800000, 0xffffffbf, x18, x2, 0, x4)

inst_28:
// rs1==x25, rs2==x9, rd==x12, rs2_w0_val == -33, rs1_w0_val == 524288
// opcode: kwmmul ; op1:x25; dest:x12; op1val:0x080000;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x12, x25, x9, 0x00000000, 0x080000, 0xffffffdf, x25, x2, 8, x4)

inst_29:
// rs1==x29, rs2==x3, rd==x0, rs2_w0_val == -17, rs1_w0_val == 4194304
// opcode: kwmmul ; op1:x29; dest:x0; op1val:0x400000;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x0, x29, x3, 0x00000000, 0x400000, 0xffffffef, x29, x2, 16, x4)

inst_30:
// rs1==x31, rs2==x13, rd==x30, rs2_w0_val == -9, rs1_w0_val == -65537
// opcode: kwmmul ; op1:x31; dest:x30; op1val:0xfffeffff;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x30, x31, x13, 0x00000000, 0xfffeffff, 0xfffffff7, x31, x2, 24, x4)

inst_31:
// rs1==x15, rs2==x8, rd==x3, rs2_w0_val == -5, 
// opcode: kwmmul ; op1:x15; dest:x3; op1val:0x000004;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x3, x15, x8, 0x00000000, 0x000004, 0xfffffffb, x15, x2, 32, x4)

inst_32:
// rs2_w0_val == -3, 
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0x66666667;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0x66666667, 0xfffffffd, x30, x2, 40, x4)

inst_33:
// rs2_w0_val == -2, rs1_w0_val == -32769
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0xffff7fff;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0xffff7fff, 0xfffffffe, x30, x2, 48, x4)

inst_34:
// rs2_w0_val == -2147483648, 
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0xfffffffe;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0xfffffffe, 0x80000000, x30, x2, 56, x4)

inst_35:
// rs2_w0_val == 1073741824, rs1_w0_val == -268435457
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0xefffffff;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0xefffffff, 0x40000000, x30, x2, 64, x4)

inst_36:
// rs2_w0_val == 536870912, 
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0xfffdffff;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0xfffdffff, 0x20000000, x30, x2, 72, x4)

inst_37:
// rs2_w0_val == 268435456, 
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0xfffffff7;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0xfffffff7, 0x10000000, x30, x2, 80, x4)

inst_38:
// rs2_w0_val == 134217728, 
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0xffffefff;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0xffffefff, 0x8000000, x30, x2, 88, x4)

inst_39:
// rs2_w0_val == 67108864, rs1_w0_val == 32768
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0x008000;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0x008000, 0x4000000, x30, x2, 96, x4)

inst_40:
// rs2_w0_val == 33554432, 
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0x55555554;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0x55555554, 0x2000000, x30, x2, 104, x4)

inst_41:
// rs2_w0_val == 16777216, 
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0xc0000000;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0xc0000000, 0x1000000, x30, x2, 112, x4)

inst_42:
// rs2_w0_val == 8388608, 
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0xfffffffc;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0xfffffffc, 0x800000, x30, x2, 120, x4)

inst_43:
// rs2_w0_val == 4194304, rs1_w0_val == -1073741825
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0xbfffffff;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0xbfffffff, 0x400000, x30, x2, 128, x4)

inst_44:
// rs2_w0_val == 2097152, 
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0x400000;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0x400000, 0x200000, x30, x2, 136, x4)

inst_45:
// rs2_w0_val == 1048576, 
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0xfffffbff;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0xfffffbff, 0x100000, x30, x2, 144, x4)

inst_46:
// rs2_w0_val == 524288, rs1_w0_val == 2147483647
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0x7fffffff;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0x7fffffff, 0x080000, x30, x2, 152, x4)

inst_47:
// rs1_w0_val == 32, 
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0x000020;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0x000020, 0xf7ffffff, x30, x2, 160, x4)

inst_48:
// rs1_w0_val == 16, rs2_w0_val == 16
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0x000010;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0x000010, 0x000010, x30, x2, 168, x4)

inst_49:
// rs1_w0_val == 8, 
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0x000008;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0x000008, 0x40000000, x30, x2, 176, x4)

inst_50:
// rs1_w0_val == 1, 
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0x000001;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0x000001, 0x10000000, x30, x2, 184, x4)

inst_51:
// rs1_w0_val == 0, 
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0x000000;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0x000000, 0x3fffffff, x30, x2, 192, x4)

inst_52:
// rs1_w0_val == -1, 
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0xffffffff;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0xffffffff, 0xfffeffff, x30, x2, 200, x4)

inst_53:
// rs2_w0_val == 262144, rs1_w0_val == 256
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0x000100;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0x000100, 0x040000, x30, x2, 208, x4)

inst_54:
// rs2_w0_val == 131072, rs1_w0_val == 131072
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0x020000;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0x020000, 0x020000, x30, x2, 216, x4)

inst_55:
// rs2_w0_val == 65536, rs1_w0_val == -513
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0xfffffdff;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0xfffffdff, 0x010000, x30, x2, 224, x4)

inst_56:
// rs2_w0_val == 32768, rs1_w0_val == -33554433
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0xfdffffff;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0xfdffffff, 0x008000, x30, x2, 232, x4)

inst_57:
// rs2_w0_val == 16384, 
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0xfffeffff;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0xfffeffff, 0x004000, x30, x2, 240, x4)

inst_58:
// rs2_w0_val == 8192, 
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0x040000;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0x040000, 0x002000, x30, x2, 248, x4)

inst_59:
// rs2_w0_val == 4096, 
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0x000003;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0x000003, 0x001000, x30, x2, 256, x4)

inst_60:
// rs2_w0_val == 2048, 
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0x80000000;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0x80000000, 0x000800, x30, x2, 264, x4)

inst_61:
// rs2_w0_val == 1024, rs1_w0_val == -8193
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0xffffdfff;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0xffffdfff, 0x000400, x30, x2, 272, x4)

inst_62:
// rs2_w0_val == 512, rs1_w0_val == 512
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0x000200;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0x000200, 0x000200, x30, x2, 280, x4)

inst_63:
// rs2_w0_val == 256, 
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0x002000;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0x002000, 0x000100, x30, x2, 288, x4)

inst_64:
// rs2_w0_val == 128, 
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0xfffdffff;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0xfffdffff, 0x000080, x30, x2, 296, x4)

inst_65:
// rs2_w0_val == 64, rs1_w0_val == -1431655766
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0xaaaaaaaa;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0xaaaaaaaa, 0x000040, x30, x2, 304, x4)

inst_66:
// rs2_w0_val == 32, rs1_w0_val == -2049
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0xfffff7ff;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0xfffff7ff, 0x000020, x30, x2, 312, x4)

inst_67:
// rs2_w0_val == 8, 
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0xffffff7f;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0xffffff7f, 0x000008, x30, x2, 320, x4)

inst_68:
// rs2_w0_val == 4, 
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0x33333333;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0x33333333, 0x000004, x30, x2, 328, x4)

inst_69:
// rs2_w0_val == 2, 
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0x000020;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0x000020, 0x000002, x30, x2, 336, x4)

inst_70:
// rs2_w0_val == 1, 
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0xffff4afd;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0xffff4afd, 0x000001, x30, x2, 344, x4)

inst_71:
// rs2_w0_val == 0, 
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0x66666666;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0x66666666, 0x000000, x30, x2, 352, x4)

inst_72:
// rs2_w0_val == -1, rs1_w0_val == -33
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0xffffffdf;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0xffffffdf, 0xffffffff, x30, x2, 360, x4)

inst_73:
// rs1_w0_val == 1431655765, 
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0x55555555;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0x55555555, 0x00b503, x30, x2, 368, x4)

inst_74:
// rs1_w0_val == -134217729, 
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0xf7ffffff;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0xf7ffffff, 0x000003, x30, x2, 376, x4)

inst_75:
// rs1_w0_val == -16777217, 
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0xfeffffff;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0xfeffffff, 0xffffffef, x30, x2, 384, x4)

inst_76:
// rs1_w0_val == -4194305, 
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0xffbfffff;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0xffbfffff, 0xffffdfff, x30, x2, 392, x4)

inst_77:
// rs1_w0_val == -2097153, 
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0xffdfffff;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0xffdfffff, 0xffbfffff, x30, x2, 400, x4)

inst_78:
// rs1_w0_val == -262145, 
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0xfffbffff;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0xfffbffff, 0x00b505, x30, x2, 408, x4)

inst_79:
// rs1_w0_val == -16385, 
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0xffffbfff;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0xffffbfff, 0xfffffdff, x30, x2, 416, x4)

inst_80:
// rs1_w0_val == -257, 
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0xfffffeff;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0xfffffeff, 0xfffffffb, x30, x2, 424, x4)

inst_81:
// rs1_w0_val == -65, 
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0xffffffbf;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0xffffffbf, 0xffff4afc, x30, x2, 432, x4)

inst_82:
// rs1_w0_val == -5, 
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0xfffffffb;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0xfffffffb, 0x3fffffff, x30, x2, 440, x4)

inst_83:
// rs1_w0_val == -3, 
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0xfffffffd;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0xfffffffd, 0xfffffff8, x30, x2, 448, x4)

inst_84:
// rs1_w0_val == 1073741824, 
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0x40000000;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0x40000000, 0x800000, x30, x2, 456, x4)

inst_85:
// rs1_w0_val == 536870912, 
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0x20000000;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0x20000000, 0x33333334, x30, x2, 464, x4)

inst_86:
// rs1_w0_val == 268435456, 
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0x10000000;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0x10000000, 0xfffdffff, x30, x2, 472, x4)

inst_87:
// rs1_w0_val == 134217728, 
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0x8000000;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0x8000000, 0x080000, x30, x2, 480, x4)

inst_88:
// rs1_w0_val == 67108864, 
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0x4000000;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0x4000000, 0xfffffbff, x30, x2, 488, x4)

inst_89:
// rs1_w0_val == 16777216, 
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0x1000000;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0x1000000, 0x000006, x30, x2, 496, x4)

inst_90:
// rs1_w0_val == 2097152, 
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0x200000;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0x200000, 0xfffffff6, x30, x2, 504, x4)

inst_91:
// rs1_w0_val == 1048576, 
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0x100000;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0x100000, 0x80000000, x30, x2, 512, x4)

inst_92:
// rs1_w0_val == 65536, 
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0x010000;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0x010000, 0xff7fffff, x30, x2, 520, x4)

inst_93:
// rs1_w0_val == 16384, 
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0x004000;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0x004000, 0xfffffffd, x30, x2, 528, x4)

inst_94:
// rs1_w0_val == 4096, 
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0x001000;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0x001000, 0x000040, x30, x2, 536, x4)

inst_95:
// rs1_w0_val == 2048, 
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0x000800;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0x000800, 0x33333332, x30, x2, 544, x4)

inst_96:
// rs1_w0_val == 1024, 
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0x000400;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0x000400, 0x800000, x30, x2, 552, x4)

inst_97:
// rs1_w0_val == 128, 
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0x000080;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0x000080, 0x004000, x30, x2, 560, x4)

inst_98:
// rs1_w0_val == 64, 
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0x000040;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0x000040, 0x3fffffff, x30, x2, 568, x4)

inst_99:
// rs2_w0_val == -1431655766, rs1_w0_val == -9
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0xfffffff7;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0xfffffff7, 0xaaaaaaaa, x30, x2, 576, x4)

inst_100:
// rs2_w0_val == 2147483647, rs1_w0_val == -4097
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0xffffefff;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0xffffefff, 0x7fffffff, x30, x2, 584, x4)

inst_101:
// rs2_w0_val == -1048577, 
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0x000006;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0x000006, 0xffefffff, x30, x2, 592, x4)

inst_102:
// rs2_w0_val == -2049, rs1_w0_val == -1025
// opcode: kwmmul ; op1:x30; dest:x31; op1val:0xfffffbff;  immval:$imm_val
TEST_PKRR_OP(kwmmul, x31, x30, x29, 0x00000000, 0xfffffbff, 0xfffff7ff, x30, x2, 600, x4)
#endif


RVTEST_CODE_END
RVMODEL_HALT

RVTEST_DATA_BEGIN
.align 4
rvtest_data:
.word 0xbabecafe
.word 0xabecafeb
.word 0xbecafeba
.word 0xecafebab
RVTEST_DATA_END

RVMODEL_DATA_BEGIN


signature_x8_0:
    .fill 0*(XLEN/32),4,0xdeadbeef


signature_x8_1:
    .fill 28*(XLEN/32),4,0xdeadbeef


signature_x3_0:
    .fill 26*(XLEN/32),4,0xdeadbeef


signature_x2_0:
    .fill 152*(XLEN/32),4,0xdeadbeef

#ifdef rvtest_mtrap_routine

mtrap_sigptr:
    .fill 64*(XLEN/32),4,0xdeadbeef

#endif

#ifdef rvtest_gpr_save

gpr_save:
    .fill 32*(XLEN/32),4,0xdeadbeef

#endif

RVMODEL_DATA_END
