
// -----------
// This file was generated by riscv_ctg (https://github.com/riscv-software-src/riscv-ctg)
// version   : 0.6.3
// timestamp : Sat Apr 23 14:53:29 2022 GMT
// usage     : riscv_ctg \
//                  --cgf /scratch/git-repo/github/riscv_ctg/sample_cgfs/dataset.cgf \
//                  --cgf /scratch/git-repo/github/riscv_ctg/sample_cgfs/rv32ip.cgf \
//                  --xlen 32  \
//                  --randomize \
// -----------
//
// -----------
// Copyright (c) 2020. RISC-V International. All rights reserved.
// SPDX-License-Identifier: BSD-3-Clause
// -----------
//
// This assembly file tests the mulsr64 instruction of the RISC-V RV32PZicsr extension for the mulsr64 covergroup.
// 
#include "model_test.h"
#include "arch_test.h"
RVTEST_ISA("RV32IPZicsr")

.section .text.init
.org 0x80
.globl rvtest_entry_point
rvtest_entry_point:
RVMODEL_BOOT
RVTEST_CODE_BEGIN

#ifdef TEST_CASE_1

RVTEST_CASE(0,"//check ISA:=regex(.*32.*);check ISA:=regex(.*I.*P.*Zicsr.*);def TEST_CASE_1=True;",mulsr64)

RVTEST_VXSAT_ENABLE()
RVTEST_SIGBASE(x1,signature_x1_1)

inst_0:
// rs1 != rs2  and rs1 != rd and rs2 != rd, rs1==x21, rs2==x13, rd==x30, rs1_w0_val == -2147483648, rs2_w0_val == 16384
// opcode: mulsr64 ; op1:x21; op2:x13; dest:x30; op1val:0x80000000;  op2val:0x00004000
TEST_P64_PNN_OP(mulsr64, x30, x31, x21, x13, 0x00000000, 0, 0x80000000, 0x00004000, x1, 0, x4)

inst_1:
// rs1 == rs2 != rd, rs1==x15, rs2==x15, rd==x16, rs2_w0_val == -1431655766, rs1_w0_val == -33554433
// opcode: mulsr64 ; op1:x15; op2:x15; dest:x16; op1val:0xfdffffff;  op2val:0xaaaaaaaa
TEST_P64_PNN_OP(mulsr64, x16, x17, x15, x15, 0x00000000, 0, 0xfdffffff, 0xaaaaaaaa, x1, 8, x4)

inst_2:
// rs1 == rd != rs2, rs1==x12, rs2==x28, rd==x12, rs2_w0_val == 1431655765, rs1_w0_val == -1431655766
// opcode: mulsr64 ; op1:x12; op2:x28; dest:x12; op1val:0xaaaaaaaa;  op2val:0x55555555
TEST_P64_PNN_OP(mulsr64, x12, x13, x12, x28, 0x00000000, 0, 0xaaaaaaaa, 0x55555555, x1, 16, x4)

inst_3:
// rs1 == rs2 == rd, rs1==x8, rs2==x8, rd==x8, rs2_w0_val == 2147483647, rs1_w0_val == -5
// opcode: mulsr64 ; op1:x8; op2:x8; dest:x8; op1val:0xfffffffb;  op2val:0x7fffffff
TEST_P64_PNN_OP(mulsr64, x8, x9, x8, x8, 0x00000000, 0, 0xfffffffb, 0x7fffffff, x1, 24, x4)

inst_4:
// rs2 == rd != rs1, rs1==x5, rs2==x2, rd==x2, rs2_w0_val == -1073741825, rs1_w0_val == -32769
// opcode: mulsr64 ; op1:x5; op2:x2; dest:x2; op1val:0xffff7fff;  op2val:0xbfffffff
TEST_P64_PNN_OP(mulsr64, x2, x3, x5, x2, 0x00000000, 0, 0xffff7fff, 0xbfffffff, x1, 32, x4)

inst_5:
// rs1==x14, rs2==x27, rd==x10, rs2_w0_val == -536870913, 
// opcode: mulsr64 ; op1:x14; op2:x27; dest:x10; op1val:0x00000005;  op2val:0xdfffffff
TEST_P64_PNN_OP(mulsr64, x10, x11, x14, x27, 0x00000000, 0, 0x00000005, 0xdfffffff, x1, 40, x4)

inst_6:
// rs1==x3, rs2==x29, rd==x18, rs2_w0_val == -268435457, rs1_w0_val == 131072
// opcode: mulsr64 ; op1:x3; op2:x29; dest:x18; op1val:0x00020000;  op2val:0xefffffff
TEST_P64_PNN_OP(mulsr64, x18, x19, x3, x29, 0x00000000, 0, 0x00020000, 0xefffffff, x1, 48, x4)

inst_7:
// rs1==x26, rs2==x9, rd==x28, rs2_w0_val == -134217729, rs1_w0_val == 33554432
// opcode: mulsr64 ; op1:x26; op2:x9; dest:x28; op1val:0x02000000;  op2val:0xf7ffffff
TEST_P64_PNN_OP(mulsr64, x28, x29, x26, x9, 0x00000000, 0, 0x02000000, 0xf7ffffff, x1, 56, x4)

inst_8:
// rs1==x20, rs2==x3, rd==x6, rs2_w0_val == -67108865, rs1_w0_val == 2048
// opcode: mulsr64 ; op1:x20; op2:x3; dest:x6; op1val:0x00000800;  op2val:0xfbffffff
TEST_P64_PNN_OP(mulsr64, x6, x7, x20, x3, 0x00000000, 0, 0x00000800, 0xfbffffff, x1, 64, x4)

inst_9:
// rs1==x0, rs2==x16, rd==x22, rs2_w0_val == -33554433, rs1_w0_val == 64
// opcode: mulsr64 ; op1:x0; op2:x16; dest:x22; op1val:0x00000040;  op2val:0xfdffffff
TEST_P64_PNN_OP(mulsr64, x22, x23, x0, x16, 0x00000000, 0, 0x00000040, 0xfdffffff, x1, 72, x3)
RVTEST_SIGBASE(x2,signature_x2_0)

inst_10:
// rs1==x16, rs2==x25, rd==x4, rs2_w0_val == -16777217, rs1_w0_val == 262144
// opcode: mulsr64 ; op1:x16; op2:x25; dest:x4; op1val:0x00040000;  op2val:0xfeffffff
TEST_P64_PNN_OP(mulsr64, x4, x5, x16, x25, 0x00000000, 0, 0x00040000, 0xfeffffff, x2, 0, x3)

inst_11:
// rs1==x19, rs2==x4, rd==x20, rs2_w0_val == -8388609, rs1_w0_val == 2
// opcode: mulsr64 ; op1:x19; op2:x4; dest:x20; op1val:0x00000002;  op2val:0xff7fffff
TEST_P64_PNN_OP(mulsr64, x20, x21, x19, x4, 0x00000000, 0, 0x00000002, 0xff7fffff, x2, 8, x3)

inst_12:
// rs1==x23, rs2==x21, rd==x24, rs2_w0_val == -4194305, rs1_w0_val == -4097
// opcode: mulsr64 ; op1:x23; op2:x21; dest:x24; op1val:0xffffefff;  op2val:0xffbfffff
TEST_P64_PNN_OP(mulsr64, x24, x25, x23, x21, 0x00000000, 0, 0xffffefff, 0xffbfffff, x2, 16, x3)

inst_13:
// rs1==x13, rs2==x1, rd==x26, rs2_w0_val == -2097153, rs1_w0_val == 256
// opcode: mulsr64 ; op1:x13; op2:x1; dest:x26; op1val:0x00000100;  op2val:0xffdfffff
TEST_P64_PNN_OP(mulsr64, x26, x27, x13, x1, 0x00000000, 0, 0x00000100, 0xffdfffff, x2, 24, x3)

inst_14:
// rs1==x6, rs2==x7, rd==x14, rs2_w0_val == -1048577, rs1_w0_val == 16777216
// opcode: mulsr64 ; op1:x6; op2:x7; dest:x14; op1val:0x01000000;  op2val:0xffefffff
TEST_P64_PNN_OP(mulsr64, x14, x15, x6, x7, 0x00000000, 0, 0x01000000, 0xffefffff, x2, 32, x3)

inst_15:
// rs1==x7, rs2==x22, rs2_w0_val == -524289, 
// opcode: mulsr64 ; op1:x7; op2:x22; dest:x8; op1val:0xfffffff6;  op2val:0xfff7ffff
TEST_P64_PNN_OP(mulsr64, x8, x9, x7, x22, 0x00000000, 0, 0xfffffff6, 0xfff7ffff, x2, 40, x3)

inst_16:
// rs1==x27, rs2==x12, rs2_w0_val == -262145, 
// opcode: mulsr64 ; op1:x27; op2:x12; dest:x22; op1val:0xfffffff9;  op2val:0xfffbffff
TEST_P64_PNN_OP(mulsr64, x22, x23, x27, x12, 0x00000000, 0, 0xfffffff9, 0xfffbffff, x2, 48, x3)

inst_17:
// rs1==x9, rs2==x26, rs2_w0_val == -131073, rs1_w0_val == -1073741825
// opcode: mulsr64 ; op1:x9; op2:x26; dest:x28; op1val:0xbfffffff;  op2val:0xfffdffff
TEST_P64_PNN_OP(mulsr64, x28, x29, x9, x26, 0x00000000, 0, 0xbfffffff, 0xfffdffff, x2, 56, x3)

inst_18:
// rs1==x25, rs2==x31, rs2_w0_val == -65537, 
// opcode: mulsr64 ; op1:x25; op2:x31; dest:x20; op1val:0x00040000;  op2val:0xfffeffff
TEST_P64_PNN_OP(mulsr64, x20, x21, x25, x31, 0x00000000, 0, 0x00040000, 0xfffeffff, x2, 64, x3)

inst_19:
// rs1==x31, rs2==x11, rs2_w0_val == -32769, rs1_w0_val == 8
// opcode: mulsr64 ; op1:x31; op2:x11; dest:x10; op1val:0x00000008;  op2val:0xffff7fff
TEST_P64_PNN_OP(mulsr64, x10, x11, x31, x11, 0x00000000, 0, 0x00000008, 0xffff7fff, x2, 72, x3)
RVTEST_SIGBASE(x8,signature_x8_0)

inst_20:
// rs1==x28, rs2==x18, rs2_w0_val == -16385, 
// opcode: mulsr64 ; op1:x28; op2:x18; dest:x22; op1val:0x3fffffff;  op2val:0xffffbfff
TEST_P64_PNN_OP(mulsr64, x22, x23, x28, x18, 0x00000000, 0, 0x3fffffff, 0xffffbfff, x8, 0, x7)

inst_21:
// rs1==x4, rs2==x0, rs2_w0_val == -8193, 
// opcode: mulsr64 ; op1:x4; op2:x0; dest:x16; op1val:0x02000000;  op2val:0xffffdfff
TEST_P64_PNN_OP(mulsr64, x16, x17, x4, x0, 0x00000000, 0, 0x02000000, 0xffffdfff, x8, 8, x7)

inst_22:
// rs1==x29, rs2==x24, rs2_w0_val == -4097, rs1_w0_val == -65
// opcode: mulsr64 ; op1:x29; op2:x24; dest:x2; op1val:0xffffffbf;  op2val:0xffffefff
TEST_P64_PNN_OP(mulsr64, x2, x3, x29, x24, 0x00000000, 0, 0xffffffbf, 0xffffefff, x8, 16, x7)

inst_23:
// rs1==x18, rs2==x10, rs2_w0_val == -2049, 
// opcode: mulsr64 ; op1:x18; op2:x10; dest:x14; op1val:0xc0000000;  op2val:0xfffff7ff
TEST_P64_PNN_OP(mulsr64, x14, x15, x18, x10, 0x00000000, 0, 0xc0000000, 0xfffff7ff, x8, 24, x7)

inst_24:
// rs1==x11, rs2==x19, rs2_w0_val == -1025, rs1_w0_val == 1
// opcode: mulsr64 ; op1:x11; op2:x19; dest:x30; op1val:0x00000001;  op2val:0xfffffbff
TEST_P64_PNN_OP(mulsr64, x30, x31, x11, x19, 0x00000000, 0, 0x00000001, 0xfffffbff, x8, 32, x7)

inst_25:
// rs1==x1, rs2==x23, rs2_w0_val == -513, rs1_w0_val == 128
// opcode: mulsr64 ; op1:x1; op2:x23; dest:x24; op1val:0x00000080;  op2val:0xfffffdff
TEST_P64_PNN_OP(mulsr64, x24, x25, x1, x23, 0x00000000, 0, 0x00000080, 0xfffffdff, x8, 40, x7)

inst_26:
// rs1==x24, rs2==x5, rs2_w0_val == -257, rs1_w0_val == 32
// opcode: mulsr64 ; op1:x24; op2:x5; dest:x4; op1val:0x00000020;  op2val:0xfffffeff
TEST_P64_PNN_OP(mulsr64, x4, x5, x24, x5, 0x00000000, 0, 0x00000020, 0xfffffeff, x8, 48, x7)

inst_27:
// rs1==x17, rs2==x14, rs2_w0_val == -129, 
// opcode: mulsr64 ; op1:x17; op2:x14; dest:x12; op1val:0x02000000;  op2val:0xffffff7f
TEST_P64_PNN_OP(mulsr64, x12, x13, x17, x14, 0x00000000, 0, 0x02000000, 0xffffff7f, x8, 56, x7)

inst_28:
// rs1==x10, rs2==x17, rs2_w0_val == -65, 
// opcode: mulsr64 ; op1:x10; op2:x17; dest:x12; op1val:0xc0000000;  op2val:0xffffffbf
TEST_P64_PNN_OP(mulsr64, x12, x13, x10, x17, 0x00000000, 0, 0xc0000000, 0xffffffbf, x8, 64, x7)

inst_29:
// rs1==x22, rs2==x6, rs2_w0_val == -33, 
// opcode: mulsr64 ; op1:x22; op2:x6; dest:x12; op1val:0x00000009;  op2val:0xffffffdf
TEST_P64_PNN_OP(mulsr64, x12, x13, x22, x6, 0x00000000, 0, 0x00000009, 0xffffffdf, x8, 72, x7)

inst_30:
// rs1==x30, rs2==x20, rs2_w0_val == -17, rs1_w0_val == -536870913
// opcode: mulsr64 ; op1:x30; op2:x20; dest:x6; op1val:0xdfffffff;  op2val:0xffffffef
TEST_P64_PNN_OP(mulsr64, x6, x7, x30, x20, 0x00000000, 0, 0xdfffffff, 0xffffffef, x8, 80, x7)
RVTEST_SIGBASE(x1,signature_x1_2)

inst_31:
// rs1==x2, rs2==x30, rs2_w0_val == -9, rs1_w0_val == 1431655765
// opcode: mulsr64 ; op1:x2; op2:x30; dest:x24; op1val:0x55555555;  op2val:0xfffffff7
TEST_P64_PNN_OP(mulsr64, x24, x25, x2, x30, 0x00000000, 0, 0x55555555, 0xfffffff7, x1, 0, x7)

inst_32:
// rs2_w0_val == -5, rs1_w0_val == -16777217
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0xfeffffff;  op2val:0xfffffffb
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0xfeffffff, 0xfffffffb, x1, 8, x7)

inst_33:
// rs2_w0_val == -3, 
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0xffffffbf;  op2val:0xfffffffd
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0xffffffbf, 0xfffffffd, x1, 16, x7)

inst_34:
// rs2_w0_val == -2, rs1_w0_val == 268435456
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0x10000000;  op2val:0xfffffffe
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0x10000000, 0xfffffffe, x1, 24, x7)

inst_35:
// rs2_w0_val == -2147483648, 
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0x00000040;  op2val:0x80000000
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0x00000040, 0x80000000, x1, 32, x7)

inst_36:
// rs2_w0_val == 1073741824, rs1_w0_val == 134217728
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0x08000000;  op2val:0x40000000
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0x08000000, 0x40000000, x1, 40, x7)

inst_37:
// rs2_w0_val == 536870912, 
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0xfffffffb;  op2val:0x20000000
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0xfffffffb, 0x20000000, x1, 48, x7)

inst_38:
// rs2_w0_val == 268435456, 
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0x00000020;  op2val:0x10000000
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0x00000020, 0x10000000, x1, 56, x7)

inst_39:
// rs2_w0_val == 134217728, rs1_w0_val == 8388608
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0x00800000;  op2val:0x08000000
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0x00800000, 0x08000000, x1, 64, x7)

inst_40:
// rs2_w0_val == 67108864, rs1_w0_val == 16
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0x00000010;  op2val:0x04000000
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0x00000010, 0x04000000, x1, 72, x7)

inst_41:
// rs2_w0_val == 33554432, rs1_w0_val == -524289
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0xfff7ffff;  op2val:0x02000000
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0xfff7ffff, 0x02000000, x1, 80, x7)

inst_42:
// rs2_w0_val == 16777216, 
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0x55555555;  op2val:0x01000000
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0x55555555, 0x01000000, x1, 88, x7)

inst_43:
// rs2_w0_val == 8388608, rs1_w0_val == -131073
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0xfffdffff;  op2val:0x00800000
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0xfffdffff, 0x00800000, x1, 96, x7)

inst_44:
// rs2_w0_val == 4194304, rs1_w0_val == -1048577
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0xffefffff;  op2val:0x00400000
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0xffefffff, 0x00400000, x1, 104, x7)

inst_45:
// rs1_w0_val == 4, 
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0x00000004;  op2val:0xffdfffff
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0x00000004, 0xffdfffff, x1, 112, x7)

inst_46:
// rs1_w0_val == 0, 
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0x00000000;  op2val:0x04000000
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0x00000000, 0x04000000, x1, 120, x7)

inst_47:
// rs1_w0_val == -1, 
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0xffffffff;  op2val:0xffff7fff
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0xffffffff, 0xffff7fff, x1, 128, x7)

inst_48:
// rs2_w0_val == 2097152, 
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0x01000000;  op2val:0x00200000
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0x01000000, 0x00200000, x1, 136, x7)

inst_49:
// rs2_w0_val == 1048576, rs1_w0_val == 4096
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0x00001000;  op2val:0x00100000
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0x00001000, 0x00100000, x1, 144, x7)

inst_50:
// rs2_w0_val == 524288, 
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0xfffffff8;  op2val:0x00080000
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0xfffffff8, 0x00080000, x1, 152, x7)

inst_51:
// rs2_w0_val == 262144, 
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0xffffefff;  op2val:0x00040000
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0xffffefff, 0x00040000, x1, 160, x7)

inst_52:
// rs2_w0_val == 131072, 
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0xfff7ffff;  op2val:0x00020000
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0xfff7ffff, 0x00020000, x1, 168, x7)

inst_53:
// rs2_w0_val == 65536, rs1_w0_val == -9
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0xfffffff7;  op2val:0x00010000
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0xfffffff7, 0x00010000, x1, 176, x7)

inst_54:
// rs2_w0_val == 32768, 
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0x80000000;  op2val:0x00008000
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0x80000000, 0x00008000, x1, 184, x7)

inst_55:
// rs2_w0_val == 8192, 
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0x00000004;  op2val:0x00002000
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0x00000004, 0x00002000, x1, 192, x7)

inst_56:
// rs2_w0_val == 4096, 
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0xaaaaaaaa;  op2val:0x00001000
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0xaaaaaaaa, 0x00001000, x1, 200, x7)

inst_57:
// rs2_w0_val == 2048, 
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0x3fffffff;  op2val:0x00000800
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0x3fffffff, 0x00000800, x1, 208, x7)

inst_58:
// rs2_w0_val == 1024, 
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0xfffffff8;  op2val:0x00000400
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0xfffffff8, 0x00000400, x1, 216, x7)

inst_59:
// rs2_w0_val == 512, 
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0x00000040;  op2val:0x00000200
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0x00000040, 0x00000200, x1, 224, x7)

inst_60:
// rs2_w0_val == 256, 
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0x01000000;  op2val:0x00000100
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0x01000000, 0x00000100, x1, 232, x7)

inst_61:
// rs2_w0_val == 128, 
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0xc0000000;  op2val:0x00000080
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0xc0000000, 0x00000080, x1, 240, x7)

inst_62:
// rs2_w0_val == 64, rs1_w0_val == 4194304
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0x00400000;  op2val:0x00000040
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0x00400000, 0x00000040, x1, 248, x7)

inst_63:
// rs2_w0_val == 32, 
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0x00000100;  op2val:0x00000020
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0x00000100, 0x00000020, x1, 256, x7)

inst_64:
// rs2_w0_val == 16, rs1_w0_val == 2147483647
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0x7fffffff;  op2val:0x00000010
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0x7fffffff, 0x00000010, x1, 264, x7)

inst_65:
// rs2_w0_val == 8, rs1_w0_val == -2049
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0xfffff7ff;  op2val:0x00000008
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0xfffff7ff, 0x00000008, x1, 272, x7)

inst_66:
// rs2_w0_val == 4, rs1_w0_val == -67108865
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0xfbffffff;  op2val:0x00000004
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0xfbffffff, 0x00000004, x1, 280, x7)

inst_67:
// rs2_w0_val == 2, 
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0xfdffffff;  op2val:0x00000002
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0xfdffffff, 0x00000002, x1, 288, x7)

inst_68:
// rs2_w0_val == 1, rs1_w0_val == -129
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0xffffff7f;  op2val:0x00000001
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0xffffff7f, 0x00000001, x1, 296, x7)

inst_69:
// rs2_w0_val == 0, 
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0xbfffffff;  op2val:0x00000000
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0xbfffffff, 0x00000000, x1, 304, x7)

inst_70:
// rs2_w0_val == -1, 
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0x02000000;  op2val:0xffffffff
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0x02000000, 0xffffffff, x1, 312, x7)

inst_71:
// rs1_w0_val == -268435457, 
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0xefffffff;  op2val:0x55555555
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0xefffffff, 0x55555555, x1, 320, x7)

inst_72:
// rs1_w0_val == -134217729, 
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0xf7ffffff;  op2val:0x00000001
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0xf7ffffff, 0x00000001, x1, 328, x7)

inst_73:
// rs1_w0_val == -8388609, 
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0xff7fffff;  op2val:0xfffffff9
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0xff7fffff, 0xfffffff9, x1, 336, x7)

inst_74:
// rs1_w0_val == -4194305, 
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0xffbfffff;  op2val:0xfdffffff
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0xffbfffff, 0xfdffffff, x1, 344, x7)

inst_75:
// rs1_w0_val == -2097153, 
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0xffdfffff;  op2val:0x00001000
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0xffdfffff, 0x00001000, x1, 352, x7)

inst_76:
// rs1_w0_val == -262145, 
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0xfffbffff;  op2val:0x00000007
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0xfffbffff, 0x00000007, x1, 360, x7)

inst_77:
// rs1_w0_val == -65537, 
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0xfffeffff;  op2val:0x3fffffff
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0xfffeffff, 0x3fffffff, x1, 368, x7)

inst_78:
// rs1_w0_val == -16385, 
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0xffffbfff;  op2val:0xfffffff8
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0xffffbfff, 0xfffffff8, x1, 376, x7)

inst_79:
// rs1_w0_val == -8193, 
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0xffffdfff;  op2val:0xfffff7ff
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0xffffdfff, 0xfffff7ff, x1, 384, x7)

inst_80:
// rs1_w0_val == -1025, 
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0xfffffbff;  op2val:0xfffffffe
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0xfffffbff, 0xfffffffe, x1, 392, x7)

inst_81:
// rs1_w0_val == -513, 
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0xfffffdff;  op2val:0xffffbfff
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0xfffffdff, 0xffffbfff, x1, 400, x7)

inst_82:
// rs1_w0_val == -257, 
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0xfffffeff;  op2val:0xfffffbff
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0xfffffeff, 0xfffffbff, x1, 408, x7)

inst_83:
// rs1_w0_val == -33, 
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0xffffffdf;  op2val:0xf7ffffff
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0xffffffdf, 0xf7ffffff, x1, 416, x7)

inst_84:
// rs1_w0_val == -17, 
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0xffffffef;  op2val:0xffffefff
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0xffffffef, 0xffffefff, x1, 424, x7)

inst_85:
// rs1_w0_val == -3, 
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0xfffffffd;  op2val:0xfffffffe
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0xfffffffd, 0xfffffffe, x1, 432, x7)

inst_86:
// rs1_w0_val == -2, 
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0xfffffffe;  op2val:0xdfffffff
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0xfffffffe, 0xdfffffff, x1, 440, x7)

inst_87:
// rs1_w0_val == 1073741824, 
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0x40000000;  op2val:0x00000400
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0x40000000, 0x00000400, x1, 448, x7)

inst_88:
// rs1_w0_val == 536870912, 
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0x20000000;  op2val:0xfffffffc
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0x20000000, 0xfffffffc, x1, 456, x7)

inst_89:
// rs1_w0_val == 67108864, 
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0x04000000;  op2val:0xffffefff
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0x04000000, 0xffffefff, x1, 464, x7)

inst_90:
// rs1_w0_val == 2097152, 
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0x00200000;  op2val:0xfbffffff
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0x00200000, 0xfbffffff, x1, 472, x7)

inst_91:
// rs1_w0_val == 1048576, 
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0x00100000;  op2val:0x00000000
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0x00100000, 0x00000000, x1, 480, x7)

inst_92:
// rs1_w0_val == 524288, 
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0x00080000;  op2val:0x00008000
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0x00080000, 0x00008000, x1, 488, x7)

inst_93:
// rs1_w0_val == 65536, 
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0x00010000;  op2val:0x3fffffff
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0x00010000, 0x3fffffff, x1, 496, x7)

inst_94:
// rs1_w0_val == 32768, 
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0x00008000;  op2val:0x00004000
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0x00008000, 0x00004000, x1, 504, x7)

inst_95:
// rs1_w0_val == 8192, 
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0x00002000;  op2val:0xffffbfff
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0x00002000, 0xffffbfff, x1, 512, x7)

inst_96:
// rs1_w0_val == 1024, 
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0x00000400;  op2val:0x00000006
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0x00000400, 0x00000006, x1, 520, x7)

inst_97:
// rs1_w0_val == 512, 
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0x00000200;  op2val:0x00040000
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0x00000200, 0x00040000, x1, 528, x7)

inst_98:
// rs1_w0_val == 16384, 
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0x00004000;  op2val:0x00400000
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0x00004000, 0x00400000, x1, 536, x7)

inst_99:
// rs2_w0_val == -1431655766, rs1_w0_val == -33554433
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0xfdffffff;  op2val:0xaaaaaaaa
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0xfdffffff, 0xaaaaaaaa, x1, 544, x7)

inst_100:
// rs2_w0_val == 2147483647, rs1_w0_val == -5
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0xfffffffb;  op2val:0x7fffffff
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0xfffffffb, 0x7fffffff, x1, 552, x7)

inst_101:
// rs2_w0_val == -8193, 
// opcode: mulsr64 ; op1:x31; op2:x29; dest:x30; op1val:0x02000000;  op2val:0xffffdfff
TEST_P64_PNN_OP(mulsr64, x30, x31, x31, x29, 0x00000000, 0, 0x02000000, 0xffffdfff, x1, 560, x7)
#endif


RVTEST_CODE_END
RVMODEL_HALT

RVTEST_DATA_BEGIN
.align 4
rvtest_data:
.word 0xbabecafe
.word 0xabecafeb
.word 0xbecafeba
.word 0xecafebab
RVTEST_DATA_END

RVMODEL_DATA_BEGIN


signature_x1_0:
    .fill 0*(XLEN/32),4,0xdeadbeef


signature_x1_1:
    .fill 20*(XLEN/32),4,0xdeadbeef


signature_x2_0:
    .fill 20*(XLEN/32),4,0xdeadbeef


signature_x8_0:
    .fill 22*(XLEN/32),4,0xdeadbeef


signature_x1_2:
    .fill 142*(XLEN/32),4,0xdeadbeef

#ifdef rvtest_mtrap_routine

mtrap_sigptr:
    .fill 64*(XLEN/32),4,0xdeadbeef

#endif

#ifdef rvtest_gpr_save

gpr_save:
    .fill 32*(XLEN/32),4,0xdeadbeef

#endif

RVMODEL_DATA_END
