
// -----------
// This file was generated by riscv_ctg (https://github.com/riscv-software-src/riscv-ctg)
// version   : 0.6.3
// timestamp : Sat Apr 23 14:53:29 2022 GMT
// usage     : riscv_ctg \
//                  --cgf /scratch/git-repo/github/riscv_ctg/sample_cgfs/dataset.cgf \
//                  --cgf /scratch/git-repo/github/riscv_ctg/sample_cgfs/rv32ip.cgf \
//                  --xlen 32  \
//                  --randomize \
// -----------
//
// -----------
// Copyright (c) 2020. RISC-V International. All rights reserved.
// SPDX-License-Identifier: BSD-3-Clause
// -----------
//
// This assembly file tests the slli16 instruction of the RISC-V RV32PZicsr extension for the slli16 covergroup.
// 
#include "model_test.h"
#include "arch_test.h"
RVTEST_ISA("RV32IPZicsr")

.section .text.init
.org 0x80
.globl rvtest_entry_point
rvtest_entry_point:
RVMODEL_BOOT
RVTEST_CODE_BEGIN

#ifdef TEST_CASE_1

RVTEST_CASE(0,"//check ISA:=regex(.*32.*);check ISA:=regex(.*I.*P.*Zicsr.*);def TEST_CASE_1=True;",slli16)

RVTEST_VXSAT_ENABLE()
RVTEST_SIGBASE(x2,signature_x2_1)

inst_0:
// rs1 != rd, rs1==x4, rd==x22, rs1_h0_val == 0, imm_val == 2, rs1_h1_val == 2048
// opcode: slli16 ; op1:x4; dest:x22; op1val:0x8000000;  immval:0x2
TEST_IMM_OP( slli16, x22, x4, 0x00000000, 0x8000000, 0x2, x2, 0, x15)

inst_1:
// rs1 == rd, rs1==x31, rd==x31, imm_val == 15, rs1_h1_val == 65471, rs1_h0_val == 4
// opcode: slli16 ; op1:x31; dest:x31; op1val:0xffbf0004;  immval:0xf
TEST_IMM_OP( slli16, x31, x31, 0x00000000, 0xffbf0004, 0xf, x2, 4, x15)

inst_2:
// rs1==x24, rd==x1, imm_val == 14, rs1_h0_val == 2
// opcode: slli16 ; op1:x24; dest:x1; op1val:0x120002;  immval:0xe
TEST_IMM_OP( slli16, x1, x24, 0x00000000, 0x120002, 0xe, x2, 8, x15)

inst_3:
// rs1==x16, rd==x11, imm_val == 13, rs1_h1_val == 21845, rs1_h0_val == 65531
// opcode: slli16 ; op1:x16; dest:x11; op1val:0x5555fffb;  immval:0xd
TEST_IMM_OP( slli16, x11, x16, 0x00000000, 0x5555fffb, 0xd, x2, 12, x15)

inst_4:
// rs1==x29, rd==x8, imm_val == 12, rs1_h1_val == 0, rs1_h0_val == 32767
// opcode: slli16 ; op1:x29; dest:x8; op1val:0x007fff;  immval:0xc
TEST_IMM_OP( slli16, x8, x29, 0x00000000, 0x007fff, 0xc, x2, 16, x15)

inst_5:
// rs1==x12, rd==x3, imm_val == 11, rs1_h1_val == 65503, rs1_h0_val == 21845
// opcode: slli16 ; op1:x12; dest:x3; op1val:0xffdf5555;  immval:0xb
TEST_IMM_OP( slli16, x3, x12, 0x00000000, 0xffdf5555, 0xb, x2, 20, x15)

inst_6:
// rs1==x18, rd==x9, imm_val == 10, rs1_h0_val == 61439, rs1_h1_val == 8192
// opcode: slli16 ; op1:x18; dest:x9; op1val:0x2000efff;  immval:0xa
TEST_IMM_OP( slli16, x9, x18, 0x00000000, 0x2000efff, 0xa, x2, 24, x15)

inst_7:
// rs1==x22, rd==x25, imm_val == 9, rs1_h0_val == 4096
// opcode: slli16 ; op1:x22; dest:x25; op1val:0x001000;  immval:0x9
TEST_IMM_OP( slli16, x25, x22, 0x00000000, 0x001000, 0x9, x2, 28, x15)

inst_8:
// rs1==x3, rd==x12, imm_val == 8, rs1_h0_val == 64, rs1_h1_val == 512
// opcode: slli16 ; op1:x3; dest:x12; op1val:0x2000040;  immval:0x8
TEST_IMM_OP( slli16, x12, x3, 0x00000000, 0x2000040, 0x8, x2, 32, x15)

inst_9:
// rs1==x5, rd==x6, imm_val == 7, rs1_h1_val == 4, rs1_h0_val == 49151
// opcode: slli16 ; op1:x5; dest:x6; op1val:0x04bfff;  immval:0x7
TEST_IMM_OP( slli16, x6, x5, 0x00000000, 0x04bfff, 0x7, x2, 36, x15)

inst_10:
// rs1==x28, rd==x20, imm_val == 6, 
// opcode: slli16 ; op1:x28; dest:x20; op1val:0x55550003;  immval:0x6
TEST_IMM_OP( slli16, x20, x28, 0x00000000, 0x55550003, 0x6, x2, 40, x15)

inst_11:
// rs1==x11, rd==x13, imm_val == 5, 
// opcode: slli16 ; op1:x11; dest:x13; op1val:0x0d0040;  immval:0x5
TEST_IMM_OP( slli16, x13, x11, 0x00000000, 0x0d0040, 0x5, x2, 44, x15)

inst_12:
// rs1==x23, rd==x28, imm_val == 4, rs1_h1_val == 16
// opcode: slli16 ; op1:x23; dest:x28; op1val:0x100006;  immval:0x4
TEST_IMM_OP( slli16, x28, x23, 0x00000000, 0x100006, 0x4, x2, 48, x15)

inst_13:
// rs1==x10, rd==x14, imm_val == 3, rs1_h0_val == 32768
// opcode: slli16 ; op1:x10; dest:x14; op1val:0x138000;  immval:0x3
TEST_IMM_OP( slli16, x14, x10, 0x00000000, 0x138000, 0x3, x2, 52, x15)

inst_14:
// rs1==x8, rd==x27, imm_val == 1, rs1_h1_val == 65534
// opcode: slli16 ; op1:x8; dest:x27; op1val:0xfffe0005;  immval:0x1
TEST_IMM_OP( slli16, x27, x8, 0x00000000, 0xfffe0005, 0x1, x2, 56, x15)

inst_15:
// rs1==x7, rd==x16, imm_val == 0, rs1_h0_val == 32
// opcode: slli16 ; op1:x7; dest:x16; op1val:0x090020;  immval:0x0
TEST_IMM_OP( slli16, x16, x7, 0x00000000, 0x090020, 0x0, x2, 60, x15)

inst_16:
// rs1==x30, rd==x5, rs1_h1_val == 43690, 
// opcode: slli16 ; op1:x30; dest:x5; op1val:0xaaaa000e;  immval:0xe
TEST_IMM_OP( slli16, x5, x30, 0x00000000, 0xaaaa000e, 0xe, x2, 64, x15)

inst_17:
// rs1==x19, rd==x26, rs1_h1_val == 32767, 
// opcode: slli16 ; op1:x19; dest:x26; op1val:0x7fff0004;  immval:0x0
TEST_IMM_OP( slli16, x26, x19, 0x00000000, 0x7fff0004, 0x0, x2, 68, x15)

inst_18:
// rs1==x13, rd==x10, rs1_h1_val == 49151, 
// opcode: slli16 ; op1:x13; dest:x10; op1val:0xbfff8000;  immval:0xd
TEST_IMM_OP( slli16, x10, x13, 0x00000000, 0xbfff8000, 0xd, x2, 72, x5)

inst_19:
// rs1==x15, rd==x17, rs1_h1_val == 57343, 
// opcode: slli16 ; op1:x15; dest:x17; op1val:0xdfff5555;  immval:0xd
TEST_IMM_OP( slli16, x17, x15, 0x00000000, 0xdfff5555, 0xd, x2, 76, x5)
RVTEST_SIGBASE(x3,signature_x3_0)

inst_20:
// rs1==x17, rd==x7, rs1_h1_val == 61439, 
// opcode: slli16 ; op1:x17; dest:x7; op1val:0xefff000c;  immval:0xd
TEST_IMM_OP( slli16, x7, x17, 0x00000000, 0xefff000c, 0xd, x3, 0, x5)

inst_21:
// rs1==x0, rd==x15, rs1_h1_val == 63487, 
// opcode: slli16 ; op1:x0; dest:x15; op1val:0xf7ff0005;  immval:0x1
TEST_IMM_OP( slli16, x15, x0, 0x00000000, 0xf7ff0005, 0x1, x3, 4, x5)

inst_22:
// rs1==x6, rd==x23, rs1_h1_val == 64511, rs1_h0_val == 1
// opcode: slli16 ; op1:x6; dest:x23; op1val:0xfbff0001;  immval:0xb
TEST_IMM_OP( slli16, x23, x6, 0x00000000, 0xfbff0001, 0xb, x3, 8, x5)

inst_23:
// rs1==x14, rd==x0, rs1_h1_val == 65023, rs1_h0_val == 65023
// opcode: slli16 ; op1:x14; dest:x0; op1val:0xfdfffdff;  immval:0xc
TEST_IMM_OP( slli16, x0, x14, 0x00000000, 0xfdfffdff, 0xc, x3, 12, x5)

inst_24:
// rs1==x26, rd==x4, rs1_h1_val == 65279, 
// opcode: slli16 ; op1:x26; dest:x4; op1val:0xfeff1000;  immval:0xc
TEST_IMM_OP( slli16, x4, x26, 0x00000000, 0xfeff1000, 0xc, x3, 16, x5)

inst_25:
// rs1==x21, rd==x2, rs1_h1_val == 65407, 
// opcode: slli16 ; op1:x21; dest:x2; op1val:0xff7f1000;  immval:0x8
TEST_IMM_OP( slli16, x2, x21, 0x00000000, 0xff7f1000, 0x8, x3, 20, x5)

inst_26:
// rs1==x2, rd==x30, rs1_h1_val == 65519, 
// opcode: slli16 ; op1:x2; dest:x30; op1val:0xffeffffb;  immval:0x1
TEST_IMM_OP( slli16, x30, x2, 0x00000000, 0xffeffffb, 0x1, x3, 24, x5)

inst_27:
// rs1==x9, rd==x29, rs1_h1_val == 65527, rs1_h0_val == 2048
// opcode: slli16 ; op1:x9; dest:x29; op1val:0xfff70800;  immval:0x9
TEST_IMM_OP( slli16, x29, x9, 0x00000000, 0xfff70800, 0x9, x3, 28, x5)

inst_28:
// rs1==x1, rd==x19, rs1_h1_val == 65531, 
// opcode: slli16 ; op1:x1; dest:x19; op1val:0xfffb0004;  immval:0xd
TEST_IMM_OP( slli16, x19, x1, 0x00000000, 0xfffb0004, 0xd, x3, 32, x5)

inst_29:
// rs1==x27, rd==x24, rs1_h1_val == 65533, 
// opcode: slli16 ; op1:x27; dest:x24; op1val:0xfffd0001;  immval:0xf
TEST_IMM_OP( slli16, x24, x27, 0x00000000, 0xfffd0001, 0xf, x3, 36, x5)

inst_30:
// rs1==x20, rd==x18, rs1_h1_val == 32768, 
// opcode: slli16 ; op1:x20; dest:x18; op1val:0x80000007;  immval:0xa
TEST_IMM_OP( slli16, x18, x20, 0x00000000, 0x80000007, 0xa, x3, 40, x5)

inst_31:
// rs1==x25, rd==x21, rs1_h1_val == 16384, 
// opcode: slli16 ; op1:x25; dest:x21; op1val:0x40000800;  immval:0xa
TEST_IMM_OP( slli16, x21, x25, 0x00000000, 0x40000800, 0xa, x3, 44, x5)

inst_32:
// rs1_h0_val == 65471, rs1_h1_val == 4096
// opcode: slli16 ; op1:x30; dest:x31; op1val:0x1000ffbf;  immval:0x4
TEST_IMM_OP( slli16, x31, x30, 0x00000000, 0x1000ffbf, 0x4, x3, 48, x5)

inst_33:
// rs1_h0_val == 65503, 
// opcode: slli16 ; op1:x30; dest:x31; op1val:0xffbfffdf;  immval:0xd
TEST_IMM_OP( slli16, x31, x30, 0x00000000, 0xffbfffdf, 0xd, x3, 52, x5)

inst_34:
// rs1_h0_val == 65519, 
// opcode: slli16 ; op1:x30; dest:x31; op1val:0x0affef;  immval:0x4
TEST_IMM_OP( slli16, x31, x30, 0x00000000, 0x0affef, 0x4, x3, 56, x5)

inst_35:
// rs1_h0_val == 65527, rs1_h1_val == 256
// opcode: slli16 ; op1:x30; dest:x31; op1val:0x100fff7;  immval:0x8
TEST_IMM_OP( slli16, x31, x30, 0x00000000, 0x100fff7, 0x8, x3, 60, x5)

inst_36:
// rs1_h0_val == 65533, 
// opcode: slli16 ; op1:x30; dest:x31; op1val:0xeffffffd;  immval:0x1
TEST_IMM_OP( slli16, x31, x30, 0x00000000, 0xeffffffd, 0x1, x3, 64, x5)

inst_37:
// rs1_h0_val == 65534, rs1_h1_val == 32
// opcode: slli16 ; op1:x30; dest:x31; op1val:0x20fffe;  immval:0x5
TEST_IMM_OP( slli16, x31, x30, 0x00000000, 0x20fffe, 0x5, x3, 68, x5)

inst_38:
// rs1_h0_val == 16384, 
// opcode: slli16 ; op1:x30; dest:x31; op1val:0xffbf4000;  immval:0xb
TEST_IMM_OP( slli16, x31, x30, 0x00000000, 0xffbf4000, 0xb, x3, 72, x5)

inst_39:
// rs1_h0_val == 8192, 
// opcode: slli16 ; op1:x30; dest:x31; op1val:0x102000;  immval:0x6
TEST_IMM_OP( slli16, x31, x30, 0x00000000, 0x102000, 0x6, x3, 76, x5)

inst_40:
// rs1_h0_val == 1024, 
// opcode: slli16 ; op1:x30; dest:x31; op1val:0x40000400;  immval:0x8
TEST_IMM_OP( slli16, x31, x30, 0x00000000, 0x40000400, 0x8, x3, 80, x5)

inst_41:
// rs1_h0_val == 512, 
// opcode: slli16 ; op1:x30; dest:x31; op1val:0x40000200;  immval:0x8
TEST_IMM_OP( slli16, x31, x30, 0x00000000, 0x40000200, 0x8, x3, 84, x5)

inst_42:
// rs1_h0_val == 256, 
// opcode: slli16 ; op1:x30; dest:x31; op1val:0x100100;  immval:0x6
TEST_IMM_OP( slli16, x31, x30, 0x00000000, 0x100100, 0x6, x3, 88, x5)

inst_43:
// rs1_h0_val == 128, 
// opcode: slli16 ; op1:x30; dest:x31; op1val:0x070080;  immval:0xe
TEST_IMM_OP( slli16, x31, x30, 0x00000000, 0x070080, 0xe, x3, 92, x5)

inst_44:
// rs1_h0_val == 16, rs1_h1_val == 2
// opcode: slli16 ; op1:x30; dest:x31; op1val:0x020010;  immval:0xe
TEST_IMM_OP( slli16, x31, x30, 0x00000000, 0x020010, 0xe, x3, 96, x5)

inst_45:
// rs1_h1_val == 1024, rs1_h0_val == 64511
// opcode: slli16 ; op1:x30; dest:x31; op1val:0x400fbff;  immval:0x2
TEST_IMM_OP( slli16, x31, x30, 0x00000000, 0x400fbff, 0x2, x3, 100, x5)

inst_46:
// rs1_h1_val == 128, 
// opcode: slli16 ; op1:x30; dest:x31; op1val:0x800002;  immval:0x7
TEST_IMM_OP( slli16, x31, x30, 0x00000000, 0x800002, 0x7, x3, 104, x5)

inst_47:
// rs1_h1_val == 64, rs1_h0_val == 8
// opcode: slli16 ; op1:x30; dest:x31; op1val:0x400008;  immval:0x1
TEST_IMM_OP( slli16, x31, x30, 0x00000000, 0x400008, 0x1, x3, 108, x5)

inst_48:
// rs1_h1_val == 8, 
// opcode: slli16 ; op1:x30; dest:x31; op1val:0x084000;  immval:0xa
TEST_IMM_OP( slli16, x31, x30, 0x00000000, 0x084000, 0xa, x3, 112, x5)

inst_49:
// rs1_h1_val == 1, 
// opcode: slli16 ; op1:x30; dest:x31; op1val:0x010001;  immval:0x6
TEST_IMM_OP( slli16, x31, x30, 0x00000000, 0x010001, 0x6, x3, 116, x5)

inst_50:
// rs1_h1_val == 65535, 
// opcode: slli16 ; op1:x30; dest:x31; op1val:0xffff0100;  immval:0x7
TEST_IMM_OP( slli16, x31, x30, 0x00000000, 0xffff0100, 0x7, x3, 120, x5)

inst_51:
// rs1_h0_val == 43690, 
// opcode: slli16 ; op1:x30; dest:x31; op1val:0x02aaaa;  immval:0x2
TEST_IMM_OP( slli16, x31, x30, 0x00000000, 0x02aaaa, 0x2, x3, 124, x5)

inst_52:
// rs1_h0_val == 65535, 
// opcode: slli16 ; op1:x30; dest:x31; op1val:0x11ffff;  immval:0xf
TEST_IMM_OP( slli16, x31, x30, 0x00000000, 0x11ffff, 0xf, x3, 128, x5)

inst_53:
// rs1_h0_val == 57343, 
// opcode: slli16 ; op1:x30; dest:x31; op1val:0x4000dfff;  immval:0x9
TEST_IMM_OP( slli16, x31, x30, 0x00000000, 0x4000dfff, 0x9, x3, 132, x5)

inst_54:
// rs1_h0_val == 63487, 
// opcode: slli16 ; op1:x30; dest:x31; op1val:0x0bf7ff;  immval:0xb
TEST_IMM_OP( slli16, x31, x30, 0x00000000, 0x0bf7ff, 0xb, x3, 136, x5)

inst_55:
// rs1_h0_val == 65279, 
// opcode: slli16 ; op1:x30; dest:x31; op1val:0xfffefeff;  immval:0x7
TEST_IMM_OP( slli16, x31, x30, 0x00000000, 0xfffefeff, 0x7, x3, 140, x5)

inst_56:
// rs1_h0_val == 65407, 
// opcode: slli16 ; op1:x30; dest:x31; op1val:0xfff7ff7f;  immval:0xb
TEST_IMM_OP( slli16, x31, x30, 0x00000000, 0xfff7ff7f, 0xb, x3, 144, x5)

inst_57:
// rs1_h1_val == 63487, 
// opcode: slli16 ; op1:x30; dest:x31; op1val:0xf7ff0005;  immval:0x1
TEST_IMM_OP( slli16, x31, x30, 0x00000000, 0xf7ff0005, 0x1, x3, 148, x5)

inst_58:
// rs1_h1_val == 65023, rs1_h0_val == 65023
// opcode: slli16 ; op1:x30; dest:x31; op1val:0xfdfffdff;  immval:0xc
TEST_IMM_OP( slli16, x31, x30, 0x00000000, 0xfdfffdff, 0xc, x3, 152, x5)
#endif


RVTEST_CODE_END
RVMODEL_HALT

RVTEST_DATA_BEGIN
.align 4
rvtest_data:
.word 0xbabecafe
.word 0xabecafeb
.word 0xbecafeba
.word 0xecafebab
RVTEST_DATA_END

RVMODEL_DATA_BEGIN


signature_x2_0:
    .fill 0*(XLEN/32),4,0xdeadbeef


signature_x2_1:
    .fill 20*(XLEN/32),4,0xdeadbeef


signature_x3_0:
    .fill 39*(XLEN/32),4,0xdeadbeef

#ifdef rvtest_mtrap_routine

mtrap_sigptr:
    .fill 64*(XLEN/32),4,0xdeadbeef

#endif

#ifdef rvtest_gpr_save

gpr_save:
    .fill 32*(XLEN/32),4,0xdeadbeef

#endif

RVMODEL_DATA_END
