
// -----------
// This file was generated by riscv_ctg (https://github.com/riscv-software-src/riscv-ctg)
// version   : 0.6.3
// timestamp : Sat Apr 23 14:53:29 2022 GMT
// usage     : riscv_ctg \
//                  --cgf /scratch/git-repo/github/riscv_ctg/sample_cgfs/dataset.cgf \
//                  --cgf /scratch/git-repo/github/riscv_ctg/sample_cgfs/rv32ip.cgf \
//                  --xlen 32  \
//                  --randomize \
// -----------
//
// -----------
// Copyright (c) 2020. RISC-V International. All rights reserved.
// SPDX-License-Identifier: BSD-3-Clause
// -----------
//
// This assembly file tests the smmul instruction of the RISC-V RV32PZicsr extension for the smmul covergroup.
// 
#include "model_test.h"
#include "arch_test.h"
RVTEST_ISA("RV32IPZicsr")

.section .text.init
.org 0x80
.globl rvtest_entry_point
rvtest_entry_point:
RVMODEL_BOOT
RVTEST_CODE_BEGIN

#ifdef TEST_CASE_1

RVTEST_CASE(0,"//check ISA:=regex(.*32.*);check ISA:=regex(.*I.*P.*Zicsr.*);def TEST_CASE_1=True;",smmul)

RVTEST_VXSAT_ENABLE()
RVTEST_SIGBASE(x6,signature_x6_1)

inst_0:
// rs1 != rs2  and rs1 != rd and rs2 != rd, rs1==x19, rs2==x15, rd==x27, rs1_w0_val == -2147483648, rs2_w0_val == 256
// opcode: smmul ; op1:x19; dest:x27; op1val:0x80000000;  immval:$imm_val
TEST_RR_OP(smmul, x27, x19, x15, 0x00000000, 0x80000000, 0x000100, x6, 0, x16)

inst_1:
// rs1 == rs2 != rd, rs1==x24, rs2==x24, rd==x7, rs2_w0_val == -1431655766, rs1_w0_val == 256
// opcode: smmul ; op1:x24; dest:x7; op1val:0x000100;  immval:$imm_val
TEST_RR_OP(smmul, x7, x24, x24, 0x00000000, 0x000100, 0xaaaaaaaa, x6, 4, x16)

inst_2:
// rs1 == rd != rs2, rs1==x5, rs2==x31, rd==x5, rs2_w0_val == 1431655765, 
// opcode: smmul ; op1:x5; dest:x5; op1val:0x000003;  immval:$imm_val
TEST_RR_OP(smmul, x5, x5, x31, 0x00000000, 0x000003, 0x55555555, x6, 8, x16)

inst_3:
// rs1 == rs2 == rd, rs1==x30, rs2==x30, rd==x30, rs2_w0_val == 2147483647, 
// opcode: smmul ; op1:x30; dest:x30; op1val:0x000009;  immval:$imm_val
TEST_RR_OP(smmul, x30, x30, x30, 0x00000000, 0x000009, 0x7fffffff, x6, 12, x16)

inst_4:
// rs2 == rd != rs1, rs1==x29, rs2==x22, rd==x22, rs2_w0_val == -1073741825, rs1_w0_val == 2147483647
// opcode: smmul ; op1:x29; dest:x22; op1val:0x7fffffff;  immval:$imm_val
TEST_RR_OP(smmul, x22, x29, x22, 0x00000000, 0x7fffffff, 0xbfffffff, x6, 16, x16)

inst_5:
// rs1==x22, rs2==x1, rd==x18, rs2_w0_val == -536870913, 
// opcode: smmul ; op1:x22; dest:x18; op1val:0xfffffff9;  immval:$imm_val
TEST_RR_OP(smmul, x18, x22, x1, 0x00000000, 0xfffffff9, 0xdfffffff, x6, 20, x16)

inst_6:
// rs1==x4, rs2==x9, rd==x12, rs2_w0_val == -268435457, 
// opcode: smmul ; op1:x4; dest:x12; op1val:0xfffffffc;  immval:$imm_val
TEST_RR_OP(smmul, x12, x4, x9, 0x00000000, 0xfffffffc, 0xefffffff, x6, 24, x16)

inst_7:
// rs1==x26, rs2==x12, rd==x13, rs2_w0_val == -134217729, rs1_w0_val == 33554432
// opcode: smmul ; op1:x26; dest:x13; op1val:0x2000000;  immval:$imm_val
TEST_RR_OP(smmul, x13, x26, x12, 0x00000000, 0x2000000, 0xf7ffffff, x6, 28, x16)

inst_8:
// rs1==x28, rs2==x0, rd==x1, rs2_w0_val == -67108865, rs1_w0_val == -32769
// opcode: smmul ; op1:x28; dest:x1; op1val:0xffff7fff;  immval:$imm_val
TEST_RR_OP(smmul, x1, x28, x0, 0x00000000, 0xffff7fff, 0xfbffffff, x6, 32, x16)

inst_9:
// rs1==x17, rs2==x27, rd==x21, rs2_w0_val == -33554433, rs1_w0_val == -131073
// opcode: smmul ; op1:x17; dest:x21; op1val:0xfffdffff;  immval:$imm_val
TEST_RR_OP(smmul, x21, x17, x27, 0x00000000, 0xfffdffff, 0xfdffffff, x6, 36, x16)

inst_10:
// rs1==x21, rs2==x10, rd==x26, rs2_w0_val == -16777217, rs1_w0_val == 1073741824
// opcode: smmul ; op1:x21; dest:x26; op1val:0x40000000;  immval:$imm_val
TEST_RR_OP(smmul, x26, x21, x10, 0x00000000, 0x40000000, 0xfeffffff, x6, 40, x16)

inst_11:
// rs1==x3, rs2==x18, rd==x29, rs2_w0_val == -8388609, 
// opcode: smmul ; op1:x3; dest:x29; op1val:0x000009;  immval:$imm_val
TEST_RR_OP(smmul, x29, x3, x18, 0x00000000, 0x000009, 0xff7fffff, x6, 44, x16)

inst_12:
// rs1==x14, rs2==x7, rd==x8, rs2_w0_val == -4194305, 
// opcode: smmul ; op1:x14; dest:x8; op1val:0x7fffffff;  immval:$imm_val
TEST_RR_OP(smmul, x8, x14, x7, 0x00000000, 0x7fffffff, 0xffbfffff, x6, 48, x16)

inst_13:
// rs1==x12, rs2==x28, rd==x10, rs2_w0_val == -2097153, 
// opcode: smmul ; op1:x12; dest:x10; op1val:0xfffdffff;  immval:$imm_val
TEST_RR_OP(smmul, x10, x12, x28, 0x00000000, 0xfffdffff, 0xffdfffff, x6, 52, x16)

inst_14:
// rs1==x9, rs2==x17, rd==x2, rs2_w0_val == -1048577, rs1_w0_val == -17
// opcode: smmul ; op1:x9; dest:x2; op1val:0xffffffef;  immval:$imm_val
TEST_RR_OP(smmul, x2, x9, x17, 0x00000000, 0xffffffef, 0xffefffff, x6, 56, x16)

inst_15:
// rs1==x1, rs2==x4, rd==x31, rs2_w0_val == -524289, rs1_w0_val == 16777216
// opcode: smmul ; op1:x1; dest:x31; op1val:0x1000000;  immval:$imm_val
TEST_RR_OP(smmul, x31, x1, x4, 0x00000000, 0x1000000, 0xfff7ffff, x6, 60, x16)

inst_16:
// rs1==x10, rs2==x13, rd==x11, rs2_w0_val == -262145, 
// opcode: smmul ; op1:x10; dest:x11; op1val:0xc0000000;  immval:$imm_val
TEST_RR_OP(smmul, x11, x10, x13, 0x00000000, 0xc0000000, 0xfffbffff, x6, 64, x16)

inst_17:
// rs1==x23, rs2==x29, rd==x14, rs2_w0_val == -131073, 
// opcode: smmul ; op1:x23; dest:x14; op1val:0xfffffffc;  immval:$imm_val
TEST_RR_OP(smmul, x14, x23, x29, 0x00000000, 0xfffffffc, 0xfffdffff, x6, 68, x10)
RVTEST_SIGBASE(x1,signature_x1_0)

inst_18:
// rs1==x16, rs2==x19, rd==x15, rs2_w0_val == -65537, 
// opcode: smmul ; op1:x16; dest:x15; op1val:0x1000000;  immval:$imm_val
TEST_RR_OP(smmul, x15, x16, x19, 0x00000000, 0x1000000, 0xfffeffff, x1, 0, x10)

inst_19:
// rs1==x25, rs2==x21, rd==x23, rs2_w0_val == -32769, rs1_w0_val == -1073741825
// opcode: smmul ; op1:x25; dest:x23; op1val:0xbfffffff;  immval:$imm_val
TEST_RR_OP(smmul, x23, x25, x21, 0x00000000, 0xbfffffff, 0xffff7fff, x1, 4, x10)

inst_20:
// rs1==x15, rs2==x8, rd==x25, rs2_w0_val == -16385, rs1_w0_val == -536870913
// opcode: smmul ; op1:x15; dest:x25; op1val:0xdfffffff;  immval:$imm_val
TEST_RR_OP(smmul, x25, x15, x8, 0x00000000, 0xdfffffff, 0xffffbfff, x1, 8, x10)

inst_21:
// rs1==x20, rs2==x25, rd==x6, rs2_w0_val == -8193, 
// opcode: smmul ; op1:x20; dest:x6; op1val:0xdfffffff;  immval:$imm_val
TEST_RR_OP(smmul, x6, x20, x25, 0x00000000, 0xdfffffff, 0xffffdfff, x1, 12, x10)

inst_22:
// rs1==x31, rs2==x23, rd==x19, rs2_w0_val == -4097, rs1_w0_val == -257
// opcode: smmul ; op1:x31; dest:x19; op1val:0xfffffeff;  immval:$imm_val
TEST_RR_OP(smmul, x19, x31, x23, 0x00000000, 0xfffffeff, 0xffffefff, x1, 16, x10)

inst_23:
// rs1==x11, rs2==x20, rd==x9, rs2_w0_val == -2049, 
// opcode: smmul ; op1:x11; dest:x9; op1val:0xffff7fff;  immval:$imm_val
TEST_RR_OP(smmul, x9, x11, x20, 0x00000000, 0xffff7fff, 0xfffff7ff, x1, 20, x10)

inst_24:
// rs1==x2, rs2==x14, rd==x20, rs2_w0_val == -1025, rs1_w0_val == -2049
// opcode: smmul ; op1:x2; dest:x20; op1val:0xfffff7ff;  immval:$imm_val
TEST_RR_OP(smmul, x20, x2, x14, 0x00000000, 0xfffff7ff, 0xfffffbff, x1, 24, x10)

inst_25:
// rs1==x18, rs2==x6, rd==x3, rs2_w0_val == -513, 
// opcode: smmul ; op1:x18; dest:x3; op1val:0x000005;  immval:$imm_val
TEST_RR_OP(smmul, x3, x18, x6, 0x00000000, 0x000005, 0xfffffdff, x1, 28, x10)

inst_26:
// rs1==x13, rs2==x11, rd==x4, rs2_w0_val == -257, rs1_w0_val == 524288
// opcode: smmul ; op1:x13; dest:x4; op1val:0x080000;  immval:$imm_val
TEST_RR_OP(smmul, x4, x13, x11, 0x00000000, 0x080000, 0xfffffeff, x1, 32, x10)

inst_27:
// rs1==x8, rs2==x26, rd==x28, rs2_w0_val == -129, rs1_w0_val == -134217729
// opcode: smmul ; op1:x8; dest:x28; op1val:0xf7ffffff;  immval:$imm_val
TEST_RR_OP(smmul, x28, x8, x26, 0x00000000, 0xf7ffffff, 0xffffff7f, x1, 36, x10)

inst_28:
// rs1==x7, rs2==x2, rd==x0, rs2_w0_val == -65, rs1_w0_val == -67108865
// opcode: smmul ; op1:x7; dest:x0; op1val:0xfbffffff;  immval:$imm_val
TEST_RR_OP(smmul, x0, x7, x2, 0x00000000, 0xfbffffff, 0xffffffbf, x1, 40, x10)

inst_29:
// rs1==x6, rs2==x5, rd==x24, rs2_w0_val == -33, rs1_w0_val == 16
// opcode: smmul ; op1:x6; dest:x24; op1val:0x000010;  immval:$imm_val
TEST_RR_OP(smmul, x24, x6, x5, 0x00000000, 0x000010, 0xffffffdf, x1, 44, x10)

inst_30:
// rs1==x0, rs2==x3, rd==x16, rs2_w0_val == -17, rs1_w0_val == 4096
// opcode: smmul ; op1:x0; dest:x16; op1val:0x001000;  immval:$imm_val
TEST_RR_OP(smmul, x16, x0, x3, 0x00000000, 0x001000, 0xffffffef, x1, 48, x10)

inst_31:
// rs1==x27, rs2==x16, rd==x17, rs2_w0_val == -9, 
// opcode: smmul ; op1:x27; dest:x17; op1val:0xfffdffff;  immval:$imm_val
TEST_RR_OP(smmul, x17, x27, x16, 0x00000000, 0xfffdffff, 0xfffffff7, x1, 52, x10)

inst_32:
// rs2_w0_val == -5, rs1_w0_val == -129
// opcode: smmul ; op1:x30; dest:x31; op1val:0xffffff7f;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0xffffff7f, 0xfffffffb, x1, 56, x2)
RVTEST_SIGBASE(x1,signature_x1_1)

inst_33:
// rs2_w0_val == -3, 
// opcode: smmul ; op1:x30; dest:x31; op1val:0xfffffff9;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0xfffffff9, 0xfffffffd, x1, 0, x2)

inst_34:
// rs2_w0_val == -2, 
// opcode: smmul ; op1:x30; dest:x31; op1val:0xf7ffffff;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0xf7ffffff, 0xfffffffe, x1, 4, x2)

inst_35:
// rs2_w0_val == -2147483648, rs1_w0_val == 128
// opcode: smmul ; op1:x30; dest:x31; op1val:0x000080;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0x000080, 0x80000000, x1, 8, x2)

inst_36:
// rs2_w0_val == 1073741824, rs1_w0_val == 32
// opcode: smmul ; op1:x30; dest:x31; op1val:0x000020;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0x000020, 0x40000000, x1, 12, x2)

inst_37:
// rs2_w0_val == 536870912, rs1_w0_val == -268435457
// opcode: smmul ; op1:x30; dest:x31; op1val:0xefffffff;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0xefffffff, 0x20000000, x1, 16, x2)

inst_38:
// rs2_w0_val == 268435456, rs1_w0_val == 2048
// opcode: smmul ; op1:x30; dest:x31; op1val:0x000800;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0x000800, 0x10000000, x1, 20, x2)

inst_39:
// rs2_w0_val == 134217728, rs1_w0_val == 65536
// opcode: smmul ; op1:x30; dest:x31; op1val:0x010000;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0x010000, 0x8000000, x1, 24, x2)

inst_40:
// rs2_w0_val == 67108864, 
// opcode: smmul ; op1:x30; dest:x31; op1val:0x40000000;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0x40000000, 0x4000000, x1, 28, x2)

inst_41:
// rs2_w0_val == 33554432, rs1_w0_val == 4
// opcode: smmul ; op1:x30; dest:x31; op1val:0x000004;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0x000004, 0x2000000, x1, 32, x2)

inst_42:
// rs2_w0_val == 16777216, 
// opcode: smmul ; op1:x30; dest:x31; op1val:0x1000000;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0x1000000, 0x1000000, x1, 36, x2)

inst_43:
// rs2_w0_val == 8388608, 
// opcode: smmul ; op1:x30; dest:x31; op1val:0xfffffffc;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0xfffffffc, 0x800000, x1, 40, x2)

inst_44:
// rs2_w0_val == 4194304, rs1_w0_val == -8193
// opcode: smmul ; op1:x30; dest:x31; op1val:0xffffdfff;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0xffffdfff, 0x400000, x1, 44, x2)

inst_45:
// rs2_w0_val == 2097152, rs1_w0_val == -4194305
// opcode: smmul ; op1:x30; dest:x31; op1val:0xffbfffff;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0xffbfffff, 0x200000, x1, 48, x2)

inst_46:
// rs2_w0_val == 1048576, rs1_w0_val == -262145
// opcode: smmul ; op1:x30; dest:x31; op1val:0xfffbffff;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0xfffbffff, 0x100000, x1, 52, x2)

inst_47:
// rs1_w0_val == 8, 
// opcode: smmul ; op1:x30; dest:x31; op1val:0x000008;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0x000008, 0xffffff7f, x1, 56, x2)

inst_48:
// rs1_w0_val == 2, 
// opcode: smmul ; op1:x30; dest:x31; op1val:0x000002;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0x000002, 0xffffbfff, x1, 60, x2)

inst_49:
// rs1_w0_val == 1, 
// opcode: smmul ; op1:x30; dest:x31; op1val:0x000001;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0x000001, 0xfffffff7, x1, 64, x2)

inst_50:
// rs1_w0_val == 0, 
// opcode: smmul ; op1:x30; dest:x31; op1val:0x000000;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0x000000, 0x4000000, x1, 68, x2)

inst_51:
// rs1_w0_val == -1, 
// opcode: smmul ; op1:x30; dest:x31; op1val:0xffffffff;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0xffffffff, 0xfffff7ff, x1, 72, x2)

inst_52:
// rs2_w0_val == 524288, rs1_w0_val == -1048577
// opcode: smmul ; op1:x30; dest:x31; op1val:0xffefffff;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0xffefffff, 0x080000, x1, 76, x2)

inst_53:
// rs2_w0_val == 262144, 
// opcode: smmul ; op1:x30; dest:x31; op1val:0x000003;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0x000003, 0x040000, x1, 80, x2)

inst_54:
// rs2_w0_val == 131072, rs1_w0_val == -3
// opcode: smmul ; op1:x30; dest:x31; op1val:0xfffffffd;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0xfffffffd, 0x020000, x1, 84, x2)

inst_55:
// rs2_w0_val == 65536, 
// opcode: smmul ; op1:x30; dest:x31; op1val:0x000000;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0x000000, 0x010000, x1, 88, x2)

inst_56:
// rs2_w0_val == 32768, 
// opcode: smmul ; op1:x30; dest:x31; op1val:0x1000000;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0x1000000, 0x008000, x1, 92, x2)

inst_57:
// rs2_w0_val == 16384, rs1_w0_val == -4097
// opcode: smmul ; op1:x30; dest:x31; op1val:0xffffefff;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0xffffefff, 0x004000, x1, 96, x2)

inst_58:
// rs2_w0_val == 8192, rs1_w0_val == -65537
// opcode: smmul ; op1:x30; dest:x31; op1val:0xfffeffff;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0xfffeffff, 0x002000, x1, 100, x2)

inst_59:
// rs2_w0_val == 4096, rs1_w0_val == 67108864
// opcode: smmul ; op1:x30; dest:x31; op1val:0x4000000;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0x4000000, 0x001000, x1, 104, x2)

inst_60:
// rs2_w0_val == 2048, 
// opcode: smmul ; op1:x30; dest:x31; op1val:0xfffffffd;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0xfffffffd, 0x000800, x1, 108, x2)

inst_61:
// rs2_w0_val == 1024, 
// opcode: smmul ; op1:x30; dest:x31; op1val:0x000008;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0x000008, 0x000400, x1, 112, x2)

inst_62:
// rs2_w0_val == 512, 
// opcode: smmul ; op1:x30; dest:x31; op1val:0x000800;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0x000800, 0x000200, x1, 116, x2)

inst_63:
// rs2_w0_val == 128, 
// opcode: smmul ; op1:x30; dest:x31; op1val:0xfffffffc;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0xfffffffc, 0x000080, x1, 120, x2)

inst_64:
// rs2_w0_val == 64, 
// opcode: smmul ; op1:x30; dest:x31; op1val:0xfffffffa;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0xfffffffa, 0x000040, x1, 124, x2)

inst_65:
// rs2_w0_val == 32, 
// opcode: smmul ; op1:x30; dest:x31; op1val:0xffff7fff;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0xffff7fff, 0x000020, x1, 128, x2)

inst_66:
// rs2_w0_val == 16, 
// opcode: smmul ; op1:x30; dest:x31; op1val:0x000006;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0x000006, 0x000010, x1, 132, x2)

inst_67:
// rs2_w0_val == 8, rs1_w0_val == 16384
// opcode: smmul ; op1:x30; dest:x31; op1val:0x004000;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0x004000, 0x000008, x1, 136, x2)

inst_68:
// rs2_w0_val == 4, 
// opcode: smmul ; op1:x30; dest:x31; op1val:0xffffffff;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0xffffffff, 0x000004, x1, 140, x2)

inst_69:
// rs2_w0_val == 2, rs1_w0_val == 8192
// opcode: smmul ; op1:x30; dest:x31; op1val:0x002000;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0x002000, 0x000002, x1, 144, x2)

inst_70:
// rs2_w0_val == 1, 
// opcode: smmul ; op1:x30; dest:x31; op1val:0xbfffffff;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0xbfffffff, 0x000001, x1, 148, x2)

inst_71:
// rs2_w0_val == 0, 
// opcode: smmul ; op1:x30; dest:x31; op1val:0xfffffffc;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0xfffffffc, 0x000000, x1, 152, x2)

inst_72:
// rs2_w0_val == -1, rs1_w0_val == -513
// opcode: smmul ; op1:x30; dest:x31; op1val:0xfffffdff;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0xfffffdff, 0xffffffff, x1, 156, x2)

inst_73:
// rs1_w0_val == -1431655766, 
// opcode: smmul ; op1:x30; dest:x31; op1val:0xaaaaaaaa;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0xaaaaaaaa, 0x3fffffff, x1, 160, x2)

inst_74:
// rs1_w0_val == 1431655765, 
// opcode: smmul ; op1:x30; dest:x31; op1val:0x55555555;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0x55555555, 0x000006, x1, 164, x2)

inst_75:
// rs1_w0_val == -33554433, 
// opcode: smmul ; op1:x30; dest:x31; op1val:0xfdffffff;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0xfdffffff, 0xfffbffff, x1, 168, x2)

inst_76:
// rs1_w0_val == -16777217, 
// opcode: smmul ; op1:x30; dest:x31; op1val:0xfeffffff;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0xfeffffff, 0xfffffdff, x1, 172, x2)

inst_77:
// rs1_w0_val == -8388609, 
// opcode: smmul ; op1:x30; dest:x31; op1val:0xff7fffff;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0xff7fffff, 0xffffbfff, x1, 176, x2)

inst_78:
// rs1_w0_val == -2097153, 
// opcode: smmul ; op1:x30; dest:x31; op1val:0xffdfffff;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0xffdfffff, 0xfffffffc, x1, 180, x2)

inst_79:
// rs1_w0_val == -524289, 
// opcode: smmul ; op1:x30; dest:x31; op1val:0xfff7ffff;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0xfff7ffff, 0xffff7fff, x1, 184, x2)

inst_80:
// rs1_w0_val == -16385, 
// opcode: smmul ; op1:x30; dest:x31; op1val:0xffffbfff;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0xffffbfff, 0xfffffeff, x1, 188, x2)

inst_81:
// rs1_w0_val == -1025, 
// opcode: smmul ; op1:x30; dest:x31; op1val:0xfffffbff;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0xfffffbff, 0x000008, x1, 192, x2)

inst_82:
// rs1_w0_val == -65, 
// opcode: smmul ; op1:x30; dest:x31; op1val:0xffffffbf;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0xffffffbf, 0x20000000, x1, 196, x2)

inst_83:
// rs1_w0_val == -33, 
// opcode: smmul ; op1:x30; dest:x31; op1val:0xffffffdf;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0xffffffdf, 0x80000000, x1, 200, x2)

inst_84:
// rs1_w0_val == -9, 
// opcode: smmul ; op1:x30; dest:x31; op1val:0xfffffff7;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0xfffffff7, 0xffbfffff, x1, 204, x2)

inst_85:
// rs1_w0_val == -5, 
// opcode: smmul ; op1:x30; dest:x31; op1val:0xfffffffb;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0xfffffffb, 0x010000, x1, 208, x2)

inst_86:
// rs1_w0_val == -2, 
// opcode: smmul ; op1:x30; dest:x31; op1val:0xfffffffe;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0xfffffffe, 0xffffbfff, x1, 212, x2)

inst_87:
// rs1_w0_val == 536870912, 
// opcode: smmul ; op1:x30; dest:x31; op1val:0x20000000;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0x20000000, 0xfffffffd, x1, 216, x2)

inst_88:
// rs1_w0_val == 268435456, 
// opcode: smmul ; op1:x30; dest:x31; op1val:0x10000000;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0x10000000, 0xfffffeff, x1, 220, x2)

inst_89:
// rs1_w0_val == 134217728, 
// opcode: smmul ; op1:x30; dest:x31; op1val:0x8000000;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0x8000000, 0x000040, x1, 224, x2)

inst_90:
// rs1_w0_val == 8388608, 
// opcode: smmul ; op1:x30; dest:x31; op1val:0x800000;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0x800000, 0xfbffffff, x1, 228, x2)

inst_91:
// rs1_w0_val == 4194304, 
// opcode: smmul ; op1:x30; dest:x31; op1val:0x400000;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0x400000, 0x000001, x1, 232, x2)

inst_92:
// rs1_w0_val == 2097152, 
// opcode: smmul ; op1:x30; dest:x31; op1val:0x200000;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0x200000, 0xfffffffb, x1, 236, x2)

inst_93:
// rs1_w0_val == 1048576, 
// opcode: smmul ; op1:x30; dest:x31; op1val:0x100000;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0x100000, 0x000001, x1, 240, x2)

inst_94:
// rs1_w0_val == 262144, 
// opcode: smmul ; op1:x30; dest:x31; op1val:0x040000;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0x040000, 0x000040, x1, 244, x2)

inst_95:
// rs1_w0_val == 131072, 
// opcode: smmul ; op1:x30; dest:x31; op1val:0x020000;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0x020000, 0xc0000000, x1, 248, x2)

inst_96:
// rs1_w0_val == 1024, 
// opcode: smmul ; op1:x30; dest:x31; op1val:0x000400;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0x000400, 0x2000000, x1, 252, x2)

inst_97:
// rs1_w0_val == 512, 
// opcode: smmul ; op1:x30; dest:x31; op1val:0x000200;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0x000200, 0xfffffeff, x1, 256, x2)

inst_98:
// rs1_w0_val == 32768, 
// opcode: smmul ; op1:x30; dest:x31; op1val:0x008000;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0x008000, 0x20000000, x1, 260, x2)

inst_99:
// rs1_w0_val == 64, 
// opcode: smmul ; op1:x30; dest:x31; op1val:0x000040;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0x000040, 0x080000, x1, 264, x2)

inst_100:
// rs2_w0_val == -1431655766, rs1_w0_val == 256
// opcode: smmul ; op1:x30; dest:x31; op1val:0x000100;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0x000100, 0xaaaaaaaa, x1, 268, x2)

inst_101:
// rs2_w0_val == 2147483647, 
// opcode: smmul ; op1:x30; dest:x31; op1val:0x000009;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0x000009, 0x7fffffff, x1, 272, x2)

inst_102:
// rs2_w0_val == -65, rs1_w0_val == -67108865
// opcode: smmul ; op1:x30; dest:x31; op1val:0xfbffffff;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0xfbffffff, 0xffffffbf, x1, 276, x2)

inst_103:
// rs2_w0_val == -17, rs1_w0_val == 4096
// opcode: smmul ; op1:x30; dest:x31; op1val:0x001000;  immval:$imm_val
TEST_RR_OP(smmul, x31, x30, x29, 0x00000000, 0x001000, 0xffffffef, x1, 280, x2)
#endif


RVTEST_CODE_END
RVMODEL_HALT

RVTEST_DATA_BEGIN
.align 4
rvtest_data:
.word 0xbabecafe
.word 0xabecafeb
.word 0xbecafeba
.word 0xecafebab
RVTEST_DATA_END

RVMODEL_DATA_BEGIN


signature_x6_0:
    .fill 0*(XLEN/32),4,0xdeadbeef


signature_x6_1:
    .fill 18*(XLEN/32),4,0xdeadbeef


signature_x1_0:
    .fill 15*(XLEN/32),4,0xdeadbeef


signature_x1_1:
    .fill 71*(XLEN/32),4,0xdeadbeef

#ifdef rvtest_mtrap_routine

mtrap_sigptr:
    .fill 64*(XLEN/32),4,0xdeadbeef

#endif

#ifdef rvtest_gpr_save

gpr_save:
    .fill 32*(XLEN/32),4,0xdeadbeef

#endif

RVMODEL_DATA_END
