
// -----------
// This file was generated by riscv_ctg (https://github.com/riscv-software-src/riscv-ctg)
// version   : 0.6.3
// timestamp : Sat Apr 23 14:53:29 2022 GMT
// usage     : riscv_ctg \
//                  --cgf /scratch/git-repo/github/riscv_ctg/sample_cgfs/dataset.cgf \
//                  --cgf /scratch/git-repo/github/riscv_ctg/sample_cgfs/rv32ip.cgf \
//                  --xlen 32  \
//                  --randomize \
// -----------
//
// -----------
// Copyright (c) 2020. RISC-V International. All rights reserved.
// SPDX-License-Identifier: BSD-3-Clause
// -----------
//
// This assembly file tests the smmwt.u instruction of the RISC-V RV32PZicsr extension for the smmwt.u covergroup.
// 
#include "model_test.h"
#include "arch_test.h"
RVTEST_ISA("RV32IPZicsr")

.section .text.init
.org 0x80
.globl rvtest_entry_point
rvtest_entry_point:
RVMODEL_BOOT
RVTEST_CODE_BEGIN

#ifdef TEST_CASE_1

RVTEST_CASE(0,"//check ISA:=regex(.*32.*);check ISA:=regex(.*I.*P.*Zicsr.*);def TEST_CASE_1=True;",smmwt.u)

RVTEST_VXSAT_ENABLE()
RVTEST_SIGBASE(x14,signature_x14_1)

inst_0:
// rs1 != rs2  and rs1 != rd and rs2 != rd, rs1==x28, rs2==x15, rd==x11, rs1_w0_val == -2147483648, rs2_h1_val == 8192
// opcode: smmwt.u ; op1:x28; op2:x15; dest:x11; op1val:0x80000000;  op2val:0x20003fff
TEST_RR_OP(smmwt.u, x11, x28, x15, 0x00000000, 0x80000000, 0x20003fff, x14, 0, x1)

inst_1:
// rs1 == rs2 != rd, rs1==x22, rs2==x22, rd==x23, rs2_h1_val == -21846, rs1_w0_val == -262145, rs2_h0_val == 2
// opcode: smmwt.u ; op1:x22; op2:x22; dest:x23; op1val:0xfffbffff;  op2val:0xaaaa0002
TEST_RR_OP(smmwt.u, x23, x22, x22, 0x00000000, 0xfffbffff, 0xaaaa0002, x14, 4, x1)

inst_2:
// rs1 == rd != rs2, rs1==x16, rs2==x21, rd==x16, rs2_h1_val == 21845, rs2_h0_val == 1, rs1_w0_val == 4
// opcode: smmwt.u ; op1:x16; op2:x21; dest:x16; op1val:0x000004;  op2val:0x55550001
TEST_RR_OP(smmwt.u, x16, x16, x21, 0x00000000, 0x000004, 0x55550001, x14, 8, x1)

inst_3:
// rs1 == rs2 == rd, rs1==x7, rs2==x7, rd==x7, rs2_h1_val == 32767, rs2_h0_val == 4096, rs1_w0_val == -8388609
// opcode: smmwt.u ; op1:x7; op2:x7; dest:x7; op1val:0xff7fffff;  op2val:0x7fff1000
TEST_RR_OP(smmwt.u, x7, x7, x7, 0x00000000, 0xff7fffff, 0x7fff1000, x14, 12, x1)

inst_4:
// rs2 == rd != rs1, rs1==x8, rs2==x26, rd==x26, rs2_h1_val == -16385, 
// opcode: smmwt.u ; op1:x8; op2:x26; dest:x26; op1val:0xff7fffff;  op2val:0xbffffff9
TEST_RR_OP(smmwt.u, x26, x8, x26, 0x00000000, 0xff7fffff, 0xbffffff9, x14, 16, x1)

inst_5:
// rs1==x25, rs2==x30, rd==x5, rs2_h1_val == -8193, rs2_h0_val == 16384, rs1_w0_val == 536870912
// opcode: smmwt.u ; op1:x25; op2:x30; dest:x5; op1val:0x20000000;  op2val:0xdfff4000
TEST_RR_OP(smmwt.u, x5, x25, x30, 0x00000000, 0x20000000, 0xdfff4000, x14, 20, x1)

inst_6:
// rs1==x15, rs2==x0, rd==x10, rs2_h1_val == -4097, rs2_h0_val == -5, rs1_w0_val == -16385
// opcode: smmwt.u ; op1:x15; op2:x0; dest:x10; op1val:0xffffbfff;  op2val:0xeffffffb
TEST_RR_OP(smmwt.u, x10, x15, x0, 0x00000000, 0xffffbfff, 0xeffffffb, x14, 24, x1)

inst_7:
// rs1==x9, rs2==x31, rd==x13, rs2_h1_val == -2049, rs1_w0_val == 16384
// opcode: smmwt.u ; op1:x9; op2:x31; dest:x13; op1val:0x004000;  op2val:0xf7fffff9
TEST_RR_OP(smmwt.u, x13, x9, x31, 0x00000000, 0x004000, 0xf7fffff9, x14, 28, x1)

inst_8:
// rs1==x12, rs2==x29, rd==x0, rs2_h1_val == -1025, rs2_h0_val == -17
// opcode: smmwt.u ; op1:x12; op2:x29; dest:x0; op1val:0x000004;  op2val:0xfbffffef
TEST_RR_OP(smmwt.u, x0, x12, x29, 0x00000000, 0x000004, 0xfbffffef, x14, 32, x1)

inst_9:
// rs1==x0, rs2==x4, rd==x21, rs2_h1_val == -513, rs1_w0_val == -3, rs2_h0_val == -2
// opcode: smmwt.u ; op1:x0; op2:x4; dest:x21; op1val:0xfffffffd;  op2val:0xfdfffffe
TEST_RR_OP(smmwt.u, x21, x0, x4, 0x00000000, 0xfffffffd, 0xfdfffffe, x14, 36, x1)

inst_10:
// rs1==x13, rs2==x6, rd==x2, rs2_h1_val == -257, rs1_w0_val == -1073741825, rs2_h0_val == -257
// opcode: smmwt.u ; op1:x13; op2:x6; dest:x2; op1val:0xbfffffff;  op2val:0xfefffeff
TEST_RR_OP(smmwt.u, x2, x13, x6, 0x00000000, 0xbfffffff, 0xfefffeff, x14, 40, x1)

inst_11:
// rs1==x21, rs2==x19, rd==x17, rs2_h1_val == -129, rs2_h0_val == 8
// opcode: smmwt.u ; op1:x21; op2:x19; dest:x17; op1val:0x80000000;  op2val:0xff7f0008
TEST_RR_OP(smmwt.u, x17, x21, x19, 0x00000000, 0x80000000, 0xff7f0008, x14, 44, x1)

inst_12:
// rs1==x2, rs2==x8, rd==x25, rs2_h1_val == -65, rs1_w0_val == 1431655765, rs2_h0_val == 512
// opcode: smmwt.u ; op1:x2; op2:x8; dest:x25; op1val:0x55555555;  op2val:0xffbf0200
TEST_RR_OP(smmwt.u, x25, x2, x8, 0x00000000, 0x55555555, 0xffbf0200, x14, 48, x1)

inst_13:
// rs1==x6, rs2==x3, rd==x9, rs2_h1_val == -33, 
// opcode: smmwt.u ; op1:x6; op2:x3; dest:x9; op1val:0xfffbffff;  op2val:0xffdffff8
TEST_RR_OP(smmwt.u, x9, x6, x3, 0x00000000, 0xfffbffff, 0xffdffff8, x14, 52, x1)

inst_14:
// rs1==x29, rs2==x16, rd==x31, rs2_h1_val == -17, 
// opcode: smmwt.u ; op1:x29; op2:x16; dest:x31; op1val:0x000004;  op2val:0xffef3fff
TEST_RR_OP(smmwt.u, x31, x29, x16, 0x00000000, 0x000004, 0xffef3fff, x14, 56, x1)

inst_15:
// rs1==x26, rs2==x2, rd==x3, rs2_h1_val == -9, rs2_h0_val == 64
// opcode: smmwt.u ; op1:x26; op2:x2; dest:x3; op1val:0xff7fffff;  op2val:0xfff70040
TEST_RR_OP(smmwt.u, x3, x26, x2, 0x00000000, 0xff7fffff, 0xfff70040, x14, 60, x1)

inst_16:
// rs1==x3, rs2==x25, rd==x18, rs2_h1_val == -5, rs2_h0_val == -21846, rs1_w0_val == -268435457
// opcode: smmwt.u ; op1:x3; op2:x25; dest:x18; op1val:0xefffffff;  op2val:0xfffbaaaa
TEST_RR_OP(smmwt.u, x18, x3, x25, 0x00000000, 0xefffffff, 0xfffbaaaa, x14, 64, x1)

inst_17:
// rs1==x1, rs2==x5, rd==x24, rs2_h1_val == -3, rs2_h0_val == 0
// opcode: smmwt.u ; op1:x1; op2:x5; dest:x24; op1val:0xfffffff9;  op2val:0xfffd0000
TEST_RR_OP(smmwt.u, x24, x1, x5, 0x00000000, 0xfffffff9, 0xfffd0000, x14, 68, x3)
RVTEST_SIGBASE(x2,signature_x2_0)

inst_18:
// rs1==x31, rs2==x24, rd==x28, rs2_h1_val == -2, rs2_h0_val == -1, rs1_w0_val == 1024
// opcode: smmwt.u ; op1:x31; op2:x24; dest:x28; op1val:0x000400;  op2val:0xfffeffff
TEST_RR_OP(smmwt.u, x28, x31, x24, 0x00000000, 0x000400, 0xfffeffff, x2, 0, x3)

inst_19:
// rs1==x4, rs2==x10, rd==x30, rs2_h1_val == -32768, rs1_w0_val == 16
// opcode: smmwt.u ; op1:x4; op2:x10; dest:x30; op1val:0x000010;  op2val:0x8000fffe
TEST_RR_OP(smmwt.u, x30, x4, x10, 0x00000000, 0x000010, 0x8000fffe, x2, 4, x3)

inst_20:
// rs1==x10, rs2==x28, rd==x6, rs2_h1_val == 16384, rs1_w0_val == 256, rs2_h0_val == -32768
// opcode: smmwt.u ; op1:x10; op2:x28; dest:x6; op1val:0x000100;  op2val:0x40008000
TEST_RR_OP(smmwt.u, x6, x10, x28, 0x00000000, 0x000100, 0x40008000, x2, 8, x3)

inst_21:
// rs1==x30, rs2==x27, rd==x1, rs2_h1_val == 4096, rs1_w0_val == 8388608
// opcode: smmwt.u ; op1:x30; op2:x27; dest:x1; op1val:0x800000;  op2val:0x10001000
TEST_RR_OP(smmwt.u, x1, x30, x27, 0x00000000, 0x800000, 0x10001000, x2, 12, x3)

inst_22:
// rs1==x24, rs2==x23, rd==x4, rs2_h1_val == 2048, rs2_h0_val == -9
// opcode: smmwt.u ; op1:x24; op2:x23; dest:x4; op1val:0xbfffffff;  op2val:0x800fff7
TEST_RR_OP(smmwt.u, x4, x24, x23, 0x00000000, 0xbfffffff, 0x800fff7, x2, 16, x3)

inst_23:
// rs1==x27, rs2==x12, rd==x22, rs2_h1_val == 1024, 
// opcode: smmwt.u ; op1:x27; op2:x12; dest:x22; op1val:0x800000;  op2val:0x400fffe
TEST_RR_OP(smmwt.u, x22, x27, x12, 0x00000000, 0x800000, 0x400fffe, x2, 20, x3)

inst_24:
// rs1==x5, rs2==x13, rd==x12, rs2_h1_val == 512, 
// opcode: smmwt.u ; op1:x5; op2:x13; dest:x12; op1val:0x004000;  op2val:0x200fffa
TEST_RR_OP(smmwt.u, x12, x5, x13, 0x00000000, 0x004000, 0x200fffa, x2, 24, x3)

inst_25:
// rs1==x23, rs2==x18, rd==x14, rs2_h1_val == 256, 
// opcode: smmwt.u ; op1:x23; op2:x18; dest:x14; op1val:0xfffffff6;  op2val:0x100c000
TEST_RR_OP(smmwt.u, x14, x23, x18, 0x00000000, 0xfffffff6, 0x100c000, x2, 28, x3)

inst_26:
// rs1==x14, rs2==x1, rd==x20, rs2_h1_val == 128, rs1_w0_val == 128, rs2_h0_val == 4
// opcode: smmwt.u ; op1:x14; op2:x1; dest:x20; op1val:0x000080;  op2val:0x800004
TEST_RR_OP(smmwt.u, x20, x14, x1, 0x00000000, 0x000080, 0x800004, x2, 32, x3)

inst_27:
// rs1==x17, rs2==x9, rd==x15, rs2_h1_val == 64, 
// opcode: smmwt.u ; op1:x17; op2:x9; dest:x15; op1val:0x000007;  op2val:0x40ffef
TEST_RR_OP(smmwt.u, x15, x17, x9, 0x00000000, 0x000007, 0x40ffef, x2, 36, x3)

inst_28:
// rs1==x19, rs2==x20, rd==x27, rs2_h1_val == 32, rs1_w0_val == 67108864
// opcode: smmwt.u ; op1:x19; op2:x20; dest:x27; op1val:0x4000000;  op2val:0x200200
TEST_RR_OP(smmwt.u, x27, x19, x20, 0x00000000, 0x4000000, 0x200200, x2, 40, x3)

inst_29:
// rs1==x20, rs2==x11, rd==x29, rs2_h1_val == 16, rs2_h0_val == 2048
// opcode: smmwt.u ; op1:x20; op2:x11; dest:x29; op1val:0x000003;  op2val:0x100800
TEST_RR_OP(smmwt.u, x29, x20, x11, 0x00000000, 0x000003, 0x100800, x2, 44, x3)

inst_30:
// rs1==x11, rs2==x14, rd==x8, rs2_h1_val == 8, 
// opcode: smmwt.u ; op1:x11; op2:x14; dest:x8; op1val:0xff7fffff;  op2val:0x08ffff
TEST_RR_OP(smmwt.u, x8, x11, x14, 0x00000000, 0xff7fffff, 0x08ffff, x2, 48, x3)

inst_31:
// rs1==x18, rs2==x17, rd==x19, rs2_h1_val == 4, rs1_w0_val == -17
// opcode: smmwt.u ; op1:x18; op2:x17; dest:x19; op1val:0xffffffef;  op2val:0x04c000
TEST_RR_OP(smmwt.u, x19, x18, x17, 0x00000000, 0xffffffef, 0x04c000, x2, 52, x3)

inst_32:
// rs2_h1_val == 2, rs1_w0_val == -536870913
// opcode: smmwt.u ; op1:x30; op2:x29; dest:x31; op1val:0xdfffffff;  op2val:0x020004
TEST_RR_OP(smmwt.u, x31, x30, x29, 0x00000000, 0xdfffffff, 0x020004, x2, 56, x3)

inst_33:
// rs2_h1_val == 1, rs2_h0_val == -129
// opcode: smmwt.u ; op1:x30; op2:x29; dest:x31; op1val:0x000010;  op2val:0x01ff7f
TEST_RR_OP(smmwt.u, x31, x30, x29, 0x00000000, 0x000010, 0x01ff7f, x2, 60, x3)

inst_34:
// rs2_h1_val == 0, rs1_w0_val == -134217729
// opcode: smmwt.u ; op1:x30; op2:x29; dest:x31; op1val:0xf7ffffff;  op2val:0x00fffe
TEST_RR_OP(smmwt.u, x31, x30, x29, 0x00000000, 0xf7ffffff, 0x00fffe, x2, 64, x3)

inst_35:
// rs2_h1_val == -1, rs1_w0_val == 512
// opcode: smmwt.u ; op1:x30; op2:x29; dest:x31; op1val:0x000200;  op2val:0xffff0003
TEST_RR_OP(smmwt.u, x31, x30, x29, 0x00000000, 0x000200, 0xffff0003, x2, 68, x3)

inst_36:
// rs2_h0_val == 21845, rs1_w0_val == 65536
// opcode: smmwt.u ; op1:x30; op2:x29; dest:x31; op1val:0x010000;  op2val:0x055555
TEST_RR_OP(smmwt.u, x31, x30, x29, 0x00000000, 0x010000, 0x055555, x2, 72, x3)

inst_37:
// rs1_w0_val == 64, 
// opcode: smmwt.u ; op1:x30; op2:x29; dest:x31; op1val:0x000040;  op2val:0x09fff8
TEST_RR_OP(smmwt.u, x31, x30, x29, 0x00000000, 0x000040, 0x09fff8, x2, 76, x3)

inst_38:
// rs1_w0_val == 32, 
// opcode: smmwt.u ; op1:x30; op2:x29; dest:x31; op1val:0x000020;  op2val:0x08fffb
TEST_RR_OP(smmwt.u, x31, x30, x29, 0x00000000, 0x000020, 0x08fffb, x2, 80, x3)

inst_39:
// rs1_w0_val == 8, 
// opcode: smmwt.u ; op1:x30; op2:x29; dest:x31; op1val:0x000008;  op2val:0x080002
TEST_RR_OP(smmwt.u, x31, x30, x29, 0x00000000, 0x000008, 0x080002, x2, 84, x3)

inst_40:
// rs1_w0_val == 2, 
// opcode: smmwt.u ; op1:x30; op2:x29; dest:x31; op1val:0x000002;  op2val:0xefff1000
TEST_RR_OP(smmwt.u, x31, x30, x29, 0x00000000, 0x000002, 0xefff1000, x2, 88, x3)

inst_41:
// rs1_w0_val == 1, 
// opcode: smmwt.u ; op1:x30; op2:x29; dest:x31; op1val:0x000001;  op2val:0xf7fffeff
TEST_RR_OP(smmwt.u, x31, x30, x29, 0x00000000, 0x000001, 0xf7fffeff, x2, 92, x3)

inst_42:
// rs1_w0_val == 0, rs2_h0_val == -513
// opcode: smmwt.u ; op1:x30; op2:x29; dest:x31; op1val:0x000000;  op2val:0x06fdff
TEST_RR_OP(smmwt.u, x31, x30, x29, 0x00000000, 0x000000, 0x06fdff, x2, 96, x3)

inst_43:
// rs1_w0_val == -1, 
// opcode: smmwt.u ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0xdfff0004
TEST_RR_OP(smmwt.u, x31, x30, x29, 0x00000000, 0xffffffff, 0xdfff0004, x2, 100, x3)

inst_44:
// rs2_h0_val == 32767, 
// opcode: smmwt.u ; op1:x30; op2:x29; dest:x31; op1val:0x000080;  op2val:0xfff77fff
TEST_RR_OP(smmwt.u, x31, x30, x29, 0x00000000, 0x000080, 0xfff77fff, x2, 104, x3)

inst_45:
// rs2_h0_val == -16385, 
// opcode: smmwt.u ; op1:x30; op2:x29; dest:x31; op1val:0x000007;  op2val:0x200bfff
TEST_RR_OP(smmwt.u, x31, x30, x29, 0x00000000, 0x000007, 0x200bfff, x2, 108, x3)

inst_46:
// rs2_h0_val == -8193, rs1_w0_val == -129
// opcode: smmwt.u ; op1:x30; op2:x29; dest:x31; op1val:0xffffff7f;  op2val:0xfffddfff
TEST_RR_OP(smmwt.u, x31, x30, x29, 0x00000000, 0xffffff7f, 0xfffddfff, x2, 112, x3)

inst_47:
// rs2_h0_val == -4097, rs1_w0_val == -65537
// opcode: smmwt.u ; op1:x30; op2:x29; dest:x31; op1val:0xfffeffff;  op2val:0xbfffefff
TEST_RR_OP(smmwt.u, x31, x30, x29, 0x00000000, 0xfffeffff, 0xbfffefff, x2, 116, x3)

inst_48:
// rs2_h0_val == -2049, rs1_w0_val == 1073741824
// opcode: smmwt.u ; op1:x30; op2:x29; dest:x31; op1val:0x40000000;  op2val:0x7ffff7ff
TEST_RR_OP(smmwt.u, x31, x30, x29, 0x00000000, 0x40000000, 0x7ffff7ff, x2, 120, x3)

inst_49:
// rs2_h0_val == -1025, 
// opcode: smmwt.u ; op1:x30; op2:x29; dest:x31; op1val:0xfffffff6;  op2val:0xffbffbff
TEST_RR_OP(smmwt.u, x31, x30, x29, 0x00000000, 0xfffffff6, 0xffbffbff, x2, 124, x3)

inst_50:
// rs2_h0_val == -65, 
// opcode: smmwt.u ; op1:x30; op2:x29; dest:x31; op1val:0x3fffffff;  op2val:0xfeffffbf
TEST_RR_OP(smmwt.u, x31, x30, x29, 0x00000000, 0x3fffffff, 0xfeffffbf, x2, 128, x3)

inst_51:
// rs2_h0_val == -33, 
// opcode: smmwt.u ; op1:x30; op2:x29; dest:x31; op1val:0x40000000;  op2val:0x1000ffdf
TEST_RR_OP(smmwt.u, x31, x30, x29, 0x00000000, 0x40000000, 0x1000ffdf, x2, 132, x3)

inst_52:
// rs2_h0_val == -3, rs1_w0_val == 262144
// opcode: smmwt.u ; op1:x30; op2:x29; dest:x31; op1val:0x040000;  op2val:0xffdffffd
TEST_RR_OP(smmwt.u, x31, x30, x29, 0x00000000, 0x040000, 0xffdffffd, x2, 136, x3)

inst_53:
// rs2_h0_val == 8192, rs1_w0_val == 134217728
// opcode: smmwt.u ; op1:x30; op2:x29; dest:x31; op1val:0x8000000;  op2val:0x55552000
TEST_RR_OP(smmwt.u, x31, x30, x29, 0x00000000, 0x8000000, 0x55552000, x2, 140, x3)

inst_54:
// rs2_h0_val == 1024, rs1_w0_val == -1048577
// opcode: smmwt.u ; op1:x30; op2:x29; dest:x31; op1val:0xffefffff;  op2val:0xfbff0400
TEST_RR_OP(smmwt.u, x31, x30, x29, 0x00000000, 0xffefffff, 0xfbff0400, x2, 144, x3)

inst_55:
// rs2_h0_val == 256, 
// opcode: smmwt.u ; op1:x30; op2:x29; dest:x31; op1val:0xffefffff;  op2val:0xffff0100
TEST_RR_OP(smmwt.u, x31, x30, x29, 0x00000000, 0xffefffff, 0xffff0100, x2, 148, x3)

inst_56:
// rs2_h0_val == 128, 
// opcode: smmwt.u ; op1:x30; op2:x29; dest:x31; op1val:0xffffffef;  op2val:0xf7ff0080
TEST_RR_OP(smmwt.u, x31, x30, x29, 0x00000000, 0xffffffef, 0xf7ff0080, x2, 152, x3)

inst_57:
// rs2_h0_val == 32, 
// opcode: smmwt.u ; op1:x30; op2:x29; dest:x31; op1val:0x800000;  op2val:0x4000020
TEST_RR_OP(smmwt.u, x31, x30, x29, 0x00000000, 0x800000, 0x4000020, x2, 156, x3)

inst_58:
// rs2_h0_val == 16, 
// opcode: smmwt.u ; op1:x30; op2:x29; dest:x31; op1val:0x000040;  op2val:0xfff70010
TEST_RR_OP(smmwt.u, x31, x30, x29, 0x00000000, 0x000040, 0xfff70010, x2, 160, x3)

inst_59:
// rs1_w0_val == -1431655766, 
// opcode: smmwt.u ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaaa;  op2val:0xfffb0000
TEST_RR_OP(smmwt.u, x31, x30, x29, 0x00000000, 0xaaaaaaaa, 0xfffb0000, x2, 164, x3)

inst_60:
// rs1_w0_val == 2147483647, 
// opcode: smmwt.u ; op1:x30; op2:x29; dest:x31; op1val:0x7fffffff;  op2val:0xfff87fff
TEST_RR_OP(smmwt.u, x31, x30, x29, 0x00000000, 0x7fffffff, 0xfff87fff, x2, 168, x3)

inst_61:
// rs1_w0_val == -67108865, 
// opcode: smmwt.u ; op1:x30; op2:x29; dest:x31; op1val:0xfbffffff;  op2val:0xfffb0009
TEST_RR_OP(smmwt.u, x31, x30, x29, 0x00000000, 0xfbffffff, 0xfffb0009, x2, 172, x3)

inst_62:
// rs1_w0_val == -33554433, 
// opcode: smmwt.u ; op1:x30; op2:x29; dest:x31; op1val:0xfdffffff;  op2val:0x007fff
TEST_RR_OP(smmwt.u, x31, x30, x29, 0x00000000, 0xfdffffff, 0x007fff, x2, 176, x3)

inst_63:
// rs1_w0_val == -16777217, 
// opcode: smmwt.u ; op1:x30; op2:x29; dest:x31; op1val:0xfeffffff;  op2val:0xffef0200
TEST_RR_OP(smmwt.u, x31, x30, x29, 0x00000000, 0xfeffffff, 0xffef0200, x2, 180, x3)

inst_64:
// rs1_w0_val == -4194305, 
// opcode: smmwt.u ; op1:x30; op2:x29; dest:x31; op1val:0xffbfffff;  op2val:0xaaaa5555
TEST_RR_OP(smmwt.u, x31, x30, x29, 0x00000000, 0xffbfffff, 0xaaaa5555, x2, 184, x3)

inst_65:
// rs1_w0_val == -2097153, 
// opcode: smmwt.u ; op1:x30; op2:x29; dest:x31; op1val:0xffdfffff;  op2val:0x050020
TEST_RR_OP(smmwt.u, x31, x30, x29, 0x00000000, 0xffdfffff, 0x050020, x2, 188, x3)

inst_66:
// rs1_w0_val == -524289, 
// opcode: smmwt.u ; op1:x30; op2:x29; dest:x31; op1val:0xfff7ffff;  op2val:0x5555fffc
TEST_RR_OP(smmwt.u, x31, x30, x29, 0x00000000, 0xfff7ffff, 0x5555fffc, x2, 192, x3)

inst_67:
// rs1_w0_val == -131073, 
// opcode: smmwt.u ; op1:x30; op2:x29; dest:x31; op1val:0xfffdffff;  op2val:0xfffd0009
TEST_RR_OP(smmwt.u, x31, x30, x29, 0x00000000, 0xfffdffff, 0xfffd0009, x2, 196, x3)

inst_68:
// rs1_w0_val == -32769, 
// opcode: smmwt.u ; op1:x30; op2:x29; dest:x31; op1val:0xffff7fff;  op2val:0xff7fdfff
TEST_RR_OP(smmwt.u, x31, x30, x29, 0x00000000, 0xffff7fff, 0xff7fdfff, x2, 200, x3)

inst_69:
// rs1_w0_val == -8193, 
// opcode: smmwt.u ; op1:x30; op2:x29; dest:x31; op1val:0xffffdfff;  op2val:0xfdff4000
TEST_RR_OP(smmwt.u, x31, x30, x29, 0x00000000, 0xffffdfff, 0xfdff4000, x2, 204, x3)

inst_70:
// rs1_w0_val == -4097, 
// opcode: smmwt.u ; op1:x30; op2:x29; dest:x31; op1val:0xffffefff;  op2val:0x55550006
TEST_RR_OP(smmwt.u, x31, x30, x29, 0x00000000, 0xffffefff, 0x55550006, x2, 208, x3)

inst_71:
// rs1_w0_val == -2049, 
// opcode: smmwt.u ; op1:x30; op2:x29; dest:x31; op1val:0xfffff7ff;  op2val:0xfdfffffb
TEST_RR_OP(smmwt.u, x31, x30, x29, 0x00000000, 0xfffff7ff, 0xfdfffffb, x2, 212, x3)

inst_72:
// rs1_w0_val == -1025, 
// opcode: smmwt.u ; op1:x30; op2:x29; dest:x31; op1val:0xfffffbff;  op2val:0xfff6fff7
TEST_RR_OP(smmwt.u, x31, x30, x29, 0x00000000, 0xfffffbff, 0xfff6fff7, x2, 216, x3)

inst_73:
// rs1_w0_val == -513, 
// opcode: smmwt.u ; op1:x30; op2:x29; dest:x31; op1val:0xfffffdff;  op2val:0xaaaafff7
TEST_RR_OP(smmwt.u, x31, x30, x29, 0x00000000, 0xfffffdff, 0xaaaafff7, x2, 220, x3)

inst_74:
// rs1_w0_val == -257, 
// opcode: smmwt.u ; op1:x30; op2:x29; dest:x31; op1val:0xfffffeff;  op2val:0x020006
TEST_RR_OP(smmwt.u, x31, x30, x29, 0x00000000, 0xfffffeff, 0x020006, x2, 224, x3)

inst_75:
// rs1_w0_val == -65, 
// opcode: smmwt.u ; op1:x30; op2:x29; dest:x31; op1val:0xffffffbf;  op2val:0xbffff7ff
TEST_RR_OP(smmwt.u, x31, x30, x29, 0x00000000, 0xffffffbf, 0xbffff7ff, x2, 228, x3)

inst_76:
// rs1_w0_val == -33, 
// opcode: smmwt.u ; op1:x30; op2:x29; dest:x31; op1val:0xffffffdf;  op2val:0x404000
TEST_RR_OP(smmwt.u, x31, x30, x29, 0x00000000, 0xffffffdf, 0x404000, x2, 232, x3)

inst_77:
// rs1_w0_val == -9, 
// opcode: smmwt.u ; op1:x30; op2:x29; dest:x31; op1val:0xfffffff7;  op2val:0x80fffd
TEST_RR_OP(smmwt.u, x31, x30, x29, 0x00000000, 0xfffffff7, 0x80fffd, x2, 236, x3)

inst_78:
// rs1_w0_val == -5, 
// opcode: smmwt.u ; op1:x30; op2:x29; dest:x31; op1val:0xfffffffb;  op2val:0x090003
TEST_RR_OP(smmwt.u, x31, x30, x29, 0x00000000, 0xfffffffb, 0x090003, x2, 240, x3)

inst_79:
// rs1_w0_val == -2, 
// opcode: smmwt.u ; op1:x30; op2:x29; dest:x31; op1val:0xfffffffe;  op2val:0x55552000
TEST_RR_OP(smmwt.u, x31, x30, x29, 0x00000000, 0xfffffffe, 0x55552000, x2, 244, x3)

inst_80:
// rs1_w0_val == 268435456, 
// opcode: smmwt.u ; op1:x30; op2:x29; dest:x31; op1val:0x10000000;  op2val:0xfffd0003
TEST_RR_OP(smmwt.u, x31, x30, x29, 0x00000000, 0x10000000, 0xfffd0003, x2, 248, x3)

inst_81:
// rs1_w0_val == 33554432, 
// opcode: smmwt.u ; op1:x30; op2:x29; dest:x31; op1val:0x2000000;  op2val:0xfff9fffc
TEST_RR_OP(smmwt.u, x31, x30, x29, 0x00000000, 0x2000000, 0xfff9fffc, x2, 252, x3)

inst_82:
// rs1_w0_val == 16777216, 
// opcode: smmwt.u ; op1:x30; op2:x29; dest:x31; op1val:0x1000000;  op2val:0x10fffc
TEST_RR_OP(smmwt.u, x31, x30, x29, 0x00000000, 0x1000000, 0x10fffc, x2, 256, x3)

inst_83:
// rs1_w0_val == 4194304, 
// opcode: smmwt.u ; op1:x30; op2:x29; dest:x31; op1val:0x400000;  op2val:0xfffe0080
TEST_RR_OP(smmwt.u, x31, x30, x29, 0x00000000, 0x400000, 0xfffe0080, x2, 260, x3)

inst_84:
// rs1_w0_val == 2097152, 
// opcode: smmwt.u ; op1:x30; op2:x29; dest:x31; op1val:0x200000;  op2val:0x400007
TEST_RR_OP(smmwt.u, x31, x30, x29, 0x00000000, 0x200000, 0x400007, x2, 264, x3)

inst_85:
// rs1_w0_val == 1048576, 
// opcode: smmwt.u ; op1:x30; op2:x29; dest:x31; op1val:0x100000;  op2val:0x060003
TEST_RR_OP(smmwt.u, x31, x30, x29, 0x00000000, 0x100000, 0x060003, x2, 268, x3)

inst_86:
// rs1_w0_val == 524288, 
// opcode: smmwt.u ; op1:x30; op2:x29; dest:x31; op1val:0x080000;  op2val:0xfffcbfff
TEST_RR_OP(smmwt.u, x31, x30, x29, 0x00000000, 0x080000, 0xfffcbfff, x2, 272, x3)

inst_87:
// rs1_w0_val == 131072, 
// opcode: smmwt.u ; op1:x30; op2:x29; dest:x31; op1val:0x020000;  op2val:0x20000009
TEST_RR_OP(smmwt.u, x31, x30, x29, 0x00000000, 0x020000, 0x20000009, x2, 276, x3)

inst_88:
// rs1_w0_val == 32768, 
// opcode: smmwt.u ; op1:x30; op2:x29; dest:x31; op1val:0x008000;  op2val:0x10000800
TEST_RR_OP(smmwt.u, x31, x30, x29, 0x00000000, 0x008000, 0x10000800, x2, 280, x3)

inst_89:
// rs1_w0_val == 8192, 
// opcode: smmwt.u ; op1:x30; op2:x29; dest:x31; op1val:0x002000;  op2val:0x400004
TEST_RR_OP(smmwt.u, x31, x30, x29, 0x00000000, 0x002000, 0x400004, x2, 284, x3)

inst_90:
// rs1_w0_val == 4096, 
// opcode: smmwt.u ; op1:x30; op2:x29; dest:x31; op1val:0x001000;  op2val:0xdfffbfff
TEST_RR_OP(smmwt.u, x31, x30, x29, 0x00000000, 0x001000, 0xdfffbfff, x2, 288, x3)

inst_91:
// rs1_w0_val == 2048, 
// opcode: smmwt.u ; op1:x30; op2:x29; dest:x31; op1val:0x000800;  op2val:0xfffaf7ff
TEST_RR_OP(smmwt.u, x31, x30, x29, 0x00000000, 0x000800, 0xfffaf7ff, x2, 292, x3)

inst_92:
// rs2_h1_val == -4097, rs2_h0_val == -5, rs1_w0_val == -16385
// opcode: smmwt.u ; op1:x30; op2:x29; dest:x31; op1val:0xffffbfff;  op2val:0xeffffffb
TEST_RR_OP(smmwt.u, x31, x30, x29, 0x00000000, 0xffffbfff, 0xeffffffb, x2, 296, x3)

inst_93:
// rs2_h1_val == -513, rs1_w0_val == -3, rs2_h0_val == -2
// opcode: smmwt.u ; op1:x30; op2:x29; dest:x31; op1val:0xfffffffd;  op2val:0xfdfffffe
TEST_RR_OP(smmwt.u, x31, x30, x29, 0x00000000, 0xfffffffd, 0xfdfffffe, x2, 300, x3)
#endif


RVTEST_CODE_END
RVMODEL_HALT

RVTEST_DATA_BEGIN
.align 4
rvtest_data:
.word 0xbabecafe
.word 0xabecafeb
.word 0xbecafeba
.word 0xecafebab
RVTEST_DATA_END

RVMODEL_DATA_BEGIN


signature_x14_0:
    .fill 0*(XLEN/32),4,0xdeadbeef


signature_x14_1:
    .fill 18*(XLEN/32),4,0xdeadbeef


signature_x2_0:
    .fill 76*(XLEN/32),4,0xdeadbeef

#ifdef rvtest_mtrap_routine

mtrap_sigptr:
    .fill 64*(XLEN/32),4,0xdeadbeef

#endif

#ifdef rvtest_gpr_save

gpr_save:
    .fill 32*(XLEN/32),4,0xdeadbeef

#endif

RVMODEL_DATA_END
