
// -----------
// This file was generated by riscv_ctg (https://github.com/riscv-software-src/riscv-ctg)
// version   : 0.6.3
// timestamp : Sat Apr 23 14:53:29 2022 GMT
// usage     : riscv_ctg \
//                  --cgf /scratch/git-repo/github/riscv_ctg/sample_cgfs/dataset.cgf \
//                  --cgf /scratch/git-repo/github/riscv_ctg/sample_cgfs/rv32ip.cgf \
//                  --xlen 32  \
//                  --randomize \
// -----------
//
// -----------
// Copyright (c) 2020. RISC-V International. All rights reserved.
// SPDX-License-Identifier: BSD-3-Clause
// -----------
//
// This assembly file tests the sra16 instruction of the RISC-V RV32PZicsr extension for the sra16 covergroup.
// 
#include "model_test.h"
#include "arch_test.h"
RVTEST_ISA("RV32IPZicsr")

.section .text.init
.org 0x80
.globl rvtest_entry_point
rvtest_entry_point:
RVMODEL_BOOT
RVTEST_CODE_BEGIN

#ifdef TEST_CASE_1

RVTEST_CASE(0,"//check ISA:=regex(.*32.*);check ISA:=regex(.*I.*P.*Zicsr.*);def TEST_CASE_1=True;",sra16)

RVTEST_VXSAT_ENABLE()
RVTEST_SIGBASE(x6,signature_x6_1)

inst_0:
// rs1 != rs2  and rs1 != rd and rs2 != rd, rs1==x21, rs2==x29, rd==x30, rs2_val == 5, rs1_h1_val == 2
// opcode: sra16 ; op1:x21; op2:x29; dest:x30; op1val:0x02fff9;  op2val:0x5
TEST_RR_OP(sra16, x30, x21, x29, 0x00000000, 0x02fff9, 0x5, x6, 0, x15)

inst_1:
// rs1 == rs2 != rd, rs1==x5, rs2==x5, rd==x3, rs2_val == 7, rs1_h1_val == -1025, rs1_h0_val == 32767
// opcode: sra16 ; op1:x5; op2:x5; dest:x3; op1val:0xfbff7fff;  op2val:0x7
TEST_RR_OP(sra16, x3, x5, x5, 0x00000000, 0xfbff7fff, 0x7, x6, 4, x15)

inst_2:
// rs1 == rd != rs2, rs1==x20, rs2==x26, rd==x20, rs2_val == 11, 
// opcode: sra16 ; op1:x20; op2:x26; dest:x20; op1val:0x3fff7fff;  op2val:0xb
TEST_RR_OP(sra16, x20, x20, x26, 0x00000000, 0x3fff7fff, 0xb, x6, 8, x15)

inst_3:
// rs1 == rs2 == rd, rs1==x8, rs2==x8, rd==x8, rs2_val == 13, 
// opcode: sra16 ; op1:x8; op2:x8; dest:x8; op1val:0x02fff8;  op2val:0xd
TEST_RR_OP(sra16, x8, x8, x8, 0x00000000, 0x02fff8, 0xd, x6, 12, x15)

inst_4:
// rs2 == rd != rs1, rs1==x9, rs2==x28, rd==x28, rs2_val == 14, rs1_h1_val == 512
// opcode: sra16 ; op1:x9; op2:x28; dest:x28; op1val:0x200fff8;  op2val:0xe
TEST_RR_OP(sra16, x28, x9, x28, 0x00000000, 0x200fff8, 0xe, x6, 16, x15)

inst_5:
// rs1==x1, rs2==x12, rd==x17, rs2_val == 8, rs1_h0_val == -33, rs1_h1_val == -65
// opcode: sra16 ; op1:x1; op2:x12; dest:x17; op1val:0xffbfffdf;  op2val:0x8
TEST_RR_OP(sra16, x17, x1, x12, 0x00000000, 0xffbfffdf, 0x8, x6, 20, x15)

inst_6:
// rs1==x26, rs2==x4, rd==x16, rs2_val == 4, rs1_h1_val == 2048
// opcode: sra16 ; op1:x26; op2:x4; dest:x16; op1val:0x8003fff;  op2val:0x4
TEST_RR_OP(sra16, x16, x26, x4, 0x00000000, 0x8003fff, 0x4, x6, 24, x15)

inst_7:
// rs1==x11, rs2==x17, rd==x21, rs2_val == 2, rs1_h1_val == 21845, rs1_h0_val == 4096
// opcode: sra16 ; op1:x11; op2:x17; dest:x21; op1val:0x55551000;  op2val:0x2
TEST_RR_OP(sra16, x21, x11, x17, 0x00000000, 0x55551000, 0x2, x6, 28, x15)

inst_8:
// rs1==x31, rs2==x11, rd==x9, rs2_val == 1, rs1_h1_val == 4, rs1_h0_val == 1024
// opcode: sra16 ; op1:x31; op2:x11; dest:x9; op1val:0x040400;  op2val:0x1
TEST_RR_OP(sra16, x9, x31, x11, 0x00000000, 0x040400, 0x1, x6, 32, x15)

inst_9:
// rs1==x10, rs2==x25, rd==x13, rs1_h1_val == -21846, 
// opcode: sra16 ; op1:x10; op2:x25; dest:x13; op1val:0xaaaa0006;  op2val:0x12
TEST_RR_OP(sra16, x13, x10, x25, 0x00000000, 0xaaaa0006, 0x12, x6, 36, x15)

inst_10:
// rs1==x14, rs2==x18, rd==x0, rs1_h1_val == 32767, 
// opcode: sra16 ; op1:x14; op2:x18; dest:x0; op1val:0x7ffffff6;  op2val:0xb
TEST_RR_OP(sra16, x0, x14, x18, 0x00000000, 0x7ffffff6, 0xb, x6, 40, x15)

inst_11:
// rs1==x2, rs2==x1, rd==x22, rs1_h1_val == -16385, 
// opcode: sra16 ; op1:x2; op2:x1; dest:x22; op1val:0xbffffffc;  op2val:0x9
TEST_RR_OP(sra16, x22, x2, x1, 0x00000000, 0xbffffffc, 0x9, x6, 44, x15)

inst_12:
// rs1==x17, rs2==x31, rd==x25, rs1_h1_val == -8193, rs1_h0_val == 32
// opcode: sra16 ; op1:x17; op2:x31; dest:x25; op1val:0xdfff0020;  op2val:0x8
TEST_RR_OP(sra16, x25, x17, x31, 0x00000000, 0xdfff0020, 0x8, x6, 48, x15)

inst_13:
// rs1==x23, rs2==x7, rd==x31, rs1_h1_val == -4097, rs1_h0_val == 256
// opcode: sra16 ; op1:x23; op2:x7; dest:x31; op1val:0xefff0100;  op2val:0x10
TEST_RR_OP(sra16, x31, x23, x7, 0x00000000, 0xefff0100, 0x10, x6, 52, x15)

inst_14:
// rs1==x22, rs2==x3, rd==x26, rs1_h1_val == -2049, rs1_h0_val == 8192
// opcode: sra16 ; op1:x22; op2:x3; dest:x26; op1val:0xf7ff2000;  op2val:0x13
TEST_RR_OP(sra16, x26, x22, x3, 0x00000000, 0xf7ff2000, 0x13, x6, 56, x9)

inst_15:
// rs1==x0, rs2==x30, rd==x10, rs1_h1_val == -513, rs1_h0_val == 2048
// opcode: sra16 ; op1:x0; op2:x30; dest:x10; op1val:0xfdff0800;  op2val:0x10
TEST_RR_OP(sra16, x10, x0, x30, 0x00000000, 0xfdff0800, 0x10, x6, 60, x9)

inst_16:
// rs1==x13, rs2==x20, rd==x7, rs1_h1_val == -257, 
// opcode: sra16 ; op1:x13; op2:x20; dest:x7; op1val:0xfeffffdf;  op2val:0x4
TEST_RR_OP(sra16, x7, x13, x20, 0x00000000, 0xfeffffdf, 0x4, x6, 64, x9)

inst_17:
// rs1==x27, rs2==x10, rd==x23, rs1_h1_val == -129, rs1_h0_val == 8
// opcode: sra16 ; op1:x27; op2:x10; dest:x23; op1val:0xff7f0008;  op2val:0xb
TEST_RR_OP(sra16, x23, x27, x10, 0x00000000, 0xff7f0008, 0xb, x6, 68, x9)
RVTEST_SIGBASE(x8,signature_x8_0)

inst_18:
// rs1==x4, rs2==x24, rd==x27, rs1_h1_val == -33, rs1_h0_val == 0
// opcode: sra16 ; op1:x4; op2:x24; dest:x27; op1val:0xffdf0000;  op2val:0x7
TEST_RR_OP(sra16, x27, x4, x24, 0x00000000, 0xffdf0000, 0x7, x8, 0, x9)

inst_19:
// rs1==x29, rs2==x0, rd==x4, rs1_h1_val == -17, 
// opcode: sra16 ; op1:x29; op2:x0; dest:x4; op1val:0xffef0005;  op2val:0x0
TEST_RR_OP(sra16, x4, x29, x0, 0x00000000, 0xffef0005, 0x0, x8, 4, x9)

inst_20:
// rs1==x7, rs2==x14, rd==x29, rs1_h1_val == -9, rs1_h0_val == -513
// opcode: sra16 ; op1:x7; op2:x14; dest:x29; op1val:0xfff7fdff;  op2val:0x5
TEST_RR_OP(sra16, x29, x7, x14, 0x00000000, 0xfff7fdff, 0x5, x8, 8, x9)

inst_21:
// rs1==x6, rs2==x19, rd==x2, rs1_h1_val == -5, rs1_h0_val == -129
// opcode: sra16 ; op1:x6; op2:x19; dest:x2; op1val:0xfffbff7f;  op2val:0x11
TEST_RR_OP(sra16, x2, x6, x19, 0x00000000, 0xfffbff7f, 0x11, x8, 12, x9)

inst_22:
// rs1==x3, rs2==x23, rd==x14, rs1_h1_val == -3, 
// opcode: sra16 ; op1:x3; op2:x23; dest:x14; op1val:0xfffd0007;  op2val:0xe
TEST_RR_OP(sra16, x14, x3, x23, 0x00000000, 0xfffd0007, 0xe, x8, 16, x9)

inst_23:
// rs1==x25, rs2==x21, rd==x5, rs1_h1_val == -2, rs2_val == 10
// opcode: sra16 ; op1:x25; op2:x21; dest:x5; op1val:0xfffe1000;  op2val:0xa
TEST_RR_OP(sra16, x5, x25, x21, 0x00000000, 0xfffe1000, 0xa, x8, 20, x9)

inst_24:
// rs1==x18, rs2==x22, rd==x15, rs1_h1_val == -32768, 
// opcode: sra16 ; op1:x18; op2:x22; dest:x15; op1val:0x80000000;  op2val:0x2
TEST_RR_OP(sra16, x15, x18, x22, 0x00000000, 0x80000000, 0x2, x8, 24, x9)

inst_25:
// rs1==x12, rs2==x2, rd==x1, rs1_h1_val == 16384, rs1_h0_val == -4097
// opcode: sra16 ; op1:x12; op2:x2; dest:x1; op1val:0x4000efff;  op2val:0xf
TEST_RR_OP(sra16, x1, x12, x2, 0x00000000, 0x4000efff, 0xf, x8, 28, x9)

inst_26:
// rs1==x24, rs2==x6, rd==x11, rs1_h1_val == 8192, rs1_h0_val == 16
// opcode: sra16 ; op1:x24; op2:x6; dest:x11; op1val:0x20000010;  op2val:0x10
TEST_RR_OP(sra16, x11, x24, x6, 0x00000000, 0x20000010, 0x10, x8, 32, x9)

inst_27:
// rs1==x16, rs2==x13, rd==x18, rs1_h1_val == 4096, 
// opcode: sra16 ; op1:x16; op2:x13; dest:x18; op1val:0x10000020;  op2val:0xf
TEST_RR_OP(sra16, x18, x16, x13, 0x00000000, 0x10000020, 0xf, x8, 36, x9)

inst_28:
// rs1==x15, rs2==x27, rd==x19, rs1_h1_val == 1024, rs1_h0_val == -5
// opcode: sra16 ; op1:x15; op2:x27; dest:x19; op1val:0x400fffb;  op2val:0x1
TEST_RR_OP(sra16, x19, x15, x27, 0x00000000, 0x400fffb, 0x1, x8, 40, x1)

inst_29:
// rs1==x28, rs2==x16, rd==x12, rs1_h0_val == 16384, 
// opcode: sra16 ; op1:x28; op2:x16; dest:x12; op1val:0x034000;  op2val:0x12
TEST_RR_OP(sra16, x12, x28, x16, 0x00000000, 0x034000, 0x12, x8, 44, x1)

inst_30:
// rs1==x30, rs2==x15, rd==x24, rs1_h0_val == 512, 
// opcode: sra16 ; op1:x30; op2:x15; dest:x24; op1val:0xffef0200;  op2val:0x12
TEST_RR_OP(sra16, x24, x30, x15, 0x00000000, 0xffef0200, 0x12, x8, 48, x1)

inst_31:
// rs1==x19, rs2==x9, rd==x6, rs1_h0_val == 128, rs1_h1_val == 8
// opcode: sra16 ; op1:x19; op2:x9; dest:x6; op1val:0x080080;  op2val:0x8
TEST_RR_OP(sra16, x6, x19, x9, 0x00000000, 0x080080, 0x8, x8, 52, x1)

inst_32:
// rs1_h0_val == 64, 
// opcode: sra16 ; op1:x30; op2:x29; dest:x31; op1val:0x10000040;  op2val:0xd
TEST_RR_OP(sra16, x31, x30, x29, 0x00000000, 0x10000040, 0xd, x8, 56, x1)

inst_33:
// rs1_h0_val == 4, 
// opcode: sra16 ; op1:x30; op2:x29; dest:x31; op1val:0xbfff0004;  op2val:0x4
TEST_RR_OP(sra16, x31, x30, x29, 0x00000000, 0xbfff0004, 0x4, x8, 60, x1)

inst_34:
// rs1_h0_val == 2, rs1_h1_val == 128
// opcode: sra16 ; op1:x30; op2:x29; dest:x31; op1val:0x800002;  op2val:0x12
TEST_RR_OP(sra16, x31, x30, x29, 0x00000000, 0x800002, 0x12, x8, 64, x1)

inst_35:
// rs1_h0_val == 1, 
// opcode: sra16 ; op1:x30; op2:x29; dest:x31; op1val:0x20000001;  op2val:0xc
TEST_RR_OP(sra16, x31, x30, x29, 0x00000000, 0x20000001, 0xc, x8, 68, x1)

inst_36:
// rs1_h0_val == -1, 
// opcode: sra16 ; op1:x30; op2:x29; dest:x31; op1val:0x09ffff;  op2val:0xb
TEST_RR_OP(sra16, x31, x30, x29, 0x00000000, 0x09ffff, 0xb, x8, 72, x1)

inst_37:
// rs1_h1_val == 256, 
// opcode: sra16 ; op1:x30; op2:x29; dest:x31; op1val:0x100fff9;  op2val:0x5
TEST_RR_OP(sra16, x31, x30, x29, 0x00000000, 0x100fff9, 0x5, x8, 76, x1)

inst_38:
// rs1_h1_val == 64, 
// opcode: sra16 ; op1:x30; op2:x29; dest:x31; op1val:0x400080;  op2val:0xb
TEST_RR_OP(sra16, x31, x30, x29, 0x00000000, 0x400080, 0xb, x8, 80, x1)

inst_39:
// rs1_h1_val == 32, rs1_h0_val == -257
// opcode: sra16 ; op1:x30; op2:x29; dest:x31; op1val:0x20feff;  op2val:0x0
TEST_RR_OP(sra16, x31, x30, x29, 0x00000000, 0x20feff, 0x0, x8, 84, x1)

inst_40:
// rs1_h1_val == 16, rs1_h0_val == -1025
// opcode: sra16 ; op1:x30; op2:x29; dest:x31; op1val:0x10fbff;  op2val:0x12
TEST_RR_OP(sra16, x31, x30, x29, 0x00000000, 0x10fbff, 0x12, x8, 88, x1)

inst_41:
// rs1_h1_val == 1, 
// opcode: sra16 ; op1:x30; op2:x29; dest:x31; op1val:0x01fff6;  op2val:0x7
TEST_RR_OP(sra16, x31, x30, x29, 0x00000000, 0x01fff6, 0x7, x8, 92, x1)

inst_42:
// rs1_h1_val == 0, 
// opcode: sra16 ; op1:x30; op2:x29; dest:x31; op1val:0x000006;  op2val:0xb
TEST_RR_OP(sra16, x31, x30, x29, 0x00000000, 0x000006, 0xb, x8, 96, x1)

inst_43:
// rs1_h1_val == -1, 
// opcode: sra16 ; op1:x30; op2:x29; dest:x31; op1val:0xffff0005;  op2val:0x9
TEST_RR_OP(sra16, x31, x30, x29, 0x00000000, 0xffff0005, 0x9, x8, 100, x1)

inst_44:
// rs1_h0_val == -21846, 
// opcode: sra16 ; op1:x30; op2:x29; dest:x31; op1val:0xfffdaaaa;  op2val:0x2
TEST_RR_OP(sra16, x31, x30, x29, 0x00000000, 0xfffdaaaa, 0x2, x8, 104, x1)

inst_45:
// rs1_h0_val == 21845, 
// opcode: sra16 ; op1:x30; op2:x29; dest:x31; op1val:0x2005555;  op2val:0x10
TEST_RR_OP(sra16, x31, x30, x29, 0x00000000, 0x2005555, 0x10, x8, 108, x1)

inst_46:
// rs1_h0_val == -16385, 
// opcode: sra16 ; op1:x30; op2:x29; dest:x31; op1val:0xffdfbfff;  op2val:0x8
TEST_RR_OP(sra16, x31, x30, x29, 0x00000000, 0xffdfbfff, 0x8, x8, 112, x1)

inst_47:
// rs1_h0_val == -8193, 
// opcode: sra16 ; op1:x30; op2:x29; dest:x31; op1val:0xfffedfff;  op2val:0x11
TEST_RR_OP(sra16, x31, x30, x29, 0x00000000, 0xfffedfff, 0x11, x8, 116, x1)

inst_48:
// rs1_h0_val == -2049, 
// opcode: sra16 ; op1:x30; op2:x29; dest:x31; op1val:0x09f7ff;  op2val:0x11
TEST_RR_OP(sra16, x31, x30, x29, 0x00000000, 0x09f7ff, 0x11, x8, 120, x1)

inst_49:
// rs1_h0_val == -65, 
// opcode: sra16 ; op1:x30; op2:x29; dest:x31; op1val:0x02ffbf;  op2val:0x1
TEST_RR_OP(sra16, x31, x30, x29, 0x00000000, 0x02ffbf, 0x1, x8, 124, x1)

inst_50:
// rs1_h0_val == -17, 
// opcode: sra16 ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaffef;  op2val:0x7
TEST_RR_OP(sra16, x31, x30, x29, 0x00000000, 0xaaaaffef, 0x7, x8, 128, x1)

inst_51:
// rs1_h0_val == -9, 
// opcode: sra16 ; op1:x30; op2:x29; dest:x31; op1val:0x01fff7;  op2val:0x12
TEST_RR_OP(sra16, x31, x30, x29, 0x00000000, 0x01fff7, 0x12, x8, 132, x1)

inst_52:
// rs1_h0_val == -3, 
// opcode: sra16 ; op1:x30; op2:x29; dest:x31; op1val:0x02fffd;  op2val:0x3
TEST_RR_OP(sra16, x31, x30, x29, 0x00000000, 0x02fffd, 0x3, x8, 136, x1)

inst_53:
// rs1_h0_val == -2, 
// opcode: sra16 ; op1:x30; op2:x29; dest:x31; op1val:0x800fffe;  op2val:0xf
TEST_RR_OP(sra16, x31, x30, x29, 0x00000000, 0x800fffe, 0xf, x8, 140, x1)

inst_54:
// rs1_h0_val == -32768, 
// opcode: sra16 ; op1:x30; op2:x29; dest:x31; op1val:0xfff78000;  op2val:0x6
TEST_RR_OP(sra16, x31, x30, x29, 0x00000000, 0xfff78000, 0x6, x8, 144, x1)

inst_55:
// rs2_val == 7, rs1_h1_val == -1025, rs1_h0_val == 32767
// opcode: sra16 ; op1:x30; op2:x29; dest:x31; op1val:0xfbff7fff;  op2val:0x7
TEST_RR_OP(sra16, x31, x30, x29, 0x00000000, 0xfbff7fff, 0x7, x8, 148, x1)

inst_56:
// rs1_h1_val == 32767, 
// opcode: sra16 ; op1:x30; op2:x29; dest:x31; op1val:0x7ffffff6;  op2val:0xb
TEST_RR_OP(sra16, x31, x30, x29, 0x00000000, 0x7ffffff6, 0xb, x8, 152, x1)

inst_57:
// rs1_h1_val == -513, rs1_h0_val == 2048
// opcode: sra16 ; op1:x30; op2:x29; dest:x31; op1val:0xfdff0800;  op2val:0x10
TEST_RR_OP(sra16, x31, x30, x29, 0x00000000, 0xfdff0800, 0x10, x8, 156, x1)
#endif


RVTEST_CODE_END
RVMODEL_HALT

RVTEST_DATA_BEGIN
.align 4
rvtest_data:
.word 0xbabecafe
.word 0xabecafeb
.word 0xbecafeba
.word 0xecafebab
RVTEST_DATA_END

RVMODEL_DATA_BEGIN


signature_x6_0:
    .fill 0*(XLEN/32),4,0xdeadbeef


signature_x6_1:
    .fill 18*(XLEN/32),4,0xdeadbeef


signature_x8_0:
    .fill 40*(XLEN/32),4,0xdeadbeef

#ifdef rvtest_mtrap_routine

mtrap_sigptr:
    .fill 64*(XLEN/32),4,0xdeadbeef

#endif

#ifdef rvtest_gpr_save

gpr_save:
    .fill 32*(XLEN/32),4,0xdeadbeef

#endif

RVMODEL_DATA_END
