
// -----------
// This file was generated by riscv_ctg (https://github.com/riscv-software-src/riscv-ctg)
// version   : 0.6.3
// timestamp : Sat Apr 23 14:53:29 2022 GMT
// usage     : riscv_ctg \
//                  --cgf /scratch/git-repo/github/riscv_ctg/sample_cgfs/dataset.cgf \
//                  --cgf /scratch/git-repo/github/riscv_ctg/sample_cgfs/rv32ip.cgf \
//                  --xlen 32  \
//                  --randomize \
// -----------
//
// -----------
// Copyright (c) 2020. RISC-V International. All rights reserved.
// SPDX-License-Identifier: BSD-3-Clause
// -----------
//
// This assembly file tests the srai.u instruction of the RISC-V RV32PZicsr extension for the srai.u covergroup.
// 
#include "model_test.h"
#include "arch_test.h"
RVTEST_ISA("RV32IPZicsr")

.section .text.init
.org 0x80
.globl rvtest_entry_point
rvtest_entry_point:
RVMODEL_BOOT
RVTEST_CODE_BEGIN

#ifdef TEST_CASE_1

RVTEST_CASE(0,"//check ISA:=regex(.*32.*);check ISA:=regex(.*I.*P.*Zicsr.*);def TEST_CASE_1=True;",srai.u)

RVTEST_VXSAT_ENABLE()
RVTEST_SIGBASE(x14,signature_x14_1)

inst_0:
// rs1 != rd, rs1==x15, rd==x10, imm_val == 21, rs1_val == 536870912
// opcode: srai.u ; op1:x15; dest:x10; op1val:0x20000000;  immval:0x15
TEST_IMM_OP( srai.u, x10, x15, 0x00000000, 0x20000000, 0x15, x14, 0, x25)

inst_1:
// rs1 == rd, rs1==x24, rd==x24, rs1_val == 2147483647, 
// opcode: srai.u ; op1:x24; dest:x24; op1val:0x7fffffff;  immval:0x5
TEST_IMM_OP( srai.u, x24, x24, 0x00000000, 0x7fffffff, 0x5, x14, 4, x25)

inst_2:
// rs1==x31, rd==x20, rs1_val == -1073741825, imm_val == 29
// opcode: srai.u ; op1:x31; dest:x20; op1val:-0x40000001;  immval:0x1d
TEST_IMM_OP( srai.u, x20, x31, 0x00000000, -0x40000001, 0x1d, x14, 8, x25)

inst_3:
// rs1==x8, rd==x7, rs1_val == -536870913, 
// opcode: srai.u ; op1:x8; dest:x7; op1val:-0x20000001;  immval:0x9
TEST_IMM_OP( srai.u, x7, x8, 0x00000000, -0x20000001, 0x9, x14, 12, x25)

inst_4:
// rs1==x11, rd==x22, rs1_val == -268435457, 
// opcode: srai.u ; op1:x11; dest:x22; op1val:-0x10000001;  immval:0x1a
TEST_IMM_OP( srai.u, x22, x11, 0x00000000, -0x10000001, 0x1a, x14, 16, x25)

inst_5:
// rs1==x2, rd==x18, rs1_val == -134217729, imm_val == 4
// opcode: srai.u ; op1:x2; dest:x18; op1val:-0x8000001;  immval:0x4
TEST_IMM_OP( srai.u, x18, x2, 0x00000000, -0x8000001, 0x4, x14, 20, x25)

inst_6:
// rs1==x5, rd==x13, rs1_val == -67108865, 
// opcode: srai.u ; op1:x5; dest:x13; op1val:-0x4000001;  immval:0x1f
TEST_IMM_OP( srai.u, x13, x5, 0x00000000, -0x4000001, 0x1f, x14, 24, x25)

inst_7:
// rs1==x18, rd==x19, rs1_val == -33554433, 
// opcode: srai.u ; op1:x18; dest:x19; op1val:-0x2000001;  immval:0x14
TEST_IMM_OP( srai.u, x19, x18, 0x00000000, -0x2000001, 0x14, x14, 28, x25)

inst_8:
// rs1==x20, rd==x5, rs1_val == -16777217, 
// opcode: srai.u ; op1:x20; dest:x5; op1val:-0x1000001;  immval:0x19
TEST_IMM_OP( srai.u, x5, x20, 0x00000000, -0x1000001, 0x19, x14, 32, x25)

inst_9:
// rs1==x17, rd==x21, rs1_val == -8388609, imm_val == 27
// opcode: srai.u ; op1:x17; dest:x21; op1val:-0x800001;  immval:0x1b
TEST_IMM_OP( srai.u, x21, x17, 0x00000000, -0x800001, 0x1b, x14, 36, x25)

inst_10:
// rs1==x12, rd==x27, rs1_val == -4194305, 
// opcode: srai.u ; op1:x12; dest:x27; op1val:-0x400001;  immval:0x5
TEST_IMM_OP( srai.u, x27, x12, 0x00000000, -0x400001, 0x5, x14, 40, x25)

inst_11:
// rs1==x22, rd==x8, rs1_val == -2097153, imm_val == 2
// opcode: srai.u ; op1:x22; dest:x8; op1val:-0x200001;  immval:0x2
TEST_IMM_OP( srai.u, x8, x22, 0x00000000, -0x200001, 0x2, x14, 44, x25)

inst_12:
// rs1==x3, rd==x26, rs1_val == -1048577, 
// opcode: srai.u ; op1:x3; dest:x26; op1val:-0x100001;  immval:0x0
TEST_IMM_OP( srai.u, x26, x3, 0x00000000, -0x100001, 0x0, x14, 48, x25)

inst_13:
// rs1==x4, rd==x23, rs1_val == -524289, 
// opcode: srai.u ; op1:x4; dest:x23; op1val:-0x80001;  immval:0x12
TEST_IMM_OP( srai.u, x23, x4, 0x00000000, -0x80001, 0x12, x14, 52, x25)

inst_14:
// rs1==x28, rd==x9, rs1_val == -262145, 
// opcode: srai.u ; op1:x28; dest:x9; op1val:-0x40001;  immval:0x14
TEST_IMM_OP( srai.u, x9, x28, 0x00000000, -0x40001, 0x14, x14, 56, x25)

inst_15:
// rs1==x1, rd==x6, rs1_val == -131073, imm_val == 15
// opcode: srai.u ; op1:x1; dest:x6; op1val:-0x20001;  immval:0xf
TEST_IMM_OP( srai.u, x6, x1, 0x00000000, -0x20001, 0xf, x14, 60, x25)

inst_16:
// rs1==x16, rd==x0, rs1_val == -65537, 
// opcode: srai.u ; op1:x16; dest:x0; op1val:-0x10001;  immval:0x1b
TEST_IMM_OP( srai.u, x0, x16, 0x00000000, -0x10001, 0x1b, x14, 64, x25)

inst_17:
// rs1==x23, rd==x11, rs1_val == -32769, 
// opcode: srai.u ; op1:x23; dest:x11; op1val:-0x8001;  immval:0x1d
TEST_IMM_OP( srai.u, x11, x23, 0x00000000, -0x8001, 0x1d, x14, 68, x8)

inst_18:
// rs1==x29, rd==x16, rs1_val == -16385, 
// opcode: srai.u ; op1:x29; dest:x16; op1val:-0x4001;  immval:0x14
TEST_IMM_OP( srai.u, x16, x29, 0x00000000, -0x4001, 0x14, x14, 72, x8)
RVTEST_SIGBASE(x5,signature_x5_0)

inst_19:
// rs1==x26, rd==x28, rs1_val == -8193, imm_val == 16
// opcode: srai.u ; op1:x26; dest:x28; op1val:-0x2001;  immval:0x10
TEST_IMM_OP( srai.u, x28, x26, 0x00000000, -0x2001, 0x10, x5, 0, x8)

inst_20:
// rs1==x14, rd==x1, rs1_val == -4097, 
// opcode: srai.u ; op1:x14; dest:x1; op1val:-0x1001;  immval:0x1a
TEST_IMM_OP( srai.u, x1, x14, 0x00000000, -0x1001, 0x1a, x5, 4, x8)

inst_21:
// rs1==x30, rd==x15, rs1_val == -2049, 
// opcode: srai.u ; op1:x30; dest:x15; op1val:-0x801;  immval:0x9
TEST_IMM_OP( srai.u, x15, x30, 0x00000000, -0x801, 0x9, x5, 8, x8)

inst_22:
// rs1==x6, rd==x31, rs1_val == -1025, 
// opcode: srai.u ; op1:x6; dest:x31; op1val:-0x401;  immval:0xc
TEST_IMM_OP( srai.u, x31, x6, 0x00000000, -0x401, 0xc, x5, 12, x8)

inst_23:
// rs1==x25, rd==x4, rs1_val == -513, 
// opcode: srai.u ; op1:x25; dest:x4; op1val:-0x201;  immval:0x16
TEST_IMM_OP( srai.u, x4, x25, 0x00000000, -0x201, 0x16, x5, 16, x8)

inst_24:
// rs1==x19, rd==x29, rs1_val == -257, 
// opcode: srai.u ; op1:x19; dest:x29; op1val:-0x101;  immval:0x1c
TEST_IMM_OP( srai.u, x29, x19, 0x00000000, -0x101, 0x1c, x5, 20, x8)

inst_25:
// rs1==x27, rd==x2, rs1_val == -129, 
// opcode: srai.u ; op1:x27; dest:x2; op1val:-0x81;  immval:0x15
TEST_IMM_OP( srai.u, x2, x27, 0x00000000, -0x81, 0x15, x5, 24, x8)

inst_26:
// rs1==x9, rd==x14, rs1_val == -65, 
// opcode: srai.u ; op1:x9; dest:x14; op1val:-0x41;  immval:0x1f
TEST_IMM_OP( srai.u, x14, x9, 0x00000000, -0x41, 0x1f, x5, 28, x8)

inst_27:
// rs1==x7, rd==x3, rs1_val == -33, imm_val == 30
// opcode: srai.u ; op1:x7; dest:x3; op1val:-0x21;  immval:0x1e
TEST_IMM_OP( srai.u, x3, x7, 0x00000000, -0x21, 0x1e, x5, 32, x8)

inst_28:
// rs1==x13, rd==x17, rs1_val == -17, 
// opcode: srai.u ; op1:x13; dest:x17; op1val:-0x11;  immval:0xd
TEST_IMM_OP( srai.u, x17, x13, 0x00000000, -0x11, 0xd, x5, 36, x8)

inst_29:
// rs1==x21, rd==x12, rs1_val == -9, 
// opcode: srai.u ; op1:x21; dest:x12; op1val:-0x9;  immval:0xe
TEST_IMM_OP( srai.u, x12, x21, 0x00000000, -0x9, 0xe, x5, 40, x8)

inst_30:
// rs1==x0, rd==x30, rs1_val == -5, 
// opcode: srai.u ; op1:x0; dest:x30; op1val:0x0;  immval:0x9
TEST_IMM_OP( srai.u, x30, x0, 0x00000000, 0x0, 0x9, x5, 44, x8)

inst_31:
// rs1==x10, rd==x25, rs1_val == -3, 
// opcode: srai.u ; op1:x10; dest:x25; op1val:-0x3;  immval:0xd
TEST_IMM_OP( srai.u, x25, x10, 0x00000000, -0x3, 0xd, x5, 48, x8)

inst_32:
// rs1_val == -2, 
// opcode: srai.u ; op1:x30; dest:x31; op1val:-0x2;  immval:0x4
TEST_IMM_OP( srai.u, x31, x30, 0x00000000, -0x2, 0x4, x5, 52, x8)

inst_33:
// imm_val == 23, rs1_val == 8388608
// opcode: srai.u ; op1:x30; dest:x31; op1val:0x800000;  immval:0x17
TEST_IMM_OP( srai.u, x31, x30, 0x00000000, 0x800000, 0x17, x5, 56, x8)

inst_34:
// rs1_val == -2147483648, 
// opcode: srai.u ; op1:x30; dest:x31; op1val:-0x80000000;  immval:0x1e
TEST_IMM_OP( srai.u, x31, x30, 0x00000000, -0x80000000, 0x1e, x5, 60, x8)

inst_35:
// rs1_val == 1073741824, 
// opcode: srai.u ; op1:x30; dest:x31; op1val:0x40000000;  immval:0x3
TEST_IMM_OP( srai.u, x31, x30, 0x00000000, 0x40000000, 0x3, x5, 64, x8)

inst_36:
// rs1_val == 268435456, imm_val == 8
// opcode: srai.u ; op1:x30; dest:x31; op1val:0x10000000;  immval:0x8
TEST_IMM_OP( srai.u, x31, x30, 0x00000000, 0x10000000, 0x8, x5, 68, x8)

inst_37:
// rs1_val == 134217728, 
// opcode: srai.u ; op1:x30; dest:x31; op1val:0x8000000;  immval:0x4
TEST_IMM_OP( srai.u, x31, x30, 0x00000000, 0x8000000, 0x4, x5, 72, x8)

inst_38:
// rs1_val == 32, 
// opcode: srai.u ; op1:x30; dest:x31; op1val:0x20;  immval:0x14
TEST_IMM_OP( srai.u, x31, x30, 0x00000000, 0x20, 0x14, x5, 76, x8)

inst_39:
// rs1_val == 16, imm_val == 1
// opcode: srai.u ; op1:x30; dest:x31; op1val:0x10;  immval:0x1
TEST_IMM_OP( srai.u, x31, x30, 0x00000000, 0x10, 0x1, x5, 80, x8)

inst_40:
// rs1_val == 8, 
// opcode: srai.u ; op1:x30; dest:x31; op1val:0x8;  immval:0xb
TEST_IMM_OP( srai.u, x31, x30, 0x00000000, 0x8, 0xb, x5, 84, x8)

inst_41:
// rs1_val == 4, 
// opcode: srai.u ; op1:x30; dest:x31; op1val:0x4;  immval:0x19
TEST_IMM_OP( srai.u, x31, x30, 0x00000000, 0x4, 0x19, x5, 88, x8)

inst_42:
// rs1_val == 2, 
// opcode: srai.u ; op1:x30; dest:x31; op1val:0x2;  immval:0xf
TEST_IMM_OP( srai.u, x31, x30, 0x00000000, 0x2, 0xf, x5, 92, x8)

inst_43:
// rs1_val == 1, 
// opcode: srai.u ; op1:x30; dest:x31; op1val:0x1;  immval:0x1c
TEST_IMM_OP( srai.u, x31, x30, 0x00000000, 0x1, 0x1c, x5, 96, x8)

inst_44:
// rs1_val == -1431655766, 
// opcode: srai.u ; op1:x30; dest:x31; op1val:-0x55555556;  immval:0xf
TEST_IMM_OP( srai.u, x31, x30, 0x00000000, -0x55555556, 0xf, x5, 100, x8)

inst_45:
// rs1_val == 1431655765, 
// opcode: srai.u ; op1:x30; dest:x31; op1val:0x55555555;  immval:0x12
TEST_IMM_OP( srai.u, x31, x30, 0x00000000, 0x55555555, 0x12, x5, 104, x8)

inst_46:
// imm_val == 10, 
// opcode: srai.u ; op1:x30; dest:x31; op1val:0x2;  immval:0xa
TEST_IMM_OP( srai.u, x31, x30, 0x00000000, 0x2, 0xa, x5, 108, x8)

inst_47:
// rs1_val == 67108864, 
// opcode: srai.u ; op1:x30; dest:x31; op1val:0x4000000;  immval:0x1a
TEST_IMM_OP( srai.u, x31, x30, 0x00000000, 0x4000000, 0x1a, x5, 112, x8)

inst_48:
// rs1_val == 33554432, 
// opcode: srai.u ; op1:x30; dest:x31; op1val:0x2000000;  immval:0xa
TEST_IMM_OP( srai.u, x31, x30, 0x00000000, 0x2000000, 0xa, x5, 116, x8)

inst_49:
// rs1_val == 16777216, 
// opcode: srai.u ; op1:x30; dest:x31; op1val:0x1000000;  immval:0xd
TEST_IMM_OP( srai.u, x31, x30, 0x00000000, 0x1000000, 0xd, x5, 120, x8)

inst_50:
// rs1_val == 4194304, 
// opcode: srai.u ; op1:x30; dest:x31; op1val:0x400000;  immval:0x1e
TEST_IMM_OP( srai.u, x31, x30, 0x00000000, 0x400000, 0x1e, x5, 124, x8)

inst_51:
// rs1_val == 2097152, 
// opcode: srai.u ; op1:x30; dest:x31; op1val:0x200000;  immval:0x12
TEST_IMM_OP( srai.u, x31, x30, 0x00000000, 0x200000, 0x12, x5, 128, x8)

inst_52:
// rs1_val == 1048576, 
// opcode: srai.u ; op1:x30; dest:x31; op1val:0x100000;  immval:0x14
TEST_IMM_OP( srai.u, x31, x30, 0x00000000, 0x100000, 0x14, x5, 132, x8)

inst_53:
// rs1_val == 524288, 
// opcode: srai.u ; op1:x30; dest:x31; op1val:0x80000;  immval:0x4
TEST_IMM_OP( srai.u, x31, x30, 0x00000000, 0x80000, 0x4, x5, 136, x8)

inst_54:
// rs1_val == 262144, 
// opcode: srai.u ; op1:x30; dest:x31; op1val:0x40000;  immval:0x12
TEST_IMM_OP( srai.u, x31, x30, 0x00000000, 0x40000, 0x12, x5, 140, x8)

inst_55:
// rs1_val == 131072, 
// opcode: srai.u ; op1:x30; dest:x31; op1val:0x20000;  immval:0x12
TEST_IMM_OP( srai.u, x31, x30, 0x00000000, 0x20000, 0x12, x5, 144, x8)

inst_56:
// rs1_val == 65536, 
// opcode: srai.u ; op1:x30; dest:x31; op1val:0x10000;  immval:0x9
TEST_IMM_OP( srai.u, x31, x30, 0x00000000, 0x10000, 0x9, x5, 148, x8)

inst_57:
// rs1_val == 32768, 
// opcode: srai.u ; op1:x30; dest:x31; op1val:0x8000;  immval:0x1a
TEST_IMM_OP( srai.u, x31, x30, 0x00000000, 0x8000, 0x1a, x5, 152, x8)

inst_58:
// rs1_val == 16384, 
// opcode: srai.u ; op1:x30; dest:x31; op1val:0x4000;  immval:0xf
TEST_IMM_OP( srai.u, x31, x30, 0x00000000, 0x4000, 0xf, x5, 156, x8)

inst_59:
// rs1_val == 8192, 
// opcode: srai.u ; op1:x30; dest:x31; op1val:0x2000;  immval:0x15
TEST_IMM_OP( srai.u, x31, x30, 0x00000000, 0x2000, 0x15, x5, 160, x8)

inst_60:
// rs1_val == 4096, 
// opcode: srai.u ; op1:x30; dest:x31; op1val:0x1000;  immval:0xb
TEST_IMM_OP( srai.u, x31, x30, 0x00000000, 0x1000, 0xb, x5, 164, x8)

inst_61:
// rs1_val == 2048, 
// opcode: srai.u ; op1:x30; dest:x31; op1val:0x800;  immval:0xb
TEST_IMM_OP( srai.u, x31, x30, 0x00000000, 0x800, 0xb, x5, 168, x8)

inst_62:
// rs1_val == 1024, 
// opcode: srai.u ; op1:x30; dest:x31; op1val:0x400;  immval:0x6
TEST_IMM_OP( srai.u, x31, x30, 0x00000000, 0x400, 0x6, x5, 172, x8)

inst_63:
// rs1_val == 512, 
// opcode: srai.u ; op1:x30; dest:x31; op1val:0x200;  immval:0xf
TEST_IMM_OP( srai.u, x31, x30, 0x00000000, 0x200, 0xf, x5, 176, x8)

inst_64:
// rs1_val == 256, 
// opcode: srai.u ; op1:x30; dest:x31; op1val:0x100;  immval:0x18
TEST_IMM_OP( srai.u, x31, x30, 0x00000000, 0x100, 0x18, x5, 180, x8)

inst_65:
// rs1_val == 128, 
// opcode: srai.u ; op1:x30; dest:x31; op1val:0x80;  immval:0x12
TEST_IMM_OP( srai.u, x31, x30, 0x00000000, 0x80, 0x12, x5, 184, x8)

inst_66:
// rs1_val == 64, 
// opcode: srai.u ; op1:x30; dest:x31; op1val:0x40;  immval:0x1e
TEST_IMM_OP( srai.u, x31, x30, 0x00000000, 0x40, 0x1e, x5, 188, x8)

inst_67:
// rs1_val == -65537, 
// opcode: srai.u ; op1:x30; dest:x31; op1val:-0x10001;  immval:0x1b
TEST_IMM_OP( srai.u, x31, x30, 0x00000000, -0x10001, 0x1b, x5, 192, x8)

inst_68:
// rs1_val == -5, 
// opcode: srai.u ; op1:x30; dest:x31; op1val:-0x5;  immval:0x9
TEST_IMM_OP( srai.u, x31, x30, 0x00000000, -0x5, 0x9, x5, 196, x8)
#endif


RVTEST_CODE_END
RVMODEL_HALT

RVTEST_DATA_BEGIN
.align 4
rvtest_data:
.word 0xbabecafe
.word 0xabecafeb
.word 0xbecafeba
.word 0xecafebab
RVTEST_DATA_END

RVMODEL_DATA_BEGIN


signature_x14_0:
    .fill 0*(XLEN/32),4,0xdeadbeef


signature_x14_1:
    .fill 19*(XLEN/32),4,0xdeadbeef


signature_x5_0:
    .fill 50*(XLEN/32),4,0xdeadbeef

#ifdef rvtest_mtrap_routine

mtrap_sigptr:
    .fill 64*(XLEN/32),4,0xdeadbeef

#endif

#ifdef rvtest_gpr_save

gpr_save:
    .fill 32*(XLEN/32),4,0xdeadbeef

#endif

RVMODEL_DATA_END
