
// -----------
// This file was generated by riscv_ctg (https://github.com/riscv-software-src/riscv-ctg)
// version   : 0.6.3
// timestamp : Sat Apr 23 14:53:29 2022 GMT
// usage     : riscv_ctg \
//                  --cgf /scratch/git-repo/github/riscv_ctg/sample_cgfs/dataset.cgf \
//                  --cgf /scratch/git-repo/github/riscv_ctg/sample_cgfs/rv32ip.cgf \
//                  --xlen 32  \
//                  --randomize \
// -----------
//
// -----------
// Copyright (c) 2020. RISC-V International. All rights reserved.
// SPDX-License-Identifier: BSD-3-Clause
// -----------
//
// This assembly file tests the srl16.u instruction of the RISC-V RV32PZicsr extension for the srl16.u covergroup.
// 
#include "model_test.h"
#include "arch_test.h"
RVTEST_ISA("RV32IPZicsr")

.section .text.init
.org 0x80
.globl rvtest_entry_point
rvtest_entry_point:
RVMODEL_BOOT
RVTEST_CODE_BEGIN

#ifdef TEST_CASE_1

RVTEST_CASE(0,"//check ISA:=regex(.*32.*);check ISA:=regex(.*I.*P.*Zicsr.*);def TEST_CASE_1=True;",srl16.u)

RVTEST_VXSAT_ENABLE()
RVTEST_SIGBASE(x11,signature_x11_1)

inst_0:
// rs1 != rs2  and rs1 != rd and rs2 != rd, rs1==x0, rs2==x14, rd==x8, rs2_val == 5, rs1_h0_val == 64
// opcode: srl16.u ; op1:x0; op2:x14; dest:x8; op1val:0x0b0040;  op2val:0x5
TEST_RR_OP(srl16.u, x8, x0, x14, 0x00000000, 0x0b0040, 0x5, x11, 0, x17)

inst_1:
// rs1 == rs2 != rd, rs1==x4, rs2==x4, rd==x10, rs2_val == 7, 
// opcode: srl16.u ; op1:x4; op2:x4; dest:x10; op1val:0x030006;  op2val:0x7
TEST_RR_OP(srl16.u, x10, x4, x4, 0x00000000, 0x030006, 0x7, x11, 4, x17)

inst_2:
// rs1 == rd != rs2, rs1==x31, rs2==x2, rd==x31, rs2_val == 11, rs1_h0_val == 16, rs1_h1_val == 8192
// opcode: srl16.u ; op1:x31; op2:x2; dest:x31; op1val:0x20000010;  op2val:0xb
TEST_RR_OP(srl16.u, x31, x31, x2, 0x00000000, 0x20000010, 0xb, x11, 8, x17)

inst_3:
// rs1 == rs2 == rd, rs1==x27, rs2==x27, rd==x27, rs2_val == 13, rs1_h1_val == 65407, rs1_h0_val == 4
// opcode: srl16.u ; op1:x27; op2:x27; dest:x27; op1val:0xff7f0004;  op2val:0xd
TEST_RR_OP(srl16.u, x27, x27, x27, 0x00000000, 0xff7f0004, 0xd, x11, 12, x17)

inst_4:
// rs2 == rd != rs1, rs1==x14, rs2==x0, rd==x0, rs2_val == 14, rs1_h1_val == 256
// opcode: srl16.u ; op1:x14; op2:x0; dest:x0; op1val:0x1000004;  op2val:0x0
TEST_RR_OP(srl16.u, x0, x14, x0, 0x00000000, 0x1000004, 0x0, x11, 16, x17)

inst_5:
// rs1==x12, rs2==x24, rd==x1, rs2_val == 8, rs1_h0_val == 2
// opcode: srl16.u ; op1:x12; op2:x24; dest:x1; op1val:0x050002;  op2val:0x8
TEST_RR_OP(srl16.u, x1, x12, x24, 0x00000000, 0x050002, 0x8, x11, 20, x17)

inst_6:
// rs1==x19, rs2==x9, rd==x6, rs2_val == 4, rs1_h0_val == 1024, rs1_h1_val == 16
// opcode: srl16.u ; op1:x19; op2:x9; dest:x6; op1val:0x100400;  op2val:0x4
TEST_RR_OP(srl16.u, x6, x19, x9, 0x00000000, 0x100400, 0x4, x11, 24, x17)

inst_7:
// rs1==x30, rs2==x25, rd==x18, rs2_val == 2, rs1_h1_val == 1024, rs1_h0_val == 1
// opcode: srl16.u ; op1:x30; op2:x25; dest:x18; op1val:0x4000001;  op2val:0x2
TEST_RR_OP(srl16.u, x18, x30, x25, 0x00000000, 0x4000001, 0x2, x11, 28, x17)

inst_8:
// rs1==x9, rs2==x20, rd==x15, rs2_val == 1, 
// opcode: srl16.u ; op1:x9; op2:x20; dest:x15; op1val:0x050040;  op2val:0x1
TEST_RR_OP(srl16.u, x15, x9, x20, 0x00000000, 0x050040, 0x1, x11, 32, x17)

inst_9:
// rs1==x18, rs2==x28, rd==x26, rs1_h1_val == 43690, rs1_h0_val == 65534
// opcode: srl16.u ; op1:x18; op2:x28; dest:x26; op1val:0xaaaafffe;  op2val:0x13
TEST_RR_OP(srl16.u, x26, x18, x28, 0x00000000, 0xaaaafffe, 0x13, x11, 36, x17)

inst_10:
// rs1==x10, rs2==x5, rd==x23, rs1_h1_val == 21845, rs1_h0_val == 0
// opcode: srl16.u ; op1:x10; op2:x5; dest:x23; op1val:0x55550000;  op2val:0x10
TEST_RR_OP(srl16.u, x23, x10, x5, 0x00000000, 0x55550000, 0x10, x11, 40, x17)

inst_11:
// rs1==x7, rs2==x16, rd==x29, rs1_h1_val == 32767, rs1_h0_val == 32
// opcode: srl16.u ; op1:x7; op2:x16; dest:x29; op1val:0x7fff0020;  op2val:0xd
TEST_RR_OP(srl16.u, x29, x7, x16, 0x00000000, 0x7fff0020, 0xd, x11, 44, x17)

inst_12:
// rs1==x1, rs2==x30, rd==x19, rs1_h1_val == 49151, rs1_h0_val == 49151
// opcode: srl16.u ; op1:x1; op2:x30; dest:x19; op1val:0xbfffbfff;  op2val:0x0
TEST_RR_OP(srl16.u, x19, x1, x30, 0x00000000, 0xbfffbfff, 0x0, x11, 48, x17)

inst_13:
// rs1==x13, rs2==x3, rd==x16, rs1_h1_val == 57343, rs1_h0_val == 65279
// opcode: srl16.u ; op1:x13; op2:x3; dest:x16; op1val:0xdffffeff;  op2val:0xb
TEST_RR_OP(srl16.u, x16, x13, x3, 0x00000000, 0xdffffeff, 0xb, x11, 52, x17)
RVTEST_SIGBASE(x16,signature_x16_0)

inst_14:
// rs1==x25, rs2==x26, rd==x28, rs1_h1_val == 61439, rs1_h0_val == 32767
// opcode: srl16.u ; op1:x25; op2:x26; dest:x28; op1val:0xefff7fff;  op2val:0x6
TEST_RR_OP(srl16.u, x28, x25, x26, 0x00000000, 0xefff7fff, 0x6, x16, 0, x19)

inst_15:
// rs1==x2, rs2==x22, rd==x30, rs1_h1_val == 63487, 
// opcode: srl16.u ; op1:x2; op2:x22; dest:x30; op1val:0xf7ff0009;  op2val:0x13
TEST_RR_OP(srl16.u, x30, x2, x22, 0x00000000, 0xf7ff0009, 0x13, x16, 4, x19)

inst_16:
// rs1==x22, rs2==x1, rd==x13, rs1_h1_val == 64511, 
// opcode: srl16.u ; op1:x22; op2:x1; dest:x13; op1val:0xfbff000a;  op2val:0x7
TEST_RR_OP(srl16.u, x13, x22, x1, 0x00000000, 0xfbff000a, 0x7, x16, 8, x19)

inst_17:
// rs1==x21, rs2==x29, rd==x9, rs1_h1_val == 65023, rs1_h0_val == 43690
// opcode: srl16.u ; op1:x21; op2:x29; dest:x9; op1val:0xfdffaaaa;  op2val:0x5
TEST_RR_OP(srl16.u, x9, x21, x29, 0x00000000, 0xfdffaaaa, 0x5, x16, 12, x19)

inst_18:
// rs1==x24, rs2==x17, rd==x22, rs1_h1_val == 65279, 
// opcode: srl16.u ; op1:x24; op2:x17; dest:x22; op1val:0xfeff0020;  op2val:0xb
TEST_RR_OP(srl16.u, x22, x24, x17, 0x00000000, 0xfeff0020, 0xb, x16, 16, x19)

inst_19:
// rs1==x6, rs2==x8, rd==x7, rs1_h1_val == 65471, 
// opcode: srl16.u ; op1:x6; op2:x8; dest:x7; op1val:0xffbf0400;  op2val:0x3
TEST_RR_OP(srl16.u, x7, x6, x8, 0x00000000, 0xffbf0400, 0x3, x16, 20, x19)

inst_20:
// rs1==x8, rs2==x7, rd==x5, rs1_h1_val == 65503, 
// opcode: srl16.u ; op1:x8; op2:x7; dest:x5; op1val:0xffdf000b;  op2val:0x2
TEST_RR_OP(srl16.u, x5, x8, x7, 0x00000000, 0xffdf000b, 0x2, x16, 24, x19)

inst_21:
// rs1==x15, rs2==x11, rd==x21, rs1_h1_val == 65519, rs1_h0_val == 256
// opcode: srl16.u ; op1:x15; op2:x11; dest:x21; op1val:0xffef0100;  op2val:0xe
TEST_RR_OP(srl16.u, x21, x15, x11, 0x00000000, 0xffef0100, 0xe, x16, 28, x19)

inst_22:
// rs1==x17, rs2==x18, rd==x25, rs1_h1_val == 65527, 
// opcode: srl16.u ; op1:x17; op2:x18; dest:x25; op1val:0xfff70010;  op2val:0xb
TEST_RR_OP(srl16.u, x25, x17, x18, 0x00000000, 0xfff70010, 0xb, x16, 32, x19)

inst_23:
// rs1==x28, rs2==x21, rd==x3, rs1_h1_val == 65531, rs2_val == 10
// opcode: srl16.u ; op1:x28; op2:x21; dest:x3; op1val:0xfffb0004;  op2val:0xa
TEST_RR_OP(srl16.u, x3, x28, x21, 0x00000000, 0xfffb0004, 0xa, x16, 36, x19)

inst_24:
// rs1==x29, rs2==x15, rd==x4, rs1_h1_val == 65533, 
// opcode: srl16.u ; op1:x29; op2:x15; dest:x4; op1val:0xfffd0006;  op2val:0xa
TEST_RR_OP(srl16.u, x4, x29, x15, 0x00000000, 0xfffd0006, 0xa, x16, 40, x19)

inst_25:
// rs1==x26, rs2==x23, rd==x17, rs1_h1_val == 65534, 
// opcode: srl16.u ; op1:x26; op2:x23; dest:x17; op1val:0xfffe0020;  op2val:0x11
TEST_RR_OP(srl16.u, x17, x26, x23, 0x00000000, 0xfffe0020, 0x11, x16, 44, x19)

inst_26:
// rs1==x20, rs2==x6, rd==x12, rs1_h1_val == 32768, 
// opcode: srl16.u ; op1:x20; op2:x6; dest:x12; op1val:0x80000002;  op2val:0xa
TEST_RR_OP(srl16.u, x12, x20, x6, 0x00000000, 0x80000002, 0xa, x16, 48, x19)

inst_27:
// rs1==x11, rs2==x10, rd==x14, rs1_h1_val == 16384, 
// opcode: srl16.u ; op1:x11; op2:x10; dest:x14; op1val:0x40000009;  op2val:0x2
TEST_RR_OP(srl16.u, x14, x11, x10, 0x00000000, 0x40000009, 0x2, x16, 52, x19)
RVTEST_SIGBASE(x1,signature_x1_0)

inst_28:
// rs1==x5, rs2==x19, rd==x11, rs1_h1_val == 4096, 
// opcode: srl16.u ; op1:x5; op2:x19; dest:x11; op1val:0x1000000f;  op2val:0x7
TEST_RR_OP(srl16.u, x11, x5, x19, 0x00000000, 0x1000000f, 0x7, x1, 0, x4)

inst_29:
// rs1==x3, rs2==x31, rd==x24, rs1_h1_val == 2048, 
// opcode: srl16.u ; op1:x3; op2:x31; dest:x24; op1val:0x800000c;  op2val:0x8
TEST_RR_OP(srl16.u, x24, x3, x31, 0x00000000, 0x800000c, 0x8, x1, 4, x4)

inst_30:
// rs1==x16, rs2==x13, rd==x20, rs1_h1_val == 512, rs1_h0_val == 16384
// opcode: srl16.u ; op1:x16; op2:x13; dest:x20; op1val:0x2004000;  op2val:0x9
TEST_RR_OP(srl16.u, x20, x16, x13, 0x00000000, 0x2004000, 0x9, x1, 8, x4)

inst_31:
// rs1==x23, rs2==x12, rd==x2, rs1_h0_val == 8192, 
// opcode: srl16.u ; op1:x23; op2:x12; dest:x2; op1val:0x8002000;  op2val:0xe
TEST_RR_OP(srl16.u, x2, x23, x12, 0x00000000, 0x8002000, 0xe, x1, 12, x4)

inst_32:
// rs1_h0_val == 4096, 
// opcode: srl16.u ; op1:x30; op2:x29; dest:x31; op1val:0xfeff1000;  op2val:0x10
TEST_RR_OP(srl16.u, x31, x30, x29, 0x00000000, 0xfeff1000, 0x10, x1, 16, x4)

inst_33:
// rs1_h0_val == 2048, 
// opcode: srl16.u ; op1:x30; op2:x29; dest:x31; op1val:0xfbff0800;  op2val:0x0
TEST_RR_OP(srl16.u, x31, x30, x29, 0x00000000, 0xfbff0800, 0x0, x1, 20, x4)

inst_34:
// rs1_h0_val == 512, 
// opcode: srl16.u ; op1:x30; op2:x29; dest:x31; op1val:0xfbff0200;  op2val:0x6
TEST_RR_OP(srl16.u, x31, x30, x29, 0x00000000, 0xfbff0200, 0x6, x1, 24, x4)

inst_35:
// rs1_h0_val == 128, 
// opcode: srl16.u ; op1:x30; op2:x29; dest:x31; op1val:0x4000080;  op2val:0xa
TEST_RR_OP(srl16.u, x31, x30, x29, 0x00000000, 0x4000080, 0xa, x1, 28, x4)

inst_36:
// rs1_h0_val == 8, 
// opcode: srl16.u ; op1:x30; op2:x29; dest:x31; op1val:0x090008;  op2val:0x3
TEST_RR_OP(srl16.u, x31, x30, x29, 0x00000000, 0x090008, 0x3, x1, 32, x4)

inst_37:
// rs1_h0_val == 65535, 
// opcode: srl16.u ; op1:x30; op2:x29; dest:x31; op1val:0xffefffff;  op2val:0x10
TEST_RR_OP(srl16.u, x31, x30, x29, 0x00000000, 0xffefffff, 0x10, x1, 36, x4)

inst_38:
// rs1_h1_val == 128, rs1_h0_val == 65519
// opcode: srl16.u ; op1:x30; op2:x29; dest:x31; op1val:0x80ffef;  op2val:0x7
TEST_RR_OP(srl16.u, x31, x30, x29, 0x00000000, 0x80ffef, 0x7, x1, 40, x4)

inst_39:
// rs1_h1_val == 64, 
// opcode: srl16.u ; op1:x30; op2:x29; dest:x31; op1val:0x400080;  op2val:0xf
TEST_RR_OP(srl16.u, x31, x30, x29, 0x00000000, 0x400080, 0xf, x1, 44, x4)

inst_40:
// rs1_h1_val == 32, 
// opcode: srl16.u ; op1:x30; op2:x29; dest:x31; op1val:0x20000b;  op2val:0x7
TEST_RR_OP(srl16.u, x31, x30, x29, 0x00000000, 0x20000b, 0x7, x1, 48, x4)

inst_41:
// rs1_h1_val == 8, rs1_h0_val == 64511
// opcode: srl16.u ; op1:x30; op2:x29; dest:x31; op1val:0x08fbff;  op2val:0x10
TEST_RR_OP(srl16.u, x31, x30, x29, 0x00000000, 0x08fbff, 0x10, x1, 52, x4)

inst_42:
// rs1_h1_val == 4, rs1_h0_val == 21845
// opcode: srl16.u ; op1:x30; op2:x29; dest:x31; op1val:0x045555;  op2val:0x11
TEST_RR_OP(srl16.u, x31, x30, x29, 0x00000000, 0x045555, 0x11, x1, 56, x4)

inst_43:
// rs1_h1_val == 2, 
// opcode: srl16.u ; op1:x30; op2:x29; dest:x31; op1val:0x020080;  op2val:0x13
TEST_RR_OP(srl16.u, x31, x30, x29, 0x00000000, 0x020080, 0x13, x1, 60, x4)

inst_44:
// rs1_h1_val == 1, 
// opcode: srl16.u ; op1:x30; op2:x29; dest:x31; op1val:0x010200;  op2val:0xd
TEST_RR_OP(srl16.u, x31, x30, x29, 0x00000000, 0x010200, 0xd, x1, 64, x4)

inst_45:
// rs1_h1_val == 65535, 
// opcode: srl16.u ; op1:x30; op2:x29; dest:x31; op1val:0xffff0005;  op2val:0x10
TEST_RR_OP(srl16.u, x31, x30, x29, 0x00000000, 0xffff0005, 0x10, x1, 68, x4)

inst_46:
// rs1_h1_val == 0, 
// opcode: srl16.u ; op1:x30; op2:x29; dest:x31; op1val:0x00000d;  op2val:0x4
TEST_RR_OP(srl16.u, x31, x30, x29, 0x00000000, 0x00000d, 0x4, x1, 72, x4)

inst_47:
// rs1_h0_val == 57343, 
// opcode: srl16.u ; op1:x30; op2:x29; dest:x31; op1val:0x08dfff;  op2val:0x12
TEST_RR_OP(srl16.u, x31, x30, x29, 0x00000000, 0x08dfff, 0x12, x1, 76, x4)

inst_48:
// rs1_h0_val == 61439, 
// opcode: srl16.u ; op1:x30; op2:x29; dest:x31; op1val:0x200efff;  op2val:0xf
TEST_RR_OP(srl16.u, x31, x30, x29, 0x00000000, 0x200efff, 0xf, x1, 80, x4)

inst_49:
// rs1_h0_val == 63487, 
// opcode: srl16.u ; op1:x30; op2:x29; dest:x31; op1val:0x200f7ff;  op2val:0xe
TEST_RR_OP(srl16.u, x31, x30, x29, 0x00000000, 0x200f7ff, 0xe, x1, 84, x4)

inst_50:
// rs1_h0_val == 65023, 
// opcode: srl16.u ; op1:x30; op2:x29; dest:x31; op1val:0xff7ffdff;  op2val:0x1
TEST_RR_OP(srl16.u, x31, x30, x29, 0x00000000, 0xff7ffdff, 0x1, x1, 88, x4)

inst_51:
// rs1_h0_val == 65407, 
// opcode: srl16.u ; op1:x30; op2:x29; dest:x31; op1val:0xffdfff7f;  op2val:0x3
TEST_RR_OP(srl16.u, x31, x30, x29, 0x00000000, 0xffdfff7f, 0x3, x1, 92, x4)

inst_52:
// rs1_h0_val == 65471, 
// opcode: srl16.u ; op1:x30; op2:x29; dest:x31; op1val:0x4000ffbf;  op2val:0x2
TEST_RR_OP(srl16.u, x31, x30, x29, 0x00000000, 0x4000ffbf, 0x2, x1, 96, x4)

inst_53:
// rs1_h0_val == 65503, 
// opcode: srl16.u ; op1:x30; op2:x29; dest:x31; op1val:0xffbfffdf;  op2val:0xb
TEST_RR_OP(srl16.u, x31, x30, x29, 0x00000000, 0xffbfffdf, 0xb, x1, 100, x4)

inst_54:
// rs1_h0_val == 65527, 
// opcode: srl16.u ; op1:x30; op2:x29; dest:x31; op1val:0x200fff7;  op2val:0x4
TEST_RR_OP(srl16.u, x31, x30, x29, 0x00000000, 0x200fff7, 0x4, x1, 104, x4)

inst_55:
// rs1_h0_val == 65531, 
// opcode: srl16.u ; op1:x30; op2:x29; dest:x31; op1val:0x00fffb;  op2val:0x2
TEST_RR_OP(srl16.u, x31, x30, x29, 0x00000000, 0x00fffb, 0x2, x1, 108, x4)

inst_56:
// rs1_h0_val == 65533, 
// opcode: srl16.u ; op1:x30; op2:x29; dest:x31; op1val:0x06fffd;  op2val:0x4
TEST_RR_OP(srl16.u, x31, x30, x29, 0x00000000, 0x06fffd, 0x4, x1, 112, x4)

inst_57:
// rs1_h0_val == 32768, 
// opcode: srl16.u ; op1:x30; op2:x29; dest:x31; op1val:0x0c8000;  op2val:0xa
TEST_RR_OP(srl16.u, x31, x30, x29, 0x00000000, 0x0c8000, 0xa, x1, 116, x4)

inst_58:
// rs2_val == 14, rs1_h1_val == 256
// opcode: srl16.u ; op1:x30; op2:x29; dest:x31; op1val:0x1000004;  op2val:0xe
TEST_RR_OP(srl16.u, x31, x30, x29, 0x00000000, 0x1000004, 0xe, x1, 120, x4)
#endif


RVTEST_CODE_END
RVMODEL_HALT

RVTEST_DATA_BEGIN
.align 4
rvtest_data:
.word 0xbabecafe
.word 0xabecafeb
.word 0xbecafeba
.word 0xecafebab
RVTEST_DATA_END

RVMODEL_DATA_BEGIN


signature_x11_0:
    .fill 0*(XLEN/32),4,0xdeadbeef


signature_x11_1:
    .fill 14*(XLEN/32),4,0xdeadbeef


signature_x16_0:
    .fill 14*(XLEN/32),4,0xdeadbeef


signature_x1_0:
    .fill 31*(XLEN/32),4,0xdeadbeef

#ifdef rvtest_mtrap_routine

mtrap_sigptr:
    .fill 64*(XLEN/32),4,0xdeadbeef

#endif

#ifdef rvtest_gpr_save

gpr_save:
    .fill 32*(XLEN/32),4,0xdeadbeef

#endif

RVMODEL_DATA_END
