
// -----------
// This file was generated by riscv_ctg (https://github.com/riscv-software-src/riscv-ctg)
// version   : 0.6.3
// timestamp : Sat Apr 23 14:53:29 2022 GMT
// usage     : riscv_ctg \
//                  --cgf /scratch/git-repo/github/riscv_ctg/sample_cgfs/dataset.cgf \
//                  --cgf /scratch/git-repo/github/riscv_ctg/sample_cgfs/rv32ip.cgf \
//                  --xlen 32  \
//                  --randomize \
// -----------
//
// -----------
// Copyright (c) 2020. RISC-V International. All rights reserved.
// SPDX-License-Identifier: BSD-3-Clause
// -----------
//
// This assembly file tests the srl8 instruction of the RISC-V RV32PZicsr extension for the srl8 covergroup.
// 
#include "model_test.h"
#include "arch_test.h"
RVTEST_ISA("RV32IPZicsr")

.section .text.init
.org 0x80
.globl rvtest_entry_point
rvtest_entry_point:
RVMODEL_BOOT
RVTEST_CODE_BEGIN

#ifdef TEST_CASE_1

RVTEST_CASE(0,"//check ISA:=regex(.*32.*);check ISA:=regex(.*I.*P.*Zicsr.*);def TEST_CASE_1=True;",srl8)

RVTEST_VXSAT_ENABLE()
RVTEST_SIGBASE(x3,signature_x3_1)

inst_0:
// rs1 != rs2  and rs1 != rd and rs2 != rd, rs1==x16, rs2==x5, rd==x9, rs2_val == 5, rs1_b0_val == 64, rs1_b1_val == 254, rs1_b3_val == 254
// opcode: srl8 ; op1:x16; op2:x5; dest:x9; op1val:0xfe0cfe40;  op2val:0x5
TEST_RR_OP(srl8, x9, x16, x5, 0x00000000, 0xfe0cfe40, 0x5, x3, 0, x27)

inst_1:
// rs1 == rs2 != rd, rs1==x7, rs2==x7, rd==x19, rs2_val == 3, rs1_b1_val == 223, rs1_b3_val == 8, rs1_b0_val == 223
// opcode: srl8 ; op1:x7; op2:x7; dest:x19; op1val:0x80fdfdf;  op2val:0x3
TEST_RR_OP(srl8, x19, x7, x7, 0x00000000, 0x80fdfdf, 0x3, x3, 4, x27)

inst_2:
// rs1 == rd != rs2, rs1==x23, rs2==x31, rd==x23, rs2_val == 6, rs1_b0_val == 239
// opcode: srl8 ; op1:x23; op2:x31; dest:x23; op1val:0xb0506ef;  op2val:0x6
TEST_RR_OP(srl8, x23, x23, x31, 0x00000000, 0xb0506ef, 0x6, x3, 8, x27)

inst_3:
// rs1 == rs2 == rd, rs1==x25, rs2==x25, rd==x25, rs2_val == 4, rs1_b3_val == 191, rs1_b1_val == 32, rs1_b2_val == 0
// opcode: srl8 ; op1:x25; op2:x25; dest:x25; op1val:0xbf0020df;  op2val:0x4
TEST_RR_OP(srl8, x25, x25, x25, 0x00000000, 0xbf0020df, 0x4, x3, 12, x27)

inst_4:
// rs2 == rd != rs1, rs1==x18, rs2==x12, rd==x12, rs2_val == 2, 
// opcode: srl8 ; op1:x18; op2:x12; dest:x12; op1val:0xc120b0c;  op2val:0x2
TEST_RR_OP(srl8, x12, x18, x12, 0x00000000, 0xc120b0c, 0x2, x3, 16, x27)

inst_5:
// rs1==x2, rs2==x17, rd==x15, rs2_val == 1, rs1_b0_val == 85, rs1_b1_val == 8, rs1_b3_val == 253, rs1_b2_val == 223
// opcode: srl8 ; op1:x2; op2:x17; dest:x15; op1val:0xfddf0855;  op2val:0x1
TEST_RR_OP(srl8, x15, x2, x17, 0x00000000, 0xfddf0855, 0x1, x3, 20, x27)

inst_6:
// rs1==x11, rs2==x15, rd==x30, rs1_b3_val == 170, rs1_b1_val == 128, rs1_b2_val == 2
// opcode: srl8 ; op1:x11; op2:x15; dest:x30; op1val:0xaa028005;  op2val:0x1
TEST_RR_OP(srl8, x30, x11, x15, 0x00000000, 0xaa028005, 0x1, x3, 24, x27)

inst_7:
// rs1==x0, rs2==x18, rd==x14, rs1_b3_val == 85, rs1_b1_val == 16
// opcode: srl8 ; op1:x0; op2:x18; dest:x14; op1val:0x550e1009;  op2val:0x0
TEST_RR_OP(srl8, x14, x0, x18, 0x00000000, 0x550e1009, 0x0, x3, 28, x27)

inst_8:
// rs1==x8, rs2==x9, rd==x7, rs1_b3_val == 127, rs1_b2_val == 191, rs1_b0_val == 32
// opcode: srl8 ; op1:x8; op2:x9; dest:x7; op1val:0x7fbf2020;  op2val:0x11
TEST_RR_OP(srl8, x7, x8, x9, 0x00000000, 0x7fbf2020, 0x11, x3, 32, x27)

inst_9:
// rs1==x21, rs2==x19, rd==x10, rs1_b3_val == 223, rs1_b0_val == 16
// opcode: srl8 ; op1:x21; op2:x19; dest:x10; op1val:0xdf050510;  op2val:0x10
TEST_RR_OP(srl8, x10, x21, x19, 0x00000000, 0xdf050510, 0x10, x3, 36, x27)

inst_10:
// rs1==x22, rs2==x10, rd==x13, rs1_b3_val == 239, rs1_b2_val == 170
// opcode: srl8 ; op1:x22; op2:x10; dest:x13; op1val:0xefaa1312;  op2val:0xa
TEST_RR_OP(srl8, x13, x22, x10, 0x00000000, 0xefaa1312, 0xa, x3, 40, x27)

inst_11:
// rs1==x20, rs2==x24, rd==x31, rs1_b3_val == 247, 
// opcode: srl8 ; op1:x20; op2:x24; dest:x31; op1val:0xf70d11df;  op2val:0xf
TEST_RR_OP(srl8, x31, x20, x24, 0x00000000, 0xf70d11df, 0xf, x3, 44, x27)

inst_12:
// rs1==x5, rs2==x4, rd==x6, rs1_b3_val == 251, rs1_b2_val == 32
// opcode: srl8 ; op1:x5; op2:x4; dest:x6; op1val:0xfb20800d;  op2val:0x9
TEST_RR_OP(srl8, x6, x5, x4, 0x00000000, 0xfb20800d, 0x9, x3, 48, x27)

inst_13:
// rs1==x24, rs2==x22, rd==x2, rs1_b3_val == 128, 
// opcode: srl8 ; op1:x24; op2:x22; dest:x2; op1val:0x80091313;  op2val:0x13
TEST_RR_OP(srl8, x2, x24, x22, 0x00000000, 0x80091313, 0x13, x3, 52, x27)

inst_14:
// rs1==x6, rs2==x16, rd==x11, rs1_b3_val == 64, rs1_b2_val == 64
// opcode: srl8 ; op1:x6; op2:x16; dest:x11; op1val:0x4040130c;  op2val:0xf
TEST_RR_OP(srl8, x11, x6, x16, 0x00000000, 0x4040130c, 0xf, x3, 56, x27)

inst_15:
// rs1==x19, rs2==x2, rd==x20, rs1_b3_val == 32, rs1_b1_val == 251
// opcode: srl8 ; op1:x19; op2:x2; dest:x20; op1val:0x200efb0e;  op2val:0x11
TEST_RR_OP(srl8, x20, x19, x2, 0x00000000, 0x200efb0e, 0x11, x3, 60, x27)

inst_16:
// rs1==x1, rs2==x26, rd==x22, rs1_b3_val == 16, rs1_b0_val == 253, rs1_b2_val == 85
// opcode: srl8 ; op1:x1; op2:x26; dest:x22; op1val:0x105513fd;  op2val:0x3
TEST_RR_OP(srl8, x22, x1, x26, 0x00000000, 0x105513fd, 0x3, x3, 64, x27)
RVTEST_SIGBASE(x2,signature_x2_0)

inst_17:
// rs1==x4, rs2==x1, rd==x0, rs1_b3_val == 4, rs1_b1_val == 2
// opcode: srl8 ; op1:x4; op2:x1; dest:x0; op1val:0x4070205;  op2val:0x10
TEST_RR_OP(srl8, x0, x4, x1, 0x00000000, 0x4070205, 0x10, x2, 0, x7)

inst_18:
// rs1==x12, rs2==x27, rd==x24, rs1_b3_val == 2, rs1_b0_val == 254
// opcode: srl8 ; op1:x12; op2:x27; dest:x24; op1val:0x20220fe;  op2val:0xf
TEST_RR_OP(srl8, x24, x12, x27, 0x00000000, 0x20220fe, 0xf, x2, 4, x7)

inst_19:
// rs1==x30, rs2==x14, rd==x26, rs1_b3_val == 1, rs1_b0_val == 251
// opcode: srl8 ; op1:x30; op2:x14; dest:x26; op1val:0x1030cfb;  op2val:0x7
TEST_RR_OP(srl8, x26, x30, x14, 0x00000000, 0x1030cfb, 0x7, x2, 8, x7)

inst_20:
// rs1==x3, rs2==x8, rd==x18, rs1_b3_val == 255, rs1_b2_val == 128, rs1_b0_val == 128
// opcode: srl8 ; op1:x3; op2:x8; dest:x18; op1val:0xff80fb80;  op2val:0x6
TEST_RR_OP(srl8, x18, x3, x8, 0x00000000, 0xff80fb80, 0x6, x2, 12, x7)

inst_21:
// rs1==x28, rs2==x6, rd==x3, rs1_b3_val == 0, rs1_b0_val == 255
// opcode: srl8 ; op1:x28; op2:x6; dest:x3; op1val:0x1109ff;  op2val:0xf
TEST_RR_OP(srl8, x3, x28, x6, 0x00000000, 0x1109ff, 0xf, x2, 16, x7)

inst_22:
// rs1==x15, rs2==x0, rd==x1, rs1_b2_val == 127, rs1_b0_val == 170
// opcode: srl8 ; op1:x15; op2:x0; dest:x1; op1val:0x107f0caa;  op2val:0x0
TEST_RR_OP(srl8, x1, x15, x0, 0x00000000, 0x107f0caa, 0x0, x2, 20, x7)

inst_23:
// rs1==x17, rs2==x13, rd==x29, rs1_b1_val == 255, rs1_b2_val == 1
// opcode: srl8 ; op1:x17; op2:x13; dest:x29; op1val:0xaa01ffef;  op2val:0x4
TEST_RR_OP(srl8, x29, x17, x13, 0x00000000, 0xaa01ffef, 0x4, x2, 24, x7)

inst_24:
// rs1==x27, rs2==x20, rd==x4, rs1_b1_val == 0, 
// opcode: srl8 ; op1:x27; op2:x20; dest:x4; op1val:0xe110006;  op2val:0x9
TEST_RR_OP(srl8, x4, x27, x20, 0x00000000, 0xe110006, 0x9, x2, 28, x7)

inst_25:
// rs1==x14, rs2==x30, rd==x16, rs1_b0_val == 127, rs1_b2_val == 253
// opcode: srl8 ; op1:x14; op2:x30; dest:x16; op1val:0xf7fd0c7f;  op2val:0x12
TEST_RR_OP(srl8, x16, x14, x30, 0x00000000, 0xf7fd0c7f, 0x12, x2, 32, x7)

inst_26:
// rs1==x31, rs2==x3, rd==x27, rs1_b0_val == 191, rs1_b1_val == 191
// opcode: srl8 ; op1:x31; op2:x3; dest:x27; op1val:0xfe02bfbf;  op2val:0x11
TEST_RR_OP(srl8, x27, x31, x3, 0x00000000, 0xfe02bfbf, 0x11, x2, 36, x7)

inst_27:
// rs1==x9, rs2==x29, rd==x28, rs1_b0_val == 247, 
// opcode: srl8 ; op1:x9; op2:x29; dest:x28; op1val:0x10cfef7;  op2val:0x10
TEST_RR_OP(srl8, x28, x9, x29, 0x00000000, 0x10cfef7, 0x10, x2, 40, x7)

inst_28:
// rs1==x29, rs2==x28, rd==x17, rs1_b0_val == 8, 
// opcode: srl8 ; op1:x29; op2:x28; dest:x17; op1val:0x13120608;  op2val:0x6
TEST_RR_OP(srl8, x17, x29, x28, 0x00000000, 0x13120608, 0x6, x2, 44, x7)

inst_29:
// rs1==x13, rs2==x11, rd==x21, rs1_b0_val == 4, rs1_b1_val == 247
// opcode: srl8 ; op1:x13; op2:x11; dest:x21; op1val:0xef0bf704;  op2val:0xc
TEST_RR_OP(srl8, x21, x13, x11, 0x00000000, 0xef0bf704, 0xc, x2, 48, x7)

inst_30:
// rs1==x10, rs2==x21, rd==x5, rs1_b0_val == 2, 
// opcode: srl8 ; op1:x10; op2:x21; dest:x5; op1val:0x7f120502;  op2val:0xb
TEST_RR_OP(srl8, x5, x10, x21, 0x00000000, 0x7f120502, 0xb, x2, 52, x7)

inst_31:
// rs1==x26, rs2==x23, rd==x8, rs1_b0_val == 1, 
// opcode: srl8 ; op1:x26; op2:x23; dest:x8; op1val:0xfb061301;  op2val:0xb
TEST_RR_OP(srl8, x8, x26, x23, 0x00000000, 0xfb061301, 0xb, x2, 56, x7)

inst_32:
// rs1_b0_val == 0, 
// opcode: srl8 ; op1:x30; op2:x29; dest:x31; op1val:0x6120b00;  op2val:0x6
TEST_RR_OP(srl8, x31, x30, x29, 0x00000000, 0x6120b00, 0x6, x2, 60, x1)

inst_33:
// rs1_b2_val == 239, rs1_b1_val == 127
// opcode: srl8 ; op1:x30; op2:x29; dest:x31; op1val:0x20ef7f12;  op2val:0x13
TEST_RR_OP(srl8, x31, x30, x29, 0x00000000, 0x20ef7f12, 0x13, x2, 64, x1)

inst_34:
// rs1_b2_val == 247, 
// opcode: srl8 ; op1:x30; op2:x29; dest:x31; op1val:0x7ff70810;  op2val:0x10
TEST_RR_OP(srl8, x31, x30, x29, 0x00000000, 0x7ff70810, 0x10, x2, 68, x1)

inst_35:
// rs1_b2_val == 251, 
// opcode: srl8 ; op1:x30; op2:x29; dest:x31; op1val:0x20fb090d;  op2val:0x13
TEST_RR_OP(srl8, x31, x30, x29, 0x00000000, 0x20fb090d, 0x13, x2, 72, x1)

inst_36:
// rs1_b2_val == 254, 
// opcode: srl8 ; op1:x30; op2:x29; dest:x31; op1val:0x11fe1211;  op2val:0x10
TEST_RR_OP(srl8, x31, x30, x29, 0x00000000, 0x11fe1211, 0x10, x2, 76, x1)

inst_37:
// rs1_b2_val == 16, 
// opcode: srl8 ; op1:x30; op2:x29; dest:x31; op1val:0x8100a10;  op2val:0xd
TEST_RR_OP(srl8, x31, x30, x29, 0x00000000, 0x8100a10, 0xd, x2, 80, x1)

inst_38:
// rs1_b2_val == 8, 
// opcode: srl8 ; op1:x30; op2:x29; dest:x31; op1val:0x6080dfe;  op2val:0xa
TEST_RR_OP(srl8, x31, x30, x29, 0x00000000, 0x6080dfe, 0xa, x2, 84, x1)

inst_39:
// rs1_b2_val == 4, 
// opcode: srl8 ; op1:x30; op2:x29; dest:x31; op1val:0xaa040c55;  op2val:0x7
TEST_RR_OP(srl8, x31, x30, x29, 0x00000000, 0xaa040c55, 0x7, x2, 88, x1)

inst_40:
// rs1_b2_val == 255, rs1_b1_val == 85
// opcode: srl8 ; op1:x30; op2:x29; dest:x31; op1val:0x6ff5513;  op2val:0xb
TEST_RR_OP(srl8, x31, x30, x29, 0x00000000, 0x6ff5513, 0xb, x2, 92, x1)

inst_41:
// rs1_b1_val == 170, 
// opcode: srl8 ; op1:x30; op2:x29; dest:x31; op1val:0x1200aa01;  op2val:0xe
TEST_RR_OP(srl8, x31, x30, x29, 0x00000000, 0x1200aa01, 0xe, x2, 96, x1)

inst_42:
// rs1_b1_val == 239, 
// opcode: srl8 ; op1:x30; op2:x29; dest:x31; op1val:0x5aaef08;  op2val:0x6
TEST_RR_OP(srl8, x31, x30, x29, 0x00000000, 0x5aaef08, 0x6, x2, 100, x1)

inst_43:
// rs1_b1_val == 64, 
// opcode: srl8 ; op1:x30; op2:x29; dest:x31; op1val:0xfb0e4001;  op2val:0xe
TEST_RR_OP(srl8, x31, x30, x29, 0x00000000, 0xfb0e4001, 0xe, x2, 104, x1)

inst_44:
// rs1_b1_val == 4, 
// opcode: srl8 ; op1:x30; op2:x29; dest:x31; op1val:0x5040455;  op2val:0x1
TEST_RR_OP(srl8, x31, x30, x29, 0x00000000, 0x5040455, 0x1, x2, 108, x1)

inst_45:
// rs1_b1_val == 253, 
// opcode: srl8 ; op1:x30; op2:x29; dest:x31; op1val:0x510fdf7;  op2val:0x4
TEST_RR_OP(srl8, x31, x30, x29, 0x00000000, 0x510fdf7, 0x4, x2, 112, x1)

inst_46:
// rs1_b1_val == 1, 
// opcode: srl8 ; op1:x30; op2:x29; dest:x31; op1val:0x7f0e0104;  op2val:0x5
TEST_RR_OP(srl8, x31, x30, x29, 0x00000000, 0x7f0e0104, 0x5, x2, 116, x1)

inst_47:
// rs2_val == 3, rs1_b1_val == 223, rs1_b3_val == 8, rs1_b0_val == 223
// opcode: srl8 ; op1:x30; op2:x29; dest:x31; op1val:0x80fdfdf;  op2val:0x3
TEST_RR_OP(srl8, x31, x30, x29, 0x00000000, 0x80fdfdf, 0x3, x2, 120, x1)

inst_48:
// rs2_val == 4, rs1_b3_val == 191, rs1_b1_val == 32, rs1_b2_val == 0
// opcode: srl8 ; op1:x30; op2:x29; dest:x31; op1val:0xbf0020df;  op2val:0x4
TEST_RR_OP(srl8, x31, x30, x29, 0x00000000, 0xbf0020df, 0x4, x2, 124, x1)

inst_49:
// rs1_b3_val == 85, rs1_b1_val == 16
// opcode: srl8 ; op1:x30; op2:x29; dest:x31; op1val:0x550e1009;  op2val:0x0
TEST_RR_OP(srl8, x31, x30, x29, 0x00000000, 0x550e1009, 0x0, x2, 128, x1)

inst_50:
// rs1_b3_val == 4, rs1_b1_val == 2
// opcode: srl8 ; op1:x30; op2:x29; dest:x31; op1val:0x4070205;  op2val:0x10
TEST_RR_OP(srl8, x31, x30, x29, 0x00000000, 0x4070205, 0x10, x2, 132, x1)

inst_51:
// rs1_b2_val == 127, rs1_b0_val == 170
// opcode: srl8 ; op1:x30; op2:x29; dest:x31; op1val:0x107f0caa;  op2val:0xf
TEST_RR_OP(srl8, x31, x30, x29, 0x00000000, 0x107f0caa, 0xf, x2, 136, x1)
#endif


RVTEST_CODE_END
RVMODEL_HALT

RVTEST_DATA_BEGIN
.align 4
rvtest_data:
.word 0xbabecafe
.word 0xabecafeb
.word 0xbecafeba
.word 0xecafebab
RVTEST_DATA_END

RVMODEL_DATA_BEGIN


signature_x3_0:
    .fill 0*(XLEN/32),4,0xdeadbeef


signature_x3_1:
    .fill 17*(XLEN/32),4,0xdeadbeef


signature_x2_0:
    .fill 35*(XLEN/32),4,0xdeadbeef

#ifdef rvtest_mtrap_routine

mtrap_sigptr:
    .fill 64*(XLEN/32),4,0xdeadbeef

#endif

#ifdef rvtest_gpr_save

gpr_save:
    .fill 32*(XLEN/32),4,0xdeadbeef

#endif

RVMODEL_DATA_END
