
// -----------
// This file was generated by riscv_ctg (https://github.com/riscv-software-src/riscv-ctg)
// version   : 0.6.3
// timestamp : Sat Apr 23 14:53:29 2022 GMT
// usage     : riscv_ctg \
//                  --cgf /scratch/git-repo/github/riscv_ctg/sample_cgfs/dataset.cgf \
//                  --cgf /scratch/git-repo/github/riscv_ctg/sample_cgfs/rv32ip.cgf \
//                  --xlen 32  \
//                  --randomize \
// -----------
//
// -----------
// Copyright (c) 2020. RISC-V International. All rights reserved.
// SPDX-License-Identifier: BSD-3-Clause
// -----------
//
// This assembly file tests the uclip32 instruction of the RISC-V RV32PZicsr extension for the uclip32 covergroup.
// 
#include "model_test.h"
#include "arch_test.h"
RVTEST_ISA("RV32IPZicsr")

.section .text.init
.org 0x80
.globl rvtest_entry_point
rvtest_entry_point:
RVMODEL_BOOT
RVTEST_CODE_BEGIN

#ifdef TEST_CASE_1

RVTEST_CASE(0,"//check ISA:=regex(.*32.*);check ISA:=regex(.*I.*P.*Zicsr.*);def TEST_CASE_1=True;",uclip32)

RVTEST_VXSAT_ENABLE()
RVTEST_SIGBASE(x5,signature_x5_1)

inst_0:
// rs1 != rd, rs1==x24, rd==x28, rs1_w0_val == 0, imm_val == 24
// opcode: uclip32 ; op1:x24; dest:x28; op1val:0x000000;  immval:0x18
TEST_PKIMM_OP( uclip32, x28, x24, 0x00000000, 0x000000, 0x18, x24, x5, 0, x8)

inst_1:
// rs1 == rd, rs1==x4, rd==x4, imm_val == 31, rs1_w0_val == 524288
// opcode: uclip32 ; op1:x4; dest:x4; op1val:0x080000;  immval:0x1f
TEST_PKIMM_OP( uclip32, x4, x4, 0x00000000, 0x080000, 0x1f, x4, x5, 8, x8)

inst_2:
// rs1==x15, rd==x26, imm_val == 30, rs1_w0_val == 4294967279
// opcode: uclip32 ; op1:x15; dest:x26; op1val:0xffffffef;  immval:0x1e
TEST_PKIMM_OP( uclip32, x26, x15, 0x00000000, 0xffffffef, 0x1e, x15, x5, 16, x8)

inst_3:
// rs1==x26, rd==x29, imm_val == 29, rs1_w0_val == 2147483648
// opcode: uclip32 ; op1:x26; dest:x29; op1val:0x80000000;  immval:0x1d
TEST_PKIMM_OP( uclip32, x29, x26, 0x00000000, 0x80000000, 0x1d, x26, x5, 24, x8)

inst_4:
// rs1==x7, rd==x23, imm_val == 28, rs1_w0_val == 131072
// opcode: uclip32 ; op1:x7; dest:x23; op1val:0x020000;  immval:0x1c
TEST_PKIMM_OP( uclip32, x23, x7, 0x00000000, 0x020000, 0x1c, x7, x5, 32, x8)

inst_5:
// rs1==x21, rd==x30, imm_val == 27, rs1_w0_val == 4290772991
// opcode: uclip32 ; op1:x21; dest:x30; op1val:0xffbfffff;  immval:0x1b
TEST_PKIMM_OP( uclip32, x30, x21, 0x00000000, 0xffbfffff, 0x1b, x21, x5, 40, x8)

inst_6:
// rs1==x22, rd==x25, imm_val == 26, rs1_w0_val == 4194304
// opcode: uclip32 ; op1:x22; dest:x25; op1val:0x400000;  immval:0x1a
TEST_PKIMM_OP( uclip32, x25, x22, 0x00000000, 0x400000, 0x1a, x22, x5, 48, x8)

inst_7:
// rs1==x10, rd==x18, imm_val == 25, 
// opcode: uclip32 ; op1:x10; dest:x18; op1val:0x000013;  immval:0x19
TEST_PKIMM_OP( uclip32, x18, x10, 0x00000000, 0x000013, 0x19, x10, x5, 56, x8)

inst_8:
// rs1==x17, rd==x16, imm_val == 23, 
// opcode: uclip32 ; op1:x17; dest:x16; op1val:0x00000d;  immval:0x17
TEST_PKIMM_OP( uclip32, x16, x17, 0x00000000, 0x00000d, 0x17, x17, x5, 64, x8)

inst_9:
// rs1==x18, rd==x3, imm_val == 22, 
// opcode: uclip32 ; op1:x18; dest:x3; op1val:0x400000;  immval:0x16
TEST_PKIMM_OP( uclip32, x3, x18, 0x00000000, 0x400000, 0x16, x18, x5, 72, x8)

inst_10:
// rs1==x28, rd==x6, imm_val == 21, rs1_w0_val == 16384
// opcode: uclip32 ; op1:x28; dest:x6; op1val:0x004000;  immval:0x15
TEST_PKIMM_OP( uclip32, x6, x28, 0x00000000, 0x004000, 0x15, x28, x5, 80, x8)

inst_11:
// rs1==x20, rd==x1, imm_val == 20, rs1_w0_val == 4294967263
// opcode: uclip32 ; op1:x20; dest:x1; op1val:0xffffffdf;  immval:0x14
TEST_PKIMM_OP( uclip32, x1, x20, 0x00000000, 0xffffffdf, 0x14, x20, x5, 88, x8)

inst_12:
// rs1==x27, rd==x7, imm_val == 19, rs1_w0_val == 4294963199
// opcode: uclip32 ; op1:x27; dest:x7; op1val:0xffffefff;  immval:0x13
TEST_PKIMM_OP( uclip32, x7, x27, 0x00000000, 0xffffefff, 0x13, x27, x5, 96, x8)

inst_13:
// rs1==x14, rd==x11, imm_val == 18, rs1_w0_val == 262144
// opcode: uclip32 ; op1:x14; dest:x11; op1val:0x040000;  immval:0x12
TEST_PKIMM_OP( uclip32, x11, x14, 0x00000000, 0x040000, 0x12, x14, x5, 104, x8)

inst_14:
// rs1==x6, rd==x22, imm_val == 17, rs1_w0_val == 4294967231
// opcode: uclip32 ; op1:x6; dest:x22; op1val:0xffffffbf;  immval:0x11
TEST_PKIMM_OP( uclip32, x22, x6, 0x00000000, 0xffffffbf, 0x11, x6, x5, 112, x8)

inst_15:
// rs1==x29, rd==x19, imm_val == 16, 
// opcode: uclip32 ; op1:x29; dest:x19; op1val:0xffbfffff;  immval:0x10
TEST_PKIMM_OP( uclip32, x19, x29, 0x00000000, 0xffbfffff, 0x10, x29, x5, 120, x8)

inst_16:
// rs1==x0, rd==x10, imm_val == 15, 
// opcode: uclip32 ; op1:x0; dest:x10; op1val:0x080000;  immval:0xf
TEST_PKIMM_OP( uclip32, x10, x0, 0x00000000, 0x080000, 0xf, x0, x5, 128, x8)

inst_17:
// rs1==x30, rd==x31, imm_val == 14, rs1_w0_val == 4
// opcode: uclip32 ; op1:x30; dest:x31; op1val:0x000004;  immval:0xe
TEST_PKIMM_OP( uclip32, x31, x30, 0x00000000, 0x000004, 0xe, x30, x5, 136, x8)

inst_18:
// rs1==x3, rd==x12, imm_val == 13, rs1_w0_val == 4160749567
// opcode: uclip32 ; op1:x3; dest:x12; op1val:0xf7ffffff;  immval:0xd
TEST_PKIMM_OP( uclip32, x12, x3, 0x00000000, 0xf7ffffff, 0xd, x3, x5, 144, x8)

inst_19:
// rs1==x19, rd==x14, imm_val == 12, 
// opcode: uclip32 ; op1:x19; dest:x14; op1val:0x400000;  immval:0xc
TEST_PKIMM_OP( uclip32, x14, x19, 0x00000000, 0x400000, 0xc, x19, x5, 152, x8)

inst_20:
// rs1==x2, rd==x15, imm_val == 11, rs1_w0_val == 2147483647
// opcode: uclip32 ; op1:x2; dest:x15; op1val:0x7fffffff;  immval:0xb
TEST_PKIMM_OP( uclip32, x15, x2, 0x00000000, 0x7fffffff, 0xb, x2, x5, 160, x8)

inst_21:
// rs1==x25, rd==x27, imm_val == 10, 
// opcode: uclip32 ; op1:x25; dest:x27; op1val:0x000013;  immval:0xa
TEST_PKIMM_OP( uclip32, x27, x25, 0x00000000, 0x000013, 0xa, x25, x5, 168, x4)

inst_22:
// rs1==x12, rd==x13, imm_val == 9, 
// opcode: uclip32 ; op1:x12; dest:x13; op1val:0x00000b;  immval:0x9
TEST_PKIMM_OP( uclip32, x13, x12, 0x00000000, 0x00000b, 0x9, x12, x5, 176, x4)
RVTEST_SIGBASE(x3,signature_x3_0)

inst_23:
// rs1==x16, rd==x20, imm_val == 8, 
// opcode: uclip32 ; op1:x16; dest:x20; op1val:0x000005;  immval:0x8
TEST_PKIMM_OP( uclip32, x20, x16, 0x00000000, 0x000005, 0x8, x16, x3, 0, x4)

inst_24:
// rs1==x23, rd==x0, imm_val == 7, 
// opcode: uclip32 ; op1:x23; dest:x0; op1val:0x00000e;  immval:0x7
TEST_PKIMM_OP( uclip32, x0, x23, 0x00000000, 0x00000e, 0x7, x23, x3, 8, x4)

inst_25:
// rs1==x9, rd==x21, imm_val == 6, rs1_w0_val == 4278190079
// opcode: uclip32 ; op1:x9; dest:x21; op1val:0xfeffffff;  immval:0x6
TEST_PKIMM_OP( uclip32, x21, x9, 0x00000000, 0xfeffffff, 0x6, x9, x3, 16, x4)

inst_26:
// rs1==x1, rd==x8, imm_val == 5, 
// opcode: uclip32 ; op1:x1; dest:x8; op1val:0x000006;  immval:0x5
TEST_PKIMM_OP( uclip32, x8, x1, 0x00000000, 0x000006, 0x5, x1, x3, 24, x4)

inst_27:
// rs1==x5, rd==x9, imm_val == 4, rs1_w0_val == 4293918719
// opcode: uclip32 ; op1:x5; dest:x9; op1val:0xffefffff;  immval:0x4
TEST_PKIMM_OP( uclip32, x9, x5, 0x00000000, 0xffefffff, 0x4, x5, x3, 32, x4)

inst_28:
// rs1==x31, rd==x5, imm_val == 3, 
// opcode: uclip32 ; op1:x31; dest:x5; op1val:0xffffffbf;  immval:0x3
TEST_PKIMM_OP( uclip32, x5, x31, 0x00000000, 0xffffffbf, 0x3, x31, x3, 40, x4)

inst_29:
// rs1==x8, rd==x2, imm_val == 2, rs1_w0_val == 4227858431
// opcode: uclip32 ; op1:x8; dest:x2; op1val:0xfbffffff;  immval:0x2
TEST_PKIMM_OP( uclip32, x2, x8, 0x00000000, 0xfbffffff, 0x2, x8, x3, 48, x4)

inst_30:
// rs1==x11, rd==x17, imm_val == 1, 
// opcode: uclip32 ; op1:x11; dest:x17; op1val:0x000007;  immval:0x1
TEST_PKIMM_OP( uclip32, x17, x11, 0x00000000, 0x000007, 0x1, x11, x3, 56, x4)

inst_31:
// rs1==x13, rd==x24, imm_val == 0, rs1_w0_val == 3221225471
// opcode: uclip32 ; op1:x13; dest:x24; op1val:0xbfffffff;  immval:0x0
TEST_PKIMM_OP( uclip32, x24, x13, 0x00000000, 0xbfffffff, 0x0, x13, x3, 64, x4)

inst_32:
// rs1_w0_val == 2863311530, 
// opcode: uclip32 ; op1:x30; dest:x31; op1val:0xaaaaaaaa;  immval:0x2
TEST_PKIMM_OP( uclip32, x31, x30, 0x00000000, 0xaaaaaaaa, 0x2, x30, x3, 72, x4)

inst_33:
// rs1_w0_val == 1431655765, 
// opcode: uclip32 ; op1:x30; dest:x31; op1val:0x55555555;  immval:0x2
TEST_PKIMM_OP( uclip32, x31, x30, 0x00000000, 0x55555555, 0x2, x30, x3, 80, x4)

inst_34:
// rs1_w0_val == 3758096383, 
// opcode: uclip32 ; op1:x30; dest:x31; op1val:0xdfffffff;  immval:0x16
TEST_PKIMM_OP( uclip32, x31, x30, 0x00000000, 0xdfffffff, 0x16, x30, x3, 88, x4)

inst_35:
// rs1_w0_val == 4026531839, 
// opcode: uclip32 ; op1:x30; dest:x31; op1val:0xefffffff;  immval:0x1b
TEST_PKIMM_OP( uclip32, x31, x30, 0x00000000, 0xefffffff, 0x1b, x30, x3, 96, x4)

inst_36:
// rs1_w0_val == 4261412863, 
// opcode: uclip32 ; op1:x30; dest:x31; op1val:0xfdffffff;  immval:0xd
TEST_PKIMM_OP( uclip32, x31, x30, 0x00000000, 0xfdffffff, 0xd, x30, x3, 104, x4)

inst_37:
// rs1_w0_val == 4286578687, 
// opcode: uclip32 ; op1:x30; dest:x31; op1val:0xff7fffff;  immval:0x0
TEST_PKIMM_OP( uclip32, x31, x30, 0x00000000, 0xff7fffff, 0x0, x30, x3, 112, x4)

inst_38:
// rs1_w0_val == 4292870143, 
// opcode: uclip32 ; op1:x30; dest:x31; op1val:0xffdfffff;  immval:0x3
TEST_PKIMM_OP( uclip32, x31, x30, 0x00000000, 0xffdfffff, 0x3, x30, x3, 120, x4)

inst_39:
// rs1_w0_val == 4294443007, 
// opcode: uclip32 ; op1:x30; dest:x31; op1val:0xfff7ffff;  immval:0x1a
TEST_PKIMM_OP( uclip32, x31, x30, 0x00000000, 0xfff7ffff, 0x1a, x30, x3, 128, x4)

inst_40:
// rs1_w0_val == 4294705151, 
// opcode: uclip32 ; op1:x30; dest:x31; op1val:0xfffbffff;  immval:0x1b
TEST_PKIMM_OP( uclip32, x31, x30, 0x00000000, 0xfffbffff, 0x1b, x30, x3, 136, x4)

inst_41:
// rs1_w0_val == 4294836223, 
// opcode: uclip32 ; op1:x30; dest:x31; op1val:0xfffdffff;  immval:0x5
TEST_PKIMM_OP( uclip32, x31, x30, 0x00000000, 0xfffdffff, 0x5, x30, x3, 144, x4)

inst_42:
// rs1_w0_val == 4294901759, 
// opcode: uclip32 ; op1:x30; dest:x31; op1val:0xfffeffff;  immval:0xe
TEST_PKIMM_OP( uclip32, x31, x30, 0x00000000, 0xfffeffff, 0xe, x30, x3, 152, x4)

inst_43:
// rs1_w0_val == 4294934527, 
// opcode: uclip32 ; op1:x30; dest:x31; op1val:0xffff7fff;  immval:0x5
TEST_PKIMM_OP( uclip32, x31, x30, 0x00000000, 0xffff7fff, 0x5, x30, x3, 160, x4)

inst_44:
// rs1_w0_val == 4294950911, 
// opcode: uclip32 ; op1:x30; dest:x31; op1val:0xffffbfff;  immval:0x9
TEST_PKIMM_OP( uclip32, x31, x30, 0x00000000, 0xffffbfff, 0x9, x30, x3, 168, x4)

inst_45:
// rs1_w0_val == 4294959103, 
// opcode: uclip32 ; op1:x30; dest:x31; op1val:0xffffdfff;  immval:0x12
TEST_PKIMM_OP( uclip32, x31, x30, 0x00000000, 0xffffdfff, 0x12, x30, x3, 176, x4)

inst_46:
// rs1_w0_val == 4294965247, 
// opcode: uclip32 ; op1:x30; dest:x31; op1val:0xfffff7ff;  immval:0x1
TEST_PKIMM_OP( uclip32, x31, x30, 0x00000000, 0xfffff7ff, 0x1, x30, x3, 184, x4)

inst_47:
// rs1_w0_val == 4294966271, 
// opcode: uclip32 ; op1:x30; dest:x31; op1val:0xfffffbff;  immval:0xb
TEST_PKIMM_OP( uclip32, x31, x30, 0x00000000, 0xfffffbff, 0xb, x30, x3, 192, x4)

inst_48:
// rs1_w0_val == 4294966783, 
// opcode: uclip32 ; op1:x30; dest:x31; op1val:0xfffffdff;  immval:0xc
TEST_PKIMM_OP( uclip32, x31, x30, 0x00000000, 0xfffffdff, 0xc, x30, x3, 200, x4)

inst_49:
// rs1_w0_val == 4294967039, 
// opcode: uclip32 ; op1:x30; dest:x31; op1val:0xfffffeff;  immval:0x19
TEST_PKIMM_OP( uclip32, x31, x30, 0x00000000, 0xfffffeff, 0x19, x30, x3, 208, x4)

inst_50:
// rs1_w0_val == 4294967291, 
// opcode: uclip32 ; op1:x30; dest:x31; op1val:0xfffffffb;  immval:0x1c
TEST_PKIMM_OP( uclip32, x31, x30, 0x00000000, 0xfffffffb, 0x1c, x30, x3, 216, x4)

inst_51:
// rs1_w0_val == 4294967293, 
// opcode: uclip32 ; op1:x30; dest:x31; op1val:0xfffffffd;  immval:0xc
TEST_PKIMM_OP( uclip32, x31, x30, 0x00000000, 0xfffffffd, 0xc, x30, x3, 224, x4)

inst_52:
// rs1_w0_val == 4294967294, 
// opcode: uclip32 ; op1:x30; dest:x31; op1val:0xfffffffe;  immval:0x1d
TEST_PKIMM_OP( uclip32, x31, x30, 0x00000000, 0xfffffffe, 0x1d, x30, x3, 232, x4)

inst_53:
// rs1_w0_val == 1073741824, 
// opcode: uclip32 ; op1:x30; dest:x31; op1val:0x40000000;  immval:0x5
TEST_PKIMM_OP( uclip32, x31, x30, 0x00000000, 0x40000000, 0x5, x30, x3, 240, x4)

inst_54:
// rs1_w0_val == 536870912, 
// opcode: uclip32 ; op1:x30; dest:x31; op1val:0x20000000;  immval:0xa
TEST_PKIMM_OP( uclip32, x31, x30, 0x00000000, 0x20000000, 0xa, x30, x3, 248, x4)

inst_55:
// rs1_w0_val == 268435456, 
// opcode: uclip32 ; op1:x30; dest:x31; op1val:0x10000000;  immval:0x12
TEST_PKIMM_OP( uclip32, x31, x30, 0x00000000, 0x10000000, 0x12, x30, x3, 256, x4)

inst_56:
// rs1_w0_val == 134217728, 
// opcode: uclip32 ; op1:x30; dest:x31; op1val:0x8000000;  immval:0x1c
TEST_PKIMM_OP( uclip32, x31, x30, 0x00000000, 0x8000000, 0x1c, x30, x3, 264, x4)

inst_57:
// rs1_w0_val == 67108864, 
// opcode: uclip32 ; op1:x30; dest:x31; op1val:0x4000000;  immval:0xc
TEST_PKIMM_OP( uclip32, x31, x30, 0x00000000, 0x4000000, 0xc, x30, x3, 272, x4)

inst_58:
// rs1_w0_val == 33554432, 
// opcode: uclip32 ; op1:x30; dest:x31; op1val:0x2000000;  immval:0x13
TEST_PKIMM_OP( uclip32, x31, x30, 0x00000000, 0x2000000, 0x13, x30, x3, 280, x4)

inst_59:
// rs1_w0_val == 16777216, 
// opcode: uclip32 ; op1:x30; dest:x31; op1val:0x1000000;  immval:0x16
TEST_PKIMM_OP( uclip32, x31, x30, 0x00000000, 0x1000000, 0x16, x30, x3, 288, x4)

inst_60:
// rs1_w0_val == 8388608, 
// opcode: uclip32 ; op1:x30; dest:x31; op1val:0x800000;  immval:0x12
TEST_PKIMM_OP( uclip32, x31, x30, 0x00000000, 0x800000, 0x12, x30, x3, 296, x4)

inst_61:
// rs1_w0_val == 2097152, 
// opcode: uclip32 ; op1:x30; dest:x31; op1val:0x200000;  immval:0xd
TEST_PKIMM_OP( uclip32, x31, x30, 0x00000000, 0x200000, 0xd, x30, x3, 304, x4)

inst_62:
// rs1_w0_val == 1048576, 
// opcode: uclip32 ; op1:x30; dest:x31; op1val:0x100000;  immval:0xf
TEST_PKIMM_OP( uclip32, x31, x30, 0x00000000, 0x100000, 0xf, x30, x3, 312, x4)

inst_63:
// rs1_w0_val == 65536, 
// opcode: uclip32 ; op1:x30; dest:x31; op1val:0x010000;  immval:0xe
TEST_PKIMM_OP( uclip32, x31, x30, 0x00000000, 0x010000, 0xe, x30, x3, 320, x4)

inst_64:
// rs1_w0_val == 32768, 
// opcode: uclip32 ; op1:x30; dest:x31; op1val:0x008000;  immval:0x1a
TEST_PKIMM_OP( uclip32, x31, x30, 0x00000000, 0x008000, 0x1a, x30, x3, 328, x4)

inst_65:
// rs1_w0_val == 8192, 
// opcode: uclip32 ; op1:x30; dest:x31; op1val:0x002000;  immval:0xf
TEST_PKIMM_OP( uclip32, x31, x30, 0x00000000, 0x002000, 0xf, x30, x3, 336, x4)

inst_66:
// rs1_w0_val == 2, 
// opcode: uclip32 ; op1:x30; dest:x31; op1val:0x000002;  immval:0xd
TEST_PKIMM_OP( uclip32, x31, x30, 0x00000000, 0x000002, 0xd, x30, x3, 344, x4)

inst_67:
// rs1_w0_val == 1, 
// opcode: uclip32 ; op1:x30; dest:x31; op1val:0x000001;  immval:0x18
TEST_PKIMM_OP( uclip32, x31, x30, 0x00000000, 0x000001, 0x18, x30, x3, 352, x4)

inst_68:
// rs1_w0_val == 4294967295, 
// opcode: uclip32 ; op1:x30; dest:x31; op1val:0xffffffff;  immval:0xa
TEST_PKIMM_OP( uclip32, x31, x30, 0x00000000, 0xffffffff, 0xa, x30, x3, 360, x4)

inst_69:
// rs1_w0_val == 128, 
// opcode: uclip32 ; op1:x30; dest:x31; op1val:0x000080;  immval:0x0
TEST_PKIMM_OP( uclip32, x31, x30, 0x00000000, 0x000080, 0x0, x30, x3, 368, x4)

inst_70:
// rs1_w0_val == 4294967287, 
// opcode: uclip32 ; op1:x30; dest:x31; op1val:0xfffffff7;  immval:0xb
TEST_PKIMM_OP( uclip32, x31, x30, 0x00000000, 0xfffffff7, 0xb, x30, x3, 376, x4)

inst_71:
// rs1_w0_val == 4096, 
// opcode: uclip32 ; op1:x30; dest:x31; op1val:0x001000;  immval:0xc
TEST_PKIMM_OP( uclip32, x31, x30, 0x00000000, 0x001000, 0xc, x30, x3, 384, x4)

inst_72:
// rs1_w0_val == 2048, 
// opcode: uclip32 ; op1:x30; dest:x31; op1val:0x000800;  immval:0xe
TEST_PKIMM_OP( uclip32, x31, x30, 0x00000000, 0x000800, 0xe, x30, x3, 392, x4)

inst_73:
// rs1_w0_val == 1024, 
// opcode: uclip32 ; op1:x30; dest:x31; op1val:0x000400;  immval:0x12
TEST_PKIMM_OP( uclip32, x31, x30, 0x00000000, 0x000400, 0x12, x30, x3, 400, x4)

inst_74:
// rs1_w0_val == 512, 
// opcode: uclip32 ; op1:x30; dest:x31; op1val:0x000200;  immval:0xa
TEST_PKIMM_OP( uclip32, x31, x30, 0x00000000, 0x000200, 0xa, x30, x3, 408, x4)

inst_75:
// rs1_w0_val == 256, 
// opcode: uclip32 ; op1:x30; dest:x31; op1val:0x000100;  immval:0x3
TEST_PKIMM_OP( uclip32, x31, x30, 0x00000000, 0x000100, 0x3, x30, x3, 416, x4)

inst_76:
// rs1_w0_val == 4294967167, 
// opcode: uclip32 ; op1:x30; dest:x31; op1val:0xffffff7f;  immval:0x13
TEST_PKIMM_OP( uclip32, x31, x30, 0x00000000, 0xffffff7f, 0x13, x30, x3, 424, x4)

inst_77:
// rs1_w0_val == 64, 
// opcode: uclip32 ; op1:x30; dest:x31; op1val:0x000040;  immval:0x4
TEST_PKIMM_OP( uclip32, x31, x30, 0x00000000, 0x000040, 0x4, x30, x3, 432, x4)

inst_78:
// rs1_w0_val == 32, 
// opcode: uclip32 ; op1:x30; dest:x31; op1val:0x000020;  immval:0x1
TEST_PKIMM_OP( uclip32, x31, x30, 0x00000000, 0x000020, 0x1, x30, x3, 440, x4)

inst_79:
// rs1_w0_val == 16, 
// opcode: uclip32 ; op1:x30; dest:x31; op1val:0x000010;  immval:0x14
TEST_PKIMM_OP( uclip32, x31, x30, 0x00000000, 0x000010, 0x14, x30, x3, 448, x4)

inst_80:
// rs1_w0_val == 8, 
// opcode: uclip32 ; op1:x30; dest:x31; op1val:0x000008;  immval:0x1e
TEST_PKIMM_OP( uclip32, x31, x30, 0x00000000, 0x000008, 0x1e, x30, x3, 456, x4)

inst_81:
// imm_val == 7, 
// opcode: uclip32 ; op1:x30; dest:x31; op1val:0x00000e;  immval:0x7
TEST_PKIMM_OP( uclip32, x31, x30, 0x00000000, 0x00000e, 0x7, x30, x3, 464, x4)
#endif


RVTEST_CODE_END
RVMODEL_HALT

RVTEST_DATA_BEGIN
.align 4
rvtest_data:
.word 0xbabecafe
.word 0xabecafeb
.word 0xbecafeba
.word 0xecafebab
RVTEST_DATA_END

RVMODEL_DATA_BEGIN


signature_x5_0:
    .fill 0*(XLEN/32),4,0xdeadbeef


signature_x5_1:
    .fill 46*(XLEN/32),4,0xdeadbeef


signature_x3_0:
    .fill 118*(XLEN/32),4,0xdeadbeef

#ifdef rvtest_mtrap_routine

mtrap_sigptr:
    .fill 64*(XLEN/32),4,0xdeadbeef

#endif

#ifdef rvtest_gpr_save

gpr_save:
    .fill 32*(XLEN/32),4,0xdeadbeef

#endif

RVMODEL_DATA_END
