
// -----------
// This file was generated by riscv_ctg (https://github.com/riscv-software-src/riscv-ctg)
// version   : 0.6.3
// timestamp : Sat Apr 23 14:53:29 2022 GMT
// usage     : riscv_ctg \
//                  --cgf /scratch/git-repo/github/riscv_ctg/sample_cgfs/dataset.cgf \
//                  --cgf /scratch/git-repo/github/riscv_ctg/sample_cgfs/rv32ip.cgf \
//                  --xlen 32  \
//                  --randomize \
// -----------
//
// -----------
// Copyright (c) 2020. RISC-V International. All rights reserved.
// SPDX-License-Identifier: BSD-3-Clause
// -----------
//
// This assembly file tests the ukaddw instruction of the RISC-V RV32PZicsr extension for the ukaddw covergroup.
// 
#include "model_test.h"
#include "arch_test.h"
RVTEST_ISA("RV32IPZicsr")

.section .text.init
.org 0x80
.globl rvtest_entry_point
rvtest_entry_point:
RVMODEL_BOOT
RVTEST_CODE_BEGIN

#ifdef TEST_CASE_1

RVTEST_CASE(0,"//check ISA:=regex(.*32.*);check ISA:=regex(.*I.*P.*Zicsr.*);def TEST_CASE_1=True;",ukaddw)

RVTEST_VXSAT_ENABLE()
RVTEST_SIGBASE(x1,signature_x1_1)

inst_0:
// rs1 != rs2  and rs1 != rd and rs2 != rd, rs1==x24, rs2==x8, rd==x11, rs1_w0_val == 0, rs2_w0_val == 131072
// opcode: ukaddw ; op1:x24; op2:x8; dest:x11; op1val:0x000000;  op2val:0x020000
TEST_PKRR_OP(ukaddw, x11, x24, x8, 0x00000000, 0x000000, 0x020000, x24, x1, 0, x2)

inst_1:
// rs1 == rs2 != rd, rs1==x3, rs2==x3, rd==x4, rs1_w0_val != rs2_w0_val and rs1_w0_val > 0 and rs2_w0_val > 0, rs1_w0_val == 8
// opcode: ukaddw ; op1:x3; op2:x3; dest:x4; op1val:0x000008;  op2val:0x000011
TEST_PKRR_OP(ukaddw, x4, x3, x3, 0x00000000, 0x000008, 0x000011, x3, x1, 8, x2)

inst_2:
// rs1 == rd != rs2, rs1==x27, rs2==x10, rd==x27, rs1_w0_val == rs2_w0_val and rs1_w0_val > 0 and rs2_w0_val > 0, rs1_w0_val == 1, rs2_w0_val == 1
// opcode: ukaddw ; op1:x27; op2:x10; dest:x27; op1val:0x000001;  op2val:0x000001
TEST_PKRR_OP(ukaddw, x27, x27, x10, 0x00000000, 0x000001, 0x000001, x27, x1, 16, x2)

inst_3:
// rs1 == rs2 == rd, rs1==x31, rs2==x31, rd==x31, rs2_w0_val == 2863311530, rs1_w0_val == 65536
// opcode: ukaddw ; op1:x31; op2:x31; dest:x31; op1val:0x010000;  op2val:0xaaaaaaaa
TEST_PKRR_OP(ukaddw, x31, x31, x31, 0x00000000, 0x010000, 0xaaaaaaaa, x31, x1, 24, x2)

inst_4:
// rs2 == rd != rs1, rs1==x13, rs2==x14, rd==x14, rs2_w0_val == 1431655765, 
// opcode: ukaddw ; op1:x13; op2:x14; dest:x14; op1val:0x00000b;  op2val:0x55555555
TEST_PKRR_OP(ukaddw, x14, x13, x14, 0x00000000, 0x00000b, 0x55555555, x13, x1, 32, x2)

inst_5:
// rs1==x6, rs2==x17, rd==x26, rs2_w0_val == 2147483647, rs1_w0_val == 536870912
// opcode: ukaddw ; op1:x6; op2:x17; dest:x26; op1val:0x20000000;  op2val:0x7fffffff
TEST_PKRR_OP(ukaddw, x26, x6, x17, 0x00000000, 0x20000000, 0x7fffffff, x6, x1, 40, x2)

inst_6:
// rs1==x5, rs2==x27, rd==x22, rs2_w0_val == 3221225471, 
// opcode: ukaddw ; op1:x5; op2:x27; dest:x22; op1val:0x20000000;  op2val:0xbfffffff
TEST_PKRR_OP(ukaddw, x22, x5, x27, 0x00000000, 0x20000000, 0xbfffffff, x5, x1, 48, x2)

inst_7:
// rs1==x7, rs2==x21, rd==x25, rs2_w0_val == 3758096383, rs1_w0_val == 32768
// opcode: ukaddw ; op1:x7; op2:x21; dest:x25; op1val:0x008000;  op2val:0xdfffffff
TEST_PKRR_OP(ukaddw, x25, x7, x21, 0x00000000, 0x008000, 0xdfffffff, x7, x1, 56, x2)

inst_8:
// rs1==x16, rs2==x26, rd==x21, rs2_w0_val == 4026531839, rs1_w0_val == 2
// opcode: ukaddw ; op1:x16; op2:x26; dest:x21; op1val:0x000002;  op2val:0xefffffff
TEST_PKRR_OP(ukaddw, x21, x16, x26, 0x00000000, 0x000002, 0xefffffff, x16, x1, 64, x2)

inst_9:
// rs1==x11, rs2==x18, rd==x7, rs2_w0_val == 4160749567, rs1_w0_val == 4294901759
// opcode: ukaddw ; op1:x11; op2:x18; dest:x7; op1val:0xfffeffff;  op2val:0xf7ffffff
TEST_PKRR_OP(ukaddw, x7, x11, x18, 0x00000000, 0xfffeffff, 0xf7ffffff, x11, x1, 72, x2)

inst_10:
// rs1==x29, rs2==x24, rd==x0, rs2_w0_val == 4227858431, 
// opcode: ukaddw ; op1:x29; op2:x24; dest:x0; op1val:0x000009;  op2val:0xfbffffff
TEST_PKRR_OP(ukaddw, x0, x29, x24, 0x00000000, 0x000009, 0xfbffffff, x29, x1, 80, x2)

inst_11:
// rs1==x28, rs2==x15, rd==x16, rs2_w0_val == 4261412863, rs1_w0_val == 131072
// opcode: ukaddw ; op1:x28; op2:x15; dest:x16; op1val:0x020000;  op2val:0xfdffffff
TEST_PKRR_OP(ukaddw, x16, x28, x15, 0x00000000, 0x020000, 0xfdffffff, x28, x1, 88, x2)

inst_12:
// rs1==x9, rs2==x22, rd==x20, rs2_w0_val == 4278190079, 
// opcode: ukaddw ; op1:x9; op2:x22; dest:x20; op1val:0x020000;  op2val:0xfeffffff
TEST_PKRR_OP(ukaddw, x20, x9, x22, 0x00000000, 0x020000, 0xfeffffff, x9, x1, 96, x2)

inst_13:
// rs1==x17, rs2==x29, rd==x12, rs2_w0_val == 4286578687, 
// opcode: ukaddw ; op1:x17; op2:x29; dest:x12; op1val:0x00000b;  op2val:0xff7fffff
TEST_PKRR_OP(ukaddw, x12, x17, x29, 0x00000000, 0x00000b, 0xff7fffff, x17, x1, 104, x2)

inst_14:
// rs1==x25, rs2==x23, rd==x6, rs2_w0_val == 4290772991, rs1_w0_val == 2147483648
// opcode: ukaddw ; op1:x25; op2:x23; dest:x6; op1val:0x80000000;  op2val:0xffbfffff
TEST_PKRR_OP(ukaddw, x6, x25, x23, 0x00000000, 0x80000000, 0xffbfffff, x25, x1, 112, x19)
RVTEST_SIGBASE(x20,signature_x20_0)

inst_15:
// rs1==x14, rs2==x28, rd==x8, rs2_w0_val == 4292870143, rs1_w0_val == 4294967039
// opcode: ukaddw ; op1:x14; op2:x28; dest:x8; op1val:0xfffffeff;  op2val:0xffdfffff
TEST_PKRR_OP(ukaddw, x8, x14, x28, 0x00000000, 0xfffffeff, 0xffdfffff, x14, x20, 0, x19)

inst_16:
// rs1==x21, rs2==x9, rd==x17, rs2_w0_val == 4293918719, 
// opcode: ukaddw ; op1:x21; op2:x9; dest:x17; op1val:0xfffffeff;  op2val:0xffefffff
TEST_PKRR_OP(ukaddw, x17, x21, x9, 0x00000000, 0xfffffeff, 0xffefffff, x21, x20, 8, x19)

inst_17:
// rs1==x0, rs2==x11, rd==x5, rs2_w0_val == 4294443007, rs1_w0_val == 4294959103
// opcode: ukaddw ; op1:x0; op2:x11; dest:x5; op1val:0xffffdfff;  op2val:0xfff7ffff
TEST_PKRR_OP(ukaddw, x5, x0, x11, 0x00000000, 0xffffdfff, 0xfff7ffff, x0, x20, 16, x19)

inst_18:
// rs1==x2, rs2==x1, rd==x28, rs2_w0_val == 4294705151, rs1_w0_val == 4294967293
// opcode: ukaddw ; op1:x2; op2:x1; dest:x28; op1val:0xfffffffd;  op2val:0xfffbffff
TEST_PKRR_OP(ukaddw, x28, x2, x1, 0x00000000, 0xfffffffd, 0xfffbffff, x2, x20, 24, x19)

inst_19:
// rs1==x30, rs2==x7, rd==x24, rs2_w0_val == 4294836223, 
// opcode: ukaddw ; op1:x30; op2:x7; dest:x24; op1val:0x20000000;  op2val:0xfffdffff
TEST_PKRR_OP(ukaddw, x24, x30, x7, 0x00000000, 0x20000000, 0xfffdffff, x30, x20, 32, x19)

inst_20:
// rs1==x12, rs2==x2, rd==x30, rs2_w0_val == 4294901759, rs1_w0_val == 1073741824
// opcode: ukaddw ; op1:x12; op2:x2; dest:x30; op1val:0x40000000;  op2val:0xfffeffff
TEST_PKRR_OP(ukaddw, x30, x12, x2, 0x00000000, 0x40000000, 0xfffeffff, x12, x20, 40, x19)

inst_21:
// rs1==x22, rs2==x25, rd==x3, rs2_w0_val == 4294934527, rs1_w0_val == 1048576
// opcode: ukaddw ; op1:x22; op2:x25; dest:x3; op1val:0x100000;  op2val:0xffff7fff
TEST_PKRR_OP(ukaddw, x3, x22, x25, 0x00000000, 0x100000, 0xffff7fff, x22, x20, 48, x19)

inst_22:
// rs1==x8, rs2==x4, rd==x15, rs2_w0_val == 4294950911, rs1_w0_val == 16777216
// opcode: ukaddw ; op1:x8; op2:x4; dest:x15; op1val:0x1000000;  op2val:0xffffbfff
TEST_PKRR_OP(ukaddw, x15, x8, x4, 0x00000000, 0x1000000, 0xffffbfff, x8, x20, 56, x19)

inst_23:
// rs1==x15, rs2==x0, rd==x10, rs2_w0_val == 4294959103, 
// opcode: ukaddw ; op1:x15; op2:x0; dest:x10; op1val:0xfffffeff;  op2val:0xffffdfff
TEST_PKRR_OP(ukaddw, x10, x15, x0, 0x00000000, 0xfffffeff, 0xffffdfff, x15, x20, 64, x19)

inst_24:
// rs1==x1, rs2==x13, rd==x9, rs2_w0_val == 4294963199, rs1_w0_val == 1024
// opcode: ukaddw ; op1:x1; op2:x13; dest:x9; op1val:0x000400;  op2val:0xffffefff
TEST_PKRR_OP(ukaddw, x9, x1, x13, 0x00000000, 0x000400, 0xffffefff, x1, x20, 72, x19)

inst_25:
// rs1==x10, rs2==x30, rd==x13, rs2_w0_val == 4294965247, 
// opcode: ukaddw ; op1:x10; op2:x30; dest:x13; op1val:0x000011;  op2val:0xfffff7ff
TEST_PKRR_OP(ukaddw, x13, x10, x30, 0x00000000, 0x000011, 0xfffff7ff, x10, x20, 80, x19)

inst_26:
// rs1==x4, rs2==x5, rd==x29, rs2_w0_val == 4294966271, rs1_w0_val == 4
// opcode: ukaddw ; op1:x4; op2:x5; dest:x29; op1val:0x000004;  op2val:0xfffffbff
TEST_PKRR_OP(ukaddw, x29, x4, x5, 0x00000000, 0x000004, 0xfffffbff, x4, x20, 88, x19)

inst_27:
// rs1==x26, rs2==x12, rd==x23, rs2_w0_val == 4294966783, rs1_w0_val == 4294966783
// opcode: ukaddw ; op1:x26; op2:x12; dest:x23; op1val:0xfffffdff;  op2val:0xfffffdff
TEST_PKRR_OP(ukaddw, x23, x26, x12, 0x00000000, 0xfffffdff, 0xfffffdff, x26, x20, 96, x19)

inst_28:
// rs1==x18, rs2==x16, rd==x2, rs2_w0_val == 4294967039, 
// opcode: ukaddw ; op1:x18; op2:x16; dest:x2; op1val:0x000007;  op2val:0xfffffeff
TEST_PKRR_OP(ukaddw, x2, x18, x16, 0x00000000, 0x000007, 0xfffffeff, x18, x20, 104, x19)

inst_29:
// rs1==x23, rs2==x6, rd==x19, rs2_w0_val == 4294967167, rs1_w0_val == 268435456
// opcode: ukaddw ; op1:x23; op2:x6; dest:x19; op1val:0x10000000;  op2val:0xffffff7f
TEST_PKRR_OP(ukaddw, x19, x23, x6, 0x00000000, 0x10000000, 0xffffff7f, x23, x20, 112, x3)
RVTEST_SIGBASE(x2,signature_x2_0)

inst_30:
// rs1==x20, rs2==x19, rd==x18, rs2_w0_val == 4294967231, 
// opcode: ukaddw ; op1:x20; op2:x19; dest:x18; op1val:0x000006;  op2val:0xffffffbf
TEST_PKRR_OP(ukaddw, x18, x20, x19, 0x00000000, 0x000006, 0xffffffbf, x20, x2, 0, x3)

inst_31:
// rs1==x19, rs2==x20, rd==x1, rs2_w0_val == 4294967263, rs1_w0_val == 4294967279
// opcode: ukaddw ; op1:x19; op2:x20; dest:x1; op1val:0xffffffef;  op2val:0xffffffdf
TEST_PKRR_OP(ukaddw, x1, x19, x20, 0x00000000, 0xffffffef, 0xffffffdf, x19, x2, 8, x3)

inst_32:
// rs2_w0_val == 4294967279, 
// opcode: ukaddw ; op1:x30; op2:x29; dest:x31; op1val:0x1000000;  op2val:0xffffffef
TEST_PKRR_OP(ukaddw, x31, x30, x29, 0x00000000, 0x1000000, 0xffffffef, x30, x2, 16, x3)

inst_33:
// rs2_w0_val == 4294967287, 
// opcode: ukaddw ; op1:x30; op2:x29; dest:x31; op1val:0x00000f;  op2val:0xfffffff7
TEST_PKRR_OP(ukaddw, x31, x30, x29, 0x00000000, 0x00000f, 0xfffffff7, x30, x2, 24, x3)

inst_34:
// rs2_w0_val == 4294967291, 
// opcode: ukaddw ; op1:x30; op2:x29; dest:x31; op1val:0xfffffffd;  op2val:0xfffffffb
TEST_PKRR_OP(ukaddw, x31, x30, x29, 0x00000000, 0xfffffffd, 0xfffffffb, x30, x2, 32, x3)

inst_35:
// rs2_w0_val == 4294967293, rs1_w0_val == 16384
// opcode: ukaddw ; op1:x30; op2:x29; dest:x31; op1val:0x004000;  op2val:0xfffffffd
TEST_PKRR_OP(ukaddw, x31, x30, x29, 0x00000000, 0x004000, 0xfffffffd, x30, x2, 40, x3)

inst_36:
// rs2_w0_val == 4294967294, 
// opcode: ukaddw ; op1:x30; op2:x29; dest:x31; op1val:0x000002;  op2val:0xfffffffe
TEST_PKRR_OP(ukaddw, x31, x30, x29, 0x00000000, 0x000002, 0xfffffffe, x30, x2, 48, x3)

inst_37:
// rs2_w0_val == 2147483648, 
// opcode: ukaddw ; op1:x30; op2:x29; dest:x31; op1val:0xffffdfff;  op2val:0x80000000
TEST_PKRR_OP(ukaddw, x31, x30, x29, 0x00000000, 0xffffdfff, 0x80000000, x30, x2, 56, x3)

inst_38:
// rs2_w0_val == 1073741824, rs1_w0_val == 3221225471
// opcode: ukaddw ; op1:x30; op2:x29; dest:x31; op1val:0xbfffffff;  op2val:0x40000000
TEST_PKRR_OP(ukaddw, x31, x30, x29, 0x00000000, 0xbfffffff, 0x40000000, x30, x2, 64, x3)

inst_39:
// rs2_w0_val == 536870912, rs1_w0_val == 4278190079
// opcode: ukaddw ; op1:x30; op2:x29; dest:x31; op1val:0xfeffffff;  op2val:0x20000000
TEST_PKRR_OP(ukaddw, x31, x30, x29, 0x00000000, 0xfeffffff, 0x20000000, x30, x2, 72, x3)

inst_40:
// rs2_w0_val == 268435456, rs1_w0_val == 4294963199
// opcode: ukaddw ; op1:x30; op2:x29; dest:x31; op1val:0xffffefff;  op2val:0x10000000
TEST_PKRR_OP(ukaddw, x31, x30, x29, 0x00000000, 0xffffefff, 0x10000000, x30, x2, 80, x3)

inst_41:
// rs2_w0_val == 134217728, rs1_w0_val == 4261412863
// opcode: ukaddw ; op1:x30; op2:x29; dest:x31; op1val:0xfdffffff;  op2val:0x8000000
TEST_PKRR_OP(ukaddw, x31, x30, x29, 0x00000000, 0xfdffffff, 0x8000000, x30, x2, 88, x3)

inst_42:
// rs2_w0_val == 67108864, rs1_w0_val == 524288
// opcode: ukaddw ; op1:x30; op2:x29; dest:x31; op1val:0x080000;  op2val:0x4000000
TEST_PKRR_OP(ukaddw, x31, x30, x29, 0x00000000, 0x080000, 0x4000000, x30, x2, 96, x3)

inst_43:
// rs2_w0_val == 33554432, 
// opcode: ukaddw ; op1:x30; op2:x29; dest:x31; op1val:0xfffeffff;  op2val:0x2000000
TEST_PKRR_OP(ukaddw, x31, x30, x29, 0x00000000, 0xfffeffff, 0x2000000, x30, x2, 104, x3)

inst_44:
// rs2_w0_val == 16777216, rs1_w0_val == 256
// opcode: ukaddw ; op1:x30; op2:x29; dest:x31; op1val:0x000100;  op2val:0x1000000
TEST_PKRR_OP(ukaddw, x31, x30, x29, 0x00000000, 0x000100, 0x1000000, x30, x2, 112, x3)

inst_45:
// rs2_w0_val == 8388608, rs1_w0_val == 16
// opcode: ukaddw ; op1:x30; op2:x29; dest:x31; op1val:0x000010;  op2val:0x800000
TEST_PKRR_OP(ukaddw, x31, x30, x29, 0x00000000, 0x000010, 0x800000, x30, x2, 120, x3)

inst_46:
// rs1_w0_val == 128, 
// opcode: ukaddw ; op1:x30; op2:x29; dest:x31; op1val:0x000080;  op2val:0xfffffffb
TEST_PKRR_OP(ukaddw, x31, x30, x29, 0x00000000, 0x000080, 0xfffffffb, x30, x2, 128, x3)

inst_47:
// rs1_w0_val == 64, rs2_w0_val == 4194304
// opcode: ukaddw ; op1:x30; op2:x29; dest:x31; op1val:0x000040;  op2val:0x400000
TEST_PKRR_OP(ukaddw, x31, x30, x29, 0x00000000, 0x000040, 0x400000, x30, x2, 136, x3)

inst_48:
// rs1_w0_val == 32, 
// opcode: ukaddw ; op1:x30; op2:x29; dest:x31; op1val:0x000020;  op2val:0x000003
TEST_PKRR_OP(ukaddw, x31, x30, x29, 0x00000000, 0x000020, 0x000003, x30, x2, 144, x3)

inst_49:
// rs1_w0_val == 4294967295, rs2_w0_val == 8
// opcode: ukaddw ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x000008
TEST_PKRR_OP(ukaddw, x31, x30, x29, 0x00000000, 0xffffffff, 0x000008, x30, x2, 152, x3)

inst_50:
// rs2_w0_val == 2097152, rs1_w0_val == 4294443007
// opcode: ukaddw ; op1:x30; op2:x29; dest:x31; op1val:0xfff7ffff;  op2val:0x200000
TEST_PKRR_OP(ukaddw, x31, x30, x29, 0x00000000, 0xfff7ffff, 0x200000, x30, x2, 160, x3)

inst_51:
// rs2_w0_val == 1048576, rs1_w0_val == 4294967294
// opcode: ukaddw ; op1:x30; op2:x29; dest:x31; op1val:0xfffffffe;  op2val:0x100000
TEST_PKRR_OP(ukaddw, x31, x30, x29, 0x00000000, 0xfffffffe, 0x100000, x30, x2, 168, x3)

inst_52:
// rs2_w0_val == 524288, rs1_w0_val == 512
// opcode: ukaddw ; op1:x30; op2:x29; dest:x31; op1val:0x000200;  op2val:0x080000
TEST_PKRR_OP(ukaddw, x31, x30, x29, 0x00000000, 0x000200, 0x080000, x30, x2, 176, x3)

inst_53:
// rs2_w0_val == 262144, 
// opcode: ukaddw ; op1:x30; op2:x29; dest:x31; op1val:0x000002;  op2val:0x040000
TEST_PKRR_OP(ukaddw, x31, x30, x29, 0x00000000, 0x000002, 0x040000, x30, x2, 184, x3)

inst_54:
// rs2_w0_val == 65536, 
// opcode: ukaddw ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0x010000
TEST_PKRR_OP(ukaddw, x31, x30, x29, 0x00000000, 0xffffffff, 0x010000, x30, x2, 192, x3)

inst_55:
// rs2_w0_val == 32768, 
// opcode: ukaddw ; op1:x30; op2:x29; dest:x31; op1val:0x000004;  op2val:0x008000
TEST_PKRR_OP(ukaddw, x31, x30, x29, 0x00000000, 0x000004, 0x008000, x30, x2, 200, x3)

inst_56:
// rs2_w0_val == 16384, 
// opcode: ukaddw ; op1:x30; op2:x29; dest:x31; op1val:0x000020;  op2val:0x004000
TEST_PKRR_OP(ukaddw, x31, x30, x29, 0x00000000, 0x000020, 0x004000, x30, x2, 208, x3)

inst_57:
// rs2_w0_val == 8192, rs1_w0_val == 4026531839
// opcode: ukaddw ; op1:x30; op2:x29; dest:x31; op1val:0xefffffff;  op2val:0x002000
TEST_PKRR_OP(ukaddw, x31, x30, x29, 0x00000000, 0xefffffff, 0x002000, x30, x2, 216, x3)

inst_58:
// rs2_w0_val == 4096, rs1_w0_val == 67108864
// opcode: ukaddw ; op1:x30; op2:x29; dest:x31; op1val:0x4000000;  op2val:0x001000
TEST_PKRR_OP(ukaddw, x31, x30, x29, 0x00000000, 0x4000000, 0x001000, x30, x2, 224, x3)

inst_59:
// rs2_w0_val == 2048, 
// opcode: ukaddw ; op1:x30; op2:x29; dest:x31; op1val:0xefffffff;  op2val:0x000800
TEST_PKRR_OP(ukaddw, x31, x30, x29, 0x00000000, 0xefffffff, 0x000800, x30, x2, 232, x3)

inst_60:
// rs2_w0_val == 1024, 
// opcode: ukaddw ; op1:x30; op2:x29; dest:x31; op1val:0x004000;  op2val:0x000400
TEST_PKRR_OP(ukaddw, x31, x30, x29, 0x00000000, 0x004000, 0x000400, x30, x2, 240, x3)

inst_61:
// rs2_w0_val == 512, rs1_w0_val == 4294950911
// opcode: ukaddw ; op1:x30; op2:x29; dest:x31; op1val:0xffffbfff;  op2val:0x000200
TEST_PKRR_OP(ukaddw, x31, x30, x29, 0x00000000, 0xffffbfff, 0x000200, x30, x2, 248, x3)

inst_62:
// rs2_w0_val == 256, rs1_w0_val == 4294967167
// opcode: ukaddw ; op1:x30; op2:x29; dest:x31; op1val:0xffffff7f;  op2val:0x000100
TEST_PKRR_OP(ukaddw, x31, x30, x29, 0x00000000, 0xffffff7f, 0x000100, x30, x2, 256, x3)

inst_63:
// rs2_w0_val == 128, 
// opcode: ukaddw ; op1:x30; op2:x29; dest:x31; op1val:0xefffffff;  op2val:0x000080
TEST_PKRR_OP(ukaddw, x31, x30, x29, 0x00000000, 0xefffffff, 0x000080, x30, x2, 264, x3)

inst_64:
// rs2_w0_val == 64, 
// opcode: ukaddw ; op1:x30; op2:x29; dest:x31; op1val:0x4000000;  op2val:0x000040
TEST_PKRR_OP(ukaddw, x31, x30, x29, 0x00000000, 0x4000000, 0x000040, x30, x2, 272, x3)

inst_65:
// rs2_w0_val == 32, rs1_w0_val == 4294965247
// opcode: ukaddw ; op1:x30; op2:x29; dest:x31; op1val:0xfffff7ff;  op2val:0x000020
TEST_PKRR_OP(ukaddw, x31, x30, x29, 0x00000000, 0xfffff7ff, 0x000020, x30, x2, 280, x3)

inst_66:
// rs2_w0_val == 16, 
// opcode: ukaddw ; op1:x30; op2:x29; dest:x31; op1val:0x000200;  op2val:0x000010
TEST_PKRR_OP(ukaddw, x31, x30, x29, 0x00000000, 0x000200, 0x000010, x30, x2, 288, x3)

inst_67:
// rs2_w0_val == 4, 
// opcode: ukaddw ; op1:x30; op2:x29; dest:x31; op1val:0x010000;  op2val:0x000004
TEST_PKRR_OP(ukaddw, x31, x30, x29, 0x00000000, 0x010000, 0x000004, x30, x2, 296, x3)

inst_68:
// rs2_w0_val == 2, rs1_w0_val == 134217728
// opcode: ukaddw ; op1:x30; op2:x29; dest:x31; op1val:0x8000000;  op2val:0x000002
TEST_PKRR_OP(ukaddw, x31, x30, x29, 0x00000000, 0x8000000, 0x000002, x30, x2, 304, x3)

inst_69:
// rs2_w0_val == 4294967295, rs1_w0_val == 4194304
// opcode: ukaddw ; op1:x30; op2:x29; dest:x31; op1val:0x400000;  op2val:0xffffffff
TEST_PKRR_OP(ukaddw, x31, x30, x29, 0x00000000, 0x400000, 0xffffffff, x30, x2, 312, x3)

inst_70:
// rs2_w0_val == 0, 
// opcode: ukaddw ; op1:x30; op2:x29; dest:x31; op1val:0xfffffdff;  op2val:0x000000
TEST_PKRR_OP(ukaddw, x31, x30, x29, 0x00000000, 0xfffffdff, 0x000000, x30, x2, 320, x3)

inst_71:
// rs1_w0_val == 2863311530, 
// opcode: ukaddw ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaaa;  op2val:0x00000c
TEST_PKRR_OP(ukaddw, x31, x30, x29, 0x00000000, 0xaaaaaaaa, 0x00000c, x30, x2, 328, x3)

inst_72:
// rs1_w0_val == 1431655765, 
// opcode: ukaddw ; op1:x30; op2:x29; dest:x31; op1val:0x55555555;  op2val:0x000005
TEST_PKRR_OP(ukaddw, x31, x30, x29, 0x00000000, 0x55555555, 0x000005, x30, x2, 336, x3)

inst_73:
// rs1_w0_val == 2147483647, 
// opcode: ukaddw ; op1:x30; op2:x29; dest:x31; op1val:0x7fffffff;  op2val:0xfffff7ff
TEST_PKRR_OP(ukaddw, x31, x30, x29, 0x00000000, 0x7fffffff, 0xfffff7ff, x30, x2, 344, x3)

inst_74:
// rs1_w0_val == 3758096383, 
// opcode: ukaddw ; op1:x30; op2:x29; dest:x31; op1val:0xdfffffff;  op2val:0x000011
TEST_PKRR_OP(ukaddw, x31, x30, x29, 0x00000000, 0xdfffffff, 0x000011, x30, x2, 352, x3)

inst_75:
// rs1_w0_val == 4160749567, 
// opcode: ukaddw ; op1:x30; op2:x29; dest:x31; op1val:0xf7ffffff;  op2val:0x000080
TEST_PKRR_OP(ukaddw, x31, x30, x29, 0x00000000, 0xf7ffffff, 0x000080, x30, x2, 360, x3)

inst_76:
// rs1_w0_val == 4227858431, 
// opcode: ukaddw ; op1:x30; op2:x29; dest:x31; op1val:0xfbffffff;  op2val:0x4000000
TEST_PKRR_OP(ukaddw, x31, x30, x29, 0x00000000, 0xfbffffff, 0x4000000, x30, x2, 368, x3)

inst_77:
// rs1_w0_val == 4286578687, 
// opcode: ukaddw ; op1:x30; op2:x29; dest:x31; op1val:0xff7fffff;  op2val:0x20000000
TEST_PKRR_OP(ukaddw, x31, x30, x29, 0x00000000, 0xff7fffff, 0x20000000, x30, x2, 376, x3)

inst_78:
// rs1_w0_val == 4290772991, 
// opcode: ukaddw ; op1:x30; op2:x29; dest:x31; op1val:0xffbfffff;  op2val:0xfff7ffff
TEST_PKRR_OP(ukaddw, x31, x30, x29, 0x00000000, 0xffbfffff, 0xfff7ffff, x30, x2, 384, x3)

inst_79:
// rs1_w0_val == 4292870143, 
// opcode: ukaddw ; op1:x30; op2:x29; dest:x31; op1val:0xffdfffff;  op2val:0xffefffff
TEST_PKRR_OP(ukaddw, x31, x30, x29, 0x00000000, 0xffdfffff, 0xffefffff, x30, x2, 392, x3)

inst_80:
// rs1_w0_val == 4293918719, 
// opcode: ukaddw ; op1:x30; op2:x29; dest:x31; op1val:0xffefffff;  op2val:0xfffffbff
TEST_PKRR_OP(ukaddw, x31, x30, x29, 0x00000000, 0xffefffff, 0xfffffbff, x30, x2, 400, x3)

inst_81:
// rs1_w0_val == 4294967231, 
// opcode: ukaddw ; op1:x30; op2:x29; dest:x31; op1val:0xffffffbf;  op2val:0xfeffffff
TEST_PKRR_OP(ukaddw, x31, x30, x29, 0x00000000, 0xffffffbf, 0xfeffffff, x30, x2, 408, x3)

inst_82:
// rs1_w0_val == 4294967263, 
// opcode: ukaddw ; op1:x30; op2:x29; dest:x31; op1val:0xffffffdf;  op2val:0x00000d
TEST_PKRR_OP(ukaddw, x31, x30, x29, 0x00000000, 0xffffffdf, 0x00000d, x30, x2, 416, x3)

inst_83:
// rs1_w0_val == 4294967287, 
// opcode: ukaddw ; op1:x30; op2:x29; dest:x31; op1val:0xfffffff7;  op2val:0xffffffef
TEST_PKRR_OP(ukaddw, x31, x30, x29, 0x00000000, 0xfffffff7, 0xffffffef, x30, x2, 424, x3)

inst_84:
// rs1_w0_val == 4294967291, 
// opcode: ukaddw ; op1:x30; op2:x29; dest:x31; op1val:0xfffffffb;  op2val:0xfffffffd
TEST_PKRR_OP(ukaddw, x31, x30, x29, 0x00000000, 0xfffffffb, 0xfffffffd, x30, x2, 432, x3)

inst_85:
// rs1_w0_val == 33554432, 
// opcode: ukaddw ; op1:x30; op2:x29; dest:x31; op1val:0x2000000;  op2val:0x000003
TEST_PKRR_OP(ukaddw, x31, x30, x29, 0x00000000, 0x2000000, 0x000003, x30, x2, 440, x3)

inst_86:
// rs1_w0_val == 8388608, 
// opcode: ukaddw ; op1:x30; op2:x29; dest:x31; op1val:0x800000;  op2val:0x800000
TEST_PKRR_OP(ukaddw, x31, x30, x29, 0x00000000, 0x800000, 0x800000, x30, x2, 448, x3)

inst_87:
// rs1_w0_val == 2097152, 
// opcode: ukaddw ; op1:x30; op2:x29; dest:x31; op1val:0x200000;  op2val:0x000010
TEST_PKRR_OP(ukaddw, x31, x30, x29, 0x00000000, 0x200000, 0x000010, x30, x2, 456, x3)

inst_88:
// rs1_w0_val == 4294705151, 
// opcode: ukaddw ; op1:x30; op2:x29; dest:x31; op1val:0xfffbffff;  op2val:0xaaaaaaaa
TEST_PKRR_OP(ukaddw, x31, x30, x29, 0x00000000, 0xfffbffff, 0xaaaaaaaa, x30, x2, 464, x3)

inst_89:
// rs1_w0_val == 262144, 
// opcode: ukaddw ; op1:x30; op2:x29; dest:x31; op1val:0x040000;  op2val:0xffffbfff
TEST_PKRR_OP(ukaddw, x31, x30, x29, 0x00000000, 0x040000, 0xffffbfff, x30, x2, 472, x3)

inst_90:
// rs1_w0_val == 4294836223, 
// opcode: ukaddw ; op1:x30; op2:x29; dest:x31; op1val:0xfffdffff;  op2val:0x200000
TEST_PKRR_OP(ukaddw, x31, x30, x29, 0x00000000, 0xfffdffff, 0x200000, x30, x2, 480, x3)

inst_91:
// rs1_w0_val == 4294934527, 
// opcode: ukaddw ; op1:x30; op2:x29; dest:x31; op1val:0xffff7fff;  op2val:0x80000000
TEST_PKRR_OP(ukaddw, x31, x30, x29, 0x00000000, 0xffff7fff, 0x80000000, x30, x2, 488, x3)

inst_92:
// rs1_w0_val == 8192, 
// opcode: ukaddw ; op1:x30; op2:x29; dest:x31; op1val:0x002000;  op2val:0xfdffffff
TEST_PKRR_OP(ukaddw, x31, x30, x29, 0x00000000, 0x002000, 0xfdffffff, x30, x2, 496, x3)

inst_93:
// rs1_w0_val == 4096, 
// opcode: ukaddw ; op1:x30; op2:x29; dest:x31; op1val:0x001000;  op2val:0xffffffff
TEST_PKRR_OP(ukaddw, x31, x30, x29, 0x00000000, 0x001000, 0xffffffff, x30, x2, 504, x3)

inst_94:
// rs1_w0_val == 2048, 
// opcode: ukaddw ; op1:x30; op2:x29; dest:x31; op1val:0x000800;  op2val:0x100000
TEST_PKRR_OP(ukaddw, x31, x30, x29, 0x00000000, 0x000800, 0x100000, x30, x2, 512, x3)

inst_95:
// rs1_w0_val == 4294966271, 
// opcode: ukaddw ; op1:x30; op2:x29; dest:x31; op1val:0xfffffbff;  op2val:0xfffffeff
TEST_PKRR_OP(ukaddw, x31, x30, x29, 0x00000000, 0xfffffbff, 0xfffffeff, x30, x2, 520, x3)

inst_96:
// rs1_w0_val != rs2_w0_val and rs1_w0_val > 0 and rs2_w0_val > 0, rs1_w0_val == 8
// opcode: ukaddw ; op1:x30; op2:x29; dest:x31; op1val:0x000008;  op2val:0x000011
TEST_PKRR_OP(ukaddw, x31, x30, x29, 0x00000000, 0x000008, 0x000011, x30, x2, 528, x3)

inst_97:
// rs2_w0_val == 4227858431, 
// opcode: ukaddw ; op1:x30; op2:x29; dest:x31; op1val:0x000009;  op2val:0xfbffffff
TEST_PKRR_OP(ukaddw, x31, x30, x29, 0x00000000, 0x000009, 0xfbffffff, x30, x2, 536, x3)

inst_98:
// rs2_w0_val == 4294959103, 
// opcode: ukaddw ; op1:x30; op2:x29; dest:x31; op1val:0xfffffeff;  op2val:0xffffdfff
TEST_PKRR_OP(ukaddw, x31, x30, x29, 0x00000000, 0xfffffeff, 0xffffdfff, x30, x2, 544, x3)
#endif


RVTEST_CODE_END
RVMODEL_HALT

RVTEST_DATA_BEGIN
.align 4
rvtest_data:
.word 0xbabecafe
.word 0xabecafeb
.word 0xbecafeba
.word 0xecafebab
RVTEST_DATA_END

RVMODEL_DATA_BEGIN


signature_x1_0:
    .fill 0*(XLEN/32),4,0xdeadbeef


signature_x1_1:
    .fill 30*(XLEN/32),4,0xdeadbeef


signature_x20_0:
    .fill 30*(XLEN/32),4,0xdeadbeef


signature_x2_0:
    .fill 138*(XLEN/32),4,0xdeadbeef

#ifdef rvtest_mtrap_routine

mtrap_sigptr:
    .fill 64*(XLEN/32),4,0xdeadbeef

#endif

#ifdef rvtest_gpr_save

gpr_save:
    .fill 32*(XLEN/32),4,0xdeadbeef

#endif

RVMODEL_DATA_END
