
// -----------
// This file was generated by riscv_ctg (https://github.com/riscv-software-src/riscv-ctg)
// version   : 0.6.3
// timestamp : Sat Apr 23 14:53:29 2022 GMT
// usage     : riscv_ctg \
//                  --cgf /scratch/git-repo/github/riscv_ctg/sample_cgfs/dataset.cgf \
//                  --cgf /scratch/git-repo/github/riscv_ctg/sample_cgfs/rv32ip.cgf \
//                  --xlen 32  \
//                  --randomize \
// -----------
//
// -----------
// Copyright (c) 2020. RISC-V International. All rights reserved.
// SPDX-License-Identifier: BSD-3-Clause
// -----------
//
// This assembly file tests the ukmsr64 instruction of the RISC-V RV32PZicsr extension for the ukmsr64 covergroup.
// 
#include "model_test.h"
#include "arch_test.h"
RVTEST_ISA("RV32IPZicsr")

.section .text.init
.org 0x80
.globl rvtest_entry_point
rvtest_entry_point:
RVMODEL_BOOT
RVTEST_CODE_BEGIN

#ifdef TEST_CASE_1

RVTEST_CASE(0,"//check ISA:=regex(.*32.*);check ISA:=regex(.*I.*P.*Zicsr.*);def TEST_CASE_1=True;",ukmsr64)

RVTEST_VXSAT_ENABLE()
RVTEST_SIGBASE(x12,signature_x12_1)

inst_0:
// rs1 != rs2  and rs1 != rd and rs2 != rd, rs1==x25, rs2==x9, rd==x16, rs1_w0_val == 0, rs2_w0_val == 33554432
// opcode: ukmsr64 ; op1:x25; op2:x9; dest:x16; op1val:0x00000000;  op2val:0x02000000
TEST_PK64_PNN_OP(ukmsr64, x16, x17, x25, x9, 0x00000000, 0, 0x00000000, 0x02000000, x25, x12, 0, x13)

inst_1:
// rs1 == rs2 != rd, rs1==x30, rs2==x30, rd==x26, rs1_w0_val != rs2_w0_val and rs1_w0_val > 0 and rs2_w0_val > 0, rs1_w0_val == 8
// opcode: ukmsr64 ; op1:x30; op2:x30; dest:x26; op1val:0x00000008;  op2val:0x0000000b
TEST_PK64_PNN_OP(ukmsr64, x26, x27, x30, x30, 0x00000000, 0, 0x00000008, 0x0000000b, x30, x12, 12, x13)

inst_2:
// rs1 == rd != rs2, rs1==x28, rs2==x15, rd==x28, rs1_w0_val == rs2_w0_val and rs1_w0_val > 0 and rs2_w0_val > 0, rs1_w0_val == 4294901759, rs2_w0_val == 4294901759
// opcode: ukmsr64 ; op1:x28; op2:x15; dest:x28; op1val:0xfffeffff;  op2val:0xfffeffff
TEST_PK64_PNN_OP(ukmsr64, x28, x29, x28, x15, 0x00000000, 0, 0xfffeffff, 0xfffeffff, x28, x12, 24, x13)

inst_3:
// rs1 == rs2 == rd, rs1==x14, rs2==x14, rd==x14, rs2_w0_val == 2863311530, 
// opcode: ukmsr64 ; op1:x14; op2:x14; dest:x14; op1val:0x0000000b;  op2val:0xaaaaaaaa
TEST_PK64_PNN_OP(ukmsr64, x14, x15, x14, x14, 0x00000000, 0, 0x0000000b, 0xaaaaaaaa, x14, x12, 36, x13)

inst_4:
// rs2 == rd != rs1, rs1==x15, rs2==x20, rd==x20, rs2_w0_val == 1431655765, rs1_w0_val == 4293918719
// opcode: ukmsr64 ; op1:x15; op2:x20; dest:x20; op1val:0xffefffff;  op2val:0x55555555
TEST_PK64_PNN_OP(ukmsr64, x20, x21, x15, x20, 0x00000000, 0, 0xffefffff, 0x55555555, x15, x12, 48, x13)

inst_5:
// rs1==x4, rs2==x31, rd==x8, rs2_w0_val == 2147483647, rs1_w0_val == 4294963199
// opcode: ukmsr64 ; op1:x4; op2:x31; dest:x8; op1val:0xffffefff;  op2val:0x7fffffff
TEST_PK64_PNN_OP(ukmsr64, x8, x9, x4, x31, 0x00000000, 0, 0xffffefff, 0x7fffffff, x4, x12, 60, x13)

inst_6:
// rs1==x6, rs2==x5, rd==x24, rs2_w0_val == 3221225471, rs1_w0_val == 512
// opcode: ukmsr64 ; op1:x6; op2:x5; dest:x24; op1val:0x00000200;  op2val:0xbfffffff
TEST_PK64_PNN_OP(ukmsr64, x24, x25, x6, x5, 0x00000000, 0, 0x00000200, 0xbfffffff, x6, x12, 72, x13)

inst_7:
// rs1==x21, rs2==x28, rd==x18, rs2_w0_val == 3758096383, 
// opcode: ukmsr64 ; op1:x21; op2:x28; dest:x18; op1val:0x0000000f;  op2val:0xdfffffff
TEST_PK64_PNN_OP(ukmsr64, x18, x19, x21, x28, 0x00000000, 0, 0x0000000f, 0xdfffffff, x21, x12, 84, x13)

inst_8:
// rs1==x16, rs2==x17, rd==x2, rs2_w0_val == 4026531839, rs1_w0_val == 4294967279
// opcode: ukmsr64 ; op1:x16; op2:x17; dest:x2; op1val:0xffffffef;  op2val:0xefffffff
TEST_PK64_PNN_OP(ukmsr64, x2, x3, x16, x17, 0x00000000, 0, 0xffffffef, 0xefffffff, x16, x12, 96, x13)

inst_9:
// rs1==x26, rs2==x1, rd==x4, rs2_w0_val == 4160749567, rs1_w0_val == 2863311530
// opcode: ukmsr64 ; op1:x26; op2:x1; dest:x4; op1val:0xaaaaaaaa;  op2val:0xf7ffffff
TEST_PK64_PNN_OP(ukmsr64, x4, x5, x26, x1, 0x00000000, 0, 0xaaaaaaaa, 0xf7ffffff, x26, x12, 108, x13)

inst_10:
// rs1==x2, rs2==x7, rd==x6, rs2_w0_val == 4227858431, 
// opcode: ukmsr64 ; op1:x2; op2:x7; dest:x6; op1val:0x00000011;  op2val:0xfbffffff
TEST_PK64_PNN_OP(ukmsr64, x6, x7, x2, x7, 0x00000000, 0, 0x00000011, 0xfbffffff, x2, x12, 120, x13)

inst_11:
// rs1==x19, rs2==x25, rd==x10, rs2_w0_val == 4261412863, 
// opcode: ukmsr64 ; op1:x19; op2:x25; dest:x10; op1val:0x0000000c;  op2val:0xfdffffff
TEST_PK64_PNN_OP(ukmsr64, x10, x11, x19, x25, 0x00000000, 0, 0x0000000c, 0xfdffffff, x19, x12, 132, x13)
RVTEST_SIGBASE(x7,signature_x7_0)

inst_12:
// rs1==x27, rs2==x24, rd==x22, rs2_w0_val == 4278190079, rs1_w0_val == 4294950911
// opcode: ukmsr64 ; op1:x27; op2:x24; dest:x22; op1val:0xffffbfff;  op2val:0xfeffffff
TEST_PK64_PNN_OP(ukmsr64, x22, x23, x27, x24, 0x00000000, 0, 0xffffbfff, 0xfeffffff, x27, x7, 0, x8)

inst_13:
// rs1==x0, rs2==x10, rd==x12, rs2_w0_val == 4286578687, rs1_w0_val == 4294966271
// opcode: ukmsr64 ; op1:x0; op2:x10; dest:x12; op1val:0xfffffbff;  op2val:0xff7fffff
TEST_PK64_PNN_OP(ukmsr64, x12, x13, x0, x10, 0x00000000, 0, 0xfffffbff, 0xff7fffff, x0, x7, 12, x8)

inst_14:
// rs1==x24, rs2==x2, rd==x30, rs2_w0_val == 4290772991, 
// opcode: ukmsr64 ; op1:x24; op2:x2; dest:x30; op1val:0xffefffff;  op2val:0xffbfffff
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x24, x2, 0x00000000, 0, 0xffefffff, 0xffbfffff, x24, x7, 24, x8)

inst_15:
// rs1==x5, rs2==x6, rs2_w0_val == 4292870143, 
// opcode: ukmsr64 ; op1:x5; op2:x6; dest:x30; op1val:0x00000013;  op2val:0xffdfffff
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x5, x6, 0x00000000, 0, 0x00000013, 0xffdfffff, x5, x7, 36, x8)

inst_16:
// rs1==x31, rs2==x23, rs2_w0_val == 4293918719, rs1_w0_val == 1
// opcode: ukmsr64 ; op1:x31; op2:x23; dest:x28; op1val:0x00000001;  op2val:0xffefffff
TEST_PK64_PNN_OP(ukmsr64, x28, x29, x31, x23, 0x00000000, 0, 0x00000001, 0xffefffff, x31, x7, 48, x8)

inst_17:
// rs1==x23, rs2==x13, rs2_w0_val == 4294443007, rs1_w0_val == 33554432
// opcode: ukmsr64 ; op1:x23; op2:x13; dest:x30; op1val:0x02000000;  op2val:0xfff7ffff
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x23, x13, 0x00000000, 0, 0x02000000, 0xfff7ffff, x23, x7, 60, x8)

inst_18:
// rs1==x11, rs2==x26, rs2_w0_val == 4294705151, rs1_w0_val == 4294967231
// opcode: ukmsr64 ; op1:x11; op2:x26; dest:x18; op1val:0xffffffbf;  op2val:0xfffbffff
TEST_PK64_PNN_OP(ukmsr64, x18, x19, x11, x26, 0x00000000, 0, 0xffffffbf, 0xfffbffff, x11, x7, 72, x8)

inst_19:
// rs1==x29, rs2==x3, rs2_w0_val == 4294836223, rs1_w0_val == 4194304
// opcode: ukmsr64 ; op1:x29; op2:x3; dest:x24; op1val:0x00400000;  op2val:0xfffdffff
TEST_PK64_PNN_OP(ukmsr64, x24, x25, x29, x3, 0x00000000, 0, 0x00400000, 0xfffdffff, x29, x7, 84, x8)

inst_20:
// rs1==x9, rs2==x11, rs2_w0_val == 4294934527, rs1_w0_val == 16
// opcode: ukmsr64 ; op1:x9; op2:x11; dest:x4; op1val:0x00000010;  op2val:0xffff7fff
TEST_PK64_PNN_OP(ukmsr64, x4, x5, x9, x11, 0x00000000, 0, 0x00000010, 0xffff7fff, x9, x7, 96, x8)

inst_21:
// rs1==x20, rs2==x21, rs2_w0_val == 4294950911, rs1_w0_val == 4026531839
// opcode: ukmsr64 ; op1:x20; op2:x21; dest:x4; op1val:0xefffffff;  op2val:0xffffbfff
TEST_PK64_PNN_OP(ukmsr64, x4, x5, x20, x21, 0x00000000, 0, 0xefffffff, 0xffffbfff, x20, x7, 108, x8)

inst_22:
// rs1==x1, rs2==x16, rs2_w0_val == 4294959103, rs1_w0_val == 262144
// opcode: ukmsr64 ; op1:x1; op2:x16; dest:x22; op1val:0x00040000;  op2val:0xffffdfff
TEST_PK64_PNN_OP(ukmsr64, x22, x23, x1, x16, 0x00000000, 0, 0x00040000, 0xffffdfff, x1, x7, 120, x8)
RVTEST_SIGBASE(x1,signature_x1_0)

inst_23:
// rs1==x18, rs2==x27, rs2_w0_val == 4294963199, 
// opcode: ukmsr64 ; op1:x18; op2:x27; dest:x22; op1val:0x00000008;  op2val:0xffffefff
TEST_PK64_PNN_OP(ukmsr64, x22, x23, x18, x27, 0x00000000, 0, 0x00000008, 0xffffefff, x18, x1, 0, x2)

inst_24:
// rs1==x22, rs2==x18, rs2_w0_val == 4294965247, 
// opcode: ukmsr64 ; op1:x22; op2:x18; dest:x26; op1val:0xffefffff;  op2val:0xfffff7ff
TEST_PK64_PNN_OP(ukmsr64, x26, x27, x22, x18, 0x00000000, 0, 0xffefffff, 0xfffff7ff, x22, x1, 12, x2)

inst_25:
// rs1==x12, rs2==x19, rs2_w0_val == 4294966271, 
// opcode: ukmsr64 ; op1:x12; op2:x19; dest:x14; op1val:0x00000009;  op2val:0xfffffbff
TEST_PK64_PNN_OP(ukmsr64, x14, x15, x12, x19, 0x00000000, 0, 0x00000009, 0xfffffbff, x12, x1, 24, x2)

inst_26:
// rs1==x17, rs2==x0, rs2_w0_val == 4294966783, 
// opcode: ukmsr64 ; op1:x17; op2:x0; dest:x26; op1val:0x00000012;  op2val:0xfffffdff
TEST_PK64_PNN_OP(ukmsr64, x26, x27, x17, x0, 0x00000000, 0, 0x00000012, 0xfffffdff, x17, x1, 36, x2)

inst_27:
// rs1==x3, rs2==x29, rs2_w0_val == 4294967039, rs1_w0_val == 1048576
// opcode: ukmsr64 ; op1:x3; op2:x29; dest:x26; op1val:0x00100000;  op2val:0xfffffeff
TEST_PK64_PNN_OP(ukmsr64, x26, x27, x3, x29, 0x00000000, 0, 0x00100000, 0xfffffeff, x3, x1, 48, x2)

inst_28:
// rs1==x7, rs2==x12, rs2_w0_val == 4294967167, rs1_w0_val == 8388608
// opcode: ukmsr64 ; op1:x7; op2:x12; dest:x28; op1val:0x00800000;  op2val:0xffffff7f
TEST_PK64_PNN_OP(ukmsr64, x28, x29, x7, x12, 0x00000000, 0, 0x00800000, 0xffffff7f, x7, x1, 60, x2)

inst_29:
// rs1==x10, rs2==x8, rs2_w0_val == 4294967231, rs1_w0_val == 4286578687
// opcode: ukmsr64 ; op1:x10; op2:x8; dest:x12; op1val:0xff7fffff;  op2val:0xffffffbf
TEST_PK64_PNN_OP(ukmsr64, x12, x13, x10, x8, 0x00000000, 0, 0xff7fffff, 0xffffffbf, x10, x1, 72, x2)

inst_30:
// rs1==x13, rs2==x4, rs2_w0_val == 4294967263, 
// opcode: ukmsr64 ; op1:x13; op2:x4; dest:x14; op1val:0x00400000;  op2val:0xffffffdf
TEST_PK64_PNN_OP(ukmsr64, x14, x15, x13, x4, 0x00000000, 0, 0x00400000, 0xffffffdf, x13, x1, 84, x2)

inst_31:
// rs1==x8, rs2==x22, rs2_w0_val == 4294967279, 
// opcode: ukmsr64 ; op1:x8; op2:x22; dest:x30; op1val:0x00000006;  op2val:0xffffffef
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x8, x22, 0x00000000, 0, 0x00000006, 0xffffffef, x8, x1, 96, x2)

inst_32:
// rs2_w0_val == 4294967287, 
// opcode: ukmsr64 ; op1:x31; op2:x29; dest:x30; op1val:0xffffefff;  op2val:0xfffffff7
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x31, x29, 0x00000000, 0, 0xffffefff, 0xfffffff7, x31, x1, 108, x2)

inst_33:
// rs2_w0_val == 4294967291, 
// opcode: ukmsr64 ; op1:x31; op2:x29; dest:x30; op1val:0x00000011;  op2val:0xfffffffb
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x31, x29, 0x00000000, 0, 0x00000011, 0xfffffffb, x31, x1, 120, x2)

inst_34:
// rs2_w0_val == 4294967293, rs1_w0_val == 2
// opcode: ukmsr64 ; op1:x31; op2:x29; dest:x30; op1val:0x00000002;  op2val:0xfffffffd
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x31, x29, 0x00000000, 0, 0x00000002, 0xfffffffd, x31, x1, 132, x2)

inst_35:
// rs2_w0_val == 4294967294, 
// opcode: ukmsr64 ; op1:x31; op2:x29; dest:x30; op1val:0xaaaaaaaa;  op2val:0xfffffffe
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x31, x29, 0x00000000, 0, 0xaaaaaaaa, 0xfffffffe, x31, x1, 144, x2)

inst_36:
// rs2_w0_val == 2147483648, rs1_w0_val == 524288
// opcode: ukmsr64 ; op1:x31; op2:x29; dest:x30; op1val:0x00080000;  op2val:0x80000000
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x31, x29, 0x00000000, 0, 0x00080000, 0x80000000, x31, x1, 156, x2)

inst_37:
// rs2_w0_val == 1073741824, rs1_w0_val == 4227858431
// opcode: ukmsr64 ; op1:x31; op2:x29; dest:x30; op1val:0xfbffffff;  op2val:0x40000000
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x31, x29, 0x00000000, 0, 0xfbffffff, 0x40000000, x31, x1, 168, x2)

inst_38:
// rs2_w0_val == 536870912, rs1_w0_val == 256
// opcode: ukmsr64 ; op1:x31; op2:x29; dest:x30; op1val:0x00000100;  op2val:0x20000000
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x31, x29, 0x00000000, 0, 0x00000100, 0x20000000, x31, x1, 180, x2)

inst_39:
// rs2_w0_val == 268435456, rs1_w0_val == 128
// opcode: ukmsr64 ; op1:x31; op2:x29; dest:x30; op1val:0x00000080;  op2val:0x10000000
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x31, x29, 0x00000000, 0, 0x00000080, 0x10000000, x31, x1, 192, x2)

inst_40:
// rs2_w0_val == 134217728, 
// opcode: ukmsr64 ; op1:x31; op2:x29; dest:x30; op1val:0x0000000b;  op2val:0x08000000
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x31, x29, 0x00000000, 0, 0x0000000b, 0x08000000, x31, x1, 204, x2)

inst_41:
// rs2_w0_val == 67108864, rs1_w0_val == 4
// opcode: ukmsr64 ; op1:x31; op2:x29; dest:x30; op1val:0x00000004;  op2val:0x04000000
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x31, x29, 0x00000000, 0, 0x00000004, 0x04000000, x31, x1, 216, x2)

inst_42:
// rs2_w0_val == 16777216, rs1_w0_val == 4290772991
// opcode: ukmsr64 ; op1:x31; op2:x29; dest:x30; op1val:0xffbfffff;  op2val:0x01000000
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x31, x29, 0x00000000, 0, 0xffbfffff, 0x01000000, x31, x1, 228, x2)

inst_43:
// rs2_w0_val == 8388608, rs1_w0_val == 2048
// opcode: ukmsr64 ; op1:x31; op2:x29; dest:x30; op1val:0x00000800;  op2val:0x00800000
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x31, x29, 0x00000000, 0, 0x00000800, 0x00800000, x31, x1, 240, x2)

inst_44:
// rs2_w0_val == 4194304, 
// opcode: ukmsr64 ; op1:x31; op2:x29; dest:x30; op1val:0x00000000;  op2val:0x00400000
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x31, x29, 0x00000000, 0, 0x00000000, 0x00400000, x31, x1, 252, x2)

inst_45:
// rs2_w0_val == 2097152, 
// opcode: ukmsr64 ; op1:x31; op2:x29; dest:x30; op1val:0x00100000;  op2val:0x00200000
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x31, x29, 0x00000000, 0, 0x00100000, 0x00200000, x31, x1, 264, x2)

inst_46:
// rs1_w0_val == 64, 
// opcode: ukmsr64 ; op1:x31; op2:x29; dest:x30; op1val:0x00000040;  op2val:0xfffff7ff
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x31, x29, 0x00000000, 0, 0x00000040, 0xfffff7ff, x31, x1, 276, x2)

inst_47:
// rs1_w0_val == 32, 
// opcode: ukmsr64 ; op1:x31; op2:x29; dest:x30; op1val:0x00000020;  op2val:0x00000012
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x31, x29, 0x00000000, 0, 0x00000020, 0x00000012, x31, x1, 288, x2)

inst_48:
// rs1_w0_val == 4294967295, rs2_w0_val == 16384
// opcode: ukmsr64 ; op1:x31; op2:x29; dest:x30; op1val:0xffffffff;  op2val:0x00004000
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x31, x29, 0x00000000, 0, 0xffffffff, 0x00004000, x31, x1, 300, x2)

inst_49:
// rs2_w0_val == 1048576, 
// opcode: ukmsr64 ; op1:x31; op2:x29; dest:x30; op1val:0x00800000;  op2val:0x00100000
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x31, x29, 0x00000000, 0, 0x00800000, 0x00100000, x31, x1, 312, x2)

inst_50:
// rs2_w0_val == 524288, rs1_w0_val == 4096
// opcode: ukmsr64 ; op1:x31; op2:x29; dest:x30; op1val:0x00001000;  op2val:0x00080000
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x31, x29, 0x00000000, 0, 0x00001000, 0x00080000, x31, x1, 324, x2)

inst_51:
// rs2_w0_val == 262144, rs1_w0_val == 65536
// opcode: ukmsr64 ; op1:x31; op2:x29; dest:x30; op1val:0x00010000;  op2val:0x00040000
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x31, x29, 0x00000000, 0, 0x00010000, 0x00040000, x31, x1, 336, x2)

inst_52:
// rs2_w0_val == 131072, rs1_w0_val == 4294967287
// opcode: ukmsr64 ; op1:x31; op2:x29; dest:x30; op1val:0xfffffff7;  op2val:0x00020000
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x31, x29, 0x00000000, 0, 0xfffffff7, 0x00020000, x31, x1, 348, x2)

inst_53:
// rs2_w0_val == 65536, 
// opcode: ukmsr64 ; op1:x31; op2:x29; dest:x30; op1val:0xffbfffff;  op2val:0x00010000
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x31, x29, 0x00000000, 0, 0xffbfffff, 0x00010000, x31, x1, 360, x2)

inst_54:
// rs2_w0_val == 32768, rs1_w0_val == 4278190079
// opcode: ukmsr64 ; op1:x31; op2:x29; dest:x30; op1val:0xfeffffff;  op2val:0x00008000
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x31, x29, 0x00000000, 0, 0xfeffffff, 0x00008000, x31, x1, 372, x2)

inst_55:
// rs2_w0_val == 8192, rs1_w0_val == 4294959103
// opcode: ukmsr64 ; op1:x31; op2:x29; dest:x30; op1val:0xffffdfff;  op2val:0x00002000
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x31, x29, 0x00000000, 0, 0xffffdfff, 0x00002000, x31, x1, 384, x2)

inst_56:
// rs2_w0_val == 4096, rs1_w0_val == 4294967291
// opcode: ukmsr64 ; op1:x31; op2:x29; dest:x30; op1val:0xfffffffb;  op2val:0x00001000
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x31, x29, 0x00000000, 0, 0xfffffffb, 0x00001000, x31, x1, 396, x2)

inst_57:
// rs2_w0_val == 2048, rs1_w0_val == 131072
// opcode: ukmsr64 ; op1:x31; op2:x29; dest:x30; op1val:0x00020000;  op2val:0x00000800
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x31, x29, 0x00000000, 0, 0x00020000, 0x00000800, x31, x1, 408, x2)

inst_58:
// rs2_w0_val == 1024, 
// opcode: ukmsr64 ; op1:x31; op2:x29; dest:x30; op1val:0x00000002;  op2val:0x00000400
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x31, x29, 0x00000000, 0, 0x00000002, 0x00000400, x31, x1, 420, x2)

inst_59:
// rs2_w0_val == 512, rs1_w0_val == 4160749567
// opcode: ukmsr64 ; op1:x31; op2:x29; dest:x30; op1val:0xf7ffffff;  op2val:0x00000200
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x31, x29, 0x00000000, 0, 0xf7ffffff, 0x00000200, x31, x1, 432, x2)

inst_60:
// rs2_w0_val == 256, 
// opcode: ukmsr64 ; op1:x31; op2:x29; dest:x30; op1val:0x0000000b;  op2val:0x00000100
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x31, x29, 0x00000000, 0, 0x0000000b, 0x00000100, x31, x1, 444, x2)

inst_61:
// rs2_w0_val == 128, 
// opcode: ukmsr64 ; op1:x31; op2:x29; dest:x30; op1val:0xfffffffb;  op2val:0x00000080
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x31, x29, 0x00000000, 0, 0xfffffffb, 0x00000080, x31, x1, 456, x2)

inst_62:
// rs2_w0_val == 64, 
// opcode: ukmsr64 ; op1:x31; op2:x29; dest:x30; op1val:0x0000000d;  op2val:0x00000040
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x31, x29, 0x00000000, 0, 0x0000000d, 0x00000040, x31, x1, 468, x2)

inst_63:
// rs2_w0_val == 32, 
// opcode: ukmsr64 ; op1:x31; op2:x29; dest:x30; op1val:0xfffffbff;  op2val:0x00000020
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x31, x29, 0x00000000, 0, 0xfffffbff, 0x00000020, x31, x1, 480, x2)

inst_64:
// rs2_w0_val == 16, rs1_w0_val == 4292870143
// opcode: ukmsr64 ; op1:x31; op2:x29; dest:x30; op1val:0xffdfffff;  op2val:0x00000010
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x31, x29, 0x00000000, 0, 0xffdfffff, 0x00000010, x31, x1, 492, x2)

inst_65:
// rs2_w0_val == 8, 
// opcode: ukmsr64 ; op1:x31; op2:x29; dest:x30; op1val:0x00010000;  op2val:0x00000008
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x31, x29, 0x00000000, 0, 0x00010000, 0x00000008, x31, x1, 504, x2)

inst_66:
// rs2_w0_val == 4, rs1_w0_val == 4294836223
// opcode: ukmsr64 ; op1:x31; op2:x29; dest:x30; op1val:0xfffdffff;  op2val:0x00000004
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x31, x29, 0x00000000, 0, 0xfffdffff, 0x00000004, x31, x1, 516, x2)

inst_67:
// rs2_w0_val == 2, 
// opcode: ukmsr64 ; op1:x31; op2:x29; dest:x30; op1val:0xff7fffff;  op2val:0x00000002
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x31, x29, 0x00000000, 0, 0xff7fffff, 0x00000002, x31, x1, 528, x2)

inst_68:
// rs2_w0_val == 1, 
// opcode: ukmsr64 ; op1:x31; op2:x29; dest:x30; op1val:0x00000040;  op2val:0x00000001
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x31, x29, 0x00000000, 0, 0x00000040, 0x00000001, x31, x1, 540, x2)

inst_69:
// rs2_w0_val == 4294967295, rs1_w0_val == 8192
// opcode: ukmsr64 ; op1:x31; op2:x29; dest:x30; op1val:0x00002000;  op2val:0xffffffff
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x31, x29, 0x00000000, 0, 0x00002000, 0xffffffff, x31, x1, 552, x2)

inst_70:
// rs2_w0_val == 0, 
// opcode: ukmsr64 ; op1:x31; op2:x29; dest:x30; op1val:0xffffffff;  op2val:0x00000000
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x31, x29, 0x00000000, 0, 0xffffffff, 0x00000000, x31, x1, 564, x2)

inst_71:
// rs1_w0_val == 1431655765, 
// opcode: ukmsr64 ; op1:x31; op2:x29; dest:x30; op1val:0x55555555;  op2val:0xff7fffff
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x31, x29, 0x00000000, 0, 0x55555555, 0xff7fffff, x31, x1, 576, x2)

inst_72:
// rs1_w0_val == 2147483647, 
// opcode: ukmsr64 ; op1:x31; op2:x29; dest:x30; op1val:0x7fffffff;  op2val:0x0000000c
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x31, x29, 0x00000000, 0, 0x7fffffff, 0x0000000c, x31, x1, 588, x2)

inst_73:
// rs1_w0_val == 3221225471, 
// opcode: ukmsr64 ; op1:x31; op2:x29; dest:x30; op1val:0xbfffffff;  op2val:0x00000400
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x31, x29, 0x00000000, 0, 0xbfffffff, 0x00000400, x31, x1, 600, x2)

inst_74:
// rs1_w0_val == 3758096383, 
// opcode: ukmsr64 ; op1:x31; op2:x29; dest:x30; op1val:0xdfffffff;  op2val:0xfffff7ff
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x31, x29, 0x00000000, 0, 0xdfffffff, 0xfffff7ff, x31, x1, 612, x2)

inst_75:
// rs1_w0_val == 4261412863, 
// opcode: ukmsr64 ; op1:x31; op2:x29; dest:x30; op1val:0xfdffffff;  op2val:0xffff7fff
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x31, x29, 0x00000000, 0, 0xfdffffff, 0xffff7fff, x31, x1, 624, x2)

inst_76:
// rs1_w0_val == 4294443007, 
// opcode: ukmsr64 ; op1:x31; op2:x29; dest:x30; op1val:0xfff7ffff;  op2val:0x00000007
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x31, x29, 0x00000000, 0, 0xfff7ffff, 0x00000007, x31, x1, 636, x2)

inst_77:
// rs1_w0_val == 4294705151, 
// opcode: ukmsr64 ; op1:x31; op2:x29; dest:x30; op1val:0xfffbffff;  op2val:0xffefffff
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x31, x29, 0x00000000, 0, 0xfffbffff, 0xffefffff, x31, x1, 648, x2)

inst_78:
// rs1_w0_val == 4294934527, 
// opcode: ukmsr64 ; op1:x31; op2:x29; dest:x30; op1val:0xffff7fff;  op2val:0xbfffffff
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x31, x29, 0x00000000, 0, 0xffff7fff, 0xbfffffff, x31, x1, 660, x2)

inst_79:
// rs1_w0_val == 4294965247, 
// opcode: ukmsr64 ; op1:x31; op2:x29; dest:x30; op1val:0xfffff7ff;  op2val:0x00000003
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x31, x29, 0x00000000, 0, 0xfffff7ff, 0x00000003, x31, x1, 672, x2)

inst_80:
// rs1_w0_val == 4294966783, 
// opcode: ukmsr64 ; op1:x31; op2:x29; dest:x30; op1val:0xfffffdff;  op2val:0xaaaaaaaa
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x31, x29, 0x00000000, 0, 0xfffffdff, 0xaaaaaaaa, x31, x1, 684, x2)

inst_81:
// rs1_w0_val == 4294967039, 
// opcode: ukmsr64 ; op1:x31; op2:x29; dest:x30; op1val:0xfffffeff;  op2val:0x00040000
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x31, x29, 0x00000000, 0, 0xfffffeff, 0x00040000, x31, x1, 696, x2)

inst_82:
// rs1_w0_val == 4294967167, 
// opcode: ukmsr64 ; op1:x31; op2:x29; dest:x30; op1val:0xffffff7f;  op2val:0xfffeffff
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x31, x29, 0x00000000, 0, 0xffffff7f, 0xfffeffff, x31, x1, 708, x2)

inst_83:
// rs1_w0_val == 4294967263, 
// opcode: ukmsr64 ; op1:x31; op2:x29; dest:x30; op1val:0xffffffdf;  op2val:0x00004000
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x31, x29, 0x00000000, 0, 0xffffffdf, 0x00004000, x31, x1, 720, x2)

inst_84:
// rs1_w0_val == 4294967293, 
// opcode: ukmsr64 ; op1:x31; op2:x29; dest:x30; op1val:0xfffffffd;  op2val:0x00020000
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x31, x29, 0x00000000, 0, 0xfffffffd, 0x00020000, x31, x1, 732, x2)

inst_85:
// rs1_w0_val == 4294967294, 
// opcode: ukmsr64 ; op1:x31; op2:x29; dest:x30; op1val:0xfffffffe;  op2val:0x00000005
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x31, x29, 0x00000000, 0, 0xfffffffe, 0x00000005, x31, x1, 744, x2)

inst_86:
// rs1_w0_val == 2147483648, 
// opcode: ukmsr64 ; op1:x31; op2:x29; dest:x30; op1val:0x80000000;  op2val:0x00000040
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x31, x29, 0x00000000, 0, 0x80000000, 0x00000040, x31, x1, 756, x2)

inst_87:
// rs1_w0_val == 1073741824, 
// opcode: ukmsr64 ; op1:x31; op2:x29; dest:x30; op1val:0x40000000;  op2val:0x00000000
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x31, x29, 0x00000000, 0, 0x40000000, 0x00000000, x31, x1, 768, x2)

inst_88:
// rs1_w0_val == 536870912, 
// opcode: ukmsr64 ; op1:x31; op2:x29; dest:x30; op1val:0x20000000;  op2val:0xbfffffff
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x31, x29, 0x00000000, 0, 0x20000000, 0xbfffffff, x31, x1, 780, x2)

inst_89:
// rs1_w0_val == 268435456, 
// opcode: ukmsr64 ; op1:x31; op2:x29; dest:x30; op1val:0x10000000;  op2val:0xfffffffd
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x31, x29, 0x00000000, 0, 0x10000000, 0xfffffffd, x31, x1, 792, x2)

inst_90:
// rs1_w0_val == 16777216, 
// opcode: ukmsr64 ; op1:x31; op2:x29; dest:x30; op1val:0x01000000;  op2val:0x00001000
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x31, x29, 0x00000000, 0, 0x01000000, 0x00001000, x31, x1, 804, x2)

inst_91:
// rs1_w0_val == 2097152, 
// opcode: ukmsr64 ; op1:x31; op2:x29; dest:x30; op1val:0x00200000;  op2val:0x40000000
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x31, x29, 0x00000000, 0, 0x00200000, 0x40000000, x31, x1, 816, x2)

inst_92:
// rs1_w0_val == 1024, 
// opcode: ukmsr64 ; op1:x31; op2:x29; dest:x30; op1val:0x00000400;  op2val:0x00000000
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x31, x29, 0x00000000, 0, 0x00000400, 0x00000000, x31, x1, 828, x2)

inst_93:
// rs1_w0_val == 32768, 
// opcode: ukmsr64 ; op1:x31; op2:x29; dest:x30; op1val:0x00008000;  op2val:0x00000009
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x31, x29, 0x00000000, 0, 0x00008000, 0x00000009, x31, x1, 840, x2)

inst_94:
// rs1_w0_val == 16384, 
// opcode: ukmsr64 ; op1:x31; op2:x29; dest:x30; op1val:0x00004000;  op2val:0x00000002
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x31, x29, 0x00000000, 0, 0x00004000, 0x00000002, x31, x1, 852, x2)

inst_95:
// rs1_w0_val == 134217728, 
// opcode: ukmsr64 ; op1:x31; op2:x29; dest:x30; op1val:0x08000000;  op2val:0x00000002
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x31, x29, 0x00000000, 0, 0x08000000, 0x00000002, x31, x1, 864, x2)

inst_96:
// rs1_w0_val == 67108864, 
// opcode: ukmsr64 ; op1:x31; op2:x29; dest:x30; op1val:0x04000000;  op2val:0xffbfffff
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x31, x29, 0x00000000, 0, 0x04000000, 0xffbfffff, x31, x1, 876, x2)

inst_97:
// rs2_w0_val == 4294966783, 
// opcode: ukmsr64 ; op1:x31; op2:x29; dest:x30; op1val:0x00000012;  op2val:0xfffffdff
TEST_PK64_PNN_OP(ukmsr64, x30, x31, x31, x29, 0x00000000, 0, 0x00000012, 0xfffffdff, x31, x1, 888, x2)
#endif


RVTEST_CODE_END
RVMODEL_HALT

RVTEST_DATA_BEGIN
.align 4
rvtest_data:
.word 0xbabecafe
.word 0xabecafeb
.word 0xbecafeba
.word 0xecafebab
RVTEST_DATA_END

RVMODEL_DATA_BEGIN


signature_x12_0:
    .fill 0*(XLEN/32),4,0xdeadbeef


signature_x12_1:
    .fill 36*(XLEN/32),4,0xdeadbeef


signature_x7_0:
    .fill 33*(XLEN/32),4,0xdeadbeef


signature_x1_0:
    .fill 225*(XLEN/32),4,0xdeadbeef

#ifdef rvtest_mtrap_routine

mtrap_sigptr:
    .fill 64*(XLEN/32),4,0xdeadbeef

#endif

#ifdef rvtest_gpr_save

gpr_save:
    .fill 32*(XLEN/32),4,0xdeadbeef

#endif

RVMODEL_DATA_END
