
// -----------
// This file was generated by riscv_ctg (https://github.com/riscv-software-src/riscv-ctg)
// version   : 0.6.3
// timestamp : Sat Apr 23 14:53:29 2022 GMT
// usage     : riscv_ctg \
//                  --cgf /scratch/git-repo/github/riscv_ctg/sample_cgfs/dataset.cgf \
//                  --cgf /scratch/git-repo/github/riscv_ctg/sample_cgfs/rv32ip.cgf \
//                  --xlen 32  \
//                  --randomize \
// -----------
//
// -----------
// Copyright (c) 2020. RISC-V International. All rights reserved.
// SPDX-License-Identifier: BSD-3-Clause
// -----------
//
// This assembly file tests the uksubw instruction of the RISC-V RV32PZicsr extension for the uksubw covergroup.
// 
#include "model_test.h"
#include "arch_test.h"
RVTEST_ISA("RV32IPZicsr")

.section .text.init
.org 0x80
.globl rvtest_entry_point
rvtest_entry_point:
RVMODEL_BOOT
RVTEST_CODE_BEGIN

#ifdef TEST_CASE_1

RVTEST_CASE(0,"//check ISA:=regex(.*32.*);check ISA:=regex(.*I.*P.*Zicsr.*);def TEST_CASE_1=True;",uksubw)

RVTEST_VXSAT_ENABLE()
RVTEST_SIGBASE(x11,signature_x11_1)

inst_0:
// rs1 != rs2  and rs1 != rd and rs2 != rd, rs1==x29, rs2==x24, rd==x13, rs1_w0_val == 0, rs2_w0_val == 2097152
// opcode: uksubw ; op1:x29; op2:x24; dest:x13; op1val:0x000000;  op2val:0x200000
TEST_PKRR_OP(uksubw, x13, x29, x24, 0x00000000, 0x000000, 0x200000, x29, x11, 0, x17)

inst_1:
// rs1 == rs2 != rd, rs1==x18, rs2==x18, rd==x12, rs1_w0_val != rs2_w0_val and rs1_w0_val > 0 and rs2_w0_val > 0, rs2_w0_val == 4293918719, rs1_w0_val == 16
// opcode: uksubw ; op1:x18; op2:x18; dest:x12; op1val:0x000010;  op2val:0xffefffff
TEST_PKRR_OP(uksubw, x12, x18, x18, 0x00000000, 0x000010, 0xffefffff, x18, x11, 8, x17)

inst_2:
// rs1 == rd != rs2, rs1==x2, rs2==x15, rd==x2, rs1_w0_val == rs2_w0_val and rs1_w0_val > 0 and rs2_w0_val > 0, rs1_w0_val == 4293918719
// opcode: uksubw ; op1:x2; op2:x15; dest:x2; op1val:0xffefffff;  op2val:0xffefffff
TEST_PKRR_OP(uksubw, x2, x2, x15, 0x00000000, 0xffefffff, 0xffefffff, x2, x11, 16, x17)

inst_3:
// rs1 == rs2 == rd, rs1==x20, rs2==x20, rd==x20, rs2_w0_val == 2863311530, 
// opcode: uksubw ; op1:x20; op2:x20; dest:x20; op1val:0x000013;  op2val:0xaaaaaaaa
TEST_PKRR_OP(uksubw, x20, x20, x20, 0x00000000, 0x000013, 0xaaaaaaaa, x20, x11, 24, x17)

inst_4:
// rs2 == rd != rs1, rs1==x25, rs2==x22, rd==x22, rs2_w0_val == 1431655765, 
// opcode: uksubw ; op1:x25; op2:x22; dest:x22; op1val:0xffefffff;  op2val:0x55555555
TEST_PKRR_OP(uksubw, x22, x25, x22, 0x00000000, 0xffefffff, 0x55555555, x25, x11, 32, x17)

inst_5:
// rs1==x31, rs2==x3, rd==x14, rs2_w0_val == 2147483647, 
// opcode: uksubw ; op1:x31; op2:x3; dest:x14; op1val:0x00000c;  op2val:0x7fffffff
TEST_PKRR_OP(uksubw, x14, x31, x3, 0x00000000, 0x00000c, 0x7fffffff, x31, x11, 40, x17)

inst_6:
// rs1==x4, rs2==x26, rd==x6, rs2_w0_val == 3221225471, rs1_w0_val == 4294967293
// opcode: uksubw ; op1:x4; op2:x26; dest:x6; op1val:0xfffffffd;  op2val:0xbfffffff
TEST_PKRR_OP(uksubw, x6, x4, x26, 0x00000000, 0xfffffffd, 0xbfffffff, x4, x11, 48, x17)

inst_7:
// rs1==x26, rs2==x25, rd==x5, rs2_w0_val == 3758096383, 
// opcode: uksubw ; op1:x26; op2:x25; dest:x5; op1val:0x00000a;  op2val:0xdfffffff
TEST_PKRR_OP(uksubw, x5, x26, x25, 0x00000000, 0x00000a, 0xdfffffff, x26, x11, 56, x17)

inst_8:
// rs1==x27, rs2==x2, rd==x1, rs2_w0_val == 4026531839, 
// opcode: uksubw ; op1:x27; op2:x2; dest:x1; op1val:0x000003;  op2val:0xefffffff
TEST_PKRR_OP(uksubw, x1, x27, x2, 0x00000000, 0x000003, 0xefffffff, x27, x11, 64, x17)

inst_9:
// rs1==x0, rs2==x12, rd==x7, rs2_w0_val == 4160749567, 
// opcode: uksubw ; op1:x0; op2:x12; dest:x7; op1val:0x00000a;  op2val:0xf7ffffff
TEST_PKRR_OP(uksubw, x7, x0, x12, 0x00000000, 0x00000a, 0xf7ffffff, x0, x11, 72, x17)

inst_10:
// rs1==x10, rs2==x30, rd==x24, rs2_w0_val == 4227858431, rs1_w0_val == 4294950911
// opcode: uksubw ; op1:x10; op2:x30; dest:x24; op1val:0xffffbfff;  op2val:0xfbffffff
TEST_PKRR_OP(uksubw, x24, x10, x30, 0x00000000, 0xffffbfff, 0xfbffffff, x10, x11, 80, x17)

inst_11:
// rs1==x14, rs2==x16, rd==x15, rs2_w0_val == 4261412863, rs1_w0_val == 4294965247
// opcode: uksubw ; op1:x14; op2:x16; dest:x15; op1val:0xfffff7ff;  op2val:0xfdffffff
TEST_PKRR_OP(uksubw, x15, x14, x16, 0x00000000, 0xfffff7ff, 0xfdffffff, x14, x11, 88, x17)

inst_12:
// rs1==x9, rs2==x5, rd==x8, rs2_w0_val == 4278190079, rs1_w0_val == 2
// opcode: uksubw ; op1:x9; op2:x5; dest:x8; op1val:0x000002;  op2val:0xfeffffff
TEST_PKRR_OP(uksubw, x8, x9, x5, 0x00000000, 0x000002, 0xfeffffff, x9, x11, 96, x17)

inst_13:
// rs1==x3, rs2==x31, rd==x21, rs2_w0_val == 4286578687, rs1_w0_val == 4294959103
// opcode: uksubw ; op1:x3; op2:x31; dest:x21; op1val:0xffffdfff;  op2val:0xff7fffff
TEST_PKRR_OP(uksubw, x21, x3, x31, 0x00000000, 0xffffdfff, 0xff7fffff, x3, x11, 104, x17)

inst_14:
// rs1==x5, rs2==x7, rd==x17, rs2_w0_val == 4290772991, rs1_w0_val == 1073741824
// opcode: uksubw ; op1:x5; op2:x7; dest:x17; op1val:0x40000000;  op2val:0xffbfffff
TEST_PKRR_OP(uksubw, x17, x5, x7, 0x00000000, 0x40000000, 0xffbfffff, x5, x11, 112, x1)
RVTEST_SIGBASE(x2,signature_x2_0)

inst_15:
// rs1==x30, rs2==x10, rd==x18, rs2_w0_val == 4292870143, 
// opcode: uksubw ; op1:x30; op2:x10; dest:x18; op1val:0x40000000;  op2val:0xffdfffff
TEST_PKRR_OP(uksubw, x18, x30, x10, 0x00000000, 0x40000000, 0xffdfffff, x30, x2, 0, x1)

inst_16:
// rs1==x19, rs2==x28, rd==x25, rs2_w0_val == 4294443007, 
// opcode: uksubw ; op1:x19; op2:x28; dest:x25; op1val:0x000009;  op2val:0xfff7ffff
TEST_PKRR_OP(uksubw, x25, x19, x28, 0x00000000, 0x000009, 0xfff7ffff, x19, x2, 8, x1)

inst_17:
// rs1==x12, rs2==x17, rd==x28, rs2_w0_val == 4294705151, rs1_w0_val == 4
// opcode: uksubw ; op1:x12; op2:x17; dest:x28; op1val:0x000004;  op2val:0xfffbffff
TEST_PKRR_OP(uksubw, x28, x12, x17, 0x00000000, 0x000004, 0xfffbffff, x12, x2, 16, x1)

inst_18:
// rs1==x16, rs2==x29, rd==x26, rs2_w0_val == 4294836223, rs1_w0_val == 3758096383
// opcode: uksubw ; op1:x16; op2:x29; dest:x26; op1val:0xdfffffff;  op2val:0xfffdffff
TEST_PKRR_OP(uksubw, x26, x16, x29, 0x00000000, 0xdfffffff, 0xfffdffff, x16, x2, 24, x1)

inst_19:
// rs1==x7, rs2==x21, rd==x11, rs2_w0_val == 4294901759, rs1_w0_val == 33554432
// opcode: uksubw ; op1:x7; op2:x21; dest:x11; op1val:0x2000000;  op2val:0xfffeffff
TEST_PKRR_OP(uksubw, x11, x7, x21, 0x00000000, 0x2000000, 0xfffeffff, x7, x2, 32, x1)

inst_20:
// rs1==x6, rs2==x23, rd==x10, rs2_w0_val == 4294934527, 
// opcode: uksubw ; op1:x6; op2:x23; dest:x10; op1val:0x000011;  op2val:0xffff7fff
TEST_PKRR_OP(uksubw, x10, x6, x23, 0x00000000, 0x000011, 0xffff7fff, x6, x2, 40, x1)

inst_21:
// rs1==x11, rs2==x9, rd==x4, rs2_w0_val == 4294950911, rs1_w0_val == 4261412863
// opcode: uksubw ; op1:x11; op2:x9; dest:x4; op1val:0xfdffffff;  op2val:0xffffbfff
TEST_PKRR_OP(uksubw, x4, x11, x9, 0x00000000, 0xfdffffff, 0xffffbfff, x11, x2, 48, x1)

inst_22:
// rs1==x23, rs2==x27, rd==x3, rs2_w0_val == 4294959103, rs1_w0_val == 4294443007
// opcode: uksubw ; op1:x23; op2:x27; dest:x3; op1val:0xfff7ffff;  op2val:0xffffdfff
TEST_PKRR_OP(uksubw, x3, x23, x27, 0x00000000, 0xfff7ffff, 0xffffdfff, x23, x2, 56, x1)

inst_23:
// rs1==x22, rs2==x11, rd==x31, rs2_w0_val == 4294963199, rs1_w0_val == 4294901759
// opcode: uksubw ; op1:x22; op2:x11; dest:x31; op1val:0xfffeffff;  op2val:0xffffefff
TEST_PKRR_OP(uksubw, x31, x22, x11, 0x00000000, 0xfffeffff, 0xffffefff, x22, x2, 64, x1)

inst_24:
// rs1==x28, rs2==x4, rd==x9, rs2_w0_val == 4294965247, rs1_w0_val == 512
// opcode: uksubw ; op1:x28; op2:x4; dest:x9; op1val:0x000200;  op2val:0xfffff7ff
TEST_PKRR_OP(uksubw, x9, x28, x4, 0x00000000, 0x000200, 0xfffff7ff, x28, x2, 72, x1)

inst_25:
// rs1==x8, rs2==x0, rd==x16, rs2_w0_val == 4294966271, rs1_w0_val == 3221225471
// opcode: uksubw ; op1:x8; op2:x0; dest:x16; op1val:0xbfffffff;  op2val:0xfffffbff
TEST_PKRR_OP(uksubw, x16, x8, x0, 0x00000000, 0xbfffffff, 0xfffffbff, x8, x2, 80, x1)

inst_26:
// rs1==x24, rs2==x8, rd==x23, rs2_w0_val == 4294966783, 
// opcode: uksubw ; op1:x24; op2:x8; dest:x23; op1val:0x40000000;  op2val:0xfffffdff
TEST_PKRR_OP(uksubw, x23, x24, x8, 0x00000000, 0x40000000, 0xfffffdff, x24, x2, 88, x1)

inst_27:
// rs1==x17, rs2==x19, rd==x27, rs2_w0_val == 4294967039, 
// opcode: uksubw ; op1:x17; op2:x19; dest:x27; op1val:0x000012;  op2val:0xfffffeff
TEST_PKRR_OP(uksubw, x27, x17, x19, 0x00000000, 0x000012, 0xfffffeff, x17, x2, 96, x1)

inst_28:
// rs1==x21, rs2==x13, rd==x29, rs2_w0_val == 4294967167, rs1_w0_val == 4294967279
// opcode: uksubw ; op1:x21; op2:x13; dest:x29; op1val:0xffffffef;  op2val:0xffffff7f
TEST_PKRR_OP(uksubw, x29, x21, x13, 0x00000000, 0xffffffef, 0xffffff7f, x21, x2, 104, x1)

inst_29:
// rs1==x13, rs2==x14, rd==x19, rs2_w0_val == 4294967231, rs1_w0_val == 2863311530
// opcode: uksubw ; op1:x13; op2:x14; dest:x19; op1val:0xaaaaaaaa;  op2val:0xffffffbf
TEST_PKRR_OP(uksubw, x19, x13, x14, 0x00000000, 0xaaaaaaaa, 0xffffffbf, x13, x2, 112, x3)

inst_30:
// rs1==x15, rs2==x1, rd==x30, rs2_w0_val == 4294967263, rs1_w0_val == 4294967039
// opcode: uksubw ; op1:x15; op2:x1; dest:x30; op1val:0xfffffeff;  op2val:0xffffffdf
TEST_PKRR_OP(uksubw, x30, x15, x1, 0x00000000, 0xfffffeff, 0xffffffdf, x15, x2, 120, x3)
RVTEST_SIGBASE(x2,signature_x2_1)

inst_31:
// rs1==x1, rs2==x6, rd==x0, rs2_w0_val == 4294967279, rs1_w0_val == 32768
// opcode: uksubw ; op1:x1; op2:x6; dest:x0; op1val:0x008000;  op2val:0xffffffef
TEST_PKRR_OP(uksubw, x0, x1, x6, 0x00000000, 0x008000, 0xffffffef, x1, x2, 0, x3)

inst_32:
// rs2_w0_val == 4294967287, 
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0x00000e;  op2val:0xfffffff7
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0x00000e, 0xfffffff7, x30, x2, 8, x3)

inst_33:
// rs2_w0_val == 4294967291, rs1_w0_val == 1
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0x000001;  op2val:0xfffffffb
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0x000001, 0xfffffffb, x30, x2, 16, x3)

inst_34:
// rs2_w0_val == 4294967293, 
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0x000200;  op2val:0xfffffffd
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0x000200, 0xfffffffd, x30, x2, 24, x3)

inst_35:
// rs2_w0_val == 4294967294, rs1_w0_val == 2048
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0x000800;  op2val:0xfffffffe
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0x000800, 0xfffffffe, x30, x2, 32, x3)

inst_36:
// rs2_w0_val == 2147483648, rs1_w0_val == 1024
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0x000400;  op2val:0x80000000
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0x000400, 0x80000000, x30, x2, 40, x3)

inst_37:
// rs2_w0_val == 1073741824, rs1_w0_val == 16777216
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0x1000000;  op2val:0x40000000
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0x1000000, 0x40000000, x30, x2, 48, x3)

inst_38:
// rs2_w0_val == 536870912, rs1_w0_val == 67108864
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0x4000000;  op2val:0x20000000
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0x4000000, 0x20000000, x30, x2, 56, x3)

inst_39:
// rs2_w0_val == 268435456, 
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0xffffdfff;  op2val:0x10000000
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0xffffdfff, 0x10000000, x30, x2, 64, x3)

inst_40:
// rs2_w0_val == 134217728, rs1_w0_val == 4096
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0x001000;  op2val:0x8000000
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0x001000, 0x8000000, x30, x2, 72, x3)

inst_41:
// rs2_w0_val == 67108864, rs1_w0_val == 16384
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0x004000;  op2val:0x4000000
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0x004000, 0x4000000, x30, x2, 80, x3)

inst_42:
// rs2_w0_val == 33554432, 
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0xfffeffff;  op2val:0x2000000
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0xfffeffff, 0x2000000, x30, x2, 88, x3)

inst_43:
// rs2_w0_val == 16777216, rs1_w0_val == 4294963199
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0xffffefff;  op2val:0x1000000
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0xffffefff, 0x1000000, x30, x2, 96, x3)

inst_44:
// rs2_w0_val == 8388608, 
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0x000200;  op2val:0x800000
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0x000200, 0x800000, x30, x2, 104, x3)

inst_45:
// rs1_w0_val == 256, 
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0x000100;  op2val:0xbfffffff
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0x000100, 0xbfffffff, x30, x2, 112, x3)

inst_46:
// rs1_w0_val == 128, rs2_w0_val == 1024
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0x000080;  op2val:0x000400
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0x000080, 0x000400, x30, x2, 120, x3)

inst_47:
// rs1_w0_val == 64, 
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0x000040;  op2val:0xfffeffff
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0x000040, 0xfffeffff, x30, x2, 128, x3)

inst_48:
// rs1_w0_val == 32, 
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0x000020;  op2val:0x000003
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0x000020, 0x000003, x30, x2, 136, x3)

inst_49:
// rs1_w0_val == 8, rs2_w0_val == 512
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0x000008;  op2val:0x000200
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0x000008, 0x000200, x30, x2, 144, x3)

inst_50:
// rs1_w0_val == 4294967295, 
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0xffffffff;  op2val:0xfeffffff
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0xffffffff, 0xfeffffff, x30, x2, 152, x3)

inst_51:
// rs2_w0_val == 4194304, 
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0xfffff7ff;  op2val:0x400000
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0xfffff7ff, 0x400000, x30, x2, 160, x3)

inst_52:
// rs2_w0_val == 1048576, 
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0x004000;  op2val:0x100000
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0x004000, 0x100000, x30, x2, 168, x3)

inst_53:
// rs2_w0_val == 524288, rs1_w0_val == 4227858431
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0xfbffffff;  op2val:0x080000
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0xfbffffff, 0x080000, x30, x2, 176, x3)

inst_54:
// rs2_w0_val == 262144, 
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0xfbffffff;  op2val:0x040000
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0xfbffffff, 0x040000, x30, x2, 184, x3)

inst_55:
// rs2_w0_val == 131072, 
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0xaaaaaaaa;  op2val:0x020000
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0xaaaaaaaa, 0x020000, x30, x2, 192, x3)

inst_56:
// rs2_w0_val == 65536, 
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0xffffffef;  op2val:0x010000
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0xffffffef, 0x010000, x30, x2, 200, x3)

inst_57:
// rs2_w0_val == 32768, 
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0x00000b;  op2val:0x008000
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0x00000b, 0x008000, x30, x2, 208, x3)

inst_58:
// rs2_w0_val == 16384, 
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0x2000000;  op2val:0x004000
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0x2000000, 0x004000, x30, x2, 216, x3)

inst_59:
// rs2_w0_val == 8192, 
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0x000004;  op2val:0x002000
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0x000004, 0x002000, x30, x2, 224, x3)

inst_60:
// rs2_w0_val == 4096, 
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0x00000a;  op2val:0x001000
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0x00000a, 0x001000, x30, x2, 232, x3)

inst_61:
// rs2_w0_val == 2048, rs1_w0_val == 4026531839
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0xefffffff;  op2val:0x000800
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0xefffffff, 0x000800, x30, x2, 240, x3)

inst_62:
// rs2_w0_val == 256, 
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0x001000;  op2val:0x000100
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0x001000, 0x000100, x30, x2, 248, x3)

inst_63:
// rs2_w0_val == 128, 
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0x000004;  op2val:0x000080
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0x000004, 0x000080, x30, x2, 256, x3)

inst_64:
// rs2_w0_val == 64, 
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0x000002;  op2val:0x000040
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0x000002, 0x000040, x30, x2, 264, x3)

inst_65:
// rs2_w0_val == 32, 
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0xffefffff;  op2val:0x000020
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0xffefffff, 0x000020, x30, x2, 272, x3)

inst_66:
// rs2_w0_val == 16, 
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0xfbffffff;  op2val:0x000010
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0xfbffffff, 0x000010, x30, x2, 280, x3)

inst_67:
// rs2_w0_val == 8, rs1_w0_val == 268435456
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0x10000000;  op2val:0x000008
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0x10000000, 0x000008, x30, x2, 288, x3)

inst_68:
// rs2_w0_val == 4, rs1_w0_val == 4294967294
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0xfffffffe;  op2val:0x000004
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0xfffffffe, 0x000004, x30, x2, 296, x3)

inst_69:
// rs2_w0_val == 2, 
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0x00000d;  op2val:0x000002
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0x00000d, 0x000002, x30, x2, 304, x3)

inst_70:
// rs2_w0_val == 1, 
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0xbfffffff;  op2val:0x000001
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0xbfffffff, 0x000001, x30, x2, 312, x3)

inst_71:
// rs2_w0_val == 4294967295, 
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0xbfffffff;  op2val:0xffffffff
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0xbfffffff, 0xffffffff, x30, x2, 320, x3)

inst_72:
// rs2_w0_val == 0, 
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0xfffeffff;  op2val:0x000000
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0xfffeffff, 0x000000, x30, x2, 328, x3)

inst_73:
// rs1_w0_val == 1431655765, 
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0x55555555;  op2val:0xfffffffd
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0x55555555, 0xfffffffd, x30, x2, 336, x3)

inst_74:
// rs1_w0_val == 2147483647, 
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0x7fffffff;  op2val:0x10000000
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0x7fffffff, 0x10000000, x30, x2, 344, x3)

inst_75:
// rs1_w0_val == 4160749567, 
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0xf7ffffff;  op2val:0x80000000
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0xf7ffffff, 0x80000000, x30, x2, 352, x3)

inst_76:
// rs1_w0_val == 4278190079, 
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0xfeffffff;  op2val:0x800000
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0xfeffffff, 0x800000, x30, x2, 360, x3)

inst_77:
// rs1_w0_val == 4286578687, 
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0xff7fffff;  op2val:0xffffbfff
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0xff7fffff, 0xffffbfff, x30, x2, 368, x3)

inst_78:
// rs1_w0_val == 4290772991, 
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0xffbfffff;  op2val:0x000002
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0xffbfffff, 0x000002, x30, x2, 376, x3)

inst_79:
// rs1_w0_val == 4292870143, 
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0xffdfffff;  op2val:0xfeffffff
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0xffdfffff, 0xfeffffff, x30, x2, 384, x3)

inst_80:
// rs1_w0_val == 4294705151, 
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0xfffbffff;  op2val:0x000100
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0xfffbffff, 0x000100, x30, x2, 392, x3)

inst_81:
// rs1_w0_val == 4294836223, 
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0xfffdffff;  op2val:0xbfffffff
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0xfffdffff, 0xbfffffff, x30, x2, 400, x3)

inst_82:
// rs1_w0_val == 4294934527, 
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0xffff7fff;  op2val:0xfffeffff
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0xffff7fff, 0xfffeffff, x30, x2, 408, x3)

inst_83:
// rs1_w0_val == 4294966271, 
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0xfffffbff;  op2val:0x200000
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0xfffffbff, 0x200000, x30, x2, 416, x3)

inst_84:
// rs1_w0_val == 4294966783, 
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0xfffffdff;  op2val:0x000000
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0xfffffdff, 0x000000, x30, x2, 424, x3)

inst_85:
// rs1_w0_val == 4294967167, 
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0xffffff7f;  op2val:0x00000f
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0xffffff7f, 0x00000f, x30, x2, 432, x3)

inst_86:
// rs1_w0_val == 4294967231, 
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0xffffffbf;  op2val:0x000012
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0xffffffbf, 0x000012, x30, x2, 440, x3)

inst_87:
// rs1_w0_val == 4294967263, 
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0xffffffdf;  op2val:0x000000
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0xffffffdf, 0x000000, x30, x2, 448, x3)

inst_88:
// rs1_w0_val == 4294967287, 
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0xfffffff7;  op2val:0xdfffffff
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0xfffffff7, 0xdfffffff, x30, x2, 456, x3)

inst_89:
// rs1_w0_val == 4294967291, 
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0xfffffffb;  op2val:0x000012
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0xfffffffb, 0x000012, x30, x2, 464, x3)

inst_90:
// rs1_w0_val == 2147483648, 
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0x80000000;  op2val:0x100000
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0x80000000, 0x100000, x30, x2, 472, x3)

inst_91:
// rs1_w0_val == 536870912, 
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0x20000000;  op2val:0x800000
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0x20000000, 0x800000, x30, x2, 480, x3)

inst_92:
// rs1_w0_val == 134217728, 
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0x8000000;  op2val:0x020000
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0x8000000, 0x020000, x30, x2, 488, x3)

inst_93:
// rs1_w0_val == 8388608, 
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0x800000;  op2val:0xbfffffff
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0x800000, 0xbfffffff, x30, x2, 496, x3)

inst_94:
// rs1_w0_val == 4194304, 
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0x400000;  op2val:0xffffdfff
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0x400000, 0xffffdfff, x30, x2, 504, x3)

inst_95:
// rs1_w0_val == 2097152, 
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0x200000;  op2val:0xffefffff
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0x200000, 0xffefffff, x30, x2, 512, x3)

inst_96:
// rs1_w0_val == 1048576, 
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0x100000;  op2val:0xfffffeff
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0x100000, 0xfffffeff, x30, x2, 520, x3)

inst_97:
// rs1_w0_val == 524288, 
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0x080000;  op2val:0xfffffffd
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0x080000, 0xfffffffd, x30, x2, 528, x3)

inst_98:
// rs1_w0_val == 65536, 
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0x010000;  op2val:0xfffffeff
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0x010000, 0xfffffeff, x30, x2, 536, x3)

inst_99:
// rs1_w0_val == 8192, 
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0x002000;  op2val:0x020000
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0x002000, 0x020000, x30, x2, 544, x3)

inst_100:
// rs1_w0_val == 262144, 
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0x040000;  op2val:0x000002
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0x040000, 0x000002, x30, x2, 552, x3)

inst_101:
// rs1_w0_val == 131072, 
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0x020000;  op2val:0xfffffbff
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0x020000, 0xfffffbff, x30, x2, 560, x3)

inst_102:
// rs1_w0_val != rs2_w0_val and rs1_w0_val > 0 and rs2_w0_val > 0, rs2_w0_val == 4293918719, rs1_w0_val == 16
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0x000010;  op2val:0xffefffff
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0x000010, 0xffefffff, x30, x2, 568, x3)

inst_103:
// rs2_w0_val == 2863311530, 
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0x000013;  op2val:0xaaaaaaaa
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0x000013, 0xaaaaaaaa, x30, x2, 576, x3)

inst_104:
// rs2_w0_val == 4160749567, 
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0x00000a;  op2val:0xf7ffffff
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0x00000a, 0xf7ffffff, x30, x2, 584, x3)

inst_105:
// rs2_w0_val == 4294967279, rs1_w0_val == 32768
// opcode: uksubw ; op1:x30; op2:x29; dest:x31; op1val:0x008000;  op2val:0xffffffef
TEST_PKRR_OP(uksubw, x31, x30, x29, 0x00000000, 0x008000, 0xffffffef, x30, x2, 592, x3)
#endif


RVTEST_CODE_END
RVMODEL_HALT

RVTEST_DATA_BEGIN
.align 4
rvtest_data:
.word 0xbabecafe
.word 0xabecafeb
.word 0xbecafeba
.word 0xecafebab
RVTEST_DATA_END

RVMODEL_DATA_BEGIN


signature_x11_0:
    .fill 0*(XLEN/32),4,0xdeadbeef


signature_x11_1:
    .fill 30*(XLEN/32),4,0xdeadbeef


signature_x2_0:
    .fill 32*(XLEN/32),4,0xdeadbeef


signature_x2_1:
    .fill 150*(XLEN/32),4,0xdeadbeef

#ifdef rvtest_mtrap_routine

mtrap_sigptr:
    .fill 64*(XLEN/32),4,0xdeadbeef

#endif

#ifdef rvtest_gpr_save

gpr_save:
    .fill 32*(XLEN/32),4,0xdeadbeef

#endif

RVMODEL_DATA_END
