
// -----------
// This file was generated by riscv_ctg (https://github.com/riscv-software-src/riscv-ctg)
// version   : 0.6.3
// timestamp : Sat Apr 23 14:53:29 2022 GMT
// usage     : riscv_ctg \
//                  --cgf /scratch/git-repo/github/riscv_ctg/sample_cgfs/dataset.cgf \
//                  --cgf /scratch/git-repo/github/riscv_ctg/sample_cgfs/rv32ip.cgf \
//                  --xlen 32  \
//                  --randomize \
// -----------
//
// -----------
// Copyright (c) 2020. RISC-V International. All rights reserved.
// SPDX-License-Identifier: BSD-3-Clause
// -----------
//
// This assembly file tests the uraddw instruction of the RISC-V RV32PZicsr extension for the uraddw covergroup.
// 
#include "model_test.h"
#include "arch_test.h"
RVTEST_ISA("RV32IPZicsr")

.section .text.init
.org 0x80
.globl rvtest_entry_point
rvtest_entry_point:
RVMODEL_BOOT
RVTEST_CODE_BEGIN

#ifdef TEST_CASE_1

RVTEST_CASE(0,"//check ISA:=regex(.*32.*);check ISA:=regex(.*I.*P.*Zicsr.*);def TEST_CASE_1=True;",uraddw)

RVTEST_VXSAT_ENABLE()
RVTEST_SIGBASE(x6,signature_x6_1)

inst_0:
// rs1 != rs2  and rs1 != rd and rs2 != rd, rs1==x11, rs2==x3, rd==x4, rs1_w0_val == 0, rs2_w0_val == 3758096383
// opcode: uraddw ; op1:x11; dest:x4; op1val:0x000000;  immval:$imm_val
TEST_RR_OP(uraddw, x4, x11, x3, 0x00000000, 0x000000, 0xdfffffff, x6, 0, x8)

inst_1:
// rs1 == rs2 != rd, rs1==x22, rs2==x22, rd==x29, rs2_w0_val == 2863311530, rs1_w0_val == 16
// opcode: uraddw ; op1:x22; dest:x29; op1val:0x000010;  immval:$imm_val
TEST_RR_OP(uraddw, x29, x22, x22, 0x00000000, 0x000010, 0xaaaaaaaa, x6, 4, x8)

inst_2:
// rs1 == rd != rs2, rs1==x19, rs2==x14, rd==x19, rs2_w0_val == 1431655765, rs1_w0_val == 4294966271
// opcode: uraddw ; op1:x19; dest:x19; op1val:0xfffffbff;  immval:$imm_val
TEST_RR_OP(uraddw, x19, x19, x14, 0x00000000, 0xfffffbff, 0x55555555, x6, 8, x8)

inst_3:
// rs1 == rs2 == rd, rs1==x17, rs2==x17, rd==x17, rs2_w0_val == 2147483647, rs1_w0_val == 256
// opcode: uraddw ; op1:x17; dest:x17; op1val:0x000100;  immval:$imm_val
TEST_RR_OP(uraddw, x17, x17, x17, 0x00000000, 0x000100, 0x7fffffff, x6, 12, x8)

inst_4:
// rs2 == rd != rs1, rs1==x13, rs2==x1, rd==x1, rs2_w0_val == 3221225471, rs1_w0_val == 4294967287
// opcode: uraddw ; op1:x13; dest:x1; op1val:0xfffffff7;  immval:$imm_val
TEST_RR_OP(uraddw, x1, x13, x1, 0x00000000, 0xfffffff7, 0xbfffffff, x6, 16, x8)

inst_5:
// rs1==x23, rs2==x21, rd==x25, rs2_w0_val == 4026531839, rs1_w0_val == 16777216
// opcode: uraddw ; op1:x23; dest:x25; op1val:0x1000000;  immval:$imm_val
TEST_RR_OP(uraddw, x25, x23, x21, 0x00000000, 0x1000000, 0xefffffff, x6, 20, x8)

inst_6:
// rs1==x20, rs2==x28, rd==x14, rs2_w0_val == 4160749567, rs1_w0_val == 4227858431
// opcode: uraddw ; op1:x20; dest:x14; op1val:0xfbffffff;  immval:$imm_val
TEST_RR_OP(uraddw, x14, x20, x28, 0x00000000, 0xfbffffff, 0xf7ffffff, x6, 24, x8)

inst_7:
// rs1==x30, rs2==x0, rd==x10, rs2_w0_val == 4227858431, 
// opcode: uraddw ; op1:x30; dest:x10; op1val:0xfffffbff;  immval:$imm_val
TEST_RR_OP(uraddw, x10, x30, x0, 0x00000000, 0xfffffbff, 0xfbffffff, x6, 28, x8)

inst_8:
// rs1==x16, rs2==x7, rd==x22, rs2_w0_val == 4261412863, rs1_w0_val == 2
// opcode: uraddw ; op1:x16; dest:x22; op1val:0x000002;  immval:$imm_val
TEST_RR_OP(uraddw, x22, x16, x7, 0x00000000, 0x000002, 0xfdffffff, x6, 32, x8)

inst_9:
// rs1==x24, rs2==x2, rd==x9, rs2_w0_val == 4278190079, rs1_w0_val == 2048
// opcode: uraddw ; op1:x24; dest:x9; op1val:0x000800;  immval:$imm_val
TEST_RR_OP(uraddw, x9, x24, x2, 0x00000000, 0x000800, 0xfeffffff, x6, 36, x8)

inst_10:
// rs1==x12, rs2==x5, rd==x7, rs2_w0_val == 4286578687, 
// opcode: uraddw ; op1:x12; dest:x7; op1val:0x000007;  immval:$imm_val
TEST_RR_OP(uraddw, x7, x12, x5, 0x00000000, 0x000007, 0xff7fffff, x6, 40, x8)

inst_11:
// rs1==x26, rs2==x30, rd==x23, rs2_w0_val == 4290772991, rs1_w0_val == 4294967291
// opcode: uraddw ; op1:x26; dest:x23; op1val:0xfffffffb;  immval:$imm_val
TEST_RR_OP(uraddw, x23, x26, x30, 0x00000000, 0xfffffffb, 0xffbfffff, x6, 44, x8)

inst_12:
// rs1==x27, rs2==x4, rd==x21, rs2_w0_val == 4292870143, rs1_w0_val == 1048576
// opcode: uraddw ; op1:x27; dest:x21; op1val:0x100000;  immval:$imm_val
TEST_RR_OP(uraddw, x21, x27, x4, 0x00000000, 0x100000, 0xffdfffff, x6, 48, x8)

inst_13:
// rs1==x7, rs2==x24, rd==x31, rs2_w0_val == 4293918719, rs1_w0_val == 4160749567
// opcode: uraddw ; op1:x7; dest:x31; op1val:0xf7ffffff;  immval:$imm_val
TEST_RR_OP(uraddw, x31, x7, x24, 0x00000000, 0xf7ffffff, 0xffefffff, x6, 52, x4)
RVTEST_SIGBASE(x7,signature_x7_0)

inst_14:
// rs1==x3, rs2==x6, rd==x15, rs2_w0_val == 4294443007, rs1_w0_val == 2863311530
// opcode: uraddw ; op1:x3; dest:x15; op1val:0xaaaaaaaa;  immval:$imm_val
TEST_RR_OP(uraddw, x15, x3, x6, 0x00000000, 0xaaaaaaaa, 0xfff7ffff, x7, 0, x4)

inst_15:
// rs1==x21, rs2==x18, rd==x2, rs2_w0_val == 4294705151, rs1_w0_val == 524288
// opcode: uraddw ; op1:x21; dest:x2; op1val:0x080000;  immval:$imm_val
TEST_RR_OP(uraddw, x2, x21, x18, 0x00000000, 0x080000, 0xfffbffff, x7, 4, x4)

inst_16:
// rs1==x5, rs2==x11, rd==x13, rs2_w0_val == 4294836223, 
// opcode: uraddw ; op1:x5; dest:x13; op1val:0x000005;  immval:$imm_val
TEST_RR_OP(uraddw, x13, x5, x11, 0x00000000, 0x000005, 0xfffdffff, x7, 8, x4)

inst_17:
// rs1==x8, rs2==x16, rd==x11, rs2_w0_val == 4294901759, rs1_w0_val == 8
// opcode: uraddw ; op1:x8; dest:x11; op1val:0x000008;  immval:$imm_val
TEST_RR_OP(uraddw, x11, x8, x16, 0x00000000, 0x000008, 0xfffeffff, x7, 12, x4)

inst_18:
// rs1==x14, rs2==x29, rd==x0, rs2_w0_val == 4294934527, rs1_w0_val == 32
// opcode: uraddw ; op1:x14; dest:x0; op1val:0x000020;  immval:$imm_val
TEST_RR_OP(uraddw, x0, x14, x29, 0x00000000, 0x000020, 0xffff7fff, x7, 16, x4)

inst_19:
// rs1==x31, rs2==x19, rd==x24, rs2_w0_val == 4294950911, rs1_w0_val == 4293918719
// opcode: uraddw ; op1:x31; dest:x24; op1val:0xffefffff;  immval:$imm_val
TEST_RR_OP(uraddw, x24, x31, x19, 0x00000000, 0xffefffff, 0xffffbfff, x7, 20, x4)

inst_20:
// rs1==x25, rs2==x31, rd==x16, rs2_w0_val == 4294959103, 
// opcode: uraddw ; op1:x25; dest:x16; op1val:0x000011;  immval:$imm_val
TEST_RR_OP(uraddw, x16, x25, x31, 0x00000000, 0x000011, 0xffffdfff, x7, 24, x4)

inst_21:
// rs1==x10, rs2==x8, rd==x18, rs2_w0_val == 4294963199, rs1_w0_val == 1024
// opcode: uraddw ; op1:x10; dest:x18; op1val:0x000400;  immval:$imm_val
TEST_RR_OP(uraddw, x18, x10, x8, 0x00000000, 0x000400, 0xffffefff, x7, 28, x4)

inst_22:
// rs1==x1, rs2==x15, rd==x26, rs2_w0_val == 4294965247, rs1_w0_val == 2147483647
// opcode: uraddw ; op1:x1; dest:x26; op1val:0x7fffffff;  immval:$imm_val
TEST_RR_OP(uraddw, x26, x1, x15, 0x00000000, 0x7fffffff, 0xfffff7ff, x7, 32, x4)

inst_23:
// rs1==x18, rs2==x13, rd==x27, rs2_w0_val == 4294966271, 
// opcode: uraddw ; op1:x18; dest:x27; op1val:0x000800;  immval:$imm_val
TEST_RR_OP(uraddw, x27, x18, x13, 0x00000000, 0x000800, 0xfffffbff, x7, 36, x4)

inst_24:
// rs1==x29, rs2==x23, rd==x3, rs2_w0_val == 4294966783, rs1_w0_val == 536870912
// opcode: uraddw ; op1:x29; dest:x3; op1val:0x20000000;  immval:$imm_val
TEST_RR_OP(uraddw, x3, x29, x23, 0x00000000, 0x20000000, 0xfffffdff, x7, 40, x4)

inst_25:
// rs1==x28, rs2==x20, rd==x5, rs2_w0_val == 4294967039, 
// opcode: uraddw ; op1:x28; dest:x5; op1val:0x000003;  immval:$imm_val
TEST_RR_OP(uraddw, x5, x28, x20, 0x00000000, 0x000003, 0xfffffeff, x7, 44, x4)

inst_26:
// rs1==x9, rs2==x25, rd==x12, rs2_w0_val == 4294967167, rs1_w0_val == 4
// opcode: uraddw ; op1:x9; dest:x12; op1val:0x000004;  immval:$imm_val
TEST_RR_OP(uraddw, x12, x9, x25, 0x00000000, 0x000004, 0xffffff7f, x7, 48, x4)

inst_27:
// rs1==x4, rs2==x27, rd==x20, rs2_w0_val == 4294967231, 
// opcode: uraddw ; op1:x4; dest:x20; op1val:0x000800;  immval:$imm_val
TEST_RR_OP(uraddw, x20, x4, x27, 0x00000000, 0x000800, 0xffffffbf, x7, 52, x3)
RVTEST_SIGBASE(x1,signature_x1_0)

inst_28:
// rs1==x15, rs2==x10, rd==x30, rs2_w0_val == 4294967263, rs1_w0_val == 4294836223
// opcode: uraddw ; op1:x15; dest:x30; op1val:0xfffdffff;  immval:$imm_val
TEST_RR_OP(uraddw, x30, x15, x10, 0x00000000, 0xfffdffff, 0xffffffdf, x1, 0, x3)

inst_29:
// rs1==x2, rs2==x26, rd==x8, rs2_w0_val == 4294967279, 
// opcode: uraddw ; op1:x2; dest:x8; op1val:0x000012;  immval:$imm_val
TEST_RR_OP(uraddw, x8, x2, x26, 0x00000000, 0x000012, 0xffffffef, x1, 4, x3)

inst_30:
// rs1==x0, rs2==x9, rd==x6, rs2_w0_val == 4294967287, 
// opcode: uraddw ; op1:x0; dest:x6; op1val:0xfffffffb;  immval:$imm_val
TEST_RR_OP(uraddw, x6, x0, x9, 0x00000000, 0xfffffffb, 0xfffffff7, x1, 8, x3)

inst_31:
// rs1==x6, rs2==x12, rd==x28, rs2_w0_val == 4294967291, 
// opcode: uraddw ; op1:x6; dest:x28; op1val:0x000400;  immval:$imm_val
TEST_RR_OP(uraddw, x28, x6, x12, 0x00000000, 0x000400, 0xfffffffb, x1, 12, x3)

inst_32:
// rs2_w0_val == 4294967293, rs1_w0_val == 4294966783
// opcode: uraddw ; op1:x30; dest:x31; op1val:0xfffffdff;  immval:$imm_val
TEST_RR_OP(uraddw, x31, x30, x29, 0x00000000, 0xfffffdff, 0xfffffffd, x1, 16, x3)

inst_33:
// rs2_w0_val == 4294967294, 
// opcode: uraddw ; op1:x30; dest:x31; op1val:0xfffffff7;  immval:$imm_val
TEST_RR_OP(uraddw, x31, x30, x29, 0x00000000, 0xfffffff7, 0xfffffffe, x1, 20, x3)

inst_34:
// rs2_w0_val == 2147483648, 
// opcode: uraddw ; op1:x30; dest:x31; op1val:0x00000c;  immval:$imm_val
TEST_RR_OP(uraddw, x31, x30, x29, 0x00000000, 0x00000c, 0x80000000, x1, 24, x3)

inst_35:
// rs2_w0_val == 1073741824, rs1_w0_val == 3221225471
// opcode: uraddw ; op1:x30; dest:x31; op1val:0xbfffffff;  immval:$imm_val
TEST_RR_OP(uraddw, x31, x30, x29, 0x00000000, 0xbfffffff, 0x40000000, x1, 28, x3)

inst_36:
// rs2_w0_val == 536870912, rs1_w0_val == 4294967295
// opcode: uraddw ; op1:x30; dest:x31; op1val:0xffffffff;  immval:$imm_val
TEST_RR_OP(uraddw, x31, x30, x29, 0x00000000, 0xffffffff, 0x20000000, x1, 32, x3)

inst_37:
// rs2_w0_val == 268435456, rs1_w0_val == 4096
// opcode: uraddw ; op1:x30; dest:x31; op1val:0x001000;  immval:$imm_val
TEST_RR_OP(uraddw, x31, x30, x29, 0x00000000, 0x001000, 0x10000000, x1, 36, x3)

inst_38:
// rs2_w0_val == 134217728, 
// opcode: uraddw ; op1:x30; dest:x31; op1val:0x000004;  immval:$imm_val
TEST_RR_OP(uraddw, x31, x30, x29, 0x00000000, 0x000004, 0x8000000, x1, 40, x3)

inst_39:
// rs2_w0_val == 67108864, 
// opcode: uraddw ; op1:x30; dest:x31; op1val:0x000002;  immval:$imm_val
TEST_RR_OP(uraddw, x31, x30, x29, 0x00000000, 0x000002, 0x4000000, x1, 44, x3)

inst_40:
// rs2_w0_val == 33554432, rs1_w0_val == 67108864
// opcode: uraddw ; op1:x30; dest:x31; op1val:0x4000000;  immval:$imm_val
TEST_RR_OP(uraddw, x31, x30, x29, 0x00000000, 0x4000000, 0x2000000, x1, 48, x3)

inst_41:
// rs2_w0_val == 16777216, 
// opcode: uraddw ; op1:x30; dest:x31; op1val:0x000009;  immval:$imm_val
TEST_RR_OP(uraddw, x31, x30, x29, 0x00000000, 0x000009, 0x1000000, x1, 52, x3)

inst_42:
// rs2_w0_val == 8388608, rs1_w0_val == 4294967231
// opcode: uraddw ; op1:x30; dest:x31; op1val:0xffffffbf;  immval:$imm_val
TEST_RR_OP(uraddw, x31, x30, x29, 0x00000000, 0xffffffbf, 0x800000, x1, 56, x3)

inst_43:
// rs2_w0_val == 4194304, rs1_w0_val == 4026531839
// opcode: uraddw ; op1:x30; dest:x31; op1val:0xefffffff;  immval:$imm_val
TEST_RR_OP(uraddw, x31, x30, x29, 0x00000000, 0xefffffff, 0x400000, x1, 60, x3)

inst_44:
// rs2_w0_val == 2097152, rs1_w0_val == 8388608
// opcode: uraddw ; op1:x30; dest:x31; op1val:0x800000;  immval:$imm_val
TEST_RR_OP(uraddw, x31, x30, x29, 0x00000000, 0x800000, 0x200000, x1, 64, x3)

inst_45:
// rs1_w0_val == 64, rs2_w0_val == 1024
// opcode: uraddw ; op1:x30; dest:x31; op1val:0x000040;  immval:$imm_val
TEST_RR_OP(uraddw, x31, x30, x29, 0x00000000, 0x000040, 0x000400, x1, 68, x3)

inst_46:
// rs1_w0_val == 1, 
// opcode: uraddw ; op1:x30; dest:x31; op1val:0x000001;  immval:$imm_val
TEST_RR_OP(uraddw, x31, x30, x29, 0x00000000, 0x000001, 0x10000000, x1, 72, x3)

inst_47:
// rs2_w0_val == 1048576, rs1_w0_val == 4294934527
// opcode: uraddw ; op1:x30; dest:x31; op1val:0xffff7fff;  immval:$imm_val
TEST_RR_OP(uraddw, x31, x30, x29, 0x00000000, 0xffff7fff, 0x100000, x1, 76, x3)

inst_48:
// rs2_w0_val == 524288, rs1_w0_val == 4294967293
// opcode: uraddw ; op1:x30; dest:x31; op1val:0xfffffffd;  immval:$imm_val
TEST_RR_OP(uraddw, x31, x30, x29, 0x00000000, 0xfffffffd, 0x080000, x1, 80, x3)

inst_49:
// rs2_w0_val == 262144, rs1_w0_val == 1073741824
// opcode: uraddw ; op1:x30; dest:x31; op1val:0x40000000;  immval:$imm_val
TEST_RR_OP(uraddw, x31, x30, x29, 0x00000000, 0x40000000, 0x040000, x1, 84, x3)

inst_50:
// rs2_w0_val == 131072, 
// opcode: uraddw ; op1:x30; dest:x31; op1val:0x00000c;  immval:$imm_val
TEST_RR_OP(uraddw, x31, x30, x29, 0x00000000, 0x00000c, 0x020000, x1, 88, x3)

inst_51:
// rs2_w0_val == 65536, rs1_w0_val == 4294965247
// opcode: uraddw ; op1:x30; dest:x31; op1val:0xfffff7ff;  immval:$imm_val
TEST_RR_OP(uraddw, x31, x30, x29, 0x00000000, 0xfffff7ff, 0x010000, x1, 92, x3)

inst_52:
// rs2_w0_val == 32768, 
// opcode: uraddw ; op1:x30; dest:x31; op1val:0xfffffffd;  immval:$imm_val
TEST_RR_OP(uraddw, x31, x30, x29, 0x00000000, 0xfffffffd, 0x008000, x1, 96, x3)

inst_53:
// rs2_w0_val == 16384, 
// opcode: uraddw ; op1:x30; dest:x31; op1val:0xfffffdff;  immval:$imm_val
TEST_RR_OP(uraddw, x31, x30, x29, 0x00000000, 0xfffffdff, 0x004000, x1, 100, x3)

inst_54:
// rs2_w0_val == 8192, rs1_w0_val == 3758096383
// opcode: uraddw ; op1:x30; dest:x31; op1val:0xdfffffff;  immval:$imm_val
TEST_RR_OP(uraddw, x31, x30, x29, 0x00000000, 0xdfffffff, 0x002000, x1, 104, x3)

inst_55:
// rs2_w0_val == 4096, rs1_w0_val == 4292870143
// opcode: uraddw ; op1:x30; dest:x31; op1val:0xffdfffff;  immval:$imm_val
TEST_RR_OP(uraddw, x31, x30, x29, 0x00000000, 0xffdfffff, 0x001000, x1, 108, x3)

inst_56:
// rs2_w0_val == 2048, 
// opcode: uraddw ; op1:x30; dest:x31; op1val:0x000013;  immval:$imm_val
TEST_RR_OP(uraddw, x31, x30, x29, 0x00000000, 0x000013, 0x000800, x1, 112, x3)

inst_57:
// rs2_w0_val == 512, 
// opcode: uraddw ; op1:x30; dest:x31; op1val:0xdfffffff;  immval:$imm_val
TEST_RR_OP(uraddw, x31, x30, x29, 0x00000000, 0xdfffffff, 0x000200, x1, 116, x3)

inst_58:
// rs2_w0_val == 256, 
// opcode: uraddw ; op1:x30; dest:x31; op1val:0x00000d;  immval:$imm_val
TEST_RR_OP(uraddw, x31, x30, x29, 0x00000000, 0x00000d, 0x000100, x1, 120, x3)

inst_59:
// rs2_w0_val == 128, 
// opcode: uraddw ; op1:x30; dest:x31; op1val:0x000020;  immval:$imm_val
TEST_RR_OP(uraddw, x31, x30, x29, 0x00000000, 0x000020, 0x000080, x1, 124, x3)

inst_60:
// rs2_w0_val == 64, rs1_w0_val == 4294967167
// opcode: uraddw ; op1:x30; dest:x31; op1val:0xffffff7f;  immval:$imm_val
TEST_RR_OP(uraddw, x31, x30, x29, 0x00000000, 0xffffff7f, 0x000040, x1, 128, x3)

inst_61:
// rs2_w0_val == 32, 
// opcode: uraddw ; op1:x30; dest:x31; op1val:0x00000b;  immval:$imm_val
TEST_RR_OP(uraddw, x31, x30, x29, 0x00000000, 0x00000b, 0x000020, x1, 132, x3)

inst_62:
// rs2_w0_val == 16, 
// opcode: uraddw ; op1:x30; dest:x31; op1val:0x00000c;  immval:$imm_val
TEST_RR_OP(uraddw, x31, x30, x29, 0x00000000, 0x00000c, 0x000010, x1, 136, x3)

inst_63:
// rs2_w0_val == 8, rs1_w0_val == 4294959103
// opcode: uraddw ; op1:x30; dest:x31; op1val:0xffffdfff;  immval:$imm_val
TEST_RR_OP(uraddw, x31, x30, x29, 0x00000000, 0xffffdfff, 0x000008, x1, 140, x3)

inst_64:
// rs2_w0_val == 4, 
// opcode: uraddw ; op1:x30; dest:x31; op1val:0x000013;  immval:$imm_val
TEST_RR_OP(uraddw, x31, x30, x29, 0x00000000, 0x000013, 0x000004, x1, 144, x3)

inst_65:
// rs2_w0_val == 2, rs1_w0_val == 512
// opcode: uraddw ; op1:x30; dest:x31; op1val:0x000200;  immval:$imm_val
TEST_RR_OP(uraddw, x31, x30, x29, 0x00000000, 0x000200, 0x000002, x1, 148, x3)

inst_66:
// rs2_w0_val == 1, 
// opcode: uraddw ; op1:x30; dest:x31; op1val:0xefffffff;  immval:$imm_val
TEST_RR_OP(uraddw, x31, x30, x29, 0x00000000, 0xefffffff, 0x000001, x1, 152, x3)

inst_67:
// rs2_w0_val == 4294967295, 
// opcode: uraddw ; op1:x30; dest:x31; op1val:0xffffff7f;  immval:$imm_val
TEST_RR_OP(uraddw, x31, x30, x29, 0x00000000, 0xffffff7f, 0xffffffff, x1, 156, x3)

inst_68:
// rs2_w0_val == 0, 
// opcode: uraddw ; op1:x30; dest:x31; op1val:0xdfffffff;  immval:$imm_val
TEST_RR_OP(uraddw, x31, x30, x29, 0x00000000, 0xdfffffff, 0x000000, x1, 160, x3)

inst_69:
// rs1_w0_val == 1431655765, 
// opcode: uraddw ; op1:x30; dest:x31; op1val:0x55555555;  immval:$imm_val
TEST_RR_OP(uraddw, x31, x30, x29, 0x00000000, 0x55555555, 0x000010, x1, 164, x3)

inst_70:
// rs1_w0_val == 4261412863, 
// opcode: uraddw ; op1:x30; dest:x31; op1val:0xfdffffff;  immval:$imm_val
TEST_RR_OP(uraddw, x31, x30, x29, 0x00000000, 0xfdffffff, 0x000001, x1, 168, x3)

inst_71:
// rs1_w0_val == 4278190079, 
// opcode: uraddw ; op1:x30; dest:x31; op1val:0xfeffffff;  immval:$imm_val
TEST_RR_OP(uraddw, x31, x30, x29, 0x00000000, 0xfeffffff, 0xfdffffff, x1, 172, x3)

inst_72:
// rs1_w0_val == 4286578687, 
// opcode: uraddw ; op1:x30; dest:x31; op1val:0xff7fffff;  immval:$imm_val
TEST_RR_OP(uraddw, x31, x30, x29, 0x00000000, 0xff7fffff, 0x000004, x1, 176, x3)

inst_73:
// rs1_w0_val == 4290772991, 
// opcode: uraddw ; op1:x30; dest:x31; op1val:0xffbfffff;  immval:$imm_val
TEST_RR_OP(uraddw, x31, x30, x29, 0x00000000, 0xffbfffff, 0x020000, x1, 180, x3)

inst_74:
// rs1_w0_val == 4294443007, 
// opcode: uraddw ; op1:x30; dest:x31; op1val:0xfff7ffff;  immval:$imm_val
TEST_RR_OP(uraddw, x31, x30, x29, 0x00000000, 0xfff7ffff, 0x000004, x1, 184, x3)

inst_75:
// rs1_w0_val == 4294705151, 
// opcode: uraddw ; op1:x30; dest:x31; op1val:0xfffbffff;  immval:$imm_val
TEST_RR_OP(uraddw, x31, x30, x29, 0x00000000, 0xfffbffff, 0xfffffdff, x1, 188, x3)

inst_76:
// rs1_w0_val == 4294901759, 
// opcode: uraddw ; op1:x30; dest:x31; op1val:0xfffeffff;  immval:$imm_val
TEST_RR_OP(uraddw, x31, x30, x29, 0x00000000, 0xfffeffff, 0xffffffff, x1, 192, x3)

inst_77:
// rs1_w0_val == 4294950911, 
// opcode: uraddw ; op1:x30; dest:x31; op1val:0xffffbfff;  immval:$imm_val
TEST_RR_OP(uraddw, x31, x30, x29, 0x00000000, 0xffffbfff, 0x000020, x1, 196, x3)

inst_78:
// rs1_w0_val == 4294963199, 
// opcode: uraddw ; op1:x30; dest:x31; op1val:0xffffefff;  immval:$imm_val
TEST_RR_OP(uraddw, x31, x30, x29, 0x00000000, 0xffffefff, 0xff7fffff, x1, 200, x3)

inst_79:
// rs1_w0_val == 4294967039, 
// opcode: uraddw ; op1:x30; dest:x31; op1val:0xfffffeff;  immval:$imm_val
TEST_RR_OP(uraddw, x31, x30, x29, 0x00000000, 0xfffffeff, 0xfffffeff, x1, 204, x3)

inst_80:
// rs1_w0_val == 4294967263, 
// opcode: uraddw ; op1:x30; dest:x31; op1val:0xffffffdf;  immval:$imm_val
TEST_RR_OP(uraddw, x31, x30, x29, 0x00000000, 0xffffffdf, 0x080000, x1, 208, x3)

inst_81:
// rs1_w0_val == 4294967279, 
// opcode: uraddw ; op1:x30; dest:x31; op1val:0xffffffef;  immval:$imm_val
TEST_RR_OP(uraddw, x31, x30, x29, 0x00000000, 0xffffffef, 0x100000, x1, 212, x3)

inst_82:
// rs1_w0_val == 4294967294, 
// opcode: uraddw ; op1:x30; dest:x31; op1val:0xfffffffe;  immval:$imm_val
TEST_RR_OP(uraddw, x31, x30, x29, 0x00000000, 0xfffffffe, 0x20000000, x1, 216, x3)

inst_83:
// rs1_w0_val == 2147483648, 
// opcode: uraddw ; op1:x30; dest:x31; op1val:0x80000000;  immval:$imm_val
TEST_RR_OP(uraddw, x31, x30, x29, 0x00000000, 0x80000000, 0xfffff7ff, x1, 220, x3)

inst_84:
// rs1_w0_val == 268435456, 
// opcode: uraddw ; op1:x30; dest:x31; op1val:0x10000000;  immval:$imm_val
TEST_RR_OP(uraddw, x31, x30, x29, 0x00000000, 0x10000000, 0x000002, x1, 224, x3)

inst_85:
// rs1_w0_val == 134217728, 
// opcode: uraddw ; op1:x30; dest:x31; op1val:0x8000000;  immval:$imm_val
TEST_RR_OP(uraddw, x31, x30, x29, 0x00000000, 0x8000000, 0x000100, x1, 228, x3)

inst_86:
// rs1_w0_val == 33554432, 
// opcode: uraddw ; op1:x30; dest:x31; op1val:0x2000000;  immval:$imm_val
TEST_RR_OP(uraddw, x31, x30, x29, 0x00000000, 0x2000000, 0x00000e, x1, 232, x3)

inst_87:
// rs1_w0_val == 4194304, 
// opcode: uraddw ; op1:x30; dest:x31; op1val:0x400000;  immval:$imm_val
TEST_RR_OP(uraddw, x31, x30, x29, 0x00000000, 0x400000, 0xffffffef, x1, 236, x3)

inst_88:
// rs1_w0_val == 2097152, 
// opcode: uraddw ; op1:x30; dest:x31; op1val:0x200000;  immval:$imm_val
TEST_RR_OP(uraddw, x31, x30, x29, 0x00000000, 0x200000, 0xffefffff, x1, 240, x3)

inst_89:
// rs1_w0_val == 262144, 
// opcode: uraddw ; op1:x30; dest:x31; op1val:0x040000;  immval:$imm_val
TEST_RR_OP(uraddw, x31, x30, x29, 0x00000000, 0x040000, 0xffffffdf, x1, 244, x3)

inst_90:
// rs1_w0_val == 131072, 
// opcode: uraddw ; op1:x30; dest:x31; op1val:0x020000;  immval:$imm_val
TEST_RR_OP(uraddw, x31, x30, x29, 0x00000000, 0x020000, 0x000010, x1, 248, x3)

inst_91:
// rs1_w0_val == 65536, 
// opcode: uraddw ; op1:x30; dest:x31; op1val:0x010000;  immval:$imm_val
TEST_RR_OP(uraddw, x31, x30, x29, 0x00000000, 0x010000, 0x008000, x1, 252, x3)

inst_92:
// rs1_w0_val == 16384, 
// opcode: uraddw ; op1:x30; dest:x31; op1val:0x004000;  immval:$imm_val
TEST_RR_OP(uraddw, x31, x30, x29, 0x00000000, 0x004000, 0x000010, x1, 256, x3)

inst_93:
// rs1_w0_val == 8192, 
// opcode: uraddw ; op1:x30; dest:x31; op1val:0x002000;  immval:$imm_val
TEST_RR_OP(uraddw, x31, x30, x29, 0x00000000, 0x002000, 0xfffff7ff, x1, 260, x3)

inst_94:
// rs1_w0_val == 128, 
// opcode: uraddw ; op1:x30; dest:x31; op1val:0x000080;  immval:$imm_val
TEST_RR_OP(uraddw, x31, x30, x29, 0x00000000, 0x000080, 0xfbffffff, x1, 264, x3)

inst_95:
// rs1_w0_val == 32768, 
// opcode: uraddw ; op1:x30; dest:x31; op1val:0x008000;  immval:$imm_val
TEST_RR_OP(uraddw, x31, x30, x29, 0x00000000, 0x008000, 0x00000a, x1, 268, x3)

inst_96:
// rs2_w0_val == 2863311530, rs1_w0_val == 16
// opcode: uraddw ; op1:x30; dest:x31; op1val:0x000010;  immval:$imm_val
TEST_RR_OP(uraddw, x31, x30, x29, 0x00000000, 0x000010, 0xaaaaaaaa, x1, 272, x3)

inst_97:
// rs2_w0_val == 2147483647, rs1_w0_val == 256
// opcode: uraddw ; op1:x30; dest:x31; op1val:0x000100;  immval:$imm_val
TEST_RR_OP(uraddw, x31, x30, x29, 0x00000000, 0x000100, 0x7fffffff, x1, 276, x3)

inst_98:
// rs2_w0_val == 4294934527, rs1_w0_val == 32
// opcode: uraddw ; op1:x30; dest:x31; op1val:0x000020;  immval:$imm_val
TEST_RR_OP(uraddw, x31, x30, x29, 0x00000000, 0x000020, 0xffff7fff, x1, 280, x3)

inst_99:
// rs2_w0_val == 4294967287, 
// opcode: uraddw ; op1:x30; dest:x31; op1val:0xfffffffb;  immval:$imm_val
TEST_RR_OP(uraddw, x31, x30, x29, 0x00000000, 0xfffffffb, 0xfffffff7, x1, 284, x3)
#endif


RVTEST_CODE_END
RVMODEL_HALT

RVTEST_DATA_BEGIN
.align 4
rvtest_data:
.word 0xbabecafe
.word 0xabecafeb
.word 0xbecafeba
.word 0xecafebab
RVTEST_DATA_END

RVMODEL_DATA_BEGIN


signature_x6_0:
    .fill 0*(XLEN/32),4,0xdeadbeef


signature_x6_1:
    .fill 14*(XLEN/32),4,0xdeadbeef


signature_x7_0:
    .fill 14*(XLEN/32),4,0xdeadbeef


signature_x1_0:
    .fill 72*(XLEN/32),4,0xdeadbeef

#ifdef rvtest_mtrap_routine

mtrap_sigptr:
    .fill 64*(XLEN/32),4,0xdeadbeef

#endif

#ifdef rvtest_gpr_save

gpr_save:
    .fill 32*(XLEN/32),4,0xdeadbeef

#endif

RVMODEL_DATA_END
