// -----------
// This file was generated by riscv_ctg (https://gitlab.com/incoresemi/riscv-compliance/riscv_ctg)
// version   : 0.5.1
// timestamp : Wed Aug  4 07:22:49 2021 GMT
// usage     : riscv_ctg \
//                  --cgf /home/bilalsakhawat/dev2/riscv-ctg/sample_cgfs/dataset.cgf \
//                  --cgf /home/bilalsakhawat/dev2/riscv-ctg/sample_cgfs/rv32em.cgf \
//                  --base-isa rv32e \
//                  --randomize
// -----------
//
// -----------
// Copyright (c) 2020. RISC-V International. All rights reserved.
// SPDX-License-Identifier: BSD-3-Clause
// -----------
//
// This assembly file tests the div instruction of the RISC-V M extension for the div covergroup.
// 
#include "model_test.h"
#include "arch_test.h"
RVTEST_ISA("RV32EM")

.section .text.init
.globl rvtest_entry_point
rvtest_entry_point:
RVMODEL_BOOT
RVTEST_CODE_BEGIN

#ifdef TEST_CASE_1

RVTEST_CASE(0,"//check ISA:=regex(.*32.*);check ISA:=regex(.*E.*M.*) ;def RVTEST_E = True;def TEST_CASE_1=True;",div)

RVTEST_SIGBASE( x2,signature_x2_1)

inst_0:
// rs2 == rd != rs1, rs1==x7, rs2==x11, rd==x11, rs1_val != rs2_val, rs1_val > 0 and rs2_val > 0, rs2_val == 128
// opcode: div ; op1:x7; op2:x11; dest:x11; op1val:0x6;  op2val:0x80
TEST_RR_OP(div, x11, x7, x11, 0x0, 0x6, 0x80, x2, 0, x3)

inst_1:
// rs1 == rd != rs2, rs1==x15, rs2==x8, rd==x15, rs2_val == 2147483647, rs1_val < 0 and rs2_val > 0, rs2_val == (2**(xlen-1)-1), rs1_val == -131073
// opcode: div ; op1:x15; op2:x8; dest:x15; op1val:-0x20001;  op2val:0x7fffffff
TEST_RR_OP(div, x15, x15, x8, 0x0, -0x20001, 0x7fffffff, x2, 4, x3)

inst_2:
// rs1 == rs2 == rd, rs1==x9, rs2==x9, rd==x9, rs2_val == -1073741825, rs1_val < 0 and rs2_val < 0
// opcode: div ; op1:x9; op2:x9; dest:x9; op1val:-0x8;  op2val:-0x8
TEST_RR_OP(div, x9, x9, x9, 0x1, -0x8, -0x8, x2, 8, x3)

inst_3:
// rs1 == rs2 != rd, rs1==x4, rs2==x4, rd==x5, rs2_val == -536870913, rs1_val == 16384, rs1_val > 0 and rs2_val < 0
// opcode: div ; op1:x4; op2:x4; dest:x5; op1val:0x4000;  op2val:0x4000
TEST_RR_OP(div, x5, x4, x4, 0x1, 0x4000, 0x4000, x2, 12, x3)

inst_4:
// rs1 != rs2  and rs1 != rd and rs2 != rd, rs1==x12, rs2==x0, rd==x7, rs2_val == -268435457, rs1_val == -4194305
// opcode: div ; op1:x12; op2:x0; dest:x7; op1val:-0x400001;  op2val:0x0
TEST_RR_OP(div, x7, x12, x0, 0xFFFFFFFF, -0x400001, 0x0, x2, 16, x3)

inst_5:
// rs1==x6, rs2==x1, rd==x8, rs2_val == -134217729, rs1_val == 16
// opcode: div ; op1:x6; op2:x1; dest:x8; op1val:0x10;  op2val:-0x8000001
TEST_RR_OP(div, x8, x6, x1, 0x0, 0x10, -0x8000001, x2, 20, x3)

inst_6:
// rs1==x13, rs2==x15, rd==x0, rs2_val == -67108865, 
// opcode: div ; op1:x13; op2:x15; dest:x0; op1val:0x66666666;  op2val:-0x4000001
TEST_RR_OP(div, x0, x13, x15, 0, 0x66666666, -0x4000001, x2, 24, x3)

inst_7:
// rs1==x14, rs2==x13, rd==x6, rs2_val == -33554433, rs1_val == 4096
// opcode: div ; op1:x14; op2:x13; dest:x6; op1val:0x1000;  op2val:-0x2000001
TEST_RR_OP(div, x6, x14, x13, 0x0, 0x1000, -0x2000001, x2, 28, x9)
RVTEST_SIGBASE( x4,signature_x4_0)

inst_8:
// rs1==x1, rs2==x5, rd==x10, rs2_val == -16777217, 
// opcode: div ; op1:x1; op2:x5; dest:x10; op1val:-0x20001;  op2val:-0x1000001
TEST_RR_OP(div, x10, x1, x5, 0x0, -0x20001, -0x1000001, x4, 0, x9)

inst_9:
// rs1==x8, rs2==x12, rd==x2, rs2_val == -8388609, rs1_val == 4
// opcode: div ; op1:x8; op2:x12; dest:x2; op1val:0x4;  op2val:-0x800001
TEST_RR_OP(div, x2, x8, x12, 0x0, 0x4, -0x800001, x4, 4, x9)

inst_10:
// rs1==x10, rs2==x3, rd==x1, rs2_val == -4194305, rs1_val == -32769
// opcode: div ; op1:x10; op2:x3; dest:x1; op1val:-0x8001;  op2val:-0x400001
TEST_RR_OP(div, x1, x10, x3, 0x0, -0x8001, -0x400001, x4, 8, x9)

inst_11:
// rs1==x3, rs2==x14, rd==x12, rs2_val == -2097153, rs1_val == 1431655765
// opcode: div ; op1:x3; op2:x14; dest:x12; op1val:0x55555555;  op2val:-0x200001
TEST_RR_OP(div, x12, x3, x14, -0x2aa, 0x55555555, -0x200001, x4, 12, x9)

inst_12:
// rs1==x0, rs2==x6, rd==x13, rs2_val == -1048577, 
// opcode: div ; op1:x0; op2:x6; dest:x13; op1val:0x0;  op2val:-0x100001
TEST_RR_OP(div, x13, x0, x6, 0x0, 0x0, -0x100001, x4, 16, x9)

inst_13:
// rs1==x11, rs2==x7, rd==x3, rs2_val == -524289, rs1_val == -17
// opcode: div ; op1:x11; op2:x7; dest:x3; op1val:-0x11;  op2val:-0x80001
TEST_RR_OP(div, x3, x11, x7, 0x0, -0x11, -0x80001, x4, 20, x9)
RVTEST_SIGBASE( x1,signature_x1_0)

inst_14:
// rs1==x2, rs2==x10, rd==x4, rs2_val == -262145, 
// opcode: div ; op1:x2; op2:x10; dest:x4; op1val:-0xb503;  op2val:-0x40001
TEST_RR_OP(div, x4, x2, x10, 0x0, -0xb503, -0x40001, x1, 0, x3)

inst_15:
// rs1==x5, rs2==x2, rd==x14, rs2_val == -131073, rs1_val == rs2_val
// opcode: div ; op1:x5; op2:x2; dest:x14; op1val:-0x20001;  op2val:-0x20001
TEST_RR_OP(div, x14, x5, x2, 0x1, -0x20001, -0x20001, x1, 4, x3)

inst_16:
// rs2_val == -65537, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x8;  op2val:-0x10001
TEST_RR_OP(div, x12, x10, x11, 0x0, -0x8, -0x10001, x1, 8, x3)

inst_17:
// rs2_val == -32769, rs1_val == 16777216
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x1000000;  op2val:-0x8001
TEST_RR_OP(div, x12, x10, x11, -0x1ff, 0x1000000, -0x8001, x1, 12, x3)

inst_18:
// rs2_val == -16385, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x7;  op2val:-0x4001
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x7, -0x4001, x1, 16, x3)

inst_19:
// rs2_val == -8193, rs1_val == -3
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x3;  op2val:-0x2001
TEST_RR_OP(div, x12, x10, x11, 0x0, -0x3, -0x2001, x1, 20, x3)

inst_20:
// rs2_val == -4097, rs1_val == 512
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x200;  op2val:-0x1001
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x200, -0x1001, x1, 24, x3)

inst_21:
// rs2_val == -2049, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:-0x801
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x5, -0x801, x1, 28, x3)

inst_22:
// rs2_val == -1025, rs1_val == -513
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x201;  op2val:-0x401
TEST_RR_OP(div, x12, x10, x11, 0x0, -0x201, -0x401, x1, 32, x3)

inst_23:
// rs2_val == -513, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x400001;  op2val:-0x201
TEST_RR_OP(div, x12, x10, x11, 0x1ff0, -0x400001, -0x201, x1, 36, x3)

inst_24:
// rs2_val == -257, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:-0x101
TEST_RR_OP(div, x12, x10, x11, -0x330033, 0x33333333, -0x101, x1, 40, x3)

inst_25:
// rs2_val == -129, rs1_val == -8193
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x2001;  op2val:-0x81
TEST_RR_OP(div, x12, x10, x11, 0x3f, -0x2001, -0x81, x1, 44, x3)

inst_26:
// rs2_val == -65, rs1_val == 1073741824
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x40000000;  op2val:-0x41
TEST_RR_OP(div, x12, x10, x11, -0xfc0fc0, 0x40000000, -0x41, x1, 48, x3)

inst_27:
// rs2_val == -33, rs1_val == -536870913
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x20000001;  op2val:-0x21
TEST_RR_OP(div, x12, x10, x11, 0xf83e0f, -0x20000001, -0x21, x1, 52, x3)

inst_28:
// rs2_val == -17, rs1_val == 4194304
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x400000;  op2val:-0x11
TEST_RR_OP(div, x12, x10, x11, -0x3c3c3, 0x400000, -0x11, x1, 56, x3)

inst_29:
// rs2_val == -9, rs1_val == -33554433
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x2000001;  op2val:-0x9
TEST_RR_OP(div, x12, x10, x11, 0x38e38e, -0x2000001, -0x9, x1, 60, x3)

inst_30:
// rs2_val == -5, rs1_val == -524289
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x80001;  op2val:-0x5
TEST_RR_OP(div, x12, x10, x11, 0x19999, -0x80001, -0x5, x1, 64, x3)

inst_31:
// rs2_val == -3, rs1_val == -2097153
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x200001;  op2val:-0x3
TEST_RR_OP(div, x12, x10, x11, 0xaaaab, -0x200001, -0x3, x1, 68, x3)

inst_32:
// rs2_val == -2, rs1_val == 134217728
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x8000000;  op2val:-0x2
TEST_RR_OP(div, x12, x10, x11, -0x4000000, 0x8000000, -0x2, x1, 72, x3)

inst_33:
// rs1_val == 2147483647, rs1_val == (2**(xlen-1)-1)
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x7fffffff;  op2val:-0x2000001
TEST_RR_OP(div, x12, x10, x11, -0x3f, 0x7fffffff, -0x2000001, x1, 76, x3)

inst_34:
// rs1_val == -1073741825, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x40000001;  op2val:-0x8001
TEST_RR_OP(div, x12, x10, x11, 0x7fff, -0x40000001, -0x8001, x1, 80, x3)

inst_35:
// rs1_val == -268435457, rs2_val == 2048
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x10000001;  op2val:0x800
TEST_RR_OP(div, x12, x10, x11, -0x20000, -0x10000001, 0x800, x1, 84, x3)

inst_36:
// rs1_val == -134217729, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x8000001;  op2val:-0x3
TEST_RR_OP(div, x12, x10, x11, 0x2aaaaab, -0x8000001, -0x3, x1, 88, x3)

inst_37:
// rs1_val == -67108865, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x4000001;  op2val:-0x4000001
TEST_RR_OP(div, x12, x10, x11, 0x1, -0x4000001, -0x4000001, x1, 92, x3)

inst_38:
// rs1_val == -16777217, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x1000001;  op2val:-0x40001
TEST_RR_OP(div, x12, x10, x11, 0x3f, -0x1000001, -0x40001, x1, 96, x3)

inst_39:
// rs1_val == -8388609, rs2_val == 256
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x800001;  op2val:0x100
TEST_RR_OP(div, x12, x10, x11, -0x8000, -0x800001, 0x100, x1, 100, x3)

inst_40:
// rs1_val == -1048577, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x100001;  op2val:0x66666665
TEST_RR_OP(div, x12, x10, x11, 0x0, -0x100001, 0x66666665, x1, 104, x3)

inst_41:
// rs1_val == -262145, rs2_val == 524288
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x40001;  op2val:0x80000
TEST_RR_OP(div, x12, x10, x11, 0x0, -0x40001, 0x80000, x1, 108, x3)

inst_42:
// rs1_val == -65537, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x10001;  op2val:-0x100001
TEST_RR_OP(div, x12, x10, x11, 0x0, -0x10001, -0x100001, x1, 112, x3)

inst_43:
// rs1_val == -16385, rs2_val == 2097152
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x4001;  op2val:0x200000
TEST_RR_OP(div, x12, x10, x11, 0x0, -0x4001, 0x200000, x1, 116, x3)

inst_44:
// rs1_val == -4097, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x1001;  op2val:-0x201
TEST_RR_OP(div, x12, x10, x11, 0x7, -0x1001, -0x201, x1, 120, x3)

inst_45:
// rs1_val == -2049, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x801;  op2val:-0x9
TEST_RR_OP(div, x12, x10, x11, 0xe3, -0x801, -0x9, x1, 124, x3)

inst_46:
// rs1_val == -1025, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x401;  op2val:-0x7
TEST_RR_OP(div, x12, x10, x11, 0x92, -0x401, -0x7, x1, 128, x3)

inst_47:
// rs1_val == -257, rs2_val == 4194304
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x101;  op2val:0x400000
TEST_RR_OP(div, x12, x10, x11, 0x0, -0x101, 0x400000, x1, 132, x3)

inst_48:
// rs1_val == -129, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x81;  op2val:-0x1
TEST_RR_OP(div, x12, x10, x11, 0x81, -0x81, -0x1, x1, 136, x3)

inst_49:
// rs1_val == -65, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x41;  op2val:-0x40001
TEST_RR_OP(div, x12, x10, x11, 0x0, -0x41, -0x40001, x1, 140, x3)

inst_50:
// rs1_val == -33, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x21;  op2val:-0x40001
TEST_RR_OP(div, x12, x10, x11, 0x0, -0x21, -0x40001, x1, 144, x3)

inst_51:
// rs1_val == -9, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x9;  op2val:0x66666665
TEST_RR_OP(div, x12, x10, x11, 0x0, -0x9, 0x66666665, x1, 148, x3)

inst_52:
// rs1_val == -5, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x5;  op2val:-0x400001
TEST_RR_OP(div, x12, x10, x11, 0x0, -0x5, -0x400001, x1, 152, x3)

inst_53:
// rs1_val == -2, rs2_val == 64
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x2;  op2val:0x40
TEST_RR_OP(div, x12, x10, x11, 0x0, -0x2, 0x40, x1, 156, x3)

inst_54:
// rs2_val == -2147483648, rs2_val == (-2**(xlen-1))
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x3;  op2val:-0x80000000
TEST_RR_OP(div, x12, x10, x11, 0x0, -0x3, -0x80000000, x1, 160, x3)

inst_55:
// rs2_val == 1073741824, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x2001;  op2val:0x40000000
TEST_RR_OP(div, x12, x10, x11, 0x0, -0x2001, 0x40000000, x1, 164, x3)

inst_56:
// rs2_val == 536870912, rs1_val == 1048576
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x100000;  op2val:0x20000000
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x100000, 0x20000000, x1, 168, x3)

inst_57:
// rs2_val == 268435456, rs1_val == 2
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x10000000
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x2, 0x10000000, x1, 172, x3)

inst_58:
// rs2_val == 134217728, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x4000001;  op2val:0x8000000
TEST_RR_OP(div, x12, x10, x11, 0x0, -0x4000001, 0x8000000, x1, 176, x3)

inst_59:
// rs2_val == 67108864, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x21;  op2val:0x4000000
TEST_RR_OP(div, x12, x10, x11, 0x0, -0x21, 0x4000000, x1, 180, x3)

inst_60:
// rs2_val == 33554432, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x101;  op2val:0x2000000
TEST_RR_OP(div, x12, x10, x11, 0x0, -0x101, 0x2000000, x1, 184, x3)

inst_61:
// rs2_val == 16777216, rs1_val == 256
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x100;  op2val:0x1000000
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x100, 0x1000000, x1, 188, x3)

inst_62:
// rs2_val == 8388608, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x400000;  op2val:0x800000
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x400000, 0x800000, x1, 192, x3)

inst_63:
// rs2_val == 1048576, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x100000
TEST_RR_OP(div, x12, x10, x11, 0x333, 0x33333334, 0x100000, x1, 196, x3)

inst_64:
// rs2_val == 262144, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x40000
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x4, 0x40000, x1, 200, x3)

inst_65:
// rs2_val == 131072, rs1_val == 0
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x20000
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x0, 0x20000, x1, 204, x3)

inst_66:
// rs2_val == 65536, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x1000;  op2val:0x10000
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x1000, 0x10000, x1, 208, x3)

inst_67:
// rs2_val == 32768, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x8000
TEST_RR_OP(div, x12, x10, x11, 0xaaaa, 0x55555555, 0x8000, x1, 212, x3)

inst_68:
// rs2_val == 16384, rs1_val == 1
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x1;  op2val:0x4000
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x1, 0x4000, x1, 216, x3)

inst_69:
// rs2_val == 8192, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x2000
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x2, 0x2000, x1, 220, x3)

inst_70:
// rs2_val == 4096, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x1000
TEST_RR_OP(div, x12, x10, x11, 0x33333, 0x33333334, 0x1000, x1, 224, x3)

inst_71:
// rs2_val == 1024, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x41;  op2val:0x400
TEST_RR_OP(div, x12, x10, x11, 0x0, -0x41, 0x400, x1, 228, x3)

inst_72:
// rs2_val == 512, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x1000;  op2val:0x200
TEST_RR_OP(div, x12, x10, x11, 0x8, 0x1000, 0x200, x1, 232, x3)

inst_73:
// rs2_val == 32, rs1_val == 128
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x80;  op2val:0x20
TEST_RR_OP(div, x12, x10, x11, 0x4, 0x80, 0x20, x1, 236, x3)

inst_74:
// rs2_val == 16, rs1_val == 32
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x20;  op2val:0x10
TEST_RR_OP(div, x12, x10, x11, 0x2, 0x20, 0x10, x1, 240, x3)

inst_75:
// rs2_val == 8, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x8
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x2, 0x8, x1, 244, x3)

inst_76:
// rs2_val == 4, rs1_val == 536870912
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x20000000;  op2val:0x4
TEST_RR_OP(div, x12, x10, x11, 0x8000000, 0x20000000, 0x4, x1, 248, x3)

inst_77:
// rs2_val == 2, rs1_val==5 and rs2_val==2
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x2
TEST_RR_OP(div, x12, x10, x11, 0x2, 0x5, 0x2, x1, 252, x3)

inst_78:
// rs2_val == 1, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x40000000;  op2val:0x1
TEST_RR_OP(div, x12, x10, x11, 0x40000000, 0x40000000, 0x1, x1, 256, x3)

inst_79:
// rs1_val == -2147483648, rs2_val == 0, rs1_val == (-2**(xlen-1))
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x80000000;  op2val:0x0
TEST_RR_OP(div, x12, x10, x11, 0xFFFFFFFF, -0x80000000, 0x0, x1, 260, x3)

inst_80:
// rs1_val == 268435456, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x10000000;  op2val:0x66666667
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x10000000, 0x66666667, x1, 264, x3)

inst_81:
// rs1_val == 67108864, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x4000000;  op2val:0x40000
TEST_RR_OP(div, x12, x10, x11, 0x100, 0x4000000, 0x40000, x1, 268, x3)

inst_82:
// rs1_val == 33554432, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x2000000;  op2val:0x55555556
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x2000000, 0x55555556, x1, 272, x3)

inst_83:
// rs1_val == 8388608, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x800000;  op2val:-0x801
TEST_RR_OP(div, x12, x10, x11, -0xffe, 0x800000, -0x801, x1, 276, x3)

inst_84:
// rs1_val == 2097152, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x200000;  op2val:-0x80000000
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x200000, -0x80000000, x1, 280, x3)

inst_85:
// rs1_val == 524288, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x80000;  op2val:-0x401
TEST_RR_OP(div, x12, x10, x11, -0x1ff, 0x80000, -0x401, x1, 284, x3)

inst_86:
// rs1_val == 262144, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x40000;  op2val:0x33333333
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x40000, 0x33333333, x1, 288, x3)

inst_87:
// rs1_val == 131072, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x20000;  op2val:0x800
TEST_RR_OP(div, x12, x10, x11, 0x40, 0x20000, 0x800, x1, 292, x3)

inst_88:
// rs1_val == 65536, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x10000;  op2val:0x6
TEST_RR_OP(div, x12, x10, x11, 0x2aaa, 0x10000, 0x6, x1, 296, x3)

inst_89:
// rs1_val == 32768, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x8000;  op2val:-0x40001
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x8000, -0x40001, x1, 300, x3)

inst_90:
// rs1_val == 8192, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x2000;  op2val:-0x201
TEST_RR_OP(div, x12, x10, x11, -0xf, 0x2000, -0x201, x1, 304, x3)

inst_91:
// rs1_val == 2048, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x800;  op2val:0x33333333
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x800, 0x33333333, x1, 308, x3)

inst_92:
// rs1_val == 1024, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x400;  op2val:-0x20001
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x400, -0x20001, x1, 312, x3)

inst_93:
// rs1_val == 64, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x40;  op2val:0x2
TEST_RR_OP(div, x12, x10, x11, 0x20, 0x40, 0x2, x1, 316, x3)

inst_94:
// rs1_val == 8, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x8;  op2val:0x66666667
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x8, 0x66666667, x1, 320, x3)

inst_95:
// rs1_val==46341 and rs2_val==46341, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0xb505
TEST_RR_OP(div, x12, x10, x11, 0x1, 0xb505, 0xb505, x1, 324, x3)

inst_96:
// rs1_val==46341 and rs2_val==-46339, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:-0xb503
TEST_RR_OP(div, x12, x10, x11, -0x1, 0xb505, -0xb503, x1, 328, x3)

inst_97:
// rs1_val==46341 and rs2_val==1717986919, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x66666667
TEST_RR_OP(div, x12, x10, x11, 0x0, 0xb505, 0x66666667, x1, 332, x3)

inst_98:
// rs1_val==46341 and rs2_val==858993460, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x33333334
TEST_RR_OP(div, x12, x10, x11, 0x0, 0xb505, 0x33333334, x1, 336, x3)

inst_99:
// rs1_val==46341 and rs2_val==6, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x6
TEST_RR_OP(div, x12, x10, x11, 0x1e2b, 0xb505, 0x6, x1, 340, x3)

inst_100:
// rs1_val==46341 and rs2_val==-1431655765, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:-0x55555555
TEST_RR_OP(div, x12, x10, x11, 0x0, 0xb505, -0x55555555, x1, 344, x3)

inst_101:
// rs1_val==46341 and rs2_val==1431655766, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x55555556
TEST_RR_OP(div, x12, x10, x11, 0x0, 0xb505, 0x55555556, x1, 348, x3)

inst_102:
// rs1_val==46341 and rs2_val==4, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x4
TEST_RR_OP(div, x12, x10, x11, 0x2d41, 0xb505, 0x4, x1, 352, x3)

inst_103:
// rs1_val==46341 and rs2_val==46339, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0xb503
TEST_RR_OP(div, x12, x10, x11, 0x1, 0xb505, 0xb503, x1, 356, x3)

inst_104:
// rs1_val==46341 and rs2_val==0, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x0
TEST_RR_OP(div, x12, x10, x11, 0xFFFFFFFF, 0xb505, 0x0, x1, 360, x3)

inst_105:
// rs1_val==46341 and rs2_val==1717986917, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x66666665
TEST_RR_OP(div, x12, x10, x11, 0x0, 0xb505, 0x66666665, x1, 364, x3)

inst_106:
// rs1_val==46341 and rs2_val==858993458, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x33333332
TEST_RR_OP(div, x12, x10, x11, 0x0, 0xb505, 0x33333332, x1, 368, x3)

inst_107:
// rs1_val==46341 and rs2_val==1431655764, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x55555554
TEST_RR_OP(div, x12, x10, x11, 0x0, 0xb505, 0x55555554, x1, 372, x3)

inst_108:
// rs1_val==46341 and rs2_val==2, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x2
TEST_RR_OP(div, x12, x10, x11, 0x5a82, 0xb505, 0x2, x1, 376, x3)

inst_109:
// rs1_val==46341 and rs2_val==46340, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0xb504
TEST_RR_OP(div, x12, x10, x11, 0x1, 0xb505, 0xb504, x1, 380, x3)

inst_110:
// rs1_val==46341 and rs2_val==-46340, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:-0xb504
TEST_RR_OP(div, x12, x10, x11, -0x1, 0xb505, -0xb504, x1, 384, x3)

inst_111:
// rs1_val==46341 and rs2_val==1717986918, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x66666666
TEST_RR_OP(div, x12, x10, x11, 0x0, 0xb505, 0x66666666, x1, 388, x3)

inst_112:
// rs1_val==46341 and rs2_val==858993459, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x33333333
TEST_RR_OP(div, x12, x10, x11, 0x0, 0xb505, 0x33333333, x1, 392, x3)

inst_113:
// rs1_val==46341 and rs2_val==5, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x5
TEST_RR_OP(div, x12, x10, x11, 0x2434, 0xb505, 0x5, x1, 396, x3)

inst_114:
// rs1_val==46341 and rs2_val==-1431655766, rs2_val == -1431655766
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:-0x55555556
TEST_RR_OP(div, x12, x10, x11, 0x0, 0xb505, -0x55555556, x1, 400, x3)

inst_115:
// rs1_val==46341 and rs2_val==1431655765, rs2_val == 1431655765
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x55555555
TEST_RR_OP(div, x12, x10, x11, 0x0, 0xb505, 0x55555555, x1, 404, x3)

inst_116:
// rs1_val==46341 and rs2_val==3, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x3
TEST_RR_OP(div, x12, x10, x11, 0x3c57, 0xb505, 0x3, x1, 408, x3)

inst_117:
// rs1_val==-46339 and rs2_val==46341, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0xb505
TEST_RR_OP(div, x12, x10, x11, 0x0, -0xb503, 0xb505, x1, 412, x3)

inst_118:
// rs1_val==-46339 and rs2_val==-46339, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:-0xb503
TEST_RR_OP(div, x12, x10, x11, 0x1, -0xb503, -0xb503, x1, 416, x3)

inst_119:
// rs1_val==-46339 and rs2_val==1717986919, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x66666667
TEST_RR_OP(div, x12, x10, x11, 0x0, -0xb503, 0x66666667, x1, 420, x3)

inst_120:
// rs1_val==-46339 and rs2_val==858993460, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x33333334
TEST_RR_OP(div, x12, x10, x11, 0x0, -0xb503, 0x33333334, x1, 424, x3)

inst_121:
// rs1_val==-46339 and rs2_val==6, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x6
TEST_RR_OP(div, x12, x10, x11, -0x1e2b, -0xb503, 0x6, x1, 428, x3)

inst_122:
// rs1_val==-46339 and rs2_val==-1431655765, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:-0x55555555
TEST_RR_OP(div, x12, x10, x11, 0x0, -0xb503, -0x55555555, x1, 432, x3)

inst_123:
// rs1_val==-46339 and rs2_val==1431655766, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x55555556
TEST_RR_OP(div, x12, x10, x11, 0x0, -0xb503, 0x55555556, x1, 436, x3)

inst_124:
// rs1_val==-46339 and rs2_val==4, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x4
TEST_RR_OP(div, x12, x10, x11, -0x2d40, -0xb503, 0x4, x1, 440, x3)

inst_125:
// rs1_val==-46339 and rs2_val==46339, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0xb503
TEST_RR_OP(div, x12, x10, x11, -0x1, -0xb503, 0xb503, x1, 444, x3)

inst_126:
// rs1_val==-46339 and rs2_val==0, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x0
TEST_RR_OP(div, x12, x10, x11, 0xFFFFFFFF, -0xb503, 0x0, x1, 448, x3)

inst_127:
// rs1_val==-46339 and rs2_val==1717986917, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x66666665
TEST_RR_OP(div, x12, x10, x11, 0x0, -0xb503, 0x66666665, x1, 452, x3)

inst_128:
// rs1_val==-46339 and rs2_val==858993458, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x33333332
TEST_RR_OP(div, x12, x10, x11, 0x0, -0xb503, 0x33333332, x1, 456, x3)

inst_129:
// rs1_val==-46339 and rs2_val==1431655764, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x55555554
TEST_RR_OP(div, x12, x10, x11, 0x0, -0xb503, 0x55555554, x1, 460, x3)

inst_130:
// rs1_val==-46339 and rs2_val==2, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x2
TEST_RR_OP(div, x12, x10, x11, -0x5a81, -0xb503, 0x2, x1, 464, x3)

inst_131:
// rs1_val==-46339 and rs2_val==46340, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0xb504
TEST_RR_OP(div, x12, x10, x11, 0x0, -0xb503, 0xb504, x1, 468, x3)

inst_132:
// rs1_val==-46339 and rs2_val==-46340, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:-0xb504
TEST_RR_OP(div, x12, x10, x11, 0x0, -0xb503, -0xb504, x1, 472, x3)

inst_133:
// rs1_val==-46339 and rs2_val==1717986918, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x66666666
TEST_RR_OP(div, x12, x10, x11, 0x0, -0xb503, 0x66666666, x1, 476, x3)

inst_134:
// rs1_val==-46339 and rs2_val==858993459, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x33333333
TEST_RR_OP(div, x12, x10, x11, 0x0, -0xb503, 0x33333333, x1, 480, x3)

inst_135:
// rs1_val==-46339 and rs2_val==5, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x5
TEST_RR_OP(div, x12, x10, x11, -0x2433, -0xb503, 0x5, x1, 484, x3)

inst_136:
// rs1_val==-46339 and rs2_val==-1431655766, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:-0x55555556
TEST_RR_OP(div, x12, x10, x11, 0x0, -0xb503, -0x55555556, x1, 488, x3)

inst_137:
// rs1_val==-46339 and rs2_val==1431655765, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x55555555
TEST_RR_OP(div, x12, x10, x11, 0x0, -0xb503, 0x55555555, x1, 492, x3)

inst_138:
// rs1_val==-46339 and rs2_val==3, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x3
TEST_RR_OP(div, x12, x10, x11, -0x3c56, -0xb503, 0x3, x1, 496, x3)

inst_139:
// rs1_val==1717986919 and rs2_val==46341, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0xb505
TEST_RR_OP(div, x12, x10, x11, 0x90d0, 0x66666667, 0xb505, x1, 500, x3)

inst_140:
// rs1_val==1717986919 and rs2_val==-46339, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:-0xb503
TEST_RR_OP(div, x12, x10, x11, -0x90d2, 0x66666667, -0xb503, x1, 504, x3)

inst_141:
// rs1_val==1717986919 and rs2_val==1717986919, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x66666667
TEST_RR_OP(div, x12, x10, x11, 0x1, 0x66666667, 0x66666667, x1, 508, x3)

inst_142:
// rs1_val==1717986919 and rs2_val==858993460, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x33333334
TEST_RR_OP(div, x12, x10, x11, 0x1, 0x66666667, 0x33333334, x1, 512, x3)

inst_143:
// rs1_val==1717986919 and rs2_val==6, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x6
TEST_RR_OP(div, x12, x10, x11, 0x11111111, 0x66666667, 0x6, x1, 516, x3)

inst_144:
// rs1_val==1717986919 and rs2_val==-1431655765, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:-0x55555555
TEST_RR_OP(div, x12, x10, x11, -0x1, 0x66666667, -0x55555555, x1, 520, x3)

inst_145:
// rs1_val==1717986919 and rs2_val==1431655766, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x55555556
TEST_RR_OP(div, x12, x10, x11, 0x1, 0x66666667, 0x55555556, x1, 524, x3)

inst_146:
// rs1_val==1717986919 and rs2_val==4, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x4
TEST_RR_OP(div, x12, x10, x11, 0x19999999, 0x66666667, 0x4, x1, 528, x3)

inst_147:
// rs1_val==1717986919 and rs2_val==46339, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0xb503
TEST_RR_OP(div, x12, x10, x11, 0x90d2, 0x66666667, 0xb503, x1, 532, x3)

inst_148:
// rs1_val==1717986919 and rs2_val==0, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x0
TEST_RR_OP(div, x12, x10, x11, 0xFFFFFFFF, 0x66666667, 0x0, x1, 536, x3)

inst_149:
// rs1_val==1717986919 and rs2_val==1717986917, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x66666665
TEST_RR_OP(div, x12, x10, x11, 0x1, 0x66666667, 0x66666665, x1, 540, x3)

inst_150:
// rs1_val==1717986919 and rs2_val==858993458, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x33333332
TEST_RR_OP(div, x12, x10, x11, 0x2, 0x66666667, 0x33333332, x1, 544, x3)

inst_151:
// rs1_val==1717986919 and rs2_val==1431655764, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x55555554
TEST_RR_OP(div, x12, x10, x11, 0x1, 0x66666667, 0x55555554, x1, 548, x3)

inst_152:
// rs1_val==1717986919 and rs2_val==2, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x2
TEST_RR_OP(div, x12, x10, x11, 0x33333333, 0x66666667, 0x2, x1, 552, x3)

inst_153:
// rs1_val==1717986919 and rs2_val==46340, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0xb504
TEST_RR_OP(div, x12, x10, x11, 0x90d1, 0x66666667, 0xb504, x1, 556, x3)

inst_154:
// rs1_val==1717986919 and rs2_val==-46340, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:-0xb504
TEST_RR_OP(div, x12, x10, x11, -0x90d1, 0x66666667, -0xb504, x1, 560, x3)

inst_155:
// rs1_val==1717986919 and rs2_val==1717986918, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x66666666
TEST_RR_OP(div, x12, x10, x11, 0x1, 0x66666667, 0x66666666, x1, 564, x3)

inst_156:
// rs1_val==1717986919 and rs2_val==858993459, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x33333333
TEST_RR_OP(div, x12, x10, x11, 0x2, 0x66666667, 0x33333333, x1, 568, x3)

inst_157:
// rs1_val==1717986919 and rs2_val==5, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x5
TEST_RR_OP(div, x12, x10, x11, 0x147ae147, 0x66666667, 0x5, x1, 572, x3)

inst_158:
// rs1_val==1717986919 and rs2_val==-1431655766, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:-0x55555556
TEST_RR_OP(div, x12, x10, x11, -0x1, 0x66666667, -0x55555556, x1, 576, x3)

inst_159:
// rs1_val==1717986919 and rs2_val==1431655765, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x55555555
TEST_RR_OP(div, x12, x10, x11, 0x1, 0x66666667, 0x55555555, x1, 580, x3)

inst_160:
// rs1_val==1717986919 and rs2_val==3, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x3
TEST_RR_OP(div, x12, x10, x11, 0x22222222, 0x66666667, 0x3, x1, 584, x3)

inst_161:
// rs1_val==858993460 and rs2_val==46341, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0xb505
TEST_RR_OP(div, x12, x10, x11, 0x4868, 0x33333334, 0xb505, x1, 588, x3)

inst_162:
// rs1_val==858993460 and rs2_val==-46339, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:-0xb503
TEST_RR_OP(div, x12, x10, x11, -0x4869, 0x33333334, -0xb503, x1, 592, x3)

inst_163:
// rs1_val==858993460 and rs2_val==1717986919, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x66666667
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x33333334, 0x66666667, x1, 596, x3)

inst_164:
// rs1_val==858993460 and rs2_val==858993460, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x33333334
TEST_RR_OP(div, x12, x10, x11, 0x1, 0x33333334, 0x33333334, x1, 600, x3)

inst_165:
// rs1_val==858993460 and rs2_val==6, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x6
TEST_RR_OP(div, x12, x10, x11, 0x8888888, 0x33333334, 0x6, x1, 604, x3)

inst_166:
// rs1_val==858993460 and rs2_val==-1431655765, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:-0x55555555
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x33333334, -0x55555555, x1, 608, x3)

inst_167:
// rs1_val==858993460 and rs2_val==1431655766, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x55555556
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x33333334, 0x55555556, x1, 612, x3)

inst_168:
// rs1_val==858993460 and rs2_val==4, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x4
TEST_RR_OP(div, x12, x10, x11, 0xccccccd, 0x33333334, 0x4, x1, 616, x3)

inst_169:
// rs1_val==858993460 and rs2_val==46339, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0xb503
TEST_RR_OP(div, x12, x10, x11, 0x4869, 0x33333334, 0xb503, x1, 620, x3)

inst_170:
// rs1_val==858993460 and rs2_val==0, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x0
TEST_RR_OP(div, x12, x10, x11, 0xFFFFFFFF, 0x33333334, 0x0, x1, 624, x3)

inst_171:
// rs1_val==858993460 and rs2_val==1717986917, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x66666665
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x33333334, 0x66666665, x1, 628, x3)

inst_172:
// rs1_val==858993460 and rs2_val==858993458, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x33333332
TEST_RR_OP(div, x12, x10, x11, 0x1, 0x33333334, 0x33333332, x1, 632, x3)

inst_173:
// rs1_val==858993460 and rs2_val==1431655764, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x55555554
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x33333334, 0x55555554, x1, 636, x3)

inst_174:
// rs1_val==858993460 and rs2_val==2, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x2
TEST_RR_OP(div, x12, x10, x11, 0x1999999a, 0x33333334, 0x2, x1, 640, x3)

inst_175:
// rs1_val==858993460 and rs2_val==46340, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0xb504
TEST_RR_OP(div, x12, x10, x11, 0x4868, 0x33333334, 0xb504, x1, 644, x3)

inst_176:
// rs1_val==858993460 and rs2_val==-46340, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:-0xb504
TEST_RR_OP(div, x12, x10, x11, -0x4868, 0x33333334, -0xb504, x1, 648, x3)

inst_177:
// rs1_val==858993460 and rs2_val==1717986918, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x66666666
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x33333334, 0x66666666, x1, 652, x3)

inst_178:
// rs1_val==858993460 and rs2_val==858993459, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x33333333
TEST_RR_OP(div, x12, x10, x11, 0x1, 0x33333334, 0x33333333, x1, 656, x3)

inst_179:
// rs1_val==858993460 and rs2_val==5, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x5
TEST_RR_OP(div, x12, x10, x11, 0xa3d70a4, 0x33333334, 0x5, x1, 660, x3)

inst_180:
// rs1_val==858993460 and rs2_val==-1431655766, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:-0x55555556
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x33333334, -0x55555556, x1, 664, x3)

inst_181:
// rs1_val==858993460 and rs2_val==1431655765, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x55555555
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x33333334, 0x55555555, x1, 668, x3)

inst_182:
// rs1_val==858993460 and rs2_val==3, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x3
TEST_RR_OP(div, x12, x10, x11, 0x11111111, 0x33333334, 0x3, x1, 672, x3)

inst_183:
// rs1_val==6 and rs2_val==46341, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0xb505
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x6, 0xb505, x1, 676, x3)

inst_184:
// rs1_val==6 and rs2_val==-46339, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:-0xb503
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x6, -0xb503, x1, 680, x3)

inst_185:
// rs1_val==6 and rs2_val==1717986919, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x66666667
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x6, 0x66666667, x1, 684, x3)

inst_186:
// rs1_val==6 and rs2_val==858993460, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x33333334
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x6, 0x33333334, x1, 688, x3)

inst_187:
// rs1_val==6 and rs2_val==6, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x6
TEST_RR_OP(div, x12, x10, x11, 0x1, 0x6, 0x6, x1, 692, x3)

inst_188:
// rs1_val==6 and rs2_val==-1431655765, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:-0x55555555
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x6, -0x55555555, x1, 696, x3)

inst_189:
// rs1_val==6 and rs2_val==1431655766, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x55555556
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x6, 0x55555556, x1, 700, x3)

inst_190:
// rs1_val==6 and rs2_val==4, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x4
TEST_RR_OP(div, x12, x10, x11, 0x1, 0x6, 0x4, x1, 704, x3)

inst_191:
// rs1_val==6 and rs2_val==46339, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0xb503
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x6, 0xb503, x1, 708, x3)

inst_192:
// rs1_val==6 and rs2_val==0, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x0
TEST_RR_OP(div, x12, x10, x11, 0xFFFFFFFF, 0x6, 0x0, x1, 712, x3)

inst_193:
// rs1_val==6 and rs2_val==1717986917, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x66666665
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x6, 0x66666665, x1, 716, x3)

inst_194:
// rs1_val==6 and rs2_val==858993458, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x33333332
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x6, 0x33333332, x1, 720, x3)

inst_195:
// rs1_val==6 and rs2_val==1431655764, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x55555554
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x6, 0x55555554, x1, 724, x3)

inst_196:
// rs1_val==6 and rs2_val==2, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x2
TEST_RR_OP(div, x12, x10, x11, 0x3, 0x6, 0x2, x1, 728, x3)

inst_197:
// rs1_val==6 and rs2_val==46340, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0xb504
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x6, 0xb504, x1, 732, x3)

inst_198:
// rs1_val==6 and rs2_val==-46340, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:-0xb504
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x6, -0xb504, x1, 736, x3)

inst_199:
// rs1_val==6 and rs2_val==1717986918, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x66666666
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x6, 0x66666666, x1, 740, x3)

inst_200:
// rs1_val==6 and rs2_val==858993459, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x33333333
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x6, 0x33333333, x1, 744, x3)

inst_201:
// rs1_val==6 and rs2_val==5, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x5
TEST_RR_OP(div, x12, x10, x11, 0x1, 0x6, 0x5, x1, 748, x3)

inst_202:
// rs1_val==6 and rs2_val==-1431655766, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:-0x55555556
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x6, -0x55555556, x1, 752, x3)

inst_203:
// rs1_val==6 and rs2_val==1431655765, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x55555555
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x6, 0x55555555, x1, 756, x3)

inst_204:
// rs1_val==6 and rs2_val==3, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x3
TEST_RR_OP(div, x12, x10, x11, 0x2, 0x6, 0x3, x1, 760, x3)

inst_205:
// rs1_val==-1431655765 and rs2_val==46341, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0xb505
TEST_RR_OP(div, x12, x10, x11, -0x78ad, -0x55555555, 0xb505, x1, 764, x3)

inst_206:
// rs1_val==-1431655765 and rs2_val==-46339, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:-0xb503
TEST_RR_OP(div, x12, x10, x11, 0x78af, -0x55555555, -0xb503, x1, 768, x3)

inst_207:
// rs1_val==-1431655765 and rs2_val==1717986919, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x66666667
TEST_RR_OP(div, x12, x10, x11, 0x0, -0x55555555, 0x66666667, x1, 772, x3)

inst_208:
// rs1_val==-1431655765 and rs2_val==858993460, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x33333334
TEST_RR_OP(div, x12, x10, x11, -0x1, -0x55555555, 0x33333334, x1, 776, x3)

inst_209:
// rs1_val==-1431655765 and rs2_val==6, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x6
TEST_RR_OP(div, x12, x10, x11, -0xe38e38e, -0x55555555, 0x6, x1, 780, x3)

inst_210:
// rs1_val==-1431655765 and rs2_val==-1431655765, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:-0x55555555
TEST_RR_OP(div, x12, x10, x11, 0x1, -0x55555555, -0x55555555, x1, 784, x3)

inst_211:
// rs1_val==-1431655765 and rs2_val==1431655766, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x55555556
TEST_RR_OP(div, x12, x10, x11, 0x0, -0x55555555, 0x55555556, x1, 788, x3)

inst_212:
// rs1_val==-1431655765 and rs2_val==4, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x4
TEST_RR_OP(div, x12, x10, x11, -0x15555555, -0x55555555, 0x4, x1, 792, x3)

inst_213:
// rs1_val==-1431655765 and rs2_val==46339, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0xb503
TEST_RR_OP(div, x12, x10, x11, -0x78af, -0x55555555, 0xb503, x1, 796, x3)

inst_214:
// rs1_val==-1431655765 and rs2_val==0, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x0
TEST_RR_OP(div, x12, x10, x11, 0xFFFFFFFF, -0x55555555, 0x0, x1, 800, x3)

inst_215:
// rs1_val==-1431655765 and rs2_val==1717986917, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x66666665
TEST_RR_OP(div, x12, x10, x11, 0x0, -0x55555555, 0x66666665, x1, 804, x3)

inst_216:
// rs1_val==-1431655765 and rs2_val==858993458, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x33333332
TEST_RR_OP(div, x12, x10, x11, -0x1, -0x55555555, 0x33333332, x1, 808, x3)

inst_217:
// rs1_val==-1431655765 and rs2_val==1431655764, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x55555554
TEST_RR_OP(div, x12, x10, x11, -0x1, -0x55555555, 0x55555554, x1, 812, x3)

inst_218:
// rs1_val==-1431655765 and rs2_val==2, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x2
TEST_RR_OP(div, x12, x10, x11, -0x2aaaaaaa, -0x55555555, 0x2, x1, 816, x3)

inst_219:
// rs1_val==-1431655765 and rs2_val==46340, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0xb504
TEST_RR_OP(div, x12, x10, x11, -0x78ae, -0x55555555, 0xb504, x1, 820, x3)

inst_220:
// rs1_val==-1431655765 and rs2_val==-46340, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:-0xb504
TEST_RR_OP(div, x12, x10, x11, 0x78ae, -0x55555555, -0xb504, x1, 824, x3)

inst_221:
// rs1_val==-1431655765 and rs2_val==1717986918, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x66666666
TEST_RR_OP(div, x12, x10, x11, 0x0, -0x55555555, 0x66666666, x1, 828, x3)

inst_222:
// rs1_val==-1431655765 and rs2_val==858993459, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x33333333
TEST_RR_OP(div, x12, x10, x11, -0x1, -0x55555555, 0x33333333, x1, 832, x3)

inst_223:
// rs1_val==-1431655765 and rs2_val==5, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x5
TEST_RR_OP(div, x12, x10, x11, -0x11111111, -0x55555555, 0x5, x1, 836, x3)

inst_224:
// rs1_val==-1431655765 and rs2_val==-1431655766, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:-0x55555556
TEST_RR_OP(div, x12, x10, x11, 0x0, -0x55555555, -0x55555556, x1, 840, x3)

inst_225:
// rs1_val==-1431655765 and rs2_val==1431655765, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x55555555
TEST_RR_OP(div, x12, x10, x11, -0x1, -0x55555555, 0x55555555, x1, 844, x3)

inst_226:
// rs1_val==-1431655765 and rs2_val==3, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x3
TEST_RR_OP(div, x12, x10, x11, -0x1c71c71c, -0x55555555, 0x3, x1, 848, x3)

inst_227:
// rs1_val==1431655766 and rs2_val==46341, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0xb505
TEST_RR_OP(div, x12, x10, x11, 0x78ad, 0x55555556, 0xb505, x1, 852, x3)

inst_228:
// rs1_val==1431655766 and rs2_val==-46339, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:-0xb503
TEST_RR_OP(div, x12, x10, x11, -0x78af, 0x55555556, -0xb503, x1, 856, x3)

inst_229:
// rs1_val==1431655766 and rs2_val==1717986919, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x66666667
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x55555556, 0x66666667, x1, 860, x3)

inst_230:
// rs1_val==1431655766 and rs2_val==858993460, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x33333334
TEST_RR_OP(div, x12, x10, x11, 0x1, 0x55555556, 0x33333334, x1, 864, x3)

inst_231:
// rs1_val==1431655766 and rs2_val==6, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x6
TEST_RR_OP(div, x12, x10, x11, 0xe38e38e, 0x55555556, 0x6, x1, 868, x3)

inst_232:
// rs1_val==1431655766 and rs2_val==-1431655765, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:-0x55555555
TEST_RR_OP(div, x12, x10, x11, -0x1, 0x55555556, -0x55555555, x1, 872, x3)

inst_233:
// rs1_val==1431655766 and rs2_val==1431655766, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x55555556
TEST_RR_OP(div, x12, x10, x11, 0x1, 0x55555556, 0x55555556, x1, 876, x3)

inst_234:
// rs1_val==1431655766 and rs2_val==4, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x4
TEST_RR_OP(div, x12, x10, x11, 0x15555555, 0x55555556, 0x4, x1, 880, x3)

inst_235:
// rs1_val==1431655766 and rs2_val==46339, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0xb503
TEST_RR_OP(div, x12, x10, x11, 0x78af, 0x55555556, 0xb503, x1, 884, x3)

inst_236:
// rs1_val==1431655766 and rs2_val==0, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x0
TEST_RR_OP(div, x12, x10, x11, 0xFFFFFFFF, 0x55555556, 0x0, x1, 888, x3)

inst_237:
// rs1_val==1431655766 and rs2_val==1717986917, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x66666665
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x55555556, 0x66666665, x1, 892, x3)

inst_238:
// rs1_val==1431655766 and rs2_val==858993458, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x33333332
TEST_RR_OP(div, x12, x10, x11, 0x1, 0x55555556, 0x33333332, x1, 896, x3)

inst_239:
// rs1_val==1431655766 and rs2_val==1431655764, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x55555554
TEST_RR_OP(div, x12, x10, x11, 0x1, 0x55555556, 0x55555554, x1, 900, x3)

inst_240:
// rs1_val==1431655766 and rs2_val==2, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x2
TEST_RR_OP(div, x12, x10, x11, 0x2aaaaaab, 0x55555556, 0x2, x1, 904, x3)

inst_241:
// rs1_val==1431655766 and rs2_val==46340, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0xb504
TEST_RR_OP(div, x12, x10, x11, 0x78ae, 0x55555556, 0xb504, x1, 908, x3)

inst_242:
// rs1_val==1431655766 and rs2_val==-46340, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:-0xb504
TEST_RR_OP(div, x12, x10, x11, -0x78ae, 0x55555556, -0xb504, x1, 912, x3)

inst_243:
// rs1_val==1431655766 and rs2_val==1717986918, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x66666666
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x55555556, 0x66666666, x1, 916, x3)

inst_244:
// rs1_val==1431655766 and rs2_val==858993459, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x33333333
TEST_RR_OP(div, x12, x10, x11, 0x1, 0x55555556, 0x33333333, x1, 920, x3)

inst_245:
// rs1_val==1431655766 and rs2_val==5, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x5
TEST_RR_OP(div, x12, x10, x11, 0x11111111, 0x55555556, 0x5, x1, 924, x3)

inst_246:
// rs1_val==1431655766 and rs2_val==-1431655766, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:-0x55555556
TEST_RR_OP(div, x12, x10, x11, -0x1, 0x55555556, -0x55555556, x1, 928, x3)

inst_247:
// rs1_val==1431655766 and rs2_val==1431655765, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x55555555
TEST_RR_OP(div, x12, x10, x11, 0x1, 0x55555556, 0x55555555, x1, 932, x3)

inst_248:
// rs1_val==1431655766 and rs2_val==3, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x3
TEST_RR_OP(div, x12, x10, x11, 0x1c71c71c, 0x55555556, 0x3, x1, 936, x3)

inst_249:
// rs1_val==4 and rs2_val==46341, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0xb505
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x4, 0xb505, x1, 940, x3)

inst_250:
// rs1_val==4 and rs2_val==-46339, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:-0xb503
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x4, -0xb503, x1, 944, x3)

inst_251:
// rs1_val==4 and rs2_val==1717986919, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x66666667
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x4, 0x66666667, x1, 948, x3)

inst_252:
// rs1_val==4 and rs2_val==858993460, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x33333334
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x4, 0x33333334, x1, 952, x3)

inst_253:
// rs1_val==4 and rs2_val==6, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x6
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x4, 0x6, x1, 956, x3)

inst_254:
// rs1_val==4 and rs2_val==-1431655765, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:-0x55555555
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x4, -0x55555555, x1, 960, x3)

inst_255:
// rs1_val==4 and rs2_val==1431655766, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x55555556
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x4, 0x55555556, x1, 964, x3)

inst_256:
// rs1_val==4 and rs2_val==4, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x4
TEST_RR_OP(div, x12, x10, x11, 0x1, 0x4, 0x4, x1, 968, x3)

inst_257:
// rs1_val==4 and rs2_val==46339, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0xb503
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x4, 0xb503, x1, 972, x3)

inst_258:
// rs1_val==4 and rs2_val==0, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x0
TEST_RR_OP(div, x12, x10, x11, 0xFFFFFFFF, 0x4, 0x0, x1, 976, x3)

inst_259:
// rs1_val==4 and rs2_val==1717986917, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x66666665
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x4, 0x66666665, x1, 980, x3)

inst_260:
// rs1_val==4 and rs2_val==858993458, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x33333332
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x4, 0x33333332, x1, 984, x3)

inst_261:
// rs1_val==4 and rs2_val==1431655764, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x55555554
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x4, 0x55555554, x1, 988, x3)

inst_262:
// rs1_val==4 and rs2_val==2, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x2
TEST_RR_OP(div, x12, x10, x11, 0x2, 0x4, 0x2, x1, 992, x3)

inst_263:
// rs1_val==4 and rs2_val==46340, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0xb504
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x4, 0xb504, x1, 996, x3)

inst_264:
// rs1_val==4 and rs2_val==-46340, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:-0xb504
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x4, -0xb504, x1, 1000, x3)

inst_265:
// rs1_val==4 and rs2_val==1717986918, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x66666666
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x4, 0x66666666, x1, 1004, x3)

inst_266:
// rs1_val==4 and rs2_val==858993459, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x33333333
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x4, 0x33333333, x1, 1008, x3)

inst_267:
// rs1_val==4 and rs2_val==5, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x5
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x4, 0x5, x1, 1012, x3)

inst_268:
// rs1_val==4 and rs2_val==-1431655766, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:-0x55555556
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x4, -0x55555556, x1, 1016, x3)

inst_269:
// rs1_val==4 and rs2_val==1431655765, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x55555555
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x4, 0x55555555, x1, 1020, x3)

inst_270:
// rs1_val==4 and rs2_val==3, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x3
TEST_RR_OP(div, x12, x10, x11, 0x1, 0x4, 0x3, x1, 1024, x3)

inst_271:
// rs1_val==46339 and rs2_val==46341, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0xb505
TEST_RR_OP(div, x12, x10, x11, 0x0, 0xb503, 0xb505, x1, 1028, x3)

inst_272:
// rs1_val==46339 and rs2_val==-46339, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:-0xb503
TEST_RR_OP(div, x12, x10, x11, -0x1, 0xb503, -0xb503, x1, 1032, x3)

inst_273:
// rs1_val==46339 and rs2_val==1717986919, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x66666667
TEST_RR_OP(div, x12, x10, x11, 0x0, 0xb503, 0x66666667, x1, 1036, x3)

inst_274:
// rs1_val==46339 and rs2_val==858993460, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x33333334
TEST_RR_OP(div, x12, x10, x11, 0x0, 0xb503, 0x33333334, x1, 1040, x3)

inst_275:
// rs1_val==46339 and rs2_val==6, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x6
TEST_RR_OP(div, x12, x10, x11, 0x1e2b, 0xb503, 0x6, x1, 1044, x3)

inst_276:
// rs1_val==46339 and rs2_val==-1431655765, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:-0x55555555
TEST_RR_OP(div, x12, x10, x11, 0x0, 0xb503, -0x55555555, x1, 1048, x3)

inst_277:
// rs1_val==46339 and rs2_val==1431655766, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x55555556
TEST_RR_OP(div, x12, x10, x11, 0x0, 0xb503, 0x55555556, x1, 1052, x3)

inst_278:
// rs1_val==46339 and rs2_val==4, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x4
TEST_RR_OP(div, x12, x10, x11, 0x2d40, 0xb503, 0x4, x1, 1056, x3)

inst_279:
// rs1_val==46339 and rs2_val==46339, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0xb503
TEST_RR_OP(div, x12, x10, x11, 0x1, 0xb503, 0xb503, x1, 1060, x3)

inst_280:
// rs1_val==46339 and rs2_val==0, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x0
TEST_RR_OP(div, x12, x10, x11, 0xFFFFFFFF, 0xb503, 0x0, x1, 1064, x3)

inst_281:
// rs1_val==46339 and rs2_val==1717986917, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x66666665
TEST_RR_OP(div, x12, x10, x11, 0x0, 0xb503, 0x66666665, x1, 1068, x3)

inst_282:
// rs1_val==46339 and rs2_val==858993458, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x33333332
TEST_RR_OP(div, x12, x10, x11, 0x0, 0xb503, 0x33333332, x1, 1072, x3)

inst_283:
// rs1_val==46339 and rs2_val==1431655764, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x55555554
TEST_RR_OP(div, x12, x10, x11, 0x0, 0xb503, 0x55555554, x1, 1076, x3)

inst_284:
// rs1_val==46339 and rs2_val==2, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x2
TEST_RR_OP(div, x12, x10, x11, 0x5a81, 0xb503, 0x2, x1, 1080, x3)

inst_285:
// rs1_val==46339 and rs2_val==46340, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0xb504
TEST_RR_OP(div, x12, x10, x11, 0x0, 0xb503, 0xb504, x1, 1084, x3)

inst_286:
// rs1_val==46339 and rs2_val==-46340, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:-0xb504
TEST_RR_OP(div, x12, x10, x11, 0x0, 0xb503, -0xb504, x1, 1088, x3)

inst_287:
// rs1_val==46339 and rs2_val==1717986918, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x66666666
TEST_RR_OP(div, x12, x10, x11, 0x0, 0xb503, 0x66666666, x1, 1092, x3)

inst_288:
// rs1_val==46339 and rs2_val==858993459, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x33333333
TEST_RR_OP(div, x12, x10, x11, 0x0, 0xb503, 0x33333333, x1, 1096, x3)

inst_289:
// rs1_val==46339 and rs2_val==5, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x5
TEST_RR_OP(div, x12, x10, x11, 0x2433, 0xb503, 0x5, x1, 1100, x3)

inst_290:
// rs1_val==46339 and rs2_val==-1431655766, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:-0x55555556
TEST_RR_OP(div, x12, x10, x11, 0x0, 0xb503, -0x55555556, x1, 1104, x3)

inst_291:
// rs1_val==46339 and rs2_val==1431655765, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x55555555
TEST_RR_OP(div, x12, x10, x11, 0x0, 0xb503, 0x55555555, x1, 1108, x3)

inst_292:
// rs1_val==46339 and rs2_val==3, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x3
TEST_RR_OP(div, x12, x10, x11, 0x3c56, 0xb503, 0x3, x1, 1112, x3)

inst_293:
// rs1_val==0 and rs2_val==46341, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0xb505
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x0, 0xb505, x1, 1116, x3)

inst_294:
// rs1_val==0 and rs2_val==-46339, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:-0xb503
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x0, -0xb503, x1, 1120, x3)

inst_295:
// rs1_val==0 and rs2_val==1717986919, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x66666667
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x0, 0x66666667, x1, 1124, x3)

inst_296:
// rs1_val==0 and rs2_val==858993460, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x33333334
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x0, 0x33333334, x1, 1128, x3)

inst_297:
// rs1_val==0 and rs2_val==6, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x6
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x0, 0x6, x1, 1132, x3)

inst_298:
// rs1_val==0 and rs2_val==-1431655765, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:-0x55555555
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x0, -0x55555555, x1, 1136, x3)

inst_299:
// rs1_val==0 and rs2_val==1431655766, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x55555556
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x0, 0x55555556, x1, 1140, x3)

inst_300:
// rs1_val==0 and rs2_val==4, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x4
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x0, 0x4, x1, 1144, x3)

inst_301:
// rs1_val==0 and rs2_val==46339, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0xb503
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x0, 0xb503, x1, 1148, x3)

inst_302:
// rs1_val==0 and rs2_val==0, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x0
TEST_RR_OP(div, x12, x10, x11, 0xFFFFFFFF, 0x0, 0x0, x1, 1152, x3)

inst_303:
// rs1_val==0 and rs2_val==1717986917, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x66666665
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x0, 0x66666665, x1, 1156, x3)

inst_304:
// rs1_val==0 and rs2_val==858993458, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x33333332
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x0, 0x33333332, x1, 1160, x3)

inst_305:
// rs1_val==0 and rs2_val==1431655764, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x55555554
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x0, 0x55555554, x1, 1164, x3)

inst_306:
// rs1_val==0 and rs2_val==2, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x2
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x0, 0x2, x1, 1168, x3)

inst_307:
// rs1_val==0 and rs2_val==46340, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0xb504
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x0, 0xb504, x1, 1172, x3)

inst_308:
// rs1_val==0 and rs2_val==-46340, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:-0xb504
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x0, -0xb504, x1, 1176, x3)

inst_309:
// rs1_val==0 and rs2_val==1717986918, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x66666666
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x0, 0x66666666, x1, 1180, x3)

inst_310:
// rs1_val==0 and rs2_val==858993459, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x33333333
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x0, 0x33333333, x1, 1184, x3)

inst_311:
// rs1_val==0 and rs2_val==5, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x5
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x0, 0x5, x1, 1188, x3)

inst_312:
// rs1_val==0 and rs2_val==-1431655766, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:-0x55555556
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x0, -0x55555556, x1, 1192, x3)

inst_313:
// rs1_val==0 and rs2_val==1431655765, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x55555555
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x0, 0x55555555, x1, 1196, x3)

inst_314:
// rs1_val==0 and rs2_val==3, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x3
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x0, 0x3, x1, 1200, x3)

inst_315:
// rs1_val==1717986917 and rs2_val==46341, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0xb505
TEST_RR_OP(div, x12, x10, x11, 0x90d0, 0x66666665, 0xb505, x1, 1204, x3)

inst_316:
// rs1_val==1717986917 and rs2_val==-46339, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:-0xb503
TEST_RR_OP(div, x12, x10, x11, -0x90d2, 0x66666665, -0xb503, x1, 1208, x3)

inst_317:
// rs1_val==1717986917 and rs2_val==1717986919, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x66666667
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x66666665, 0x66666667, x1, 1212, x3)

inst_318:
// rs1_val==1717986917 and rs2_val==858993460, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x33333334
TEST_RR_OP(div, x12, x10, x11, 0x1, 0x66666665, 0x33333334, x1, 1216, x3)

inst_319:
// rs1_val==1717986917 and rs2_val==6, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x6
TEST_RR_OP(div, x12, x10, x11, 0x11111110, 0x66666665, 0x6, x1, 1220, x3)

inst_320:
// rs1_val==1717986917 and rs2_val==-1431655765, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:-0x55555555
TEST_RR_OP(div, x12, x10, x11, -0x1, 0x66666665, -0x55555555, x1, 1224, x3)

inst_321:
// rs1_val==1717986917 and rs2_val==1431655766, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x55555556
TEST_RR_OP(div, x12, x10, x11, 0x1, 0x66666665, 0x55555556, x1, 1228, x3)

inst_322:
// rs1_val==1717986917 and rs2_val==4, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x4
TEST_RR_OP(div, x12, x10, x11, 0x19999999, 0x66666665, 0x4, x1, 1232, x3)

inst_323:
// rs1_val==1717986917 and rs2_val==46339, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0xb503
TEST_RR_OP(div, x12, x10, x11, 0x90d2, 0x66666665, 0xb503, x1, 1236, x3)

inst_324:
// rs1_val==858993459 and rs2_val==0, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x0
TEST_RR_OP(div, x12, x10, x11, 0xFFFFFFFF, 0x33333333, 0x0, x1, 1240, x3)

inst_325:
// rs1_val==858993459 and rs2_val==1717986917, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x66666665
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x33333333, 0x66666665, x1, 1244, x3)

inst_326:
// rs1_val==858993459 and rs2_val==858993458, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x33333332
TEST_RR_OP(div, x12, x10, x11, 0x1, 0x33333333, 0x33333332, x1, 1248, x3)

inst_327:
// rs1_val==858993459 and rs2_val==1431655764, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x55555554
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x33333333, 0x55555554, x1, 1252, x3)

inst_328:
// rs1_val==858993459 and rs2_val==2, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x2
TEST_RR_OP(div, x12, x10, x11, 0x19999999, 0x33333333, 0x2, x1, 1256, x3)

inst_329:
// rs1_val==858993459 and rs2_val==46340, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0xb504
TEST_RR_OP(div, x12, x10, x11, 0x4868, 0x33333333, 0xb504, x1, 1260, x3)

inst_330:
// rs1_val==858993459 and rs2_val==-46340, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:-0xb504
TEST_RR_OP(div, x12, x10, x11, -0x4868, 0x33333333, -0xb504, x1, 1264, x3)

inst_331:
// rs1_val==858993459 and rs2_val==1717986918, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x66666666
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x33333333, 0x66666666, x1, 1268, x3)

inst_332:
// rs1_val==858993459 and rs2_val==858993459, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x33333333
TEST_RR_OP(div, x12, x10, x11, 0x1, 0x33333333, 0x33333333, x1, 1272, x3)

inst_333:
// rs1_val==858993459 and rs2_val==5, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x5
TEST_RR_OP(div, x12, x10, x11, 0xa3d70a3, 0x33333333, 0x5, x1, 1276, x3)

inst_334:
// rs1_val==858993459 and rs2_val==-1431655766, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:-0x55555556
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x33333333, -0x55555556, x1, 1280, x3)

inst_335:
// rs1_val==858993459 and rs2_val==1431655765, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x55555555
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x33333333, 0x55555555, x1, 1284, x3)

inst_336:
// rs1_val==858993459 and rs2_val==3, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x3
TEST_RR_OP(div, x12, x10, x11, 0x11111111, 0x33333333, 0x3, x1, 1288, x3)

inst_337:
// rs1_val==5 and rs2_val==46341, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0xb505
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x5, 0xb505, x1, 1292, x3)

inst_338:
// rs1_val==5 and rs2_val==-46339, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:-0xb503
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x5, -0xb503, x1, 1296, x3)

inst_339:
// rs1_val==5 and rs2_val==1717986919, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x66666667
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x5, 0x66666667, x1, 1300, x3)

inst_340:
// rs1_val==5 and rs2_val==858993460, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x33333334
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x5, 0x33333334, x1, 1304, x3)

inst_341:
// rs1_val==5 and rs2_val==6, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x6
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x5, 0x6, x1, 1308, x3)

inst_342:
// rs1_val==5 and rs2_val==-1431655765, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:-0x55555555
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x5, -0x55555555, x1, 1312, x3)

inst_343:
// rs1_val==5 and rs2_val==1431655766, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x55555556
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x5, 0x55555556, x1, 1316, x3)

inst_344:
// rs1_val==5 and rs2_val==4, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x4
TEST_RR_OP(div, x12, x10, x11, 0x1, 0x5, 0x4, x1, 1320, x3)

inst_345:
// rs1_val==5 and rs2_val==46339, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0xb503
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x5, 0xb503, x1, 1324, x3)

inst_346:
// rs1_val==5 and rs2_val==0, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x0
TEST_RR_OP(div, x12, x10, x11, 0xFFFFFFFF, 0x5, 0x0, x1, 1328, x3)

inst_347:
// rs1_val==5 and rs2_val==1717986917, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x66666665
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x5, 0x66666665, x1, 1332, x3)

inst_348:
// rs1_val==5 and rs2_val==858993458, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x33333332
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x5, 0x33333332, x1, 1336, x3)

inst_349:
// rs1_val==5 and rs2_val==1431655764, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x55555554
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x5, 0x55555554, x1, 1340, x3)

inst_350:
// rs1_val==5 and rs2_val==46340, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0xb504
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x5, 0xb504, x1, 1344, x3)

inst_351:
// rs1_val==5 and rs2_val==-46340, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:-0xb504
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x5, -0xb504, x1, 1348, x3)

inst_352:
// rs1_val==5 and rs2_val==1717986918, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x66666666
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x5, 0x66666666, x1, 1352, x3)

inst_353:
// rs1_val==5 and rs2_val==858993459, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x33333333
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x5, 0x33333333, x1, 1356, x3)

inst_354:
// rs1_val==5 and rs2_val==5, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x5
TEST_RR_OP(div, x12, x10, x11, 0x1, 0x5, 0x5, x1, 1360, x3)

inst_355:
// rs1_val==5 and rs2_val==-1431655766, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:-0x55555556
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x5, -0x55555556, x1, 1364, x3)

inst_356:
// rs1_val==5 and rs2_val==1431655765, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x55555555
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x5, 0x55555555, x1, 1368, x3)

inst_357:
// rs1_val==5 and rs2_val==3, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x3
TEST_RR_OP(div, x12, x10, x11, 0x1, 0x5, 0x3, x1, 1372, x3)

inst_358:
// rs1_val==-1431655766 and rs2_val==46341, rs1_val == -1431655766
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0xb505
TEST_RR_OP(div, x12, x10, x11, -0x78ad, -0x55555556, 0xb505, x1, 1376, x3)

inst_359:
// rs1_val==-1431655766 and rs2_val==-46339, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:-0xb503
TEST_RR_OP(div, x12, x10, x11, 0x78af, -0x55555556, -0xb503, x1, 1380, x3)

inst_360:
// rs1_val==-1431655766 and rs2_val==1717986919, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x66666667
TEST_RR_OP(div, x12, x10, x11, 0x0, -0x55555556, 0x66666667, x1, 1384, x3)

inst_361:
// rs1_val==-1431655766 and rs2_val==858993460, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x33333334
TEST_RR_OP(div, x12, x10, x11, -0x1, -0x55555556, 0x33333334, x1, 1388, x3)

inst_362:
// rs1_val==-1431655766 and rs2_val==6, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x6
TEST_RR_OP(div, x12, x10, x11, -0xe38e38e, -0x55555556, 0x6, x1, 1392, x3)

inst_363:
// rs1_val==-1431655766 and rs2_val==-1431655765, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:-0x55555555
TEST_RR_OP(div, x12, x10, x11, 0x1, -0x55555556, -0x55555555, x1, 1396, x3)

inst_364:
// rs1_val==-1431655766 and rs2_val==1431655766, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x55555556
TEST_RR_OP(div, x12, x10, x11, -0x1, -0x55555556, 0x55555556, x1, 1400, x3)

inst_365:
// rs1_val==-1431655766 and rs2_val==4, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x4
TEST_RR_OP(div, x12, x10, x11, -0x15555555, -0x55555556, 0x4, x1, 1404, x3)

inst_366:
// rs1_val==-1431655766 and rs2_val==46339, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0xb503
TEST_RR_OP(div, x12, x10, x11, -0x78af, -0x55555556, 0xb503, x1, 1408, x3)

inst_367:
// rs1_val==-1431655766 and rs2_val==0, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x0
TEST_RR_OP(div, x12, x10, x11, 0xFFFFFFFF, -0x55555556, 0x0, x1, 1412, x3)

inst_368:
// rs1_val==-1431655766 and rs2_val==1717986917, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x66666665
TEST_RR_OP(div, x12, x10, x11, 0x0, -0x55555556, 0x66666665, x1, 1416, x3)

inst_369:
// rs1_val==-1431655766 and rs2_val==858993458, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x33333332
TEST_RR_OP(div, x12, x10, x11, -0x1, -0x55555556, 0x33333332, x1, 1420, x3)

inst_370:
// rs1_val==-1431655766 and rs2_val==1431655764, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x55555554
TEST_RR_OP(div, x12, x10, x11, -0x1, -0x55555556, 0x55555554, x1, 1424, x3)

inst_371:
// rs1_val==-1431655766 and rs2_val==2, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x2
TEST_RR_OP(div, x12, x10, x11, -0x2aaaaaab, -0x55555556, 0x2, x1, 1428, x3)

inst_372:
// rs1_val==-1431655766 and rs2_val==46340, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0xb504
TEST_RR_OP(div, x12, x10, x11, -0x78ae, -0x55555556, 0xb504, x1, 1432, x3)

inst_373:
// rs1_val==-1431655766 and rs2_val==-46340, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:-0xb504
TEST_RR_OP(div, x12, x10, x11, 0x78ae, -0x55555556, -0xb504, x1, 1436, x3)

inst_374:
// rs1_val==-1431655766 and rs2_val==1717986918, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x66666666
TEST_RR_OP(div, x12, x10, x11, 0x0, -0x55555556, 0x66666666, x1, 1440, x3)

inst_375:
// rs1_val==-1431655766 and rs2_val==858993459, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x33333333
TEST_RR_OP(div, x12, x10, x11, -0x1, -0x55555556, 0x33333333, x1, 1444, x3)

inst_376:
// rs1_val==-1431655766 and rs2_val==5, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x5
TEST_RR_OP(div, x12, x10, x11, -0x11111111, -0x55555556, 0x5, x1, 1448, x3)

inst_377:
// rs1_val==-1431655766 and rs2_val==-1431655766, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:-0x55555556
TEST_RR_OP(div, x12, x10, x11, 0x1, -0x55555556, -0x55555556, x1, 1452, x3)

inst_378:
// rs1_val==-1431655766 and rs2_val==1431655765, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x55555555
TEST_RR_OP(div, x12, x10, x11, -0x1, -0x55555556, 0x55555555, x1, 1456, x3)

inst_379:
// rs1_val==-1431655766 and rs2_val==3, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x3
TEST_RR_OP(div, x12, x10, x11, -0x1c71c71c, -0x55555556, 0x3, x1, 1460, x3)

inst_380:
// rs1_val==1431655765 and rs2_val==46341, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0xb505
TEST_RR_OP(div, x12, x10, x11, 0x78ad, 0x55555555, 0xb505, x1, 1464, x3)

inst_381:
// rs1_val==1431655765 and rs2_val==-46339, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:-0xb503
TEST_RR_OP(div, x12, x10, x11, -0x78af, 0x55555555, -0xb503, x1, 1468, x3)

inst_382:
// rs1_val==1431655765 and rs2_val==1717986919, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x66666667
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x55555555, 0x66666667, x1, 1472, x3)

inst_383:
// rs1_val==1431655765 and rs2_val==858993460, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x33333334
TEST_RR_OP(div, x12, x10, x11, 0x1, 0x55555555, 0x33333334, x1, 1476, x3)

inst_384:
// rs1_val==1431655765 and rs2_val==6, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x6
TEST_RR_OP(div, x12, x10, x11, 0xe38e38e, 0x55555555, 0x6, x1, 1480, x3)

inst_385:
// rs1_val==1431655765 and rs2_val==-1431655765, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:-0x55555555
TEST_RR_OP(div, x12, x10, x11, -0x1, 0x55555555, -0x55555555, x1, 1484, x3)

inst_386:
// rs1_val==1431655765 and rs2_val==1431655766, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x55555556
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x55555555, 0x55555556, x1, 1488, x3)

inst_387:
// rs1_val==1431655765 and rs2_val==4, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x4
TEST_RR_OP(div, x12, x10, x11, 0x15555555, 0x55555555, 0x4, x1, 1492, x3)

inst_388:
// rs1_val==1431655765 and rs2_val==46339, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0xb503
TEST_RR_OP(div, x12, x10, x11, 0x78af, 0x55555555, 0xb503, x1, 1496, x3)

inst_389:
// rs1_val==1431655765 and rs2_val==0, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x0
TEST_RR_OP(div, x12, x10, x11, 0xFFFFFFFF, 0x55555555, 0x0, x1, 1500, x3)

inst_390:
// rs1_val==1431655765 and rs2_val==1717986917, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x66666665
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x55555555, 0x66666665, x1, 1504, x3)

inst_391:
// rs1_val==1431655765 and rs2_val==858993458, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x33333332
TEST_RR_OP(div, x12, x10, x11, 0x1, 0x55555555, 0x33333332, x1, 1508, x3)

inst_392:
// rs1_val==1431655765 and rs2_val==1431655764, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x55555554
TEST_RR_OP(div, x12, x10, x11, 0x1, 0x55555555, 0x55555554, x1, 1512, x3)

inst_393:
// rs1_val==1431655765 and rs2_val==2, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x2
TEST_RR_OP(div, x12, x10, x11, 0x2aaaaaaa, 0x55555555, 0x2, x1, 1516, x3)

inst_394:
// rs1_val==1431655765 and rs2_val==46340, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0xb504
TEST_RR_OP(div, x12, x10, x11, 0x78ae, 0x55555555, 0xb504, x1, 1520, x3)

inst_395:
// rs1_val==1431655765 and rs2_val==-46340, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:-0xb504
TEST_RR_OP(div, x12, x10, x11, -0x78ae, 0x55555555, -0xb504, x1, 1524, x3)

inst_396:
// rs1_val==1431655765 and rs2_val==1717986918, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x66666666
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x55555555, 0x66666666, x1, 1528, x3)

inst_397:
// rs1_val==1431655765 and rs2_val==858993459, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x33333333
TEST_RR_OP(div, x12, x10, x11, 0x1, 0x55555555, 0x33333333, x1, 1532, x3)

inst_398:
// rs1_val==1431655765 and rs2_val==5, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x5
TEST_RR_OP(div, x12, x10, x11, 0x11111111, 0x55555555, 0x5, x1, 1536, x3)

inst_399:
// rs1_val==1431655765 and rs2_val==-1431655766, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:-0x55555556
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x55555555, -0x55555556, x1, 1540, x3)

inst_400:
// rs1_val==1431655765 and rs2_val==1431655765, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x55555555
TEST_RR_OP(div, x12, x10, x11, 0x1, 0x55555555, 0x55555555, x1, 1544, x3)

inst_401:
// rs1_val==1431655765 and rs2_val==3, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x3
TEST_RR_OP(div, x12, x10, x11, 0x1c71c71c, 0x55555555, 0x3, x1, 1548, x3)

inst_402:
// rs1_val==3 and rs2_val==46341, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0xb505
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x3, 0xb505, x1, 1552, x3)

inst_403:
// rs1_val==3 and rs2_val==-46339, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:-0xb503
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x3, -0xb503, x1, 1556, x3)

inst_404:
// rs1_val==3 and rs2_val==1717986919, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x66666667
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x3, 0x66666667, x1, 1560, x3)

inst_405:
// rs1_val==3 and rs2_val==858993460, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x33333334
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x3, 0x33333334, x1, 1564, x3)

inst_406:
// rs1_val==3 and rs2_val==6, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x6
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x3, 0x6, x1, 1568, x3)

inst_407:
// rs1_val==3 and rs2_val==-1431655765, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:-0x55555555
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x3, -0x55555555, x1, 1572, x3)

inst_408:
// rs1_val==3 and rs2_val==1431655766, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x55555556
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x3, 0x55555556, x1, 1576, x3)

inst_409:
// rs1_val==3 and rs2_val==4, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x4
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x3, 0x4, x1, 1580, x3)

inst_410:
// rs1_val==3 and rs2_val==46339, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0xb503
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x3, 0xb503, x1, 1584, x3)

inst_411:
// rs1_val==3 and rs2_val==0, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x0
TEST_RR_OP(div, x12, x10, x11, 0xFFFFFFFF, 0x3, 0x0, x1, 1588, x3)

inst_412:
// rs1_val==3 and rs2_val==1717986917, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x66666665
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x3, 0x66666665, x1, 1592, x3)

inst_413:
// rs1_val==3 and rs2_val==858993458, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x33333332
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x3, 0x33333332, x1, 1596, x3)

inst_414:
// rs1_val==3 and rs2_val==1431655764, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x55555554
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x3, 0x55555554, x1, 1600, x3)

inst_415:
// rs1_val==3 and rs2_val==2, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x2
TEST_RR_OP(div, x12, x10, x11, 0x1, 0x3, 0x2, x1, 1604, x3)

inst_416:
// rs1_val==3 and rs2_val==46340, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0xb504
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x3, 0xb504, x1, 1608, x3)

inst_417:
// rs1_val==3 and rs2_val==-46340, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:-0xb504
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x3, -0xb504, x1, 1612, x3)

inst_418:
// rs1_val==3 and rs2_val==1717986918, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x66666666
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x3, 0x66666666, x1, 1616, x3)

inst_419:
// rs1_val==3 and rs2_val==858993459, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x33333333
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x3, 0x33333333, x1, 1620, x3)

inst_420:
// rs1_val==3 and rs2_val==5, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x5
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x3, 0x5, x1, 1624, x3)

inst_421:
// rs1_val==3 and rs2_val==-1431655766, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:-0x55555556
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x3, -0x55555556, x1, 1628, x3)

inst_422:
// rs1_val==3 and rs2_val==1431655765, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x55555555
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x3, 0x55555555, x1, 1632, x3)

inst_423:
// rs1_val==3 and rs2_val==3, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x3
TEST_RR_OP(div, x12, x10, x11, 0x1, 0x3, 0x3, x1, 1636, x3)

inst_424:
// rs1_val==1717986917 and rs2_val==0, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x0
TEST_RR_OP(div, x12, x10, x11, 0xFFFFFFFF, 0x66666665, 0x0, x1, 1640, x3)

inst_425:
// rs1_val==1717986917 and rs2_val==1717986917, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x66666665
TEST_RR_OP(div, x12, x10, x11, 0x1, 0x66666665, 0x66666665, x1, 1644, x3)

inst_426:
// rs1_val==1717986917 and rs2_val==858993458, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x33333332
TEST_RR_OP(div, x12, x10, x11, 0x2, 0x66666665, 0x33333332, x1, 1648, x3)

inst_427:
// rs1_val==1717986917 and rs2_val==1431655764, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x55555554
TEST_RR_OP(div, x12, x10, x11, 0x1, 0x66666665, 0x55555554, x1, 1652, x3)

inst_428:
// rs1_val==1717986917 and rs2_val==2, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x2
TEST_RR_OP(div, x12, x10, x11, 0x33333332, 0x66666665, 0x2, x1, 1656, x3)

inst_429:
// rs1_val==1717986917 and rs2_val==46340, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0xb504
TEST_RR_OP(div, x12, x10, x11, 0x90d1, 0x66666665, 0xb504, x1, 1660, x3)

inst_430:
// rs1_val==1717986917 and rs2_val==-46340, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:-0xb504
TEST_RR_OP(div, x12, x10, x11, -0x90d1, 0x66666665, -0xb504, x1, 1664, x3)

inst_431:
// rs1_val==1717986917 and rs2_val==1717986918, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x66666666
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x66666665, 0x66666666, x1, 1668, x3)

inst_432:
// rs1_val==1717986917 and rs2_val==858993459, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x33333333
TEST_RR_OP(div, x12, x10, x11, 0x1, 0x66666665, 0x33333333, x1, 1672, x3)

inst_433:
// rs1_val==1717986917 and rs2_val==5, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x5
TEST_RR_OP(div, x12, x10, x11, 0x147ae147, 0x66666665, 0x5, x1, 1676, x3)

inst_434:
// rs1_val==1717986917 and rs2_val==-1431655766, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:-0x55555556
TEST_RR_OP(div, x12, x10, x11, -0x1, 0x66666665, -0x55555556, x1, 1680, x3)

inst_435:
// rs1_val==1717986917 and rs2_val==1431655765, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x55555555
TEST_RR_OP(div, x12, x10, x11, 0x1, 0x66666665, 0x55555555, x1, 1684, x3)

inst_436:
// rs1_val==1717986917 and rs2_val==3, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x3
TEST_RR_OP(div, x12, x10, x11, 0x22222221, 0x66666665, 0x3, x1, 1688, x3)

inst_437:
// rs1_val==858993458 and rs2_val==46341, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0xb505
TEST_RR_OP(div, x12, x10, x11, 0x4868, 0x33333332, 0xb505, x1, 1692, x3)

inst_438:
// rs1_val==858993458 and rs2_val==-46339, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:-0xb503
TEST_RR_OP(div, x12, x10, x11, -0x4869, 0x33333332, -0xb503, x1, 1696, x3)

inst_439:
// rs1_val==858993458 and rs2_val==1717986919, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x66666667
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x33333332, 0x66666667, x1, 1700, x3)

inst_440:
// rs1_val==858993458 and rs2_val==858993460, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x33333334
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x33333332, 0x33333334, x1, 1704, x3)

inst_441:
// rs1_val==858993458 and rs2_val==6, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x6
TEST_RR_OP(div, x12, x10, x11, 0x8888888, 0x33333332, 0x6, x1, 1708, x3)

inst_442:
// rs1_val==858993458 and rs2_val==-1431655765, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:-0x55555555
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x33333332, -0x55555555, x1, 1712, x3)

inst_443:
// rs1_val==858993458 and rs2_val==1431655766, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x55555556
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x33333332, 0x55555556, x1, 1716, x3)

inst_444:
// rs1_val==858993458 and rs2_val==4, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x4
TEST_RR_OP(div, x12, x10, x11, 0xccccccc, 0x33333332, 0x4, x1, 1720, x3)

inst_445:
// rs1_val==858993458 and rs2_val==46339, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0xb503
TEST_RR_OP(div, x12, x10, x11, 0x4869, 0x33333332, 0xb503, x1, 1724, x3)

inst_446:
// rs1_val==858993458 and rs2_val==0, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x0
TEST_RR_OP(div, x12, x10, x11, 0xFFFFFFFF, 0x33333332, 0x0, x1, 1728, x3)

inst_447:
// rs1_val==858993458 and rs2_val==1717986917, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x66666665
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x33333332, 0x66666665, x1, 1732, x3)

inst_448:
// rs1_val==858993458 and rs2_val==858993458, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x33333332
TEST_RR_OP(div, x12, x10, x11, 0x1, 0x33333332, 0x33333332, x1, 1736, x3)

inst_449:
// rs1_val==858993458 and rs2_val==1431655764, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x55555554
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x33333332, 0x55555554, x1, 1740, x3)

inst_450:
// rs1_val==858993458 and rs2_val==2, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x2
TEST_RR_OP(div, x12, x10, x11, 0x19999999, 0x33333332, 0x2, x1, 1744, x3)

inst_451:
// rs1_val==858993458 and rs2_val==46340, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0xb504
TEST_RR_OP(div, x12, x10, x11, 0x4868, 0x33333332, 0xb504, x1, 1748, x3)

inst_452:
// rs1_val==858993458 and rs2_val==-46340, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:-0xb504
TEST_RR_OP(div, x12, x10, x11, -0x4868, 0x33333332, -0xb504, x1, 1752, x3)

inst_453:
// rs1_val==858993458 and rs2_val==1717986918, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x66666666
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x33333332, 0x66666666, x1, 1756, x3)

inst_454:
// rs1_val==858993458 and rs2_val==858993459, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x33333333
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x33333332, 0x33333333, x1, 1760, x3)

inst_455:
// rs1_val==858993458 and rs2_val==5, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x5
TEST_RR_OP(div, x12, x10, x11, 0xa3d70a3, 0x33333332, 0x5, x1, 1764, x3)

inst_456:
// rs1_val==858993458 and rs2_val==-1431655766, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:-0x55555556
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x33333332, -0x55555556, x1, 1768, x3)

inst_457:
// rs1_val==858993458 and rs2_val==1431655765, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x55555555
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x33333332, 0x55555555, x1, 1772, x3)

inst_458:
// rs1_val==858993458 and rs2_val==3, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x3
TEST_RR_OP(div, x12, x10, x11, 0x11111110, 0x33333332, 0x3, x1, 1776, x3)

inst_459:
// rs1_val==1431655764 and rs2_val==46341, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0xb505
TEST_RR_OP(div, x12, x10, x11, 0x78ad, 0x55555554, 0xb505, x1, 1780, x3)

inst_460:
// rs1_val==1431655764 and rs2_val==-46339, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:-0xb503
TEST_RR_OP(div, x12, x10, x11, -0x78af, 0x55555554, -0xb503, x1, 1784, x3)

inst_461:
// rs1_val==1431655764 and rs2_val==1717986919, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x66666667
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x55555554, 0x66666667, x1, 1788, x3)

inst_462:
// rs1_val==1431655764 and rs2_val==858993460, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x33333334
TEST_RR_OP(div, x12, x10, x11, 0x1, 0x55555554, 0x33333334, x1, 1792, x3)

inst_463:
// rs1_val==1431655764 and rs2_val==6, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x6
TEST_RR_OP(div, x12, x10, x11, 0xe38e38e, 0x55555554, 0x6, x1, 1796, x3)

inst_464:
// rs1_val==1431655764 and rs2_val==-1431655765, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:-0x55555555
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x55555554, -0x55555555, x1, 1800, x3)

inst_465:
// rs1_val==1431655764 and rs2_val==1431655766, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x55555556
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x55555554, 0x55555556, x1, 1804, x3)

inst_466:
// rs1_val==1431655764 and rs2_val==4, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x4
TEST_RR_OP(div, x12, x10, x11, 0x15555555, 0x55555554, 0x4, x1, 1808, x3)

inst_467:
// rs1_val==1431655764 and rs2_val==46339, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0xb503
TEST_RR_OP(div, x12, x10, x11, 0x78af, 0x55555554, 0xb503, x1, 1812, x3)

inst_468:
// rs1_val==1431655764 and rs2_val==0, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x0
TEST_RR_OP(div, x12, x10, x11, 0xFFFFFFFF, 0x55555554, 0x0, x1, 1816, x3)

inst_469:
// rs1_val==1431655764 and rs2_val==1717986917, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x66666665
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x55555554, 0x66666665, x1, 1820, x3)

inst_470:
// rs1_val==1431655764 and rs2_val==858993458, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x33333332
TEST_RR_OP(div, x12, x10, x11, 0x1, 0x55555554, 0x33333332, x1, 1824, x3)

inst_471:
// rs1_val==1431655764 and rs2_val==1431655764, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x55555554
TEST_RR_OP(div, x12, x10, x11, 0x1, 0x55555554, 0x55555554, x1, 1828, x3)

inst_472:
// rs1_val==1431655764 and rs2_val==2, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x2
TEST_RR_OP(div, x12, x10, x11, 0x2aaaaaaa, 0x55555554, 0x2, x1, 1832, x3)

inst_473:
// rs1_val==1431655764 and rs2_val==46340, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0xb504
TEST_RR_OP(div, x12, x10, x11, 0x78ae, 0x55555554, 0xb504, x1, 1836, x3)

inst_474:
// rs1_val==1431655764 and rs2_val==-46340, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:-0xb504
TEST_RR_OP(div, x12, x10, x11, -0x78ae, 0x55555554, -0xb504, x1, 1840, x3)

inst_475:
// rs1_val==1431655764 and rs2_val==1717986918, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x66666666
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x55555554, 0x66666666, x1, 1844, x3)

inst_476:
// rs1_val==1431655764 and rs2_val==858993459, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x33333333
TEST_RR_OP(div, x12, x10, x11, 0x1, 0x55555554, 0x33333333, x1, 1848, x3)

inst_477:
// rs1_val==1431655764 and rs2_val==5, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x5
TEST_RR_OP(div, x12, x10, x11, 0x11111110, 0x55555554, 0x5, x1, 1852, x3)

inst_478:
// rs1_val==1431655764 and rs2_val==-1431655766, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:-0x55555556
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x55555554, -0x55555556, x1, 1856, x3)

inst_479:
// rs1_val==1431655764 and rs2_val==1431655765, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x55555555
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x55555554, 0x55555555, x1, 1860, x3)

inst_480:
// rs1_val==1431655764 and rs2_val==3, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x3
TEST_RR_OP(div, x12, x10, x11, 0x1c71c71c, 0x55555554, 0x3, x1, 1864, x3)

inst_481:
// rs1_val==2 and rs2_val==46341, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0xb505
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x2, 0xb505, x1, 1868, x3)

inst_482:
// rs1_val==2 and rs2_val==-46339, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:-0xb503
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x2, -0xb503, x1, 1872, x3)

inst_483:
// rs1_val==2 and rs2_val==1717986919, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x66666667
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x2, 0x66666667, x1, 1876, x3)

inst_484:
// rs1_val==2 and rs2_val==858993460, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x33333334
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x2, 0x33333334, x1, 1880, x3)

inst_485:
// rs1_val==2 and rs2_val==6, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x6
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x2, 0x6, x1, 1884, x3)

inst_486:
// rs1_val==2 and rs2_val==-1431655765, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:-0x55555555
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x2, -0x55555555, x1, 1888, x3)

inst_487:
// rs1_val==2 and rs2_val==1431655766, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x55555556
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x2, 0x55555556, x1, 1892, x3)

inst_488:
// rs1_val==2 and rs2_val==4, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x4
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x2, 0x4, x1, 1896, x3)

inst_489:
// rs1_val==2 and rs2_val==46339, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0xb503
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x2, 0xb503, x1, 1900, x3)

inst_490:
// rs1_val==2 and rs2_val==0, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x0
TEST_RR_OP(div, x12, x10, x11, 0xFFFFFFFF, 0x2, 0x0, x1, 1904, x3)

inst_491:
// rs1_val==2 and rs2_val==1717986917, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x66666665
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x2, 0x66666665, x1, 1908, x3)

inst_492:
// rs1_val==2 and rs2_val==858993458, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x33333332
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x2, 0x33333332, x1, 1912, x3)

inst_493:
// rs1_val==2 and rs2_val==1431655764, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x55555554
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x2, 0x55555554, x1, 1916, x3)

inst_494:
// rs1_val==2 and rs2_val==2, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x2
TEST_RR_OP(div, x12, x10, x11, 0x1, 0x2, 0x2, x1, 1920, x3)

inst_495:
// rs1_val==2 and rs2_val==46340, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0xb504
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x2, 0xb504, x1, 1924, x3)

inst_496:
// rs1_val==2 and rs2_val==-46340, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:-0xb504
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x2, -0xb504, x1, 1928, x3)

inst_497:
// rs1_val==2 and rs2_val==1717986918, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x66666666
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x2, 0x66666666, x1, 1932, x3)

inst_498:
// rs1_val==2 and rs2_val==858993459, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x33333333
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x2, 0x33333333, x1, 1936, x3)

inst_499:
// rs1_val==2 and rs2_val==5, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x5
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x2, 0x5, x1, 1940, x3)

inst_500:
// rs1_val==2 and rs2_val==-1431655766, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:-0x55555556
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x2, -0x55555556, x1, 1944, x3)

inst_501:
// rs1_val==2 and rs2_val==1431655765, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x55555555
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x2, 0x55555555, x1, 1948, x3)

inst_502:
// rs1_val==2 and rs2_val==3, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x3
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x2, 0x3, x1, 1952, x3)

inst_503:
// rs1_val==46340 and rs2_val==46341, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0xb505
TEST_RR_OP(div, x12, x10, x11, 0x0, 0xb504, 0xb505, x1, 1956, x3)

inst_504:
// rs1_val==46340 and rs2_val==-46339, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:-0xb503
TEST_RR_OP(div, x12, x10, x11, -0x1, 0xb504, -0xb503, x1, 1960, x3)

inst_505:
// rs1_val==46340 and rs2_val==1717986919, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x66666667
TEST_RR_OP(div, x12, x10, x11, 0x0, 0xb504, 0x66666667, x1, 1964, x3)

inst_506:
// rs1_val==46340 and rs2_val==858993460, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x33333334
TEST_RR_OP(div, x12, x10, x11, 0x0, 0xb504, 0x33333334, x1, 1968, x3)

inst_507:
// rs1_val==46340 and rs2_val==6, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x6
TEST_RR_OP(div, x12, x10, x11, 0x1e2b, 0xb504, 0x6, x1, 1972, x3)

inst_508:
// rs1_val==46340 and rs2_val==-1431655765, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:-0x55555555
TEST_RR_OP(div, x12, x10, x11, 0x0, 0xb504, -0x55555555, x1, 1976, x3)

inst_509:
// rs1_val==46340 and rs2_val==1431655766, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x55555556
TEST_RR_OP(div, x12, x10, x11, 0x0, 0xb504, 0x55555556, x1, 1980, x3)

inst_510:
// rs1_val==46340 and rs2_val==4, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x4
TEST_RR_OP(div, x12, x10, x11, 0x2d41, 0xb504, 0x4, x1, 1984, x3)

inst_511:
// rs1_val==46340 and rs2_val==46339, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0xb503
TEST_RR_OP(div, x12, x10, x11, 0x1, 0xb504, 0xb503, x1, 1988, x3)

inst_512:
// rs1_val==46340 and rs2_val==0, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x0
TEST_RR_OP(div, x12, x10, x11, 0xFFFFFFFF, 0xb504, 0x0, x1, 1992, x3)

inst_513:
// rs1_val==46340 and rs2_val==1717986917, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x66666665
TEST_RR_OP(div, x12, x10, x11, 0x0, 0xb504, 0x66666665, x1, 1996, x3)

inst_514:
// rs1_val==46340 and rs2_val==858993458, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x33333332
TEST_RR_OP(div, x12, x10, x11, 0x0, 0xb504, 0x33333332, x1, 2000, x3)

inst_515:
// rs1_val==46340 and rs2_val==1431655764, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x55555554
TEST_RR_OP(div, x12, x10, x11, 0x0, 0xb504, 0x55555554, x1, 2004, x3)

inst_516:
// rs1_val==46340 and rs2_val==2, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x2
TEST_RR_OP(div, x12, x10, x11, 0x5a82, 0xb504, 0x2, x1, 2008, x3)

inst_517:
// rs1_val==46340 and rs2_val==46340, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0xb504
TEST_RR_OP(div, x12, x10, x11, 0x1, 0xb504, 0xb504, x1, 2012, x3)

inst_518:
// rs1_val==46340 and rs2_val==-46340, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:-0xb504
TEST_RR_OP(div, x12, x10, x11, -0x1, 0xb504, -0xb504, x1, 2016, x3)

inst_519:
// rs1_val==46340 and rs2_val==1717986918, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x66666666
TEST_RR_OP(div, x12, x10, x11, 0x0, 0xb504, 0x66666666, x1, 2020, x3)

inst_520:
// rs1_val==46340 and rs2_val==858993459, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x33333333
TEST_RR_OP(div, x12, x10, x11, 0x0, 0xb504, 0x33333333, x1, 2024, x3)

inst_521:
// rs1_val==46340 and rs2_val==5, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x5
TEST_RR_OP(div, x12, x10, x11, 0x2434, 0xb504, 0x5, x1, 2028, x3)

inst_522:
// rs1_val==46340 and rs2_val==-1431655766, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:-0x55555556
TEST_RR_OP(div, x12, x10, x11, 0x0, 0xb504, -0x55555556, x1, 2032, x3)

inst_523:
// rs1_val==46340 and rs2_val==1431655765, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x55555555
TEST_RR_OP(div, x12, x10, x11, 0x0, 0xb504, 0x55555555, x1, 2036, x3)

inst_524:
// rs1_val==46340 and rs2_val==3, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x3
TEST_RR_OP(div, x12, x10, x11, 0x3c56, 0xb504, 0x3, x1, 2040, x3)

inst_525:
// rs1_val==-46340 and rs2_val==46341, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0xb505
TEST_RR_OP(div, x12, x10, x11, 0x0, -0xb504, 0xb505, x1, 2044, x3)
RVTEST_SIGBASE( x1,signature_x1_1)

inst_526:
// rs1_val==-46340 and rs2_val==-46339, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:-0xb503
TEST_RR_OP(div, x12, x10, x11, 0x1, -0xb504, -0xb503, x1, 0, x3)

inst_527:
// rs1_val==-46340 and rs2_val==1717986919, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x66666667
TEST_RR_OP(div, x12, x10, x11, 0x0, -0xb504, 0x66666667, x1, 4, x3)

inst_528:
// rs1_val==-46340 and rs2_val==858993460, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x33333334
TEST_RR_OP(div, x12, x10, x11, 0x0, -0xb504, 0x33333334, x1, 8, x3)

inst_529:
// rs1_val==-46340 and rs2_val==6, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x6
TEST_RR_OP(div, x12, x10, x11, -0x1e2b, -0xb504, 0x6, x1, 12, x3)

inst_530:
// rs1_val==-46340 and rs2_val==-1431655765, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:-0x55555555
TEST_RR_OP(div, x12, x10, x11, 0x0, -0xb504, -0x55555555, x1, 16, x3)

inst_531:
// rs1_val==-46340 and rs2_val==1431655766, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x55555556
TEST_RR_OP(div, x12, x10, x11, 0x0, -0xb504, 0x55555556, x1, 20, x3)

inst_532:
// rs1_val==-46340 and rs2_val==4, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x4
TEST_RR_OP(div, x12, x10, x11, -0x2d41, -0xb504, 0x4, x1, 24, x3)

inst_533:
// rs1_val==-46340 and rs2_val==46339, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0xb503
TEST_RR_OP(div, x12, x10, x11, -0x1, -0xb504, 0xb503, x1, 28, x3)

inst_534:
// rs1_val==-46340 and rs2_val==0, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x0
TEST_RR_OP(div, x12, x10, x11, 0xFFFFFFFF, -0xb504, 0x0, x1, 32, x3)

inst_535:
// rs1_val==-46340 and rs2_val==1717986917, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x66666665
TEST_RR_OP(div, x12, x10, x11, 0x0, -0xb504, 0x66666665, x1, 36, x3)

inst_536:
// rs1_val==-46340 and rs2_val==858993458, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x33333332
TEST_RR_OP(div, x12, x10, x11, 0x0, -0xb504, 0x33333332, x1, 40, x3)

inst_537:
// rs1_val==-46340 and rs2_val==1431655764, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x55555554
TEST_RR_OP(div, x12, x10, x11, 0x0, -0xb504, 0x55555554, x1, 44, x3)

inst_538:
// rs1_val==-46340 and rs2_val==2, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x2
TEST_RR_OP(div, x12, x10, x11, -0x5a82, -0xb504, 0x2, x1, 48, x3)

inst_539:
// rs1_val==-46340 and rs2_val==46340, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0xb504
TEST_RR_OP(div, x12, x10, x11, -0x1, -0xb504, 0xb504, x1, 52, x3)

inst_540:
// rs1_val==-46340 and rs2_val==-46340, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:-0xb504
TEST_RR_OP(div, x12, x10, x11, 0x1, -0xb504, -0xb504, x1, 56, x3)

inst_541:
// rs1_val==-46340 and rs2_val==1717986918, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x66666666
TEST_RR_OP(div, x12, x10, x11, 0x0, -0xb504, 0x66666666, x1, 60, x3)

inst_542:
// rs1_val==-46340 and rs2_val==858993459, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x33333333
TEST_RR_OP(div, x12, x10, x11, 0x0, -0xb504, 0x33333333, x1, 64, x3)

inst_543:
// rs1_val==-46340 and rs2_val==5, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x5
TEST_RR_OP(div, x12, x10, x11, -0x2434, -0xb504, 0x5, x1, 68, x3)

inst_544:
// rs1_val==-46340 and rs2_val==-1431655766, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:-0x55555556
TEST_RR_OP(div, x12, x10, x11, 0x0, -0xb504, -0x55555556, x1, 72, x3)

inst_545:
// rs1_val==-46340 and rs2_val==1431655765, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x55555555
TEST_RR_OP(div, x12, x10, x11, 0x0, -0xb504, 0x55555555, x1, 76, x3)

inst_546:
// rs1_val==-46340 and rs2_val==3, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x3
TEST_RR_OP(div, x12, x10, x11, -0x3c56, -0xb504, 0x3, x1, 80, x3)

inst_547:
// rs1_val==1717986918 and rs2_val==46341, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0xb505
TEST_RR_OP(div, x12, x10, x11, 0x90d0, 0x66666666, 0xb505, x1, 84, x3)

inst_548:
// rs1_val==1717986918 and rs2_val==-46339, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:-0xb503
TEST_RR_OP(div, x12, x10, x11, -0x90d2, 0x66666666, -0xb503, x1, 88, x3)

inst_549:
// rs1_val==1717986918 and rs2_val==1717986919, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x66666667
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x66666666, 0x66666667, x1, 92, x3)

inst_550:
// rs1_val==1717986918 and rs2_val==858993460, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x33333334
TEST_RR_OP(div, x12, x10, x11, 0x1, 0x66666666, 0x33333334, x1, 96, x3)

inst_551:
// rs1_val==1717986918 and rs2_val==6, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x6
TEST_RR_OP(div, x12, x10, x11, 0x11111111, 0x66666666, 0x6, x1, 100, x3)

inst_552:
// rs1_val==1717986918 and rs2_val==-1431655765, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:-0x55555555
TEST_RR_OP(div, x12, x10, x11, -0x1, 0x66666666, -0x55555555, x1, 104, x3)

inst_553:
// rs1_val==1717986918 and rs2_val==1431655766, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x55555556
TEST_RR_OP(div, x12, x10, x11, 0x1, 0x66666666, 0x55555556, x1, 108, x3)

inst_554:
// rs1_val==1717986918 and rs2_val==4, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x4
TEST_RR_OP(div, x12, x10, x11, 0x19999999, 0x66666666, 0x4, x1, 112, x3)

inst_555:
// rs1_val==1717986918 and rs2_val==46339, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0xb503
TEST_RR_OP(div, x12, x10, x11, 0x90d2, 0x66666666, 0xb503, x1, 116, x3)

inst_556:
// rs1_val==1717986918 and rs2_val==0, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x0
TEST_RR_OP(div, x12, x10, x11, 0xFFFFFFFF, 0x66666666, 0x0, x1, 120, x3)

inst_557:
// rs1_val==1717986918 and rs2_val==1717986917, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x66666665
TEST_RR_OP(div, x12, x10, x11, 0x1, 0x66666666, 0x66666665, x1, 124, x3)

inst_558:
// rs1_val==1717986918 and rs2_val==858993458, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x33333332
TEST_RR_OP(div, x12, x10, x11, 0x2, 0x66666666, 0x33333332, x1, 128, x3)

inst_559:
// rs1_val==1717986918 and rs2_val==1431655764, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x55555554
TEST_RR_OP(div, x12, x10, x11, 0x1, 0x66666666, 0x55555554, x1, 132, x3)

inst_560:
// rs1_val==1717986918 and rs2_val==2, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x2
TEST_RR_OP(div, x12, x10, x11, 0x33333333, 0x66666666, 0x2, x1, 136, x3)

inst_561:
// rs1_val==1717986918 and rs2_val==46340, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0xb504
TEST_RR_OP(div, x12, x10, x11, 0x90d1, 0x66666666, 0xb504, x1, 140, x3)

inst_562:
// rs1_val==1717986918 and rs2_val==-46340, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:-0xb504
TEST_RR_OP(div, x12, x10, x11, -0x90d1, 0x66666666, -0xb504, x1, 144, x3)

inst_563:
// rs1_val==1717986918 and rs2_val==1717986918, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x66666666
TEST_RR_OP(div, x12, x10, x11, 0x1, 0x66666666, 0x66666666, x1, 148, x3)

inst_564:
// rs1_val==1717986918 and rs2_val==858993459, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x33333333
TEST_RR_OP(div, x12, x10, x11, 0x2, 0x66666666, 0x33333333, x1, 152, x3)

inst_565:
// rs1_val==1717986918 and rs2_val==5, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x5
TEST_RR_OP(div, x12, x10, x11, 0x147ae147, 0x66666666, 0x5, x1, 156, x3)

inst_566:
// rs1_val==1717986918 and rs2_val==-1431655766, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:-0x55555556
TEST_RR_OP(div, x12, x10, x11, -0x1, 0x66666666, -0x55555556, x1, 160, x3)

inst_567:
// rs1_val==1717986918 and rs2_val==1431655765, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x55555555
TEST_RR_OP(div, x12, x10, x11, 0x1, 0x66666666, 0x55555555, x1, 164, x3)

inst_568:
// rs1_val==1717986918 and rs2_val==3, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x3
TEST_RR_OP(div, x12, x10, x11, 0x22222222, 0x66666666, 0x3, x1, 168, x3)

inst_569:
// rs1_val==858993459 and rs2_val==46341, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0xb505
TEST_RR_OP(div, x12, x10, x11, 0x4868, 0x33333333, 0xb505, x1, 172, x3)

inst_570:
// rs1_val==858993459 and rs2_val==-46339, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:-0xb503
TEST_RR_OP(div, x12, x10, x11, -0x4869, 0x33333333, -0xb503, x1, 176, x3)

inst_571:
// rs1_val==858993459 and rs2_val==1717986919, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x66666667
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x33333333, 0x66666667, x1, 180, x3)

inst_572:
// rs1_val==858993459 and rs2_val==858993460, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x33333334
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x33333333, 0x33333334, x1, 184, x3)

inst_573:
// rs1_val==858993459 and rs2_val==6, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x6
TEST_RR_OP(div, x12, x10, x11, 0x8888888, 0x33333333, 0x6, x1, 188, x3)

inst_574:
// rs1_val==858993459 and rs2_val==-1431655765, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:-0x55555555
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x33333333, -0x55555555, x1, 192, x3)

inst_575:
// rs1_val==858993459 and rs2_val==1431655766, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x55555556
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x33333333, 0x55555556, x1, 196, x3)

inst_576:
// rs1_val==858993459 and rs2_val==4, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x4
TEST_RR_OP(div, x12, x10, x11, 0xccccccc, 0x33333333, 0x4, x1, 200, x3)

inst_577:
// rs1_val==858993459 and rs2_val==46339, 
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0xb503
TEST_RR_OP(div, x12, x10, x11, 0x4869, 0x33333333, 0xb503, x1, 204, x3)

inst_578:
// rs2_val == -1073741825, rs1_val < 0 and rs2_val < 0
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x8;  op2val:-0x40000001
TEST_RR_OP(div, x12, x10, x11, 0x0, -0x8, -0x40000001, x1, 208, x3)

inst_579:
// rs2_val == -536870913, rs1_val == 16384, rs1_val > 0 and rs2_val < 0
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:0x4000;  op2val:-0x20000001
TEST_RR_OP(div, x12, x10, x11, 0x0, 0x4000, -0x20000001, x1, 212, x3)

inst_580:
// rs2_val == -268435457, rs1_val == -4194305
// opcode: div ; op1:x10; op2:x11; dest:x12; op1val:-0x400001;  op2val:-0x10000001
TEST_RR_OP(div, x12, x10, x11, 0x0, -0x400001, -0x10000001, x1, 216, x3)
#endif


RVTEST_CODE_END
RVMODEL_HALT

RVTEST_DATA_BEGIN
.align 4

rvtest_data:
.word 0xbabecafe
.word 0xbabecafe
.word 0xbabecafe
.word 0xbabecafe
RVTEST_DATA_END


RVMODEL_DATA_BEGIN
rvtest_sig_begin:
sig_begin_canary:
CANARY;


signature_x2_0:
    .fill 0*(XLEN/32),4,0xdeadbeef


signature_x2_1:
    .fill 8*(XLEN/32),4,0xdeadbeef


signature_x4_0:
    .fill 6*(XLEN/32),4,0xdeadbeef


signature_x1_0:
    .fill 512*(XLEN/32),4,0xdeadbeef


signature_x1_1:
    .fill 55*(XLEN/32),4,0xdeadbeef

#ifdef rvtest_mtrap_routine

tsig_begin_canary:
CANARY;
mtrap_sigptr:
    .fill 64*(XLEN/32),4,0xdeadbeef
tsig_end_canary:
CANARY;

#endif

#ifdef rvtest_gpr_save

gpr_save:
    .fill 32*(XLEN/32),4,0xdeadbeef

#endif

sig_end_canary:
CANARY;
rvtest_sig_end:
RVMODEL_DATA_END
