// -----------
// This file was generated by riscv_ctg (https://gitlab.com/incoresemi/riscv-compliance/riscv_ctg)
// version   : 0.5.1
// timestamp : Wed Aug  4 07:22:49 2021 GMT
// usage     : riscv_ctg \
//                  --cgf /home/bilalsakhawat/dev2/riscv-ctg/sample_cgfs/dataset.cgf \
//                  --cgf /home/bilalsakhawat/dev2/riscv-ctg/sample_cgfs/rv32em.cgf \
//                  --base-isa rv32e \
//                  --randomize
// -----------
//
// -----------
// Copyright (c) 2020. RISC-V International. All rights reserved.
// SPDX-License-Identifier: BSD-3-Clause
// -----------
//
// This assembly file tests the mul instruction of the RISC-V M extension for the mul covergroup.
// 
#include "model_test.h"
#include "arch_test.h"
RVTEST_ISA("RV32EM")

.section .text.init
.globl rvtest_entry_point
rvtest_entry_point:
RVMODEL_BOOT
RVTEST_CODE_BEGIN

#ifdef TEST_CASE_1

RVTEST_CASE(0,"//check ISA:=regex(.*32.*);check ISA:=regex(.*E.*M.*) ;def RVTEST_E = True;def TEST_CASE_1=True;",mul)

RVTEST_SIGBASE( x2,signature_x2_1)

inst_0:
// rs2 == rd != rs1, rs1==x6, rs2==x10, rd==x10, rs1_val != rs2_val, rs1_val==6 and rs2_val==-1431655765, rs1_val > 0 and rs2_val < 0
// opcode: mul ; op1:x6; op2:x10; dest:x10; op1val:0x6;  op2val:-0x55555555
TEST_RR_OP(mul, x10, x6, x10, 0x2, 0x6, -0x55555555, x2, 0, x11)

inst_1:
// rs1 == rd != rs2, rs1==x7, rs2==x1, rd==x7, rs2_val == 2147483647, rs1_val == 1431655765, rs2_val == (2**(xlen-1)-1), rs1_val > 0 and rs2_val > 0
// opcode: mul ; op1:x7; op2:x1; dest:x7; op1val:0x55555555;  op2val:0x7fffffff
TEST_RR_OP(mul, x7, x7, x1, 0x2aaaaaab, 0x55555555, 0x7fffffff, x2, 4, x11)

inst_2:
// rs1 == rs2 == rd, rs1==x14, rs2==x14, rd==x14, rs2_val == -1073741825, rs1_val == 134217728
// opcode: mul ; op1:x14; op2:x14; dest:x14; op1val:0x8000000;  op2val:0x8000000
TEST_RR_OP(mul, x14, x14, x14, 0x0, 0x8000000, 0x8000000, x2, 8, x11)

inst_3:
// rs1 == rs2 != rd, rs1==x15, rs2==x15, rd==x1, rs2_val == -536870913, rs1_val == 8
// opcode: mul ; op1:x15; op2:x15; dest:x1; op1val:0x8;  op2val:0x8
TEST_RR_OP(mul, x1, x15, x15, 0x40, 0x8, 0x8, x2, 12, x11)

inst_4:
// rs1 != rs2  and rs1 != rd and rs2 != rd, rs1==x3, rs2==x9, rd==x4, rs2_val == -268435457, rs1_val == -257, rs1_val < 0 and rs2_val < 0
// opcode: mul ; op1:x3; op2:x9; dest:x4; op1val:-0x101;  op2val:-0x10000001
TEST_RR_OP(mul, x4, x3, x9, 0x10000101, -0x101, -0x10000001, x2, 16, x11)

inst_5:
// rs1==x5, rs2==x0, rd==x8, rs2_val == -134217729, rs1_val == 4
// opcode: mul ; op1:x5; op2:x0; dest:x8; op1val:0x4;  op2val:0x0
TEST_RR_OP(mul, x8, x5, x0, 0x0, 0x4, 0x0, x2, 20, x11)

inst_6:
// rs1==x12, rs2==x13, rd==x15, rs2_val == -67108865, rs1_val == -524289
// opcode: mul ; op1:x12; op2:x13; dest:x15; op1val:-0x80001;  op2val:-0x4000001
TEST_RR_OP(mul, x15, x12, x13, 0x4080001, -0x80001, -0x4000001, x2, 24, x3)
RVTEST_SIGBASE( x1,signature_x1_0)

inst_7:
// rs1==x9, rs2==x4, rd==x11, rs2_val == -33554433, 
// opcode: mul ; op1:x9; op2:x4; dest:x11; op1val:0x9;  op2val:-0x2000001
TEST_RR_OP(mul, x11, x9, x4, 0xedfffff7, 0x9, -0x2000001, x1, 0, x3)

inst_8:
// rs1==x10, rs2==x5, rd==x6, rs2_val == -16777217, rs1_val == 0
// opcode: mul ; op1:x10; op2:x5; dest:x6; op1val:0x0;  op2val:-0x1000001
TEST_RR_OP(mul, x6, x10, x5, 0x0, 0x0, -0x1000001, x1, 4, x3)

inst_9:
// rs1==x13, rs2==x8, rd==x0, rs2_val == -8388609, 
// opcode: mul ; op1:x13; op2:x8; dest:x0; op1val:0x9;  op2val:-0x800001
TEST_RR_OP(mul, x0, x13, x8, 0, 0x9, -0x800001, x1, 8, x3)

inst_10:
// rs1==x0, rs2==x6, rd==x5, rs2_val == -4194305, rs1_val == 32
// opcode: mul ; op1:x0; op2:x6; dest:x5; op1val:0x0;  op2val:-0x400001
TEST_RR_OP(mul, x5, x0, x6, 0x0, 0x0, -0x400001, x1, 12, x10)

inst_11:
// rs1==x8, rs2==x2, rd==x13, rs2_val == -2097153, 
// opcode: mul ; op1:x8; op2:x2; dest:x13; op1val:0x33333333;  op2val:-0x200001
TEST_RR_OP(mul, x13, x8, x2, 0x666ccccd, 0x33333333, -0x200001, x1, 16, x10)

inst_12:
// rs1==x4, rs2==x11, rd==x3, rs2_val == -1048577, 
// opcode: mul ; op1:x4; op2:x11; dest:x3; op1val:0x0;  op2val:-0x100001
TEST_RR_OP(mul, x3, x4, x11, 0x0, 0x0, -0x100001, x1, 20, x10)

inst_13:
// rs1==x2, rs2==x3, rd==x9, rs2_val == -524289, rs1_val == -16777217
// opcode: mul ; op1:x2; op2:x3; dest:x9; op1val:-0x1000001;  op2val:-0x80001
TEST_RR_OP(mul, x9, x2, x3, 0x1080001, -0x1000001, -0x80001, x1, 24, x10)

inst_14:
// rs1==x11, rs2==x7, rd==x12, rs2_val == -262145, 
// opcode: mul ; op1:x11; op2:x7; dest:x12; op1val:0x66666666;  op2val:-0x40001
TEST_RR_OP(mul, x12, x11, x7, 0x1999a, 0x66666666, -0x40001, x1, 28, x10)
RVTEST_SIGBASE( x3,signature_x3_0)

inst_15:
// rs1==x1, rs2==x12, rd==x2, rs2_val == -131073, rs1_val == 128
// opcode: mul ; op1:x1; op2:x12; dest:x2; op1val:0x80;  op2val:-0x20001
TEST_RR_OP(mul, x2, x1, x12, 0xfeffff80, 0x80, -0x20001, x3, 0, x4)

inst_16:
// rs2_val == -65537, rs1_val == -1431655766
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:-0x10001
TEST_RR_OP(mul, x12, x10, x11, 0xaaab5556, -0x55555556, -0x10001, x3, 4, x4)

inst_17:
// rs2_val == -32769, rs1_val == -1048577
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x100001;  op2val:-0x8001
TEST_RR_OP(mul, x12, x10, x11, 0x108001, -0x100001, -0x8001, x3, 8, x4)

inst_18:
// rs2_val == -16385, rs1_val == 16
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x10;  op2val:-0x4001
TEST_RR_OP(mul, x12, x10, x11, 0xfffbfff0, 0x10, -0x4001, x3, 12, x4)

inst_19:
// rs2_val == -8193, rs1_val == -134217729
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x8000001;  op2val:-0x2001
TEST_RR_OP(mul, x12, x10, x11, 0x8002001, -0x8000001, -0x2001, x3, 16, x4)

inst_20:
// rs2_val == -4097, rs1_val == -33554433
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x2000001;  op2val:-0x1001
TEST_RR_OP(mul, x12, x10, x11, 0x2001001, -0x2000001, -0x1001, x3, 20, x4)

inst_21:
// rs2_val == -2049, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x7;  op2val:-0x801
TEST_RR_OP(mul, x12, x10, x11, 0xffffc7f9, 0x7, -0x801, x3, 24, x4)

inst_22:
// rs2_val == -1025, rs1_val == 268435456
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x10000000;  op2val:-0x401
TEST_RR_OP(mul, x12, x10, x11, 0xf0000000, 0x10000000, -0x401, x3, 28, x4)

inst_23:
// rs2_val == -513, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:-0x201
TEST_RR_OP(mul, x12, x10, x11, 0xcccccb99, 0x66666667, -0x201, x3, 32, x4)

inst_24:
// rs2_val == -257, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x4;  op2val:-0x101
TEST_RR_OP(mul, x12, x10, x11, 0x404, -0x4, -0x101, x3, 36, x4)

inst_25:
// rs2_val == -129, rs1_val == 32768
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x8000;  op2val:-0x81
TEST_RR_OP(mul, x12, x10, x11, 0xffbf8000, 0x8000, -0x81, x3, 40, x4)

inst_26:
// rs2_val == -65, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x100001;  op2val:-0x41
TEST_RR_OP(mul, x12, x10, x11, 0x4100041, -0x100001, -0x41, x3, 44, x4)

inst_27:
// rs2_val == -33, rs1_val == 536870912
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x20000000;  op2val:-0x21
TEST_RR_OP(mul, x12, x10, x11, 0xe0000000, 0x20000000, -0x21, x3, 48, x4)

inst_28:
// rs2_val == -17, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:-0x11
TEST_RR_OP(mul, x12, x10, x11, 0xaaaaaaa5, -0x55555555, -0x11, x3, 52, x4)

inst_29:
// rs2_val == -9, rs1_val == 2147483647, rs1_val == (2**(xlen-1)-1)
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x7fffffff;  op2val:-0x9
TEST_RR_OP(mul, x12, x10, x11, 0x80000009, 0x7fffffff, -0x9, x3, 56, x4)

inst_30:
// rs2_val == -5, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:-0x5
TEST_RR_OP(mul, x12, x10, x11, 0xffffffe2, 0x6, -0x5, x3, 60, x4)

inst_31:
// rs2_val == -3, rs1_val == -17
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x11;  op2val:-0x3
TEST_RR_OP(mul, x12, x10, x11, 0x33, -0x11, -0x3, x3, 64, x4)

inst_32:
// rs2_val == -2, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:-0x2
TEST_RR_OP(mul, x12, x10, x11, 0x0, 0x0, -0x2, x3, 68, x4)

inst_33:
// rs1_val == -1073741825, rs1_val < 0 and rs2_val > 0, rs2_val == 262144
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x40000001;  op2val:0x40000
TEST_RR_OP(mul, x12, x10, x11, 0xfffc0000, -0x40000001, 0x40000, x3, 72, x4)

inst_34:
// rs1_val == -536870913, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x20000001;  op2val:0x5
TEST_RR_OP(mul, x12, x10, x11, 0x5ffffffb, -0x20000001, 0x5, x3, 76, x4)

inst_35:
// rs1_val == -268435457, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x10000001;  op2val:0x55555556
TEST_RR_OP(mul, x12, x10, x11, 0x4aaaaaaa, -0x10000001, 0x55555556, x3, 80, x4)

inst_36:
// rs1_val == -67108865, rs2_val == 65536
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x4000001;  op2val:0x10000
TEST_RR_OP(mul, x12, x10, x11, 0xffff0000, -0x4000001, 0x10000, x3, 84, x4)

inst_37:
// rs1_val == -8388609, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x800001;  op2val:0x3fffffff
TEST_RR_OP(mul, x12, x10, x11, 0xc0800001, -0x800001, 0x3fffffff, x3, 88, x4)

inst_38:
// rs1_val == -4194305, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x400001;  op2val:0x33333334
TEST_RR_OP(mul, x12, x10, x11, 0xffcccccc, -0x400001, 0x33333334, x3, 92, x4)

inst_39:
// rs1_val == -2097153, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x200001;  op2val:-0x20001
TEST_RR_OP(mul, x12, x10, x11, 0x220001, -0x200001, -0x20001, x3, 96, x4)

inst_40:
// rs1_val == -262145, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x40001;  op2val:-0x4001
TEST_RR_OP(mul, x12, x10, x11, 0x44001, -0x40001, -0x4001, x3, 100, x4)

inst_41:
// rs1_val == -131073, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x20001;  op2val:-0x80001
TEST_RR_OP(mul, x12, x10, x11, 0xa0001, -0x20001, -0x80001, x3, 104, x4)

inst_42:
// rs1_val == -65537, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x10001;  op2val:-0x1001
TEST_RR_OP(mul, x12, x10, x11, 0x10011001, -0x10001, -0x1001, x3, 108, x4)

inst_43:
// rs1_val == -32769, rs2_val == 131072
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x8001;  op2val:0x20000
TEST_RR_OP(mul, x12, x10, x11, 0xfffe0000, -0x8001, 0x20000, x3, 112, x4)

inst_44:
// rs1_val == -16385, rs2_val == -2147483648, rs2_val == (-2**(xlen-1))
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x4001;  op2val:-0x80000000
TEST_RR_OP(mul, x12, x10, x11, 0x80000000, -0x4001, -0x80000000, x3, 116, x4)

inst_45:
// rs1_val == -8193, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x2001;  op2val:-0x200001
TEST_RR_OP(mul, x12, x10, x11, 0x202001, -0x2001, -0x200001, x3, 120, x4)

inst_46:
// rs1_val == -4097, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x1001;  op2val:-0x1
TEST_RR_OP(mul, x12, x10, x11, 0x1001, -0x1001, -0x1, x3, 124, x4)

inst_47:
// rs1_val == -2049, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x801;  op2val:0x55555554
TEST_RR_OP(mul, x12, x10, x11, 0xaac, -0x801, 0x55555554, x3, 128, x4)

inst_48:
// rs1_val == -1025, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x401;  op2val:0x33333334
TEST_RR_OP(mul, x12, x10, x11, 0xfffffccc, -0x401, 0x33333334, x3, 132, x4)

inst_49:
// rs1_val == -513, rs2_val == 2
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x201;  op2val:0x2
TEST_RR_OP(mul, x12, x10, x11, 0xfffffbfe, -0x201, 0x2, x3, 136, x4)

inst_50:
// rs1_val == -129, rs2_val == 1024
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x81;  op2val:0x400
TEST_RR_OP(mul, x12, x10, x11, 0xfffdfc00, -0x81, 0x400, x3, 140, x4)

inst_51:
// rs1_val == -65, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x41;  op2val:0xb504
TEST_RR_OP(mul, x12, x10, x11, 0xffd209fc, -0x41, 0xb504, x3, 144, x4)

inst_52:
// rs1_val == -33, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x21;  op2val:-0x5
TEST_RR_OP(mul, x12, x10, x11, 0xa5, -0x21, -0x5, x3, 148, x4)

inst_53:
// rs1_val == -9, rs2_val == 8
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x9;  op2val:0x8
TEST_RR_OP(mul, x12, x10, x11, 0xffffffb8, -0x9, 0x8, x3, 152, x4)

inst_54:
// rs1_val == -5, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x5;  op2val:0x3
TEST_RR_OP(mul, x12, x10, x11, 0xfffffff1, -0x5, 0x3, x3, 156, x4)

inst_55:
// rs1_val == -3, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x3;  op2val:-0x8
TEST_RR_OP(mul, x12, x10, x11, 0x18, -0x3, -0x8, x3, 160, x4)

inst_56:
// rs1_val == -2, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x2;  op2val:0x8
TEST_RR_OP(mul, x12, x10, x11, 0xfffffff0, -0x2, 0x8, x3, 164, x4)

inst_57:
// rs2_val == 1073741824, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x40000000
TEST_RR_OP(mul, x12, x10, x11, 0x0, 0x33333334, 0x40000000, x3, 168, x4)

inst_58:
// rs2_val == 536870912, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x10;  op2val:0x20000000
TEST_RR_OP(mul, x12, x10, x11, 0x0, 0x10, 0x20000000, x3, 172, x4)

inst_59:
// rs2_val == 268435456, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x4001;  op2val:0x10000000
TEST_RR_OP(mul, x12, x10, x11, 0xf0000000, -0x4001, 0x10000000, x3, 176, x4)

inst_60:
// rs2_val == 134217728, rs1_val == 1048576
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x100000;  op2val:0x8000000
TEST_RR_OP(mul, x12, x10, x11, 0x0, 0x100000, 0x8000000, x3, 180, x4)

inst_61:
// rs2_val == 67108864, rs1_val == 256
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x100;  op2val:0x4000000
TEST_RR_OP(mul, x12, x10, x11, 0x0, 0x100, 0x4000000, x3, 184, x4)

inst_62:
// rs2_val == 33554432, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0xa;  op2val:0x2000000
TEST_RR_OP(mul, x12, x10, x11, 0xec000000, -0xa, 0x2000000, x3, 188, x4)

inst_63:
// rs2_val == 16777216, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x40001;  op2val:0x1000000
TEST_RR_OP(mul, x12, x10, x11, 0xff000000, -0x40001, 0x1000000, x3, 192, x4)

inst_64:
// rs2_val == 8388608, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x800000
TEST_RR_OP(mul, x12, x10, x11, 0x99800000, 0x33333333, 0x800000, x3, 196, x4)

inst_65:
// rs2_val == 4194304, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x400000
TEST_RR_OP(mul, x12, x10, x11, 0x1800000, 0x6, 0x400000, x3, 200, x4)

inst_66:
// rs2_val == 2097152, rs1_val == 4096
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x1000;  op2val:0x200000
TEST_RR_OP(mul, x12, x10, x11, 0x0, 0x1000, 0x200000, x3, 204, x4)

inst_67:
// rs2_val == 1048576, rs1_val == 16777216
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x1000000;  op2val:0x100000
TEST_RR_OP(mul, x12, x10, x11, 0x0, 0x1000000, 0x100000, x3, 208, x4)

inst_68:
// rs2_val == 524288, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x40000001;  op2val:0x80000
TEST_RR_OP(mul, x12, x10, x11, 0xfff80000, -0x40000001, 0x80000, x3, 212, x4)

inst_69:
// rs2_val == 32768, rs1_val == 1024
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x400;  op2val:0x8000
TEST_RR_OP(mul, x12, x10, x11, 0x2000000, 0x400, 0x8000, x3, 216, x4)

inst_70:
// rs2_val == 16384, rs1_val == 524288
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x80000;  op2val:0x4000
TEST_RR_OP(mul, x12, x10, x11, 0x0, 0x80000, 0x4000, x3, 220, x4)

inst_71:
// rs2_val == 8192, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x10;  op2val:0x2000
TEST_RR_OP(mul, x12, x10, x11, 0x20000, 0x10, 0x2000, x3, 224, x4)

inst_72:
// rs2_val == 4096, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x7fffffff;  op2val:0x1000
TEST_RR_OP(mul, x12, x10, x11, 0xfffff000, 0x7fffffff, 0x1000, x3, 228, x4)

inst_73:
// rs2_val == 2048, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x800
TEST_RR_OP(mul, x12, x10, x11, 0xfa57e000, -0xb504, 0x800, x3, 232, x4)

inst_74:
// rs2_val == 512, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x200
TEST_RR_OP(mul, x12, x10, x11, 0xa00, 0x5, 0x200, x3, 236, x4)

inst_75:
// rs2_val == 256, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0xa;  op2val:0x100
TEST_RR_OP(mul, x12, x10, x11, 0xfffff600, -0xa, 0x100, x3, 240, x4)

inst_76:
// rs2_val == 128, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x400;  op2val:0x80
TEST_RR_OP(mul, x12, x10, x11, 0x20000, 0x400, 0x80, x3, 244, x4)

inst_77:
// rs2_val == 64, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x40
TEST_RR_OP(mul, x12, x10, x11, 0x0, 0x0, 0x40, x3, 248, x4)

inst_78:
// rs2_val == 32, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x20
TEST_RR_OP(mul, x12, x10, x11, 0xc0, 0x6, 0x20, x3, 252, x4)

inst_79:
// rs2_val == 16, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x10
TEST_RR_OP(mul, x12, x10, x11, 0x40, 0x4, 0x10, x3, 256, x4)

inst_80:
// rs2_val == 4, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x1000000;  op2val:0x4
TEST_RR_OP(mul, x12, x10, x11, 0x4000000, 0x1000000, 0x4, x3, 260, x4)

inst_81:
// rs2_val == 1, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x5;  op2val:0x1
TEST_RR_OP(mul, x12, x10, x11, 0xfffffffb, -0x5, 0x1, x3, 264, x4)

inst_82:
// rs1_val == -2147483648, rs1_val == (-2**(xlen-1))
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x80000000;  op2val:0x9
TEST_RR_OP(mul, x12, x10, x11, 0x80000000, -0x80000000, 0x9, x3, 268, x4)

inst_83:
// rs1_val == 1073741824, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x40000000;  op2val:0x100000
TEST_RR_OP(mul, x12, x10, x11, 0x0, 0x40000000, 0x100000, x3, 272, x4)

inst_84:
// rs1_val == 67108864, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x4000000;  op2val:-0x101
TEST_RR_OP(mul, x12, x10, x11, 0xfc000000, 0x4000000, -0x101, x3, 276, x4)

inst_85:
// rs1_val == 33554432, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x2000000;  op2val:0x3
TEST_RR_OP(mul, x12, x10, x11, 0x6000000, 0x2000000, 0x3, x3, 280, x4)

inst_86:
// rs1_val == 8388608, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x800000;  op2val:-0x20001
TEST_RR_OP(mul, x12, x10, x11, 0xff800000, 0x800000, -0x20001, x3, 284, x4)

inst_87:
// rs1_val == 4194304, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x400000;  op2val:-0x8000001
TEST_RR_OP(mul, x12, x10, x11, 0xffc00000, 0x400000, -0x8000001, x3, 288, x4)

inst_88:
// rs1_val == 2097152, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x200000;  op2val:0x2000
TEST_RR_OP(mul, x12, x10, x11, 0x0, 0x200000, 0x2000, x3, 292, x4)

inst_89:
// rs1_val == 262144, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x40000;  op2val:0x5
TEST_RR_OP(mul, x12, x10, x11, 0x140000, 0x40000, 0x5, x3, 296, x4)

inst_90:
// rs1_val == 131072, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x20000;  op2val:0xb504
TEST_RR_OP(mul, x12, x10, x11, 0x6a080000, 0x20000, 0xb504, x3, 300, x4)

inst_91:
// rs1_val == 65536, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x10000;  op2val:0x10
TEST_RR_OP(mul, x12, x10, x11, 0x100000, 0x10000, 0x10, x3, 304, x4)

inst_92:
// rs1_val == 16384, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x4000;  op2val:0x2000
TEST_RR_OP(mul, x12, x10, x11, 0x8000000, 0x4000, 0x2000, x3, 308, x4)

inst_93:
// rs1_val == 8192, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x2000;  op2val:0x80
TEST_RR_OP(mul, x12, x10, x11, 0x100000, 0x2000, 0x80, x3, 312, x4)

inst_94:
// rs1_val == 2048, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x800;  op2val:0x2000000
TEST_RR_OP(mul, x12, x10, x11, 0x0, 0x800, 0x2000000, x3, 316, x4)

inst_95:
// rs1_val == 512, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x200;  op2val:-0x7
TEST_RR_OP(mul, x12, x10, x11, 0xfffff200, 0x200, -0x7, x3, 320, x4)

inst_96:
// rs1_val == 64, rs2_val == 1431655765
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x40;  op2val:0x55555555
TEST_RR_OP(mul, x12, x10, x11, 0x55555540, 0x40, 0x55555555, x3, 324, x4)

inst_97:
// rs1_val == 2, rs1_val==2 and rs2_val==6
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x6
TEST_RR_OP(mul, x12, x10, x11, 0xc, 0x2, 0x6, x3, 328, x4)

inst_98:
// rs1_val == 1, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x1;  op2val:-0x21
TEST_RR_OP(mul, x12, x10, x11, 0xffffffdf, 0x1, -0x21, x3, 332, x4)

inst_99:
// rs1_val==46341 and rs2_val==46341, rs1_val == rs2_val
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0xb505
TEST_RR_OP(mul, x12, x10, x11, 0x80001219, 0xb505, 0xb505, x3, 336, x4)

inst_100:
// rs1_val==46341 and rs2_val==-46339, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:-0xb503
TEST_RR_OP(mul, x12, x10, x11, 0x800157f1, 0xb505, -0xb503, x3, 340, x4)

inst_101:
// rs1_val==46341 and rs2_val==1717986919, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x66666667
TEST_RR_OP(mul, x12, x10, x11, 0x6666d303, 0xb505, 0x66666667, x3, 344, x4)

inst_102:
// rs1_val==46341 and rs2_val==858993460, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x33333334
TEST_RR_OP(mul, x12, x10, x11, 0x3333c404, 0xb505, 0x33333334, x3, 348, x4)

inst_103:
// rs1_val==46341 and rs2_val==6, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x6
TEST_RR_OP(mul, x12, x10, x11, 0x43e1e, 0xb505, 0x6, x3, 352, x4)

inst_104:
// rs1_val==46341 and rs2_val==-1431655765, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:-0x55555555
TEST_RR_OP(mul, x12, x10, x11, 0x3c57, 0xb505, -0x55555555, x3, 356, x4)

inst_105:
// rs1_val==46341 and rs2_val==1431655766, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x55555556
TEST_RR_OP(mul, x12, x10, x11, 0x78ae, 0xb505, 0x55555556, x3, 360, x4)

inst_106:
// rs1_val==46341 and rs2_val==4, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x4
TEST_RR_OP(mul, x12, x10, x11, 0x2d414, 0xb505, 0x4, x3, 364, x4)

inst_107:
// rs1_val==46341 and rs2_val==46339, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0xb503
TEST_RR_OP(mul, x12, x10, x11, 0x7ffea80f, 0xb505, 0xb503, x3, 368, x4)

inst_108:
// rs1_val==46341 and rs2_val==0, rs2_val == 0
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x0
TEST_RR_OP(mul, x12, x10, x11, 0x0, 0xb505, 0x0, x3, 372, x4)

inst_109:
// rs1_val==46341 and rs2_val==1717986917, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x66666665
TEST_RR_OP(mul, x12, x10, x11, 0x666568f9, 0xb505, 0x66666665, x3, 376, x4)

inst_110:
// rs1_val==46341 and rs2_val==858993458, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x33333332
TEST_RR_OP(mul, x12, x10, x11, 0x333259fa, 0xb505, 0x33333332, x3, 380, x4)

inst_111:
// rs1_val==46341 and rs2_val==1431655764, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x55555554
TEST_RR_OP(mul, x12, x10, x11, 0xffff0ea4, 0xb505, 0x55555554, x3, 384, x4)

inst_112:
// rs1_val==46341 and rs2_val==2, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x2
TEST_RR_OP(mul, x12, x10, x11, 0x16a0a, 0xb505, 0x2, x3, 388, x4)

inst_113:
// rs1_val==46341 and rs2_val==46340, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0xb504
TEST_RR_OP(mul, x12, x10, x11, 0x7fff5d14, 0xb505, 0xb504, x3, 392, x4)

inst_114:
// rs1_val==46341 and rs2_val==-46340, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:-0xb504
TEST_RR_OP(mul, x12, x10, x11, 0x8000a2ec, 0xb505, -0xb504, x3, 396, x4)

inst_115:
// rs1_val==46341 and rs2_val==1717986918, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x66666666
TEST_RR_OP(mul, x12, x10, x11, 0x66661dfe, 0xb505, 0x66666666, x3, 400, x4)

inst_116:
// rs1_val==46341 and rs2_val==858993459, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x33333333
TEST_RR_OP(mul, x12, x10, x11, 0x33330eff, 0xb505, 0x33333333, x3, 404, x4)

inst_117:
// rs1_val==46341 and rs2_val==5, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x5
TEST_RR_OP(mul, x12, x10, x11, 0x38919, 0xb505, 0x5, x3, 408, x4)

inst_118:
// rs1_val==46341 and rs2_val==-1431655766, rs2_val == -1431655766
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:-0x55555556
TEST_RR_OP(mul, x12, x10, x11, 0xffff8752, 0xb505, -0x55555556, x3, 412, x4)

inst_119:
// rs1_val==46341 and rs2_val==1431655765, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x55555555
TEST_RR_OP(mul, x12, x10, x11, 0xffffc3a9, 0xb505, 0x55555555, x3, 416, x4)

inst_120:
// rs1_val==46341 and rs2_val==3, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x3
TEST_RR_OP(mul, x12, x10, x11, 0x21f0f, 0xb505, 0x3, x3, 420, x4)

inst_121:
// rs1_val==-46339 and rs2_val==46341, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0xb505
TEST_RR_OP(mul, x12, x10, x11, 0x800157f1, -0xb503, 0xb505, x3, 424, x4)

inst_122:
// rs1_val==-46339 and rs2_val==-46339, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:-0xb503
TEST_RR_OP(mul, x12, x10, x11, 0x7ffd3e09, -0xb503, -0xb503, x3, 428, x4)

inst_123:
// rs1_val==-46339 and rs2_val==1717986919, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x66666667
TEST_RR_OP(mul, x12, x10, x11, 0x6665f9cb, -0xb503, 0x66666667, x3, 432, x4)

inst_124:
// rs1_val==-46339 and rs2_val==858993460, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x33333334
TEST_RR_OP(mul, x12, x10, x11, 0x3332a264, -0xb503, 0x33333334, x3, 436, x4)

inst_125:
// rs1_val==-46339 and rs2_val==6, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x6
TEST_RR_OP(mul, x12, x10, x11, 0xfffbc1ee, -0xb503, 0x6, x3, 440, x4)

inst_126:
// rs1_val==-46339 and rs2_val==-1431655765, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:-0x55555555
TEST_RR_OP(mul, x12, x10, x11, 0x555518ff, -0xb503, -0x55555555, x3, 444, x4)

inst_127:
// rs1_val==-46339 and rs2_val==1431655766, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x55555556
TEST_RR_OP(mul, x12, x10, x11, 0xaaaa31fe, -0xb503, 0x55555556, x3, 448, x4)

inst_128:
// rs1_val==-46339 and rs2_val==4, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x4
TEST_RR_OP(mul, x12, x10, x11, 0xfffd2bf4, -0xb503, 0x4, x3, 452, x4)

inst_129:
// rs1_val==-46339 and rs2_val==46339, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0xb503
TEST_RR_OP(mul, x12, x10, x11, 0x8002c1f7, -0xb503, 0xb503, x3, 456, x4)

inst_130:
// rs1_val==-46339 and rs2_val==0, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x0
TEST_RR_OP(mul, x12, x10, x11, 0x0, -0xb503, 0x0, x3, 460, x4)

inst_131:
// rs1_val==-46339 and rs2_val==1717986917, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x66666665
TEST_RR_OP(mul, x12, x10, x11, 0x666763d1, -0xb503, 0x66666665, x3, 464, x4)

inst_132:
// rs1_val==-46339 and rs2_val==858993458, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x33333332
TEST_RR_OP(mul, x12, x10, x11, 0x33340c6a, -0xb503, 0x33333332, x3, 468, x4)

inst_133:
// rs1_val==-46339 and rs2_val==1431655764, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x55555554
TEST_RR_OP(mul, x12, x10, x11, 0xaaab9c04, -0xb503, 0x55555554, x3, 472, x4)

inst_134:
// rs1_val==-46339 and rs2_val==2, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x2
TEST_RR_OP(mul, x12, x10, x11, 0xfffe95fa, -0xb503, 0x2, x3, 476, x4)

inst_135:
// rs1_val==-46339 and rs2_val==46340, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0xb504
TEST_RR_OP(mul, x12, x10, x11, 0x80020cf4, -0xb503, 0xb504, x3, 480, x4)

inst_136:
// rs1_val==-46339 and rs2_val==-46340, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:-0xb504
TEST_RR_OP(mul, x12, x10, x11, 0x7ffdf30c, -0xb503, -0xb504, x3, 484, x4)

inst_137:
// rs1_val==-46339 and rs2_val==1717986918, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x66666666
TEST_RR_OP(mul, x12, x10, x11, 0x6666aece, -0xb503, 0x66666666, x3, 488, x4)

inst_138:
// rs1_val==-46339 and rs2_val==858993459, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x33333333
TEST_RR_OP(mul, x12, x10, x11, 0x33335767, -0xb503, 0x33333333, x3, 492, x4)

inst_139:
// rs1_val==-46339 and rs2_val==5, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x5
TEST_RR_OP(mul, x12, x10, x11, 0xfffc76f1, -0xb503, 0x5, x3, 496, x4)

inst_140:
// rs1_val==-46339 and rs2_val==-1431655766, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:-0x55555556
TEST_RR_OP(mul, x12, x10, x11, 0x5555ce02, -0xb503, -0x55555556, x3, 500, x4)

inst_141:
// rs1_val==-46339 and rs2_val==1431655765, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x55555555
TEST_RR_OP(mul, x12, x10, x11, 0xaaaae701, -0xb503, 0x55555555, x3, 504, x4)

inst_142:
// rs1_val==-46339 and rs2_val==3, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x3
TEST_RR_OP(mul, x12, x10, x11, 0xfffde0f7, -0xb503, 0x3, x3, 508, x4)

inst_143:
// rs1_val==1717986919 and rs2_val==46341, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0xb505
TEST_RR_OP(mul, x12, x10, x11, 0x6666d303, 0x66666667, 0xb505, x3, 512, x4)

inst_144:
// rs1_val==1717986919 and rs2_val==-46339, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:-0xb503
TEST_RR_OP(mul, x12, x10, x11, 0x6665f9cb, 0x66666667, -0xb503, x3, 516, x4)

inst_145:
// rs1_val==1717986919 and rs2_val==1717986919, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x66666667
TEST_RR_OP(mul, x12, x10, x11, 0xd70a3d71, 0x66666667, 0x66666667, x3, 520, x4)

inst_146:
// rs1_val==1717986919 and rs2_val==858993460, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x33333334
TEST_RR_OP(mul, x12, x10, x11, 0x1eb851ec, 0x66666667, 0x33333334, x3, 524, x4)

inst_147:
// rs1_val==1717986919 and rs2_val==6, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x6
TEST_RR_OP(mul, x12, x10, x11, 0x6666666a, 0x66666667, 0x6, x3, 528, x4)

inst_148:
// rs1_val==1717986919 and rs2_val==-1431655765, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:-0x55555555
TEST_RR_OP(mul, x12, x10, x11, 0xcccccccd, 0x66666667, -0x55555555, x3, 532, x4)

inst_149:
// rs1_val==1717986919 and rs2_val==1431655766, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x55555556
TEST_RR_OP(mul, x12, x10, x11, 0x9999999a, 0x66666667, 0x55555556, x3, 536, x4)

inst_150:
// rs1_val==1717986919 and rs2_val==4, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x4
TEST_RR_OP(mul, x12, x10, x11, 0x9999999c, 0x66666667, 0x4, x3, 540, x4)

inst_151:
// rs1_val==1717986919 and rs2_val==46339, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0xb503
TEST_RR_OP(mul, x12, x10, x11, 0x999a0635, 0x66666667, 0xb503, x3, 544, x4)

inst_152:
// rs1_val==1717986919 and rs2_val==0, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x0
TEST_RR_OP(mul, x12, x10, x11, 0x0, 0x66666667, 0x0, x3, 548, x4)

inst_153:
// rs1_val==1717986919 and rs2_val==1717986917, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x66666665
TEST_RR_OP(mul, x12, x10, x11, 0xa3d70a3, 0x66666667, 0x66666665, x3, 552, x4)

inst_154:
// rs1_val==1717986919 and rs2_val==858993458, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x33333332
TEST_RR_OP(mul, x12, x10, x11, 0x51eb851e, 0x66666667, 0x33333332, x3, 556, x4)

inst_155:
// rs1_val==1717986919 and rs2_val==1431655764, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x55555554
TEST_RR_OP(mul, x12, x10, x11, 0xcccccccc, 0x66666667, 0x55555554, x3, 560, x4)

inst_156:
// rs1_val==1717986919 and rs2_val==2, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x2
TEST_RR_OP(mul, x12, x10, x11, 0xccccccce, 0x66666667, 0x2, x3, 564, x4)

inst_157:
// rs1_val==1717986919 and rs2_val==46340, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0xb504
TEST_RR_OP(mul, x12, x10, x11, 0x6c9c, 0x66666667, 0xb504, x3, 568, x4)

inst_158:
// rs1_val==1717986919 and rs2_val==-46340, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:-0xb504
TEST_RR_OP(mul, x12, x10, x11, 0xffff9364, 0x66666667, -0xb504, x3, 572, x4)

inst_159:
// rs1_val==1717986919 and rs2_val==1717986918, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x66666666
TEST_RR_OP(mul, x12, x10, x11, 0x70a3d70a, 0x66666667, 0x66666666, x3, 576, x4)

inst_160:
// rs1_val==1717986919 and rs2_val==858993459, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x33333333
TEST_RR_OP(mul, x12, x10, x11, 0xb851eb85, 0x66666667, 0x33333333, x3, 580, x4)

inst_161:
// rs1_val==1717986919 and rs2_val==5, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x5
TEST_RR_OP(mul, x12, x10, x11, 0x3, 0x66666667, 0x5, x3, 584, x4)

inst_162:
// rs1_val==1717986919 and rs2_val==-1431655766, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:-0x55555556
TEST_RR_OP(mul, x12, x10, x11, 0x66666666, 0x66666667, -0x55555556, x3, 588, x4)

inst_163:
// rs1_val==1717986919 and rs2_val==1431655765, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x55555555
TEST_RR_OP(mul, x12, x10, x11, 0x33333333, 0x66666667, 0x55555555, x3, 592, x4)

inst_164:
// rs1_val==1717986919 and rs2_val==3, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x3
TEST_RR_OP(mul, x12, x10, x11, 0x33333335, 0x66666667, 0x3, x3, 596, x4)

inst_165:
// rs1_val==858993460 and rs2_val==46341, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0xb505
TEST_RR_OP(mul, x12, x10, x11, 0x3333c404, 0x33333334, 0xb505, x3, 600, x4)

inst_166:
// rs1_val==858993460 and rs2_val==-46339, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:-0xb503
TEST_RR_OP(mul, x12, x10, x11, 0x3332a264, 0x33333334, -0xb503, x3, 604, x4)

inst_167:
// rs1_val==858993460 and rs2_val==1717986919, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x66666667
TEST_RR_OP(mul, x12, x10, x11, 0x1eb851ec, 0x33333334, 0x66666667, x3, 608, x4)

inst_168:
// rs1_val==858993460 and rs2_val==858993460, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x33333334
TEST_RR_OP(mul, x12, x10, x11, 0x28f5c290, 0x33333334, 0x33333334, x3, 612, x4)

inst_169:
// rs1_val==858993460 and rs2_val==6, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x6
TEST_RR_OP(mul, x12, x10, x11, 0x33333338, 0x33333334, 0x6, x3, 616, x4)

inst_170:
// rs1_val==858993460 and rs2_val==-1431655765, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:-0x55555555
TEST_RR_OP(mul, x12, x10, x11, 0xbbbbbbbc, 0x33333334, -0x55555555, x3, 620, x4)

inst_171:
// rs1_val==858993460 and rs2_val==1431655766, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x55555556
TEST_RR_OP(mul, x12, x10, x11, 0x77777778, 0x33333334, 0x55555556, x3, 624, x4)

inst_172:
// rs1_val==858993460 and rs2_val==4, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x4
TEST_RR_OP(mul, x12, x10, x11, 0xccccccd0, 0x33333334, 0x4, x3, 628, x4)

inst_173:
// rs1_val==858993460 and rs2_val==46339, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0xb503
TEST_RR_OP(mul, x12, x10, x11, 0xcccd5d9c, 0x33333334, 0xb503, x3, 632, x4)

inst_174:
// rs1_val==858993460 and rs2_val==0, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x0
TEST_RR_OP(mul, x12, x10, x11, 0x0, 0x33333334, 0x0, x3, 636, x4)

inst_175:
// rs1_val==858993460 and rs2_val==1717986917, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x66666665
TEST_RR_OP(mul, x12, x10, x11, 0xb851eb84, 0x33333334, 0x66666665, x3, 640, x4)

inst_176:
// rs1_val==858993460 and rs2_val==858993458, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x33333332
TEST_RR_OP(mul, x12, x10, x11, 0xc28f5c28, 0x33333334, 0x33333332, x3, 644, x4)

inst_177:
// rs1_val==858993460 and rs2_val==1431655764, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x55555554
TEST_RR_OP(mul, x12, x10, x11, 0x11111110, 0x33333334, 0x55555554, x3, 648, x4)

inst_178:
// rs1_val==858993460 and rs2_val==2, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x2
TEST_RR_OP(mul, x12, x10, x11, 0x66666668, 0x33333334, 0x2, x3, 652, x4)

inst_179:
// rs1_val==858993460 and rs2_val==46340, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0xb504
TEST_RR_OP(mul, x12, x10, x11, 0x90d0, 0x33333334, 0xb504, x3, 656, x4)

inst_180:
// rs1_val==858993460 and rs2_val==-46340, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:-0xb504
TEST_RR_OP(mul, x12, x10, x11, 0xffff6f30, 0x33333334, -0xb504, x3, 660, x4)

inst_181:
// rs1_val==858993460 and rs2_val==1717986918, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x66666666
TEST_RR_OP(mul, x12, x10, x11, 0xeb851eb8, 0x33333334, 0x66666666, x3, 664, x4)

inst_182:
// rs1_val==858993460 and rs2_val==858993459, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x33333333
TEST_RR_OP(mul, x12, x10, x11, 0xf5c28f5c, 0x33333334, 0x33333333, x3, 668, x4)

inst_183:
// rs1_val==858993460 and rs2_val==5, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x5
TEST_RR_OP(mul, x12, x10, x11, 0x4, 0x33333334, 0x5, x3, 672, x4)

inst_184:
// rs1_val==858993460 and rs2_val==-1431655766, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:-0x55555556
TEST_RR_OP(mul, x12, x10, x11, 0x88888888, 0x33333334, -0x55555556, x3, 676, x4)

inst_185:
// rs1_val==858993460 and rs2_val==1431655765, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x55555555
TEST_RR_OP(mul, x12, x10, x11, 0x44444444, 0x33333334, 0x55555555, x3, 680, x4)

inst_186:
// rs1_val==858993460 and rs2_val==3, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x3
TEST_RR_OP(mul, x12, x10, x11, 0x9999999c, 0x33333334, 0x3, x3, 684, x4)

inst_187:
// rs1_val==6 and rs2_val==46341, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0xb505
TEST_RR_OP(mul, x12, x10, x11, 0x43e1e, 0x6, 0xb505, x3, 688, x4)

inst_188:
// rs1_val==6 and rs2_val==-46339, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:-0xb503
TEST_RR_OP(mul, x12, x10, x11, 0xfffbc1ee, 0x6, -0xb503, x3, 692, x4)

inst_189:
// rs1_val==6 and rs2_val==1717986919, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x66666667
TEST_RR_OP(mul, x12, x10, x11, 0x6666666a, 0x6, 0x66666667, x3, 696, x4)

inst_190:
// rs1_val==6 and rs2_val==858993460, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x33333334
TEST_RR_OP(mul, x12, x10, x11, 0x33333338, 0x6, 0x33333334, x3, 700, x4)

inst_191:
// rs1_val==6 and rs2_val==6, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x6
TEST_RR_OP(mul, x12, x10, x11, 0x24, 0x6, 0x6, x3, 704, x4)

inst_192:
// rs1_val==6 and rs2_val==1431655766, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x55555556
TEST_RR_OP(mul, x12, x10, x11, 0x4, 0x6, 0x55555556, x3, 708, x4)

inst_193:
// rs1_val==6 and rs2_val==4, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x4
TEST_RR_OP(mul, x12, x10, x11, 0x18, 0x6, 0x4, x3, 712, x4)

inst_194:
// rs1_val==6 and rs2_val==46339, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0xb503
TEST_RR_OP(mul, x12, x10, x11, 0x43e12, 0x6, 0xb503, x3, 716, x4)

inst_195:
// rs1_val==6 and rs2_val==0, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x0
TEST_RR_OP(mul, x12, x10, x11, 0x0, 0x6, 0x0, x3, 720, x4)

inst_196:
// rs1_val==6 and rs2_val==1717986917, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x66666665
TEST_RR_OP(mul, x12, x10, x11, 0x6666665e, 0x6, 0x66666665, x3, 724, x4)

inst_197:
// rs1_val==6 and rs2_val==858993458, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x33333332
TEST_RR_OP(mul, x12, x10, x11, 0x3333332c, 0x6, 0x33333332, x3, 728, x4)

inst_198:
// rs1_val==6 and rs2_val==1431655764, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x55555554
TEST_RR_OP(mul, x12, x10, x11, 0xfffffff8, 0x6, 0x55555554, x3, 732, x4)

inst_199:
// rs1_val==6 and rs2_val==2, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x2
TEST_RR_OP(mul, x12, x10, x11, 0xc, 0x6, 0x2, x3, 736, x4)

inst_200:
// rs1_val==6 and rs2_val==46340, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0xb504
TEST_RR_OP(mul, x12, x10, x11, 0x43e18, 0x6, 0xb504, x3, 740, x4)

inst_201:
// rs1_val==6 and rs2_val==-46340, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:-0xb504
TEST_RR_OP(mul, x12, x10, x11, 0xfffbc1e8, 0x6, -0xb504, x3, 744, x4)

inst_202:
// rs1_val==6 and rs2_val==1717986918, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x66666666
TEST_RR_OP(mul, x12, x10, x11, 0x66666664, 0x6, 0x66666666, x3, 748, x4)

inst_203:
// rs1_val==6 and rs2_val==858993459, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x33333333
TEST_RR_OP(mul, x12, x10, x11, 0x33333332, 0x6, 0x33333333, x3, 752, x4)

inst_204:
// rs1_val==6 and rs2_val==5, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x5
TEST_RR_OP(mul, x12, x10, x11, 0x1e, 0x6, 0x5, x3, 756, x4)

inst_205:
// rs1_val==6 and rs2_val==-1431655766, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:-0x55555556
TEST_RR_OP(mul, x12, x10, x11, 0xfffffffc, 0x6, -0x55555556, x3, 760, x4)

inst_206:
// rs1_val==6 and rs2_val==1431655765, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x55555555
TEST_RR_OP(mul, x12, x10, x11, 0xfffffffe, 0x6, 0x55555555, x3, 764, x4)

inst_207:
// rs1_val==6 and rs2_val==3, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x3
TEST_RR_OP(mul, x12, x10, x11, 0x12, 0x6, 0x3, x3, 768, x4)

inst_208:
// rs1_val==-1431655765 and rs2_val==46341, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0xb505
TEST_RR_OP(mul, x12, x10, x11, 0x3c57, -0x55555555, 0xb505, x3, 772, x4)

inst_209:
// rs1_val==-1431655765 and rs2_val==-46339, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:-0xb503
TEST_RR_OP(mul, x12, x10, x11, 0x555518ff, -0x55555555, -0xb503, x3, 776, x4)

inst_210:
// rs1_val==-1431655765 and rs2_val==1717986919, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x66666667
TEST_RR_OP(mul, x12, x10, x11, 0xcccccccd, -0x55555555, 0x66666667, x3, 780, x4)

inst_211:
// rs1_val==-1431655765 and rs2_val==858993460, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x33333334
TEST_RR_OP(mul, x12, x10, x11, 0xbbbbbbbc, -0x55555555, 0x33333334, x3, 784, x4)

inst_212:
// rs1_val==-1431655765 and rs2_val==6, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x6
TEST_RR_OP(mul, x12, x10, x11, 0x2, -0x55555555, 0x6, x3, 788, x4)

inst_213:
// rs1_val==-1431655765 and rs2_val==-1431655765, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:-0x55555555
TEST_RR_OP(mul, x12, x10, x11, 0x38e38e39, -0x55555555, -0x55555555, x3, 792, x4)

inst_214:
// rs1_val==-1431655765 and rs2_val==1431655766, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x55555556
TEST_RR_OP(mul, x12, x10, x11, 0x71c71c72, -0x55555555, 0x55555556, x3, 796, x4)

inst_215:
// rs1_val==-1431655765 and rs2_val==4, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x4
TEST_RR_OP(mul, x12, x10, x11, 0xaaaaaaac, -0x55555555, 0x4, x3, 800, x4)

inst_216:
// rs1_val==-1431655765 and rs2_val==46339, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0xb503
TEST_RR_OP(mul, x12, x10, x11, 0xaaaae701, -0x55555555, 0xb503, x3, 804, x4)

inst_217:
// rs1_val==-1431655765 and rs2_val==0, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x0
TEST_RR_OP(mul, x12, x10, x11, 0x0, -0x55555555, 0x0, x3, 808, x4)

inst_218:
// rs1_val==-1431655765 and rs2_val==1717986917, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x66666665
TEST_RR_OP(mul, x12, x10, x11, 0x77777777, -0x55555555, 0x66666665, x3, 812, x4)

inst_219:
// rs1_val==-1431655765 and rs2_val==858993458, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x33333332
TEST_RR_OP(mul, x12, x10, x11, 0x66666666, -0x55555555, 0x33333332, x3, 816, x4)

inst_220:
// rs1_val==-1431655765 and rs2_val==1431655764, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x55555554
TEST_RR_OP(mul, x12, x10, x11, 0x1c71c71c, -0x55555555, 0x55555554, x3, 820, x4)

inst_221:
// rs1_val==-1431655765 and rs2_val==2, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x2
TEST_RR_OP(mul, x12, x10, x11, 0x55555556, -0x55555555, 0x2, x3, 824, x4)

inst_222:
// rs1_val==-1431655765 and rs2_val==46340, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0xb504
TEST_RR_OP(mul, x12, x10, x11, 0x555591ac, -0x55555555, 0xb504, x3, 828, x4)

inst_223:
// rs1_val==-1431655765 and rs2_val==-46340, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:-0xb504
TEST_RR_OP(mul, x12, x10, x11, 0xaaaa6e54, -0x55555555, -0xb504, x3, 832, x4)

inst_224:
// rs1_val==-1431655765 and rs2_val==1717986918, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x66666666
TEST_RR_OP(mul, x12, x10, x11, 0x22222222, -0x55555555, 0x66666666, x3, 836, x4)

inst_225:
// rs1_val==-1431655765 and rs2_val==858993459, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x33333333
TEST_RR_OP(mul, x12, x10, x11, 0x11111111, -0x55555555, 0x33333333, x3, 840, x4)

inst_226:
// rs1_val==-1431655765 and rs2_val==5, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x5
TEST_RR_OP(mul, x12, x10, x11, 0x55555557, -0x55555555, 0x5, x3, 844, x4)

inst_227:
// rs1_val==-1431655765 and rs2_val==-1431655766, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:-0x55555556
TEST_RR_OP(mul, x12, x10, x11, 0x8e38e38e, -0x55555555, -0x55555556, x3, 848, x4)

inst_228:
// rs1_val==-1431655765 and rs2_val==1431655765, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x55555555
TEST_RR_OP(mul, x12, x10, x11, 0xc71c71c7, -0x55555555, 0x55555555, x3, 852, x4)

inst_229:
// rs1_val==-1431655765 and rs2_val==3, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x3
TEST_RR_OP(mul, x12, x10, x11, 0x1, -0x55555555, 0x3, x3, 856, x4)

inst_230:
// rs1_val==1431655766 and rs2_val==46341, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0xb505
TEST_RR_OP(mul, x12, x10, x11, 0x78ae, 0x55555556, 0xb505, x3, 860, x4)

inst_231:
// rs1_val==1431655766 and rs2_val==-46339, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:-0xb503
TEST_RR_OP(mul, x12, x10, x11, 0xaaaa31fe, 0x55555556, -0xb503, x3, 864, x4)

inst_232:
// rs1_val==1431655766 and rs2_val==1717986919, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x66666667
TEST_RR_OP(mul, x12, x10, x11, 0x9999999a, 0x55555556, 0x66666667, x3, 868, x4)

inst_233:
// rs1_val==1431655766 and rs2_val==858993460, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x33333334
TEST_RR_OP(mul, x12, x10, x11, 0x77777778, 0x55555556, 0x33333334, x3, 872, x4)

inst_234:
// rs1_val==1431655766 and rs2_val==6, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x6
TEST_RR_OP(mul, x12, x10, x11, 0x4, 0x55555556, 0x6, x3, 876, x4)

inst_235:
// rs1_val==1431655766 and rs2_val==-1431655765, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:-0x55555555
TEST_RR_OP(mul, x12, x10, x11, 0x71c71c72, 0x55555556, -0x55555555, x3, 880, x4)

inst_236:
// rs1_val==1431655766 and rs2_val==1431655766, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x55555556
TEST_RR_OP(mul, x12, x10, x11, 0xe38e38e4, 0x55555556, 0x55555556, x3, 884, x4)

inst_237:
// rs1_val==1431655766 and rs2_val==4, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x4
TEST_RR_OP(mul, x12, x10, x11, 0x55555558, 0x55555556, 0x4, x3, 888, x4)

inst_238:
// rs1_val==1431655766 and rs2_val==46339, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0xb503
TEST_RR_OP(mul, x12, x10, x11, 0x5555ce02, 0x55555556, 0xb503, x3, 892, x4)

inst_239:
// rs1_val==1431655766 and rs2_val==0, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x0
TEST_RR_OP(mul, x12, x10, x11, 0x0, 0x55555556, 0x0, x3, 896, x4)

inst_240:
// rs1_val==1431655766 and rs2_val==1717986917, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x66666665
TEST_RR_OP(mul, x12, x10, x11, 0xeeeeeeee, 0x55555556, 0x66666665, x3, 900, x4)

inst_241:
// rs1_val==1431655766 and rs2_val==858993458, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x33333332
TEST_RR_OP(mul, x12, x10, x11, 0xcccccccc, 0x55555556, 0x33333332, x3, 904, x4)

inst_242:
// rs1_val==1431655766 and rs2_val==1431655764, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x55555554
TEST_RR_OP(mul, x12, x10, x11, 0x38e38e38, 0x55555556, 0x55555554, x3, 908, x4)

inst_243:
// rs1_val==1431655766 and rs2_val==2, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x2
TEST_RR_OP(mul, x12, x10, x11, 0xaaaaaaac, 0x55555556, 0x2, x3, 912, x4)

inst_244:
// rs1_val==1431655766 and rs2_val==46340, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0xb504
TEST_RR_OP(mul, x12, x10, x11, 0xaaab2358, 0x55555556, 0xb504, x3, 916, x4)

inst_245:
// rs1_val==1431655766 and rs2_val==-46340, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:-0xb504
TEST_RR_OP(mul, x12, x10, x11, 0x5554dca8, 0x55555556, -0xb504, x3, 920, x4)

inst_246:
// rs1_val==1431655766 and rs2_val==1717986918, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x66666666
TEST_RR_OP(mul, x12, x10, x11, 0x44444444, 0x55555556, 0x66666666, x3, 924, x4)

inst_247:
// rs1_val==1431655766 and rs2_val==858993459, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x33333333
TEST_RR_OP(mul, x12, x10, x11, 0x22222222, 0x55555556, 0x33333333, x3, 928, x4)

inst_248:
// rs1_val==1431655766 and rs2_val==5, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x5
TEST_RR_OP(mul, x12, x10, x11, 0xaaaaaaae, 0x55555556, 0x5, x3, 932, x4)

inst_249:
// rs1_val==1431655766 and rs2_val==-1431655766, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:-0x55555556
TEST_RR_OP(mul, x12, x10, x11, 0x1c71c71c, 0x55555556, -0x55555556, x3, 936, x4)

inst_250:
// rs1_val==1431655766 and rs2_val==1431655765, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x55555555
TEST_RR_OP(mul, x12, x10, x11, 0x8e38e38e, 0x55555556, 0x55555555, x3, 940, x4)

inst_251:
// rs1_val==1431655766 and rs2_val==3, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x3
TEST_RR_OP(mul, x12, x10, x11, 0x2, 0x55555556, 0x3, x3, 944, x4)

inst_252:
// rs1_val==4 and rs2_val==46341, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0xb505
TEST_RR_OP(mul, x12, x10, x11, 0x2d414, 0x4, 0xb505, x3, 948, x4)

inst_253:
// rs1_val==4 and rs2_val==-46339, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:-0xb503
TEST_RR_OP(mul, x12, x10, x11, 0xfffd2bf4, 0x4, -0xb503, x3, 952, x4)

inst_254:
// rs1_val==4 and rs2_val==1717986919, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x66666667
TEST_RR_OP(mul, x12, x10, x11, 0x9999999c, 0x4, 0x66666667, x3, 956, x4)

inst_255:
// rs1_val==4 and rs2_val==858993460, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x33333334
TEST_RR_OP(mul, x12, x10, x11, 0xccccccd0, 0x4, 0x33333334, x3, 960, x4)

inst_256:
// rs1_val==4 and rs2_val==6, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x6
TEST_RR_OP(mul, x12, x10, x11, 0x18, 0x4, 0x6, x3, 964, x4)

inst_257:
// rs1_val==4 and rs2_val==-1431655765, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:-0x55555555
TEST_RR_OP(mul, x12, x10, x11, 0xaaaaaaac, 0x4, -0x55555555, x3, 968, x4)

inst_258:
// rs1_val==4 and rs2_val==1431655766, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x55555556
TEST_RR_OP(mul, x12, x10, x11, 0x55555558, 0x4, 0x55555556, x3, 972, x4)

inst_259:
// rs1_val==4 and rs2_val==4, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x4
TEST_RR_OP(mul, x12, x10, x11, 0x10, 0x4, 0x4, x3, 976, x4)

inst_260:
// rs1_val==4 and rs2_val==46339, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0xb503
TEST_RR_OP(mul, x12, x10, x11, 0x2d40c, 0x4, 0xb503, x3, 980, x4)

inst_261:
// rs1_val==4 and rs2_val==0, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x0
TEST_RR_OP(mul, x12, x10, x11, 0x0, 0x4, 0x0, x3, 984, x4)

inst_262:
// rs1_val==4 and rs2_val==1717986917, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x66666665
TEST_RR_OP(mul, x12, x10, x11, 0x99999994, 0x4, 0x66666665, x3, 988, x4)

inst_263:
// rs1_val==4 and rs2_val==858993458, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x33333332
TEST_RR_OP(mul, x12, x10, x11, 0xccccccc8, 0x4, 0x33333332, x3, 992, x4)

inst_264:
// rs1_val==4 and rs2_val==1431655764, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x55555554
TEST_RR_OP(mul, x12, x10, x11, 0x55555550, 0x4, 0x55555554, x3, 996, x4)

inst_265:
// rs1_val==4 and rs2_val==2, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x2
TEST_RR_OP(mul, x12, x10, x11, 0x8, 0x4, 0x2, x3, 1000, x4)

inst_266:
// rs1_val==4 and rs2_val==46340, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0xb504
TEST_RR_OP(mul, x12, x10, x11, 0x2d410, 0x4, 0xb504, x3, 1004, x4)

inst_267:
// rs1_val==4 and rs2_val==-46340, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:-0xb504
TEST_RR_OP(mul, x12, x10, x11, 0xfffd2bf0, 0x4, -0xb504, x3, 1008, x4)

inst_268:
// rs1_val==4 and rs2_val==1717986918, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x66666666
TEST_RR_OP(mul, x12, x10, x11, 0x99999998, 0x4, 0x66666666, x3, 1012, x4)

inst_269:
// rs1_val==4 and rs2_val==858993459, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x33333333
TEST_RR_OP(mul, x12, x10, x11, 0xcccccccc, 0x4, 0x33333333, x3, 1016, x4)

inst_270:
// rs1_val==4 and rs2_val==5, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x5
TEST_RR_OP(mul, x12, x10, x11, 0x14, 0x4, 0x5, x3, 1020, x4)

inst_271:
// rs1_val==4 and rs2_val==-1431655766, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:-0x55555556
TEST_RR_OP(mul, x12, x10, x11, 0xaaaaaaa8, 0x4, -0x55555556, x3, 1024, x4)

inst_272:
// rs1_val==4 and rs2_val==1431655765, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x55555555
TEST_RR_OP(mul, x12, x10, x11, 0x55555554, 0x4, 0x55555555, x3, 1028, x4)

inst_273:
// rs1_val==4 and rs2_val==3, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x3
TEST_RR_OP(mul, x12, x10, x11, 0xc, 0x4, 0x3, x3, 1032, x4)

inst_274:
// rs1_val==46339 and rs2_val==46341, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0xb505
TEST_RR_OP(mul, x12, x10, x11, 0x7ffea80f, 0xb503, 0xb505, x3, 1036, x4)

inst_275:
// rs1_val==46339 and rs2_val==-46339, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:-0xb503
TEST_RR_OP(mul, x12, x10, x11, 0x8002c1f7, 0xb503, -0xb503, x3, 1040, x4)

inst_276:
// rs1_val==46339 and rs2_val==1717986919, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x66666667
TEST_RR_OP(mul, x12, x10, x11, 0x999a0635, 0xb503, 0x66666667, x3, 1044, x4)

inst_277:
// rs1_val==46339 and rs2_val==858993460, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x33333334
TEST_RR_OP(mul, x12, x10, x11, 0xcccd5d9c, 0xb503, 0x33333334, x3, 1048, x4)

inst_278:
// rs1_val==46339 and rs2_val==6, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x6
TEST_RR_OP(mul, x12, x10, x11, 0x43e12, 0xb503, 0x6, x3, 1052, x4)

inst_279:
// rs1_val==46339 and rs2_val==-1431655765, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:-0x55555555
TEST_RR_OP(mul, x12, x10, x11, 0xaaaae701, 0xb503, -0x55555555, x3, 1056, x4)

inst_280:
// rs1_val==46339 and rs2_val==1431655766, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x55555556
TEST_RR_OP(mul, x12, x10, x11, 0x5555ce02, 0xb503, 0x55555556, x3, 1060, x4)

inst_281:
// rs1_val==46339 and rs2_val==4, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x4
TEST_RR_OP(mul, x12, x10, x11, 0x2d40c, 0xb503, 0x4, x3, 1064, x4)

inst_282:
// rs1_val==46339 and rs2_val==46339, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0xb503
TEST_RR_OP(mul, x12, x10, x11, 0x7ffd3e09, 0xb503, 0xb503, x3, 1068, x4)

inst_283:
// rs1_val==46339 and rs2_val==0, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x0
TEST_RR_OP(mul, x12, x10, x11, 0x0, 0xb503, 0x0, x3, 1072, x4)

inst_284:
// rs1_val==46339 and rs2_val==1717986917, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x66666665
TEST_RR_OP(mul, x12, x10, x11, 0x99989c2f, 0xb503, 0x66666665, x3, 1076, x4)

inst_285:
// rs1_val==46339 and rs2_val==858993458, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x33333332
TEST_RR_OP(mul, x12, x10, x11, 0xcccbf396, 0xb503, 0x33333332, x3, 1080, x4)

inst_286:
// rs1_val==46339 and rs2_val==1431655764, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x55555554
TEST_RR_OP(mul, x12, x10, x11, 0x555463fc, 0xb503, 0x55555554, x3, 1084, x4)

inst_287:
// rs1_val==46339 and rs2_val==2, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x2
TEST_RR_OP(mul, x12, x10, x11, 0x16a06, 0xb503, 0x2, x3, 1088, x4)

inst_288:
// rs1_val==46339 and rs2_val==46340, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0xb504
TEST_RR_OP(mul, x12, x10, x11, 0x7ffdf30c, 0xb503, 0xb504, x3, 1092, x4)

inst_289:
// rs1_val==46339 and rs2_val==-46340, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:-0xb504
TEST_RR_OP(mul, x12, x10, x11, 0x80020cf4, 0xb503, -0xb504, x3, 1096, x4)

inst_290:
// rs1_val==46339 and rs2_val==1717986918, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x66666666
TEST_RR_OP(mul, x12, x10, x11, 0x99995132, 0xb503, 0x66666666, x3, 1100, x4)

inst_291:
// rs1_val==46339 and rs2_val==858993459, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x33333333
TEST_RR_OP(mul, x12, x10, x11, 0xcccca899, 0xb503, 0x33333333, x3, 1104, x4)

inst_292:
// rs1_val==46339 and rs2_val==5, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x5
TEST_RR_OP(mul, x12, x10, x11, 0x3890f, 0xb503, 0x5, x3, 1108, x4)

inst_293:
// rs1_val==46339 and rs2_val==-1431655766, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:-0x55555556
TEST_RR_OP(mul, x12, x10, x11, 0xaaaa31fe, 0xb503, -0x55555556, x3, 1112, x4)

inst_294:
// rs1_val==46339 and rs2_val==1431655765, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x55555555
TEST_RR_OP(mul, x12, x10, x11, 0x555518ff, 0xb503, 0x55555555, x3, 1116, x4)

inst_295:
// rs1_val==46339 and rs2_val==3, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x3
TEST_RR_OP(mul, x12, x10, x11, 0x21f09, 0xb503, 0x3, x3, 1120, x4)

inst_296:
// rs1_val==0 and rs2_val==46341, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0xb505
TEST_RR_OP(mul, x12, x10, x11, 0x0, 0x0, 0xb505, x3, 1124, x4)

inst_297:
// rs1_val==0 and rs2_val==-46339, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:-0xb503
TEST_RR_OP(mul, x12, x10, x11, 0x0, 0x0, -0xb503, x3, 1128, x4)

inst_298:
// rs1_val==0 and rs2_val==1717986919, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x66666667
TEST_RR_OP(mul, x12, x10, x11, 0x0, 0x0, 0x66666667, x3, 1132, x4)

inst_299:
// rs1_val==0 and rs2_val==858993460, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x33333334
TEST_RR_OP(mul, x12, x10, x11, 0x0, 0x0, 0x33333334, x3, 1136, x4)

inst_300:
// rs1_val==0 and rs2_val==6, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x6
TEST_RR_OP(mul, x12, x10, x11, 0x0, 0x0, 0x6, x3, 1140, x4)

inst_301:
// rs1_val==0 and rs2_val==-1431655765, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:-0x55555555
TEST_RR_OP(mul, x12, x10, x11, 0x0, 0x0, -0x55555555, x3, 1144, x4)

inst_302:
// rs1_val==0 and rs2_val==1431655766, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x55555556
TEST_RR_OP(mul, x12, x10, x11, 0x0, 0x0, 0x55555556, x3, 1148, x4)

inst_303:
// rs1_val==0 and rs2_val==4, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x4
TEST_RR_OP(mul, x12, x10, x11, 0x0, 0x0, 0x4, x3, 1152, x4)

inst_304:
// rs1_val==0 and rs2_val==46339, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0xb503
TEST_RR_OP(mul, x12, x10, x11, 0x0, 0x0, 0xb503, x3, 1156, x4)

inst_305:
// rs1_val==0 and rs2_val==0, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x0
TEST_RR_OP(mul, x12, x10, x11, 0x0, 0x0, 0x0, x3, 1160, x4)

inst_306:
// rs1_val==0 and rs2_val==1717986917, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x66666665
TEST_RR_OP(mul, x12, x10, x11, 0x0, 0x0, 0x66666665, x3, 1164, x4)

inst_307:
// rs1_val==0 and rs2_val==858993458, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x33333332
TEST_RR_OP(mul, x12, x10, x11, 0x0, 0x0, 0x33333332, x3, 1168, x4)

inst_308:
// rs1_val==0 and rs2_val==1431655764, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x55555554
TEST_RR_OP(mul, x12, x10, x11, 0x0, 0x0, 0x55555554, x3, 1172, x4)

inst_309:
// rs1_val==0 and rs2_val==2, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x2
TEST_RR_OP(mul, x12, x10, x11, 0x0, 0x0, 0x2, x3, 1176, x4)

inst_310:
// rs1_val==0 and rs2_val==46340, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0xb504
TEST_RR_OP(mul, x12, x10, x11, 0x0, 0x0, 0xb504, x3, 1180, x4)

inst_311:
// rs1_val==0 and rs2_val==-46340, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:-0xb504
TEST_RR_OP(mul, x12, x10, x11, 0x0, 0x0, -0xb504, x3, 1184, x4)

inst_312:
// rs1_val==0 and rs2_val==1717986918, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x66666666
TEST_RR_OP(mul, x12, x10, x11, 0x0, 0x0, 0x66666666, x3, 1188, x4)

inst_313:
// rs1_val==0 and rs2_val==858993459, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x33333333
TEST_RR_OP(mul, x12, x10, x11, 0x0, 0x0, 0x33333333, x3, 1192, x4)

inst_314:
// rs1_val==0 and rs2_val==5, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x5
TEST_RR_OP(mul, x12, x10, x11, 0x0, 0x0, 0x5, x3, 1196, x4)

inst_315:
// rs1_val==0 and rs2_val==-1431655766, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:-0x55555556
TEST_RR_OP(mul, x12, x10, x11, 0x0, 0x0, -0x55555556, x3, 1200, x4)

inst_316:
// rs1_val==0 and rs2_val==1431655765, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x55555555
TEST_RR_OP(mul, x12, x10, x11, 0x0, 0x0, 0x55555555, x3, 1204, x4)

inst_317:
// rs1_val==0 and rs2_val==3, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x3
TEST_RR_OP(mul, x12, x10, x11, 0x0, 0x0, 0x3, x3, 1208, x4)

inst_318:
// rs1_val==1717986917 and rs2_val==46341, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0xb505
TEST_RR_OP(mul, x12, x10, x11, 0x666568f9, 0x66666665, 0xb505, x3, 1212, x4)

inst_319:
// rs1_val==1717986917 and rs2_val==-46339, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:-0xb503
TEST_RR_OP(mul, x12, x10, x11, 0x666763d1, 0x66666665, -0xb503, x3, 1216, x4)

inst_320:
// rs1_val==1717986917 and rs2_val==1717986919, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x66666667
TEST_RR_OP(mul, x12, x10, x11, 0xa3d70a3, 0x66666665, 0x66666667, x3, 1220, x4)

inst_321:
// rs1_val==1717986917 and rs2_val==858993460, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x33333334
TEST_RR_OP(mul, x12, x10, x11, 0xb851eb84, 0x66666665, 0x33333334, x3, 1224, x4)

inst_322:
// rs1_val==1717986917 and rs2_val==6, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x6
TEST_RR_OP(mul, x12, x10, x11, 0x6666665e, 0x66666665, 0x6, x3, 1228, x4)

inst_323:
// rs1_val==1717986917 and rs2_val==-1431655765, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:-0x55555555
TEST_RR_OP(mul, x12, x10, x11, 0x77777777, 0x66666665, -0x55555555, x3, 1232, x4)

inst_324:
// rs1_val==1717986917 and rs2_val==1431655766, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x55555556
TEST_RR_OP(mul, x12, x10, x11, 0xeeeeeeee, 0x66666665, 0x55555556, x3, 1236, x4)

inst_325:
// rs1_val==1717986917 and rs2_val==4, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x4
TEST_RR_OP(mul, x12, x10, x11, 0x99999994, 0x66666665, 0x4, x3, 1240, x4)

inst_326:
// rs1_val==858993459 and rs2_val==0, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x0
TEST_RR_OP(mul, x12, x10, x11, 0x0, 0x33333333, 0x0, x3, 1244, x4)

inst_327:
// rs1_val==858993459 and rs2_val==1717986917, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x66666665
TEST_RR_OP(mul, x12, x10, x11, 0x51eb851f, 0x33333333, 0x66666665, x3, 1248, x4)

inst_328:
// rs1_val==858993459 and rs2_val==858993458, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x33333332
TEST_RR_OP(mul, x12, x10, x11, 0x8f5c28f6, 0x33333333, 0x33333332, x3, 1252, x4)

inst_329:
// rs1_val==858993459 and rs2_val==1431655764, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x55555554
TEST_RR_OP(mul, x12, x10, x11, 0xbbbbbbbc, 0x33333333, 0x55555554, x3, 1256, x4)

inst_330:
// rs1_val==858993459 and rs2_val==2, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x2
TEST_RR_OP(mul, x12, x10, x11, 0x66666666, 0x33333333, 0x2, x3, 1260, x4)

inst_331:
// rs1_val==858993459 and rs2_val==46340, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0xb504
TEST_RR_OP(mul, x12, x10, x11, 0xffffdbcc, 0x33333333, 0xb504, x3, 1264, x4)

inst_332:
// rs1_val==858993459 and rs2_val==-46340, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:-0xb504
TEST_RR_OP(mul, x12, x10, x11, 0x2434, 0x33333333, -0xb504, x3, 1268, x4)

inst_333:
// rs1_val==858993459 and rs2_val==1717986918, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x66666666
TEST_RR_OP(mul, x12, x10, x11, 0x851eb852, 0x33333333, 0x66666666, x3, 1272, x4)

inst_334:
// rs1_val==858993459 and rs2_val==858993459, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x33333333
TEST_RR_OP(mul, x12, x10, x11, 0xc28f5c29, 0x33333333, 0x33333333, x3, 1276, x4)

inst_335:
// rs1_val==858993459 and rs2_val==5, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x5
TEST_RR_OP(mul, x12, x10, x11, 0xffffffff, 0x33333333, 0x5, x3, 1280, x4)

inst_336:
// rs1_val==858993459 and rs2_val==-1431655766, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:-0x55555556
TEST_RR_OP(mul, x12, x10, x11, 0xddddddde, 0x33333333, -0x55555556, x3, 1284, x4)

inst_337:
// rs1_val==858993459 and rs2_val==1431655765, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x55555555
TEST_RR_OP(mul, x12, x10, x11, 0xeeeeeeef, 0x33333333, 0x55555555, x3, 1288, x4)

inst_338:
// rs1_val==858993459 and rs2_val==3, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x3
TEST_RR_OP(mul, x12, x10, x11, 0x99999999, 0x33333333, 0x3, x3, 1292, x4)

inst_339:
// rs1_val==5 and rs2_val==46341, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0xb505
TEST_RR_OP(mul, x12, x10, x11, 0x38919, 0x5, 0xb505, x3, 1296, x4)

inst_340:
// rs1_val==5 and rs2_val==-46339, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:-0xb503
TEST_RR_OP(mul, x12, x10, x11, 0xfffc76f1, 0x5, -0xb503, x3, 1300, x4)

inst_341:
// rs1_val==5 and rs2_val==1717986919, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x66666667
TEST_RR_OP(mul, x12, x10, x11, 0x3, 0x5, 0x66666667, x3, 1304, x4)

inst_342:
// rs1_val==5 and rs2_val==858993460, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x33333334
TEST_RR_OP(mul, x12, x10, x11, 0x4, 0x5, 0x33333334, x3, 1308, x4)

inst_343:
// rs1_val==5 and rs2_val==6, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x6
TEST_RR_OP(mul, x12, x10, x11, 0x1e, 0x5, 0x6, x3, 1312, x4)

inst_344:
// rs1_val==5 and rs2_val==-1431655765, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:-0x55555555
TEST_RR_OP(mul, x12, x10, x11, 0x55555557, 0x5, -0x55555555, x3, 1316, x4)

inst_345:
// rs1_val==5 and rs2_val==1431655766, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x55555556
TEST_RR_OP(mul, x12, x10, x11, 0xaaaaaaae, 0x5, 0x55555556, x3, 1320, x4)

inst_346:
// rs1_val==5 and rs2_val==4, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x4
TEST_RR_OP(mul, x12, x10, x11, 0x14, 0x5, 0x4, x3, 1324, x4)

inst_347:
// rs1_val==5 and rs2_val==46339, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0xb503
TEST_RR_OP(mul, x12, x10, x11, 0x3890f, 0x5, 0xb503, x3, 1328, x4)

inst_348:
// rs1_val==5 and rs2_val==0, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x0
TEST_RR_OP(mul, x12, x10, x11, 0x0, 0x5, 0x0, x3, 1332, x4)

inst_349:
// rs1_val==5 and rs2_val==1717986917, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x66666665
TEST_RR_OP(mul, x12, x10, x11, 0xfffffff9, 0x5, 0x66666665, x3, 1336, x4)

inst_350:
// rs1_val==5 and rs2_val==858993458, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x33333332
TEST_RR_OP(mul, x12, x10, x11, 0xfffffffa, 0x5, 0x33333332, x3, 1340, x4)

inst_351:
// rs1_val==5 and rs2_val==1431655764, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x55555554
TEST_RR_OP(mul, x12, x10, x11, 0xaaaaaaa4, 0x5, 0x55555554, x3, 1344, x4)

inst_352:
// rs1_val==5 and rs2_val==2, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x2
TEST_RR_OP(mul, x12, x10, x11, 0xa, 0x5, 0x2, x3, 1348, x4)

inst_353:
// rs1_val==5 and rs2_val==46340, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0xb504
TEST_RR_OP(mul, x12, x10, x11, 0x38914, 0x5, 0xb504, x3, 1352, x4)

inst_354:
// rs1_val==5 and rs2_val==-46340, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:-0xb504
TEST_RR_OP(mul, x12, x10, x11, 0xfffc76ec, 0x5, -0xb504, x3, 1356, x4)

inst_355:
// rs1_val==5 and rs2_val==1717986918, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x66666666
TEST_RR_OP(mul, x12, x10, x11, 0xfffffffe, 0x5, 0x66666666, x3, 1360, x4)

inst_356:
// rs1_val==5 and rs2_val==858993459, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x33333333
TEST_RR_OP(mul, x12, x10, x11, 0xffffffff, 0x5, 0x33333333, x3, 1364, x4)

inst_357:
// rs1_val==5 and rs2_val==5, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x5
TEST_RR_OP(mul, x12, x10, x11, 0x19, 0x5, 0x5, x3, 1368, x4)

inst_358:
// rs1_val==5 and rs2_val==-1431655766, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:-0x55555556
TEST_RR_OP(mul, x12, x10, x11, 0x55555552, 0x5, -0x55555556, x3, 1372, x4)

inst_359:
// rs1_val==5 and rs2_val==1431655765, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x55555555
TEST_RR_OP(mul, x12, x10, x11, 0xaaaaaaa9, 0x5, 0x55555555, x3, 1376, x4)

inst_360:
// rs1_val==5 and rs2_val==3, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x3
TEST_RR_OP(mul, x12, x10, x11, 0xf, 0x5, 0x3, x3, 1380, x4)

inst_361:
// rs1_val==-1431655766 and rs2_val==46341, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0xb505
TEST_RR_OP(mul, x12, x10, x11, 0xffff8752, -0x55555556, 0xb505, x3, 1384, x4)

inst_362:
// rs1_val==-1431655766 and rs2_val==-46339, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:-0xb503
TEST_RR_OP(mul, x12, x10, x11, 0x5555ce02, -0x55555556, -0xb503, x3, 1388, x4)

inst_363:
// rs1_val==-1431655766 and rs2_val==1717986919, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x66666667
TEST_RR_OP(mul, x12, x10, x11, 0x66666666, -0x55555556, 0x66666667, x3, 1392, x4)

inst_364:
// rs1_val==-1431655766 and rs2_val==858993460, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x33333334
TEST_RR_OP(mul, x12, x10, x11, 0x88888888, -0x55555556, 0x33333334, x3, 1396, x4)

inst_365:
// rs1_val==-1431655766 and rs2_val==6, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x6
TEST_RR_OP(mul, x12, x10, x11, 0xfffffffc, -0x55555556, 0x6, x3, 1400, x4)

inst_366:
// rs1_val==-1431655766 and rs2_val==-1431655765, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:-0x55555555
TEST_RR_OP(mul, x12, x10, x11, 0x8e38e38e, -0x55555556, -0x55555555, x3, 1404, x4)

inst_367:
// rs1_val==-1431655766 and rs2_val==1431655766, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x55555556
TEST_RR_OP(mul, x12, x10, x11, 0x1c71c71c, -0x55555556, 0x55555556, x3, 1408, x4)

inst_368:
// rs1_val==-1431655766 and rs2_val==4, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x4
TEST_RR_OP(mul, x12, x10, x11, 0xaaaaaaa8, -0x55555556, 0x4, x3, 1412, x4)

inst_369:
// rs1_val==-1431655766 and rs2_val==46339, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0xb503
TEST_RR_OP(mul, x12, x10, x11, 0xaaaa31fe, -0x55555556, 0xb503, x3, 1416, x4)

inst_370:
// rs1_val==-1431655766 and rs2_val==0, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x0
TEST_RR_OP(mul, x12, x10, x11, 0x0, -0x55555556, 0x0, x3, 1420, x4)

inst_371:
// rs1_val==-1431655766 and rs2_val==1717986917, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x66666665
TEST_RR_OP(mul, x12, x10, x11, 0x11111112, -0x55555556, 0x66666665, x3, 1424, x4)

inst_372:
// rs1_val==-1431655766 and rs2_val==858993458, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x33333332
TEST_RR_OP(mul, x12, x10, x11, 0x33333334, -0x55555556, 0x33333332, x3, 1428, x4)

inst_373:
// rs1_val==-1431655766 and rs2_val==1431655764, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x55555554
TEST_RR_OP(mul, x12, x10, x11, 0xc71c71c8, -0x55555556, 0x55555554, x3, 1432, x4)

inst_374:
// rs1_val==-1431655766 and rs2_val==2, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x2
TEST_RR_OP(mul, x12, x10, x11, 0x55555554, -0x55555556, 0x2, x3, 1436, x4)

inst_375:
// rs1_val==-1431655766 and rs2_val==46340, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0xb504
TEST_RR_OP(mul, x12, x10, x11, 0x5554dca8, -0x55555556, 0xb504, x3, 1440, x4)

inst_376:
// rs1_val==-1431655766 and rs2_val==-46340, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:-0xb504
TEST_RR_OP(mul, x12, x10, x11, 0xaaab2358, -0x55555556, -0xb504, x3, 1444, x4)

inst_377:
// rs1_val==-1431655766 and rs2_val==1717986918, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x66666666
TEST_RR_OP(mul, x12, x10, x11, 0xbbbbbbbc, -0x55555556, 0x66666666, x3, 1448, x4)

inst_378:
// rs1_val==-1431655766 and rs2_val==858993459, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x33333333
TEST_RR_OP(mul, x12, x10, x11, 0xddddddde, -0x55555556, 0x33333333, x3, 1452, x4)

inst_379:
// rs1_val==-1431655766 and rs2_val==5, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x5
TEST_RR_OP(mul, x12, x10, x11, 0x55555552, -0x55555556, 0x5, x3, 1456, x4)

inst_380:
// rs1_val==-1431655766 and rs2_val==-1431655766, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:-0x55555556
TEST_RR_OP(mul, x12, x10, x11, 0xe38e38e4, -0x55555556, -0x55555556, x3, 1460, x4)

inst_381:
// rs1_val==-1431655766 and rs2_val==1431655765, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x55555555
TEST_RR_OP(mul, x12, x10, x11, 0x71c71c72, -0x55555556, 0x55555555, x3, 1464, x4)

inst_382:
// rs1_val==-1431655766 and rs2_val==3, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x3
TEST_RR_OP(mul, x12, x10, x11, 0xfffffffe, -0x55555556, 0x3, x3, 1468, x4)

inst_383:
// rs1_val==1431655765 and rs2_val==46341, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0xb505
TEST_RR_OP(mul, x12, x10, x11, 0xffffc3a9, 0x55555555, 0xb505, x3, 1472, x4)

inst_384:
// rs1_val==1431655765 and rs2_val==-46339, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:-0xb503
TEST_RR_OP(mul, x12, x10, x11, 0xaaaae701, 0x55555555, -0xb503, x3, 1476, x4)

inst_385:
// rs1_val==1431655765 and rs2_val==1717986919, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x66666667
TEST_RR_OP(mul, x12, x10, x11, 0x33333333, 0x55555555, 0x66666667, x3, 1480, x4)

inst_386:
// rs1_val==1431655765 and rs2_val==858993460, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x33333334
TEST_RR_OP(mul, x12, x10, x11, 0x44444444, 0x55555555, 0x33333334, x3, 1484, x4)

inst_387:
// rs1_val==1431655765 and rs2_val==6, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x6
TEST_RR_OP(mul, x12, x10, x11, 0xfffffffe, 0x55555555, 0x6, x3, 1488, x4)

inst_388:
// rs1_val==1431655765 and rs2_val==-1431655765, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:-0x55555555
TEST_RR_OP(mul, x12, x10, x11, 0xc71c71c7, 0x55555555, -0x55555555, x3, 1492, x4)

inst_389:
// rs1_val==1431655765 and rs2_val==1431655766, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x55555556
TEST_RR_OP(mul, x12, x10, x11, 0x8e38e38e, 0x55555555, 0x55555556, x3, 1496, x4)

inst_390:
// rs1_val==1431655765 and rs2_val==4, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x4
TEST_RR_OP(mul, x12, x10, x11, 0x55555554, 0x55555555, 0x4, x3, 1500, x4)

inst_391:
// rs1_val==1431655765 and rs2_val==46339, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0xb503
TEST_RR_OP(mul, x12, x10, x11, 0x555518ff, 0x55555555, 0xb503, x3, 1504, x4)

inst_392:
// rs1_val==1431655765 and rs2_val==0, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x0
TEST_RR_OP(mul, x12, x10, x11, 0x0, 0x55555555, 0x0, x3, 1508, x4)

inst_393:
// rs1_val==1431655765 and rs2_val==1717986917, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x66666665
TEST_RR_OP(mul, x12, x10, x11, 0x88888889, 0x55555555, 0x66666665, x3, 1512, x4)

inst_394:
// rs1_val==1431655765 and rs2_val==858993458, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x33333332
TEST_RR_OP(mul, x12, x10, x11, 0x9999999a, 0x55555555, 0x33333332, x3, 1516, x4)

inst_395:
// rs1_val==1431655765 and rs2_val==1431655764, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x55555554
TEST_RR_OP(mul, x12, x10, x11, 0xe38e38e4, 0x55555555, 0x55555554, x3, 1520, x4)

inst_396:
// rs1_val==1431655765 and rs2_val==2, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x2
TEST_RR_OP(mul, x12, x10, x11, 0xaaaaaaaa, 0x55555555, 0x2, x3, 1524, x4)

inst_397:
// rs1_val==1431655765 and rs2_val==46340, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0xb504
TEST_RR_OP(mul, x12, x10, x11, 0xaaaa6e54, 0x55555555, 0xb504, x3, 1528, x4)

inst_398:
// rs1_val==1431655765 and rs2_val==-46340, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:-0xb504
TEST_RR_OP(mul, x12, x10, x11, 0x555591ac, 0x55555555, -0xb504, x3, 1532, x4)

inst_399:
// rs1_val==1431655765 and rs2_val==1717986918, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x66666666
TEST_RR_OP(mul, x12, x10, x11, 0xddddddde, 0x55555555, 0x66666666, x3, 1536, x4)

inst_400:
// rs1_val==1431655765 and rs2_val==858993459, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x33333333
TEST_RR_OP(mul, x12, x10, x11, 0xeeeeeeef, 0x55555555, 0x33333333, x3, 1540, x4)

inst_401:
// rs1_val==1431655765 and rs2_val==5, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x5
TEST_RR_OP(mul, x12, x10, x11, 0xaaaaaaa9, 0x55555555, 0x5, x3, 1544, x4)

inst_402:
// rs1_val==1431655765 and rs2_val==-1431655766, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:-0x55555556
TEST_RR_OP(mul, x12, x10, x11, 0x71c71c72, 0x55555555, -0x55555556, x3, 1548, x4)

inst_403:
// rs1_val==1431655765 and rs2_val==1431655765, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x55555555
TEST_RR_OP(mul, x12, x10, x11, 0x38e38e39, 0x55555555, 0x55555555, x3, 1552, x4)

inst_404:
// rs1_val==1431655765 and rs2_val==3, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x3
TEST_RR_OP(mul, x12, x10, x11, 0xffffffff, 0x55555555, 0x3, x3, 1556, x4)

inst_405:
// rs1_val==3 and rs2_val==46341, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0xb505
TEST_RR_OP(mul, x12, x10, x11, 0x21f0f, 0x3, 0xb505, x3, 1560, x4)

inst_406:
// rs1_val==3 and rs2_val==-46339, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:-0xb503
TEST_RR_OP(mul, x12, x10, x11, 0xfffde0f7, 0x3, -0xb503, x3, 1564, x4)

inst_407:
// rs1_val==3 and rs2_val==1717986919, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x66666667
TEST_RR_OP(mul, x12, x10, x11, 0x33333335, 0x3, 0x66666667, x3, 1568, x4)

inst_408:
// rs1_val==3 and rs2_val==858993460, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x33333334
TEST_RR_OP(mul, x12, x10, x11, 0x9999999c, 0x3, 0x33333334, x3, 1572, x4)

inst_409:
// rs1_val==3 and rs2_val==6, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x6
TEST_RR_OP(mul, x12, x10, x11, 0x12, 0x3, 0x6, x3, 1576, x4)

inst_410:
// rs1_val==3 and rs2_val==-1431655765, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:-0x55555555
TEST_RR_OP(mul, x12, x10, x11, 0x1, 0x3, -0x55555555, x3, 1580, x4)

inst_411:
// rs1_val==3 and rs2_val==1431655766, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x55555556
TEST_RR_OP(mul, x12, x10, x11, 0x2, 0x3, 0x55555556, x3, 1584, x4)

inst_412:
// rs1_val==3 and rs2_val==4, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x4
TEST_RR_OP(mul, x12, x10, x11, 0xc, 0x3, 0x4, x3, 1588, x4)

inst_413:
// rs1_val==3 and rs2_val==46339, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0xb503
TEST_RR_OP(mul, x12, x10, x11, 0x21f09, 0x3, 0xb503, x3, 1592, x4)

inst_414:
// rs1_val==3 and rs2_val==0, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x0
TEST_RR_OP(mul, x12, x10, x11, 0x0, 0x3, 0x0, x3, 1596, x4)

inst_415:
// rs1_val==3 and rs2_val==1717986917, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x66666665
TEST_RR_OP(mul, x12, x10, x11, 0x3333332f, 0x3, 0x66666665, x3, 1600, x4)

inst_416:
// rs1_val==3 and rs2_val==858993458, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x33333332
TEST_RR_OP(mul, x12, x10, x11, 0x99999996, 0x3, 0x33333332, x3, 1604, x4)

inst_417:
// rs1_val==3 and rs2_val==1431655764, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x55555554
TEST_RR_OP(mul, x12, x10, x11, 0xfffffffc, 0x3, 0x55555554, x3, 1608, x4)

inst_418:
// rs1_val==3 and rs2_val==2, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x2
TEST_RR_OP(mul, x12, x10, x11, 0x6, 0x3, 0x2, x3, 1612, x4)

inst_419:
// rs1_val==3 and rs2_val==46340, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0xb504
TEST_RR_OP(mul, x12, x10, x11, 0x21f0c, 0x3, 0xb504, x3, 1616, x4)

inst_420:
// rs1_val==3 and rs2_val==-46340, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:-0xb504
TEST_RR_OP(mul, x12, x10, x11, 0xfffde0f4, 0x3, -0xb504, x3, 1620, x4)

inst_421:
// rs1_val==3 and rs2_val==1717986918, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x66666666
TEST_RR_OP(mul, x12, x10, x11, 0x33333332, 0x3, 0x66666666, x3, 1624, x4)

inst_422:
// rs1_val==3 and rs2_val==858993459, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x33333333
TEST_RR_OP(mul, x12, x10, x11, 0x99999999, 0x3, 0x33333333, x3, 1628, x4)

inst_423:
// rs1_val==3 and rs2_val==5, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x5
TEST_RR_OP(mul, x12, x10, x11, 0xf, 0x3, 0x5, x3, 1632, x4)

inst_424:
// rs1_val==3 and rs2_val==-1431655766, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:-0x55555556
TEST_RR_OP(mul, x12, x10, x11, 0xfffffffe, 0x3, -0x55555556, x3, 1636, x4)

inst_425:
// rs1_val==3 and rs2_val==1431655765, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x55555555
TEST_RR_OP(mul, x12, x10, x11, 0xffffffff, 0x3, 0x55555555, x3, 1640, x4)

inst_426:
// rs1_val==3 and rs2_val==3, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x3
TEST_RR_OP(mul, x12, x10, x11, 0x9, 0x3, 0x3, x3, 1644, x4)

inst_427:
// rs1_val==1717986917 and rs2_val==46339, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0xb503
TEST_RR_OP(mul, x12, x10, x11, 0x99989c2f, 0x66666665, 0xb503, x3, 1648, x4)

inst_428:
// rs1_val==1717986917 and rs2_val==0, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x0
TEST_RR_OP(mul, x12, x10, x11, 0x0, 0x66666665, 0x0, x3, 1652, x4)

inst_429:
// rs1_val==1717986917 and rs2_val==1717986917, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x66666665
TEST_RR_OP(mul, x12, x10, x11, 0x3d70a3d9, 0x66666665, 0x66666665, x3, 1656, x4)

inst_430:
// rs1_val==1717986917 and rs2_val==858993458, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x33333332
TEST_RR_OP(mul, x12, x10, x11, 0xeb851eba, 0x66666665, 0x33333332, x3, 1660, x4)

inst_431:
// rs1_val==1717986917 and rs2_val==1431655764, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x55555554
TEST_RR_OP(mul, x12, x10, x11, 0x22222224, 0x66666665, 0x55555554, x3, 1664, x4)

inst_432:
// rs1_val==1717986917 and rs2_val==2, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x2
TEST_RR_OP(mul, x12, x10, x11, 0xccccccca, 0x66666665, 0x2, x3, 1668, x4)

inst_433:
// rs1_val==1717986917 and rs2_val==46340, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0xb504
TEST_RR_OP(mul, x12, x10, x11, 0xffff0294, 0x66666665, 0xb504, x3, 1672, x4)

inst_434:
// rs1_val==1717986917 and rs2_val==-46340, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:-0xb504
TEST_RR_OP(mul, x12, x10, x11, 0xfd6c, 0x66666665, -0xb504, x3, 1676, x4)

inst_435:
// rs1_val==1717986917 and rs2_val==1717986918, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x66666666
TEST_RR_OP(mul, x12, x10, x11, 0xa3d70a3e, 0x66666665, 0x66666666, x3, 1680, x4)

inst_436:
// rs1_val==1717986917 and rs2_val==858993459, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x33333333
TEST_RR_OP(mul, x12, x10, x11, 0x51eb851f, 0x66666665, 0x33333333, x3, 1684, x4)

inst_437:
// rs1_val==1717986917 and rs2_val==5, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x5
TEST_RR_OP(mul, x12, x10, x11, 0xfffffff9, 0x66666665, 0x5, x3, 1688, x4)

inst_438:
// rs1_val==1717986917 and rs2_val==-1431655766, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:-0x55555556
TEST_RR_OP(mul, x12, x10, x11, 0x11111112, 0x66666665, -0x55555556, x3, 1692, x4)

inst_439:
// rs1_val==1717986917 and rs2_val==1431655765, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x55555555
TEST_RR_OP(mul, x12, x10, x11, 0x88888889, 0x66666665, 0x55555555, x3, 1696, x4)

inst_440:
// rs1_val==1717986917 and rs2_val==3, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x3
TEST_RR_OP(mul, x12, x10, x11, 0x3333332f, 0x66666665, 0x3, x3, 1700, x4)

inst_441:
// rs1_val==858993458 and rs2_val==46341, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0xb505
TEST_RR_OP(mul, x12, x10, x11, 0x333259fa, 0x33333332, 0xb505, x3, 1704, x4)

inst_442:
// rs1_val==858993458 and rs2_val==-46339, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:-0xb503
TEST_RR_OP(mul, x12, x10, x11, 0x33340c6a, 0x33333332, -0xb503, x3, 1708, x4)

inst_443:
// rs1_val==858993458 and rs2_val==1717986919, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x66666667
TEST_RR_OP(mul, x12, x10, x11, 0x51eb851e, 0x33333332, 0x66666667, x3, 1712, x4)

inst_444:
// rs1_val==858993458 and rs2_val==858993460, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x33333334
TEST_RR_OP(mul, x12, x10, x11, 0xc28f5c28, 0x33333332, 0x33333334, x3, 1716, x4)

inst_445:
// rs1_val==858993458 and rs2_val==6, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x6
TEST_RR_OP(mul, x12, x10, x11, 0x3333332c, 0x33333332, 0x6, x3, 1720, x4)

inst_446:
// rs1_val==858993458 and rs2_val==-1431655765, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:-0x55555555
TEST_RR_OP(mul, x12, x10, x11, 0x66666666, 0x33333332, -0x55555555, x3, 1724, x4)

inst_447:
// rs1_val==858993458 and rs2_val==1431655766, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x55555556
TEST_RR_OP(mul, x12, x10, x11, 0xcccccccc, 0x33333332, 0x55555556, x3, 1728, x4)

inst_448:
// rs1_val==858993458 and rs2_val==4, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x4
TEST_RR_OP(mul, x12, x10, x11, 0xccccccc8, 0x33333332, 0x4, x3, 1732, x4)

inst_449:
// rs1_val==858993458 and rs2_val==46339, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0xb503
TEST_RR_OP(mul, x12, x10, x11, 0xcccbf396, 0x33333332, 0xb503, x3, 1736, x4)

inst_450:
// rs1_val==858993458 and rs2_val==0, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x0
TEST_RR_OP(mul, x12, x10, x11, 0x0, 0x33333332, 0x0, x3, 1740, x4)

inst_451:
// rs1_val==858993458 and rs2_val==1717986917, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x66666665
TEST_RR_OP(mul, x12, x10, x11, 0xeb851eba, 0x33333332, 0x66666665, x3, 1744, x4)

inst_452:
// rs1_val==858993458 and rs2_val==858993458, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x33333332
TEST_RR_OP(mul, x12, x10, x11, 0x5c28f5c4, 0x33333332, 0x33333332, x3, 1748, x4)

inst_453:
// rs1_val==858993458 and rs2_val==1431655764, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x55555554
TEST_RR_OP(mul, x12, x10, x11, 0x66666668, 0x33333332, 0x55555554, x3, 1752, x4)

inst_454:
// rs1_val==858993458 and rs2_val==2, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x2
TEST_RR_OP(mul, x12, x10, x11, 0x66666664, 0x33333332, 0x2, x3, 1756, x4)

inst_455:
// rs1_val==858993458 and rs2_val==46340, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0xb504
TEST_RR_OP(mul, x12, x10, x11, 0xffff26c8, 0x33333332, 0xb504, x3, 1760, x4)

inst_456:
// rs1_val==858993458 and rs2_val==-46340, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:-0xb504
TEST_RR_OP(mul, x12, x10, x11, 0xd938, 0x33333332, -0xb504, x3, 1764, x4)

inst_457:
// rs1_val==858993458 and rs2_val==1717986918, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x66666666
TEST_RR_OP(mul, x12, x10, x11, 0x1eb851ec, 0x33333332, 0x66666666, x3, 1768, x4)

inst_458:
// rs1_val==858993458 and rs2_val==858993459, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x33333333
TEST_RR_OP(mul, x12, x10, x11, 0x8f5c28f6, 0x33333332, 0x33333333, x3, 1772, x4)

inst_459:
// rs1_val==858993458 and rs2_val==5, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x5
TEST_RR_OP(mul, x12, x10, x11, 0xfffffffa, 0x33333332, 0x5, x3, 1776, x4)

inst_460:
// rs1_val==858993458 and rs2_val==-1431655766, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:-0x55555556
TEST_RR_OP(mul, x12, x10, x11, 0x33333334, 0x33333332, -0x55555556, x3, 1780, x4)

inst_461:
// rs1_val==858993458 and rs2_val==1431655765, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x55555555
TEST_RR_OP(mul, x12, x10, x11, 0x9999999a, 0x33333332, 0x55555555, x3, 1784, x4)

inst_462:
// rs1_val==858993458 and rs2_val==3, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x3
TEST_RR_OP(mul, x12, x10, x11, 0x99999996, 0x33333332, 0x3, x3, 1788, x4)

inst_463:
// rs1_val==1431655764 and rs2_val==46341, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0xb505
TEST_RR_OP(mul, x12, x10, x11, 0xffff0ea4, 0x55555554, 0xb505, x3, 1792, x4)

inst_464:
// rs1_val==1431655764 and rs2_val==-46339, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:-0xb503
TEST_RR_OP(mul, x12, x10, x11, 0xaaab9c04, 0x55555554, -0xb503, x3, 1796, x4)

inst_465:
// rs1_val==1431655764 and rs2_val==1717986919, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x66666667
TEST_RR_OP(mul, x12, x10, x11, 0xcccccccc, 0x55555554, 0x66666667, x3, 1800, x4)

inst_466:
// rs1_val==1431655764 and rs2_val==858993460, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x33333334
TEST_RR_OP(mul, x12, x10, x11, 0x11111110, 0x55555554, 0x33333334, x3, 1804, x4)

inst_467:
// rs1_val==1431655764 and rs2_val==6, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x6
TEST_RR_OP(mul, x12, x10, x11, 0xfffffff8, 0x55555554, 0x6, x3, 1808, x4)

inst_468:
// rs1_val==1431655764 and rs2_val==-1431655765, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:-0x55555555
TEST_RR_OP(mul, x12, x10, x11, 0x1c71c71c, 0x55555554, -0x55555555, x3, 1812, x4)

inst_469:
// rs1_val==1431655764 and rs2_val==1431655766, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x55555556
TEST_RR_OP(mul, x12, x10, x11, 0x38e38e38, 0x55555554, 0x55555556, x3, 1816, x4)

inst_470:
// rs1_val==1431655764 and rs2_val==4, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x4
TEST_RR_OP(mul, x12, x10, x11, 0x55555550, 0x55555554, 0x4, x3, 1820, x4)

inst_471:
// rs1_val==1431655764 and rs2_val==46339, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0xb503
TEST_RR_OP(mul, x12, x10, x11, 0x555463fc, 0x55555554, 0xb503, x3, 1824, x4)

inst_472:
// rs1_val==1431655764 and rs2_val==0, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x0
TEST_RR_OP(mul, x12, x10, x11, 0x0, 0x55555554, 0x0, x3, 1828, x4)

inst_473:
// rs1_val==1431655764 and rs2_val==1717986917, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x66666665
TEST_RR_OP(mul, x12, x10, x11, 0x22222224, 0x55555554, 0x66666665, x3, 1832, x4)

inst_474:
// rs1_val==1431655764 and rs2_val==858993458, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x33333332
TEST_RR_OP(mul, x12, x10, x11, 0x66666668, 0x55555554, 0x33333332, x3, 1836, x4)

inst_475:
// rs1_val==1431655764 and rs2_val==1431655764, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x55555554
TEST_RR_OP(mul, x12, x10, x11, 0x8e38e390, 0x55555554, 0x55555554, x3, 1840, x4)

inst_476:
// rs1_val==1431655764 and rs2_val==2, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x2
TEST_RR_OP(mul, x12, x10, x11, 0xaaaaaaa8, 0x55555554, 0x2, x3, 1844, x4)

inst_477:
// rs1_val==1431655764 and rs2_val==46340, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0xb504
TEST_RR_OP(mul, x12, x10, x11, 0xaaa9b950, 0x55555554, 0xb504, x3, 1848, x4)

inst_478:
// rs1_val==1431655764 and rs2_val==-46340, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:-0xb504
TEST_RR_OP(mul, x12, x10, x11, 0x555646b0, 0x55555554, -0xb504, x3, 1852, x4)

inst_479:
// rs1_val==1431655764 and rs2_val==1717986918, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x66666666
TEST_RR_OP(mul, x12, x10, x11, 0x77777778, 0x55555554, 0x66666666, x3, 1856, x4)

inst_480:
// rs1_val==1431655764 and rs2_val==858993459, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x33333333
TEST_RR_OP(mul, x12, x10, x11, 0xbbbbbbbc, 0x55555554, 0x33333333, x3, 1860, x4)

inst_481:
// rs1_val==1431655764 and rs2_val==5, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x5
TEST_RR_OP(mul, x12, x10, x11, 0xaaaaaaa4, 0x55555554, 0x5, x3, 1864, x4)

inst_482:
// rs1_val==1431655764 and rs2_val==-1431655766, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:-0x55555556
TEST_RR_OP(mul, x12, x10, x11, 0xc71c71c8, 0x55555554, -0x55555556, x3, 1868, x4)

inst_483:
// rs1_val==1431655764 and rs2_val==1431655765, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x55555555
TEST_RR_OP(mul, x12, x10, x11, 0xe38e38e4, 0x55555554, 0x55555555, x3, 1872, x4)

inst_484:
// rs1_val==1431655764 and rs2_val==3, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x3
TEST_RR_OP(mul, x12, x10, x11, 0xfffffffc, 0x55555554, 0x3, x3, 1876, x4)

inst_485:
// rs1_val==2 and rs2_val==46341, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0xb505
TEST_RR_OP(mul, x12, x10, x11, 0x16a0a, 0x2, 0xb505, x3, 1880, x4)

inst_486:
// rs1_val==2 and rs2_val==-46339, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:-0xb503
TEST_RR_OP(mul, x12, x10, x11, 0xfffe95fa, 0x2, -0xb503, x3, 1884, x4)

inst_487:
// rs1_val==2 and rs2_val==1717986919, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x66666667
TEST_RR_OP(mul, x12, x10, x11, 0xccccccce, 0x2, 0x66666667, x3, 1888, x4)

inst_488:
// rs1_val==2 and rs2_val==858993460, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x33333334
TEST_RR_OP(mul, x12, x10, x11, 0x66666668, 0x2, 0x33333334, x3, 1892, x4)

inst_489:
// rs1_val==2 and rs2_val==-1431655765, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:-0x55555555
TEST_RR_OP(mul, x12, x10, x11, 0x55555556, 0x2, -0x55555555, x3, 1896, x4)

inst_490:
// rs1_val==2 and rs2_val==1431655766, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x55555556
TEST_RR_OP(mul, x12, x10, x11, 0xaaaaaaac, 0x2, 0x55555556, x3, 1900, x4)

inst_491:
// rs1_val==2 and rs2_val==4, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x4
TEST_RR_OP(mul, x12, x10, x11, 0x8, 0x2, 0x4, x3, 1904, x4)

inst_492:
// rs1_val==2 and rs2_val==46339, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0xb503
TEST_RR_OP(mul, x12, x10, x11, 0x16a06, 0x2, 0xb503, x3, 1908, x4)

inst_493:
// rs1_val==2 and rs2_val==0, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x0
TEST_RR_OP(mul, x12, x10, x11, 0x0, 0x2, 0x0, x3, 1912, x4)

inst_494:
// rs1_val==2 and rs2_val==1717986917, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x66666665
TEST_RR_OP(mul, x12, x10, x11, 0xccccccca, 0x2, 0x66666665, x3, 1916, x4)

inst_495:
// rs1_val==2 and rs2_val==858993458, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x33333332
TEST_RR_OP(mul, x12, x10, x11, 0x66666664, 0x2, 0x33333332, x3, 1920, x4)

inst_496:
// rs1_val==2 and rs2_val==1431655764, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x55555554
TEST_RR_OP(mul, x12, x10, x11, 0xaaaaaaa8, 0x2, 0x55555554, x3, 1924, x4)

inst_497:
// rs1_val==2 and rs2_val==2, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x2
TEST_RR_OP(mul, x12, x10, x11, 0x4, 0x2, 0x2, x3, 1928, x4)

inst_498:
// rs1_val==2 and rs2_val==46340, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0xb504
TEST_RR_OP(mul, x12, x10, x11, 0x16a08, 0x2, 0xb504, x3, 1932, x4)

inst_499:
// rs1_val==2 and rs2_val==-46340, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:-0xb504
TEST_RR_OP(mul, x12, x10, x11, 0xfffe95f8, 0x2, -0xb504, x3, 1936, x4)

inst_500:
// rs1_val==2 and rs2_val==1717986918, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x66666666
TEST_RR_OP(mul, x12, x10, x11, 0xcccccccc, 0x2, 0x66666666, x3, 1940, x4)

inst_501:
// rs1_val==2 and rs2_val==858993459, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x33333333
TEST_RR_OP(mul, x12, x10, x11, 0x66666666, 0x2, 0x33333333, x3, 1944, x4)

inst_502:
// rs1_val==2 and rs2_val==5, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x5
TEST_RR_OP(mul, x12, x10, x11, 0xa, 0x2, 0x5, x3, 1948, x4)

inst_503:
// rs1_val==2 and rs2_val==-1431655766, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:-0x55555556
TEST_RR_OP(mul, x12, x10, x11, 0x55555554, 0x2, -0x55555556, x3, 1952, x4)

inst_504:
// rs1_val==2 and rs2_val==1431655765, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x55555555
TEST_RR_OP(mul, x12, x10, x11, 0xaaaaaaaa, 0x2, 0x55555555, x3, 1956, x4)

inst_505:
// rs1_val==2 and rs2_val==3, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x3
TEST_RR_OP(mul, x12, x10, x11, 0x6, 0x2, 0x3, x3, 1960, x4)

inst_506:
// rs1_val==46340 and rs2_val==46341, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0xb505
TEST_RR_OP(mul, x12, x10, x11, 0x7fff5d14, 0xb504, 0xb505, x3, 1964, x4)

inst_507:
// rs1_val==46340 and rs2_val==-46339, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:-0xb503
TEST_RR_OP(mul, x12, x10, x11, 0x80020cf4, 0xb504, -0xb503, x3, 1968, x4)

inst_508:
// rs1_val==46340 and rs2_val==1717986919, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x66666667
TEST_RR_OP(mul, x12, x10, x11, 0x6c9c, 0xb504, 0x66666667, x3, 1972, x4)

inst_509:
// rs1_val==46340 and rs2_val==858993460, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x33333334
TEST_RR_OP(mul, x12, x10, x11, 0x90d0, 0xb504, 0x33333334, x3, 1976, x4)

inst_510:
// rs1_val==46340 and rs2_val==6, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x6
TEST_RR_OP(mul, x12, x10, x11, 0x43e18, 0xb504, 0x6, x3, 1980, x4)

inst_511:
// rs1_val==46340 and rs2_val==-1431655765, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:-0x55555555
TEST_RR_OP(mul, x12, x10, x11, 0x555591ac, 0xb504, -0x55555555, x3, 1984, x4)

inst_512:
// rs1_val==46340 and rs2_val==1431655766, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x55555556
TEST_RR_OP(mul, x12, x10, x11, 0xaaab2358, 0xb504, 0x55555556, x3, 1988, x4)

inst_513:
// rs1_val==46340 and rs2_val==4, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x4
TEST_RR_OP(mul, x12, x10, x11, 0x2d410, 0xb504, 0x4, x3, 1992, x4)

inst_514:
// rs1_val==46340 and rs2_val==46339, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0xb503
TEST_RR_OP(mul, x12, x10, x11, 0x7ffdf30c, 0xb504, 0xb503, x3, 1996, x4)

inst_515:
// rs1_val==46340 and rs2_val==0, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x0
TEST_RR_OP(mul, x12, x10, x11, 0x0, 0xb504, 0x0, x3, 2000, x4)

inst_516:
// rs1_val==46340 and rs2_val==1717986917, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x66666665
TEST_RR_OP(mul, x12, x10, x11, 0xffff0294, 0xb504, 0x66666665, x3, 2004, x4)

inst_517:
// rs1_val==46340 and rs2_val==858993458, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x33333332
TEST_RR_OP(mul, x12, x10, x11, 0xffff26c8, 0xb504, 0x33333332, x3, 2008, x4)

inst_518:
// rs1_val==46340 and rs2_val==1431655764, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x55555554
TEST_RR_OP(mul, x12, x10, x11, 0xaaa9b950, 0xb504, 0x55555554, x3, 2012, x4)

inst_519:
// rs1_val==46340 and rs2_val==2, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x2
TEST_RR_OP(mul, x12, x10, x11, 0x16a08, 0xb504, 0x2, x3, 2016, x4)

inst_520:
// rs1_val==46340 and rs2_val==46340, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0xb504
TEST_RR_OP(mul, x12, x10, x11, 0x7ffea810, 0xb504, 0xb504, x3, 2020, x4)

inst_521:
// rs1_val==46340 and rs2_val==-46340, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:-0xb504
TEST_RR_OP(mul, x12, x10, x11, 0x800157f0, 0xb504, -0xb504, x3, 2024, x4)

inst_522:
// rs1_val==46340 and rs2_val==1717986918, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x66666666
TEST_RR_OP(mul, x12, x10, x11, 0xffffb798, 0xb504, 0x66666666, x3, 2028, x4)

inst_523:
// rs1_val==46340 and rs2_val==858993459, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x33333333
TEST_RR_OP(mul, x12, x10, x11, 0xffffdbcc, 0xb504, 0x33333333, x3, 2032, x4)

inst_524:
// rs1_val==46340 and rs2_val==5, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x5
TEST_RR_OP(mul, x12, x10, x11, 0x38914, 0xb504, 0x5, x3, 2036, x4)

inst_525:
// rs1_val==46340 and rs2_val==-1431655766, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:-0x55555556
TEST_RR_OP(mul, x12, x10, x11, 0x5554dca8, 0xb504, -0x55555556, x3, 2040, x4)

inst_526:
// rs1_val==46340 and rs2_val==1431655765, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x55555555
TEST_RR_OP(mul, x12, x10, x11, 0xaaaa6e54, 0xb504, 0x55555555, x3, 2044, x4)
RVTEST_SIGBASE( x3,signature_x3_1)

inst_527:
// rs1_val==46340 and rs2_val==3, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x3
TEST_RR_OP(mul, x12, x10, x11, 0x21f0c, 0xb504, 0x3, x3, 0, x4)

inst_528:
// rs1_val==-46340 and rs2_val==46341, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0xb505
TEST_RR_OP(mul, x12, x10, x11, 0x8000a2ec, -0xb504, 0xb505, x3, 4, x4)

inst_529:
// rs1_val==-46340 and rs2_val==-46339, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:-0xb503
TEST_RR_OP(mul, x12, x10, x11, 0x7ffdf30c, -0xb504, -0xb503, x3, 8, x4)

inst_530:
// rs1_val==-46340 and rs2_val==1717986919, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x66666667
TEST_RR_OP(mul, x12, x10, x11, 0xffff9364, -0xb504, 0x66666667, x3, 12, x4)

inst_531:
// rs1_val==-46340 and rs2_val==858993460, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x33333334
TEST_RR_OP(mul, x12, x10, x11, 0xffff6f30, -0xb504, 0x33333334, x3, 16, x4)

inst_532:
// rs1_val==-46340 and rs2_val==6, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x6
TEST_RR_OP(mul, x12, x10, x11, 0xfffbc1e8, -0xb504, 0x6, x3, 20, x4)

inst_533:
// rs1_val==-46340 and rs2_val==-1431655765, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:-0x55555555
TEST_RR_OP(mul, x12, x10, x11, 0xaaaa6e54, -0xb504, -0x55555555, x3, 24, x4)

inst_534:
// rs1_val==-46340 and rs2_val==1431655766, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x55555556
TEST_RR_OP(mul, x12, x10, x11, 0x5554dca8, -0xb504, 0x55555556, x3, 28, x4)

inst_535:
// rs1_val==-46340 and rs2_val==4, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x4
TEST_RR_OP(mul, x12, x10, x11, 0xfffd2bf0, -0xb504, 0x4, x3, 32, x4)

inst_536:
// rs1_val==-46340 and rs2_val==46339, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0xb503
TEST_RR_OP(mul, x12, x10, x11, 0x80020cf4, -0xb504, 0xb503, x3, 36, x4)

inst_537:
// rs1_val==-46340 and rs2_val==0, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x0
TEST_RR_OP(mul, x12, x10, x11, 0x0, -0xb504, 0x0, x3, 40, x4)

inst_538:
// rs1_val==-46340 and rs2_val==1717986917, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x66666665
TEST_RR_OP(mul, x12, x10, x11, 0xfd6c, -0xb504, 0x66666665, x3, 44, x4)

inst_539:
// rs1_val==-46340 and rs2_val==858993458, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x33333332
TEST_RR_OP(mul, x12, x10, x11, 0xd938, -0xb504, 0x33333332, x3, 48, x4)

inst_540:
// rs1_val==-46340 and rs2_val==1431655764, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x55555554
TEST_RR_OP(mul, x12, x10, x11, 0x555646b0, -0xb504, 0x55555554, x3, 52, x4)

inst_541:
// rs1_val==-46340 and rs2_val==2, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x2
TEST_RR_OP(mul, x12, x10, x11, 0xfffe95f8, -0xb504, 0x2, x3, 56, x4)

inst_542:
// rs1_val==-46340 and rs2_val==46340, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0xb504
TEST_RR_OP(mul, x12, x10, x11, 0x800157f0, -0xb504, 0xb504, x3, 60, x4)

inst_543:
// rs1_val==-46340 and rs2_val==-46340, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:-0xb504
TEST_RR_OP(mul, x12, x10, x11, 0x7ffea810, -0xb504, -0xb504, x3, 64, x4)

inst_544:
// rs1_val==-46340 and rs2_val==1717986918, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x66666666
TEST_RR_OP(mul, x12, x10, x11, 0x4868, -0xb504, 0x66666666, x3, 68, x4)

inst_545:
// rs1_val==-46340 and rs2_val==858993459, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x33333333
TEST_RR_OP(mul, x12, x10, x11, 0x2434, -0xb504, 0x33333333, x3, 72, x4)

inst_546:
// rs1_val==-46340 and rs2_val==5, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x5
TEST_RR_OP(mul, x12, x10, x11, 0xfffc76ec, -0xb504, 0x5, x3, 76, x4)

inst_547:
// rs1_val==-46340 and rs2_val==-1431655766, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:-0x55555556
TEST_RR_OP(mul, x12, x10, x11, 0xaaab2358, -0xb504, -0x55555556, x3, 80, x4)

inst_548:
// rs1_val==-46340 and rs2_val==1431655765, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x55555555
TEST_RR_OP(mul, x12, x10, x11, 0x555591ac, -0xb504, 0x55555555, x3, 84, x4)

inst_549:
// rs1_val==-46340 and rs2_val==3, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x3
TEST_RR_OP(mul, x12, x10, x11, 0xfffde0f4, -0xb504, 0x3, x3, 88, x4)

inst_550:
// rs1_val==1717986918 and rs2_val==46341, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0xb505
TEST_RR_OP(mul, x12, x10, x11, 0x66661dfe, 0x66666666, 0xb505, x3, 92, x4)

inst_551:
// rs1_val==1717986918 and rs2_val==-46339, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:-0xb503
TEST_RR_OP(mul, x12, x10, x11, 0x6666aece, 0x66666666, -0xb503, x3, 96, x4)

inst_552:
// rs1_val==1717986918 and rs2_val==1717986919, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x66666667
TEST_RR_OP(mul, x12, x10, x11, 0x70a3d70a, 0x66666666, 0x66666667, x3, 100, x4)

inst_553:
// rs1_val==1717986918 and rs2_val==858993460, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x33333334
TEST_RR_OP(mul, x12, x10, x11, 0xeb851eb8, 0x66666666, 0x33333334, x3, 104, x4)

inst_554:
// rs1_val==1717986918 and rs2_val==6, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x6
TEST_RR_OP(mul, x12, x10, x11, 0x66666664, 0x66666666, 0x6, x3, 108, x4)

inst_555:
// rs1_val==1717986918 and rs2_val==-1431655765, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:-0x55555555
TEST_RR_OP(mul, x12, x10, x11, 0x22222222, 0x66666666, -0x55555555, x3, 112, x4)

inst_556:
// rs1_val==1717986918 and rs2_val==1431655766, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x55555556
TEST_RR_OP(mul, x12, x10, x11, 0x44444444, 0x66666666, 0x55555556, x3, 116, x4)

inst_557:
// rs1_val==1717986918 and rs2_val==4, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x4
TEST_RR_OP(mul, x12, x10, x11, 0x99999998, 0x66666666, 0x4, x3, 120, x4)

inst_558:
// rs1_val==1717986918 and rs2_val==46339, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0xb503
TEST_RR_OP(mul, x12, x10, x11, 0x99995132, 0x66666666, 0xb503, x3, 124, x4)

inst_559:
// rs1_val==1717986918 and rs2_val==0, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x0
TEST_RR_OP(mul, x12, x10, x11, 0x0, 0x66666666, 0x0, x3, 128, x4)

inst_560:
// rs1_val==1717986918 and rs2_val==1717986917, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x66666665
TEST_RR_OP(mul, x12, x10, x11, 0xa3d70a3e, 0x66666666, 0x66666665, x3, 132, x4)

inst_561:
// rs1_val==1717986918 and rs2_val==858993458, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x33333332
TEST_RR_OP(mul, x12, x10, x11, 0x1eb851ec, 0x66666666, 0x33333332, x3, 136, x4)

inst_562:
// rs1_val==1717986918 and rs2_val==1431655764, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x55555554
TEST_RR_OP(mul, x12, x10, x11, 0x77777778, 0x66666666, 0x55555554, x3, 140, x4)

inst_563:
// rs1_val==1717986918 and rs2_val==2, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x2
TEST_RR_OP(mul, x12, x10, x11, 0xcccccccc, 0x66666666, 0x2, x3, 144, x4)

inst_564:
// rs1_val==1717986918 and rs2_val==46340, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0xb504
TEST_RR_OP(mul, x12, x10, x11, 0xffffb798, 0x66666666, 0xb504, x3, 148, x4)

inst_565:
// rs1_val==1717986918 and rs2_val==-46340, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:-0xb504
TEST_RR_OP(mul, x12, x10, x11, 0x4868, 0x66666666, -0xb504, x3, 152, x4)

inst_566:
// rs1_val==1717986918 and rs2_val==1717986918, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x66666666
TEST_RR_OP(mul, x12, x10, x11, 0xa3d70a4, 0x66666666, 0x66666666, x3, 156, x4)

inst_567:
// rs1_val==1717986918 and rs2_val==858993459, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x33333333
TEST_RR_OP(mul, x12, x10, x11, 0x851eb852, 0x66666666, 0x33333333, x3, 160, x4)

inst_568:
// rs1_val==1717986918 and rs2_val==5, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x5
TEST_RR_OP(mul, x12, x10, x11, 0xfffffffe, 0x66666666, 0x5, x3, 164, x4)

inst_569:
// rs1_val==1717986918 and rs2_val==-1431655766, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:-0x55555556
TEST_RR_OP(mul, x12, x10, x11, 0xbbbbbbbc, 0x66666666, -0x55555556, x3, 168, x4)

inst_570:
// rs1_val==1717986918 and rs2_val==1431655765, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x55555555
TEST_RR_OP(mul, x12, x10, x11, 0xddddddde, 0x66666666, 0x55555555, x3, 172, x4)

inst_571:
// rs1_val==1717986918 and rs2_val==3, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x3
TEST_RR_OP(mul, x12, x10, x11, 0x33333332, 0x66666666, 0x3, x3, 176, x4)

inst_572:
// rs1_val==858993459 and rs2_val==46341, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0xb505
TEST_RR_OP(mul, x12, x10, x11, 0x33330eff, 0x33333333, 0xb505, x3, 180, x4)

inst_573:
// rs1_val==858993459 and rs2_val==-46339, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:-0xb503
TEST_RR_OP(mul, x12, x10, x11, 0x33335767, 0x33333333, -0xb503, x3, 184, x4)

inst_574:
// rs1_val==858993459 and rs2_val==1717986919, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x66666667
TEST_RR_OP(mul, x12, x10, x11, 0xb851eb85, 0x33333333, 0x66666667, x3, 188, x4)

inst_575:
// rs1_val==858993459 and rs2_val==858993460, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x33333334
TEST_RR_OP(mul, x12, x10, x11, 0xf5c28f5c, 0x33333333, 0x33333334, x3, 192, x4)

inst_576:
// rs1_val==858993459 and rs2_val==6, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x6
TEST_RR_OP(mul, x12, x10, x11, 0x33333332, 0x33333333, 0x6, x3, 196, x4)

inst_577:
// rs1_val==858993459 and rs2_val==-1431655765, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:-0x55555555
TEST_RR_OP(mul, x12, x10, x11, 0x11111111, 0x33333333, -0x55555555, x3, 200, x4)

inst_578:
// rs1_val==858993459 and rs2_val==1431655766, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x55555556
TEST_RR_OP(mul, x12, x10, x11, 0x22222222, 0x33333333, 0x55555556, x3, 204, x4)

inst_579:
// rs1_val==858993459 and rs2_val==4, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x4
TEST_RR_OP(mul, x12, x10, x11, 0xcccccccc, 0x33333333, 0x4, x3, 208, x4)

inst_580:
// rs1_val==858993459 and rs2_val==46339, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0xb503
TEST_RR_OP(mul, x12, x10, x11, 0xcccca899, 0x33333333, 0xb503, x3, 212, x4)

inst_581:
// rs2_val == -1073741825, rs1_val == 134217728
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x8000000;  op2val:-0x40000001
TEST_RR_OP(mul, x12, x10, x11, 0xf8000000, 0x8000000, -0x40000001, x3, 216, x4)

inst_582:
// rs2_val == -536870913, rs1_val == 8
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x8;  op2val:-0x20000001
TEST_RR_OP(mul, x12, x10, x11, 0xfffffff8, 0x8, -0x20000001, x3, 220, x4)

inst_583:
// rs2_val == -8388609, 
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x9;  op2val:-0x800001
TEST_RR_OP(mul, x12, x10, x11, 0xfb7ffff7, 0x9, -0x800001, x3, 224, x4)

inst_584:
// rs2_val == -4194305, rs1_val == 32
// opcode: mul ; op1:x10; op2:x11; dest:x12; op1val:0x20;  op2val:-0x400001
TEST_RR_OP(mul, x12, x10, x11, 0xf7ffffe0, 0x20, -0x400001, x3, 228, x4)
#endif


RVTEST_CODE_END
RVMODEL_HALT

RVTEST_DATA_BEGIN
.align 4

rvtest_data:
.word 0xbabecafe
.word 0xbabecafe
.word 0xbabecafe
.word 0xbabecafe
RVTEST_DATA_END


RVMODEL_DATA_BEGIN
rvtest_sig_begin:
sig_begin_canary:
CANARY;


signature_x2_0:
    .fill 0*(XLEN/32),4,0xdeadbeef


signature_x2_1:
    .fill 7*(XLEN/32),4,0xdeadbeef


signature_x1_0:
    .fill 8*(XLEN/32),4,0xdeadbeef


signature_x3_0:
    .fill 512*(XLEN/32),4,0xdeadbeef


signature_x3_1:
    .fill 58*(XLEN/32),4,0xdeadbeef

#ifdef rvtest_mtrap_routine

tsig_begin_canary:
CANARY;
mtrap_sigptr:
    .fill 64*(XLEN/32),4,0xdeadbeef
tsig_end_canary:
CANARY;

#endif

#ifdef rvtest_gpr_save

gpr_save:
    .fill 32*(XLEN/32),4,0xdeadbeef

#endif

sig_end_canary:
CANARY;
rvtest_sig_end:
RVMODEL_DATA_END
