
// -----------
// This file was generated by riscv_ctg (https://gitlab.com/incoresemi/riscv-compliance/riscv_ctg)
// version   : 0.4.1
// timestamp : Tue Dec 15 15:36:11 2020 GMT
// usage     : riscv_ctg \
//                  -- cgf ('/scratch/git-repo/incoresemi/riscv-compliance/riscv_ctg/sample_cgfs/dataset.cgf', '/scratch/git-repo/incoresemi/riscv-compliance/riscv_ctg/sample_cgfs/rv32i.cgf') \
//                  -- xlen 32 \
// -----------
//
// -----------
// Copyright (c) 2020. RISC-V International. All rights reserved.
// SPDX-License-Identifier: BSD-3-Clause
// -----------
//
// This assembly file tests the and instruction of the RISC-V I extension for the and covergroup.
// 
#include "model_test.h"
#include "arch_test.h"
RVTEST_ISA("RV32I")

.section .text.init
.org 0x80
.globl rvtest_entry_point
rvtest_entry_point:
RVMODEL_BOOT
RVTEST_CODE_BEGIN

#ifdef TEST_CASE_1

RVTEST_CASE(0,"//check ISA:=regex(.*32.*);check ISA:=regex(.*I.*);def TEST_CASE_1=True;",and)

RVTEST_SIGBASE( x6,signature_x6_1)

inst_0:
// rs2 == rd != rs1, rs1==x24, rs2==x25, rd==x25, rs1_val > 0 and rs2_val > 0, rs1_val == 16384, rs1_val != rs2_val
// opcode: and ; op1:x24; op2:x25; dest:x25; op1val:0x4000;  op2val:0x7
TEST_RR_OP(and, x25, x24, x25, 0x0, 0x4000, 0x7, x6, 0, x8)

inst_1:
// rs1 == rs2 != rd, rs1==x3, rs2==x3, rd==x18, rs1_val > 0 and rs2_val < 0, rs1_val == 2048, rs2_val == -1048577
// opcode: and ; op1:x3; op2:x3; dest:x18; op1val:0x800;  op2val:0x800
TEST_RR_OP(and, x18, x3, x3, 0x800, 0x800, 0x800, x6, 4, x8)

inst_2:
// rs1 == rs2 == rd, rs1==x19, rs2==x19, rd==x19, rs1_val < 0 and rs2_val < 0, rs1_val == -3
// opcode: and ; op1:x19; op2:x19; dest:x19; op1val:-0x3;  op2val:-0x3
TEST_RR_OP(and, x19, x19, x19, 0xfffffffd, -0x3, -0x3, x6, 8, x8)

inst_3:
// rs1 == rd != rs2, rs1==x5, rs2==x14, rd==x5, rs1_val < 0 and rs2_val > 0, rs2_val == (2**(xlen-1)-1), rs2_val == 2147483647
// opcode: and ; op1:x5; op2:x14; dest:x5; op1val:-0x1;  op2val:0x7fffffff
TEST_RR_OP(and, x5, x5, x14, 0x7fffffff, -0x1, 0x7fffffff, x6, 12, x8)

inst_4:
// rs1 != rs2  and rs1 != rd and rs2 != rd, rs1==x23, rs2==x16, rd==x20, rs1_val == rs2_val, rs1_val==5 and rs2_val==5
// opcode: and ; op1:x23; op2:x16; dest:x20; op1val:0x5;  op2val:0x5
TEST_RR_OP(and, x20, x23, x16, 0x5, 0x5, 0x5, x6, 16, x8)

inst_5:
// rs1==x20, rs2==x2, rd==x30, rs2_val == (-2**(xlen-1)), rs2_val == -2147483648, rs1_val == 2
// opcode: and ; op1:x20; op2:x2; dest:x30; op1val:0x2;  op2val:-0x80000000
TEST_RR_OP(and, x30, x20, x2, 0x0, 0x2, -0x80000000, x6, 20, x8)

inst_6:
// rs1==x7, rs2==x24, rd==x13, rs2_val == 0, rs1_val==858993459 and rs2_val==0
// opcode: and ; op1:x7; op2:x24; dest:x13; op1val:0x33333333;  op2val:0x0
TEST_RR_OP(and, x13, x7, x24, 0x0, 0x33333333, 0x0, x6, 24, x8)

inst_7:
// rs1==x30, rs2==x27, rd==x10, rs2_val == 1, rs1_val == -1073741825
// opcode: and ; op1:x30; op2:x27; dest:x10; op1val:-0x40000001;  op2val:0x1
TEST_RR_OP(and, x10, x30, x27, 0x1, -0x40000001, 0x1, x6, 28, x8)

inst_8:
// rs1==x28, rs2==x18, rd==x22, rs1_val == (-2**(xlen-1)), rs2_val == 2048, rs1_val == -2147483648
// opcode: and ; op1:x28; op2:x18; dest:x22; op1val:-0x80000000;  op2val:0x800
TEST_RR_OP(and, x22, x28, x18, 0x0, -0x80000000, 0x800, x6, 32, x8)

inst_9:
// rs1==x2, rs2==x15, rd==x0, rs1_val == 0, rs2_val == 512
// opcode: and ; op1:x2; op2:x15; dest:x0; op1val:0x0;  op2val:0x200
TEST_RR_OP(and, x0, x2, x15, 0, 0x0, 0x200, x6, 36, x8)

inst_10:
// rs1==x25, rs2==x26, rd==x12, rs1_val == (2**(xlen-1)-1), rs2_val == 1431655765, rs1_val == 2147483647
// opcode: and ; op1:x25; op2:x26; dest:x12; op1val:0x7fffffff;  op2val:0x55555555
TEST_RR_OP(and, x12, x25, x26, 0x55555555, 0x7fffffff, 0x55555555, x6, 40, x8)

inst_11:
// rs1==x1, rs2==x31, rd==x2, rs1_val == 1, 
// opcode: and ; op1:x1; op2:x31; dest:x2; op1val:0x1;  op2val:0x55555554
TEST_RR_OP(and, x2, x1, x31, 0x0, 0x1, 0x55555554, x6, 44, x8)

inst_12:
// rs1==x27, rs2==x11, rd==x14, rs2_val == 2, rs1_val == 262144
// opcode: and ; op1:x27; op2:x11; dest:x14; op1val:0x40000;  op2val:0x2
TEST_RR_OP(and, x14, x27, x11, 0x0, 0x40000, 0x2, x6, 48, x8)

inst_13:
// rs1==x31, rs2==x23, rd==x4, rs2_val == 4, rs1_val == -131073
// opcode: and ; op1:x31; op2:x23; dest:x4; op1val:-0x20001;  op2val:0x4
TEST_RR_OP(and, x4, x31, x23, 0x4, -0x20001, 0x4, x6, 52, x8)

inst_14:
// rs1==x21, rs2==x9, rd==x27, rs2_val == 8, 
// opcode: and ; op1:x21; op2:x9; dest:x27; op1val:-0x55555555;  op2val:0x8
TEST_RR_OP(and, x27, x21, x9, 0x8, -0x55555555, 0x8, x6, 56, x8)

inst_15:
// rs1==x26, rs2==x7, rd==x23, rs2_val == 16, rs1_val == 1024
// opcode: and ; op1:x26; op2:x7; dest:x23; op1val:0x400;  op2val:0x10
TEST_RR_OP(and, x23, x26, x7, 0x0, 0x400, 0x10, x6, 60, x19)

inst_16:
// rs1==x9, rs2==x20, rd==x24, rs2_val == 32, 
// opcode: and ; op1:x9; op2:x20; dest:x24; op1val:-0x8;  op2val:0x20
TEST_RR_OP(and, x24, x9, x20, 0x20, -0x8, 0x20, x6, 64, x19)

inst_17:
// rs1==x15, rs2==x13, rd==x26, rs2_val == 64, rs1_val == -257
// opcode: and ; op1:x15; op2:x13; dest:x26; op1val:-0x101;  op2val:0x40
TEST_RR_OP(and, x26, x15, x13, 0x40, -0x101, 0x40, x6, 68, x19)

inst_18:
// rs1==x12, rs2==x4, rd==x17, rs2_val == 128, rs1_val == -33554433
// opcode: and ; op1:x12; op2:x4; dest:x17; op1val:-0x2000001;  op2val:0x80
TEST_RR_OP(and, x17, x12, x4, 0x80, -0x2000001, 0x80, x6, 72, x19)
RVTEST_SIGBASE( x2,signature_x2_0)

inst_19:
// rs1==x4, rs2==x17, rd==x8, rs2_val == 256, 
// opcode: and ; op1:x4; op2:x17; dest:x8; op1val:0x66666665;  op2val:0x100
TEST_RR_OP(and, x8, x4, x17, 0x0, 0x66666665, 0x100, x2, 0, x19)

inst_20:
// rs1==x13, rs2==x22, rd==x1, rs2_val == 1024, rs1_val == -129
// opcode: and ; op1:x13; op2:x22; dest:x1; op1val:-0x81;  op2val:0x400
TEST_RR_OP(and, x1, x13, x22, 0x400, -0x81, 0x400, x2, 4, x19)

inst_21:
// rs1==x8, rs2==x12, rd==x7, rs2_val == 4096, rs1_val == 4
// opcode: and ; op1:x8; op2:x12; dest:x7; op1val:0x4;  op2val:0x1000
TEST_RR_OP(and, x7, x8, x12, 0x0, 0x4, 0x1000, x2, 8, x19)

inst_22:
// rs1==x11, rs2==x5, rd==x21, rs2_val == 8192, rs1_val == -32769
// opcode: and ; op1:x11; op2:x5; dest:x21; op1val:-0x8001;  op2val:0x2000
TEST_RR_OP(and, x21, x11, x5, 0x2000, -0x8001, 0x2000, x2, 12, x19)

inst_23:
// rs1==x14, rs2==x21, rd==x29, rs2_val == 16384, rs1_val == 64
// opcode: and ; op1:x14; op2:x21; dest:x29; op1val:0x40;  op2val:0x4000
TEST_RR_OP(and, x29, x14, x21, 0x0, 0x40, 0x4000, x2, 16, x19)

inst_24:
// rs1==x17, rs2==x10, rd==x11, rs2_val == 32768, 
// opcode: and ; op1:x17; op2:x10; dest:x11; op1val:0x5;  op2val:0x8000
TEST_RR_OP(and, x11, x17, x10, 0x0, 0x5, 0x8000, x2, 20, x19)

inst_25:
// rs1==x22, rs2==x6, rd==x3, rs2_val == 65536, rs1_val == 8388608
// opcode: and ; op1:x22; op2:x6; dest:x3; op1val:0x800000;  op2val:0x10000
TEST_RR_OP(and, x3, x22, x6, 0x0, 0x800000, 0x10000, x2, 24, x19)

inst_26:
// rs1==x0, rs2==x29, rd==x9, rs2_val == 131072, 
// opcode: and ; op1:x0; op2:x29; dest:x9; op1val:0x0;  op2val:0x20000
TEST_RR_OP(and, x9, x0, x29, 0x0, 0x0, 0x20000, x2, 28, x19)

inst_27:
// rs1==x29, rs2==x30, rd==x28, rs2_val == 262144, 
// opcode: and ; op1:x29; op2:x30; dest:x28; op1val:0x5;  op2val:0x40000
TEST_RR_OP(and, x28, x29, x30, 0x0, 0x5, 0x40000, x2, 32, x19)

inst_28:
// rs1==x18, rs2==x1, rd==x6, rs2_val == 524288, rs1_val == 65536
// opcode: and ; op1:x18; op2:x1; dest:x6; op1val:0x10000;  op2val:0x80000
TEST_RR_OP(and, x6, x18, x1, 0x0, 0x10000, 0x80000, x2, 36, x19)

inst_29:
// rs1==x6, rs2==x0, rd==x31, rs2_val == 1048576, rs1_val == 134217728
// opcode: and ; op1:x6; op2:x0; dest:x31; op1val:0x8000000;  op2val:0x0
TEST_RR_OP(and, x31, x6, x0, 0x0, 0x8000000, 0x0, x2, 40, x19)

inst_30:
// rs1==x16, rs2==x8, rd==x15, rs2_val == 2097152, 
// opcode: and ; op1:x16; op2:x8; dest:x15; op1val:-0x3;  op2val:0x200000
TEST_RR_OP(and, x15, x16, x8, 0x200000, -0x3, 0x200000, x2, 44, x19)

inst_31:
// rs1==x10, rs2==x28, rd==x16, rs2_val == 4194304, 
// opcode: and ; op1:x10; op2:x28; dest:x16; op1val:0x800;  op2val:0x400000
TEST_RR_OP(and, x16, x10, x28, 0x0, 0x800, 0x400000, x2, 48, x1)

inst_32:
// rs2_val == 8388608, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x800000
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x66666666, 0x800000, x2, 52, x1)

inst_33:
// rs2_val == 16777216, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x1000000
TEST_RR_OP(and, x12, x10, x11, 0x1000000, 0x33333333, 0x1000000, x2, 56, x1)

inst_34:
// rs2_val == 33554432, rs1_val == 1431655765
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x2000000
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x55555555, 0x2000000, x2, 60, x1)

inst_35:
// rs2_val == 67108864, rs1_val == 131072
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x20000;  op2val:0x4000000
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x20000, 0x4000000, x2, 64, x1)

inst_36:
// rs2_val == 134217728, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x8001;  op2val:0x8000000
TEST_RR_OP(and, x12, x10, x11, 0x8000000, -0x8001, 0x8000000, x2, 68, x1)

inst_37:
// rs2_val == 268435456, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x10000000
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x66666666, 0x10000000, x2, 72, x1)

inst_38:
// rs2_val == 536870912, rs1_val == -65537
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x10001;  op2val:0x20000000
TEST_RR_OP(and, x12, x10, x11, 0x20000000, -0x10001, 0x20000000, x2, 76, x1)

inst_39:
// rs2_val == 1073741824, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x8000000;  op2val:0x40000000
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x8000000, 0x40000000, x2, 80, x1)

inst_40:
// rs2_val == -2, rs1_val == -513
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x201;  op2val:-0x2
TEST_RR_OP(and, x12, x10, x11, 0xfffffdfe, -0x201, -0x2, x2, 84, x1)

inst_41:
// rs2_val == -3, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x40000001;  op2val:-0x3
TEST_RR_OP(and, x12, x10, x11, 0xbffffffd, -0x40000001, -0x3, x2, 88, x1)

inst_42:
// rs2_val == -5, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x800000;  op2val:-0x5
TEST_RR_OP(and, x12, x10, x11, 0x800000, 0x800000, -0x5, x2, 92, x1)

inst_43:
// rs2_val == -9, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x201;  op2val:-0x9
TEST_RR_OP(and, x12, x10, x11, 0xfffffdf7, -0x201, -0x9, x2, 96, x1)

inst_44:
// rs2_val == -17, rs1_val == -134217729
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x8000001;  op2val:-0x11
TEST_RR_OP(and, x12, x10, x11, 0xf7ffffef, -0x8000001, -0x11, x2, 100, x1)

inst_45:
// rs2_val == -33, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:-0x21
TEST_RR_OP(and, x12, x10, x11, 0x3, 0x3, -0x21, x2, 104, x1)

inst_46:
// rs2_val == -65, rs1_val == 128
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x80;  op2val:-0x41
TEST_RR_OP(and, x12, x10, x11, 0x80, 0x80, -0x41, x2, 108, x1)

inst_47:
// rs2_val == -129, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x7;  op2val:-0x81
TEST_RR_OP(and, x12, x10, x11, 0xffffff79, -0x7, -0x81, x2, 112, x1)

inst_48:
// rs2_val == -257, rs1_val == -9
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x9;  op2val:-0x101
TEST_RR_OP(and, x12, x10, x11, 0xfffffef7, -0x9, -0x101, x2, 116, x1)

inst_49:
// rs2_val == -513, rs1_val == -1431655766
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:-0x201
TEST_RR_OP(and, x12, x10, x11, 0xaaaaa8aa, -0x55555556, -0x201, x2, 120, x1)

inst_50:
// rs2_val == -1025, rs1_val == -8388609
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x800001;  op2val:-0x401
TEST_RR_OP(and, x12, x10, x11, 0xff7ffbff, -0x800001, -0x401, x2, 124, x1)

inst_51:
// rs2_val == -2049, rs1_val == -1048577
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x100001;  op2val:-0x801
TEST_RR_OP(and, x12, x10, x11, 0xffeff7ff, -0x100001, -0x801, x2, 128, x1)

inst_52:
// rs2_val == -4097, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x400;  op2val:-0x1001
TEST_RR_OP(and, x12, x10, x11, 0x400, 0x400, -0x1001, x2, 132, x1)

inst_53:
// rs2_val == -8193, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:-0x2001
TEST_RR_OP(and, x12, x10, x11, 0x66664666, 0x66666666, -0x2001, x2, 136, x1)

inst_54:
// rs2_val == -16385, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x7;  op2val:-0x4001
TEST_RR_OP(and, x12, x10, x11, 0x7, 0x7, -0x4001, x2, 140, x1)

inst_55:
// rs2_val == -32769, rs1_val == 33554432
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x2000000;  op2val:-0x8001
TEST_RR_OP(and, x12, x10, x11, 0x2000000, 0x2000000, -0x8001, x2, 144, x1)

inst_56:
// rs2_val == -65537, rs1_val == 1073741824
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x40000000;  op2val:-0x10001
TEST_RR_OP(and, x12, x10, x11, 0x40000000, 0x40000000, -0x10001, x2, 148, x1)

inst_57:
// rs2_val == -131073, rs1_val == -5
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x5;  op2val:-0x20001
TEST_RR_OP(and, x12, x10, x11, 0xfffdfffb, -0x5, -0x20001, x2, 152, x1)

inst_58:
// rs2_val == -262145, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x40000;  op2val:-0x40001
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x40000, -0x40001, x2, 156, x1)

inst_59:
// rs2_val == -524289, rs1_val == 16
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x10;  op2val:-0x80001
TEST_RR_OP(and, x12, x10, x11, 0x10, 0x10, -0x80001, x2, 160, x1)

inst_60:
// rs2_val == -2097153, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x400;  op2val:-0x200001
TEST_RR_OP(and, x12, x10, x11, 0x400, 0x400, -0x200001, x2, 164, x1)

inst_61:
// rs2_val == -4194305, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x1;  op2val:-0x400001
TEST_RR_OP(and, x12, x10, x11, 0xffbfffff, -0x1, -0x400001, x2, 168, x1)

inst_62:
// rs2_val == -8388609, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x20000;  op2val:-0x800001
TEST_RR_OP(and, x12, x10, x11, 0x20000, 0x20000, -0x800001, x2, 172, x1)

inst_63:
// rs2_val == -16777217, rs1_val == -262145
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x40001;  op2val:-0x1000001
TEST_RR_OP(and, x12, x10, x11, 0xfefbffff, -0x40001, -0x1000001, x2, 176, x1)

inst_64:
// rs2_val == -33554433, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:-0x2000001
TEST_RR_OP(and, x12, x10, x11, 0x6, 0x6, -0x2000001, x2, 180, x1)

inst_65:
// rs2_val == -67108865, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:-0x4000001
TEST_RR_OP(and, x12, x10, x11, 0xaaaaaaab, -0x55555555, -0x4000001, x2, 184, x1)

inst_66:
// rs2_val == -134217729, rs1_val == -17
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x11;  op2val:-0x8000001
TEST_RR_OP(and, x12, x10, x11, 0xf7ffffef, -0x11, -0x8000001, x2, 188, x1)

inst_67:
// rs2_val == -268435457, rs1_val == -536870913
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x20000001;  op2val:-0x10000001
TEST_RR_OP(and, x12, x10, x11, 0xcfffffff, -0x20000001, -0x10000001, x2, 192, x1)

inst_68:
// rs2_val == -536870913, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:-0x20000001
TEST_RR_OP(and, x12, x10, x11, 0xdfff4afd, -0xb503, -0x20000001, x2, 196, x1)

inst_69:
// rs2_val == -1073741825, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x80000000;  op2val:-0x40000001
TEST_RR_OP(and, x12, x10, x11, 0x80000000, -0x80000000, -0x40000001, x2, 200, x1)

inst_70:
// rs2_val == -1431655766, rs1_val==-46340 and rs2_val==-1431655766
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:-0x55555556
TEST_RR_OP(and, x12, x10, x11, 0xaaaa0aa8, -0xb504, -0x55555556, x2, 204, x1)

inst_71:
// rs1_val == 8, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x8;  op2val:0x55555554
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x8, 0x55555554, x2, 208, x1)

inst_72:
// rs1_val == 32, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x20;  op2val:0x4
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x20, 0x4, x2, 212, x1)

inst_73:
// rs1_val == 256, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x100;  op2val:-0x101
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x100, -0x101, x2, 216, x1)

inst_74:
// rs1_val == 512, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x200;  op2val:0x0
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x200, 0x0, x2, 220, x1)

inst_75:
// rs1_val == 4096, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x1000;  op2val:0x8
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x1000, 0x8, x2, 224, x1)

inst_76:
// rs1_val == 8192, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x2000;  op2val:0x40000
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x2000, 0x40000, x2, 228, x1)

inst_77:
// rs1_val == 32768, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x8000;  op2val:-0x4
TEST_RR_OP(and, x12, x10, x11, 0x8000, 0x8000, -0x4, x2, 232, x1)

inst_78:
// rs1_val == 524288, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x80000;  op2val:0x3fffffff
TEST_RR_OP(and, x12, x10, x11, 0x80000, 0x80000, 0x3fffffff, x2, 236, x1)

inst_79:
// rs1_val == 1048576, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x100000;  op2val:-0x2001
TEST_RR_OP(and, x12, x10, x11, 0x100000, 0x100000, -0x2001, x2, 240, x1)

inst_80:
// rs1_val == 2097152, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x200000;  op2val:0x8000
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x200000, 0x8000, x2, 244, x1)

inst_81:
// rs1_val == 4194304, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x400000;  op2val:-0x11
TEST_RR_OP(and, x12, x10, x11, 0x400000, 0x400000, -0x11, x2, 248, x1)

inst_82:
// rs1_val == 16777216, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x1000000;  op2val:0x3
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x1000000, 0x3, x2, 252, x1)

inst_83:
// rs1_val == 67108864, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x4000000;  op2val:0x20000
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x4000000, 0x20000, x2, 256, x1)

inst_84:
// rs1_val == 268435456, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x10000000;  op2val:0x4
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x10000000, 0x4, x2, 260, x1)

inst_85:
// rs1_val == 536870912, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x20000000;  op2val:0x4
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x20000000, 0x4, x2, 264, x1)

inst_86:
// rs1_val == -2, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x2;  op2val:-0x10000001
TEST_RR_OP(and, x12, x10, x11, 0xeffffffe, -0x2, -0x10000001, x2, 268, x1)

inst_87:
// rs1_val == -33, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x21;  op2val:0x33333332
TEST_RR_OP(and, x12, x10, x11, 0x33333312, -0x21, 0x33333332, x2, 272, x1)

inst_88:
// rs1_val == -65, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x41;  op2val:-0x400001
TEST_RR_OP(and, x12, x10, x11, 0xffbfffbf, -0x41, -0x400001, x2, 276, x1)

inst_89:
// rs1_val == -1025, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x401;  op2val:-0x4001
TEST_RR_OP(and, x12, x10, x11, 0xffffbbff, -0x401, -0x4001, x2, 280, x1)

inst_90:
// rs1_val == -2049, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x801;  op2val:-0x7
TEST_RR_OP(and, x12, x10, x11, 0xfffff7f9, -0x801, -0x7, x2, 284, x1)

inst_91:
// rs1_val == -4097, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x1001;  op2val:-0x81
TEST_RR_OP(and, x12, x10, x11, 0xffffef7f, -0x1001, -0x81, x2, 288, x1)

inst_92:
// rs1_val == -8193, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x2001;  op2val:-0x5
TEST_RR_OP(and, x12, x10, x11, 0xffffdffb, -0x2001, -0x5, x2, 292, x1)

inst_93:
// rs1_val == -16385, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x4001;  op2val:0x4
TEST_RR_OP(and, x12, x10, x11, 0x4, -0x4001, 0x4, x2, 296, x1)

inst_94:
// rs1_val == -524289, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x80001;  op2val:-0x200001
TEST_RR_OP(and, x12, x10, x11, 0xffd7ffff, -0x80001, -0x200001, x2, 300, x1)

inst_95:
// rs1_val == -2097153, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x200001;  op2val:0x4
TEST_RR_OP(and, x12, x10, x11, 0x4, -0x200001, 0x4, x2, 304, x1)

inst_96:
// rs1_val == -4194305, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x400001;  op2val:0x33333334
TEST_RR_OP(and, x12, x10, x11, 0x33333334, -0x400001, 0x33333334, x2, 308, x1)

inst_97:
// rs1_val == -16777217, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x1000001;  op2val:0x7fffffff
TEST_RR_OP(and, x12, x10, x11, 0x7effffff, -0x1000001, 0x7fffffff, x2, 312, x1)

inst_98:
// rs1_val == -67108865, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x4000001;  op2val:0x66666665
TEST_RR_OP(and, x12, x10, x11, 0x62666665, -0x4000001, 0x66666665, x2, 316, x1)

inst_99:
// rs1_val == -268435457, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x10000001;  op2val:-0xb503
TEST_RR_OP(and, x12, x10, x11, 0xefff4afd, -0x10000001, -0xb503, x2, 320, x1)

inst_100:
// rs1_val==3 and rs2_val==3, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x3
TEST_RR_OP(and, x12, x10, x11, 0x3, 0x3, 0x3, x2, 324, x1)

inst_101:
// rs1_val==3 and rs2_val==1431655765, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x55555555
TEST_RR_OP(and, x12, x10, x11, 0x1, 0x3, 0x55555555, x2, 328, x1)

inst_102:
// rs1_val==3 and rs2_val==-1431655766, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:-0x55555556
TEST_RR_OP(and, x12, x10, x11, 0x2, 0x3, -0x55555556, x2, 332, x1)

inst_103:
// rs1_val==3 and rs2_val==5, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x5
TEST_RR_OP(and, x12, x10, x11, 0x1, 0x3, 0x5, x2, 336, x1)

inst_104:
// rs1_val==3 and rs2_val==858993459, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x33333333
TEST_RR_OP(and, x12, x10, x11, 0x3, 0x3, 0x33333333, x2, 340, x1)

inst_105:
// rs1_val==3 and rs2_val==1717986918, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x66666666
TEST_RR_OP(and, x12, x10, x11, 0x2, 0x3, 0x66666666, x2, 344, x1)

inst_106:
// rs1_val==3 and rs2_val==-46340, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:-0xb504
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x3, -0xb504, x2, 348, x1)

inst_107:
// rs1_val==3 and rs2_val==46340, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0xb504
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x3, 0xb504, x2, 352, x1)

inst_108:
// rs1_val==3 and rs2_val==2, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x2
TEST_RR_OP(and, x12, x10, x11, 0x2, 0x3, 0x2, x2, 356, x1)

inst_109:
// rs1_val==3 and rs2_val==1431655764, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x55555554
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x3, 0x55555554, x2, 360, x1)

inst_110:
// rs1_val==3 and rs2_val==0, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x0
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x3, 0x0, x2, 364, x1)

inst_111:
// rs1_val==3 and rs2_val==4, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x4
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x3, 0x4, x2, 368, x1)

inst_112:
// rs1_val==3 and rs2_val==858993458, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x33333332
TEST_RR_OP(and, x12, x10, x11, 0x2, 0x3, 0x33333332, x2, 372, x1)

inst_113:
// rs1_val==3 and rs2_val==1717986917, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x66666665
TEST_RR_OP(and, x12, x10, x11, 0x1, 0x3, 0x66666665, x2, 376, x1)

inst_114:
// rs1_val==3 and rs2_val==46339, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0xb503
TEST_RR_OP(and, x12, x10, x11, 0x3, 0x3, 0xb503, x2, 380, x1)

inst_115:
// rs1_val==3 and rs2_val==1431655766, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x55555556
TEST_RR_OP(and, x12, x10, x11, 0x2, 0x3, 0x55555556, x2, 384, x1)

inst_116:
// rs1_val==3 and rs2_val==-1431655765, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:-0x55555555
TEST_RR_OP(and, x12, x10, x11, 0x3, 0x3, -0x55555555, x2, 388, x1)

inst_117:
// rs1_val==3 and rs2_val==6, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x6
TEST_RR_OP(and, x12, x10, x11, 0x2, 0x3, 0x6, x2, 392, x1)

inst_118:
// rs1_val==3 and rs2_val==858993460, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x33333334
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x3, 0x33333334, x2, 396, x1)

inst_119:
// rs1_val==3 and rs2_val==1717986919, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x66666667
TEST_RR_OP(and, x12, x10, x11, 0x3, 0x3, 0x66666667, x2, 400, x1)

inst_120:
// rs1_val==3 and rs2_val==-46339, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:-0xb503
TEST_RR_OP(and, x12, x10, x11, 0x1, 0x3, -0xb503, x2, 404, x1)

inst_121:
// rs1_val==3 and rs2_val==46341, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0xb505
TEST_RR_OP(and, x12, x10, x11, 0x1, 0x3, 0xb505, x2, 408, x1)

inst_122:
// rs1_val==1431655765 and rs2_val==3, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x3
TEST_RR_OP(and, x12, x10, x11, 0x1, 0x55555555, 0x3, x2, 412, x1)

inst_123:
// rs1_val==1431655765 and rs2_val==1431655765, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x55555555
TEST_RR_OP(and, x12, x10, x11, 0x55555555, 0x55555555, 0x55555555, x2, 416, x1)

inst_124:
// rs1_val==1431655765 and rs2_val==-1431655766, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:-0x55555556
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x55555555, -0x55555556, x2, 420, x1)

inst_125:
// rs1_val==1431655765 and rs2_val==5, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x5
TEST_RR_OP(and, x12, x10, x11, 0x5, 0x55555555, 0x5, x2, 424, x1)

inst_126:
// rs1_val==1431655765 and rs2_val==858993459, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x33333333
TEST_RR_OP(and, x12, x10, x11, 0x11111111, 0x55555555, 0x33333333, x2, 428, x1)

inst_127:
// rs1_val==1431655765 and rs2_val==1717986918, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x66666666
TEST_RR_OP(and, x12, x10, x11, 0x44444444, 0x55555555, 0x66666666, x2, 432, x1)

inst_128:
// rs1_val==1431655765 and rs2_val==-46340, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:-0xb504
TEST_RR_OP(and, x12, x10, x11, 0x55554054, 0x55555555, -0xb504, x2, 436, x1)

inst_129:
// rs1_val==1431655765 and rs2_val==46340, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0xb504
TEST_RR_OP(and, x12, x10, x11, 0x1504, 0x55555555, 0xb504, x2, 440, x1)

inst_130:
// rs1_val==1431655765 and rs2_val==2, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x2
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x55555555, 0x2, x2, 444, x1)

inst_131:
// rs1_val==1431655765 and rs2_val==1431655764, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x55555554
TEST_RR_OP(and, x12, x10, x11, 0x55555554, 0x55555555, 0x55555554, x2, 448, x1)

inst_132:
// rs1_val==1431655765 and rs2_val==0, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x0
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x55555555, 0x0, x2, 452, x1)

inst_133:
// rs1_val==1431655765 and rs2_val==4, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x4
TEST_RR_OP(and, x12, x10, x11, 0x4, 0x55555555, 0x4, x2, 456, x1)

inst_134:
// rs1_val==1431655765 and rs2_val==858993458, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x33333332
TEST_RR_OP(and, x12, x10, x11, 0x11111110, 0x55555555, 0x33333332, x2, 460, x1)

inst_135:
// rs1_val==1431655765 and rs2_val==1717986917, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x66666665
TEST_RR_OP(and, x12, x10, x11, 0x44444445, 0x55555555, 0x66666665, x2, 464, x1)

inst_136:
// rs1_val==1431655765 and rs2_val==46339, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0xb503
TEST_RR_OP(and, x12, x10, x11, 0x1501, 0x55555555, 0xb503, x2, 468, x1)

inst_137:
// rs1_val==1431655765 and rs2_val==1431655766, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x55555556
TEST_RR_OP(and, x12, x10, x11, 0x55555554, 0x55555555, 0x55555556, x2, 472, x1)

inst_138:
// rs1_val==1431655765 and rs2_val==-1431655765, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:-0x55555555
TEST_RR_OP(and, x12, x10, x11, 0x1, 0x55555555, -0x55555555, x2, 476, x1)

inst_139:
// rs1_val==1431655765 and rs2_val==6, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x6
TEST_RR_OP(and, x12, x10, x11, 0x4, 0x55555555, 0x6, x2, 480, x1)

inst_140:
// rs1_val==1431655765 and rs2_val==858993460, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x33333334
TEST_RR_OP(and, x12, x10, x11, 0x11111114, 0x55555555, 0x33333334, x2, 484, x1)

inst_141:
// rs1_val==1431655765 and rs2_val==1717986919, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x66666667
TEST_RR_OP(and, x12, x10, x11, 0x44444445, 0x55555555, 0x66666667, x2, 488, x1)

inst_142:
// rs1_val==1431655765 and rs2_val==-46339, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:-0xb503
TEST_RR_OP(and, x12, x10, x11, 0x55554055, 0x55555555, -0xb503, x2, 492, x1)

inst_143:
// rs1_val==1431655765 and rs2_val==46341, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0xb505
TEST_RR_OP(and, x12, x10, x11, 0x1505, 0x55555555, 0xb505, x2, 496, x1)

inst_144:
// rs1_val==-1431655766 and rs2_val==3, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x3
TEST_RR_OP(and, x12, x10, x11, 0x2, -0x55555556, 0x3, x2, 500, x1)

inst_145:
// rs1_val==-1431655766 and rs2_val==1431655765, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x55555555
TEST_RR_OP(and, x12, x10, x11, 0x0, -0x55555556, 0x55555555, x2, 504, x1)

inst_146:
// rs1_val==-1431655766 and rs2_val==-1431655766, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:-0x55555556
TEST_RR_OP(and, x12, x10, x11, 0xaaaaaaaa, -0x55555556, -0x55555556, x2, 508, x1)

inst_147:
// rs1_val==-1431655766 and rs2_val==5, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x5
TEST_RR_OP(and, x12, x10, x11, 0x0, -0x55555556, 0x5, x2, 512, x1)

inst_148:
// rs1_val==-1431655766 and rs2_val==858993459, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x33333333
TEST_RR_OP(and, x12, x10, x11, 0x22222222, -0x55555556, 0x33333333, x2, 516, x1)

inst_149:
// rs1_val==-1431655766 and rs2_val==1717986918, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x66666666
TEST_RR_OP(and, x12, x10, x11, 0x22222222, -0x55555556, 0x66666666, x2, 520, x1)

inst_150:
// rs1_val==-1431655766 and rs2_val==-46340, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:-0xb504
TEST_RR_OP(and, x12, x10, x11, 0xaaaa0aa8, -0x55555556, -0xb504, x2, 524, x1)

inst_151:
// rs1_val==-1431655766 and rs2_val==46340, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0xb504
TEST_RR_OP(and, x12, x10, x11, 0xa000, -0x55555556, 0xb504, x2, 528, x1)

inst_152:
// rs1_val==-1431655766 and rs2_val==2, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x2
TEST_RR_OP(and, x12, x10, x11, 0x2, -0x55555556, 0x2, x2, 532, x1)

inst_153:
// rs1_val==-1431655766 and rs2_val==1431655764, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x55555554
TEST_RR_OP(and, x12, x10, x11, 0x0, -0x55555556, 0x55555554, x2, 536, x1)

inst_154:
// rs1_val==-1431655766 and rs2_val==0, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x0
TEST_RR_OP(and, x12, x10, x11, 0x0, -0x55555556, 0x0, x2, 540, x1)

inst_155:
// rs1_val==-1431655766 and rs2_val==4, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x4
TEST_RR_OP(and, x12, x10, x11, 0x0, -0x55555556, 0x4, x2, 544, x1)

inst_156:
// rs1_val==-1431655766 and rs2_val==858993458, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x33333332
TEST_RR_OP(and, x12, x10, x11, 0x22222222, -0x55555556, 0x33333332, x2, 548, x1)

inst_157:
// rs1_val==-1431655766 and rs2_val==1717986917, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x66666665
TEST_RR_OP(and, x12, x10, x11, 0x22222220, -0x55555556, 0x66666665, x2, 552, x1)

inst_158:
// rs1_val==-1431655766 and rs2_val==46339, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0xb503
TEST_RR_OP(and, x12, x10, x11, 0xa002, -0x55555556, 0xb503, x2, 556, x1)

inst_159:
// rs1_val==-1431655766 and rs2_val==1431655766, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x55555556
TEST_RR_OP(and, x12, x10, x11, 0x2, -0x55555556, 0x55555556, x2, 560, x1)

inst_160:
// rs1_val==-1431655766 and rs2_val==-1431655765, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:-0x55555555
TEST_RR_OP(and, x12, x10, x11, 0xaaaaaaaa, -0x55555556, -0x55555555, x2, 564, x1)

inst_161:
// rs1_val==-1431655766 and rs2_val==6, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x6
TEST_RR_OP(and, x12, x10, x11, 0x2, -0x55555556, 0x6, x2, 568, x1)

inst_162:
// rs1_val==-1431655766 and rs2_val==858993460, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x33333334
TEST_RR_OP(and, x12, x10, x11, 0x22222220, -0x55555556, 0x33333334, x2, 572, x1)

inst_163:
// rs1_val==-1431655766 and rs2_val==1717986919, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x66666667
TEST_RR_OP(and, x12, x10, x11, 0x22222222, -0x55555556, 0x66666667, x2, 576, x1)

inst_164:
// rs1_val==-1431655766 and rs2_val==-46339, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:-0xb503
TEST_RR_OP(and, x12, x10, x11, 0xaaaa0aa8, -0x55555556, -0xb503, x2, 580, x1)

inst_165:
// rs1_val==-1431655766 and rs2_val==46341, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0xb505
TEST_RR_OP(and, x12, x10, x11, 0xa000, -0x55555556, 0xb505, x2, 584, x1)

inst_166:
// rs1_val==5 and rs2_val==3, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x3
TEST_RR_OP(and, x12, x10, x11, 0x1, 0x5, 0x3, x2, 588, x1)

inst_167:
// rs1_val==5 and rs2_val==1431655765, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x55555555
TEST_RR_OP(and, x12, x10, x11, 0x5, 0x5, 0x55555555, x2, 592, x1)

inst_168:
// rs1_val==5 and rs2_val==-1431655766, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:-0x55555556
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x5, -0x55555556, x2, 596, x1)

inst_169:
// rs1_val==5 and rs2_val==858993459, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x33333333
TEST_RR_OP(and, x12, x10, x11, 0x1, 0x5, 0x33333333, x2, 600, x1)

inst_170:
// rs1_val==5 and rs2_val==1717986918, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x66666666
TEST_RR_OP(and, x12, x10, x11, 0x4, 0x5, 0x66666666, x2, 604, x1)

inst_171:
// rs1_val==5 and rs2_val==-46340, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:-0xb504
TEST_RR_OP(and, x12, x10, x11, 0x4, 0x5, -0xb504, x2, 608, x1)

inst_172:
// rs1_val==5 and rs2_val==46340, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0xb504
TEST_RR_OP(and, x12, x10, x11, 0x4, 0x5, 0xb504, x2, 612, x1)

inst_173:
// rs1_val==5 and rs2_val==2, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x2
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x5, 0x2, x2, 616, x1)

inst_174:
// rs1_val==5 and rs2_val==1431655764, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x55555554
TEST_RR_OP(and, x12, x10, x11, 0x4, 0x5, 0x55555554, x2, 620, x1)

inst_175:
// rs1_val==5 and rs2_val==0, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x0
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x5, 0x0, x2, 624, x1)

inst_176:
// rs1_val==5 and rs2_val==4, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x4
TEST_RR_OP(and, x12, x10, x11, 0x4, 0x5, 0x4, x2, 628, x1)

inst_177:
// rs1_val==5 and rs2_val==858993458, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x33333332
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x5, 0x33333332, x2, 632, x1)

inst_178:
// rs1_val==5 and rs2_val==1717986917, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x66666665
TEST_RR_OP(and, x12, x10, x11, 0x5, 0x5, 0x66666665, x2, 636, x1)

inst_179:
// rs1_val==5 and rs2_val==46339, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0xb503
TEST_RR_OP(and, x12, x10, x11, 0x1, 0x5, 0xb503, x2, 640, x1)

inst_180:
// rs1_val==5 and rs2_val==1431655766, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x55555556
TEST_RR_OP(and, x12, x10, x11, 0x4, 0x5, 0x55555556, x2, 644, x1)

inst_181:
// rs1_val==5 and rs2_val==-1431655765, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:-0x55555555
TEST_RR_OP(and, x12, x10, x11, 0x1, 0x5, -0x55555555, x2, 648, x1)

inst_182:
// rs1_val==5 and rs2_val==6, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x6
TEST_RR_OP(and, x12, x10, x11, 0x4, 0x5, 0x6, x2, 652, x1)

inst_183:
// rs1_val==5 and rs2_val==858993460, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x33333334
TEST_RR_OP(and, x12, x10, x11, 0x4, 0x5, 0x33333334, x2, 656, x1)

inst_184:
// rs1_val==5 and rs2_val==1717986919, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x66666667
TEST_RR_OP(and, x12, x10, x11, 0x5, 0x5, 0x66666667, x2, 660, x1)

inst_185:
// rs1_val==5 and rs2_val==-46339, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:-0xb503
TEST_RR_OP(and, x12, x10, x11, 0x5, 0x5, -0xb503, x2, 664, x1)

inst_186:
// rs1_val==5 and rs2_val==46341, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0xb505
TEST_RR_OP(and, x12, x10, x11, 0x5, 0x5, 0xb505, x2, 668, x1)

inst_187:
// rs1_val==858993459 and rs2_val==3, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x3
TEST_RR_OP(and, x12, x10, x11, 0x3, 0x33333333, 0x3, x2, 672, x1)

inst_188:
// rs1_val==858993459 and rs2_val==1431655765, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x55555555
TEST_RR_OP(and, x12, x10, x11, 0x11111111, 0x33333333, 0x55555555, x2, 676, x1)

inst_189:
// rs1_val==858993459 and rs2_val==-1431655766, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:-0x55555556
TEST_RR_OP(and, x12, x10, x11, 0x22222222, 0x33333333, -0x55555556, x2, 680, x1)

inst_190:
// rs1_val==858993459 and rs2_val==5, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x5
TEST_RR_OP(and, x12, x10, x11, 0x1, 0x33333333, 0x5, x2, 684, x1)

inst_191:
// rs1_val==858993459 and rs2_val==858993459, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x33333333
TEST_RR_OP(and, x12, x10, x11, 0x33333333, 0x33333333, 0x33333333, x2, 688, x1)

inst_192:
// rs1_val==858993459 and rs2_val==1717986918, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x66666666
TEST_RR_OP(and, x12, x10, x11, 0x22222222, 0x33333333, 0x66666666, x2, 692, x1)

inst_193:
// rs1_val==858993459 and rs2_val==-46340, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:-0xb504
TEST_RR_OP(and, x12, x10, x11, 0x33330230, 0x33333333, -0xb504, x2, 696, x1)

inst_194:
// rs1_val==858993459 and rs2_val==46340, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0xb504
TEST_RR_OP(and, x12, x10, x11, 0x3100, 0x33333333, 0xb504, x2, 700, x1)

inst_195:
// rs1_val==858993459 and rs2_val==2, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x2
TEST_RR_OP(and, x12, x10, x11, 0x2, 0x33333333, 0x2, x2, 704, x1)

inst_196:
// rs1_val==858993459 and rs2_val==1431655764, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x55555554
TEST_RR_OP(and, x12, x10, x11, 0x11111110, 0x33333333, 0x55555554, x2, 708, x1)

inst_197:
// rs1_val==858993459 and rs2_val==4, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x4
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x33333333, 0x4, x2, 712, x1)

inst_198:
// rs1_val==858993459 and rs2_val==858993458, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x33333332
TEST_RR_OP(and, x12, x10, x11, 0x33333332, 0x33333333, 0x33333332, x2, 716, x1)

inst_199:
// rs1_val==858993459 and rs2_val==1717986917, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x66666665
TEST_RR_OP(and, x12, x10, x11, 0x22222221, 0x33333333, 0x66666665, x2, 720, x1)

inst_200:
// rs1_val==858993459 and rs2_val==46339, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0xb503
TEST_RR_OP(and, x12, x10, x11, 0x3103, 0x33333333, 0xb503, x2, 724, x1)

inst_201:
// rs1_val==858993459 and rs2_val==1431655766, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x55555556
TEST_RR_OP(and, x12, x10, x11, 0x11111112, 0x33333333, 0x55555556, x2, 728, x1)

inst_202:
// rs1_val==858993459 and rs2_val==-1431655765, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:-0x55555555
TEST_RR_OP(and, x12, x10, x11, 0x22222223, 0x33333333, -0x55555555, x2, 732, x1)

inst_203:
// rs1_val==858993459 and rs2_val==6, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x6
TEST_RR_OP(and, x12, x10, x11, 0x2, 0x33333333, 0x6, x2, 736, x1)

inst_204:
// rs1_val==858993459 and rs2_val==858993460, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x33333334
TEST_RR_OP(and, x12, x10, x11, 0x33333330, 0x33333333, 0x33333334, x2, 740, x1)

inst_205:
// rs1_val==858993459 and rs2_val==1717986919, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x66666667
TEST_RR_OP(and, x12, x10, x11, 0x22222223, 0x33333333, 0x66666667, x2, 744, x1)

inst_206:
// rs1_val==858993459 and rs2_val==-46339, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:-0xb503
TEST_RR_OP(and, x12, x10, x11, 0x33330231, 0x33333333, -0xb503, x2, 748, x1)

inst_207:
// rs1_val==858993459 and rs2_val==46341, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0xb505
TEST_RR_OP(and, x12, x10, x11, 0x3101, 0x33333333, 0xb505, x2, 752, x1)

inst_208:
// rs1_val==1717986918 and rs2_val==3, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x3
TEST_RR_OP(and, x12, x10, x11, 0x2, 0x66666666, 0x3, x2, 756, x1)

inst_209:
// rs1_val==1717986918 and rs2_val==1431655765, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x55555555
TEST_RR_OP(and, x12, x10, x11, 0x44444444, 0x66666666, 0x55555555, x2, 760, x1)

inst_210:
// rs1_val==1717986918 and rs2_val==-1431655766, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:-0x55555556
TEST_RR_OP(and, x12, x10, x11, 0x22222222, 0x66666666, -0x55555556, x2, 764, x1)

inst_211:
// rs1_val==1717986918 and rs2_val==5, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x5
TEST_RR_OP(and, x12, x10, x11, 0x4, 0x66666666, 0x5, x2, 768, x1)

inst_212:
// rs1_val==1717986918 and rs2_val==858993459, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x33333333
TEST_RR_OP(and, x12, x10, x11, 0x22222222, 0x66666666, 0x33333333, x2, 772, x1)

inst_213:
// rs1_val==1717986918 and rs2_val==1717986918, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x66666666
TEST_RR_OP(and, x12, x10, x11, 0x66666666, 0x66666666, 0x66666666, x2, 776, x1)

inst_214:
// rs1_val==1717986918 and rs2_val==-46340, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:-0xb504
TEST_RR_OP(and, x12, x10, x11, 0x66664264, 0x66666666, -0xb504, x2, 780, x1)

inst_215:
// rs1_val==1717986918 and rs2_val==46340, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0xb504
TEST_RR_OP(and, x12, x10, x11, 0x2404, 0x66666666, 0xb504, x2, 784, x1)

inst_216:
// rs1_val==1717986918 and rs2_val==2, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x2
TEST_RR_OP(and, x12, x10, x11, 0x2, 0x66666666, 0x2, x2, 788, x1)

inst_217:
// rs1_val==1717986918 and rs2_val==1431655764, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x55555554
TEST_RR_OP(and, x12, x10, x11, 0x44444444, 0x66666666, 0x55555554, x2, 792, x1)

inst_218:
// rs1_val==1717986918 and rs2_val==0, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x0
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x66666666, 0x0, x2, 796, x1)

inst_219:
// rs1_val==1717986918 and rs2_val==4, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x4
TEST_RR_OP(and, x12, x10, x11, 0x4, 0x66666666, 0x4, x2, 800, x1)

inst_220:
// rs1_val==1717986918 and rs2_val==858993458, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x33333332
TEST_RR_OP(and, x12, x10, x11, 0x22222222, 0x66666666, 0x33333332, x2, 804, x1)

inst_221:
// rs1_val==1717986918 and rs2_val==1717986917, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x66666665
TEST_RR_OP(and, x12, x10, x11, 0x66666664, 0x66666666, 0x66666665, x2, 808, x1)

inst_222:
// rs1_val==1717986918 and rs2_val==46339, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0xb503
TEST_RR_OP(and, x12, x10, x11, 0x2402, 0x66666666, 0xb503, x2, 812, x1)

inst_223:
// rs1_val==1717986918 and rs2_val==1431655766, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x55555556
TEST_RR_OP(and, x12, x10, x11, 0x44444446, 0x66666666, 0x55555556, x2, 816, x1)

inst_224:
// rs1_val==1717986918 and rs2_val==-1431655765, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:-0x55555555
TEST_RR_OP(and, x12, x10, x11, 0x22222222, 0x66666666, -0x55555555, x2, 820, x1)

inst_225:
// rs1_val==1717986918 and rs2_val==6, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x6
TEST_RR_OP(and, x12, x10, x11, 0x6, 0x66666666, 0x6, x2, 824, x1)

inst_226:
// rs1_val==1717986918 and rs2_val==858993460, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x33333334
TEST_RR_OP(and, x12, x10, x11, 0x22222224, 0x66666666, 0x33333334, x2, 828, x1)

inst_227:
// rs1_val==1717986918 and rs2_val==1717986919, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x66666667
TEST_RR_OP(and, x12, x10, x11, 0x66666666, 0x66666666, 0x66666667, x2, 832, x1)

inst_228:
// rs1_val==1717986918 and rs2_val==-46339, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:-0xb503
TEST_RR_OP(and, x12, x10, x11, 0x66664264, 0x66666666, -0xb503, x2, 836, x1)

inst_229:
// rs1_val==1717986918 and rs2_val==46341, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0xb505
TEST_RR_OP(and, x12, x10, x11, 0x2404, 0x66666666, 0xb505, x2, 840, x1)

inst_230:
// rs1_val==-46340 and rs2_val==3, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x3
TEST_RR_OP(and, x12, x10, x11, 0x0, -0xb504, 0x3, x2, 844, x1)

inst_231:
// rs1_val==-46340 and rs2_val==1431655765, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x55555555
TEST_RR_OP(and, x12, x10, x11, 0x55554054, -0xb504, 0x55555555, x2, 848, x1)

inst_232:
// rs1_val==-46340 and rs2_val==5, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x5
TEST_RR_OP(and, x12, x10, x11, 0x4, -0xb504, 0x5, x2, 852, x1)

inst_233:
// rs1_val==-46340 and rs2_val==858993459, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x33333333
TEST_RR_OP(and, x12, x10, x11, 0x33330230, -0xb504, 0x33333333, x2, 856, x1)

inst_234:
// rs1_val==-46340 and rs2_val==1717986918, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x66666666
TEST_RR_OP(and, x12, x10, x11, 0x66664264, -0xb504, 0x66666666, x2, 860, x1)

inst_235:
// rs1_val==-46340 and rs2_val==-46340, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:-0xb504
TEST_RR_OP(and, x12, x10, x11, 0xffff4afc, -0xb504, -0xb504, x2, 864, x1)

inst_236:
// rs1_val==-46340 and rs2_val==46340, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0xb504
TEST_RR_OP(and, x12, x10, x11, 0x4, -0xb504, 0xb504, x2, 868, x1)

inst_237:
// rs1_val==-46340 and rs2_val==2, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x2
TEST_RR_OP(and, x12, x10, x11, 0x0, -0xb504, 0x2, x2, 872, x1)

inst_238:
// rs1_val==-46340 and rs2_val==1431655764, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x55555554
TEST_RR_OP(and, x12, x10, x11, 0x55554054, -0xb504, 0x55555554, x2, 876, x1)

inst_239:
// rs1_val==-46340 and rs2_val==0, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x0
TEST_RR_OP(and, x12, x10, x11, 0x0, -0xb504, 0x0, x2, 880, x1)

inst_240:
// rs1_val==-46340 and rs2_val==4, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x4
TEST_RR_OP(and, x12, x10, x11, 0x4, -0xb504, 0x4, x2, 884, x1)

inst_241:
// rs1_val==-46340 and rs2_val==858993458, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x33333332
TEST_RR_OP(and, x12, x10, x11, 0x33330230, -0xb504, 0x33333332, x2, 888, x1)

inst_242:
// rs1_val==-46340 and rs2_val==1717986917, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x66666665
TEST_RR_OP(and, x12, x10, x11, 0x66664264, -0xb504, 0x66666665, x2, 892, x1)

inst_243:
// rs1_val==-46340 and rs2_val==46339, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0xb503
TEST_RR_OP(and, x12, x10, x11, 0x0, -0xb504, 0xb503, x2, 896, x1)

inst_244:
// rs1_val==-46340 and rs2_val==1431655766, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x55555556
TEST_RR_OP(and, x12, x10, x11, 0x55554054, -0xb504, 0x55555556, x2, 900, x1)

inst_245:
// rs1_val==-46340 and rs2_val==-1431655765, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:-0x55555555
TEST_RR_OP(and, x12, x10, x11, 0xaaaa0aa8, -0xb504, -0x55555555, x2, 904, x1)

inst_246:
// rs1_val==-46340 and rs2_val==6, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x6
TEST_RR_OP(and, x12, x10, x11, 0x4, -0xb504, 0x6, x2, 908, x1)

inst_247:
// rs1_val==-46340 and rs2_val==858993460, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x33333334
TEST_RR_OP(and, x12, x10, x11, 0x33330234, -0xb504, 0x33333334, x2, 912, x1)

inst_248:
// rs1_val==-46340 and rs2_val==1717986919, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x66666667
TEST_RR_OP(and, x12, x10, x11, 0x66664264, -0xb504, 0x66666667, x2, 916, x1)

inst_249:
// rs1_val==-46340 and rs2_val==-46339, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:-0xb503
TEST_RR_OP(and, x12, x10, x11, 0xffff4afc, -0xb504, -0xb503, x2, 920, x1)

inst_250:
// rs1_val==-46340 and rs2_val==46341, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0xb505
TEST_RR_OP(and, x12, x10, x11, 0x4, -0xb504, 0xb505, x2, 924, x1)

inst_251:
// rs1_val==46340 and rs2_val==3, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x3
TEST_RR_OP(and, x12, x10, x11, 0x0, 0xb504, 0x3, x2, 928, x1)

inst_252:
// rs1_val==46340 and rs2_val==1431655765, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x55555555
TEST_RR_OP(and, x12, x10, x11, 0x1504, 0xb504, 0x55555555, x2, 932, x1)

inst_253:
// rs1_val==46340 and rs2_val==-1431655766, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:-0x55555556
TEST_RR_OP(and, x12, x10, x11, 0xa000, 0xb504, -0x55555556, x2, 936, x1)

inst_254:
// rs1_val==46340 and rs2_val==5, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x5
TEST_RR_OP(and, x12, x10, x11, 0x4, 0xb504, 0x5, x2, 940, x1)

inst_255:
// rs1_val==46340 and rs2_val==858993459, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x33333333
TEST_RR_OP(and, x12, x10, x11, 0x3100, 0xb504, 0x33333333, x2, 944, x1)

inst_256:
// rs1_val==46340 and rs2_val==1717986918, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x66666666
TEST_RR_OP(and, x12, x10, x11, 0x2404, 0xb504, 0x66666666, x2, 948, x1)

inst_257:
// rs1_val==46340 and rs2_val==-46340, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:-0xb504
TEST_RR_OP(and, x12, x10, x11, 0x4, 0xb504, -0xb504, x2, 952, x1)

inst_258:
// rs1_val==46340 and rs2_val==46340, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0xb504
TEST_RR_OP(and, x12, x10, x11, 0xb504, 0xb504, 0xb504, x2, 956, x1)

inst_259:
// rs1_val==46340 and rs2_val==2, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x2
TEST_RR_OP(and, x12, x10, x11, 0x0, 0xb504, 0x2, x2, 960, x1)

inst_260:
// rs1_val==46340 and rs2_val==1431655764, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x55555554
TEST_RR_OP(and, x12, x10, x11, 0x1504, 0xb504, 0x55555554, x2, 964, x1)

inst_261:
// rs1_val==46340 and rs2_val==0, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x0
TEST_RR_OP(and, x12, x10, x11, 0x0, 0xb504, 0x0, x2, 968, x1)

inst_262:
// rs1_val==46340 and rs2_val==4, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x4
TEST_RR_OP(and, x12, x10, x11, 0x4, 0xb504, 0x4, x2, 972, x1)

inst_263:
// rs1_val==46340 and rs2_val==858993458, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x33333332
TEST_RR_OP(and, x12, x10, x11, 0x3100, 0xb504, 0x33333332, x2, 976, x1)

inst_264:
// rs1_val==46340 and rs2_val==1717986917, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x66666665
TEST_RR_OP(and, x12, x10, x11, 0x2404, 0xb504, 0x66666665, x2, 980, x1)

inst_265:
// rs1_val==46340 and rs2_val==46339, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0xb503
TEST_RR_OP(and, x12, x10, x11, 0xb500, 0xb504, 0xb503, x2, 984, x1)

inst_266:
// rs1_val==46340 and rs2_val==1431655766, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x55555556
TEST_RR_OP(and, x12, x10, x11, 0x1504, 0xb504, 0x55555556, x2, 988, x1)

inst_267:
// rs1_val==46340 and rs2_val==-1431655765, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:-0x55555555
TEST_RR_OP(and, x12, x10, x11, 0xa000, 0xb504, -0x55555555, x2, 992, x1)

inst_268:
// rs1_val==46340 and rs2_val==6, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x6
TEST_RR_OP(and, x12, x10, x11, 0x4, 0xb504, 0x6, x2, 996, x1)

inst_269:
// rs1_val==46340 and rs2_val==858993460, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x33333334
TEST_RR_OP(and, x12, x10, x11, 0x3104, 0xb504, 0x33333334, x2, 1000, x1)

inst_270:
// rs1_val==46340 and rs2_val==1717986919, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x66666667
TEST_RR_OP(and, x12, x10, x11, 0x2404, 0xb504, 0x66666667, x2, 1004, x1)

inst_271:
// rs1_val==46340 and rs2_val==-46339, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:-0xb503
TEST_RR_OP(and, x12, x10, x11, 0x4, 0xb504, -0xb503, x2, 1008, x1)

inst_272:
// rs1_val==46340 and rs2_val==46341, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0xb505
TEST_RR_OP(and, x12, x10, x11, 0xb504, 0xb504, 0xb505, x2, 1012, x1)

inst_273:
// rs1_val==2 and rs2_val==3, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x3
TEST_RR_OP(and, x12, x10, x11, 0x2, 0x2, 0x3, x2, 1016, x1)

inst_274:
// rs1_val==2 and rs2_val==1431655765, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x55555555
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x2, 0x55555555, x2, 1020, x1)

inst_275:
// rs1_val==2 and rs2_val==-1431655766, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:-0x55555556
TEST_RR_OP(and, x12, x10, x11, 0x2, 0x2, -0x55555556, x2, 1024, x1)

inst_276:
// rs1_val==2 and rs2_val==5, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x5
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x2, 0x5, x2, 1028, x1)

inst_277:
// rs1_val==2 and rs2_val==858993459, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x33333333
TEST_RR_OP(and, x12, x10, x11, 0x2, 0x2, 0x33333333, x2, 1032, x1)

inst_278:
// rs1_val==2 and rs2_val==1717986918, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x66666666
TEST_RR_OP(and, x12, x10, x11, 0x2, 0x2, 0x66666666, x2, 1036, x1)

inst_279:
// rs1_val==2 and rs2_val==-46340, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:-0xb504
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x2, -0xb504, x2, 1040, x1)

inst_280:
// rs1_val==2 and rs2_val==46340, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0xb504
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x2, 0xb504, x2, 1044, x1)

inst_281:
// rs1_val==2 and rs2_val==2, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x2
TEST_RR_OP(and, x12, x10, x11, 0x2, 0x2, 0x2, x2, 1048, x1)

inst_282:
// rs1_val==2 and rs2_val==1431655764, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x55555554
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x2, 0x55555554, x2, 1052, x1)

inst_283:
// rs1_val==2 and rs2_val==0, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x0
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x2, 0x0, x2, 1056, x1)

inst_284:
// rs1_val==2 and rs2_val==4, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x4
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x2, 0x4, x2, 1060, x1)

inst_285:
// rs1_val==2 and rs2_val==858993458, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x33333332
TEST_RR_OP(and, x12, x10, x11, 0x2, 0x2, 0x33333332, x2, 1064, x1)

inst_286:
// rs1_val==2 and rs2_val==1717986917, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x66666665
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x2, 0x66666665, x2, 1068, x1)

inst_287:
// rs1_val==2 and rs2_val==46339, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0xb503
TEST_RR_OP(and, x12, x10, x11, 0x2, 0x2, 0xb503, x2, 1072, x1)

inst_288:
// rs1_val==2 and rs2_val==1431655766, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x55555556
TEST_RR_OP(and, x12, x10, x11, 0x2, 0x2, 0x55555556, x2, 1076, x1)

inst_289:
// rs1_val==2 and rs2_val==-1431655765, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:-0x55555555
TEST_RR_OP(and, x12, x10, x11, 0x2, 0x2, -0x55555555, x2, 1080, x1)

inst_290:
// rs1_val==2 and rs2_val==6, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x6
TEST_RR_OP(and, x12, x10, x11, 0x2, 0x2, 0x6, x2, 1084, x1)

inst_291:
// rs1_val==2 and rs2_val==858993460, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x33333334
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x2, 0x33333334, x2, 1088, x1)

inst_292:
// rs1_val==2 and rs2_val==1717986919, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x66666667
TEST_RR_OP(and, x12, x10, x11, 0x2, 0x2, 0x66666667, x2, 1092, x1)

inst_293:
// rs1_val==2 and rs2_val==-46339, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:-0xb503
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x2, -0xb503, x2, 1096, x1)

inst_294:
// rs1_val==2 and rs2_val==46341, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0xb505
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x2, 0xb505, x2, 1100, x1)

inst_295:
// rs1_val==1431655764 and rs2_val==3, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x3
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x55555554, 0x3, x2, 1104, x1)

inst_296:
// rs1_val==1431655764 and rs2_val==1431655765, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x55555555
TEST_RR_OP(and, x12, x10, x11, 0x55555554, 0x55555554, 0x55555555, x2, 1108, x1)

inst_297:
// rs1_val==1431655764 and rs2_val==-1431655766, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:-0x55555556
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x55555554, -0x55555556, x2, 1112, x1)

inst_298:
// rs1_val==1431655764 and rs2_val==5, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x5
TEST_RR_OP(and, x12, x10, x11, 0x4, 0x55555554, 0x5, x2, 1116, x1)

inst_299:
// rs1_val==1431655764 and rs2_val==858993459, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x33333333
TEST_RR_OP(and, x12, x10, x11, 0x11111110, 0x55555554, 0x33333333, x2, 1120, x1)

inst_300:
// rs1_val==1431655764 and rs2_val==1717986918, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x66666666
TEST_RR_OP(and, x12, x10, x11, 0x44444444, 0x55555554, 0x66666666, x2, 1124, x1)

inst_301:
// rs1_val==1431655764 and rs2_val==-46340, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:-0xb504
TEST_RR_OP(and, x12, x10, x11, 0x55554054, 0x55555554, -0xb504, x2, 1128, x1)

inst_302:
// rs1_val==1431655764 and rs2_val==46340, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0xb504
TEST_RR_OP(and, x12, x10, x11, 0x1504, 0x55555554, 0xb504, x2, 1132, x1)

inst_303:
// rs1_val==1431655764 and rs2_val==2, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x2
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x55555554, 0x2, x2, 1136, x1)

inst_304:
// rs1_val==1431655764 and rs2_val==1431655764, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x55555554
TEST_RR_OP(and, x12, x10, x11, 0x55555554, 0x55555554, 0x55555554, x2, 1140, x1)

inst_305:
// rs1_val==1431655764 and rs2_val==0, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x0
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x55555554, 0x0, x2, 1144, x1)

inst_306:
// rs1_val==1431655764 and rs2_val==4, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x4
TEST_RR_OP(and, x12, x10, x11, 0x4, 0x55555554, 0x4, x2, 1148, x1)

inst_307:
// rs1_val==1431655764 and rs2_val==858993458, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x33333332
TEST_RR_OP(and, x12, x10, x11, 0x11111110, 0x55555554, 0x33333332, x2, 1152, x1)

inst_308:
// rs1_val==1431655764 and rs2_val==1717986917, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x66666665
TEST_RR_OP(and, x12, x10, x11, 0x44444444, 0x55555554, 0x66666665, x2, 1156, x1)

inst_309:
// rs1_val==1431655764 and rs2_val==46339, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0xb503
TEST_RR_OP(and, x12, x10, x11, 0x1500, 0x55555554, 0xb503, x2, 1160, x1)

inst_310:
// rs1_val==1431655764 and rs2_val==1431655766, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x55555556
TEST_RR_OP(and, x12, x10, x11, 0x55555554, 0x55555554, 0x55555556, x2, 1164, x1)

inst_311:
// rs1_val==1431655764 and rs2_val==-1431655765, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:-0x55555555
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x55555554, -0x55555555, x2, 1168, x1)

inst_312:
// rs1_val==1431655764 and rs2_val==6, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x6
TEST_RR_OP(and, x12, x10, x11, 0x4, 0x55555554, 0x6, x2, 1172, x1)

inst_313:
// rs1_val==1431655764 and rs2_val==858993460, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x33333334
TEST_RR_OP(and, x12, x10, x11, 0x11111114, 0x55555554, 0x33333334, x2, 1176, x1)

inst_314:
// rs1_val==1431655764 and rs2_val==1717986919, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x66666667
TEST_RR_OP(and, x12, x10, x11, 0x44444444, 0x55555554, 0x66666667, x2, 1180, x1)

inst_315:
// rs1_val==1431655764 and rs2_val==-46339, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:-0xb503
TEST_RR_OP(and, x12, x10, x11, 0x55554054, 0x55555554, -0xb503, x2, 1184, x1)

inst_316:
// rs1_val==1431655764 and rs2_val==46341, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0xb505
TEST_RR_OP(and, x12, x10, x11, 0x1504, 0x55555554, 0xb505, x2, 1188, x1)

inst_317:
// rs1_val==0 and rs2_val==3, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x3
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x0, 0x3, x2, 1192, x1)

inst_318:
// rs1_val==0 and rs2_val==1431655765, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x55555555
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x0, 0x55555555, x2, 1196, x1)

inst_319:
// rs1_val==0 and rs2_val==-1431655766, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:-0x55555556
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x0, -0x55555556, x2, 1200, x1)

inst_320:
// rs1_val==0 and rs2_val==5, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x5
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x0, 0x5, x2, 1204, x1)

inst_321:
// rs1_val==0 and rs2_val==858993459, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x33333333
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x0, 0x33333333, x2, 1208, x1)

inst_322:
// rs1_val==0 and rs2_val==1717986918, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x66666666
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x0, 0x66666666, x2, 1212, x1)

inst_323:
// rs1_val==0 and rs2_val==-46340, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:-0xb504
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x0, -0xb504, x2, 1216, x1)

inst_324:
// rs1_val==0 and rs2_val==46340, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0xb504
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x0, 0xb504, x2, 1220, x1)

inst_325:
// rs1_val==0 and rs2_val==2, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x2
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x0, 0x2, x2, 1224, x1)

inst_326:
// rs1_val==-1431655765 and rs2_val==-1431655765, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:-0x55555555
TEST_RR_OP(and, x12, x10, x11, 0xaaaaaaab, -0x55555555, -0x55555555, x2, 1228, x1)

inst_327:
// rs1_val==-1431655765 and rs2_val==6, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x6
TEST_RR_OP(and, x12, x10, x11, 0x2, -0x55555555, 0x6, x2, 1232, x1)

inst_328:
// rs1_val==-1431655765 and rs2_val==858993460, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x33333334
TEST_RR_OP(and, x12, x10, x11, 0x22222220, -0x55555555, 0x33333334, x2, 1236, x1)

inst_329:
// rs1_val==-1431655765 and rs2_val==1717986919, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x66666667
TEST_RR_OP(and, x12, x10, x11, 0x22222223, -0x55555555, 0x66666667, x2, 1240, x1)

inst_330:
// rs1_val==-1431655765 and rs2_val==-46339, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:-0xb503
TEST_RR_OP(and, x12, x10, x11, 0xaaaa0aa9, -0x55555555, -0xb503, x2, 1244, x1)

inst_331:
// rs1_val==-1431655765 and rs2_val==46341, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0xb505
TEST_RR_OP(and, x12, x10, x11, 0xa001, -0x55555555, 0xb505, x2, 1248, x1)

inst_332:
// rs1_val==6 and rs2_val==3, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x3
TEST_RR_OP(and, x12, x10, x11, 0x2, 0x6, 0x3, x2, 1252, x1)

inst_333:
// rs1_val==6 and rs2_val==1431655765, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x55555555
TEST_RR_OP(and, x12, x10, x11, 0x4, 0x6, 0x55555555, x2, 1256, x1)

inst_334:
// rs1_val==6 and rs2_val==-1431655766, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:-0x55555556
TEST_RR_OP(and, x12, x10, x11, 0x2, 0x6, -0x55555556, x2, 1260, x1)

inst_335:
// rs1_val==6 and rs2_val==5, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x5
TEST_RR_OP(and, x12, x10, x11, 0x4, 0x6, 0x5, x2, 1264, x1)

inst_336:
// rs1_val==6 and rs2_val==858993459, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x33333333
TEST_RR_OP(and, x12, x10, x11, 0x2, 0x6, 0x33333333, x2, 1268, x1)

inst_337:
// rs1_val==6 and rs2_val==1717986918, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x66666666
TEST_RR_OP(and, x12, x10, x11, 0x6, 0x6, 0x66666666, x2, 1272, x1)

inst_338:
// rs1_val==6 and rs2_val==-46340, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:-0xb504
TEST_RR_OP(and, x12, x10, x11, 0x4, 0x6, -0xb504, x2, 1276, x1)

inst_339:
// rs1_val==6 and rs2_val==46340, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0xb504
TEST_RR_OP(and, x12, x10, x11, 0x4, 0x6, 0xb504, x2, 1280, x1)

inst_340:
// rs1_val==6 and rs2_val==2, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x2
TEST_RR_OP(and, x12, x10, x11, 0x2, 0x6, 0x2, x2, 1284, x1)

inst_341:
// rs1_val==6 and rs2_val==1431655764, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x55555554
TEST_RR_OP(and, x12, x10, x11, 0x4, 0x6, 0x55555554, x2, 1288, x1)

inst_342:
// rs1_val==6 and rs2_val==0, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x0
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x6, 0x0, x2, 1292, x1)

inst_343:
// rs1_val==6 and rs2_val==4, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x4
TEST_RR_OP(and, x12, x10, x11, 0x4, 0x6, 0x4, x2, 1296, x1)

inst_344:
// rs1_val==6 and rs2_val==858993458, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x33333332
TEST_RR_OP(and, x12, x10, x11, 0x2, 0x6, 0x33333332, x2, 1300, x1)

inst_345:
// rs1_val==6 and rs2_val==1717986917, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x66666665
TEST_RR_OP(and, x12, x10, x11, 0x4, 0x6, 0x66666665, x2, 1304, x1)

inst_346:
// rs1_val==6 and rs2_val==46339, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0xb503
TEST_RR_OP(and, x12, x10, x11, 0x2, 0x6, 0xb503, x2, 1308, x1)

inst_347:
// rs1_val==6 and rs2_val==1431655766, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x55555556
TEST_RR_OP(and, x12, x10, x11, 0x6, 0x6, 0x55555556, x2, 1312, x1)

inst_348:
// rs1_val==6 and rs2_val==-1431655765, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:-0x55555555
TEST_RR_OP(and, x12, x10, x11, 0x2, 0x6, -0x55555555, x2, 1316, x1)

inst_349:
// rs1_val==6 and rs2_val==6, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x6
TEST_RR_OP(and, x12, x10, x11, 0x6, 0x6, 0x6, x2, 1320, x1)

inst_350:
// rs1_val==6 and rs2_val==858993460, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x33333334
TEST_RR_OP(and, x12, x10, x11, 0x4, 0x6, 0x33333334, x2, 1324, x1)

inst_351:
// rs1_val==6 and rs2_val==1717986919, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x66666667
TEST_RR_OP(and, x12, x10, x11, 0x6, 0x6, 0x66666667, x2, 1328, x1)

inst_352:
// rs1_val==6 and rs2_val==-46339, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:-0xb503
TEST_RR_OP(and, x12, x10, x11, 0x4, 0x6, -0xb503, x2, 1332, x1)

inst_353:
// rs1_val==6 and rs2_val==46341, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0xb505
TEST_RR_OP(and, x12, x10, x11, 0x4, 0x6, 0xb505, x2, 1336, x1)

inst_354:
// rs1_val==858993460 and rs2_val==3, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x3
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x33333334, 0x3, x2, 1340, x1)

inst_355:
// rs1_val==858993460 and rs2_val==1431655765, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x55555555
TEST_RR_OP(and, x12, x10, x11, 0x11111114, 0x33333334, 0x55555555, x2, 1344, x1)

inst_356:
// rs1_val==858993460 and rs2_val==-1431655766, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:-0x55555556
TEST_RR_OP(and, x12, x10, x11, 0x22222220, 0x33333334, -0x55555556, x2, 1348, x1)

inst_357:
// rs1_val==858993460 and rs2_val==5, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x5
TEST_RR_OP(and, x12, x10, x11, 0x4, 0x33333334, 0x5, x2, 1352, x1)

inst_358:
// rs1_val==858993460 and rs2_val==858993459, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x33333333
TEST_RR_OP(and, x12, x10, x11, 0x33333330, 0x33333334, 0x33333333, x2, 1356, x1)

inst_359:
// rs1_val==858993460 and rs2_val==1717986918, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x66666666
TEST_RR_OP(and, x12, x10, x11, 0x22222224, 0x33333334, 0x66666666, x2, 1360, x1)

inst_360:
// rs1_val==858993460 and rs2_val==-46340, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:-0xb504
TEST_RR_OP(and, x12, x10, x11, 0x33330234, 0x33333334, -0xb504, x2, 1364, x1)

inst_361:
// rs1_val==858993460 and rs2_val==46340, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0xb504
TEST_RR_OP(and, x12, x10, x11, 0x3104, 0x33333334, 0xb504, x2, 1368, x1)

inst_362:
// rs1_val==858993460 and rs2_val==2, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x2
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x33333334, 0x2, x2, 1372, x1)

inst_363:
// rs1_val==858993460 and rs2_val==1431655764, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x55555554
TEST_RR_OP(and, x12, x10, x11, 0x11111114, 0x33333334, 0x55555554, x2, 1376, x1)

inst_364:
// rs1_val==858993460 and rs2_val==0, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x0
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x33333334, 0x0, x2, 1380, x1)

inst_365:
// rs1_val==858993460 and rs2_val==4, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x4
TEST_RR_OP(and, x12, x10, x11, 0x4, 0x33333334, 0x4, x2, 1384, x1)

inst_366:
// rs1_val==858993460 and rs2_val==858993458, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x33333332
TEST_RR_OP(and, x12, x10, x11, 0x33333330, 0x33333334, 0x33333332, x2, 1388, x1)

inst_367:
// rs1_val==858993460 and rs2_val==1717986917, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x66666665
TEST_RR_OP(and, x12, x10, x11, 0x22222224, 0x33333334, 0x66666665, x2, 1392, x1)

inst_368:
// rs1_val==858993460 and rs2_val==46339, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0xb503
TEST_RR_OP(and, x12, x10, x11, 0x3100, 0x33333334, 0xb503, x2, 1396, x1)

inst_369:
// rs1_val==858993460 and rs2_val==1431655766, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x55555556
TEST_RR_OP(and, x12, x10, x11, 0x11111114, 0x33333334, 0x55555556, x2, 1400, x1)

inst_370:
// rs1_val==858993460 and rs2_val==-1431655765, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:-0x55555555
TEST_RR_OP(and, x12, x10, x11, 0x22222220, 0x33333334, -0x55555555, x2, 1404, x1)

inst_371:
// rs1_val==858993460 and rs2_val==6, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x6
TEST_RR_OP(and, x12, x10, x11, 0x4, 0x33333334, 0x6, x2, 1408, x1)

inst_372:
// rs1_val==858993460 and rs2_val==858993460, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x33333334
TEST_RR_OP(and, x12, x10, x11, 0x33333334, 0x33333334, 0x33333334, x2, 1412, x1)

inst_373:
// rs1_val==858993460 and rs2_val==1717986919, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x66666667
TEST_RR_OP(and, x12, x10, x11, 0x22222224, 0x33333334, 0x66666667, x2, 1416, x1)

inst_374:
// rs1_val==858993460 and rs2_val==-46339, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:-0xb503
TEST_RR_OP(and, x12, x10, x11, 0x33330234, 0x33333334, -0xb503, x2, 1420, x1)

inst_375:
// rs1_val==858993460 and rs2_val==46341, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0xb505
TEST_RR_OP(and, x12, x10, x11, 0x3104, 0x33333334, 0xb505, x2, 1424, x1)

inst_376:
// rs1_val==1717986919 and rs2_val==3, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x3
TEST_RR_OP(and, x12, x10, x11, 0x3, 0x66666667, 0x3, x2, 1428, x1)

inst_377:
// rs1_val==1717986919 and rs2_val==1431655765, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x55555555
TEST_RR_OP(and, x12, x10, x11, 0x44444445, 0x66666667, 0x55555555, x2, 1432, x1)

inst_378:
// rs1_val==1717986919 and rs2_val==-1431655766, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:-0x55555556
TEST_RR_OP(and, x12, x10, x11, 0x22222222, 0x66666667, -0x55555556, x2, 1436, x1)

inst_379:
// rs1_val==1717986919 and rs2_val==5, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x5
TEST_RR_OP(and, x12, x10, x11, 0x5, 0x66666667, 0x5, x2, 1440, x1)

inst_380:
// rs1_val==1717986919 and rs2_val==858993459, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x33333333
TEST_RR_OP(and, x12, x10, x11, 0x22222223, 0x66666667, 0x33333333, x2, 1444, x1)

inst_381:
// rs1_val==1717986919 and rs2_val==1717986918, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x66666666
TEST_RR_OP(and, x12, x10, x11, 0x66666666, 0x66666667, 0x66666666, x2, 1448, x1)

inst_382:
// rs1_val==1717986919 and rs2_val==-46340, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:-0xb504
TEST_RR_OP(and, x12, x10, x11, 0x66664264, 0x66666667, -0xb504, x2, 1452, x1)

inst_383:
// rs1_val==1717986919 and rs2_val==46340, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0xb504
TEST_RR_OP(and, x12, x10, x11, 0x2404, 0x66666667, 0xb504, x2, 1456, x1)

inst_384:
// rs1_val==1717986919 and rs2_val==2, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x2
TEST_RR_OP(and, x12, x10, x11, 0x2, 0x66666667, 0x2, x2, 1460, x1)

inst_385:
// rs1_val==1717986919 and rs2_val==1431655764, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x55555554
TEST_RR_OP(and, x12, x10, x11, 0x44444444, 0x66666667, 0x55555554, x2, 1464, x1)

inst_386:
// rs1_val==1717986919 and rs2_val==0, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x0
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x66666667, 0x0, x2, 1468, x1)

inst_387:
// rs1_val==1717986919 and rs2_val==4, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x4
TEST_RR_OP(and, x12, x10, x11, 0x4, 0x66666667, 0x4, x2, 1472, x1)

inst_388:
// rs1_val==1717986919 and rs2_val==858993458, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x33333332
TEST_RR_OP(and, x12, x10, x11, 0x22222222, 0x66666667, 0x33333332, x2, 1476, x1)

inst_389:
// rs1_val==1717986919 and rs2_val==1717986917, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x66666665
TEST_RR_OP(and, x12, x10, x11, 0x66666665, 0x66666667, 0x66666665, x2, 1480, x1)

inst_390:
// rs1_val==1717986919 and rs2_val==46339, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0xb503
TEST_RR_OP(and, x12, x10, x11, 0x2403, 0x66666667, 0xb503, x2, 1484, x1)

inst_391:
// rs1_val==1717986919 and rs2_val==1431655766, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x55555556
TEST_RR_OP(and, x12, x10, x11, 0x44444446, 0x66666667, 0x55555556, x2, 1488, x1)

inst_392:
// rs1_val==1717986919 and rs2_val==-1431655765, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:-0x55555555
TEST_RR_OP(and, x12, x10, x11, 0x22222223, 0x66666667, -0x55555555, x2, 1492, x1)

inst_393:
// rs1_val==1717986919 and rs2_val==6, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x6
TEST_RR_OP(and, x12, x10, x11, 0x6, 0x66666667, 0x6, x2, 1496, x1)

inst_394:
// rs1_val==1717986919 and rs2_val==858993460, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x33333334
TEST_RR_OP(and, x12, x10, x11, 0x22222224, 0x66666667, 0x33333334, x2, 1500, x1)

inst_395:
// rs1_val==1717986919 and rs2_val==1717986919, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x66666667
TEST_RR_OP(and, x12, x10, x11, 0x66666667, 0x66666667, 0x66666667, x2, 1504, x1)

inst_396:
// rs1_val==1717986919 and rs2_val==-46339, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:-0xb503
TEST_RR_OP(and, x12, x10, x11, 0x66664265, 0x66666667, -0xb503, x2, 1508, x1)

inst_397:
// rs1_val==1717986919 and rs2_val==46341, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0xb505
TEST_RR_OP(and, x12, x10, x11, 0x2405, 0x66666667, 0xb505, x2, 1512, x1)

inst_398:
// rs1_val==-46339 and rs2_val==3, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x3
TEST_RR_OP(and, x12, x10, x11, 0x1, -0xb503, 0x3, x2, 1516, x1)

inst_399:
// rs1_val==-46339 and rs2_val==1431655765, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x55555555
TEST_RR_OP(and, x12, x10, x11, 0x55554055, -0xb503, 0x55555555, x2, 1520, x1)

inst_400:
// rs1_val==-46339 and rs2_val==-1431655766, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:-0x55555556
TEST_RR_OP(and, x12, x10, x11, 0xaaaa0aa8, -0xb503, -0x55555556, x2, 1524, x1)

inst_401:
// rs1_val==-46339 and rs2_val==5, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x5
TEST_RR_OP(and, x12, x10, x11, 0x5, -0xb503, 0x5, x2, 1528, x1)

inst_402:
// rs1_val==-46339 and rs2_val==858993459, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x33333333
TEST_RR_OP(and, x12, x10, x11, 0x33330231, -0xb503, 0x33333333, x2, 1532, x1)

inst_403:
// rs1_val==-46339 and rs2_val==1717986918, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x66666666
TEST_RR_OP(and, x12, x10, x11, 0x66664264, -0xb503, 0x66666666, x2, 1536, x1)

inst_404:
// rs1_val==-46339 and rs2_val==-46340, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:-0xb504
TEST_RR_OP(and, x12, x10, x11, 0xffff4afc, -0xb503, -0xb504, x2, 1540, x1)

inst_405:
// rs1_val==-46339 and rs2_val==46340, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0xb504
TEST_RR_OP(and, x12, x10, x11, 0x4, -0xb503, 0xb504, x2, 1544, x1)

inst_406:
// rs1_val==-46339 and rs2_val==2, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x2
TEST_RR_OP(and, x12, x10, x11, 0x0, -0xb503, 0x2, x2, 1548, x1)

inst_407:
// rs1_val==-46339 and rs2_val==1431655764, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x55555554
TEST_RR_OP(and, x12, x10, x11, 0x55554054, -0xb503, 0x55555554, x2, 1552, x1)

inst_408:
// rs1_val==-46339 and rs2_val==0, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x0
TEST_RR_OP(and, x12, x10, x11, 0x0, -0xb503, 0x0, x2, 1556, x1)

inst_409:
// rs1_val==-46339 and rs2_val==4, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x4
TEST_RR_OP(and, x12, x10, x11, 0x4, -0xb503, 0x4, x2, 1560, x1)

inst_410:
// rs1_val==-46339 and rs2_val==858993458, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x33333332
TEST_RR_OP(and, x12, x10, x11, 0x33330230, -0xb503, 0x33333332, x2, 1564, x1)

inst_411:
// rs1_val==-46339 and rs2_val==1717986917, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x66666665
TEST_RR_OP(and, x12, x10, x11, 0x66664265, -0xb503, 0x66666665, x2, 1568, x1)

inst_412:
// rs1_val==-46339 and rs2_val==46339, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0xb503
TEST_RR_OP(and, x12, x10, x11, 0x1, -0xb503, 0xb503, x2, 1572, x1)

inst_413:
// rs1_val==-46339 and rs2_val==1431655766, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x55555556
TEST_RR_OP(and, x12, x10, x11, 0x55554054, -0xb503, 0x55555556, x2, 1576, x1)

inst_414:
// rs1_val==-46339 and rs2_val==-1431655765, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:-0x55555555
TEST_RR_OP(and, x12, x10, x11, 0xaaaa0aa9, -0xb503, -0x55555555, x2, 1580, x1)

inst_415:
// rs1_val==-46339 and rs2_val==6, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x6
TEST_RR_OP(and, x12, x10, x11, 0x4, -0xb503, 0x6, x2, 1584, x1)

inst_416:
// rs1_val==-46339 and rs2_val==858993460, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x33333334
TEST_RR_OP(and, x12, x10, x11, 0x33330234, -0xb503, 0x33333334, x2, 1588, x1)

inst_417:
// rs1_val==-46339 and rs2_val==1717986919, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x66666667
TEST_RR_OP(and, x12, x10, x11, 0x66664265, -0xb503, 0x66666667, x2, 1592, x1)

inst_418:
// rs1_val==-46339 and rs2_val==-46339, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:-0xb503
TEST_RR_OP(and, x12, x10, x11, 0xffff4afd, -0xb503, -0xb503, x2, 1596, x1)

inst_419:
// rs1_val==-46339 and rs2_val==46341, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0xb505
TEST_RR_OP(and, x12, x10, x11, 0x5, -0xb503, 0xb505, x2, 1600, x1)

inst_420:
// rs1_val==46341 and rs2_val==3, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x3
TEST_RR_OP(and, x12, x10, x11, 0x1, 0xb505, 0x3, x2, 1604, x1)

inst_421:
// rs1_val==46341 and rs2_val==1431655765, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x55555555
TEST_RR_OP(and, x12, x10, x11, 0x1505, 0xb505, 0x55555555, x2, 1608, x1)

inst_422:
// rs1_val==46341 and rs2_val==-1431655766, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:-0x55555556
TEST_RR_OP(and, x12, x10, x11, 0xa000, 0xb505, -0x55555556, x2, 1612, x1)

inst_423:
// rs1_val==46341 and rs2_val==5, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x5
TEST_RR_OP(and, x12, x10, x11, 0x5, 0xb505, 0x5, x2, 1616, x1)

inst_424:
// rs1_val==46341 and rs2_val==858993459, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x33333333
TEST_RR_OP(and, x12, x10, x11, 0x3101, 0xb505, 0x33333333, x2, 1620, x1)

inst_425:
// rs1_val==46341 and rs2_val==1717986918, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x66666666
TEST_RR_OP(and, x12, x10, x11, 0x2404, 0xb505, 0x66666666, x2, 1624, x1)

inst_426:
// rs1_val==46341 and rs2_val==-46340, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:-0xb504
TEST_RR_OP(and, x12, x10, x11, 0x4, 0xb505, -0xb504, x2, 1628, x1)

inst_427:
// rs1_val==46341 and rs2_val==46340, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0xb504
TEST_RR_OP(and, x12, x10, x11, 0xb504, 0xb505, 0xb504, x2, 1632, x1)

inst_428:
// rs1_val==46341 and rs2_val==2, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x2
TEST_RR_OP(and, x12, x10, x11, 0x0, 0xb505, 0x2, x2, 1636, x1)

inst_429:
// rs1_val==46341 and rs2_val==1431655764, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x55555554
TEST_RR_OP(and, x12, x10, x11, 0x1504, 0xb505, 0x55555554, x2, 1640, x1)

inst_430:
// rs1_val==46341 and rs2_val==0, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x0
TEST_RR_OP(and, x12, x10, x11, 0x0, 0xb505, 0x0, x2, 1644, x1)

inst_431:
// rs1_val==46341 and rs2_val==4, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x4
TEST_RR_OP(and, x12, x10, x11, 0x4, 0xb505, 0x4, x2, 1648, x1)

inst_432:
// rs1_val==46341 and rs2_val==858993458, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x33333332
TEST_RR_OP(and, x12, x10, x11, 0x3100, 0xb505, 0x33333332, x2, 1652, x1)

inst_433:
// rs1_val==46341 and rs2_val==1717986917, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x66666665
TEST_RR_OP(and, x12, x10, x11, 0x2405, 0xb505, 0x66666665, x2, 1656, x1)

inst_434:
// rs1_val==46341 and rs2_val==46339, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0xb503
TEST_RR_OP(and, x12, x10, x11, 0xb501, 0xb505, 0xb503, x2, 1660, x1)

inst_435:
// rs1_val==46341 and rs2_val==1431655766, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x55555556
TEST_RR_OP(and, x12, x10, x11, 0x1504, 0xb505, 0x55555556, x2, 1664, x1)

inst_436:
// rs1_val==46341 and rs2_val==-1431655765, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:-0x55555555
TEST_RR_OP(and, x12, x10, x11, 0xa001, 0xb505, -0x55555555, x2, 1668, x1)

inst_437:
// rs1_val==46341 and rs2_val==6, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x6
TEST_RR_OP(and, x12, x10, x11, 0x4, 0xb505, 0x6, x2, 1672, x1)

inst_438:
// rs1_val==46341 and rs2_val==858993460, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x33333334
TEST_RR_OP(and, x12, x10, x11, 0x3104, 0xb505, 0x33333334, x2, 1676, x1)

inst_439:
// rs1_val==46341 and rs2_val==1717986919, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x66666667
TEST_RR_OP(and, x12, x10, x11, 0x2405, 0xb505, 0x66666667, x2, 1680, x1)

inst_440:
// rs1_val==46341 and rs2_val==-46339, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:-0xb503
TEST_RR_OP(and, x12, x10, x11, 0x5, 0xb505, -0xb503, x2, 1684, x1)

inst_441:
// rs1_val==46341 and rs2_val==46341, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0xb505
TEST_RR_OP(and, x12, x10, x11, 0xb505, 0xb505, 0xb505, x2, 1688, x1)

inst_442:
// rs1_val==0 and rs2_val==1431655764, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x55555554
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x0, 0x55555554, x2, 1692, x1)

inst_443:
// rs1_val==0 and rs2_val==0, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x0
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x0, 0x0, x2, 1696, x1)

inst_444:
// rs1_val==0 and rs2_val==4, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x4
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x0, 0x4, x2, 1700, x1)

inst_445:
// rs1_val==0 and rs2_val==858993458, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x33333332
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x0, 0x33333332, x2, 1704, x1)

inst_446:
// rs1_val==0 and rs2_val==1717986917, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x66666665
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x0, 0x66666665, x2, 1708, x1)

inst_447:
// rs1_val==0 and rs2_val==46339, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0xb503
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x0, 0xb503, x2, 1712, x1)

inst_448:
// rs1_val==0 and rs2_val==1431655766, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x55555556
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x0, 0x55555556, x2, 1716, x1)

inst_449:
// rs1_val==0 and rs2_val==-1431655765, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:-0x55555555
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x0, -0x55555555, x2, 1720, x1)

inst_450:
// rs1_val==0 and rs2_val==6, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x6
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x0, 0x6, x2, 1724, x1)

inst_451:
// rs1_val==0 and rs2_val==858993460, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x33333334
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x0, 0x33333334, x2, 1728, x1)

inst_452:
// rs1_val==0 and rs2_val==1717986919, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x66666667
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x0, 0x66666667, x2, 1732, x1)

inst_453:
// rs1_val==0 and rs2_val==-46339, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:-0xb503
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x0, -0xb503, x2, 1736, x1)

inst_454:
// rs1_val==0 and rs2_val==46341, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0xb505
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x0, 0xb505, x2, 1740, x1)

inst_455:
// rs1_val==4 and rs2_val==3, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x3
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x4, 0x3, x2, 1744, x1)

inst_456:
// rs1_val==4 and rs2_val==1431655765, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x55555555
TEST_RR_OP(and, x12, x10, x11, 0x4, 0x4, 0x55555555, x2, 1748, x1)

inst_457:
// rs1_val==4 and rs2_val==-1431655766, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:-0x55555556
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x4, -0x55555556, x2, 1752, x1)

inst_458:
// rs1_val==4 and rs2_val==5, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x5
TEST_RR_OP(and, x12, x10, x11, 0x4, 0x4, 0x5, x2, 1756, x1)

inst_459:
// rs1_val==4 and rs2_val==858993459, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x33333333
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x4, 0x33333333, x2, 1760, x1)

inst_460:
// rs1_val==4 and rs2_val==1717986918, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x66666666
TEST_RR_OP(and, x12, x10, x11, 0x4, 0x4, 0x66666666, x2, 1764, x1)

inst_461:
// rs1_val==4 and rs2_val==-46340, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:-0xb504
TEST_RR_OP(and, x12, x10, x11, 0x4, 0x4, -0xb504, x2, 1768, x1)

inst_462:
// rs1_val==4 and rs2_val==46340, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0xb504
TEST_RR_OP(and, x12, x10, x11, 0x4, 0x4, 0xb504, x2, 1772, x1)

inst_463:
// rs1_val==4 and rs2_val==2, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x2
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x4, 0x2, x2, 1776, x1)

inst_464:
// rs1_val==4 and rs2_val==1431655764, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x55555554
TEST_RR_OP(and, x12, x10, x11, 0x4, 0x4, 0x55555554, x2, 1780, x1)

inst_465:
// rs1_val==4 and rs2_val==0, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x0
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x4, 0x0, x2, 1784, x1)

inst_466:
// rs1_val==4 and rs2_val==4, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x4
TEST_RR_OP(and, x12, x10, x11, 0x4, 0x4, 0x4, x2, 1788, x1)

inst_467:
// rs1_val==4 and rs2_val==858993458, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x33333332
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x4, 0x33333332, x2, 1792, x1)

inst_468:
// rs1_val==4 and rs2_val==1717986917, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x66666665
TEST_RR_OP(and, x12, x10, x11, 0x4, 0x4, 0x66666665, x2, 1796, x1)

inst_469:
// rs1_val==4 and rs2_val==46339, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0xb503
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x4, 0xb503, x2, 1800, x1)

inst_470:
// rs1_val==4 and rs2_val==1431655766, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x55555556
TEST_RR_OP(and, x12, x10, x11, 0x4, 0x4, 0x55555556, x2, 1804, x1)

inst_471:
// rs1_val==4 and rs2_val==-1431655765, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:-0x55555555
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x4, -0x55555555, x2, 1808, x1)

inst_472:
// rs1_val==4 and rs2_val==6, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x6
TEST_RR_OP(and, x12, x10, x11, 0x4, 0x4, 0x6, x2, 1812, x1)

inst_473:
// rs1_val==4 and rs2_val==858993460, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x33333334
TEST_RR_OP(and, x12, x10, x11, 0x4, 0x4, 0x33333334, x2, 1816, x1)

inst_474:
// rs1_val==4 and rs2_val==1717986919, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x66666667
TEST_RR_OP(and, x12, x10, x11, 0x4, 0x4, 0x66666667, x2, 1820, x1)

inst_475:
// rs1_val==4 and rs2_val==-46339, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:-0xb503
TEST_RR_OP(and, x12, x10, x11, 0x4, 0x4, -0xb503, x2, 1824, x1)

inst_476:
// rs1_val==4 and rs2_val==46341, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0xb505
TEST_RR_OP(and, x12, x10, x11, 0x4, 0x4, 0xb505, x2, 1828, x1)

inst_477:
// rs1_val==858993458 and rs2_val==3, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x3
TEST_RR_OP(and, x12, x10, x11, 0x2, 0x33333332, 0x3, x2, 1832, x1)

inst_478:
// rs1_val==858993458 and rs2_val==1431655765, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x55555555
TEST_RR_OP(and, x12, x10, x11, 0x11111110, 0x33333332, 0x55555555, x2, 1836, x1)

inst_479:
// rs1_val==858993458 and rs2_val==-1431655766, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:-0x55555556
TEST_RR_OP(and, x12, x10, x11, 0x22222222, 0x33333332, -0x55555556, x2, 1840, x1)

inst_480:
// rs1_val==858993458 and rs2_val==5, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x5
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x33333332, 0x5, x2, 1844, x1)

inst_481:
// rs1_val==858993458 and rs2_val==858993459, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x33333333
TEST_RR_OP(and, x12, x10, x11, 0x33333332, 0x33333332, 0x33333333, x2, 1848, x1)

inst_482:
// rs1_val==858993458 and rs2_val==1717986918, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x66666666
TEST_RR_OP(and, x12, x10, x11, 0x22222222, 0x33333332, 0x66666666, x2, 1852, x1)

inst_483:
// rs1_val==858993458 and rs2_val==-46340, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:-0xb504
TEST_RR_OP(and, x12, x10, x11, 0x33330230, 0x33333332, -0xb504, x2, 1856, x1)

inst_484:
// rs1_val==858993458 and rs2_val==46340, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0xb504
TEST_RR_OP(and, x12, x10, x11, 0x3100, 0x33333332, 0xb504, x2, 1860, x1)

inst_485:
// rs1_val==858993458 and rs2_val==2, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x2
TEST_RR_OP(and, x12, x10, x11, 0x2, 0x33333332, 0x2, x2, 1864, x1)

inst_486:
// rs1_val==858993458 and rs2_val==1431655764, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x55555554
TEST_RR_OP(and, x12, x10, x11, 0x11111110, 0x33333332, 0x55555554, x2, 1868, x1)

inst_487:
// rs1_val==858993458 and rs2_val==0, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x0
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x33333332, 0x0, x2, 1872, x1)

inst_488:
// rs1_val==858993458 and rs2_val==4, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x4
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x33333332, 0x4, x2, 1876, x1)

inst_489:
// rs1_val==858993458 and rs2_val==858993458, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x33333332
TEST_RR_OP(and, x12, x10, x11, 0x33333332, 0x33333332, 0x33333332, x2, 1880, x1)

inst_490:
// rs1_val==858993458 and rs2_val==1717986917, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x66666665
TEST_RR_OP(and, x12, x10, x11, 0x22222220, 0x33333332, 0x66666665, x2, 1884, x1)

inst_491:
// rs1_val==858993458 and rs2_val==46339, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0xb503
TEST_RR_OP(and, x12, x10, x11, 0x3102, 0x33333332, 0xb503, x2, 1888, x1)

inst_492:
// rs1_val==858993458 and rs2_val==1431655766, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x55555556
TEST_RR_OP(and, x12, x10, x11, 0x11111112, 0x33333332, 0x55555556, x2, 1892, x1)

inst_493:
// rs1_val==858993458 and rs2_val==-1431655765, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:-0x55555555
TEST_RR_OP(and, x12, x10, x11, 0x22222222, 0x33333332, -0x55555555, x2, 1896, x1)

inst_494:
// rs1_val==858993458 and rs2_val==6, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x6
TEST_RR_OP(and, x12, x10, x11, 0x2, 0x33333332, 0x6, x2, 1900, x1)

inst_495:
// rs1_val==858993458 and rs2_val==858993460, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x33333334
TEST_RR_OP(and, x12, x10, x11, 0x33333330, 0x33333332, 0x33333334, x2, 1904, x1)

inst_496:
// rs1_val==858993458 and rs2_val==1717986919, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x66666667
TEST_RR_OP(and, x12, x10, x11, 0x22222222, 0x33333332, 0x66666667, x2, 1908, x1)

inst_497:
// rs1_val==858993458 and rs2_val==-46339, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:-0xb503
TEST_RR_OP(and, x12, x10, x11, 0x33330230, 0x33333332, -0xb503, x2, 1912, x1)

inst_498:
// rs1_val==858993458 and rs2_val==46341, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0xb505
TEST_RR_OP(and, x12, x10, x11, 0x3100, 0x33333332, 0xb505, x2, 1916, x1)

inst_499:
// rs1_val==1717986917 and rs2_val==3, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x3
TEST_RR_OP(and, x12, x10, x11, 0x1, 0x66666665, 0x3, x2, 1920, x1)

inst_500:
// rs1_val==1717986917 and rs2_val==1431655765, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x55555555
TEST_RR_OP(and, x12, x10, x11, 0x44444445, 0x66666665, 0x55555555, x2, 1924, x1)

inst_501:
// rs1_val==1717986917 and rs2_val==-1431655766, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:-0x55555556
TEST_RR_OP(and, x12, x10, x11, 0x22222220, 0x66666665, -0x55555556, x2, 1928, x1)

inst_502:
// rs1_val==1717986917 and rs2_val==5, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x5
TEST_RR_OP(and, x12, x10, x11, 0x5, 0x66666665, 0x5, x2, 1932, x1)

inst_503:
// rs1_val==1717986917 and rs2_val==858993459, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x33333333
TEST_RR_OP(and, x12, x10, x11, 0x22222221, 0x66666665, 0x33333333, x2, 1936, x1)

inst_504:
// rs1_val==1717986917 and rs2_val==1717986918, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x66666666
TEST_RR_OP(and, x12, x10, x11, 0x66666664, 0x66666665, 0x66666666, x2, 1940, x1)

inst_505:
// rs1_val==1717986917 and rs2_val==-46340, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:-0xb504
TEST_RR_OP(and, x12, x10, x11, 0x66664264, 0x66666665, -0xb504, x2, 1944, x1)

inst_506:
// rs1_val==1717986917 and rs2_val==46340, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0xb504
TEST_RR_OP(and, x12, x10, x11, 0x2404, 0x66666665, 0xb504, x2, 1948, x1)

inst_507:
// rs1_val==1717986917 and rs2_val==2, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x2
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x66666665, 0x2, x2, 1952, x1)

inst_508:
// rs1_val==1717986917 and rs2_val==1431655764, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x55555554
TEST_RR_OP(and, x12, x10, x11, 0x44444444, 0x66666665, 0x55555554, x2, 1956, x1)

inst_509:
// rs1_val==1717986917 and rs2_val==0, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x0
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x66666665, 0x0, x2, 1960, x1)

inst_510:
// rs1_val==1717986917 and rs2_val==4, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x4
TEST_RR_OP(and, x12, x10, x11, 0x4, 0x66666665, 0x4, x2, 1964, x1)

inst_511:
// rs1_val==1717986917 and rs2_val==858993458, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x33333332
TEST_RR_OP(and, x12, x10, x11, 0x22222220, 0x66666665, 0x33333332, x2, 1968, x1)

inst_512:
// rs1_val==1717986917 and rs2_val==1717986917, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x66666665
TEST_RR_OP(and, x12, x10, x11, 0x66666665, 0x66666665, 0x66666665, x2, 1972, x1)

inst_513:
// rs1_val==1717986917 and rs2_val==46339, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0xb503
TEST_RR_OP(and, x12, x10, x11, 0x2401, 0x66666665, 0xb503, x2, 1976, x1)

inst_514:
// rs1_val==1717986917 and rs2_val==1431655766, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x55555556
TEST_RR_OP(and, x12, x10, x11, 0x44444444, 0x66666665, 0x55555556, x2, 1980, x1)

inst_515:
// rs1_val==1717986917 and rs2_val==-1431655765, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:-0x55555555
TEST_RR_OP(and, x12, x10, x11, 0x22222221, 0x66666665, -0x55555555, x2, 1984, x1)

inst_516:
// rs1_val==1717986917 and rs2_val==6, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x6
TEST_RR_OP(and, x12, x10, x11, 0x4, 0x66666665, 0x6, x2, 1988, x1)

inst_517:
// rs1_val==1717986917 and rs2_val==858993460, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x33333334
TEST_RR_OP(and, x12, x10, x11, 0x22222224, 0x66666665, 0x33333334, x2, 1992, x1)

inst_518:
// rs1_val==1717986917 and rs2_val==1717986919, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x66666667
TEST_RR_OP(and, x12, x10, x11, 0x66666665, 0x66666665, 0x66666667, x2, 1996, x1)

inst_519:
// rs1_val==1717986917 and rs2_val==-46339, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:-0xb503
TEST_RR_OP(and, x12, x10, x11, 0x66664265, 0x66666665, -0xb503, x2, 2000, x1)

inst_520:
// rs1_val==1717986917 and rs2_val==46341, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0xb505
TEST_RR_OP(and, x12, x10, x11, 0x2405, 0x66666665, 0xb505, x2, 2004, x1)

inst_521:
// rs1_val==46339 and rs2_val==3, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x3
TEST_RR_OP(and, x12, x10, x11, 0x3, 0xb503, 0x3, x2, 2008, x1)

inst_522:
// rs1_val==46339 and rs2_val==1431655765, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x55555555
TEST_RR_OP(and, x12, x10, x11, 0x1501, 0xb503, 0x55555555, x2, 2012, x1)

inst_523:
// rs1_val==46339 and rs2_val==-1431655766, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:-0x55555556
TEST_RR_OP(and, x12, x10, x11, 0xa002, 0xb503, -0x55555556, x2, 2016, x1)

inst_524:
// rs1_val==46339 and rs2_val==5, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x5
TEST_RR_OP(and, x12, x10, x11, 0x1, 0xb503, 0x5, x2, 2020, x1)

inst_525:
// rs1_val==46339 and rs2_val==858993459, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x33333333
TEST_RR_OP(and, x12, x10, x11, 0x3103, 0xb503, 0x33333333, x2, 2024, x1)

inst_526:
// rs1_val==46339 and rs2_val==1717986918, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x66666666
TEST_RR_OP(and, x12, x10, x11, 0x2402, 0xb503, 0x66666666, x2, 2028, x1)

inst_527:
// rs1_val==46339 and rs2_val==-46340, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:-0xb504
TEST_RR_OP(and, x12, x10, x11, 0x0, 0xb503, -0xb504, x2, 2032, x1)

inst_528:
// rs1_val==46339 and rs2_val==46340, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0xb504
TEST_RR_OP(and, x12, x10, x11, 0xb500, 0xb503, 0xb504, x2, 2036, x1)

inst_529:
// rs1_val==46339 and rs2_val==2, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x2
TEST_RR_OP(and, x12, x10, x11, 0x2, 0xb503, 0x2, x2, 2040, x1)

inst_530:
// rs1_val==46339 and rs2_val==1431655764, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x55555554
TEST_RR_OP(and, x12, x10, x11, 0x1500, 0xb503, 0x55555554, x2, 2044, x1)
RVTEST_SIGBASE( x2,signature_x2_1)

inst_531:
// rs1_val==46339 and rs2_val==0, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x0
TEST_RR_OP(and, x12, x10, x11, 0x0, 0xb503, 0x0, x2, 0, x1)

inst_532:
// rs1_val==46339 and rs2_val==4, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x4
TEST_RR_OP(and, x12, x10, x11, 0x0, 0xb503, 0x4, x2, 4, x1)

inst_533:
// rs1_val==46339 and rs2_val==858993458, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x33333332
TEST_RR_OP(and, x12, x10, x11, 0x3102, 0xb503, 0x33333332, x2, 8, x1)

inst_534:
// rs1_val==46339 and rs2_val==1717986917, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x66666665
TEST_RR_OP(and, x12, x10, x11, 0x2401, 0xb503, 0x66666665, x2, 12, x1)

inst_535:
// rs1_val==46339 and rs2_val==46339, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0xb503
TEST_RR_OP(and, x12, x10, x11, 0xb503, 0xb503, 0xb503, x2, 16, x1)

inst_536:
// rs1_val==46339 and rs2_val==1431655766, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x55555556
TEST_RR_OP(and, x12, x10, x11, 0x1502, 0xb503, 0x55555556, x2, 20, x1)

inst_537:
// rs1_val==46339 and rs2_val==-1431655765, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:-0x55555555
TEST_RR_OP(and, x12, x10, x11, 0xa003, 0xb503, -0x55555555, x2, 24, x1)

inst_538:
// rs1_val==46339 and rs2_val==6, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x6
TEST_RR_OP(and, x12, x10, x11, 0x2, 0xb503, 0x6, x2, 28, x1)

inst_539:
// rs1_val==46339 and rs2_val==858993460, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x33333334
TEST_RR_OP(and, x12, x10, x11, 0x3100, 0xb503, 0x33333334, x2, 32, x1)

inst_540:
// rs1_val==46339 and rs2_val==1717986919, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x66666667
TEST_RR_OP(and, x12, x10, x11, 0x2403, 0xb503, 0x66666667, x2, 36, x1)

inst_541:
// rs1_val==46339 and rs2_val==-46339, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:-0xb503
TEST_RR_OP(and, x12, x10, x11, 0x1, 0xb503, -0xb503, x2, 40, x1)

inst_542:
// rs1_val==46339 and rs2_val==46341, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0xb505
TEST_RR_OP(and, x12, x10, x11, 0xb501, 0xb503, 0xb505, x2, 44, x1)

inst_543:
// rs1_val==1431655766 and rs2_val==3, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x3
TEST_RR_OP(and, x12, x10, x11, 0x2, 0x55555556, 0x3, x2, 48, x1)

inst_544:
// rs1_val==1431655766 and rs2_val==1431655765, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x55555555
TEST_RR_OP(and, x12, x10, x11, 0x55555554, 0x55555556, 0x55555555, x2, 52, x1)

inst_545:
// rs1_val==1431655766 and rs2_val==-1431655766, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:-0x55555556
TEST_RR_OP(and, x12, x10, x11, 0x2, 0x55555556, -0x55555556, x2, 56, x1)

inst_546:
// rs1_val==1431655766 and rs2_val==5, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x5
TEST_RR_OP(and, x12, x10, x11, 0x4, 0x55555556, 0x5, x2, 60, x1)

inst_547:
// rs1_val==1431655766 and rs2_val==858993459, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x33333333
TEST_RR_OP(and, x12, x10, x11, 0x11111112, 0x55555556, 0x33333333, x2, 64, x1)

inst_548:
// rs1_val==1431655766 and rs2_val==1717986918, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x66666666
TEST_RR_OP(and, x12, x10, x11, 0x44444446, 0x55555556, 0x66666666, x2, 68, x1)

inst_549:
// rs1_val==1431655766 and rs2_val==-46340, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:-0xb504
TEST_RR_OP(and, x12, x10, x11, 0x55554054, 0x55555556, -0xb504, x2, 72, x1)

inst_550:
// rs1_val==1431655766 and rs2_val==46340, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0xb504
TEST_RR_OP(and, x12, x10, x11, 0x1504, 0x55555556, 0xb504, x2, 76, x1)

inst_551:
// rs1_val==1431655766 and rs2_val==2, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x2
TEST_RR_OP(and, x12, x10, x11, 0x2, 0x55555556, 0x2, x2, 80, x1)

inst_552:
// rs1_val==1431655766 and rs2_val==1431655764, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x55555554
TEST_RR_OP(and, x12, x10, x11, 0x55555554, 0x55555556, 0x55555554, x2, 84, x1)

inst_553:
// rs1_val==1431655766 and rs2_val==0, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x0
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x55555556, 0x0, x2, 88, x1)

inst_554:
// rs1_val==1431655766 and rs2_val==4, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x4
TEST_RR_OP(and, x12, x10, x11, 0x4, 0x55555556, 0x4, x2, 92, x1)

inst_555:
// rs1_val==1431655766 and rs2_val==858993458, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x33333332
TEST_RR_OP(and, x12, x10, x11, 0x11111112, 0x55555556, 0x33333332, x2, 96, x1)

inst_556:
// rs1_val==1431655766 and rs2_val==1717986917, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x66666665
TEST_RR_OP(and, x12, x10, x11, 0x44444444, 0x55555556, 0x66666665, x2, 100, x1)

inst_557:
// rs1_val==1431655766 and rs2_val==46339, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0xb503
TEST_RR_OP(and, x12, x10, x11, 0x1502, 0x55555556, 0xb503, x2, 104, x1)

inst_558:
// rs1_val==1431655766 and rs2_val==1431655766, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x55555556
TEST_RR_OP(and, x12, x10, x11, 0x55555556, 0x55555556, 0x55555556, x2, 108, x1)

inst_559:
// rs1_val==1431655766 and rs2_val==-1431655765, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:-0x55555555
TEST_RR_OP(and, x12, x10, x11, 0x2, 0x55555556, -0x55555555, x2, 112, x1)

inst_560:
// rs1_val==1431655766 and rs2_val==6, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x6
TEST_RR_OP(and, x12, x10, x11, 0x6, 0x55555556, 0x6, x2, 116, x1)

inst_561:
// rs1_val==1431655766 and rs2_val==858993460, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x33333334
TEST_RR_OP(and, x12, x10, x11, 0x11111114, 0x55555556, 0x33333334, x2, 120, x1)

inst_562:
// rs1_val==1431655766 and rs2_val==1717986919, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x66666667
TEST_RR_OP(and, x12, x10, x11, 0x44444446, 0x55555556, 0x66666667, x2, 124, x1)

inst_563:
// rs1_val==1431655766 and rs2_val==-46339, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:-0xb503
TEST_RR_OP(and, x12, x10, x11, 0x55554054, 0x55555556, -0xb503, x2, 128, x1)

inst_564:
// rs1_val==1431655766 and rs2_val==46341, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0xb505
TEST_RR_OP(and, x12, x10, x11, 0x1504, 0x55555556, 0xb505, x2, 132, x1)

inst_565:
// rs1_val==-1431655765 and rs2_val==3, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x3
TEST_RR_OP(and, x12, x10, x11, 0x3, -0x55555555, 0x3, x2, 136, x1)

inst_566:
// rs1_val==-1431655765 and rs2_val==1431655765, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x55555555
TEST_RR_OP(and, x12, x10, x11, 0x1, -0x55555555, 0x55555555, x2, 140, x1)

inst_567:
// rs1_val==-1431655765 and rs2_val==-1431655766, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:-0x55555556
TEST_RR_OP(and, x12, x10, x11, 0xaaaaaaaa, -0x55555555, -0x55555556, x2, 144, x1)

inst_568:
// rs1_val==-1431655765 and rs2_val==5, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x5
TEST_RR_OP(and, x12, x10, x11, 0x1, -0x55555555, 0x5, x2, 148, x1)

inst_569:
// rs1_val==-1431655765 and rs2_val==858993459, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x33333333
TEST_RR_OP(and, x12, x10, x11, 0x22222223, -0x55555555, 0x33333333, x2, 152, x1)

inst_570:
// rs1_val==-1431655765 and rs2_val==1717986918, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x66666666
TEST_RR_OP(and, x12, x10, x11, 0x22222222, -0x55555555, 0x66666666, x2, 156, x1)

inst_571:
// rs1_val==-1431655765 and rs2_val==-46340, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:-0xb504
TEST_RR_OP(and, x12, x10, x11, 0xaaaa0aa8, -0x55555555, -0xb504, x2, 160, x1)

inst_572:
// rs1_val==-1431655765 and rs2_val==46340, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0xb504
TEST_RR_OP(and, x12, x10, x11, 0xa000, -0x55555555, 0xb504, x2, 164, x1)

inst_573:
// rs1_val==-1431655765 and rs2_val==2, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x2
TEST_RR_OP(and, x12, x10, x11, 0x2, -0x55555555, 0x2, x2, 168, x1)

inst_574:
// rs1_val==-1431655765 and rs2_val==1431655764, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x55555554
TEST_RR_OP(and, x12, x10, x11, 0x0, -0x55555555, 0x55555554, x2, 172, x1)

inst_575:
// rs1_val==-1431655765 and rs2_val==0, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x0
TEST_RR_OP(and, x12, x10, x11, 0x0, -0x55555555, 0x0, x2, 176, x1)

inst_576:
// rs1_val==-1431655765 and rs2_val==4, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x4
TEST_RR_OP(and, x12, x10, x11, 0x0, -0x55555555, 0x4, x2, 180, x1)

inst_577:
// rs1_val==-1431655765 and rs2_val==858993458, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x33333332
TEST_RR_OP(and, x12, x10, x11, 0x22222222, -0x55555555, 0x33333332, x2, 184, x1)

inst_578:
// rs1_val==-1431655765 and rs2_val==1717986917, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x66666665
TEST_RR_OP(and, x12, x10, x11, 0x22222221, -0x55555555, 0x66666665, x2, 188, x1)

inst_579:
// rs1_val==-1431655765 and rs2_val==46339, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0xb503
TEST_RR_OP(and, x12, x10, x11, 0xa003, -0x55555555, 0xb503, x2, 192, x1)

inst_580:
// rs1_val==-1431655765 and rs2_val==1431655766, 
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x55555556
TEST_RR_OP(and, x12, x10, x11, 0x2, -0x55555555, 0x55555556, x2, 196, x1)

inst_581:
// rs1_val > 0 and rs2_val < 0, rs1_val == 2048, rs2_val == -1048577
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x800;  op2val:-0x100001
TEST_RR_OP(and, x12, x10, x11, 0x800, 0x800, -0x100001, x2, 200, x1)

inst_582:
// rs1_val == 0, rs2_val == 512
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x200
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x0, 0x200, x2, 204, x1)

inst_583:
// rs2_val == 1048576, rs1_val == 134217728
// opcode: and ; op1:x10; op2:x11; dest:x12; op1val:0x8000000;  op2val:0x100000
TEST_RR_OP(and, x12, x10, x11, 0x0, 0x8000000, 0x100000, x2, 208, x1)
#endif


RVTEST_CODE_END
RVMODEL_HALT

RVTEST_DATA_BEGIN
.align 4

rvtest_data:
.word 0xbabecafe
.word 0xbabecafe
.word 0xbabecafe
.word 0xbabecafe
RVTEST_DATA_END


RVMODEL_DATA_BEGIN
rvtest_sig_begin:
sig_begin_canary:
CANARY;


signature_x6_0:
    .fill 0*(XLEN/32),4,0xdeadbeef


signature_x6_1:
    .fill 19*(XLEN/32),4,0xdeadbeef


signature_x2_0:
    .fill 512*(XLEN/32),4,0xdeadbeef


signature_x2_1:
    .fill 53*(XLEN/32),4,0xdeadbeef

#ifdef rvtest_mtrap_routine

tsig_begin_canary:
CANARY;
mtrap_sigptr:
    .fill 64*(XLEN/32),4,0xdeadbeef
tsig_end_canary:
CANARY;

#endif

#ifdef rvtest_gpr_save

gpr_save:
    .fill 32*(XLEN/32),4,0xdeadbeef

#endif

sig_end_canary:
CANARY;
rvtest_sig_end:
RVMODEL_DATA_END
