
// -----------
// This file was generated by riscv_ctg (https://gitlab.com/incoresemi/riscv-compliance/riscv_ctg)
// version   : 0.4.1
// timestamp : Tue Dec 15 15:36:11 2020 GMT
// usage     : riscv_ctg \
//                  -- cgf ('/scratch/git-repo/incoresemi/riscv-compliance/riscv_ctg/sample_cgfs/dataset.cgf', '/scratch/git-repo/incoresemi/riscv-compliance/riscv_ctg/sample_cgfs/rv32i.cgf') \
//                  -- xlen 32 \
// -----------
//
// -----------
// Copyright (c) 2020. RISC-V International. All rights reserved.
// SPDX-License-Identifier: BSD-3-Clause
// -----------
//
// This assembly file tests the or instruction of the RISC-V I extension for the or covergroup.
// 
#include "model_test.h"
#include "arch_test.h"
RVTEST_ISA("RV32I")

.section .text.init
.org 0x80
.globl rvtest_entry_point
rvtest_entry_point:
RVMODEL_BOOT
RVTEST_CODE_BEGIN

#ifdef TEST_CASE_1

RVTEST_CASE(0,"//check ISA:=regex(.*32.*);check ISA:=regex(.*I.*);def TEST_CASE_1=True;",or)

RVTEST_SIGBASE( x3,signature_x3_1)

inst_0:
// rs2 == rd != rs1, rs1==x8, rs2==x26, rd==x26, rs1_val > 0 and rs2_val > 0, rs2_val == 16, rs1_val == 1048576, rs1_val != rs2_val
// opcode: or ; op1:x8; op2:x26; dest:x26; op1val:0x100000;  op2val:0x10
TEST_RR_OP(or, x26, x8, x26, 0x100010, 0x100000, 0x10, x3, 0, x5)

inst_1:
// rs1 == rs2 != rd, rs1==x6, rs2==x6, rd==x17, rs1_val > 0 and rs2_val < 0, rs2_val == -2049, rs1_val == 2
// opcode: or ; op1:x6; op2:x6; dest:x17; op1val:0x2;  op2val:0x2
TEST_RR_OP(or, x17, x6, x6, 0x2, 0x2, 0x2, x3, 4, x5)

inst_2:
// rs1 == rs2 == rd, rs1==x31, rs2==x31, rd==x31, rs1_val < 0 and rs2_val < 0, rs1_val == -268435457, rs2_val == -1025
// opcode: or ; op1:x31; op2:x31; dest:x31; op1val:-0x10000001;  op2val:-0x10000001
TEST_RR_OP(or, x31, x31, x31, 0xefffffff, -0x10000001, -0x10000001, x3, 8, x5)

inst_3:
// rs1 == rd != rs2, rs1==x27, rs2==x29, rd==x27, rs1_val < 0 and rs2_val > 0, rs1_val == -2049, rs2_val == 4194304
// opcode: or ; op1:x27; op2:x29; dest:x27; op1val:-0x801;  op2val:0x400000
TEST_RR_OP(or, x27, x27, x29, 0xfffff7ff, -0x801, 0x400000, x3, 12, x5)

inst_4:
// rs1 != rs2  and rs1 != rd and rs2 != rd, rs1==x30, rs2==x19, rd==x18, rs1_val == rs2_val, rs2_val == -1048577, rs1_val == -1048577
// opcode: or ; op1:x30; op2:x19; dest:x18; op1val:-0x100001;  op2val:-0x100001
TEST_RR_OP(or, x18, x30, x19, 0xffefffff, -0x100001, -0x100001, x3, 16, x5)

inst_5:
// rs1==x21, rs2==x14, rd==x9, rs2_val == (-2**(xlen-1)), rs2_val == -2147483648, rs1_val == 131072
// opcode: or ; op1:x21; op2:x14; dest:x9; op1val:0x20000;  op2val:-0x80000000
TEST_RR_OP(or, x9, x21, x14, 0x80020000, 0x20000, -0x80000000, x3, 20, x5)

inst_6:
// rs1==x26, rs2==x24, rd==x4, rs2_val == 0, rs1_val == -8193
// opcode: or ; op1:x26; op2:x24; dest:x4; op1val:-0x2001;  op2val:0x0
TEST_RR_OP(or, x4, x26, x24, 0xffffdfff, -0x2001, 0x0, x3, 24, x5)

inst_7:
// rs1==x9, rs2==x8, rd==x30, rs2_val == (2**(xlen-1)-1), rs1_val == 0, rs2_val == 2147483647
// opcode: or ; op1:x9; op2:x8; dest:x30; op1val:0x0;  op2val:0x7fffffff
TEST_RR_OP(or, x30, x9, x8, 0x7fffffff, 0x0, 0x7fffffff, x3, 28, x5)

inst_8:
// rs1==x23, rs2==x7, rd==x8, rs2_val == 1, rs1_val == -8388609
// opcode: or ; op1:x23; op2:x7; dest:x8; op1val:-0x800001;  op2val:0x1
TEST_RR_OP(or, x8, x23, x7, 0xff7fffff, -0x800001, 0x1, x3, 32, x5)

inst_9:
// rs1==x12, rs2==x0, rd==x22, rs1_val == (-2**(xlen-1)), rs1_val == -2147483648
// opcode: or ; op1:x12; op2:x0; dest:x22; op1val:-0x80000000;  op2val:0x0
TEST_RR_OP(or, x22, x12, x0, 0x80000000, -0x80000000, 0x0, x3, 36, x5)

inst_10:
// rs1==x10, rs2==x30, rd==x28, rs1_val == (2**(xlen-1)-1), rs2_val == 64, rs1_val == 2147483647
// opcode: or ; op1:x10; op2:x30; dest:x28; op1val:0x7fffffff;  op2val:0x40
TEST_RR_OP(or, x28, x10, x30, 0x7fffffff, 0x7fffffff, 0x40, x3, 40, x5)

inst_11:
// rs1==x18, rs2==x21, rd==x16, rs1_val == 1, 
// opcode: or ; op1:x18; op2:x21; dest:x16; op1val:0x1;  op2val:0x55555554
TEST_RR_OP(or, x16, x18, x21, 0x55555555, 0x1, 0x55555554, x3, 44, x5)

inst_12:
// rs1==x14, rs2==x17, rd==x12, rs2_val == 2, rs1_val == 4096
// opcode: or ; op1:x14; op2:x17; dest:x12; op1val:0x1000;  op2val:0x2
TEST_RR_OP(or, x12, x14, x17, 0x1002, 0x1000, 0x2, x3, 48, x5)

inst_13:
// rs1==x19, rs2==x16, rd==x15, rs2_val == 4, 
// opcode: or ; op1:x19; op2:x16; dest:x15; op1val:-0x800001;  op2val:0x4
TEST_RR_OP(or, x15, x19, x16, 0xff7fffff, -0x800001, 0x4, x3, 52, x5)

inst_14:
// rs1==x4, rs2==x2, rd==x7, rs2_val == 8, rs1_val == -1025
// opcode: or ; op1:x4; op2:x2; dest:x7; op1val:-0x401;  op2val:0x8
TEST_RR_OP(or, x7, x4, x2, 0xfffffbff, -0x401, 0x8, x3, 56, x5)

inst_15:
// rs1==x2, rs2==x22, rd==x11, rs2_val == 32, 
// opcode: or ; op1:x2; op2:x22; dest:x11; op1val:0x7fffffff;  op2val:0x20
TEST_RR_OP(or, x11, x2, x22, 0x7fffffff, 0x7fffffff, 0x20, x3, 60, x5)

inst_16:
// rs1==x28, rs2==x15, rd==x25, rs2_val == 128, rs1_val == -513
// opcode: or ; op1:x28; op2:x15; dest:x25; op1val:-0x201;  op2val:0x80
TEST_RR_OP(or, x25, x28, x15, 0xfffffdff, -0x201, 0x80, x3, 64, x5)

inst_17:
// rs1==x25, rs2==x1, rd==x6, rs2_val == 256, 
// opcode: or ; op1:x25; op2:x1; dest:x6; op1val:0xb504;  op2val:0x100
TEST_RR_OP(or, x6, x25, x1, 0xb504, 0xb504, 0x100, x3, 68, x5)

inst_18:
// rs1==x17, rs2==x10, rd==x20, rs2_val == 512, rs1_val == 4
// opcode: or ; op1:x17; op2:x10; dest:x20; op1val:0x4;  op2val:0x200
TEST_RR_OP(or, x20, x17, x10, 0x204, 0x4, 0x200, x3, 72, x8)
RVTEST_SIGBASE( x6,signature_x6_0)

inst_19:
// rs1==x20, rs2==x23, rd==x5, rs2_val == 1024, 
// opcode: or ; op1:x20; op2:x23; dest:x5; op1val:-0x100001;  op2val:0x400
TEST_RR_OP(or, x5, x20, x23, 0xffefffff, -0x100001, 0x400, x6, 0, x8)

inst_20:
// rs1==x11, rs2==x12, rd==x2, rs2_val == 2048, 
// opcode: or ; op1:x11; op2:x12; dest:x2; op1val:0x0;  op2val:0x800
TEST_RR_OP(or, x2, x11, x12, 0x800, 0x0, 0x800, x6, 4, x8)

inst_21:
// rs1==x13, rs2==x20, rd==x1, rs2_val == 4096, rs1_val == -67108865
// opcode: or ; op1:x13; op2:x20; dest:x1; op1val:-0x4000001;  op2val:0x1000
TEST_RR_OP(or, x1, x13, x20, 0xfbffffff, -0x4000001, 0x1000, x6, 8, x8)

inst_22:
// rs1==x15, rs2==x27, rd==x3, rs2_val == 8192, 
// opcode: or ; op1:x15; op2:x27; dest:x3; op1val:0x4;  op2val:0x2000
TEST_RR_OP(or, x3, x15, x27, 0x2004, 0x4, 0x2000, x6, 12, x8)

inst_23:
// rs1==x22, rs2==x4, rd==x21, rs2_val == 16384, rs1_val == -65537
// opcode: or ; op1:x22; op2:x4; dest:x21; op1val:-0x10001;  op2val:0x4000
TEST_RR_OP(or, x21, x22, x4, 0xfffeffff, -0x10001, 0x4000, x6, 16, x8)

inst_24:
// rs1==x7, rs2==x13, rd==x19, rs2_val == 32768, rs1_val == 524288
// opcode: or ; op1:x7; op2:x13; dest:x19; op1val:0x80000;  op2val:0x8000
TEST_RR_OP(or, x19, x7, x13, 0x88000, 0x80000, 0x8000, x6, 20, x8)

inst_25:
// rs1==x24, rs2==x5, rd==x14, rs2_val == 65536, 
// opcode: or ; op1:x24; op2:x5; dest:x14; op1val:-0x4;  op2val:0x10000
TEST_RR_OP(or, x14, x24, x5, 0xfffffffc, -0x4, 0x10000, x6, 24, x8)

inst_26:
// rs1==x16, rs2==x18, rd==x10, rs2_val == 131072, rs1_val == 1431655765
// opcode: or ; op1:x16; op2:x18; dest:x10; op1val:0x55555555;  op2val:0x20000
TEST_RR_OP(or, x10, x16, x18, 0x55575555, 0x55555555, 0x20000, x6, 28, x8)

inst_27:
// rs1==x1, rs2==x9, rd==x23, rs2_val == 262144, 
// opcode: or ; op1:x1; op2:x9; dest:x23; op1val:-0xb504;  op2val:0x40000
TEST_RR_OP(or, x23, x1, x9, 0xffff4afc, -0xb504, 0x40000, x6, 32, x8)

inst_28:
// rs1==x3, rs2==x11, rd==x29, rs2_val == 524288, 
// opcode: or ; op1:x3; op2:x11; dest:x29; op1val:0x4;  op2val:0x80000
TEST_RR_OP(or, x29, x3, x11, 0x80004, 0x4, 0x80000, x6, 36, x8)

inst_29:
// rs1==x29, rs2==x28, rd==x13, rs2_val == 1048576, rs1_val == -4097
// opcode: or ; op1:x29; op2:x28; dest:x13; op1val:-0x1001;  op2val:0x100000
TEST_RR_OP(or, x13, x29, x28, 0xffffefff, -0x1001, 0x100000, x6, 40, x8)

inst_30:
// rs1==x5, rs2==x3, rd==x0, rs2_val == 2097152, 
// opcode: or ; op1:x5; op2:x3; dest:x0; op1val:0x33333332;  op2val:0x200000
TEST_RR_OP(or, x0, x5, x3, 0, 0x33333332, 0x200000, x6, 44, x8)

inst_31:
// rs1==x0, rs2==x25, rd==x24, rs2_val == 8388608, 
// opcode: or ; op1:x0; op2:x25; dest:x24; op1val:0x0;  op2val:0x800000
TEST_RR_OP(or, x24, x0, x25, 0x800000, 0x0, 0x800000, x6, 48, x8)

inst_32:
// rs2_val == 16777216, rs1_val == 64
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x40;  op2val:0x1000000
TEST_RR_OP(or, x12, x10, x11, 0x1000040, 0x40, 0x1000000, x6, 52, x8)

inst_33:
// rs2_val == 33554432, rs1_val == -9
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x9;  op2val:0x2000000
TEST_RR_OP(or, x12, x10, x11, 0xfffffff7, -0x9, 0x2000000, x6, 56, x8)

inst_34:
// rs2_val == 67108864, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x4000000
TEST_RR_OP(or, x12, x10, x11, 0x55555556, 0x55555556, 0x4000000, x6, 60, x8)

inst_35:
// rs2_val == 134217728, rs1_val == 16777216
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x1000000;  op2val:0x8000000
TEST_RR_OP(or, x12, x10, x11, 0x9000000, 0x1000000, 0x8000000, x6, 64, x8)

inst_36:
// rs2_val == 268435456, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x6;  op2val:0x10000000
TEST_RR_OP(or, x12, x10, x11, 0xfffffffa, -0x6, 0x10000000, x6, 68, x8)

inst_37:
// rs2_val == 536870912, rs1_val == -1431655766
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x20000000
TEST_RR_OP(or, x12, x10, x11, 0xaaaaaaaa, -0x55555556, 0x20000000, x6, 72, x8)

inst_38:
// rs2_val == 1073741824, rs1_val == 8388608
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x800000;  op2val:0x40000000
TEST_RR_OP(or, x12, x10, x11, 0x40800000, 0x800000, 0x40000000, x6, 76, x8)

inst_39:
// rs2_val == -2, rs1_val == 32
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x20;  op2val:-0x2
TEST_RR_OP(or, x12, x10, x11, 0xfffffffe, 0x20, -0x2, x6, 80, x8)

inst_40:
// rs2_val == -3, rs1_val == 268435456
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x10000000;  op2val:-0x3
TEST_RR_OP(or, x12, x10, x11, 0xfffffffd, 0x10000000, -0x3, x6, 84, x8)

inst_41:
// rs2_val == -5, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x1;  op2val:-0x5
TEST_RR_OP(or, x12, x10, x11, 0xfffffffb, 0x1, -0x5, x6, 88, x8)

inst_42:
// rs2_val == -9, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x80000;  op2val:-0x9
TEST_RR_OP(or, x12, x10, x11, 0xfffffff7, 0x80000, -0x9, x6, 92, x8)

inst_43:
// rs2_val == -17, rs1_val == 8
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x8;  op2val:-0x11
TEST_RR_OP(or, x12, x10, x11, 0xffffffef, 0x8, -0x11, x6, 96, x8)

inst_44:
// rs2_val == -33, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:-0x21
TEST_RR_OP(or, x12, x10, x11, 0xffffffff, -0xb504, -0x21, x6, 100, x8)

inst_45:
// rs2_val == -65, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x20000;  op2val:-0x41
TEST_RR_OP(or, x12, x10, x11, 0xffffffbf, 0x20000, -0x41, x6, 104, x8)

inst_46:
// rs2_val == -129, rs1_val == -2097153
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x200001;  op2val:-0x81
TEST_RR_OP(or, x12, x10, x11, 0xffffffff, -0x200001, -0x81, x6, 108, x8)

inst_47:
// rs2_val == -257, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:-0x101
TEST_RR_OP(or, x12, x10, x11, 0xffffffff, 0x33333334, -0x101, x6, 112, x8)

inst_48:
// rs2_val == -513, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x7fffffff;  op2val:-0x201
TEST_RR_OP(or, x12, x10, x11, 0xffffffff, 0x7fffffff, -0x201, x6, 116, x8)

inst_49:
// rs2_val == -4097, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:-0x1001
TEST_RR_OP(or, x12, x10, x11, 0xffffefff, 0x3, -0x1001, x6, 120, x8)

inst_50:
// rs2_val == -8193, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x80000000;  op2val:-0x2001
TEST_RR_OP(or, x12, x10, x11, 0xffffdfff, -0x80000000, -0x2001, x6, 124, x8)

inst_51:
// rs2_val == -16385, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:-0x4001
TEST_RR_OP(or, x12, x10, x11, 0xffffbfff, 0x5, -0x4001, x6, 128, x8)

inst_52:
// rs2_val == -32769, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x800001;  op2val:-0x8001
TEST_RR_OP(or, x12, x10, x11, 0xffffffff, -0x800001, -0x8001, x6, 132, x8)

inst_53:
// rs2_val == -65537, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x9;  op2val:-0x10001
TEST_RR_OP(or, x12, x10, x11, 0xffffffff, -0x9, -0x10001, x6, 136, x8)

inst_54:
// rs2_val == -131073, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:-0x20001
TEST_RR_OP(or, x12, x10, x11, 0xffffffff, -0xb503, -0x20001, x6, 140, x8)

inst_55:
// rs2_val == -262145, rs1_val == -33
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x21;  op2val:-0x40001
TEST_RR_OP(or, x12, x10, x11, 0xffffffff, -0x21, -0x40001, x6, 144, x8)

inst_56:
// rs2_val == -524289, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:-0x80001
TEST_RR_OP(or, x12, x10, x11, 0xfff7ffff, 0xb503, -0x80001, x6, 148, x8)

inst_57:
// rs2_val == -2097153, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:-0x200001
TEST_RR_OP(or, x12, x10, x11, 0xffdfffff, 0x55555555, -0x200001, x6, 152, x8)

inst_58:
// rs2_val == -4194305, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:-0x400001
TEST_RR_OP(or, x12, x10, x11, 0xffbfffff, 0x3, -0x400001, x6, 156, x8)

inst_59:
// rs2_val == -8388609, rs1_val == -257
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x101;  op2val:-0x800001
TEST_RR_OP(or, x12, x10, x11, 0xffffffff, -0x101, -0x800001, x6, 160, x8)

inst_60:
// rs2_val == -16777217, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:-0x1000001
TEST_RR_OP(or, x12, x10, x11, 0xfeffffff, 0x66666666, -0x1000001, x6, 164, x8)

inst_61:
// rs2_val == -33554433, rs1_val == -32769
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x8001;  op2val:-0x2000001
TEST_RR_OP(or, x12, x10, x11, 0xffffffff, -0x8001, -0x2000001, x6, 168, x8)

inst_62:
// rs2_val == -67108865, rs1_val == 65536
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x10000;  op2val:-0x4000001
TEST_RR_OP(or, x12, x10, x11, 0xfbffffff, 0x10000, -0x4000001, x6, 172, x8)

inst_63:
// rs2_val == -134217729, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:-0x8000001
TEST_RR_OP(or, x12, x10, x11, 0xf7ffffff, 0x66666665, -0x8000001, x6, 176, x8)

inst_64:
// rs2_val == -268435457, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x40000000;  op2val:-0x10000001
TEST_RR_OP(or, x12, x10, x11, 0xefffffff, -0x40000000, -0x10000001, x6, 180, x8)

inst_65:
// rs2_val == -536870913, rs1_val == 512
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x200;  op2val:-0x20000001
TEST_RR_OP(or, x12, x10, x11, 0xdfffffff, 0x200, -0x20000001, x6, 184, x8)

inst_66:
// rs2_val == -1073741825, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:-0x40000001
TEST_RR_OP(or, x12, x10, x11, 0xbfffffff, -0x55555555, -0x40000001, x6, 188, x8)

inst_67:
// rs2_val == 1431655765, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x4;  op2val:0x55555555
TEST_RR_OP(or, x12, x10, x11, 0xfffffffd, -0x4, 0x55555555, x6, 192, x8)

inst_68:
// rs2_val == -1431655766, rs1_val == -536870913
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x20000001;  op2val:-0x55555556
TEST_RR_OP(or, x12, x10, x11, 0xffffffff, -0x20000001, -0x55555556, x6, 196, x8)

inst_69:
// rs1_val == 16, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x10;  op2val:-0x7
TEST_RR_OP(or, x12, x10, x11, 0xfffffff9, 0x10, -0x7, x6, 200, x8)

inst_70:
// rs1_val == 128, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x80;  op2val:-0x7
TEST_RR_OP(or, x12, x10, x11, 0xfffffff9, 0x80, -0x7, x6, 204, x8)

inst_71:
// rs1_val == 256, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x100;  op2val:-0x4000001
TEST_RR_OP(or, x12, x10, x11, 0xfbffffff, 0x100, -0x4000001, x6, 208, x8)

inst_72:
// rs1_val == 1024, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x400;  op2val:-0x55555556
TEST_RR_OP(or, x12, x10, x11, 0xaaaaaeaa, 0x400, -0x55555556, x6, 212, x8)

inst_73:
// rs1_val == 2048, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x800;  op2val:-0x200001
TEST_RR_OP(or, x12, x10, x11, 0xffdfffff, 0x800, -0x200001, x6, 216, x8)

inst_74:
// rs1_val == 8192, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x2000;  op2val:0xb503
TEST_RR_OP(or, x12, x10, x11, 0xb503, 0x2000, 0xb503, x6, 220, x8)

inst_75:
// rs1_val == 16384, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x4000;  op2val:-0x6
TEST_RR_OP(or, x12, x10, x11, 0xfffffffa, 0x4000, -0x6, x6, 224, x8)

inst_76:
// rs1_val == 32768, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x8000;  op2val:0x800
TEST_RR_OP(or, x12, x10, x11, 0x8800, 0x8000, 0x800, x6, 228, x8)

inst_77:
// rs1_val == 262144, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x40000;  op2val:-0x1000001
TEST_RR_OP(or, x12, x10, x11, 0xfeffffff, 0x40000, -0x1000001, x6, 232, x8)

inst_78:
// rs1_val == 2097152, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x200000;  op2val:0x0
TEST_RR_OP(or, x12, x10, x11, 0x200000, 0x200000, 0x0, x6, 236, x8)

inst_79:
// rs1_val == 4194304, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x400000;  op2val:-0xb503
TEST_RR_OP(or, x12, x10, x11, 0xffff4afd, 0x400000, -0xb503, x6, 240, x8)

inst_80:
// rs1_val == 33554432, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x2000000;  op2val:0x3fffffff
TEST_RR_OP(or, x12, x10, x11, 0x3fffffff, 0x2000000, 0x3fffffff, x6, 244, x8)

inst_81:
// rs1_val == 67108864, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x4000000;  op2val:-0x80001
TEST_RR_OP(or, x12, x10, x11, 0xfff7ffff, 0x4000000, -0x80001, x6, 248, x8)

inst_82:
// rs1_val == 134217728, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x8000000;  op2val:0x20
TEST_RR_OP(or, x12, x10, x11, 0x8000020, 0x8000000, 0x20, x6, 252, x8)

inst_83:
// rs1_val == 536870912, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x20000000;  op2val:-0x2001
TEST_RR_OP(or, x12, x10, x11, 0xffffdfff, 0x20000000, -0x2001, x6, 256, x8)

inst_84:
// rs1_val == 1073741824, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x40000000;  op2val:0x8
TEST_RR_OP(or, x12, x10, x11, 0x40000008, 0x40000000, 0x8, x6, 260, x8)

inst_85:
// rs1_val == -2, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x2;  op2val:0x4
TEST_RR_OP(or, x12, x10, x11, 0xfffffffe, -0x2, 0x4, x6, 264, x8)

inst_86:
// rs1_val == -3, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x3;  op2val:-0x8
TEST_RR_OP(or, x12, x10, x11, 0xfffffffd, -0x3, -0x8, x6, 268, x8)

inst_87:
// rs1_val == -5, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x5;  op2val:-0xb503
TEST_RR_OP(or, x12, x10, x11, 0xffffffff, -0x5, -0xb503, x6, 272, x8)

inst_88:
// rs1_val == -17, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x11;  op2val:-0x400001
TEST_RR_OP(or, x12, x10, x11, 0xffffffff, -0x11, -0x400001, x6, 276, x8)

inst_89:
// rs1_val == -65, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x41;  op2val:0x5
TEST_RR_OP(or, x12, x10, x11, 0xffffffbf, -0x41, 0x5, x6, 280, x8)

inst_90:
// rs1_val == -129, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x81;  op2val:0x800000
TEST_RR_OP(or, x12, x10, x11, 0xffffff7f, -0x81, 0x800000, x6, 284, x8)

inst_91:
// rs1_val == -16385, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x4001;  op2val:0xb503
TEST_RR_OP(or, x12, x10, x11, 0xffffbfff, -0x4001, 0xb503, x6, 288, x8)

inst_92:
// rs1_val == -131073, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x20001;  op2val:-0x4001
TEST_RR_OP(or, x12, x10, x11, 0xffffffff, -0x20001, -0x4001, x6, 292, x8)

inst_93:
// rs1_val == -262145, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x40001;  op2val:-0x55555556
TEST_RR_OP(or, x12, x10, x11, 0xfffbffff, -0x40001, -0x55555556, x6, 296, x8)

inst_94:
// rs1_val == -524289, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x80001;  op2val:-0x41
TEST_RR_OP(or, x12, x10, x11, 0xffffffff, -0x80001, -0x41, x6, 300, x8)

inst_95:
// rs1_val == -4194305, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x400001;  op2val:-0x101
TEST_RR_OP(or, x12, x10, x11, 0xffffffff, -0x400001, -0x101, x6, 304, x8)

inst_96:
// rs1_val == -16777217, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x1000001;  op2val:0x0
TEST_RR_OP(or, x12, x10, x11, 0xfeffffff, -0x1000001, 0x0, x6, 308, x8)

inst_97:
// rs1_val == -33554433, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x2000001;  op2val:0x4
TEST_RR_OP(or, x12, x10, x11, 0xfdffffff, -0x2000001, 0x4, x6, 312, x8)

inst_98:
// rs1_val == -134217729, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x8000001;  op2val:-0x5
TEST_RR_OP(or, x12, x10, x11, 0xffffffff, -0x8000001, -0x5, x6, 316, x8)

inst_99:
// rs1_val == -1073741825, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x40000001;  op2val:-0x40000001
TEST_RR_OP(or, x12, x10, x11, 0xbfffffff, -0x40000001, -0x40000001, x6, 320, x8)

inst_100:
// rs1_val==3 and rs2_val==3, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x3
TEST_RR_OP(or, x12, x10, x11, 0x3, 0x3, 0x3, x6, 324, x8)

inst_101:
// rs1_val==3 and rs2_val==1431655765, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x55555555
TEST_RR_OP(or, x12, x10, x11, 0x55555557, 0x3, 0x55555555, x6, 328, x8)

inst_102:
// rs1_val==3 and rs2_val==-1431655766, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:-0x55555556
TEST_RR_OP(or, x12, x10, x11, 0xaaaaaaab, 0x3, -0x55555556, x6, 332, x8)

inst_103:
// rs1_val==3 and rs2_val==5, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x5
TEST_RR_OP(or, x12, x10, x11, 0x7, 0x3, 0x5, x6, 336, x8)

inst_104:
// rs1_val==3 and rs2_val==858993459, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x33333333
TEST_RR_OP(or, x12, x10, x11, 0x33333333, 0x3, 0x33333333, x6, 340, x8)

inst_105:
// rs1_val==3 and rs2_val==1717986918, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x66666666
TEST_RR_OP(or, x12, x10, x11, 0x66666667, 0x3, 0x66666666, x6, 344, x8)

inst_106:
// rs1_val==3 and rs2_val==-46340, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:-0xb504
TEST_RR_OP(or, x12, x10, x11, 0xffff4aff, 0x3, -0xb504, x6, 348, x8)

inst_107:
// rs1_val==3 and rs2_val==46340, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0xb504
TEST_RR_OP(or, x12, x10, x11, 0xb507, 0x3, 0xb504, x6, 352, x8)

inst_108:
// rs1_val==3 and rs2_val==2, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x2
TEST_RR_OP(or, x12, x10, x11, 0x3, 0x3, 0x2, x6, 356, x8)

inst_109:
// rs1_val==3 and rs2_val==1431655764, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x55555554
TEST_RR_OP(or, x12, x10, x11, 0x55555557, 0x3, 0x55555554, x6, 360, x8)

inst_110:
// rs1_val==3 and rs2_val==0, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x0
TEST_RR_OP(or, x12, x10, x11, 0x3, 0x3, 0x0, x6, 364, x8)

inst_111:
// rs1_val==3 and rs2_val==4, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x4
TEST_RR_OP(or, x12, x10, x11, 0x7, 0x3, 0x4, x6, 368, x8)

inst_112:
// rs1_val==3 and rs2_val==858993458, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x33333332
TEST_RR_OP(or, x12, x10, x11, 0x33333333, 0x3, 0x33333332, x6, 372, x8)

inst_113:
// rs1_val==3 and rs2_val==1717986917, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x66666665
TEST_RR_OP(or, x12, x10, x11, 0x66666667, 0x3, 0x66666665, x6, 376, x8)

inst_114:
// rs1_val==3 and rs2_val==46339, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0xb503
TEST_RR_OP(or, x12, x10, x11, 0xb503, 0x3, 0xb503, x6, 380, x8)

inst_115:
// rs1_val==3 and rs2_val==1431655766, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x55555556
TEST_RR_OP(or, x12, x10, x11, 0x55555557, 0x3, 0x55555556, x6, 384, x8)

inst_116:
// rs1_val==3 and rs2_val==-1431655765, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:-0x55555555
TEST_RR_OP(or, x12, x10, x11, 0xaaaaaaab, 0x3, -0x55555555, x6, 388, x8)

inst_117:
// rs1_val==3 and rs2_val==6, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x6
TEST_RR_OP(or, x12, x10, x11, 0x7, 0x3, 0x6, x6, 392, x8)

inst_118:
// rs1_val==3 and rs2_val==858993460, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x33333334
TEST_RR_OP(or, x12, x10, x11, 0x33333337, 0x3, 0x33333334, x6, 396, x8)

inst_119:
// rs1_val==3 and rs2_val==1717986919, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x66666667
TEST_RR_OP(or, x12, x10, x11, 0x66666667, 0x3, 0x66666667, x6, 400, x8)

inst_120:
// rs1_val==3 and rs2_val==-46339, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:-0xb503
TEST_RR_OP(or, x12, x10, x11, 0xffff4aff, 0x3, -0xb503, x6, 404, x8)

inst_121:
// rs1_val==3 and rs2_val==46341, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0xb505
TEST_RR_OP(or, x12, x10, x11, 0xb507, 0x3, 0xb505, x6, 408, x8)

inst_122:
// rs1_val==1431655765 and rs2_val==3, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x3
TEST_RR_OP(or, x12, x10, x11, 0x55555557, 0x55555555, 0x3, x6, 412, x8)

inst_123:
// rs1_val==1431655765 and rs2_val==1431655765, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x55555555
TEST_RR_OP(or, x12, x10, x11, 0x55555555, 0x55555555, 0x55555555, x6, 416, x8)

inst_124:
// rs1_val==1431655765 and rs2_val==-1431655766, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:-0x55555556
TEST_RR_OP(or, x12, x10, x11, 0xffffffff, 0x55555555, -0x55555556, x6, 420, x8)

inst_125:
// rs1_val==1431655765 and rs2_val==5, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x5
TEST_RR_OP(or, x12, x10, x11, 0x55555555, 0x55555555, 0x5, x6, 424, x8)

inst_126:
// rs1_val==1431655765 and rs2_val==858993459, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x33333333
TEST_RR_OP(or, x12, x10, x11, 0x77777777, 0x55555555, 0x33333333, x6, 428, x8)

inst_127:
// rs1_val==1431655765 and rs2_val==1717986918, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x66666666
TEST_RR_OP(or, x12, x10, x11, 0x77777777, 0x55555555, 0x66666666, x6, 432, x8)

inst_128:
// rs1_val==1431655765 and rs2_val==-46340, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:-0xb504
TEST_RR_OP(or, x12, x10, x11, 0xffff5ffd, 0x55555555, -0xb504, x6, 436, x8)

inst_129:
// rs1_val==1431655765 and rs2_val==46340, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0xb504
TEST_RR_OP(or, x12, x10, x11, 0x5555f555, 0x55555555, 0xb504, x6, 440, x8)

inst_130:
// rs1_val==1431655765 and rs2_val==2, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x2
TEST_RR_OP(or, x12, x10, x11, 0x55555557, 0x55555555, 0x2, x6, 444, x8)

inst_131:
// rs1_val==1431655765 and rs2_val==1431655764, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x55555554
TEST_RR_OP(or, x12, x10, x11, 0x55555555, 0x55555555, 0x55555554, x6, 448, x8)

inst_132:
// rs1_val==1431655765 and rs2_val==0, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x0
TEST_RR_OP(or, x12, x10, x11, 0x55555555, 0x55555555, 0x0, x6, 452, x8)

inst_133:
// rs1_val==1431655765 and rs2_val==4, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x4
TEST_RR_OP(or, x12, x10, x11, 0x55555555, 0x55555555, 0x4, x6, 456, x8)

inst_134:
// rs1_val==1431655765 and rs2_val==858993458, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x33333332
TEST_RR_OP(or, x12, x10, x11, 0x77777777, 0x55555555, 0x33333332, x6, 460, x8)

inst_135:
// rs1_val==1431655765 and rs2_val==1717986917, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x66666665
TEST_RR_OP(or, x12, x10, x11, 0x77777775, 0x55555555, 0x66666665, x6, 464, x8)

inst_136:
// rs1_val==1431655765 and rs2_val==46339, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0xb503
TEST_RR_OP(or, x12, x10, x11, 0x5555f557, 0x55555555, 0xb503, x6, 468, x8)

inst_137:
// rs1_val==1431655765 and rs2_val==1431655766, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x55555556
TEST_RR_OP(or, x12, x10, x11, 0x55555557, 0x55555555, 0x55555556, x6, 472, x8)

inst_138:
// rs1_val==1431655765 and rs2_val==-1431655765, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:-0x55555555
TEST_RR_OP(or, x12, x10, x11, 0xffffffff, 0x55555555, -0x55555555, x6, 476, x8)

inst_139:
// rs1_val==1431655765 and rs2_val==6, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x6
TEST_RR_OP(or, x12, x10, x11, 0x55555557, 0x55555555, 0x6, x6, 480, x8)

inst_140:
// rs1_val==1431655765 and rs2_val==858993460, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x33333334
TEST_RR_OP(or, x12, x10, x11, 0x77777775, 0x55555555, 0x33333334, x6, 484, x8)

inst_141:
// rs1_val==1431655765 and rs2_val==1717986919, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x66666667
TEST_RR_OP(or, x12, x10, x11, 0x77777777, 0x55555555, 0x66666667, x6, 488, x8)

inst_142:
// rs1_val==1431655765 and rs2_val==-46339, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:-0xb503
TEST_RR_OP(or, x12, x10, x11, 0xffff5ffd, 0x55555555, -0xb503, x6, 492, x8)

inst_143:
// rs1_val==1431655765 and rs2_val==46341, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0xb505
TEST_RR_OP(or, x12, x10, x11, 0x5555f555, 0x55555555, 0xb505, x6, 496, x8)

inst_144:
// rs1_val==-1431655766 and rs2_val==3, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x3
TEST_RR_OP(or, x12, x10, x11, 0xaaaaaaab, -0x55555556, 0x3, x6, 500, x8)

inst_145:
// rs1_val==-1431655766 and rs2_val==1431655765, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x55555555
TEST_RR_OP(or, x12, x10, x11, 0xffffffff, -0x55555556, 0x55555555, x6, 504, x8)

inst_146:
// rs1_val==-1431655766 and rs2_val==-1431655766, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:-0x55555556
TEST_RR_OP(or, x12, x10, x11, 0xaaaaaaaa, -0x55555556, -0x55555556, x6, 508, x8)

inst_147:
// rs1_val==-1431655766 and rs2_val==5, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x5
TEST_RR_OP(or, x12, x10, x11, 0xaaaaaaaf, -0x55555556, 0x5, x6, 512, x8)

inst_148:
// rs1_val==-1431655766 and rs2_val==858993459, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x33333333
TEST_RR_OP(or, x12, x10, x11, 0xbbbbbbbb, -0x55555556, 0x33333333, x6, 516, x8)

inst_149:
// rs1_val==-1431655766 and rs2_val==1717986918, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x66666666
TEST_RR_OP(or, x12, x10, x11, 0xeeeeeeee, -0x55555556, 0x66666666, x6, 520, x8)

inst_150:
// rs1_val==-1431655766 and rs2_val==-46340, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:-0xb504
TEST_RR_OP(or, x12, x10, x11, 0xffffeafe, -0x55555556, -0xb504, x6, 524, x8)

inst_151:
// rs1_val==-1431655766 and rs2_val==46340, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0xb504
TEST_RR_OP(or, x12, x10, x11, 0xaaaabfae, -0x55555556, 0xb504, x6, 528, x8)

inst_152:
// rs1_val==-1431655766 and rs2_val==2, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x2
TEST_RR_OP(or, x12, x10, x11, 0xaaaaaaaa, -0x55555556, 0x2, x6, 532, x8)

inst_153:
// rs1_val==-1431655766 and rs2_val==1431655764, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x55555554
TEST_RR_OP(or, x12, x10, x11, 0xfffffffe, -0x55555556, 0x55555554, x6, 536, x8)

inst_154:
// rs1_val==-1431655766 and rs2_val==0, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x0
TEST_RR_OP(or, x12, x10, x11, 0xaaaaaaaa, -0x55555556, 0x0, x6, 540, x8)

inst_155:
// rs1_val==-1431655766 and rs2_val==4, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x4
TEST_RR_OP(or, x12, x10, x11, 0xaaaaaaae, -0x55555556, 0x4, x6, 544, x8)

inst_156:
// rs1_val==-1431655766 and rs2_val==858993458, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x33333332
TEST_RR_OP(or, x12, x10, x11, 0xbbbbbbba, -0x55555556, 0x33333332, x6, 548, x8)

inst_157:
// rs1_val==-1431655766 and rs2_val==1717986917, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x66666665
TEST_RR_OP(or, x12, x10, x11, 0xeeeeeeef, -0x55555556, 0x66666665, x6, 552, x8)

inst_158:
// rs1_val==-1431655766 and rs2_val==46339, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0xb503
TEST_RR_OP(or, x12, x10, x11, 0xaaaabfab, -0x55555556, 0xb503, x6, 556, x8)

inst_159:
// rs1_val==-1431655766 and rs2_val==1431655766, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x55555556
TEST_RR_OP(or, x12, x10, x11, 0xfffffffe, -0x55555556, 0x55555556, x6, 560, x8)

inst_160:
// rs1_val==-1431655766 and rs2_val==-1431655765, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:-0x55555555
TEST_RR_OP(or, x12, x10, x11, 0xaaaaaaab, -0x55555556, -0x55555555, x6, 564, x8)

inst_161:
// rs1_val==-1431655766 and rs2_val==6, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x6
TEST_RR_OP(or, x12, x10, x11, 0xaaaaaaae, -0x55555556, 0x6, x6, 568, x8)

inst_162:
// rs1_val==-1431655766 and rs2_val==858993460, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x33333334
TEST_RR_OP(or, x12, x10, x11, 0xbbbbbbbe, -0x55555556, 0x33333334, x6, 572, x8)

inst_163:
// rs1_val==-1431655766 and rs2_val==1717986919, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x66666667
TEST_RR_OP(or, x12, x10, x11, 0xeeeeeeef, -0x55555556, 0x66666667, x6, 576, x8)

inst_164:
// rs1_val==-1431655766 and rs2_val==-46339, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:-0xb503
TEST_RR_OP(or, x12, x10, x11, 0xffffeaff, -0x55555556, -0xb503, x6, 580, x8)

inst_165:
// rs1_val==-1431655766 and rs2_val==46341, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0xb505
TEST_RR_OP(or, x12, x10, x11, 0xaaaabfaf, -0x55555556, 0xb505, x6, 584, x8)

inst_166:
// rs1_val==5 and rs2_val==3, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x3
TEST_RR_OP(or, x12, x10, x11, 0x7, 0x5, 0x3, x6, 588, x8)

inst_167:
// rs1_val==5 and rs2_val==1431655765, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x55555555
TEST_RR_OP(or, x12, x10, x11, 0x55555555, 0x5, 0x55555555, x6, 592, x8)

inst_168:
// rs1_val==5 and rs2_val==-1431655766, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:-0x55555556
TEST_RR_OP(or, x12, x10, x11, 0xaaaaaaaf, 0x5, -0x55555556, x6, 596, x8)

inst_169:
// rs1_val==5 and rs2_val==5, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x5
TEST_RR_OP(or, x12, x10, x11, 0x5, 0x5, 0x5, x6, 600, x8)

inst_170:
// rs1_val==5 and rs2_val==858993459, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x33333333
TEST_RR_OP(or, x12, x10, x11, 0x33333337, 0x5, 0x33333333, x6, 604, x8)

inst_171:
// rs1_val==5 and rs2_val==1717986918, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x66666666
TEST_RR_OP(or, x12, x10, x11, 0x66666667, 0x5, 0x66666666, x6, 608, x8)

inst_172:
// rs1_val==5 and rs2_val==-46340, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:-0xb504
TEST_RR_OP(or, x12, x10, x11, 0xffff4afd, 0x5, -0xb504, x6, 612, x8)

inst_173:
// rs1_val==5 and rs2_val==46340, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0xb504
TEST_RR_OP(or, x12, x10, x11, 0xb505, 0x5, 0xb504, x6, 616, x8)

inst_174:
// rs1_val==5 and rs2_val==2, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x2
TEST_RR_OP(or, x12, x10, x11, 0x7, 0x5, 0x2, x6, 620, x8)

inst_175:
// rs1_val==5 and rs2_val==1431655764, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x55555554
TEST_RR_OP(or, x12, x10, x11, 0x55555555, 0x5, 0x55555554, x6, 624, x8)

inst_176:
// rs1_val==5 and rs2_val==0, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x0
TEST_RR_OP(or, x12, x10, x11, 0x5, 0x5, 0x0, x6, 628, x8)

inst_177:
// rs1_val==5 and rs2_val==4, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x4
TEST_RR_OP(or, x12, x10, x11, 0x5, 0x5, 0x4, x6, 632, x8)

inst_178:
// rs1_val==5 and rs2_val==858993458, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x33333332
TEST_RR_OP(or, x12, x10, x11, 0x33333337, 0x5, 0x33333332, x6, 636, x8)

inst_179:
// rs1_val==5 and rs2_val==1717986917, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x66666665
TEST_RR_OP(or, x12, x10, x11, 0x66666665, 0x5, 0x66666665, x6, 640, x8)

inst_180:
// rs1_val==5 and rs2_val==46339, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0xb503
TEST_RR_OP(or, x12, x10, x11, 0xb507, 0x5, 0xb503, x6, 644, x8)

inst_181:
// rs1_val==5 and rs2_val==1431655766, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x55555556
TEST_RR_OP(or, x12, x10, x11, 0x55555557, 0x5, 0x55555556, x6, 648, x8)

inst_182:
// rs1_val==5 and rs2_val==-1431655765, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:-0x55555555
TEST_RR_OP(or, x12, x10, x11, 0xaaaaaaaf, 0x5, -0x55555555, x6, 652, x8)

inst_183:
// rs1_val==5 and rs2_val==6, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x6
TEST_RR_OP(or, x12, x10, x11, 0x7, 0x5, 0x6, x6, 656, x8)

inst_184:
// rs1_val==5 and rs2_val==858993460, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x33333334
TEST_RR_OP(or, x12, x10, x11, 0x33333335, 0x5, 0x33333334, x6, 660, x8)

inst_185:
// rs1_val==5 and rs2_val==1717986919, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x66666667
TEST_RR_OP(or, x12, x10, x11, 0x66666667, 0x5, 0x66666667, x6, 664, x8)

inst_186:
// rs1_val==5 and rs2_val==-46339, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:-0xb503
TEST_RR_OP(or, x12, x10, x11, 0xffff4afd, 0x5, -0xb503, x6, 668, x8)

inst_187:
// rs1_val==5 and rs2_val==46341, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0xb505
TEST_RR_OP(or, x12, x10, x11, 0xb505, 0x5, 0xb505, x6, 672, x8)

inst_188:
// rs1_val==858993459 and rs2_val==3, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x3
TEST_RR_OP(or, x12, x10, x11, 0x33333333, 0x33333333, 0x3, x6, 676, x8)

inst_189:
// rs1_val==858993459 and rs2_val==1431655765, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x55555555
TEST_RR_OP(or, x12, x10, x11, 0x77777777, 0x33333333, 0x55555555, x6, 680, x8)

inst_190:
// rs1_val==858993459 and rs2_val==-1431655766, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:-0x55555556
TEST_RR_OP(or, x12, x10, x11, 0xbbbbbbbb, 0x33333333, -0x55555556, x6, 684, x8)

inst_191:
// rs1_val==858993459 and rs2_val==5, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x5
TEST_RR_OP(or, x12, x10, x11, 0x33333337, 0x33333333, 0x5, x6, 688, x8)

inst_192:
// rs1_val==858993459 and rs2_val==858993459, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x33333333
TEST_RR_OP(or, x12, x10, x11, 0x33333333, 0x33333333, 0x33333333, x6, 692, x8)

inst_193:
// rs1_val==858993459 and rs2_val==1717986918, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x66666666
TEST_RR_OP(or, x12, x10, x11, 0x77777777, 0x33333333, 0x66666666, x6, 696, x8)

inst_194:
// rs1_val==858993459 and rs2_val==-46340, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:-0xb504
TEST_RR_OP(or, x12, x10, x11, 0xffff7bff, 0x33333333, -0xb504, x6, 700, x8)

inst_195:
// rs1_val==858993459 and rs2_val==46340, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0xb504
TEST_RR_OP(or, x12, x10, x11, 0x3333b737, 0x33333333, 0xb504, x6, 704, x8)

inst_196:
// rs1_val==858993459 and rs2_val==2, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x2
TEST_RR_OP(or, x12, x10, x11, 0x33333333, 0x33333333, 0x2, x6, 708, x8)

inst_197:
// rs1_val==858993459 and rs2_val==1431655764, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x55555554
TEST_RR_OP(or, x12, x10, x11, 0x77777777, 0x33333333, 0x55555554, x6, 712, x8)

inst_198:
// rs1_val==858993459 and rs2_val==0, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x0
TEST_RR_OP(or, x12, x10, x11, 0x33333333, 0x33333333, 0x0, x6, 716, x8)

inst_199:
// rs1_val==858993459 and rs2_val==4, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x4
TEST_RR_OP(or, x12, x10, x11, 0x33333337, 0x33333333, 0x4, x6, 720, x8)

inst_200:
// rs1_val==858993459 and rs2_val==858993458, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x33333332
TEST_RR_OP(or, x12, x10, x11, 0x33333333, 0x33333333, 0x33333332, x6, 724, x8)

inst_201:
// rs1_val==858993459 and rs2_val==1717986917, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x66666665
TEST_RR_OP(or, x12, x10, x11, 0x77777777, 0x33333333, 0x66666665, x6, 728, x8)

inst_202:
// rs1_val==858993459 and rs2_val==46339, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0xb503
TEST_RR_OP(or, x12, x10, x11, 0x3333b733, 0x33333333, 0xb503, x6, 732, x8)

inst_203:
// rs1_val==858993459 and rs2_val==1431655766, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x55555556
TEST_RR_OP(or, x12, x10, x11, 0x77777777, 0x33333333, 0x55555556, x6, 736, x8)

inst_204:
// rs1_val==858993459 and rs2_val==-1431655765, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:-0x55555555
TEST_RR_OP(or, x12, x10, x11, 0xbbbbbbbb, 0x33333333, -0x55555555, x6, 740, x8)

inst_205:
// rs1_val==858993459 and rs2_val==6, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x6
TEST_RR_OP(or, x12, x10, x11, 0x33333337, 0x33333333, 0x6, x6, 744, x8)

inst_206:
// rs1_val==858993459 and rs2_val==858993460, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x33333334
TEST_RR_OP(or, x12, x10, x11, 0x33333337, 0x33333333, 0x33333334, x6, 748, x8)

inst_207:
// rs1_val==858993459 and rs2_val==1717986919, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x66666667
TEST_RR_OP(or, x12, x10, x11, 0x77777777, 0x33333333, 0x66666667, x6, 752, x8)

inst_208:
// rs1_val==858993459 and rs2_val==-46339, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:-0xb503
TEST_RR_OP(or, x12, x10, x11, 0xffff7bff, 0x33333333, -0xb503, x6, 756, x8)

inst_209:
// rs1_val==858993459 and rs2_val==46341, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0xb505
TEST_RR_OP(or, x12, x10, x11, 0x3333b737, 0x33333333, 0xb505, x6, 760, x8)

inst_210:
// rs1_val==1717986918 and rs2_val==3, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x3
TEST_RR_OP(or, x12, x10, x11, 0x66666667, 0x66666666, 0x3, x6, 764, x8)

inst_211:
// rs1_val==1717986918 and rs2_val==1431655765, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x55555555
TEST_RR_OP(or, x12, x10, x11, 0x77777777, 0x66666666, 0x55555555, x6, 768, x8)

inst_212:
// rs1_val==1717986918 and rs2_val==-1431655766, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:-0x55555556
TEST_RR_OP(or, x12, x10, x11, 0xeeeeeeee, 0x66666666, -0x55555556, x6, 772, x8)

inst_213:
// rs1_val==1717986918 and rs2_val==5, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x5
TEST_RR_OP(or, x12, x10, x11, 0x66666667, 0x66666666, 0x5, x6, 776, x8)

inst_214:
// rs1_val==1717986918 and rs2_val==858993459, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x33333333
TEST_RR_OP(or, x12, x10, x11, 0x77777777, 0x66666666, 0x33333333, x6, 780, x8)

inst_215:
// rs1_val==1717986918 and rs2_val==1717986918, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x66666666
TEST_RR_OP(or, x12, x10, x11, 0x66666666, 0x66666666, 0x66666666, x6, 784, x8)

inst_216:
// rs1_val==1717986918 and rs2_val==-46340, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:-0xb504
TEST_RR_OP(or, x12, x10, x11, 0xffff6efe, 0x66666666, -0xb504, x6, 788, x8)

inst_217:
// rs1_val==1717986918 and rs2_val==46340, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0xb504
TEST_RR_OP(or, x12, x10, x11, 0x6666f766, 0x66666666, 0xb504, x6, 792, x8)

inst_218:
// rs1_val==1717986918 and rs2_val==2, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x2
TEST_RR_OP(or, x12, x10, x11, 0x66666666, 0x66666666, 0x2, x6, 796, x8)

inst_219:
// rs1_val==1717986918 and rs2_val==1431655764, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x55555554
TEST_RR_OP(or, x12, x10, x11, 0x77777776, 0x66666666, 0x55555554, x6, 800, x8)

inst_220:
// rs1_val==1717986918 and rs2_val==0, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x0
TEST_RR_OP(or, x12, x10, x11, 0x66666666, 0x66666666, 0x0, x6, 804, x8)

inst_221:
// rs1_val==1717986918 and rs2_val==4, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x4
TEST_RR_OP(or, x12, x10, x11, 0x66666666, 0x66666666, 0x4, x6, 808, x8)

inst_222:
// rs1_val==1717986918 and rs2_val==858993458, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x33333332
TEST_RR_OP(or, x12, x10, x11, 0x77777776, 0x66666666, 0x33333332, x6, 812, x8)

inst_223:
// rs1_val==1717986918 and rs2_val==1717986917, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x66666665
TEST_RR_OP(or, x12, x10, x11, 0x66666667, 0x66666666, 0x66666665, x6, 816, x8)

inst_224:
// rs1_val==1717986918 and rs2_val==46339, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0xb503
TEST_RR_OP(or, x12, x10, x11, 0x6666f767, 0x66666666, 0xb503, x6, 820, x8)

inst_225:
// rs1_val==1717986918 and rs2_val==1431655766, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x55555556
TEST_RR_OP(or, x12, x10, x11, 0x77777776, 0x66666666, 0x55555556, x6, 824, x8)

inst_226:
// rs1_val==1717986918 and rs2_val==-1431655765, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:-0x55555555
TEST_RR_OP(or, x12, x10, x11, 0xeeeeeeef, 0x66666666, -0x55555555, x6, 828, x8)

inst_227:
// rs1_val==1717986918 and rs2_val==6, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x6
TEST_RR_OP(or, x12, x10, x11, 0x66666666, 0x66666666, 0x6, x6, 832, x8)

inst_228:
// rs1_val==1717986918 and rs2_val==858993460, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x33333334
TEST_RR_OP(or, x12, x10, x11, 0x77777776, 0x66666666, 0x33333334, x6, 836, x8)

inst_229:
// rs1_val==1717986918 and rs2_val==1717986919, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x66666667
TEST_RR_OP(or, x12, x10, x11, 0x66666667, 0x66666666, 0x66666667, x6, 840, x8)

inst_230:
// rs1_val==1717986918 and rs2_val==-46339, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:-0xb503
TEST_RR_OP(or, x12, x10, x11, 0xffff6eff, 0x66666666, -0xb503, x6, 844, x8)

inst_231:
// rs1_val==1717986918 and rs2_val==46341, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0xb505
TEST_RR_OP(or, x12, x10, x11, 0x6666f767, 0x66666666, 0xb505, x6, 848, x8)

inst_232:
// rs1_val==-46340 and rs2_val==3, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x3
TEST_RR_OP(or, x12, x10, x11, 0xffff4aff, -0xb504, 0x3, x6, 852, x8)

inst_233:
// rs1_val==-46340 and rs2_val==1431655765, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x55555555
TEST_RR_OP(or, x12, x10, x11, 0xffff5ffd, -0xb504, 0x55555555, x6, 856, x8)

inst_234:
// rs1_val==-46340 and rs2_val==-1431655766, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:-0x55555556
TEST_RR_OP(or, x12, x10, x11, 0xffffeafe, -0xb504, -0x55555556, x6, 860, x8)

inst_235:
// rs1_val==-46340 and rs2_val==5, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x5
TEST_RR_OP(or, x12, x10, x11, 0xffff4afd, -0xb504, 0x5, x6, 864, x8)

inst_236:
// rs1_val==-46340 and rs2_val==858993459, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x33333333
TEST_RR_OP(or, x12, x10, x11, 0xffff7bff, -0xb504, 0x33333333, x6, 868, x8)

inst_237:
// rs1_val==-46340 and rs2_val==1717986918, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x66666666
TEST_RR_OP(or, x12, x10, x11, 0xffff6efe, -0xb504, 0x66666666, x6, 872, x8)

inst_238:
// rs1_val==-46340 and rs2_val==-46340, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:-0xb504
TEST_RR_OP(or, x12, x10, x11, 0xffff4afc, -0xb504, -0xb504, x6, 876, x8)

inst_239:
// rs1_val==-46340 and rs2_val==46340, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0xb504
TEST_RR_OP(or, x12, x10, x11, 0xfffffffc, -0xb504, 0xb504, x6, 880, x8)

inst_240:
// rs1_val==-46340 and rs2_val==2, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x2
TEST_RR_OP(or, x12, x10, x11, 0xffff4afe, -0xb504, 0x2, x6, 884, x8)

inst_241:
// rs1_val==-46340 and rs2_val==1431655764, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x55555554
TEST_RR_OP(or, x12, x10, x11, 0xffff5ffc, -0xb504, 0x55555554, x6, 888, x8)

inst_242:
// rs1_val==-46340 and rs2_val==0, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x0
TEST_RR_OP(or, x12, x10, x11, 0xffff4afc, -0xb504, 0x0, x6, 892, x8)

inst_243:
// rs1_val==-46340 and rs2_val==4, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x4
TEST_RR_OP(or, x12, x10, x11, 0xffff4afc, -0xb504, 0x4, x6, 896, x8)

inst_244:
// rs1_val==-46340 and rs2_val==858993458, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x33333332
TEST_RR_OP(or, x12, x10, x11, 0xffff7bfe, -0xb504, 0x33333332, x6, 900, x8)

inst_245:
// rs1_val==-46340 and rs2_val==1717986917, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x66666665
TEST_RR_OP(or, x12, x10, x11, 0xffff6efd, -0xb504, 0x66666665, x6, 904, x8)

inst_246:
// rs1_val==-46340 and rs2_val==46339, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0xb503
TEST_RR_OP(or, x12, x10, x11, 0xffffffff, -0xb504, 0xb503, x6, 908, x8)

inst_247:
// rs1_val==-46340 and rs2_val==1431655766, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x55555556
TEST_RR_OP(or, x12, x10, x11, 0xffff5ffe, -0xb504, 0x55555556, x6, 912, x8)

inst_248:
// rs1_val==-46340 and rs2_val==-1431655765, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:-0x55555555
TEST_RR_OP(or, x12, x10, x11, 0xffffeaff, -0xb504, -0x55555555, x6, 916, x8)

inst_249:
// rs1_val==-46340 and rs2_val==6, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x6
TEST_RR_OP(or, x12, x10, x11, 0xffff4afe, -0xb504, 0x6, x6, 920, x8)

inst_250:
// rs1_val==-46340 and rs2_val==858993460, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x33333334
TEST_RR_OP(or, x12, x10, x11, 0xffff7bfc, -0xb504, 0x33333334, x6, 924, x8)

inst_251:
// rs1_val==-46340 and rs2_val==1717986919, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x66666667
TEST_RR_OP(or, x12, x10, x11, 0xffff6eff, -0xb504, 0x66666667, x6, 928, x8)

inst_252:
// rs1_val==-46340 and rs2_val==-46339, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:-0xb503
TEST_RR_OP(or, x12, x10, x11, 0xffff4afd, -0xb504, -0xb503, x6, 932, x8)

inst_253:
// rs1_val==-46340 and rs2_val==46341, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0xb505
TEST_RR_OP(or, x12, x10, x11, 0xfffffffd, -0xb504, 0xb505, x6, 936, x8)

inst_254:
// rs1_val==46340 and rs2_val==3, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x3
TEST_RR_OP(or, x12, x10, x11, 0xb507, 0xb504, 0x3, x6, 940, x8)

inst_255:
// rs1_val==46340 and rs2_val==1431655765, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x55555555
TEST_RR_OP(or, x12, x10, x11, 0x5555f555, 0xb504, 0x55555555, x6, 944, x8)

inst_256:
// rs1_val==46340 and rs2_val==-1431655766, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:-0x55555556
TEST_RR_OP(or, x12, x10, x11, 0xaaaabfae, 0xb504, -0x55555556, x6, 948, x8)

inst_257:
// rs1_val==46340 and rs2_val==5, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x5
TEST_RR_OP(or, x12, x10, x11, 0xb505, 0xb504, 0x5, x6, 952, x8)

inst_258:
// rs1_val==46340 and rs2_val==858993459, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x33333333
TEST_RR_OP(or, x12, x10, x11, 0x3333b737, 0xb504, 0x33333333, x6, 956, x8)

inst_259:
// rs1_val==46340 and rs2_val==1717986918, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x66666666
TEST_RR_OP(or, x12, x10, x11, 0x6666f766, 0xb504, 0x66666666, x6, 960, x8)

inst_260:
// rs1_val==46340 and rs2_val==-46340, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:-0xb504
TEST_RR_OP(or, x12, x10, x11, 0xfffffffc, 0xb504, -0xb504, x6, 964, x8)

inst_261:
// rs1_val==46340 and rs2_val==46340, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0xb504
TEST_RR_OP(or, x12, x10, x11, 0xb504, 0xb504, 0xb504, x6, 968, x8)

inst_262:
// rs1_val==46340 and rs2_val==2, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x2
TEST_RR_OP(or, x12, x10, x11, 0xb506, 0xb504, 0x2, x6, 972, x8)

inst_263:
// rs1_val==46340 and rs2_val==1431655764, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x55555554
TEST_RR_OP(or, x12, x10, x11, 0x5555f554, 0xb504, 0x55555554, x6, 976, x8)

inst_264:
// rs1_val==46340 and rs2_val==0, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x0
TEST_RR_OP(or, x12, x10, x11, 0xb504, 0xb504, 0x0, x6, 980, x8)

inst_265:
// rs1_val==46340 and rs2_val==4, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x4
TEST_RR_OP(or, x12, x10, x11, 0xb504, 0xb504, 0x4, x6, 984, x8)

inst_266:
// rs1_val==46340 and rs2_val==858993458, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x33333332
TEST_RR_OP(or, x12, x10, x11, 0x3333b736, 0xb504, 0x33333332, x6, 988, x8)

inst_267:
// rs1_val==46340 and rs2_val==1717986917, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x66666665
TEST_RR_OP(or, x12, x10, x11, 0x6666f765, 0xb504, 0x66666665, x6, 992, x8)

inst_268:
// rs1_val==46340 and rs2_val==46339, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0xb503
TEST_RR_OP(or, x12, x10, x11, 0xb507, 0xb504, 0xb503, x6, 996, x8)

inst_269:
// rs1_val==46340 and rs2_val==1431655766, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x55555556
TEST_RR_OP(or, x12, x10, x11, 0x5555f556, 0xb504, 0x55555556, x6, 1000, x8)

inst_270:
// rs1_val==46340 and rs2_val==-1431655765, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:-0x55555555
TEST_RR_OP(or, x12, x10, x11, 0xaaaabfaf, 0xb504, -0x55555555, x6, 1004, x8)

inst_271:
// rs1_val==46340 and rs2_val==6, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x6
TEST_RR_OP(or, x12, x10, x11, 0xb506, 0xb504, 0x6, x6, 1008, x8)

inst_272:
// rs1_val==46340 and rs2_val==858993460, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x33333334
TEST_RR_OP(or, x12, x10, x11, 0x3333b734, 0xb504, 0x33333334, x6, 1012, x8)

inst_273:
// rs1_val==46340 and rs2_val==1717986919, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x66666667
TEST_RR_OP(or, x12, x10, x11, 0x6666f767, 0xb504, 0x66666667, x6, 1016, x8)

inst_274:
// rs1_val==46340 and rs2_val==-46339, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:-0xb503
TEST_RR_OP(or, x12, x10, x11, 0xfffffffd, 0xb504, -0xb503, x6, 1020, x8)

inst_275:
// rs1_val==46340 and rs2_val==46341, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0xb505
TEST_RR_OP(or, x12, x10, x11, 0xb505, 0xb504, 0xb505, x6, 1024, x8)

inst_276:
// rs1_val==2 and rs2_val==3, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x3
TEST_RR_OP(or, x12, x10, x11, 0x3, 0x2, 0x3, x6, 1028, x8)

inst_277:
// rs1_val==2 and rs2_val==1431655765, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x55555555
TEST_RR_OP(or, x12, x10, x11, 0x55555557, 0x2, 0x55555555, x6, 1032, x8)

inst_278:
// rs1_val==2 and rs2_val==-1431655766, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:-0x55555556
TEST_RR_OP(or, x12, x10, x11, 0xaaaaaaaa, 0x2, -0x55555556, x6, 1036, x8)

inst_279:
// rs1_val==2 and rs2_val==5, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x5
TEST_RR_OP(or, x12, x10, x11, 0x7, 0x2, 0x5, x6, 1040, x8)

inst_280:
// rs1_val==2 and rs2_val==858993459, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x33333333
TEST_RR_OP(or, x12, x10, x11, 0x33333333, 0x2, 0x33333333, x6, 1044, x8)

inst_281:
// rs1_val==2 and rs2_val==1717986918, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x66666666
TEST_RR_OP(or, x12, x10, x11, 0x66666666, 0x2, 0x66666666, x6, 1048, x8)

inst_282:
// rs1_val==2 and rs2_val==-46340, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:-0xb504
TEST_RR_OP(or, x12, x10, x11, 0xffff4afe, 0x2, -0xb504, x6, 1052, x8)

inst_283:
// rs1_val==2 and rs2_val==46340, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0xb504
TEST_RR_OP(or, x12, x10, x11, 0xb506, 0x2, 0xb504, x6, 1056, x8)

inst_284:
// rs1_val==2 and rs2_val==2, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x2
TEST_RR_OP(or, x12, x10, x11, 0x2, 0x2, 0x2, x6, 1060, x8)

inst_285:
// rs1_val==2 and rs2_val==1431655764, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x55555554
TEST_RR_OP(or, x12, x10, x11, 0x55555556, 0x2, 0x55555554, x6, 1064, x8)

inst_286:
// rs1_val==2 and rs2_val==0, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x0
TEST_RR_OP(or, x12, x10, x11, 0x2, 0x2, 0x0, x6, 1068, x8)

inst_287:
// rs1_val==2 and rs2_val==4, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x4
TEST_RR_OP(or, x12, x10, x11, 0x6, 0x2, 0x4, x6, 1072, x8)

inst_288:
// rs1_val==2 and rs2_val==858993458, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x33333332
TEST_RR_OP(or, x12, x10, x11, 0x33333332, 0x2, 0x33333332, x6, 1076, x8)

inst_289:
// rs1_val==2 and rs2_val==1717986917, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x66666665
TEST_RR_OP(or, x12, x10, x11, 0x66666667, 0x2, 0x66666665, x6, 1080, x8)

inst_290:
// rs1_val==2 and rs2_val==46339, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0xb503
TEST_RR_OP(or, x12, x10, x11, 0xb503, 0x2, 0xb503, x6, 1084, x8)

inst_291:
// rs1_val==2 and rs2_val==1431655766, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x55555556
TEST_RR_OP(or, x12, x10, x11, 0x55555556, 0x2, 0x55555556, x6, 1088, x8)

inst_292:
// rs1_val==2 and rs2_val==-1431655765, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:-0x55555555
TEST_RR_OP(or, x12, x10, x11, 0xaaaaaaab, 0x2, -0x55555555, x6, 1092, x8)

inst_293:
// rs1_val==2 and rs2_val==6, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x6
TEST_RR_OP(or, x12, x10, x11, 0x6, 0x2, 0x6, x6, 1096, x8)

inst_294:
// rs1_val==2 and rs2_val==858993460, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x33333334
TEST_RR_OP(or, x12, x10, x11, 0x33333336, 0x2, 0x33333334, x6, 1100, x8)

inst_295:
// rs1_val==2 and rs2_val==1717986919, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x66666667
TEST_RR_OP(or, x12, x10, x11, 0x66666667, 0x2, 0x66666667, x6, 1104, x8)

inst_296:
// rs1_val==2 and rs2_val==-46339, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:-0xb503
TEST_RR_OP(or, x12, x10, x11, 0xffff4aff, 0x2, -0xb503, x6, 1108, x8)

inst_297:
// rs1_val==2 and rs2_val==46341, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0xb505
TEST_RR_OP(or, x12, x10, x11, 0xb507, 0x2, 0xb505, x6, 1112, x8)

inst_298:
// rs1_val==1431655764 and rs2_val==3, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x3
TEST_RR_OP(or, x12, x10, x11, 0x55555557, 0x55555554, 0x3, x6, 1116, x8)

inst_299:
// rs1_val==1431655764 and rs2_val==1431655765, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x55555555
TEST_RR_OP(or, x12, x10, x11, 0x55555555, 0x55555554, 0x55555555, x6, 1120, x8)

inst_300:
// rs1_val==1431655764 and rs2_val==-1431655766, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:-0x55555556
TEST_RR_OP(or, x12, x10, x11, 0xfffffffe, 0x55555554, -0x55555556, x6, 1124, x8)

inst_301:
// rs1_val==1431655764 and rs2_val==5, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x5
TEST_RR_OP(or, x12, x10, x11, 0x55555555, 0x55555554, 0x5, x6, 1128, x8)

inst_302:
// rs1_val==1431655764 and rs2_val==858993459, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x33333333
TEST_RR_OP(or, x12, x10, x11, 0x77777777, 0x55555554, 0x33333333, x6, 1132, x8)

inst_303:
// rs1_val==1431655764 and rs2_val==1717986918, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x66666666
TEST_RR_OP(or, x12, x10, x11, 0x77777776, 0x55555554, 0x66666666, x6, 1136, x8)

inst_304:
// rs1_val==1431655764 and rs2_val==-46340, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:-0xb504
TEST_RR_OP(or, x12, x10, x11, 0xffff5ffc, 0x55555554, -0xb504, x6, 1140, x8)

inst_305:
// rs1_val==1431655764 and rs2_val==46340, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0xb504
TEST_RR_OP(or, x12, x10, x11, 0x5555f554, 0x55555554, 0xb504, x6, 1144, x8)

inst_306:
// rs1_val==1431655764 and rs2_val==2, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x2
TEST_RR_OP(or, x12, x10, x11, 0x55555556, 0x55555554, 0x2, x6, 1148, x8)

inst_307:
// rs1_val==1431655764 and rs2_val==1431655764, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x55555554
TEST_RR_OP(or, x12, x10, x11, 0x55555554, 0x55555554, 0x55555554, x6, 1152, x8)

inst_308:
// rs1_val==1431655764 and rs2_val==0, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x0
TEST_RR_OP(or, x12, x10, x11, 0x55555554, 0x55555554, 0x0, x6, 1156, x8)

inst_309:
// rs1_val==1431655764 and rs2_val==4, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x4
TEST_RR_OP(or, x12, x10, x11, 0x55555554, 0x55555554, 0x4, x6, 1160, x8)

inst_310:
// rs1_val==1431655764 and rs2_val==858993458, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x33333332
TEST_RR_OP(or, x12, x10, x11, 0x77777776, 0x55555554, 0x33333332, x6, 1164, x8)

inst_311:
// rs1_val==1431655764 and rs2_val==1717986917, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x66666665
TEST_RR_OP(or, x12, x10, x11, 0x77777775, 0x55555554, 0x66666665, x6, 1168, x8)

inst_312:
// rs1_val==1431655764 and rs2_val==46339, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0xb503
TEST_RR_OP(or, x12, x10, x11, 0x5555f557, 0x55555554, 0xb503, x6, 1172, x8)

inst_313:
// rs1_val==1431655764 and rs2_val==1431655766, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x55555556
TEST_RR_OP(or, x12, x10, x11, 0x55555556, 0x55555554, 0x55555556, x6, 1176, x8)

inst_314:
// rs1_val==1431655764 and rs2_val==-1431655765, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:-0x55555555
TEST_RR_OP(or, x12, x10, x11, 0xffffffff, 0x55555554, -0x55555555, x6, 1180, x8)

inst_315:
// rs1_val==1431655764 and rs2_val==6, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x6
TEST_RR_OP(or, x12, x10, x11, 0x55555556, 0x55555554, 0x6, x6, 1184, x8)

inst_316:
// rs1_val==1431655764 and rs2_val==858993460, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x33333334
TEST_RR_OP(or, x12, x10, x11, 0x77777774, 0x55555554, 0x33333334, x6, 1188, x8)

inst_317:
// rs1_val==1431655764 and rs2_val==1717986919, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x66666667
TEST_RR_OP(or, x12, x10, x11, 0x77777777, 0x55555554, 0x66666667, x6, 1192, x8)

inst_318:
// rs1_val==1431655764 and rs2_val==-46339, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:-0xb503
TEST_RR_OP(or, x12, x10, x11, 0xffff5ffd, 0x55555554, -0xb503, x6, 1196, x8)

inst_319:
// rs1_val==1431655764 and rs2_val==46341, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0xb505
TEST_RR_OP(or, x12, x10, x11, 0x5555f555, 0x55555554, 0xb505, x6, 1200, x8)

inst_320:
// rs1_val==0 and rs2_val==3, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x3
TEST_RR_OP(or, x12, x10, x11, 0x3, 0x0, 0x3, x6, 1204, x8)

inst_321:
// rs1_val==0 and rs2_val==1431655765, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x55555555
TEST_RR_OP(or, x12, x10, x11, 0x55555555, 0x0, 0x55555555, x6, 1208, x8)

inst_322:
// rs1_val==0 and rs2_val==-1431655766, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:-0x55555556
TEST_RR_OP(or, x12, x10, x11, 0xaaaaaaaa, 0x0, -0x55555556, x6, 1212, x8)

inst_323:
// rs1_val==0 and rs2_val==5, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x5
TEST_RR_OP(or, x12, x10, x11, 0x5, 0x0, 0x5, x6, 1216, x8)

inst_324:
// rs1_val==0 and rs2_val==858993459, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x33333333
TEST_RR_OP(or, x12, x10, x11, 0x33333333, 0x0, 0x33333333, x6, 1220, x8)

inst_325:
// rs1_val==0 and rs2_val==1717986918, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x66666666
TEST_RR_OP(or, x12, x10, x11, 0x66666666, 0x0, 0x66666666, x6, 1224, x8)

inst_326:
// rs1_val==0 and rs2_val==-46340, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:-0xb504
TEST_RR_OP(or, x12, x10, x11, 0xffff4afc, 0x0, -0xb504, x6, 1228, x8)

inst_327:
// rs1_val==0 and rs2_val==46340, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0xb504
TEST_RR_OP(or, x12, x10, x11, 0xb504, 0x0, 0xb504, x6, 1232, x8)

inst_328:
// rs1_val==0 and rs2_val==2, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x2
TEST_RR_OP(or, x12, x10, x11, 0x2, 0x0, 0x2, x6, 1236, x8)

inst_329:
// rs1_val==-1431655765 and rs2_val==-1431655765, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:-0x55555555
TEST_RR_OP(or, x12, x10, x11, 0xaaaaaaab, -0x55555555, -0x55555555, x6, 1240, x8)

inst_330:
// rs1_val==-1431655765 and rs2_val==6, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x6
TEST_RR_OP(or, x12, x10, x11, 0xaaaaaaaf, -0x55555555, 0x6, x6, 1244, x8)

inst_331:
// rs1_val==-1431655765 and rs2_val==858993460, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x33333334
TEST_RR_OP(or, x12, x10, x11, 0xbbbbbbbf, -0x55555555, 0x33333334, x6, 1248, x8)

inst_332:
// rs1_val==-1431655765 and rs2_val==1717986919, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x66666667
TEST_RR_OP(or, x12, x10, x11, 0xeeeeeeef, -0x55555555, 0x66666667, x6, 1252, x8)

inst_333:
// rs1_val==-1431655765 and rs2_val==-46339, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:-0xb503
TEST_RR_OP(or, x12, x10, x11, 0xffffeaff, -0x55555555, -0xb503, x6, 1256, x8)

inst_334:
// rs1_val==-1431655765 and rs2_val==46341, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0xb505
TEST_RR_OP(or, x12, x10, x11, 0xaaaabfaf, -0x55555555, 0xb505, x6, 1260, x8)

inst_335:
// rs1_val==6 and rs2_val==3, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x3
TEST_RR_OP(or, x12, x10, x11, 0x7, 0x6, 0x3, x6, 1264, x8)

inst_336:
// rs1_val==6 and rs2_val==1431655765, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x55555555
TEST_RR_OP(or, x12, x10, x11, 0x55555557, 0x6, 0x55555555, x6, 1268, x8)

inst_337:
// rs1_val==6 and rs2_val==-1431655766, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:-0x55555556
TEST_RR_OP(or, x12, x10, x11, 0xaaaaaaae, 0x6, -0x55555556, x6, 1272, x8)

inst_338:
// rs1_val==6 and rs2_val==5, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x5
TEST_RR_OP(or, x12, x10, x11, 0x7, 0x6, 0x5, x6, 1276, x8)

inst_339:
// rs1_val==6 and rs2_val==858993459, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x33333333
TEST_RR_OP(or, x12, x10, x11, 0x33333337, 0x6, 0x33333333, x6, 1280, x8)

inst_340:
// rs1_val==6 and rs2_val==1717986918, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x66666666
TEST_RR_OP(or, x12, x10, x11, 0x66666666, 0x6, 0x66666666, x6, 1284, x8)

inst_341:
// rs1_val==6 and rs2_val==-46340, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:-0xb504
TEST_RR_OP(or, x12, x10, x11, 0xffff4afe, 0x6, -0xb504, x6, 1288, x8)

inst_342:
// rs1_val==6 and rs2_val==46340, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0xb504
TEST_RR_OP(or, x12, x10, x11, 0xb506, 0x6, 0xb504, x6, 1292, x8)

inst_343:
// rs1_val==6 and rs2_val==2, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x2
TEST_RR_OP(or, x12, x10, x11, 0x6, 0x6, 0x2, x6, 1296, x8)

inst_344:
// rs1_val==6 and rs2_val==1431655764, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x55555554
TEST_RR_OP(or, x12, x10, x11, 0x55555556, 0x6, 0x55555554, x6, 1300, x8)

inst_345:
// rs1_val==6 and rs2_val==0, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x0
TEST_RR_OP(or, x12, x10, x11, 0x6, 0x6, 0x0, x6, 1304, x8)

inst_346:
// rs1_val==6 and rs2_val==4, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x4
TEST_RR_OP(or, x12, x10, x11, 0x6, 0x6, 0x4, x6, 1308, x8)

inst_347:
// rs1_val==6 and rs2_val==858993458, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x33333332
TEST_RR_OP(or, x12, x10, x11, 0x33333336, 0x6, 0x33333332, x6, 1312, x8)

inst_348:
// rs1_val==6 and rs2_val==1717986917, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x66666665
TEST_RR_OP(or, x12, x10, x11, 0x66666667, 0x6, 0x66666665, x6, 1316, x8)

inst_349:
// rs1_val==6 and rs2_val==46339, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0xb503
TEST_RR_OP(or, x12, x10, x11, 0xb507, 0x6, 0xb503, x6, 1320, x8)

inst_350:
// rs1_val==6 and rs2_val==1431655766, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x55555556
TEST_RR_OP(or, x12, x10, x11, 0x55555556, 0x6, 0x55555556, x6, 1324, x8)

inst_351:
// rs1_val==6 and rs2_val==-1431655765, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:-0x55555555
TEST_RR_OP(or, x12, x10, x11, 0xaaaaaaaf, 0x6, -0x55555555, x6, 1328, x8)

inst_352:
// rs1_val==6 and rs2_val==6, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x6
TEST_RR_OP(or, x12, x10, x11, 0x6, 0x6, 0x6, x6, 1332, x8)

inst_353:
// rs1_val==6 and rs2_val==858993460, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x33333334
TEST_RR_OP(or, x12, x10, x11, 0x33333336, 0x6, 0x33333334, x6, 1336, x8)

inst_354:
// rs1_val==6 and rs2_val==1717986919, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x66666667
TEST_RR_OP(or, x12, x10, x11, 0x66666667, 0x6, 0x66666667, x6, 1340, x8)

inst_355:
// rs1_val==6 and rs2_val==-46339, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:-0xb503
TEST_RR_OP(or, x12, x10, x11, 0xffff4aff, 0x6, -0xb503, x6, 1344, x8)

inst_356:
// rs1_val==6 and rs2_val==46341, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0xb505
TEST_RR_OP(or, x12, x10, x11, 0xb507, 0x6, 0xb505, x6, 1348, x8)

inst_357:
// rs1_val==858993460 and rs2_val==3, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x3
TEST_RR_OP(or, x12, x10, x11, 0x33333337, 0x33333334, 0x3, x6, 1352, x8)

inst_358:
// rs1_val==858993460 and rs2_val==1431655765, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x55555555
TEST_RR_OP(or, x12, x10, x11, 0x77777775, 0x33333334, 0x55555555, x6, 1356, x8)

inst_359:
// rs1_val==858993460 and rs2_val==-1431655766, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:-0x55555556
TEST_RR_OP(or, x12, x10, x11, 0xbbbbbbbe, 0x33333334, -0x55555556, x6, 1360, x8)

inst_360:
// rs1_val==858993460 and rs2_val==5, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x5
TEST_RR_OP(or, x12, x10, x11, 0x33333335, 0x33333334, 0x5, x6, 1364, x8)

inst_361:
// rs1_val==858993460 and rs2_val==858993459, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x33333333
TEST_RR_OP(or, x12, x10, x11, 0x33333337, 0x33333334, 0x33333333, x6, 1368, x8)

inst_362:
// rs1_val==858993460 and rs2_val==1717986918, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x66666666
TEST_RR_OP(or, x12, x10, x11, 0x77777776, 0x33333334, 0x66666666, x6, 1372, x8)

inst_363:
// rs1_val==858993460 and rs2_val==-46340, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:-0xb504
TEST_RR_OP(or, x12, x10, x11, 0xffff7bfc, 0x33333334, -0xb504, x6, 1376, x8)

inst_364:
// rs1_val==858993460 and rs2_val==46340, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0xb504
TEST_RR_OP(or, x12, x10, x11, 0x3333b734, 0x33333334, 0xb504, x6, 1380, x8)

inst_365:
// rs1_val==858993460 and rs2_val==2, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x2
TEST_RR_OP(or, x12, x10, x11, 0x33333336, 0x33333334, 0x2, x6, 1384, x8)

inst_366:
// rs1_val==858993460 and rs2_val==1431655764, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x55555554
TEST_RR_OP(or, x12, x10, x11, 0x77777774, 0x33333334, 0x55555554, x6, 1388, x8)

inst_367:
// rs1_val==858993460 and rs2_val==0, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x0
TEST_RR_OP(or, x12, x10, x11, 0x33333334, 0x33333334, 0x0, x6, 1392, x8)

inst_368:
// rs1_val==858993460 and rs2_val==4, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x4
TEST_RR_OP(or, x12, x10, x11, 0x33333334, 0x33333334, 0x4, x6, 1396, x8)

inst_369:
// rs1_val==858993460 and rs2_val==858993458, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x33333332
TEST_RR_OP(or, x12, x10, x11, 0x33333336, 0x33333334, 0x33333332, x6, 1400, x8)

inst_370:
// rs1_val==858993460 and rs2_val==1717986917, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x66666665
TEST_RR_OP(or, x12, x10, x11, 0x77777775, 0x33333334, 0x66666665, x6, 1404, x8)

inst_371:
// rs1_val==858993460 and rs2_val==46339, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0xb503
TEST_RR_OP(or, x12, x10, x11, 0x3333b737, 0x33333334, 0xb503, x6, 1408, x8)

inst_372:
// rs1_val==858993460 and rs2_val==1431655766, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x55555556
TEST_RR_OP(or, x12, x10, x11, 0x77777776, 0x33333334, 0x55555556, x6, 1412, x8)

inst_373:
// rs1_val==858993460 and rs2_val==-1431655765, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:-0x55555555
TEST_RR_OP(or, x12, x10, x11, 0xbbbbbbbf, 0x33333334, -0x55555555, x6, 1416, x8)

inst_374:
// rs1_val==858993460 and rs2_val==6, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x6
TEST_RR_OP(or, x12, x10, x11, 0x33333336, 0x33333334, 0x6, x6, 1420, x8)

inst_375:
// rs1_val==858993460 and rs2_val==858993460, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x33333334
TEST_RR_OP(or, x12, x10, x11, 0x33333334, 0x33333334, 0x33333334, x6, 1424, x8)

inst_376:
// rs1_val==858993460 and rs2_val==1717986919, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x66666667
TEST_RR_OP(or, x12, x10, x11, 0x77777777, 0x33333334, 0x66666667, x6, 1428, x8)

inst_377:
// rs1_val==858993460 and rs2_val==-46339, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:-0xb503
TEST_RR_OP(or, x12, x10, x11, 0xffff7bfd, 0x33333334, -0xb503, x6, 1432, x8)

inst_378:
// rs1_val==858993460 and rs2_val==46341, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0xb505
TEST_RR_OP(or, x12, x10, x11, 0x3333b735, 0x33333334, 0xb505, x6, 1436, x8)

inst_379:
// rs1_val==1717986919 and rs2_val==3, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x3
TEST_RR_OP(or, x12, x10, x11, 0x66666667, 0x66666667, 0x3, x6, 1440, x8)

inst_380:
// rs1_val==1717986919 and rs2_val==1431655765, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x55555555
TEST_RR_OP(or, x12, x10, x11, 0x77777777, 0x66666667, 0x55555555, x6, 1444, x8)

inst_381:
// rs1_val==1717986919 and rs2_val==-1431655766, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:-0x55555556
TEST_RR_OP(or, x12, x10, x11, 0xeeeeeeef, 0x66666667, -0x55555556, x6, 1448, x8)

inst_382:
// rs1_val==1717986919 and rs2_val==5, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x5
TEST_RR_OP(or, x12, x10, x11, 0x66666667, 0x66666667, 0x5, x6, 1452, x8)

inst_383:
// rs1_val==1717986919 and rs2_val==858993459, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x33333333
TEST_RR_OP(or, x12, x10, x11, 0x77777777, 0x66666667, 0x33333333, x6, 1456, x8)

inst_384:
// rs1_val==1717986919 and rs2_val==1717986918, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x66666666
TEST_RR_OP(or, x12, x10, x11, 0x66666667, 0x66666667, 0x66666666, x6, 1460, x8)

inst_385:
// rs1_val==1717986919 and rs2_val==-46340, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:-0xb504
TEST_RR_OP(or, x12, x10, x11, 0xffff6eff, 0x66666667, -0xb504, x6, 1464, x8)

inst_386:
// rs1_val==1717986919 and rs2_val==46340, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0xb504
TEST_RR_OP(or, x12, x10, x11, 0x6666f767, 0x66666667, 0xb504, x6, 1468, x8)

inst_387:
// rs1_val==1717986919 and rs2_val==2, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x2
TEST_RR_OP(or, x12, x10, x11, 0x66666667, 0x66666667, 0x2, x6, 1472, x8)

inst_388:
// rs1_val==1717986919 and rs2_val==1431655764, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x55555554
TEST_RR_OP(or, x12, x10, x11, 0x77777777, 0x66666667, 0x55555554, x6, 1476, x8)

inst_389:
// rs1_val==1717986919 and rs2_val==0, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x0
TEST_RR_OP(or, x12, x10, x11, 0x66666667, 0x66666667, 0x0, x6, 1480, x8)

inst_390:
// rs1_val==1717986919 and rs2_val==4, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x4
TEST_RR_OP(or, x12, x10, x11, 0x66666667, 0x66666667, 0x4, x6, 1484, x8)

inst_391:
// rs1_val==1717986919 and rs2_val==858993458, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x33333332
TEST_RR_OP(or, x12, x10, x11, 0x77777777, 0x66666667, 0x33333332, x6, 1488, x8)

inst_392:
// rs1_val==1717986919 and rs2_val==1717986917, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x66666665
TEST_RR_OP(or, x12, x10, x11, 0x66666667, 0x66666667, 0x66666665, x6, 1492, x8)

inst_393:
// rs1_val==1717986919 and rs2_val==46339, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0xb503
TEST_RR_OP(or, x12, x10, x11, 0x6666f767, 0x66666667, 0xb503, x6, 1496, x8)

inst_394:
// rs1_val==1717986919 and rs2_val==1431655766, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x55555556
TEST_RR_OP(or, x12, x10, x11, 0x77777777, 0x66666667, 0x55555556, x6, 1500, x8)

inst_395:
// rs1_val==1717986919 and rs2_val==-1431655765, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:-0x55555555
TEST_RR_OP(or, x12, x10, x11, 0xeeeeeeef, 0x66666667, -0x55555555, x6, 1504, x8)

inst_396:
// rs1_val==1717986919 and rs2_val==6, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x6
TEST_RR_OP(or, x12, x10, x11, 0x66666667, 0x66666667, 0x6, x6, 1508, x8)

inst_397:
// rs1_val==1717986919 and rs2_val==858993460, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x33333334
TEST_RR_OP(or, x12, x10, x11, 0x77777777, 0x66666667, 0x33333334, x6, 1512, x8)

inst_398:
// rs1_val==1717986919 and rs2_val==1717986919, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x66666667
TEST_RR_OP(or, x12, x10, x11, 0x66666667, 0x66666667, 0x66666667, x6, 1516, x8)

inst_399:
// rs1_val==1717986919 and rs2_val==-46339, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:-0xb503
TEST_RR_OP(or, x12, x10, x11, 0xffff6eff, 0x66666667, -0xb503, x6, 1520, x8)

inst_400:
// rs1_val==1717986919 and rs2_val==46341, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0xb505
TEST_RR_OP(or, x12, x10, x11, 0x6666f767, 0x66666667, 0xb505, x6, 1524, x8)

inst_401:
// rs1_val==-46339 and rs2_val==3, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x3
TEST_RR_OP(or, x12, x10, x11, 0xffff4aff, -0xb503, 0x3, x6, 1528, x8)

inst_402:
// rs1_val==-46339 and rs2_val==1431655765, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x55555555
TEST_RR_OP(or, x12, x10, x11, 0xffff5ffd, -0xb503, 0x55555555, x6, 1532, x8)

inst_403:
// rs1_val==-46339 and rs2_val==-1431655766, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:-0x55555556
TEST_RR_OP(or, x12, x10, x11, 0xffffeaff, -0xb503, -0x55555556, x6, 1536, x8)

inst_404:
// rs1_val==-46339 and rs2_val==5, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x5
TEST_RR_OP(or, x12, x10, x11, 0xffff4afd, -0xb503, 0x5, x6, 1540, x8)

inst_405:
// rs1_val==-46339 and rs2_val==858993459, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x33333333
TEST_RR_OP(or, x12, x10, x11, 0xffff7bff, -0xb503, 0x33333333, x6, 1544, x8)

inst_406:
// rs1_val==-46339 and rs2_val==1717986918, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x66666666
TEST_RR_OP(or, x12, x10, x11, 0xffff6eff, -0xb503, 0x66666666, x6, 1548, x8)

inst_407:
// rs1_val==-46339 and rs2_val==-46340, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:-0xb504
TEST_RR_OP(or, x12, x10, x11, 0xffff4afd, -0xb503, -0xb504, x6, 1552, x8)

inst_408:
// rs1_val==-46339 and rs2_val==46340, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0xb504
TEST_RR_OP(or, x12, x10, x11, 0xfffffffd, -0xb503, 0xb504, x6, 1556, x8)

inst_409:
// rs1_val==-46339 and rs2_val==2, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x2
TEST_RR_OP(or, x12, x10, x11, 0xffff4aff, -0xb503, 0x2, x6, 1560, x8)

inst_410:
// rs1_val==-46339 and rs2_val==1431655764, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x55555554
TEST_RR_OP(or, x12, x10, x11, 0xffff5ffd, -0xb503, 0x55555554, x6, 1564, x8)

inst_411:
// rs1_val==-46339 and rs2_val==0, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x0
TEST_RR_OP(or, x12, x10, x11, 0xffff4afd, -0xb503, 0x0, x6, 1568, x8)

inst_412:
// rs1_val==-46339 and rs2_val==4, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x4
TEST_RR_OP(or, x12, x10, x11, 0xffff4afd, -0xb503, 0x4, x6, 1572, x8)

inst_413:
// rs1_val==-46339 and rs2_val==858993458, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x33333332
TEST_RR_OP(or, x12, x10, x11, 0xffff7bff, -0xb503, 0x33333332, x6, 1576, x8)

inst_414:
// rs1_val==-46339 and rs2_val==1717986917, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x66666665
TEST_RR_OP(or, x12, x10, x11, 0xffff6efd, -0xb503, 0x66666665, x6, 1580, x8)

inst_415:
// rs1_val==-46339 and rs2_val==46339, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0xb503
TEST_RR_OP(or, x12, x10, x11, 0xffffffff, -0xb503, 0xb503, x6, 1584, x8)

inst_416:
// rs1_val==-46339 and rs2_val==1431655766, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x55555556
TEST_RR_OP(or, x12, x10, x11, 0xffff5fff, -0xb503, 0x55555556, x6, 1588, x8)

inst_417:
// rs1_val==-46339 and rs2_val==-1431655765, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:-0x55555555
TEST_RR_OP(or, x12, x10, x11, 0xffffeaff, -0xb503, -0x55555555, x6, 1592, x8)

inst_418:
// rs1_val==-46339 and rs2_val==6, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x6
TEST_RR_OP(or, x12, x10, x11, 0xffff4aff, -0xb503, 0x6, x6, 1596, x8)

inst_419:
// rs1_val==-46339 and rs2_val==858993460, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x33333334
TEST_RR_OP(or, x12, x10, x11, 0xffff7bfd, -0xb503, 0x33333334, x6, 1600, x8)

inst_420:
// rs1_val==-46339 and rs2_val==1717986919, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x66666667
TEST_RR_OP(or, x12, x10, x11, 0xffff6eff, -0xb503, 0x66666667, x6, 1604, x8)

inst_421:
// rs1_val==-46339 and rs2_val==-46339, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:-0xb503
TEST_RR_OP(or, x12, x10, x11, 0xffff4afd, -0xb503, -0xb503, x6, 1608, x8)

inst_422:
// rs1_val==-46339 and rs2_val==46341, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0xb505
TEST_RR_OP(or, x12, x10, x11, 0xfffffffd, -0xb503, 0xb505, x6, 1612, x8)

inst_423:
// rs1_val==46341 and rs2_val==3, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x3
TEST_RR_OP(or, x12, x10, x11, 0xb507, 0xb505, 0x3, x6, 1616, x8)

inst_424:
// rs1_val==46341 and rs2_val==1431655765, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x55555555
TEST_RR_OP(or, x12, x10, x11, 0x5555f555, 0xb505, 0x55555555, x6, 1620, x8)

inst_425:
// rs1_val==46341 and rs2_val==-1431655766, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:-0x55555556
TEST_RR_OP(or, x12, x10, x11, 0xaaaabfaf, 0xb505, -0x55555556, x6, 1624, x8)

inst_426:
// rs1_val==46341 and rs2_val==5, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x5
TEST_RR_OP(or, x12, x10, x11, 0xb505, 0xb505, 0x5, x6, 1628, x8)

inst_427:
// rs1_val==46341 and rs2_val==858993459, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x33333333
TEST_RR_OP(or, x12, x10, x11, 0x3333b737, 0xb505, 0x33333333, x6, 1632, x8)

inst_428:
// rs1_val==46341 and rs2_val==1717986918, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x66666666
TEST_RR_OP(or, x12, x10, x11, 0x6666f767, 0xb505, 0x66666666, x6, 1636, x8)

inst_429:
// rs1_val==46341 and rs2_val==-46340, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:-0xb504
TEST_RR_OP(or, x12, x10, x11, 0xfffffffd, 0xb505, -0xb504, x6, 1640, x8)

inst_430:
// rs1_val==46341 and rs2_val==46340, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0xb504
TEST_RR_OP(or, x12, x10, x11, 0xb505, 0xb505, 0xb504, x6, 1644, x8)

inst_431:
// rs1_val==46341 and rs2_val==2, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x2
TEST_RR_OP(or, x12, x10, x11, 0xb507, 0xb505, 0x2, x6, 1648, x8)

inst_432:
// rs1_val==46341 and rs2_val==1431655764, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x55555554
TEST_RR_OP(or, x12, x10, x11, 0x5555f555, 0xb505, 0x55555554, x6, 1652, x8)

inst_433:
// rs1_val==46341 and rs2_val==0, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x0
TEST_RR_OP(or, x12, x10, x11, 0xb505, 0xb505, 0x0, x6, 1656, x8)

inst_434:
// rs1_val==46341 and rs2_val==4, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x4
TEST_RR_OP(or, x12, x10, x11, 0xb505, 0xb505, 0x4, x6, 1660, x8)

inst_435:
// rs1_val==46341 and rs2_val==858993458, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x33333332
TEST_RR_OP(or, x12, x10, x11, 0x3333b737, 0xb505, 0x33333332, x6, 1664, x8)

inst_436:
// rs1_val==46341 and rs2_val==1717986917, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x66666665
TEST_RR_OP(or, x12, x10, x11, 0x6666f765, 0xb505, 0x66666665, x6, 1668, x8)

inst_437:
// rs1_val==46341 and rs2_val==46339, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0xb503
TEST_RR_OP(or, x12, x10, x11, 0xb507, 0xb505, 0xb503, x6, 1672, x8)

inst_438:
// rs1_val==46341 and rs2_val==1431655766, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x55555556
TEST_RR_OP(or, x12, x10, x11, 0x5555f557, 0xb505, 0x55555556, x6, 1676, x8)

inst_439:
// rs1_val==46341 and rs2_val==-1431655765, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:-0x55555555
TEST_RR_OP(or, x12, x10, x11, 0xaaaabfaf, 0xb505, -0x55555555, x6, 1680, x8)

inst_440:
// rs1_val==46341 and rs2_val==6, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x6
TEST_RR_OP(or, x12, x10, x11, 0xb507, 0xb505, 0x6, x6, 1684, x8)

inst_441:
// rs1_val==46341 and rs2_val==858993460, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x33333334
TEST_RR_OP(or, x12, x10, x11, 0x3333b735, 0xb505, 0x33333334, x6, 1688, x8)

inst_442:
// rs1_val==46341 and rs2_val==1717986919, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x66666667
TEST_RR_OP(or, x12, x10, x11, 0x6666f767, 0xb505, 0x66666667, x6, 1692, x8)

inst_443:
// rs1_val==46341 and rs2_val==-46339, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:-0xb503
TEST_RR_OP(or, x12, x10, x11, 0xfffffffd, 0xb505, -0xb503, x6, 1696, x8)

inst_444:
// rs1_val==46341 and rs2_val==46341, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0xb505
TEST_RR_OP(or, x12, x10, x11, 0xb505, 0xb505, 0xb505, x6, 1700, x8)

inst_445:
// rs1_val==0 and rs2_val==1431655764, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x55555554
TEST_RR_OP(or, x12, x10, x11, 0x55555554, 0x0, 0x55555554, x6, 1704, x8)

inst_446:
// rs1_val==0 and rs2_val==0, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x0
TEST_RR_OP(or, x12, x10, x11, 0x0, 0x0, 0x0, x6, 1708, x8)

inst_447:
// rs1_val==0 and rs2_val==4, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x4
TEST_RR_OP(or, x12, x10, x11, 0x4, 0x0, 0x4, x6, 1712, x8)

inst_448:
// rs1_val==0 and rs2_val==858993458, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x33333332
TEST_RR_OP(or, x12, x10, x11, 0x33333332, 0x0, 0x33333332, x6, 1716, x8)

inst_449:
// rs1_val==0 and rs2_val==1717986917, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x66666665
TEST_RR_OP(or, x12, x10, x11, 0x66666665, 0x0, 0x66666665, x6, 1720, x8)

inst_450:
// rs1_val==0 and rs2_val==46339, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0xb503
TEST_RR_OP(or, x12, x10, x11, 0xb503, 0x0, 0xb503, x6, 1724, x8)

inst_451:
// rs1_val==0 and rs2_val==1431655766, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x55555556
TEST_RR_OP(or, x12, x10, x11, 0x55555556, 0x0, 0x55555556, x6, 1728, x8)

inst_452:
// rs1_val==0 and rs2_val==-1431655765, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:-0x55555555
TEST_RR_OP(or, x12, x10, x11, 0xaaaaaaab, 0x0, -0x55555555, x6, 1732, x8)

inst_453:
// rs1_val==0 and rs2_val==6, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x6
TEST_RR_OP(or, x12, x10, x11, 0x6, 0x0, 0x6, x6, 1736, x8)

inst_454:
// rs1_val==0 and rs2_val==858993460, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x33333334
TEST_RR_OP(or, x12, x10, x11, 0x33333334, 0x0, 0x33333334, x6, 1740, x8)

inst_455:
// rs1_val==0 and rs2_val==1717986919, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x66666667
TEST_RR_OP(or, x12, x10, x11, 0x66666667, 0x0, 0x66666667, x6, 1744, x8)

inst_456:
// rs1_val==0 and rs2_val==-46339, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:-0xb503
TEST_RR_OP(or, x12, x10, x11, 0xffff4afd, 0x0, -0xb503, x6, 1748, x8)

inst_457:
// rs1_val==0 and rs2_val==46341, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0xb505
TEST_RR_OP(or, x12, x10, x11, 0xb505, 0x0, 0xb505, x6, 1752, x8)

inst_458:
// rs1_val==4 and rs2_val==3, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x3
TEST_RR_OP(or, x12, x10, x11, 0x7, 0x4, 0x3, x6, 1756, x8)

inst_459:
// rs1_val==4 and rs2_val==1431655765, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x55555555
TEST_RR_OP(or, x12, x10, x11, 0x55555555, 0x4, 0x55555555, x6, 1760, x8)

inst_460:
// rs1_val==4 and rs2_val==-1431655766, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:-0x55555556
TEST_RR_OP(or, x12, x10, x11, 0xaaaaaaae, 0x4, -0x55555556, x6, 1764, x8)

inst_461:
// rs1_val==4 and rs2_val==5, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x5
TEST_RR_OP(or, x12, x10, x11, 0x5, 0x4, 0x5, x6, 1768, x8)

inst_462:
// rs1_val==4 and rs2_val==858993459, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x33333333
TEST_RR_OP(or, x12, x10, x11, 0x33333337, 0x4, 0x33333333, x6, 1772, x8)

inst_463:
// rs1_val==4 and rs2_val==1717986918, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x66666666
TEST_RR_OP(or, x12, x10, x11, 0x66666666, 0x4, 0x66666666, x6, 1776, x8)

inst_464:
// rs1_val==4 and rs2_val==-46340, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:-0xb504
TEST_RR_OP(or, x12, x10, x11, 0xffff4afc, 0x4, -0xb504, x6, 1780, x8)

inst_465:
// rs1_val==4 and rs2_val==46340, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0xb504
TEST_RR_OP(or, x12, x10, x11, 0xb504, 0x4, 0xb504, x6, 1784, x8)

inst_466:
// rs1_val==4 and rs2_val==2, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x2
TEST_RR_OP(or, x12, x10, x11, 0x6, 0x4, 0x2, x6, 1788, x8)

inst_467:
// rs1_val==4 and rs2_val==1431655764, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x55555554
TEST_RR_OP(or, x12, x10, x11, 0x55555554, 0x4, 0x55555554, x6, 1792, x8)

inst_468:
// rs1_val==4 and rs2_val==0, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x0
TEST_RR_OP(or, x12, x10, x11, 0x4, 0x4, 0x0, x6, 1796, x8)

inst_469:
// rs1_val==4 and rs2_val==4, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x4
TEST_RR_OP(or, x12, x10, x11, 0x4, 0x4, 0x4, x6, 1800, x8)

inst_470:
// rs1_val==4 and rs2_val==858993458, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x33333332
TEST_RR_OP(or, x12, x10, x11, 0x33333336, 0x4, 0x33333332, x6, 1804, x8)

inst_471:
// rs1_val==4 and rs2_val==1717986917, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x66666665
TEST_RR_OP(or, x12, x10, x11, 0x66666665, 0x4, 0x66666665, x6, 1808, x8)

inst_472:
// rs1_val==4 and rs2_val==46339, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0xb503
TEST_RR_OP(or, x12, x10, x11, 0xb507, 0x4, 0xb503, x6, 1812, x8)

inst_473:
// rs1_val==4 and rs2_val==1431655766, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x55555556
TEST_RR_OP(or, x12, x10, x11, 0x55555556, 0x4, 0x55555556, x6, 1816, x8)

inst_474:
// rs1_val==4 and rs2_val==-1431655765, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:-0x55555555
TEST_RR_OP(or, x12, x10, x11, 0xaaaaaaaf, 0x4, -0x55555555, x6, 1820, x8)

inst_475:
// rs1_val==4 and rs2_val==6, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x6
TEST_RR_OP(or, x12, x10, x11, 0x6, 0x4, 0x6, x6, 1824, x8)

inst_476:
// rs1_val==4 and rs2_val==858993460, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x33333334
TEST_RR_OP(or, x12, x10, x11, 0x33333334, 0x4, 0x33333334, x6, 1828, x8)

inst_477:
// rs1_val==4 and rs2_val==1717986919, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x66666667
TEST_RR_OP(or, x12, x10, x11, 0x66666667, 0x4, 0x66666667, x6, 1832, x8)

inst_478:
// rs1_val==4 and rs2_val==-46339, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:-0xb503
TEST_RR_OP(or, x12, x10, x11, 0xffff4afd, 0x4, -0xb503, x6, 1836, x8)

inst_479:
// rs1_val==4 and rs2_val==46341, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0xb505
TEST_RR_OP(or, x12, x10, x11, 0xb505, 0x4, 0xb505, x6, 1840, x8)

inst_480:
// rs1_val==858993458 and rs2_val==3, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x3
TEST_RR_OP(or, x12, x10, x11, 0x33333333, 0x33333332, 0x3, x6, 1844, x8)

inst_481:
// rs1_val==858993458 and rs2_val==1431655765, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x55555555
TEST_RR_OP(or, x12, x10, x11, 0x77777777, 0x33333332, 0x55555555, x6, 1848, x8)

inst_482:
// rs1_val==858993458 and rs2_val==-1431655766, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:-0x55555556
TEST_RR_OP(or, x12, x10, x11, 0xbbbbbbba, 0x33333332, -0x55555556, x6, 1852, x8)

inst_483:
// rs1_val==858993458 and rs2_val==5, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x5
TEST_RR_OP(or, x12, x10, x11, 0x33333337, 0x33333332, 0x5, x6, 1856, x8)

inst_484:
// rs1_val==858993458 and rs2_val==858993459, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x33333333
TEST_RR_OP(or, x12, x10, x11, 0x33333333, 0x33333332, 0x33333333, x6, 1860, x8)

inst_485:
// rs1_val==858993458 and rs2_val==1717986918, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x66666666
TEST_RR_OP(or, x12, x10, x11, 0x77777776, 0x33333332, 0x66666666, x6, 1864, x8)

inst_486:
// rs1_val==858993458 and rs2_val==-46340, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:-0xb504
TEST_RR_OP(or, x12, x10, x11, 0xffff7bfe, 0x33333332, -0xb504, x6, 1868, x8)

inst_487:
// rs1_val==858993458 and rs2_val==46340, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0xb504
TEST_RR_OP(or, x12, x10, x11, 0x3333b736, 0x33333332, 0xb504, x6, 1872, x8)

inst_488:
// rs1_val==858993458 and rs2_val==2, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x2
TEST_RR_OP(or, x12, x10, x11, 0x33333332, 0x33333332, 0x2, x6, 1876, x8)

inst_489:
// rs1_val==858993458 and rs2_val==1431655764, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x55555554
TEST_RR_OP(or, x12, x10, x11, 0x77777776, 0x33333332, 0x55555554, x6, 1880, x8)

inst_490:
// rs1_val==858993458 and rs2_val==0, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x0
TEST_RR_OP(or, x12, x10, x11, 0x33333332, 0x33333332, 0x0, x6, 1884, x8)

inst_491:
// rs1_val==858993458 and rs2_val==4, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x4
TEST_RR_OP(or, x12, x10, x11, 0x33333336, 0x33333332, 0x4, x6, 1888, x8)

inst_492:
// rs1_val==858993458 and rs2_val==858993458, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x33333332
TEST_RR_OP(or, x12, x10, x11, 0x33333332, 0x33333332, 0x33333332, x6, 1892, x8)

inst_493:
// rs1_val==858993458 and rs2_val==1717986917, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x66666665
TEST_RR_OP(or, x12, x10, x11, 0x77777777, 0x33333332, 0x66666665, x6, 1896, x8)

inst_494:
// rs1_val==858993458 and rs2_val==46339, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0xb503
TEST_RR_OP(or, x12, x10, x11, 0x3333b733, 0x33333332, 0xb503, x6, 1900, x8)

inst_495:
// rs1_val==858993458 and rs2_val==1431655766, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x55555556
TEST_RR_OP(or, x12, x10, x11, 0x77777776, 0x33333332, 0x55555556, x6, 1904, x8)

inst_496:
// rs1_val==858993458 and rs2_val==-1431655765, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:-0x55555555
TEST_RR_OP(or, x12, x10, x11, 0xbbbbbbbb, 0x33333332, -0x55555555, x6, 1908, x8)

inst_497:
// rs1_val==858993458 and rs2_val==6, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x6
TEST_RR_OP(or, x12, x10, x11, 0x33333336, 0x33333332, 0x6, x6, 1912, x8)

inst_498:
// rs1_val==858993458 and rs2_val==858993460, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x33333334
TEST_RR_OP(or, x12, x10, x11, 0x33333336, 0x33333332, 0x33333334, x6, 1916, x8)

inst_499:
// rs1_val==858993458 and rs2_val==1717986919, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x66666667
TEST_RR_OP(or, x12, x10, x11, 0x77777777, 0x33333332, 0x66666667, x6, 1920, x8)

inst_500:
// rs1_val==858993458 and rs2_val==-46339, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:-0xb503
TEST_RR_OP(or, x12, x10, x11, 0xffff7bff, 0x33333332, -0xb503, x6, 1924, x8)

inst_501:
// rs1_val==858993458 and rs2_val==46341, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0xb505
TEST_RR_OP(or, x12, x10, x11, 0x3333b737, 0x33333332, 0xb505, x6, 1928, x8)

inst_502:
// rs1_val==1717986917 and rs2_val==3, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x3
TEST_RR_OP(or, x12, x10, x11, 0x66666667, 0x66666665, 0x3, x6, 1932, x8)

inst_503:
// rs1_val==1717986917 and rs2_val==1431655765, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x55555555
TEST_RR_OP(or, x12, x10, x11, 0x77777775, 0x66666665, 0x55555555, x6, 1936, x8)

inst_504:
// rs1_val==1717986917 and rs2_val==-1431655766, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:-0x55555556
TEST_RR_OP(or, x12, x10, x11, 0xeeeeeeef, 0x66666665, -0x55555556, x6, 1940, x8)

inst_505:
// rs1_val==1717986917 and rs2_val==5, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x5
TEST_RR_OP(or, x12, x10, x11, 0x66666665, 0x66666665, 0x5, x6, 1944, x8)

inst_506:
// rs1_val==1717986917 and rs2_val==858993459, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x33333333
TEST_RR_OP(or, x12, x10, x11, 0x77777777, 0x66666665, 0x33333333, x6, 1948, x8)

inst_507:
// rs1_val==1717986917 and rs2_val==1717986918, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x66666666
TEST_RR_OP(or, x12, x10, x11, 0x66666667, 0x66666665, 0x66666666, x6, 1952, x8)

inst_508:
// rs1_val==1717986917 and rs2_val==-46340, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:-0xb504
TEST_RR_OP(or, x12, x10, x11, 0xffff6efd, 0x66666665, -0xb504, x6, 1956, x8)

inst_509:
// rs1_val==1717986917 and rs2_val==46340, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0xb504
TEST_RR_OP(or, x12, x10, x11, 0x6666f765, 0x66666665, 0xb504, x6, 1960, x8)

inst_510:
// rs1_val==1717986917 and rs2_val==2, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x2
TEST_RR_OP(or, x12, x10, x11, 0x66666667, 0x66666665, 0x2, x6, 1964, x8)

inst_511:
// rs1_val==1717986917 and rs2_val==1431655764, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x55555554
TEST_RR_OP(or, x12, x10, x11, 0x77777775, 0x66666665, 0x55555554, x6, 1968, x8)

inst_512:
// rs1_val==1717986917 and rs2_val==0, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x0
TEST_RR_OP(or, x12, x10, x11, 0x66666665, 0x66666665, 0x0, x6, 1972, x8)

inst_513:
// rs1_val==1717986917 and rs2_val==4, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x4
TEST_RR_OP(or, x12, x10, x11, 0x66666665, 0x66666665, 0x4, x6, 1976, x8)

inst_514:
// rs1_val==1717986917 and rs2_val==858993458, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x33333332
TEST_RR_OP(or, x12, x10, x11, 0x77777777, 0x66666665, 0x33333332, x6, 1980, x8)

inst_515:
// rs1_val==1717986917 and rs2_val==1717986917, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x66666665
TEST_RR_OP(or, x12, x10, x11, 0x66666665, 0x66666665, 0x66666665, x6, 1984, x8)

inst_516:
// rs1_val==1717986917 and rs2_val==46339, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0xb503
TEST_RR_OP(or, x12, x10, x11, 0x6666f767, 0x66666665, 0xb503, x6, 1988, x8)

inst_517:
// rs1_val==1717986917 and rs2_val==1431655766, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x55555556
TEST_RR_OP(or, x12, x10, x11, 0x77777777, 0x66666665, 0x55555556, x6, 1992, x8)

inst_518:
// rs1_val==1717986917 and rs2_val==-1431655765, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:-0x55555555
TEST_RR_OP(or, x12, x10, x11, 0xeeeeeeef, 0x66666665, -0x55555555, x6, 1996, x8)

inst_519:
// rs1_val==1717986917 and rs2_val==6, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x6
TEST_RR_OP(or, x12, x10, x11, 0x66666667, 0x66666665, 0x6, x6, 2000, x8)

inst_520:
// rs1_val==1717986917 and rs2_val==858993460, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x33333334
TEST_RR_OP(or, x12, x10, x11, 0x77777775, 0x66666665, 0x33333334, x6, 2004, x8)

inst_521:
// rs1_val==1717986917 and rs2_val==1717986919, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x66666667
TEST_RR_OP(or, x12, x10, x11, 0x66666667, 0x66666665, 0x66666667, x6, 2008, x8)

inst_522:
// rs1_val==1717986917 and rs2_val==-46339, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:-0xb503
TEST_RR_OP(or, x12, x10, x11, 0xffff6efd, 0x66666665, -0xb503, x6, 2012, x8)

inst_523:
// rs1_val==1717986917 and rs2_val==46341, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0xb505
TEST_RR_OP(or, x12, x10, x11, 0x6666f765, 0x66666665, 0xb505, x6, 2016, x8)

inst_524:
// rs1_val==46339 and rs2_val==3, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x3
TEST_RR_OP(or, x12, x10, x11, 0xb503, 0xb503, 0x3, x6, 2020, x8)

inst_525:
// rs1_val==46339 and rs2_val==1431655765, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x55555555
TEST_RR_OP(or, x12, x10, x11, 0x5555f557, 0xb503, 0x55555555, x6, 2024, x8)

inst_526:
// rs1_val==46339 and rs2_val==-1431655766, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:-0x55555556
TEST_RR_OP(or, x12, x10, x11, 0xaaaabfab, 0xb503, -0x55555556, x6, 2028, x8)

inst_527:
// rs1_val==46339 and rs2_val==5, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x5
TEST_RR_OP(or, x12, x10, x11, 0xb507, 0xb503, 0x5, x6, 2032, x8)

inst_528:
// rs1_val==46339 and rs2_val==858993459, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x33333333
TEST_RR_OP(or, x12, x10, x11, 0x3333b733, 0xb503, 0x33333333, x6, 2036, x8)

inst_529:
// rs1_val==46339 and rs2_val==1717986918, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x66666666
TEST_RR_OP(or, x12, x10, x11, 0x6666f767, 0xb503, 0x66666666, x6, 2040, x8)

inst_530:
// rs1_val==46339 and rs2_val==-46340, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:-0xb504
TEST_RR_OP(or, x12, x10, x11, 0xffffffff, 0xb503, -0xb504, x6, 2044, x8)
RVTEST_SIGBASE( x6,signature_x6_1)

inst_531:
// rs1_val==46339 and rs2_val==46340, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0xb504
TEST_RR_OP(or, x12, x10, x11, 0xb507, 0xb503, 0xb504, x6, 0, x8)

inst_532:
// rs1_val==46339 and rs2_val==2, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x2
TEST_RR_OP(or, x12, x10, x11, 0xb503, 0xb503, 0x2, x6, 4, x8)

inst_533:
// rs1_val==46339 and rs2_val==1431655764, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x55555554
TEST_RR_OP(or, x12, x10, x11, 0x5555f557, 0xb503, 0x55555554, x6, 8, x8)

inst_534:
// rs1_val==46339 and rs2_val==0, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x0
TEST_RR_OP(or, x12, x10, x11, 0xb503, 0xb503, 0x0, x6, 12, x8)

inst_535:
// rs1_val==46339 and rs2_val==4, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x4
TEST_RR_OP(or, x12, x10, x11, 0xb507, 0xb503, 0x4, x6, 16, x8)

inst_536:
// rs1_val==46339 and rs2_val==858993458, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x33333332
TEST_RR_OP(or, x12, x10, x11, 0x3333b733, 0xb503, 0x33333332, x6, 20, x8)

inst_537:
// rs1_val==46339 and rs2_val==1717986917, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x66666665
TEST_RR_OP(or, x12, x10, x11, 0x6666f767, 0xb503, 0x66666665, x6, 24, x8)

inst_538:
// rs1_val==46339 and rs2_val==46339, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0xb503
TEST_RR_OP(or, x12, x10, x11, 0xb503, 0xb503, 0xb503, x6, 28, x8)

inst_539:
// rs1_val==46339 and rs2_val==1431655766, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x55555556
TEST_RR_OP(or, x12, x10, x11, 0x5555f557, 0xb503, 0x55555556, x6, 32, x8)

inst_540:
// rs1_val==46339 and rs2_val==-1431655765, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:-0x55555555
TEST_RR_OP(or, x12, x10, x11, 0xaaaabfab, 0xb503, -0x55555555, x6, 36, x8)

inst_541:
// rs1_val==46339 and rs2_val==6, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x6
TEST_RR_OP(or, x12, x10, x11, 0xb507, 0xb503, 0x6, x6, 40, x8)

inst_542:
// rs1_val==46339 and rs2_val==858993460, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x33333334
TEST_RR_OP(or, x12, x10, x11, 0x3333b737, 0xb503, 0x33333334, x6, 44, x8)

inst_543:
// rs1_val==46339 and rs2_val==1717986919, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x66666667
TEST_RR_OP(or, x12, x10, x11, 0x6666f767, 0xb503, 0x66666667, x6, 48, x8)

inst_544:
// rs1_val==46339 and rs2_val==-46339, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:-0xb503
TEST_RR_OP(or, x12, x10, x11, 0xffffffff, 0xb503, -0xb503, x6, 52, x8)

inst_545:
// rs1_val==46339 and rs2_val==46341, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0xb505
TEST_RR_OP(or, x12, x10, x11, 0xb507, 0xb503, 0xb505, x6, 56, x8)

inst_546:
// rs1_val==1431655766 and rs2_val==3, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x3
TEST_RR_OP(or, x12, x10, x11, 0x55555557, 0x55555556, 0x3, x6, 60, x8)

inst_547:
// rs1_val==1431655766 and rs2_val==1431655765, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x55555555
TEST_RR_OP(or, x12, x10, x11, 0x55555557, 0x55555556, 0x55555555, x6, 64, x8)

inst_548:
// rs1_val==1431655766 and rs2_val==-1431655766, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:-0x55555556
TEST_RR_OP(or, x12, x10, x11, 0xfffffffe, 0x55555556, -0x55555556, x6, 68, x8)

inst_549:
// rs1_val==1431655766 and rs2_val==5, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x5
TEST_RR_OP(or, x12, x10, x11, 0x55555557, 0x55555556, 0x5, x6, 72, x8)

inst_550:
// rs1_val==1431655766 and rs2_val==858993459, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x33333333
TEST_RR_OP(or, x12, x10, x11, 0x77777777, 0x55555556, 0x33333333, x6, 76, x8)

inst_551:
// rs1_val==1431655766 and rs2_val==1717986918, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x66666666
TEST_RR_OP(or, x12, x10, x11, 0x77777776, 0x55555556, 0x66666666, x6, 80, x8)

inst_552:
// rs1_val==1431655766 and rs2_val==-46340, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:-0xb504
TEST_RR_OP(or, x12, x10, x11, 0xffff5ffe, 0x55555556, -0xb504, x6, 84, x8)

inst_553:
// rs1_val==1431655766 and rs2_val==46340, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0xb504
TEST_RR_OP(or, x12, x10, x11, 0x5555f556, 0x55555556, 0xb504, x6, 88, x8)

inst_554:
// rs1_val==1431655766 and rs2_val==2, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x2
TEST_RR_OP(or, x12, x10, x11, 0x55555556, 0x55555556, 0x2, x6, 92, x8)

inst_555:
// rs1_val==1431655766 and rs2_val==1431655764, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x55555554
TEST_RR_OP(or, x12, x10, x11, 0x55555556, 0x55555556, 0x55555554, x6, 96, x8)

inst_556:
// rs1_val==1431655766 and rs2_val==0, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x0
TEST_RR_OP(or, x12, x10, x11, 0x55555556, 0x55555556, 0x0, x6, 100, x8)

inst_557:
// rs1_val==1431655766 and rs2_val==4, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x4
TEST_RR_OP(or, x12, x10, x11, 0x55555556, 0x55555556, 0x4, x6, 104, x8)

inst_558:
// rs1_val==1431655766 and rs2_val==858993458, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x33333332
TEST_RR_OP(or, x12, x10, x11, 0x77777776, 0x55555556, 0x33333332, x6, 108, x8)

inst_559:
// rs1_val==1431655766 and rs2_val==1717986917, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x66666665
TEST_RR_OP(or, x12, x10, x11, 0x77777777, 0x55555556, 0x66666665, x6, 112, x8)

inst_560:
// rs1_val==1431655766 and rs2_val==46339, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0xb503
TEST_RR_OP(or, x12, x10, x11, 0x5555f557, 0x55555556, 0xb503, x6, 116, x8)

inst_561:
// rs1_val==1431655766 and rs2_val==1431655766, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x55555556
TEST_RR_OP(or, x12, x10, x11, 0x55555556, 0x55555556, 0x55555556, x6, 120, x8)

inst_562:
// rs1_val==1431655766 and rs2_val==-1431655765, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:-0x55555555
TEST_RR_OP(or, x12, x10, x11, 0xffffffff, 0x55555556, -0x55555555, x6, 124, x8)

inst_563:
// rs1_val==1431655766 and rs2_val==6, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x6
TEST_RR_OP(or, x12, x10, x11, 0x55555556, 0x55555556, 0x6, x6, 128, x8)

inst_564:
// rs1_val==1431655766 and rs2_val==858993460, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x33333334
TEST_RR_OP(or, x12, x10, x11, 0x77777776, 0x55555556, 0x33333334, x6, 132, x8)

inst_565:
// rs1_val==1431655766 and rs2_val==1717986919, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x66666667
TEST_RR_OP(or, x12, x10, x11, 0x77777777, 0x55555556, 0x66666667, x6, 136, x8)

inst_566:
// rs1_val==1431655766 and rs2_val==-46339, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:-0xb503
TEST_RR_OP(or, x12, x10, x11, 0xffff5fff, 0x55555556, -0xb503, x6, 140, x8)

inst_567:
// rs1_val==1431655766 and rs2_val==46341, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0xb505
TEST_RR_OP(or, x12, x10, x11, 0x5555f557, 0x55555556, 0xb505, x6, 144, x8)

inst_568:
// rs1_val==-1431655765 and rs2_val==3, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x3
TEST_RR_OP(or, x12, x10, x11, 0xaaaaaaab, -0x55555555, 0x3, x6, 148, x8)

inst_569:
// rs1_val==-1431655765 and rs2_val==1431655765, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x55555555
TEST_RR_OP(or, x12, x10, x11, 0xffffffff, -0x55555555, 0x55555555, x6, 152, x8)

inst_570:
// rs1_val==-1431655765 and rs2_val==-1431655766, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:-0x55555556
TEST_RR_OP(or, x12, x10, x11, 0xaaaaaaab, -0x55555555, -0x55555556, x6, 156, x8)

inst_571:
// rs1_val==-1431655765 and rs2_val==5, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x5
TEST_RR_OP(or, x12, x10, x11, 0xaaaaaaaf, -0x55555555, 0x5, x6, 160, x8)

inst_572:
// rs1_val==-1431655765 and rs2_val==858993459, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x33333333
TEST_RR_OP(or, x12, x10, x11, 0xbbbbbbbb, -0x55555555, 0x33333333, x6, 164, x8)

inst_573:
// rs1_val==-1431655765 and rs2_val==1717986918, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x66666666
TEST_RR_OP(or, x12, x10, x11, 0xeeeeeeef, -0x55555555, 0x66666666, x6, 168, x8)

inst_574:
// rs1_val==-1431655765 and rs2_val==-46340, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:-0xb504
TEST_RR_OP(or, x12, x10, x11, 0xffffeaff, -0x55555555, -0xb504, x6, 172, x8)

inst_575:
// rs1_val==-1431655765 and rs2_val==46340, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0xb504
TEST_RR_OP(or, x12, x10, x11, 0xaaaabfaf, -0x55555555, 0xb504, x6, 176, x8)

inst_576:
// rs1_val==-1431655765 and rs2_val==2, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x2
TEST_RR_OP(or, x12, x10, x11, 0xaaaaaaab, -0x55555555, 0x2, x6, 180, x8)

inst_577:
// rs1_val==-1431655765 and rs2_val==1431655764, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x55555554
TEST_RR_OP(or, x12, x10, x11, 0xffffffff, -0x55555555, 0x55555554, x6, 184, x8)

inst_578:
// rs1_val==-1431655765 and rs2_val==0, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x0
TEST_RR_OP(or, x12, x10, x11, 0xaaaaaaab, -0x55555555, 0x0, x6, 188, x8)

inst_579:
// rs1_val==-1431655765 and rs2_val==4, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x4
TEST_RR_OP(or, x12, x10, x11, 0xaaaaaaaf, -0x55555555, 0x4, x6, 192, x8)

inst_580:
// rs1_val==-1431655765 and rs2_val==858993458, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x33333332
TEST_RR_OP(or, x12, x10, x11, 0xbbbbbbbb, -0x55555555, 0x33333332, x6, 196, x8)

inst_581:
// rs1_val==-1431655765 and rs2_val==1717986917, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x66666665
TEST_RR_OP(or, x12, x10, x11, 0xeeeeeeef, -0x55555555, 0x66666665, x6, 200, x8)

inst_582:
// rs1_val==-1431655765 and rs2_val==46339, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0xb503
TEST_RR_OP(or, x12, x10, x11, 0xaaaabfab, -0x55555555, 0xb503, x6, 204, x8)

inst_583:
// rs1_val==-1431655765 and rs2_val==1431655766, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x55555556
TEST_RR_OP(or, x12, x10, x11, 0xffffffff, -0x55555555, 0x55555556, x6, 208, x8)

inst_584:
// rs1_val > 0 and rs2_val < 0, rs2_val == -2049, rs1_val == 2
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:-0x801
TEST_RR_OP(or, x12, x10, x11, 0xfffff7ff, 0x2, -0x801, x6, 212, x8)

inst_585:
// rs1_val < 0 and rs2_val < 0, rs1_val == -268435457, rs2_val == -1025
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:-0x10000001;  op2val:-0x401
TEST_RR_OP(or, x12, x10, x11, 0xffffffff, -0x10000001, -0x401, x6, 216, x8)

inst_586:
// rs2_val == 2097152, 
// opcode: or ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x200000
TEST_RR_OP(or, x12, x10, x11, 0x33333332, 0x33333332, 0x200000, x6, 220, x8)
#endif


RVTEST_CODE_END
RVMODEL_HALT

RVTEST_DATA_BEGIN
.align 4

rvtest_data:
.word 0xbabecafe
.word 0xbabecafe
.word 0xbabecafe
.word 0xbabecafe
RVTEST_DATA_END


RVMODEL_DATA_BEGIN
rvtest_sig_begin:
sig_begin_canary:
CANARY;


signature_x3_0:
    .fill 0*(XLEN/32),4,0xdeadbeef


signature_x3_1:
    .fill 19*(XLEN/32),4,0xdeadbeef


signature_x6_0:
    .fill 512*(XLEN/32),4,0xdeadbeef


signature_x6_1:
    .fill 56*(XLEN/32),4,0xdeadbeef

#ifdef rvtest_mtrap_routine

tsig_begin_canary:
CANARY;
mtrap_sigptr:
    .fill 64*(XLEN/32),4,0xdeadbeef
tsig_end_canary:
CANARY;

#endif

#ifdef rvtest_gpr_save

gpr_save:
    .fill 32*(XLEN/32),4,0xdeadbeef

#endif

sig_end_canary:
CANARY;
rvtest_sig_end:
RVMODEL_DATA_END
