
// -----------
// This file was generated by riscv_ctg (https://gitlab.com/incoresemi/riscv-compliance/riscv_ctg)
// version   : 0.4.1
// timestamp : Tue Dec 15 15:36:11 2020 GMT
// usage     : riscv_ctg \
//                  -- cgf ('/scratch/git-repo/incoresemi/riscv-compliance/riscv_ctg/sample_cgfs/dataset.cgf', '/scratch/git-repo/incoresemi/riscv-compliance/riscv_ctg/sample_cgfs/rv32i.cgf') \
//                  -- xlen 32 \
// -----------
//
// -----------
// Copyright (c) 2020. RISC-V International. All rights reserved.
// SPDX-License-Identifier: BSD-3-Clause
// -----------
//
// This assembly file tests the sltu instruction of the RISC-V I extension for the sltu covergroup.
// 
#include "model_test.h"
#include "arch_test.h"
RVTEST_ISA("RV32I")

.section .text.init
.org 0x80
.globl rvtest_entry_point
rvtest_entry_point:
RVMODEL_BOOT
RVTEST_CODE_BEGIN

#ifdef TEST_CASE_1

RVTEST_CASE(0,"//check ISA:=regex(.*32.*);check ISA:=regex(.*I.*);def TEST_CASE_1=True;",sltu)

RVTEST_SIGBASE( x9,signature_x9_1)

inst_0:
// rs2 == rd != rs1, rs1==x0, rs2==x31, rd==x31, rs1_val > 0 and rs2_val > 0, rs2_val == 4294967294, rs1_val != rs2_val and rs1_val > 0 and rs2_val > 0, rs1_val == 2048
// opcode: sltu ; op1:x0; op2:x31; dest:x31; op1val:0x0;  op2val:0xfffffffe
TEST_RR_OP(sltu, x31, x0, x31, 0x1, 0x0, 0xfffffffe, x9, 0, x7)

inst_1:
// rs1 == rs2 != rd, rs1==x19, rs2==x19, rd==x5, rs1_val == rs2_val and rs1_val > 0 and rs2_val > 0, rs2_val == 1048576, rs1_val == 1048576
// opcode: sltu ; op1:x19; op2:x19; dest:x5; op1val:0x100000;  op2val:0x100000
TEST_RR_OP(sltu, x5, x19, x19, 0x0, 0x100000, 0x100000, x9, 4, x7)

inst_2:
// rs1 == rs2 == rd, rs1==x25, rs2==x25, rd==x25, rs2_val == 0, rs1_val == 1073741824
// opcode: sltu ; op1:x25; op2:x25; dest:x25; op1val:0x40000000;  op2val:0x40000000
TEST_RR_OP(sltu, x25, x25, x25, 0x0, 0x40000000, 0x40000000, x9, 8, x7)

inst_3:
// rs1 == rd != rs2, rs1==x14, rs2==x24, rd==x14, rs2_val == (2**(xlen)-1), rs1_val == 4294967294
// opcode: sltu ; op1:x14; op2:x24; dest:x14; op1val:0xfffffffe;  op2val:0xffffffff
TEST_RR_OP(sltu, x14, x14, x24, 0x1, 0xfffffffe, 0xffffffff, x9, 12, x7)

inst_4:
// rs1 != rs2  and rs1 != rd and rs2 != rd, rs1==x17, rs2==x13, rd==x12, rs2_val == 1, rs1_val == 1, rs1_val==1 and rs2_val==1
// opcode: sltu ; op1:x17; op2:x13; dest:x12; op1val:0x1;  op2val:0x1
TEST_RR_OP(sltu, x12, x17, x13, 0x0, 0x1, 0x1, x9, 16, x7)

inst_5:
// rs1==x26, rs2==x18, rd==x24, rs1_val == 0, 
// opcode: sltu ; op1:x26; op2:x18; dest:x24; op1val:0x0;  op2val:0xb
TEST_RR_OP(sltu, x24, x26, x18, 0x1, 0x0, 0xb, x9, 20, x7)

inst_6:
// rs1==x5, rs2==x14, rd==x19, rs1_val == (2**(xlen)-1), 
// opcode: sltu ; op1:x5; op2:x14; dest:x19; op1val:0xffffffff;  op2val:0x0
TEST_RR_OP(sltu, x19, x5, x14, 0x0, 0xffffffff, 0x0, x9, 24, x7)

inst_7:
// rs1==x3, rs2==x22, rd==x0, rs2_val == 2, rs1_val==4 and rs2_val==2, rs1_val == 4
// opcode: sltu ; op1:x3; op2:x22; dest:x0; op1val:0x4;  op2val:0x2
TEST_RR_OP(sltu, x0, x3, x22, 0, 0x4, 0x2, x9, 28, x7)

inst_8:
// rs1==x23, rs2==x29, rd==x20, rs2_val == 4, rs1_val == 4160749567
// opcode: sltu ; op1:x23; op2:x29; dest:x20; op1val:0xf7ffffff;  op2val:0x4
TEST_RR_OP(sltu, x20, x23, x29, 0x0, 0xf7ffffff, 0x4, x9, 32, x7)

inst_9:
// rs1==x4, rs2==x6, rd==x10, rs2_val == 8, 
// opcode: sltu ; op1:x4; op2:x6; dest:x10; op1val:0x11;  op2val:0x8
TEST_RR_OP(sltu, x10, x4, x6, 0x0, 0x11, 0x8, x9, 36, x7)

inst_10:
// rs1==x12, rs2==x17, rd==x1, rs2_val == 16, rs1_val == 2147483647
// opcode: sltu ; op1:x12; op2:x17; dest:x1; op1val:0x7fffffff;  op2val:0x10
TEST_RR_OP(sltu, x1, x12, x17, 0x0, 0x7fffffff, 0x10, x9, 40, x7)

inst_11:
// rs1==x30, rs2==x8, rd==x6, rs2_val == 32, rs1_val == 33554432
// opcode: sltu ; op1:x30; op2:x8; dest:x6; op1val:0x2000000;  op2val:0x20
TEST_RR_OP(sltu, x6, x30, x8, 0x0, 0x2000000, 0x20, x9, 44, x7)

inst_12:
// rs1==x21, rs2==x16, rd==x3, rs2_val == 64, rs1_val == 4294965247
// opcode: sltu ; op1:x21; op2:x16; dest:x3; op1val:0xfffff7ff;  op2val:0x40
TEST_RR_OP(sltu, x3, x21, x16, 0x0, 0xfffff7ff, 0x40, x9, 48, x7)

inst_13:
// rs1==x29, rs2==x26, rd==x17, rs2_val == 128, rs1_val == 1024
// opcode: sltu ; op1:x29; op2:x26; dest:x17; op1val:0x400;  op2val:0x80
TEST_RR_OP(sltu, x17, x29, x26, 0x0, 0x400, 0x80, x9, 52, x7)

inst_14:
// rs1==x18, rs2==x10, rd==x28, rs2_val == 256, 
// opcode: sltu ; op1:x18; op2:x10; dest:x28; op1val:0xd;  op2val:0x100
TEST_RR_OP(sltu, x28, x18, x10, 0x1, 0xd, 0x100, x9, 56, x7)

inst_15:
// rs1==x2, rs2==x28, rd==x11, rs2_val == 512, 
// opcode: sltu ; op1:x2; op2:x28; dest:x11; op1val:0x4;  op2val:0x200
TEST_RR_OP(sltu, x11, x2, x28, 0x1, 0x4, 0x200, x9, 60, x7)

inst_16:
// rs1==x8, rs2==x30, rd==x29, rs2_val == 1024, rs1_val == 4294967231
// opcode: sltu ; op1:x8; op2:x30; dest:x29; op1val:0xffffffbf;  op2val:0x400
TEST_RR_OP(sltu, x29, x8, x30, 0x0, 0xffffffbf, 0x400, x9, 64, x17)

inst_17:
// rs1==x22, rs2==x11, rd==x7, rs2_val == 2048, rs1_val == 128
// opcode: sltu ; op1:x22; op2:x11; dest:x7; op1val:0x80;  op2val:0x800
TEST_RR_OP(sltu, x7, x22, x11, 0x1, 0x80, 0x800, x9, 68, x17)
RVTEST_SIGBASE( x14,signature_x14_0)

inst_18:
// rs1==x15, rs2==x4, rd==x9, rs2_val == 4096, rs1_val == 2097152
// opcode: sltu ; op1:x15; op2:x4; dest:x9; op1val:0x200000;  op2val:0x1000
TEST_RR_OP(sltu, x9, x15, x4, 0x0, 0x200000, 0x1000, x14, 0, x17)

inst_19:
// rs1==x28, rs2==x12, rd==x13, rs2_val == 8192, 
// opcode: sltu ; op1:x28; op2:x12; dest:x13; op1val:0x80;  op2val:0x2000
TEST_RR_OP(sltu, x13, x28, x12, 0x1, 0x80, 0x2000, x14, 4, x17)

inst_20:
// rs1==x31, rs2==x20, rd==x26, rs2_val == 16384, rs1_val == 8388608
// opcode: sltu ; op1:x31; op2:x20; dest:x26; op1val:0x800000;  op2val:0x4000
TEST_RR_OP(sltu, x26, x31, x20, 0x0, 0x800000, 0x4000, x14, 8, x17)

inst_21:
// rs1==x27, rs2==x5, rd==x16, rs2_val == 32768, rs1_val == 32768
// opcode: sltu ; op1:x27; op2:x5; dest:x16; op1val:0x8000;  op2val:0x8000
TEST_RR_OP(sltu, x16, x27, x5, 0x0, 0x8000, 0x8000, x14, 12, x17)

inst_22:
// rs1==x16, rs2==x0, rd==x2, rs2_val == 65536, rs1_val == 3758096383
// opcode: sltu ; op1:x16; op2:x0; dest:x2; op1val:0xdfffffff;  op2val:0x0
TEST_RR_OP(sltu, x2, x16, x0, 0x0, 0xdfffffff, 0x0, x14, 16, x17)

inst_23:
// rs1==x11, rs2==x9, rd==x23, rs2_val == 131072, 
// opcode: sltu ; op1:x11; op2:x9; dest:x23; op1val:0x3;  op2val:0x20000
TEST_RR_OP(sltu, x23, x11, x9, 0x1, 0x3, 0x20000, x14, 20, x17)

inst_24:
// rs1==x20, rs2==x21, rd==x4, rs2_val == 262144, rs1_val == 2147483648
// opcode: sltu ; op1:x20; op2:x21; dest:x4; op1val:0x80000000;  op2val:0x40000
TEST_RR_OP(sltu, x4, x20, x21, 0x0, 0x80000000, 0x40000, x14, 24, x17)

inst_25:
// rs1==x13, rs2==x7, rd==x27, rs2_val == 524288, rs1_val == 536870912
// opcode: sltu ; op1:x13; op2:x7; dest:x27; op1val:0x20000000;  op2val:0x80000
TEST_RR_OP(sltu, x27, x13, x7, 0x0, 0x20000000, 0x80000, x14, 28, x17)

inst_26:
// rs1==x7, rs2==x1, rd==x18, rs2_val == 2097152, rs1_val == 8
// opcode: sltu ; op1:x7; op2:x1; dest:x18; op1val:0x8;  op2val:0x200000
TEST_RR_OP(sltu, x18, x7, x1, 0x1, 0x8, 0x200000, x14, 32, x17)

inst_27:
// rs1==x1, rs2==x27, rd==x22, rs2_val == 4194304, rs1_val == 4293918719
// opcode: sltu ; op1:x1; op2:x27; dest:x22; op1val:0xffefffff;  op2val:0x400000
TEST_RR_OP(sltu, x22, x1, x27, 0x0, 0xffefffff, 0x400000, x14, 36, x17)

inst_28:
// rs1==x9, rs2==x23, rd==x21, rs2_val == 8388608, rs1_val == 2863311530
// opcode: sltu ; op1:x9; op2:x23; dest:x21; op1val:0xaaaaaaaa;  op2val:0x800000
TEST_RR_OP(sltu, x21, x9, x23, 0x0, 0xaaaaaaaa, 0x800000, x14, 40, x17)

inst_29:
// rs1==x6, rs2==x2, rd==x30, rs2_val == 16777216, 
// opcode: sltu ; op1:x6; op2:x2; dest:x30; op1val:0x66666667;  op2val:0x1000000
TEST_RR_OP(sltu, x30, x6, x2, 0x0, 0x66666667, 0x1000000, x14, 44, x17)

inst_30:
// rs1==x10, rs2==x3, rd==x15, rs2_val == 33554432, rs1_val == 4227858431
// opcode: sltu ; op1:x10; op2:x3; dest:x15; op1val:0xfbffffff;  op2val:0x2000000
TEST_RR_OP(sltu, x15, x10, x3, 0x0, 0xfbffffff, 0x2000000, x14, 48, x17)

inst_31:
// rs1==x24, rs2==x15, rd==x8, rs2_val == 67108864, rs1_val == 256
// opcode: sltu ; op1:x24; op2:x15; dest:x8; op1val:0x100;  op2val:0x4000000
TEST_RR_OP(sltu, x8, x24, x15, 0x1, 0x100, 0x4000000, x14, 52, x17)

inst_32:
// rs2_val == 134217728, rs1_val == 4294959103
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xffffdfff;  op2val:0x8000000
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xffffdfff, 0x8000000, x14, 56, x1)

inst_33:
// rs2_val == 268435456, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x40000000;  op2val:0x10000000
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x40000000, 0x10000000, x14, 60, x1)

inst_34:
// rs2_val == 536870912, rs1_val == 4278190079
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xfeffffff;  op2val:0x20000000
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xfeffffff, 0x20000000, x14, 64, x1)

inst_35:
// rs2_val == 1073741824, rs1_val == 268435456
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x10000000;  op2val:0x40000000
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x10000000, 0x40000000, x14, 68, x1)

inst_36:
// rs2_val == 2147483648, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x40000000;  op2val:0x80000000
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x40000000, 0x80000000, x14, 72, x1)

inst_37:
// rs2_val == 4294967293, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0xfffffffd
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x33333333, 0xfffffffd, x14, 76, x1)

inst_38:
// rs2_val == 4294967291, rs1_val == 262144
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x40000;  op2val:0xfffffffb
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x40000, 0xfffffffb, x14, 80, x1)

inst_39:
// rs2_val == 4294967287, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0xfffffff7
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x66666666, 0xfffffff7, x14, 84, x1)

inst_40:
// rs2_val == 4294967279, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0xffffffef
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x3, 0xffffffef, x14, 88, x1)

inst_41:
// rs2_val == 4294967263, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb;  op2val:0xffffffdf
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xb, 0xffffffdf, x14, 92, x1)

inst_42:
// rs2_val == 4294967231, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xa;  op2val:0xffffffbf
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xa, 0xffffffbf, x14, 96, x1)

inst_43:
// rs2_val == 4294967167, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x80;  op2val:0xffffff7f
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x80, 0xffffff7f, x14, 100, x1)

inst_44:
// rs2_val == 4294967039, rs1_val == 4294967287
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xfffffff7;  op2val:0xfffffeff
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xfffffff7, 0xfffffeff, x14, 104, x1)

inst_45:
// rs2_val == 4294966783, rs1_val == 16777216
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x1000000;  op2val:0xfffffdff
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x1000000, 0xfffffdff, x14, 108, x1)

inst_46:
// rs2_val == 4294966271, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xfffffff7;  op2val:0xfffffbff
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xfffffff7, 0xfffffbff, x14, 112, x1)

inst_47:
// rs2_val == 4294965247, rs1_val == 8192
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x2000;  op2val:0xfffff7ff
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x2000, 0xfffff7ff, x14, 116, x1)

inst_48:
// rs2_val == 4294963199, rs1_val == 4294443007
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xfff7ffff;  op2val:0xffffefff
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xfff7ffff, 0xffffefff, x14, 120, x1)

inst_49:
// rs2_val == 4294959103, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0xffffdfff
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x5, 0xffffdfff, x14, 124, x1)

inst_50:
// rs2_val == 4294950911, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xfffe;  op2val:0xffffbfff
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xfffe, 0xffffbfff, x14, 128, x1)

inst_51:
// rs2_val == 4294934527, rs1_val == 4294836223
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xfffdffff;  op2val:0xffff7fff
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xfffdffff, 0xffff7fff, x14, 132, x1)

inst_52:
// rs2_val == 4294901759, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xa;  op2val:0xfffeffff
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xa, 0xfffeffff, x14, 136, x1)

inst_53:
// rs2_val == 4294836223, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xfff7ffff;  op2val:0xfffdffff
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xfff7ffff, 0xfffdffff, x14, 140, x1)

inst_54:
// rs2_val == 4294705151, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x8000;  op2val:0xfffbffff
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x8000, 0xfffbffff, x14, 144, x1)

inst_55:
// rs2_val == 4294443007, rs1_val == 64
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x40;  op2val:0xfff7ffff
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x40, 0xfff7ffff, x14, 148, x1)

inst_56:
// rs2_val == 4293918719, rs1_val == 16
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x10;  op2val:0xffefffff
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x10, 0xffefffff, x14, 152, x1)

inst_57:
// rs2_val == 4292870143, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0xffdfffff
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x0, 0xffdfffff, x14, 156, x1)

inst_58:
// rs2_val == 4290772991, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0xffbfffff
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x4, 0xffbfffff, x14, 160, x1)

inst_59:
// rs2_val == 4286578687, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xfffe;  op2val:0xff7fffff
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xfffe, 0xff7fffff, x14, 164, x1)

inst_60:
// rs2_val == 4278190079, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0xfeffffff
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x5, 0xfeffffff, x14, 168, x1)

inst_61:
// rs2_val == 4261412863, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x800000;  op2val:0xfdffffff
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x800000, 0xfdffffff, x14, 172, x1)

inst_62:
// rs2_val == 4227858431, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0xfbffffff
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xb503, 0xfbffffff, x14, 176, x1)

inst_63:
// rs2_val == 4160749567, rs1_val == 1431655765
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0xf7ffffff
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x55555555, 0xf7ffffff, x14, 180, x1)

inst_64:
// rs2_val == 4026531839, rs1_val == 4292870143
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xffdfffff;  op2val:0xefffffff
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xffdfffff, 0xefffffff, x14, 184, x1)

inst_65:
// rs2_val == 3758096383, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0xdfffffff
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x3, 0xdfffffff, x14, 188, x1)

inst_66:
// rs2_val == 3221225471, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x800;  op2val:0xbfffffff
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x800, 0xbfffffff, x14, 192, x1)

inst_67:
// rs2_val == 2147483647, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x800000;  op2val:0x7fffffff
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x800000, 0x7fffffff, x14, 196, x1)

inst_68:
// rs2_val == 1431655765, rs1_val == 4290772991
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xffbfffff;  op2val:0x55555555
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xffbfffff, 0x55555555, x14, 200, x1)

inst_69:
// rs2_val == 2863311530, rs1_val==1431655764 and rs2_val==2863311530
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0xaaaaaaaa
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x55555554, 0xaaaaaaaa, x14, 204, x1)

inst_70:
// rs1_val == 2, rs1_val==2 and rs2_val==1717986917
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x66666665
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x2, 0x66666665, x14, 208, x1)

inst_71:
// rs1_val == 32, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x20;  op2val:0xb504
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x20, 0xb504, x14, 212, x1)

inst_72:
// rs1_val == 512, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x200;  op2val:0x3
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x200, 0x3, x14, 216, x1)

inst_73:
// rs1_val == 4096, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x1000;  op2val:0x3
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x1000, 0x3, x14, 220, x1)

inst_74:
// rs1_val == 16384, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x4000;  op2val:0x0
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x4000, 0x0, x14, 224, x1)

inst_75:
// rs1_val == 65536, rs1_val==65536 and rs2_val==5
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x10000;  op2val:0x5
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x10000, 0x5, x14, 228, x1)

inst_76:
// rs1_val == 131072, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x20000;  op2val:0x20000
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x20000, 0x20000, x14, 232, x1)

inst_77:
// rs1_val == 524288, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x80000;  op2val:0x55555554
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x80000, 0x55555554, x14, 236, x1)

inst_78:
// rs1_val == 4194304, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x400000;  op2val:0x200000
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x400000, 0x200000, x14, 240, x1)

inst_79:
// rs1_val == 67108864, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x4000000;  op2val:0x55555555
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x4000000, 0x55555555, x14, 244, x1)

inst_80:
// rs1_val == 134217728, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x8000000;  op2val:0xfffdffff
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x8000000, 0xfffdffff, x14, 248, x1)

inst_81:
// rs1_val == 4294967293, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xfffffffd;  op2val:0x11
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xfffffffd, 0x11, x14, 252, x1)

inst_82:
// rs1_val == 4294967291, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xfffffffb;  op2val:0xffffff7f
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xfffffffb, 0xffffff7f, x14, 256, x1)

inst_83:
// rs1_val == 4294967279, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xffffffef;  op2val:0x33333334
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xffffffef, 0x33333334, x14, 260, x1)

inst_84:
// rs1_val == 4294967263, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xffffffdf;  op2val:0xfffbffff
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xffffffdf, 0xfffbffff, x14, 264, x1)

inst_85:
// rs1_val == 4294967167, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xffffff7f;  op2val:0x1
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xffffff7f, 0x1, x14, 268, x1)

inst_86:
// rs1_val == 4294967039, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xfffffeff;  op2val:0x40000000
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xfffffeff, 0x40000000, x14, 272, x1)

inst_87:
// rs1_val == 4294966783, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xfffffdff;  op2val:0xa
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xfffffdff, 0xa, x14, 276, x1)

inst_88:
// rs1_val == 4294966271, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xfffffbff;  op2val:0xf7ffffff
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xfffffbff, 0xf7ffffff, x14, 280, x1)

inst_89:
// rs1_val == 4294963199, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xffffefff;  op2val:0x100000
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xffffefff, 0x100000, x14, 284, x1)

inst_90:
// rs1_val == 4294950911, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xffffbfff;  op2val:0x8000
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xffffbfff, 0x8000, x14, 288, x1)

inst_91:
// rs1_val == 4294934527, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xffff7fff;  op2val:0xfffeffff
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xffff7fff, 0xfffeffff, x14, 292, x1)

inst_92:
// rs1_val == 4294901759, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xfffeffff;  op2val:0xfffff7ff
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xfffeffff, 0xfffff7ff, x14, 296, x1)

inst_93:
// rs1_val == 4294705151, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xfffbffff;  op2val:0xfff7ffff
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xfffbffff, 0xfff7ffff, x14, 300, x1)

inst_94:
// rs1_val == 4286578687, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xff7fffff;  op2val:0x2
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xff7fffff, 0x2, x14, 304, x1)

inst_95:
// rs1_val == 4261412863, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xfdffffff;  op2val:0xbfffffff
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xfdffffff, 0xbfffffff, x14, 308, x1)

inst_96:
// rs1_val == 4026531839, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xefffffff;  op2val:0x800
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xefffffff, 0x800, x14, 312, x1)

inst_97:
// rs1_val == 3221225471, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xbfffffff;  op2val:0x4
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xbfffffff, 0x4, x14, 316, x1)

inst_98:
// rs1_val==3 and rs2_val==3, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x3
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x3, 0x3, x14, 320, x1)

inst_99:
// rs1_val==3 and rs2_val==1431655765, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x55555555
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x3, 0x55555555, x14, 324, x1)

inst_100:
// rs1_val==3 and rs2_val==2863311530, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0xaaaaaaaa
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x3, 0xaaaaaaaa, x14, 328, x1)

inst_101:
// rs1_val==3 and rs2_val==5, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x5
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x3, 0x5, x14, 332, x1)

inst_102:
// rs1_val==3 and rs2_val==858993459, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x33333333
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x3, 0x33333333, x14, 336, x1)

inst_103:
// rs1_val==3 and rs2_val==1717986918, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x66666666
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x3, 0x66666666, x14, 340, x1)

inst_104:
// rs1_val==3 and rs2_val==46340, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0xb504
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x3, 0xb504, x14, 344, x1)

inst_105:
// rs1_val==3 and rs2_val==0, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x0
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x3, 0x0, x14, 348, x1)

inst_106:
// rs1_val==3 and rs2_val==65535, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0xffff
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x3, 0xffff, x14, 352, x1)

inst_107:
// rs1_val==3 and rs2_val==2, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x2
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x3, 0x2, x14, 356, x1)

inst_108:
// rs1_val==3 and rs2_val==1431655764, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x55555554
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x3, 0x55555554, x14, 360, x1)

inst_109:
// rs1_val==3 and rs2_val==2863311529, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0xaaaaaaa9
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x3, 0xaaaaaaa9, x14, 364, x1)

inst_110:
// rs1_val==3 and rs2_val==4, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x4
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x3, 0x4, x14, 368, x1)

inst_111:
// rs1_val==3 and rs2_val==858993458, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x33333332
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x3, 0x33333332, x14, 372, x1)

inst_112:
// rs1_val==3 and rs2_val==1717986917, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x66666665
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x3, 0x66666665, x14, 376, x1)

inst_113:
// rs1_val==3 and rs2_val==46339, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0xb503
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x3, 0xb503, x14, 380, x1)

inst_114:
// rs1_val==3 and rs2_val==65534, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0xfffe
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x3, 0xfffe, x14, 384, x1)

inst_115:
// rs1_val==3 and rs2_val==1431655766, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x55555556
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x3, 0x55555556, x14, 388, x1)

inst_116:
// rs1_val==3 and rs2_val==2863311531, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0xaaaaaaab
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x3, 0xaaaaaaab, x14, 392, x1)

inst_117:
// rs1_val==3 and rs2_val==6, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x6
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x3, 0x6, x14, 396, x1)

inst_118:
// rs1_val==3 and rs2_val==858993460, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x33333334
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x3, 0x33333334, x14, 400, x1)

inst_119:
// rs1_val==3 and rs2_val==1717986919, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x66666667
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x3, 0x66666667, x14, 404, x1)

inst_120:
// rs1_val==3 and rs2_val==46341, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0xb505
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x3, 0xb505, x14, 408, x1)

inst_121:
// rs1_val==3 and rs2_val==1, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x1
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x3, 0x1, x14, 412, x1)

inst_122:
// rs1_val==3 and rs2_val==65536, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x10000
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x3, 0x10000, x14, 416, x1)

inst_123:
// rs1_val==1431655765 and rs2_val==3, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x3
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x55555555, 0x3, x14, 420, x1)

inst_124:
// rs1_val==1431655765 and rs2_val==1431655765, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x55555555
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x55555555, 0x55555555, x14, 424, x1)

inst_125:
// rs1_val==1431655765 and rs2_val==2863311530, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0xaaaaaaaa
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x55555555, 0xaaaaaaaa, x14, 428, x1)

inst_126:
// rs1_val==1431655765 and rs2_val==5, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x5
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x55555555, 0x5, x14, 432, x1)

inst_127:
// rs1_val==1431655765 and rs2_val==858993459, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x33333333
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x55555555, 0x33333333, x14, 436, x1)

inst_128:
// rs1_val==1431655765 and rs2_val==1717986918, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x66666666
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x55555555, 0x66666666, x14, 440, x1)

inst_129:
// rs1_val==1431655765 and rs2_val==46340, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0xb504
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x55555555, 0xb504, x14, 444, x1)

inst_130:
// rs1_val==1431655765 and rs2_val==0, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x0
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x55555555, 0x0, x14, 448, x1)

inst_131:
// rs1_val==1431655765 and rs2_val==65535, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0xffff
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x55555555, 0xffff, x14, 452, x1)

inst_132:
// rs1_val==1431655765 and rs2_val==2, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x2
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x55555555, 0x2, x14, 456, x1)

inst_133:
// rs1_val==1431655765 and rs2_val==1431655764, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x55555554
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x55555555, 0x55555554, x14, 460, x1)

inst_134:
// rs1_val==1431655765 and rs2_val==2863311529, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0xaaaaaaa9
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x55555555, 0xaaaaaaa9, x14, 464, x1)

inst_135:
// rs1_val==1431655765 and rs2_val==4, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x4
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x55555555, 0x4, x14, 468, x1)

inst_136:
// rs1_val==1431655765 and rs2_val==858993458, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x33333332
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x55555555, 0x33333332, x14, 472, x1)

inst_137:
// rs1_val==1431655765 and rs2_val==1717986917, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x66666665
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x55555555, 0x66666665, x14, 476, x1)

inst_138:
// rs1_val==1431655765 and rs2_val==46339, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0xb503
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x55555555, 0xb503, x14, 480, x1)

inst_139:
// rs1_val==1431655765 and rs2_val==65534, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0xfffe
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x55555555, 0xfffe, x14, 484, x1)

inst_140:
// rs1_val==1431655765 and rs2_val==1431655766, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x55555556
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x55555555, 0x55555556, x14, 488, x1)

inst_141:
// rs1_val==1431655765 and rs2_val==2863311531, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0xaaaaaaab
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x55555555, 0xaaaaaaab, x14, 492, x1)

inst_142:
// rs1_val==1431655765 and rs2_val==6, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x6
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x55555555, 0x6, x14, 496, x1)

inst_143:
// rs1_val==1431655765 and rs2_val==858993460, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x33333334
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x55555555, 0x33333334, x14, 500, x1)

inst_144:
// rs1_val==1431655765 and rs2_val==1717986919, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x66666667
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x55555555, 0x66666667, x14, 504, x1)

inst_145:
// rs1_val==1431655765 and rs2_val==46341, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0xb505
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x55555555, 0xb505, x14, 508, x1)

inst_146:
// rs1_val==1431655765 and rs2_val==1, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x1
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x55555555, 0x1, x14, 512, x1)

inst_147:
// rs1_val==1431655765 and rs2_val==65536, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x10000
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x55555555, 0x10000, x14, 516, x1)

inst_148:
// rs1_val==2863311530 and rs2_val==3, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaaa;  op2val:0x3
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaaa, 0x3, x14, 520, x1)

inst_149:
// rs1_val==2863311530 and rs2_val==1431655765, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaaa;  op2val:0x55555555
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaaa, 0x55555555, x14, 524, x1)

inst_150:
// rs1_val==2863311530 and rs2_val==2863311530, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaaa;  op2val:0xaaaaaaaa
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaaa, 0xaaaaaaaa, x14, 528, x1)

inst_151:
// rs1_val==2863311530 and rs2_val==5, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaaa;  op2val:0x5
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaaa, 0x5, x14, 532, x1)

inst_152:
// rs1_val==2863311530 and rs2_val==858993459, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaaa;  op2val:0x33333333
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaaa, 0x33333333, x14, 536, x1)

inst_153:
// rs1_val==2863311530 and rs2_val==1717986918, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaaa;  op2val:0x66666666
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaaa, 0x66666666, x14, 540, x1)

inst_154:
// rs1_val==2863311530 and rs2_val==46340, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaaa;  op2val:0xb504
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaaa, 0xb504, x14, 544, x1)

inst_155:
// rs1_val==2863311530 and rs2_val==0, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaaa;  op2val:0x0
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaaa, 0x0, x14, 548, x1)

inst_156:
// rs1_val==2863311530 and rs2_val==65535, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaaa;  op2val:0xffff
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaaa, 0xffff, x14, 552, x1)

inst_157:
// rs1_val==2863311530 and rs2_val==2, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaaa;  op2val:0x2
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaaa, 0x2, x14, 556, x1)

inst_158:
// rs1_val==2863311530 and rs2_val==1431655764, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaaa;  op2val:0x55555554
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaaa, 0x55555554, x14, 560, x1)

inst_159:
// rs1_val==2863311530 and rs2_val==2863311529, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaaa;  op2val:0xaaaaaaa9
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaaa, 0xaaaaaaa9, x14, 564, x1)

inst_160:
// rs1_val==2863311530 and rs2_val==4, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaaa;  op2val:0x4
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaaa, 0x4, x14, 568, x1)

inst_161:
// rs1_val==2863311530 and rs2_val==858993458, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaaa;  op2val:0x33333332
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaaa, 0x33333332, x14, 572, x1)

inst_162:
// rs1_val==2863311530 and rs2_val==1717986917, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaaa;  op2val:0x66666665
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaaa, 0x66666665, x14, 576, x1)

inst_163:
// rs1_val==2863311530 and rs2_val==46339, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaaa;  op2val:0xb503
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaaa, 0xb503, x14, 580, x1)

inst_164:
// rs1_val==2863311530 and rs2_val==65534, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaaa;  op2val:0xfffe
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaaa, 0xfffe, x14, 584, x1)

inst_165:
// rs1_val==2863311530 and rs2_val==1431655766, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaaa;  op2val:0x55555556
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaaa, 0x55555556, x14, 588, x1)

inst_166:
// rs1_val==2863311530 and rs2_val==2863311531, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaaa;  op2val:0xaaaaaaab
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xaaaaaaaa, 0xaaaaaaab, x14, 592, x1)

inst_167:
// rs1_val==2863311530 and rs2_val==6, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaaa;  op2val:0x6
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaaa, 0x6, x14, 596, x1)

inst_168:
// rs1_val==2863311530 and rs2_val==858993460, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaaa;  op2val:0x33333334
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaaa, 0x33333334, x14, 600, x1)

inst_169:
// rs1_val==2863311530 and rs2_val==1717986919, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaaa;  op2val:0x66666667
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaaa, 0x66666667, x14, 604, x1)

inst_170:
// rs1_val==2863311530 and rs2_val==46341, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaaa;  op2val:0xb505
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaaa, 0xb505, x14, 608, x1)

inst_171:
// rs1_val==2863311530 and rs2_val==1, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaaa;  op2val:0x1
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaaa, 0x1, x14, 612, x1)

inst_172:
// rs1_val==2863311530 and rs2_val==65536, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaaa;  op2val:0x10000
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaaa, 0x10000, x14, 616, x1)

inst_173:
// rs1_val==5 and rs2_val==3, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x3
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x5, 0x3, x14, 620, x1)

inst_174:
// rs1_val==5 and rs2_val==1431655765, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x55555555
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x5, 0x55555555, x14, 624, x1)

inst_175:
// rs1_val==5 and rs2_val==2863311530, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0xaaaaaaaa
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x5, 0xaaaaaaaa, x14, 628, x1)

inst_176:
// rs1_val==5 and rs2_val==5, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x5
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x5, 0x5, x14, 632, x1)

inst_177:
// rs1_val==5 and rs2_val==858993459, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x33333333
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x5, 0x33333333, x14, 636, x1)

inst_178:
// rs1_val==5 and rs2_val==1717986918, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x66666666
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x5, 0x66666666, x14, 640, x1)

inst_179:
// rs1_val==5 and rs2_val==46340, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0xb504
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x5, 0xb504, x14, 644, x1)

inst_180:
// rs1_val==5 and rs2_val==0, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x0
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x5, 0x0, x14, 648, x1)

inst_181:
// rs1_val==5 and rs2_val==65535, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0xffff
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x5, 0xffff, x14, 652, x1)

inst_182:
// rs1_val==5 and rs2_val==2, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x2
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x5, 0x2, x14, 656, x1)

inst_183:
// rs1_val==5 and rs2_val==1431655764, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x55555554
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x5, 0x55555554, x14, 660, x1)

inst_184:
// rs1_val==5 and rs2_val==2863311529, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0xaaaaaaa9
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x5, 0xaaaaaaa9, x14, 664, x1)

inst_185:
// rs1_val==5 and rs2_val==4, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x4
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x5, 0x4, x14, 668, x1)

inst_186:
// rs1_val==5 and rs2_val==858993458, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x33333332
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x5, 0x33333332, x14, 672, x1)

inst_187:
// rs1_val==5 and rs2_val==1717986917, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x66666665
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x5, 0x66666665, x14, 676, x1)

inst_188:
// rs1_val==5 and rs2_val==46339, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0xb503
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x5, 0xb503, x14, 680, x1)

inst_189:
// rs1_val==5 and rs2_val==65534, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0xfffe
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x5, 0xfffe, x14, 684, x1)

inst_190:
// rs1_val==5 and rs2_val==1431655766, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x55555556
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x5, 0x55555556, x14, 688, x1)

inst_191:
// rs1_val==5 and rs2_val==2863311531, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0xaaaaaaab
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x5, 0xaaaaaaab, x14, 692, x1)

inst_192:
// rs1_val==5 and rs2_val==6, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x6
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x5, 0x6, x14, 696, x1)

inst_193:
// rs1_val==5 and rs2_val==858993460, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x33333334
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x5, 0x33333334, x14, 700, x1)

inst_194:
// rs1_val==5 and rs2_val==1717986919, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x66666667
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x5, 0x66666667, x14, 704, x1)

inst_195:
// rs1_val==5 and rs2_val==46341, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0xb505
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x5, 0xb505, x14, 708, x1)

inst_196:
// rs1_val==5 and rs2_val==1, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x1
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x5, 0x1, x14, 712, x1)

inst_197:
// rs1_val==5 and rs2_val==65536, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x10000
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x5, 0x10000, x14, 716, x1)

inst_198:
// rs1_val==858993459 and rs2_val==3, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x3
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x33333333, 0x3, x14, 720, x1)

inst_199:
// rs1_val==858993459 and rs2_val==1431655765, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x55555555
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x33333333, 0x55555555, x14, 724, x1)

inst_200:
// rs1_val==858993459 and rs2_val==2863311530, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0xaaaaaaaa
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x33333333, 0xaaaaaaaa, x14, 728, x1)

inst_201:
// rs1_val==858993459 and rs2_val==5, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x5
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x33333333, 0x5, x14, 732, x1)

inst_202:
// rs1_val==858993459 and rs2_val==858993459, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x33333333
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x33333333, 0x33333333, x14, 736, x1)

inst_203:
// rs1_val==858993459 and rs2_val==1717986918, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x66666666
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x33333333, 0x66666666, x14, 740, x1)

inst_204:
// rs1_val==858993459 and rs2_val==46340, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0xb504
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x33333333, 0xb504, x14, 744, x1)

inst_205:
// rs1_val==858993459 and rs2_val==0, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x0
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x33333333, 0x0, x14, 748, x1)

inst_206:
// rs1_val==858993459 and rs2_val==65535, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0xffff
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x33333333, 0xffff, x14, 752, x1)

inst_207:
// rs1_val==858993459 and rs2_val==2, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x2
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x33333333, 0x2, x14, 756, x1)

inst_208:
// rs1_val==858993459 and rs2_val==1431655764, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x55555554
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x33333333, 0x55555554, x14, 760, x1)

inst_209:
// rs1_val==858993459 and rs2_val==2863311529, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0xaaaaaaa9
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x33333333, 0xaaaaaaa9, x14, 764, x1)

inst_210:
// rs1_val==858993459 and rs2_val==4, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x4
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x33333333, 0x4, x14, 768, x1)

inst_211:
// rs1_val==858993459 and rs2_val==858993458, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x33333332
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x33333333, 0x33333332, x14, 772, x1)

inst_212:
// rs1_val==858993459 and rs2_val==1717986917, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x66666665
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x33333333, 0x66666665, x14, 776, x1)

inst_213:
// rs1_val==858993459 and rs2_val==46339, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0xb503
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x33333333, 0xb503, x14, 780, x1)

inst_214:
// rs1_val==858993459 and rs2_val==65534, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0xfffe
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x33333333, 0xfffe, x14, 784, x1)

inst_215:
// rs1_val==858993459 and rs2_val==1431655766, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x55555556
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x33333333, 0x55555556, x14, 788, x1)

inst_216:
// rs1_val==858993459 and rs2_val==2863311531, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0xaaaaaaab
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x33333333, 0xaaaaaaab, x14, 792, x1)

inst_217:
// rs1_val==858993459 and rs2_val==6, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x6
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x33333333, 0x6, x14, 796, x1)

inst_218:
// rs1_val==858993459 and rs2_val==858993460, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x33333334
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x33333333, 0x33333334, x14, 800, x1)

inst_219:
// rs1_val==858993459 and rs2_val==1717986919, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x66666667
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x33333333, 0x66666667, x14, 804, x1)

inst_220:
// rs1_val==858993459 and rs2_val==46341, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0xb505
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x33333333, 0xb505, x14, 808, x1)

inst_221:
// rs1_val==858993459 and rs2_val==1, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x1
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x33333333, 0x1, x14, 812, x1)

inst_222:
// rs1_val==858993459 and rs2_val==65536, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x10000
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x33333333, 0x10000, x14, 816, x1)

inst_223:
// rs1_val==1717986918 and rs2_val==3, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x3
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x66666666, 0x3, x14, 820, x1)

inst_224:
// rs1_val==1717986918 and rs2_val==1431655765, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x55555555
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x66666666, 0x55555555, x14, 824, x1)

inst_225:
// rs1_val==1717986918 and rs2_val==2863311530, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0xaaaaaaaa
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x66666666, 0xaaaaaaaa, x14, 828, x1)

inst_226:
// rs1_val==1717986918 and rs2_val==5, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x5
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x66666666, 0x5, x14, 832, x1)

inst_227:
// rs1_val==1717986918 and rs2_val==858993459, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x33333333
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x66666666, 0x33333333, x14, 836, x1)

inst_228:
// rs1_val==1717986918 and rs2_val==1717986918, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x66666666
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x66666666, 0x66666666, x14, 840, x1)

inst_229:
// rs1_val==1717986918 and rs2_val==46340, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0xb504
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x66666666, 0xb504, x14, 844, x1)

inst_230:
// rs1_val==1717986918 and rs2_val==0, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x0
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x66666666, 0x0, x14, 848, x1)

inst_231:
// rs1_val==1717986918 and rs2_val==65535, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0xffff
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x66666666, 0xffff, x14, 852, x1)

inst_232:
// rs1_val==1717986918 and rs2_val==2, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x2
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x66666666, 0x2, x14, 856, x1)

inst_233:
// rs1_val==1717986918 and rs2_val==1431655764, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x55555554
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x66666666, 0x55555554, x14, 860, x1)

inst_234:
// rs1_val==1717986918 and rs2_val==2863311529, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0xaaaaaaa9
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x66666666, 0xaaaaaaa9, x14, 864, x1)

inst_235:
// rs1_val==1717986918 and rs2_val==4, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x4
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x66666666, 0x4, x14, 868, x1)

inst_236:
// rs1_val==1717986918 and rs2_val==858993458, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x33333332
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x66666666, 0x33333332, x14, 872, x1)

inst_237:
// rs1_val==1717986918 and rs2_val==1717986917, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x66666665
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x66666666, 0x66666665, x14, 876, x1)

inst_238:
// rs1_val==1717986918 and rs2_val==46339, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0xb503
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x66666666, 0xb503, x14, 880, x1)

inst_239:
// rs1_val==1717986918 and rs2_val==65534, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0xfffe
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x66666666, 0xfffe, x14, 884, x1)

inst_240:
// rs1_val==1717986918 and rs2_val==1431655766, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x55555556
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x66666666, 0x55555556, x14, 888, x1)

inst_241:
// rs1_val==1717986918 and rs2_val==2863311531, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0xaaaaaaab
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x66666666, 0xaaaaaaab, x14, 892, x1)

inst_242:
// rs1_val==1717986918 and rs2_val==6, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x6
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x66666666, 0x6, x14, 896, x1)

inst_243:
// rs1_val==1717986918 and rs2_val==858993460, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x33333334
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x66666666, 0x33333334, x14, 900, x1)

inst_244:
// rs1_val==1717986918 and rs2_val==1717986919, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x66666667
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x66666666, 0x66666667, x14, 904, x1)

inst_245:
// rs1_val==1717986918 and rs2_val==46341, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0xb505
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x66666666, 0xb505, x14, 908, x1)

inst_246:
// rs1_val==1717986918 and rs2_val==1, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x1
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x66666666, 0x1, x14, 912, x1)

inst_247:
// rs1_val==1717986918 and rs2_val==65536, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x10000
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x66666666, 0x10000, x14, 916, x1)

inst_248:
// rs1_val==46340 and rs2_val==3, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x3
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xb504, 0x3, x14, 920, x1)

inst_249:
// rs1_val==46340 and rs2_val==1431655765, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x55555555
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xb504, 0x55555555, x14, 924, x1)

inst_250:
// rs1_val==46340 and rs2_val==2863311530, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0xaaaaaaaa
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xb504, 0xaaaaaaaa, x14, 928, x1)

inst_251:
// rs1_val==46340 and rs2_val==5, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x5
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xb504, 0x5, x14, 932, x1)

inst_252:
// rs1_val==46340 and rs2_val==858993459, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x33333333
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xb504, 0x33333333, x14, 936, x1)

inst_253:
// rs1_val==46340 and rs2_val==1717986918, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x66666666
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xb504, 0x66666666, x14, 940, x1)

inst_254:
// rs1_val==46340 and rs2_val==46340, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0xb504
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xb504, 0xb504, x14, 944, x1)

inst_255:
// rs1_val==46340 and rs2_val==0, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x0
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xb504, 0x0, x14, 948, x1)

inst_256:
// rs1_val==46340 and rs2_val==65535, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0xffff
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xb504, 0xffff, x14, 952, x1)

inst_257:
// rs1_val==46340 and rs2_val==2, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x2
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xb504, 0x2, x14, 956, x1)

inst_258:
// rs1_val==46340 and rs2_val==1431655764, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x55555554
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xb504, 0x55555554, x14, 960, x1)

inst_259:
// rs1_val==46340 and rs2_val==2863311529, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0xaaaaaaa9
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xb504, 0xaaaaaaa9, x14, 964, x1)

inst_260:
// rs1_val==46340 and rs2_val==4, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x4
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xb504, 0x4, x14, 968, x1)

inst_261:
// rs1_val==46340 and rs2_val==858993458, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x33333332
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xb504, 0x33333332, x14, 972, x1)

inst_262:
// rs1_val==46340 and rs2_val==1717986917, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x66666665
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xb504, 0x66666665, x14, 976, x1)

inst_263:
// rs1_val==46340 and rs2_val==46339, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0xb503
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xb504, 0xb503, x14, 980, x1)

inst_264:
// rs1_val==46340 and rs2_val==65534, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0xfffe
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xb504, 0xfffe, x14, 984, x1)

inst_265:
// rs1_val==46340 and rs2_val==1431655766, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x55555556
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xb504, 0x55555556, x14, 988, x1)

inst_266:
// rs1_val==46340 and rs2_val==2863311531, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0xaaaaaaab
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xb504, 0xaaaaaaab, x14, 992, x1)

inst_267:
// rs1_val==46340 and rs2_val==6, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x6
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xb504, 0x6, x14, 996, x1)

inst_268:
// rs1_val==46340 and rs2_val==858993460, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x33333334
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xb504, 0x33333334, x14, 1000, x1)

inst_269:
// rs1_val==46340 and rs2_val==1717986919, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x66666667
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xb504, 0x66666667, x14, 1004, x1)

inst_270:
// rs1_val==46340 and rs2_val==46341, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0xb505
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xb504, 0xb505, x14, 1008, x1)

inst_271:
// rs1_val==46340 and rs2_val==1, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x1
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xb504, 0x1, x14, 1012, x1)

inst_272:
// rs1_val==46340 and rs2_val==65536, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x10000
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xb504, 0x10000, x14, 1016, x1)

inst_273:
// rs1_val==0 and rs2_val==3, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x3
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x0, 0x3, x14, 1020, x1)

inst_274:
// rs1_val==0 and rs2_val==1431655765, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x55555555
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x0, 0x55555555, x14, 1024, x1)

inst_275:
// rs1_val==0 and rs2_val==2863311530, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0xaaaaaaaa
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x0, 0xaaaaaaaa, x14, 1028, x1)

inst_276:
// rs1_val==0 and rs2_val==5, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x5
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x0, 0x5, x14, 1032, x1)

inst_277:
// rs1_val==0 and rs2_val==858993459, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x33333333
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x0, 0x33333333, x14, 1036, x1)

inst_278:
// rs1_val==0 and rs2_val==1717986918, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x66666666
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x0, 0x66666666, x14, 1040, x1)

inst_279:
// rs1_val==0 and rs2_val==46340, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0xb504
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x0, 0xb504, x14, 1044, x1)

inst_280:
// rs1_val==0 and rs2_val==0, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x0
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x0, 0x0, x14, 1048, x1)

inst_281:
// rs1_val==0 and rs2_val==65535, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0xffff
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x0, 0xffff, x14, 1052, x1)

inst_282:
// rs1_val==0 and rs2_val==2, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x2
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x0, 0x2, x14, 1056, x1)

inst_283:
// rs1_val==0 and rs2_val==1431655764, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x55555554
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x0, 0x55555554, x14, 1060, x1)

inst_284:
// rs1_val==0 and rs2_val==2863311529, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0xaaaaaaa9
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x0, 0xaaaaaaa9, x14, 1064, x1)

inst_285:
// rs1_val==0 and rs2_val==4, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x4
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x0, 0x4, x14, 1068, x1)

inst_286:
// rs1_val==0 and rs2_val==858993458, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x33333332
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x0, 0x33333332, x14, 1072, x1)

inst_287:
// rs1_val==0 and rs2_val==1717986917, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x66666665
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x0, 0x66666665, x14, 1076, x1)

inst_288:
// rs1_val==0 and rs2_val==46339, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0xb503
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x0, 0xb503, x14, 1080, x1)

inst_289:
// rs1_val==0 and rs2_val==65534, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0xfffe
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x0, 0xfffe, x14, 1084, x1)

inst_290:
// rs1_val==0 and rs2_val==1431655766, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x55555556
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x0, 0x55555556, x14, 1088, x1)

inst_291:
// rs1_val==0 and rs2_val==2863311531, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0xaaaaaaab
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x0, 0xaaaaaaab, x14, 1092, x1)

inst_292:
// rs1_val==0 and rs2_val==6, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x6
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x0, 0x6, x14, 1096, x1)

inst_293:
// rs1_val==0 and rs2_val==858993460, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x33333334
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x0, 0x33333334, x14, 1100, x1)

inst_294:
// rs1_val==0 and rs2_val==1717986919, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x66666667
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x0, 0x66666667, x14, 1104, x1)

inst_295:
// rs1_val==0 and rs2_val==46341, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0xb505
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x0, 0xb505, x14, 1108, x1)

inst_296:
// rs1_val==0 and rs2_val==1, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x1
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x0, 0x1, x14, 1112, x1)

inst_297:
// rs1_val==0 and rs2_val==65536, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x10000
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x0, 0x10000, x14, 1116, x1)

inst_298:
// rs1_val==65535 and rs2_val==3, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xffff;  op2val:0x3
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xffff, 0x3, x14, 1120, x1)

inst_299:
// rs1_val==65535 and rs2_val==1431655765, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xffff;  op2val:0x55555555
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xffff, 0x55555555, x14, 1124, x1)

inst_300:
// rs1_val==65535 and rs2_val==2863311530, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xffff;  op2val:0xaaaaaaaa
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xffff, 0xaaaaaaaa, x14, 1128, x1)

inst_301:
// rs1_val==65535 and rs2_val==5, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xffff;  op2val:0x5
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xffff, 0x5, x14, 1132, x1)

inst_302:
// rs1_val==65535 and rs2_val==858993459, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xffff;  op2val:0x33333333
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xffff, 0x33333333, x14, 1136, x1)

inst_303:
// rs1_val==65535 and rs2_val==1717986918, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xffff;  op2val:0x66666666
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xffff, 0x66666666, x14, 1140, x1)

inst_304:
// rs1_val==65535 and rs2_val==46340, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xffff;  op2val:0xb504
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xffff, 0xb504, x14, 1144, x1)

inst_305:
// rs1_val==65535 and rs2_val==0, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xffff;  op2val:0x0
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xffff, 0x0, x14, 1148, x1)

inst_306:
// rs1_val==65535 and rs2_val==65535, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xffff;  op2val:0xffff
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xffff, 0xffff, x14, 1152, x1)

inst_307:
// rs1_val==65535 and rs2_val==2, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xffff;  op2val:0x2
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xffff, 0x2, x14, 1156, x1)

inst_308:
// rs1_val==65535 and rs2_val==1431655764, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xffff;  op2val:0x55555554
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xffff, 0x55555554, x14, 1160, x1)

inst_309:
// rs1_val==65535 and rs2_val==2863311529, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xffff;  op2val:0xaaaaaaa9
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xffff, 0xaaaaaaa9, x14, 1164, x1)

inst_310:
// rs1_val==65535 and rs2_val==4, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xffff;  op2val:0x4
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xffff, 0x4, x14, 1168, x1)

inst_311:
// rs1_val==65535 and rs2_val==858993458, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xffff;  op2val:0x33333332
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xffff, 0x33333332, x14, 1172, x1)

inst_312:
// rs1_val==65535 and rs2_val==1717986917, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xffff;  op2val:0x66666665
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xffff, 0x66666665, x14, 1176, x1)

inst_313:
// rs1_val==65535 and rs2_val==46339, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xffff;  op2val:0xb503
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xffff, 0xb503, x14, 1180, x1)

inst_314:
// rs1_val==65535 and rs2_val==65534, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xffff;  op2val:0xfffe
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xffff, 0xfffe, x14, 1184, x1)

inst_315:
// rs1_val==65535 and rs2_val==1431655766, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xffff;  op2val:0x55555556
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xffff, 0x55555556, x14, 1188, x1)

inst_316:
// rs1_val==65535 and rs2_val==2863311531, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xffff;  op2val:0xaaaaaaab
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xffff, 0xaaaaaaab, x14, 1192, x1)

inst_317:
// rs1_val==65535 and rs2_val==6, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xffff;  op2val:0x6
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xffff, 0x6, x14, 1196, x1)

inst_318:
// rs1_val==65535 and rs2_val==858993460, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xffff;  op2val:0x33333334
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xffff, 0x33333334, x14, 1200, x1)

inst_319:
// rs1_val==65535 and rs2_val==1717986919, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xffff;  op2val:0x66666667
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xffff, 0x66666667, x14, 1204, x1)

inst_320:
// rs1_val==65535 and rs2_val==46341, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xffff;  op2val:0xb505
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xffff, 0xb505, x14, 1208, x1)

inst_321:
// rs1_val==65535 and rs2_val==1, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xffff;  op2val:0x1
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xffff, 0x1, x14, 1212, x1)

inst_322:
// rs1_val==65535 and rs2_val==65536, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xffff;  op2val:0x10000
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xffff, 0x10000, x14, 1216, x1)

inst_323:
// rs1_val==2 and rs2_val==3, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x3
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x2, 0x3, x14, 1220, x1)

inst_324:
// rs1_val==2 and rs2_val==1431655765, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x55555555
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x2, 0x55555555, x14, 1224, x1)

inst_325:
// rs1_val==2 and rs2_val==2863311530, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0xaaaaaaaa
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x2, 0xaaaaaaaa, x14, 1228, x1)

inst_326:
// rs1_val==2 and rs2_val==5, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x5
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x2, 0x5, x14, 1232, x1)

inst_327:
// rs1_val==2 and rs2_val==858993459, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x33333333
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x2, 0x33333333, x14, 1236, x1)

inst_328:
// rs1_val==2 and rs2_val==1717986918, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x66666666
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x2, 0x66666666, x14, 1240, x1)

inst_329:
// rs1_val==2 and rs2_val==46340, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0xb504
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x2, 0xb504, x14, 1244, x1)

inst_330:
// rs1_val==2 and rs2_val==0, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x0
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x2, 0x0, x14, 1248, x1)

inst_331:
// rs1_val==2 and rs2_val==65535, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0xffff
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x2, 0xffff, x14, 1252, x1)

inst_332:
// rs1_val==2 and rs2_val==2, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x2
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x2, 0x2, x14, 1256, x1)

inst_333:
// rs1_val==2 and rs2_val==1431655764, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x55555554
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x2, 0x55555554, x14, 1260, x1)

inst_334:
// rs1_val==2 and rs2_val==2863311529, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0xaaaaaaa9
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x2, 0xaaaaaaa9, x14, 1264, x1)

inst_335:
// rs1_val==2 and rs2_val==4, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x4
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x2, 0x4, x14, 1268, x1)

inst_336:
// rs1_val==2 and rs2_val==858993458, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x33333332
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x2, 0x33333332, x14, 1272, x1)

inst_337:
// rs1_val==2 and rs2_val==46339, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0xb503
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x2, 0xb503, x14, 1276, x1)

inst_338:
// rs1_val==2 and rs2_val==65534, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0xfffe
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x2, 0xfffe, x14, 1280, x1)

inst_339:
// rs1_val==2 and rs2_val==1431655766, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x55555556
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x2, 0x55555556, x14, 1284, x1)

inst_340:
// rs1_val==2 and rs2_val==2863311531, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0xaaaaaaab
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x2, 0xaaaaaaab, x14, 1288, x1)

inst_341:
// rs1_val==2 and rs2_val==6, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x6
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x2, 0x6, x14, 1292, x1)

inst_342:
// rs1_val==2 and rs2_val==858993460, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x33333334
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x2, 0x33333334, x14, 1296, x1)

inst_343:
// rs1_val==2 and rs2_val==1717986919, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x66666667
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x2, 0x66666667, x14, 1300, x1)

inst_344:
// rs1_val==2 and rs2_val==46341, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0xb505
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x2, 0xb505, x14, 1304, x1)

inst_345:
// rs1_val==2 and rs2_val==1, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x1
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x2, 0x1, x14, 1308, x1)

inst_346:
// rs1_val==2 and rs2_val==65536, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x10000
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x2, 0x10000, x14, 1312, x1)

inst_347:
// rs1_val==1431655764 and rs2_val==3, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x3
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x55555554, 0x3, x14, 1316, x1)

inst_348:
// rs1_val==1431655764 and rs2_val==1431655765, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x55555555
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x55555554, 0x55555555, x14, 1320, x1)

inst_349:
// rs1_val==1431655764 and rs2_val==5, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x5
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x55555554, 0x5, x14, 1324, x1)

inst_350:
// rs1_val==1431655764 and rs2_val==858993459, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x33333333
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x55555554, 0x33333333, x14, 1328, x1)

inst_351:
// rs1_val==1431655764 and rs2_val==1717986918, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x66666666
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x55555554, 0x66666666, x14, 1332, x1)

inst_352:
// rs1_val==1431655764 and rs2_val==46340, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0xb504
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x55555554, 0xb504, x14, 1336, x1)

inst_353:
// rs1_val==1431655764 and rs2_val==0, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x0
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x55555554, 0x0, x14, 1340, x1)

inst_354:
// rs1_val==1431655764 and rs2_val==65535, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0xffff
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x55555554, 0xffff, x14, 1344, x1)

inst_355:
// rs1_val==1431655764 and rs2_val==2, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x2
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x55555554, 0x2, x14, 1348, x1)

inst_356:
// rs1_val==1431655764 and rs2_val==1431655764, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x55555554
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x55555554, 0x55555554, x14, 1352, x1)

inst_357:
// rs1_val==1431655764 and rs2_val==2863311529, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0xaaaaaaa9
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x55555554, 0xaaaaaaa9, x14, 1356, x1)

inst_358:
// rs1_val==1431655764 and rs2_val==4, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x4
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x55555554, 0x4, x14, 1360, x1)

inst_359:
// rs1_val==1431655764 and rs2_val==858993458, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x33333332
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x55555554, 0x33333332, x14, 1364, x1)

inst_360:
// rs1_val==1431655764 and rs2_val==1717986917, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x66666665
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x55555554, 0x66666665, x14, 1368, x1)

inst_361:
// rs1_val==1431655764 and rs2_val==46339, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0xb503
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x55555554, 0xb503, x14, 1372, x1)

inst_362:
// rs1_val==1431655764 and rs2_val==65534, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0xfffe
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x55555554, 0xfffe, x14, 1376, x1)

inst_363:
// rs1_val==1431655764 and rs2_val==1431655766, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x55555556
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x55555554, 0x55555556, x14, 1380, x1)

inst_364:
// rs1_val==1431655764 and rs2_val==2863311531, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0xaaaaaaab
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x55555554, 0xaaaaaaab, x14, 1384, x1)

inst_365:
// rs1_val==1431655764 and rs2_val==6, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x6
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x55555554, 0x6, x14, 1388, x1)

inst_366:
// rs1_val==1431655764 and rs2_val==858993460, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x33333334
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x55555554, 0x33333334, x14, 1392, x1)

inst_367:
// rs1_val==1431655764 and rs2_val==1717986919, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x66666667
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x55555554, 0x66666667, x14, 1396, x1)

inst_368:
// rs1_val==1431655764 and rs2_val==46341, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0xb505
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x55555554, 0xb505, x14, 1400, x1)

inst_369:
// rs1_val==1431655764 and rs2_val==1, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x1
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x55555554, 0x1, x14, 1404, x1)

inst_370:
// rs1_val==1431655764 and rs2_val==65536, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x10000
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x55555554, 0x10000, x14, 1408, x1)

inst_371:
// rs1_val==2863311529 and rs2_val==3, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaa9;  op2val:0x3
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaa9, 0x3, x14, 1412, x1)

inst_372:
// rs1_val==2863311529 and rs2_val==1431655765, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaa9;  op2val:0x55555555
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaa9, 0x55555555, x14, 1416, x1)

inst_373:
// rs1_val==2863311529 and rs2_val==2863311530, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaa9;  op2val:0xaaaaaaaa
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xaaaaaaa9, 0xaaaaaaaa, x14, 1420, x1)

inst_374:
// rs1_val==2863311529 and rs2_val==5, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaa9;  op2val:0x5
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaa9, 0x5, x14, 1424, x1)

inst_375:
// rs1_val==2863311529 and rs2_val==858993459, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaa9;  op2val:0x33333333
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaa9, 0x33333333, x14, 1428, x1)

inst_376:
// rs1_val==2863311529 and rs2_val==1717986918, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaa9;  op2val:0x66666666
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaa9, 0x66666666, x14, 1432, x1)

inst_377:
// rs1_val==2863311529 and rs2_val==46340, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaa9;  op2val:0xb504
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaa9, 0xb504, x14, 1436, x1)

inst_378:
// rs1_val==2863311529 and rs2_val==0, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaa9;  op2val:0x0
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaa9, 0x0, x14, 1440, x1)

inst_379:
// rs1_val==2863311529 and rs2_val==65535, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaa9;  op2val:0xffff
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaa9, 0xffff, x14, 1444, x1)

inst_380:
// rs1_val==2863311529 and rs2_val==2, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaa9;  op2val:0x2
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaa9, 0x2, x14, 1448, x1)

inst_381:
// rs1_val==2863311529 and rs2_val==1431655764, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaa9;  op2val:0x55555554
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaa9, 0x55555554, x14, 1452, x1)

inst_382:
// rs1_val==2863311529 and rs2_val==2863311529, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaa9;  op2val:0xaaaaaaa9
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaa9, 0xaaaaaaa9, x14, 1456, x1)

inst_383:
// rs1_val==2863311529 and rs2_val==4, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaa9;  op2val:0x4
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaa9, 0x4, x14, 1460, x1)

inst_384:
// rs1_val==2863311529 and rs2_val==858993458, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaa9;  op2val:0x33333332
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaa9, 0x33333332, x14, 1464, x1)

inst_385:
// rs1_val==2863311529 and rs2_val==1717986917, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaa9;  op2val:0x66666665
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaa9, 0x66666665, x14, 1468, x1)

inst_386:
// rs1_val==2863311529 and rs2_val==46339, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaa9;  op2val:0xb503
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaa9, 0xb503, x14, 1472, x1)

inst_387:
// rs1_val==2863311529 and rs2_val==65534, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaa9;  op2val:0xfffe
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaa9, 0xfffe, x14, 1476, x1)

inst_388:
// rs1_val==2863311529 and rs2_val==1431655766, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaa9;  op2val:0x55555556
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaa9, 0x55555556, x14, 1480, x1)

inst_389:
// rs1_val==2863311529 and rs2_val==2863311531, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaa9;  op2val:0xaaaaaaab
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xaaaaaaa9, 0xaaaaaaab, x14, 1484, x1)

inst_390:
// rs1_val==2863311529 and rs2_val==6, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaa9;  op2val:0x6
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaa9, 0x6, x14, 1488, x1)

inst_391:
// rs1_val==2863311529 and rs2_val==858993460, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaa9;  op2val:0x33333334
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaa9, 0x33333334, x14, 1492, x1)

inst_392:
// rs1_val==2863311529 and rs2_val==1717986919, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaa9;  op2val:0x66666667
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaa9, 0x66666667, x14, 1496, x1)

inst_393:
// rs1_val==2863311529 and rs2_val==46341, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaa9;  op2val:0xb505
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaa9, 0xb505, x14, 1500, x1)

inst_394:
// rs1_val==2863311529 and rs2_val==1, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaa9;  op2val:0x1
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaa9, 0x1, x14, 1504, x1)

inst_395:
// rs1_val==2863311529 and rs2_val==65536, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaa9;  op2val:0x10000
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaa9, 0x10000, x14, 1508, x1)

inst_396:
// rs1_val==4 and rs2_val==3, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x3
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x4, 0x3, x14, 1512, x1)

inst_397:
// rs1_val==4 and rs2_val==1431655765, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x55555555
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x4, 0x55555555, x14, 1516, x1)

inst_398:
// rs1_val==4 and rs2_val==2863311530, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0xaaaaaaaa
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x4, 0xaaaaaaaa, x14, 1520, x1)

inst_399:
// rs1_val==4 and rs2_val==5, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x5
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x4, 0x5, x14, 1524, x1)

inst_400:
// rs1_val==4 and rs2_val==858993459, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x33333333
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x4, 0x33333333, x14, 1528, x1)

inst_401:
// rs1_val==4 and rs2_val==1717986918, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x66666666
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x4, 0x66666666, x14, 1532, x1)

inst_402:
// rs1_val==4 and rs2_val==46340, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0xb504
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x4, 0xb504, x14, 1536, x1)

inst_403:
// rs1_val==4 and rs2_val==0, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x0
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x4, 0x0, x14, 1540, x1)

inst_404:
// rs1_val==4 and rs2_val==65535, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0xffff
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x4, 0xffff, x14, 1544, x1)

inst_405:
// rs1_val==4 and rs2_val==1431655764, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x55555554
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x4, 0x55555554, x14, 1548, x1)

inst_406:
// rs1_val==4 and rs2_val==2863311529, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0xaaaaaaa9
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x4, 0xaaaaaaa9, x14, 1552, x1)

inst_407:
// rs1_val==4 and rs2_val==4, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x4
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x4, 0x4, x14, 1556, x1)

inst_408:
// rs1_val==4 and rs2_val==858993458, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x33333332
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x4, 0x33333332, x14, 1560, x1)

inst_409:
// rs1_val==4 and rs2_val==1717986917, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x66666665
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x4, 0x66666665, x14, 1564, x1)

inst_410:
// rs1_val==4 and rs2_val==46339, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0xb503
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x4, 0xb503, x14, 1568, x1)

inst_411:
// rs1_val==4 and rs2_val==65534, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0xfffe
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x4, 0xfffe, x14, 1572, x1)

inst_412:
// rs1_val==4 and rs2_val==1431655766, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x55555556
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x4, 0x55555556, x14, 1576, x1)

inst_413:
// rs1_val==4 and rs2_val==2863311531, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0xaaaaaaab
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x4, 0xaaaaaaab, x14, 1580, x1)

inst_414:
// rs1_val==4 and rs2_val==6, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x6
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x4, 0x6, x14, 1584, x1)

inst_415:
// rs1_val==4 and rs2_val==858993460, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x33333334
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x4, 0x33333334, x14, 1588, x1)

inst_416:
// rs1_val==4 and rs2_val==1717986919, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x66666667
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x4, 0x66666667, x14, 1592, x1)

inst_417:
// rs1_val==4 and rs2_val==46341, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0xb505
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x4, 0xb505, x14, 1596, x1)

inst_418:
// rs1_val==4 and rs2_val==1, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x1
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x4, 0x1, x14, 1600, x1)

inst_419:
// rs1_val==4 and rs2_val==65536, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x10000
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x4, 0x10000, x14, 1604, x1)

inst_420:
// rs1_val==858993458 and rs2_val==3, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x3
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x33333332, 0x3, x14, 1608, x1)

inst_421:
// rs1_val==858993458 and rs2_val==1431655765, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x55555555
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x33333332, 0x55555555, x14, 1612, x1)

inst_422:
// rs1_val==858993458 and rs2_val==2863311530, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0xaaaaaaaa
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x33333332, 0xaaaaaaaa, x14, 1616, x1)

inst_423:
// rs1_val==858993458 and rs2_val==5, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x5
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x33333332, 0x5, x14, 1620, x1)

inst_424:
// rs1_val==858993458 and rs2_val==858993459, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x33333333
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x33333332, 0x33333333, x14, 1624, x1)

inst_425:
// rs1_val==858993458 and rs2_val==1717986918, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x66666666
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x33333332, 0x66666666, x14, 1628, x1)

inst_426:
// rs1_val==858993458 and rs2_val==46340, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0xb504
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x33333332, 0xb504, x14, 1632, x1)

inst_427:
// rs1_val==858993458 and rs2_val==0, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x0
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x33333332, 0x0, x14, 1636, x1)

inst_428:
// rs1_val==858993458 and rs2_val==65535, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0xffff
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x33333332, 0xffff, x14, 1640, x1)

inst_429:
// rs1_val==858993458 and rs2_val==2, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x2
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x33333332, 0x2, x14, 1644, x1)

inst_430:
// rs1_val==858993458 and rs2_val==1431655764, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x55555554
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x33333332, 0x55555554, x14, 1648, x1)

inst_431:
// rs1_val==858993458 and rs2_val==2863311529, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0xaaaaaaa9
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x33333332, 0xaaaaaaa9, x14, 1652, x1)

inst_432:
// rs1_val==858993458 and rs2_val==4, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x4
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x33333332, 0x4, x14, 1656, x1)

inst_433:
// rs1_val==858993458 and rs2_val==858993458, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x33333332
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x33333332, 0x33333332, x14, 1660, x1)

inst_434:
// rs1_val==858993458 and rs2_val==1717986917, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x66666665
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x33333332, 0x66666665, x14, 1664, x1)

inst_435:
// rs1_val==858993458 and rs2_val==46339, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0xb503
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x33333332, 0xb503, x14, 1668, x1)

inst_436:
// rs1_val==858993458 and rs2_val==65534, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0xfffe
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x33333332, 0xfffe, x14, 1672, x1)

inst_437:
// rs1_val==858993458 and rs2_val==1431655766, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x55555556
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x33333332, 0x55555556, x14, 1676, x1)

inst_438:
// rs1_val==858993458 and rs2_val==2863311531, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0xaaaaaaab
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x33333332, 0xaaaaaaab, x14, 1680, x1)

inst_439:
// rs1_val==858993458 and rs2_val==6, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x6
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x33333332, 0x6, x14, 1684, x1)

inst_440:
// rs1_val==858993458 and rs2_val==858993460, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x33333334
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x33333332, 0x33333334, x14, 1688, x1)

inst_441:
// rs1_val==858993458 and rs2_val==1717986919, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x66666667
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x33333332, 0x66666667, x14, 1692, x1)

inst_442:
// rs1_val==858993458 and rs2_val==46341, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0xb505
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x33333332, 0xb505, x14, 1696, x1)

inst_443:
// rs1_val==858993458 and rs2_val==1, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x1
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x33333332, 0x1, x14, 1700, x1)

inst_444:
// rs1_val==858993458 and rs2_val==65536, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x10000
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x33333332, 0x10000, x14, 1704, x1)

inst_445:
// rs1_val==1717986917 and rs2_val==3, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x3
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x66666665, 0x3, x14, 1708, x1)

inst_446:
// rs1_val==1717986917 and rs2_val==1431655765, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x55555555
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x66666665, 0x55555555, x14, 1712, x1)

inst_447:
// rs1_val==1717986917 and rs2_val==2863311530, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0xaaaaaaaa
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x66666665, 0xaaaaaaaa, x14, 1716, x1)

inst_448:
// rs1_val==1717986917 and rs2_val==5, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x5
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x66666665, 0x5, x14, 1720, x1)

inst_449:
// rs1_val==1717986917 and rs2_val==858993459, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x33333333
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x66666665, 0x33333333, x14, 1724, x1)

inst_450:
// rs1_val==1717986917 and rs2_val==1717986918, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x66666666
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x66666665, 0x66666666, x14, 1728, x1)

inst_451:
// rs1_val==1717986917 and rs2_val==46340, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0xb504
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x66666665, 0xb504, x14, 1732, x1)

inst_452:
// rs1_val==1717986917 and rs2_val==0, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x0
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x66666665, 0x0, x14, 1736, x1)

inst_453:
// rs1_val==1717986917 and rs2_val==65535, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0xffff
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x66666665, 0xffff, x14, 1740, x1)

inst_454:
// rs1_val==1717986917 and rs2_val==2, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x2
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x66666665, 0x2, x14, 1744, x1)

inst_455:
// rs1_val==1717986917 and rs2_val==1431655764, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x55555554
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x66666665, 0x55555554, x14, 1748, x1)

inst_456:
// rs1_val==1717986917 and rs2_val==2863311529, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0xaaaaaaa9
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x66666665, 0xaaaaaaa9, x14, 1752, x1)

inst_457:
// rs1_val==1717986917 and rs2_val==4, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x4
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x66666665, 0x4, x14, 1756, x1)

inst_458:
// rs1_val==1717986917 and rs2_val==858993458, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x33333332
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x66666665, 0x33333332, x14, 1760, x1)

inst_459:
// rs1_val==1717986917 and rs2_val==1717986917, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x66666665
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x66666665, 0x66666665, x14, 1764, x1)

inst_460:
// rs1_val==1717986917 and rs2_val==46339, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0xb503
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x66666665, 0xb503, x14, 1768, x1)

inst_461:
// rs1_val==1717986917 and rs2_val==65534, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0xfffe
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x66666665, 0xfffe, x14, 1772, x1)

inst_462:
// rs1_val==1717986917 and rs2_val==1431655766, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x55555556
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x66666665, 0x55555556, x14, 1776, x1)

inst_463:
// rs1_val==1717986917 and rs2_val==1, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x1
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x66666665, 0x1, x14, 1780, x1)

inst_464:
// rs1_val==1717986917 and rs2_val==65536, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x10000
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x66666665, 0x10000, x14, 1784, x1)

inst_465:
// rs1_val==46339 and rs2_val==3, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x3
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xb503, 0x3, x14, 1788, x1)

inst_466:
// rs1_val==46339 and rs2_val==1431655765, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x55555555
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xb503, 0x55555555, x14, 1792, x1)

inst_467:
// rs1_val==46339 and rs2_val==2863311530, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0xaaaaaaaa
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xb503, 0xaaaaaaaa, x14, 1796, x1)

inst_468:
// rs1_val==46339 and rs2_val==5, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x5
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xb503, 0x5, x14, 1800, x1)

inst_469:
// rs1_val==46339 and rs2_val==858993459, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x33333333
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xb503, 0x33333333, x14, 1804, x1)

inst_470:
// rs1_val==46339 and rs2_val==1717986918, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x66666666
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xb503, 0x66666666, x14, 1808, x1)

inst_471:
// rs1_val==46339 and rs2_val==46340, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0xb504
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xb503, 0xb504, x14, 1812, x1)

inst_472:
// rs1_val==46339 and rs2_val==0, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x0
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xb503, 0x0, x14, 1816, x1)

inst_473:
// rs1_val==46339 and rs2_val==65535, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0xffff
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xb503, 0xffff, x14, 1820, x1)

inst_474:
// rs1_val==46339 and rs2_val==2, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x2
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xb503, 0x2, x14, 1824, x1)

inst_475:
// rs1_val==46339 and rs2_val==1431655764, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x55555554
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xb503, 0x55555554, x14, 1828, x1)

inst_476:
// rs1_val==46339 and rs2_val==2863311529, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0xaaaaaaa9
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xb503, 0xaaaaaaa9, x14, 1832, x1)

inst_477:
// rs1_val==46339 and rs2_val==4, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x4
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xb503, 0x4, x14, 1836, x1)

inst_478:
// rs1_val==46339 and rs2_val==858993458, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x33333332
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xb503, 0x33333332, x14, 1840, x1)

inst_479:
// rs1_val==46339 and rs2_val==1717986917, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x66666665
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xb503, 0x66666665, x14, 1844, x1)

inst_480:
// rs1_val==46339 and rs2_val==46339, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0xb503
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xb503, 0xb503, x14, 1848, x1)

inst_481:
// rs1_val==46339 and rs2_val==65534, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0xfffe
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xb503, 0xfffe, x14, 1852, x1)

inst_482:
// rs1_val==46339 and rs2_val==1431655766, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x55555556
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xb503, 0x55555556, x14, 1856, x1)

inst_483:
// rs1_val==46339 and rs2_val==2863311531, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0xaaaaaaab
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xb503, 0xaaaaaaab, x14, 1860, x1)

inst_484:
// rs1_val==46339 and rs2_val==6, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x6
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xb503, 0x6, x14, 1864, x1)

inst_485:
// rs1_val==46339 and rs2_val==858993460, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x33333334
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xb503, 0x33333334, x14, 1868, x1)

inst_486:
// rs1_val==46339 and rs2_val==1717986919, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x66666667
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xb503, 0x66666667, x14, 1872, x1)

inst_487:
// rs1_val==46339 and rs2_val==46341, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0xb505
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xb503, 0xb505, x14, 1876, x1)

inst_488:
// rs1_val==46339 and rs2_val==1, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x1
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xb503, 0x1, x14, 1880, x1)

inst_489:
// rs1_val==46339 and rs2_val==65536, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x10000
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xb503, 0x10000, x14, 1884, x1)

inst_490:
// rs1_val==65534 and rs2_val==3, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xfffe;  op2val:0x3
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xfffe, 0x3, x14, 1888, x1)

inst_491:
// rs1_val==65534 and rs2_val==1431655765, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xfffe;  op2val:0x55555555
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xfffe, 0x55555555, x14, 1892, x1)

inst_492:
// rs1_val==65534 and rs2_val==2863311530, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xfffe;  op2val:0xaaaaaaaa
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xfffe, 0xaaaaaaaa, x14, 1896, x1)

inst_493:
// rs1_val==65534 and rs2_val==5, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xfffe;  op2val:0x5
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xfffe, 0x5, x14, 1900, x1)

inst_494:
// rs1_val==65534 and rs2_val==858993459, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xfffe;  op2val:0x33333333
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xfffe, 0x33333333, x14, 1904, x1)

inst_495:
// rs1_val==65534 and rs2_val==1717986918, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xfffe;  op2val:0x66666666
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xfffe, 0x66666666, x14, 1908, x1)

inst_496:
// rs1_val==65534 and rs2_val==46340, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xfffe;  op2val:0xb504
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xfffe, 0xb504, x14, 1912, x1)

inst_497:
// rs1_val==65534 and rs2_val==0, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xfffe;  op2val:0x0
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xfffe, 0x0, x14, 1916, x1)

inst_498:
// rs1_val==65534 and rs2_val==65535, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xfffe;  op2val:0xffff
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xfffe, 0xffff, x14, 1920, x1)

inst_499:
// rs1_val==65534 and rs2_val==2, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xfffe;  op2val:0x2
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xfffe, 0x2, x14, 1924, x1)

inst_500:
// rs1_val==65534 and rs2_val==1431655764, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xfffe;  op2val:0x55555554
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xfffe, 0x55555554, x14, 1928, x1)

inst_501:
// rs1_val==65534 and rs2_val==2863311529, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xfffe;  op2val:0xaaaaaaa9
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xfffe, 0xaaaaaaa9, x14, 1932, x1)

inst_502:
// rs1_val==65534 and rs2_val==4, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xfffe;  op2val:0x4
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xfffe, 0x4, x14, 1936, x1)

inst_503:
// rs1_val==65534 and rs2_val==858993458, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xfffe;  op2val:0x33333332
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xfffe, 0x33333332, x14, 1940, x1)

inst_504:
// rs1_val==65534 and rs2_val==1717986917, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xfffe;  op2val:0x66666665
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xfffe, 0x66666665, x14, 1944, x1)

inst_505:
// rs1_val==65534 and rs2_val==46339, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xfffe;  op2val:0xb503
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xfffe, 0xb503, x14, 1948, x1)

inst_506:
// rs1_val==65534 and rs2_val==65534, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xfffe;  op2val:0xfffe
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xfffe, 0xfffe, x14, 1952, x1)

inst_507:
// rs1_val==65534 and rs2_val==1431655766, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xfffe;  op2val:0x55555556
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xfffe, 0x55555556, x14, 1956, x1)

inst_508:
// rs1_val==65534 and rs2_val==2863311531, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xfffe;  op2val:0xaaaaaaab
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xfffe, 0xaaaaaaab, x14, 1960, x1)

inst_509:
// rs1_val==65534 and rs2_val==6, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xfffe;  op2val:0x6
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xfffe, 0x6, x14, 1964, x1)

inst_510:
// rs1_val==65534 and rs2_val==858993460, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xfffe;  op2val:0x33333334
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xfffe, 0x33333334, x14, 1968, x1)

inst_511:
// rs1_val==65534 and rs2_val==1717986919, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xfffe;  op2val:0x66666667
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xfffe, 0x66666667, x14, 1972, x1)

inst_512:
// rs1_val==65534 and rs2_val==46341, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xfffe;  op2val:0xb505
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xfffe, 0xb505, x14, 1976, x1)

inst_513:
// rs1_val==65534 and rs2_val==1, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xfffe;  op2val:0x1
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xfffe, 0x1, x14, 1980, x1)

inst_514:
// rs1_val==65534 and rs2_val==65536, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xfffe;  op2val:0x10000
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xfffe, 0x10000, x14, 1984, x1)

inst_515:
// rs1_val==1431655766 and rs2_val==3, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x3
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x55555556, 0x3, x14, 1988, x1)

inst_516:
// rs1_val==1431655766 and rs2_val==1431655765, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x55555555
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x55555556, 0x55555555, x14, 1992, x1)

inst_517:
// rs1_val==1431655766 and rs2_val==2863311530, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0xaaaaaaaa
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x55555556, 0xaaaaaaaa, x14, 1996, x1)

inst_518:
// rs1_val==1431655766 and rs2_val==5, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x5
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x55555556, 0x5, x14, 2000, x1)

inst_519:
// rs1_val==1431655766 and rs2_val==858993459, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x33333333
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x55555556, 0x33333333, x14, 2004, x1)

inst_520:
// rs1_val==1431655766 and rs2_val==1717986918, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x66666666
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x55555556, 0x66666666, x14, 2008, x1)

inst_521:
// rs1_val==1431655766 and rs2_val==46340, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0xb504
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x55555556, 0xb504, x14, 2012, x1)

inst_522:
// rs1_val==1431655766 and rs2_val==0, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x0
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x55555556, 0x0, x14, 2016, x1)

inst_523:
// rs1_val==1431655766 and rs2_val==65535, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0xffff
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x55555556, 0xffff, x14, 2020, x1)

inst_524:
// rs1_val==1431655766 and rs2_val==2, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x2
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x55555556, 0x2, x14, 2024, x1)

inst_525:
// rs1_val==1431655766 and rs2_val==1431655764, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x55555554
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x55555556, 0x55555554, x14, 2028, x1)

inst_526:
// rs1_val==1431655766 and rs2_val==2863311529, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0xaaaaaaa9
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x55555556, 0xaaaaaaa9, x14, 2032, x1)

inst_527:
// rs1_val==1431655766 and rs2_val==4, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x4
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x55555556, 0x4, x14, 2036, x1)

inst_528:
// rs1_val==1431655766 and rs2_val==858993458, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x33333332
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x55555556, 0x33333332, x14, 2040, x1)

inst_529:
// rs1_val==1431655766 and rs2_val==1717986917, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x66666665
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x55555556, 0x66666665, x14, 2044, x1)
RVTEST_SIGBASE( x14,signature_x14_1)

inst_530:
// rs1_val==1431655766 and rs2_val==46339, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0xb503
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x55555556, 0xb503, x14, 0, x1)

inst_531:
// rs1_val==1431655766 and rs2_val==65534, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0xfffe
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x55555556, 0xfffe, x14, 4, x1)

inst_532:
// rs1_val==1431655766 and rs2_val==1431655766, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x55555556
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x55555556, 0x55555556, x14, 8, x1)

inst_533:
// rs1_val==1431655766 and rs2_val==2863311531, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0xaaaaaaab
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x55555556, 0xaaaaaaab, x14, 12, x1)

inst_534:
// rs1_val==1431655766 and rs2_val==6, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x6
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x55555556, 0x6, x14, 16, x1)

inst_535:
// rs1_val==1431655766 and rs2_val==858993460, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x33333334
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x55555556, 0x33333334, x14, 20, x1)

inst_536:
// rs1_val==1431655766 and rs2_val==1717986919, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x66666667
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x55555556, 0x66666667, x14, 24, x1)

inst_537:
// rs1_val==1431655766 and rs2_val==46341, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0xb505
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x55555556, 0xb505, x14, 28, x1)

inst_538:
// rs1_val==1431655766 and rs2_val==1, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x1
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x55555556, 0x1, x14, 32, x1)

inst_539:
// rs1_val==1431655766 and rs2_val==65536, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x10000
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x55555556, 0x10000, x14, 36, x1)

inst_540:
// rs1_val==2863311531 and rs2_val==3, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaab;  op2val:0x3
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaab, 0x3, x14, 40, x1)

inst_541:
// rs1_val==2863311531 and rs2_val==1431655765, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaab;  op2val:0x55555555
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaab, 0x55555555, x14, 44, x1)

inst_542:
// rs1_val==2863311531 and rs2_val==2863311530, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaab;  op2val:0xaaaaaaaa
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaab, 0xaaaaaaaa, x14, 48, x1)

inst_543:
// rs1_val==2863311531 and rs2_val==5, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaab;  op2val:0x5
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaab, 0x5, x14, 52, x1)

inst_544:
// rs1_val==2863311531 and rs2_val==858993459, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaab;  op2val:0x33333333
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaab, 0x33333333, x14, 56, x1)

inst_545:
// rs1_val==2863311531 and rs2_val==1717986918, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaab;  op2val:0x66666666
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaab, 0x66666666, x14, 60, x1)

inst_546:
// rs1_val==2863311531 and rs2_val==46340, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaab;  op2val:0xb504
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaab, 0xb504, x14, 64, x1)

inst_547:
// rs1_val==2863311531 and rs2_val==0, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaab;  op2val:0x0
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaab, 0x0, x14, 68, x1)

inst_548:
// rs1_val==2863311531 and rs2_val==65535, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaab;  op2val:0xffff
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaab, 0xffff, x14, 72, x1)

inst_549:
// rs1_val==2863311531 and rs2_val==2, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaab;  op2val:0x2
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaab, 0x2, x14, 76, x1)

inst_550:
// rs1_val==2863311531 and rs2_val==1431655764, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaab;  op2val:0x55555554
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaab, 0x55555554, x14, 80, x1)

inst_551:
// rs1_val==2863311531 and rs2_val==2863311529, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaab;  op2val:0xaaaaaaa9
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaab, 0xaaaaaaa9, x14, 84, x1)

inst_552:
// rs1_val==2863311531 and rs2_val==4, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaab;  op2val:0x4
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaab, 0x4, x14, 88, x1)

inst_553:
// rs1_val==2863311531 and rs2_val==858993458, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaab;  op2val:0x33333332
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaab, 0x33333332, x14, 92, x1)

inst_554:
// rs1_val==2863311531 and rs2_val==1717986917, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaab;  op2val:0x66666665
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaab, 0x66666665, x14, 96, x1)

inst_555:
// rs1_val==2863311531 and rs2_val==46339, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaab;  op2val:0xb503
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaab, 0xb503, x14, 100, x1)

inst_556:
// rs1_val==2863311531 and rs2_val==65534, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaab;  op2val:0xfffe
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaab, 0xfffe, x14, 104, x1)

inst_557:
// rs1_val==2863311531 and rs2_val==1431655766, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaab;  op2val:0x55555556
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaab, 0x55555556, x14, 108, x1)

inst_558:
// rs1_val==2863311531 and rs2_val==2863311531, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaab;  op2val:0xaaaaaaab
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaab, 0xaaaaaaab, x14, 112, x1)

inst_559:
// rs1_val==2863311531 and rs2_val==6, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaab;  op2val:0x6
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaab, 0x6, x14, 116, x1)

inst_560:
// rs1_val==2863311531 and rs2_val==858993460, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaab;  op2val:0x33333334
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaab, 0x33333334, x14, 120, x1)

inst_561:
// rs1_val==2863311531 and rs2_val==1717986919, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaab;  op2val:0x66666667
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaab, 0x66666667, x14, 124, x1)

inst_562:
// rs1_val==2863311531 and rs2_val==46341, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaab;  op2val:0xb505
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaab, 0xb505, x14, 128, x1)

inst_563:
// rs1_val==2863311531 and rs2_val==1, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaab;  op2val:0x1
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaab, 0x1, x14, 132, x1)

inst_564:
// rs1_val==2863311531 and rs2_val==65536, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xaaaaaaab;  op2val:0x10000
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xaaaaaaab, 0x10000, x14, 136, x1)

inst_565:
// rs1_val==6 and rs2_val==3, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x3
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x6, 0x3, x14, 140, x1)

inst_566:
// rs1_val==6 and rs2_val==1431655765, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x55555555
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x6, 0x55555555, x14, 144, x1)

inst_567:
// rs1_val==6 and rs2_val==2863311530, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0xaaaaaaaa
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x6, 0xaaaaaaaa, x14, 148, x1)

inst_568:
// rs1_val==6 and rs2_val==5, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x5
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x6, 0x5, x14, 152, x1)

inst_569:
// rs1_val==6 and rs2_val==858993459, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x33333333
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x6, 0x33333333, x14, 156, x1)

inst_570:
// rs1_val==6 and rs2_val==1717986918, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x66666666
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x6, 0x66666666, x14, 160, x1)

inst_571:
// rs1_val==6 and rs2_val==46340, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0xb504
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x6, 0xb504, x14, 164, x1)

inst_572:
// rs1_val==6 and rs2_val==0, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x0
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x6, 0x0, x14, 168, x1)

inst_573:
// rs1_val==6 and rs2_val==65535, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0xffff
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x6, 0xffff, x14, 172, x1)

inst_574:
// rs1_val==6 and rs2_val==2, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x2
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x6, 0x2, x14, 176, x1)

inst_575:
// rs1_val==6 and rs2_val==1431655764, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x55555554
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x6, 0x55555554, x14, 180, x1)

inst_576:
// rs1_val==6 and rs2_val==2863311529, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0xaaaaaaa9
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x6, 0xaaaaaaa9, x14, 184, x1)

inst_577:
// rs1_val==6 and rs2_val==4, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x4
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x6, 0x4, x14, 188, x1)

inst_578:
// rs1_val==6 and rs2_val==858993458, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x33333332
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x6, 0x33333332, x14, 192, x1)

inst_579:
// rs1_val==6 and rs2_val==1717986917, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x66666665
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x6, 0x66666665, x14, 196, x1)

inst_580:
// rs1_val==6 and rs2_val==46339, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0xb503
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x6, 0xb503, x14, 200, x1)

inst_581:
// rs1_val==6 and rs2_val==65534, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0xfffe
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x6, 0xfffe, x14, 204, x1)

inst_582:
// rs1_val==6 and rs2_val==1431655766, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x55555556
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x6, 0x55555556, x14, 208, x1)

inst_583:
// rs1_val==6 and rs2_val==2863311531, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0xaaaaaaab
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x6, 0xaaaaaaab, x14, 212, x1)

inst_584:
// rs1_val==6 and rs2_val==6, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x6
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x6, 0x6, x14, 216, x1)

inst_585:
// rs1_val==6 and rs2_val==858993460, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x33333334
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x6, 0x33333334, x14, 220, x1)

inst_586:
// rs1_val==6 and rs2_val==1717986919, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x66666667
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x6, 0x66666667, x14, 224, x1)

inst_587:
// rs1_val==6 and rs2_val==46341, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0xb505
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x6, 0xb505, x14, 228, x1)

inst_588:
// rs1_val==6 and rs2_val==1, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x1
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x6, 0x1, x14, 232, x1)

inst_589:
// rs1_val==6 and rs2_val==65536, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x10000
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x6, 0x10000, x14, 236, x1)

inst_590:
// rs1_val==858993460 and rs2_val==3, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x3
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x33333334, 0x3, x14, 240, x1)

inst_591:
// rs1_val==1717986917 and rs2_val==2863311531, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0xaaaaaaab
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x66666665, 0xaaaaaaab, x14, 244, x1)

inst_592:
// rs1_val==858993460 and rs2_val==1431655765, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x55555555
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x33333334, 0x55555555, x14, 248, x1)

inst_593:
// rs1_val==858993460 and rs2_val==2863311530, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0xaaaaaaaa
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x33333334, 0xaaaaaaaa, x14, 252, x1)

inst_594:
// rs1_val==858993460 and rs2_val==5, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x5
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x33333334, 0x5, x14, 256, x1)

inst_595:
// rs1_val==858993460 and rs2_val==858993459, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x33333333
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x33333334, 0x33333333, x14, 260, x1)

inst_596:
// rs1_val==858993460 and rs2_val==1717986918, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x66666666
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x33333334, 0x66666666, x14, 264, x1)

inst_597:
// rs1_val==858993460 and rs2_val==46340, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0xb504
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x33333334, 0xb504, x14, 268, x1)

inst_598:
// rs1_val==858993460 and rs2_val==0, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x0
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x33333334, 0x0, x14, 272, x1)

inst_599:
// rs1_val==858993460 and rs2_val==65535, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0xffff
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x33333334, 0xffff, x14, 276, x1)

inst_600:
// rs1_val==858993460 and rs2_val==2, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x2
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x33333334, 0x2, x14, 280, x1)

inst_601:
// rs1_val==858993460 and rs2_val==1431655764, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x55555554
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x33333334, 0x55555554, x14, 284, x1)

inst_602:
// rs1_val==858993460 and rs2_val==2863311529, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0xaaaaaaa9
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x33333334, 0xaaaaaaa9, x14, 288, x1)

inst_603:
// rs1_val==858993460 and rs2_val==4, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x4
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x33333334, 0x4, x14, 292, x1)

inst_604:
// rs1_val==858993460 and rs2_val==858993458, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x33333332
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x33333334, 0x33333332, x14, 296, x1)

inst_605:
// rs1_val==858993460 and rs2_val==1717986917, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x66666665
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x33333334, 0x66666665, x14, 300, x1)

inst_606:
// rs1_val==858993460 and rs2_val==46339, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0xb503
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x33333334, 0xb503, x14, 304, x1)

inst_607:
// rs1_val==858993460 and rs2_val==65534, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0xfffe
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x33333334, 0xfffe, x14, 308, x1)

inst_608:
// rs1_val==858993460 and rs2_val==1431655766, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x55555556
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x33333334, 0x55555556, x14, 312, x1)

inst_609:
// rs1_val==858993460 and rs2_val==2863311531, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0xaaaaaaab
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x33333334, 0xaaaaaaab, x14, 316, x1)

inst_610:
// rs1_val==858993460 and rs2_val==6, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x6
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x33333334, 0x6, x14, 320, x1)

inst_611:
// rs1_val==858993460 and rs2_val==858993460, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x33333334
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x33333334, 0x33333334, x14, 324, x1)

inst_612:
// rs1_val==858993460 and rs2_val==1717986919, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x66666667
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x33333334, 0x66666667, x14, 328, x1)

inst_613:
// rs1_val==858993460 and rs2_val==46341, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0xb505
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x33333334, 0xb505, x14, 332, x1)

inst_614:
// rs1_val==858993460 and rs2_val==1, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x1
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x33333334, 0x1, x14, 336, x1)

inst_615:
// rs1_val==858993460 and rs2_val==65536, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x10000
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x33333334, 0x10000, x14, 340, x1)

inst_616:
// rs1_val==1717986919 and rs2_val==3, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x3
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x66666667, 0x3, x14, 344, x1)

inst_617:
// rs1_val==1717986919 and rs2_val==1431655765, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x55555555
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x66666667, 0x55555555, x14, 348, x1)

inst_618:
// rs1_val==1717986919 and rs2_val==2863311530, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0xaaaaaaaa
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x66666667, 0xaaaaaaaa, x14, 352, x1)

inst_619:
// rs1_val==1717986919 and rs2_val==5, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x5
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x66666667, 0x5, x14, 356, x1)

inst_620:
// rs1_val==1717986919 and rs2_val==858993459, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x33333333
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x66666667, 0x33333333, x14, 360, x1)

inst_621:
// rs1_val==1717986919 and rs2_val==1717986918, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x66666666
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x66666667, 0x66666666, x14, 364, x1)

inst_622:
// rs1_val==1717986919 and rs2_val==46340, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0xb504
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x66666667, 0xb504, x14, 368, x1)

inst_623:
// rs1_val==1717986919 and rs2_val==0, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x0
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x66666667, 0x0, x14, 372, x1)

inst_624:
// rs1_val==1717986919 and rs2_val==65535, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0xffff
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x66666667, 0xffff, x14, 376, x1)

inst_625:
// rs1_val==1717986919 and rs2_val==2, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x2
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x66666667, 0x2, x14, 380, x1)

inst_626:
// rs1_val==1717986919 and rs2_val==1431655764, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x55555554
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x66666667, 0x55555554, x14, 384, x1)

inst_627:
// rs1_val==1717986919 and rs2_val==2863311529, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0xaaaaaaa9
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x66666667, 0xaaaaaaa9, x14, 388, x1)

inst_628:
// rs1_val==1717986919 and rs2_val==4, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x4
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x66666667, 0x4, x14, 392, x1)

inst_629:
// rs1_val==1717986919 and rs2_val==858993458, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x33333332
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x66666667, 0x33333332, x14, 396, x1)

inst_630:
// rs1_val==1717986919 and rs2_val==1717986917, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x66666665
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x66666667, 0x66666665, x14, 400, x1)

inst_631:
// rs1_val==1717986919 and rs2_val==46339, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0xb503
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x66666667, 0xb503, x14, 404, x1)

inst_632:
// rs1_val==1717986919 and rs2_val==65534, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0xfffe
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x66666667, 0xfffe, x14, 408, x1)

inst_633:
// rs1_val==1717986919 and rs2_val==1431655766, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x55555556
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x66666667, 0x55555556, x14, 412, x1)

inst_634:
// rs1_val==1717986919 and rs2_val==2863311531, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0xaaaaaaab
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x66666667, 0xaaaaaaab, x14, 416, x1)

inst_635:
// rs1_val==1717986919 and rs2_val==6, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x6
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x66666667, 0x6, x14, 420, x1)

inst_636:
// rs1_val==1717986919 and rs2_val==858993460, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x33333334
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x66666667, 0x33333334, x14, 424, x1)

inst_637:
// rs1_val==1717986919 and rs2_val==1717986919, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x66666667
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x66666667, 0x66666667, x14, 428, x1)

inst_638:
// rs1_val==1717986919 and rs2_val==46341, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0xb505
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x66666667, 0xb505, x14, 432, x1)

inst_639:
// rs1_val==1717986919 and rs2_val==1, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x1
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x66666667, 0x1, x14, 436, x1)

inst_640:
// rs1_val==1717986919 and rs2_val==65536, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x10000
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x66666667, 0x10000, x14, 440, x1)

inst_641:
// rs1_val==46341 and rs2_val==3, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x3
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xb505, 0x3, x14, 444, x1)

inst_642:
// rs1_val==46341 and rs2_val==1431655765, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x55555555
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xb505, 0x55555555, x14, 448, x1)

inst_643:
// rs1_val==46341 and rs2_val==2863311530, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0xaaaaaaaa
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xb505, 0xaaaaaaaa, x14, 452, x1)

inst_644:
// rs1_val==46341 and rs2_val==5, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x5
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xb505, 0x5, x14, 456, x1)

inst_645:
// rs1_val==46341 and rs2_val==858993459, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x33333333
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xb505, 0x33333333, x14, 460, x1)

inst_646:
// rs1_val==46341 and rs2_val==1717986918, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x66666666
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xb505, 0x66666666, x14, 464, x1)

inst_647:
// rs1_val==46341 and rs2_val==46340, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0xb504
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xb505, 0xb504, x14, 468, x1)

inst_648:
// rs1_val==46341 and rs2_val==0, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x0
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xb505, 0x0, x14, 472, x1)

inst_649:
// rs1_val==46341 and rs2_val==65535, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0xffff
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xb505, 0xffff, x14, 476, x1)

inst_650:
// rs1_val==46341 and rs2_val==2, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x2
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xb505, 0x2, x14, 480, x1)

inst_651:
// rs1_val==46341 and rs2_val==1431655764, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x55555554
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xb505, 0x55555554, x14, 484, x1)

inst_652:
// rs1_val==46341 and rs2_val==2863311529, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0xaaaaaaa9
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xb505, 0xaaaaaaa9, x14, 488, x1)

inst_653:
// rs1_val==46341 and rs2_val==4, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x4
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xb505, 0x4, x14, 492, x1)

inst_654:
// rs1_val==46341 and rs2_val==858993458, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x33333332
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xb505, 0x33333332, x14, 496, x1)

inst_655:
// rs1_val==46341 and rs2_val==1717986917, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x66666665
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xb505, 0x66666665, x14, 500, x1)

inst_656:
// rs1_val==46341 and rs2_val==46339, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0xb503
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xb505, 0xb503, x14, 504, x1)

inst_657:
// rs1_val==46341 and rs2_val==65534, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0xfffe
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xb505, 0xfffe, x14, 508, x1)

inst_658:
// rs1_val==46341 and rs2_val==1431655766, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x55555556
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xb505, 0x55555556, x14, 512, x1)

inst_659:
// rs1_val==46341 and rs2_val==2863311531, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0xaaaaaaab
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xb505, 0xaaaaaaab, x14, 516, x1)

inst_660:
// rs1_val==46341 and rs2_val==6, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x6
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xb505, 0x6, x14, 520, x1)

inst_661:
// rs1_val==46341 and rs2_val==858993460, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x33333334
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xb505, 0x33333334, x14, 524, x1)

inst_662:
// rs1_val==46341 and rs2_val==1717986919, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x66666667
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xb505, 0x66666667, x14, 528, x1)

inst_663:
// rs1_val==46341 and rs2_val==46341, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0xb505
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xb505, 0xb505, x14, 532, x1)

inst_664:
// rs1_val==46341 and rs2_val==1, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x1
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xb505, 0x1, x14, 536, x1)

inst_665:
// rs1_val==46341 and rs2_val==65536, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x10000
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0xb505, 0x10000, x14, 540, x1)

inst_666:
// rs1_val==1 and rs2_val==3, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x1;  op2val:0x3
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x1, 0x3, x14, 544, x1)

inst_667:
// rs1_val==1 and rs2_val==1431655765, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x1;  op2val:0x55555555
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x1, 0x55555555, x14, 548, x1)

inst_668:
// rs1_val==1 and rs2_val==2863311530, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x1;  op2val:0xaaaaaaaa
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x1, 0xaaaaaaaa, x14, 552, x1)

inst_669:
// rs1_val==1 and rs2_val==5, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x1;  op2val:0x5
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x1, 0x5, x14, 556, x1)

inst_670:
// rs1_val==1 and rs2_val==858993459, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x1;  op2val:0x33333333
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x1, 0x33333333, x14, 560, x1)

inst_671:
// rs1_val==1 and rs2_val==1717986918, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x1;  op2val:0x66666666
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x1, 0x66666666, x14, 564, x1)

inst_672:
// rs1_val==1 and rs2_val==46340, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x1;  op2val:0xb504
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x1, 0xb504, x14, 568, x1)

inst_673:
// rs1_val==1 and rs2_val==0, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x1;  op2val:0x0
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x1, 0x0, x14, 572, x1)

inst_674:
// rs1_val==1 and rs2_val==65535, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x1;  op2val:0xffff
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x1, 0xffff, x14, 576, x1)

inst_675:
// rs1_val==1 and rs2_val==2, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x1;  op2val:0x2
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x1, 0x2, x14, 580, x1)

inst_676:
// rs1_val==1 and rs2_val==1431655764, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x1;  op2val:0x55555554
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x1, 0x55555554, x14, 584, x1)

inst_677:
// rs1_val==1 and rs2_val==2863311529, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x1;  op2val:0xaaaaaaa9
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x1, 0xaaaaaaa9, x14, 588, x1)

inst_678:
// rs1_val==1 and rs2_val==4, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x1;  op2val:0x4
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x1, 0x4, x14, 592, x1)

inst_679:
// rs1_val==1 and rs2_val==858993458, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x1;  op2val:0x33333332
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x1, 0x33333332, x14, 596, x1)

inst_680:
// rs1_val==1 and rs2_val==1717986917, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x1;  op2val:0x66666665
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x1, 0x66666665, x14, 600, x1)

inst_681:
// rs1_val==1 and rs2_val==46339, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x1;  op2val:0xb503
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x1, 0xb503, x14, 604, x1)

inst_682:
// rs1_val==1 and rs2_val==65534, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x1;  op2val:0xfffe
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x1, 0xfffe, x14, 608, x1)

inst_683:
// rs1_val==1 and rs2_val==1431655766, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x1;  op2val:0x55555556
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x1, 0x55555556, x14, 612, x1)

inst_684:
// rs1_val==1 and rs2_val==2863311531, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x1;  op2val:0xaaaaaaab
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x1, 0xaaaaaaab, x14, 616, x1)

inst_685:
// rs1_val==1 and rs2_val==6, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x1;  op2val:0x6
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x1, 0x6, x14, 620, x1)

inst_686:
// rs1_val==1 and rs2_val==858993460, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x1;  op2val:0x33333334
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x1, 0x33333334, x14, 624, x1)

inst_687:
// rs1_val==1 and rs2_val==1717986919, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x1;  op2val:0x66666667
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x1, 0x66666667, x14, 628, x1)

inst_688:
// rs1_val==1 and rs2_val==46341, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x1;  op2val:0xb505
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x1, 0xb505, x14, 632, x1)

inst_689:
// rs1_val==1 and rs2_val==65536, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x1;  op2val:0x10000
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x1, 0x10000, x14, 636, x1)

inst_690:
// rs1_val==65536 and rs2_val==3, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x10000;  op2val:0x3
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x10000, 0x3, x14, 640, x1)

inst_691:
// rs1_val==65536 and rs2_val==1431655765, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x10000;  op2val:0x55555555
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x10000, 0x55555555, x14, 644, x1)

inst_692:
// rs1_val==65536 and rs2_val==2863311530, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x10000;  op2val:0xaaaaaaaa
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x10000, 0xaaaaaaaa, x14, 648, x1)

inst_693:
// rs1_val==65536 and rs2_val==858993459, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x10000;  op2val:0x33333333
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x10000, 0x33333333, x14, 652, x1)

inst_694:
// rs1_val==65536 and rs2_val==1717986918, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x10000;  op2val:0x66666666
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x10000, 0x66666666, x14, 656, x1)

inst_695:
// rs1_val==65536 and rs2_val==46340, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x10000;  op2val:0xb504
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x10000, 0xb504, x14, 660, x1)

inst_696:
// rs1_val==65536 and rs2_val==0, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x10000;  op2val:0x0
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x10000, 0x0, x14, 664, x1)

inst_697:
// rs1_val==65536 and rs2_val==65535, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x10000;  op2val:0xffff
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x10000, 0xffff, x14, 668, x1)

inst_698:
// rs1_val==65536 and rs2_val==2, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x10000;  op2val:0x2
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x10000, 0x2, x14, 672, x1)

inst_699:
// rs1_val==65536 and rs2_val==1431655764, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x10000;  op2val:0x55555554
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x10000, 0x55555554, x14, 676, x1)

inst_700:
// rs1_val==65536 and rs2_val==2863311529, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x10000;  op2val:0xaaaaaaa9
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x10000, 0xaaaaaaa9, x14, 680, x1)

inst_701:
// rs1_val==65536 and rs2_val==4, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x10000;  op2val:0x4
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x10000, 0x4, x14, 684, x1)

inst_702:
// rs1_val==65536 and rs2_val==858993458, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x10000;  op2val:0x33333332
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x10000, 0x33333332, x14, 688, x1)

inst_703:
// rs1_val==65536 and rs2_val==1717986917, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x10000;  op2val:0x66666665
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x10000, 0x66666665, x14, 692, x1)

inst_704:
// rs1_val==65536 and rs2_val==46339, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x10000;  op2val:0xb503
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x10000, 0xb503, x14, 696, x1)

inst_705:
// rs1_val==65536 and rs2_val==65534, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x10000;  op2val:0xfffe
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x10000, 0xfffe, x14, 700, x1)

inst_706:
// rs1_val==65536 and rs2_val==1431655766, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x10000;  op2val:0x55555556
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x10000, 0x55555556, x14, 704, x1)

inst_707:
// rs1_val==65536 and rs2_val==2863311531, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x10000;  op2val:0xaaaaaaab
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x10000, 0xaaaaaaab, x14, 708, x1)

inst_708:
// rs1_val==65536 and rs2_val==6, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x10000;  op2val:0x6
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x10000, 0x6, x14, 712, x1)

inst_709:
// rs1_val==65536 and rs2_val==858993460, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x10000;  op2val:0x33333334
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x10000, 0x33333334, x14, 716, x1)

inst_710:
// rs1_val==65536 and rs2_val==1717986919, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x10000;  op2val:0x66666667
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x10000, 0x66666667, x14, 720, x1)

inst_711:
// rs1_val==65536 and rs2_val==46341, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x10000;  op2val:0xb505
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x10000, 0xb505, x14, 724, x1)

inst_712:
// rs1_val==65536 and rs2_val==1, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x10000;  op2val:0x1
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x10000, 0x1, x14, 728, x1)

inst_713:
// rs1_val==65536 and rs2_val==65536, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x10000;  op2val:0x10000
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x10000, 0x10000, x14, 732, x1)

inst_714:
// rs1_val==1717986917 and rs2_val==6, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x6
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x66666665, 0x6, x14, 736, x1)

inst_715:
// rs1_val==1717986917 and rs2_val==858993460, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x33333334
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x66666665, 0x33333334, x14, 740, x1)

inst_716:
// rs1_val==1717986917 and rs2_val==1717986919, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x66666667
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x66666665, 0x66666667, x14, 744, x1)

inst_717:
// rs1_val==1717986917 and rs2_val==46341, 
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0xb505
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x66666665, 0xb505, x14, 748, x1)

inst_718:
// rs1_val > 0 and rs2_val > 0, rs2_val == 4294967294, rs1_val != rs2_val and rs1_val > 0 and rs2_val > 0, rs1_val == 2048
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x800;  op2val:0xfffffffe
TEST_RR_OP(sltu, x12, x10, x11, 0x1, 0x800, 0xfffffffe, x14, 752, x1)

inst_719:
// rs1_val == rs2_val and rs1_val > 0 and rs2_val > 0, rs2_val == 1048576, rs1_val == 1048576
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x100000;  op2val:0x100000
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x100000, 0x100000, x14, 756, x1)

inst_720:
// rs2_val == 2, rs1_val==4 and rs2_val==2, rs1_val == 4
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x2
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0x4, 0x2, x14, 760, x1)

inst_721:
// rs2_val == 65536, rs1_val == 3758096383
// opcode: sltu ; op1:x10; op2:x11; dest:x12; op1val:0xdfffffff;  op2val:0x10000
TEST_RR_OP(sltu, x12, x10, x11, 0x0, 0xdfffffff, 0x10000, x14, 764, x1)
#endif


RVTEST_CODE_END
RVMODEL_HALT

RVTEST_DATA_BEGIN
.align 4

rvtest_data:
.word 0xbabecafe
.word 0xbabecafe
.word 0xbabecafe
.word 0xbabecafe
RVTEST_DATA_END


RVMODEL_DATA_BEGIN
rvtest_sig_begin:
sig_begin_canary:
CANARY;


signature_x9_0:
    .fill 0*(XLEN/32),4,0xdeadbeef


signature_x9_1:
    .fill 18*(XLEN/32),4,0xdeadbeef


signature_x14_0:
    .fill 512*(XLEN/32),4,0xdeadbeef


signature_x14_1:
    .fill 192*(XLEN/32),4,0xdeadbeef

#ifdef rvtest_mtrap_routine

tsig_begin_canary:
CANARY;
mtrap_sigptr:
    .fill 64*(XLEN/32),4,0xdeadbeef
tsig_end_canary:
CANARY;

#endif

#ifdef rvtest_gpr_save

gpr_save:
    .fill 32*(XLEN/32),4,0xdeadbeef

#endif

sig_end_canary:
CANARY;
rvtest_sig_end:
RVMODEL_DATA_END
