
// -----------
// This file was generated by riscv_ctg (https://gitlab.com/incoresemi/riscv-compliance/riscv_ctg)
// version   : 0.4.1
// timestamp : Tue Dec 15 15:36:11 2020 GMT
// usage     : riscv_ctg \
//                  -- cgf ('/scratch/git-repo/incoresemi/riscv-compliance/riscv_ctg/sample_cgfs/dataset.cgf', '/scratch/git-repo/incoresemi/riscv-compliance/riscv_ctg/sample_cgfs/rv32i.cgf') \
//                  -- xlen 32 \
// -----------
//
// -----------
// Copyright (c) 2020. RISC-V International. All rights reserved.
// SPDX-License-Identifier: BSD-3-Clause
// -----------
//
// This assembly file tests the sub instruction of the RISC-V I extension for the sub covergroup.
// 
#include "model_test.h"
#include "arch_test.h"
RVTEST_ISA("RV32I")

.section .text.init
.org 0x80
.globl rvtest_entry_point
rvtest_entry_point:
RVMODEL_BOOT
RVTEST_CODE_BEGIN

#ifdef TEST_CASE_1

RVTEST_CASE(0,"//check ISA:=regex(.*32.*);check ISA:=regex(.*I.*);def TEST_CASE_1=True;",sub)

RVTEST_SIGBASE( x1,signature_x1_1)

inst_0:
// rs2 == rd != rs1, rs1==x24, rs2==x26, rd==x26, rs1_val > 0 and rs2_val > 0, rs1_val != rs2_val, rs1_val==1431655764 and rs2_val==6
// opcode: sub ; op1:x24; op2:x26; dest:x26; op1val:0x55555554;  op2val:0x6
TEST_RR_OP(sub, x26, x24, x26, 0x5555554e, 0x55555554, 0x6, x1, 0, x2)

inst_1:
// rs1 == rs2 != rd, rs1==x17, rs2==x17, rd==x23, rs1_val > 0 and rs2_val < 0, rs1_val == 33554432
// opcode: sub ; op1:x17; op2:x17; dest:x23; op1val:0x2000000;  op2val:0x2000000
TEST_RR_OP(sub, x23, x17, x17, 0x0, 0x2000000, 0x2000000, x1, 4, x2)

inst_2:
// rs1 == rs2 == rd, rs1==x16, rs2==x16, rd==x16, rs1_val < 0 and rs2_val < 0, rs2_val == -129
// opcode: sub ; op1:x16; op2:x16; dest:x16; op1val:-0x7;  op2val:-0x7
TEST_RR_OP(sub, x16, x16, x16, 0x0, -0x7, -0x7, x1, 8, x2)

inst_3:
// rs1 == rd != rs2, rs1==x31, rs2==x19, rd==x31, rs1_val < 0 and rs2_val > 0, rs1_val == -3
// opcode: sub ; op1:x31; op2:x19; dest:x31; op1val:-0x3;  op2val:0x66666665
TEST_RR_OP(sub, x31, x31, x19, 0x99999998, -0x3, 0x66666665, x1, 12, x2)

inst_4:
// rs1 != rs2  and rs1 != rd and rs2 != rd, rs1==x23, rs2==x14, rd==x8, rs1_val == rs2_val, rs2_val == 524288, rs1_val == 524288
// opcode: sub ; op1:x23; op2:x14; dest:x8; op1val:0x80000;  op2val:0x80000
TEST_RR_OP(sub, x8, x23, x14, 0x0, 0x80000, 0x80000, x1, 16, x2)

inst_5:
// rs1==x13, rs2==x24, rd==x18, rs2_val == (-2**(xlen-1)), rs1_val == -67108865, rs2_val == -2147483648
// opcode: sub ; op1:x13; op2:x24; dest:x18; op1val:-0x4000001;  op2val:-0x80000000
TEST_RR_OP(sub, x18, x13, x24, 0x7bffffff, -0x4000001, -0x80000000, x1, 20, x2)

inst_6:
// rs1==x12, rs2==x4, rd==x0, rs2_val == 0, rs1_val == 32
// opcode: sub ; op1:x12; op2:x4; dest:x0; op1val:0x20;  op2val:0x0
TEST_RR_OP(sub, x0, x12, x4, 0, 0x20, 0x0, x1, 24, x2)

inst_7:
// rs1==x22, rs2==x9, rd==x10, rs2_val == (2**(xlen-1)-1), rs1_val == -536870913, rs2_val == 2147483647
// opcode: sub ; op1:x22; op2:x9; dest:x10; op1val:-0x20000001;  op2val:0x7fffffff
TEST_RR_OP(sub, x10, x22, x9, 0x60000000, -0x20000001, 0x7fffffff, x1, 28, x2)

inst_8:
// rs1==x10, rs2==x27, rd==x25, rs2_val == 1, rs1_val == 65536
// opcode: sub ; op1:x10; op2:x27; dest:x25; op1val:0x10000;  op2val:0x1
TEST_RR_OP(sub, x25, x10, x27, 0xffff, 0x10000, 0x1, x1, 32, x2)

inst_9:
// rs1==x8, rs2==x3, rd==x14, rs1_val == (-2**(xlen-1)), rs1_val == -2147483648
// opcode: sub ; op1:x8; op2:x3; dest:x14; op1val:-0x80000000;  op2val:-0x40000000
TEST_RR_OP(sub, x14, x8, x3, 0xc0000000, -0x80000000, -0x40000000, x1, 36, x2)

inst_10:
// rs1==x25, rs2==x30, rd==x29, rs1_val == 0, rs2_val == 2097152
// opcode: sub ; op1:x25; op2:x30; dest:x29; op1val:0x0;  op2val:0x200000
TEST_RR_OP(sub, x29, x25, x30, 0xffe00000, 0x0, 0x200000, x1, 40, x2)

inst_11:
// rs1==x18, rs2==x8, rd==x15, rs1_val == (2**(xlen-1)-1), rs2_val == 8192, rs1_val == 2147483647
// opcode: sub ; op1:x18; op2:x8; dest:x15; op1val:0x7fffffff;  op2val:0x2000
TEST_RR_OP(sub, x15, x18, x8, 0x7fffdfff, 0x7fffffff, 0x2000, x1, 44, x2)

inst_12:
// rs1==x14, rs2==x15, rd==x3, rs1_val == 1, rs2_val == 16
// opcode: sub ; op1:x14; op2:x15; dest:x3; op1val:0x1;  op2val:0x10
TEST_RR_OP(sub, x3, x14, x15, 0xfffffff1, 0x1, 0x10, x1, 48, x2)

inst_13:
// rs1==x26, rs2==x29, rd==x13, rs2_val == 2, 
// opcode: sub ; op1:x26; op2:x29; dest:x13; op1val:-0x7;  op2val:0x2
TEST_RR_OP(sub, x13, x26, x29, 0xfffffff7, -0x7, 0x2, x1, 52, x2)

inst_14:
// rs1==x21, rs2==x31, rd==x19, rs2_val == 4, rs1_val==2 and rs2_val==4, rs1_val == 2
// opcode: sub ; op1:x21; op2:x31; dest:x19; op1val:0x2;  op2val:0x4
TEST_RR_OP(sub, x19, x21, x31, 0xfffffffe, 0x2, 0x4, x1, 56, x2)

inst_15:
// rs1==x30, rs2==x5, rd==x11, rs2_val == 8, rs1_val == -16777217
// opcode: sub ; op1:x30; op2:x5; dest:x11; op1val:-0x1000001;  op2val:0x8
TEST_RR_OP(sub, x11, x30, x5, 0xfefffff7, -0x1000001, 0x8, x1, 60, x2)

inst_16:
// rs1==x28, rs2==x7, rd==x30, rs2_val == 32, rs1_val == -1431655766
// opcode: sub ; op1:x28; op2:x7; dest:x30; op1val:-0x55555556;  op2val:0x20
TEST_RR_OP(sub, x30, x28, x7, 0xaaaaaa8a, -0x55555556, 0x20, x1, 64, x2)

inst_17:
// rs1==x9, rs2==x10, rd==x7, rs2_val == 64, rs1_val == -65
// opcode: sub ; op1:x9; op2:x10; dest:x7; op1val:-0x41;  op2val:0x40
TEST_RR_OP(sub, x7, x9, x10, 0xffffff7f, -0x41, 0x40, x1, 68, x14)

inst_18:
// rs1==x0, rs2==x18, rd==x17, rs2_val == 128, 
// opcode: sub ; op1:x0; op2:x18; dest:x17; op1val:0x0;  op2val:0x80
TEST_RR_OP(sub, x17, x0, x18, 0xffffff80, 0x0, 0x80, x1, 72, x14)

inst_19:
// rs1==x2, rs2==x12, rd==x27, rs2_val == 256, 
// opcode: sub ; op1:x2; op2:x12; dest:x27; op1val:-0x40000000;  op2val:0x100
TEST_RR_OP(sub, x27, x2, x12, 0xbfffff00, -0x40000000, 0x100, x1, 76, x14)
RVTEST_SIGBASE( x8,signature_x8_0)

inst_20:
// rs1==x4, rs2==x28, rd==x20, rs2_val == 512, 
// opcode: sub ; op1:x4; op2:x28; dest:x20; op1val:-0xb503;  op2val:0x200
TEST_RR_OP(sub, x20, x4, x28, 0xffff48fd, -0xb503, 0x200, x8, 0, x14)

inst_21:
// rs1==x15, rs2==x1, rd==x6, rs2_val == 1024, 
// opcode: sub ; op1:x15; op2:x1; dest:x6; op1val:0x0;  op2val:0x400
TEST_RR_OP(sub, x6, x15, x1, 0xfffffc00, 0x0, 0x400, x8, 4, x14)

inst_22:
// rs1==x5, rs2==x0, rd==x9, rs2_val == 2048, 
// opcode: sub ; op1:x5; op2:x0; dest:x9; op1val:-0x80000000;  op2val:0x0
TEST_RR_OP(sub, x9, x5, x0, 0x80000000, -0x80000000, 0x0, x8, 8, x14)

inst_23:
// rs1==x7, rs2==x11, rd==x4, rs2_val == 4096, rs1_val == 131072
// opcode: sub ; op1:x7; op2:x11; dest:x4; op1val:0x20000;  op2val:0x1000
TEST_RR_OP(sub, x4, x7, x11, 0x1f000, 0x20000, 0x1000, x8, 12, x14)

inst_24:
// rs1==x19, rs2==x6, rd==x1, rs2_val == 16384, rs1_val == -268435457
// opcode: sub ; op1:x19; op2:x6; dest:x1; op1val:-0x10000001;  op2val:0x4000
TEST_RR_OP(sub, x1, x19, x6, 0xefffbfff, -0x10000001, 0x4000, x8, 16, x14)

inst_25:
// rs1==x6, rs2==x20, rd==x5, rs2_val == 32768, 
// opcode: sub ; op1:x6; op2:x20; dest:x5; op1val:0x7fffffff;  op2val:0x8000
TEST_RR_OP(sub, x5, x6, x20, 0x7fff7fff, 0x7fffffff, 0x8000, x8, 20, x14)

inst_26:
// rs1==x29, rs2==x22, rd==x2, rs2_val == 65536, 
// opcode: sub ; op1:x29; op2:x22; dest:x2; op1val:-0xb503;  op2val:0x10000
TEST_RR_OP(sub, x2, x29, x22, 0xfffe4afd, -0xb503, 0x10000, x8, 24, x14)

inst_27:
// rs1==x3, rs2==x13, rd==x21, rs2_val == 131072, rs1_val == -8388609
// opcode: sub ; op1:x3; op2:x13; dest:x21; op1val:-0x800001;  op2val:0x20000
TEST_RR_OP(sub, x21, x3, x13, 0xff7dffff, -0x800001, 0x20000, x8, 28, x14)

inst_28:
// rs1==x1, rs2==x21, rd==x28, rs2_val == 262144, rs1_val == 256
// opcode: sub ; op1:x1; op2:x21; dest:x28; op1val:0x100;  op2val:0x40000
TEST_RR_OP(sub, x28, x1, x21, 0xfffc0100, 0x100, 0x40000, x8, 32, x14)

inst_29:
// rs1==x20, rs2==x23, rd==x12, rs2_val == 1048576, 
// opcode: sub ; op1:x20; op2:x23; dest:x12; op1val:0x100;  op2val:0x100000
TEST_RR_OP(sub, x12, x20, x23, 0xfff00100, 0x100, 0x100000, x8, 36, x14)

inst_30:
// rs1==x27, rs2==x25, rd==x22, rs2_val == 4194304, 
// opcode: sub ; op1:x27; op2:x25; dest:x22; op1val:-0x4;  op2val:0x400000
TEST_RR_OP(sub, x22, x27, x25, 0xffbffffc, -0x4, 0x400000, x8, 40, x14)

inst_31:
// rs1==x11, rs2==x2, rd==x24, rs2_val == 8388608, 
// opcode: sub ; op1:x11; op2:x2; dest:x24; op1val:0x66666665;  op2val:0x800000
TEST_RR_OP(sub, x24, x11, x2, 0x65e66665, 0x66666665, 0x800000, x8, 44, x14)

inst_32:
// rs2_val == 16777216, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x3fffffff;  op2val:0x1000000
TEST_RR_OP(sub, x12, x10, x11, 0x3effffff, 0x3fffffff, 0x1000000, x8, 48, x14)

inst_33:
// rs2_val == 33554432, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x2000000
TEST_RR_OP(sub, x12, x10, x11, 0xfdff4afc, -0xb504, 0x2000000, x8, 52, x14)

inst_34:
// rs2_val == 67108864, rs1_val == -32769
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x8001;  op2val:0x4000000
TEST_RR_OP(sub, x12, x10, x11, 0xfbff7fff, -0x8001, 0x4000000, x8, 56, x14)

inst_35:
// rs2_val == 134217728, rs1_val == 4
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x8000000
TEST_RR_OP(sub, x12, x10, x11, 0xf8000004, 0x4, 0x8000000, x8, 60, x14)

inst_36:
// rs2_val == 268435456, rs1_val == -4097
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x1001;  op2val:0x10000000
TEST_RR_OP(sub, x12, x10, x11, 0xefffefff, -0x1001, 0x10000000, x8, 64, x14)

inst_37:
// rs2_val == 536870912, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x1001;  op2val:0x20000000
TEST_RR_OP(sub, x12, x10, x11, 0xdfffefff, -0x1001, 0x20000000, x8, 68, x14)

inst_38:
// rs2_val == 1073741824, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x80000;  op2val:0x40000000
TEST_RR_OP(sub, x12, x10, x11, 0xc0080000, 0x80000, 0x40000000, x8, 72, x14)

inst_39:
// rs2_val == -2, rs1_val == 1431655765
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:-0x2
TEST_RR_OP(sub, x12, x10, x11, 0x55555557, 0x55555555, -0x2, x8, 76, x14)

inst_40:
// rs2_val == -3, rs1_val == -65537
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x10001;  op2val:-0x3
TEST_RR_OP(sub, x12, x10, x11, 0xffff0002, -0x10001, -0x3, x8, 80, x14)

inst_41:
// rs2_val == -5, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x100;  op2val:-0x5
TEST_RR_OP(sub, x12, x10, x11, 0x105, 0x100, -0x5, x8, 84, x14)

inst_42:
// rs2_val == -9, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x2000000;  op2val:-0x9
TEST_RR_OP(sub, x12, x10, x11, 0x2000009, 0x2000000, -0x9, x8, 88, x14)

inst_43:
// rs2_val == -17, rs1_val == 268435456
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x10000000;  op2val:-0x11
TEST_RR_OP(sub, x12, x10, x11, 0x10000011, 0x10000000, -0x11, x8, 92, x14)

inst_44:
// rs2_val == -33, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:-0x21
TEST_RR_OP(sub, x12, x10, x11, 0x23, 0x2, -0x21, x8, 96, x14)

inst_45:
// rs2_val == -65, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:-0x41
TEST_RR_OP(sub, x12, x10, x11, 0xaaaaaaeb, -0x55555556, -0x41, x8, 100, x14)

inst_46:
// rs2_val == -257, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:-0x101
TEST_RR_OP(sub, x12, x10, x11, 0xb606, 0xb505, -0x101, x8, 104, x14)

inst_47:
// rs2_val == -513, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:-0x201
TEST_RR_OP(sub, x12, x10, x11, 0xb706, 0xb505, -0x201, x8, 108, x14)

inst_48:
// rs2_val == -1025, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x3fffffff;  op2val:-0x401
TEST_RR_OP(sub, x12, x10, x11, 0x40000400, 0x3fffffff, -0x401, x8, 112, x14)

inst_49:
// rs2_val == -2049, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:-0x801
TEST_RR_OP(sub, x12, x10, x11, 0xffff52fd, -0xb504, -0x801, x8, 116, x14)

inst_50:
// rs2_val == -4097, rs1_val == -33
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x21;  op2val:-0x1001
TEST_RR_OP(sub, x12, x10, x11, 0xfe0, -0x21, -0x1001, x8, 120, x14)

inst_51:
// rs2_val == -8193, rs1_val == -1025
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x401;  op2val:-0x2001
TEST_RR_OP(sub, x12, x10, x11, 0x1c00, -0x401, -0x2001, x8, 124, x14)

inst_52:
// rs2_val == -16385, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x10001;  op2val:-0x4001
TEST_RR_OP(sub, x12, x10, x11, 0xffff4000, -0x10001, -0x4001, x8, 128, x14)

inst_53:
// rs2_val == -32769, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:-0x8001
TEST_RR_OP(sub, x12, x10, x11, 0x8003, 0x2, -0x8001, x8, 132, x14)

inst_54:
// rs2_val == -65537, rs1_val == -2049
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x801;  op2val:-0x10001
TEST_RR_OP(sub, x12, x10, x11, 0xf800, -0x801, -0x10001, x8, 136, x14)

inst_55:
// rs2_val == -131073, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x800001;  op2val:-0x20001
TEST_RR_OP(sub, x12, x10, x11, 0xff820000, -0x800001, -0x20001, x8, 140, x14)

inst_56:
// rs2_val == -262145, rs1_val == -257
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x101;  op2val:-0x40001
TEST_RR_OP(sub, x12, x10, x11, 0x3ff00, -0x101, -0x40001, x8, 144, x14)

inst_57:
// rs2_val == -524289, rs1_val == -134217729
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x8000001;  op2val:-0x80001
TEST_RR_OP(sub, x12, x10, x11, 0xf8080000, -0x8000001, -0x80001, x8, 148, x14)

inst_58:
// rs2_val == -1048577, rs1_val == -4194305
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x400001;  op2val:-0x100001
TEST_RR_OP(sub, x12, x10, x11, 0xffd00000, -0x400001, -0x100001, x8, 152, x14)

inst_59:
// rs2_val == -2097153, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x3;  op2val:-0x200001
TEST_RR_OP(sub, x12, x10, x11, 0x1ffffe, -0x3, -0x200001, x8, 156, x14)

inst_60:
// rs2_val == -4194305, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x8000001;  op2val:-0x400001
TEST_RR_OP(sub, x12, x10, x11, 0xf8400000, -0x8000001, -0x400001, x8, 160, x14)

inst_61:
// rs2_val == -8388609, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x8000001;  op2val:-0x800001
TEST_RR_OP(sub, x12, x10, x11, 0xf8800000, -0x8000001, -0x800001, x8, 164, x14)

inst_62:
// rs2_val == -16777217, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:-0x1000001
TEST_RR_OP(sub, x12, x10, x11, 0x34333335, 0x33333334, -0x1000001, x8, 168, x14)

inst_63:
// rs2_val == -33554433, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:-0x2000001
TEST_RR_OP(sub, x12, x10, x11, 0x57555556, 0x55555555, -0x2000001, x8, 172, x14)

inst_64:
// rs2_val == -67108865, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:-0x4000001
TEST_RR_OP(sub, x12, x10, x11, 0x4000004, 0x3, -0x4000001, x8, 176, x14)

inst_65:
// rs2_val == -134217729, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:-0x8000001
TEST_RR_OP(sub, x12, x10, x11, 0x3b333335, 0x33333334, -0x8000001, x8, 180, x14)

inst_66:
// rs2_val == -268435457, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:-0x10000001
TEST_RR_OP(sub, x12, x10, x11, 0x1000b504, 0xb503, -0x10000001, x8, 184, x14)

inst_67:
// rs2_val == -536870913, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:-0x20000001
TEST_RR_OP(sub, x12, x10, x11, 0x20000005, 0x4, -0x20000001, x8, 188, x14)

inst_68:
// rs2_val == -1073741825, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:-0x40000001
TEST_RR_OP(sub, x12, x10, x11, 0x40000001, 0x0, -0x40000001, x8, 192, x14)

inst_69:
// rs2_val == 1431655765, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x100;  op2val:0x55555555
TEST_RR_OP(sub, x12, x10, x11, 0xaaaaabab, 0x100, 0x55555555, x8, 196, x14)

inst_70:
// rs2_val == -1431655766, rs1_val == 262144
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x40000;  op2val:-0x55555556
TEST_RR_OP(sub, x12, x10, x11, 0x55595556, 0x40000, -0x55555556, x8, 200, x14)

inst_71:
// rs1_val == 8, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x8;  op2val:-0x1001
TEST_RR_OP(sub, x12, x10, x11, 0x1009, 0x8, -0x1001, x8, 204, x14)

inst_72:
// rs1_val == 16, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x10;  op2val:-0x40001
TEST_RR_OP(sub, x12, x10, x11, 0x40011, 0x10, -0x40001, x8, 208, x14)

inst_73:
// rs1_val == 64, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x40;  op2val:-0x55555556
TEST_RR_OP(sub, x12, x10, x11, 0x55555596, 0x40, -0x55555556, x8, 212, x14)

inst_74:
// rs1_val == 128, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x80;  op2val:-0x2001
TEST_RR_OP(sub, x12, x10, x11, 0x2081, 0x80, -0x2001, x8, 216, x14)

inst_75:
// rs1_val == 512, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x200;  op2val:-0x8001
TEST_RR_OP(sub, x12, x10, x11, 0x8201, 0x200, -0x8001, x8, 220, x14)

inst_76:
// rs1_val == 1024, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x400;  op2val:0x3
TEST_RR_OP(sub, x12, x10, x11, 0x3fd, 0x400, 0x3, x8, 224, x14)

inst_77:
// rs1_val == 2048, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x800;  op2val:-0x200001
TEST_RR_OP(sub, x12, x10, x11, 0x200801, 0x800, -0x200001, x8, 228, x14)

inst_78:
// rs1_val == 4096, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x1000;  op2val:0x10
TEST_RR_OP(sub, x12, x10, x11, 0xff0, 0x1000, 0x10, x8, 232, x14)

inst_79:
// rs1_val == 8192, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x2000;  op2val:0x800000
TEST_RR_OP(sub, x12, x10, x11, 0xff802000, 0x2000, 0x800000, x8, 236, x14)

inst_80:
// rs1_val == 16384, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x4000;  op2val:0x20000
TEST_RR_OP(sub, x12, x10, x11, 0xfffe4000, 0x4000, 0x20000, x8, 240, x14)

inst_81:
// rs1_val == 32768, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x8000;  op2val:-0x1
TEST_RR_OP(sub, x12, x10, x11, 0x8001, 0x8000, -0x1, x8, 244, x14)

inst_82:
// rs1_val == 1048576, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x100000;  op2val:0x8
TEST_RR_OP(sub, x12, x10, x11, 0xffff8, 0x100000, 0x8, x8, 248, x14)

inst_83:
// rs1_val == 2097152, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x200000;  op2val:-0x11
TEST_RR_OP(sub, x12, x10, x11, 0x200011, 0x200000, -0x11, x8, 252, x14)

inst_84:
// rs1_val == 4194304, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x400000;  op2val:0x55555555
TEST_RR_OP(sub, x12, x10, x11, 0xaaeaaaab, 0x400000, 0x55555555, x8, 256, x14)

inst_85:
// rs1_val == 8388608, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x800000;  op2val:-0x21
TEST_RR_OP(sub, x12, x10, x11, 0x800021, 0x800000, -0x21, x8, 260, x14)

inst_86:
// rs1_val == 16777216, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x1000000;  op2val:-0x20001
TEST_RR_OP(sub, x12, x10, x11, 0x1020001, 0x1000000, -0x20001, x8, 264, x14)

inst_87:
// rs1_val == 67108864, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x4000000;  op2val:0x6
TEST_RR_OP(sub, x12, x10, x11, 0x3fffffa, 0x4000000, 0x6, x8, 268, x14)

inst_88:
// rs1_val == 134217728, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x8000000;  op2val:0x8
TEST_RR_OP(sub, x12, x10, x11, 0x7fffff8, 0x8000000, 0x8, x8, 272, x14)

inst_89:
// rs1_val == 536870912, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x20000000;  op2val:-0x1000001
TEST_RR_OP(sub, x12, x10, x11, 0x21000001, 0x20000000, -0x1000001, x8, 276, x14)

inst_90:
// rs1_val == 1073741824, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x40000000;  op2val:0x3
TEST_RR_OP(sub, x12, x10, x11, 0x3ffffffd, 0x40000000, 0x3, x8, 280, x14)

inst_91:
// rs1_val == -2, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x2;  op2val:0x33333333
TEST_RR_OP(sub, x12, x10, x11, 0xcccccccb, -0x2, 0x33333333, x8, 284, x14)

inst_92:
// rs1_val == -5, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x5;  op2val:0x5
TEST_RR_OP(sub, x12, x10, x11, 0xfffffff6, -0x5, 0x5, x8, 288, x14)

inst_93:
// rs1_val == -9, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x9;  op2val:0x0
TEST_RR_OP(sub, x12, x10, x11, 0xfffffff7, -0x9, 0x0, x8, 292, x14)

inst_94:
// rs1_val == -17, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x11;  op2val:-0x20001
TEST_RR_OP(sub, x12, x10, x11, 0x1fff0, -0x11, -0x20001, x8, 296, x14)

inst_95:
// rs1_val == -129, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x81;  op2val:0x400
TEST_RR_OP(sub, x12, x10, x11, 0xfffffb7f, -0x81, 0x400, x8, 300, x14)

inst_96:
// rs1_val == -513, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x201;  op2val:0x800000
TEST_RR_OP(sub, x12, x10, x11, 0xff7ffdff, -0x201, 0x800000, x8, 304, x14)

inst_97:
// rs1_val == -8193, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x2001;  op2val:-0x2
TEST_RR_OP(sub, x12, x10, x11, 0xffffe001, -0x2001, -0x2, x8, 308, x14)

inst_98:
// rs1_val == -16385, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x4001;  op2val:-0xb504
TEST_RR_OP(sub, x12, x10, x11, 0x7503, -0x4001, -0xb504, x8, 312, x14)

inst_99:
// rs1_val == -131073, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x20001;  op2val:-0x80001
TEST_RR_OP(sub, x12, x10, x11, 0x60000, -0x20001, -0x80001, x8, 316, x14)

inst_100:
// rs1_val == -262145, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x40001;  op2val:0x10
TEST_RR_OP(sub, x12, x10, x11, 0xfffbffef, -0x40001, 0x10, x8, 320, x14)

inst_101:
// rs1_val == -524289, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x80001;  op2val:-0xb504
TEST_RR_OP(sub, x12, x10, x11, 0xfff8b503, -0x80001, -0xb504, x8, 324, x14)

inst_102:
// rs1_val == -1048577, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x100001;  op2val:0x10
TEST_RR_OP(sub, x12, x10, x11, 0xffefffef, -0x100001, 0x10, x8, 328, x14)

inst_103:
// rs1_val == -2097153, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x200001;  op2val:-0x7
TEST_RR_OP(sub, x12, x10, x11, 0xffe00006, -0x200001, -0x7, x8, 332, x14)

inst_104:
// rs1_val == -33554433, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x2000001;  op2val:0x33333332
TEST_RR_OP(sub, x12, x10, x11, 0xcacccccd, -0x2000001, 0x33333332, x8, 336, x14)

inst_105:
// rs1_val == -1073741825, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x40000001;  op2val:0x33333333
TEST_RR_OP(sub, x12, x10, x11, 0x8ccccccc, -0x40000001, 0x33333333, x8, 340, x14)

inst_106:
// rs1_val==3 and rs2_val==3, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x3
TEST_RR_OP(sub, x12, x10, x11, 0x0, 0x3, 0x3, x8, 344, x14)

inst_107:
// rs1_val==3 and rs2_val==1431655765, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x55555555
TEST_RR_OP(sub, x12, x10, x11, 0xaaaaaaae, 0x3, 0x55555555, x8, 348, x14)

inst_108:
// rs1_val==3 and rs2_val==-1431655766, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:-0x55555556
TEST_RR_OP(sub, x12, x10, x11, 0x55555559, 0x3, -0x55555556, x8, 352, x14)

inst_109:
// rs1_val==3 and rs2_val==5, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x5
TEST_RR_OP(sub, x12, x10, x11, 0xfffffffe, 0x3, 0x5, x8, 356, x14)

inst_110:
// rs1_val==3 and rs2_val==858993459, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x33333333
TEST_RR_OP(sub, x12, x10, x11, 0xccccccd0, 0x3, 0x33333333, x8, 360, x14)

inst_111:
// rs1_val==3 and rs2_val==1717986918, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x66666666
TEST_RR_OP(sub, x12, x10, x11, 0x9999999d, 0x3, 0x66666666, x8, 364, x14)

inst_112:
// rs1_val==3 and rs2_val==-46340, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:-0xb504
TEST_RR_OP(sub, x12, x10, x11, 0xb507, 0x3, -0xb504, x8, 368, x14)

inst_113:
// rs1_val==3 and rs2_val==46340, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0xb504
TEST_RR_OP(sub, x12, x10, x11, 0xffff4aff, 0x3, 0xb504, x8, 372, x14)

inst_114:
// rs1_val==3 and rs2_val==2, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x2
TEST_RR_OP(sub, x12, x10, x11, 0x1, 0x3, 0x2, x8, 376, x14)

inst_115:
// rs1_val==3 and rs2_val==1431655764, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x55555554
TEST_RR_OP(sub, x12, x10, x11, 0xaaaaaaaf, 0x3, 0x55555554, x8, 380, x14)

inst_116:
// rs1_val==3 and rs2_val==0, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x0
TEST_RR_OP(sub, x12, x10, x11, 0x3, 0x3, 0x0, x8, 384, x14)

inst_117:
// rs1_val==3 and rs2_val==4, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x4
TEST_RR_OP(sub, x12, x10, x11, 0xffffffff, 0x3, 0x4, x8, 388, x14)

inst_118:
// rs1_val==3 and rs2_val==858993458, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x33333332
TEST_RR_OP(sub, x12, x10, x11, 0xccccccd1, 0x3, 0x33333332, x8, 392, x14)

inst_119:
// rs1_val==3 and rs2_val==1717986917, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x66666665
TEST_RR_OP(sub, x12, x10, x11, 0x9999999e, 0x3, 0x66666665, x8, 396, x14)

inst_120:
// rs1_val==3 and rs2_val==46339, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0xb503
TEST_RR_OP(sub, x12, x10, x11, 0xffff4b00, 0x3, 0xb503, x8, 400, x14)

inst_121:
// rs1_val==3 and rs2_val==1431655766, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x55555556
TEST_RR_OP(sub, x12, x10, x11, 0xaaaaaaad, 0x3, 0x55555556, x8, 404, x14)

inst_122:
// rs1_val==3 and rs2_val==-1431655765, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:-0x55555555
TEST_RR_OP(sub, x12, x10, x11, 0x55555558, 0x3, -0x55555555, x8, 408, x14)

inst_123:
// rs1_val==3 and rs2_val==6, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x6
TEST_RR_OP(sub, x12, x10, x11, 0xfffffffd, 0x3, 0x6, x8, 412, x14)

inst_124:
// rs1_val==3 and rs2_val==858993460, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x33333334
TEST_RR_OP(sub, x12, x10, x11, 0xcccccccf, 0x3, 0x33333334, x8, 416, x14)

inst_125:
// rs1_val==3 and rs2_val==1717986919, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0x66666667
TEST_RR_OP(sub, x12, x10, x11, 0x9999999c, 0x3, 0x66666667, x8, 420, x14)

inst_126:
// rs1_val==3 and rs2_val==-46339, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:-0xb503
TEST_RR_OP(sub, x12, x10, x11, 0xb506, 0x3, -0xb503, x8, 424, x14)

inst_127:
// rs1_val==3 and rs2_val==46341, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x3;  op2val:0xb505
TEST_RR_OP(sub, x12, x10, x11, 0xffff4afe, 0x3, 0xb505, x8, 428, x14)

inst_128:
// rs1_val==1431655765 and rs2_val==3, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x3
TEST_RR_OP(sub, x12, x10, x11, 0x55555552, 0x55555555, 0x3, x8, 432, x14)

inst_129:
// rs1_val==1431655765 and rs2_val==1431655765, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x55555555
TEST_RR_OP(sub, x12, x10, x11, 0x0, 0x55555555, 0x55555555, x8, 436, x14)

inst_130:
// rs1_val==1431655765 and rs2_val==-1431655766, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:-0x55555556
TEST_RR_OP(sub, x12, x10, x11, 0xaaaaaaab, 0x55555555, -0x55555556, x8, 440, x14)

inst_131:
// rs1_val==1431655765 and rs2_val==5, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x5
TEST_RR_OP(sub, x12, x10, x11, 0x55555550, 0x55555555, 0x5, x8, 444, x14)

inst_132:
// rs1_val==1431655765 and rs2_val==858993459, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x33333333
TEST_RR_OP(sub, x12, x10, x11, 0x22222222, 0x55555555, 0x33333333, x8, 448, x14)

inst_133:
// rs1_val==1431655765 and rs2_val==1717986918, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x66666666
TEST_RR_OP(sub, x12, x10, x11, 0xeeeeeeef, 0x55555555, 0x66666666, x8, 452, x14)

inst_134:
// rs1_val==1431655765 and rs2_val==-46340, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:-0xb504
TEST_RR_OP(sub, x12, x10, x11, 0x55560a59, 0x55555555, -0xb504, x8, 456, x14)

inst_135:
// rs1_val==1431655765 and rs2_val==46340, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0xb504
TEST_RR_OP(sub, x12, x10, x11, 0x5554a051, 0x55555555, 0xb504, x8, 460, x14)

inst_136:
// rs1_val==1431655765 and rs2_val==2, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x2
TEST_RR_OP(sub, x12, x10, x11, 0x55555553, 0x55555555, 0x2, x8, 464, x14)

inst_137:
// rs1_val==1431655765 and rs2_val==1431655764, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x55555554
TEST_RR_OP(sub, x12, x10, x11, 0x1, 0x55555555, 0x55555554, x8, 468, x14)

inst_138:
// rs1_val==1431655765 and rs2_val==0, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x0
TEST_RR_OP(sub, x12, x10, x11, 0x55555555, 0x55555555, 0x0, x8, 472, x14)

inst_139:
// rs1_val==1431655765 and rs2_val==4, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x4
TEST_RR_OP(sub, x12, x10, x11, 0x55555551, 0x55555555, 0x4, x8, 476, x14)

inst_140:
// rs1_val==1431655765 and rs2_val==858993458, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x33333332
TEST_RR_OP(sub, x12, x10, x11, 0x22222223, 0x55555555, 0x33333332, x8, 480, x14)

inst_141:
// rs1_val==1431655765 and rs2_val==1717986917, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x66666665
TEST_RR_OP(sub, x12, x10, x11, 0xeeeeeef0, 0x55555555, 0x66666665, x8, 484, x14)

inst_142:
// rs1_val==1431655765 and rs2_val==46339, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0xb503
TEST_RR_OP(sub, x12, x10, x11, 0x5554a052, 0x55555555, 0xb503, x8, 488, x14)

inst_143:
// rs1_val==1431655765 and rs2_val==1431655766, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x55555556
TEST_RR_OP(sub, x12, x10, x11, 0xffffffff, 0x55555555, 0x55555556, x8, 492, x14)

inst_144:
// rs1_val==1431655765 and rs2_val==-1431655765, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:-0x55555555
TEST_RR_OP(sub, x12, x10, x11, 0xaaaaaaaa, 0x55555555, -0x55555555, x8, 496, x14)

inst_145:
// rs1_val==1431655765 and rs2_val==6, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x6
TEST_RR_OP(sub, x12, x10, x11, 0x5555554f, 0x55555555, 0x6, x8, 500, x14)

inst_146:
// rs1_val==1431655765 and rs2_val==858993460, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x33333334
TEST_RR_OP(sub, x12, x10, x11, 0x22222221, 0x55555555, 0x33333334, x8, 504, x14)

inst_147:
// rs1_val==1431655765 and rs2_val==1717986919, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0x66666667
TEST_RR_OP(sub, x12, x10, x11, 0xeeeeeeee, 0x55555555, 0x66666667, x8, 508, x14)

inst_148:
// rs1_val==1431655765 and rs2_val==-46339, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:-0xb503
TEST_RR_OP(sub, x12, x10, x11, 0x55560a58, 0x55555555, -0xb503, x8, 512, x14)

inst_149:
// rs1_val==1431655765 and rs2_val==46341, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x55555555;  op2val:0xb505
TEST_RR_OP(sub, x12, x10, x11, 0x5554a050, 0x55555555, 0xb505, x8, 516, x14)

inst_150:
// rs1_val==-1431655766 and rs2_val==3, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x3
TEST_RR_OP(sub, x12, x10, x11, 0xaaaaaaa7, -0x55555556, 0x3, x8, 520, x14)

inst_151:
// rs1_val==-1431655766 and rs2_val==1431655765, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x55555555
TEST_RR_OP(sub, x12, x10, x11, 0x55555555, -0x55555556, 0x55555555, x8, 524, x14)

inst_152:
// rs1_val==-1431655766 and rs2_val==-1431655766, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:-0x55555556
TEST_RR_OP(sub, x12, x10, x11, 0x0, -0x55555556, -0x55555556, x8, 528, x14)

inst_153:
// rs1_val==-1431655766 and rs2_val==5, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x5
TEST_RR_OP(sub, x12, x10, x11, 0xaaaaaaa5, -0x55555556, 0x5, x8, 532, x14)

inst_154:
// rs1_val==-1431655766 and rs2_val==858993459, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x33333333
TEST_RR_OP(sub, x12, x10, x11, 0x77777777, -0x55555556, 0x33333333, x8, 536, x14)

inst_155:
// rs1_val==-1431655766 and rs2_val==1717986918, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x66666666
TEST_RR_OP(sub, x12, x10, x11, 0x44444444, -0x55555556, 0x66666666, x8, 540, x14)

inst_156:
// rs1_val==-1431655766 and rs2_val==-46340, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:-0xb504
TEST_RR_OP(sub, x12, x10, x11, 0xaaab5fae, -0x55555556, -0xb504, x8, 544, x14)

inst_157:
// rs1_val==-1431655766 and rs2_val==46340, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0xb504
TEST_RR_OP(sub, x12, x10, x11, 0xaaa9f5a6, -0x55555556, 0xb504, x8, 548, x14)

inst_158:
// rs1_val==-1431655766 and rs2_val==2, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x2
TEST_RR_OP(sub, x12, x10, x11, 0xaaaaaaa8, -0x55555556, 0x2, x8, 552, x14)

inst_159:
// rs1_val==-1431655766 and rs2_val==1431655764, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x55555554
TEST_RR_OP(sub, x12, x10, x11, 0x55555556, -0x55555556, 0x55555554, x8, 556, x14)

inst_160:
// rs1_val==-1431655766 and rs2_val==0, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x0
TEST_RR_OP(sub, x12, x10, x11, 0xaaaaaaaa, -0x55555556, 0x0, x8, 560, x14)

inst_161:
// rs1_val==-1431655766 and rs2_val==4, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x4
TEST_RR_OP(sub, x12, x10, x11, 0xaaaaaaa6, -0x55555556, 0x4, x8, 564, x14)

inst_162:
// rs1_val==-1431655766 and rs2_val==858993458, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x33333332
TEST_RR_OP(sub, x12, x10, x11, 0x77777778, -0x55555556, 0x33333332, x8, 568, x14)

inst_163:
// rs1_val==-1431655766 and rs2_val==1717986917, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x66666665
TEST_RR_OP(sub, x12, x10, x11, 0x44444445, -0x55555556, 0x66666665, x8, 572, x14)

inst_164:
// rs1_val==-1431655766 and rs2_val==46339, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0xb503
TEST_RR_OP(sub, x12, x10, x11, 0xaaa9f5a7, -0x55555556, 0xb503, x8, 576, x14)

inst_165:
// rs1_val==-1431655766 and rs2_val==1431655766, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x55555556
TEST_RR_OP(sub, x12, x10, x11, 0x55555554, -0x55555556, 0x55555556, x8, 580, x14)

inst_166:
// rs1_val==-1431655766 and rs2_val==-1431655765, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:-0x55555555
TEST_RR_OP(sub, x12, x10, x11, 0xffffffff, -0x55555556, -0x55555555, x8, 584, x14)

inst_167:
// rs1_val==-1431655766 and rs2_val==6, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x6
TEST_RR_OP(sub, x12, x10, x11, 0xaaaaaaa4, -0x55555556, 0x6, x8, 588, x14)

inst_168:
// rs1_val==-1431655766 and rs2_val==858993460, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x33333334
TEST_RR_OP(sub, x12, x10, x11, 0x77777776, -0x55555556, 0x33333334, x8, 592, x14)

inst_169:
// rs1_val==-1431655766 and rs2_val==1717986919, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0x66666667
TEST_RR_OP(sub, x12, x10, x11, 0x44444443, -0x55555556, 0x66666667, x8, 596, x14)

inst_170:
// rs1_val==-1431655766 and rs2_val==-46339, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:-0xb503
TEST_RR_OP(sub, x12, x10, x11, 0xaaab5fad, -0x55555556, -0xb503, x8, 600, x14)

inst_171:
// rs1_val==-1431655766 and rs2_val==46341, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x55555556;  op2val:0xb505
TEST_RR_OP(sub, x12, x10, x11, 0xaaa9f5a5, -0x55555556, 0xb505, x8, 604, x14)

inst_172:
// rs1_val==5 and rs2_val==3, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x3
TEST_RR_OP(sub, x12, x10, x11, 0x2, 0x5, 0x3, x8, 608, x14)

inst_173:
// rs1_val==5 and rs2_val==1431655765, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x55555555
TEST_RR_OP(sub, x12, x10, x11, 0xaaaaaab0, 0x5, 0x55555555, x8, 612, x14)

inst_174:
// rs1_val==5 and rs2_val==-1431655766, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:-0x55555556
TEST_RR_OP(sub, x12, x10, x11, 0x5555555b, 0x5, -0x55555556, x8, 616, x14)

inst_175:
// rs1_val==5 and rs2_val==5, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x5
TEST_RR_OP(sub, x12, x10, x11, 0x0, 0x5, 0x5, x8, 620, x14)

inst_176:
// rs1_val==5 and rs2_val==858993459, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x33333333
TEST_RR_OP(sub, x12, x10, x11, 0xccccccd2, 0x5, 0x33333333, x8, 624, x14)

inst_177:
// rs1_val==5 and rs2_val==1717986918, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x66666666
TEST_RR_OP(sub, x12, x10, x11, 0x9999999f, 0x5, 0x66666666, x8, 628, x14)

inst_178:
// rs1_val==5 and rs2_val==-46340, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:-0xb504
TEST_RR_OP(sub, x12, x10, x11, 0xb509, 0x5, -0xb504, x8, 632, x14)

inst_179:
// rs1_val==5 and rs2_val==46340, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0xb504
TEST_RR_OP(sub, x12, x10, x11, 0xffff4b01, 0x5, 0xb504, x8, 636, x14)

inst_180:
// rs1_val==5 and rs2_val==2, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x2
TEST_RR_OP(sub, x12, x10, x11, 0x3, 0x5, 0x2, x8, 640, x14)

inst_181:
// rs1_val==5 and rs2_val==1431655764, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x55555554
TEST_RR_OP(sub, x12, x10, x11, 0xaaaaaab1, 0x5, 0x55555554, x8, 644, x14)

inst_182:
// rs1_val==5 and rs2_val==0, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x0
TEST_RR_OP(sub, x12, x10, x11, 0x5, 0x5, 0x0, x8, 648, x14)

inst_183:
// rs1_val==5 and rs2_val==4, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x4
TEST_RR_OP(sub, x12, x10, x11, 0x1, 0x5, 0x4, x8, 652, x14)

inst_184:
// rs1_val==5 and rs2_val==858993458, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x33333332
TEST_RR_OP(sub, x12, x10, x11, 0xccccccd3, 0x5, 0x33333332, x8, 656, x14)

inst_185:
// rs1_val==5 and rs2_val==1717986917, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x66666665
TEST_RR_OP(sub, x12, x10, x11, 0x999999a0, 0x5, 0x66666665, x8, 660, x14)

inst_186:
// rs1_val==5 and rs2_val==46339, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0xb503
TEST_RR_OP(sub, x12, x10, x11, 0xffff4b02, 0x5, 0xb503, x8, 664, x14)

inst_187:
// rs1_val==5 and rs2_val==1431655766, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x55555556
TEST_RR_OP(sub, x12, x10, x11, 0xaaaaaaaf, 0x5, 0x55555556, x8, 668, x14)

inst_188:
// rs1_val==5 and rs2_val==-1431655765, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:-0x55555555
TEST_RR_OP(sub, x12, x10, x11, 0x5555555a, 0x5, -0x55555555, x8, 672, x14)

inst_189:
// rs1_val==5 and rs2_val==6, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x6
TEST_RR_OP(sub, x12, x10, x11, 0xffffffff, 0x5, 0x6, x8, 676, x14)

inst_190:
// rs1_val==5 and rs2_val==858993460, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x33333334
TEST_RR_OP(sub, x12, x10, x11, 0xccccccd1, 0x5, 0x33333334, x8, 680, x14)

inst_191:
// rs1_val==5 and rs2_val==1717986919, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0x66666667
TEST_RR_OP(sub, x12, x10, x11, 0x9999999e, 0x5, 0x66666667, x8, 684, x14)

inst_192:
// rs1_val==5 and rs2_val==-46339, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:-0xb503
TEST_RR_OP(sub, x12, x10, x11, 0xb508, 0x5, -0xb503, x8, 688, x14)

inst_193:
// rs1_val==5 and rs2_val==46341, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x5;  op2val:0xb505
TEST_RR_OP(sub, x12, x10, x11, 0xffff4b00, 0x5, 0xb505, x8, 692, x14)

inst_194:
// rs1_val==858993459 and rs2_val==3, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x3
TEST_RR_OP(sub, x12, x10, x11, 0x33333330, 0x33333333, 0x3, x8, 696, x14)

inst_195:
// rs1_val==858993459 and rs2_val==1431655765, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x55555555
TEST_RR_OP(sub, x12, x10, x11, 0xddddddde, 0x33333333, 0x55555555, x8, 700, x14)

inst_196:
// rs1_val==858993459 and rs2_val==-1431655766, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:-0x55555556
TEST_RR_OP(sub, x12, x10, x11, 0x88888889, 0x33333333, -0x55555556, x8, 704, x14)

inst_197:
// rs1_val==858993459 and rs2_val==5, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x5
TEST_RR_OP(sub, x12, x10, x11, 0x3333332e, 0x33333333, 0x5, x8, 708, x14)

inst_198:
// rs1_val==858993459 and rs2_val==858993459, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x33333333
TEST_RR_OP(sub, x12, x10, x11, 0x0, 0x33333333, 0x33333333, x8, 712, x14)

inst_199:
// rs1_val==858993459 and rs2_val==1717986918, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x66666666
TEST_RR_OP(sub, x12, x10, x11, 0xcccccccd, 0x33333333, 0x66666666, x8, 716, x14)

inst_200:
// rs1_val==858993459 and rs2_val==-46340, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:-0xb504
TEST_RR_OP(sub, x12, x10, x11, 0x3333e837, 0x33333333, -0xb504, x8, 720, x14)

inst_201:
// rs1_val==858993459 and rs2_val==46340, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0xb504
TEST_RR_OP(sub, x12, x10, x11, 0x33327e2f, 0x33333333, 0xb504, x8, 724, x14)

inst_202:
// rs1_val==858993459 and rs2_val==2, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x2
TEST_RR_OP(sub, x12, x10, x11, 0x33333331, 0x33333333, 0x2, x8, 728, x14)

inst_203:
// rs1_val==858993459 and rs2_val==1431655764, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x55555554
TEST_RR_OP(sub, x12, x10, x11, 0xdddddddf, 0x33333333, 0x55555554, x8, 732, x14)

inst_204:
// rs1_val==858993459 and rs2_val==0, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x0
TEST_RR_OP(sub, x12, x10, x11, 0x33333333, 0x33333333, 0x0, x8, 736, x14)

inst_205:
// rs1_val==858993459 and rs2_val==4, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x4
TEST_RR_OP(sub, x12, x10, x11, 0x3333332f, 0x33333333, 0x4, x8, 740, x14)

inst_206:
// rs1_val==858993459 and rs2_val==858993458, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x33333332
TEST_RR_OP(sub, x12, x10, x11, 0x1, 0x33333333, 0x33333332, x8, 744, x14)

inst_207:
// rs1_val==858993459 and rs2_val==1717986917, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x66666665
TEST_RR_OP(sub, x12, x10, x11, 0xccccccce, 0x33333333, 0x66666665, x8, 748, x14)

inst_208:
// rs1_val==858993459 and rs2_val==46339, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0xb503
TEST_RR_OP(sub, x12, x10, x11, 0x33327e30, 0x33333333, 0xb503, x8, 752, x14)

inst_209:
// rs1_val==858993459 and rs2_val==1431655766, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x55555556
TEST_RR_OP(sub, x12, x10, x11, 0xdddddddd, 0x33333333, 0x55555556, x8, 756, x14)

inst_210:
// rs1_val==858993459 and rs2_val==-1431655765, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:-0x55555555
TEST_RR_OP(sub, x12, x10, x11, 0x88888888, 0x33333333, -0x55555555, x8, 760, x14)

inst_211:
// rs1_val==858993459 and rs2_val==6, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x6
TEST_RR_OP(sub, x12, x10, x11, 0x3333332d, 0x33333333, 0x6, x8, 764, x14)

inst_212:
// rs1_val==858993459 and rs2_val==858993460, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x33333334
TEST_RR_OP(sub, x12, x10, x11, 0xffffffff, 0x33333333, 0x33333334, x8, 768, x14)

inst_213:
// rs1_val==858993459 and rs2_val==1717986919, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0x66666667
TEST_RR_OP(sub, x12, x10, x11, 0xcccccccc, 0x33333333, 0x66666667, x8, 772, x14)

inst_214:
// rs1_val==858993459 and rs2_val==-46339, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:-0xb503
TEST_RR_OP(sub, x12, x10, x11, 0x3333e836, 0x33333333, -0xb503, x8, 776, x14)

inst_215:
// rs1_val==858993459 and rs2_val==46341, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x33333333;  op2val:0xb505
TEST_RR_OP(sub, x12, x10, x11, 0x33327e2e, 0x33333333, 0xb505, x8, 780, x14)

inst_216:
// rs1_val==1717986918 and rs2_val==3, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x3
TEST_RR_OP(sub, x12, x10, x11, 0x66666663, 0x66666666, 0x3, x8, 784, x14)

inst_217:
// rs1_val==1717986918 and rs2_val==1431655765, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x55555555
TEST_RR_OP(sub, x12, x10, x11, 0x11111111, 0x66666666, 0x55555555, x8, 788, x14)

inst_218:
// rs1_val==1717986918 and rs2_val==-1431655766, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:-0x55555556
TEST_RR_OP(sub, x12, x10, x11, 0xbbbbbbbc, 0x66666666, -0x55555556, x8, 792, x14)

inst_219:
// rs1_val==1717986918 and rs2_val==5, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x5
TEST_RR_OP(sub, x12, x10, x11, 0x66666661, 0x66666666, 0x5, x8, 796, x14)

inst_220:
// rs1_val==1717986918 and rs2_val==858993459, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x33333333
TEST_RR_OP(sub, x12, x10, x11, 0x33333333, 0x66666666, 0x33333333, x8, 800, x14)

inst_221:
// rs1_val==1717986918 and rs2_val==1717986918, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x66666666
TEST_RR_OP(sub, x12, x10, x11, 0x0, 0x66666666, 0x66666666, x8, 804, x14)

inst_222:
// rs1_val==1717986918 and rs2_val==-46340, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:-0xb504
TEST_RR_OP(sub, x12, x10, x11, 0x66671b6a, 0x66666666, -0xb504, x8, 808, x14)

inst_223:
// rs1_val==1717986918 and rs2_val==46340, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0xb504
TEST_RR_OP(sub, x12, x10, x11, 0x6665b162, 0x66666666, 0xb504, x8, 812, x14)

inst_224:
// rs1_val==1717986918 and rs2_val==2, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x2
TEST_RR_OP(sub, x12, x10, x11, 0x66666664, 0x66666666, 0x2, x8, 816, x14)

inst_225:
// rs1_val==1717986918 and rs2_val==1431655764, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x55555554
TEST_RR_OP(sub, x12, x10, x11, 0x11111112, 0x66666666, 0x55555554, x8, 820, x14)

inst_226:
// rs1_val==1717986918 and rs2_val==0, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x0
TEST_RR_OP(sub, x12, x10, x11, 0x66666666, 0x66666666, 0x0, x8, 824, x14)

inst_227:
// rs1_val==1717986918 and rs2_val==4, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x4
TEST_RR_OP(sub, x12, x10, x11, 0x66666662, 0x66666666, 0x4, x8, 828, x14)

inst_228:
// rs1_val==1717986918 and rs2_val==858993458, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x33333332
TEST_RR_OP(sub, x12, x10, x11, 0x33333334, 0x66666666, 0x33333332, x8, 832, x14)

inst_229:
// rs1_val==1717986918 and rs2_val==1717986917, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x66666665
TEST_RR_OP(sub, x12, x10, x11, 0x1, 0x66666666, 0x66666665, x8, 836, x14)

inst_230:
// rs1_val==1717986918 and rs2_val==46339, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0xb503
TEST_RR_OP(sub, x12, x10, x11, 0x6665b163, 0x66666666, 0xb503, x8, 840, x14)

inst_231:
// rs1_val==1717986918 and rs2_val==1431655766, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x55555556
TEST_RR_OP(sub, x12, x10, x11, 0x11111110, 0x66666666, 0x55555556, x8, 844, x14)

inst_232:
// rs1_val==1717986918 and rs2_val==-1431655765, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:-0x55555555
TEST_RR_OP(sub, x12, x10, x11, 0xbbbbbbbb, 0x66666666, -0x55555555, x8, 848, x14)

inst_233:
// rs1_val==1717986918 and rs2_val==6, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x6
TEST_RR_OP(sub, x12, x10, x11, 0x66666660, 0x66666666, 0x6, x8, 852, x14)

inst_234:
// rs1_val==1717986918 and rs2_val==858993460, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x33333334
TEST_RR_OP(sub, x12, x10, x11, 0x33333332, 0x66666666, 0x33333334, x8, 856, x14)

inst_235:
// rs1_val==1717986918 and rs2_val==1717986919, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0x66666667
TEST_RR_OP(sub, x12, x10, x11, 0xffffffff, 0x66666666, 0x66666667, x8, 860, x14)

inst_236:
// rs1_val==1717986918 and rs2_val==-46339, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:-0xb503
TEST_RR_OP(sub, x12, x10, x11, 0x66671b69, 0x66666666, -0xb503, x8, 864, x14)

inst_237:
// rs1_val==1717986918 and rs2_val==46341, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x66666666;  op2val:0xb505
TEST_RR_OP(sub, x12, x10, x11, 0x6665b161, 0x66666666, 0xb505, x8, 868, x14)

inst_238:
// rs1_val==-46340 and rs2_val==3, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x3
TEST_RR_OP(sub, x12, x10, x11, 0xffff4af9, -0xb504, 0x3, x8, 872, x14)

inst_239:
// rs1_val==-46340 and rs2_val==1431655765, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x55555555
TEST_RR_OP(sub, x12, x10, x11, 0xaaa9f5a7, -0xb504, 0x55555555, x8, 876, x14)

inst_240:
// rs1_val==-46340 and rs2_val==-1431655766, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:-0x55555556
TEST_RR_OP(sub, x12, x10, x11, 0x5554a052, -0xb504, -0x55555556, x8, 880, x14)

inst_241:
// rs1_val==-46340 and rs2_val==5, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x5
TEST_RR_OP(sub, x12, x10, x11, 0xffff4af7, -0xb504, 0x5, x8, 884, x14)

inst_242:
// rs1_val==-46340 and rs2_val==858993459, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x33333333
TEST_RR_OP(sub, x12, x10, x11, 0xcccc17c9, -0xb504, 0x33333333, x8, 888, x14)

inst_243:
// rs1_val==-46340 and rs2_val==1717986918, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x66666666
TEST_RR_OP(sub, x12, x10, x11, 0x9998e496, -0xb504, 0x66666666, x8, 892, x14)

inst_244:
// rs1_val==-46340 and rs2_val==-46340, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:-0xb504
TEST_RR_OP(sub, x12, x10, x11, 0x0, -0xb504, -0xb504, x8, 896, x14)

inst_245:
// rs1_val==-46340 and rs2_val==46340, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0xb504
TEST_RR_OP(sub, x12, x10, x11, 0xfffe95f8, -0xb504, 0xb504, x8, 900, x14)

inst_246:
// rs1_val==-46340 and rs2_val==2, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x2
TEST_RR_OP(sub, x12, x10, x11, 0xffff4afa, -0xb504, 0x2, x8, 904, x14)

inst_247:
// rs1_val==-46340 and rs2_val==1431655764, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x55555554
TEST_RR_OP(sub, x12, x10, x11, 0xaaa9f5a8, -0xb504, 0x55555554, x8, 908, x14)

inst_248:
// rs1_val==-46340 and rs2_val==0, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x0
TEST_RR_OP(sub, x12, x10, x11, 0xffff4afc, -0xb504, 0x0, x8, 912, x14)

inst_249:
// rs1_val==-46340 and rs2_val==4, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x4
TEST_RR_OP(sub, x12, x10, x11, 0xffff4af8, -0xb504, 0x4, x8, 916, x14)

inst_250:
// rs1_val==-46340 and rs2_val==858993458, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x33333332
TEST_RR_OP(sub, x12, x10, x11, 0xcccc17ca, -0xb504, 0x33333332, x8, 920, x14)

inst_251:
// rs1_val==-46340 and rs2_val==1717986917, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x66666665
TEST_RR_OP(sub, x12, x10, x11, 0x9998e497, -0xb504, 0x66666665, x8, 924, x14)

inst_252:
// rs1_val==-46340 and rs2_val==46339, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0xb503
TEST_RR_OP(sub, x12, x10, x11, 0xfffe95f9, -0xb504, 0xb503, x8, 928, x14)

inst_253:
// rs1_val==-46340 and rs2_val==1431655766, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x55555556
TEST_RR_OP(sub, x12, x10, x11, 0xaaa9f5a6, -0xb504, 0x55555556, x8, 932, x14)

inst_254:
// rs1_val==-46340 and rs2_val==-1431655765, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:-0x55555555
TEST_RR_OP(sub, x12, x10, x11, 0x5554a051, -0xb504, -0x55555555, x8, 936, x14)

inst_255:
// rs1_val==-46340 and rs2_val==6, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x6
TEST_RR_OP(sub, x12, x10, x11, 0xffff4af6, -0xb504, 0x6, x8, 940, x14)

inst_256:
// rs1_val==-46340 and rs2_val==858993460, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x33333334
TEST_RR_OP(sub, x12, x10, x11, 0xcccc17c8, -0xb504, 0x33333334, x8, 944, x14)

inst_257:
// rs1_val==-46340 and rs2_val==1717986919, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0x66666667
TEST_RR_OP(sub, x12, x10, x11, 0x9998e495, -0xb504, 0x66666667, x8, 948, x14)

inst_258:
// rs1_val==-46340 and rs2_val==-46339, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:-0xb503
TEST_RR_OP(sub, x12, x10, x11, 0xffffffff, -0xb504, -0xb503, x8, 952, x14)

inst_259:
// rs1_val==-46340 and rs2_val==46341, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0xb504;  op2val:0xb505
TEST_RR_OP(sub, x12, x10, x11, 0xfffe95f7, -0xb504, 0xb505, x8, 956, x14)

inst_260:
// rs1_val==46340 and rs2_val==3, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x3
TEST_RR_OP(sub, x12, x10, x11, 0xb501, 0xb504, 0x3, x8, 960, x14)

inst_261:
// rs1_val==46340 and rs2_val==1431655765, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x55555555
TEST_RR_OP(sub, x12, x10, x11, 0xaaab5faf, 0xb504, 0x55555555, x8, 964, x14)

inst_262:
// rs1_val==46340 and rs2_val==-1431655766, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:-0x55555556
TEST_RR_OP(sub, x12, x10, x11, 0x55560a5a, 0xb504, -0x55555556, x8, 968, x14)

inst_263:
// rs1_val==46340 and rs2_val==5, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x5
TEST_RR_OP(sub, x12, x10, x11, 0xb4ff, 0xb504, 0x5, x8, 972, x14)

inst_264:
// rs1_val==46340 and rs2_val==858993459, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x33333333
TEST_RR_OP(sub, x12, x10, x11, 0xcccd81d1, 0xb504, 0x33333333, x8, 976, x14)

inst_265:
// rs1_val==46340 and rs2_val==1717986918, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x66666666
TEST_RR_OP(sub, x12, x10, x11, 0x999a4e9e, 0xb504, 0x66666666, x8, 980, x14)

inst_266:
// rs1_val==46340 and rs2_val==-46340, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:-0xb504
TEST_RR_OP(sub, x12, x10, x11, 0x16a08, 0xb504, -0xb504, x8, 984, x14)

inst_267:
// rs1_val==46340 and rs2_val==46340, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0xb504
TEST_RR_OP(sub, x12, x10, x11, 0x0, 0xb504, 0xb504, x8, 988, x14)

inst_268:
// rs1_val==46340 and rs2_val==2, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x2
TEST_RR_OP(sub, x12, x10, x11, 0xb502, 0xb504, 0x2, x8, 992, x14)

inst_269:
// rs1_val==46340 and rs2_val==1431655764, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x55555554
TEST_RR_OP(sub, x12, x10, x11, 0xaaab5fb0, 0xb504, 0x55555554, x8, 996, x14)

inst_270:
// rs1_val==46340 and rs2_val==0, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x0
TEST_RR_OP(sub, x12, x10, x11, 0xb504, 0xb504, 0x0, x8, 1000, x14)

inst_271:
// rs1_val==46340 and rs2_val==4, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x4
TEST_RR_OP(sub, x12, x10, x11, 0xb500, 0xb504, 0x4, x8, 1004, x14)

inst_272:
// rs1_val==46340 and rs2_val==858993458, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x33333332
TEST_RR_OP(sub, x12, x10, x11, 0xcccd81d2, 0xb504, 0x33333332, x8, 1008, x14)

inst_273:
// rs1_val==46340 and rs2_val==1717986917, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x66666665
TEST_RR_OP(sub, x12, x10, x11, 0x999a4e9f, 0xb504, 0x66666665, x8, 1012, x14)

inst_274:
// rs1_val==46340 and rs2_val==46339, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0xb503
TEST_RR_OP(sub, x12, x10, x11, 0x1, 0xb504, 0xb503, x8, 1016, x14)

inst_275:
// rs1_val==46340 and rs2_val==1431655766, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x55555556
TEST_RR_OP(sub, x12, x10, x11, 0xaaab5fae, 0xb504, 0x55555556, x8, 1020, x14)

inst_276:
// rs1_val==46340 and rs2_val==-1431655765, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:-0x55555555
TEST_RR_OP(sub, x12, x10, x11, 0x55560a59, 0xb504, -0x55555555, x8, 1024, x14)

inst_277:
// rs1_val==46340 and rs2_val==6, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x6
TEST_RR_OP(sub, x12, x10, x11, 0xb4fe, 0xb504, 0x6, x8, 1028, x14)

inst_278:
// rs1_val==46340 and rs2_val==858993460, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x33333334
TEST_RR_OP(sub, x12, x10, x11, 0xcccd81d0, 0xb504, 0x33333334, x8, 1032, x14)

inst_279:
// rs1_val==46340 and rs2_val==1717986919, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0x66666667
TEST_RR_OP(sub, x12, x10, x11, 0x999a4e9d, 0xb504, 0x66666667, x8, 1036, x14)

inst_280:
// rs1_val==46340 and rs2_val==-46339, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:-0xb503
TEST_RR_OP(sub, x12, x10, x11, 0x16a07, 0xb504, -0xb503, x8, 1040, x14)

inst_281:
// rs1_val==46340 and rs2_val==46341, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0xb504;  op2val:0xb505
TEST_RR_OP(sub, x12, x10, x11, 0xffffffff, 0xb504, 0xb505, x8, 1044, x14)

inst_282:
// rs1_val==2 and rs2_val==3, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x3
TEST_RR_OP(sub, x12, x10, x11, 0xffffffff, 0x2, 0x3, x8, 1048, x14)

inst_283:
// rs1_val==2 and rs2_val==1431655765, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x55555555
TEST_RR_OP(sub, x12, x10, x11, 0xaaaaaaad, 0x2, 0x55555555, x8, 1052, x14)

inst_284:
// rs1_val==2 and rs2_val==-1431655766, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:-0x55555556
TEST_RR_OP(sub, x12, x10, x11, 0x55555558, 0x2, -0x55555556, x8, 1056, x14)

inst_285:
// rs1_val==2 and rs2_val==5, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x5
TEST_RR_OP(sub, x12, x10, x11, 0xfffffffd, 0x2, 0x5, x8, 1060, x14)

inst_286:
// rs1_val==2 and rs2_val==858993459, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x33333333
TEST_RR_OP(sub, x12, x10, x11, 0xcccccccf, 0x2, 0x33333333, x8, 1064, x14)

inst_287:
// rs1_val==2 and rs2_val==1717986918, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x66666666
TEST_RR_OP(sub, x12, x10, x11, 0x9999999c, 0x2, 0x66666666, x8, 1068, x14)

inst_288:
// rs1_val==2 and rs2_val==-46340, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:-0xb504
TEST_RR_OP(sub, x12, x10, x11, 0xb506, 0x2, -0xb504, x8, 1072, x14)

inst_289:
// rs1_val==2 and rs2_val==46340, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0xb504
TEST_RR_OP(sub, x12, x10, x11, 0xffff4afe, 0x2, 0xb504, x8, 1076, x14)

inst_290:
// rs1_val==2 and rs2_val==2, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x2
TEST_RR_OP(sub, x12, x10, x11, 0x0, 0x2, 0x2, x8, 1080, x14)

inst_291:
// rs1_val==2 and rs2_val==1431655764, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x55555554
TEST_RR_OP(sub, x12, x10, x11, 0xaaaaaaae, 0x2, 0x55555554, x8, 1084, x14)

inst_292:
// rs1_val==2 and rs2_val==0, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x0
TEST_RR_OP(sub, x12, x10, x11, 0x2, 0x2, 0x0, x8, 1088, x14)

inst_293:
// rs1_val==2 and rs2_val==858993458, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x33333332
TEST_RR_OP(sub, x12, x10, x11, 0xccccccd0, 0x2, 0x33333332, x8, 1092, x14)

inst_294:
// rs1_val==2 and rs2_val==1717986917, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x66666665
TEST_RR_OP(sub, x12, x10, x11, 0x9999999d, 0x2, 0x66666665, x8, 1096, x14)

inst_295:
// rs1_val==2 and rs2_val==46339, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0xb503
TEST_RR_OP(sub, x12, x10, x11, 0xffff4aff, 0x2, 0xb503, x8, 1100, x14)

inst_296:
// rs1_val==2 and rs2_val==1431655766, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x55555556
TEST_RR_OP(sub, x12, x10, x11, 0xaaaaaaac, 0x2, 0x55555556, x8, 1104, x14)

inst_297:
// rs1_val==2 and rs2_val==-1431655765, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:-0x55555555
TEST_RR_OP(sub, x12, x10, x11, 0x55555557, 0x2, -0x55555555, x8, 1108, x14)

inst_298:
// rs1_val==2 and rs2_val==6, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x6
TEST_RR_OP(sub, x12, x10, x11, 0xfffffffc, 0x2, 0x6, x8, 1112, x14)

inst_299:
// rs1_val==2 and rs2_val==858993460, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x33333334
TEST_RR_OP(sub, x12, x10, x11, 0xccccccce, 0x2, 0x33333334, x8, 1116, x14)

inst_300:
// rs1_val==2 and rs2_val==1717986919, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0x66666667
TEST_RR_OP(sub, x12, x10, x11, 0x9999999b, 0x2, 0x66666667, x8, 1120, x14)

inst_301:
// rs1_val==2 and rs2_val==-46339, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:-0xb503
TEST_RR_OP(sub, x12, x10, x11, 0xb505, 0x2, -0xb503, x8, 1124, x14)

inst_302:
// rs1_val==2 and rs2_val==46341, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x2;  op2val:0xb505
TEST_RR_OP(sub, x12, x10, x11, 0xffff4afd, 0x2, 0xb505, x8, 1128, x14)

inst_303:
// rs1_val==1431655764 and rs2_val==3, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x3
TEST_RR_OP(sub, x12, x10, x11, 0x55555551, 0x55555554, 0x3, x8, 1132, x14)

inst_304:
// rs1_val==1431655764 and rs2_val==1431655765, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x55555555
TEST_RR_OP(sub, x12, x10, x11, 0xffffffff, 0x55555554, 0x55555555, x8, 1136, x14)

inst_305:
// rs1_val==1431655764 and rs2_val==-1431655766, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:-0x55555556
TEST_RR_OP(sub, x12, x10, x11, 0xaaaaaaaa, 0x55555554, -0x55555556, x8, 1140, x14)

inst_306:
// rs1_val==1431655764 and rs2_val==5, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x5
TEST_RR_OP(sub, x12, x10, x11, 0x5555554f, 0x55555554, 0x5, x8, 1144, x14)

inst_307:
// rs1_val==1431655764 and rs2_val==858993459, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x33333333
TEST_RR_OP(sub, x12, x10, x11, 0x22222221, 0x55555554, 0x33333333, x8, 1148, x14)

inst_308:
// rs1_val==1431655764 and rs2_val==1717986918, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x66666666
TEST_RR_OP(sub, x12, x10, x11, 0xeeeeeeee, 0x55555554, 0x66666666, x8, 1152, x14)

inst_309:
// rs1_val==1431655764 and rs2_val==-46340, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:-0xb504
TEST_RR_OP(sub, x12, x10, x11, 0x55560a58, 0x55555554, -0xb504, x8, 1156, x14)

inst_310:
// rs1_val==1431655764 and rs2_val==46340, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0xb504
TEST_RR_OP(sub, x12, x10, x11, 0x5554a050, 0x55555554, 0xb504, x8, 1160, x14)

inst_311:
// rs1_val==1431655764 and rs2_val==2, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x2
TEST_RR_OP(sub, x12, x10, x11, 0x55555552, 0x55555554, 0x2, x8, 1164, x14)

inst_312:
// rs1_val==1431655764 and rs2_val==1431655764, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x55555554
TEST_RR_OP(sub, x12, x10, x11, 0x0, 0x55555554, 0x55555554, x8, 1168, x14)

inst_313:
// rs1_val==1431655764 and rs2_val==0, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x0
TEST_RR_OP(sub, x12, x10, x11, 0x55555554, 0x55555554, 0x0, x8, 1172, x14)

inst_314:
// rs1_val==1431655764 and rs2_val==4, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x4
TEST_RR_OP(sub, x12, x10, x11, 0x55555550, 0x55555554, 0x4, x8, 1176, x14)

inst_315:
// rs1_val==1431655764 and rs2_val==858993458, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x33333332
TEST_RR_OP(sub, x12, x10, x11, 0x22222222, 0x55555554, 0x33333332, x8, 1180, x14)

inst_316:
// rs1_val==1431655764 and rs2_val==1717986917, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x66666665
TEST_RR_OP(sub, x12, x10, x11, 0xeeeeeeef, 0x55555554, 0x66666665, x8, 1184, x14)

inst_317:
// rs1_val==1431655764 and rs2_val==46339, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0xb503
TEST_RR_OP(sub, x12, x10, x11, 0x5554a051, 0x55555554, 0xb503, x8, 1188, x14)

inst_318:
// rs1_val==1431655764 and rs2_val==1431655766, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x55555556
TEST_RR_OP(sub, x12, x10, x11, 0xfffffffe, 0x55555554, 0x55555556, x8, 1192, x14)

inst_319:
// rs1_val==1431655764 and rs2_val==-1431655765, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:-0x55555555
TEST_RR_OP(sub, x12, x10, x11, 0xaaaaaaa9, 0x55555554, -0x55555555, x8, 1196, x14)

inst_320:
// rs1_val==1431655764 and rs2_val==858993460, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x33333334
TEST_RR_OP(sub, x12, x10, x11, 0x22222220, 0x55555554, 0x33333334, x8, 1200, x14)

inst_321:
// rs1_val==1431655764 and rs2_val==1717986919, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0x66666667
TEST_RR_OP(sub, x12, x10, x11, 0xeeeeeeed, 0x55555554, 0x66666667, x8, 1204, x14)

inst_322:
// rs1_val==1431655764 and rs2_val==-46339, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:-0xb503
TEST_RR_OP(sub, x12, x10, x11, 0x55560a57, 0x55555554, -0xb503, x8, 1208, x14)

inst_323:
// rs1_val==1431655764 and rs2_val==46341, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x55555554;  op2val:0xb505
TEST_RR_OP(sub, x12, x10, x11, 0x5554a04f, 0x55555554, 0xb505, x8, 1212, x14)

inst_324:
// rs1_val==0 and rs2_val==3, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x3
TEST_RR_OP(sub, x12, x10, x11, 0xfffffffd, 0x0, 0x3, x8, 1216, x14)

inst_325:
// rs1_val==0 and rs2_val==1431655765, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x55555555
TEST_RR_OP(sub, x12, x10, x11, 0xaaaaaaab, 0x0, 0x55555555, x8, 1220, x14)

inst_326:
// rs1_val==0 and rs2_val==-1431655766, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:-0x55555556
TEST_RR_OP(sub, x12, x10, x11, 0x55555556, 0x0, -0x55555556, x8, 1224, x14)

inst_327:
// rs1_val==0 and rs2_val==5, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x5
TEST_RR_OP(sub, x12, x10, x11, 0xfffffffb, 0x0, 0x5, x8, 1228, x14)

inst_328:
// rs1_val==0 and rs2_val==858993459, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x33333333
TEST_RR_OP(sub, x12, x10, x11, 0xcccccccd, 0x0, 0x33333333, x8, 1232, x14)

inst_329:
// rs1_val==0 and rs2_val==1717986918, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x66666666
TEST_RR_OP(sub, x12, x10, x11, 0x9999999a, 0x0, 0x66666666, x8, 1236, x14)

inst_330:
// rs1_val==0 and rs2_val==-46340, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:-0xb504
TEST_RR_OP(sub, x12, x10, x11, 0xb504, 0x0, -0xb504, x8, 1240, x14)

inst_331:
// rs1_val==0 and rs2_val==46340, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0xb504
TEST_RR_OP(sub, x12, x10, x11, 0xffff4afc, 0x0, 0xb504, x8, 1244, x14)

inst_332:
// rs1_val==0 and rs2_val==2, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x2
TEST_RR_OP(sub, x12, x10, x11, 0xfffffffe, 0x0, 0x2, x8, 1248, x14)

inst_333:
// rs1_val==-1431655765 and rs2_val==-1431655765, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:-0x55555555
TEST_RR_OP(sub, x12, x10, x11, 0x0, -0x55555555, -0x55555555, x8, 1252, x14)

inst_334:
// rs1_val==-1431655765 and rs2_val==6, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x6
TEST_RR_OP(sub, x12, x10, x11, 0xaaaaaaa5, -0x55555555, 0x6, x8, 1256, x14)

inst_335:
// rs1_val==-1431655765 and rs2_val==858993460, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x33333334
TEST_RR_OP(sub, x12, x10, x11, 0x77777777, -0x55555555, 0x33333334, x8, 1260, x14)

inst_336:
// rs1_val==-1431655765 and rs2_val==1717986919, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x66666667
TEST_RR_OP(sub, x12, x10, x11, 0x44444444, -0x55555555, 0x66666667, x8, 1264, x14)

inst_337:
// rs1_val==-1431655765 and rs2_val==-46339, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:-0xb503
TEST_RR_OP(sub, x12, x10, x11, 0xaaab5fae, -0x55555555, -0xb503, x8, 1268, x14)

inst_338:
// rs1_val==-1431655765 and rs2_val==46341, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0xb505
TEST_RR_OP(sub, x12, x10, x11, 0xaaa9f5a6, -0x55555555, 0xb505, x8, 1272, x14)

inst_339:
// rs1_val==6 and rs2_val==3, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x3
TEST_RR_OP(sub, x12, x10, x11, 0x3, 0x6, 0x3, x8, 1276, x14)

inst_340:
// rs1_val==6 and rs2_val==1431655765, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x55555555
TEST_RR_OP(sub, x12, x10, x11, 0xaaaaaab1, 0x6, 0x55555555, x8, 1280, x14)

inst_341:
// rs1_val==6 and rs2_val==-1431655766, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:-0x55555556
TEST_RR_OP(sub, x12, x10, x11, 0x5555555c, 0x6, -0x55555556, x8, 1284, x14)

inst_342:
// rs1_val==6 and rs2_val==5, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x5
TEST_RR_OP(sub, x12, x10, x11, 0x1, 0x6, 0x5, x8, 1288, x14)

inst_343:
// rs1_val==6 and rs2_val==858993459, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x33333333
TEST_RR_OP(sub, x12, x10, x11, 0xccccccd3, 0x6, 0x33333333, x8, 1292, x14)

inst_344:
// rs1_val==6 and rs2_val==1717986918, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x66666666
TEST_RR_OP(sub, x12, x10, x11, 0x999999a0, 0x6, 0x66666666, x8, 1296, x14)

inst_345:
// rs1_val==6 and rs2_val==-46340, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:-0xb504
TEST_RR_OP(sub, x12, x10, x11, 0xb50a, 0x6, -0xb504, x8, 1300, x14)

inst_346:
// rs1_val==6 and rs2_val==46340, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0xb504
TEST_RR_OP(sub, x12, x10, x11, 0xffff4b02, 0x6, 0xb504, x8, 1304, x14)

inst_347:
// rs1_val==6 and rs2_val==2, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x2
TEST_RR_OP(sub, x12, x10, x11, 0x4, 0x6, 0x2, x8, 1308, x14)

inst_348:
// rs1_val==6 and rs2_val==1431655764, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x55555554
TEST_RR_OP(sub, x12, x10, x11, 0xaaaaaab2, 0x6, 0x55555554, x8, 1312, x14)

inst_349:
// rs1_val==6 and rs2_val==0, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x0
TEST_RR_OP(sub, x12, x10, x11, 0x6, 0x6, 0x0, x8, 1316, x14)

inst_350:
// rs1_val==6 and rs2_val==4, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x4
TEST_RR_OP(sub, x12, x10, x11, 0x2, 0x6, 0x4, x8, 1320, x14)

inst_351:
// rs1_val==6 and rs2_val==858993458, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x33333332
TEST_RR_OP(sub, x12, x10, x11, 0xccccccd4, 0x6, 0x33333332, x8, 1324, x14)

inst_352:
// rs1_val==6 and rs2_val==1717986917, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x66666665
TEST_RR_OP(sub, x12, x10, x11, 0x999999a1, 0x6, 0x66666665, x8, 1328, x14)

inst_353:
// rs1_val==6 and rs2_val==46339, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0xb503
TEST_RR_OP(sub, x12, x10, x11, 0xffff4b03, 0x6, 0xb503, x8, 1332, x14)

inst_354:
// rs1_val==6 and rs2_val==1431655766, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x55555556
TEST_RR_OP(sub, x12, x10, x11, 0xaaaaaab0, 0x6, 0x55555556, x8, 1336, x14)

inst_355:
// rs1_val==6 and rs2_val==-1431655765, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:-0x55555555
TEST_RR_OP(sub, x12, x10, x11, 0x5555555b, 0x6, -0x55555555, x8, 1340, x14)

inst_356:
// rs1_val==6 and rs2_val==6, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x6
TEST_RR_OP(sub, x12, x10, x11, 0x0, 0x6, 0x6, x8, 1344, x14)

inst_357:
// rs1_val==6 and rs2_val==858993460, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x33333334
TEST_RR_OP(sub, x12, x10, x11, 0xccccccd2, 0x6, 0x33333334, x8, 1348, x14)

inst_358:
// rs1_val==6 and rs2_val==1717986919, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0x66666667
TEST_RR_OP(sub, x12, x10, x11, 0x9999999f, 0x6, 0x66666667, x8, 1352, x14)

inst_359:
// rs1_val==6 and rs2_val==-46339, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:-0xb503
TEST_RR_OP(sub, x12, x10, x11, 0xb509, 0x6, -0xb503, x8, 1356, x14)

inst_360:
// rs1_val==6 and rs2_val==46341, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x6;  op2val:0xb505
TEST_RR_OP(sub, x12, x10, x11, 0xffff4b01, 0x6, 0xb505, x8, 1360, x14)

inst_361:
// rs1_val==858993460 and rs2_val==3, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x3
TEST_RR_OP(sub, x12, x10, x11, 0x33333331, 0x33333334, 0x3, x8, 1364, x14)

inst_362:
// rs1_val==858993460 and rs2_val==1431655765, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x55555555
TEST_RR_OP(sub, x12, x10, x11, 0xdddddddf, 0x33333334, 0x55555555, x8, 1368, x14)

inst_363:
// rs1_val==858993460 and rs2_val==-1431655766, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:-0x55555556
TEST_RR_OP(sub, x12, x10, x11, 0x8888888a, 0x33333334, -0x55555556, x8, 1372, x14)

inst_364:
// rs1_val==858993460 and rs2_val==5, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x5
TEST_RR_OP(sub, x12, x10, x11, 0x3333332f, 0x33333334, 0x5, x8, 1376, x14)

inst_365:
// rs1_val==858993460 and rs2_val==858993459, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x33333333
TEST_RR_OP(sub, x12, x10, x11, 0x1, 0x33333334, 0x33333333, x8, 1380, x14)

inst_366:
// rs1_val==858993460 and rs2_val==1717986918, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x66666666
TEST_RR_OP(sub, x12, x10, x11, 0xccccccce, 0x33333334, 0x66666666, x8, 1384, x14)

inst_367:
// rs1_val==858993460 and rs2_val==-46340, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:-0xb504
TEST_RR_OP(sub, x12, x10, x11, 0x3333e838, 0x33333334, -0xb504, x8, 1388, x14)

inst_368:
// rs1_val==858993460 and rs2_val==46340, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0xb504
TEST_RR_OP(sub, x12, x10, x11, 0x33327e30, 0x33333334, 0xb504, x8, 1392, x14)

inst_369:
// rs1_val==858993460 and rs2_val==2, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x2
TEST_RR_OP(sub, x12, x10, x11, 0x33333332, 0x33333334, 0x2, x8, 1396, x14)

inst_370:
// rs1_val==858993460 and rs2_val==1431655764, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x55555554
TEST_RR_OP(sub, x12, x10, x11, 0xdddddde0, 0x33333334, 0x55555554, x8, 1400, x14)

inst_371:
// rs1_val==858993460 and rs2_val==0, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x0
TEST_RR_OP(sub, x12, x10, x11, 0x33333334, 0x33333334, 0x0, x8, 1404, x14)

inst_372:
// rs1_val==858993460 and rs2_val==4, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x4
TEST_RR_OP(sub, x12, x10, x11, 0x33333330, 0x33333334, 0x4, x8, 1408, x14)

inst_373:
// rs1_val==858993460 and rs2_val==858993458, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x33333332
TEST_RR_OP(sub, x12, x10, x11, 0x2, 0x33333334, 0x33333332, x8, 1412, x14)

inst_374:
// rs1_val==858993460 and rs2_val==1717986917, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x66666665
TEST_RR_OP(sub, x12, x10, x11, 0xcccccccf, 0x33333334, 0x66666665, x8, 1416, x14)

inst_375:
// rs1_val==858993460 and rs2_val==46339, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0xb503
TEST_RR_OP(sub, x12, x10, x11, 0x33327e31, 0x33333334, 0xb503, x8, 1420, x14)

inst_376:
// rs1_val==858993460 and rs2_val==1431655766, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x55555556
TEST_RR_OP(sub, x12, x10, x11, 0xddddddde, 0x33333334, 0x55555556, x8, 1424, x14)

inst_377:
// rs1_val==858993460 and rs2_val==-1431655765, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:-0x55555555
TEST_RR_OP(sub, x12, x10, x11, 0x88888889, 0x33333334, -0x55555555, x8, 1428, x14)

inst_378:
// rs1_val==858993460 and rs2_val==6, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x6
TEST_RR_OP(sub, x12, x10, x11, 0x3333332e, 0x33333334, 0x6, x8, 1432, x14)

inst_379:
// rs1_val==858993460 and rs2_val==858993460, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x33333334
TEST_RR_OP(sub, x12, x10, x11, 0x0, 0x33333334, 0x33333334, x8, 1436, x14)

inst_380:
// rs1_val==858993460 and rs2_val==1717986919, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0x66666667
TEST_RR_OP(sub, x12, x10, x11, 0xcccccccd, 0x33333334, 0x66666667, x8, 1440, x14)

inst_381:
// rs1_val==858993460 and rs2_val==-46339, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:-0xb503
TEST_RR_OP(sub, x12, x10, x11, 0x3333e837, 0x33333334, -0xb503, x8, 1444, x14)

inst_382:
// rs1_val==858993460 and rs2_val==46341, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x33333334;  op2val:0xb505
TEST_RR_OP(sub, x12, x10, x11, 0x33327e2f, 0x33333334, 0xb505, x8, 1448, x14)

inst_383:
// rs1_val==1717986919 and rs2_val==3, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x3
TEST_RR_OP(sub, x12, x10, x11, 0x66666664, 0x66666667, 0x3, x8, 1452, x14)

inst_384:
// rs1_val==1717986919 and rs2_val==1431655765, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x55555555
TEST_RR_OP(sub, x12, x10, x11, 0x11111112, 0x66666667, 0x55555555, x8, 1456, x14)

inst_385:
// rs1_val==1717986919 and rs2_val==-1431655766, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:-0x55555556
TEST_RR_OP(sub, x12, x10, x11, 0xbbbbbbbd, 0x66666667, -0x55555556, x8, 1460, x14)

inst_386:
// rs1_val==1717986919 and rs2_val==5, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x5
TEST_RR_OP(sub, x12, x10, x11, 0x66666662, 0x66666667, 0x5, x8, 1464, x14)

inst_387:
// rs1_val==1717986919 and rs2_val==858993459, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x33333333
TEST_RR_OP(sub, x12, x10, x11, 0x33333334, 0x66666667, 0x33333333, x8, 1468, x14)

inst_388:
// rs1_val==1717986919 and rs2_val==1717986918, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x66666666
TEST_RR_OP(sub, x12, x10, x11, 0x1, 0x66666667, 0x66666666, x8, 1472, x14)

inst_389:
// rs1_val==1717986919 and rs2_val==-46340, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:-0xb504
TEST_RR_OP(sub, x12, x10, x11, 0x66671b6b, 0x66666667, -0xb504, x8, 1476, x14)

inst_390:
// rs1_val==1717986919 and rs2_val==46340, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0xb504
TEST_RR_OP(sub, x12, x10, x11, 0x6665b163, 0x66666667, 0xb504, x8, 1480, x14)

inst_391:
// rs1_val==1717986919 and rs2_val==2, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x2
TEST_RR_OP(sub, x12, x10, x11, 0x66666665, 0x66666667, 0x2, x8, 1484, x14)

inst_392:
// rs1_val==1717986919 and rs2_val==1431655764, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x55555554
TEST_RR_OP(sub, x12, x10, x11, 0x11111113, 0x66666667, 0x55555554, x8, 1488, x14)

inst_393:
// rs1_val==1717986919 and rs2_val==0, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x0
TEST_RR_OP(sub, x12, x10, x11, 0x66666667, 0x66666667, 0x0, x8, 1492, x14)

inst_394:
// rs1_val==1717986919 and rs2_val==4, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x4
TEST_RR_OP(sub, x12, x10, x11, 0x66666663, 0x66666667, 0x4, x8, 1496, x14)

inst_395:
// rs1_val==1717986919 and rs2_val==858993458, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x33333332
TEST_RR_OP(sub, x12, x10, x11, 0x33333335, 0x66666667, 0x33333332, x8, 1500, x14)

inst_396:
// rs1_val==1717986919 and rs2_val==1717986917, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x66666665
TEST_RR_OP(sub, x12, x10, x11, 0x2, 0x66666667, 0x66666665, x8, 1504, x14)

inst_397:
// rs1_val==1717986919 and rs2_val==46339, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0xb503
TEST_RR_OP(sub, x12, x10, x11, 0x6665b164, 0x66666667, 0xb503, x8, 1508, x14)

inst_398:
// rs1_val==1717986919 and rs2_val==1431655766, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x55555556
TEST_RR_OP(sub, x12, x10, x11, 0x11111111, 0x66666667, 0x55555556, x8, 1512, x14)

inst_399:
// rs1_val==1717986919 and rs2_val==-1431655765, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:-0x55555555
TEST_RR_OP(sub, x12, x10, x11, 0xbbbbbbbc, 0x66666667, -0x55555555, x8, 1516, x14)

inst_400:
// rs1_val==1717986919 and rs2_val==6, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x6
TEST_RR_OP(sub, x12, x10, x11, 0x66666661, 0x66666667, 0x6, x8, 1520, x14)

inst_401:
// rs1_val==1717986919 and rs2_val==858993460, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x33333334
TEST_RR_OP(sub, x12, x10, x11, 0x33333333, 0x66666667, 0x33333334, x8, 1524, x14)

inst_402:
// rs1_val==1717986919 and rs2_val==1717986919, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0x66666667
TEST_RR_OP(sub, x12, x10, x11, 0x0, 0x66666667, 0x66666667, x8, 1528, x14)

inst_403:
// rs1_val==1717986919 and rs2_val==-46339, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:-0xb503
TEST_RR_OP(sub, x12, x10, x11, 0x66671b6a, 0x66666667, -0xb503, x8, 1532, x14)

inst_404:
// rs1_val==1717986919 and rs2_val==46341, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x66666667;  op2val:0xb505
TEST_RR_OP(sub, x12, x10, x11, 0x6665b162, 0x66666667, 0xb505, x8, 1536, x14)

inst_405:
// rs1_val==-46339 and rs2_val==3, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x3
TEST_RR_OP(sub, x12, x10, x11, 0xffff4afa, -0xb503, 0x3, x8, 1540, x14)

inst_406:
// rs1_val==-46339 and rs2_val==1431655765, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x55555555
TEST_RR_OP(sub, x12, x10, x11, 0xaaa9f5a8, -0xb503, 0x55555555, x8, 1544, x14)

inst_407:
// rs1_val==-46339 and rs2_val==-1431655766, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:-0x55555556
TEST_RR_OP(sub, x12, x10, x11, 0x5554a053, -0xb503, -0x55555556, x8, 1548, x14)

inst_408:
// rs1_val==-46339 and rs2_val==5, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x5
TEST_RR_OP(sub, x12, x10, x11, 0xffff4af8, -0xb503, 0x5, x8, 1552, x14)

inst_409:
// rs1_val==-46339 and rs2_val==858993459, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x33333333
TEST_RR_OP(sub, x12, x10, x11, 0xcccc17ca, -0xb503, 0x33333333, x8, 1556, x14)

inst_410:
// rs1_val==-46339 and rs2_val==1717986918, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x66666666
TEST_RR_OP(sub, x12, x10, x11, 0x9998e497, -0xb503, 0x66666666, x8, 1560, x14)

inst_411:
// rs1_val==-46339 and rs2_val==-46340, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:-0xb504
TEST_RR_OP(sub, x12, x10, x11, 0x1, -0xb503, -0xb504, x8, 1564, x14)

inst_412:
// rs1_val==-46339 and rs2_val==46340, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0xb504
TEST_RR_OP(sub, x12, x10, x11, 0xfffe95f9, -0xb503, 0xb504, x8, 1568, x14)

inst_413:
// rs1_val==-46339 and rs2_val==2, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x2
TEST_RR_OP(sub, x12, x10, x11, 0xffff4afb, -0xb503, 0x2, x8, 1572, x14)

inst_414:
// rs1_val==-46339 and rs2_val==1431655764, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x55555554
TEST_RR_OP(sub, x12, x10, x11, 0xaaa9f5a9, -0xb503, 0x55555554, x8, 1576, x14)

inst_415:
// rs1_val==-46339 and rs2_val==0, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x0
TEST_RR_OP(sub, x12, x10, x11, 0xffff4afd, -0xb503, 0x0, x8, 1580, x14)

inst_416:
// rs1_val==-46339 and rs2_val==4, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x4
TEST_RR_OP(sub, x12, x10, x11, 0xffff4af9, -0xb503, 0x4, x8, 1584, x14)

inst_417:
// rs1_val==-46339 and rs2_val==858993458, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x33333332
TEST_RR_OP(sub, x12, x10, x11, 0xcccc17cb, -0xb503, 0x33333332, x8, 1588, x14)

inst_418:
// rs1_val==-46339 and rs2_val==1717986917, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x66666665
TEST_RR_OP(sub, x12, x10, x11, 0x9998e498, -0xb503, 0x66666665, x8, 1592, x14)

inst_419:
// rs1_val==-46339 and rs2_val==46339, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0xb503
TEST_RR_OP(sub, x12, x10, x11, 0xfffe95fa, -0xb503, 0xb503, x8, 1596, x14)

inst_420:
// rs1_val==-46339 and rs2_val==1431655766, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x55555556
TEST_RR_OP(sub, x12, x10, x11, 0xaaa9f5a7, -0xb503, 0x55555556, x8, 1600, x14)

inst_421:
// rs1_val==-46339 and rs2_val==-1431655765, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:-0x55555555
TEST_RR_OP(sub, x12, x10, x11, 0x5554a052, -0xb503, -0x55555555, x8, 1604, x14)

inst_422:
// rs1_val==-46339 and rs2_val==6, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x6
TEST_RR_OP(sub, x12, x10, x11, 0xffff4af7, -0xb503, 0x6, x8, 1608, x14)

inst_423:
// rs1_val==-46339 and rs2_val==858993460, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x33333334
TEST_RR_OP(sub, x12, x10, x11, 0xcccc17c9, -0xb503, 0x33333334, x8, 1612, x14)

inst_424:
// rs1_val==-46339 and rs2_val==1717986919, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0x66666667
TEST_RR_OP(sub, x12, x10, x11, 0x9998e496, -0xb503, 0x66666667, x8, 1616, x14)

inst_425:
// rs1_val==-46339 and rs2_val==-46339, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:-0xb503
TEST_RR_OP(sub, x12, x10, x11, 0x0, -0xb503, -0xb503, x8, 1620, x14)

inst_426:
// rs1_val==-46339 and rs2_val==46341, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0xb503;  op2val:0xb505
TEST_RR_OP(sub, x12, x10, x11, 0xfffe95f8, -0xb503, 0xb505, x8, 1624, x14)

inst_427:
// rs1_val==46341 and rs2_val==3, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x3
TEST_RR_OP(sub, x12, x10, x11, 0xb502, 0xb505, 0x3, x8, 1628, x14)

inst_428:
// rs1_val==46341 and rs2_val==1431655765, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x55555555
TEST_RR_OP(sub, x12, x10, x11, 0xaaab5fb0, 0xb505, 0x55555555, x8, 1632, x14)

inst_429:
// rs1_val==46341 and rs2_val==-1431655766, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:-0x55555556
TEST_RR_OP(sub, x12, x10, x11, 0x55560a5b, 0xb505, -0x55555556, x8, 1636, x14)

inst_430:
// rs1_val==46341 and rs2_val==5, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x5
TEST_RR_OP(sub, x12, x10, x11, 0xb500, 0xb505, 0x5, x8, 1640, x14)

inst_431:
// rs1_val==46341 and rs2_val==858993459, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x33333333
TEST_RR_OP(sub, x12, x10, x11, 0xcccd81d2, 0xb505, 0x33333333, x8, 1644, x14)

inst_432:
// rs1_val==46341 and rs2_val==1717986918, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x66666666
TEST_RR_OP(sub, x12, x10, x11, 0x999a4e9f, 0xb505, 0x66666666, x8, 1648, x14)

inst_433:
// rs1_val==46341 and rs2_val==-46340, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:-0xb504
TEST_RR_OP(sub, x12, x10, x11, 0x16a09, 0xb505, -0xb504, x8, 1652, x14)

inst_434:
// rs1_val==46341 and rs2_val==46340, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0xb504
TEST_RR_OP(sub, x12, x10, x11, 0x1, 0xb505, 0xb504, x8, 1656, x14)

inst_435:
// rs1_val==46341 and rs2_val==2, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x2
TEST_RR_OP(sub, x12, x10, x11, 0xb503, 0xb505, 0x2, x8, 1660, x14)

inst_436:
// rs1_val==46341 and rs2_val==1431655764, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x55555554
TEST_RR_OP(sub, x12, x10, x11, 0xaaab5fb1, 0xb505, 0x55555554, x8, 1664, x14)

inst_437:
// rs1_val==46341 and rs2_val==0, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x0
TEST_RR_OP(sub, x12, x10, x11, 0xb505, 0xb505, 0x0, x8, 1668, x14)

inst_438:
// rs1_val==46341 and rs2_val==4, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x4
TEST_RR_OP(sub, x12, x10, x11, 0xb501, 0xb505, 0x4, x8, 1672, x14)

inst_439:
// rs1_val==46341 and rs2_val==858993458, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x33333332
TEST_RR_OP(sub, x12, x10, x11, 0xcccd81d3, 0xb505, 0x33333332, x8, 1676, x14)

inst_440:
// rs1_val==46341 and rs2_val==1717986917, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x66666665
TEST_RR_OP(sub, x12, x10, x11, 0x999a4ea0, 0xb505, 0x66666665, x8, 1680, x14)

inst_441:
// rs1_val==46341 and rs2_val==46339, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0xb503
TEST_RR_OP(sub, x12, x10, x11, 0x2, 0xb505, 0xb503, x8, 1684, x14)

inst_442:
// rs1_val==46341 and rs2_val==1431655766, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x55555556
TEST_RR_OP(sub, x12, x10, x11, 0xaaab5faf, 0xb505, 0x55555556, x8, 1688, x14)

inst_443:
// rs1_val==46341 and rs2_val==-1431655765, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:-0x55555555
TEST_RR_OP(sub, x12, x10, x11, 0x55560a5a, 0xb505, -0x55555555, x8, 1692, x14)

inst_444:
// rs1_val==46341 and rs2_val==6, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x6
TEST_RR_OP(sub, x12, x10, x11, 0xb4ff, 0xb505, 0x6, x8, 1696, x14)

inst_445:
// rs1_val==46341 and rs2_val==858993460, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x33333334
TEST_RR_OP(sub, x12, x10, x11, 0xcccd81d1, 0xb505, 0x33333334, x8, 1700, x14)

inst_446:
// rs1_val==46341 and rs2_val==1717986919, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0x66666667
TEST_RR_OP(sub, x12, x10, x11, 0x999a4e9e, 0xb505, 0x66666667, x8, 1704, x14)

inst_447:
// rs1_val==46341 and rs2_val==-46339, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:-0xb503
TEST_RR_OP(sub, x12, x10, x11, 0x16a08, 0xb505, -0xb503, x8, 1708, x14)

inst_448:
// rs1_val==46341 and rs2_val==46341, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0xb505;  op2val:0xb505
TEST_RR_OP(sub, x12, x10, x11, 0x0, 0xb505, 0xb505, x8, 1712, x14)

inst_449:
// rs1_val==0 and rs2_val==1431655764, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x55555554
TEST_RR_OP(sub, x12, x10, x11, 0xaaaaaaac, 0x0, 0x55555554, x8, 1716, x14)

inst_450:
// rs1_val==0 and rs2_val==0, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x0
TEST_RR_OP(sub, x12, x10, x11, 0x0, 0x0, 0x0, x8, 1720, x14)

inst_451:
// rs1_val==0 and rs2_val==4, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x4
TEST_RR_OP(sub, x12, x10, x11, 0xfffffffc, 0x0, 0x4, x8, 1724, x14)

inst_452:
// rs1_val==0 and rs2_val==858993458, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x33333332
TEST_RR_OP(sub, x12, x10, x11, 0xccccccce, 0x0, 0x33333332, x8, 1728, x14)

inst_453:
// rs1_val==0 and rs2_val==1717986917, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x66666665
TEST_RR_OP(sub, x12, x10, x11, 0x9999999b, 0x0, 0x66666665, x8, 1732, x14)

inst_454:
// rs1_val==0 and rs2_val==46339, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0xb503
TEST_RR_OP(sub, x12, x10, x11, 0xffff4afd, 0x0, 0xb503, x8, 1736, x14)

inst_455:
// rs1_val==0 and rs2_val==1431655766, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x55555556
TEST_RR_OP(sub, x12, x10, x11, 0xaaaaaaaa, 0x0, 0x55555556, x8, 1740, x14)

inst_456:
// rs1_val==0 and rs2_val==-1431655765, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:-0x55555555
TEST_RR_OP(sub, x12, x10, x11, 0x55555555, 0x0, -0x55555555, x8, 1744, x14)

inst_457:
// rs1_val==0 and rs2_val==6, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x6
TEST_RR_OP(sub, x12, x10, x11, 0xfffffffa, 0x0, 0x6, x8, 1748, x14)

inst_458:
// rs1_val==0 and rs2_val==858993460, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x33333334
TEST_RR_OP(sub, x12, x10, x11, 0xcccccccc, 0x0, 0x33333334, x8, 1752, x14)

inst_459:
// rs1_val==0 and rs2_val==1717986919, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0x66666667
TEST_RR_OP(sub, x12, x10, x11, 0x99999999, 0x0, 0x66666667, x8, 1756, x14)

inst_460:
// rs1_val==0 and rs2_val==-46339, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:-0xb503
TEST_RR_OP(sub, x12, x10, x11, 0xb503, 0x0, -0xb503, x8, 1760, x14)

inst_461:
// rs1_val==0 and rs2_val==46341, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x0;  op2val:0xb505
TEST_RR_OP(sub, x12, x10, x11, 0xffff4afb, 0x0, 0xb505, x8, 1764, x14)

inst_462:
// rs1_val==4 and rs2_val==3, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x3
TEST_RR_OP(sub, x12, x10, x11, 0x1, 0x4, 0x3, x8, 1768, x14)

inst_463:
// rs1_val==4 and rs2_val==1431655765, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x55555555
TEST_RR_OP(sub, x12, x10, x11, 0xaaaaaaaf, 0x4, 0x55555555, x8, 1772, x14)

inst_464:
// rs1_val==4 and rs2_val==-1431655766, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:-0x55555556
TEST_RR_OP(sub, x12, x10, x11, 0x5555555a, 0x4, -0x55555556, x8, 1776, x14)

inst_465:
// rs1_val==4 and rs2_val==5, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x5
TEST_RR_OP(sub, x12, x10, x11, 0xffffffff, 0x4, 0x5, x8, 1780, x14)

inst_466:
// rs1_val==4 and rs2_val==858993459, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x33333333
TEST_RR_OP(sub, x12, x10, x11, 0xccccccd1, 0x4, 0x33333333, x8, 1784, x14)

inst_467:
// rs1_val==4 and rs2_val==1717986918, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x66666666
TEST_RR_OP(sub, x12, x10, x11, 0x9999999e, 0x4, 0x66666666, x8, 1788, x14)

inst_468:
// rs1_val==4 and rs2_val==-46340, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:-0xb504
TEST_RR_OP(sub, x12, x10, x11, 0xb508, 0x4, -0xb504, x8, 1792, x14)

inst_469:
// rs1_val==4 and rs2_val==46340, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0xb504
TEST_RR_OP(sub, x12, x10, x11, 0xffff4b00, 0x4, 0xb504, x8, 1796, x14)

inst_470:
// rs1_val==4 and rs2_val==2, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x2
TEST_RR_OP(sub, x12, x10, x11, 0x2, 0x4, 0x2, x8, 1800, x14)

inst_471:
// rs1_val==4 and rs2_val==1431655764, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x55555554
TEST_RR_OP(sub, x12, x10, x11, 0xaaaaaab0, 0x4, 0x55555554, x8, 1804, x14)

inst_472:
// rs1_val==4 and rs2_val==0, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x0
TEST_RR_OP(sub, x12, x10, x11, 0x4, 0x4, 0x0, x8, 1808, x14)

inst_473:
// rs1_val==4 and rs2_val==4, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x4
TEST_RR_OP(sub, x12, x10, x11, 0x0, 0x4, 0x4, x8, 1812, x14)

inst_474:
// rs1_val==4 and rs2_val==858993458, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x33333332
TEST_RR_OP(sub, x12, x10, x11, 0xccccccd2, 0x4, 0x33333332, x8, 1816, x14)

inst_475:
// rs1_val==4 and rs2_val==1717986917, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x66666665
TEST_RR_OP(sub, x12, x10, x11, 0x9999999f, 0x4, 0x66666665, x8, 1820, x14)

inst_476:
// rs1_val==4 and rs2_val==46339, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0xb503
TEST_RR_OP(sub, x12, x10, x11, 0xffff4b01, 0x4, 0xb503, x8, 1824, x14)

inst_477:
// rs1_val==4 and rs2_val==1431655766, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x55555556
TEST_RR_OP(sub, x12, x10, x11, 0xaaaaaaae, 0x4, 0x55555556, x8, 1828, x14)

inst_478:
// rs1_val==4 and rs2_val==-1431655765, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:-0x55555555
TEST_RR_OP(sub, x12, x10, x11, 0x55555559, 0x4, -0x55555555, x8, 1832, x14)

inst_479:
// rs1_val==4 and rs2_val==6, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x6
TEST_RR_OP(sub, x12, x10, x11, 0xfffffffe, 0x4, 0x6, x8, 1836, x14)

inst_480:
// rs1_val==4 and rs2_val==858993460, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x33333334
TEST_RR_OP(sub, x12, x10, x11, 0xccccccd0, 0x4, 0x33333334, x8, 1840, x14)

inst_481:
// rs1_val==4 and rs2_val==1717986919, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0x66666667
TEST_RR_OP(sub, x12, x10, x11, 0x9999999d, 0x4, 0x66666667, x8, 1844, x14)

inst_482:
// rs1_val==4 and rs2_val==-46339, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:-0xb503
TEST_RR_OP(sub, x12, x10, x11, 0xb507, 0x4, -0xb503, x8, 1848, x14)

inst_483:
// rs1_val==4 and rs2_val==46341, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x4;  op2val:0xb505
TEST_RR_OP(sub, x12, x10, x11, 0xffff4aff, 0x4, 0xb505, x8, 1852, x14)

inst_484:
// rs1_val==858993458 and rs2_val==3, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x3
TEST_RR_OP(sub, x12, x10, x11, 0x3333332f, 0x33333332, 0x3, x8, 1856, x14)

inst_485:
// rs1_val==858993458 and rs2_val==1431655765, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x55555555
TEST_RR_OP(sub, x12, x10, x11, 0xdddddddd, 0x33333332, 0x55555555, x8, 1860, x14)

inst_486:
// rs1_val==858993458 and rs2_val==-1431655766, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:-0x55555556
TEST_RR_OP(sub, x12, x10, x11, 0x88888888, 0x33333332, -0x55555556, x8, 1864, x14)

inst_487:
// rs1_val==858993458 and rs2_val==5, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x5
TEST_RR_OP(sub, x12, x10, x11, 0x3333332d, 0x33333332, 0x5, x8, 1868, x14)

inst_488:
// rs1_val==858993458 and rs2_val==858993459, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x33333333
TEST_RR_OP(sub, x12, x10, x11, 0xffffffff, 0x33333332, 0x33333333, x8, 1872, x14)

inst_489:
// rs1_val==858993458 and rs2_val==1717986918, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x66666666
TEST_RR_OP(sub, x12, x10, x11, 0xcccccccc, 0x33333332, 0x66666666, x8, 1876, x14)

inst_490:
// rs1_val==858993458 and rs2_val==-46340, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:-0xb504
TEST_RR_OP(sub, x12, x10, x11, 0x3333e836, 0x33333332, -0xb504, x8, 1880, x14)

inst_491:
// rs1_val==858993458 and rs2_val==46340, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0xb504
TEST_RR_OP(sub, x12, x10, x11, 0x33327e2e, 0x33333332, 0xb504, x8, 1884, x14)

inst_492:
// rs1_val==858993458 and rs2_val==2, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x2
TEST_RR_OP(sub, x12, x10, x11, 0x33333330, 0x33333332, 0x2, x8, 1888, x14)

inst_493:
// rs1_val==858993458 and rs2_val==1431655764, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x55555554
TEST_RR_OP(sub, x12, x10, x11, 0xddddddde, 0x33333332, 0x55555554, x8, 1892, x14)

inst_494:
// rs1_val==858993458 and rs2_val==0, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x0
TEST_RR_OP(sub, x12, x10, x11, 0x33333332, 0x33333332, 0x0, x8, 1896, x14)

inst_495:
// rs1_val==858993458 and rs2_val==4, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x4
TEST_RR_OP(sub, x12, x10, x11, 0x3333332e, 0x33333332, 0x4, x8, 1900, x14)

inst_496:
// rs1_val==858993458 and rs2_val==858993458, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x33333332
TEST_RR_OP(sub, x12, x10, x11, 0x0, 0x33333332, 0x33333332, x8, 1904, x14)

inst_497:
// rs1_val==858993458 and rs2_val==1717986917, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x66666665
TEST_RR_OP(sub, x12, x10, x11, 0xcccccccd, 0x33333332, 0x66666665, x8, 1908, x14)

inst_498:
// rs1_val==858993458 and rs2_val==46339, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0xb503
TEST_RR_OP(sub, x12, x10, x11, 0x33327e2f, 0x33333332, 0xb503, x8, 1912, x14)

inst_499:
// rs1_val==858993458 and rs2_val==1431655766, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x55555556
TEST_RR_OP(sub, x12, x10, x11, 0xdddddddc, 0x33333332, 0x55555556, x8, 1916, x14)

inst_500:
// rs1_val==858993458 and rs2_val==-1431655765, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:-0x55555555
TEST_RR_OP(sub, x12, x10, x11, 0x88888887, 0x33333332, -0x55555555, x8, 1920, x14)

inst_501:
// rs1_val==858993458 and rs2_val==6, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x6
TEST_RR_OP(sub, x12, x10, x11, 0x3333332c, 0x33333332, 0x6, x8, 1924, x14)

inst_502:
// rs1_val==858993458 and rs2_val==858993460, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x33333334
TEST_RR_OP(sub, x12, x10, x11, 0xfffffffe, 0x33333332, 0x33333334, x8, 1928, x14)

inst_503:
// rs1_val==858993458 and rs2_val==1717986919, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0x66666667
TEST_RR_OP(sub, x12, x10, x11, 0xcccccccb, 0x33333332, 0x66666667, x8, 1932, x14)

inst_504:
// rs1_val==858993458 and rs2_val==-46339, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:-0xb503
TEST_RR_OP(sub, x12, x10, x11, 0x3333e835, 0x33333332, -0xb503, x8, 1936, x14)

inst_505:
// rs1_val==858993458 and rs2_val==46341, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x33333332;  op2val:0xb505
TEST_RR_OP(sub, x12, x10, x11, 0x33327e2d, 0x33333332, 0xb505, x8, 1940, x14)

inst_506:
// rs1_val==1717986917 and rs2_val==3, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x3
TEST_RR_OP(sub, x12, x10, x11, 0x66666662, 0x66666665, 0x3, x8, 1944, x14)

inst_507:
// rs1_val==1717986917 and rs2_val==1431655765, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x55555555
TEST_RR_OP(sub, x12, x10, x11, 0x11111110, 0x66666665, 0x55555555, x8, 1948, x14)

inst_508:
// rs1_val==1717986917 and rs2_val==-1431655766, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:-0x55555556
TEST_RR_OP(sub, x12, x10, x11, 0xbbbbbbbb, 0x66666665, -0x55555556, x8, 1952, x14)

inst_509:
// rs1_val==1717986917 and rs2_val==5, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x5
TEST_RR_OP(sub, x12, x10, x11, 0x66666660, 0x66666665, 0x5, x8, 1956, x14)

inst_510:
// rs1_val==1717986917 and rs2_val==858993459, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x33333333
TEST_RR_OP(sub, x12, x10, x11, 0x33333332, 0x66666665, 0x33333333, x8, 1960, x14)

inst_511:
// rs1_val==1717986917 and rs2_val==1717986918, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x66666666
TEST_RR_OP(sub, x12, x10, x11, 0xffffffff, 0x66666665, 0x66666666, x8, 1964, x14)

inst_512:
// rs1_val==1717986917 and rs2_val==-46340, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:-0xb504
TEST_RR_OP(sub, x12, x10, x11, 0x66671b69, 0x66666665, -0xb504, x8, 1968, x14)

inst_513:
// rs1_val==1717986917 and rs2_val==46340, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0xb504
TEST_RR_OP(sub, x12, x10, x11, 0x6665b161, 0x66666665, 0xb504, x8, 1972, x14)

inst_514:
// rs1_val==1717986917 and rs2_val==2, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x2
TEST_RR_OP(sub, x12, x10, x11, 0x66666663, 0x66666665, 0x2, x8, 1976, x14)

inst_515:
// rs1_val==1717986917 and rs2_val==1431655764, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x55555554
TEST_RR_OP(sub, x12, x10, x11, 0x11111111, 0x66666665, 0x55555554, x8, 1980, x14)

inst_516:
// rs1_val==1717986917 and rs2_val==0, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x0
TEST_RR_OP(sub, x12, x10, x11, 0x66666665, 0x66666665, 0x0, x8, 1984, x14)

inst_517:
// rs1_val==1717986917 and rs2_val==4, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x4
TEST_RR_OP(sub, x12, x10, x11, 0x66666661, 0x66666665, 0x4, x8, 1988, x14)

inst_518:
// rs1_val==1717986917 and rs2_val==858993458, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x33333332
TEST_RR_OP(sub, x12, x10, x11, 0x33333333, 0x66666665, 0x33333332, x8, 1992, x14)

inst_519:
// rs1_val==1717986917 and rs2_val==1717986917, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x66666665
TEST_RR_OP(sub, x12, x10, x11, 0x0, 0x66666665, 0x66666665, x8, 1996, x14)

inst_520:
// rs1_val==1717986917 and rs2_val==46339, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0xb503
TEST_RR_OP(sub, x12, x10, x11, 0x6665b162, 0x66666665, 0xb503, x8, 2000, x14)

inst_521:
// rs1_val==1717986917 and rs2_val==1431655766, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x55555556
TEST_RR_OP(sub, x12, x10, x11, 0x1111110f, 0x66666665, 0x55555556, x8, 2004, x14)

inst_522:
// rs1_val==1717986917 and rs2_val==-1431655765, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:-0x55555555
TEST_RR_OP(sub, x12, x10, x11, 0xbbbbbbba, 0x66666665, -0x55555555, x8, 2008, x14)

inst_523:
// rs1_val==1717986917 and rs2_val==6, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x6
TEST_RR_OP(sub, x12, x10, x11, 0x6666665f, 0x66666665, 0x6, x8, 2012, x14)

inst_524:
// rs1_val==1717986917 and rs2_val==858993460, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x33333334
TEST_RR_OP(sub, x12, x10, x11, 0x33333331, 0x66666665, 0x33333334, x8, 2016, x14)

inst_525:
// rs1_val==1717986917 and rs2_val==1717986919, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0x66666667
TEST_RR_OP(sub, x12, x10, x11, 0xfffffffe, 0x66666665, 0x66666667, x8, 2020, x14)

inst_526:
// rs1_val==1717986917 and rs2_val==-46339, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:-0xb503
TEST_RR_OP(sub, x12, x10, x11, 0x66671b68, 0x66666665, -0xb503, x8, 2024, x14)

inst_527:
// rs1_val==1717986917 and rs2_val==46341, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x66666665;  op2val:0xb505
TEST_RR_OP(sub, x12, x10, x11, 0x6665b160, 0x66666665, 0xb505, x8, 2028, x14)

inst_528:
// rs1_val==46339 and rs2_val==3, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x3
TEST_RR_OP(sub, x12, x10, x11, 0xb500, 0xb503, 0x3, x8, 2032, x14)

inst_529:
// rs1_val==46339 and rs2_val==1431655765, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x55555555
TEST_RR_OP(sub, x12, x10, x11, 0xaaab5fae, 0xb503, 0x55555555, x8, 2036, x14)

inst_530:
// rs1_val==46339 and rs2_val==-1431655766, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:-0x55555556
TEST_RR_OP(sub, x12, x10, x11, 0x55560a59, 0xb503, -0x55555556, x8, 2040, x14)

inst_531:
// rs1_val==46339 and rs2_val==5, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x5
TEST_RR_OP(sub, x12, x10, x11, 0xb4fe, 0xb503, 0x5, x8, 2044, x14)
RVTEST_SIGBASE( x8,signature_x8_1)

inst_532:
// rs1_val==46339 and rs2_val==858993459, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x33333333
TEST_RR_OP(sub, x12, x10, x11, 0xcccd81d0, 0xb503, 0x33333333, x8, 0, x14)

inst_533:
// rs1_val==46339 and rs2_val==1717986918, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x66666666
TEST_RR_OP(sub, x12, x10, x11, 0x999a4e9d, 0xb503, 0x66666666, x8, 4, x14)

inst_534:
// rs1_val==46339 and rs2_val==-46340, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:-0xb504
TEST_RR_OP(sub, x12, x10, x11, 0x16a07, 0xb503, -0xb504, x8, 8, x14)

inst_535:
// rs1_val==46339 and rs2_val==46340, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0xb504
TEST_RR_OP(sub, x12, x10, x11, 0xffffffff, 0xb503, 0xb504, x8, 12, x14)

inst_536:
// rs1_val==46339 and rs2_val==2, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x2
TEST_RR_OP(sub, x12, x10, x11, 0xb501, 0xb503, 0x2, x8, 16, x14)

inst_537:
// rs1_val==46339 and rs2_val==1431655764, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x55555554
TEST_RR_OP(sub, x12, x10, x11, 0xaaab5faf, 0xb503, 0x55555554, x8, 20, x14)

inst_538:
// rs1_val==46339 and rs2_val==0, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x0
TEST_RR_OP(sub, x12, x10, x11, 0xb503, 0xb503, 0x0, x8, 24, x14)

inst_539:
// rs1_val==46339 and rs2_val==4, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x4
TEST_RR_OP(sub, x12, x10, x11, 0xb4ff, 0xb503, 0x4, x8, 28, x14)

inst_540:
// rs1_val==46339 and rs2_val==858993458, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x33333332
TEST_RR_OP(sub, x12, x10, x11, 0xcccd81d1, 0xb503, 0x33333332, x8, 32, x14)

inst_541:
// rs1_val==46339 and rs2_val==1717986917, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x66666665
TEST_RR_OP(sub, x12, x10, x11, 0x999a4e9e, 0xb503, 0x66666665, x8, 36, x14)

inst_542:
// rs1_val==46339 and rs2_val==46339, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0xb503
TEST_RR_OP(sub, x12, x10, x11, 0x0, 0xb503, 0xb503, x8, 40, x14)

inst_543:
// rs1_val==46339 and rs2_val==1431655766, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x55555556
TEST_RR_OP(sub, x12, x10, x11, 0xaaab5fad, 0xb503, 0x55555556, x8, 44, x14)

inst_544:
// rs1_val==46339 and rs2_val==-1431655765, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:-0x55555555
TEST_RR_OP(sub, x12, x10, x11, 0x55560a58, 0xb503, -0x55555555, x8, 48, x14)

inst_545:
// rs1_val==46339 and rs2_val==6, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x6
TEST_RR_OP(sub, x12, x10, x11, 0xb4fd, 0xb503, 0x6, x8, 52, x14)

inst_546:
// rs1_val==46339 and rs2_val==858993460, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x33333334
TEST_RR_OP(sub, x12, x10, x11, 0xcccd81cf, 0xb503, 0x33333334, x8, 56, x14)

inst_547:
// rs1_val==46339 and rs2_val==1717986919, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0x66666667
TEST_RR_OP(sub, x12, x10, x11, 0x999a4e9c, 0xb503, 0x66666667, x8, 60, x14)

inst_548:
// rs1_val==46339 and rs2_val==-46339, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:-0xb503
TEST_RR_OP(sub, x12, x10, x11, 0x16a06, 0xb503, -0xb503, x8, 64, x14)

inst_549:
// rs1_val==46339 and rs2_val==46341, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0xb503;  op2val:0xb505
TEST_RR_OP(sub, x12, x10, x11, 0xfffffffe, 0xb503, 0xb505, x8, 68, x14)

inst_550:
// rs1_val==1431655766 and rs2_val==3, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x3
TEST_RR_OP(sub, x12, x10, x11, 0x55555553, 0x55555556, 0x3, x8, 72, x14)

inst_551:
// rs1_val==1431655766 and rs2_val==1431655765, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x55555555
TEST_RR_OP(sub, x12, x10, x11, 0x1, 0x55555556, 0x55555555, x8, 76, x14)

inst_552:
// rs1_val==1431655766 and rs2_val==-1431655766, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:-0x55555556
TEST_RR_OP(sub, x12, x10, x11, 0xaaaaaaac, 0x55555556, -0x55555556, x8, 80, x14)

inst_553:
// rs1_val==1431655766 and rs2_val==5, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x5
TEST_RR_OP(sub, x12, x10, x11, 0x55555551, 0x55555556, 0x5, x8, 84, x14)

inst_554:
// rs1_val==1431655766 and rs2_val==858993459, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x33333333
TEST_RR_OP(sub, x12, x10, x11, 0x22222223, 0x55555556, 0x33333333, x8, 88, x14)

inst_555:
// rs1_val==1431655766 and rs2_val==1717986918, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x66666666
TEST_RR_OP(sub, x12, x10, x11, 0xeeeeeef0, 0x55555556, 0x66666666, x8, 92, x14)

inst_556:
// rs1_val==1431655766 and rs2_val==-46340, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:-0xb504
TEST_RR_OP(sub, x12, x10, x11, 0x55560a5a, 0x55555556, -0xb504, x8, 96, x14)

inst_557:
// rs1_val==1431655766 and rs2_val==46340, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0xb504
TEST_RR_OP(sub, x12, x10, x11, 0x5554a052, 0x55555556, 0xb504, x8, 100, x14)

inst_558:
// rs1_val==1431655766 and rs2_val==2, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x2
TEST_RR_OP(sub, x12, x10, x11, 0x55555554, 0x55555556, 0x2, x8, 104, x14)

inst_559:
// rs1_val==1431655766 and rs2_val==1431655764, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x55555554
TEST_RR_OP(sub, x12, x10, x11, 0x2, 0x55555556, 0x55555554, x8, 108, x14)

inst_560:
// rs1_val==1431655766 and rs2_val==0, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x0
TEST_RR_OP(sub, x12, x10, x11, 0x55555556, 0x55555556, 0x0, x8, 112, x14)

inst_561:
// rs1_val==1431655766 and rs2_val==4, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x4
TEST_RR_OP(sub, x12, x10, x11, 0x55555552, 0x55555556, 0x4, x8, 116, x14)

inst_562:
// rs1_val==1431655766 and rs2_val==858993458, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x33333332
TEST_RR_OP(sub, x12, x10, x11, 0x22222224, 0x55555556, 0x33333332, x8, 120, x14)

inst_563:
// rs1_val==1431655766 and rs2_val==1717986917, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x66666665
TEST_RR_OP(sub, x12, x10, x11, 0xeeeeeef1, 0x55555556, 0x66666665, x8, 124, x14)

inst_564:
// rs1_val==1431655766 and rs2_val==46339, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0xb503
TEST_RR_OP(sub, x12, x10, x11, 0x5554a053, 0x55555556, 0xb503, x8, 128, x14)

inst_565:
// rs1_val==1431655766 and rs2_val==1431655766, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x55555556
TEST_RR_OP(sub, x12, x10, x11, 0x0, 0x55555556, 0x55555556, x8, 132, x14)

inst_566:
// rs1_val==1431655766 and rs2_val==-1431655765, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:-0x55555555
TEST_RR_OP(sub, x12, x10, x11, 0xaaaaaaab, 0x55555556, -0x55555555, x8, 136, x14)

inst_567:
// rs1_val==1431655766 and rs2_val==6, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x6
TEST_RR_OP(sub, x12, x10, x11, 0x55555550, 0x55555556, 0x6, x8, 140, x14)

inst_568:
// rs1_val==1431655766 and rs2_val==858993460, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x33333334
TEST_RR_OP(sub, x12, x10, x11, 0x22222222, 0x55555556, 0x33333334, x8, 144, x14)

inst_569:
// rs1_val==1431655766 and rs2_val==1717986919, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0x66666667
TEST_RR_OP(sub, x12, x10, x11, 0xeeeeeeef, 0x55555556, 0x66666667, x8, 148, x14)

inst_570:
// rs1_val==1431655766 and rs2_val==-46339, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:-0xb503
TEST_RR_OP(sub, x12, x10, x11, 0x55560a59, 0x55555556, -0xb503, x8, 152, x14)

inst_571:
// rs1_val==1431655766 and rs2_val==46341, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x55555556;  op2val:0xb505
TEST_RR_OP(sub, x12, x10, x11, 0x5554a051, 0x55555556, 0xb505, x8, 156, x14)

inst_572:
// rs1_val==-1431655765 and rs2_val==3, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x3
TEST_RR_OP(sub, x12, x10, x11, 0xaaaaaaa8, -0x55555555, 0x3, x8, 160, x14)

inst_573:
// rs1_val==-1431655765 and rs2_val==1431655765, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x55555555
TEST_RR_OP(sub, x12, x10, x11, 0x55555556, -0x55555555, 0x55555555, x8, 164, x14)

inst_574:
// rs1_val==-1431655765 and rs2_val==-1431655766, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:-0x55555556
TEST_RR_OP(sub, x12, x10, x11, 0x1, -0x55555555, -0x55555556, x8, 168, x14)

inst_575:
// rs1_val==-1431655765 and rs2_val==5, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x5
TEST_RR_OP(sub, x12, x10, x11, 0xaaaaaaa6, -0x55555555, 0x5, x8, 172, x14)

inst_576:
// rs1_val==-1431655765 and rs2_val==858993459, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x33333333
TEST_RR_OP(sub, x12, x10, x11, 0x77777778, -0x55555555, 0x33333333, x8, 176, x14)

inst_577:
// rs1_val==-1431655765 and rs2_val==1717986918, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x66666666
TEST_RR_OP(sub, x12, x10, x11, 0x44444445, -0x55555555, 0x66666666, x8, 180, x14)

inst_578:
// rs1_val==-1431655765 and rs2_val==-46340, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:-0xb504
TEST_RR_OP(sub, x12, x10, x11, 0xaaab5faf, -0x55555555, -0xb504, x8, 184, x14)

inst_579:
// rs1_val==-1431655765 and rs2_val==46340, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0xb504
TEST_RR_OP(sub, x12, x10, x11, 0xaaa9f5a7, -0x55555555, 0xb504, x8, 188, x14)

inst_580:
// rs1_val==-1431655765 and rs2_val==2, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x2
TEST_RR_OP(sub, x12, x10, x11, 0xaaaaaaa9, -0x55555555, 0x2, x8, 192, x14)

inst_581:
// rs1_val==-1431655765 and rs2_val==1431655764, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x55555554
TEST_RR_OP(sub, x12, x10, x11, 0x55555557, -0x55555555, 0x55555554, x8, 196, x14)

inst_582:
// rs1_val==-1431655765 and rs2_val==0, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x0
TEST_RR_OP(sub, x12, x10, x11, 0xaaaaaaab, -0x55555555, 0x0, x8, 200, x14)

inst_583:
// rs1_val==-1431655765 and rs2_val==4, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x4
TEST_RR_OP(sub, x12, x10, x11, 0xaaaaaaa7, -0x55555555, 0x4, x8, 204, x14)

inst_584:
// rs1_val==-1431655765 and rs2_val==858993458, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x33333332
TEST_RR_OP(sub, x12, x10, x11, 0x77777779, -0x55555555, 0x33333332, x8, 208, x14)

inst_585:
// rs1_val==-1431655765 and rs2_val==1717986917, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x66666665
TEST_RR_OP(sub, x12, x10, x11, 0x44444446, -0x55555555, 0x66666665, x8, 212, x14)

inst_586:
// rs1_val==-1431655765 and rs2_val==46339, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0xb503
TEST_RR_OP(sub, x12, x10, x11, 0xaaa9f5a8, -0x55555555, 0xb503, x8, 216, x14)

inst_587:
// rs1_val==-1431655765 and rs2_val==1431655766, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x55555555;  op2val:0x55555556
TEST_RR_OP(sub, x12, x10, x11, 0x55555555, -0x55555555, 0x55555556, x8, 220, x14)

inst_588:
// rs1_val < 0 and rs2_val < 0, rs2_val == -129
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x7;  op2val:-0x81
TEST_RR_OP(sub, x12, x10, x11, 0x7a, -0x7, -0x81, x8, 224, x14)

inst_589:
// rs2_val == 0, rs1_val == 32
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x20;  op2val:0x0
TEST_RR_OP(sub, x12, x10, x11, 0x20, 0x20, 0x0, x8, 228, x14)

inst_590:
// rs2_val == 128, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:0x9;  op2val:0x80
TEST_RR_OP(sub, x12, x10, x11, 0xffffff89, 0x9, 0x80, x8, 232, x14)

inst_591:
// rs2_val == 2048, 
// opcode: sub ; op1:x10; op2:x11; dest:x12; op1val:-0x80000000;  op2val:0x800
TEST_RR_OP(sub, x12, x10, x11, 0x7ffff800, -0x80000000, 0x800, x8, 236, x14)
#endif


RVTEST_CODE_END
RVMODEL_HALT

RVTEST_DATA_BEGIN
.align 4

rvtest_data:
.word 0xbabecafe
.word 0xbabecafe
.word 0xbabecafe
.word 0xbabecafe
RVTEST_DATA_END


RVMODEL_DATA_BEGIN
rvtest_sig_begin:
sig_begin_canary:
CANARY;


signature_x1_0:
    .fill 0*(XLEN/32),4,0xdeadbeef


signature_x1_1:
    .fill 20*(XLEN/32),4,0xdeadbeef


signature_x8_0:
    .fill 512*(XLEN/32),4,0xdeadbeef


signature_x8_1:
    .fill 60*(XLEN/32),4,0xdeadbeef

#ifdef rvtest_mtrap_routine

tsig_begin_canary:
CANARY;
mtrap_sigptr:
    .fill 64*(XLEN/32),4,0xdeadbeef
tsig_end_canary:
CANARY;

#endif

#ifdef rvtest_gpr_save

gpr_save:
    .fill 32*(XLEN/32),4,0xdeadbeef

#endif

sig_end_canary:
CANARY;
rvtest_sig_end:
RVMODEL_DATA_END
